(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



(* :Title: FigLabel *)
(* :Context: SciDraw` *)
(* :Summary: Label object *)
(* :Author: Mark A. Caprio, Department of Physics, University of Notre Dame *)
(* :Copyright: Copyright FIGYEAR, Mark A. Caprio *)
(* :Package Version: FIGVERSION *)
(* :Mathematica Version: MATHVERSION *)
(* :Discussion: FIGDISCUSSION *)
(* :History: See package information file. *)


BeginPackage["SciDraw`",SciDraw`Private`$ExternalContexts];


Unprotect[Evaluate[$Context<>"*"]];


FigLabel::usage="FIGURE OBJECT: FigLabel[point,text] generates a label at the given point.  If point is given as an anchor object, the default text offset and orientation information is taken from the anchor.  FigLabel[object,name,text] or FigLabel[object,name,arg,text] attaches the label to an anchor extracted from the given object.  FigLabel[text] takes its position from the option Position.";


Displacement::usage="Option name for use with figure objects.";
DisplacedPoint::usage="Option name for use with figure objects.";
IntermediatePoints::usage="Option name for use with figure objects.";


Begin["`Private`"];





DeclareFigClass[
FigLabel,
{"TheAnchor","TextElement","Points"},
{},
{}
];
DefineFigClassOptions[
FigLabel,
{ShowLine->False},  (* callout is off by default *)
{
(* given position *)
Point->{0,0},

(* anchor position *)
Position->Automatic,

(* label displacement *)
DisplacedPoint->None,
Displacement->None,

(* callout *)
IntermediatePoints->None,
(* curve/arrowhead *)
FigArrowheadOptions[False,True],
FigCurveOptions
}
];


BasicLabel[Self_Object][GivenAnchor_Object,TextArt_]:=Module[
{
RelativeAnchor,Anchor,UsedIntermediatePoints,Curve,CanvasPoints,TextElement,GivenDisplacedPoint
},

(* validate options *)
FigCheckOption[Self,DisplacedPoint,None|FigPointPattern,FigOptions];
FigCheckOption[Self,Displacement,FigDisplacementPattern,FigOptions];
FigCheckOption[Self,IntermediatePoints,None|{FigCurvePointPattern...},FigOptions];
FigCheckArrowheadOptions[Self];
FigCheckCurveOptions[Self];

(* generate anchor point for text *)
RelativeAnchor=DisplacePoint[FigAnchor[GivenAnchor],(Displacement/.FigOptions)];
GivenDisplacedPoint=ResolveOption[DisplacedPoint,{None->RelativeAnchor},FigOptions];
Anchor=FigAnchor[GivenDisplacedPoint];

(* construct callout curve specification *)
UsedIntermediatePoints=ResolveOption[IntermediatePoints,{None->{}},FigOptions];
Curve=Join[{Anchor},UsedIntermediatePoints,{GivenAnchor}];
CanvasPoints=FigResolveCurve[Self,Curve,FigOptions];

(* save data needed for anchor generation on callout curve *)
Self@SetPoints[CanvasPoints];

(* make graphics elements *)
(* short circuit if no displaced point -- else have divide-by-zero errors on arrowheads *)
If[((Displacement/.FigOptions)=!=None)||((DisplacedPoint/.FigOptions)=!=None),
(* curve *)
FigLineElement[
{Line[CanvasPoints]},
FigOptions
];
(* arrowheads *)
FigLineElement[
{Line[FigCurveArrowheadPoints[
Self@MakeAnchor[Tail,None],
Self@MakeAnchor[Head,None],
FigOptions
]]},
Flatten[{LineDashing->None,FigOptions}]
];
];

(* make text *)
TextElement=FigTextElement[
Anchor,
TextArt,
FigOptions
];

(* save references to spawned objects *)
Self@SetTheAnchor[Anchor];
Self@SetTextElement[TextElement];

];


Constructor[Class:FigLabel,Self_Object][TextArt_,Opts___?OptionQ]:=FigObjectWrapper[Class,Self,{Opts},

(* validate special option *)
FigCheckOption[Self,Point,FigPointPattern,FigOptions];

BasicLabel[Self][FigAnchor[(Point/.FigOptions)],TextArt]

];


Constructor[Class:FigLabel,Self_Object][p:FigPointPattern,TextArt_,Opts___?OptionQ]:=FigObjectWrapper[Class,Self,{Opts},
BasicLabel[Self][FigAnchor[p],TextArt]
];


Constructor[Class:FigLabel,Self_Object][(n:ObjectNamePattern[FigObject]),Name_,AnchorArg:_:None,TextArt:Except[_?OptionQ],Opts___?OptionQ]:=FigObjectWrapper[Class,Self,{Opts},
(*Print[n," ",Name," ",TextArt," ",{Opts}];*)
BasicLabel[Self][
FigAnchor[n,Name,ResolveOption[Position,{Automatic->AnchorArg},FigOptions]],
TextArt
]
];


(* rectangle-style anchor points, deduced from text element *)
MakeAnchor[Class:FigLabel,Self_Object][Name:Except[(Head|Tail)],Arg_]:=FigMakeAnchorWrapper[Class,Self,Name,Arg,
FigRectangleAnchor[
(Self@GetTextElement[])@GetCenter[],(Self@GetTextElement[])@GetRadius[],(Self@GetTextElement[])@GetPivot[],(Self@GetTextElement[])@GetRotation[],
Name,Arg
]
];


(* curve-style anchor points, from callout curve -- needed for arrowhead generation -- only define Head/Tail*)
MakeAnchor[Class:FigLabel,Self_Object][Name:(Head|Tail),Arg:_]:=FigMakeAnchorWrapper[Class,Self,Name,Arg,
FigCurveAnchorFromPoints[Self@GetPoints[],Name,Arg]
];


MakeBoundingBox[Class:FigLabel,Self_Object][]:=FigRectangleBoundingBox[
(Self@GetTextElement[])@GetCenter[],(Self@GetTextElement[])@GetRadius[],(Self@GetTextElement[])@GetPivot[],(Self@GetTextElement[])@GetRotation[]
];


End[];


Protect[Evaluate[$Context<>"*"]];
Unprotect[Evaluate[$Context<>"$*"]];
EndPackage[];
