(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[   1962030,      40887]
NotebookOptionsPosition[   1954446,      40650]
NotebookOutlinePosition[   1955313,      40680]
CellTagsIndexPosition[   1955270,      40677]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData["  "], "Input",
 CellChangeTimes->{{3.5663259382387295`*^9, 3.566325938847131*^9}}],

Cell[TextData[StyleBox["SciDraw examples: Plots",
 FontFamily->"Times New Roman",
 FontSize->36]], "Text",
 CellChangeTimes->{{3.4912582924375*^9, 3.4912582936875*^9}, {
   3.4912586879375*^9, 3.49125868853125*^9}, {3.4990222156875*^9, 
   3.499022216765625*^9}, {3.51812290828125*^9, 3.518122909421875*^9}, 
   3.5837845428840714`*^9},
 FontSize->10],

Cell[TextData[{
 StyleBox["M. A. Caprio, ", "SmallText",
  FontFamily->"Times New Roman",
  FontSize->12],
 "Department of Physics, University of Notre Dame\nrev. November 16, 2014"
}], "Text",
 CellChangeTimes->{{3.39552255203125*^9, 3.3955225581875*^9}, {
   3.396878383875*^9, 3.39687838403125*^9}, 3.397586352671875*^9, {
   3.39854548165625*^9, 3.398545486203125*^9}, {3.430247945015625*^9, 
   3.430247947875*^9}, {3.436820309328125*^9, 3.436820313328125*^9}, {
   3.443996368375*^9, 3.443996375046875*^9}, {3.47108965090625*^9, 
   3.471089655984375*^9}, {3.497225037953125*^9, 3.497225038359375*^9}, {
   3.5666842678508472`*^9, 3.566684268209648*^9}, {3.5837845474860797`*^9, 
   3.583784548718482*^9}, 3.5840542485996447`*^9, {3.6224180058048277`*^9, 
   3.6224180083148313`*^9}, {3.6251802132384424`*^9, 3.625180214829645*^9}}],

Cell[CellGroupData[{

Cell["Package initialization", "Section"],

Cell[TextData[{
 "If you have not already loaded the SciDraw package since starting this ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " session, you must do so now.  See the user guide for information first on \
installing the package and then on loading it at the beginning of each ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " session."
}], "Text",
 CellChangeTimes->{{3.4921245209375*^9, 3.492124756234375*^9}, {
  3.492124799609375*^9, 3.492124838453125*^9}, {3.495659733515625*^9, 
  3.495659808359375*^9}, {3.5181229165*^9, 3.51812291978125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", "\"\<SciDraw`\>\"", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.492124284765625*^9, 3.49212429721875*^9}, 
   3.492124551328125*^9, {3.51812292428125*^9, 3.51812292534375*^9}}],

Cell[BoxData[
 FrameBox[
  TemplateBox[{TagBox[
     GridBox[{{
        StyleBox[
         TemplateBox[{
           StyleBox[
           "\"\[ScriptCapitalS]\[ScriptC]\[ScriptI]\[ScriptCapitalD]\[ScriptR]\
\[ScriptA]\[ScriptW]:\"", StripOnInput -> False, FontFamily -> "Times", 
            FontWeight -> "Bold"], 
           "\" Publication\[Dash]quality scientific figures with \
Mathematica\""}, "RowDefault"], StripOnInput -> False, FontFamily -> 
         "Courier"]}, {
        StyleBox[
        "\"M. A. Caprio, University of Notre Dame\"", StripOnInput -> False, 
         FontFamily -> "Courier"]}, {
        StyleBox[
        "\"Version 0.0.0 (November 24, 2013)\"", StripOnInput -> False, 
         FontFamily -> "Courier"]}, {
        RowBox[{
          ButtonBox[
           StyleBox[
            RowBox[{"View", " ", "color", " ", "palette"}], FontFamily -> 
            "Times"], Active -> True, Appearance -> {Automatic, "DialogBox"}, 
           ButtonFunction :> (NamedColors`NamedColorPalette[]& ), ButtonNote -> 
           "Named color palette", Evaluator -> Automatic, ImageSize -> 
           Automatic], 
          TagBox[
           ButtonBox[
            StyleBox[
             RowBox[{"Visit", " ", "home", " ", "page"}], FontFamily -> 
             "Times"], Active -> True, Appearance -> {Automatic, "DialogBox"},
             ButtonData :> {
              URL["http://scidraw.nd.edu/landing/scidraw-0.0.0.html"], None}, 
            ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookLocate[#2]}]& ), ButtonNote -> 
            "http://scidraw.nd.edu/landing/scidraw-0.0.0.html", ImageSize -> 
            Automatic], DisplayForm]}]}}, 
      GridBoxAlignment -> {
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}}], DisplayForm],"\"  \"",GraphicsBox[{{{
        FaceForm[None], 
        RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
        InsetBox[
         GraphicsBox[{
           EdgeForm[None], 
           FaceForm[
            RGBColor[1., 0.894101, 0.709799]], 
           RectangleBox[{0., 0.}, {93.1764705882353, 72.}]}, Frame -> False, 
          ImageSize -> {95.1764705882353, 74.}, 
          PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0, 
         0}]}, {
        FaceForm[None], 
        RectangleBox[{0., 0.}, {93.1764705882353, 72.}], 
        InsetBox[
         GraphicsBox[{{
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             GraphicsBox[{{
                GrayLevel[0], 
                AbsoluteThickness[1], 
                Dashing[{}], 
                CapForm[None], 
                JoinForm[{"Miter", 3.25}], 
                
                LineBox[{{14.782805429864256`, 46.24615384615386}, {
                 43.58047834518423, 46.24615384615386}}]}, {
                GrayLevel[0], 
                AbsoluteThickness[1], 
                Dashing[{}], 
                CapForm[None], 
                JoinForm[{"Miter", 3.25}], 
                
                LineBox[{{20.54234001292825, 36.150000000000006`}, {
                 23.54234001292825, 36.150000000000006`}, {25.54234001292825, 
                 32.400000000000006`}, {44.34001292824823, 
                 32.400000000000006`}, {46.34001292824823, 
                 36.150000000000006`}, {49.34001292824823, 
                 36.150000000000006`}}]}, {
                GrayLevel[0], 
                AbsoluteThickness[1], 
                Dashing[{}], 
                CapForm[None], 
                JoinForm[{"Miter", 3.25}], 
                
                LineBox[{{26.301874595992246`, 18.553846153846155`}, {
                 55.099547511312224`, 18.553846153846155`}}]}, {
                EdgeForm[{
                  GrayLevel[0], 
                  AbsoluteThickness[1], 
                  Dashing[{}], 
                  CapForm[None], 
                  JoinForm[{"Miter", 3.25}]}], 
                FaceForm[
                 GrayLevel[0.5]], 
                
                PolygonBox[{{34.418791692075665`, 46.24615384615386}, {
                 29.704026666036818`, 46.24615384615386}, {
                 37.415840042594645`, 33.886479882377664`}, {
                 36.90680088862935, 33.568865116143016`}, {
                 40.700711053652235`, 32.400000000000006`}, {
                 41.31847355632861, 36.321526423509994`}, {40.80943440236331, 
                 36.00391165727534}}]}, {
                EdgeForm[{
                  GrayLevel[0], 
                  AbsoluteThickness[1], 
                  Dashing[{}], 
                  CapForm[None], 
                  JoinForm[{"Miter", 3.25}]}], 
                FaceForm[
                 GrayLevel[0.5]], 
                
                PolygonBox[{{32.97890804630967, 32.400000000000006`}, {
                 28.26414302027082, 32.400000000000006`}, {35.97595639682864, 
                 20.040326036223817`}, {35.466917242863346`, 
                 19.722711269989166`}, {39.26082740788623, 
                 18.553846153846155`}, {39.87858991056261, 
                 22.47537257735614}, {39.369550756597306`, 
                 22.157757811121492`}}]}}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{0., 0.}, {93.17647058823529, 72.}], 
            InsetBox[
             GraphicsBox[{{
                EdgeForm[None], 
                FaceForm[
                 RGBColor[0.5, 0.539994, 0.53]], 
                PolygonBox[CompressedData["
1:eJx13Xk0F9//B3B7CG1SSqgkpCxFRZpRoYVIUrQoaaNFIoqkQiupT4lKpLK0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                 "]]}, {
                RGBColor[1, 0, 0], 
                AbsoluteThickness[1], 
                Dashing[{}], 
                CapForm[None], 
                JoinForm[{"Miter", 3.25}], 
                LineBox[CompressedData["
1:eJx13XlUD9//B/B2lcpSIlIhSaKFQslMqCylJGlBJFtZkiJKQmUt8VEKKSFl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                 "]]}}, Frame -> False, ImageSize -> {93.17647058823529, 72.},
               PlotRange -> {{0., 93.17647058823529}, {0., 72.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, 
           InsetBox[
            FrameBox[
             StyleBox[
              StyleBox[
               TagBox[
               "\"\[ScriptCapitalS]\[ScriptC]\[ScriptI]\[ScriptCapitalD]\
\[ScriptR]\[ScriptA]\[ScriptW]\"", DisplayForm], StripOnInput -> False, 
               ShowAutoStyles -> False, SingleLetterItalics -> False, 
               FontFamily -> "Times", FontSize -> 14.5, FontWeight -> Bold, 
               FontSlant -> Plain, FontTracking -> "Extended"], StripOnInput -> 
              False, ShowContents -> False], Background -> None, 
             ContentPadding -> False, FrameMargins -> {{0, 0}, {0, 0}}, 
             FrameStyle -> None, RoundingRadius -> {0, 0}, StripOnInput -> 
             False], {4.658823529411765, 64.8}, {-1, 1}, Automatic, {1, 0}], 
           InsetBox[
            FrameBox[
             StyleBox[
              TagBox[
              "\"\[ScriptCapitalS]\[ScriptC]\[ScriptI]\[ScriptCapitalD]\
\[ScriptR]\[ScriptA]\[ScriptW]\"", DisplayForm], StripOnInput -> False, 
              ShowAutoStyles -> False, SingleLetterItalics -> False, 
              FontFamily -> "Times", FontSize -> 14.5, FontWeight -> Bold, 
              FontSlant -> Plain, FontTracking -> "Extended"], Background -> 
             None, ContentPadding -> False, FrameMargins -> {{0, 0}, {0, 0}}, 
             FrameStyle -> None, RoundingRadius -> {0, 0}, StripOnInput -> 
             False], {4.658823529411765, 64.8}, {-1, 1}, Automatic, {1, 0}]}, 
          Frame -> False, ImageSize -> {93.1764705882353, 72.}, 
          PlotRange -> {{0., 93.1764705882353}, {0., 72.}}], {0, 0}, {0, 
         0}]}, {
        FaceForm[None], 
        RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
        InsetBox[
         GraphicsBox[{}, Frame -> False, ImageSize -> {95.1764705882353, 74.},
           PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0, 
         0}]}, {
        FaceForm[None], 
        RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
        InsetBox[
         GraphicsBox[{{
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{0., 0.}, {0., 72.}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{}, {}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{93.1764705882353, 0.}, {93.1764705882353, 72.}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{}, {}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{0., 0.}, {93.1764705882353, 0.}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{}, {}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{0., 72.}, {93.1764705882353, 72.}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{}, {}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}]}}, Frame -> False, 
          ImageSize -> {95.1764705882353, 74.}, 
          PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0, 
         0}]}}, {}}, AspectRatio -> 0.7775030902348578, Background -> None, 
     DisplayFunction -> Identity, Frame -> False, 
     ImageSize -> {95.1764705882353, 74.}, 
     PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}]},
   "RowDefault"],
  Background->GrayLevel[0.85],
  FrameMargins->10,
  FrameStyle->None,
  StripOnInput->False]], "Print",
 CellChangeTimes->{3.521400818890625*^9, 3.52474810590625*^9, 
  3.5662579270603805`*^9, 3.5662579628524303`*^9, 3.566258085496815*^9, 
  3.5662597084083395`*^9, 3.5663381441395884`*^9, 3.579121894620434*^9, 
  3.5846175923475733`*^9, 3.5846186685950637`*^9, 3.594304587035236*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Mini-tutorial: An introduction to data plotting", "Section",
 CellChangeTimes->{{3.5184824335*^9, 3.51848243953125*^9}, {
   3.51856222439225*^9, 3.518562233689125*^9}, {3.520947757453125*^9, 
   3.5209477681875*^9}, {3.583784454619117*^9, 3.5837844589403243`*^9}, 
   3.584374848376128*^9, {3.584376510204197*^9, 3.584376512774201*^9}, {
   3.5943046272833066`*^9, 3.5943046300289116`*^9}}],

Cell[TextData[{
 StyleBox["To view the examples below:",
  FontWeight->"Bold"],
 " Double-click on the downward arrow on the \[OpenCurlyDoubleQuote]bracket\
\[CloseCurlyDoubleQuote] at the right side of each header line."
}], "Text",
 CellChangeTimes->{{3.524748239359375*^9, 3.52474829528125*^9}}],

Cell[CellGroupData[{

Cell["SETUP -- be sure to evaluate both of the cells below first!", \
"Subsection",
 CellChangeTimes->{{3.5843748985232153`*^9, 3.5843749002860184`*^9}, {
  3.5843756409020767`*^9, 3.584375667509985*^9}, {3.584376458616912*^9, 
  3.5843764816425524`*^9}, {3.5930079404747205`*^9, 3.5930079447947264`*^9}}],

Cell[TextData[{
 "First let us make up some data, in tabular format -- in this example each \
row is meant to be an ",
 StyleBox["x",
  FontSlant->"Italic"],
 " value, a ",
 StyleBox["y",
  FontSlant->"Italic"],
 " value, and an error bar."
}], "Text",
 CellChangeTimes->{{3.5843749090064335`*^9, 3.5843749585053205`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Data", "=", 
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{"Sin", "[", "x", "]"}], ",", 
        RowBox[{"Abs", "[", 
         RowBox[{"0.3", "*", 
          RowBox[{"Cos", "[", "x", "]"}]}], "]"}]}], "}"}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{"2", "*", "Pi"}], ",", 
       RowBox[{"2", "*", 
        RowBox[{"Pi", "/", "16"}]}]}], "}"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\n", 
 RowBox[{"Data", "//", "TableForm"}]}], "Input",
 CellChangeTimes->{{3.58437490661963*^9, 3.5843749068692303`*^9}, {
  3.584374943825695*^9, 3.5843749765857525`*^9}, {3.5843757175907545`*^9, 
  3.58437571992079*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"0.`", "0.`", "0.3`"},
    {"0.39269908169872414`", "0.3826834323650898`", "0.27716385975338603`"},
    {"0.7853981633974483`", "0.7071067811865475`", "0.21213203435596423`"},
    {"1.1780972450961724`", "0.9238795325112867`", "0.11480502970952693`"},
    {"1.5707963267948966`", "1.`", "0.`"},
    {"1.9634954084936207`", "0.9238795325112867`", "0.11480502970952693`"},
    {"2.356194490192345`", "0.7071067811865475`", "0.21213203435596423`"},
    {"2.748893571891069`", "0.3826834323650898`", "0.27716385975338603`"},
    {"3.141592653589793`", "0.`", "0.3`"},
    {"3.5342917352885173`", 
     RowBox[{"-", "0.3826834323650898`"}], "0.27716385975338603`"},
    {"3.9269908169872414`", 
     RowBox[{"-", "0.7071067811865475`"}], "0.21213203435596423`"},
    {"4.319689898685965`", 
     RowBox[{"-", "0.9238795325112867`"}], "0.11480502970952693`"},
    {"4.71238898038469`", 
     RowBox[{"-", "1.`"}], "0.`"},
    {"5.105088062083414`", 
     RowBox[{"-", "0.9238795325112867`"}], "0.11480502970952693`"},
    {"5.497787143782138`", 
     RowBox[{"-", "0.7071067811865475`"}], "0.21213203435596423`"},
    {"5.890486225480862`", 
     RowBox[{"-", "0.3826834323650898`"}], "0.27716385975338603`"},
    {"6.283185307179586`", "0.`", "0.3`"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{
  3.5843749890189743`*^9, 3.5843757205583*^9, 3.5843758167580285`*^9, 
   3.5846177138249865`*^9, 3.5846186825258884`*^9, 3.593007950664735*^9, 
   3.593009361413111*^9, 3.5930103533515368`*^9, {3.5943046158640866`*^9, 
   3.5943046458317394`*^9}, 3.6222336314015102`*^9, 3.622234612175233*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"DefineStyle", "[", 
  RowBox[{"\"\<ExampleDataFigure\>\"", ",", "\[IndentingNewLine]", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"FigurePanel", "\[Rule]", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"XPlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", 
          RowBox[{"2", "*", "Pi"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"XExtendRange", "\[Rule]", "0.05"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"XFrameLabel", "\[Rule]", 
        RowBox[{"Row", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"textit", "[", "\"\<t\>\"", "]"}], ",", "\"\< (s)\>\""}], 
          "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"XFrameLabelPosition", "\[Rule]", "1"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"YPlotRange", "->", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "2"}], ",", "2"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"YFrameLabel", "\[Rule]", 
        RowBox[{"Row", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"textit", "[", "\"\<y\>\"", "]"}], ",", "\"\< (m)\>\""}], 
          "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"YFrameLabelPosition", "\[Rule]", "1"}]}], 
      "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "}"}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.5843756716250486`*^9, 3.5843757366635475`*^9}, {
   3.5846186947407093`*^9, 3.5846187002475195`*^9}, 3.5930080310348473`*^9, 
   3.593009381548139*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Basic plot", "Subsection",
 CellChangeTimes->{{3.584375003917001*^9, 3.584375005445803*^9}}],

Cell["Here is a basic data plot, with no options...", "Text",
 CellChangeTimes->{{3.5843750135110173`*^9, 3.5843750208118305`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"DataPlot", "[", "Data", "]"}], ";"}], "\[IndentingNewLine]", 
      "}"}], "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Style", "->", "\"\<ExampleDataFigure\>\""}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.5843750252578382`*^9, 3.5843750429170694`*^9}, 
   3.584375148569232*^9, {3.584375744728671*^9, 3.5843757511262693`*^9}, 
   3.5930093817581396`*^9, {3.5943047800387745`*^9, 3.5943047810683765`*^9}}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {432., 306.}]}, InsetBox[
      GraphicsBox[{
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{19.636363636363637`, 153.}, {44.18181818181819, 
          182.27528257592937`}, {68.72727272727273, 207.09366876077087`}, {
          93.27272727272728, 223.67678423711345`}, {117.81818181818183`, 
          229.5}, {142.36363636363637`, 223.67678423711345`}, {
          166.9090909090909, 207.09366876077087`}, {191.45454545454544`, 
          182.27528257592937`}, {216., 153.}, {240.54545454545453`, 
          123.72471742407063`}, {265.0909090909091, 98.90633123922912}, {
          289.6363636363636, 82.32321576288656}, {314.1818181818182, 76.5}, {
          338.72727272727275`, 82.32321576288656}, {363.27272727272725`, 
          98.90633123922912}, {387.8181818181818, 123.72471742407063`}, {
          412.3636363636364, 153.}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{20.791213052002746`, 153.47835429045637`}, {
            20.52024711284682, 153.8838834764832}, {20.11471792682, 
            154.15484941563912`}, {19.636363636363637`, 154.25}, {
            19.158009345907274`, 154.15484941563912`}, {18.752480159880452`, 
            153.8838834764832}, {18.481514220724527`, 153.47835429045637`}, {
            18.386363636363637`, 153.}, {18.481514220724527`, 
            152.52164570954363`}, {18.752480159880452`, 152.1161165235168}, {
            19.158009345907274`, 151.84515058436088`}, {19.636363636363637`, 
            151.75}, {20.11471792682, 151.84515058436088`}, {
            20.52024711284682, 152.1161165235168}, {20.791213052002746`, 
            152.52164570954363`}, {20.886363636363637`, 153.}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{45.33666759745729, 182.75363686638573`}, {
            45.06570165830137, 183.15916605241256`}, {44.660172472274546`, 
            183.4301319915685}, {44.18181818181819, 183.52528257592937`}, {
            43.70346389136183, 183.4301319915685}, {43.297934705335, 
            183.15916605241256`}, {43.02696876617908, 182.75363686638573`}, {
            42.93181818181819, 182.27528257592937`}, {43.02696876617908, 
            181.796928285473}, {43.297934705335, 181.39139909944618`}, {
            43.70346389136183, 181.12043316029025`}, {44.18181818181819, 
            181.02528257592937`}, {44.660172472274546`, 
            181.12043316029025`}, {45.06570165830137, 181.39139909944618`}, {
            45.33666759745729, 181.796928285473}, {45.43181818181819, 
            182.27528257592937`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{69.88212214291184, 207.57202305122723`}, {
            69.61115620375591, 207.97755223725406`}, {69.2056270177291, 
            208.24851817641}, {68.72727272727273, 208.34366876077087`}, {
            68.24891843681637, 208.24851817641}, {67.84338925078956, 
            207.97755223725406`}, {67.57242331163363, 207.57202305122723`}, {
            67.47727272727273, 207.09366876077087`}, {67.57242331163363, 
            206.6153144703145}, {67.84338925078956, 206.20978528428768`}, {
            68.24891843681637, 205.93881934513175`}, {68.72727272727273, 
            205.84366876077087`}, {69.2056270177291, 205.93881934513175`}, {
            69.61115620375591, 206.20978528428768`}, {69.88212214291184, 
            206.6153144703145}, {69.97727272727273, 207.09366876077087`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{94.42757668836639, 224.15513852756982`}, {
            94.15661074921046, 224.56066771359664`}, {93.75108156318365, 
            224.83163365275257`}, {93.27272727272728, 224.92678423711345`}, {
            92.79437298227091, 224.83163365275257`}, {92.3888437962441, 
            224.56066771359664`}, {92.11787785708817, 224.15513852756982`}, {
            92.02272727272728, 223.67678423711345`}, {92.11787785708817, 
            223.1984299466571}, {92.3888437962441, 222.79290076063026`}, {
            92.79437298227091, 222.52193482147433`}, {93.27272727272728, 
            222.42678423711345`}, {93.75108156318365, 222.52193482147433`}, {
            94.15661074921046, 222.79290076063026`}, {94.42757668836639, 
            223.1984299466571}, {94.52272727272728, 223.67678423711345`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{118.97303123382093`, 229.97835429045637`}, {
            118.702065294665, 230.3838834764832}, {118.2965361086382, 
            230.65484941563912`}, {117.81818181818183`, 230.75}, {
            117.33982752772546`, 230.65484941563912`}, {116.93429834169865`, 
            230.3838834764832}, {116.66333240254272`, 229.97835429045637`}, {
            116.56818181818183`, 229.5}, {116.66333240254272`, 
            229.02164570954363`}, {116.93429834169865`, 228.6161165235168}, {
            117.33982752772546`, 228.34515058436088`}, {117.81818181818183`, 
            228.25}, {118.2965361086382, 228.34515058436088`}, {
            118.702065294665, 228.6161165235168}, {118.97303123382093`, 
            229.02164570954363`}, {119.06818181818183`, 229.5}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{143.5184857792755, 224.15513852756982`}, {
            143.24751984011957`, 224.56066771359664`}, {142.84199065409274`, 
            224.83163365275257`}, {142.36363636363637`, 
            224.92678423711345`}, {141.88528207318, 224.83163365275257`}, {
            141.47975288715318`, 224.56066771359664`}, {141.20878694799725`, 
            224.15513852756982`}, {141.11363636363637`, 
            223.67678423711345`}, {141.20878694799725`, 223.1984299466571}, {
            141.47975288715318`, 222.79290076063026`}, {141.88528207318, 
            222.52193482147433`}, {142.36363636363637`, 
            222.42678423711345`}, {142.84199065409274`, 
            222.52193482147433`}, {143.24751984011957`, 
            222.79290076063026`}, {143.5184857792755, 223.1984299466571}, {
            143.61363636363637`, 223.67678423711345`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{168.06394032473003`, 207.57202305122723`}, {
            167.7929743855741, 207.97755223725406`}, {167.38744519954727`, 
            208.24851817641}, {166.9090909090909, 208.34366876077087`}, {
            166.43073661863454`, 208.24851817641}, {166.02520743260771`, 
            207.97755223725406`}, {165.7542414934518, 207.57202305122723`}, {
            165.6590909090909, 207.09366876077087`}, {165.7542414934518, 
            206.6153144703145}, {166.02520743260771`, 206.20978528428768`}, {
            166.43073661863454`, 205.93881934513175`}, {166.9090909090909, 
            205.84366876077087`}, {167.38744519954727`, 
            205.93881934513175`}, {167.7929743855741, 206.20978528428768`}, {
            168.06394032473003`, 206.6153144703145}, {168.1590909090909, 
            207.09366876077087`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{192.60939487018456`, 182.75363686638573`}, {
            192.33842893102863`, 183.15916605241256`}, {191.9328997450018, 
            183.4301319915685}, {191.45454545454544`, 183.52528257592937`}, {
            190.97619116408907`, 183.4301319915685}, {190.57066197806225`, 
            183.15916605241256`}, {190.29969603890632`, 
            182.75363686638573`}, {190.20454545454544`, 
            182.27528257592937`}, {190.29969603890632`, 181.796928285473}, {
            190.57066197806225`, 181.39139909944618`}, {190.97619116408907`, 
            181.12043316029025`}, {191.45454545454544`, 
            181.02528257592937`}, {191.9328997450018, 181.12043316029025`}, {
            192.33842893102863`, 181.39139909944618`}, {192.60939487018456`, 
            181.796928285473}, {192.70454545454544`, 
            182.27528257592937`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{217.15484941563912`, 153.47835429045637`}, {
            216.8838834764832, 153.8838834764832}, {216.47835429045637`, 
            154.15484941563912`}, {216., 154.25}, {215.52164570954363`, 
            154.15484941563912`}, {215.1161165235168, 153.8838834764832}, {
            214.84515058436088`, 153.47835429045637`}, {214.75, 153.}, {
            214.84515058436088`, 152.52164570954363`}, {215.1161165235168, 
            152.1161165235168}, {215.52164570954363`, 151.84515058436088`}, {
            216., 151.75}, {216.47835429045637`, 151.84515058436088`}, {
            216.8838834764832, 152.1161165235168}, {217.15484941563912`, 
            152.52164570954363`}, {217.25, 153.}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{241.70030396109365`, 124.203071714527}, {
            241.42933802193772`, 124.60860090055381`}, {241.0238088359109, 
            124.87956683970974`}, {240.54545454545453`, 
            124.97471742407063`}, {240.06710025499817`, 
            124.87956683970974`}, {239.66157106897134`, 
            124.60860090055381`}, {239.3906051298154, 124.203071714527}, {
            239.29545454545453`, 123.72471742407063`}, {239.3906051298154, 
            123.24636313361427`}, {239.66157106897134`, 
            122.84083394758746`}, {240.06710025499817`, 
            122.56986800843153`}, {240.54545454545453`, 
            122.47471742407063`}, {241.0238088359109, 122.56986800843153`}, {
            241.42933802193772`, 122.84083394758746`}, {241.70030396109365`, 
            123.24636313361427`}, {241.79545454545453`, 
            123.72471742407063`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{266.2457585065482, 99.38468552968548}, {
            265.9747925673923, 99.7902147157123}, {265.5692633813655, 
            100.06118065486822`}, {265.0909090909091, 100.15633123922912`}, {
            264.61255480045276`, 100.06118065486822`}, {264.20702561442596`, 
            99.7902147157123}, {263.93605967527003`, 99.38468552968548}, {
            263.8409090909091, 98.90633123922912}, {263.93605967527003`, 
            98.42797694877275}, {264.20702561442596`, 98.02244776274594}, {
            264.61255480045276`, 97.75148182359001}, {265.0909090909091, 
            97.65633123922912}, {265.5692633813655, 97.75148182359001}, {
            265.9747925673923, 98.02244776274594}, {266.2457585065482, 
            98.42797694877275}, {266.3409090909091, 98.90633123922912}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{290.7912130520027, 82.80157005334293}, {
            290.5202471128468, 83.20709923936974}, {290.11471792682, 
            83.47806517852567}, {289.6363636363636, 83.57321576288656}, {
            289.15800934590726`, 83.47806517852567}, {288.75248015988046`, 
            83.20709923936974}, {288.48151422072453`, 82.80157005334293}, {
            288.3863636363636, 82.32321576288656}, {288.48151422072453`, 
            81.8448614724302}, {288.75248015988046`, 81.43933228640338}, {
            289.15800934590726`, 81.16836634724746}, {289.6363636363636, 
            81.07321576288656}, {290.11471792682, 81.16836634724746}, {
            290.5202471128468, 81.43933228640338}, {290.7912130520027, 
            81.8448614724302}, {290.8863636363636, 82.32321576288656}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{315.3366675974573, 76.97835429045637}, {
            315.06570165830135`, 77.38388347648318}, {314.66017247227455`, 
            77.6548494156391}, {314.1818181818182, 77.75}, {313.7034638913618,
             77.6548494156391}, {313.297934705335, 77.38388347648318}, {
            313.0269687661791, 76.97835429045637}, {312.9318181818182, 
            76.5}, {313.0269687661791, 76.02164570954363}, {313.297934705335, 
            75.61611652351682}, {313.7034638913618, 75.3451505843609}, {
            314.1818181818182, 75.25}, {314.66017247227455`, 
            75.3451505843609}, {315.06570165830135`, 75.61611652351682}, {
            315.3366675974573, 76.02164570954363}, {315.4318181818182, 
            76.5}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{339.88212214291184`, 82.80157005334293}, {
            339.6111562037559, 83.20709923936974}, {339.2056270177291, 
            83.47806517852567}, {338.72727272727275`, 83.57321576288656}, {
            338.2489184368164, 83.47806517852567}, {337.8433892507896, 
            83.20709923936974}, {337.57242331163366`, 82.80157005334293}, {
            337.47727272727275`, 82.32321576288656}, {337.57242331163366`, 
            81.8448614724302}, {337.8433892507896, 81.43933228640338}, {
            338.2489184368164, 81.16836634724746}, {338.72727272727275`, 
            81.07321576288656}, {339.2056270177291, 81.16836634724746}, {
            339.6111562037559, 81.43933228640338}, {339.88212214291184`, 
            81.8448614724302}, {339.97727272727275`, 82.32321576288656}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{364.42757668836634`, 99.38468552968548}, {
            364.1566107492104, 99.7902147157123}, {363.7510815631836, 
            100.06118065486822`}, {363.27272727272725`, 
            100.15633123922912`}, {362.7943729822709, 100.06118065486822`}, {
            362.3888437962441, 99.7902147157123}, {362.11787785708816`, 
            99.38468552968548}, {362.02272727272725`, 98.90633123922912}, {
            362.11787785708816`, 98.42797694877275}, {362.3888437962441, 
            98.02244776274594}, {362.7943729822709, 97.75148182359001}, {
            363.27272727272725`, 97.65633123922912}, {363.7510815631836, 
            97.75148182359001}, {364.1566107492104, 98.02244776274594}, {
            364.42757668836634`, 98.42797694877275}, {364.52272727272725`, 
            98.90633123922912}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{388.9730312338209, 124.203071714527}, {
            388.702065294665, 124.60860090055381`}, {388.2965361086382, 
            124.87956683970974`}, {387.8181818181818, 124.97471742407063`}, {
            387.33982752772545`, 124.87956683970974`}, {386.93429834169865`, 
            124.60860090055381`}, {386.6633324025427, 124.203071714527}, {
            386.5681818181818, 123.72471742407063`}, {386.6633324025427, 
            123.24636313361427`}, {386.93429834169865`, 
            122.84083394758746`}, {387.33982752772545`, 
            122.56986800843153`}, {387.8181818181818, 122.47471742407063`}, {
            388.2965361086382, 122.56986800843153`}, {388.702065294665, 
            122.84083394758746`}, {388.9730312338209, 123.24636313361427`}, {
            389.0681818181818, 123.72471742407063`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{413.51848577927547`, 153.47835429045637`}, {
            413.24751984011954`, 153.8838834764832}, {412.84199065409274`, 
            154.15484941563912`}, {412.3636363636364, 154.25}, {
            411.88528207318, 154.15484941563912`}, {411.4797528871532, 
            153.8838834764832}, {411.2087869479973, 153.47835429045637`}, {
            411.1136363636364, 153.}, {411.2087869479973, 
            152.52164570954363`}, {411.4797528871532, 152.1161165235168}, {
            411.88528207318, 151.84515058436088`}, {412.3636363636364, 
            151.75}, {412.84199065409274`, 151.84515058436088`}, {
            413.24751984011954`, 152.1161165235168}, {413.51848577927547`, 
            152.52164570954363`}, {413.6136363636364, 153.}}]}}}},
       Frame->False,
       ImageSize->{432., 306.},
       PlotRange->{{0., 432.}, {0., 306.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {0., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{3.69, 0.}, {0., 0.}}], 
         LineBox[{{1.845, 15.299999999999983`}, {0., 15.299999999999983`}}], 
         LineBox[{{1.845, 30.599999999999994`}, {0., 30.599999999999994`}}], 
         LineBox[{{1.845, 45.900000000000006`}, {0., 45.900000000000006`}}], 
         LineBox[{{1.845, 61.2}, {0., 61.2}}], 
         LineBox[{{3.69, 76.5}, {0., 76.5}}], 
         LineBox[{{1.845, 91.8}, {0., 91.8}}], 
         LineBox[{{1.845, 107.1}, {0., 107.1}}], 
         LineBox[{{1.845, 122.4}, {0., 122.4}}], 
         LineBox[{{1.845, 137.7}, {0., 137.7}}], 
         LineBox[{{3.69, 153.}, {0., 153.}}], 
         LineBox[{{1.845, 168.3}, {0., 168.3}}], 
         LineBox[{{1.845, 183.6}, {0., 183.6}}], 
         LineBox[{{1.845, 198.9}, {0., 198.9}}], 
         LineBox[{{1.845, 214.2}, {0., 214.2}}], 
         LineBox[{{3.69, 229.5}, {0., 229.5}}], 
         LineBox[{{1.845, 244.8}, {0., 244.8}}], 
         LineBox[{{1.845, 260.1}, {0., 260.1}}], 
         LineBox[{{1.845, 275.4}, {0., 275.4}}], 
         LineBox[{{1.845, 290.70000000000005`}, {0., 290.70000000000005`}}], 
         LineBox[{{3.69, 306.}, {0., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{432., 0.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{428.31, 0.}, {432., 0.}}], 
         LineBox[{{430.155, 15.299999999999983`}, {432., 
          15.299999999999983`}}], 
         LineBox[{{430.155, 30.599999999999994`}, {432., 
          30.599999999999994`}}], 
         LineBox[{{430.155, 45.900000000000006`}, {432., 
          45.900000000000006`}}], LineBox[{{430.155, 61.2}, {432., 61.2}}], 
         LineBox[{{428.31, 76.5}, {432., 76.5}}], 
         LineBox[{{430.155, 91.8}, {432., 91.8}}], 
         LineBox[{{430.155, 107.1}, {432., 107.1}}], 
         LineBox[{{430.155, 122.4}, {432., 122.4}}], 
         LineBox[{{430.155, 137.7}, {432., 137.7}}], 
         LineBox[{{428.31, 153.}, {432., 153.}}], 
         LineBox[{{430.155, 168.3}, {432., 168.3}}], 
         LineBox[{{430.155, 183.6}, {432., 183.6}}], 
         LineBox[{{430.155, 198.9}, {432., 198.9}}], 
         LineBox[{{430.155, 214.2}, {432., 214.2}}], 
         LineBox[{{428.31, 229.5}, {432., 229.5}}], 
         LineBox[{{430.155, 244.8}, {432., 244.8}}], 
         LineBox[{{430.155, 260.1}, {432., 260.1}}], 
         LineBox[{{430.155, 275.4}, {432., 275.4}}], 
         LineBox[{{430.155, 290.70000000000005`}, {432., 
          290.70000000000005`}}], LineBox[{{428.31, 306.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {432., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{7.135466288054765, 1.845}, {7.135466288054765, 0.}}], 
         LineBox[{{19.636363636363637`, 3.69}, {19.636363636363637`, 0.}}], 
         LineBox[{{32.13726098467251, 1.845}, {32.13726098467251, 0.}}], 
         LineBox[{{44.63815833298138, 1.845}, {44.63815833298138, 0.}}], 
         LineBox[{{57.13905568129026, 1.845}, {57.13905568129026, 0.}}], 
         LineBox[{{69.63995302959913, 1.845}, {69.63995302959913, 0.}}], 
         LineBox[{{82.140850377908, 3.69}, {82.140850377908, 0.}}], 
         LineBox[{{94.64174772621686, 1.845}, {94.64174772621686, 0.}}], 
         LineBox[{{107.14264507452573`, 1.845}, {107.14264507452573`, 0.}}], 
         LineBox[{{119.64354242283461`, 1.845}, {119.64354242283461`, 0.}}], 
         LineBox[{{132.14443977114348`, 1.845}, {132.14443977114348`, 0.}}], 
         LineBox[{{144.64533711945234`, 3.69}, {144.64533711945234`, 0.}}], 
         LineBox[{{157.14623446776122`, 1.845}, {157.14623446776122`, 0.}}], 
         LineBox[{{169.64713181607007`, 1.845}, {169.64713181607007`, 0.}}], 
         LineBox[{{182.14802916437895`, 1.845}, {182.14802916437895`, 0.}}], 
         LineBox[{{194.6489265126878, 1.845}, {194.6489265126878, 0.}}], 
         LineBox[{{207.1498238609967, 3.69}, {207.1498238609967, 0.}}], 
         LineBox[{{219.65072120930557`, 1.845}, {219.65072120930557`, 0.}}], 
         LineBox[{{232.15161855761443`, 1.845}, {232.15161855761443`, 0.}}], 
         LineBox[{{244.6525159059233, 1.845}, {244.6525159059233, 0.}}], 
         LineBox[{{257.1534132542322, 1.845}, {257.1534132542322, 0.}}], 
         LineBox[{{269.65431060254105`, 3.69}, {269.65431060254105`, 0.}}], 
         LineBox[{{282.1552079508499, 1.845}, {282.1552079508499, 0.}}], 
         LineBox[{{294.6561052991588, 1.845}, {294.6561052991588, 0.}}], 
         LineBox[{{307.15700264746766`, 1.845}, {307.15700264746766`, 0.}}], 
         LineBox[{{319.6578999957765, 1.845}, {319.6578999957765, 0.}}], 
         LineBox[{{332.15879734408543`, 3.69}, {332.15879734408543`, 0.}}], 
         LineBox[{{344.6596946923943, 1.845}, {344.6596946923943, 0.}}], 
         LineBox[{{357.16059204070314`, 1.845}, {357.16059204070314`, 0.}}], 
         LineBox[{{369.661489389012, 1.845}, {369.661489389012, 0.}}], 
         LineBox[{{382.1623867373209, 1.845}, {382.1623867373209, 0.}}], 
         LineBox[{{394.66328408562975`, 3.69}, {394.66328408562975`, 0.}}], 
         LineBox[{{407.1641814339386, 1.845}, {407.1641814339386, 0.}}], 
         LineBox[{{419.6650787822475, 1.845}, {419.6650787822475, 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 306.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{7.135466288054765, 304.155}, {7.135466288054765, 306.}}], 
         LineBox[{{19.636363636363637`, 302.31}, {19.636363636363637`, 
          306.}}], 
         LineBox[{{32.13726098467251, 304.155}, {32.13726098467251, 306.}}], 
         LineBox[{{44.63815833298138, 304.155}, {44.63815833298138, 306.}}], 
         LineBox[{{57.13905568129026, 304.155}, {57.13905568129026, 306.}}], 
         LineBox[{{69.63995302959913, 304.155}, {69.63995302959913, 306.}}], 
         LineBox[{{82.140850377908, 302.31}, {82.140850377908, 306.}}], 
         LineBox[{{94.64174772621686, 304.155}, {94.64174772621686, 306.}}], 
         LineBox[{{107.14264507452573`, 304.155}, {107.14264507452573`, 
          306.}}], 
         LineBox[{{119.64354242283461`, 304.155}, {119.64354242283461`, 
          306.}}], 
         LineBox[{{132.14443977114348`, 304.155}, {132.14443977114348`, 
          306.}}], 
         LineBox[{{144.64533711945234`, 302.31}, {144.64533711945234`, 
          306.}}], 
         LineBox[{{157.14623446776122`, 304.155}, {157.14623446776122`, 
          306.}}], 
         LineBox[{{169.64713181607007`, 304.155}, {169.64713181607007`, 
          306.}}], 
         LineBox[{{182.14802916437895`, 304.155}, {182.14802916437895`, 
          306.}}], 
         LineBox[{{194.6489265126878, 304.155}, {194.6489265126878, 306.}}], 
         LineBox[{{207.1498238609967, 302.31}, {207.1498238609967, 306.}}], 
         LineBox[{{219.65072120930557`, 304.155}, {219.65072120930557`, 
          306.}}], 
         LineBox[{{232.15161855761443`, 304.155}, {232.15161855761443`, 
          306.}}], 
         LineBox[{{244.6525159059233, 304.155}, {244.6525159059233, 306.}}], 
         LineBox[{{257.1534132542322, 304.155}, {257.1534132542322, 306.}}], 
         LineBox[{{269.65431060254105`, 302.31}, {269.65431060254105`, 
          306.}}], 
         LineBox[{{282.1552079508499, 304.155}, {282.1552079508499, 306.}}], 
         LineBox[{{294.6561052991588, 304.155}, {294.6561052991588, 306.}}], 
         LineBox[{{307.15700264746766`, 304.155}, {307.15700264746766`, 
          306.}}], 
         LineBox[{{319.6578999957765, 304.155}, {319.6578999957765, 306.}}], 
         LineBox[{{332.15879734408543`, 302.31}, {332.15879734408543`, 
          306.}}], 
         LineBox[{{344.6596946923943, 304.155}, {344.6596946923943, 306.}}], 
         LineBox[{{357.16059204070314`, 304.155}, {357.16059204070314`, 
          306.}}], 
         LineBox[{{369.661489389012, 304.155}, {369.661489389012, 306.}}], 
         LineBox[{{382.1623867373209, 304.155}, {382.1623867373209, 306.}}], 
         LineBox[{{394.66328408562975`, 302.31}, {394.66328408562975`, 
          306.}}], 
         LineBox[{{407.1641814339386, 304.155}, {407.1641814339386, 306.}}], 
         LineBox[{{419.6650787822475, 304.155}, {419.6650787822475, 306.}}]}, 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {1, 0}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 76.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 153.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 229.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 306.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"y\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" (m)\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-18., 306.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {19.636363636363637`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {82.140850377908, 0.}, {0, 1}, Automatic, {1, 
         0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {144.64533711945234`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"3\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {207.1498238609967, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"4\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {269.65431060254105`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {332.15879734408543`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"6\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {394.66328408562975`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"t\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" (s)\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -15.}, {0, 1}, Automatic, {1., 0.}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {1, 0}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 76.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 153.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 229.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 306.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"y\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" (m)\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-18., 306.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {19.636363636363637`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {82.140850377908, 0.}, {0, 1}, Automatic, {1, 
         0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {144.64533711945234`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"3\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {207.1498238609967, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"4\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {269.65431060254105`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {332.15879734408543`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"6\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {394.66328408562975`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"t\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" (s)\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -15.}, {0, 1}, Automatic, {1., 0.}]},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->0.78125,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{576, 450.},
  PlotRange->{{-72, 504}, {-72., 378.}}]], "Output",
 CellChangeTimes->{{3.584375034243454*^9, 3.5843750442430716`*^9}, 
   3.584375149364233*^9, 3.5843757521762857`*^9, 3.5846187063939304`*^9, 
   3.5930080123348207`*^9, 3.5943047820511785`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Style, legend, and error bars", "Subsection",
 CellChangeTimes->{{3.49903452359375*^9, 3.49903452525*^9}, {
  3.5843750528230867`*^9, 3.584375057035094*^9}}],

Cell["\<\
Let us now:
\t-- Set the error bar column
\t-- Define a plot style \[OpenCurlyDoubleQuote]DataPlot\
\[CloseCurlyDoubleQuote], and use this to format the plot
\t-- Make a legend\
\>", "Text",
 CellChangeTimes->{{3.584375059125498*^9, 3.5843751015591664`*^9}, {
  3.5843752376919813`*^9, 3.584375241373588*^9}, {3.5930096626597495`*^9, 
  3.59300966295615*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"DefineStyle", "[", 
   RowBox[{"\"\<DataPlot\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"DataLine", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"LineDashing", "\[Rule]", "4"}], "}"}]}], ",", 
      RowBox[{"DataSymbol", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"SymbolShape", "\[Rule]", "\"\<Square\>\""}], ",", 
         RowBox[{"FillColor", "\[Rule]", "Red"}], ",", 
         RowBox[{"SymbolSize", "\[Rule]", "6"}]}], "}"}]}]}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"DataPlot", "[", 
        RowBox[{"Data", ",", 
         RowBox[{"YErrorColumn", "\[Rule]", "3"}], ",", 
         RowBox[{"Style", "->", "\"\<DataPlot\>\""}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"DataLegend", "[", 
        RowBox[{
         RowBox[{"Scaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.1", ",", "0.4"}], "}"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"\"\<DataPlot\>\"", ",", "\"\<Amplitude\>\""}], "}"}], 
          "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"TextFrame", "\[Rule]", "True"}], ",", 
         RowBox[{"TextMargin", "\[Rule]", "4"}], ",", 
         RowBox[{"TextRoundingRadius", "\[Rule]", "2"}], ",", 
         RowBox[{"TextBackground", "\[Rule]", "Moccasin"}]}], 
        "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "}"}], 
     "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Style", "->", "\"\<ExampleDataFigure\>\""}]}], 
  "\[IndentingNewLine]", "]"}]}], "Input",
 CellChangeTimes->{{3.518118989375*^9, 3.51811900096875*^9}, {
   3.518119070828125*^9, 3.518119080140625*^9}, 3.518434829484375*^9, {
   3.518434975890625*^9, 3.51843500028125*^9}, {3.5184377235*^9, 
   3.518437729046875*^9}, 3.518438256265625*^9, {3.51843828675*^9, 
   3.518438315203125*^9}, 3.5184383755*^9, {3.51843951065625*^9, 
   3.51843951134375*^9}, {3.5184634049375*^9, 3.51846340696875*^9}, 
   3.518464317515625*^9, 3.518468703859375*^9, {3.518469036125*^9, 
   3.51846906240625*^9}, {3.518469211125*^9, 3.518469221234375*^9}, {
   3.518469265765625*^9, 3.51846928140625*^9}, 3.518469336328125*^9, {
   3.5185313745*^9, 3.518531402796875*^9}, {3.518531456359375*^9, 
   3.5185315070625*^9}, 3.518536526953125*^9, {3.518536570734375*^9, 
   3.518536595796875*^9}, {3.518553731157875*^9, 3.51855373376725*^9}, {
   3.5185554990485*^9, 3.51855550657975*^9}, {3.518556831251625*^9, 
   3.518556849220375*^9}, {3.518557469001625*^9, 3.518557489111*^9}, {
   3.518560641501625*^9, 3.518560662736*^9}, {3.518560963236*^9, 
   3.518560963907875*^9}, {3.518561198220375*^9, 3.51856123345475*^9}, {
   3.566338764256277*^9, 3.5663387702310877`*^9}, 3.5837841993860683`*^9, {
   3.583784249430956*^9, 3.5837843021278486`*^9}, 3.5843749964289875`*^9, 
   3.5843750939191556`*^9, {3.584375129344205*^9, 3.5843751433742247`*^9}, 
   3.5843757548263264`*^9, 3.5930093817631397`*^9, {3.5930096517397304`*^9, 
   3.593009665748555*^9}, {3.5943047908027935`*^9, 3.5943048225644493`*^9}}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {432., 306.}]}, InsetBox[
      GraphicsBox[{
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[4], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{19.636363636363637`, 153.}, {44.18181818181819, 
          182.27528257592937`}, {68.72727272727273, 207.09366876077087`}, {
          93.27272727272728, 223.67678423711345`}, {117.81818181818183`, 
          229.5}, {142.36363636363637`, 223.67678423711345`}, {
          166.9090909090909, 207.09366876077087`}, {191.45454545454544`, 
          182.27528257592937`}, {216., 153.}, {240.54545454545453`, 
          123.72471742407063`}, {265.0909090909091, 98.90633123922912}, {
          289.6363636363636, 82.32321576288656}, {314.1818181818182, 76.5}, {
          338.72727272727275`, 82.32321576288656}, {363.27272727272725`, 
          98.90633123922912}, {387.8181818181818, 123.72471742407063`}, {
          412.3636363636364, 153.}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{19.636363636363637`, 153.}, {19.636363636363637`, 
            130.05}}, {{16.636363636363637`, 130.05}, {22.636363636363637`, 
            130.05}}, {{19.636363636363637`, 153.}, {19.636363636363637`, 
            175.95}}, {{16.636363636363637`, 175.95}, {22.636363636363637`, 
            175.95}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{17.090779224092067`, 155.54558441227158`}, {
            17.090779224092067`, 150.45441558772842`}, {22.181948048635206`, 
            150.45441558772842`}, {22.181948048635206`, 
            155.54558441227158`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{44.18181818181819, 182.27528257592937`}, {
            44.18181818181819, 161.07224730479533`}}, {{41.18181818181819, 
            161.07224730479533`}, {47.18181818181819, 
            161.07224730479533`}}, {{44.18181818181819, 
            182.27528257592937`}, {44.18181818181819, 203.4783178470634}}, {{
            41.18181818181819, 203.4783178470634}, {47.18181818181819, 
            203.4783178470634}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{41.636233769546614`, 184.82086698820095`}, {
            41.636233769546614`, 179.7296981636578}, {46.72740259408976, 
            179.7296981636578}, {46.72740259408976, 184.82086698820095`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{68.72727272727273, 207.09366876077087`}, {
            68.72727272727273, 190.8655681325396}}, {{65.72727272727273, 
            190.8655681325396}, {71.72727272727273, 190.8655681325396}}, {{
            68.72727272727273, 207.09366876077087`}, {68.72727272727273, 
            223.32176938900216`}}, {{65.72727272727273, 
            223.32176938900216`}, {71.72727272727273, 
            223.32176938900216`}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{66.18168831500117, 209.63925317304245`}, {
            66.18168831500117, 204.5480843484993}, {71.2728571395443, 
            204.5480843484993}, {71.2728571395443, 209.63925317304245`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{93.27272727272728, 223.67678423711345`}, {
            93.27272727272728, 214.89419946433463`}}, {{90.27272727272728, 
            214.89419946433463`}, {96.27272727272728, 
            214.89419946433463`}}, {{93.27272727272728, 
            223.67678423711345`}, {93.27272727272728, 
            232.45936900989224`}}, {{90.27272727272728, 
            232.45936900989224`}, {96.27272727272728, 
            232.45936900989224`}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{90.72714286045571, 226.22236864938503`}, {
            90.72714286045571, 221.13119982484187`}, {95.81831168499885, 
            221.13119982484187`}, {95.81831168499885, 
            226.22236864938503`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{117.81818181818183`, 229.5}, {117.81818181818183`, 
            229.5}}, {{114.81818181818183`, 229.5}, {120.81818181818183`, 
            229.5}}, {{117.81818181818183`, 229.5}, {117.81818181818183`, 
            229.5}}, {{114.81818181818183`, 229.5}, {120.81818181818183`, 
            229.5}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{115.27259740591026`, 232.04558441227158`}, {
            115.27259740591026`, 226.95441558772842`}, {120.3637662304534, 
            226.95441558772842`}, {120.3637662304534, 
            232.04558441227158`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{142.36363636363637`, 223.67678423711345`}, {
            142.36363636363637`, 214.89419946433463`}}, {{139.36363636363637`,
             214.89419946433463`}, {145.36363636363637`, 
            214.89419946433463`}}, {{142.36363636363637`, 
            223.67678423711345`}, {142.36363636363637`, 
            232.45936900989224`}}, {{139.36363636363637`, 
            232.45936900989224`}, {145.36363636363637`, 
            232.45936900989224`}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{139.8180519513648, 226.22236864938503`}, {
            139.8180519513648, 221.13119982484187`}, {144.90922077590795`, 
            221.13119982484187`}, {144.90922077590795`, 
            226.22236864938503`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{166.9090909090909, 207.09366876077087`}, {
            166.9090909090909, 190.8655681325396}}, {{163.9090909090909, 
            190.8655681325396}, {169.9090909090909, 190.8655681325396}}, {{
            166.9090909090909, 207.09366876077087`}, {166.9090909090909, 
            223.32176938900216`}}, {{163.9090909090909, 
            223.32176938900216`}, {169.9090909090909, 
            223.32176938900216`}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{164.36350649681933`, 209.63925317304245`}, {
            164.36350649681933`, 204.5480843484993}, {169.4546753213625, 
            204.5480843484993}, {169.4546753213625, 209.63925317304245`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{191.45454545454544`, 182.27528257592937`}, {
            191.45454545454544`, 161.07224730479533`}}, {{188.45454545454544`,
             161.07224730479533`}, {194.45454545454544`, 
            161.07224730479533`}}, {{191.45454545454544`, 
            182.27528257592937`}, {191.45454545454544`, 
            203.4783178470634}}, {{188.45454545454544`, 203.4783178470634}, {
            194.45454545454544`, 203.4783178470634}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{188.90896104227386`, 184.82086698820095`}, {
            188.90896104227386`, 179.7296981636578}, {194.00012986681702`, 
            179.7296981636578}, {194.00012986681702`, 
            184.82086698820095`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{216., 153.}, {216., 130.05}}, {{213., 130.05}, {219., 
            130.05}}, {{216., 153.}, {216., 175.95}}, {{213., 175.95}, {219., 
            175.95}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{213.45441558772842`, 155.54558441227158`}, {
            213.45441558772842`, 150.45441558772842`}, {218.54558441227158`, 
            150.45441558772842`}, {218.54558441227158`, 
            155.54558441227158`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{240.54545454545453`, 123.72471742407063`}, {
            240.54545454545453`, 102.52168215293659`}}, {{237.54545454545453`,
             102.52168215293659`}, {243.54545454545453`, 
            102.52168215293659`}}, {{240.54545454545453`, 
            123.72471742407063`}, {240.54545454545453`, 
            144.92775269520467`}}, {{237.54545454545453`, 
            144.92775269520467`}, {243.54545454545453`, 
            144.92775269520467`}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{237.99987013318295`, 126.2703018363422}, {
            237.99987013318295`, 121.17913301179907`}, {243.0910389577261, 
            121.17913301179907`}, {243.0910389577261, 126.2703018363422}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{265.0909090909091, 98.90633123922912}, {
            265.0909090909091, 82.67823061099786}}, {{262.0909090909091, 
            82.67823061099786}, {268.0909090909091, 82.67823061099786}}, {{
            265.0909090909091, 98.90633123922912}, {265.0909090909091, 
            115.13443186746039`}}, {{262.0909090909091, 
            115.13443186746039`}, {268.0909090909091, 
            115.13443186746039`}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{262.54532467863754`, 101.45191565150068`}, {
            262.54532467863754`, 96.36074682695755}, {267.6364935031807, 
            96.36074682695755}, {267.6364935031807, 101.45191565150068`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{289.6363636363636, 82.32321576288656}, {
            289.6363636363636, 73.54063099010776}}, {{286.6363636363636, 
            73.54063099010776}, {292.6363636363636, 73.54063099010776}}, {{
            289.6363636363636, 82.32321576288656}, {289.6363636363636, 
            91.10580053566537}}, {{286.6363636363636, 91.10580053566537}, {
            292.6363636363636, 91.10580053566537}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{287.09077922409205`, 84.86880017515813}, {
            287.09077922409205`, 79.777631350615}, {292.1819480486352, 
            79.777631350615}, {292.1819480486352, 84.86880017515813}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{314.1818181818182, 76.5}, {314.1818181818182, 76.5}}, {{
            311.1818181818182, 76.5}, {317.1818181818182, 76.5}}, {{
            314.1818181818182, 76.5}, {314.1818181818182, 76.5}}, {{
            311.1818181818182, 76.5}, {317.1818181818182, 76.5}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{311.6362337695466, 79.04558441227157}, {
            311.6362337695466, 73.95441558772843}, {316.72740259408977`, 
            73.95441558772843}, {316.72740259408977`, 79.04558441227157}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{338.72727272727275`, 82.32321576288656}, {
            338.72727272727275`, 73.54063099010776}}, {{335.72727272727275`, 
            73.54063099010776}, {341.72727272727275`, 73.54063099010776}}, {{
            338.72727272727275`, 82.32321576288656}, {338.72727272727275`, 
            91.10580053566537}}, {{335.72727272727275`, 91.10580053566537}, {
            341.72727272727275`, 91.10580053566537}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{336.18168831500117`, 84.86880017515813}, {
            336.18168831500117`, 79.777631350615}, {341.2728571395443, 
            79.777631350615}, {341.2728571395443, 84.86880017515813}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{363.27272727272725`, 98.90633123922912}, {
            363.27272727272725`, 82.67823061099786}}, {{360.27272727272725`, 
            82.67823061099786}, {366.27272727272725`, 82.67823061099786}}, {{
            363.27272727272725`, 98.90633123922912}, {363.27272727272725`, 
            115.13443186746039`}}, {{360.27272727272725`, 
            115.13443186746039`}, {366.27272727272725`, 
            115.13443186746039`}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{360.7271428604557, 101.45191565150068`}, {
            360.7271428604557, 96.36074682695755}, {365.81831168499883`, 
            96.36074682695755}, {365.81831168499883`, 
            101.45191565150068`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{387.8181818181818, 123.72471742407063`}, {
            387.8181818181818, 102.52168215293659`}}, {{384.8181818181818, 
            102.52168215293659`}, {390.8181818181818, 
            102.52168215293659`}}, {{387.8181818181818, 
            123.72471742407063`}, {387.8181818181818, 
            144.92775269520467`}}, {{384.8181818181818, 
            144.92775269520467`}, {390.8181818181818, 
            144.92775269520467`}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{385.27259740591023`, 126.2703018363422}, {
            385.27259740591023`, 121.17913301179907`}, {390.3637662304534, 
            121.17913301179907`}, {390.3637662304534, 126.2703018363422}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{412.3636363636364, 153.}, {412.3636363636364, 
            130.05}}, {{409.3636363636364, 130.05}, {415.3636363636364, 
            130.05}}, {{412.3636363636364, 153.}, {412.3636363636364, 
            175.95}}, {{409.3636363636364, 175.95}, {415.3636363636364, 
            175.95}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{409.8180519513648, 155.54558441227158`}, {
            409.8180519513648, 150.45441558772842`}, {414.90922077590795`, 
            150.45441558772842`}, {414.90922077590795`, 
            155.54558441227158`}}]}}}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {
                 TagBox[GridBox[{
                    {
                    GraphicsBox[{
                    {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[4], 
                    CapForm[None], JoinForm[{"Miter", 3.25}], 
                    LineBox[{{-10, 0}, {10, 0}}]}, 
                    {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], 
                    Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
                    FaceForm[RGBColor[1, 0, 0]], 
                    PolygonBox[{{-2.545584412271571, 
                    2.545584412271571}, {-2.545584412271571, \
-2.545584412271571}, {2.545584412271571, -2.545584412271571}, {
                    2.545584412271571, 2.545584412271571}}]}},
                    ImageSize->{20, 8},
                    PlotRange->{{-10, 10}, {-4, 4}}], 
                    StyleBox[
                    TagBox["\<\"Amplitude\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                   },
                   AutoDelete->False,
                   
                   GridBoxAlignment->{
                    "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                   
                   GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                   GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                  "Grid"]}
               },
               AutoDelete->False,
               GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Center}}},
               
               GridBoxItemSize->{
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
               GridBoxSpacings->{"Columns" -> {{
                    Rational[5, 8]}}, "Rows" -> {{
                    Rational[1, 8]}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->RGBColor[1., 0.894101, 0.709799],
          ContentPadding->False,
          FrameMargins->{{4, 4}, {4, 4}},
          FrameStyle->GrayLevel[0],
          RoundingRadius->{2, 2},
          StripOnInput->False], {43.2, 122.4}, {-1, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {
                TagBox[GridBox[{
                   {
                    GraphicsBox[{
                    {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[4], 
                    CapForm[None], JoinForm[{"Miter", 3.25}], 
                    LineBox[{{-10, 0}, {10, 0}}]}, 
                    {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], 
                    Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
                    FaceForm[RGBColor[1, 0, 0]], 
                    PolygonBox[{{-2.545584412271571, 
                    2.545584412271571}, {-2.545584412271571, \
-2.545584412271571}, {2.545584412271571, -2.545584412271571}, {
                    2.545584412271571, 2.545584412271571}}]}},
                    ImageSize->{20, 8},
                    PlotRange->{{-10, 10}, {-4, 4}}], 
                    StyleBox[
                    TagBox["\<\"Amplitude\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                  },
                  AutoDelete->False,
                  GridBoxAlignment->{
                   "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                  
                  GridBoxItemSize->{
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                  GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                 "Grid"]}
              },
              AutoDelete->False,
              GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Center}}},
              
              GridBoxItemSize->{
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
              GridBoxSpacings->{"Columns" -> {{
                   Rational[5, 8]}}, "Rows" -> {{
                   Rational[1, 8]}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{4, 4}, {4, 4}},
          FrameStyle->None,
          RoundingRadius->{2, 2},
          StripOnInput->False], {43.2, 122.4}, {-1, 1}, Automatic, {1, 0}]},
       Frame->False,
       ImageSize->{432., 306.},
       PlotRange->{{0., 432.}, {0., 306.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {0., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{3.69, 0.}, {0., 0.}}], 
         LineBox[{{1.845, 15.299999999999983`}, {0., 15.299999999999983`}}], 
         LineBox[{{1.845, 30.599999999999994`}, {0., 30.599999999999994`}}], 
         LineBox[{{1.845, 45.900000000000006`}, {0., 45.900000000000006`}}], 
         LineBox[{{1.845, 61.2}, {0., 61.2}}], 
         LineBox[{{3.69, 76.5}, {0., 76.5}}], 
         LineBox[{{1.845, 91.8}, {0., 91.8}}], 
         LineBox[{{1.845, 107.1}, {0., 107.1}}], 
         LineBox[{{1.845, 122.4}, {0., 122.4}}], 
         LineBox[{{1.845, 137.7}, {0., 137.7}}], 
         LineBox[{{3.69, 153.}, {0., 153.}}], 
         LineBox[{{1.845, 168.3}, {0., 168.3}}], 
         LineBox[{{1.845, 183.6}, {0., 183.6}}], 
         LineBox[{{1.845, 198.9}, {0., 198.9}}], 
         LineBox[{{1.845, 214.2}, {0., 214.2}}], 
         LineBox[{{3.69, 229.5}, {0., 229.5}}], 
         LineBox[{{1.845, 244.8}, {0., 244.8}}], 
         LineBox[{{1.845, 260.1}, {0., 260.1}}], 
         LineBox[{{1.845, 275.4}, {0., 275.4}}], 
         LineBox[{{1.845, 290.70000000000005`}, {0., 290.70000000000005`}}], 
         LineBox[{{3.69, 306.}, {0., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{432., 0.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{428.31, 0.}, {432., 0.}}], 
         LineBox[{{430.155, 15.299999999999983`}, {432., 
          15.299999999999983`}}], 
         LineBox[{{430.155, 30.599999999999994`}, {432., 
          30.599999999999994`}}], 
         LineBox[{{430.155, 45.900000000000006`}, {432., 
          45.900000000000006`}}], LineBox[{{430.155, 61.2}, {432., 61.2}}], 
         LineBox[{{428.31, 76.5}, {432., 76.5}}], 
         LineBox[{{430.155, 91.8}, {432., 91.8}}], 
         LineBox[{{430.155, 107.1}, {432., 107.1}}], 
         LineBox[{{430.155, 122.4}, {432., 122.4}}], 
         LineBox[{{430.155, 137.7}, {432., 137.7}}], 
         LineBox[{{428.31, 153.}, {432., 153.}}], 
         LineBox[{{430.155, 168.3}, {432., 168.3}}], 
         LineBox[{{430.155, 183.6}, {432., 183.6}}], 
         LineBox[{{430.155, 198.9}, {432., 198.9}}], 
         LineBox[{{430.155, 214.2}, {432., 214.2}}], 
         LineBox[{{428.31, 229.5}, {432., 229.5}}], 
         LineBox[{{430.155, 244.8}, {432., 244.8}}], 
         LineBox[{{430.155, 260.1}, {432., 260.1}}], 
         LineBox[{{430.155, 275.4}, {432., 275.4}}], 
         LineBox[{{430.155, 290.70000000000005`}, {432., 
          290.70000000000005`}}], LineBox[{{428.31, 306.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {432., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{7.135466288054765, 1.845}, {7.135466288054765, 0.}}], 
         LineBox[{{19.636363636363637`, 3.69}, {19.636363636363637`, 0.}}], 
         LineBox[{{32.13726098467251, 1.845}, {32.13726098467251, 0.}}], 
         LineBox[{{44.63815833298138, 1.845}, {44.63815833298138, 0.}}], 
         LineBox[{{57.13905568129026, 1.845}, {57.13905568129026, 0.}}], 
         LineBox[{{69.63995302959913, 1.845}, {69.63995302959913, 0.}}], 
         LineBox[{{82.140850377908, 3.69}, {82.140850377908, 0.}}], 
         LineBox[{{94.64174772621686, 1.845}, {94.64174772621686, 0.}}], 
         LineBox[{{107.14264507452573`, 1.845}, {107.14264507452573`, 0.}}], 
         LineBox[{{119.64354242283461`, 1.845}, {119.64354242283461`, 0.}}], 
         LineBox[{{132.14443977114348`, 1.845}, {132.14443977114348`, 0.}}], 
         LineBox[{{144.64533711945234`, 3.69}, {144.64533711945234`, 0.}}], 
         LineBox[{{157.14623446776122`, 1.845}, {157.14623446776122`, 0.}}], 
         LineBox[{{169.64713181607007`, 1.845}, {169.64713181607007`, 0.}}], 
         LineBox[{{182.14802916437895`, 1.845}, {182.14802916437895`, 0.}}], 
         LineBox[{{194.6489265126878, 1.845}, {194.6489265126878, 0.}}], 
         LineBox[{{207.1498238609967, 3.69}, {207.1498238609967, 0.}}], 
         LineBox[{{219.65072120930557`, 1.845}, {219.65072120930557`, 0.}}], 
         LineBox[{{232.15161855761443`, 1.845}, {232.15161855761443`, 0.}}], 
         LineBox[{{244.6525159059233, 1.845}, {244.6525159059233, 0.}}], 
         LineBox[{{257.1534132542322, 1.845}, {257.1534132542322, 0.}}], 
         LineBox[{{269.65431060254105`, 3.69}, {269.65431060254105`, 0.}}], 
         LineBox[{{282.1552079508499, 1.845}, {282.1552079508499, 0.}}], 
         LineBox[{{294.6561052991588, 1.845}, {294.6561052991588, 0.}}], 
         LineBox[{{307.15700264746766`, 1.845}, {307.15700264746766`, 0.}}], 
         LineBox[{{319.6578999957765, 1.845}, {319.6578999957765, 0.}}], 
         LineBox[{{332.15879734408543`, 3.69}, {332.15879734408543`, 0.}}], 
         LineBox[{{344.6596946923943, 1.845}, {344.6596946923943, 0.}}], 
         LineBox[{{357.16059204070314`, 1.845}, {357.16059204070314`, 0.}}], 
         LineBox[{{369.661489389012, 1.845}, {369.661489389012, 0.}}], 
         LineBox[{{382.1623867373209, 1.845}, {382.1623867373209, 0.}}], 
         LineBox[{{394.66328408562975`, 3.69}, {394.66328408562975`, 0.}}], 
         LineBox[{{407.1641814339386, 1.845}, {407.1641814339386, 0.}}], 
         LineBox[{{419.6650787822475, 1.845}, {419.6650787822475, 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 306.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{7.135466288054765, 304.155}, {7.135466288054765, 306.}}], 
         LineBox[{{19.636363636363637`, 302.31}, {19.636363636363637`, 
          306.}}], 
         LineBox[{{32.13726098467251, 304.155}, {32.13726098467251, 306.}}], 
         LineBox[{{44.63815833298138, 304.155}, {44.63815833298138, 306.}}], 
         LineBox[{{57.13905568129026, 304.155}, {57.13905568129026, 306.}}], 
         LineBox[{{69.63995302959913, 304.155}, {69.63995302959913, 306.}}], 
         LineBox[{{82.140850377908, 302.31}, {82.140850377908, 306.}}], 
         LineBox[{{94.64174772621686, 304.155}, {94.64174772621686, 306.}}], 
         LineBox[{{107.14264507452573`, 304.155}, {107.14264507452573`, 
          306.}}], 
         LineBox[{{119.64354242283461`, 304.155}, {119.64354242283461`, 
          306.}}], 
         LineBox[{{132.14443977114348`, 304.155}, {132.14443977114348`, 
          306.}}], 
         LineBox[{{144.64533711945234`, 302.31}, {144.64533711945234`, 
          306.}}], 
         LineBox[{{157.14623446776122`, 304.155}, {157.14623446776122`, 
          306.}}], 
         LineBox[{{169.64713181607007`, 304.155}, {169.64713181607007`, 
          306.}}], 
         LineBox[{{182.14802916437895`, 304.155}, {182.14802916437895`, 
          306.}}], 
         LineBox[{{194.6489265126878, 304.155}, {194.6489265126878, 306.}}], 
         LineBox[{{207.1498238609967, 302.31}, {207.1498238609967, 306.}}], 
         LineBox[{{219.65072120930557`, 304.155}, {219.65072120930557`, 
          306.}}], 
         LineBox[{{232.15161855761443`, 304.155}, {232.15161855761443`, 
          306.}}], 
         LineBox[{{244.6525159059233, 304.155}, {244.6525159059233, 306.}}], 
         LineBox[{{257.1534132542322, 304.155}, {257.1534132542322, 306.}}], 
         LineBox[{{269.65431060254105`, 302.31}, {269.65431060254105`, 
          306.}}], 
         LineBox[{{282.1552079508499, 304.155}, {282.1552079508499, 306.}}], 
         LineBox[{{294.6561052991588, 304.155}, {294.6561052991588, 306.}}], 
         LineBox[{{307.15700264746766`, 304.155}, {307.15700264746766`, 
          306.}}], 
         LineBox[{{319.6578999957765, 304.155}, {319.6578999957765, 306.}}], 
         LineBox[{{332.15879734408543`, 302.31}, {332.15879734408543`, 
          306.}}], 
         LineBox[{{344.6596946923943, 304.155}, {344.6596946923943, 306.}}], 
         LineBox[{{357.16059204070314`, 304.155}, {357.16059204070314`, 
          306.}}], 
         LineBox[{{369.661489389012, 304.155}, {369.661489389012, 306.}}], 
         LineBox[{{382.1623867373209, 304.155}, {382.1623867373209, 306.}}], 
         LineBox[{{394.66328408562975`, 302.31}, {394.66328408562975`, 
          306.}}], 
         LineBox[{{407.1641814339386, 304.155}, {407.1641814339386, 306.}}], 
         LineBox[{{419.6650787822475, 304.155}, {419.6650787822475, 306.}}]}, 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {1, 0}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 76.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 153.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 229.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 306.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"y\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" (m)\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-18., 306.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {19.636363636363637`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {82.140850377908, 0.}, {0, 1}, Automatic, {1, 
         0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {144.64533711945234`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"3\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {207.1498238609967, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"4\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {269.65431060254105`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {332.15879734408543`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"6\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {394.66328408562975`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"t\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" (s)\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -15.}, {0, 1}, Automatic, {1., 0.}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {1, 0}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 76.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 153.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 229.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 306.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"y\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" (m)\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-18., 306.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {19.636363636363637`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {82.140850377908, 0.}, {0, 1}, Automatic, {1, 
         0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {144.64533711945234`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"3\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {207.1498238609967, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"4\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {269.65431060254105`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {332.15879734408543`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"6\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {394.66328408562975`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"t\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" (s)\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -15.}, {0, 1}, Automatic, {1., 0.}]},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->0.78125,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{576, 450.},
  PlotRange->{{-72, 504}, {-72., 378.}}]], "Output",
 CellChangeTimes->{{3.518469055890625*^9, 3.51846906278125*^9}, 
   3.518469221828125*^9, {3.518469268890625*^9, 3.51846928221875*^9}, 
   3.51847277134375*^9, 3.51847280665625*^9, {3.518531360875*^9, 
   3.518531390421875*^9}, {3.518531478453125*^9, 3.5185315074375*^9}, 
   3.518534826359375*^9, 3.518536527265625*^9, {3.518536563421875*^9, 
   3.518536596109375*^9}, {3.518553743595375*^9, 3.51855374889225*^9}, {
   3.51855550226725*^9, 3.518555508032875*^9}, {3.51855656970475*^9, 
   3.518556590407875*^9}, 3.518556682111*^9, {3.5185568165485*^9, 
   3.518556849689125*^9}, 3.518556882345375*^9, 3.5185569300485*^9, 
   3.518557019564125*^9, {3.518557469470375*^9, 3.51855749039225*^9}, {
   3.518560647345375*^9, 3.51856066326725*^9}, {3.518560952595375*^9, 
   3.51856096451725*^9}, {3.51856118839225*^9, 3.518561233845375*^9}, 
   3.51856230470475*^9, 3.519652165609375*^9, 3.5247481060625*^9, 
   3.566338772976692*^9, 3.579121896197524*^9, 3.5837842051736784`*^9, 
   3.5837843033602505`*^9, 3.5843748207498803`*^9, {3.584375134909213*^9, 
   3.584375144249226*^9}, 3.584375756196347*^9, 3.5846187133827424`*^9, 
   3.5930079661147566`*^9, 3.5930093550981026`*^9, {3.593009666481756*^9, 
   3.5930096755453725`*^9}, {3.594304792596797*^9, 3.594304798930408*^9}, 
   3.5943048304892635`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Fun with plot symbols and the legend", "Subsection",
 CellChangeTimes->{{3.518534838171875*^9, 3.51853484209375*^9}, {
  3.518535171234375*^9, 3.51853517740625*^9}, {3.5843751778970766`*^9, 
  3.584375184667488*^9}}],

Cell["\<\
Here we will modify the above plot a bit...
\t-- Try out a different plot symbol, one with a fancier name involving an \
argument (the number of polygon sides)
\t-- Play with the DataLegend dimensions, showing how labels can be arranged \
in columns
(Of course, in real life, we would probably not include the same curve \
descriptor (data symbol and/or line) in the legend 4 times!  This is just to \
illustrate the use of DataLegend.)\
\>", "Text",
 CellChangeTimes->{{3.5843752142763405`*^9, 3.584375296004884*^9}, {
  3.5846187259095645`*^9, 3.5846187886216745`*^9}, {3.59430485679091*^9, 
  3.5943048635145216`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"DefineStyle", "[", 
   RowBox[{"\"\<DataPlotPolygon\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"DataLine", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"LineDashing", "\[Rule]", "4"}], "}"}]}], ",", 
      RowBox[{"DataSymbol", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"SymbolShape", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"\"\<Polygon\>\"", ",", "5"}], "}"}]}], ",", 
         RowBox[{"FillColor", "\[Rule]", "Red"}], ",", 
         RowBox[{"SymbolSize", "\[Rule]", "6"}]}], "}"}]}]}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"DataPlot", "[", 
        RowBox[{"Data", ",", 
         RowBox[{"YErrorColumn", "\[Rule]", "3"}], ",", 
         RowBox[{"Style", "\[Rule]", "\"\<DataPlotPolygon\>\""}]}], "]"}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"DataLegend", "[", 
        RowBox[{
         RowBox[{"Scaled", "[", 
          RowBox[{"{", 
           RowBox[{"0.05", ",", "0.3"}], "}"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"\"\<DataPlotPolygon\>\"", ",", "\"\<Data\>\""}], "}"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"\"\<DataPlotPolygon\>\"", ",", "\"\<Some more\>\""}], 
            "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"\"\<DataPlotPolygon\>\"", ",", "\"\<Yet more\>\""}], 
            "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"\"\<DataPlotPolygon\>\"", ",", "\"\<The last!\>\""}], 
            "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"None", ",", 
             RowBox[{"textsize", "[", 
              RowBox[{"Small", ",", "\"\<(Really!)\>\""}], "]"}]}], "}"}]}], 
          "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"TextFrame", "\[Rule]", "True"}], ",", 
         RowBox[{"TextMargin", "\[Rule]", "4"}], ",", 
         RowBox[{"TextRoundingRadius", "\[Rule]", "2"}], ",", 
         RowBox[{"TextBackground", "\[Rule]", "Moccasin"}], ",", 
         RowBox[{"RowLimit", "\[Rule]", "3"}]}], "]"}]}], 
      "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", "]"}], 
    "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Style", "->", "\"\<ExampleDataFigure\>\""}]}], 
  "\[IndentingNewLine]", "]"}]}], "Input",
 CellChangeTimes->{{3.518118989375*^9, 3.51811900096875*^9}, {
   3.518119070828125*^9, 3.518119080140625*^9}, 3.518434829484375*^9, {
   3.518434975890625*^9, 3.51843500028125*^9}, {3.5184377235*^9, 
   3.518437729046875*^9}, 3.518438256265625*^9, {3.51843828675*^9, 
   3.518438315203125*^9}, 3.5184383755*^9, {3.51843951065625*^9, 
   3.51843951134375*^9}, {3.5184634049375*^9, 3.51846340696875*^9}, 
   3.518464317515625*^9, 3.518468703859375*^9, {3.518469036125*^9, 
   3.51846906240625*^9}, {3.518469211125*^9, 3.518469221234375*^9}, {
   3.518469265765625*^9, 3.51846928140625*^9}, 3.518469336328125*^9, {
   3.5185313745*^9, 3.518531402796875*^9}, {3.518531456359375*^9, 
   3.5185315070625*^9}, {3.518534850078125*^9, 3.51853485828125*^9}, {
   3.518534995328125*^9, 3.5185350056875*^9}, {3.518535076828125*^9, 
   3.51853515815625*^9}, {3.518562318376625*^9, 3.51856231951725*^9}, {
   3.5663387791543036`*^9, 3.566338791478325*^9}, 3.5837841994172688`*^9, {
   3.584375176571074*^9, 3.584375211593136*^9}, 3.5843752561000137`*^9, {
   3.5843753016208935`*^9, 3.584375618569234*^9}, 3.5843757643639727`*^9, 
   3.59300938194814*^9, {3.593009688867796*^9, 3.593009720504651*^9}, {
   3.5943048463856916`*^9, 3.5943048471812925`*^9}}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {432., 306.}]}, InsetBox[
      GraphicsBox[{
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[4], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{19.636363636363637`, 153.}, {44.18181818181819, 
          182.27528257592937`}, {68.72727272727273, 207.09366876077087`}, {
          93.27272727272728, 223.67678423711345`}, {117.81818181818183`, 
          229.5}, {142.36363636363637`, 223.67678423711345`}, {
          166.9090909090909, 207.09366876077087`}, {191.45454545454544`, 
          182.27528257592937`}, {216., 153.}, {240.54545454545453`, 
          123.72471742407063`}, {265.0909090909091, 98.90633123922912}, {
          289.6363636363636, 82.32321576288656}, {314.1818181818182, 76.5}, {
          338.72727272727275`, 82.32321576288656}, {363.27272727272725`, 
          98.90633123922912}, {387.8181818181818, 123.72471742407063`}, {
          412.3636363636364, 153.}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{19.636363636363637`, 153.}, {19.636363636363637`, 
            130.05}}, {{16.636363636363637`, 130.05}, {22.636363636363637`, 
            130.05}}, {{19.636363636363637`, 153.}, {19.636363636363637`, 
            175.95}}, {{16.636363636363637`, 175.95}, {22.636363636363637`, 
            175.95}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{16.783194087478176`, 153.92705098312484`}, {
            17.873007879486217`, 150.57294901687516`}, {21.399719393241057`, 
            150.57294901687516`}, {22.489533185249098`, 
            153.92705098312484`}, {19.636363636363637`, 156.}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{44.18181818181819, 182.27528257592937`}, {
            44.18181818181819, 161.07224730479533`}}, {{41.18181818181819, 
            161.07224730479533`}, {47.18181818181819, 
            161.07224730479533`}}, {{44.18181818181819, 
            182.27528257592937`}, {44.18181818181819, 203.4783178470634}}, {{
            41.18181818181819, 203.4783178470634}, {47.18181818181819, 
            203.4783178470634}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{41.328648632932726`, 183.2023335590542}, {
            42.41846242494077, 179.84823159280452`}, {45.9451739386956, 
            179.84823159280452`}, {47.03498773070365, 183.2023335590542}, {
            44.18181818181819, 185.27528257592937`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{68.72727272727273, 207.09366876077087`}, {
            68.72727272727273, 190.8655681325396}}, {{65.72727272727273, 
            190.8655681325396}, {71.72727272727273, 190.8655681325396}}, {{
            68.72727272727273, 207.09366876077087`}, {68.72727272727273, 
            223.32176938900216`}}, {{65.72727272727273, 
            223.32176938900216`}, {71.72727272727273, 
            223.32176938900216`}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{65.87410317838727, 208.0207197438957}, {
            66.96391697039532, 204.66661777764602`}, {70.49062848415015, 
            204.66661777764602`}, {71.5804422761582, 208.0207197438957}, {
            68.72727272727273, 210.09366876077087`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{93.27272727272728, 223.67678423711345`}, {
            93.27272727272728, 214.89419946433463`}}, {{90.27272727272728, 
            214.89419946433463`}, {96.27272727272728, 
            214.89419946433463`}}, {{93.27272727272728, 
            223.67678423711345`}, {93.27272727272728, 
            232.45936900989224`}}, {{90.27272727272728, 
            232.45936900989224`}, {96.27272727272728, 
            232.45936900989224`}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{90.41955772384182, 224.6038352202383}, {
            91.50937151584986, 221.2497332539886}, {95.0360830296047, 
            221.2497332539886}, {96.12589682161274, 224.6038352202383}, {
            93.27272727272728, 226.67678423711345`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{117.81818181818183`, 229.5}, {117.81818181818183`, 
            229.5}}, {{114.81818181818183`, 229.5}, {120.81818181818183`, 
            229.5}}, {{117.81818181818183`, 229.5}, {117.81818181818183`, 
            229.5}}, {{114.81818181818183`, 229.5}, {120.81818181818183`, 
            229.5}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{114.96501226929637`, 230.42705098312484`}, {
            116.05482606130441`, 227.07294901687516`}, {119.58153757505924`, 
            227.07294901687516`}, {120.67135136706729`, 
            230.42705098312484`}, {117.81818181818183`, 232.5}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{142.36363636363637`, 223.67678423711345`}, {
            142.36363636363637`, 214.89419946433463`}}, {{139.36363636363637`,
             214.89419946433463`}, {145.36363636363637`, 
            214.89419946433463`}}, {{142.36363636363637`, 
            223.67678423711345`}, {142.36363636363637`, 
            232.45936900989224`}}, {{139.36363636363637`, 
            232.45936900989224`}, {145.36363636363637`, 
            232.45936900989224`}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{139.5104668147509, 224.6038352202383}, {
            140.60028060675896`, 221.2497332539886}, {144.1269921205138, 
            221.2497332539886}, {145.21680591252183`, 224.6038352202383}, {
            142.36363636363637`, 226.67678423711345`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{166.9090909090909, 207.09366876077087`}, {
            166.9090909090909, 190.8655681325396}}, {{163.9090909090909, 
            190.8655681325396}, {169.9090909090909, 190.8655681325396}}, {{
            166.9090909090909, 207.09366876077087`}, {166.9090909090909, 
            223.32176938900216`}}, {{163.9090909090909, 
            223.32176938900216`}, {169.9090909090909, 
            223.32176938900216`}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{164.05592136020545`, 208.0207197438957}, {
            165.1457351522135, 204.66661777764602`}, {168.67244666596832`, 
            204.66661777764602`}, {169.76226045797637`, 208.0207197438957}, {
            166.9090909090909, 210.09366876077087`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{191.45454545454544`, 182.27528257592937`}, {
            191.45454545454544`, 161.07224730479533`}}, {{188.45454545454544`,
             161.07224730479533`}, {194.45454545454544`, 
            161.07224730479533`}}, {{191.45454545454544`, 
            182.27528257592937`}, {191.45454545454544`, 
            203.4783178470634}}, {{188.45454545454544`, 203.4783178470634}, {
            194.45454545454544`, 203.4783178470634}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{188.60137590565998`, 183.2023335590542}, {
            189.69118969766802`, 179.84823159280452`}, {193.21790121142286`, 
            179.84823159280452`}, {194.3077150034309, 183.2023335590542}, {
            191.45454545454544`, 185.27528257592937`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{216., 153.}, {216., 130.05}}, {{213., 130.05}, {219., 
            130.05}}, {{216., 153.}, {216., 175.95}}, {{213., 175.95}, {219., 
            175.95}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{213.14683045111454`, 153.92705098312484`}, {
            214.23664424312258`, 150.57294901687516`}, {217.76335575687742`, 
            150.57294901687516`}, {218.85316954888546`, 
            153.92705098312484`}, {216., 156.}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{240.54545454545453`, 123.72471742407063`}, {
            240.54545454545453`, 102.52168215293659`}}, {{237.54545454545453`,
             102.52168215293659`}, {243.54545454545453`, 
            102.52168215293659`}}, {{240.54545454545453`, 
            123.72471742407063`}, {240.54545454545453`, 
            144.92775269520467`}}, {{237.54545454545453`, 
            144.92775269520467`}, {243.54545454545453`, 
            144.92775269520467`}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{237.69228499656907`, 124.65176840719548`}, {
            238.78209878857712`, 121.29766644094579`}, {242.30881030233195`, 
            121.29766644094579`}, {243.39862409434, 124.65176840719548`}, {
            240.54545454545453`, 126.72471742407063`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{265.0909090909091, 98.90633123922912}, {
            265.0909090909091, 82.67823061099786}}, {{262.0909090909091, 
            82.67823061099786}, {268.0909090909091, 82.67823061099786}}, {{
            265.0909090909091, 98.90633123922912}, {265.0909090909091, 
            115.13443186746039`}}, {{262.0909090909091, 
            115.13443186746039`}, {268.0909090909091, 
            115.13443186746039`}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{262.2377395420237, 99.83338222235396}, {
            263.3275533340317, 96.47928025610427}, {266.85426484778657`, 
            96.47928025610427}, {267.94407863979455`, 99.83338222235396}, {
            265.0909090909091, 101.90633123922912`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{289.6363636363636, 82.32321576288656}, {
            289.6363636363636, 73.54063099010776}}, {{286.6363636363636, 
            73.54063099010776}, {292.6363636363636, 73.54063099010776}}, {{
            289.6363636363636, 82.32321576288656}, {289.6363636363636, 
            91.10580053566537}}, {{286.6363636363636, 91.10580053566537}, {
            292.6363636363636, 91.10580053566537}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{286.7831940874782, 83.2502667460114}, {
            287.8730078794862, 79.89616477976172}, {291.39971939324107`, 
            79.89616477976172}, {292.48953318524906`, 83.2502667460114}, {
            289.6363636363636, 85.32321576288656}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{314.1818181818182, 76.5}, {314.1818181818182, 76.5}}, {{
            311.1818181818182, 76.5}, {317.1818181818182, 76.5}}, {{
            314.1818181818182, 76.5}, {314.1818181818182, 76.5}}, {{
            311.1818181818182, 76.5}, {317.1818181818182, 76.5}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{311.32864863293275`, 77.42705098312484}, {
            312.41846242494074`, 74.07294901687516}, {315.94517393869563`, 
            74.07294901687516}, {317.0349877307036, 77.42705098312484}, {
            314.1818181818182, 79.5}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{338.72727272727275`, 82.32321576288656}, {
            338.72727272727275`, 73.54063099010776}}, {{335.72727272727275`, 
            73.54063099010776}, {341.72727272727275`, 73.54063099010776}}, {{
            338.72727272727275`, 82.32321576288656}, {338.72727272727275`, 
            91.10580053566537}}, {{335.72727272727275`, 91.10580053566537}, {
            341.72727272727275`, 91.10580053566537}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{335.8741031783873, 83.2502667460114}, {
            336.9639169703953, 79.89616477976172}, {340.4906284841502, 
            79.89616477976172}, {341.5804422761582, 83.2502667460114}, {
            338.72727272727275`, 85.32321576288656}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{363.27272727272725`, 98.90633123922912}, {
            363.27272727272725`, 82.67823061099786}}, {{360.27272727272725`, 
            82.67823061099786}, {366.27272727272725`, 82.67823061099786}}, {{
            363.27272727272725`, 98.90633123922912}, {363.27272727272725`, 
            115.13443186746039`}}, {{360.27272727272725`, 
            115.13443186746039`}, {366.27272727272725`, 
            115.13443186746039`}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{360.4195577238418, 99.83338222235396}, {
            361.5093715158498, 96.47928025610427}, {365.0360830296047, 
            96.47928025610427}, {366.1258968216127, 99.83338222235396}, {
            363.27272727272725`, 101.90633123922912`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{387.8181818181818, 123.72471742407063`}, {
            387.8181818181818, 102.52168215293659`}}, {{384.8181818181818, 
            102.52168215293659`}, {390.8181818181818, 
            102.52168215293659`}}, {{387.8181818181818, 
            123.72471742407063`}, {387.8181818181818, 
            144.92775269520467`}}, {{384.8181818181818, 
            144.92775269520467`}, {390.8181818181818, 
            144.92775269520467`}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{384.9650122692964, 124.65176840719548`}, {
            386.05482606130437`, 121.29766644094579`}, {389.58153757505926`, 
            121.29766644094579`}, {390.67135136706725`, 
            124.65176840719548`}, {387.8181818181818, 
            126.72471742407063`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{412.3636363636364, 153.}, {412.3636363636364, 
            130.05}}, {{409.3636363636364, 130.05}, {415.3636363636364, 
            130.05}}, {{412.3636363636364, 153.}, {412.3636363636364, 
            175.95}}, {{409.3636363636364, 175.95}, {415.3636363636364, 
            175.95}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{409.51046681475094`, 153.92705098312484`}, {
            410.60028060675893`, 150.57294901687516`}, {414.1269921205138, 
            150.57294901687516`}, {415.2168059125218, 153.92705098312484`}, {
            412.3636363636364, 156.}}]}}}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {
                 TagBox[GridBox[{
                    {
                    GraphicsBox[{
                    {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[4], 
                    CapForm[None], JoinForm[{"Miter", 3.25}], 
                    LineBox[{{-10, 0}, {10, 0}}]}, 
                    {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], 
                    Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
                    FaceForm[RGBColor[1, 0, 0]], 
                    PolygonBox[{{-2.8531695488854605`, 
                    0.9270509831248424}, {-1.7633557568774194`, \
-2.4270509831248424`}, {1.7633557568774194`, -2.4270509831248424`}, {
                    2.8531695488854605`, 0.9270509831248424}, {0., 3.}}]}},
                    ImageSize->{20, 8},
                    PlotRange->{{-10, 10}, {-4, 4}}], 
                    StyleBox[
                    TagBox["\<\"Data\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                   },
                   AutoDelete->False,
                   
                   GridBoxAlignment->{
                    "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                   
                   GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                   GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                  "Grid"], 
                 TagBox[GridBox[{
                    {
                    GraphicsBox[{
                    {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[4], 
                    CapForm[None], JoinForm[{"Miter", 3.25}], 
                    LineBox[{{-10, 0}, {10, 0}}]}, 
                    {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], 
                    Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
                    FaceForm[RGBColor[1, 0, 0]], 
                    PolygonBox[{{-2.8531695488854605`, 
                    0.9270509831248424}, {-1.7633557568774194`, \
-2.4270509831248424`}, {1.7633557568774194`, -2.4270509831248424`}, {
                    2.8531695488854605`, 0.9270509831248424}, {0., 3.}}]}},
                    ImageSize->{20, 8},
                    PlotRange->{{-10, 10}, {-4, 4}}], 
                    StyleBox[
                    TagBox["\<\"The last!\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                   },
                   AutoDelete->False,
                   
                   GridBoxAlignment->{
                    "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                   
                   GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                   GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                  "Grid"]},
                {
                 TagBox[GridBox[{
                    {
                    GraphicsBox[{
                    {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[4], 
                    CapForm[None], JoinForm[{"Miter", 3.25}], 
                    LineBox[{{-10, 0}, {10, 0}}]}, 
                    {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], 
                    Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
                    FaceForm[RGBColor[1, 0, 0]], 
                    PolygonBox[{{-2.8531695488854605`, 
                    0.9270509831248424}, {-1.7633557568774194`, \
-2.4270509831248424`}, {1.7633557568774194`, -2.4270509831248424`}, {
                    2.8531695488854605`, 0.9270509831248424}, {0., 3.}}]}},
                    ImageSize->{20, 8},
                    PlotRange->{{-10, 10}, {-4, 4}}], 
                    StyleBox[
                    TagBox["\<\"Some more\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                   },
                   AutoDelete->False,
                   
                   GridBoxAlignment->{
                    "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                   
                   GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                   GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                  "Grid"], 
                 TagBox[GridBox[{
                    {
                    GraphicsBox[{},
                    ImageSize->{20, 8},
                    PlotRange->{{-10, 10}, {-4, 4}}], 
                    StyleBox[
                    TagBox[
                    TagBox[
                    StyleBox["\<\"(Really!)\"\>",
                    FontSize->Small],
                    StyleForm[#, FontSize -> Small]& ],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                   },
                   AutoDelete->False,
                   
                   GridBoxAlignment->{
                    "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                   
                   GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                   GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                  "Grid"]},
                {
                 TagBox[GridBox[{
                    {
                    GraphicsBox[{
                    {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[4], 
                    CapForm[None], JoinForm[{"Miter", 3.25}], 
                    LineBox[{{-10, 0}, {10, 0}}]}, 
                    {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], 
                    Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
                    FaceForm[RGBColor[1, 0, 0]], 
                    PolygonBox[{{-2.8531695488854605`, 
                    0.9270509831248424}, {-1.7633557568774194`, \
-2.4270509831248424`}, {1.7633557568774194`, -2.4270509831248424`}, {
                    2.8531695488854605`, 0.9270509831248424}, {0., 3.}}]}},
                    ImageSize->{20, 8},
                    PlotRange->{{-10, 10}, {-4, 4}}], 
                    StyleBox[
                    TagBox["\<\"Yet more\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                   },
                   AutoDelete->False,
                   
                   GridBoxAlignment->{
                    "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                   
                   GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                   GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                  "Grid"], 
                 TagBox[GridBox[{
                    {"", ""}
                   },
                   AutoDelete->False,
                   
                   GridBoxAlignment->{
                    "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                   
                   GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                   GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                  "Grid"]}
               },
               AutoDelete->False,
               GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Center}}},
               
               GridBoxItemSize->{
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
               GridBoxSpacings->{"Columns" -> {{
                    Rational[5, 8]}}, "Rows" -> {{
                    Rational[1, 8]}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->RGBColor[1., 0.894101, 0.709799],
          ContentPadding->False,
          FrameMargins->{{4, 4}, {4, 4}},
          FrameStyle->GrayLevel[0],
          RoundingRadius->{2, 2},
          StripOnInput->False], {21.6, 91.8}, {-1, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {
                TagBox[GridBox[{
                   {
                    GraphicsBox[{
                    {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[4], 
                    CapForm[None], JoinForm[{"Miter", 3.25}], 
                    LineBox[{{-10, 0}, {10, 0}}]}, 
                    {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], 
                    Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
                    FaceForm[RGBColor[1, 0, 0]], 
                    PolygonBox[{{-2.8531695488854605`, 
                    0.9270509831248424}, {-1.7633557568774194`, \
-2.4270509831248424`}, {1.7633557568774194`, -2.4270509831248424`}, {
                    2.8531695488854605`, 0.9270509831248424}, {0., 3.}}]}},
                    ImageSize->{20, 8},
                    PlotRange->{{-10, 10}, {-4, 4}}], 
                    StyleBox[
                    TagBox["\<\"Data\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                  },
                  AutoDelete->False,
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                  
                  GridBoxItemSize->{
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                  GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                 "Grid"], 
                TagBox[GridBox[{
                   {
                    GraphicsBox[{
                    {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[4], 
                    CapForm[None], JoinForm[{"Miter", 3.25}], 
                    LineBox[{{-10, 0}, {10, 0}}]}, 
                    {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], 
                    Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
                    FaceForm[RGBColor[1, 0, 0]], 
                    PolygonBox[{{-2.8531695488854605`, 
                    0.9270509831248424}, {-1.7633557568774194`, \
-2.4270509831248424`}, {1.7633557568774194`, -2.4270509831248424`}, {
                    2.8531695488854605`, 0.9270509831248424}, {0., 3.}}]}},
                    ImageSize->{20, 8},
                    PlotRange->{{-10, 10}, {-4, 4}}], 
                    StyleBox[
                    TagBox["\<\"The last!\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                  },
                  AutoDelete->False,
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                  
                  GridBoxItemSize->{
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                  GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                 "Grid"]},
               {
                TagBox[GridBox[{
                   {
                    GraphicsBox[{
                    {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[4], 
                    CapForm[None], JoinForm[{"Miter", 3.25}], 
                    LineBox[{{-10, 0}, {10, 0}}]}, 
                    {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], 
                    Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
                    FaceForm[RGBColor[1, 0, 0]], 
                    PolygonBox[{{-2.8531695488854605`, 
                    0.9270509831248424}, {-1.7633557568774194`, \
-2.4270509831248424`}, {1.7633557568774194`, -2.4270509831248424`}, {
                    2.8531695488854605`, 0.9270509831248424}, {0., 3.}}]}},
                    ImageSize->{20, 8},
                    PlotRange->{{-10, 10}, {-4, 4}}], 
                    StyleBox[
                    TagBox["\<\"Some more\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                  },
                  AutoDelete->False,
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                  
                  GridBoxItemSize->{
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                  GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                 "Grid"], 
                TagBox[GridBox[{
                   {
                    GraphicsBox[{},
                    ImageSize->{20, 8},
                    PlotRange->{{-10, 10}, {-4, 4}}], 
                    StyleBox[
                    TagBox[
                    TagBox[
                    StyleBox["\<\"(Really!)\"\>",
                    FontSize->Small],
                    StyleForm[#, FontSize -> Small]& ],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                  },
                  AutoDelete->False,
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                  
                  GridBoxItemSize->{
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                  GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                 "Grid"]},
               {
                TagBox[GridBox[{
                   {
                    GraphicsBox[{
                    {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[4], 
                    CapForm[None], JoinForm[{"Miter", 3.25}], 
                    LineBox[{{-10, 0}, {10, 0}}]}, 
                    {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], 
                    Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
                    FaceForm[RGBColor[1, 0, 0]], 
                    PolygonBox[{{-2.8531695488854605`, 
                    0.9270509831248424}, {-1.7633557568774194`, \
-2.4270509831248424`}, {1.7633557568774194`, -2.4270509831248424`}, {
                    2.8531695488854605`, 0.9270509831248424}, {0., 3.}}]}},
                    ImageSize->{20, 8},
                    PlotRange->{{-10, 10}, {-4, 4}}], 
                    StyleBox[
                    TagBox["\<\"Yet more\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                  },
                  AutoDelete->False,
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                  
                  GridBoxItemSize->{
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                  GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                 "Grid"], 
                TagBox[GridBox[{
                   {"", ""}
                  },
                  AutoDelete->False,
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                  GridBoxItemSize->{
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                  GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                 "Grid"]}
              },
              AutoDelete->False,
              GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Center}}},
              
              GridBoxItemSize->{
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
              GridBoxSpacings->{"Columns" -> {{
                   Rational[5, 8]}}, "Rows" -> {{
                   Rational[1, 8]}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{4, 4}, {4, 4}},
          FrameStyle->None,
          RoundingRadius->{2, 2},
          StripOnInput->False], {21.6, 91.8}, {-1, 1}, Automatic, {1, 0}]},
       Frame->False,
       ImageSize->{432., 306.},
       PlotRange->{{0., 432.}, {0., 306.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {0., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{3.69, 0.}, {0., 0.}}], 
         LineBox[{{1.845, 15.299999999999983`}, {0., 15.299999999999983`}}], 
         LineBox[{{1.845, 30.599999999999994`}, {0., 30.599999999999994`}}], 
         LineBox[{{1.845, 45.900000000000006`}, {0., 45.900000000000006`}}], 
         LineBox[{{1.845, 61.2}, {0., 61.2}}], 
         LineBox[{{3.69, 76.5}, {0., 76.5}}], 
         LineBox[{{1.845, 91.8}, {0., 91.8}}], 
         LineBox[{{1.845, 107.1}, {0., 107.1}}], 
         LineBox[{{1.845, 122.4}, {0., 122.4}}], 
         LineBox[{{1.845, 137.7}, {0., 137.7}}], 
         LineBox[{{3.69, 153.}, {0., 153.}}], 
         LineBox[{{1.845, 168.3}, {0., 168.3}}], 
         LineBox[{{1.845, 183.6}, {0., 183.6}}], 
         LineBox[{{1.845, 198.9}, {0., 198.9}}], 
         LineBox[{{1.845, 214.2}, {0., 214.2}}], 
         LineBox[{{3.69, 229.5}, {0., 229.5}}], 
         LineBox[{{1.845, 244.8}, {0., 244.8}}], 
         LineBox[{{1.845, 260.1}, {0., 260.1}}], 
         LineBox[{{1.845, 275.4}, {0., 275.4}}], 
         LineBox[{{1.845, 290.70000000000005`}, {0., 290.70000000000005`}}], 
         LineBox[{{3.69, 306.}, {0., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{432., 0.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{428.31, 0.}, {432., 0.}}], 
         LineBox[{{430.155, 15.299999999999983`}, {432., 
          15.299999999999983`}}], 
         LineBox[{{430.155, 30.599999999999994`}, {432., 
          30.599999999999994`}}], 
         LineBox[{{430.155, 45.900000000000006`}, {432., 
          45.900000000000006`}}], LineBox[{{430.155, 61.2}, {432., 61.2}}], 
         LineBox[{{428.31, 76.5}, {432., 76.5}}], 
         LineBox[{{430.155, 91.8}, {432., 91.8}}], 
         LineBox[{{430.155, 107.1}, {432., 107.1}}], 
         LineBox[{{430.155, 122.4}, {432., 122.4}}], 
         LineBox[{{430.155, 137.7}, {432., 137.7}}], 
         LineBox[{{428.31, 153.}, {432., 153.}}], 
         LineBox[{{430.155, 168.3}, {432., 168.3}}], 
         LineBox[{{430.155, 183.6}, {432., 183.6}}], 
         LineBox[{{430.155, 198.9}, {432., 198.9}}], 
         LineBox[{{430.155, 214.2}, {432., 214.2}}], 
         LineBox[{{428.31, 229.5}, {432., 229.5}}], 
         LineBox[{{430.155, 244.8}, {432., 244.8}}], 
         LineBox[{{430.155, 260.1}, {432., 260.1}}], 
         LineBox[{{430.155, 275.4}, {432., 275.4}}], 
         LineBox[{{430.155, 290.70000000000005`}, {432., 
          290.70000000000005`}}], LineBox[{{428.31, 306.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {432., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{7.135466288054765, 1.845}, {7.135466288054765, 0.}}], 
         LineBox[{{19.636363636363637`, 3.69}, {19.636363636363637`, 0.}}], 
         LineBox[{{32.13726098467251, 1.845}, {32.13726098467251, 0.}}], 
         LineBox[{{44.63815833298138, 1.845}, {44.63815833298138, 0.}}], 
         LineBox[{{57.13905568129026, 1.845}, {57.13905568129026, 0.}}], 
         LineBox[{{69.63995302959913, 1.845}, {69.63995302959913, 0.}}], 
         LineBox[{{82.140850377908, 3.69}, {82.140850377908, 0.}}], 
         LineBox[{{94.64174772621686, 1.845}, {94.64174772621686, 0.}}], 
         LineBox[{{107.14264507452573`, 1.845}, {107.14264507452573`, 0.}}], 
         LineBox[{{119.64354242283461`, 1.845}, {119.64354242283461`, 0.}}], 
         LineBox[{{132.14443977114348`, 1.845}, {132.14443977114348`, 0.}}], 
         LineBox[{{144.64533711945234`, 3.69}, {144.64533711945234`, 0.}}], 
         LineBox[{{157.14623446776122`, 1.845}, {157.14623446776122`, 0.}}], 
         LineBox[{{169.64713181607007`, 1.845}, {169.64713181607007`, 0.}}], 
         LineBox[{{182.14802916437895`, 1.845}, {182.14802916437895`, 0.}}], 
         LineBox[{{194.6489265126878, 1.845}, {194.6489265126878, 0.}}], 
         LineBox[{{207.1498238609967, 3.69}, {207.1498238609967, 0.}}], 
         LineBox[{{219.65072120930557`, 1.845}, {219.65072120930557`, 0.}}], 
         LineBox[{{232.15161855761443`, 1.845}, {232.15161855761443`, 0.}}], 
         LineBox[{{244.6525159059233, 1.845}, {244.6525159059233, 0.}}], 
         LineBox[{{257.1534132542322, 1.845}, {257.1534132542322, 0.}}], 
         LineBox[{{269.65431060254105`, 3.69}, {269.65431060254105`, 0.}}], 
         LineBox[{{282.1552079508499, 1.845}, {282.1552079508499, 0.}}], 
         LineBox[{{294.6561052991588, 1.845}, {294.6561052991588, 0.}}], 
         LineBox[{{307.15700264746766`, 1.845}, {307.15700264746766`, 0.}}], 
         LineBox[{{319.6578999957765, 1.845}, {319.6578999957765, 0.}}], 
         LineBox[{{332.15879734408543`, 3.69}, {332.15879734408543`, 0.}}], 
         LineBox[{{344.6596946923943, 1.845}, {344.6596946923943, 0.}}], 
         LineBox[{{357.16059204070314`, 1.845}, {357.16059204070314`, 0.}}], 
         LineBox[{{369.661489389012, 1.845}, {369.661489389012, 0.}}], 
         LineBox[{{382.1623867373209, 1.845}, {382.1623867373209, 0.}}], 
         LineBox[{{394.66328408562975`, 3.69}, {394.66328408562975`, 0.}}], 
         LineBox[{{407.1641814339386, 1.845}, {407.1641814339386, 0.}}], 
         LineBox[{{419.6650787822475, 1.845}, {419.6650787822475, 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 306.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{7.135466288054765, 304.155}, {7.135466288054765, 306.}}], 
         LineBox[{{19.636363636363637`, 302.31}, {19.636363636363637`, 
          306.}}], 
         LineBox[{{32.13726098467251, 304.155}, {32.13726098467251, 306.}}], 
         LineBox[{{44.63815833298138, 304.155}, {44.63815833298138, 306.}}], 
         LineBox[{{57.13905568129026, 304.155}, {57.13905568129026, 306.}}], 
         LineBox[{{69.63995302959913, 304.155}, {69.63995302959913, 306.}}], 
         LineBox[{{82.140850377908, 302.31}, {82.140850377908, 306.}}], 
         LineBox[{{94.64174772621686, 304.155}, {94.64174772621686, 306.}}], 
         LineBox[{{107.14264507452573`, 304.155}, {107.14264507452573`, 
          306.}}], 
         LineBox[{{119.64354242283461`, 304.155}, {119.64354242283461`, 
          306.}}], 
         LineBox[{{132.14443977114348`, 304.155}, {132.14443977114348`, 
          306.}}], 
         LineBox[{{144.64533711945234`, 302.31}, {144.64533711945234`, 
          306.}}], 
         LineBox[{{157.14623446776122`, 304.155}, {157.14623446776122`, 
          306.}}], 
         LineBox[{{169.64713181607007`, 304.155}, {169.64713181607007`, 
          306.}}], 
         LineBox[{{182.14802916437895`, 304.155}, {182.14802916437895`, 
          306.}}], 
         LineBox[{{194.6489265126878, 304.155}, {194.6489265126878, 306.}}], 
         LineBox[{{207.1498238609967, 302.31}, {207.1498238609967, 306.}}], 
         LineBox[{{219.65072120930557`, 304.155}, {219.65072120930557`, 
          306.}}], 
         LineBox[{{232.15161855761443`, 304.155}, {232.15161855761443`, 
          306.}}], 
         LineBox[{{244.6525159059233, 304.155}, {244.6525159059233, 306.}}], 
         LineBox[{{257.1534132542322, 304.155}, {257.1534132542322, 306.}}], 
         LineBox[{{269.65431060254105`, 302.31}, {269.65431060254105`, 
          306.}}], 
         LineBox[{{282.1552079508499, 304.155}, {282.1552079508499, 306.}}], 
         LineBox[{{294.6561052991588, 304.155}, {294.6561052991588, 306.}}], 
         LineBox[{{307.15700264746766`, 304.155}, {307.15700264746766`, 
          306.}}], 
         LineBox[{{319.6578999957765, 304.155}, {319.6578999957765, 306.}}], 
         LineBox[{{332.15879734408543`, 302.31}, {332.15879734408543`, 
          306.}}], 
         LineBox[{{344.6596946923943, 304.155}, {344.6596946923943, 306.}}], 
         LineBox[{{357.16059204070314`, 304.155}, {357.16059204070314`, 
          306.}}], 
         LineBox[{{369.661489389012, 304.155}, {369.661489389012, 306.}}], 
         LineBox[{{382.1623867373209, 304.155}, {382.1623867373209, 306.}}], 
         LineBox[{{394.66328408562975`, 302.31}, {394.66328408562975`, 
          306.}}], 
         LineBox[{{407.1641814339386, 304.155}, {407.1641814339386, 306.}}], 
         LineBox[{{419.6650787822475, 304.155}, {419.6650787822475, 306.}}]}, 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {1, 0}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 76.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 153.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 229.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 306.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"y\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" (m)\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-18., 306.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {19.636363636363637`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {82.140850377908, 0.}, {0, 1}, Automatic, {1, 
         0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {144.64533711945234`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"3\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {207.1498238609967, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"4\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {269.65431060254105`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {332.15879734408543`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"6\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {394.66328408562975`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"t\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" (s)\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -15.}, {0, 1}, Automatic, {1., 0.}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {1, 0}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 76.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 153.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 229.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 306.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"y\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" (m)\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-18., 306.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {19.636363636363637`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {82.140850377908, 0.}, {0, 1}, Automatic, {1, 
         0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {144.64533711945234`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"3\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {207.1498238609967, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"4\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {269.65431060254105`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {332.15879734408543`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"6\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {394.66328408562975`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"t\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" (s)\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -15.}, {0, 1}, Automatic, {1., 0.}]},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->0.78125,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{576, 450.},
  PlotRange->{{-72, 504}, {-72., 378.}}]], "Output",
 CellChangeTimes->{
  3.5185348595625*^9, 3.5185348925*^9, {3.5185349995*^9, 
   3.518535104453125*^9}, {3.518535150609375*^9, 3.518535158703125*^9}, {
   3.518562311657875*^9, 3.518562319876625*^9}, 3.524748108125*^9, 
   3.5663387919775257`*^9, 3.5791218968865633`*^9, {3.584375461700574*^9, 
   3.5843755958413844`*^9}, 3.58437576547649*^9, 3.5846187918352804`*^9, {
   3.5930097131726384`*^9, 3.5930097216902533`*^9}, {3.5943048438896875`*^9, 
   3.5943048481328945`*^9}}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Fun with attached labels", "Subsection",
 CellChangeTimes->{{3.518534838171875*^9, 3.51853484209375*^9}, {
  3.518535171234375*^9, 3.51853517740625*^9}, {3.5843751778970766`*^9, 
  3.584375184667488*^9}, {3.58461767031651*^9, 3.584617672656514*^9}}],

Cell[TextData[{
 "Here we will make use of the predefined \[OpenCurlyDoubleQuote]attached \
labels\[CloseCurlyDoubleQuote] on a plot, and also name the curves so we can \
make anchors along them...\n\t-- Labels at the \[OpenCurlyDoubleQuote]heads\
\[CloseCurlyDoubleQuote] of the curves\n\t-- Labels along the sides of the \
curve\n\t-- Using anchors to help annotate the curves -- here we circle some \
of the points \nNote that we are making the ",
 StyleBox["x",
  FontSlant->"Italic"],
 " plot range a little wider, on the right, for this example, via \
XExtendRange, so there is room for labels at the ends.\nNote that that we use \
HeadTextNudge to move the labels at the head of the curve comfortably to the \
right of the data symbol.\nNote that that we use Left/RightTextBuffer to move \
the labels at the sides of the curve comfortably beyond the data symbols."
}], "Text",
 CellChangeTimes->{{3.5843752142763405`*^9, 3.584375296004884*^9}, {
  3.5846176819853306`*^9, 3.5846177466630445`*^9}, {3.5846191455659018`*^9, 
  3.5846191826627665`*^9}, {3.584619581212267*^9, 3.5846197318773317`*^9}, {
  3.5846200116170225`*^9, 3.5846200979475746`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"DefineStyle", "[", 
   RowBox[{"\"\<DataPlot1\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"DataLine", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"LineDashing", "\[Rule]", "4"}], "}"}]}], ",", 
      RowBox[{"DataSymbol", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"SymbolShape", "\[Rule]", "\"\<Circle\>\""}], ",", 
         RowBox[{"FillColor", "\[Rule]", "Red"}], ",", 
         RowBox[{"SymbolSize", "\[Rule]", "6"}]}], "}"}]}]}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Data1", "=", 
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{"Sin", "[", "x", "]"}]}], "}"}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{"2", "*", "Pi"}], ",", 
       RowBox[{"2", "*", 
        RowBox[{"Pi", "/", "16"}]}]}], "}"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineStyle", "[", 
   RowBox[{"\"\<DataPlot2\>\"", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"DataLine", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"LineDashing", "\[Rule]", "4"}], "}"}]}], ",", 
      RowBox[{"DataSymbol", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"SymbolShape", "\[Rule]", "\"\<Diamond\>\""}], ",", 
         RowBox[{"FillColor", "\[Rule]", "Red"}], ",", 
         RowBox[{"SymbolSize", "\[Rule]", "6"}]}], "}"}]}]}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Data2", "=", 
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"N", "[", 
      RowBox[{"{", 
       RowBox[{"x", ",", 
        RowBox[{"Sin", "[", 
         RowBox[{"x", "-", 
          RowBox[{"Pi", "/", "6"}]}], "]"}]}], "}"}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{"2", "*", "Pi"}], ",", 
       RowBox[{"2", "*", 
        RowBox[{"Pi", "/", "16"}]}]}], "}"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineStyle", "[", 
   RowBox[{"\"\<DataMarker\>\"", ",", 
    RowBox[{"{", 
     RowBox[{"FigCircle", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Radius", "\[Rule]", 
         RowBox[{"Canvas", "[", "8", "]"}]}], ",", 
        RowBox[{"FillColor", "\[Rule]", "Moccasin"}], ",", 
        RowBox[{"Layer", "\[Rule]", "0"}]}], "}"}]}], "}"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"SetOptions", "[", 
         RowBox[{"DataPlot", ",", 
          RowBox[{"HeadTextNudge", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"5", ",", "0"}], "}"}]}], ",", 
          RowBox[{"LeftTextBuffer", "\[Rule]", "2"}], ",", 
          RowBox[{"RightTextBuffer", "\[Rule]", "2"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "DataPlot", "\[LeftDoubleBracket]", "\"\<plot1\>\"", 
          "\[RightDoubleBracket]"}], "[", "\[IndentingNewLine]", 
         RowBox[{"Data1", ",", "\[IndentingNewLine]", 
          RowBox[{"Style", "\[Rule]", "\"\<DataPlot1\>\""}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"RightLabel", "\[Rule]", "\"\<Original\>\""}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"HeadLabel", "\[Rule]", "\"\<\[Pi]/6\>\""}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "DataPlot", "\[LeftDoubleBracket]", "\"\<plot2\>\"", 
          "\[RightDoubleBracket]"}], "[", "\[IndentingNewLine]", 
         RowBox[{"Data2", ",", "\[IndentingNewLine]", 
          RowBox[{"Style", "\[Rule]", "\"\<DataPlot2\>\""}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"LeftLabel", "\[Rule]", "\"\<Displaced\>\""}], ",", 
          RowBox[{"LeftLabelPosition", "\[Rule]", "0.6"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"HeadLabel", "\[Rule]", "\"\<0\>\""}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"FigCircle", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"FigAnchor", "[", 
           RowBox[{"\"\<plot1\>\"", ",", "Point", ",", "3"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Style", "\[Rule]", "\"\<DataMarker\>\""}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCircle", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"FigAnchor", "[", 
           RowBox[{"\"\<plot2\>\"", ",", "Point", ",", "3"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Style", "\[Rule]", "\"\<DataMarker\>\""}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"RightLabel", "\[Rule]", 
           RowBox[{"Column", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
              "\"\<This point is\>\"", ",", "\"\<circled because\>\"", ",", 
               "\"\<we like it!\>\""}], "}"}], ",", "Left", ",", "0"}], 
            "]"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"FontSize", "\[Rule]", "10"}], ",", "\[IndentingNewLine]", 
          RowBox[{"TextOffset", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "1"}], ",", "0.5"}], "}"}]}]}], 
         "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"XExtendRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"0.05", ",", "0.10"}], "}"}]}]}], "\[IndentingNewLine]", 
     "]"}], "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Style", "->", "\"\<ExampleDataFigure\>\""}]}], 
  "\[IndentingNewLine]", "]"}]}], "Input",
 CellChangeTimes->{{3.518118989375*^9, 3.51811900096875*^9}, {
   3.518119070828125*^9, 3.518119080140625*^9}, 3.518434829484375*^9, {
   3.518434975890625*^9, 3.51843500028125*^9}, {3.5184377235*^9, 
   3.518437729046875*^9}, 3.518438256265625*^9, {3.51843828675*^9, 
   3.518438315203125*^9}, 3.5184383755*^9, {3.51843951065625*^9, 
   3.51843951134375*^9}, {3.5184634049375*^9, 3.51846340696875*^9}, 
   3.518464317515625*^9, 3.518468703859375*^9, {3.518469036125*^9, 
   3.51846906240625*^9}, {3.518469211125*^9, 3.518469221234375*^9}, {
   3.518469265765625*^9, 3.51846928140625*^9}, 3.518469336328125*^9, {
   3.5185313745*^9, 3.518531402796875*^9}, {3.518531456359375*^9, 
   3.5185315070625*^9}, {3.518534850078125*^9, 3.51853485828125*^9}, {
   3.518534995328125*^9, 3.5185350056875*^9}, {3.518535076828125*^9, 
   3.51853515815625*^9}, {3.518562318376625*^9, 3.51856231951725*^9}, {
   3.5663387791543036`*^9, 3.566338791478325*^9}, 3.5837841994172688`*^9, {
   3.584375176571074*^9, 3.584375211593136*^9}, 3.5843752561000137`*^9, {
   3.5843753016208935`*^9, 3.584375618569234*^9}, 3.5843757643639727`*^9, 
   3.5846177085521774`*^9, {3.58461776717708*^9, 3.584617990070272*^9}, {
   3.5846188094165115`*^9, 3.584618812084116*^9}, {3.584619089998604*^9, 
   3.5846191175170527`*^9}, {3.5846191884503765`*^9, 
   3.5846193250754166`*^9}, {3.584619436990013*^9, 3.584619573973854*^9}, {
   3.5846197673049936`*^9, 3.5846200023038063`*^9}, {3.584620115466405*^9, 
   3.5846201156380053`*^9}, 3.59300938201814*^9, {3.59300973115947*^9, 
   3.593009773357544*^9}, {3.5943048782409477`*^9, 3.594304938379053*^9}, {
   3.625180141369116*^9, 3.625180146470325*^9}}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {432., 306.}]}, InsetBox[
      GraphicsBox[{
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {EdgeForm[None], FaceForm[RGBColor[1., 0.894101, 0.709799]], 
         GeometricTransformationBox[
          DiskBox[{65.73913043478261, 207.09366876077087`}, 8, {0., 
           6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         GeometricTransformationBox[
          CircleBox[{65.73913043478261, 207.09366876077087`}, 8, {0., 
           6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {EdgeForm[None], FaceForm[RGBColor[1., 0.894101, 0.709799]], 
         GeometricTransformationBox[
          DiskBox[{65.73913043478261, 172.79965695034284`}, 8, {0., 
           6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         GeometricTransformationBox[
          CircleBox[{65.73913043478261, 172.79965695034284`}, 8, {0., 
           6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[GridBox[{
               {
                RowBox[{"This", " ", "point", " ", "is"}]},
               {
                RowBox[{"circled", " ", "because"}]},
               {
                RowBox[{"we", " ", "like", " ", 
                 RowBox[{"it", "!"}]}]}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.5599999999999999]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {73.73913043478261, 172.79965695034284`}, {-1, 0.5},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[GridBox[{
              {
               RowBox[{"This", " ", "point", " ", "is"}]},
              {
               RowBox[{"circled", " ", "because"}]},
              {
               RowBox[{"we", " ", "like", " ", 
                RowBox[{"it", "!"}]}]}
             },
             
             GridBoxAlignment->{
              "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, 
               "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.27999999999999997`], {
                  Offset[0.5599999999999999]}, 
                 Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
               "Rows" -> {
                 Offset[0.2], {
                  Offset[0.]}, 
                 Offset[0.2]}, "RowsIndexed" -> {}}],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {73.73913043478261, 172.79965695034284`}, {-1, 0.5},
          Automatic, {1, 0}], 
        {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[4], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{18.782608695652176`, 153.}, {42.26086956521739, 
          182.27528257592937`}, {65.73913043478261, 207.09366876077087`}, {
          89.21739130434783, 223.67678423711345`}, {112.69565217391305`, 
          229.5}, {136.17391304347828`, 223.67678423711345`}, {
          159.6521739130435, 207.09366876077087`}, {183.13043478260872`, 
          182.27528257592937`}, {206.60869565217394`, 153.}, {
          230.08695652173915`, 123.72471742407063`}, {253.56521739130437`, 
          98.90633123922912}, {277.04347826086956`, 82.32321576288656}, {
          300.5217391304348, 76.5}, {324.00000000000006`, 
          82.32321576288656}, {347.47826086956525`, 98.90633123922912}, {
          370.95652173913044`, 123.72471742407063`}, {394.4347826086957, 
          153.}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{21.554247293186037`, 154.14805029709527`}, {
            20.903929039211818`, 155.12132034355963`}, {19.930658992747446`, 
            155.77163859753387`}, {18.782608695652176`, 156.}, {
            17.634558398556905`, 155.77163859753387`}, {16.661288352092534`, 
            155.12132034355963`}, {16.010970098118314`, 
            154.14805029709527`}, {15.782608695652176`, 153.}, {
            16.010970098118314`, 151.85194970290473`}, {16.661288352092534`, 
            150.87867965644037`}, {17.634558398556905`, 
            150.22836140246613`}, {18.782608695652176`, 150.}, {
            19.930658992747446`, 150.22836140246613`}, {20.903929039211818`, 
            150.87867965644037`}, {21.554247293186037`, 
            151.85194970290473`}, {21.782608695652176`, 153.}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{45.03250816275125, 183.42333287302463`}, {
            44.382189908777036`, 184.396602919489}, {43.40891986231266, 
            185.04692117346323`}, {42.26086956521739, 185.27528257592937`}, {
            41.112819268122124`, 185.04692117346323`}, {40.139549221657745`, 
            184.396602919489}, {39.48923096768353, 183.42333287302463`}, {
            39.26086956521739, 182.27528257592937`}, {39.48923096768353, 
            181.1272322788341}, {40.139549221657745`, 180.15396223236974`}, {
            41.112819268122124`, 179.5036439783955}, {42.26086956521739, 
            179.27528257592937`}, {43.40891986231266, 179.5036439783955}, {
            44.382189908777036`, 180.15396223236974`}, {45.03250816275125, 
            181.1272322788341}, {45.26086956521739, 182.27528257592937`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{68.51076903231647, 208.24171905786613`}, {
            67.86045077834225, 209.2149891043305}, {66.88718073187788, 
            209.86530735830473`}, {65.73913043478261, 210.09366876077087`}, {
            64.59108013768734, 209.86530735830473`}, {63.617810091222964`, 
            209.2149891043305}, {62.96749183724875, 208.24171905786613`}, {
            62.73913043478261, 207.09366876077087`}, {62.96749183724875, 
            205.9456184636756}, {63.617810091222964`, 204.97234841721124`}, {
            64.59108013768734, 204.322030163237}, {65.73913043478261, 
            204.09366876077087`}, {66.88718073187788, 204.322030163237}, {
            67.86045077834225, 204.97234841721124`}, {68.51076903231647, 
            205.9456184636756}, {68.73913043478261, 207.09366876077087`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{91.9890299018817, 224.82483453420872`}, {
            91.33871164790747, 225.79810458067308`}, {90.3654416014431, 
            226.44842283464732`}, {89.21739130434783, 226.67678423711345`}, {
            88.06934100725256, 226.44842283464732`}, {87.09607096078818, 
            225.79810458067308`}, {86.44575270681396, 224.82483453420872`}, {
            86.21739130434783, 223.67678423711345`}, {86.44575270681396, 
            222.52873394001818`}, {87.09607096078818, 221.55546389355382`}, {
            88.06934100725256, 220.9051456395796}, {89.21739130434783, 
            220.67678423711345`}, {90.3654416014431, 220.9051456395796}, {
            91.33871164790747, 221.55546389355382`}, {91.9890299018817, 
            222.52873394001818`}, {92.21739130434783, 
            223.67678423711345`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{115.46729077144691`, 230.64805029709527`}, {
            114.81697251747269`, 231.62132034355963`}, {113.84370247100831`, 
            232.27163859753387`}, {112.69565217391305`, 232.5}, {
            111.54760187681778`, 232.27163859753387`}, {110.5743318303534, 
            231.62132034355963`}, {109.92401357637918`, 
            230.64805029709527`}, {109.69565217391305`, 229.5}, {
            109.92401357637918`, 228.35194970290473`}, {110.5743318303534, 
            227.37867965644037`}, {111.54760187681778`, 
            226.72836140246613`}, {112.69565217391305`, 226.5}, {
            113.84370247100831`, 226.72836140246613`}, {114.81697251747269`, 
            227.37867965644037`}, {115.46729077144691`, 
            228.35194970290473`}, {115.69565217391305`, 229.5}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{138.94555164101214`, 224.82483453420872`}, {
            138.2952333870379, 225.79810458067308`}, {137.32196334057355`, 
            226.44842283464732`}, {136.17391304347828`, 
            226.67678423711345`}, {135.025862746383, 226.44842283464732`}, {
            134.05259269991865`, 225.79810458067308`}, {133.4022744459444, 
            224.82483453420872`}, {133.17391304347828`, 
            223.67678423711345`}, {133.4022744459444, 222.52873394001818`}, {
            134.05259269991865`, 221.55546389355382`}, {135.025862746383, 
            220.9051456395796}, {136.17391304347828`, 220.67678423711345`}, {
            137.32196334057355`, 220.9051456395796}, {138.2952333870379, 
            221.55546389355382`}, {138.94555164101214`, 
            222.52873394001818`}, {139.17391304347828`, 
            223.67678423711345`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{162.42381251057736`, 208.24171905786613`}, {
            161.77349425660313`, 209.2149891043305}, {160.80022421013877`, 
            209.86530735830473`}, {159.6521739130435, 210.09366876077087`}, {
            158.50412361594823`, 209.86530735830473`}, {157.53085356948387`, 
            209.2149891043305}, {156.88053531550963`, 208.24171905786613`}, {
            156.6521739130435, 207.09366876077087`}, {156.88053531550963`, 
            205.9456184636756}, {157.53085356948387`, 204.97234841721124`}, {
            158.50412361594823`, 204.322030163237}, {159.6521739130435, 
            204.09366876077087`}, {160.80022421013877`, 204.322030163237}, {
            161.77349425660313`, 204.97234841721124`}, {162.42381251057736`, 
            205.9456184636756}, {162.6521739130435, 207.09366876077087`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{185.90207338014258`, 183.42333287302463`}, {
            185.25175512616835`, 184.396602919489}, {184.27848507970398`, 
            185.04692117346323`}, {183.13043478260872`, 
            185.27528257592937`}, {181.98238448551345`, 
            185.04692117346323`}, {181.00911443904909`, 184.396602919489}, {
            180.35879618507485`, 183.42333287302463`}, {180.13043478260872`, 
            182.27528257592937`}, {180.35879618507485`, 181.1272322788341}, {
            181.00911443904909`, 180.15396223236974`}, {181.98238448551345`, 
            179.5036439783955}, {183.13043478260872`, 179.27528257592937`}, {
            184.27848507970398`, 179.5036439783955}, {185.25175512616835`, 
            180.15396223236974`}, {185.90207338014258`, 181.1272322788341}, {
            186.13043478260872`, 182.27528257592937`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{209.3803342497078, 154.14805029709527`}, {
            208.73001599573357`, 155.12132034355963`}, {207.7567459492692, 
            155.77163859753387`}, {206.60869565217394`, 156.}, {
            205.46064535507867`, 155.77163859753387`}, {204.4873753086143, 
            155.12132034355963`}, {203.83705705464007`, 
            154.14805029709527`}, {203.60869565217394`, 153.}, {
            203.83705705464007`, 151.85194970290473`}, {204.4873753086143, 
            150.87867965644037`}, {205.46064535507867`, 
            150.22836140246613`}, {206.60869565217394`, 150.}, {
            207.7567459492692, 150.22836140246613`}, {208.73001599573357`, 
            150.87867965644037`}, {209.3803342497078, 151.85194970290473`}, {
            209.60869565217394`, 153.}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{232.85859511927302`, 124.8727677211659}, {
            232.20827686529879`, 125.84603776763028`}, {231.23500681883442`, 
            126.4963560216045}, {230.08695652173915`, 126.72471742407063`}, {
            228.9389062246439, 126.4963560216045}, {227.96563617817952`, 
            125.84603776763028`}, {227.3153179242053, 124.8727677211659}, {
            227.08695652173915`, 123.72471742407063`}, {227.3153179242053, 
            122.57666712697537`}, {227.96563617817952`, 
            121.60339708051099`}, {228.9389062246439, 120.95307882653677`}, {
            230.08695652173915`, 120.72471742407063`}, {231.23500681883442`, 
            120.95307882653677`}, {232.20827686529879`, 
            121.60339708051099`}, {232.85859511927302`, 
            122.57666712697537`}, {233.08695652173915`, 
            123.72471742407063`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{256.33685598883824`, 100.05438153632439`}, {
            255.686537734864, 101.02765158278876`}, {254.71326768839964`, 
            101.67796983676298`}, {253.56521739130437`, 
            101.90633123922912`}, {252.4171670942091, 101.67796983676298`}, {
            251.44389704774474`, 101.02765158278876`}, {250.7935787937705, 
            100.05438153632439`}, {250.56521739130437`, 98.90633123922912}, {
            250.7935787937705, 97.75828094213385}, {251.44389704774474`, 
            96.78501089566947}, {252.4171670942091, 96.13469264169525}, {
            253.56521739130437`, 95.90633123922912}, {254.71326768839964`, 
            96.13469264169525}, {255.686537734864, 96.78501089566947}, {
            256.33685598883824`, 97.75828094213385}, {256.5652173913044, 
            98.90633123922912}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{279.8151168584034, 83.47126605998183}, {
            279.1647986044292, 84.44453610644621}, {278.19152855796483`, 
            85.09485436042043}, {277.04347826086956`, 85.32321576288656}, {
            275.8954279637743, 85.09485436042043}, {274.9221579173099, 
            84.44453610644621}, {274.2718396633357, 83.47126605998183}, {
            274.04347826086956`, 82.32321576288656}, {274.2718396633357, 
            81.1751654657913}, {274.9221579173099, 80.20189541932692}, {
            275.8954279637743, 79.5515771653527}, {277.04347826086956`, 
            79.32321576288656}, {278.19152855796483`, 79.5515771653527}, {
            279.1647986044292, 80.20189541932692}, {279.8151168584034, 
            81.1751654657913}, {280.04347826086956`, 82.32321576288656}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{303.2933777279687, 77.64805029709527}, {
            302.64305947399447`, 78.62132034355965}, {301.6697894275301, 
            79.27163859753387}, {300.5217391304348, 79.5}, {
            299.37368883333954`, 79.27163859753387}, {298.40041878687515`, 
            78.62132034355965}, {297.75010053290094`, 77.64805029709527}, {
            297.5217391304348, 76.5}, {297.75010053290094`, 
            75.35194970290473}, {298.40041878687515`, 74.37867965644035}, {
            299.37368883333954`, 73.72836140246613}, {300.5217391304348, 
            73.5}, {301.6697894275301, 73.72836140246613}, {
            302.64305947399447`, 74.37867965644035}, {303.2933777279687, 
            75.35194970290473}, {303.5217391304348, 76.5}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{326.7716385975339, 83.47126605998183}, {
            326.1213203435597, 84.44453610644621}, {325.1480502970953, 
            85.09485436042043}, {324.00000000000006`, 85.32321576288656}, {
            322.8519497029048, 85.09485436042043}, {321.8786796564404, 
            84.44453610644621}, {321.2283614024662, 83.47126605998183}, {
            321.00000000000006`, 82.32321576288656}, {321.2283614024662, 
            81.1751654657913}, {321.8786796564404, 80.20189541932692}, {
            322.8519497029048, 79.5515771653527}, {324.00000000000006`, 
            79.32321576288656}, {325.1480502970953, 79.5515771653527}, {
            326.1213203435597, 80.20189541932692}, {326.7716385975339, 
            81.1751654657913}, {327.00000000000006`, 82.32321576288656}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{350.2498994670991, 100.05438153632439`}, {
            349.5995812131249, 101.02765158278876`}, {348.6263111666605, 
            101.67796983676298`}, {347.47826086956525`, 
            101.90633123922912`}, {346.33021057247, 101.67796983676298`}, {
            345.3569405260056, 101.02765158278876`}, {344.7066222720314, 
            100.05438153632439`}, {344.47826086956525`, 98.90633123922912}, {
            344.7066222720314, 97.75828094213385}, {345.3569405260056, 
            96.78501089566947}, {346.33021057247, 96.13469264169525}, {
            347.47826086956525`, 95.90633123922912}, {348.6263111666605, 
            96.13469264169525}, {349.5995812131249, 96.78501089566947}, {
            350.2498994670991, 97.75828094213385}, {350.47826086956525`, 
            98.90633123922912}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{373.7281603366643, 124.8727677211659}, {
            373.0778420826901, 125.84603776763028`}, {372.1045720362257, 
            126.4963560216045}, {370.95652173913044`, 126.72471742407063`}, {
            369.80847144203517`, 126.4963560216045}, {368.8352013955708, 
            125.84603776763028`}, {368.1848831415966, 124.8727677211659}, {
            367.95652173913044`, 123.72471742407063`}, {368.1848831415966, 
            122.57666712697537`}, {368.8352013955708, 121.60339708051099`}, {
            369.80847144203517`, 120.95307882653677`}, {370.95652173913044`, 
            120.72471742407063`}, {372.1045720362257, 120.95307882653677`}, {
            373.0778420826901, 121.60339708051099`}, {373.7281603366643, 
            122.57666712697537`}, {373.95652173913044`, 
            123.72471742407063`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{397.20642120622955`, 154.14805029709527`}, {
            396.55610295225534`, 155.12132034355963`}, {395.58283290579095`, 
            155.77163859753387`}, {394.4347826086957, 156.}, {
            393.2867323116004, 155.77163859753387`}, {392.313462265136, 
            155.12132034355963`}, {391.6631440111618, 154.14805029709527`}, {
            391.4347826086957, 153.}, {391.6631440111618, 
            151.85194970290473`}, {392.313462265136, 150.87867965644037`}, {
            393.2867323116004, 150.22836140246613`}, {394.4347826086957, 
            150.}, {395.58283290579095`, 150.22836140246613`}, {
            396.55610295225534`, 150.87867965644037`}, {397.20642120622955`, 
            151.85194970290473`}, {397.4347826086957, 153.}}]}}}, 
        {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[4], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{18.782608695652176`, 114.75}, {42.26086956521739, 
          143.01474629516605`}, {65.73913043478261, 172.79965695034284`}, {
          89.21739130434783, 199.57024931916715`}, {112.69565217391305`, 
          219.25094338950956`}, {136.17391304347828`, 228.84553189509649`}, {
          159.6521739130435, 226.89332571111373`}, {183.13043478260872`, 
          213.6915305322795}, {206.60869565217394`, 191.25}, {
          230.08695652173915`, 162.98525370483395`}, {253.56521739130437`, 
          133.20034304965716`}, {277.04347826086956`, 106.42975068083287`}, {
          300.5217391304348, 86.74905661049044}, {324.00000000000006`, 
          77.1544681049035}, {347.47826086956525`, 79.10667428888628}, {
          370.95652173913044`, 92.3084694677205}, {394.4347826086957, 
          114.75}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{18.782608695652176`, 118.35}, {15.182608695652176`, 
            114.75}, {18.782608695652176`, 111.15}, {22.382608695652173`, 
            114.75}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{42.26086956521739, 146.61474629516604`}, {
            38.66086956521739, 143.01474629516605`}, {42.26086956521739, 
            139.41474629516605`}, {45.86086956521739, 
            143.01474629516605`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{65.73913043478261, 176.39965695034283`}, {
            62.13913043478261, 172.79965695034284`}, {65.73913043478261, 
            169.19965695034284`}, {69.3391304347826, 
            172.79965695034284`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{89.21739130434783, 203.17024931916714`}, {
            85.61739130434783, 199.57024931916715`}, {89.21739130434783, 
            195.97024931916715`}, {92.81739130434782, 
            199.57024931916715`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{112.69565217391305`, 222.85094338950955`}, {
            109.09565217391305`, 219.25094338950956`}, {112.69565217391305`, 
            215.65094338950956`}, {116.29565217391304`, 
            219.25094338950956`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{136.17391304347828`, 232.44553189509648`}, {
            132.57391304347829`, 228.84553189509649`}, {136.17391304347828`, 
            225.2455318950965}, {139.77391304347827`, 
            228.84553189509649`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{159.6521739130435, 230.49332571111373`}, {
            156.0521739130435, 226.89332571111373`}, {159.6521739130435, 
            223.29332571111374`}, {163.2521739130435, 
            226.89332571111373`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{183.13043478260872`, 217.2915305322795}, {
            179.53043478260872`, 213.6915305322795}, {183.13043478260872`, 
            210.0915305322795}, {186.7304347826087, 213.6915305322795}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{206.60869565217394`, 194.85}, {203.00869565217394`, 
            191.25}, {206.60869565217394`, 187.65}, {210.20869565217393`, 
            191.25}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{230.08695652173915`, 166.58525370483395`}, {
            226.48695652173916`, 162.98525370483395`}, {230.08695652173915`, 
            159.38525370483396`}, {233.68695652173915`, 
            162.98525370483395`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{253.56521739130437`, 136.80034304965716`}, {
            249.96521739130438`, 133.20034304965716`}, {253.56521739130437`, 
            129.60034304965717`}, {257.1652173913044, 
            133.20034304965716`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{277.04347826086956`, 110.02975068083286`}, {
            273.44347826086954`, 106.42975068083287`}, {277.04347826086956`, 
            102.82975068083287`}, {280.6434782608696, 
            106.42975068083287`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{300.5217391304348, 90.34905661049044}, {
            296.9217391304348, 86.74905661049044}, {300.5217391304348, 
            83.14905661049045}, {304.12173913043483`, 86.74905661049044}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{324.00000000000006`, 80.7544681049035}, {
            320.40000000000003`, 77.1544681049035}, {324.00000000000006`, 
            73.5544681049035}, {327.6000000000001, 77.1544681049035}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{347.47826086956525`, 82.70667428888628}, {
            343.8782608695652, 79.10667428888628}, {347.47826086956525`, 
            75.50667428888629}, {351.07826086956527`, 79.10667428888628}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{370.95652173913044`, 95.9084694677205}, {
            367.3565217391304, 92.3084694677205}, {370.95652173913044`, 
            88.7084694677205}, {374.55652173913046`, 92.3084694677205}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{394.4347826086957, 118.35}, {390.83478260869566`, 
            114.75}, {394.4347826086957, 111.15}, {398.0347826086957, 
            114.75}}]}}}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Original\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {205.04846793699068`, 151.74872485968353`}, {0, 1},
          Automatic, {0.6256375701582155, -0.7801138575916492}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"\[Pi]/6\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {399.43478260869574`, 153.00000000000006`}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Displaced\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {239.77092217457155`, 153.9307344999918}, {0, -1},
          Automatic, {0.619057045269988, -0.7853460222739987}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {399.43478260869574`, 114.75000000000004`}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Original\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {205.04846793699068`, 151.74872485968353`}, {0, 1},
          Automatic, {0.6256375701582155, -0.7801138575916492}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"\[Pi]/6\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {399.43478260869574`, 153.00000000000006`}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Displaced\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {239.77092217457155`, 153.9307344999918}, {0, -1},
          Automatic, {0.619057045269988, -0.7853460222739987}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {399.43478260869574`, 114.75000000000004`}, {-1, 0},
          Automatic, {1, 0}]},
       Frame->False,
       ImageSize->{432., 306.},
       PlotRange->{{0., 432.}, {0., 306.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {0., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{3.69, 0.}, {0., 0.}}], 
         LineBox[{{1.845, 15.299999999999983`}, {0., 15.299999999999983`}}], 
         LineBox[{{1.845, 30.599999999999994`}, {0., 30.599999999999994`}}], 
         LineBox[{{1.845, 45.900000000000006`}, {0., 45.900000000000006`}}], 
         LineBox[{{1.845, 61.2}, {0., 61.2}}], 
         LineBox[{{3.69, 76.5}, {0., 76.5}}], 
         LineBox[{{1.845, 91.8}, {0., 91.8}}], 
         LineBox[{{1.845, 107.1}, {0., 107.1}}], 
         LineBox[{{1.845, 122.4}, {0., 122.4}}], 
         LineBox[{{1.845, 137.7}, {0., 137.7}}], 
         LineBox[{{3.69, 153.}, {0., 153.}}], 
         LineBox[{{1.845, 168.3}, {0., 168.3}}], 
         LineBox[{{1.845, 183.6}, {0., 183.6}}], 
         LineBox[{{1.845, 198.9}, {0., 198.9}}], 
         LineBox[{{1.845, 214.2}, {0., 214.2}}], 
         LineBox[{{3.69, 229.5}, {0., 229.5}}], 
         LineBox[{{1.845, 244.8}, {0., 244.8}}], 
         LineBox[{{1.845, 260.1}, {0., 260.1}}], 
         LineBox[{{1.845, 275.4}, {0., 275.4}}], 
         LineBox[{{1.845, 290.70000000000005`}, {0., 290.70000000000005`}}], 
         LineBox[{{3.69, 306.}, {0., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{432., 0.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{428.31, 0.}, {432., 0.}}], 
         LineBox[{{430.155, 15.299999999999983`}, {432., 
          15.299999999999983`}}], 
         LineBox[{{430.155, 30.599999999999994`}, {432., 
          30.599999999999994`}}], 
         LineBox[{{430.155, 45.900000000000006`}, {432., 
          45.900000000000006`}}], LineBox[{{430.155, 61.2}, {432., 61.2}}], 
         LineBox[{{428.31, 76.5}, {432., 76.5}}], 
         LineBox[{{430.155, 91.8}, {432., 91.8}}], 
         LineBox[{{430.155, 107.1}, {432., 107.1}}], 
         LineBox[{{430.155, 122.4}, {432., 122.4}}], 
         LineBox[{{430.155, 137.7}, {432., 137.7}}], 
         LineBox[{{428.31, 153.}, {432., 153.}}], 
         LineBox[{{430.155, 168.3}, {432., 168.3}}], 
         LineBox[{{430.155, 183.6}, {432., 183.6}}], 
         LineBox[{{430.155, 198.9}, {432., 198.9}}], 
         LineBox[{{430.155, 214.2}, {432., 214.2}}], 
         LineBox[{{428.31, 229.5}, {432., 229.5}}], 
         LineBox[{{430.155, 244.8}, {432., 244.8}}], 
         LineBox[{{430.155, 260.1}, {432., 260.1}}], 
         LineBox[{{430.155, 275.4}, {432., 275.4}}], 
         LineBox[{{430.155, 290.70000000000005`}, {432., 
          290.70000000000005`}}], LineBox[{{428.31, 306.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {432., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{6.8252286233567325`, 1.845}, {6.8252286233567325`, 0.}}], 
         LineBox[{{18.782608695652176`, 3.69}, {18.782608695652176`, 0.}}], 
         LineBox[{{30.73998876794762, 1.845}, {30.73998876794762, 0.}}], 
         LineBox[{{42.69736884024306, 1.845}, {42.69736884024306, 0.}}], 
         LineBox[{{54.65474891253851, 1.845}, {54.65474891253851, 0.}}], 
         LineBox[{{66.61212898483394, 1.845}, {66.61212898483394, 0.}}], 
         LineBox[{{78.56950905712938, 3.69}, {78.56950905712938, 0.}}], 
         LineBox[{{90.52688912942482, 1.845}, {90.52688912942482, 0.}}], 
         LineBox[{{102.48426920172025`, 1.845}, {102.48426920172025`, 0.}}], 
         LineBox[{{114.44164927401572`, 1.845}, {114.44164927401572`, 0.}}], 
         LineBox[{{126.39902934631115`, 1.845}, {126.39902934631115`, 0.}}], 
         LineBox[{{138.3564094186066, 3.69}, {138.3564094186066, 0.}}], 
         LineBox[{{150.31378949090205`, 1.845}, {150.31378949090205`, 0.}}], 
         LineBox[{{162.27116956319747`, 1.845}, {162.27116956319747`, 0.}}], 
         LineBox[{{174.22854963549293`, 1.845}, {174.22854963549293`, 0.}}], 
         LineBox[{{186.18592970778835`, 1.845}, {186.18592970778835`, 0.}}], 
         LineBox[{{198.14330978008383`, 3.69}, {198.14330978008383`, 0.}}], 
         LineBox[{{210.10068985237928`, 1.845}, {210.10068985237928`, 0.}}], 
         LineBox[{{222.0580699246747, 1.845}, {222.0580699246747, 0.}}], 
         LineBox[{{234.01544999697015`, 1.845}, {234.01544999697015`, 0.}}], 
         LineBox[{{245.97283006926557`, 1.845}, {245.97283006926557`, 0.}}], 
         LineBox[{{257.930210141561, 3.69}, {257.930210141561, 0.}}], 
         LineBox[{{269.88759021385647`, 1.845}, {269.88759021385647`, 0.}}], 
         LineBox[{{281.8449702861519, 1.845}, {281.8449702861519, 0.}}], 
         LineBox[{{293.8023503584473, 1.845}, {293.8023503584473, 0.}}], 
         LineBox[{{305.75973043074276`, 1.845}, {305.75973043074276`, 0.}}], 
         LineBox[{{317.7171105030382, 3.69}, {317.7171105030382, 0.}}], 
         LineBox[{{329.67449057533366`, 1.845}, {329.67449057533366`, 0.}}], 
         LineBox[{{341.6318706476291, 1.845}, {341.6318706476291, 0.}}], 
         LineBox[{{353.5892507199245, 1.845}, {353.5892507199245, 0.}}], 
         LineBox[{{365.54663079221996`, 1.845}, {365.54663079221996`, 0.}}], 
         LineBox[{{377.50401086451546`, 3.69}, {377.50401086451546`, 0.}}], 
         LineBox[{{389.4613909368109, 1.845}, {389.4613909368109, 0.}}], 
         LineBox[{{401.41877100910636`, 1.845}, {401.41877100910636`, 0.}}], 
         LineBox[{{413.3761510814018, 1.845}, {413.3761510814018, 0.}}], 
         LineBox[{{425.33353115369727`, 1.845}, {425.33353115369727`, 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 306.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{6.8252286233567325`, 304.155}, {6.8252286233567325`, 
          306.}}], 
         LineBox[{{18.782608695652176`, 302.31}, {18.782608695652176`, 
          306.}}], 
         LineBox[{{30.73998876794762, 304.155}, {30.73998876794762, 306.}}], 
         LineBox[{{42.69736884024306, 304.155}, {42.69736884024306, 306.}}], 
         LineBox[{{54.65474891253851, 304.155}, {54.65474891253851, 306.}}], 
         LineBox[{{66.61212898483394, 304.155}, {66.61212898483394, 306.}}], 
         LineBox[{{78.56950905712938, 302.31}, {78.56950905712938, 306.}}], 
         LineBox[{{90.52688912942482, 304.155}, {90.52688912942482, 306.}}], 
         LineBox[{{102.48426920172025`, 304.155}, {102.48426920172025`, 
          306.}}], 
         LineBox[{{114.44164927401572`, 304.155}, {114.44164927401572`, 
          306.}}], 
         LineBox[{{126.39902934631115`, 304.155}, {126.39902934631115`, 
          306.}}], 
         LineBox[{{138.3564094186066, 302.31}, {138.3564094186066, 306.}}], 
         LineBox[{{150.31378949090205`, 304.155}, {150.31378949090205`, 
          306.}}], 
         LineBox[{{162.27116956319747`, 304.155}, {162.27116956319747`, 
          306.}}], 
         LineBox[{{174.22854963549293`, 304.155}, {174.22854963549293`, 
          306.}}], 
         LineBox[{{186.18592970778835`, 304.155}, {186.18592970778835`, 
          306.}}], 
         LineBox[{{198.14330978008383`, 302.31}, {198.14330978008383`, 
          306.}}], 
         LineBox[{{210.10068985237928`, 304.155}, {210.10068985237928`, 
          306.}}], 
         LineBox[{{222.0580699246747, 304.155}, {222.0580699246747, 306.}}], 
         LineBox[{{234.01544999697015`, 304.155}, {234.01544999697015`, 
          306.}}], 
         LineBox[{{245.97283006926557`, 304.155}, {245.97283006926557`, 
          306.}}], 
         LineBox[{{257.930210141561, 302.31}, {257.930210141561, 306.}}], 
         LineBox[{{269.88759021385647`, 304.155}, {269.88759021385647`, 
          306.}}], 
         LineBox[{{281.8449702861519, 304.155}, {281.8449702861519, 306.}}], 
         LineBox[{{293.8023503584473, 304.155}, {293.8023503584473, 306.}}], 
         LineBox[{{305.75973043074276`, 304.155}, {305.75973043074276`, 
          306.}}], 
         LineBox[{{317.7171105030382, 302.31}, {317.7171105030382, 306.}}], 
         LineBox[{{329.67449057533366`, 304.155}, {329.67449057533366`, 
          306.}}], 
         LineBox[{{341.6318706476291, 304.155}, {341.6318706476291, 306.}}], 
         LineBox[{{353.5892507199245, 304.155}, {353.5892507199245, 306.}}], 
         LineBox[{{365.54663079221996`, 304.155}, {365.54663079221996`, 
          306.}}], 
         LineBox[{{377.50401086451546`, 302.31}, {377.50401086451546`, 
          306.}}], 
         LineBox[{{389.4613909368109, 304.155}, {389.4613909368109, 306.}}], 
         LineBox[{{401.41877100910636`, 304.155}, {401.41877100910636`, 
          306.}}], 
         LineBox[{{413.3761510814018, 304.155}, {413.3761510814018, 306.}}], 
         LineBox[{{425.33353115369727`, 304.155}, {425.33353115369727`, 
          306.}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {1, 0}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 76.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 153.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 229.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 306.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"y\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" (m)\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-18., 306.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {18.782608695652176`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {78.56950905712938, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {138.3564094186066, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"3\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {198.14330978008383`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"4\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {257.930210141561, 0.}, {0, 1}, Automatic, {1,
          0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {317.7171105030382, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"6\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {377.50401086451546`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"t\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" (s)\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -15.}, {0, 1}, Automatic, {1., 0.}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {1, 0}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 76.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 153.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 229.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 306.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"y\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" (m)\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-18., 306.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {18.782608695652176`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {78.56950905712938, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {138.3564094186066, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"3\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {198.14330978008383`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"4\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {257.930210141561, 0.}, {0, 1}, Automatic, {1,
          0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {317.7171105030382, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"6\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {377.50401086451546`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"t\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" (s)\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -15.}, {0, 1}, Automatic, {1., 0.}]},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->0.78125,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{576, 450.},
  PlotRange->{{-72, 504}, {-72., 378.}}]], "Output",
 CellChangeTimes->{{3.58461788071408*^9, 3.5846178884204936`*^9}, {
   3.58461793181977*^9, 3.5846179491982*^9}, {3.584617982675859*^9, 
   3.5846179910374737`*^9}, 3.5846187988084927`*^9, 3.5846190561621447`*^9, 
   3.584619118952255*^9, 3.5846191893239784`*^9, {3.5846192746093283`*^9, 
   3.5846193005209737`*^9}, 3.5846193981459455`*^9, {3.5846194854280987`*^9, 
   3.5846195753154564`*^9}, {3.5846197817974195`*^9, 3.58461979384064*^9}, {
   3.5846198912472115`*^9, 3.5846199208248634`*^9}, {3.5846199775153627`*^9, 
   3.5846200033334084`*^9}, 3.584620116714407*^9, 3.5930097867891674`*^9, {
   3.5930103460589247`*^9, 3.593010356999093*^9}, {3.594304890627369*^9, 
   3.594304905946596*^9}, 3.5943049394398546`*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Log plot", "Subsection",
 CellChangeTimes->{{3.49903452359375*^9, 3.49903452525*^9}, {
  3.51846896715625*^9, 3.51846901259375*^9}, {3.584375824838843*^9, 
  3.584375840048869*^9}}],

Cell["\<\
Now plotted on a log plot...  Note negative values don\[CloseCurlyQuote]t \
show up, of course...
\tNote: Error bars extending to negative y values become error bars to -\
\[Infinity] on a log plot!  Let\[CloseCurlyQuote]s make up some new data with \
bigger error bars to show this!\
\>", "Text",
 CellChangeTimes->{{3.5843758428568745`*^9, 3.584375852357291*^9}, {
  3.584375895007766*^9, 3.5843759316522303`*^9}, {3.584375998123947*^9, 
  3.5843760075775633`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DataForLog", "=", 
  RowBox[{"N", "@", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"Sin", "[", "x", "]"}], ",", 
       RowBox[{
        RowBox[{"Abs", "[", 
         RowBox[{"0.3", "*", 
          RowBox[{"Cos", "[", "x", "]"}]}], "]"}], "+", "0.2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", 
       RowBox[{"2", "*", "Pi"}], ",", 
       RowBox[{"2", "*", 
        RowBox[{"Pi", "/", "16"}]}]}], "}"}]}], "]"}]}]}]], "Input",
 CellChangeTimes->{{3.518118989375*^9, 3.51811900096875*^9}, {
   3.518119070828125*^9, 3.518119080140625*^9}, 3.518434829484375*^9, {
   3.518434975890625*^9, 3.51843500028125*^9}, {3.5184377235*^9, 
   3.518437729046875*^9}, 3.518438256265625*^9, {3.51843828675*^9, 
   3.518438315203125*^9}, 3.5184383755*^9, {3.51843951065625*^9, 
   3.51843951134375*^9}, {3.5184634049375*^9, 3.51846340696875*^9}, 
   3.518464317515625*^9, 3.518468703859375*^9, {3.518469065765625*^9, 
   3.51846912021875*^9}, {3.51846915140625*^9, 3.51846919640625*^9}, {
   3.518469259125*^9, 3.518469296625*^9}, 3.5184693335625*^9, {
   3.518562335220375*^9, 3.51856234876725*^9}, {3.566338797078735*^9, 
   3.566338801306342*^9}, 3.5837841994640684`*^9, {3.584375773419112*^9, 
   3.5843758125460215`*^9}, {3.5843758870205517`*^9, 3.584375911075794*^9}, {
   3.584375961120682*^9, 3.584375962181484*^9}, 3.584376016063978*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.`", ",", "0.`", ",", "0.5`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.39269908169872414`", ",", "0.3826834323650898`", ",", 
     "0.47716385975338604`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "0.7853981633974483`", ",", "0.7071067811865475`", ",", 
     "0.41213203435596424`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1.1780972450961724`", ",", "0.9238795325112867`", ",", 
     "0.31480502970952695`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.5707963267948966`", ",", "1.`", ",", "0.2`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "1.9634954084936207`", ",", "0.9238795325112867`", ",", 
     "0.31480502970952695`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "2.356194490192345`", ",", "0.7071067811865475`", ",", 
     "0.41213203435596424`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "2.748893571891069`", ",", "0.3826834323650898`", ",", 
     "0.47716385975338604`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3.141592653589793`", ",", "0.`", ",", "0.5`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3.5342917352885173`", ",", 
     RowBox[{"-", "0.3826834323650898`"}], ",", "0.47716385975338604`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3.9269908169872414`", ",", 
     RowBox[{"-", "0.7071067811865475`"}], ",", "0.41213203435596424`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4.319689898685965`", ",", 
     RowBox[{"-", "0.9238795325112867`"}], ",", "0.31480502970952695`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4.71238898038469`", ",", 
     RowBox[{"-", "1.`"}], ",", "0.2`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5.105088062083414`", ",", 
     RowBox[{"-", "0.9238795325112867`"}], ",", "0.31480502970952695`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5.497787143782138`", ",", 
     RowBox[{"-", "0.7071067811865475`"}], ",", "0.41213203435596424`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5.890486225480862`", ",", 
     RowBox[{"-", "0.3826834323650898`"}], ",", "0.47716385975338604`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6.283185307179586`", ",", "0.`", ",", "0.5`"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.5843760171871805`*^9, 3.5930109407190585`*^9, 
  3.5943047172174644`*^9}]
}, Open  ]],

Cell["\<\
Note: It is assumed that you have already evaluated the cell which defines \
the style \[OpenCurlyDoubleQuote]DataPlot\[CloseCurlyDoubleQuote], somewhere \
up above.\
\>", "Text",
 CellChangeTimes->{{3.594305037579627*^9, 3.594305068233681*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DataPlot", "[", 
         RowBox[{"DataForLog", ",", 
          RowBox[{"YErrorColumn", "\[Rule]", "3"}], ",", 
          RowBox[{"YAxisScale", "\[Rule]", "Log"}], ",", 
          RowBox[{"Style", "\[Rule]", "\"\<DataPlot\>\""}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"DataLegend", "[", 
         RowBox[{
          RowBox[{"Scaled", "[", 
           RowBox[{"{", 
            RowBox[{"0.1", ",", "0.95"}], "}"}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"\"\<DataPlot\>\"", ",", "\"\<Data\>\""}], "}"}], "}"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"TextFrame", "\[Rule]", "True"}], ",", 
          RowBox[{"TextMargin", "\[Rule]", "4"}], ",", 
          RowBox[{"TextRoundingRadius", "\[Rule]", "2"}], ",", 
          RowBox[{"TextBackground", "\[Rule]", "Moccasin"}]}], "]"}]}], 
       "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"YPlotRange", "->", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1.5"}], ",", "0.5"}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"YTicks", "\[Rule]", "LogTicks"}]}], "\[IndentingNewLine]", 
     "]"}], "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Style", "->", "\"\<ExampleDataFigure\>\""}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.518118989375*^9, 3.51811900096875*^9}, {
   3.518119070828125*^9, 3.518119080140625*^9}, 3.518434829484375*^9, {
   3.518434975890625*^9, 3.51843500028125*^9}, {3.5184377235*^9, 
   3.518437729046875*^9}, 3.518438256265625*^9, {3.51843828675*^9, 
   3.518438315203125*^9}, 3.5184383755*^9, {3.51843951065625*^9, 
   3.51843951134375*^9}, {3.5184634049375*^9, 3.51846340696875*^9}, 
   3.518464317515625*^9, 3.518468703859375*^9, {3.518469065765625*^9, 
   3.51846912021875*^9}, {3.51846915140625*^9, 3.51846919640625*^9}, {
   3.518469259125*^9, 3.518469296625*^9}, 3.5184693335625*^9, {
   3.518562335220375*^9, 3.51856234876725*^9}, {3.566338797078735*^9, 
   3.566338801306342*^9}, 3.5837841994640684`*^9, {3.584375773419112*^9, 
   3.5843758125460215`*^9}, {3.5843758870205517`*^9, 3.584375911075794*^9}, {
   3.584375961120682*^9, 3.584375962181484*^9}, 3.584376016063978*^9, 
   3.59300938205814*^9, {3.5943047379187007`*^9, 3.59430474851112*^9}, {
   3.5943049812479286`*^9, 3.5943049933379498`*^9}}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {432., 306.}]}, InsetBox[
      GraphicsBox[{
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[4], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{44.18181818181819, 165.67446806921163`}, {
          68.72727272727273, 206.47120533170545`}, {93.27272727272728, 
          224.2391479259047}, {117.81818181818183`, 229.5}, {
          142.36363636363637`, 224.2391479259047}, {166.9090909090909, 
          206.47120533170545`}, {191.45454545454544`, 165.67446806921163`}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{44.18181818181819, 165.67446806921163`}, {
            44.18181818181819, -3.06*^6}}, {{41.18181818181819, -3.06*^6}, {
            47.18181818181819, -3.06*^6}}, {{44.18181818181819, 
            165.67446806921163`}, {44.18181818181819, 
            219.46646316804768`}}, {{41.18181818181819, 
            219.46646316804768`}, {47.18181818181819, 
            219.46646316804768`}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{41.636233769546614`, 168.2200524814832}, {
            41.636233769546614`, 163.12888365694005`}, {46.72740259408976, 
            163.12888365694005`}, {46.72740259408976, 168.2200524814832}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{68.72727272727273, 206.47120533170545`}, {
            68.72727272727273, 148.37708006980677`}}, {{65.72727272727273, 
            148.37708006980677`}, {71.72727272727273, 
            148.37708006980677`}}, {{68.72727272727273, 
            206.47120533170545`}, {68.72727272727273, 236.9851827710776}}, {{
            65.72727272727273, 236.9851827710776}, {71.72727272727273, 
            236.9851827710776}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{66.18168831500117, 209.01678974397703`}, {
            66.18168831500117, 203.92562091943387`}, {71.2728571395443, 
            203.92562091943387`}, {71.2728571395443, 
            209.01678974397703`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{93.27272727272728, 224.2391479259047}, {
            93.27272727272728, 196.5545741620466}}, {{90.27272727272728, 
            196.5545741620466}, {96.27272727272728, 196.5545741620466}}, {{
            93.27272727272728, 224.2391479259047}, {93.27272727272728, 
            243.72299092457345`}}, {{90.27272727272728, 
            243.72299092457345`}, {96.27272727272728, 
            243.72299092457345`}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{90.72714286045571, 226.78473233817627`}, {
            90.72714286045571, 221.6935635136331}, {95.81831168499885, 
            221.6935635136331}, {95.81831168499885, 226.78473233817627`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{117.81818181818183`, 229.5}, {117.81818181818183`, 
            214.67276800976737`}}, {{114.81818181818183`, 
            214.67276800976737`}, {120.81818181818183`, 
            214.67276800976737`}}, {{117.81818181818183`, 229.5}, {
            117.81818181818183`, 241.61473064528658`}}, {{114.81818181818183`,
             241.61473064528658`}, {120.81818181818183`, 
            241.61473064528658`}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{115.27259740591026`, 232.04558441227158`}, {
            115.27259740591026`, 226.95441558772842`}, {120.3637662304534, 
            226.95441558772842`}, {120.3637662304534, 
            232.04558441227158`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{142.36363636363637`, 224.2391479259047}, {
            142.36363636363637`, 196.5545741620466}}, {{139.36363636363637`, 
            196.5545741620466}, {145.36363636363637`, 196.5545741620466}}, {{
            142.36363636363637`, 224.2391479259047}, {142.36363636363637`, 
            243.72299092457345`}}, {{139.36363636363637`, 
            243.72299092457345`}, {145.36363636363637`, 
            243.72299092457345`}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{139.8180519513648, 226.78473233817627`}, {
            139.8180519513648, 221.6935635136331}, {144.90922077590795`, 
            221.6935635136331}, {144.90922077590795`, 
            226.78473233817627`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{166.9090909090909, 206.47120533170545`}, {
            166.9090909090909, 148.37708006980677`}}, {{163.9090909090909, 
            148.37708006980677`}, {169.9090909090909, 
            148.37708006980677`}}, {{166.9090909090909, 
            206.47120533170545`}, {166.9090909090909, 236.9851827710776}}, {{
            163.9090909090909, 236.9851827710776}, {169.9090909090909, 
            236.9851827710776}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{164.36350649681933`, 209.01678974397703`}, {
            164.36350649681933`, 203.92562091943387`}, {169.4546753213625, 
            203.92562091943387`}, {169.4546753213625, 
            209.01678974397703`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], 
           LineBox[{{{191.45454545454544`, 165.67446806921163`}, {
            191.45454545454544`, -3.06*^6}}, {{
            188.45454545454544`, -3.06*^6}, {
            194.45454545454544`, -3.06*^6}}, {{191.45454545454544`, 
            165.67446806921163`}, {191.45454545454544`, 
            219.46646316804768`}}, {{188.45454545454544`, 
            219.46646316804768`}, {194.45454545454544`, 
            219.46646316804768`}}}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[1, 0, 0]], 
           PolygonBox[{{188.90896104227386`, 168.2200524814832}, {
            188.90896104227386`, 163.12888365694005`}, {194.00012986681702`, 
            163.12888365694005`}, {194.00012986681702`, 
            168.2200524814832}}]}}}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {
                 TagBox[GridBox[{
                    {
                    GraphicsBox[{
                    {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[4], 
                    CapForm[None], JoinForm[{"Miter", 3.25}], 
                    LineBox[{{-10, 0}, {10, 0}}]}, 
                    {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], 
                    Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
                    FaceForm[RGBColor[1, 0, 0]], 
                    PolygonBox[{{-2.545584412271571, 
                    2.545584412271571}, {-2.545584412271571, \
-2.545584412271571}, {2.545584412271571, -2.545584412271571}, {
                    2.545584412271571, 2.545584412271571}}]}},
                    ImageSize->{20, 8},
                    PlotRange->{{-10, 10}, {-4, 4}}], 
                    StyleBox[
                    TagBox["\<\"Data\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                   },
                   AutoDelete->False,
                   
                   GridBoxAlignment->{
                    "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                   
                   GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                   GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                  "Grid"]}
               },
               AutoDelete->False,
               GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Center}}},
               
               GridBoxItemSize->{
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
               GridBoxSpacings->{"Columns" -> {{
                    Rational[5, 8]}}, "Rows" -> {{
                    Rational[1, 8]}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->RGBColor[1., 0.894101, 0.709799],
          ContentPadding->False,
          FrameMargins->{{4, 4}, {4, 4}},
          FrameStyle->GrayLevel[0],
          RoundingRadius->{2, 2},
          StripOnInput->False], {43.2, 290.7}, {-1, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {
                TagBox[GridBox[{
                   {
                    GraphicsBox[{
                    {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[4], 
                    CapForm[None], JoinForm[{"Miter", 3.25}], 
                    LineBox[{{-10, 0}, {10, 0}}]}, 
                    {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], 
                    Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
                    FaceForm[RGBColor[1, 0, 0]], 
                    PolygonBox[{{-2.545584412271571, 
                    2.545584412271571}, {-2.545584412271571, \
-2.545584412271571}, {2.545584412271571, -2.545584412271571}, {
                    2.545584412271571, 2.545584412271571}}]}},
                    ImageSize->{20, 8},
                    PlotRange->{{-10, 10}, {-4, 4}}], 
                    StyleBox[
                    TagBox["\<\"Data\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                  },
                  AutoDelete->False,
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                  
                  GridBoxItemSize->{
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                  GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                 "Grid"]}
              },
              AutoDelete->False,
              GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Center}}},
              
              GridBoxItemSize->{
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
              GridBoxSpacings->{"Columns" -> {{
                   Rational[5, 8]}}, "Rows" -> {{
                   Rational[1, 8]}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{4, 4}, {4, 4}},
          FrameStyle->None,
          RoundingRadius->{2, 2},
          StripOnInput->False], {43.2, 290.7}, {-1, 1}, Automatic, {1, 0}]},
       Frame->False,
       ImageSize->{432., 306.},
       PlotRange->{{0., 432.}, {0., 306.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {0., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{1.845, 15.615178673178235`}, {0., 15.615178673178235`}}], 
         LineBox[{{1.845, 30.442410663410868`}, {0., 30.442410663410868`}}], 
         LineBox[{{1.845, 42.55714130869745}, {0., 42.55714130869745}}], 
         LineBox[{{1.845, 52.800000122181274`}, {0., 52.800000122181274`}}], 
         LineBox[{{1.845, 61.67276800976734}, {0., 61.67276800976734}}], 
         LineBox[{{1.845, 69.4991039442167}, {0., 69.4991039442167}}], 
         LineBox[{{3.69, 76.5}, {0., 76.5}}], 
         LineBox[{{1.845, 122.55758933658912`}, {0., 122.55758933658912`}}], 
         LineBox[{{1.845, 149.49955197210835`}, {0., 149.49955197210835`}}], 
         LineBox[{{1.845, 168.61517867317824`}, {0., 168.61517867317824`}}], 
         LineBox[{{1.845, 183.44241066341084`}, {0., 183.44241066341084`}}], 
         LineBox[{{1.845, 195.55714130869745`}, {0., 195.55714130869745`}}], 
         LineBox[{{1.845, 205.80000012218127`}, {0., 205.80000012218127`}}], 
         LineBox[{{1.845, 214.67276800976734`}, {0., 214.67276800976734`}}], 
         LineBox[{{1.845, 222.4991039442167}, {0., 222.4991039442167}}], 
         LineBox[{{3.69, 229.5}, {0., 229.5}}], 
         LineBox[{{1.845, 275.5575893365891}, {0., 275.5575893365891}}], 
         LineBox[{{1.845, 302.49955197210835`}, {0., 302.49955197210835`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{432., 0.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{430.155, 15.615178673178235`}, {432., 
          15.615178673178235`}}], 
         LineBox[{{430.155, 30.442410663410868`}, {432., 
          30.442410663410868`}}], 
         LineBox[{{430.155, 42.55714130869745}, {432., 42.55714130869745}}], 
         LineBox[{{430.155, 52.800000122181274`}, {432., 
          52.800000122181274`}}], 
         LineBox[{{430.155, 61.67276800976734}, {432., 61.67276800976734}}], 
         LineBox[{{430.155, 69.4991039442167}, {432., 69.4991039442167}}], 
         LineBox[{{428.31, 76.5}, {432., 76.5}}], 
         LineBox[{{430.155, 122.55758933658912`}, {432., 
          122.55758933658912`}}], 
         LineBox[{{430.155, 149.49955197210835`}, {432., 
          149.49955197210835`}}], 
         LineBox[{{430.155, 168.61517867317824`}, {432., 
          168.61517867317824`}}], 
         LineBox[{{430.155, 183.44241066341084`}, {432., 
          183.44241066341084`}}], 
         LineBox[{{430.155, 195.55714130869745`}, {432., 
          195.55714130869745`}}], 
         LineBox[{{430.155, 205.80000012218127`}, {432., 
          205.80000012218127`}}], 
         LineBox[{{430.155, 214.67276800976734`}, {432., 
          214.67276800976734`}}], 
         LineBox[{{430.155, 222.4991039442167}, {432., 222.4991039442167}}], 
         LineBox[{{428.31, 229.5}, {432., 229.5}}], 
         LineBox[{{430.155, 275.5575893365891}, {432., 275.5575893365891}}], 
         LineBox[{{430.155, 302.49955197210835`}, {432., 
          302.49955197210835`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {432., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{7.135466288054765, 1.845}, {7.135466288054765, 0.}}], 
         LineBox[{{19.636363636363637`, 3.69}, {19.636363636363637`, 0.}}], 
         LineBox[{{32.13726098467251, 1.845}, {32.13726098467251, 0.}}], 
         LineBox[{{44.63815833298138, 1.845}, {44.63815833298138, 0.}}], 
         LineBox[{{57.13905568129026, 1.845}, {57.13905568129026, 0.}}], 
         LineBox[{{69.63995302959913, 1.845}, {69.63995302959913, 0.}}], 
         LineBox[{{82.140850377908, 3.69}, {82.140850377908, 0.}}], 
         LineBox[{{94.64174772621686, 1.845}, {94.64174772621686, 0.}}], 
         LineBox[{{107.14264507452573`, 1.845}, {107.14264507452573`, 0.}}], 
         LineBox[{{119.64354242283461`, 1.845}, {119.64354242283461`, 0.}}], 
         LineBox[{{132.14443977114348`, 1.845}, {132.14443977114348`, 0.}}], 
         LineBox[{{144.64533711945234`, 3.69}, {144.64533711945234`, 0.}}], 
         LineBox[{{157.14623446776122`, 1.845}, {157.14623446776122`, 0.}}], 
         LineBox[{{169.64713181607007`, 1.845}, {169.64713181607007`, 0.}}], 
         LineBox[{{182.14802916437895`, 1.845}, {182.14802916437895`, 0.}}], 
         LineBox[{{194.6489265126878, 1.845}, {194.6489265126878, 0.}}], 
         LineBox[{{207.1498238609967, 3.69}, {207.1498238609967, 0.}}], 
         LineBox[{{219.65072120930557`, 1.845}, {219.65072120930557`, 0.}}], 
         LineBox[{{232.15161855761443`, 1.845}, {232.15161855761443`, 0.}}], 
         LineBox[{{244.6525159059233, 1.845}, {244.6525159059233, 0.}}], 
         LineBox[{{257.1534132542322, 1.845}, {257.1534132542322, 0.}}], 
         LineBox[{{269.65431060254105`, 3.69}, {269.65431060254105`, 0.}}], 
         LineBox[{{282.1552079508499, 1.845}, {282.1552079508499, 0.}}], 
         LineBox[{{294.6561052991588, 1.845}, {294.6561052991588, 0.}}], 
         LineBox[{{307.15700264746766`, 1.845}, {307.15700264746766`, 0.}}], 
         LineBox[{{319.6578999957765, 1.845}, {319.6578999957765, 0.}}], 
         LineBox[{{332.15879734408543`, 3.69}, {332.15879734408543`, 0.}}], 
         LineBox[{{344.6596946923943, 1.845}, {344.6596946923943, 0.}}], 
         LineBox[{{357.16059204070314`, 1.845}, {357.16059204070314`, 0.}}], 
         LineBox[{{369.661489389012, 1.845}, {369.661489389012, 0.}}], 
         LineBox[{{382.1623867373209, 1.845}, {382.1623867373209, 0.}}], 
         LineBox[{{394.66328408562975`, 3.69}, {394.66328408562975`, 0.}}], 
         LineBox[{{407.1641814339386, 1.845}, {407.1641814339386, 0.}}], 
         LineBox[{{419.6650787822475, 1.845}, {419.6650787822475, 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 306.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{7.135466288054765, 304.155}, {7.135466288054765, 306.}}], 
         LineBox[{{19.636363636363637`, 302.31}, {19.636363636363637`, 
          306.}}], 
         LineBox[{{32.13726098467251, 304.155}, {32.13726098467251, 306.}}], 
         LineBox[{{44.63815833298138, 304.155}, {44.63815833298138, 306.}}], 
         LineBox[{{57.13905568129026, 304.155}, {57.13905568129026, 306.}}], 
         LineBox[{{69.63995302959913, 304.155}, {69.63995302959913, 306.}}], 
         LineBox[{{82.140850377908, 302.31}, {82.140850377908, 306.}}], 
         LineBox[{{94.64174772621686, 304.155}, {94.64174772621686, 306.}}], 
         LineBox[{{107.14264507452573`, 304.155}, {107.14264507452573`, 
          306.}}], 
         LineBox[{{119.64354242283461`, 304.155}, {119.64354242283461`, 
          306.}}], 
         LineBox[{{132.14443977114348`, 304.155}, {132.14443977114348`, 
          306.}}], 
         LineBox[{{144.64533711945234`, 302.31}, {144.64533711945234`, 
          306.}}], 
         LineBox[{{157.14623446776122`, 304.155}, {157.14623446776122`, 
          306.}}], 
         LineBox[{{169.64713181607007`, 304.155}, {169.64713181607007`, 
          306.}}], 
         LineBox[{{182.14802916437895`, 304.155}, {182.14802916437895`, 
          306.}}], 
         LineBox[{{194.6489265126878, 304.155}, {194.6489265126878, 306.}}], 
         LineBox[{{207.1498238609967, 302.31}, {207.1498238609967, 306.}}], 
         LineBox[{{219.65072120930557`, 304.155}, {219.65072120930557`, 
          306.}}], 
         LineBox[{{232.15161855761443`, 304.155}, {232.15161855761443`, 
          306.}}], 
         LineBox[{{244.6525159059233, 304.155}, {244.6525159059233, 306.}}], 
         LineBox[{{257.1534132542322, 304.155}, {257.1534132542322, 306.}}], 
         LineBox[{{269.65431060254105`, 302.31}, {269.65431060254105`, 
          306.}}], 
         LineBox[{{282.1552079508499, 304.155}, {282.1552079508499, 306.}}], 
         LineBox[{{294.6561052991588, 304.155}, {294.6561052991588, 306.}}], 
         LineBox[{{307.15700264746766`, 304.155}, {307.15700264746766`, 
          306.}}], 
         LineBox[{{319.6578999957765, 304.155}, {319.6578999957765, 306.}}], 
         LineBox[{{332.15879734408543`, 302.31}, {332.15879734408543`, 
          306.}}], 
         LineBox[{{344.6596946923943, 304.155}, {344.6596946923943, 306.}}], 
         LineBox[{{357.16059204070314`, 304.155}, {357.16059204070314`, 
          306.}}], 
         LineBox[{{369.661489389012, 304.155}, {369.661489389012, 306.}}], 
         LineBox[{{382.1623867373209, 304.155}, {382.1623867373209, 306.}}], 
         LineBox[{{394.66328408562975`, 302.31}, {394.66328408562975`, 
          306.}}], 
         LineBox[{{407.1641814339386, 304.155}, {407.1641814339386, 306.}}], 
         LineBox[{{419.6650787822475, 304.155}, {419.6650787822475, 306.}}]}, 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              SuperscriptBox["10", 
               RowBox[{"-", "1"}]],
              DisplayForm],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 76.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              SuperscriptBox["10", "0"],
              DisplayForm],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 229.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"y\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" (m)\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-28., 306.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {19.636363636363637`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {82.140850377908, 0.}, {0, 1}, Automatic, {1, 
         0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {144.64533711945234`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"3\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {207.1498238609967, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"4\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {269.65431060254105`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {332.15879734408543`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"6\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {394.66328408562975`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"t\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" (s)\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -15.}, {0, 1}, Automatic, {1., 0.}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             SuperscriptBox["10", 
              RowBox[{"-", "1"}]],
             DisplayForm],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 76.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             SuperscriptBox["10", "0"],
             DisplayForm],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 229.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"y\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" (m)\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-28., 306.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {19.636363636363637`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {82.140850377908, 0.}, {0, 1}, Automatic, {1, 
         0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {144.64533711945234`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"3\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {207.1498238609967, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"4\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {269.65431060254105`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {332.15879734408543`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"6\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {394.66328408562975`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"t\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" (s)\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -15.}, {0, 1}, Automatic, {1., 0.}]},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->0.78125,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{576, 450.},
  PlotRange->{{-72, 504}, {-72., 378.}}]], "Output",
 CellChangeTimes->{{3.518469092265625*^9, 3.5184691211875*^9}, {
   3.518469168796875*^9, 3.51846917534375*^9}, {3.518469288109375*^9, 
   3.51846929709375*^9}, 3.5184726360625*^9, 3.51847281203125*^9, {
   3.51856233045475*^9, 3.518562349126625*^9}, 3.524748110265625*^9, 
   3.566338802304744*^9, 3.5791218976136055`*^9, {3.584375783434266*^9, 
   3.5843758313752537`*^9}, {3.584375905241384*^9, 3.584375911434595*^9}, 
   3.584375968031494*^9, 3.5843760187939835`*^9, 3.593010943089095*^9, {
   3.5943047183406663`*^9, 3.5943047279814835`*^9}, {3.5943049725899134`*^9, 
   3.5943049841807337`*^9}, 3.594305029592413*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Fills for data curves", "Subsection",
 CellChangeTimes->{{3.51846434496875*^9, 3.5184643455625*^9}, {
   3.518468296609375*^9, 3.51846829803125*^9}, {3.51848241671875*^9, 
   3.51848241984375*^9}, 3.518482454703125*^9, 3.5843761013337283`*^9, {
   3.584376442222285*^9, 3.5843764443972883`*^9}}],

Cell["Let us set up some new data to demonstrate various fills...", "Text",
 CellChangeTimes->{{3.5843761163097544`*^9, 3.5843761251237698`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DataForFill", "=", 
  RowBox[{"N", "@", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"x", "^", "3"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "1"}], ",", "1", ",", "0.1"}], "}"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.518118989375*^9, 3.51811900096875*^9}, {
   3.518119070828125*^9, 3.518119080140625*^9}, 3.518434829484375*^9, {
   3.518434975890625*^9, 3.51843500028125*^9}, {3.5184377235*^9, 
   3.518437729046875*^9}, 3.518438256265625*^9, {3.51843828675*^9, 
   3.518438315203125*^9}, 3.5184383755*^9, {3.51843951065625*^9, 
   3.51843951134375*^9}, {3.5184634049375*^9, 3.51846340696875*^9}, 
   3.518464317515625*^9, {3.51846435009375*^9, 3.518464368390625*^9}, {
   3.5184645371875*^9, 3.518464557*^9}, {3.518464794203125*^9, 
   3.51846479571875*^9}, {3.518465025515625*^9, 3.518465026484375*^9}, {
   3.5184650614375*^9, 3.5184650675*^9}, {3.5184651670625*^9, 
   3.518465178015625*^9}, {3.518466446140625*^9, 3.51846653075*^9}, {
   3.518466656234375*^9, 3.5184666735625*^9}, {3.518468302109375*^9, 
   3.518468302640625*^9}, {3.5184686916875*^9, 3.518468701453125*^9}, {
   3.518468743921875*^9, 3.518468748859375*^9}, {3.5663388084511547`*^9, 
   3.566338809121956*^9}, {3.5843760294020023`*^9, 3.584376074548481*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.`"}], ",", 
     RowBox[{"-", "1.`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.9`"}], ",", 
     RowBox[{"-", "0.7290000000000001`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.8`"}], ",", 
     RowBox[{"-", "0.5120000000000001`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.7`"}], ",", 
     RowBox[{"-", "0.3429999999999999`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.6`"}], ",", 
     RowBox[{"-", "0.216`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.5`"}], ",", 
     RowBox[{"-", "0.125`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.3999999999999999`"}], ",", 
     RowBox[{"-", "0.06399999999999996`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.29999999999999993`"}], ",", 
     RowBox[{"-", "0.02699999999999998`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.19999999999999996`"}], ",", 
     RowBox[{"-", "0.007999999999999995`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.09999999999999998`"}], ",", 
     RowBox[{"-", "0.0009999999999999994`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.`", ",", "0.`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.10000000000000009`", ",", "0.0010000000000000026`"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"0.20000000000000018`", ",", "0.008000000000000021`"}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"0.30000000000000004`", ",", "0.02700000000000001`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.40000000000000013`", ",", "0.06400000000000007`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.5`", ",", "0.125`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.6000000000000001`", ",", "0.21600000000000008`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.7000000000000002`", ",", "0.34300000000000025`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.8`", ",", "0.5120000000000001`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9000000000000001`", ",", "0.7290000000000003`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.`", ",", "1.`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.622234629974864*^9}]
}, Open  ]],

Cell["Filling to the axis", "Text",
 CellChangeTimes->{{3.584376112565748*^9, 3.584376129054977*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DataPlot", "[", 
         RowBox[{"DataForFill", ",", 
          RowBox[{"DataFill", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Filling", "\[Rule]", "Axis"}], ",", 
             RowBox[{"FillColor", "\[Rule]", "Moccasin"}]}], "}"}]}]}], "]"}],
         ";"}], "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], ",", 
      RowBox[{"ExtendRange", "\[Rule]", "0.05"}]}], "\[IndentingNewLine]", 
     "]"}], "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Style", "->", "\"\<ExampleDataFigure\>\""}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.518118989375*^9, 3.51811900096875*^9}, {
   3.518119070828125*^9, 3.518119080140625*^9}, 3.518434829484375*^9, {
   3.518434975890625*^9, 3.51843500028125*^9}, {3.5184377235*^9, 
   3.518437729046875*^9}, 3.518438256265625*^9, {3.51843828675*^9, 
   3.518438315203125*^9}, 3.5184383755*^9, {3.51843951065625*^9, 
   3.51843951134375*^9}, {3.5184634049375*^9, 3.51846340696875*^9}, 
   3.518464317515625*^9, {3.51846435009375*^9, 3.518464368390625*^9}, {
   3.5184645371875*^9, 3.518464557*^9}, {3.518464794203125*^9, 
   3.51846479571875*^9}, {3.518465025515625*^9, 3.518465026484375*^9}, {
   3.5184650614375*^9, 3.5184650675*^9}, {3.5184651670625*^9, 
   3.518465178015625*^9}, {3.518466446140625*^9, 3.51846653075*^9}, {
   3.518466656234375*^9, 3.5184666735625*^9}, {3.518468302109375*^9, 
   3.518468302640625*^9}, {3.5184686916875*^9, 3.518468701453125*^9}, {
   3.518468743921875*^9, 3.518468748859375*^9}, {3.5663388084511547`*^9, 
   3.566338809121956*^9}, {3.5843760294020023`*^9, 3.58437609095971*^9}, 
   3.594305083568508*^9}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {432., 306.00000000000006`}]}, 
     InsetBox[
      GraphicsBox[{
        {EdgeForm[None], FaceForm[RGBColor[1., 0.894101, 0.709799]], 
         PolygonBox[CompressedData["
1:eJxTTMoPSmViYGAQB2IQvaJbb9eLRcYOjEA2g0KyA4z/wFU8tuSitsMSMN/Z
YUPSJS21s54OJRdBEr4Oxn4qj12KQqDywQ5pQOm1QVEOvSBud4TD/4DL/KZ7
4xxKwepjIeKfExwMQNJ6iQ5PXIz8VJiToPqTHQRN/wZcXp7kIBELsiHNYa7H
sc6UP0kOPWDzMhxET1pM7JFOdmAAg2y4eyHm5zq8NTueV6yS7PBqEcjAfIfU
7ZZls52THfTB9hU6fDzFtF5nRrLDS5B8RpGD3O6zG2/bpDgsBttfDDHHJ9UB
bP3dEofmcLGK1IdpUPeUOVyc9ipnpVimwyWQdYHlDi9u5PbdZcuBuq/CISLd
u3TbmXwHN1CwHa2EqHMsgvNh7gUAfZSdhw==
          "]]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQvaJbb9eLRcYOD1zFY0suajssAfOdHTYkXdJSO+vp
UHIRJOHrYOyn8tilKAQqH+yQBpReGxTl0Avidkc4/A+4zG+6N86hFKw+FiL+
OcHBACStl+jwxMXIT4U5Cao/2UHQ9G/A5eVJDhKxIBvSHOZ6HOtM+ZPk0AM2
L8NB9KTFxB7pZAcGMMh2YARRCslQ83Md3podzytWSXZ4tQhkYL5D6nbLstnO
yQ76YPsKHT6eYlqvMyPZ4SVIPqPIQW732Y23bVIcFoPtL4aY45PqALb+bolD
c7hYRerDNKh7yhwuTnuVs1Is0+ESyLrAcocXN3L77rLlQN1X4RCR7l267Uy+
gxso2I5WQtQ5FjkAAAcJlGg=
          "]]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{20.791213052002764`, 14.387445199547297`}, {
            20.52024711284684, 14.79297438557412}, {20.114717926820017`, 
            15.063940324730044`}, {19.636363636363654`, 
            15.159090909090935`}, {19.158009345907292`, 
            15.063940324730044`}, {18.75248015988047, 14.79297438557412}, {
            18.481514220724545`, 14.387445199547297`}, {18.386363636363654`, 
            13.909090909090935`}, {18.481514220724545`, 
            13.430736618634572`}, {18.75248015988047, 13.02520743260775}, {
            19.158009345907292`, 12.754241493451826`}, {19.636363636363654`, 
            12.659090909090935`}, {20.114717926820017`, 
            12.754241493451826`}, {20.52024711284684, 13.02520743260775}, {
            20.791213052002764`, 13.430736618634572`}, {20.886363636363654`, 
            13.909090909090935`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{40.427576688366386`, 52.08108156318365}, {
            40.156610749210465`, 52.48661074921048}, {39.75108156318364, 
            52.7575766883664}, {39.27272727272728, 52.85272727272729}, {
            38.79437298227092, 52.7575766883664}, {38.388843796244096`, 
            52.48661074921048}, {38.117877857088175`, 52.08108156318365}, {
            38.02272727272728, 51.60272727272729}, {38.117877857088175`, 
            51.124372982270934`}, {38.388843796244096`, 50.71884379624411}, {
            38.79437298227092, 50.44787785708819}, {39.27272727272728, 
            50.35272727272729}, {39.75108156318364, 50.44787785708819}, {
            40.156610749210465`, 50.71884379624411}, {40.427576688366386`, 
            51.124372982270934`}, {40.52272727272728, 51.60272727272729}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{60.06394032473001, 82.26380883591092}, {
            59.79297438557409, 82.66933802193773}, {59.387445199547265`, 
            82.94030396109366}, {58.90909090909091, 83.03545454545456}, {
            58.43073661863455, 82.94030396109366}, {58.02520743260772, 
            82.66933802193773}, {57.7542414934518, 82.26380883591092}, {
            57.65909090909091, 81.78545454545456}, {57.7542414934518, 
            81.30710025499819}, {58.02520743260772, 80.90157106897138}, {
            58.43073661863455, 80.63060512981545}, {58.90909090909091, 
            80.53545454545456}, {59.387445199547265`, 80.63060512981545}, {
            59.79297438557409, 80.90157106897138}, {60.06394032473001, 
            81.30710025499819}, {60.15909090909091, 81.78545454545456}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{79.70030396109367, 105.7701724722746}, {
            79.42933802193774, 106.1757016583014}, {79.02380883591093, 
            106.44666759745733`}, {78.54545454545456, 106.54181818181823`}, {
            78.0671002549982, 106.44666759745733`}, {77.66157106897138, 
            106.1757016583014}, {77.39060512981546, 105.7701724722746}, {
            77.29545454545456, 105.29181818181823`}, {77.39060512981546, 
            104.81346389136186`}, {77.66157106897138, 104.40793470533505`}, {
            78.0671002549982, 104.13696876617912`}, {78.54545454545456, 
            104.04181818181823`}, {79.02380883591093, 104.13696876617912`}, {
            79.42933802193774, 104.40793470533505`}, {79.70030396109367, 
            104.81346389136186`}, {79.79545454545456, 
            105.29181818181823`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{99.3366675974573, 123.43471792682003`}, {
            99.06570165830138, 123.84024711284684`}, {98.66017247227457, 
            124.11121305200277`}, {98.1818181818182, 124.20636363636366`}, {
            97.70346389136184, 124.11121305200277`}, {97.29793470533502, 
            123.84024711284684`}, {97.0269687661791, 123.43471792682003`}, {
            96.9318181818182, 122.95636363636366`}, {97.0269687661791, 
            122.4780093459073}, {97.29793470533502, 122.07248015988048`}, {
            97.70346389136184, 121.80151422072456`}, {98.1818181818182, 
            121.70636363636366`}, {98.66017247227457, 121.80151422072456`}, {
            99.06570165830138, 122.07248015988048`}, {99.3366675974573, 
            122.4780093459073}, {99.4318181818182, 122.95636363636366`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{118.97303123382093`, 136.09199065409277`}, {
            118.702065294665, 136.4975198401196}, {118.2965361086382, 
            136.76848577927552`}, {117.81818181818183`, 136.8636363636364}, {
            117.33982752772546`, 136.76848577927552`}, {116.93429834169865`, 
            136.4975198401196}, {116.66333240254272`, 136.09199065409277`}, {
            116.56818181818183`, 135.6136363636364}, {116.66333240254272`, 
            135.13528207318004`}, {116.93429834169865`, 134.7297528871532}, {
            117.33982752772546`, 134.45878694799728`}, {117.81818181818183`, 
            134.3636363636364}, {118.2965361086382, 134.45878694799728`}, {
            118.702065294665, 134.7297528871532}, {118.97303123382093`, 
            135.13528207318004`}, {119.06818181818183`, 
            135.6136363636364}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{138.60939487018462`, 144.5765361086382}, {
            138.3384289310287, 144.98206529466503`}, {137.93289974500186`, 
            145.25303123382096`}, {137.4545454545455, 145.34818181818184`}, {
            136.97619116408913`, 145.25303123382096`}, {136.5706619780623, 
            144.98206529466503`}, {136.29969603890638`, 144.5765361086382}, {
            136.2045454545455, 144.09818181818184`}, {136.29969603890638`, 
            143.61982752772548`}, {136.5706619780623, 143.21429834169865`}, {
            136.97619116408913`, 142.94333240254272`}, {137.4545454545455, 
            142.84818181818184`}, {137.93289974500186`, 
            142.94333240254272`}, {138.3384289310287, 143.21429834169865`}, {
            138.60939487018462`, 143.61982752772548`}, {138.7045454545455, 
            144.09818181818184`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{158.24575850654824`, 149.72289974500185`}, {
            157.9747925673923, 150.12842893102868`}, {157.5692633813655, 
            150.3993948701846}, {157.09090909090912`, 150.4945454545455}, {
            156.61255480045276`, 150.3993948701846}, {156.20702561442593`, 
            150.12842893102868`}, {155.93605967527, 149.72289974500185`}, {
            155.84090909090912`, 149.2445454545455}, {155.93605967527, 
            148.76619116408912`}, {156.20702561442593`, 148.3606619780623}, {
            156.61255480045276`, 148.08969603890637`}, {157.09090909090912`, 
            147.9945454545455}, {157.5692633813655, 148.08969603890637`}, {
            157.9747925673923, 148.3606619780623}, {158.24575850654824`, 
            148.76619116408912`}, {158.34090909090912`, 
            149.2445454545455}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{177.88212214291187`, 152.3656270177291}, {
            177.61115620375594`, 152.77115620375594`}, {177.2056270177291, 
            153.04212214291186`}, {176.72727272727275`, 
            153.13727272727274`}, {176.24891843681638`, 
            153.04212214291186`}, {175.84338925078956`, 
            152.77115620375594`}, {175.57242331163363`, 152.3656270177291}, {
            175.47727272727275`, 151.88727272727274`}, {175.57242331163363`, 
            151.40891843681638`}, {175.84338925078956`, 
            151.00338925078955`}, {176.24891843681638`, 
            150.73242331163362`}, {176.72727272727275`, 
            150.63727272727274`}, {177.2056270177291, 150.73242331163362`}, {
            177.61115620375594`, 151.00338925078955`}, {177.88212214291187`, 
            151.40891843681638`}, {177.97727272727275`, 
            151.88727272727274`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{197.5184857792755, 153.3392633813655}, {
            197.24751984011957`, 153.74479256739232`}, {196.84199065409274`, 
            154.01575850654825`}, {196.36363636363637`, 
            154.11090909090913`}, {195.88528207318, 154.01575850654825`}, {
            195.47975288715318`, 153.74479256739232`}, {195.20878694799725`, 
            153.3392633813655}, {195.11363636363637`, 152.86090909090913`}, {
            195.20878694799725`, 152.38255480045277`}, {195.47975288715318`, 
            151.97702561442594`}, {195.88528207318, 151.70605967527}, {
            196.36363636363637`, 151.61090909090913`}, {196.84199065409274`, 
            151.70605967527}, {197.24751984011957`, 151.97702561442594`}, {
            197.5184857792755, 152.38255480045277`}, {197.61363636363637`, 
            152.86090909090913`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{217.15484941563912`, 153.4783542904564}, {
            216.8838834764832, 153.88388347648322`}, {216.47835429045637`, 
            154.15484941563915`}, {216., 154.25000000000003`}, {
            215.52164570954363`, 154.15484941563915`}, {215.1161165235168, 
            153.88388347648322`}, {214.84515058436088`, 153.4783542904564}, {
            214.75, 153.00000000000003`}, {214.84515058436088`, 
            152.52164570954366`}, {215.1161165235168, 152.11611652351684`}, {
            215.52164570954363`, 151.8451505843609}, {216., 
            151.75000000000003`}, {216.47835429045637`, 151.8451505843609}, {
            216.8838834764832, 152.11611652351684`}, {217.15484941563912`, 
            152.52164570954366`}, {217.25, 153.00000000000003`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{236.79121305200277`, 153.6174451995473}, {
            236.52024711284685`, 154.02297438557412`}, {236.11471792682002`, 
            154.29394032473004`}, {235.63636363636365`, 
            154.38909090909092`}, {235.1580093459073, 154.29394032473004`}, {
            234.75248015988046`, 154.02297438557412`}, {234.48151422072453`, 
            153.6174451995473}, {234.38636363636365`, 153.13909090909092`}, {
            234.48151422072453`, 152.66073661863456`}, {234.75248015988046`, 
            152.25520743260773`}, {235.1580093459073, 151.9842414934518}, {
            235.63636363636365`, 151.88909090909092`}, {236.11471792682002`, 
            151.9842414934518}, {236.52024711284685`, 152.25520743260773`}, {
            236.79121305200277`, 152.66073661863456`}, {236.88636363636365`, 
            153.13909090909092`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{256.4275766883664, 154.59108156318368`}, {
            256.1566107492105, 154.9966107492105}, {255.75108156318367`, 
            155.26757668836643`}, {255.2727272727273, 155.3627272727273}, {
            254.79437298227094`, 155.26757668836643`}, {254.38884379624412`, 
            154.9966107492105}, {254.1178778570882, 154.59108156318368`}, {
            254.0227272727273, 154.1127272727273}, {254.1178778570882, 
            153.63437298227095`}, {254.38884379624412`, 
            153.22884379624412`}, {254.79437298227094`, 152.9578778570882}, {
            255.2727272727273, 152.8627272727273}, {255.75108156318367`, 
            152.9578778570882}, {256.1566107492105, 153.22884379624412`}, {
            256.4275766883664, 153.63437298227095`}, {256.5227272727273, 
            154.1127272727273}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{276.06394032473, 157.23380883591093`}, {
            275.7929743855741, 157.63933802193776`}, {275.3874451995473, 
            157.9103039610937}, {274.90909090909093`, 158.00545454545457`}, {
            274.43073661863457`, 157.9103039610937}, {274.0252074326078, 
            157.63933802193776`}, {273.75424149345184`, 
            157.23380883591093`}, {273.65909090909093`, 
            156.75545454545457`}, {273.75424149345184`, 156.2771002549982}, {
            274.0252074326078, 155.87157106897138`}, {274.43073661863457`, 
            155.60060512981545`}, {274.90909090909093`, 
            155.50545454545457`}, {275.3874451995473, 155.60060512981545`}, {
            275.7929743855741, 155.87157106897138`}, {276.06394032473, 
            156.2771002549982}, {276.15909090909093`, 
            156.75545454545457`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{295.70030396109365`, 162.38017247227458`}, {
            295.4293380219377, 162.7857016583014}, {295.0238088359109, 
            163.05666759745733`}, {294.54545454545456`, 
            163.15181818181821`}, {294.0671002549982, 163.05666759745733`}, {
            293.6615710689714, 162.7857016583014}, {293.39060512981547`, 
            162.38017247227458`}, {293.29545454545456`, 
            161.90181818181821`}, {293.39060512981547`, 
            161.42346389136185`}, {293.6615710689714, 161.01793470533502`}, {
            294.0671002549982, 160.7469687661791}, {294.54545454545456`, 
            160.65181818181821`}, {295.0238088359109, 160.7469687661791}, {
            295.4293380219377, 161.01793470533502`}, {295.70030396109365`, 
            161.42346389136185`}, {295.79545454545456`, 
            161.90181818181821`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{315.3366675974573, 170.86471792682002`}, {
            315.06570165830135`, 171.27024711284685`}, {314.66017247227455`, 
            171.54121305200277`}, {314.1818181818182, 171.63636363636365`}, {
            313.7034638913618, 171.54121305200277`}, {313.297934705335, 
            171.27024711284685`}, {313.0269687661791, 170.86471792682002`}, {
            312.9318181818182, 170.38636363636365`}, {313.0269687661791, 
            169.9080093459073}, {313.297934705335, 169.50248015988046`}, {
            313.7034638913618, 169.23151422072453`}, {314.1818181818182, 
            169.13636363636365`}, {314.66017247227455`, 
            169.23151422072453`}, {315.06570165830135`, 
            169.50248015988046`}, {315.3366675974573, 169.9080093459073}, {
            315.4318181818182, 170.38636363636365`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{334.9730312338209, 183.52199065409278`}, {
            334.702065294665, 183.9275198401196}, {334.2965361086382, 
            184.19848577927553`}, {333.8181818181818, 184.2936363636364}, {
            333.33982752772545`, 184.19848577927553`}, {332.93429834169865`, 
            183.9275198401196}, {332.6633324025427, 183.52199065409278`}, {
            332.5681818181818, 183.0436363636364}, {332.6633324025427, 
            182.56528207318004`}, {332.93429834169865`, 
            182.15975288715322`}, {333.33982752772545`, 181.8887869479973}, {
            333.8181818181818, 181.7936363636364}, {334.2965361086382, 
            181.8887869479973}, {334.702065294665, 182.15975288715322`}, {
            334.9730312338209, 182.56528207318004`}, {335.0681818181818, 
            183.0436363636364}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{354.6093948701846, 201.18653610863825`}, {
            354.33842893102866`, 201.59206529466508`}, {353.93289974500186`, 
            201.863031233821}, {353.4545454545455, 201.95818181818188`}, {
            352.97619116408913`, 201.863031233821}, {352.57066197806233`, 
            201.59206529466508`}, {352.2996960389064, 201.18653610863825`}, {
            352.2045454545455, 200.70818181818188`}, {352.2996960389064, 
            200.22982752772552`}, {352.57066197806233`, 199.8242983416987}, {
            352.97619116408913`, 199.55333240254276`}, {353.4545454545455, 
            199.45818181818188`}, {353.93289974500186`, 
            199.55333240254276`}, {354.33842893102866`, 199.8242983416987}, {
            354.6093948701846, 200.22982752772552`}, {354.7045454545455, 
            200.70818181818188`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{374.2457585065482, 224.69289974500185`}, {
            373.9747925673923, 225.09842893102868`}, {373.5692633813655, 
            225.3693948701846}, {373.0909090909091, 225.4645454545455}, {
            372.61255480045276`, 225.3693948701846}, {372.20702561442596`, 
            225.09842893102868`}, {371.93605967527003`, 
            224.69289974500185`}, {371.8409090909091, 224.2145454545455}, {
            371.93605967527003`, 223.73619116408912`}, {372.20702561442596`, 
            223.3306619780623}, {372.61255480045276`, 223.05969603890637`}, {
            373.0909090909091, 222.9645454545455}, {373.5692633813655, 
            223.05969603890637`}, {373.9747925673923, 223.3306619780623}, {
            374.2457585065482, 223.73619116408912`}, {374.3409090909091, 
            224.2145454545455}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{393.88212214291184`, 254.8756270177292}, {
            393.6111562037559, 255.281156203756}, {393.2056270177291, 
            255.55212214291194`}, {392.72727272727275`, 
            255.64727272727282`}, {392.2489184368164, 255.55212214291194`}, {
            391.8433892507896, 255.281156203756}, {391.57242331163366`, 
            254.8756270177292}, {391.47727272727275`, 254.39727272727282`}, {
            391.57242331163366`, 253.91891843681645`}, {391.8433892507896, 
            253.51338925078963`}, {392.2489184368164, 253.2424233116337}, {
            392.72727272727275`, 253.14727272727282`}, {393.2056270177291, 
            253.2424233116337}, {393.6111562037559, 253.51338925078963`}, {
            393.88212214291184`, 253.91891843681645`}, {393.97727272727275`, 
            254.39727272727282`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{413.51848577927547`, 292.5692633813655}, {
            413.24751984011954`, 292.9747925673923}, {412.84199065409274`, 
            293.2457585065482}, {412.3636363636364, 293.3409090909091}, {
            411.88528207318, 293.2457585065482}, {411.4797528871532, 
            292.9747925673923}, {411.2087869479973, 292.5692633813655}, {
            411.1136363636364, 292.0909090909091}, {411.2087869479973, 
            291.61255480045276`}, {411.4797528871532, 291.20702561442596`}, {
            411.88528207318, 290.93605967527003`}, {412.3636363636364, 
            290.8409090909091}, {412.84199065409274`, 290.93605967527003`}, {
            413.24751984011954`, 291.20702561442596`}, {413.51848577927547`, 
            291.61255480045276`}, {413.6136363636364, 292.0909090909091}}]}}}},
       Frame->False,
       ImageSize->{432., 306.00000000000006`},
       PlotRange->{{0., 432.}, {0., 306.00000000000006`}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 0.}, {0., 306.00000000000006`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{3.69, 13.909090909090935`}, {0., 13.909090909090935`}}], 
         LineBox[{{1.845, 27.81818181818184}, {0., 27.81818181818184}}], 
         LineBox[{{1.845, 41.72727272727275}, {0., 41.72727272727275}}], 
         LineBox[{{1.845, 55.63636363636367}, {0., 55.63636363636367}}], 
         LineBox[{{1.845, 69.54545454545458}, {0., 69.54545454545458}}], 
         LineBox[{{3.69, 83.45454545454548}, {0., 83.45454545454548}}], 
         LineBox[{{1.845, 97.36363636363639}, {0., 97.36363636363639}}], 
         LineBox[{{1.845, 111.27272727272731`}, {0., 111.27272727272731`}}], 
         LineBox[{{1.845, 125.18181818181822`}, {0., 125.18181818181822`}}], 
         LineBox[{{1.845, 139.09090909090912`}, {0., 139.09090909090912`}}], 
         LineBox[{{3.69, 153.00000000000003`}, {0., 153.00000000000003`}}], 
         LineBox[{{1.845, 166.90909090909093`}, {0., 166.90909090909093`}}], 
         LineBox[{{1.845, 180.81818181818184`}, {0., 180.81818181818184`}}], 
         LineBox[{{1.845, 194.72727272727275`}, {0., 194.72727272727275`}}], 
         LineBox[{{1.845, 208.63636363636368`}, {0., 208.63636363636368`}}], 
         LineBox[{{3.69, 222.54545454545456`}, {0., 222.54545454545456`}}], 
         LineBox[{{1.845, 236.4545454545455}, {0., 236.4545454545455}}], 
         LineBox[{{1.845, 250.36363636363637`}, {0., 250.36363636363637`}}], 
         LineBox[{{1.845, 264.2727272727273}, {0., 264.2727272727273}}], 
         LineBox[{{1.845, 278.18181818181824`}, {0., 278.18181818181824`}}], 
         LineBox[{{3.69, 292.0909090909091}, {0., 292.0909090909091}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{432., 0.}, {432., 306.00000000000006`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{428.31, 13.909090909090935`}, {432., 
          13.909090909090935`}}], 
         LineBox[{{430.155, 27.81818181818184}, {432., 27.81818181818184}}], 
         LineBox[{{430.155, 41.72727272727275}, {432., 41.72727272727275}}], 
         LineBox[{{430.155, 55.63636363636367}, {432., 55.63636363636367}}], 
         LineBox[{{430.155, 69.54545454545458}, {432., 69.54545454545458}}], 
         LineBox[{{428.31, 83.45454545454548}, {432., 83.45454545454548}}], 
         LineBox[{{430.155, 97.36363636363639}, {432., 97.36363636363639}}], 
         LineBox[{{430.155, 111.27272727272731`}, {432., 
          111.27272727272731`}}], 
         LineBox[{{430.155, 125.18181818181822`}, {432., 
          125.18181818181822`}}], 
         LineBox[{{430.155, 139.09090909090912`}, {432., 
          139.09090909090912`}}], 
         LineBox[{{428.31, 153.00000000000003`}, {432., 
          153.00000000000003`}}], 
         LineBox[{{430.155, 166.90909090909093`}, {432., 
          166.90909090909093`}}], 
         LineBox[{{430.155, 180.81818181818184`}, {432., 
          180.81818181818184`}}], 
         LineBox[{{430.155, 194.72727272727275`}, {432., 
          194.72727272727275`}}], 
         LineBox[{{430.155, 208.63636363636368`}, {432., 
          208.63636363636368`}}], 
         LineBox[{{428.31, 222.54545454545456`}, {432., 
          222.54545454545456`}}], 
         LineBox[{{430.155, 236.4545454545455}, {432., 236.4545454545455}}], 
         LineBox[{{430.155, 250.36363636363637`}, {432., 
          250.36363636363637`}}], 
         LineBox[{{430.155, 264.2727272727273}, {432., 264.2727272727273}}], 
         LineBox[{{430.155, 278.18181818181824`}, {432., 
          278.18181818181824`}}], 
         LineBox[{{428.31, 292.0909090909091}, {432., 292.0909090909091}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {432., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{19.636363636363654`, 3.69}, {19.636363636363654`, 0.}}], 
         LineBox[{{39.27272727272728, 1.845}, {39.27272727272728, 0.}}], 
         LineBox[{{58.90909090909091, 1.845}, {58.90909090909091, 0.}}], 
         LineBox[{{78.54545454545456, 1.845}, {78.54545454545456, 0.}}], 
         LineBox[{{98.1818181818182, 1.845}, {98.1818181818182, 0.}}], 
         LineBox[{{117.81818181818183`, 3.69}, {117.81818181818183`, 0.}}], 
         LineBox[{{137.45454545454544`, 1.845}, {137.45454545454544`, 0.}}], 
         LineBox[{{157.0909090909091, 1.845}, {157.0909090909091, 0.}}], 
         LineBox[{{176.72727272727275`, 1.845}, {176.72727272727275`, 0.}}], 
         LineBox[{{196.36363636363637`, 1.845}, {196.36363636363637`, 0.}}], 
         LineBox[{{216., 3.69}, {216., 0.}}], 
         LineBox[{{235.63636363636363`, 1.845}, {235.63636363636363`, 0.}}], 
         LineBox[{{255.27272727272728`, 1.845}, {255.27272727272728`, 0.}}], 
         LineBox[{{274.90909090909093`, 1.845}, {274.90909090909093`, 0.}}], 
         LineBox[{{294.54545454545456`, 1.845}, {294.54545454545456`, 0.}}], 
         LineBox[{{314.1818181818182, 3.69}, {314.1818181818182, 0.}}], 
         LineBox[{{333.8181818181818, 1.845}, {333.8181818181818, 0.}}], 
         LineBox[{{353.45454545454544`, 1.845}, {353.45454545454544`, 0.}}], 
         LineBox[{{373.0909090909091, 1.845}, {373.0909090909091, 0.}}], 
         LineBox[{{392.72727272727275`, 1.845}, {392.72727272727275`, 0.}}], 
         LineBox[{{412.3636363636364, 3.69}, {412.3636363636364, 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 306.00000000000006`}, {432., 306.00000000000006`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{19.636363636363654`, 302.31000000000006`}, {
          19.636363636363654`, 306.00000000000006`}}], 
         LineBox[{{39.27272727272728, 304.15500000000003`}, {
          39.27272727272728, 306.00000000000006`}}], 
         LineBox[{{58.90909090909091, 304.15500000000003`}, {
          58.90909090909091, 306.00000000000006`}}], 
         LineBox[{{78.54545454545456, 304.15500000000003`}, {
          78.54545454545456, 306.00000000000006`}}], 
         LineBox[{{98.1818181818182, 304.15500000000003`}, {98.1818181818182, 
          306.00000000000006`}}], 
         LineBox[{{117.81818181818183`, 302.31000000000006`}, {
          117.81818181818183`, 306.00000000000006`}}], 
         LineBox[{{137.45454545454544`, 304.15500000000003`}, {
          137.45454545454544`, 306.00000000000006`}}], 
         LineBox[{{157.0909090909091, 304.15500000000003`}, {
          157.0909090909091, 306.00000000000006`}}], 
         LineBox[{{176.72727272727275`, 304.15500000000003`}, {
          176.72727272727275`, 306.00000000000006`}}], 
         LineBox[{{196.36363636363637`, 304.15500000000003`}, {
          196.36363636363637`, 306.00000000000006`}}], 
         LineBox[{{216., 302.31000000000006`}, {216., 306.00000000000006`}}], 
         LineBox[{{235.63636363636363`, 304.15500000000003`}, {
          235.63636363636363`, 306.00000000000006`}}], 
         LineBox[{{255.27272727272728`, 304.15500000000003`}, {
          255.27272727272728`, 306.00000000000006`}}], 
         LineBox[{{274.90909090909093`, 304.15500000000003`}, {
          274.90909090909093`, 306.00000000000006`}}], 
         LineBox[{{294.54545454545456`, 304.15500000000003`}, {
          294.54545454545456`, 306.00000000000006`}}], 
         LineBox[{{314.1818181818182, 302.31000000000006`}, {
          314.1818181818182, 306.00000000000006`}}], 
         LineBox[{{333.8181818181818, 304.15500000000003`}, {
          333.8181818181818, 306.00000000000006`}}], 
         LineBox[{{353.45454545454544`, 304.15500000000003`}, {
          353.45454545454544`, 306.00000000000006`}}], 
         LineBox[{{373.0909090909091, 304.15500000000003`}, {
          373.0909090909091, 306.00000000000006`}}], 
         LineBox[{{392.72727272727275`, 304.15500000000003`}, {
          392.72727272727275`, 306.00000000000006`}}], 
         LineBox[{{412.3636363636364, 302.31000000000006`}, {
          412.3636363636364, 306.00000000000006`}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-1.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 13.909090909090935`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 83.45454545454548}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 153.00000000000003`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 222.54545454545456`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 292.0909090909091}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"y\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" (m)\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-30., 306.00000000000006`}, {0, -1}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-1.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {19.636363636363654`, -1.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {117.81818181818183`, -1.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {216., -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {314.1818181818182, -1.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {412.3636363636364, -1.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"t\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" (s)\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -16.}, {0, 1}, Automatic, {1., 0.}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-1.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 13.909090909090935`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 83.45454545454548}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 153.00000000000003`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 222.54545454545456`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 292.0909090909091}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"y\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" (m)\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-30., 306.00000000000006`}, {0, -1}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-1.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {19.636363636363654`, -1.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {117.81818181818183`, -1.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {216., -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {314.1818181818182, -1.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {412.3636363636364, -1.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"t\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" (s)\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -16.}, {0, 1}, Automatic, {1., 0.}]},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->0.78125,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{576, 450.},
  PlotRange->{{-72, 504}, {-72., 378.}}]], "Output",
 CellChangeTimes->{{3.518464758015625*^9, 3.51846481940625*^9}, 
   3.518464983921875*^9, {3.51846502690625*^9, 3.51846506815625*^9}, {
   3.518465160109375*^9, 3.518465171109375*^9}, {3.51846648865625*^9, 
   3.518466531125*^9}, 3.518466566328125*^9, {3.518466649375*^9, 
   3.518466674*^9}, 3.518468303171875*^9, {3.518468692015625*^9, 
   3.5184687164375*^9}, 3.5184687560625*^9, 3.518562369220375*^9, 
   3.520278477109375*^9, 3.524748112*^9, 3.5663388094339566`*^9, 
   3.5791218982116394`*^9, {3.584376035189612*^9, 3.5843760922701125`*^9}, 
   3.593010955056779*^9, {3.5943046531481524`*^9, 3.5943046571885595`*^9}, 
   3.59430508472291*^9, 3.622234634140071*^9}]
}, Open  ]],

Cell["Another example of filling to the axis...", "Text",
 CellChangeTimes->{{3.5943046710725837`*^9, 3.594304687312212*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DataPlot", "[", 
         RowBox[{"DataForFill", ",", 
          RowBox[{"DataFill", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Filling", "\[Rule]", 
              RowBox[{"-", "Infinity"}]}], ",", 
             RowBox[{"FillColor", "\[Rule]", "Moccasin"}]}], "}"}]}]}], "]"}],
         ";"}], "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "}"}]}], ",", 
      RowBox[{"ExtendRange", "\[Rule]", "0.05"}]}], "\[IndentingNewLine]", 
     "]"}], "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Style", "->", "\"\<ExampleDataFigure\>\""}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.518118989375*^9, 3.51811900096875*^9}, {
   3.518119070828125*^9, 3.518119080140625*^9}, 3.518434829484375*^9, {
   3.518434975890625*^9, 3.51843500028125*^9}, {3.5184377235*^9, 
   3.518437729046875*^9}, 3.518438256265625*^9, {3.51843828675*^9, 
   3.518438315203125*^9}, 3.5184383755*^9, {3.51843951065625*^9, 
   3.51843951134375*^9}, {3.5184634049375*^9, 3.51846340696875*^9}, 
   3.518464317515625*^9, {3.51846435009375*^9, 3.518464368390625*^9}, {
   3.5184645371875*^9, 3.518464557*^9}, {3.518464794203125*^9, 
   3.51846479571875*^9}, {3.518465025515625*^9, 3.518465026484375*^9}, {
   3.5184650614375*^9, 3.5184650675*^9}, {3.5184651670625*^9, 
   3.518465178015625*^9}, {3.518466446140625*^9, 3.51846653075*^9}, {
   3.518466656234375*^9, 3.5184666735625*^9}, {3.518468302109375*^9, 
   3.518468302640625*^9}, {3.5184686916875*^9, 3.518468701453125*^9}, {
   3.518468743921875*^9, 3.518468748859375*^9}, {3.5663388084511547`*^9, 
   3.566338809121956*^9}, {3.5843760294020023`*^9, 3.58437609095971*^9}, {
   3.584376139631796*^9, 3.5843761407393975`*^9}, 3.594305087437315*^9}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {432., 306.00000000000006`}]}, 
     InsetBox[
      GraphicsBox[{
        {EdgeForm[None], FaceForm[RGBColor[1., 0.894101, 0.709799]], 
         PolygonBox[CompressedData["
1:eJxTTMoPSmViYGAQB2IQvaJbb9eLRcYOQCbDhAj3gzD+A1fx2JKL2g5LwHxn
hw1Jl7TUzno6lFwESfg6GPupPHYpCoHKBzukAaXXBkU59IK43REO/wMu85vu
jXMoBauPhYh/TnAwAEnrJTo8cTHyU2FOgupPdhA0/RtweXmSg0QsyIY0h7ke
xzpT/iQ59IDNy3AQPWkxsUc6GexOBoZsB0YQpZAMNT/X4a3Z8bxilWSHV4tA
BuY7pG63LJvtnOygD7av0OHjKab1OjOSHV6C5DOKHOR2n9142ybFYTHY/mKI
OT6pDmDr75Y4NIeLVaQ+TIO6p8zh4rRXOSvFMh0ugawLLHd4cSO37y5bDtR9
FQ4R6d6l287kO7iBgu1oJUSdYxGcDwtfACCEn98=
          "]]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQvaJbb9eLRcYOD1zFY0suajssAfOdHTYkXdJSO+vp
UHIRJOHrYOyn8tilKAQqH+yQBpReGxTl0Avidkc4/A+4zG+6N86hFKw+FiL+
OcHBACStl+jwxMXIT4U5Cao/2UHQ9G/A5eVJDhKxIBvSHOZ6HOtM+ZPk0AM2
L8NB9KTFxB7pZAcGMMh2YARRCslQ83Md3podzytWSXZ4tQhkYL5D6nbLstnO
yQ76YPsKHT6eYlqvMyPZ4SVIPqPIQW732Y23bVIcFoPtL4aY45PqALb+bolD
c7hYRerDNKh7yhwuTnuVs1Is0+ESyLrAcocXN3L77rLlQN1X4RCR7l267Uy+
gxso2I5WQtQ5FjkAAAcJlGg=
          "]]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{20.791213052002764`, 14.387445199547297`}, {
            20.52024711284684, 14.79297438557412}, {20.114717926820017`, 
            15.063940324730044`}, {19.636363636363654`, 
            15.159090909090935`}, {19.158009345907292`, 
            15.063940324730044`}, {18.75248015988047, 14.79297438557412}, {
            18.481514220724545`, 14.387445199547297`}, {18.386363636363654`, 
            13.909090909090935`}, {18.481514220724545`, 
            13.430736618634572`}, {18.75248015988047, 13.02520743260775}, {
            19.158009345907292`, 12.754241493451826`}, {19.636363636363654`, 
            12.659090909090935`}, {20.114717926820017`, 
            12.754241493451826`}, {20.52024711284684, 13.02520743260775}, {
            20.791213052002764`, 13.430736618634572`}, {20.886363636363654`, 
            13.909090909090935`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{40.427576688366386`, 52.08108156318365}, {
            40.156610749210465`, 52.48661074921048}, {39.75108156318364, 
            52.7575766883664}, {39.27272727272728, 52.85272727272729}, {
            38.79437298227092, 52.7575766883664}, {38.388843796244096`, 
            52.48661074921048}, {38.117877857088175`, 52.08108156318365}, {
            38.02272727272728, 51.60272727272729}, {38.117877857088175`, 
            51.124372982270934`}, {38.388843796244096`, 50.71884379624411}, {
            38.79437298227092, 50.44787785708819}, {39.27272727272728, 
            50.35272727272729}, {39.75108156318364, 50.44787785708819}, {
            40.156610749210465`, 50.71884379624411}, {40.427576688366386`, 
            51.124372982270934`}, {40.52272727272728, 51.60272727272729}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{60.06394032473001, 82.26380883591092}, {
            59.79297438557409, 82.66933802193773}, {59.387445199547265`, 
            82.94030396109366}, {58.90909090909091, 83.03545454545456}, {
            58.43073661863455, 82.94030396109366}, {58.02520743260772, 
            82.66933802193773}, {57.7542414934518, 82.26380883591092}, {
            57.65909090909091, 81.78545454545456}, {57.7542414934518, 
            81.30710025499819}, {58.02520743260772, 80.90157106897138}, {
            58.43073661863455, 80.63060512981545}, {58.90909090909091, 
            80.53545454545456}, {59.387445199547265`, 80.63060512981545}, {
            59.79297438557409, 80.90157106897138}, {60.06394032473001, 
            81.30710025499819}, {60.15909090909091, 81.78545454545456}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{79.70030396109367, 105.7701724722746}, {
            79.42933802193774, 106.1757016583014}, {79.02380883591093, 
            106.44666759745733`}, {78.54545454545456, 106.54181818181823`}, {
            78.0671002549982, 106.44666759745733`}, {77.66157106897138, 
            106.1757016583014}, {77.39060512981546, 105.7701724722746}, {
            77.29545454545456, 105.29181818181823`}, {77.39060512981546, 
            104.81346389136186`}, {77.66157106897138, 104.40793470533505`}, {
            78.0671002549982, 104.13696876617912`}, {78.54545454545456, 
            104.04181818181823`}, {79.02380883591093, 104.13696876617912`}, {
            79.42933802193774, 104.40793470533505`}, {79.70030396109367, 
            104.81346389136186`}, {79.79545454545456, 
            105.29181818181823`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{99.3366675974573, 123.43471792682003`}, {
            99.06570165830138, 123.84024711284684`}, {98.66017247227457, 
            124.11121305200277`}, {98.1818181818182, 124.20636363636366`}, {
            97.70346389136184, 124.11121305200277`}, {97.29793470533502, 
            123.84024711284684`}, {97.0269687661791, 123.43471792682003`}, {
            96.9318181818182, 122.95636363636366`}, {97.0269687661791, 
            122.4780093459073}, {97.29793470533502, 122.07248015988048`}, {
            97.70346389136184, 121.80151422072456`}, {98.1818181818182, 
            121.70636363636366`}, {98.66017247227457, 121.80151422072456`}, {
            99.06570165830138, 122.07248015988048`}, {99.3366675974573, 
            122.4780093459073}, {99.4318181818182, 122.95636363636366`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{118.97303123382093`, 136.09199065409277`}, {
            118.702065294665, 136.4975198401196}, {118.2965361086382, 
            136.76848577927552`}, {117.81818181818183`, 136.8636363636364}, {
            117.33982752772546`, 136.76848577927552`}, {116.93429834169865`, 
            136.4975198401196}, {116.66333240254272`, 136.09199065409277`}, {
            116.56818181818183`, 135.6136363636364}, {116.66333240254272`, 
            135.13528207318004`}, {116.93429834169865`, 134.7297528871532}, {
            117.33982752772546`, 134.45878694799728`}, {117.81818181818183`, 
            134.3636363636364}, {118.2965361086382, 134.45878694799728`}, {
            118.702065294665, 134.7297528871532}, {118.97303123382093`, 
            135.13528207318004`}, {119.06818181818183`, 
            135.6136363636364}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{138.60939487018462`, 144.5765361086382}, {
            138.3384289310287, 144.98206529466503`}, {137.93289974500186`, 
            145.25303123382096`}, {137.4545454545455, 145.34818181818184`}, {
            136.97619116408913`, 145.25303123382096`}, {136.5706619780623, 
            144.98206529466503`}, {136.29969603890638`, 144.5765361086382}, {
            136.2045454545455, 144.09818181818184`}, {136.29969603890638`, 
            143.61982752772548`}, {136.5706619780623, 143.21429834169865`}, {
            136.97619116408913`, 142.94333240254272`}, {137.4545454545455, 
            142.84818181818184`}, {137.93289974500186`, 
            142.94333240254272`}, {138.3384289310287, 143.21429834169865`}, {
            138.60939487018462`, 143.61982752772548`}, {138.7045454545455, 
            144.09818181818184`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{158.24575850654824`, 149.72289974500185`}, {
            157.9747925673923, 150.12842893102868`}, {157.5692633813655, 
            150.3993948701846}, {157.09090909090912`, 150.4945454545455}, {
            156.61255480045276`, 150.3993948701846}, {156.20702561442593`, 
            150.12842893102868`}, {155.93605967527, 149.72289974500185`}, {
            155.84090909090912`, 149.2445454545455}, {155.93605967527, 
            148.76619116408912`}, {156.20702561442593`, 148.3606619780623}, {
            156.61255480045276`, 148.08969603890637`}, {157.09090909090912`, 
            147.9945454545455}, {157.5692633813655, 148.08969603890637`}, {
            157.9747925673923, 148.3606619780623}, {158.24575850654824`, 
            148.76619116408912`}, {158.34090909090912`, 
            149.2445454545455}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{177.88212214291187`, 152.3656270177291}, {
            177.61115620375594`, 152.77115620375594`}, {177.2056270177291, 
            153.04212214291186`}, {176.72727272727275`, 
            153.13727272727274`}, {176.24891843681638`, 
            153.04212214291186`}, {175.84338925078956`, 
            152.77115620375594`}, {175.57242331163363`, 152.3656270177291}, {
            175.47727272727275`, 151.88727272727274`}, {175.57242331163363`, 
            151.40891843681638`}, {175.84338925078956`, 
            151.00338925078955`}, {176.24891843681638`, 
            150.73242331163362`}, {176.72727272727275`, 
            150.63727272727274`}, {177.2056270177291, 150.73242331163362`}, {
            177.61115620375594`, 151.00338925078955`}, {177.88212214291187`, 
            151.40891843681638`}, {177.97727272727275`, 
            151.88727272727274`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{197.5184857792755, 153.3392633813655}, {
            197.24751984011957`, 153.74479256739232`}, {196.84199065409274`, 
            154.01575850654825`}, {196.36363636363637`, 
            154.11090909090913`}, {195.88528207318, 154.01575850654825`}, {
            195.47975288715318`, 153.74479256739232`}, {195.20878694799725`, 
            153.3392633813655}, {195.11363636363637`, 152.86090909090913`}, {
            195.20878694799725`, 152.38255480045277`}, {195.47975288715318`, 
            151.97702561442594`}, {195.88528207318, 151.70605967527}, {
            196.36363636363637`, 151.61090909090913`}, {196.84199065409274`, 
            151.70605967527}, {197.24751984011957`, 151.97702561442594`}, {
            197.5184857792755, 152.38255480045277`}, {197.61363636363637`, 
            152.86090909090913`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{217.15484941563912`, 153.4783542904564}, {
            216.8838834764832, 153.88388347648322`}, {216.47835429045637`, 
            154.15484941563915`}, {216., 154.25000000000003`}, {
            215.52164570954363`, 154.15484941563915`}, {215.1161165235168, 
            153.88388347648322`}, {214.84515058436088`, 153.4783542904564}, {
            214.75, 153.00000000000003`}, {214.84515058436088`, 
            152.52164570954366`}, {215.1161165235168, 152.11611652351684`}, {
            215.52164570954363`, 151.8451505843609}, {216., 
            151.75000000000003`}, {216.47835429045637`, 151.8451505843609}, {
            216.8838834764832, 152.11611652351684`}, {217.15484941563912`, 
            152.52164570954366`}, {217.25, 153.00000000000003`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{236.79121305200277`, 153.6174451995473}, {
            236.52024711284685`, 154.02297438557412`}, {236.11471792682002`, 
            154.29394032473004`}, {235.63636363636365`, 
            154.38909090909092`}, {235.1580093459073, 154.29394032473004`}, {
            234.75248015988046`, 154.02297438557412`}, {234.48151422072453`, 
            153.6174451995473}, {234.38636363636365`, 153.13909090909092`}, {
            234.48151422072453`, 152.66073661863456`}, {234.75248015988046`, 
            152.25520743260773`}, {235.1580093459073, 151.9842414934518}, {
            235.63636363636365`, 151.88909090909092`}, {236.11471792682002`, 
            151.9842414934518}, {236.52024711284685`, 152.25520743260773`}, {
            236.79121305200277`, 152.66073661863456`}, {236.88636363636365`, 
            153.13909090909092`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{256.4275766883664, 154.59108156318368`}, {
            256.1566107492105, 154.9966107492105}, {255.75108156318367`, 
            155.26757668836643`}, {255.2727272727273, 155.3627272727273}, {
            254.79437298227094`, 155.26757668836643`}, {254.38884379624412`, 
            154.9966107492105}, {254.1178778570882, 154.59108156318368`}, {
            254.0227272727273, 154.1127272727273}, {254.1178778570882, 
            153.63437298227095`}, {254.38884379624412`, 
            153.22884379624412`}, {254.79437298227094`, 152.9578778570882}, {
            255.2727272727273, 152.8627272727273}, {255.75108156318367`, 
            152.9578778570882}, {256.1566107492105, 153.22884379624412`}, {
            256.4275766883664, 153.63437298227095`}, {256.5227272727273, 
            154.1127272727273}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{276.06394032473, 157.23380883591093`}, {
            275.7929743855741, 157.63933802193776`}, {275.3874451995473, 
            157.9103039610937}, {274.90909090909093`, 158.00545454545457`}, {
            274.43073661863457`, 157.9103039610937}, {274.0252074326078, 
            157.63933802193776`}, {273.75424149345184`, 
            157.23380883591093`}, {273.65909090909093`, 
            156.75545454545457`}, {273.75424149345184`, 156.2771002549982}, {
            274.0252074326078, 155.87157106897138`}, {274.43073661863457`, 
            155.60060512981545`}, {274.90909090909093`, 
            155.50545454545457`}, {275.3874451995473, 155.60060512981545`}, {
            275.7929743855741, 155.87157106897138`}, {276.06394032473, 
            156.2771002549982}, {276.15909090909093`, 
            156.75545454545457`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{295.70030396109365`, 162.38017247227458`}, {
            295.4293380219377, 162.7857016583014}, {295.0238088359109, 
            163.05666759745733`}, {294.54545454545456`, 
            163.15181818181821`}, {294.0671002549982, 163.05666759745733`}, {
            293.6615710689714, 162.7857016583014}, {293.39060512981547`, 
            162.38017247227458`}, {293.29545454545456`, 
            161.90181818181821`}, {293.39060512981547`, 
            161.42346389136185`}, {293.6615710689714, 161.01793470533502`}, {
            294.0671002549982, 160.7469687661791}, {294.54545454545456`, 
            160.65181818181821`}, {295.0238088359109, 160.7469687661791}, {
            295.4293380219377, 161.01793470533502`}, {295.70030396109365`, 
            161.42346389136185`}, {295.79545454545456`, 
            161.90181818181821`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{315.3366675974573, 170.86471792682002`}, {
            315.06570165830135`, 171.27024711284685`}, {314.66017247227455`, 
            171.54121305200277`}, {314.1818181818182, 171.63636363636365`}, {
            313.7034638913618, 171.54121305200277`}, {313.297934705335, 
            171.27024711284685`}, {313.0269687661791, 170.86471792682002`}, {
            312.9318181818182, 170.38636363636365`}, {313.0269687661791, 
            169.9080093459073}, {313.297934705335, 169.50248015988046`}, {
            313.7034638913618, 169.23151422072453`}, {314.1818181818182, 
            169.13636363636365`}, {314.66017247227455`, 
            169.23151422072453`}, {315.06570165830135`, 
            169.50248015988046`}, {315.3366675974573, 169.9080093459073}, {
            315.4318181818182, 170.38636363636365`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{334.9730312338209, 183.52199065409278`}, {
            334.702065294665, 183.9275198401196}, {334.2965361086382, 
            184.19848577927553`}, {333.8181818181818, 184.2936363636364}, {
            333.33982752772545`, 184.19848577927553`}, {332.93429834169865`, 
            183.9275198401196}, {332.6633324025427, 183.52199065409278`}, {
            332.5681818181818, 183.0436363636364}, {332.6633324025427, 
            182.56528207318004`}, {332.93429834169865`, 
            182.15975288715322`}, {333.33982752772545`, 181.8887869479973}, {
            333.8181818181818, 181.7936363636364}, {334.2965361086382, 
            181.8887869479973}, {334.702065294665, 182.15975288715322`}, {
            334.9730312338209, 182.56528207318004`}, {335.0681818181818, 
            183.0436363636364}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{354.6093948701846, 201.18653610863825`}, {
            354.33842893102866`, 201.59206529466508`}, {353.93289974500186`, 
            201.863031233821}, {353.4545454545455, 201.95818181818188`}, {
            352.97619116408913`, 201.863031233821}, {352.57066197806233`, 
            201.59206529466508`}, {352.2996960389064, 201.18653610863825`}, {
            352.2045454545455, 200.70818181818188`}, {352.2996960389064, 
            200.22982752772552`}, {352.57066197806233`, 199.8242983416987}, {
            352.97619116408913`, 199.55333240254276`}, {353.4545454545455, 
            199.45818181818188`}, {353.93289974500186`, 
            199.55333240254276`}, {354.33842893102866`, 199.8242983416987}, {
            354.6093948701846, 200.22982752772552`}, {354.7045454545455, 
            200.70818181818188`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{374.2457585065482, 224.69289974500185`}, {
            373.9747925673923, 225.09842893102868`}, {373.5692633813655, 
            225.3693948701846}, {373.0909090909091, 225.4645454545455}, {
            372.61255480045276`, 225.3693948701846}, {372.20702561442596`, 
            225.09842893102868`}, {371.93605967527003`, 
            224.69289974500185`}, {371.8409090909091, 224.2145454545455}, {
            371.93605967527003`, 223.73619116408912`}, {372.20702561442596`, 
            223.3306619780623}, {372.61255480045276`, 223.05969603890637`}, {
            373.0909090909091, 222.9645454545455}, {373.5692633813655, 
            223.05969603890637`}, {373.9747925673923, 223.3306619780623}, {
            374.2457585065482, 223.73619116408912`}, {374.3409090909091, 
            224.2145454545455}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{393.88212214291184`, 254.8756270177292}, {
            393.6111562037559, 255.281156203756}, {393.2056270177291, 
            255.55212214291194`}, {392.72727272727275`, 
            255.64727272727282`}, {392.2489184368164, 255.55212214291194`}, {
            391.8433892507896, 255.281156203756}, {391.57242331163366`, 
            254.8756270177292}, {391.47727272727275`, 254.39727272727282`}, {
            391.57242331163366`, 253.91891843681645`}, {391.8433892507896, 
            253.51338925078963`}, {392.2489184368164, 253.2424233116337}, {
            392.72727272727275`, 253.14727272727282`}, {393.2056270177291, 
            253.2424233116337}, {393.6111562037559, 253.51338925078963`}, {
            393.88212214291184`, 253.91891843681645`}, {393.97727272727275`, 
            254.39727272727282`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{413.51848577927547`, 292.5692633813655}, {
            413.24751984011954`, 292.9747925673923}, {412.84199065409274`, 
            293.2457585065482}, {412.3636363636364, 293.3409090909091}, {
            411.88528207318, 293.2457585065482}, {411.4797528871532, 
            292.9747925673923}, {411.2087869479973, 292.5692633813655}, {
            411.1136363636364, 292.0909090909091}, {411.2087869479973, 
            291.61255480045276`}, {411.4797528871532, 291.20702561442596`}, {
            411.88528207318, 290.93605967527003`}, {412.3636363636364, 
            290.8409090909091}, {412.84199065409274`, 290.93605967527003`}, {
            413.24751984011954`, 291.20702561442596`}, {413.51848577927547`, 
            291.61255480045276`}, {413.6136363636364, 292.0909090909091}}]}}}},
       Frame->False,
       ImageSize->{432., 306.00000000000006`},
       PlotRange->{{0., 432.}, {0., 306.00000000000006`}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 0.}, {0., 306.00000000000006`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{3.69, 13.909090909090935`}, {0., 13.909090909090935`}}], 
         LineBox[{{1.845, 27.81818181818184}, {0., 27.81818181818184}}], 
         LineBox[{{1.845, 41.72727272727275}, {0., 41.72727272727275}}], 
         LineBox[{{1.845, 55.63636363636367}, {0., 55.63636363636367}}], 
         LineBox[{{1.845, 69.54545454545458}, {0., 69.54545454545458}}], 
         LineBox[{{3.69, 83.45454545454548}, {0., 83.45454545454548}}], 
         LineBox[{{1.845, 97.36363636363639}, {0., 97.36363636363639}}], 
         LineBox[{{1.845, 111.27272727272731`}, {0., 111.27272727272731`}}], 
         LineBox[{{1.845, 125.18181818181822`}, {0., 125.18181818181822`}}], 
         LineBox[{{1.845, 139.09090909090912`}, {0., 139.09090909090912`}}], 
         LineBox[{{3.69, 153.00000000000003`}, {0., 153.00000000000003`}}], 
         LineBox[{{1.845, 166.90909090909093`}, {0., 166.90909090909093`}}], 
         LineBox[{{1.845, 180.81818181818184`}, {0., 180.81818181818184`}}], 
         LineBox[{{1.845, 194.72727272727275`}, {0., 194.72727272727275`}}], 
         LineBox[{{1.845, 208.63636363636368`}, {0., 208.63636363636368`}}], 
         LineBox[{{3.69, 222.54545454545456`}, {0., 222.54545454545456`}}], 
         LineBox[{{1.845, 236.4545454545455}, {0., 236.4545454545455}}], 
         LineBox[{{1.845, 250.36363636363637`}, {0., 250.36363636363637`}}], 
         LineBox[{{1.845, 264.2727272727273}, {0., 264.2727272727273}}], 
         LineBox[{{1.845, 278.18181818181824`}, {0., 278.18181818181824`}}], 
         LineBox[{{3.69, 292.0909090909091}, {0., 292.0909090909091}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{432., 0.}, {432., 306.00000000000006`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{428.31, 13.909090909090935`}, {432., 
          13.909090909090935`}}], 
         LineBox[{{430.155, 27.81818181818184}, {432., 27.81818181818184}}], 
         LineBox[{{430.155, 41.72727272727275}, {432., 41.72727272727275}}], 
         LineBox[{{430.155, 55.63636363636367}, {432., 55.63636363636367}}], 
         LineBox[{{430.155, 69.54545454545458}, {432., 69.54545454545458}}], 
         LineBox[{{428.31, 83.45454545454548}, {432., 83.45454545454548}}], 
         LineBox[{{430.155, 97.36363636363639}, {432., 97.36363636363639}}], 
         LineBox[{{430.155, 111.27272727272731`}, {432., 
          111.27272727272731`}}], 
         LineBox[{{430.155, 125.18181818181822`}, {432., 
          125.18181818181822`}}], 
         LineBox[{{430.155, 139.09090909090912`}, {432., 
          139.09090909090912`}}], 
         LineBox[{{428.31, 153.00000000000003`}, {432., 
          153.00000000000003`}}], 
         LineBox[{{430.155, 166.90909090909093`}, {432., 
          166.90909090909093`}}], 
         LineBox[{{430.155, 180.81818181818184`}, {432., 
          180.81818181818184`}}], 
         LineBox[{{430.155, 194.72727272727275`}, {432., 
          194.72727272727275`}}], 
         LineBox[{{430.155, 208.63636363636368`}, {432., 
          208.63636363636368`}}], 
         LineBox[{{428.31, 222.54545454545456`}, {432., 
          222.54545454545456`}}], 
         LineBox[{{430.155, 236.4545454545455}, {432., 236.4545454545455}}], 
         LineBox[{{430.155, 250.36363636363637`}, {432., 
          250.36363636363637`}}], 
         LineBox[{{430.155, 264.2727272727273}, {432., 264.2727272727273}}], 
         LineBox[{{430.155, 278.18181818181824`}, {432., 
          278.18181818181824`}}], 
         LineBox[{{428.31, 292.0909090909091}, {432., 292.0909090909091}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {432., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{19.636363636363654`, 3.69}, {19.636363636363654`, 0.}}], 
         LineBox[{{39.27272727272728, 1.845}, {39.27272727272728, 0.}}], 
         LineBox[{{58.90909090909091, 1.845}, {58.90909090909091, 0.}}], 
         LineBox[{{78.54545454545456, 1.845}, {78.54545454545456, 0.}}], 
         LineBox[{{98.1818181818182, 1.845}, {98.1818181818182, 0.}}], 
         LineBox[{{117.81818181818183`, 3.69}, {117.81818181818183`, 0.}}], 
         LineBox[{{137.45454545454544`, 1.845}, {137.45454545454544`, 0.}}], 
         LineBox[{{157.0909090909091, 1.845}, {157.0909090909091, 0.}}], 
         LineBox[{{176.72727272727275`, 1.845}, {176.72727272727275`, 0.}}], 
         LineBox[{{196.36363636363637`, 1.845}, {196.36363636363637`, 0.}}], 
         LineBox[{{216., 3.69}, {216., 0.}}], 
         LineBox[{{235.63636363636363`, 1.845}, {235.63636363636363`, 0.}}], 
         LineBox[{{255.27272727272728`, 1.845}, {255.27272727272728`, 0.}}], 
         LineBox[{{274.90909090909093`, 1.845}, {274.90909090909093`, 0.}}], 
         LineBox[{{294.54545454545456`, 1.845}, {294.54545454545456`, 0.}}], 
         LineBox[{{314.1818181818182, 3.69}, {314.1818181818182, 0.}}], 
         LineBox[{{333.8181818181818, 1.845}, {333.8181818181818, 0.}}], 
         LineBox[{{353.45454545454544`, 1.845}, {353.45454545454544`, 0.}}], 
         LineBox[{{373.0909090909091, 1.845}, {373.0909090909091, 0.}}], 
         LineBox[{{392.72727272727275`, 1.845}, {392.72727272727275`, 0.}}], 
         LineBox[{{412.3636363636364, 3.69}, {412.3636363636364, 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 306.00000000000006`}, {432., 306.00000000000006`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{19.636363636363654`, 302.31000000000006`}, {
          19.636363636363654`, 306.00000000000006`}}], 
         LineBox[{{39.27272727272728, 304.15500000000003`}, {
          39.27272727272728, 306.00000000000006`}}], 
         LineBox[{{58.90909090909091, 304.15500000000003`}, {
          58.90909090909091, 306.00000000000006`}}], 
         LineBox[{{78.54545454545456, 304.15500000000003`}, {
          78.54545454545456, 306.00000000000006`}}], 
         LineBox[{{98.1818181818182, 304.15500000000003`}, {98.1818181818182, 
          306.00000000000006`}}], 
         LineBox[{{117.81818181818183`, 302.31000000000006`}, {
          117.81818181818183`, 306.00000000000006`}}], 
         LineBox[{{137.45454545454544`, 304.15500000000003`}, {
          137.45454545454544`, 306.00000000000006`}}], 
         LineBox[{{157.0909090909091, 304.15500000000003`}, {
          157.0909090909091, 306.00000000000006`}}], 
         LineBox[{{176.72727272727275`, 304.15500000000003`}, {
          176.72727272727275`, 306.00000000000006`}}], 
         LineBox[{{196.36363636363637`, 304.15500000000003`}, {
          196.36363636363637`, 306.00000000000006`}}], 
         LineBox[{{216., 302.31000000000006`}, {216., 306.00000000000006`}}], 
         LineBox[{{235.63636363636363`, 304.15500000000003`}, {
          235.63636363636363`, 306.00000000000006`}}], 
         LineBox[{{255.27272727272728`, 304.15500000000003`}, {
          255.27272727272728`, 306.00000000000006`}}], 
         LineBox[{{274.90909090909093`, 304.15500000000003`}, {
          274.90909090909093`, 306.00000000000006`}}], 
         LineBox[{{294.54545454545456`, 304.15500000000003`}, {
          294.54545454545456`, 306.00000000000006`}}], 
         LineBox[{{314.1818181818182, 302.31000000000006`}, {
          314.1818181818182, 306.00000000000006`}}], 
         LineBox[{{333.8181818181818, 304.15500000000003`}, {
          333.8181818181818, 306.00000000000006`}}], 
         LineBox[{{353.45454545454544`, 304.15500000000003`}, {
          353.45454545454544`, 306.00000000000006`}}], 
         LineBox[{{373.0909090909091, 304.15500000000003`}, {
          373.0909090909091, 306.00000000000006`}}], 
         LineBox[{{392.72727272727275`, 304.15500000000003`}, {
          392.72727272727275`, 306.00000000000006`}}], 
         LineBox[{{412.3636363636364, 302.31000000000006`}, {
          412.3636363636364, 306.00000000000006`}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-1.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 13.909090909090935`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 83.45454545454548}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 153.00000000000003`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 222.54545454545456`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 292.0909090909091}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"y\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" (m)\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-29., 306.00000000000006`}, {0, -1}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-1.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {19.636363636363654`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {117.81818181818183`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {216., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {314.1818181818182, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {412.3636363636364, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"t\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" (s)\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -15.}, {0, 1}, Automatic, {1., 0.}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-1.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 13.909090909090935`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 83.45454545454548}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 153.00000000000003`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 222.54545454545456`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 292.0909090909091}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"y\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" (m)\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-29., 306.00000000000006`}, {0, -1}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-1.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {19.636363636363654`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {117.81818181818183`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {216., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {314.1818181818182, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {412.3636363636364, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"t\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" (s)\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -15.}, {0, 1}, Automatic, {1., 0.}]},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->0.78125,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{576, 450.},
  PlotRange->{{-72, 504}, {-72., 378.}}]], "Output",
 CellChangeTimes->{{3.518468770171875*^9, 3.518468775734375*^9}, 
   3.518562377376625*^9, 3.520278484875*^9, 3.52474811515625*^9, 
   3.5663388150811663`*^9, 3.579121899257699*^9, 3.5843761415973988`*^9, 
   3.5930109573718147`*^9, 3.5943046643333716`*^9, 3.5943050883577166`*^9}]
}, Open  ]],

Cell["... or between curves", "Text",
 CellChangeTimes->{{3.518468627828125*^9, 3.51846863096875*^9}, {
  3.520947775453125*^9, 3.5209477775625*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DataForFill2", "=", 
  RowBox[{"N", "@", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{
        RowBox[{"x", "^", "3"}], "+", "0.3"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "1"}], ",", "1", ",", "0.1"}], "}"}]}], 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.518118989375*^9, 3.51811900096875*^9}, {
   3.518119070828125*^9, 3.518119080140625*^9}, 3.518434829484375*^9, {
   3.518434975890625*^9, 3.51843500028125*^9}, {3.5184377235*^9, 
   3.518437729046875*^9}, 3.518438256265625*^9, {3.51843828675*^9, 
   3.518438315203125*^9}, 3.5184383755*^9, {3.51843951065625*^9, 
   3.51843951134375*^9}, {3.5184634049375*^9, 3.51846340696875*^9}, 
   3.518464317515625*^9, {3.51846435009375*^9, 3.518464368390625*^9}, {
   3.5184645371875*^9, 3.518464557*^9}, {3.518464794203125*^9, 
   3.51846479571875*^9}, {3.518465025515625*^9, 3.518465026484375*^9}, {
   3.5184650614375*^9, 3.5184650675*^9}, {3.5184651670625*^9, 
   3.518465178015625*^9}, {3.518466446140625*^9, 3.51846653075*^9}, {
   3.518466656234375*^9, 3.5184666735625*^9}, {3.518466839125*^9, 
   3.518466945625*^9}, {3.518467059203125*^9, 3.518467081875*^9}, {
   3.5184686338125*^9, 3.51846867084375*^9}, 3.518468702140625*^9, {
   3.518562617064125*^9, 3.51856262601725*^9}, 3.518562658939125*^9, {
   3.566338818871973*^9, 3.5663388274207883`*^9}, {3.584376153047819*^9, 
   3.5843761587106295`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.`"}], ",", 
     RowBox[{"-", "0.7`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.9`"}], ",", 
     RowBox[{"-", "0.4290000000000001`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.8`"}], ",", 
     RowBox[{"-", "0.21200000000000013`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.7`"}], ",", 
     RowBox[{"-", "0.04299999999999993`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.6`"}], ",", "0.08399999999999999`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.5`"}], ",", "0.175`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.3999999999999999`"}], ",", "0.23600000000000004`"}], 
    "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.29999999999999993`"}], ",", "0.273`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.19999999999999996`"}], ",", "0.292`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "0.09999999999999998`"}], ",", "0.299`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.`", ",", "0.3`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.10000000000000009`", ",", "0.301`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.20000000000000018`", ",", "0.308`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.30000000000000004`", ",", "0.327`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.40000000000000013`", ",", "0.36400000000000005`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.5`", ",", "0.425`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.6000000000000001`", ",", "0.516`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.7000000000000002`", ",", "0.6430000000000002`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.8`", ",", "0.812`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9000000000000001`", ",", "1.0290000000000004`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.`", ",", "1.3`"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.58437615941263*^9, 3.59301095906184*^9, 
  3.5943050906197205`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{
         "DataPlot", "\[LeftDoubleBracket]", "\"\<p1\>\"", 
          "\[RightDoubleBracket]"}], "[", "DataForFill", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "DataPlot", "\[LeftDoubleBracket]", "\"\<p2\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"DataForFill2", ",", 
          RowBox[{"DataFill", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Filling", "\[Rule]", "\"\<p1\>\""}], ",", 
             RowBox[{"FillColor", "\[Rule]", "Moccasin"}]}], "}"}]}]}], "]"}],
         ";"}], "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1.3"}], "}"}]}], "}"}]}], ",", 
      RowBox[{"ExtendRange", "\[Rule]", "0.05"}]}], "\[IndentingNewLine]", 
     "]"}], "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Style", "->", "\"\<ExampleDataFigure\>\""}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.518118989375*^9, 3.51811900096875*^9}, {
   3.518119070828125*^9, 3.518119080140625*^9}, 3.518434829484375*^9, {
   3.518434975890625*^9, 3.51843500028125*^9}, {3.5184377235*^9, 
   3.518437729046875*^9}, 3.518438256265625*^9, {3.51843828675*^9, 
   3.518438315203125*^9}, 3.5184383755*^9, {3.51843951065625*^9, 
   3.51843951134375*^9}, {3.5184634049375*^9, 3.51846340696875*^9}, 
   3.518464317515625*^9, {3.51846435009375*^9, 3.518464368390625*^9}, {
   3.5184645371875*^9, 3.518464557*^9}, {3.518464794203125*^9, 
   3.51846479571875*^9}, {3.518465025515625*^9, 3.518465026484375*^9}, {
   3.5184650614375*^9, 3.5184650675*^9}, {3.5184651670625*^9, 
   3.518465178015625*^9}, {3.518466446140625*^9, 3.51846653075*^9}, {
   3.518466656234375*^9, 3.5184666735625*^9}, {3.518466839125*^9, 
   3.518466945625*^9}, {3.518467059203125*^9, 3.518467081875*^9}, {
   3.5184686338125*^9, 3.51846867084375*^9}, 3.518468702140625*^9, {
   3.518562617064125*^9, 3.51856262601725*^9}, 3.518562658939125*^9, {
   3.566338818871973*^9, 3.5663388274207883`*^9}, {3.584376153047819*^9, 
   3.584376189442683*^9}, 3.5943050935369253`*^9}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {432., 306.}]}, InsetBox[
      GraphicsBox[{
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {EdgeForm[None], FaceForm[RGBColor[1., 0.894101, 0.709799]], 
         PolygonBox[CompressedData["
1:eJxTTMoPSmViYGDQAmIQvaJbb9eLRcYOHBGy8ackPB2WgPnODnErDpxQ2Bfi
UHLRVTy2xNfh1qP+k3d8o6HywQ67jp0qYzVNcOgFcbsjHIRzTSv6FJIcSsHq
Yx0qaq+4HWpIdjAASeslOjybUHLgZk4KVH+yQ5TDo0O8f1IcJGJBNqQ5XFF5
pT3dNdWhB2xehkPQ9Yib6xJSHRjAINvh0odfK3pTUqHm5zoEcc2tyMlIdXi1
CGRgvsP5PdxqLc2pDvpg+wodvBYK9/OeTXV4CZLPKHLYF9A40TEmzWEx2P5i
B50URe5Ij3QHsPV3SxxAzutZkQF1T5nDKynt26JTshwugawLLHcw+6D7Vkcp
F+q+CofdYP8XOLgBpS8erXQAO8uxCM7/u9Ii4+zPfLj6C6vnz37/IBtu3iQ+
i9mCMxH2uVmadv7iSoO7582kU+2F8ilw97Y3ae+03Z8E949Ufre92uVEuH+X
7pe1/eScCA8PoOuvZPxKgIfXWo3laoH3E+DhqcvPGl50OwEe3mu/JrVPvp4A
jw995y83q/ckwONra9ybgk9FCfD4bIz7e6fmeDw8vpeZ733p+z4Wnh7uitX7
PNNDpBedUys9r4SHw9PTBPklqsusg+DpTQMs7+4AS48XQMouajsAADnNMdo=

          "]]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQvaJbb9eLRcYOF1zFY0suajssAfOdHTROrfS8Eu7u
UHIRJOHrMEF+ieoy6yCofLCDDlg+3KEXxO2OcLgrVu/zTC/aoRSsPtZhmfne
l77vYx0MQNJ6iQ6NcX/v1ByPh+pPdtga96bgU1GCg0QsyIY0B33nLzer9yQ4
9IDNy3BY+zWpffL1BAcGMMh20OVnDS+6nQA1P9dhrcZytcD7CQ6vFoEMzHfQ
vi16JeNXgoM+2L5Ch6X7ZW0/OSc6vATJZxQ5SOV326tdTnRYDLa/2KG9SXun
7f4kB7D1d0sc3kw61V4onwJ1T5mDm6Vp5y+uNIdLIOsCyx0m8VnMFpyZAXVf
hcOF1fNnv3+Q7eAGCrajlQ5/V1pknP2Z7wAApyCbng==
          "]]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{20.791213052002764`, 14.387445199547269`}, {
            20.52024711284684, 14.792974385574091`}, {20.114717926820017`, 
            15.063940324730016`}, {19.636363636363654`, 
            15.159090909090907`}, {19.158009345907292`, 
            15.063940324730016`}, {18.75248015988047, 14.792974385574091`}, {
            18.481514220724545`, 14.387445199547269`}, {18.386363636363654`, 
            13.909090909090907`}, {18.481514220724545`, 
            13.430736618634544`}, {18.75248015988047, 13.025207432607722`}, {
            19.158009345907292`, 12.754241493451797`}, {19.636363636363654`, 
            12.659090909090907`}, {20.114717926820017`, 
            12.754241493451797`}, {20.52024711284684, 13.025207432607722`}, {
            20.791213052002764`, 13.430736618634544`}, {20.886363636363654`, 
            13.909090909090907`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{40.427576688366386`, 47.164520298361474`}, {
            40.156610749210465`, 47.5700494843883}, {39.75108156318364, 
            47.84101542354422}, {39.27272727272728, 47.936166007905115`}, {
            38.79437298227092, 47.84101542354422}, {38.388843796244096`, 
            47.5700494843883}, {38.117877857088175`, 47.164520298361474`}, {
            38.02272727272728, 46.686166007905115`}, {38.117877857088175`, 
            46.207811717448756`}, {38.388843796244096`, 45.80228253142193}, {
            38.79437298227092, 45.53131659226601}, {39.27272727272728, 
            45.436166007905115`}, {39.75108156318364, 45.53131659226601}, {
            40.156610749210465`, 45.80228253142193}, {40.427576688366386`, 
            46.207811717448756`}, {40.52272727272728, 
            46.686166007905115`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{60.06394032473001, 73.41037010073302}, {
            59.79297438557409, 73.81589928675983}, {59.387445199547265`, 
            74.08686522591576}, {58.90909090909091, 74.18201581027665}, {
            58.43073661863455, 74.08686522591576}, {58.02520743260772, 
            73.81589928675983}, {57.7542414934518, 73.41037010073302}, {
            57.65909090909091, 72.93201581027665}, {57.7542414934518, 
            72.45366151982029}, {58.02520743260772, 72.04813233379348}, {
            58.43073661863455, 71.77716639463755}, {58.90909090909091, 
            71.68201581027665}, {59.387445199547265`, 71.77716639463755}, {
            59.79297438557409, 72.04813233379348}, {60.06394032473001, 
            72.45366151982029}, {60.15909090909091, 72.93201581027665}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{79.70030396109367, 93.85068630626665}, {
            79.42933802193774, 94.25621549229346}, {79.02380883591093, 
            94.52718143144939}, {78.54545454545456, 94.62233201581029}, {
            78.0671002549982, 94.52718143144939}, {77.66157106897138, 
            94.25621549229346}, {77.39060512981546, 93.85068630626665}, {
            77.29545454545456, 93.37233201581029}, {77.39060512981546, 
            92.89397772535392}, {77.66157106897138, 92.48844853932711}, {
            78.0671002549982, 92.21748260017118}, {78.54545454545456, 
            92.12233201581029}, {79.02380883591093, 92.21748260017118}, {
            79.42933802193774, 92.48844853932711}, {79.70030396109367, 
            92.89397772535392}, {79.79545454545456, 93.37233201581029}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{99.3366675974573, 109.21116061456702`}, {
            99.06570165830138, 109.61668980059383`}, {98.66017247227457, 
            109.88765573974976`}, {98.1818181818182, 109.98280632411065`}, {
            97.70346389136184, 109.88765573974976`}, {97.29793470533502, 
            109.61668980059383`}, {97.0269687661791, 109.21116061456702`}, {
            96.9318181818182, 108.73280632411065`}, {97.0269687661791, 
            108.25445203365429`}, {97.29793470533502, 107.84892284762748`}, {
            97.70346389136184, 107.57795690847155`}, {98.1818181818182, 
            107.48280632411065`}, {98.66017247227457, 107.57795690847155`}, {
            99.06570165830138, 107.84892284762748`}, {99.3366675974573, 
            108.25445203365429`}, {99.4318181818182, 
            108.73280632411065`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{118.97303123382093`, 120.21748472523896`}, {
            118.702065294665, 120.62301391126577`}, {118.2965361086382, 
            120.8939798504217}, {117.81818181818183`, 120.9891304347826}, {
            117.33982752772546`, 120.8939798504217}, {116.93429834169865`, 
            120.62301391126577`}, {116.66333240254272`, 
            120.21748472523896`}, {116.56818181818183`, 119.7391304347826}, {
            116.66333240254272`, 119.26077614432623`}, {116.93429834169865`, 
            118.85524695829942`}, {117.33982752772546`, 
            118.58428101914349`}, {117.81818181818183`, 118.4891304347826}, {
            118.2965361086382, 118.58428101914349`}, {118.702065294665, 
            118.85524695829942`}, {118.97303123382093`, 
            119.26077614432623`}, {119.06818181818183`, 
            119.7391304347826}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{138.60939487018462`, 127.59535033788718`}, {
            138.3384289310287, 128.000879523914}, {137.93289974500186`, 
            128.27184546306992`}, {137.4545454545455, 128.3669960474308}, {
            136.97619116408913`, 128.27184546306992`}, {136.5706619780623, 
            128.000879523914}, {136.29969603890638`, 127.59535033788718`}, {
            136.2045454545455, 127.11699604743082`}, {136.29969603890638`, 
            126.63864175697445`}, {136.5706619780623, 126.23311257094764`}, {
            136.97619116408913`, 125.96214663179171`}, {137.4545454545455, 
            125.86699604743082`}, {137.93289974500186`, 
            125.96214663179171`}, {138.3384289310287, 126.23311257094764`}, {
            138.60939487018462`, 126.63864175697445`}, {138.7045454545455, 
            127.11699604743082`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{158.24575850654824`, 132.07044915211642`}, {
            157.9747925673923, 132.47597833814325`}, {157.5692633813655, 
            132.74694427729918`}, {157.09090909090912`, 
            132.84209486166006`}, {156.61255480045276`, 
            132.74694427729918`}, {156.20702561442593`, 
            132.47597833814325`}, {155.93605967527, 132.07044915211642`}, {
            155.84090909090912`, 131.59209486166006`}, {155.93605967527, 
            131.1137405712037}, {156.20702561442593`, 130.70821138517687`}, {
            156.61255480045276`, 130.43724544602094`}, {157.09090909090912`, 
            130.34209486166006`}, {157.5692633813655, 130.43724544602094`}, {
            157.9747925673923, 130.70821138517687`}, {158.24575850654824`, 
            131.1137405712037}, {158.34090909090912`, 
            131.59209486166006`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{177.88212214291187`, 134.36847286753144`}, {
            177.61115620375594`, 134.77400205355826`}, {177.2056270177291, 
            135.0449679927142}, {176.72727272727275`, 135.14011857707507`}, {
            176.24891843681638`, 135.0449679927142}, {175.84338925078956`, 
            134.77400205355826`}, {175.57242331163363`, 
            134.36847286753144`}, {175.47727272727275`, 
            133.89011857707507`}, {175.57242331163363`, 133.4117642866187}, {
            175.84338925078956`, 133.00623510059188`}, {176.24891843681638`, 
            132.73526916143595`}, {176.72727272727275`, 
            132.64011857707507`}, {177.2056270177291, 132.73526916143595`}, {
            177.61115620375594`, 133.00623510059188`}, {177.88212214291187`, 
            133.4117642866187}, {177.97727272727275`, 
            133.89011857707507`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{197.5184857792755, 135.21511318373697`}, {
            197.24751984011957`, 135.6206423697638}, {196.84199065409274`, 
            135.89160830891973`}, {196.36363636363637`, 135.9867588932806}, {
            195.88528207318, 135.89160830891973`}, {195.47975288715318`, 
            135.6206423697638}, {195.20878694799725`, 135.21511318373697`}, {
            195.11363636363637`, 134.7367588932806}, {195.20878694799725`, 
            134.25840460282424`}, {195.47975288715318`, 
            133.85287541679742`}, {195.88528207318, 133.5819094776415}, {
            196.36363636363637`, 133.4867588932806}, {196.84199065409274`, 
            133.5819094776415}, {197.24751984011957`, 133.85287541679742`}, {
            197.5184857792755, 134.25840460282424`}, {197.61363636363637`, 
            134.7367588932806}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{217.15484941563912`, 135.33606180033777`}, {
            216.8838834764832, 135.7415909863646}, {216.47835429045637`, 
            136.01255692552053`}, {216., 136.1077075098814}, {
            215.52164570954363`, 136.01255692552053`}, {215.1161165235168, 
            135.7415909863646}, {214.84515058436088`, 135.33606180033777`}, {
            214.75, 134.8577075098814}, {214.84515058436088`, 
            134.37935321942504`}, {215.1161165235168, 133.97382403339822`}, {
            215.52164570954363`, 133.7028580942423}, {216., 
            133.6077075098814}, {216.47835429045637`, 133.7028580942423}, {
            216.8838834764832, 133.97382403339822`}, {217.15484941563912`, 
            134.37935321942504`}, {217.25, 134.8577075098814}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{236.79121305200277`, 135.45701041693857`}, {
            236.52024711284685`, 135.8625396029654}, {236.11471792682002`, 
            136.13350554212133`}, {235.63636363636365`, 136.2286561264822}, {
            235.1580093459073, 136.13350554212133`}, {234.75248015988046`, 
            135.8625396029654}, {234.48151422072453`, 135.45701041693857`}, {
            234.38636363636365`, 134.9786561264822}, {234.48151422072453`, 
            134.50030183602584`}, {234.75248015988046`, 
            134.09477264999902`}, {235.1580093459073, 133.8238067108431}, {
            235.63636363636365`, 133.7286561264822}, {236.11471792682002`, 
            133.8238067108431}, {236.52024711284685`, 134.09477264999902`}, {
            236.79121305200277`, 134.50030183602584`}, {236.88636363636365`, 
            134.9786561264822}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{256.4275766883664, 136.3036507331441}, {
            256.1566107492105, 136.70917991917094`}, {255.75108156318367`, 
            136.98014585832686`}, {255.2727272727273, 137.07529644268774`}, {
            254.79437298227094`, 136.98014585832686`}, {254.38884379624412`, 
            136.70917991917094`}, {254.1178778570882, 136.3036507331441}, {
            254.0227272727273, 135.82529644268774`}, {254.1178778570882, 
            135.34694215223138`}, {254.38884379624412`, 
            134.94141296620455`}, {254.79437298227094`, 
            134.67044702704862`}, {255.2727272727273, 134.57529644268774`}, {
            255.75108156318367`, 134.67044702704862`}, {256.1566107492105, 
            134.94141296620455`}, {256.4275766883664, 135.34694215223138`}, {
            256.5227272727273, 135.82529644268774`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{276.06394032473, 138.60167444855912`}, {
            275.7929743855741, 139.00720363458595`}, {275.3874451995473, 
            139.27816957374188`}, {274.90909090909093`, 
            139.37332015810276`}, {274.43073661863457`, 
            139.27816957374188`}, {274.0252074326078, 139.00720363458595`}, {
            273.75424149345184`, 138.60167444855912`}, {273.65909090909093`, 
            138.12332015810276`}, {273.75424149345184`, 137.6449658676464}, {
            274.0252074326078, 137.23943668161957`}, {274.43073661863457`, 
            136.96847074246364`}, {274.90909090909093`, 
            136.87332015810276`}, {275.3874451995473, 136.96847074246364`}, {
            275.7929743855741, 137.23943668161957`}, {276.06394032473, 
            137.6449658676464}, {276.15909090909093`, 
            138.12332015810276`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{295.70030396109365`, 143.07677326278838`}, {
            295.4293380219377, 143.4823024488152}, {295.0238088359109, 
            143.75326838797113`}, {294.54545454545456`, 143.848418972332}, {
            294.0671002549982, 143.75326838797113`}, {293.6615710689714, 
            143.4823024488152}, {293.39060512981547`, 143.07677326278838`}, {
            293.29545454545456`, 142.598418972332}, {293.39060512981547`, 
            142.12006468187565`}, {293.6615710689714, 141.71453549584882`}, {
            294.0671002549982, 141.4435695566929}, {294.54545454545456`, 
            141.348418972332}, {295.0238088359109, 141.4435695566929}, {
            295.4293380219377, 141.71453549584882`}, {295.70030396109365`, 
            142.12006468187565`}, {295.79545454545456`, 
            142.598418972332}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{315.3366675974573, 150.4546388754366}, {
            315.06570165830135`, 150.8601680614634}, {314.66017247227455`, 
            151.13113400061934`}, {314.1818181818182, 151.22628458498022`}, {
            313.7034638913618, 151.13113400061934`}, {313.297934705335, 
            150.8601680614634}, {313.0269687661791, 150.4546388754366}, {
            312.9318181818182, 149.97628458498022`}, {313.0269687661791, 
            149.49793029452385`}, {313.297934705335, 149.09240110849703`}, {
            313.7034638913618, 148.8214351693411}, {314.1818181818182, 
            148.72628458498022`}, {314.66017247227455`, 148.8214351693411}, {
            315.06570165830135`, 149.09240110849703`}, {315.3366675974573, 
            149.49793029452385`}, {315.4318181818182, 
            149.97628458498022`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{334.9730312338209, 161.46096298610854`}, {
            334.702065294665, 161.86649217213537`}, {334.2965361086382, 
            162.1374581112913}, {333.8181818181818, 162.23260869565217`}, {
            333.33982752772545`, 162.1374581112913}, {332.93429834169865`, 
            161.86649217213537`}, {332.6633324025427, 161.46096298610854`}, {
            332.5681818181818, 160.98260869565217`}, {332.6633324025427, 
            160.5042544051958}, {332.93429834169865`, 160.09872521916898`}, {
            333.33982752772545`, 159.82775928001305`}, {333.8181818181818, 
            159.73260869565217`}, {334.2965361086382, 159.82775928001305`}, {
            334.702065294665, 160.09872521916898`}, {334.9730312338209, 
            160.5042544051958}, {335.0681818181818, 160.98260869565217`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{354.6093948701846, 176.82143729440895`}, {
            354.33842893102866`, 177.22696648043578`}, {353.93289974500186`, 
            177.4979324195917}, {353.4545454545455, 177.5930830039526}, {
            352.97619116408913`, 177.4979324195917}, {352.57066197806233`, 
            177.22696648043578`}, {352.2996960389064, 176.82143729440895`}, {
            352.2045454545455, 176.3430830039526}, {352.2996960389064, 
            175.86472871349622`}, {352.57066197806233`, 175.4591995274694}, {
            352.97619116408913`, 175.18823358831347`}, {353.4545454545455, 
            175.0930830039526}, {353.93289974500186`, 175.18823358831347`}, {
            354.33842893102866`, 175.4591995274694}, {354.6093948701846, 
            175.86472871349622`}, {354.7045454545455, 176.3430830039526}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{374.2457585065482, 197.26175349994253`}, {
            373.9747925673923, 197.66728268596935`}, {373.5692633813655, 
            197.93824862512528`}, {373.0909090909091, 198.03339920948616`}, {
            372.61255480045276`, 197.93824862512528`}, {372.20702561442596`, 
            197.66728268596935`}, {371.93605967527003`, 
            197.26175349994253`}, {371.8409090909091, 196.78339920948616`}, {
            371.93605967527003`, 196.3050449190298}, {372.20702561442596`, 
            195.89951573300297`}, {372.61255480045276`, 
            195.62854979384704`}, {373.0909090909091, 195.53339920948616`}, {
            373.5692633813655, 195.62854979384704`}, {373.9747925673923, 
            195.89951573300297`}, {374.2457585065482, 196.3050449190298}, {
            374.3409090909091, 196.78339920948616`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{393.88212214291184`, 223.50760330231407`}, {
            393.6111562037559, 223.9131324883409}, {393.2056270177291, 
            224.18409842749682`}, {392.72727272727275`, 224.2792490118577}, {
            392.2489184368164, 224.18409842749682`}, {391.8433892507896, 
            223.9131324883409}, {391.57242331163366`, 223.50760330231407`}, {
            391.47727272727275`, 223.0292490118577}, {391.57242331163366`, 
            222.55089472140133`}, {391.8433892507896, 222.1453655353745}, {
            392.2489184368164, 221.87439959621858`}, {392.72727272727275`, 
            221.7792490118577}, {393.2056270177291, 221.87439959621858`}, {
            393.6111562037559, 222.1453655353745}, {393.88212214291184`, 
            222.55089472140133`}, {393.97727272727275`, 
            223.0292490118577}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{413.51848577927547`, 256.28467840112825`}, {
            413.24751984011954`, 256.6902075871551}, {412.84199065409274`, 
            256.96117352631103`}, {412.3636363636364, 257.0563241106719}, {
            411.88528207318, 256.96117352631103`}, {411.4797528871532, 
            256.6902075871551}, {411.2087869479973, 256.28467840112825`}, {
            411.1136363636364, 255.8063241106719}, {411.2087869479973, 
            255.32796982021554`}, {411.4797528871532, 254.92244063418872`}, {
            411.88528207318, 254.6514746950328}, {412.3636363636364, 
            254.5563241106719}, {412.84199065409274`, 254.6514746950328}, {
            413.24751984011954`, 254.92244063418872`}, {413.51848577927547`, 
            255.32796982021554`}, {413.6136363636364, 255.8063241106719}}]}}}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQvaJbb9eLRcYOHBGy8ackPB2WgPnODnErDpxQ2Bfi
UHLRVTy2xNfh1qP+k3d8o6HywQ67jp0qYzVNcOgFcbsjHIRzTSv6FJIcSsHq
Yx0qaq+4HWpIdjAASeslOjybUHLgZk4KVH+yQ5TDo0O8f1IcJGJBNqQ5XFF5
pT3dNdWhB2xehkPQ9Yib6xJSHRjAINvh0odfK3pTUqHm5zoEcc2tyMlIdXi1
CGRgvsP5PdxqLc2pDvpg+wodvBYK9/OeTXV4CZLPKHLYF9A40TEmzWEx2P5i
B50URe5Ij3QHsPV3SxxAzutZkQF1T5nDKynt26JTshwugawLLHcw+6D7Vkcp
F+q+CofdYP8XOLgBpS8erXQAO8uxyAEAGrOX2w==
          "]]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{20.791213052002764`, 50.67203017978442}, {
            20.52024711284684, 51.07755936581125}, {20.114717926820017`, 
            51.34852530496717}, {19.636363636363654`, 51.44367588932806}, {
            19.158009345907292`, 51.34852530496717}, {18.75248015988047, 
            51.07755936581125}, {18.481514220724545`, 50.67203017978442}, {
            18.386363636363654`, 50.19367588932806}, {18.481514220724545`, 
            49.715321598871704`}, {18.75248015988047, 49.30979241284488}, {
            19.158009345907292`, 49.03882647368896}, {19.636363636363654`, 
            48.94367588932806}, {20.114717926820017`, 49.03882647368896}, {
            20.52024711284684, 49.30979241284488}, {20.791213052002764`, 
            49.715321598871704`}, {20.886363636363654`, 
            50.19367588932806}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{40.427576688366386`, 83.44910527859864}, {
            40.156610749210465`, 83.85463446462545}, {39.75108156318364, 
            84.12560040378138}, {39.27272727272728, 84.22075098814227}, {
            38.79437298227092, 84.12560040378138}, {38.388843796244096`, 
            83.85463446462545}, {38.117877857088175`, 83.44910527859864}, {
            38.02272727272728, 82.97075098814227}, {38.117877857088175`, 
            82.4923966976859}, {38.388843796244096`, 82.0868675116591}, {
            38.79437298227092, 81.81590157250317}, {39.27272727272728, 
            81.72075098814227}, {39.75108156318364, 81.81590157250317}, {
            40.156610749210465`, 82.0868675116591}, {40.427576688366386`, 
            82.4923966976859}, {40.52272727272728, 82.97075098814227}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{60.06394032473001, 109.69495508097017`}, {
            59.79297438557409, 110.10048426699699`}, {59.387445199547265`, 
            110.37145020615291`}, {58.90909090909091, 110.46660079051381`}, {
            58.43073661863455, 110.37145020615291`}, {58.02520743260772, 
            110.10048426699699`}, {57.7542414934518, 109.69495508097017`}, {
            57.65909090909091, 109.21660079051381`}, {57.7542414934518, 
            108.73824650005744`}, {58.02520743260772, 108.33271731403063`}, {
            58.43073661863455, 108.0617513748747}, {58.90909090909091, 
            107.96660079051381`}, {59.387445199547265`, 108.0617513748747}, {
            59.79297438557409, 108.33271731403063`}, {60.06394032473001, 
            108.73824650005744`}, {60.15909090909091, 
            109.21660079051381`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{79.70030396109367, 130.13527128650378`}, {
            79.42933802193774, 130.5408004725306}, {79.02380883591093, 
            130.81176641168653`}, {78.54545454545456, 130.9069169960474}, {
            78.0671002549982, 130.81176641168653`}, {77.66157106897138, 
            130.5408004725306}, {77.39060512981546, 130.13527128650378`}, {
            77.29545454545456, 129.6569169960474}, {77.39060512981546, 
            129.17856270559105`}, {77.66157106897138, 128.77303351956422`}, {
            78.0671002549982, 128.5020675804083}, {78.54545454545456, 
            128.4069169960474}, {79.02380883591093, 128.5020675804083}, {
            79.42933802193774, 128.77303351956422`}, {79.70030396109367, 
            129.17856270559105`}, {79.79545454545456, 129.6569169960474}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{99.3366675974573, 145.49574559480416`}, {
            99.06570165830138, 145.901274780831}, {98.66017247227457, 
            146.17224071998692`}, {98.1818181818182, 146.2673913043478}, {
            97.70346389136184, 146.17224071998692`}, {97.29793470533502, 
            145.901274780831}, {97.0269687661791, 145.49574559480416`}, {
            96.9318181818182, 145.0173913043478}, {97.0269687661791, 
            144.53903701389143`}, {97.29793470533502, 144.1335078278646}, {
            97.70346389136184, 143.86254188870868`}, {98.1818181818182, 
            143.7673913043478}, {98.66017247227457, 143.86254188870868`}, {
            99.06570165830138, 144.1335078278646}, {99.3366675974573, 
            144.53903701389143`}, {99.4318181818182, 145.0173913043478}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{118.97303123382093`, 156.50206970547612`}, {
            118.702065294665, 156.90759889150294`}, {118.2965361086382, 
            157.17856483065887`}, {117.81818181818183`, 
            157.27371541501975`}, {117.33982752772546`, 
            157.17856483065887`}, {116.93429834169865`, 
            156.90759889150294`}, {116.66333240254272`, 
            156.50206970547612`}, {116.56818181818183`, 
            156.02371541501975`}, {116.66333240254272`, 
            155.54536112456339`}, {116.93429834169865`, 
            155.13983193853656`}, {117.33982752772546`, 
            154.86886599938063`}, {117.81818181818183`, 
            154.77371541501975`}, {118.2965361086382, 154.86886599938063`}, {
            118.702065294665, 155.13983193853656`}, {118.97303123382093`, 
            155.54536112456339`}, {119.06818181818183`, 
            156.02371541501975`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{138.60939487018462`, 163.87993531812435`}, {
            138.3384289310287, 164.28546450415118`}, {137.93289974500186`, 
            164.5564304433071}, {137.4545454545455, 164.651581027668}, {
            136.97619116408913`, 164.5564304433071}, {136.5706619780623, 
            164.28546450415118`}, {136.29969603890638`, 
            163.87993531812435`}, {136.2045454545455, 163.401581027668}, {
            136.29969603890638`, 162.92322673721162`}, {136.5706619780623, 
            162.5176975511848}, {136.97619116408913`, 162.24673161202887`}, {
            137.4545454545455, 162.151581027668}, {137.93289974500186`, 
            162.24673161202887`}, {138.3384289310287, 162.5176975511848}, {
            138.60939487018462`, 162.92322673721162`}, {138.7045454545455, 
            163.401581027668}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{158.24575850654824`, 168.35503413235358`}, {
            157.9747925673923, 168.7605633183804}, {157.5692633813655, 
            169.03152925753633`}, {157.09090909090912`, 
            169.12667984189721`}, {156.61255480045276`, 
            169.03152925753633`}, {156.20702561442593`, 168.7605633183804}, {
            155.93605967527, 168.35503413235358`}, {155.84090909090912`, 
            167.87667984189721`}, {155.93605967527, 167.39832555144085`}, {
            156.20702561442593`, 166.99279636541402`}, {156.61255480045276`, 
            166.7218304262581}, {157.09090909090912`, 166.62667984189721`}, {
            157.5692633813655, 166.7218304262581}, {157.9747925673923, 
            166.99279636541402`}, {158.24575850654824`, 
            167.39832555144085`}, {158.34090909090912`, 
            167.87667984189721`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{177.88212214291187`, 170.6530578477686}, {
            177.61115620375594`, 171.05858703379542`}, {177.2056270177291, 
            171.32955297295135`}, {176.72727272727275`, 
            171.42470355731223`}, {176.24891843681638`, 
            171.32955297295135`}, {175.84338925078956`, 
            171.05858703379542`}, {175.57242331163363`, 170.6530578477686}, {
            175.47727272727275`, 170.17470355731223`}, {175.57242331163363`, 
            169.69634926685586`}, {175.84338925078956`, 
            169.29082008082904`}, {176.24891843681638`, 169.0198541416731}, {
            176.72727272727275`, 168.92470355731223`}, {177.2056270177291, 
            169.0198541416731}, {177.61115620375594`, 169.29082008082904`}, {
            177.88212214291187`, 169.69634926685586`}, {177.97727272727275`, 
            170.17470355731223`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{197.5184857792755, 171.49969816397413`}, {
            197.24751984011957`, 171.90522735000096`}, {196.84199065409274`, 
            172.17619328915688`}, {196.36363636363637`, 
            172.27134387351776`}, {195.88528207318, 172.17619328915688`}, {
            195.47975288715318`, 171.90522735000096`}, {195.20878694799725`, 
            171.49969816397413`}, {195.11363636363637`, 
            171.02134387351776`}, {195.20878694799725`, 170.5429895830614}, {
            195.47975288715318`, 170.13746039703457`}, {195.88528207318, 
            169.86649445787864`}, {196.36363636363637`, 
            169.77134387351776`}, {196.84199065409274`, 
            169.86649445787864`}, {197.24751984011957`, 
            170.13746039703457`}, {197.5184857792755, 170.5429895830614}, {
            197.61363636363637`, 171.02134387351776`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{217.15484941563912`, 171.62064678057493`}, {
            216.8838834764832, 172.02617596660176`}, {216.47835429045637`, 
            172.29714190575768`}, {216., 172.39229249011856`}, {
            215.52164570954363`, 172.29714190575768`}, {215.1161165235168, 
            172.02617596660176`}, {214.84515058436088`, 
            171.62064678057493`}, {214.75, 171.14229249011856`}, {
            214.84515058436088`, 170.6639381996622}, {215.1161165235168, 
            170.25840901363537`}, {215.52164570954363`, 
            169.98744307447944`}, {216., 169.89229249011856`}, {
            216.47835429045637`, 169.98744307447944`}, {216.8838834764832, 
            170.25840901363537`}, {217.15484941563912`, 170.6639381996622}, {
            217.25, 171.14229249011856`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{236.79121305200277`, 171.74159539717573`}, {
            236.52024711284685`, 172.14712458320255`}, {236.11471792682002`, 
            172.41809052235848`}, {235.63636363636365`, 
            172.51324110671936`}, {235.1580093459073, 172.41809052235848`}, {
            234.75248015988046`, 172.14712458320255`}, {234.48151422072453`, 
            171.74159539717573`}, {234.38636363636365`, 
            171.26324110671936`}, {234.48151422072453`, 170.784886816263}, {
            234.75248015988046`, 170.37935763023617`}, {235.1580093459073, 
            170.10839169108024`}, {235.63636363636365`, 
            170.01324110671936`}, {236.11471792682002`, 
            170.10839169108024`}, {236.52024711284685`, 
            170.37935763023617`}, {236.79121305200277`, 170.784886816263}, {
            236.88636363636365`, 171.26324110671936`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{256.4275766883664, 172.58823571338124`}, {
            256.1566107492105, 172.99376489940806`}, {255.75108156318367`, 
            173.264730838564}, {255.2727272727273, 173.35988142292487`}, {
            254.79437298227094`, 173.264730838564}, {254.38884379624412`, 
            172.99376489940806`}, {254.1178778570882, 172.58823571338124`}, {
            254.0227272727273, 172.10988142292487`}, {254.1178778570882, 
            171.6315271324685}, {254.38884379624412`, 171.22599794644168`}, {
            254.79437298227094`, 170.95503200728575`}, {255.2727272727273, 
            170.85988142292487`}, {255.75108156318367`, 
            170.95503200728575`}, {256.1566107492105, 171.22599794644168`}, {
            256.4275766883664, 171.6315271324685}, {256.5227272727273, 
            172.10988142292487`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{276.06394032473, 174.88625942879628`}, {
            275.7929743855741, 175.2917886148231}, {275.3874451995473, 
            175.56275455397903`}, {274.90909090909093`, 175.6579051383399}, {
            274.43073661863457`, 175.56275455397903`}, {274.0252074326078, 
            175.2917886148231}, {273.75424149345184`, 174.88625942879628`}, {
            273.65909090909093`, 174.4079051383399}, {273.75424149345184`, 
            173.92955084788355`}, {274.0252074326078, 173.52402166185672`}, {
            274.43073661863457`, 173.2530557227008}, {274.90909090909093`, 
            173.1579051383399}, {275.3874451995473, 173.2530557227008}, {
            275.7929743855741, 173.52402166185672`}, {276.06394032473, 
            173.92955084788355`}, {276.15909090909093`, 
            174.4079051383399}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{295.70030396109365`, 179.3613582430255}, {
            295.4293380219377, 179.76688742905233`}, {295.0238088359109, 
            180.03785336820826`}, {294.54545454545456`, 
            180.13300395256914`}, {294.0671002549982, 180.03785336820826`}, {
            293.6615710689714, 179.76688742905233`}, {293.39060512981547`, 
            179.3613582430255}, {293.29545454545456`, 178.88300395256914`}, {
            293.39060512981547`, 178.40464966211277`}, {293.6615710689714, 
            177.99912047608595`}, {294.0671002549982, 177.72815453693002`}, {
            294.54545454545456`, 177.63300395256914`}, {295.0238088359109, 
            177.72815453693002`}, {295.4293380219377, 177.99912047608595`}, {
            295.70030396109365`, 178.40464966211277`}, {295.79545454545456`, 
            178.88300395256914`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{315.3366675974573, 186.73922385567374`}, {
            315.06570165830135`, 187.14475304170057`}, {314.66017247227455`, 
            187.4157189808565}, {314.1818181818182, 187.51086956521738`}, {
            313.7034638913618, 187.4157189808565}, {313.297934705335, 
            187.14475304170057`}, {313.0269687661791, 186.73922385567374`}, {
            312.9318181818182, 186.26086956521738`}, {313.0269687661791, 
            185.782515274761}, {313.297934705335, 185.37698608873418`}, {
            313.7034638913618, 185.10602014957826`}, {314.1818181818182, 
            185.01086956521738`}, {314.66017247227455`, 
            185.10602014957826`}, {315.06570165830135`, 
            185.37698608873418`}, {315.3366675974573, 185.782515274761}, {
            315.4318181818182, 186.26086956521738`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{334.9730312338209, 197.74554796634567`}, {
            334.702065294665, 198.1510771523725}, {334.2965361086382, 
            198.42204309152842`}, {333.8181818181818, 198.5171936758893}, {
            333.33982752772545`, 198.42204309152842`}, {332.93429834169865`, 
            198.1510771523725}, {332.6633324025427, 197.74554796634567`}, {
            332.5681818181818, 197.2671936758893}, {332.6633324025427, 
            196.78883938543294`}, {332.93429834169865`, 196.3833101994061}, {
            333.33982752772545`, 196.11234426025018`}, {333.8181818181818, 
            196.0171936758893}, {334.2965361086382, 196.11234426025018`}, {
            334.702065294665, 196.3833101994061}, {334.9730312338209, 
            196.78883938543294`}, {335.0681818181818, 197.2671936758893}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{354.6093948701846, 213.10602227464608`}, {
            354.33842893102866`, 213.5115514606729}, {353.93289974500186`, 
            213.78251739982883`}, {353.4545454545455, 213.8776679841897}, {
            352.97619116408913`, 213.78251739982883`}, {352.57066197806233`, 
            213.5115514606729}, {352.2996960389064, 213.10602227464608`}, {
            352.2045454545455, 212.6276679841897}, {352.2996960389064, 
            212.14931369373335`}, {352.57066197806233`, 
            211.74378450770652`}, {352.97619116408913`, 211.4728185685506}, {
            353.4545454545455, 211.3776679841897}, {353.93289974500186`, 
            211.4728185685506}, {354.33842893102866`, 211.74378450770652`}, {
            354.6093948701846, 212.14931369373335`}, {354.7045454545455, 
            212.6276679841897}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{374.2457585065482, 233.54633848017966`}, {
            373.9747925673923, 233.95186766620648`}, {373.5692633813655, 
            234.2228336053624}, {373.0909090909091, 234.3179841897233}, {
            372.61255480045276`, 234.2228336053624}, {372.20702561442596`, 
            233.95186766620648`}, {371.93605967527003`, 
            233.54633848017966`}, {371.8409090909091, 233.0679841897233}, {
            371.93605967527003`, 232.58962989926692`}, {372.20702561442596`, 
            232.1841007132401}, {372.61255480045276`, 231.91313477408417`}, {
            373.0909090909091, 231.8179841897233}, {373.5692633813655, 
            231.91313477408417`}, {373.9747925673923, 232.1841007132401}, {
            374.2457585065482, 232.58962989926692`}, {374.3409090909091, 
            233.0679841897233}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{393.88212214291184`, 259.79218828255125`}, {
            393.6111562037559, 260.19771746857805`}, {393.2056270177291, 
            260.468683407734}, {392.72727272727275`, 260.5638339920949}, {
            392.2489184368164, 260.468683407734}, {391.8433892507896, 
            260.19771746857805`}, {391.57242331163366`, 
            259.79218828255125`}, {391.47727272727275`, 259.3138339920949}, {
            391.57242331163366`, 258.8354797016385}, {391.8433892507896, 
            258.4299505156117}, {392.2489184368164, 258.1589845764558}, {
            392.72727272727275`, 258.0638339920949}, {393.2056270177291, 
            258.1589845764558}, {393.6111562037559, 258.4299505156117}, {
            393.88212214291184`, 258.8354797016385}, {393.97727272727275`, 
            259.3138339920949}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{413.51848577927547`, 292.56926338136543`}, {
            413.24751984011954`, 292.9747925673922}, {412.84199065409274`, 
            293.24575850654816`}, {412.3636363636364, 293.34090909090907`}, {
            411.88528207318, 293.24575850654816`}, {411.4797528871532, 
            292.9747925673922}, {411.2087869479973, 292.56926338136543`}, {
            411.1136363636364, 292.09090909090907`}, {411.2087869479973, 
            291.6125548004527}, {411.4797528871532, 291.2070256144259}, {
            411.88528207318, 290.93605967527}, {412.3636363636364, 
            290.84090909090907`}, {412.84199065409274`, 290.93605967527}, {
            413.24751984011954`, 291.2070256144259}, {413.51848577927547`, 
            291.6125548004527}, {413.6136363636364, 292.09090909090907`}}]}}}},
       Frame->False,
       ImageSize->{432., 306.},
       PlotRange->{{0., 432.}, {0., 306.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {0., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{1.845, 1.814229249011845}, {0., 1.814229249011845}}], 
         LineBox[{{3.69, 13.909090909090907`}, {0., 13.909090909090907`}}], 
         LineBox[{{1.845, 26.003952569169954`}, {0., 26.003952569169954`}}], 
         LineBox[{{1.845, 38.098814229249}, {0., 38.098814229249}}], 
         LineBox[{{1.845, 50.19367588932806}, {0., 50.19367588932806}}], 
         LineBox[{{1.845, 62.28853754940711}, {0., 62.28853754940711}}], 
         LineBox[{{3.69, 74.38339920948616}, {0., 74.38339920948616}}], 
         LineBox[{{1.845, 86.4782608695652}, {0., 86.4782608695652}}], 
         LineBox[{{1.845, 98.57312252964425}, {0., 98.57312252964425}}], 
         LineBox[{{1.845, 110.66798418972331`}, {0., 110.66798418972331`}}], 
         LineBox[{{1.845, 122.76284584980236`}, {0., 122.76284584980236`}}], 
         LineBox[{{3.69, 134.8577075098814}, {0., 134.8577075098814}}], 
         LineBox[{{1.845, 146.95256916996047`}, {0., 146.95256916996047`}}], 
         LineBox[{{1.845, 159.0474308300395}, {0., 159.0474308300395}}], 
         LineBox[{{1.845, 171.14229249011856`}, {0., 171.14229249011856`}}], 
         LineBox[{{1.845, 183.23715415019763`}, {0., 183.23715415019763`}}], 
         LineBox[{{3.69, 195.33201581027666`}, {0., 195.33201581027666`}}], 
         LineBox[{{1.845, 207.4268774703557}, {0., 207.4268774703557}}], 
         LineBox[{{1.845, 219.52173913043475`}, {0., 219.52173913043475`}}], 
         LineBox[{{1.845, 231.61660079051381`}, {0., 231.61660079051381`}}], 
         LineBox[{{1.845, 243.71146245059288`}, {0., 243.71146245059288`}}], 
         LineBox[{{3.69, 255.8063241106719}, {0., 255.8063241106719}}], 
         LineBox[{{1.845, 267.901185770751}, {0., 267.901185770751}}], 
         LineBox[{{1.845, 279.99604743083}, {0., 279.99604743083}}], 
         LineBox[{{1.845, 292.0909090909091}, {0., 292.0909090909091}}], 
         LineBox[{{1.845, 304.1857707509881}, {0., 304.1857707509881}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{432., 0.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{430.155, 1.814229249011845}, {432., 1.814229249011845}}], 
         LineBox[{{428.31, 13.909090909090907`}, {432., 
          13.909090909090907`}}], 
         LineBox[{{430.155, 26.003952569169954`}, {432., 
          26.003952569169954`}}], 
         LineBox[{{430.155, 38.098814229249}, {432., 38.098814229249}}], 
         LineBox[{{430.155, 50.19367588932806}, {432., 50.19367588932806}}], 
         LineBox[{{430.155, 62.28853754940711}, {432., 62.28853754940711}}], 
         LineBox[{{428.31, 74.38339920948616}, {432., 74.38339920948616}}], 
         LineBox[{{430.155, 86.4782608695652}, {432., 86.4782608695652}}], 
         LineBox[{{430.155, 98.57312252964425}, {432., 98.57312252964425}}], 
         LineBox[{{430.155, 110.66798418972331`}, {432., 
          110.66798418972331`}}], 
         LineBox[{{430.155, 122.76284584980236`}, {432., 
          122.76284584980236`}}], 
         LineBox[{{428.31, 134.8577075098814}, {432., 134.8577075098814}}], 
         LineBox[{{430.155, 146.95256916996047`}, {432., 
          146.95256916996047`}}], 
         LineBox[{{430.155, 159.0474308300395}, {432., 159.0474308300395}}], 
         LineBox[{{430.155, 171.14229249011856`}, {432., 
          171.14229249011856`}}], 
         LineBox[{{430.155, 183.23715415019763`}, {432., 
          183.23715415019763`}}], 
         LineBox[{{428.31, 195.33201581027666`}, {432., 
          195.33201581027666`}}], 
         LineBox[{{430.155, 207.4268774703557}, {432., 207.4268774703557}}], 
         LineBox[{{430.155, 219.52173913043475`}, {432., 
          219.52173913043475`}}], 
         LineBox[{{430.155, 231.61660079051381`}, {432., 
          231.61660079051381`}}], 
         LineBox[{{430.155, 243.71146245059288`}, {432., 
          243.71146245059288`}}], 
         LineBox[{{428.31, 255.8063241106719}, {432., 255.8063241106719}}], 
         LineBox[{{430.155, 267.901185770751}, {432., 267.901185770751}}], 
         LineBox[{{430.155, 279.99604743083}, {432., 279.99604743083}}], 
         LineBox[{{430.155, 292.0909090909091}, {432., 292.0909090909091}}], 
         LineBox[{{430.155, 304.1857707509881}, {432., 304.1857707509881}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {432., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{19.636363636363654`, 3.69}, {19.636363636363654`, 0.}}], 
         LineBox[{{39.27272727272728, 1.845}, {39.27272727272728, 0.}}], 
         LineBox[{{58.90909090909091, 1.845}, {58.90909090909091, 0.}}], 
         LineBox[{{78.54545454545456, 1.845}, {78.54545454545456, 0.}}], 
         LineBox[{{98.1818181818182, 1.845}, {98.1818181818182, 0.}}], 
         LineBox[{{117.81818181818183`, 3.69}, {117.81818181818183`, 0.}}], 
         LineBox[{{137.45454545454544`, 1.845}, {137.45454545454544`, 0.}}], 
         LineBox[{{157.0909090909091, 1.845}, {157.0909090909091, 0.}}], 
         LineBox[{{176.72727272727275`, 1.845}, {176.72727272727275`, 0.}}], 
         LineBox[{{196.36363636363637`, 1.845}, {196.36363636363637`, 0.}}], 
         LineBox[{{216., 3.69}, {216., 0.}}], 
         LineBox[{{235.63636363636363`, 1.845}, {235.63636363636363`, 0.}}], 
         LineBox[{{255.27272727272728`, 1.845}, {255.27272727272728`, 0.}}], 
         LineBox[{{274.90909090909093`, 1.845}, {274.90909090909093`, 0.}}], 
         LineBox[{{294.54545454545456`, 1.845}, {294.54545454545456`, 0.}}], 
         LineBox[{{314.1818181818182, 3.69}, {314.1818181818182, 0.}}], 
         LineBox[{{333.8181818181818, 1.845}, {333.8181818181818, 0.}}], 
         LineBox[{{353.45454545454544`, 1.845}, {353.45454545454544`, 0.}}], 
         LineBox[{{373.0909090909091, 1.845}, {373.0909090909091, 0.}}], 
         LineBox[{{392.72727272727275`, 1.845}, {392.72727272727275`, 0.}}], 
         LineBox[{{412.3636363636364, 3.69}, {412.3636363636364, 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 306.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{19.636363636363654`, 302.31}, {19.636363636363654`, 
          306.}}], 
         LineBox[{{39.27272727272728, 304.155}, {39.27272727272728, 306.}}], 
         LineBox[{{58.90909090909091, 304.155}, {58.90909090909091, 306.}}], 
         LineBox[{{78.54545454545456, 304.155}, {78.54545454545456, 306.}}], 
         LineBox[{{98.1818181818182, 304.155}, {98.1818181818182, 306.}}], 
         LineBox[{{117.81818181818183`, 302.31}, {117.81818181818183`, 
          306.}}], 
         LineBox[{{137.45454545454544`, 304.155}, {137.45454545454544`, 
          306.}}], 
         LineBox[{{157.0909090909091, 304.155}, {157.0909090909091, 306.}}], 
         LineBox[{{176.72727272727275`, 304.155}, {176.72727272727275`, 
          306.}}], 
         LineBox[{{196.36363636363637`, 304.155}, {196.36363636363637`, 
          306.}}], LineBox[{{216., 302.31}, {216., 306.}}], 
         LineBox[{{235.63636363636363`, 304.155}, {235.63636363636363`, 
          306.}}], 
         LineBox[{{255.27272727272728`, 304.155}, {255.27272727272728`, 
          306.}}], 
         LineBox[{{274.90909090909093`, 304.155}, {274.90909090909093`, 
          306.}}], 
         LineBox[{{294.54545454545456`, 304.155}, {294.54545454545456`, 
          306.}}], 
         LineBox[{{314.1818181818182, 302.31}, {314.1818181818182, 306.}}], 
         LineBox[{{333.8181818181818, 304.155}, {333.8181818181818, 306.}}], 
         LineBox[{{353.45454545454544`, 304.155}, {353.45454545454544`, 
          306.}}], 
         LineBox[{{373.0909090909091, 304.155}, {373.0909090909091, 306.}}], 
         LineBox[{{392.72727272727275`, 304.155}, {392.72727272727275`, 
          306.}}], 
         LineBox[{{412.3636363636364, 302.31}, {412.3636363636364, 306.}}]}, 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-1.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 13.909090909090907`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 74.38339920948616}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 134.8577075098814}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 195.33201581027666`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 255.8063241106719}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"y\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" (m)\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-29., 306.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-1.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {19.636363636363654`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {117.81818181818183`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {216., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {314.1818181818182, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {412.3636363636364, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"t\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" (s)\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -15.}, {0, 1}, Automatic, {1., 0.}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-1.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 13.909090909090907`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 74.38339920948616}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 134.8577075098814}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 195.33201581027666`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 255.8063241106719}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"y\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" (m)\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-29., 306.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-1.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {19.636363636363654`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {117.81818181818183`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {216., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {314.1818181818182, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {412.3636363636364, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"t\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" (s)\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -15.}, {0, 1}, Automatic, {1., 0.}]},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->0.78125,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{576, 450.},
  PlotRange->{{-72, 504}, {-72., 378.}}]], "Output",
 CellChangeTimes->{{3.51846692890625*^9, 3.51846694596875*^9}, {
   3.5184670433125*^9, 3.518467082171875*^9}, 3.518468641890625*^9, 
   3.51846867246875*^9, 3.5185623831735*^9, {3.518562617970375*^9, 
   3.51856262645475*^9}, {3.5185626596735*^9, 3.51856267264225*^9}, 
   3.52027852715625*^9, 3.520278714*^9, 3.524748115265625*^9, 
   3.5663388276859884`*^9, 3.5791218992997017`*^9, 3.584376190877886*^9, 
   3.5930109604943624`*^9, 3.5943050945041275`*^9}]
}, Open  ]],

Cell["\<\
Here is an aside comment illustrating the importance of \
\[OpenCurlyDoubleQuote]layers\[CloseCurlyDoubleQuote] in figure generation\
\>", "Text",
 CellChangeTimes->{{3.518468419453125*^9, 3.51846844984375*^9}, {
  3.518562392845375*^9, 3.518562426486*^9}, {3.520947793*^9, 
  3.52094782984375*^9}, {3.5843762234947433`*^9, 3.5843762275195503`*^9}}],

Cell["\<\
This is an example which illustrates how layers are so helpful.  Usually, \
line/fill objects appear in layer 1.  However, DataFill has default Layer->0, \
as noted in the reference manual. Let us inspect now the unfortunate \
consequences which would have occured if we did not have layering.  This is \
replicated by putting the DataFill in layer 1, along with everything else.  \
We see that the DataFill would obstruct the lower curve\[CloseCurlyQuote]s \
points, as shown below, and even half of the lower curve\[CloseCurlyQuote]s \
line, which therefore appears unnaturally thin!\
\>", "Text",
 CellChangeTimes->{{3.518562430907875*^9, 3.51856257664225*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{
         "DataPlot", "\[LeftDoubleBracket]", "\"\<p1\>\"", 
          "\[RightDoubleBracket]"}], "[", "DataForFill", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "DataPlot", "\[LeftDoubleBracket]", "\"\<p2\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"DataForFill2", ",", 
          RowBox[{"DataFill", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Filling", "\[Rule]", "\"\<p1\>\""}], ",", 
             RowBox[{"FillColor", "\[Rule]", "Moccasin"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"Layer", "\[Rule]", "Automatic"}]}], " ", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{
              "HOW", " ", "THIS", " ", "PLOT", " ", "WOULD", " ", "WORK", " ",
                "IN", " ", "A", " ", "LESS", " ", "HAPPY", " ", "PARALLEL", 
               " ", "UNIVERSE", " ", "WITHOUT", " ", "Layer"}], "\[Rule]", 
              RowBox[{"0", " ", "FOR", " ", 
               RowBox[{"DataFill", "!!"}]}]}], " ", "*)"}], 
            "\[IndentingNewLine]", "}"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"FigArrow", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"DisplaceHead", "[", 
             RowBox[{"Canvas", "[", 
              RowBox[{"{", 
               RowBox[{"40", ",", 
                RowBox[{"-", "40"}]}], "}"}], "]"}], "]"}], ",", 
            RowBox[{"FigAnchor", "[", 
             RowBox[{"\"\<p1\>\"", ",", "Center"}], "]"}]}], "}"}], ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<Ugly, no?\>\""}], ",", 
          RowBox[{"TextOrientation", "\[Rule]", "Horizontal"}], ",", 
          RowBox[{"TextOffset", "\[Rule]", "TopLeft"}]}], "]"}], ";"}], 
       "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "1.3"}], "}"}]}], "}"}]}], ",", 
      RowBox[{"ExtendRange", "\[Rule]", "0.05"}]}], "\[IndentingNewLine]", 
     "]"}], "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Style", "->", "\"\<ExampleDataFigure\>\""}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.518118989375*^9, 3.51811900096875*^9}, {
   3.518119070828125*^9, 3.518119080140625*^9}, 3.518434829484375*^9, {
   3.518434975890625*^9, 3.51843500028125*^9}, {3.5184377235*^9, 
   3.518437729046875*^9}, 3.518438256265625*^9, {3.51843828675*^9, 
   3.518438315203125*^9}, 3.5184383755*^9, {3.51843951065625*^9, 
   3.51843951134375*^9}, {3.5184634049375*^9, 3.51846340696875*^9}, 
   3.518464317515625*^9, {3.51846435009375*^9, 3.518464368390625*^9}, {
   3.5184645371875*^9, 3.518464557*^9}, {3.518464794203125*^9, 
   3.51846479571875*^9}, {3.518465025515625*^9, 3.518465026484375*^9}, {
   3.5184650614375*^9, 3.5184650675*^9}, {3.5184651670625*^9, 
   3.518465178015625*^9}, {3.518466446140625*^9, 3.51846653075*^9}, {
   3.518466656234375*^9, 3.5184666735625*^9}, {3.518466839125*^9, 
   3.518466945625*^9}, {3.518467059203125*^9, 3.518467081875*^9}, {
   3.5184686338125*^9, 3.51846867084375*^9}, 3.518468702140625*^9, {
   3.518562617064125*^9, 3.51856262601725*^9}, 3.518562658939125*^9, {
   3.566338818871973*^9, 3.5663388274207883`*^9}, {3.584376153047819*^9, 
   3.584376189442683*^9}, {3.584376234984563*^9, 3.584376237792568*^9}, {
   3.584376269476224*^9, 3.5843764177472506`*^9}, 3.594305096797331*^9, 
   3.625454738832388*^9}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {432., 306.}]}, InsetBox[
      GraphicsBox[{
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQvaJbb9eLRcYOF1zFY0suajssAfOdHTROrfS8Eu7u
UHIRJOHrMEF+ieoy6yCofLCDDlg+3KEXxO2OcLgrVu/zTC/aoRSsPtZhmfne
l77vYx0MQNJ6iQ6NcX/v1ByPh+pPdtga96bgU1GCg0QsyIY0B33nLzer9yQ4
9IDNy3BY+zWpffL1BAcGMMh20OVnDS+6nQA1P9dhrcZytcD7CQ6vFoEMzHfQ
vi16JeNXgoM+2L5Ch6X7ZW0/OSc6vATJZxQ5SOV326tdTnRYDLa/2KG9SXun
7f4kB7D1d0sc3kw61V4onwJ1T5mDm6Vp5y+uNIdLIOsCyx0m8VnMFpyZAXVf
hcOF1fNnv3+Q7eAGCrajlQ5/V1pknP2Z7wAApyCbng==
          "]]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{20.791213052002764`, 14.387445199547269`}, {
            20.52024711284684, 14.792974385574091`}, {20.114717926820017`, 
            15.063940324730016`}, {19.636363636363654`, 
            15.159090909090907`}, {19.158009345907292`, 
            15.063940324730016`}, {18.75248015988047, 14.792974385574091`}, {
            18.481514220724545`, 14.387445199547269`}, {18.386363636363654`, 
            13.909090909090907`}, {18.481514220724545`, 
            13.430736618634544`}, {18.75248015988047, 13.025207432607722`}, {
            19.158009345907292`, 12.754241493451797`}, {19.636363636363654`, 
            12.659090909090907`}, {20.114717926820017`, 
            12.754241493451797`}, {20.52024711284684, 13.025207432607722`}, {
            20.791213052002764`, 13.430736618634544`}, {20.886363636363654`, 
            13.909090909090907`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{40.427576688366386`, 47.164520298361474`}, {
            40.156610749210465`, 47.5700494843883}, {39.75108156318364, 
            47.84101542354422}, {39.27272727272728, 47.936166007905115`}, {
            38.79437298227092, 47.84101542354422}, {38.388843796244096`, 
            47.5700494843883}, {38.117877857088175`, 47.164520298361474`}, {
            38.02272727272728, 46.686166007905115`}, {38.117877857088175`, 
            46.207811717448756`}, {38.388843796244096`, 45.80228253142193}, {
            38.79437298227092, 45.53131659226601}, {39.27272727272728, 
            45.436166007905115`}, {39.75108156318364, 45.53131659226601}, {
            40.156610749210465`, 45.80228253142193}, {40.427576688366386`, 
            46.207811717448756`}, {40.52272727272728, 
            46.686166007905115`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{60.06394032473001, 73.41037010073302}, {
            59.79297438557409, 73.81589928675983}, {59.387445199547265`, 
            74.08686522591576}, {58.90909090909091, 74.18201581027665}, {
            58.43073661863455, 74.08686522591576}, {58.02520743260772, 
            73.81589928675983}, {57.7542414934518, 73.41037010073302}, {
            57.65909090909091, 72.93201581027665}, {57.7542414934518, 
            72.45366151982029}, {58.02520743260772, 72.04813233379348}, {
            58.43073661863455, 71.77716639463755}, {58.90909090909091, 
            71.68201581027665}, {59.387445199547265`, 71.77716639463755}, {
            59.79297438557409, 72.04813233379348}, {60.06394032473001, 
            72.45366151982029}, {60.15909090909091, 72.93201581027665}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{79.70030396109367, 93.85068630626665}, {
            79.42933802193774, 94.25621549229346}, {79.02380883591093, 
            94.52718143144939}, {78.54545454545456, 94.62233201581029}, {
            78.0671002549982, 94.52718143144939}, {77.66157106897138, 
            94.25621549229346}, {77.39060512981546, 93.85068630626665}, {
            77.29545454545456, 93.37233201581029}, {77.39060512981546, 
            92.89397772535392}, {77.66157106897138, 92.48844853932711}, {
            78.0671002549982, 92.21748260017118}, {78.54545454545456, 
            92.12233201581029}, {79.02380883591093, 92.21748260017118}, {
            79.42933802193774, 92.48844853932711}, {79.70030396109367, 
            92.89397772535392}, {79.79545454545456, 93.37233201581029}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{99.3366675974573, 109.21116061456702`}, {
            99.06570165830138, 109.61668980059383`}, {98.66017247227457, 
            109.88765573974976`}, {98.1818181818182, 109.98280632411065`}, {
            97.70346389136184, 109.88765573974976`}, {97.29793470533502, 
            109.61668980059383`}, {97.0269687661791, 109.21116061456702`}, {
            96.9318181818182, 108.73280632411065`}, {97.0269687661791, 
            108.25445203365429`}, {97.29793470533502, 107.84892284762748`}, {
            97.70346389136184, 107.57795690847155`}, {98.1818181818182, 
            107.48280632411065`}, {98.66017247227457, 107.57795690847155`}, {
            99.06570165830138, 107.84892284762748`}, {99.3366675974573, 
            108.25445203365429`}, {99.4318181818182, 
            108.73280632411065`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{118.97303123382093`, 120.21748472523896`}, {
            118.702065294665, 120.62301391126577`}, {118.2965361086382, 
            120.8939798504217}, {117.81818181818183`, 120.9891304347826}, {
            117.33982752772546`, 120.8939798504217}, {116.93429834169865`, 
            120.62301391126577`}, {116.66333240254272`, 
            120.21748472523896`}, {116.56818181818183`, 119.7391304347826}, {
            116.66333240254272`, 119.26077614432623`}, {116.93429834169865`, 
            118.85524695829942`}, {117.33982752772546`, 
            118.58428101914349`}, {117.81818181818183`, 118.4891304347826}, {
            118.2965361086382, 118.58428101914349`}, {118.702065294665, 
            118.85524695829942`}, {118.97303123382093`, 
            119.26077614432623`}, {119.06818181818183`, 
            119.7391304347826}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{138.60939487018462`, 127.59535033788718`}, {
            138.3384289310287, 128.000879523914}, {137.93289974500186`, 
            128.27184546306992`}, {137.4545454545455, 128.3669960474308}, {
            136.97619116408913`, 128.27184546306992`}, {136.5706619780623, 
            128.000879523914}, {136.29969603890638`, 127.59535033788718`}, {
            136.2045454545455, 127.11699604743082`}, {136.29969603890638`, 
            126.63864175697445`}, {136.5706619780623, 126.23311257094764`}, {
            136.97619116408913`, 125.96214663179171`}, {137.4545454545455, 
            125.86699604743082`}, {137.93289974500186`, 
            125.96214663179171`}, {138.3384289310287, 126.23311257094764`}, {
            138.60939487018462`, 126.63864175697445`}, {138.7045454545455, 
            127.11699604743082`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{158.24575850654824`, 132.07044915211642`}, {
            157.9747925673923, 132.47597833814325`}, {157.5692633813655, 
            132.74694427729918`}, {157.09090909090912`, 
            132.84209486166006`}, {156.61255480045276`, 
            132.74694427729918`}, {156.20702561442593`, 
            132.47597833814325`}, {155.93605967527, 132.07044915211642`}, {
            155.84090909090912`, 131.59209486166006`}, {155.93605967527, 
            131.1137405712037}, {156.20702561442593`, 130.70821138517687`}, {
            156.61255480045276`, 130.43724544602094`}, {157.09090909090912`, 
            130.34209486166006`}, {157.5692633813655, 130.43724544602094`}, {
            157.9747925673923, 130.70821138517687`}, {158.24575850654824`, 
            131.1137405712037}, {158.34090909090912`, 
            131.59209486166006`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{177.88212214291187`, 134.36847286753144`}, {
            177.61115620375594`, 134.77400205355826`}, {177.2056270177291, 
            135.0449679927142}, {176.72727272727275`, 135.14011857707507`}, {
            176.24891843681638`, 135.0449679927142}, {175.84338925078956`, 
            134.77400205355826`}, {175.57242331163363`, 
            134.36847286753144`}, {175.47727272727275`, 
            133.89011857707507`}, {175.57242331163363`, 133.4117642866187}, {
            175.84338925078956`, 133.00623510059188`}, {176.24891843681638`, 
            132.73526916143595`}, {176.72727272727275`, 
            132.64011857707507`}, {177.2056270177291, 132.73526916143595`}, {
            177.61115620375594`, 133.00623510059188`}, {177.88212214291187`, 
            133.4117642866187}, {177.97727272727275`, 
            133.89011857707507`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{197.5184857792755, 135.21511318373697`}, {
            197.24751984011957`, 135.6206423697638}, {196.84199065409274`, 
            135.89160830891973`}, {196.36363636363637`, 135.9867588932806}, {
            195.88528207318, 135.89160830891973`}, {195.47975288715318`, 
            135.6206423697638}, {195.20878694799725`, 135.21511318373697`}, {
            195.11363636363637`, 134.7367588932806}, {195.20878694799725`, 
            134.25840460282424`}, {195.47975288715318`, 
            133.85287541679742`}, {195.88528207318, 133.5819094776415}, {
            196.36363636363637`, 133.4867588932806}, {196.84199065409274`, 
            133.5819094776415}, {197.24751984011957`, 133.85287541679742`}, {
            197.5184857792755, 134.25840460282424`}, {197.61363636363637`, 
            134.7367588932806}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{217.15484941563912`, 135.33606180033777`}, {
            216.8838834764832, 135.7415909863646}, {216.47835429045637`, 
            136.01255692552053`}, {216., 136.1077075098814}, {
            215.52164570954363`, 136.01255692552053`}, {215.1161165235168, 
            135.7415909863646}, {214.84515058436088`, 135.33606180033777`}, {
            214.75, 134.8577075098814}, {214.84515058436088`, 
            134.37935321942504`}, {215.1161165235168, 133.97382403339822`}, {
            215.52164570954363`, 133.7028580942423}, {216., 
            133.6077075098814}, {216.47835429045637`, 133.7028580942423}, {
            216.8838834764832, 133.97382403339822`}, {217.15484941563912`, 
            134.37935321942504`}, {217.25, 134.8577075098814}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{236.79121305200277`, 135.45701041693857`}, {
            236.52024711284685`, 135.8625396029654}, {236.11471792682002`, 
            136.13350554212133`}, {235.63636363636365`, 136.2286561264822}, {
            235.1580093459073, 136.13350554212133`}, {234.75248015988046`, 
            135.8625396029654}, {234.48151422072453`, 135.45701041693857`}, {
            234.38636363636365`, 134.9786561264822}, {234.48151422072453`, 
            134.50030183602584`}, {234.75248015988046`, 
            134.09477264999902`}, {235.1580093459073, 133.8238067108431}, {
            235.63636363636365`, 133.7286561264822}, {236.11471792682002`, 
            133.8238067108431}, {236.52024711284685`, 134.09477264999902`}, {
            236.79121305200277`, 134.50030183602584`}, {236.88636363636365`, 
            134.9786561264822}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{256.4275766883664, 136.3036507331441}, {
            256.1566107492105, 136.70917991917094`}, {255.75108156318367`, 
            136.98014585832686`}, {255.2727272727273, 137.07529644268774`}, {
            254.79437298227094`, 136.98014585832686`}, {254.38884379624412`, 
            136.70917991917094`}, {254.1178778570882, 136.3036507331441}, {
            254.0227272727273, 135.82529644268774`}, {254.1178778570882, 
            135.34694215223138`}, {254.38884379624412`, 
            134.94141296620455`}, {254.79437298227094`, 
            134.67044702704862`}, {255.2727272727273, 134.57529644268774`}, {
            255.75108156318367`, 134.67044702704862`}, {256.1566107492105, 
            134.94141296620455`}, {256.4275766883664, 135.34694215223138`}, {
            256.5227272727273, 135.82529644268774`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{276.06394032473, 138.60167444855912`}, {
            275.7929743855741, 139.00720363458595`}, {275.3874451995473, 
            139.27816957374188`}, {274.90909090909093`, 
            139.37332015810276`}, {274.43073661863457`, 
            139.27816957374188`}, {274.0252074326078, 139.00720363458595`}, {
            273.75424149345184`, 138.60167444855912`}, {273.65909090909093`, 
            138.12332015810276`}, {273.75424149345184`, 137.6449658676464}, {
            274.0252074326078, 137.23943668161957`}, {274.43073661863457`, 
            136.96847074246364`}, {274.90909090909093`, 
            136.87332015810276`}, {275.3874451995473, 136.96847074246364`}, {
            275.7929743855741, 137.23943668161957`}, {276.06394032473, 
            137.6449658676464}, {276.15909090909093`, 
            138.12332015810276`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{295.70030396109365`, 143.07677326278838`}, {
            295.4293380219377, 143.4823024488152}, {295.0238088359109, 
            143.75326838797113`}, {294.54545454545456`, 143.848418972332}, {
            294.0671002549982, 143.75326838797113`}, {293.6615710689714, 
            143.4823024488152}, {293.39060512981547`, 143.07677326278838`}, {
            293.29545454545456`, 142.598418972332}, {293.39060512981547`, 
            142.12006468187565`}, {293.6615710689714, 141.71453549584882`}, {
            294.0671002549982, 141.4435695566929}, {294.54545454545456`, 
            141.348418972332}, {295.0238088359109, 141.4435695566929}, {
            295.4293380219377, 141.71453549584882`}, {295.70030396109365`, 
            142.12006468187565`}, {295.79545454545456`, 
            142.598418972332}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{315.3366675974573, 150.4546388754366}, {
            315.06570165830135`, 150.8601680614634}, {314.66017247227455`, 
            151.13113400061934`}, {314.1818181818182, 151.22628458498022`}, {
            313.7034638913618, 151.13113400061934`}, {313.297934705335, 
            150.8601680614634}, {313.0269687661791, 150.4546388754366}, {
            312.9318181818182, 149.97628458498022`}, {313.0269687661791, 
            149.49793029452385`}, {313.297934705335, 149.09240110849703`}, {
            313.7034638913618, 148.8214351693411}, {314.1818181818182, 
            148.72628458498022`}, {314.66017247227455`, 148.8214351693411}, {
            315.06570165830135`, 149.09240110849703`}, {315.3366675974573, 
            149.49793029452385`}, {315.4318181818182, 
            149.97628458498022`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{334.9730312338209, 161.46096298610854`}, {
            334.702065294665, 161.86649217213537`}, {334.2965361086382, 
            162.1374581112913}, {333.8181818181818, 162.23260869565217`}, {
            333.33982752772545`, 162.1374581112913}, {332.93429834169865`, 
            161.86649217213537`}, {332.6633324025427, 161.46096298610854`}, {
            332.5681818181818, 160.98260869565217`}, {332.6633324025427, 
            160.5042544051958}, {332.93429834169865`, 160.09872521916898`}, {
            333.33982752772545`, 159.82775928001305`}, {333.8181818181818, 
            159.73260869565217`}, {334.2965361086382, 159.82775928001305`}, {
            334.702065294665, 160.09872521916898`}, {334.9730312338209, 
            160.5042544051958}, {335.0681818181818, 160.98260869565217`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{354.6093948701846, 176.82143729440895`}, {
            354.33842893102866`, 177.22696648043578`}, {353.93289974500186`, 
            177.4979324195917}, {353.4545454545455, 177.5930830039526}, {
            352.97619116408913`, 177.4979324195917}, {352.57066197806233`, 
            177.22696648043578`}, {352.2996960389064, 176.82143729440895`}, {
            352.2045454545455, 176.3430830039526}, {352.2996960389064, 
            175.86472871349622`}, {352.57066197806233`, 175.4591995274694}, {
            352.97619116408913`, 175.18823358831347`}, {353.4545454545455, 
            175.0930830039526}, {353.93289974500186`, 175.18823358831347`}, {
            354.33842893102866`, 175.4591995274694}, {354.6093948701846, 
            175.86472871349622`}, {354.7045454545455, 176.3430830039526}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{374.2457585065482, 197.26175349994253`}, {
            373.9747925673923, 197.66728268596935`}, {373.5692633813655, 
            197.93824862512528`}, {373.0909090909091, 198.03339920948616`}, {
            372.61255480045276`, 197.93824862512528`}, {372.20702561442596`, 
            197.66728268596935`}, {371.93605967527003`, 
            197.26175349994253`}, {371.8409090909091, 196.78339920948616`}, {
            371.93605967527003`, 196.3050449190298}, {372.20702561442596`, 
            195.89951573300297`}, {372.61255480045276`, 
            195.62854979384704`}, {373.0909090909091, 195.53339920948616`}, {
            373.5692633813655, 195.62854979384704`}, {373.9747925673923, 
            195.89951573300297`}, {374.2457585065482, 196.3050449190298}, {
            374.3409090909091, 196.78339920948616`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{393.88212214291184`, 223.50760330231407`}, {
            393.6111562037559, 223.9131324883409}, {393.2056270177291, 
            224.18409842749682`}, {392.72727272727275`, 224.2792490118577}, {
            392.2489184368164, 224.18409842749682`}, {391.8433892507896, 
            223.9131324883409}, {391.57242331163366`, 223.50760330231407`}, {
            391.47727272727275`, 223.0292490118577}, {391.57242331163366`, 
            222.55089472140133`}, {391.8433892507896, 222.1453655353745}, {
            392.2489184368164, 221.87439959621858`}, {392.72727272727275`, 
            221.7792490118577}, {393.2056270177291, 221.87439959621858`}, {
            393.6111562037559, 222.1453655353745}, {393.88212214291184`, 
            222.55089472140133`}, {393.97727272727275`, 
            223.0292490118577}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{413.51848577927547`, 256.28467840112825`}, {
            413.24751984011954`, 256.6902075871551}, {412.84199065409274`, 
            256.96117352631103`}, {412.3636363636364, 257.0563241106719}, {
            411.88528207318, 256.96117352631103`}, {411.4797528871532, 
            256.6902075871551}, {411.2087869479973, 256.28467840112825`}, {
            411.1136363636364, 255.8063241106719}, {411.2087869479973, 
            255.32796982021554`}, {411.4797528871532, 254.92244063418872`}, {
            411.88528207318, 254.6514746950328}, {412.3636363636364, 
            254.5563241106719}, {412.84199065409274`, 254.6514746950328}, {
            413.24751984011954`, 254.92244063418872`}, {413.51848577927547`, 
            255.32796982021554`}, {413.6136363636364, 255.8063241106719}}]}}}, 
        {EdgeForm[None], FaceForm[RGBColor[1., 0.894101, 0.709799]], 
         PolygonBox[CompressedData["
1:eJxTTMoPSmViYGDQAmIQvaJbb9eLRcYOHBGy8ackPB2WgPnODnErDpxQ2Bfi
UHLRVTy2xNfh1qP+k3d8o6HywQ67jp0qYzVNcOgFcbsjHIRzTSv6FJIcSsHq
Yx0qaq+4HWpIdjAASeslOjybUHLgZk4KVH+yQ5TDo0O8f1IcJGJBNqQ5XFF5
pT3dNdWhB2xehkPQ9Yib6xJSHRjAINvh0odfK3pTUqHm5zoEcc2tyMlIdXi1
CGRgvsP5PdxqLc2pDvpg+wodvBYK9/OeTXV4CZLPKHLYF9A40TEmzWEx2P5i
B50URe5Ij3QHsPV3SxxAzutZkQF1T5nDKynt26JTshwugawLLHcw+6D7Vkcp
F+q+CofdYP8XOLgBpS8erXQAO8uxCM7/u9Ii4+zPfLj6C6vnz37/IBtu3iQ+
i9mCMxH2uVmadv7iSoO7582kU+2F8ilw97Y3ae+03Z8E949Ufre92uVEuH+X
7pe1/eScCA8PoOuvZPxKgIfXWo3laoH3E+DhqcvPGl50OwEe3mu/JrVPvp4A
jw995y83q/ckwONra9ybgk9FCfD4bIz7e6fmeDw8vpeZ733p+z4Wnh7uitX7
PNNDpBedUys9r4SHw9PTBPklqsusg+DpTQMs7+4AS48XQMouajsAADnNMdo=

          "]]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQvaJbb9eLRcYOHBGy8ackPB2WgPnODnErDpxQ2Bfi
UHLRVTy2xNfh1qP+k3d8o6HywQ67jp0qYzVNcOgFcbsjHIRzTSv6FJIcSsHq
Yx0qaq+4HWpIdjAASeslOjybUHLgZk4KVH+yQ5TDo0O8f1IcJGJBNqQ5XFF5
pT3dNdWhB2xehkPQ9Yib6xJSHRjAINvh0odfK3pTUqHm5zoEcc2tyMlIdXi1
CGRgvsP5PdxqLc2pDvpg+wodvBYK9/OeTXV4CZLPKHLYF9A40TEmzWEx2P5i
B50URe5Ij3QHsPV3SxxAzutZkQF1T5nDKynt26JTshwugawLLHcw+6D7Vkcp
F+q+CofdYP8XOLgBpS8erXQAO8uxyAEAGrOX2w==
          "]]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{20.791213052002764`, 50.67203017978442}, {
            20.52024711284684, 51.07755936581125}, {20.114717926820017`, 
            51.34852530496717}, {19.636363636363654`, 51.44367588932806}, {
            19.158009345907292`, 51.34852530496717}, {18.75248015988047, 
            51.07755936581125}, {18.481514220724545`, 50.67203017978442}, {
            18.386363636363654`, 50.19367588932806}, {18.481514220724545`, 
            49.715321598871704`}, {18.75248015988047, 49.30979241284488}, {
            19.158009345907292`, 49.03882647368896}, {19.636363636363654`, 
            48.94367588932806}, {20.114717926820017`, 49.03882647368896}, {
            20.52024711284684, 49.30979241284488}, {20.791213052002764`, 
            49.715321598871704`}, {20.886363636363654`, 
            50.19367588932806}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{40.427576688366386`, 83.44910527859864}, {
            40.156610749210465`, 83.85463446462545}, {39.75108156318364, 
            84.12560040378138}, {39.27272727272728, 84.22075098814227}, {
            38.79437298227092, 84.12560040378138}, {38.388843796244096`, 
            83.85463446462545}, {38.117877857088175`, 83.44910527859864}, {
            38.02272727272728, 82.97075098814227}, {38.117877857088175`, 
            82.4923966976859}, {38.388843796244096`, 82.0868675116591}, {
            38.79437298227092, 81.81590157250317}, {39.27272727272728, 
            81.72075098814227}, {39.75108156318364, 81.81590157250317}, {
            40.156610749210465`, 82.0868675116591}, {40.427576688366386`, 
            82.4923966976859}, {40.52272727272728, 82.97075098814227}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{60.06394032473001, 109.69495508097017`}, {
            59.79297438557409, 110.10048426699699`}, {59.387445199547265`, 
            110.37145020615291`}, {58.90909090909091, 110.46660079051381`}, {
            58.43073661863455, 110.37145020615291`}, {58.02520743260772, 
            110.10048426699699`}, {57.7542414934518, 109.69495508097017`}, {
            57.65909090909091, 109.21660079051381`}, {57.7542414934518, 
            108.73824650005744`}, {58.02520743260772, 108.33271731403063`}, {
            58.43073661863455, 108.0617513748747}, {58.90909090909091, 
            107.96660079051381`}, {59.387445199547265`, 108.0617513748747}, {
            59.79297438557409, 108.33271731403063`}, {60.06394032473001, 
            108.73824650005744`}, {60.15909090909091, 
            109.21660079051381`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{79.70030396109367, 130.13527128650378`}, {
            79.42933802193774, 130.5408004725306}, {79.02380883591093, 
            130.81176641168653`}, {78.54545454545456, 130.9069169960474}, {
            78.0671002549982, 130.81176641168653`}, {77.66157106897138, 
            130.5408004725306}, {77.39060512981546, 130.13527128650378`}, {
            77.29545454545456, 129.6569169960474}, {77.39060512981546, 
            129.17856270559105`}, {77.66157106897138, 128.77303351956422`}, {
            78.0671002549982, 128.5020675804083}, {78.54545454545456, 
            128.4069169960474}, {79.02380883591093, 128.5020675804083}, {
            79.42933802193774, 128.77303351956422`}, {79.70030396109367, 
            129.17856270559105`}, {79.79545454545456, 129.6569169960474}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{99.3366675974573, 145.49574559480416`}, {
            99.06570165830138, 145.901274780831}, {98.66017247227457, 
            146.17224071998692`}, {98.1818181818182, 146.2673913043478}, {
            97.70346389136184, 146.17224071998692`}, {97.29793470533502, 
            145.901274780831}, {97.0269687661791, 145.49574559480416`}, {
            96.9318181818182, 145.0173913043478}, {97.0269687661791, 
            144.53903701389143`}, {97.29793470533502, 144.1335078278646}, {
            97.70346389136184, 143.86254188870868`}, {98.1818181818182, 
            143.7673913043478}, {98.66017247227457, 143.86254188870868`}, {
            99.06570165830138, 144.1335078278646}, {99.3366675974573, 
            144.53903701389143`}, {99.4318181818182, 145.0173913043478}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{118.97303123382093`, 156.50206970547612`}, {
            118.702065294665, 156.90759889150294`}, {118.2965361086382, 
            157.17856483065887`}, {117.81818181818183`, 
            157.27371541501975`}, {117.33982752772546`, 
            157.17856483065887`}, {116.93429834169865`, 
            156.90759889150294`}, {116.66333240254272`, 
            156.50206970547612`}, {116.56818181818183`, 
            156.02371541501975`}, {116.66333240254272`, 
            155.54536112456339`}, {116.93429834169865`, 
            155.13983193853656`}, {117.33982752772546`, 
            154.86886599938063`}, {117.81818181818183`, 
            154.77371541501975`}, {118.2965361086382, 154.86886599938063`}, {
            118.702065294665, 155.13983193853656`}, {118.97303123382093`, 
            155.54536112456339`}, {119.06818181818183`, 
            156.02371541501975`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{138.60939487018462`, 163.87993531812435`}, {
            138.3384289310287, 164.28546450415118`}, {137.93289974500186`, 
            164.5564304433071}, {137.4545454545455, 164.651581027668}, {
            136.97619116408913`, 164.5564304433071}, {136.5706619780623, 
            164.28546450415118`}, {136.29969603890638`, 
            163.87993531812435`}, {136.2045454545455, 163.401581027668}, {
            136.29969603890638`, 162.92322673721162`}, {136.5706619780623, 
            162.5176975511848}, {136.97619116408913`, 162.24673161202887`}, {
            137.4545454545455, 162.151581027668}, {137.93289974500186`, 
            162.24673161202887`}, {138.3384289310287, 162.5176975511848}, {
            138.60939487018462`, 162.92322673721162`}, {138.7045454545455, 
            163.401581027668}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{158.24575850654824`, 168.35503413235358`}, {
            157.9747925673923, 168.7605633183804}, {157.5692633813655, 
            169.03152925753633`}, {157.09090909090912`, 
            169.12667984189721`}, {156.61255480045276`, 
            169.03152925753633`}, {156.20702561442593`, 168.7605633183804}, {
            155.93605967527, 168.35503413235358`}, {155.84090909090912`, 
            167.87667984189721`}, {155.93605967527, 167.39832555144085`}, {
            156.20702561442593`, 166.99279636541402`}, {156.61255480045276`, 
            166.7218304262581}, {157.09090909090912`, 166.62667984189721`}, {
            157.5692633813655, 166.7218304262581}, {157.9747925673923, 
            166.99279636541402`}, {158.24575850654824`, 
            167.39832555144085`}, {158.34090909090912`, 
            167.87667984189721`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{177.88212214291187`, 170.6530578477686}, {
            177.61115620375594`, 171.05858703379542`}, {177.2056270177291, 
            171.32955297295135`}, {176.72727272727275`, 
            171.42470355731223`}, {176.24891843681638`, 
            171.32955297295135`}, {175.84338925078956`, 
            171.05858703379542`}, {175.57242331163363`, 170.6530578477686}, {
            175.47727272727275`, 170.17470355731223`}, {175.57242331163363`, 
            169.69634926685586`}, {175.84338925078956`, 
            169.29082008082904`}, {176.24891843681638`, 169.0198541416731}, {
            176.72727272727275`, 168.92470355731223`}, {177.2056270177291, 
            169.0198541416731}, {177.61115620375594`, 169.29082008082904`}, {
            177.88212214291187`, 169.69634926685586`}, {177.97727272727275`, 
            170.17470355731223`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{197.5184857792755, 171.49969816397413`}, {
            197.24751984011957`, 171.90522735000096`}, {196.84199065409274`, 
            172.17619328915688`}, {196.36363636363637`, 
            172.27134387351776`}, {195.88528207318, 172.17619328915688`}, {
            195.47975288715318`, 171.90522735000096`}, {195.20878694799725`, 
            171.49969816397413`}, {195.11363636363637`, 
            171.02134387351776`}, {195.20878694799725`, 170.5429895830614}, {
            195.47975288715318`, 170.13746039703457`}, {195.88528207318, 
            169.86649445787864`}, {196.36363636363637`, 
            169.77134387351776`}, {196.84199065409274`, 
            169.86649445787864`}, {197.24751984011957`, 
            170.13746039703457`}, {197.5184857792755, 170.5429895830614}, {
            197.61363636363637`, 171.02134387351776`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{217.15484941563912`, 171.62064678057493`}, {
            216.8838834764832, 172.02617596660176`}, {216.47835429045637`, 
            172.29714190575768`}, {216., 172.39229249011856`}, {
            215.52164570954363`, 172.29714190575768`}, {215.1161165235168, 
            172.02617596660176`}, {214.84515058436088`, 
            171.62064678057493`}, {214.75, 171.14229249011856`}, {
            214.84515058436088`, 170.6639381996622}, {215.1161165235168, 
            170.25840901363537`}, {215.52164570954363`, 
            169.98744307447944`}, {216., 169.89229249011856`}, {
            216.47835429045637`, 169.98744307447944`}, {216.8838834764832, 
            170.25840901363537`}, {217.15484941563912`, 170.6639381996622}, {
            217.25, 171.14229249011856`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{236.79121305200277`, 171.74159539717573`}, {
            236.52024711284685`, 172.14712458320255`}, {236.11471792682002`, 
            172.41809052235848`}, {235.63636363636365`, 
            172.51324110671936`}, {235.1580093459073, 172.41809052235848`}, {
            234.75248015988046`, 172.14712458320255`}, {234.48151422072453`, 
            171.74159539717573`}, {234.38636363636365`, 
            171.26324110671936`}, {234.48151422072453`, 170.784886816263}, {
            234.75248015988046`, 170.37935763023617`}, {235.1580093459073, 
            170.10839169108024`}, {235.63636363636365`, 
            170.01324110671936`}, {236.11471792682002`, 
            170.10839169108024`}, {236.52024711284685`, 
            170.37935763023617`}, {236.79121305200277`, 170.784886816263}, {
            236.88636363636365`, 171.26324110671936`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{256.4275766883664, 172.58823571338124`}, {
            256.1566107492105, 172.99376489940806`}, {255.75108156318367`, 
            173.264730838564}, {255.2727272727273, 173.35988142292487`}, {
            254.79437298227094`, 173.264730838564}, {254.38884379624412`, 
            172.99376489940806`}, {254.1178778570882, 172.58823571338124`}, {
            254.0227272727273, 172.10988142292487`}, {254.1178778570882, 
            171.6315271324685}, {254.38884379624412`, 171.22599794644168`}, {
            254.79437298227094`, 170.95503200728575`}, {255.2727272727273, 
            170.85988142292487`}, {255.75108156318367`, 
            170.95503200728575`}, {256.1566107492105, 171.22599794644168`}, {
            256.4275766883664, 171.6315271324685}, {256.5227272727273, 
            172.10988142292487`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{276.06394032473, 174.88625942879628`}, {
            275.7929743855741, 175.2917886148231}, {275.3874451995473, 
            175.56275455397903`}, {274.90909090909093`, 175.6579051383399}, {
            274.43073661863457`, 175.56275455397903`}, {274.0252074326078, 
            175.2917886148231}, {273.75424149345184`, 174.88625942879628`}, {
            273.65909090909093`, 174.4079051383399}, {273.75424149345184`, 
            173.92955084788355`}, {274.0252074326078, 173.52402166185672`}, {
            274.43073661863457`, 173.2530557227008}, {274.90909090909093`, 
            173.1579051383399}, {275.3874451995473, 173.2530557227008}, {
            275.7929743855741, 173.52402166185672`}, {276.06394032473, 
            173.92955084788355`}, {276.15909090909093`, 
            174.4079051383399}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{295.70030396109365`, 179.3613582430255}, {
            295.4293380219377, 179.76688742905233`}, {295.0238088359109, 
            180.03785336820826`}, {294.54545454545456`, 
            180.13300395256914`}, {294.0671002549982, 180.03785336820826`}, {
            293.6615710689714, 179.76688742905233`}, {293.39060512981547`, 
            179.3613582430255}, {293.29545454545456`, 178.88300395256914`}, {
            293.39060512981547`, 178.40464966211277`}, {293.6615710689714, 
            177.99912047608595`}, {294.0671002549982, 177.72815453693002`}, {
            294.54545454545456`, 177.63300395256914`}, {295.0238088359109, 
            177.72815453693002`}, {295.4293380219377, 177.99912047608595`}, {
            295.70030396109365`, 178.40464966211277`}, {295.79545454545456`, 
            178.88300395256914`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{315.3366675974573, 186.73922385567374`}, {
            315.06570165830135`, 187.14475304170057`}, {314.66017247227455`, 
            187.4157189808565}, {314.1818181818182, 187.51086956521738`}, {
            313.7034638913618, 187.4157189808565}, {313.297934705335, 
            187.14475304170057`}, {313.0269687661791, 186.73922385567374`}, {
            312.9318181818182, 186.26086956521738`}, {313.0269687661791, 
            185.782515274761}, {313.297934705335, 185.37698608873418`}, {
            313.7034638913618, 185.10602014957826`}, {314.1818181818182, 
            185.01086956521738`}, {314.66017247227455`, 
            185.10602014957826`}, {315.06570165830135`, 
            185.37698608873418`}, {315.3366675974573, 185.782515274761}, {
            315.4318181818182, 186.26086956521738`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{334.9730312338209, 197.74554796634567`}, {
            334.702065294665, 198.1510771523725}, {334.2965361086382, 
            198.42204309152842`}, {333.8181818181818, 198.5171936758893}, {
            333.33982752772545`, 198.42204309152842`}, {332.93429834169865`, 
            198.1510771523725}, {332.6633324025427, 197.74554796634567`}, {
            332.5681818181818, 197.2671936758893}, {332.6633324025427, 
            196.78883938543294`}, {332.93429834169865`, 196.3833101994061}, {
            333.33982752772545`, 196.11234426025018`}, {333.8181818181818, 
            196.0171936758893}, {334.2965361086382, 196.11234426025018`}, {
            334.702065294665, 196.3833101994061}, {334.9730312338209, 
            196.78883938543294`}, {335.0681818181818, 197.2671936758893}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{354.6093948701846, 213.10602227464608`}, {
            354.33842893102866`, 213.5115514606729}, {353.93289974500186`, 
            213.78251739982883`}, {353.4545454545455, 213.8776679841897}, {
            352.97619116408913`, 213.78251739982883`}, {352.57066197806233`, 
            213.5115514606729}, {352.2996960389064, 213.10602227464608`}, {
            352.2045454545455, 212.6276679841897}, {352.2996960389064, 
            212.14931369373335`}, {352.57066197806233`, 
            211.74378450770652`}, {352.97619116408913`, 211.4728185685506}, {
            353.4545454545455, 211.3776679841897}, {353.93289974500186`, 
            211.4728185685506}, {354.33842893102866`, 211.74378450770652`}, {
            354.6093948701846, 212.14931369373335`}, {354.7045454545455, 
            212.6276679841897}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{374.2457585065482, 233.54633848017966`}, {
            373.9747925673923, 233.95186766620648`}, {373.5692633813655, 
            234.2228336053624}, {373.0909090909091, 234.3179841897233}, {
            372.61255480045276`, 234.2228336053624}, {372.20702561442596`, 
            233.95186766620648`}, {371.93605967527003`, 
            233.54633848017966`}, {371.8409090909091, 233.0679841897233}, {
            371.93605967527003`, 232.58962989926692`}, {372.20702561442596`, 
            232.1841007132401}, {372.61255480045276`, 231.91313477408417`}, {
            373.0909090909091, 231.8179841897233}, {373.5692633813655, 
            231.91313477408417`}, {373.9747925673923, 232.1841007132401}, {
            374.2457585065482, 232.58962989926692`}, {374.3409090909091, 
            233.0679841897233}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{393.88212214291184`, 259.79218828255125`}, {
            393.6111562037559, 260.19771746857805`}, {393.2056270177291, 
            260.468683407734}, {392.72727272727275`, 260.5638339920949}, {
            392.2489184368164, 260.468683407734}, {391.8433892507896, 
            260.19771746857805`}, {391.57242331163366`, 
            259.79218828255125`}, {391.47727272727275`, 259.3138339920949}, {
            391.57242331163366`, 258.8354797016385}, {391.8433892507896, 
            258.4299505156117}, {392.2489184368164, 258.1589845764558}, {
            392.72727272727275`, 258.0638339920949}, {393.2056270177291, 
            258.1589845764558}, {393.6111562037559, 258.4299505156117}, {
            393.88212214291184`, 258.8354797016385}, {393.97727272727275`, 
            259.3138339920949}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{413.51848577927547`, 292.56926338136543`}, {
            413.24751984011954`, 292.9747925673922}, {412.84199065409274`, 
            293.24575850654816`}, {412.3636363636364, 293.34090909090907`}, {
            411.88528207318, 293.24575850654816`}, {411.4797528871532, 
            292.9747925673922}, {411.2087869479973, 292.56926338136543`}, {
            411.1136363636364, 292.09090909090907`}, {411.2087869479973, 
            291.6125548004527}, {411.4797528871532, 291.2070256144259}, {
            411.88528207318, 290.93605967527}, {412.3636363636364, 
            290.84090909090907`}, {412.84199065409274`, 290.93605967527}, {
            413.24751984011954`, 291.2070256144259}, {413.51848577927547`, 
            291.6125548004527}, {413.6136363636364, 292.09090909090907`}}]}}}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{256., 94.85770750988141}, {216., 134.8577075098814}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{218.12132034355963`, 128.49374647920249`}, {216., 
           134.8577075098814}, {222.36396103067892`, 132.73638716632178`}}}]},
         InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Ugly, no?\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {256., 94.85770750988141}, {-1, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Ugly, no?\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {256., 94.85770750988141}, {-1, 1}, 
         Automatic, {1, 0}]},
       Frame->False,
       ImageSize->{432., 306.},
       PlotRange->{{0., 432.}, {0., 306.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {0., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{1.845, 1.814229249011845}, {0., 1.814229249011845}}], 
         LineBox[{{3.69, 13.909090909090907`}, {0., 13.909090909090907`}}], 
         LineBox[{{1.845, 26.003952569169954`}, {0., 26.003952569169954`}}], 
         LineBox[{{1.845, 38.098814229249}, {0., 38.098814229249}}], 
         LineBox[{{1.845, 50.19367588932806}, {0., 50.19367588932806}}], 
         LineBox[{{1.845, 62.28853754940711}, {0., 62.28853754940711}}], 
         LineBox[{{3.69, 74.38339920948616}, {0., 74.38339920948616}}], 
         LineBox[{{1.845, 86.4782608695652}, {0., 86.4782608695652}}], 
         LineBox[{{1.845, 98.57312252964425}, {0., 98.57312252964425}}], 
         LineBox[{{1.845, 110.66798418972331`}, {0., 110.66798418972331`}}], 
         LineBox[{{1.845, 122.76284584980236`}, {0., 122.76284584980236`}}], 
         LineBox[{{3.69, 134.8577075098814}, {0., 134.8577075098814}}], 
         LineBox[{{1.845, 146.95256916996047`}, {0., 146.95256916996047`}}], 
         LineBox[{{1.845, 159.0474308300395}, {0., 159.0474308300395}}], 
         LineBox[{{1.845, 171.14229249011856`}, {0., 171.14229249011856`}}], 
         LineBox[{{1.845, 183.23715415019763`}, {0., 183.23715415019763`}}], 
         LineBox[{{3.69, 195.33201581027666`}, {0., 195.33201581027666`}}], 
         LineBox[{{1.845, 207.4268774703557}, {0., 207.4268774703557}}], 
         LineBox[{{1.845, 219.52173913043475`}, {0., 219.52173913043475`}}], 
         LineBox[{{1.845, 231.61660079051381`}, {0., 231.61660079051381`}}], 
         LineBox[{{1.845, 243.71146245059288`}, {0., 243.71146245059288`}}], 
         LineBox[{{3.69, 255.8063241106719}, {0., 255.8063241106719}}], 
         LineBox[{{1.845, 267.901185770751}, {0., 267.901185770751}}], 
         LineBox[{{1.845, 279.99604743083}, {0., 279.99604743083}}], 
         LineBox[{{1.845, 292.0909090909091}, {0., 292.0909090909091}}], 
         LineBox[{{1.845, 304.1857707509881}, {0., 304.1857707509881}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{432., 0.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{430.155, 1.814229249011845}, {432., 1.814229249011845}}], 
         LineBox[{{428.31, 13.909090909090907`}, {432., 
          13.909090909090907`}}], 
         LineBox[{{430.155, 26.003952569169954`}, {432., 
          26.003952569169954`}}], 
         LineBox[{{430.155, 38.098814229249}, {432., 38.098814229249}}], 
         LineBox[{{430.155, 50.19367588932806}, {432., 50.19367588932806}}], 
         LineBox[{{430.155, 62.28853754940711}, {432., 62.28853754940711}}], 
         LineBox[{{428.31, 74.38339920948616}, {432., 74.38339920948616}}], 
         LineBox[{{430.155, 86.4782608695652}, {432., 86.4782608695652}}], 
         LineBox[{{430.155, 98.57312252964425}, {432., 98.57312252964425}}], 
         LineBox[{{430.155, 110.66798418972331`}, {432., 
          110.66798418972331`}}], 
         LineBox[{{430.155, 122.76284584980236`}, {432., 
          122.76284584980236`}}], 
         LineBox[{{428.31, 134.8577075098814}, {432., 134.8577075098814}}], 
         LineBox[{{430.155, 146.95256916996047`}, {432., 
          146.95256916996047`}}], 
         LineBox[{{430.155, 159.0474308300395}, {432., 159.0474308300395}}], 
         LineBox[{{430.155, 171.14229249011856`}, {432., 
          171.14229249011856`}}], 
         LineBox[{{430.155, 183.23715415019763`}, {432., 
          183.23715415019763`}}], 
         LineBox[{{428.31, 195.33201581027666`}, {432., 
          195.33201581027666`}}], 
         LineBox[{{430.155, 207.4268774703557}, {432., 207.4268774703557}}], 
         LineBox[{{430.155, 219.52173913043475`}, {432., 
          219.52173913043475`}}], 
         LineBox[{{430.155, 231.61660079051381`}, {432., 
          231.61660079051381`}}], 
         LineBox[{{430.155, 243.71146245059288`}, {432., 
          243.71146245059288`}}], 
         LineBox[{{428.31, 255.8063241106719}, {432., 255.8063241106719}}], 
         LineBox[{{430.155, 267.901185770751}, {432., 267.901185770751}}], 
         LineBox[{{430.155, 279.99604743083}, {432., 279.99604743083}}], 
         LineBox[{{430.155, 292.0909090909091}, {432., 292.0909090909091}}], 
         LineBox[{{430.155, 304.1857707509881}, {432., 304.1857707509881}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {432., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{19.636363636363654`, 3.69}, {19.636363636363654`, 0.}}], 
         LineBox[{{39.27272727272728, 1.845}, {39.27272727272728, 0.}}], 
         LineBox[{{58.90909090909091, 1.845}, {58.90909090909091, 0.}}], 
         LineBox[{{78.54545454545456, 1.845}, {78.54545454545456, 0.}}], 
         LineBox[{{98.1818181818182, 1.845}, {98.1818181818182, 0.}}], 
         LineBox[{{117.81818181818183`, 3.69}, {117.81818181818183`, 0.}}], 
         LineBox[{{137.45454545454544`, 1.845}, {137.45454545454544`, 0.}}], 
         LineBox[{{157.0909090909091, 1.845}, {157.0909090909091, 0.}}], 
         LineBox[{{176.72727272727275`, 1.845}, {176.72727272727275`, 0.}}], 
         LineBox[{{196.36363636363637`, 1.845}, {196.36363636363637`, 0.}}], 
         LineBox[{{216., 3.69}, {216., 0.}}], 
         LineBox[{{235.63636363636363`, 1.845}, {235.63636363636363`, 0.}}], 
         LineBox[{{255.27272727272728`, 1.845}, {255.27272727272728`, 0.}}], 
         LineBox[{{274.90909090909093`, 1.845}, {274.90909090909093`, 0.}}], 
         LineBox[{{294.54545454545456`, 1.845}, {294.54545454545456`, 0.}}], 
         LineBox[{{314.1818181818182, 3.69}, {314.1818181818182, 0.}}], 
         LineBox[{{333.8181818181818, 1.845}, {333.8181818181818, 0.}}], 
         LineBox[{{353.45454545454544`, 1.845}, {353.45454545454544`, 0.}}], 
         LineBox[{{373.0909090909091, 1.845}, {373.0909090909091, 0.}}], 
         LineBox[{{392.72727272727275`, 1.845}, {392.72727272727275`, 0.}}], 
         LineBox[{{412.3636363636364, 3.69}, {412.3636363636364, 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 306.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{19.636363636363654`, 302.31}, {19.636363636363654`, 
          306.}}], 
         LineBox[{{39.27272727272728, 304.155}, {39.27272727272728, 306.}}], 
         LineBox[{{58.90909090909091, 304.155}, {58.90909090909091, 306.}}], 
         LineBox[{{78.54545454545456, 304.155}, {78.54545454545456, 306.}}], 
         LineBox[{{98.1818181818182, 304.155}, {98.1818181818182, 306.}}], 
         LineBox[{{117.81818181818183`, 302.31}, {117.81818181818183`, 
          306.}}], 
         LineBox[{{137.45454545454544`, 304.155}, {137.45454545454544`, 
          306.}}], 
         LineBox[{{157.0909090909091, 304.155}, {157.0909090909091, 306.}}], 
         LineBox[{{176.72727272727275`, 304.155}, {176.72727272727275`, 
          306.}}], 
         LineBox[{{196.36363636363637`, 304.155}, {196.36363636363637`, 
          306.}}], LineBox[{{216., 302.31}, {216., 306.}}], 
         LineBox[{{235.63636363636363`, 304.155}, {235.63636363636363`, 
          306.}}], 
         LineBox[{{255.27272727272728`, 304.155}, {255.27272727272728`, 
          306.}}], 
         LineBox[{{274.90909090909093`, 304.155}, {274.90909090909093`, 
          306.}}], 
         LineBox[{{294.54545454545456`, 304.155}, {294.54545454545456`, 
          306.}}], 
         LineBox[{{314.1818181818182, 302.31}, {314.1818181818182, 306.}}], 
         LineBox[{{333.8181818181818, 304.155}, {333.8181818181818, 306.}}], 
         LineBox[{{353.45454545454544`, 304.155}, {353.45454545454544`, 
          306.}}], 
         LineBox[{{373.0909090909091, 304.155}, {373.0909090909091, 306.}}], 
         LineBox[{{392.72727272727275`, 304.155}, {392.72727272727275`, 
          306.}}], 
         LineBox[{{412.3636363636364, 302.31}, {412.3636363636364, 306.}}]}, 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-1.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 13.909090909090907`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 74.38339920948616}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 134.8577075098814}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 195.33201581027666`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 255.8063241106719}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"y\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" (m)\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-29., 306.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-1.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {19.636363636363654`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {117.81818181818183`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {216., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {314.1818181818182, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {412.3636363636364, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"t\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" (s)\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -15.}, {0, 1}, Automatic, {1., 0.}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-1.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 13.909090909090907`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 74.38339920948616}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 134.8577075098814}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 195.33201581027666`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 255.8063241106719}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"y\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" (m)\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-29., 306.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-1.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {19.636363636363654`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {117.81818181818183`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {216., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {314.1818181818182, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {412.3636363636364, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"t\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" (s)\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -15.}, {0, 1}, Automatic, {1., 0.}]},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->0.78125,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{576, 450.},
  PlotRange->{{-72, 504}, {-72., 378.}}]], "Output",
 CellChangeTimes->{
  3.518468490375*^9, {3.518468649015625*^9, 3.518468681171875*^9}, 
   3.5185623984235*^9, {3.5185626009235*^9, 3.518562606532875*^9}, 
   3.51856264970475*^9, 3.52027872325*^9, 3.524748118984375*^9, {
   3.566338842147214*^9, 3.5663388470300226`*^9}, 3.579121900442767*^9, 
   3.584376332397131*^9, {3.5843763881322093`*^9, 3.584376418792252*^9}, 
   3.5930109679169765`*^9, 3.5943050982481337`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Drop lines for data curves", "Subsection",
 CellChangeTimes->{{3.51846434496875*^9, 3.5184643455625*^9}, {
   3.518468296609375*^9, 3.51846829803125*^9}, {3.51848241671875*^9, 
   3.51848241984375*^9}, 3.518482454703125*^9, 3.5843761013337283`*^9, {
   3.584376442222285*^9, 3.5843764443972883`*^9}, {3.622233582869825*^9, 
   3.6222335841958275`*^9}}],

Cell["Drop lines are generated similarly to fills", "Text",
 CellChangeTimes->{{3.584376112565748*^9, 3.584376129054977*^9}, {
  3.6222339748673134`*^9, 3.6222339928853445`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"DataPlot", "[", 
        RowBox[{"Data", ",", 
         RowBox[{"DataDrop", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Filling", "\[Rule]", "Axis"}], ",", 
            RowBox[{"Color", "\[Rule]", "Firebrick"}]}], "}"}]}]}], "]"}], 
       ";"}], "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", "]"}], 
    "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Style", "->", "\"\<ExampleDataFigure\>\""}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.5843750252578382`*^9, 3.5843750429170694`*^9}, 
   3.584375148569232*^9, {3.584375744728671*^9, 3.5843757511262693`*^9}, 
   3.5930093817581396`*^9, {3.5943047800387745`*^9, 3.5943047810683765`*^9}, {
   3.6222339550240784`*^9, 3.6222339552580786`*^9}, {3.6222339971909523`*^9, 
   3.6222340250214014`*^9}}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {432., 306.}]}, InsetBox[
      GraphicsBox[{
        {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         LineBox[CompressedData["
1:eJxTTMoPSmVmYGAQBGImKF7crbfrxSJjBwYQUEh2QOdLxJZcdBV3w+Cfn5Eu
e/5EmoM+UHW3XiBcHsaPY10Y+v9RpsMlV/HYksBwuDyMbzE7y3zF12yH0osg
gVi4PAp/Q45DD8g5pxPh8jA+TD/YOXdT4PIwPsx+kPLud+lweRgf5n6wOEM2
XB6dD3aOYB4GP+mcwdHEd3EQ/0wsQPUfkO/8dW8I464IB3BwSBXB5WH8iSe1
Jq6fEgIN72K08IfxgyH+1S5F9T+QD9MP8m7sljK4PIwPsx8cHrYVqOED5MPc
7wZ07sWjlXB5dD4A5iO0fw==
          "]]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{19.636363636363637`, 153.}, {44.18181818181819, 
          182.27528257592937`}, {68.72727272727273, 207.09366876077087`}, {
          93.27272727272728, 223.67678423711345`}, {117.81818181818183`, 
          229.5}, {142.36363636363637`, 223.67678423711345`}, {
          166.9090909090909, 207.09366876077087`}, {191.45454545454544`, 
          182.27528257592937`}, {216., 153.}, {240.54545454545453`, 
          123.72471742407063`}, {265.0909090909091, 98.90633123922912}, {
          289.6363636363636, 82.32321576288656}, {314.1818181818182, 76.5}, {
          338.72727272727275`, 82.32321576288656}, {363.27272727272725`, 
          98.90633123922912}, {387.8181818181818, 123.72471742407063`}, {
          412.3636363636364, 153.}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{20.791213052002746`, 153.47835429045637`}, {
            20.52024711284682, 153.8838834764832}, {20.11471792682, 
            154.15484941563912`}, {19.636363636363637`, 154.25}, {
            19.158009345907274`, 154.15484941563912`}, {18.752480159880452`, 
            153.8838834764832}, {18.481514220724527`, 153.47835429045637`}, {
            18.386363636363637`, 153.}, {18.481514220724527`, 
            152.52164570954363`}, {18.752480159880452`, 152.1161165235168}, {
            19.158009345907274`, 151.84515058436088`}, {19.636363636363637`, 
            151.75}, {20.11471792682, 151.84515058436088`}, {
            20.52024711284682, 152.1161165235168}, {20.791213052002746`, 
            152.52164570954363`}, {20.886363636363637`, 153.}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{45.33666759745729, 182.75363686638573`}, {
            45.06570165830137, 183.15916605241256`}, {44.660172472274546`, 
            183.4301319915685}, {44.18181818181819, 183.52528257592937`}, {
            43.70346389136183, 183.4301319915685}, {43.297934705335, 
            183.15916605241256`}, {43.02696876617908, 182.75363686638573`}, {
            42.93181818181819, 182.27528257592937`}, {43.02696876617908, 
            181.796928285473}, {43.297934705335, 181.39139909944618`}, {
            43.70346389136183, 181.12043316029025`}, {44.18181818181819, 
            181.02528257592937`}, {44.660172472274546`, 
            181.12043316029025`}, {45.06570165830137, 181.39139909944618`}, {
            45.33666759745729, 181.796928285473}, {45.43181818181819, 
            182.27528257592937`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{69.88212214291184, 207.57202305122723`}, {
            69.61115620375591, 207.97755223725406`}, {69.2056270177291, 
            208.24851817641}, {68.72727272727273, 208.34366876077087`}, {
            68.24891843681637, 208.24851817641}, {67.84338925078956, 
            207.97755223725406`}, {67.57242331163363, 207.57202305122723`}, {
            67.47727272727273, 207.09366876077087`}, {67.57242331163363, 
            206.6153144703145}, {67.84338925078956, 206.20978528428768`}, {
            68.24891843681637, 205.93881934513175`}, {68.72727272727273, 
            205.84366876077087`}, {69.2056270177291, 205.93881934513175`}, {
            69.61115620375591, 206.20978528428768`}, {69.88212214291184, 
            206.6153144703145}, {69.97727272727273, 207.09366876077087`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{94.42757668836639, 224.15513852756982`}, {
            94.15661074921046, 224.56066771359664`}, {93.75108156318365, 
            224.83163365275257`}, {93.27272727272728, 224.92678423711345`}, {
            92.79437298227091, 224.83163365275257`}, {92.3888437962441, 
            224.56066771359664`}, {92.11787785708817, 224.15513852756982`}, {
            92.02272727272728, 223.67678423711345`}, {92.11787785708817, 
            223.1984299466571}, {92.3888437962441, 222.79290076063026`}, {
            92.79437298227091, 222.52193482147433`}, {93.27272727272728, 
            222.42678423711345`}, {93.75108156318365, 222.52193482147433`}, {
            94.15661074921046, 222.79290076063026`}, {94.42757668836639, 
            223.1984299466571}, {94.52272727272728, 223.67678423711345`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{118.97303123382093`, 229.97835429045637`}, {
            118.702065294665, 230.3838834764832}, {118.2965361086382, 
            230.65484941563912`}, {117.81818181818183`, 230.75}, {
            117.33982752772546`, 230.65484941563912`}, {116.93429834169865`, 
            230.3838834764832}, {116.66333240254272`, 229.97835429045637`}, {
            116.56818181818183`, 229.5}, {116.66333240254272`, 
            229.02164570954363`}, {116.93429834169865`, 228.6161165235168}, {
            117.33982752772546`, 228.34515058436088`}, {117.81818181818183`, 
            228.25}, {118.2965361086382, 228.34515058436088`}, {
            118.702065294665, 228.6161165235168}, {118.97303123382093`, 
            229.02164570954363`}, {119.06818181818183`, 229.5}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{143.5184857792755, 224.15513852756982`}, {
            143.24751984011957`, 224.56066771359664`}, {142.84199065409274`, 
            224.83163365275257`}, {142.36363636363637`, 
            224.92678423711345`}, {141.88528207318, 224.83163365275257`}, {
            141.47975288715318`, 224.56066771359664`}, {141.20878694799725`, 
            224.15513852756982`}, {141.11363636363637`, 
            223.67678423711345`}, {141.20878694799725`, 223.1984299466571}, {
            141.47975288715318`, 222.79290076063026`}, {141.88528207318, 
            222.52193482147433`}, {142.36363636363637`, 
            222.42678423711345`}, {142.84199065409274`, 
            222.52193482147433`}, {143.24751984011957`, 
            222.79290076063026`}, {143.5184857792755, 223.1984299466571}, {
            143.61363636363637`, 223.67678423711345`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{168.06394032473003`, 207.57202305122723`}, {
            167.7929743855741, 207.97755223725406`}, {167.38744519954727`, 
            208.24851817641}, {166.9090909090909, 208.34366876077087`}, {
            166.43073661863454`, 208.24851817641}, {166.02520743260771`, 
            207.97755223725406`}, {165.7542414934518, 207.57202305122723`}, {
            165.6590909090909, 207.09366876077087`}, {165.7542414934518, 
            206.6153144703145}, {166.02520743260771`, 206.20978528428768`}, {
            166.43073661863454`, 205.93881934513175`}, {166.9090909090909, 
            205.84366876077087`}, {167.38744519954727`, 
            205.93881934513175`}, {167.7929743855741, 206.20978528428768`}, {
            168.06394032473003`, 206.6153144703145}, {168.1590909090909, 
            207.09366876077087`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{192.60939487018456`, 182.75363686638573`}, {
            192.33842893102863`, 183.15916605241256`}, {191.9328997450018, 
            183.4301319915685}, {191.45454545454544`, 183.52528257592937`}, {
            190.97619116408907`, 183.4301319915685}, {190.57066197806225`, 
            183.15916605241256`}, {190.29969603890632`, 
            182.75363686638573`}, {190.20454545454544`, 
            182.27528257592937`}, {190.29969603890632`, 181.796928285473}, {
            190.57066197806225`, 181.39139909944618`}, {190.97619116408907`, 
            181.12043316029025`}, {191.45454545454544`, 
            181.02528257592937`}, {191.9328997450018, 181.12043316029025`}, {
            192.33842893102863`, 181.39139909944618`}, {192.60939487018456`, 
            181.796928285473}, {192.70454545454544`, 
            182.27528257592937`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{217.15484941563912`, 153.47835429045637`}, {
            216.8838834764832, 153.8838834764832}, {216.47835429045637`, 
            154.15484941563912`}, {216., 154.25}, {215.52164570954363`, 
            154.15484941563912`}, {215.1161165235168, 153.8838834764832}, {
            214.84515058436088`, 153.47835429045637`}, {214.75, 153.}, {
            214.84515058436088`, 152.52164570954363`}, {215.1161165235168, 
            152.1161165235168}, {215.52164570954363`, 151.84515058436088`}, {
            216., 151.75}, {216.47835429045637`, 151.84515058436088`}, {
            216.8838834764832, 152.1161165235168}, {217.15484941563912`, 
            152.52164570954363`}, {217.25, 153.}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{241.70030396109365`, 124.203071714527}, {
            241.42933802193772`, 124.60860090055381`}, {241.0238088359109, 
            124.87956683970974`}, {240.54545454545453`, 
            124.97471742407063`}, {240.06710025499817`, 
            124.87956683970974`}, {239.66157106897134`, 
            124.60860090055381`}, {239.3906051298154, 124.203071714527}, {
            239.29545454545453`, 123.72471742407063`}, {239.3906051298154, 
            123.24636313361427`}, {239.66157106897134`, 
            122.84083394758746`}, {240.06710025499817`, 
            122.56986800843153`}, {240.54545454545453`, 
            122.47471742407063`}, {241.0238088359109, 122.56986800843153`}, {
            241.42933802193772`, 122.84083394758746`}, {241.70030396109365`, 
            123.24636313361427`}, {241.79545454545453`, 
            123.72471742407063`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{266.2457585065482, 99.38468552968548}, {
            265.9747925673923, 99.7902147157123}, {265.5692633813655, 
            100.06118065486822`}, {265.0909090909091, 100.15633123922912`}, {
            264.61255480045276`, 100.06118065486822`}, {264.20702561442596`, 
            99.7902147157123}, {263.93605967527003`, 99.38468552968548}, {
            263.8409090909091, 98.90633123922912}, {263.93605967527003`, 
            98.42797694877275}, {264.20702561442596`, 98.02244776274594}, {
            264.61255480045276`, 97.75148182359001}, {265.0909090909091, 
            97.65633123922912}, {265.5692633813655, 97.75148182359001}, {
            265.9747925673923, 98.02244776274594}, {266.2457585065482, 
            98.42797694877275}, {266.3409090909091, 98.90633123922912}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{290.7912130520027, 82.80157005334293}, {
            290.5202471128468, 83.20709923936974}, {290.11471792682, 
            83.47806517852567}, {289.6363636363636, 83.57321576288656}, {
            289.15800934590726`, 83.47806517852567}, {288.75248015988046`, 
            83.20709923936974}, {288.48151422072453`, 82.80157005334293}, {
            288.3863636363636, 82.32321576288656}, {288.48151422072453`, 
            81.8448614724302}, {288.75248015988046`, 81.43933228640338}, {
            289.15800934590726`, 81.16836634724746}, {289.6363636363636, 
            81.07321576288656}, {290.11471792682, 81.16836634724746}, {
            290.5202471128468, 81.43933228640338}, {290.7912130520027, 
            81.8448614724302}, {290.8863636363636, 82.32321576288656}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{315.3366675974573, 76.97835429045637}, {
            315.06570165830135`, 77.38388347648318}, {314.66017247227455`, 
            77.6548494156391}, {314.1818181818182, 77.75}, {313.7034638913618,
             77.6548494156391}, {313.297934705335, 77.38388347648318}, {
            313.0269687661791, 76.97835429045637}, {312.9318181818182, 
            76.5}, {313.0269687661791, 76.02164570954363}, {313.297934705335, 
            75.61611652351682}, {313.7034638913618, 75.3451505843609}, {
            314.1818181818182, 75.25}, {314.66017247227455`, 
            75.3451505843609}, {315.06570165830135`, 75.61611652351682}, {
            315.3366675974573, 76.02164570954363}, {315.4318181818182, 
            76.5}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{339.88212214291184`, 82.80157005334293}, {
            339.6111562037559, 83.20709923936974}, {339.2056270177291, 
            83.47806517852567}, {338.72727272727275`, 83.57321576288656}, {
            338.2489184368164, 83.47806517852567}, {337.8433892507896, 
            83.20709923936974}, {337.57242331163366`, 82.80157005334293}, {
            337.47727272727275`, 82.32321576288656}, {337.57242331163366`, 
            81.8448614724302}, {337.8433892507896, 81.43933228640338}, {
            338.2489184368164, 81.16836634724746}, {338.72727272727275`, 
            81.07321576288656}, {339.2056270177291, 81.16836634724746}, {
            339.6111562037559, 81.43933228640338}, {339.88212214291184`, 
            81.8448614724302}, {339.97727272727275`, 82.32321576288656}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{364.42757668836634`, 99.38468552968548}, {
            364.1566107492104, 99.7902147157123}, {363.7510815631836, 
            100.06118065486822`}, {363.27272727272725`, 
            100.15633123922912`}, {362.7943729822709, 100.06118065486822`}, {
            362.3888437962441, 99.7902147157123}, {362.11787785708816`, 
            99.38468552968548}, {362.02272727272725`, 98.90633123922912}, {
            362.11787785708816`, 98.42797694877275}, {362.3888437962441, 
            98.02244776274594}, {362.7943729822709, 97.75148182359001}, {
            363.27272727272725`, 97.65633123922912}, {363.7510815631836, 
            97.75148182359001}, {364.1566107492104, 98.02244776274594}, {
            364.42757668836634`, 98.42797694877275}, {364.52272727272725`, 
            98.90633123922912}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{388.9730312338209, 124.203071714527}, {
            388.702065294665, 124.60860090055381`}, {388.2965361086382, 
            124.87956683970974`}, {387.8181818181818, 124.97471742407063`}, {
            387.33982752772545`, 124.87956683970974`}, {386.93429834169865`, 
            124.60860090055381`}, {386.6633324025427, 124.203071714527}, {
            386.5681818181818, 123.72471742407063`}, {386.6633324025427, 
            123.24636313361427`}, {386.93429834169865`, 
            122.84083394758746`}, {387.33982752772545`, 
            122.56986800843153`}, {387.8181818181818, 122.47471742407063`}, {
            388.2965361086382, 122.56986800843153`}, {388.702065294665, 
            122.84083394758746`}, {388.9730312338209, 123.24636313361427`}, {
            389.0681818181818, 123.72471742407063`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{413.51848577927547`, 153.47835429045637`}, {
            413.24751984011954`, 153.8838834764832}, {412.84199065409274`, 
            154.15484941563912`}, {412.3636363636364, 154.25}, {
            411.88528207318, 154.15484941563912`}, {411.4797528871532, 
            153.8838834764832}, {411.2087869479973, 153.47835429045637`}, {
            411.1136363636364, 153.}, {411.2087869479973, 
            152.52164570954363`}, {411.4797528871532, 152.1161165235168}, {
            411.88528207318, 151.84515058436088`}, {412.3636363636364, 
            151.75}, {412.84199065409274`, 151.84515058436088`}, {
            413.24751984011954`, 152.1161165235168}, {413.51848577927547`, 
            152.52164570954363`}, {413.6136363636364, 153.}}]}}}},
       Frame->False,
       ImageSize->{432., 306.},
       PlotRange->{{0., 432.}, {0., 306.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {0., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{3.69, 0.}, {0., 0.}}], 
         LineBox[{{1.845, 15.299999999999983`}, {0., 15.299999999999983`}}], 
         LineBox[{{1.845, 30.599999999999994`}, {0., 30.599999999999994`}}], 
         LineBox[{{1.845, 45.900000000000006`}, {0., 45.900000000000006`}}], 
         LineBox[{{1.845, 61.2}, {0., 61.2}}], 
         LineBox[{{3.69, 76.5}, {0., 76.5}}], 
         LineBox[{{1.845, 91.8}, {0., 91.8}}], 
         LineBox[{{1.845, 107.1}, {0., 107.1}}], 
         LineBox[{{1.845, 122.4}, {0., 122.4}}], 
         LineBox[{{1.845, 137.7}, {0., 137.7}}], 
         LineBox[{{3.69, 153.}, {0., 153.}}], 
         LineBox[{{1.845, 168.3}, {0., 168.3}}], 
         LineBox[{{1.845, 183.6}, {0., 183.6}}], 
         LineBox[{{1.845, 198.9}, {0., 198.9}}], 
         LineBox[{{1.845, 214.2}, {0., 214.2}}], 
         LineBox[{{3.69, 229.5}, {0., 229.5}}], 
         LineBox[{{1.845, 244.8}, {0., 244.8}}], 
         LineBox[{{1.845, 260.1}, {0., 260.1}}], 
         LineBox[{{1.845, 275.4}, {0., 275.4}}], 
         LineBox[{{1.845, 290.70000000000005`}, {0., 290.70000000000005`}}], 
         LineBox[{{3.69, 306.}, {0., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{432., 0.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{428.31, 0.}, {432., 0.}}], 
         LineBox[{{430.155, 15.299999999999983`}, {432., 
          15.299999999999983`}}], 
         LineBox[{{430.155, 30.599999999999994`}, {432., 
          30.599999999999994`}}], 
         LineBox[{{430.155, 45.900000000000006`}, {432., 
          45.900000000000006`}}], LineBox[{{430.155, 61.2}, {432., 61.2}}], 
         LineBox[{{428.31, 76.5}, {432., 76.5}}], 
         LineBox[{{430.155, 91.8}, {432., 91.8}}], 
         LineBox[{{430.155, 107.1}, {432., 107.1}}], 
         LineBox[{{430.155, 122.4}, {432., 122.4}}], 
         LineBox[{{430.155, 137.7}, {432., 137.7}}], 
         LineBox[{{428.31, 153.}, {432., 153.}}], 
         LineBox[{{430.155, 168.3}, {432., 168.3}}], 
         LineBox[{{430.155, 183.6}, {432., 183.6}}], 
         LineBox[{{430.155, 198.9}, {432., 198.9}}], 
         LineBox[{{430.155, 214.2}, {432., 214.2}}], 
         LineBox[{{428.31, 229.5}, {432., 229.5}}], 
         LineBox[{{430.155, 244.8}, {432., 244.8}}], 
         LineBox[{{430.155, 260.1}, {432., 260.1}}], 
         LineBox[{{430.155, 275.4}, {432., 275.4}}], 
         LineBox[{{430.155, 290.70000000000005`}, {432., 
          290.70000000000005`}}], LineBox[{{428.31, 306.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {432., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{7.135466288054765, 1.845}, {7.135466288054765, 0.}}], 
         LineBox[{{19.636363636363637`, 3.69}, {19.636363636363637`, 0.}}], 
         LineBox[{{32.13726098467251, 1.845}, {32.13726098467251, 0.}}], 
         LineBox[{{44.63815833298138, 1.845}, {44.63815833298138, 0.}}], 
         LineBox[{{57.13905568129026, 1.845}, {57.13905568129026, 0.}}], 
         LineBox[{{69.63995302959913, 1.845}, {69.63995302959913, 0.}}], 
         LineBox[{{82.140850377908, 3.69}, {82.140850377908, 0.}}], 
         LineBox[{{94.64174772621686, 1.845}, {94.64174772621686, 0.}}], 
         LineBox[{{107.14264507452573`, 1.845}, {107.14264507452573`, 0.}}], 
         LineBox[{{119.64354242283461`, 1.845}, {119.64354242283461`, 0.}}], 
         LineBox[{{132.14443977114348`, 1.845}, {132.14443977114348`, 0.}}], 
         LineBox[{{144.64533711945234`, 3.69}, {144.64533711945234`, 0.}}], 
         LineBox[{{157.14623446776122`, 1.845}, {157.14623446776122`, 0.}}], 
         LineBox[{{169.64713181607007`, 1.845}, {169.64713181607007`, 0.}}], 
         LineBox[{{182.14802916437895`, 1.845}, {182.14802916437895`, 0.}}], 
         LineBox[{{194.6489265126878, 1.845}, {194.6489265126878, 0.}}], 
         LineBox[{{207.1498238609967, 3.69}, {207.1498238609967, 0.}}], 
         LineBox[{{219.65072120930557`, 1.845}, {219.65072120930557`, 0.}}], 
         LineBox[{{232.15161855761443`, 1.845}, {232.15161855761443`, 0.}}], 
         LineBox[{{244.6525159059233, 1.845}, {244.6525159059233, 0.}}], 
         LineBox[{{257.1534132542322, 1.845}, {257.1534132542322, 0.}}], 
         LineBox[{{269.65431060254105`, 3.69}, {269.65431060254105`, 0.}}], 
         LineBox[{{282.1552079508499, 1.845}, {282.1552079508499, 0.}}], 
         LineBox[{{294.6561052991588, 1.845}, {294.6561052991588, 0.}}], 
         LineBox[{{307.15700264746766`, 1.845}, {307.15700264746766`, 0.}}], 
         LineBox[{{319.6578999957765, 1.845}, {319.6578999957765, 0.}}], 
         LineBox[{{332.15879734408543`, 3.69}, {332.15879734408543`, 0.}}], 
         LineBox[{{344.6596946923943, 1.845}, {344.6596946923943, 0.}}], 
         LineBox[{{357.16059204070314`, 1.845}, {357.16059204070314`, 0.}}], 
         LineBox[{{369.661489389012, 1.845}, {369.661489389012, 0.}}], 
         LineBox[{{382.1623867373209, 1.845}, {382.1623867373209, 0.}}], 
         LineBox[{{394.66328408562975`, 3.69}, {394.66328408562975`, 0.}}], 
         LineBox[{{407.1641814339386, 1.845}, {407.1641814339386, 0.}}], 
         LineBox[{{419.6650787822475, 1.845}, {419.6650787822475, 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 306.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{7.135466288054765, 304.155}, {7.135466288054765, 306.}}], 
         LineBox[{{19.636363636363637`, 302.31}, {19.636363636363637`, 
          306.}}], 
         LineBox[{{32.13726098467251, 304.155}, {32.13726098467251, 306.}}], 
         LineBox[{{44.63815833298138, 304.155}, {44.63815833298138, 306.}}], 
         LineBox[{{57.13905568129026, 304.155}, {57.13905568129026, 306.}}], 
         LineBox[{{69.63995302959913, 304.155}, {69.63995302959913, 306.}}], 
         LineBox[{{82.140850377908, 302.31}, {82.140850377908, 306.}}], 
         LineBox[{{94.64174772621686, 304.155}, {94.64174772621686, 306.}}], 
         LineBox[{{107.14264507452573`, 304.155}, {107.14264507452573`, 
          306.}}], 
         LineBox[{{119.64354242283461`, 304.155}, {119.64354242283461`, 
          306.}}], 
         LineBox[{{132.14443977114348`, 304.155}, {132.14443977114348`, 
          306.}}], 
         LineBox[{{144.64533711945234`, 302.31}, {144.64533711945234`, 
          306.}}], 
         LineBox[{{157.14623446776122`, 304.155}, {157.14623446776122`, 
          306.}}], 
         LineBox[{{169.64713181607007`, 304.155}, {169.64713181607007`, 
          306.}}], 
         LineBox[{{182.14802916437895`, 304.155}, {182.14802916437895`, 
          306.}}], 
         LineBox[{{194.6489265126878, 304.155}, {194.6489265126878, 306.}}], 
         LineBox[{{207.1498238609967, 302.31}, {207.1498238609967, 306.}}], 
         LineBox[{{219.65072120930557`, 304.155}, {219.65072120930557`, 
          306.}}], 
         LineBox[{{232.15161855761443`, 304.155}, {232.15161855761443`, 
          306.}}], 
         LineBox[{{244.6525159059233, 304.155}, {244.6525159059233, 306.}}], 
         LineBox[{{257.1534132542322, 304.155}, {257.1534132542322, 306.}}], 
         LineBox[{{269.65431060254105`, 302.31}, {269.65431060254105`, 
          306.}}], 
         LineBox[{{282.1552079508499, 304.155}, {282.1552079508499, 306.}}], 
         LineBox[{{294.6561052991588, 304.155}, {294.6561052991588, 306.}}], 
         LineBox[{{307.15700264746766`, 304.155}, {307.15700264746766`, 
          306.}}], 
         LineBox[{{319.6578999957765, 304.155}, {319.6578999957765, 306.}}], 
         LineBox[{{332.15879734408543`, 302.31}, {332.15879734408543`, 
          306.}}], 
         LineBox[{{344.6596946923943, 304.155}, {344.6596946923943, 306.}}], 
         LineBox[{{357.16059204070314`, 304.155}, {357.16059204070314`, 
          306.}}], 
         LineBox[{{369.661489389012, 304.155}, {369.661489389012, 306.}}], 
         LineBox[{{382.1623867373209, 304.155}, {382.1623867373209, 306.}}], 
         LineBox[{{394.66328408562975`, 302.31}, {394.66328408562975`, 
          306.}}], 
         LineBox[{{407.1641814339386, 304.155}, {407.1641814339386, 306.}}], 
         LineBox[{{419.6650787822475, 304.155}, {419.6650787822475, 306.}}]}, 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 0.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 76.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 153.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 229.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 306.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"y\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" (m)\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-19., 306.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {19.636363636363637`, -1.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {82.140850377908, -1.}, {0, 1}, Automatic, {1,
          0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {144.64533711945234`, -1.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"3\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {207.1498238609967, -1.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"4\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {269.65431060254105`, -1.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {332.15879734408543`, -1.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"6\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {394.66328408562975`, -1.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"t\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" (s)\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -16.}, {0, 1}, Automatic, {1., 0.}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 0.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 76.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 153.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 229.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 306.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"y\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" (m)\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-19., 306.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {19.636363636363637`, -1.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {82.140850377908, -1.}, {0, 1}, Automatic, {1,
          0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {144.64533711945234`, -1.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"3\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {207.1498238609967, -1.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"4\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {269.65431060254105`, -1.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {332.15879734408543`, -1.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"6\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {394.66328408562975`, -1.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"t\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" (s)\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -16.}, {0, 1}, Automatic, {1., 0.}]},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->0.78125,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{576, 450.},
  PlotRange->{{-72, 504}, {-72., 378.}}]], "Output",
 CellChangeTimes->{
  3.6222339574576826`*^9, {3.6222340039613647`*^9, 3.622234027595406*^9}, 
   3.62223464468569*^9}]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Attaching text labels to plots -- Woods-Saxon wave functions", "Section",
 CellChangeTimes->{{3.499032716421875*^9, 3.499032727734375*^9}}],

Cell["\<\
In this example, we use SciDraw to control the appearance of the plot line, \
by feeding the output of Plot to FigLine, which takes the plot's curve, \
extracts the coordinates of its points, and (re)draws the curve following \
these points, but using FigLine's formatting options.\
\>", "Text",
 CellChangeTimes->{{3.499022408515625*^9, 3.499022501*^9}, {
  3.499032886046875*^9, 3.499032945375*^9}, {3.52054082803125*^9, 
  3.520540840859375*^9}}],

Cell["Define wave functions", "Text",
 CellChangeTimes->{{3.499032854328125*^9, 3.499032858109375*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"g", "[", 
    RowBox[{"b_", ",", "n_", ",", "l_", ",", "r_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Sqrt", "[", 
     RowBox[{"2", "*", 
      RowBox[{
       RowBox[{"Factorial", "[", "n", "]"}], "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"b", "^", "3"}], "*", 
         RowBox[{"Gamma", "[", 
          RowBox[{"n", "+", "l", "+", 
           RowBox[{"3", "/", "2"}]}], "]"}]}], ")"}]}]}], "]"}], "*", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"r", "/", "b"}], ")"}], "^", "l"}], "*", 
    RowBox[{"Exp", "[", 
     RowBox[{
      RowBox[{"-", 
       RowBox[{"r", "^", "2"}]}], "/", 
      RowBox[{"(", 
       RowBox[{"2", "*", 
        RowBox[{"b", "^", "2"}]}], ")"}]}], "]"}], "*", 
    RowBox[{"LaguerreL", "[", 
     RowBox[{"n", ",", 
      RowBox[{"l", "+", 
       RowBox[{"1", "/", "2"}]}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"r", "/", "b"}], ")"}], "^", "2"}]}], "]"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"b40", "=", "1.94"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"R0s1", "[", "r_", "]"}], ":=", 
   RowBox[{
    RowBox[{"0.995", "*", 
     RowBox[{"g", "[", 
      RowBox[{"b40", ",", "0", ",", "0", ",", "r"}], "]"}]}], "-", 
    RowBox[{"0.087", "*", 
     RowBox[{"g", "[", 
      RowBox[{"b40", ",", "1", ",", "0", ",", "r"}], "]"}]}], "-", 
    RowBox[{"0.034", "*", 
     RowBox[{"g", "[", 
      RowBox[{"b40", ",", "2", ",", "0", ",", "r"}], "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"R0p3", "[", "r_", "]"}], ":=", 
   RowBox[{
    RowBox[{"0.998", "*", 
     RowBox[{"g", "[", 
      RowBox[{"b40", ",", "0", ",", "1", ",", "r"}], "]"}]}], "-", 
    RowBox[{"0.044", "*", 
     RowBox[{"g", "[", 
      RowBox[{"b40", ",", "1", ",", "1", ",", "r"}], "]"}]}], "-", 
    RowBox[{"0.026", "*", 
     RowBox[{"g", "[", 
      RowBox[{"b40", ",", "2", ",", "1", ",", "r"}], "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"R0p1", "[", "r_", "]"}], ":=", 
   RowBox[{
    RowBox[{"0.999", "*", 
     RowBox[{"g", "[", 
      RowBox[{"b40", ",", "0", ",", "1", ",", "r"}], "]"}]}], "-", 
    RowBox[{"0.002", "*", 
     RowBox[{"g", "[", 
      RowBox[{"b40", ",", "1", ",", "1", ",", "r"}], "]"}]}], "-", 
    RowBox[{"0.009", "*", 
     RowBox[{"g", "[", 
      RowBox[{"b40", ",", "2", ",", "1", ",", "r"}], "]"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"R0s1HO", "[", "r_", "]"}], ":=", 
   RowBox[{"g", "[", 
    RowBox[{"b40", ",", "0", ",", "0", ",", "r"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"R0p3HO", "[", "r_", "]"}], ":=", 
   RowBox[{"g", "[", 
    RowBox[{"b40", ",", "0", ",", "1", ",", "r"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"R0p1HO", "[", "r_", "]"}], ":=", 
   RowBox[{"g", "[", 
    RowBox[{"b40", ",", "0", ",", "1", ",", "r"}], "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.499033007703125*^9, 3.4990330079375*^9}, 
   3.520540929828125*^9}],

Cell["Generate figure", "Text",
 CellChangeTimes->{{3.49903286125*^9, 3.499032862890625*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"FigLine", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Plot", "[", 
          RowBox[{
           RowBox[{"R0s1", "[", "r", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"r", ",", "0", ",", "5"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"CenterLabel", "\[Rule]", 
          RowBox[{"ShellLabel", "[", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", 
             RowBox[{"1", "/", "2"}]}], "}"}], "]"}]}], ",", 
         RowBox[{"CenterLabelPosition", "\[Rule]", "0.25"}], ",", 
         RowBox[{"TextOffset", "\[Rule]", "Top"}]}], "\[IndentingNewLine]", 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"FigLine", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Plot", "[", 
          RowBox[{
           RowBox[{"R0p3", "[", "r", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"r", ",", "0", ",", "5"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"CenterLabel", "\[Rule]", 
          RowBox[{"ShellLabel", "[", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1", ",", 
             RowBox[{"3", "/", "2"}]}], "}"}], "]"}]}], ",", 
         RowBox[{"CenterLabelPosition", "\[Rule]", "0.25"}], ",", 
         RowBox[{"TextOffset", "\[Rule]", "Top"}]}], "\[IndentingNewLine]", 
        "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"FigLine", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Plot", "[", 
          RowBox[{
           RowBox[{"R0p1", "[", "r", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"r", ",", "0", ",", "5"}], "}"}]}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"CenterLabel", "\[Rule]", 
          RowBox[{"ShellLabel", "[", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1", ",", 
             RowBox[{"1", "/", "2"}]}], "}"}], "]"}]}], ",", 
         RowBox[{"CenterLabelPosition", "\[Rule]", "0.25"}], ",", 
         RowBox[{"TextOffset", "\[Rule]", "Bottom"}], ",", 
         RowBox[{"TextBuffer", "\[Rule]", "2"}]}], "\[IndentingNewLine]", 
        "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"SetOptions", "[", 
        RowBox[{"FigLine", ",", 
         RowBox[{"LineDashing", "\[Rule]", "3"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"FigLine", "[", 
        RowBox[{"Plot", "[", 
         RowBox[{
          RowBox[{"R0s1HO", "[", "r", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"r", ",", "0", ",", "5"}], "}"}]}], "]"}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"FigLine", "[", 
        RowBox[{"Plot", "[", 
         RowBox[{
          RowBox[{"R0p3HO", "[", "r", "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"r", ",", "0", ",", "5"}], "}"}]}], "]"}], "]"}], ";"}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"XPlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "5"}], "}"}]}], ",", 
     RowBox[{"XFrameLabel", "\[Rule]", 
      RowBox[{"Row", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"textit", "[", "\"\<r\>\"", "]"}], ",", "\"\< (fm)\>\""}], 
        "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"YPlotRange", "->", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0.6"}], "}"}]}], ",", 
     RowBox[{"YFrameLabel", "->", 
      RowBox[{"Row", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"textit", "[", "\"\<R\>\"", "]"}], ",", "\"\<(\>\"", ",", 
         RowBox[{"textit", "[", "\"\<r\>\"", "]"}], ",", "\"\<)\>\""}], "}"}],
        "]"}]}]}], "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
   RowBox[{"CanvasSize", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"6", ",", "4"}], "}"}]}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellChangeTimes->{{3.40243520075*^9, 3.40243524146875*^9}, {
   3.402435289734375*^9, 3.402435537453125*^9}, {3.402435570578125*^9, 
   3.402435759390625*^9}, {3.40243588296875*^9, 3.40243591275*^9}, {
   3.40829301315625*^9, 3.40829302334375*^9}, {3.4922891346875*^9, 
   3.49228921690625*^9}, {3.492289314296875*^9, 3.492289561734375*^9}, {
   3.49228959565625*^9, 3.49228962503125*^9}, {3.4922899125*^9, 
   3.492290116265625*^9}, 3.49903275740625*^9, {3.5205408448125*^9, 
   3.52054094225*^9}, {3.520540977859375*^9, 3.5205411023125*^9}, {
   3.52054114190625*^9, 3.5205411591875*^9}, {3.520541189765625*^9, 
   3.520541213828125*^9}, {3.5205413528125*^9, 3.520541434046875*^9}, {
   3.52054146784375*^9, 3.520541486125*^9}, {3.520542909828125*^9, 
   3.520542920015625*^9}, {3.5663386142776136`*^9, 3.566338626913636*^9}}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 360}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 432},
       PlotRange->{{-72, 504}, {-72, 360}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {432., 288.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJwV1Xk41QkXB/A7IiL70kjWwu0SuZSluvd707UNsleyJQm/S9fOJYxEpXii
ojQiuxhtg5QmkmVmSNkiDFJSowwhY3t/7x/nOc/nOc9znnOe88dR9T7lcIKP
QqH8Qsb/c6Tslnsmp8cYdIr1RltZDlKp15K7554x9axvl9iQdmxWuVg118l0
l6iItibtFTXfHcbtZ7Jd/ROtSBvKfhD7ZW6EGYyBBnPSjC92D9bo75kJY6uG
B0gfaHl8yJs7yRTz7xtnkv4pT2O5qXKK2STg02pCuuyJRWfm3DTTYrZwzIC0
9vY4NbbMLNMx/Ia+Dum7Vx+EzdPnmLfeHHisQZrON9lcYr/A/BRSGK1EujpI
Sf4Id5G5dvtRkCxpk7eOhHD6EvPXzqQbIqSfmp+vf1y5wmznrF+hkPaW+G9n
+hwFoyM6vpMyHBQ0ywxM8POhvKWXM0j6fazuGcisQ5qJYXkHaf9Jn55/6QIo
YG9ru0u6/FZ8nNX+9fhkcL88j/Rn5xuaBfaCCPdYakwnfarxZbQTdwMGgxuz
CNL3oj6pVcYLQ3qJ5XSY9KyOwF8C6SI4sBJvfoB0ZI6JUk2lKErE9ryWJ82s
cxi9OCcB347WqMfSHHjKjuwyPi0JEctDn/NJJ3ADL7znl8I4UXElhXSjxjl9
how07gdWpdqRNsusP/uVLguPh3tE+qU4OPnFaiCnThbqSWoGj0gnW77Rsdgv
B/Oggcxs0q1rM3159ptQFvF8wYm0NYdKc+DKI+dakX2TJAeBLb/FrS7II9EI
ermk09RMu8rjN+NUea15JOnON+6x69IV4C9gJa9J2omd2fGwUhEaL1QPnpbg
YId4/KPUORWY57oJ8otzIHLFpECOqYrC7lmhdjEOJn+cv5h/ThVm8dZKV0kX
qwV61SioYaukbZIaaZXdRwXfsbbCe/3HfXRRDqTdDZ1N0tTBjTkYoC7Cwczo
DONFnzr2MWLL/hYm5/H9lWqnqoGPpbeWs0lf4qovn3ioAcnY/mEh0oJJ0gWX
BzRRKnQ2c0iIg8Xyr9MfNWhw++1Ag+t6Dnp17wyEcmmYHa5lrSdd/dC3afUR
DUtJJ3rvCnAQ/HQoS8ZGC/RI3t51pD+/+pOBUG3QpGSXb67jYPh7ycWs33VA
6Ta3KaRwcHzrTpmtFXqwlNjkxvcfgcvXa2qjOvQgNxv+Q/YigQZxpnvHtB6U
e/r6tUmrLNsUR++iQ/ta7Van7wQGuwmjzqd0RGnHbrk+T8AlucTt9Ct9qIzf
LF6eIWA1qVTUN78L6rFdprTPBGI8iy13yO/G3mdLjsWfCJT17PiSuGc33jb1
Z6mSFmzca6iTsBuX1l7WyU4SaLrh2pa0wRAC352Dvn0gwLC+NqW3xQjapUGX
U8cI0KtEd19kmSBHfNOCSj+BzQ3XT+06bgKxO+yC5DcEfuhSLxtOMkFJ0efU
z30EOub3bdFrNcG32UdSD3oJBDCC+Hpt92CqUHPBqJtAXntHh7LbXlx5XKCq
8pKAxD/pJx9EMMBUmNFzayIwv6KQ75bNwKV6IqbsOYEh8dIBgToGhvLs+OYb
CdzRf2ZzeIWBq9tOt15sIGAeM62/coYJBQkrw3tPCeAsNaHAAmhO3lzcU0sg
Uua89ZQzC1pP2gQuVZD7OWrL6/qxsFMxsPPuHQICGS/fc3ksLE771nSVE8gU
l4v/lsvCJ6QNyJURqBIuuLc0wUJPBSUyo4jABKVeTpi3H0N/WEl75pL3mJoe
0cg1xa2r3+i26QQMmg+He31gI0NFTigliMDb4c4jAQtsPIu60ZEUSCBxwYIR
JmSGINGuVz9zCHRSjQXP0cxw6GxmWnQAAU6q/PWqIDPYo3rM05dAod3Ak9V5
M2Qz/6QIeRCQeXuU/xdBC0yEVXObrQnMfvXI7KdaodxMmLqmSSAj7X5pbrMt
vlRvei7UEQDp19a6RIk9ko/eHDzkF4Dh7Lf8F5oc0ZSb+/voij82b5bstRV3
wYcHEZMGcf5w6RvNl9M/jKhlZ8p/S34QtVuu32TtilLZcJtTIX4wOFPf8zTD
DQypkN7Hr0/i6Iz8R7/7HkjxnKhMMDiJxUtiMYPxXrCY7VetivdFImUXTTX/
GFjtq7mZL05ARLLMZeJXb9QNPKpSlDyBv+KmExK6jmNp71jRczMfpF04S80Z
94HyhE9VatJxpMxOtZ/b6IvWflXCotIbDJMYBWndk6if+pik0nsMc0ouH5QY
ftB0sHScFz6GcS/+qpXj/ojguzskvcMLXaDMuUcEIHvjKcX6Og8krKq8cz1D
YPzGA7P929xxQl72Ja2Eg1HlsQjloKOweu1iFFsTCOV7SnL3+4/g5EfiVt5w
EEJrH+Yo0w5D9YtD304KF/XmGZ9kUl0gVnNN0SGFi5kDr0voks7I0mkaG5QP
hj4zrWsx0RFq4dm+pbeDUW8W98JVwQEXaPGMRmoIVmvkj9Fb7JCWdvAquy4E
Wpmum8fbbJHZ0Fy+YX8oCNdmYzMHaxgUaDINe0LhUy2qKdxiiR5H3YwijzAM
cbW8HFPM4Rxqaez9PgzU9Sl/DwazEcyy8TwXGQ6LpLpXxg6mSBteMP26Fg5l
j6SJhkgW2LSLJb9nRiC7uuZCEJ2JwXG65/C2SFxR3lDf0b4HIUEJPfsqIqG2
Ua8uddQIhcU1f6xnRsHpdKvcyMIu9FVejZNojULBywJb4xh9TG5NTvazjQYj
z7bvMvSQZeElShuJRpvCtkVBRR2w9446aPvxcJ77Y2+uPw1/P+HmpwbwcDnE
2O3LERqi9lGmP3F48Kz/UZJtRcMdhvKlsmAe+Aa01gS1aJBiubdoxPCgW2H1
27t/tmOI3b9HNY0Hh8Gh9ung7Yg4+Gqb3EMerhXltDr+TIVEp1doeDUP0okN
tmdDqCizm27oruWh32VDU/1xKobsxT0z63mo814NNTWjwtTJ5rpECw+iU9x7
+SJUiB9pExUZ4KE7PGW0JIv8E/2H3QIGyXnv+Pqbn9fEfteP5W3DPDzXcnw2
xdNE2FFBi3PveGCXWnbZemhiwJ2dKDBF1i3cnL3VNRE+3N3p85WH9mQXRaNN
mhDz9FFu+pcHSg+7UGaDJlheZ54kzpP95ec+jP6jgbcjUiJj33mYj6vMfT2s
gbBjt4+wlngo6/pJ9I9ODYiO6ZXmrfBwm/+vna2NGijxbphfW+NhbnS7YDv5
5/4Ht+pdVA==
          "]]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJwV1nk4VO0bB3Bbi7JHvZZQVLJW1hLzJSIpW8k2Z8yYOTOWihAmiWTJVtZU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          "]]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJwV1nk4lO0XB/CJVFRC6NVi31vsisp8KRVlX5KYecbMM7aUvUylhexRibQo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          "]]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[3], CapForm[
         None], JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJwV1Hk01VsbB3CJhAxlKA2iwyHX1MlQh875HjKklLEiJzIWYpv5leEiCelG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          "]]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[3], CapForm[
         None], JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJwV1nk8VOsfB3AlItlJ0RXlSkrWFDfmo6LSJltjmzkzc2bGEqEUQxI3Kksh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          "]]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{"0",SubscriptBox["\"s\"", 
                TagBox[
                 GridBox[{{"1", "\"/\"", "2"}}, AutoDelete -> False, 
                  BaselinePosition -> {{1, 3}, Baseline}, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {115.68094063998022`, 189.77746192829485`}, {0, 1},
          Automatic, {0.8642457939572389, -0.5030697840530892}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{"0",SubscriptBox["\"p\"", 
                TagBox[
                 
                 GridBox[{{"3", "\"/\"", "2"}}, AutoDelete -> False, 
                  BaselinePosition -> {{1, 3}, Baseline}, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {87.72823439955835, 88.79867102020482}, {0, 1},
          Automatic, {0.7781782782866422, 0.6280434437225161}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{"0",SubscriptBox["\"p\"", 
                TagBox[
                 
                 GridBox[{{"1", "\"/\"", "2"}}, AutoDelete -> False, 
                  BaselinePosition -> {{1, 3}, Baseline}, 
                  GridBoxItemSize -> {
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                  GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {84.48543665776657, 94.79688564549015}, {0, -1},
          Automatic, {0.7604722599233655, 0.6493704196273873}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{"0",SubscriptBox["\"s\"", 
               TagBox[
                
                GridBox[{{"1", "\"/\"", "2"}}, AutoDelete -> False, 
                 BaselinePosition -> {{1, 3}, Baseline}, 
                 GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {115.68094063998022`, 189.77746192829485`}, {0, 1},
          Automatic, {0.8642457939572389, -0.5030697840530892}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{"0",SubscriptBox["\"p\"", 
               TagBox[
                
                GridBox[{{"3", "\"/\"", "2"}}, AutoDelete -> False, 
                 BaselinePosition -> {{1, 3}, Baseline}, 
                 GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {87.72823439955835, 88.79867102020482}, {0, 1},
          Automatic, {0.7781782782866422, 0.6280434437225161}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{"0",SubscriptBox["\"p\"", 
               TagBox[
                
                GridBox[{{"1", "\"/\"", "2"}}, AutoDelete -> False, 
                 BaselinePosition -> {{1, 3}, Baseline}, 
                 GridBoxItemSize -> {
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                 GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {84.48543665776657, 94.79688564549015}, {0, -1},
          Automatic, {0.7604722599233655, 0.6493704196273873}]},
       Frame->False,
       ImageSize->{432., 288.},
       PlotRange->{{0., 432.}, {0., 288.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 360}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 432},
       PlotRange->{{-72, 504}, {-72, 360}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 360}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {0., 288.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{3.6, 0.}, {0., 0.}}], 
         LineBox[{{1.8, 9.600000000000001}, {0., 9.600000000000001}}], 
         LineBox[{{1.8, 19.200000000000003`}, {0., 19.200000000000003`}}], 
         LineBox[{{1.8, 28.800000000000004`}, {0., 28.800000000000004`}}], 
         LineBox[{{1.8, 38.400000000000006`}, {0., 38.400000000000006`}}], 
         LineBox[{{3.6, 48.}, {0., 48.}}], LineBox[{{1.8, 57.6}, {0., 57.6}}],
          LineBox[{{1.8, 67.2}, {0., 67.2}}], 
         LineBox[{{1.8, 76.80000000000001}, {0., 76.80000000000001}}], 
         LineBox[{{1.8, 86.4}, {0., 86.4}}], LineBox[{{3.6, 96.}, {0., 96.}}],
          LineBox[{{1.8, 105.60000000000001`}, {0., 105.60000000000001`}}], 
         LineBox[{{1.8, 115.2}, {0., 115.2}}], 
         LineBox[{{1.8, 124.80000000000001`}, {0., 124.80000000000001`}}], 
         LineBox[{{1.8, 134.4}, {0., 134.4}}], 
         LineBox[{{3.6, 144.00000000000003`}, {0., 144.00000000000003`}}], 
         LineBox[{{1.8, 153.60000000000002`}, {0., 153.60000000000002`}}], 
         LineBox[{{1.8, 163.20000000000005`}, {0., 163.20000000000005`}}], 
         LineBox[{{1.8, 172.8}, {0., 172.8}}], 
         LineBox[{{1.8, 182.40000000000003`}, {0., 182.40000000000003`}}], 
         LineBox[{{3.6, 192.}, {0., 192.}}], 
         LineBox[{{1.8, 201.60000000000002`}, {0., 201.60000000000002`}}], 
         LineBox[{{1.8, 211.20000000000002`}, {0., 211.20000000000002`}}], 
         LineBox[{{1.8, 220.8}, {0., 220.8}}], 
         LineBox[{{1.8, 230.4}, {0., 230.4}}], 
         LineBox[{{3.6, 240.}, {0., 240.}}], 
         LineBox[{{1.8, 249.60000000000002`}, {0., 249.60000000000002`}}], 
         LineBox[{{1.8, 259.20000000000005`}, {0., 259.20000000000005`}}], 
         LineBox[{{1.8, 268.8}, {0., 268.8}}], 
         LineBox[{{1.8, 278.40000000000003`}, {0., 278.40000000000003`}}], 
         LineBox[{{3.6, 288.00000000000006`}, {0., 288.00000000000006`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{432., 0.}, {432., 288.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{428.4, 0.}, {432., 0.}}], 
         LineBox[{{430.2, 9.600000000000001}, {432., 9.600000000000001}}], 
         LineBox[{{430.2, 19.200000000000003`}, {432., 19.200000000000003`}}],
          LineBox[{{430.2, 28.800000000000004`}, {432., 
          28.800000000000004`}}], 
         LineBox[{{430.2, 38.400000000000006`}, {432., 38.400000000000006`}}],
          LineBox[{{428.4, 48.}, {432., 48.}}], 
         LineBox[{{430.2, 57.6}, {432., 57.6}}], 
         LineBox[{{430.2, 67.2}, {432., 67.2}}], 
         LineBox[{{430.2, 76.80000000000001}, {432., 76.80000000000001}}], 
         LineBox[{{430.2, 86.4}, {432., 86.4}}], 
         LineBox[{{428.4, 96.}, {432., 96.}}], 
         LineBox[{{430.2, 105.60000000000001`}, {432., 105.60000000000001`}}],
          LineBox[{{430.2, 115.2}, {432., 115.2}}], 
         LineBox[{{430.2, 124.80000000000001`}, {432., 124.80000000000001`}}],
          LineBox[{{430.2, 134.4}, {432., 134.4}}], 
         LineBox[{{428.4, 144.00000000000003`}, {432., 144.00000000000003`}}],
          LineBox[{{430.2, 153.60000000000002`}, {432., 
          153.60000000000002`}}], 
         LineBox[{{430.2, 163.20000000000005`}, {432., 163.20000000000005`}}],
          LineBox[{{430.2, 172.8}, {432., 172.8}}], 
         LineBox[{{430.2, 182.40000000000003`}, {432., 182.40000000000003`}}],
          LineBox[{{428.4, 192.}, {432., 192.}}], 
         LineBox[{{430.2, 201.60000000000002`}, {432., 201.60000000000002`}}],
          LineBox[{{430.2, 211.20000000000002`}, {432., 
          211.20000000000002`}}], LineBox[{{430.2, 220.8}, {432., 220.8}}], 
         LineBox[{{430.2, 230.4}, {432., 230.4}}], 
         LineBox[{{428.4, 240.}, {432., 240.}}], 
         LineBox[{{430.2, 249.60000000000002`}, {432., 249.60000000000002`}}],
          LineBox[{{430.2, 259.20000000000005`}, {432., 
          259.20000000000005`}}], LineBox[{{430.2, 268.8}, {432., 268.8}}], 
         LineBox[{{430.2, 278.40000000000003`}, {432., 278.40000000000003`}}],
          LineBox[{{428.4, 288.00000000000006`}, {432., 
          288.00000000000006`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {432., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 3.6}, {0., 0.}}], 
         LineBox[{{17.28, 1.8}, {17.28, 0.}}], 
         LineBox[{{34.56, 1.8}, {34.56, 0.}}], 
         LineBox[{{51.84000000000001, 1.8}, {51.84000000000001, 0.}}], 
         LineBox[{{69.12, 1.8}, {69.12, 0.}}], 
         LineBox[{{86.4, 3.6}, {86.4, 0.}}], 
         LineBox[{{103.68, 1.8}, {103.68, 0.}}], 
         LineBox[{{120.96, 1.8}, {120.96, 0.}}], 
         LineBox[{{138.24, 1.8}, {138.24, 0.}}], 
         LineBox[{{155.52, 1.8}, {155.52, 0.}}], 
         LineBox[{{172.8, 3.6}, {172.8, 0.}}], 
         LineBox[{{190.08000000000004`, 1.8}, {190.08000000000004`, 0.}}], 
         LineBox[{{207.36, 1.8}, {207.36, 0.}}], 
         LineBox[{{224.64000000000001`, 1.8}, {224.64000000000001`, 0.}}], 
         LineBox[{{241.92, 1.8}, {241.92, 0.}}], 
         LineBox[{{259.20000000000005`, 3.6}, {259.20000000000005`, 0.}}], 
         LineBox[{{276.48, 1.8}, {276.48, 0.}}], 
         LineBox[{{293.76, 1.8}, {293.76, 0.}}], 
         LineBox[{{311.04, 1.8}, {311.04, 0.}}], 
         LineBox[{{328.32, 1.8}, {328.32, 0.}}], 
         LineBox[{{345.6, 3.6}, {345.6, 0.}}], 
         LineBox[{{362.88000000000005`, 1.8}, {362.88000000000005`, 0.}}], 
         LineBox[{{380.1600000000001, 1.8}, {380.1600000000001, 0.}}], 
         LineBox[{{397.44, 1.8}, {397.44, 0.}}], 
         LineBox[{{414.72, 1.8}, {414.72, 0.}}], 
         LineBox[{{432., 3.6}, {432., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 288.}, {432., 288.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 284.4}, {0., 288.}}], 
         LineBox[{{17.28, 286.2}, {17.28, 288.}}], 
         LineBox[{{34.56, 286.2}, {34.56, 288.}}], 
         LineBox[{{51.84000000000001, 286.2}, {51.84000000000001, 288.}}], 
         LineBox[{{69.12, 286.2}, {69.12, 288.}}], 
         LineBox[{{86.4, 284.4}, {86.4, 288.}}], 
         LineBox[{{103.68, 286.2}, {103.68, 288.}}], 
         LineBox[{{120.96, 286.2}, {120.96, 288.}}], 
         LineBox[{{138.24, 286.2}, {138.24, 288.}}], 
         LineBox[{{155.52, 286.2}, {155.52, 288.}}], 
         LineBox[{{172.8, 284.4}, {172.8, 288.}}], 
         LineBox[{{190.08000000000004`, 286.2}, {190.08000000000004`, 288.}}],
          LineBox[{{207.36, 286.2}, {207.36, 288.}}], 
         LineBox[{{224.64000000000001`, 286.2}, {224.64000000000001`, 288.}}],
          LineBox[{{241.92, 286.2}, {241.92, 288.}}], 
         LineBox[{{259.20000000000005`, 284.4}, {259.20000000000005`, 288.}}],
          LineBox[{{276.48, 286.2}, {276.48, 288.}}], 
         LineBox[{{293.76, 286.2}, {293.76, 288.}}], 
         LineBox[{{311.04, 286.2}, {311.04, 288.}}], 
         LineBox[{{328.32, 286.2}, {328.32, 288.}}], 
         LineBox[{{345.6, 284.4}, {345.6, 288.}}], 
         LineBox[{{362.88000000000005`, 286.2}, {362.88000000000005`, 288.}}],
          LineBox[{{380.1600000000001, 286.2}, {380.1600000000001, 288.}}], 
         LineBox[{{397.44, 286.2}, {397.44, 288.}}], 
         LineBox[{{414.72, 286.2}, {414.72, 288.}}], 
         LineBox[{{432., 284.4}, {432., 288.}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {1, 0}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 48.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 96.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.3\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 144.00000000000003`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.4\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 192.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 240.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.6\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 288.00000000000006`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"R\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\"(\"",TagBox[
                StyleBox["\"r\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\")\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-20., 144.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {0, 1}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {86.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {172.8, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"3\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {259.20000000000005`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"4\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {345.6, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"r\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\" (fm)\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {216., -15.}, {0, 1}, Automatic, {1., 0.}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {1, 0}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 48.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 96.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.3\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 144.00000000000003`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.4\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 192.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 240.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.6\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 288.00000000000006`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"R\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\"(\"",TagBox[
               StyleBox["\"r\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\")\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-20., 144.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {0, 1}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {86.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {172.8, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"3\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {259.20000000000005`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"4\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {345.6, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"r\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\" (fm)\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {216., -15.}, {0, 1}, Automatic, {1., 0.}]},
       Frame->False,
       ImageSize->{576, 432},
       PlotRange->{{-72, 504}, {-72, 360}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->NCache[
    Rational[3, 4], 0.75],
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{576, 432},
  PlotRange->{{-72, 504}, {-72, 360}}]], "Output",
 CellChangeTimes->{{3.5205423800625*^9, 3.5205423905625*^9}, 
   3.5205426526875*^9, 3.520542697171875*^9, {3.52054278984375*^9, 
   3.5205428001875*^9}, {3.52054290603125*^9, 3.520542923390625*^9}, 
   3.524748124890625*^9, 3.5663386305484424`*^9, 3.579121902404879*^9, {
   3.5837843829993906`*^9, 3.5837843892706017`*^9}, 3.594304590404842*^9, 
   3.594305117748168*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Plot making use of styles", "Section",
 CellChangeTimes->{{3.5662457857829647`*^9, 3.566245810605402*^9}}],

Cell["Figure concept from M. Morrison", "Text",
 CellChangeTimes->{{3.566262320526925*^9, 3.566262370223939*^9}, {
  3.566339205731743*^9, 3.5663392318617797`*^9}}],

Cell["Define functions for hydrogenic atom", "Text",
 CellChangeTimes->{{3.566245834175435*^9, 3.5662458431454477`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"atomicUnits", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"hbar", "->", "1"}], ",", " ", 
     RowBox[{"me", "->", "1"}], ",", " ", 
     RowBox[{"e", "->", "1"}], ",", " ", 
     RowBox[{"a0", "->", "1"}], ",", " ", 
     RowBox[{"Eh", "->", "1"}], ",", " ", 
     RowBox[{"Ryd", "->", 
      RowBox[{"1", "/", "2"}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"radFnH", "[", 
     RowBox[{"n_", ",", " ", "l_", ",", " ", 
      RowBox[{"Z_:", "1"}]}], "]"}], "[", "r_", "]"}], " ", ":=", "\n", 
   RowBox[{
    RowBox[{"2", "/", 
     RowBox[{"n", "^", "2"}]}], " ", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"Z", "/", "a0"}], ")"}], "^", 
     RowBox[{"(", 
      RowBox[{"3", "/", "2"}], ")"}]}], " ", 
    RowBox[{"Sqrt", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"n", "-", "l", "-", "1"}], ")"}], "!"}], "/", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"n", "+", "l"}], ")"}], "!"}]}], "]"}], " ", "*", "\n", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"2", "/", "n"}], ")"}], 
       RowBox[{"(", 
        RowBox[{"Z", " ", 
         RowBox[{"r", "/", "a0"}]}], ")"}]}], ")"}], "^", "l"}], " ", "*", 
    " ", 
    RowBox[{"Exp", "[", 
     RowBox[{"-", 
      RowBox[{"(", 
       RowBox[{"Z", " ", 
        RowBox[{"r", "/", 
         RowBox[{"(", 
          RowBox[{"n", " ", "a0"}], ")"}]}]}], ")"}]}], "]"}], " ", "*", 
    RowBox[{"LaguerreL", "[", 
     RowBox[{
      RowBox[{"n", "-", "l", "-", "1"}], ",", " ", 
      RowBox[{
       RowBox[{"2", "*", "l"}], "+", "1"}], ",", " ", 
      RowBox[{"(", 
       RowBox[{"2", " ", "Z", " ", 
        RowBox[{"r", "/", 
         RowBox[{"(", 
          RowBox[{"n", " ", "a0"}], ")"}]}]}], ")"}]}], "]"}]}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"uFnH", "[", 
     RowBox[{"n_", ",", " ", "l_", ",", " ", 
      RowBox[{"Z_:", "1"}]}], "]"}], "[", "r_", "]"}], " ", ":=", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"radFnH", "[", 
      RowBox[{"n", ",", "l", ",", "Z"}], "]"}], "[", "r", "]"}], "*", "r"}]}],
   " ", ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ufnHForPlot", "[", 
     RowBox[{"Orbital", ":", 
      RowBox[{"{", 
       RowBox[{"n_", ",", "l_"}], "}"}]}], "]"}], "[", "r_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{
      RowBox[{"uFnH", "[", 
       RowBox[{"n", ",", " ", "l"}], "]"}], "[", "r", "]"}], "/.", 
     "atomicUnits"}], ")"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.5662458138904066`*^9, 3.566245831705432*^9}, {
  3.566245864205477*^9, 3.566245934925576*^9}}],

Cell["For example, these are...", "Text",
 CellChangeTimes->{{3.5662459509055986`*^9, 3.566245956125606*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ufnHForPlot", "[", 
    RowBox[{"{", 
     RowBox[{"1", ",", "0"}], "}"}], "]"}], "[", "r", "]"}], "  ", 
  RowBox[{"(*", " ", 
   RowBox[{"for", " ", "1", "s", " ", "orbital"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ufnHForPlot", "[", 
    RowBox[{"{", 
     RowBox[{"2", ",", "0"}], "}"}], "]"}], "[", "r", "]"}], "  ", 
  RowBox[{"(*", " ", 
   RowBox[{"for", " ", "2", "s", " ", "orbital"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ufnHForPlot", "[", 
    RowBox[{"{", 
     RowBox[{"2", ",", "1"}], "}"}], "]"}], "[", "r", "]"}], "  ", 
  RowBox[{"(*", " ", 
   RowBox[{"for", " ", "2", "p", " ", "orbital"}], " ", 
   "*)"}]}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.5662459391955824`*^9, 3.566245996235662*^9}}],

Cell[BoxData[
 RowBox[{"2", " ", 
  SuperscriptBox["\[ExponentialE]", 
   RowBox[{"-", "r"}]], " ", "r"}]], "Output",
 CellChangeTimes->{3.566245946285592*^9, 3.5662459967356625`*^9, 
  3.5663369795507426`*^9, 3.566338171049635*^9, 3.579121910707354*^9, 
  3.583784426492267*^9, 3.594304593727648*^9, 3.594305122287776*^9, 
  3.6251801731775723`*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", "r"}], "/", "2"}]], " ", 
   RowBox[{"(", 
    RowBox[{"2", "-", "r"}], ")"}], " ", "r"}], 
  RowBox[{"2", " ", 
   SqrtBox["2"]}]]], "Output",
 CellChangeTimes->{3.566245946285592*^9, 3.5662459967356625`*^9, 
  3.5663369795507426`*^9, 3.566338171049635*^9, 3.579121910707354*^9, 
  3.583784426492267*^9, 3.594304593727648*^9, 3.594305122287776*^9, 
  3.6251801731775723`*^9}],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox["\[ExponentialE]", 
    RowBox[{
     RowBox[{"-", "r"}], "/", "2"}]], " ", 
   SuperscriptBox["r", "2"]}], 
  RowBox[{"2", " ", 
   SqrtBox["6"]}]]], "Output",
 CellChangeTimes->{3.566245946285592*^9, 3.5662459967356625`*^9, 
  3.5663369795507426`*^9, 3.566338171049635*^9, 3.579121910707354*^9, 
  3.583784426492267*^9, 3.594304593727648*^9, 3.594305122287776*^9, 
  3.6251801731775723`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"OrbitalLabel", "[", 
    RowBox[{"{", 
     RowBox[{"n_", ",", "l_"}], "}"}], "]"}], ":=", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{"n", ",", 
      RowBox[{"SpectroscopicLetter", "[", "l", "]"}]}], "}"}], "]"}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.566262098291012*^9, 3.566262112946237*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DefineStyle", "[", 
   RowBox[{"\"\<JQP\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FigObject", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"FontFamily", "\[Rule]", "\"\<Helvetica\>\""}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"FrameFontSize", "\[Rule]", "11"}], ",", 
         RowBox[{"PanelLetterFontSize", "\[Rule]", "12"}]}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigLabel", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"FontSize", "\[Rule]", "12"}], "}"}]}]}], 
     "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineStyle", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\"\<orbital\>\"", ",", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0"}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"FigLine", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"LineColor", "\[Rule]", "Black"}], ",", 
        RowBox[{"LineThickness", "\[Rule]", "Medium"}], ",", 
        RowBox[{"LineDashing", "\[Rule]", "None"}]}], "}"}]}], "}"}]}], "]"}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineStyle", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\"\<orbital\>\"", ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "0"}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"FigLine", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"LineColor", "\[Rule]", "Red"}], ",", 
        RowBox[{"LineThickness", "\[Rule]", "Medium"}], ",", 
        RowBox[{"LineDashing", "\[Rule]", "Large"}]}], "}"}]}], "}"}]}], 
   "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineStyle", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\"\<orbital\>\"", ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "1"}], "}"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"FigLine", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"LineColor", "\[Rule]", "Blue"}], ",", 
        RowBox[{"LineThickness", "\[Rule]", "Medium"}], ",", 
        RowBox[{"LineDashing", "\[Rule]", "Medium"}]}], "}"}]}], "}"}]}], 
   "]"}], ";"}]}], "Input",
 CellChangeTimes->{{3.5662460485107355`*^9, 3.566246051165739*^9}, {
  3.5662605601998672`*^9, 3.566260640154979*^9}, {3.566260710101144*^9, 
  3.5662608708906264`*^9}, {3.5662609185345078`*^9, 3.566261074824727*^9}, {
  3.5662622509308567`*^9, 3.5662622929140015`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Module", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"r", ",", "rMax", ",", "Orbital"}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Figure", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"FigurePanel", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SetOptionOverrides", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"\"\<wfplot\>\"", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "0"}], "}"}]}], "}"}], "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"LeftLabelPosition", "\[Rule]", "0.3"}], "}"}]}], "}"}], 
          "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"Do", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{"plot", " ", "curve"}], " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"FigLine", "\[LeftDoubleBracket]", 
              RowBox[{"{", 
               RowBox[{"\"\<wfplot\>\"", ",", "Orbital"}], "}"}], 
              "\[RightDoubleBracket]"}], "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Plot", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{"ufnHForPlot", "[", "Orbital", "]"}], "[", "r", 
                 "]"}], " ", ",", 
                RowBox[{"{", 
                 RowBox[{"r", ",", "0", ",", "15"}], "}"}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Style", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"\"\<orbital\>\"", ",", "Orbital"}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"LeftLabel", "\[Rule]", 
               RowBox[{"OrbitalLabel", "[", "Orbital", "]"}]}]}], 
             "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{"mark", " ", "extremum"}], " ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"Orbital", "[", 
                RowBox[{"[", "2", "]"}], "]"}], "\[Equal]", 
               RowBox[{
                RowBox[{"Orbital", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "-", "1"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"rMax", "=", 
                RowBox[{"r", "/.", 
                 RowBox[{"Last", "@", 
                  RowBox[{"FindMaximum", "[", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"ufnHForPlot", "[", "Orbital", "]"}], "[", "r", 
                    "]"}], ",", "r"}], "]"}]}]}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"(*", 
                RowBox[{
                 RowBox[{"Print", "[", 
                  RowBox[{
                   RowBox[{"OrbitalLabel", "[", "Orbital", "]"}], ",", 
                   "\"\< \>\"", ",", "rMax"}], "]"}], ";"}], "*)"}], 
               "\[IndentingNewLine]", 
               RowBox[{"FigLabel", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"rMax", ",", 
                   RowBox[{"Scaled", "[", "1", "]"}]}], "}"}], ",", 
                 RowBox[{"Column", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"OrbitalLabel", "[", "Orbital", "]"}], ",", 
                    "\"\<\[DoubleDownArrow]\>\""}], "}"}], ",", "Center", ",",
                    "0"}], "]"}], ",", 
                 RowBox[{"TextOffset", "\[Rule]", "Top"}], ",", 
                 RowBox[{"TextNudge", "\[Rule]", 
                  RowBox[{"-", "8"}]}]}], "]"}]}]}], "\[IndentingNewLine]", 
             "]"}], ";"}], "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"Orbital", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"1", ",", "0"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "0"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"2", ",", "1"}], "}"}]}], "}"}]}], "}"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"draw", " ", "horizontal", " ", "axis"}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"FigRule", "[", 
          RowBox[{"Horizontal", ",", "0", ",", "All"}], "]"}], ";"}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"XPlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "15"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"XTicks", "\[Rule]", 
        RowBox[{"LinTicks", "[", 
         RowBox[{"0", ",", "15", ",", "1", ",", "1"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"XFrameLabel", "\[Rule]", 
        RowBox[{"Row", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"textit", "[", "\"\<r\>\"", "]"}], ",", "\"\<   \>\"", 
           ",", "\"\<(\>\"", ",", 
           RowBox[{"Subscript", "[", 
            RowBox[{
             RowBox[{"textit", "[", "\"\<a\>\"", "]"}], ",", "\"\<0\>\""}], 
            "]"}], ",", "\"\<)\>\""}], "}"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"YPlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"YTicks", "\[Rule]", 
        RowBox[{"LinTicks", "[", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "1", ",", "0.5", ",", "5"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"YFrameLabel", "\[Rule]", 
        RowBox[{"Row", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Subscript", "[", 
            RowBox[{
             RowBox[{"textit", "[", "\"\<u\>\"", "]"}], ",", 
             RowBox[{"Row", "[", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"textit", "[", "\"\<n\>\"", "]"}], ",", "\"\<,\>\"", 
                ",", "\"\<\[ScriptL]\>\""}], "}"}], "]"}]}], "]"}], ",", 
           "\"\<(\>\"", ",", 
           RowBox[{"textit", "[", "\"\<r\>\"", "]"}], ",", "\"\<)\>\""}], 
          "}"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Style", "\[Rule]", "\"\<JQP\>\""}]}], "\[IndentingNewLine]", 
    "]"}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.56624601625569*^9, 3.566246018345693*^9}, {
   3.5662605672848773`*^9, 3.566260571449883*^9}, {3.5662611070909743`*^9, 
   3.566261166931275*^9}, {3.5662612132863398`*^9, 3.5662616541847477`*^9}, {
   3.566262117208802*^9, 3.56626214503423*^9}, {3.5662621846823387`*^9, 
   3.56626220559266*^9}, {3.566262241305709*^9, 3.56626224268073*^9}, 
   3.566262295946548*^9, {3.566262510440199*^9, 3.566262670938778*^9}, {
   3.5662627013695183`*^9, 3.56626270786589*^9}, {3.5662627821071362`*^9, 
   3.5662628975019836`*^9}, {3.566336971735129*^9, 3.566337065662894*^9}, {
   3.566337140511825*^9, 3.5663371693406763`*^9}, 3.5663376284338827`*^9, {
   3.5943046002796593`*^9, 3.594304601995662*^9}, {3.6251801581079454`*^9, 
   3.6251801647223573`*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"FindMaximum", "::", "fmgz"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Encountered a gradient that is effectively zero. The \
result returned may not be a maximum; it may be a minimum or a saddle point. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/message/FindMaximum/fmgz\\\", \
ButtonNote -> \\\"FindMaximum::fmgz\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{{3.566262664792426*^9, 3.56626267167982*^9}, {
   3.5662627058437743`*^9, 3.566262708621933*^9}, {3.5662628115138183`*^9, 
   3.5662628491106987`*^9}, 3.566262899951188*^9, {3.5663370422628527`*^9, 
   3.5663370672228966`*^9}, 3.5663371702766776`*^9, 3.5663372572780304`*^9, 
   3.5663375165504856`*^9, 3.5663376293854837`*^9, {3.5663377429848833`*^9, 
   3.5663377727029357`*^9}, {3.5663381639672227`*^9, 3.5663381740916405`*^9}, 
   3.5791219110543737`*^9, 3.583784429378272*^9, 3.5943046028224635`*^9, 
   3.6251801784659815`*^9}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {432., 306.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[Medium], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJwV2Hc81W8UB3CJShRKikohypaV7WNTGRkZ4Sf3Gte613YvGakopaxoWA0N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          "]]}, 
        {GrayLevel[0], AbsoluteThickness[Medium], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[Medium], Dashing[Large], 
         CapForm[None], JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJwV13c81d8fB3ANiRRlpUFEyd4zvFSEMsK9uNa9n7uKhIS6UopKKN+sjGwZ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          "]]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[Medium], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[Medium], Dashing[Medium], 
         CapForm[None], JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJwV13k8VF0YB3BZylL2lJSyJkooIml+shSRfZ0Z4o5tbpYoNEQlZSt7kUhR
2SpFC2khoU2LkFaEUinVK6XkPf018/08d86c5Z7nPEfJN9TRj5+Pj09zGh/f
v8+o2fPPr97ZvzaAfOdbRCFb5Rfv6dhNRpTUsgAhYmZjwq5zY48YSfzF6bOJ
R0ZTbm0L62Hoj7r76xAzJK0ECsd6GdOcQp65EAuX3S+d0htkcIdndiQSP2bY
W/qGDTOkTkSZ3STO7+5413xmhPEjccYcISUK5y9XNmePjTIaT2gZOxPnJgTP
tpD9ztAYCyw8Q7zDbrn/D70xhreTp5aUMgW2wtdLpx3GGcfdqp/EEa97d2GG
R9gvxl1r3d0/iDVqtrmLpv9m8EvUqUarUJgZb1B+9cwkI07UqFJAlQJXjK2W
PsYHFxdHeUM1Cqyv1x68E+THgvVGr3qJN3UrRkJWAAKpNWuy1SmsKOlt+aon
BEPhof2yGhTUkk1DrddNx86rOfZvieeEnphT4jADnNRbIVeXUPizmhPoHCYC
xaII//1aFD4vui15Jl4UjwsyF8QspdA3Xb1OKF0M0gJBg1HLKNx+8k7k8plZ
SNXwptKWU1h/8WJn2pgk+g4dNl24kgI0hpYY7ZSCWt/C0x76FIwK5OIGBaUx
nXXy8FEDCkt3R6mvlZVByWuLZ8ZGFCRtjaK+6M3GKtOd0q/XUhC5GXSvoH42
nnYJiDJBgX/FkYUb1skhS7pRrNeUwn9zf7cWO8xBeuWnz9MsKPQMNMx1DJPH
hFZmfMlGsn5uI1v+jsvj0NF2GW9bCvfuLmisiJ8H2S/WBsp2FK5VxwUJpCug
jBc0fN2RwvFY1NeeWYB1mZoce08K+qL9Z1LHFiF54azWFi6FGj36sBxDCUd/
+MepBFPQY/6363iSEr6HHOBPCqWgXTXd+bKCMnZOdi0J3EbWc5PWRL+pCnbe
qhNKiKOgkLXNcvVBNXCVV9+TyaEwbd6MN+/VNVG3pl1kWTOF+HUZbRFhmpBI
3BTr20rhL1f+wt86TeRVmFUV3qUwcVUrUdZWC82/OcJqj8n42fZaiFgKnhKf
VORrCu+O50cdvqGNEROJEtkJCkOycsIqVbooT+rs71vJgYzwvqrodl0YVDTt
CDfkAL/H7NtHddGfys6YvoaDI32d+Tv09VBhcljGyIwD27O5Wo+u62F/5oRL
iwMHNetn2+18vAJpt9bI7QjlIJ4ne6j7hz6ahZYc/VPFgXyvtGqa6WoYtz94
d0DbDx3iFRhxMYV90+FoLyN/XC708N88ZAHBKzrMTPcAbBLdvrtHwxrivkkS
HQ6BuFlzLdfe2BobDunffOISiBXs6RWtttaI2yDv9sgjEPLVh59cDLcGqzhN
+7ZPIAZd6lWyGqzxn3+pZe7WQMQen7ptbb8RKk1B6x5kBKLMMEW0IcoGRZFp
jQcfBEIg4Fh2Ucsm1N/cWv6bEQSPfG74jWebEBzWX+tqFoTz9/Qdej9swlvF
VW7nLIOwWee+uLKEHRbNuMHysA3CjV8/k0+62YH9Lt4hwzMIMWmOu6re24FT
eX1h8rYgTDzbY8BOtMdCG5c/xaeCsPWvvgp92gG790+pWwtw4R66r+jNOQeU
PH1a2yXEBXq75J2vOODKxFcxH2EuxJuiJE3uOCBEaN/s0FlcVCbWTYp/dEDM
epnssDlcDMw0eXZB2xGjYTLqIlpcuCqYH5i46Aj7wYO7Muy5MEnLEQ697gih
r9sUuxy5UJ0cSHjb4gjNoA2J8i5cfH+dyLvf7Qj+QOWz+R5cpJ9oDSj65Yiv
d4ZD4325aFuycd06EydEPjbr6I3gwtjQcTy52QkJTiv9/+Rwwd+aIXrxAYkb
6EWqH+binsvDBb1dTrB83PHNNp8Ljwgbc4NhJ8glxK/ILeQi8qxlZv8sZ5iX
2r4SPMXFeVVjLWM3Z9z86b486BIXi6VUvT8NO0PyReZMq04uvhzzDZ/z3RlZ
d+elKnVzcUn7eOK6P85QvhGfOP6MCwsbxao8cReUaeuMFrzkgto/95f5Cheo
r79+puUtF0WTM7MLY12Qd7TLsfQrF7Ifxlo2Sbgih5nTtVeMxiH7hUOv5rhC
eW795PeZNOQvbxAKXuSKOyrvhHzEaSzcW2CWquuKebZNV1dK0dBSNL3Z6uQK
77kF7U1yNEwd0+qQ54rtnUnzeUo0guuVq/SU3JDCfdzroU9jdJHNvcYlbqDP
rebsM6ARsX/7B3s9N7jOSH1VvYpGtHObRqiZGxQFztZOGdHY+zn4ZKWfG2Ry
rwknrqVxRLmuSLXCDYhZ9F57PY2WFLtMuRXu4NOqLBV0o9GgX5/LM3bHFd+Z
5Z+Iq3tVj7w2c0fuC9v2J+40CgwmTpxydse1cs+4fE8aof2ltQaR7vBKk02W
9CLjXT3R7VrnjmZDk88nOTTEBzkv6xvdMbfqhXuYHw2BjIe9infdEd2nM2ro
T2NksHR46Lk74uMFypoDaDRl2v2O/OOOjHU8hxYuDXq4VPEwwwOvdAMMIsJo
+ORIqPxe7wFVi8rWRVtpuDB4i73tPaD5+03mfWLk2uks9vHAz+v6TxUjaMia
Tphe3uOB/U5s9bPbaVzLs/Prvu2BH1aj56J5NGrM6oOM2z3wJenXMtEYGmWf
VUOOdXnAcjL+az5xlvlEZMA7D1Tv0LWpjaURMFqaNC7sib2XQv2fxtGQ2DBR
OcfGE0UdwX1Ne2gMSDpt0HMh8f2nJMwSaNT3VA7YeHkihDPXvJGYQ7MX7Anz
xDy5O7cu7yXxgzcPfsrxxBUTd+MD+2iku8lrzSjyRJOs45VJYr9F4a1Kpz1x
f+5Dsy37aUheUOFzq/PE2vTYFLMkEu/ct7XxlSf29HR/f55MY3XRm1kvhzwh
9UuBf00K6V+AYcWPL544r2iyuIC4/udwvxY/E8256+udUkl7822dD6kz8VWl
d9HZNBqDAydHq5czMT4QLMB3gDx/5m/aPUMmHv3HELIn9mNU3+bbyISF8nvu
h39xX5lVdCgTr990vBBOJ/3X2tKRGM3EBQHxro3EnP+aQ4t3M1E28Hc8jVhi
X2RZZzYTTcO4LJJB/m/TQ/PRo0wUBVW7WhBfnaPRJ3qKiUGmjHI8sV95jzyu
MPHx/FeMEBuH613ybGRCNiTtkFIm6b9xquP2u0yEb/SY70x89f6a1IqXTLy0
u9NQQ5yRm7v49iATMyvTenqJ/bw+33rzmfTvQJPmzCzy+9Fjf2SnsUB5toaw
iQev/MxbLsqC+MrLVALx1d0O+tYyLISHMzNPE/vLCITEq7Hwo0eg4APxmpdM
0SPaLFw8uGSHSDYNqZO1p2pXsbDnmmWOOnGDgf+bYSsW/J0qE5nEmVPXYwSd
WPC5JesVQezfNmfuQhYLjtfqopKJ12SG1Rr5sWDjV9lR+K89zzv2ziEsuH+Y
CK8mHlJWHgmJYiErsc618V/7H3nJybtYWLPjZ/yjf+3XdqiVJrPQLXHny6t/
7e9c2nQ9i4VVBWtODxOPLwjjmhSQ8Ry4LfKdOOl6jXRDCQsHX9V8niCW9x6v
X13FglfJoOu0HBrlU6upuloWzv4yNJtObFQcJ2Z4jYWjk6m1IsR30FRz6TYL
M9obKsWIPfuEWPrtLAyklC+ZSfxxt5VgbRcL55x1lv+LxyofqNJ7w0LbxuXX
hIln3XrkfP4dC8/T9z4VJC6kZCeXj7JgyRCPnCL90RZ0P3n2JwspkRUnfhLf
KC2wXTaNjRN2q5ijxPYWb8YqRdiI6csqHiLuG1Qu0pRmg8koiHhBvHWfv2X5
PDbWR2t3thPzL674vFiFjahDmi03ibNbRw6d0mKjoSh4/Xli1UBdhtpKNr6n
d3oUE18U3v6uZA0bYb74e4DYovxKurIFG1tnpOnziLus/qw6bstGSuAhPj/i
nykJSUVebNx84eViQJys1aqzIIA491nv/H/ze1+0pyCUPO+ZJMBPbDwra0n+
LjYyBvmk28j7dP9M5+M5yWyE8CVOlRGzN8nzDmWyYdl+cX8ScVx68d3sE2w0
ncymzYgldAbCpSvZOHLsd5sicfGjxQqZNWw0a+1r/kne90apc/TBZja+mUTn
lxEL5VybmTzERuW5aR3jZD/lrpx2ccYXNnSFqo3aiNU7zdn7xtnovxdkcZh4
g9z9MwnCXoh+EG6nS5ya93xTnKYXMgz/WLiQ/TzfSHH8j54XFmhrjMwjPtPj
cyzG2AsGbWZ4c5BG+7zhL9E2XnjPrR+hiKUKxzMiQrwQ+aBmJ5vkj7zjsh2B
F7ywbeNPXWmSj0Q2W8oUXfXC37xeqwaSr3iK0U4dzV6wngjq5xCzC150mHR7
QbzvSv55ku8W5Z54Kv3HC7PYVQwjkg9PJ+l0NVh4Y6JuN5M/kcz3el+5b5u8
8WcgdSqH5NsUoRzXxe7eqDiwT1+deMue8a5Mrjfyyo4wzUl+Xh57vds/3Rv9
g3ZnQ3fTuBxq0yPZ4w2xoQfshJ00NLTj5C37vbEtZPfxKXIe5H865xHz0Rva
9uuSeMSxQTLPBye9YXNIy2wLOT+O6QYHs6U2w9B0YxpjBw1Ka2WInsFmRIgH
u5/aRuOTYlPoy/jN4F0J0Ikl551Xccwen72bEbSXT/xJEI2HSvq5Q0mboayQ
eVWduEa1rH40czMOvI9LuU/Oyx2aB4WESjeDU9UkLUrO1xkGngXL2jbDxOHC
SVtvGsq231riJH0QXXAybdKRhluMsqLScR+M3axW0if1wunAxwbuJ31gs9j7
sCupJ8Zddtmll/sAlW2GUaTeyNV5vWvyvA8ePr407dIKGh2D+W97mnzQ1uJy
c4kODVt7qfKsAR+8747O+qBBw1yNb6Wghi+mN2akdsmT+Xz4yurdWV+UfBv5
E/eL1J9vWBG7OihkzgkVravggjlkMK9ggANdR7Ozj925OFv+9HrSTH+cLvnh
fOpXEGx/HxGTWR6AR3tM5WbnkXravKFTcW0grpxeGKtlHIQtVscLJ6kgNKUK
vJ/WFYiPFn397EguXAb4uf7Rgbj0yOqRJ1lXsbU2+l6KgUiaE3lV8/QW/Ng3
ZMq7EYBWl0mV2MvBcFUbiFHlBkDCfkNK8esQvFIYuFohFQD7T+z7OnxhmDd1
p83whj/sl1pIO+4PQ3Wn1YroSH84WYt3v5TfCrn5lWsMlvpj1sBez7ITWyHP
d0N+/Uc/fGqW0GvSCAezQ9mi5pwfHibEJlnUh0O9+sOKpAg/BF0/VCiyLgIf
BSlfHsMP07uzdFd1RqDjs8I2FzE/eNJr9p702oZap8qcna856LCc0PQd3Ia4
ecFa/13kwI7viH1S1HY4Pj0vfPQABwn671Z+mdqOqFEjWoPmoH6DXN6N7Egs
PGw/MduKA7kSD7vXqlGoE4tWvKjJwZId1rdNqqJQIJPt9kGS3NeWLaifzohG
PZgb9o5TZF8VBku2RYM/rfr7jH4KUx262wM37UBh1fz7b9spjGmU/V7SuwNq
CrxL8g0UTvy6h6WBPGyNe69oUUXu6w9L0lO5PPw+UfVtGvGH0pjXH7bwIHLR
c+B6Jbnf2mvFlm/loT/PQsmI+NaplMvqMTwIDs3iW15B4a2TlbbSQR5UzXXW
LyqjoHa2RUGulgfxkeqKuaUU7iQUcbdf4kE3ealaTwmFYI/IuqdXeKC3L2rI
J74kqO6WfY2H8e9mDAViS2ZilmQrDzfMTfIXnqAQIGwuIvacOFw5a1kxBbHX
Cu7clzy8OPii/csxCudqvp+685qY47H4AvG4V4l50lseVj6J1FpFvP8i/y6h
ER5qdvLHryuioJX6vJ3zhQfp+ZV5QsQPN19Y0PyVh+SxGw/aCinMnel7dc8P
Ht4z+VPsiK/1GYn2/+Rh/zd5KRnizZelPEx/83Cqe2tN11EKggeGTxdP8tAw
dyrsCHGZb+OPqSkezrdcsvIi/h/Nvk1S
          "]]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[Medium], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 153.}, {432., 153.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{"1","\"s\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {149.50472821908025`, 162.87430200059703`}, {0, -1},
          Automatic, {0.9672559479572937, -0.2538029376134899}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {
                 TemplateBox[{"1","\"s\""},
                  "RowDefault"]},
                {"\<\"\[DoubleDownArrow]\"\>"}
               },
               DefaultBaseStyle->"Column",
               GridBoxAlignment->{"Columns" -> {{Center}}},
               
               GridBoxItemSize->{
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
               GridBoxSpacings->{"Columns" -> {{Automatic}}, "Rows" -> {{0}}}],
              "Column"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {28.8, 298.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{"2","\"s\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {94.25262479994107, 110.51847982677171`}, {0, -1},
          Automatic, {0.7459490653918137, -0.6660029968709447}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{"2","\"p\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {205.83131699364222`, 198.8209290450269}, {0, -1},
          Automatic, {0.9464363137559698, -0.3228905449281714}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {
                 TemplateBox[{"2","\"p\""},
                  "RowDefault"]},
                {"\<\"\[DoubleDownArrow]\"\>"}
               },
               DefaultBaseStyle->"Column",
               GridBoxAlignment->{"Columns" -> {{Center}}},
               
               GridBoxItemSize->{
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
               GridBoxSpacings->{"Columns" -> {{Automatic}}, "Rows" -> {{0}}}],
              "Column"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {115.20000000268102`, 298.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{"1","\"s\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {149.50472821908025`, 162.87430200059703`}, {0, -1},
          Automatic, {0.9672559479572937, -0.2538029376134899}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {
                TemplateBox[{"1","\"s\""},
                 "RowDefault"]},
               {"\<\"\[DoubleDownArrow]\"\>"}
              },
              DefaultBaseStyle->"Column",
              GridBoxAlignment->{"Columns" -> {{Center}}},
              
              GridBoxItemSize->{
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
              GridBoxSpacings->{"Columns" -> {{Automatic}}, "Rows" -> {{0}}}],
             "Column"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {28.8, 298.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{"2","\"s\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {94.25262479994107, 110.51847982677171`}, {0, -1},
          Automatic, {0.7459490653918137, -0.6660029968709447}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{"2","\"p\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {205.83131699364222`, 198.8209290450269}, {0, -1},
          Automatic, {0.9464363137559698, -0.3228905449281714}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {
                TemplateBox[{"2","\"p\""},
                 "RowDefault"]},
               {"\<\"\[DoubleDownArrow]\"\>"}
              },
              DefaultBaseStyle->"Column",
              GridBoxAlignment->{"Columns" -> {{Center}}},
              
              GridBoxItemSize->{
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
              GridBoxSpacings->{"Columns" -> {{Automatic}}, "Rows" -> {{0}}}],
             "Column"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {115.20000000268102`, 298.}, {0, 1}, 
         Automatic, {1, 0}]},
       Frame->False,
       ImageSize->{432., 306.},
       PlotRange->{{0., 432.}, {0., 306.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {0., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{3.69, 0.}, {0., 0.}}], 
         LineBox[{{1.845, 15.299999999999983`}, {0., 15.299999999999983`}}], 
         LineBox[{{1.845, 30.599999999999994`}, {0., 30.599999999999994`}}], 
         LineBox[{{1.845, 45.900000000000006`}, {0., 45.900000000000006`}}], 
         LineBox[{{1.845, 61.2}, {0., 61.2}}], 
         LineBox[{{3.69, 76.5}, {0., 76.5}}], 
         LineBox[{{1.845, 91.8}, {0., 91.8}}], 
         LineBox[{{1.845, 107.1}, {0., 107.1}}], 
         LineBox[{{1.845, 122.4}, {0., 122.4}}], 
         LineBox[{{1.845, 137.7}, {0., 137.7}}], 
         LineBox[{{3.69, 153.}, {0., 153.}}], 
         LineBox[{{1.845, 168.3}, {0., 168.3}}], 
         LineBox[{{1.845, 183.6}, {0., 183.6}}], 
         LineBox[{{1.845, 198.9}, {0., 198.9}}], 
         LineBox[{{1.845, 214.2}, {0., 214.2}}], 
         LineBox[{{3.69, 229.5}, {0., 229.5}}], 
         LineBox[{{1.845, 244.8}, {0., 244.8}}], 
         LineBox[{{1.845, 260.1}, {0., 260.1}}], 
         LineBox[{{1.845, 275.4}, {0., 275.4}}], 
         LineBox[{{1.845, 290.70000000000005`}, {0., 290.70000000000005`}}], 
         LineBox[{{3.69, 306.}, {0., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{432., 0.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{428.31, 0.}, {432., 0.}}], 
         LineBox[{{430.155, 15.299999999999983`}, {432., 
          15.299999999999983`}}], 
         LineBox[{{430.155, 30.599999999999994`}, {432., 
          30.599999999999994`}}], 
         LineBox[{{430.155, 45.900000000000006`}, {432., 
          45.900000000000006`}}], LineBox[{{430.155, 61.2}, {432., 61.2}}], 
         LineBox[{{428.31, 76.5}, {432., 76.5}}], 
         LineBox[{{430.155, 91.8}, {432., 91.8}}], 
         LineBox[{{430.155, 107.1}, {432., 107.1}}], 
         LineBox[{{430.155, 122.4}, {432., 122.4}}], 
         LineBox[{{430.155, 137.7}, {432., 137.7}}], 
         LineBox[{{428.31, 153.}, {432., 153.}}], 
         LineBox[{{430.155, 168.3}, {432., 168.3}}], 
         LineBox[{{430.155, 183.6}, {432., 183.6}}], 
         LineBox[{{430.155, 198.9}, {432., 198.9}}], 
         LineBox[{{430.155, 214.2}, {432., 214.2}}], 
         LineBox[{{428.31, 229.5}, {432., 229.5}}], 
         LineBox[{{430.155, 244.8}, {432., 244.8}}], 
         LineBox[{{430.155, 260.1}, {432., 260.1}}], 
         LineBox[{{430.155, 275.4}, {432., 275.4}}], 
         LineBox[{{430.155, 290.70000000000005`}, {432., 
          290.70000000000005`}}], LineBox[{{428.31, 306.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {432., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 3.69}, {0., 0.}}], 
         LineBox[{{28.8, 3.69}, {28.8, 0.}}], 
         LineBox[{{57.6, 3.69}, {57.6, 0.}}], 
         LineBox[{{86.4, 3.69}, {86.4, 0.}}], 
         LineBox[{{115.2, 3.69}, {115.2, 0.}}], 
         LineBox[{{144., 3.69}, {144., 0.}}], 
         LineBox[{{172.8, 3.69}, {172.8, 0.}}], 
         LineBox[{{201.6, 3.69}, {201.6, 0.}}], 
         LineBox[{{230.4, 3.69}, {230.4, 0.}}], 
         LineBox[{{259.2, 3.69}, {259.2, 0.}}], 
         LineBox[{{288., 3.69}, {288., 0.}}], 
         LineBox[{{316.8, 3.69}, {316.8, 0.}}], 
         LineBox[{{345.6, 3.69}, {345.6, 0.}}], 
         LineBox[{{374.40000000000003`, 3.69}, {374.40000000000003`, 0.}}], 
         LineBox[{{403.2, 3.69}, {403.2, 0.}}], 
         LineBox[{{432., 3.69}, {432., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 306.}, {432., 306.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 302.31}, {0., 306.}}], 
         LineBox[{{28.8, 302.31}, {28.8, 306.}}], 
         LineBox[{{57.6, 302.31}, {57.6, 306.}}], 
         LineBox[{{86.4, 302.31}, {86.4, 306.}}], 
         LineBox[{{115.2, 302.31}, {115.2, 306.}}], 
         LineBox[{{144., 302.31}, {144., 306.}}], 
         LineBox[{{172.8, 302.31}, {172.8, 306.}}], 
         LineBox[{{201.6, 302.31}, {201.6, 306.}}], 
         LineBox[{{230.4, 302.31}, {230.4, 306.}}], 
         LineBox[{{259.2, 302.31}, {259.2, 306.}}], 
         LineBox[{{288., 302.31}, {288., 306.}}], 
         LineBox[{{316.8, 302.31}, {316.8, 306.}}], 
         LineBox[{{345.6, 302.31}, {345.6, 306.}}], 
         LineBox[{{374.40000000000003`, 302.31}, {374.40000000000003`, 
          306.}}], LineBox[{{403.2, 302.31}, {403.2, 306.}}], 
         LineBox[{{432., 302.31}, {432., 306.}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-1.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 0.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 76.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 153.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 229.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 306.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{SubscriptBox[
                TagBox[
                 StyleBox["\"u\"", FontSlant -> "Italic"], 
                 StyleForm[#, FontSlant -> "Italic"]& ], 
                TemplateBox[{
                  TagBox[
                   StyleBox["\"n\"", FontSlant -> "Italic"], 
                   StyleForm[#, FontSlant -> "Italic"]& ], "\",\"", 
                  "\"\[ScriptL]\""}, "RowDefault"]],"\"(\"",TagBox[
                StyleBox["\"r\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\")\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->11,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-31., 153.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {28.8, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {57.6, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 3\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {86.4, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 4\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {115.2, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {144., -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 6\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {172.8, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 7\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {201.6, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 8\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {230.4, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 9\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {259.2, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"10\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {288., -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"11\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {316.8, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"12\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {345.6, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"13\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {374.40000000000003`, -1.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"14\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {403.2, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"15\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"r\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\"   \"","\"(\"",
               SubscriptBox[
                TagBox[
                 StyleBox["\"a\"", FontSlant -> "Italic"], 
                 StyleForm[#, FontSlant -> "Italic"]& ], "\"0\""],"\")\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Helvetica",
            FontSize->11,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {216., -16.}, {0, 1}, Automatic, {1., 0.}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-1.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 0.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 76.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 153.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 229.5}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-1., 306.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{SubscriptBox[
               TagBox[
                StyleBox["\"u\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ], 
               TemplateBox[{
                 TagBox[
                  StyleBox["\"n\"", FontSlant -> "Italic"], 
                  StyleForm[#, FontSlant -> "Italic"]& ], "\",\"", 
                 "\"\[ScriptL]\""}, "RowDefault"]],"\"(\"",TagBox[
               StyleBox["\"r\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\")\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->11,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-31., 153.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {28.8, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {57.6, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 3\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {86.4, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 4\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {115.2, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {144., -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 6\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {172.8, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 7\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {201.6, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 8\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {230.4, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 9\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {259.2, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"10\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {288., -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"11\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {316.8, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"12\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {345.6, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"13\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {374.40000000000003`, -1.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"14\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {403.2, -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"15\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {432., -1.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"r\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\"   \"","\"(\"",
              SubscriptBox[
               TagBox[
                StyleBox["\"a\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ], "\"0\""],"\")\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Helvetica",
           FontSize->11,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {216., -16.}, {0, 1}, Automatic, {1., 0.}]},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->0.78125,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{576, 450.},
  PlotRange->{{-72, 504}, {-72., 378.}}]], "Output",
 CellChangeTimes->{
  3.566261124500605*^9, {3.566261328411501*^9, 3.56626136326155*^9}, 
   3.566261433551648*^9, {3.5662615233067737`*^9, 3.5662616334194283`*^9}, 
   3.566262124818919*^9, {3.566262282353839*^9, 3.5662622984815865`*^9}, {
   3.5662626659524927`*^9, 3.566262672849887*^9}, {3.5662627070198417`*^9, 
   3.5662627097980003`*^9}, {3.5662628126718845`*^9, 3.5662628502495003`*^9}, 
   3.5662629010899897`*^9, {3.566337042855654*^9, 3.5663370683460984`*^9}, 
   3.5663371713686795`*^9, 3.5663372583856325`*^9, 3.566337517673688*^9, 
   3.566337630508686*^9, {3.5663377441080856`*^9, 3.5663377737949376`*^9}, {
   3.5663381639672227`*^9, 3.566338175168042*^9}, 3.579121912092433*^9, 
   3.583784430407874*^9, 3.5943046037584653`*^9, 3.6251801814143867`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Multipanel plot -- Lissajous curves", "Section",
 CellChangeTimes->{{3.49212486321875*^9, 3.492124867125*^9}}],

Cell["\<\
This plot illustrates the use of different sized panels, gaps between panels, \
and custom tick marks.
In this example, the graphical output of Plot or ParametricPlot is used as \
the \[OpenCurlyDoubleQuote]curve\[CloseCurlyDoubleQuote] argument to FigLine.\
\>", "Text",
 CellChangeTimes->{{3.499022378875*^9, 3.499022384765625*^9}, {
  3.5840543448674135`*^9, 3.584054351481826*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Multipanel", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"FigLine", "[", 
            RowBox[{"ParametricPlot", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Cos", "[", 
                 RowBox[{"1", "*", "t"}], "]"}], ",", 
                RowBox[{"Cos", "[", 
                 RowBox[{
                  RowBox[{"1", "*", "t"}], "-", 
                  RowBox[{"Pi", "/", "2"}]}], "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"t", ",", "0", ",", 
                RowBox[{"2", "*", "Pi"}]}], "}"}]}], "]"}], "]"}], ";"}], 
          "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}]}], "\[IndentingNewLine]", "]"}], ";",
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"FigLine", "[", 
            RowBox[{
             RowBox[{"Plot", "[", 
              RowBox[{
               RowBox[{"Cos", "[", 
                RowBox[{"1", "*", "t"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"t", ",", "0", ",", 
                 RowBox[{"8", "*", "Pi"}]}], "}"}]}], "]"}], ",", 
             RowBox[{"LineDashing", "\[Rule]", "4"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"FigLine", "[", 
            RowBox[{"Plot", "[", 
             RowBox[{
              RowBox[{"Cos", "[", 
               RowBox[{
                RowBox[{"1", "*", "t"}], "-", 
                RowBox[{"Pi", "/", "2"}]}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"t", ",", "0", ",", 
                RowBox[{"8", "*", "Pi"}]}], "}"}]}], "]"}], "]"}], ";"}], 
          "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2"}], "}"}]}], "\[IndentingNewLine]", "]"}], ";",
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"FigLine", "[", 
            RowBox[{"ParametricPlot", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"Cos", "[", 
                 RowBox[{"1", "*", "t"}], "]"}], ",", 
                RowBox[{"Cos", "[", 
                 RowBox[{
                  RowBox[{"4", "*", "t"}], "-", 
                  RowBox[{"Pi", "/", "2"}]}], "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"t", ",", "0", ",", 
                RowBox[{"2", "*", "Pi"}]}], "}"}]}], "]"}], "]"}], ";"}], 
          "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1"}], "}"}]}], "\[IndentingNewLine]", "]"}], ";",
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"FigLine", "[", 
            RowBox[{
             RowBox[{"Plot", "[", 
              RowBox[{
               RowBox[{"Cos", "[", 
                RowBox[{"1", "*", "t"}], "]"}], ",", 
               RowBox[{"{", 
                RowBox[{"t", ",", "0", ",", 
                 RowBox[{"8", "*", "Pi"}]}], "}"}]}], "]"}], ",", 
             RowBox[{"LineDashing", "\[Rule]", "4"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"FigLine", "[", 
            RowBox[{"Plot", "[", 
             RowBox[{
              RowBox[{"Cos", "[", 
               RowBox[{
                RowBox[{"4", "*", "t"}], "-", 
                RowBox[{"Pi", "/", "2"}]}], "]"}], ",", 
              RowBox[{"{", 
               RowBox[{"t", ",", "0", ",", 
                RowBox[{"8", "*", "Pi"}]}], "}"}]}], "]"}], "]"}], ";"}], 
          "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2"}], "}"}]}], "\[IndentingNewLine]", "]"}], 
       ";"}], "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", "geometry", " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"Dimensions", "->", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2"}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"XPanelSizes", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "2.5"}], "}"}]}], ",", 
     RowBox[{"XPanelGaps", "\[Rule]", 
      RowBox[{"{", "0.1", "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"YPanelSizes", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1"}], "}"}]}], ",", 
     RowBox[{"YPanelGaps", "\[Rule]", 
      RowBox[{"{", "0.1", "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", "axes", " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"XPlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1.5"}], ",", "1.5"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "Pi"}], "/", "2"}], ",", 
          RowBox[{
           RowBox[{"8", "*", "Pi"}], "+", 
           RowBox[{"Pi", "/", "2"}]}]}], "}"}]}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"XFrameLabel", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"textit", "[", "\"\<x\>\"", "]"}], ",", 
        RowBox[{"textit", "[", "\"\<t\>\"", "]"}]}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"XTicks", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"LinTicks", "[", 
         RowBox[{
          RowBox[{"-", "2"}], ",", "2", ",", "1", ",", "5"}], "]"}], ",", 
        RowBox[{"LinTicks", "[", 
         RowBox[{
          RowBox[{"-", "Pi"}], ",", 
          RowBox[{"9", "*", "Pi"}], ",", "Pi", ",", "4", ",", 
          RowBox[{"TickLabelFunction", "\[Rule]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{"Rationalize", "[", 
               RowBox[{"#", "/", "Pi"}], "]"}], "*", "Pi"}], "&"}], ")"}]}]}],
          "]"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"YPlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1.4"}], ",", "1.4"}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"YFrameLabel", "\[Rule]", 
      RowBox[{"textit", "[", "\"\<y\>\"", "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"YTicks", "\[Rule]", 
      RowBox[{"LinTicks", "[", 
       RowBox[{
        RowBox[{"-", "2"}], ",", "2", ",", "1", ",", "5"}], "]"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", "appearance", " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"Background", "\[Rule]", "Moccasin"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"PanelLetterTextBackground", "\[Rule]", "Automatic"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"TickFontSize", "\[Rule]", "10"}], ",", "\[IndentingNewLine]", 
     RowBox[{"PanelLetterFontSize", "\[Rule]", "12"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"TopLabel", "->", "\"\<Lissajous curves\>\""}], ",", 
     RowBox[{"TopFontSize", "\[Rule]", "25"}]}], "\[IndentingNewLine]", "]"}],
    ",", "\[IndentingNewLine]", 
   RowBox[{"CanvasSize", "\[Rule]", 
    RowBox[{"2", "*", 
     RowBox[{"{", 
      RowBox[{"3.6", ",", "2.1"}], "}"}]}]}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellChangeTimes->{{3.395521502984375*^9, 3.395521519828125*^9}, {
  3.583784606781784*^9, 3.5837846268746195`*^9}, {3.5837846601806774`*^9, 
  3.5837849024491034`*^9}, {3.583784950107187*^9, 3.5837850287781253`*^9}, {
  3.583785072489402*^9, 3.5837851206466866`*^9}}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], 
      RectangleBox[{-72., -72.}, {590.4, 374.40000000000003`}]}, InsetBox[
      GraphicsBox[
       {EdgeForm[None], FaceForm[RGBColor[1., 0.894101, 0.709799]], 
        RectangleBox[{0., 158.40000000000003`}, {144., 302.40000000000003`}]},
       Frame->False,
       ImageSize->{662.4, 446.40000000000003`},
       PlotRange->{{-72., 590.4}, {-72., 
        374.40000000000003`}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], 
      RectangleBox[{0., 158.40000000000003`}, {144., 302.40000000000003`}]}, 
     InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJxd22k41N/7B3CFLG0qFJUUEi1EZay9KZJ9xs5MIc0Ms5hpL0t71kSRki1b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          "]]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}},
       Frame->False,
       ImageSize->{144., 144.},
       PlotRange->{{0., 144.}, {158.40000000000003`, 
        302.40000000000003`}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], 
      RectangleBox[{-72., -72.}, {590.4, 374.40000000000003`}]}, InsetBox[
      GraphicsBox[{InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{"\"(\"","\"a\"","\")\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->RGBColor[1., 0.894101, 0.709799],
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {15., 287.4000000000001}, {0, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{"\"(\"","\"a\"","\")\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {15., 287.4000000000001}, {0, 0}, Automatic, {
         1, 0}]},
       Frame->False,
       ImageSize->{662.4, 446.40000000000003`},
       PlotRange->{{-72., 590.4}, {-72., 
        374.40000000000003`}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], 
      RectangleBox[{-72., -72.}, {590.4, 374.40000000000003`}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 158.40000000000003`}, {0., 302.40000000000003`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0.72, 158.40000000000003`}, {0., 158.40000000000003`}}], 
         LineBox[{{0.72, 168.6857142857143}, {0., 168.6857142857143}}], 
         LineBox[{{1.44, 178.9714285714286}, {0., 178.9714285714286}}], 
         LineBox[{{0.72, 189.25714285714287`}, {0., 189.25714285714287`}}], 
         LineBox[{{0.72, 199.54285714285717`}, {0., 199.54285714285717`}}], 
         LineBox[{{0.72, 209.82857142857145`}, {0., 209.82857142857145`}}], 
         LineBox[{{0.72, 220.11428571428576`}, {0., 220.11428571428576`}}], 
         LineBox[{{1.44, 230.40000000000003`}, {0., 230.40000000000003`}}], 
         LineBox[{{0.72, 240.6857142857143}, {0., 240.6857142857143}}], 
         LineBox[{{0.72, 250.97142857142862`}, {0., 250.97142857142862`}}], 
         LineBox[{{0.72, 261.25714285714287`}, {0., 261.25714285714287`}}], 
         LineBox[{{0.72, 271.5428571428572}, {0., 271.5428571428572}}], 
         LineBox[{{1.44, 281.8285714285715}, {0., 281.8285714285715}}], 
         LineBox[{{0.72, 292.11428571428576`}, {0., 292.11428571428576`}}], 
         LineBox[{{0.72, 302.40000000000003`}, {0., 302.40000000000003`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{144., 158.40000000000003`}, {144., 302.40000000000003`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{143.28, 158.40000000000003`}, {144., 
          158.40000000000003`}}], 
         LineBox[{{143.28, 168.6857142857143}, {144., 168.6857142857143}}], 
         LineBox[{{142.56, 178.9714285714286}, {144., 178.9714285714286}}], 
         LineBox[{{143.28, 189.25714285714287`}, {144., 
          189.25714285714287`}}], 
         LineBox[{{143.28, 199.54285714285717`}, {144., 
          199.54285714285717`}}], 
         LineBox[{{143.28, 209.82857142857145`}, {144., 
          209.82857142857145`}}], 
         LineBox[{{143.28, 220.11428571428576`}, {144., 
          220.11428571428576`}}], 
         LineBox[{{142.56, 230.40000000000003`}, {144., 
          230.40000000000003`}}], 
         LineBox[{{143.28, 240.6857142857143}, {144., 240.6857142857143}}], 
         LineBox[{{143.28, 250.97142857142862`}, {144., 
          250.97142857142862`}}], 
         LineBox[{{143.28, 261.25714285714287`}, {144., 
          261.25714285714287`}}], 
         LineBox[{{143.28, 271.5428571428572}, {144., 271.5428571428572}}], 
         LineBox[{{142.56, 281.8285714285715}, {144., 281.8285714285715}}], 
         LineBox[{{143.28, 292.11428571428576`}, {144., 
          292.11428571428576`}}], 
         LineBox[{{143.28, 302.40000000000003`}, {144., 
          302.40000000000003`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 158.40000000000003`}, {144., 158.40000000000003`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{4.800000000000011, 159.12000000000003`}, {
          4.800000000000011, 158.40000000000003`}}], 
         LineBox[{{14.400000000000006`, 159.12000000000003`}, {
          14.400000000000006`, 158.40000000000003`}}], 
         LineBox[{{24., 159.84000000000003`}, {24., 158.40000000000003`}}], 
         LineBox[{{33.599999999999994`, 159.12000000000003`}, {
          33.599999999999994`, 158.40000000000003`}}], 
         LineBox[{{43.2, 159.12000000000003`}, {43.2, 158.40000000000003`}}], 
         LineBox[{{52.8, 159.12000000000003`}, {52.8, 158.40000000000003`}}], 
         LineBox[{{62.4, 159.12000000000003`}, {62.4, 158.40000000000003`}}], 
         LineBox[{{72., 159.84000000000003`}, {72., 158.40000000000003`}}], 
         LineBox[{{81.6, 159.12000000000003`}, {81.6, 158.40000000000003`}}], 
         LineBox[{{91.2, 159.12000000000003`}, {91.2, 158.40000000000003`}}], 
         LineBox[{{100.8, 159.12000000000003`}, {100.8, 
          158.40000000000003`}}], 
         LineBox[{{110.4, 159.12000000000003`}, {110.4, 
          158.40000000000003`}}], 
         LineBox[{{120., 159.84000000000003`}, {120., 158.40000000000003`}}], 
         LineBox[{{129.6, 159.12000000000003`}, {129.6, 
          158.40000000000003`}}], 
         LineBox[{{139.2, 159.12000000000003`}, {139.2, 
          158.40000000000003`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 302.40000000000003`}, {144., 302.40000000000003`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{4.800000000000011, 301.68}, {4.800000000000011, 
          302.40000000000003`}}], 
         LineBox[{{14.400000000000006`, 301.68}, {14.400000000000006`, 
          302.40000000000003`}}], 
         LineBox[{{24., 300.96000000000004`}, {24., 302.40000000000003`}}], 
         LineBox[{{33.599999999999994`, 301.68}, {33.599999999999994`, 
          302.40000000000003`}}], 
         LineBox[{{43.2, 301.68}, {43.2, 302.40000000000003`}}], 
         LineBox[{{52.8, 301.68}, {52.8, 302.40000000000003`}}], 
         LineBox[{{62.4, 301.68}, {62.4, 302.40000000000003`}}], 
         LineBox[{{72., 300.96000000000004`}, {72., 302.40000000000003`}}], 
         LineBox[{{81.6, 301.68}, {81.6, 302.40000000000003`}}], 
         LineBox[{{91.2, 301.68}, {91.2, 302.40000000000003`}}], 
         LineBox[{{100.8, 301.68}, {100.8, 302.40000000000003`}}], 
         LineBox[{{110.4, 301.68}, {110.4, 302.40000000000003`}}], 
         LineBox[{{120., 300.96000000000004`}, {120., 302.40000000000003`}}], 
         LineBox[{{129.6, 301.68}, {129.6, 302.40000000000003`}}], 
         LineBox[{{139.2, 301.68}, {139.2, 302.40000000000003`}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 178.9714285714286}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 230.40000000000003`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 281.8285714285715}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              StyleBox["\<\"y\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-13., 230.40000000000003`}, {0, -1}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 178.9714285714286}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 230.40000000000003`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 281.8285714285715}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             StyleBox["\<\"y\"\>",
              FontSlant->"Italic"],
             StyleForm[#, FontSlant -> "Italic"]& ],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-13., 230.40000000000003`}, {0, -1}, 
         Automatic, {6.123233995736766*^-17, 1.}]},
       Frame->False,
       ImageSize->{662.4, 446.40000000000003`},
       PlotRange->{{-72., 590.4}, {-72., 
        374.40000000000003`}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], 
      RectangleBox[{-72., -72.}, {590.4, 374.40000000000003`}]}, InsetBox[
      GraphicsBox[
       {EdgeForm[None], FaceForm[RGBColor[1., 0.894101, 0.709799]], 
        RectangleBox[{158.4, 158.40000000000003`}, \
{518.4000000000001, 302.40000000000003`}]},
       Frame->False,
       ImageSize->{662.4, 446.40000000000003`},
       PlotRange->{{-72., 590.4}, {-72., 
        374.40000000000003`}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], 
      RectangleBox[{158.4, 158.40000000000003`}, \
{518.4000000000001, 302.40000000000003`}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[4], CapForm[
         None], JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJw9nGk4VH8fxrVQKolKSBEpSUopIXWTNmRLWqxJZ8wMZjFjGGMsoZJEShKS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          "]]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJwVm3k4lG0UximkkJStKFJRKiS0kO4UEV9JSqWQmIUZ5jVjzBgziFRCEinZ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          "]]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}},
       Frame->False,
       ImageSize->{360.0000000000001, 144.},
       PlotRange->{{158.4, 518.4000000000001}, {158.40000000000003`, 
        302.40000000000003`}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], 
      RectangleBox[{-72., -72.}, {590.4, 374.40000000000003`}]}, InsetBox[
      GraphicsBox[{InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{"\"(\"","\"b\"","\")\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->RGBColor[1., 0.894101, 0.709799],
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {173.4, 287.4000000000001}, {0, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{"\"(\"","\"b\"","\")\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {173.4, 287.4000000000001}, {0, 0}, 
         Automatic, {1, 0}]},
       Frame->False,
       ImageSize->{662.4, 446.40000000000003`},
       PlotRange->{{-72., 590.4}, {-72., 
        374.40000000000003`}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], 
      RectangleBox[{-72., -72.}, {590.4, 374.40000000000003`}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{158.4, 158.40000000000003`}, {158.4, 
          302.40000000000003`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{159.66, 158.40000000000003`}, {158.4, 
          158.40000000000003`}}], 
         LineBox[{{159.66, 168.6857142857143}, {158.4, 168.6857142857143}}], 
         LineBox[{{160.92000000000002`, 178.9714285714286}, {158.4, 
          178.9714285714286}}], 
         LineBox[{{159.66, 189.25714285714287`}, {158.4, 
          189.25714285714287`}}], 
         LineBox[{{159.66, 199.54285714285717`}, {158.4, 
          199.54285714285717`}}], 
         LineBox[{{159.66, 209.82857142857145`}, {158.4, 
          209.82857142857145`}}], 
         LineBox[{{159.66, 220.11428571428576`}, {158.4, 
          220.11428571428576`}}], 
         LineBox[{{160.92000000000002`, 230.40000000000003`}, {158.4, 
          230.40000000000003`}}], 
         LineBox[{{159.66, 240.6857142857143}, {158.4, 240.6857142857143}}], 
         LineBox[{{159.66, 250.97142857142862`}, {158.4, 
          250.97142857142862`}}], 
         LineBox[{{159.66, 261.25714285714287`}, {158.4, 
          261.25714285714287`}}], 
         LineBox[{{159.66, 271.5428571428572}, {158.4, 271.5428571428572}}], 
         LineBox[{{160.92000000000002`, 281.8285714285715}, {158.4, 
          281.8285714285715}}], 
         LineBox[{{159.66, 292.11428571428576`}, {158.4, 
          292.11428571428576`}}], 
         LineBox[{{159.66, 302.40000000000003`}, {158.4, 
          302.40000000000003`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{518.4000000000001, 158.40000000000003`}, {
          518.4000000000001, 302.40000000000003`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{517.1400000000001, 158.40000000000003`}, {
          518.4000000000001, 158.40000000000003`}}], 
         LineBox[{{517.1400000000001, 168.6857142857143}, {518.4000000000001, 
          168.6857142857143}}], 
         LineBox[{{515.8800000000001, 178.9714285714286}, {518.4000000000001, 
          178.9714285714286}}], 
         LineBox[{{517.1400000000001, 189.25714285714287`}, {
          518.4000000000001, 189.25714285714287`}}], 
         LineBox[{{517.1400000000001, 199.54285714285717`}, {
          518.4000000000001, 199.54285714285717`}}], 
         LineBox[{{517.1400000000001, 209.82857142857145`}, {
          518.4000000000001, 209.82857142857145`}}], 
         LineBox[{{517.1400000000001, 220.11428571428576`}, {
          518.4000000000001, 220.11428571428576`}}], 
         LineBox[{{515.8800000000001, 230.40000000000003`}, {
          518.4000000000001, 230.40000000000003`}}], 
         LineBox[{{517.1400000000001, 240.6857142857143}, {518.4000000000001, 
          240.6857142857143}}], 
         LineBox[{{517.1400000000001, 250.97142857142862`}, {
          518.4000000000001, 250.97142857142862`}}], 
         LineBox[{{517.1400000000001, 261.25714285714287`}, {
          518.4000000000001, 261.25714285714287`}}], 
         LineBox[{{517.1400000000001, 271.5428571428572}, {518.4000000000001, 
          271.5428571428572}}], 
         LineBox[{{515.8800000000001, 281.8285714285715}, {518.4000000000001, 
          281.8285714285715}}], 
         LineBox[{{517.1400000000001, 292.11428571428576`}, {
          518.4000000000001, 292.11428571428576`}}], 
         LineBox[{{517.1400000000001, 302.40000000000003`}, {
          518.4000000000001, 302.40000000000003`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{158.4, 158.40000000000003`}, {518.4000000000001, 
          158.40000000000003`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{158.4, 159.66000000000003`}, {158.4, 
          158.40000000000003`}}], 
         LineBox[{{168.4, 159.66000000000003`}, {168.4, 
          158.40000000000003`}}], 
         LineBox[{{178.4, 160.92000000000004`}, {178.4, 
          158.40000000000003`}}], 
         LineBox[{{188.4, 159.66000000000003`}, {188.4, 
          158.40000000000003`}}], 
         LineBox[{{198.4, 159.66000000000003`}, {198.4, 
          158.40000000000003`}}], 
         LineBox[{{208.4, 159.66000000000003`}, {208.4, 
          158.40000000000003`}}], 
         LineBox[{{218.4, 160.92000000000004`}, {218.4, 
          158.40000000000003`}}], 
         LineBox[{{228.4, 159.66000000000003`}, {228.4, 
          158.40000000000003`}}], 
         LineBox[{{238.4, 159.66000000000003`}, {238.4, 
          158.40000000000003`}}], 
         LineBox[{{248.4, 159.66000000000003`}, {248.4, 
          158.40000000000003`}}], 
         LineBox[{{258.4, 160.92000000000004`}, {258.4, 
          158.40000000000003`}}], 
         LineBox[{{268.4, 159.66000000000003`}, {268.4, 
          158.40000000000003`}}], 
         LineBox[{{278.4, 159.66000000000003`}, {278.4, 
          158.40000000000003`}}], 
         LineBox[{{288.4, 159.66000000000003`}, {288.4, 
          158.40000000000003`}}], 
         LineBox[{{298.4, 160.92000000000004`}, {298.4, 
          158.40000000000003`}}], 
         LineBox[{{308.40000000000003`, 159.66000000000003`}, {
          308.40000000000003`, 158.40000000000003`}}], 
         LineBox[{{318.4, 159.66000000000003`}, {318.4, 
          158.40000000000003`}}], 
         LineBox[{{328.4, 159.66000000000003`}, {328.4, 
          158.40000000000003`}}], 
         LineBox[{{338.4, 160.92000000000004`}, {338.4, 
          158.40000000000003`}}], 
         LineBox[{{348.40000000000003`, 159.66000000000003`}, {
          348.40000000000003`, 158.40000000000003`}}], 
         LineBox[{{358.4, 159.66000000000003`}, {358.4, 
          158.40000000000003`}}], 
         LineBox[{{368.4, 159.66000000000003`}, {368.4, 
          158.40000000000003`}}], 
         LineBox[{{378.4, 160.92000000000004`}, {378.4, 
          158.40000000000003`}}], 
         LineBox[{{388.40000000000003`, 159.66000000000003`}, {
          388.40000000000003`, 158.40000000000003`}}], 
         LineBox[{{398.4, 159.66000000000003`}, {398.4, 
          158.40000000000003`}}], 
         LineBox[{{408.4, 159.66000000000003`}, {408.4, 
          158.40000000000003`}}], 
         LineBox[{{418.4, 160.92000000000004`}, {418.4, 
          158.40000000000003`}}], 
         LineBox[{{428.40000000000003`, 159.66000000000003`}, {
          428.40000000000003`, 158.40000000000003`}}], 
         LineBox[{{438.4000000000001, 159.66000000000003`}, {
          438.4000000000001, 158.40000000000003`}}], 
         LineBox[{{448.4, 159.66000000000003`}, {448.4, 
          158.40000000000003`}}], 
         LineBox[{{458.4, 160.92000000000004`}, {458.4, 
          158.40000000000003`}}], 
         LineBox[{{468.4, 159.66000000000003`}, {468.4, 
          158.40000000000003`}}], 
         LineBox[{{478.4, 159.66000000000003`}, {478.4, 
          158.40000000000003`}}], 
         LineBox[{{488.4, 159.66000000000003`}, {488.4, 
          158.40000000000003`}}], 
         LineBox[{{498.4, 160.92000000000004`}, {498.4, 
          158.40000000000003`}}], 
         LineBox[{{508.4000000000001, 159.66000000000003`}, {
          508.4000000000001, 158.40000000000003`}}], 
         LineBox[{{518.4000000000001, 159.66000000000003`}, {
          518.4000000000001, 158.40000000000003`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{158.4, 302.40000000000003`}, {518.4000000000001, 
          302.40000000000003`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{158.4, 301.14000000000004`}, {158.4, 
          302.40000000000003`}}], 
         LineBox[{{168.4, 301.14000000000004`}, {168.4, 
          302.40000000000003`}}], 
         LineBox[{{178.4, 299.88000000000005`}, {178.4, 
          302.40000000000003`}}], 
         LineBox[{{188.4, 301.14000000000004`}, {188.4, 
          302.40000000000003`}}], 
         LineBox[{{198.4, 301.14000000000004`}, {198.4, 
          302.40000000000003`}}], 
         LineBox[{{208.4, 301.14000000000004`}, {208.4, 
          302.40000000000003`}}], 
         LineBox[{{218.4, 299.88000000000005`}, {218.4, 
          302.40000000000003`}}], 
         LineBox[{{228.4, 301.14000000000004`}, {228.4, 
          302.40000000000003`}}], 
         LineBox[{{238.4, 301.14000000000004`}, {238.4, 
          302.40000000000003`}}], 
         LineBox[{{248.4, 301.14000000000004`}, {248.4, 
          302.40000000000003`}}], 
         LineBox[{{258.4, 299.88000000000005`}, {258.4, 
          302.40000000000003`}}], 
         LineBox[{{268.4, 301.14000000000004`}, {268.4, 
          302.40000000000003`}}], 
         LineBox[{{278.4, 301.14000000000004`}, {278.4, 
          302.40000000000003`}}], 
         LineBox[{{288.4, 301.14000000000004`}, {288.4, 
          302.40000000000003`}}], 
         LineBox[{{298.4, 299.88000000000005`}, {298.4, 
          302.40000000000003`}}], 
         LineBox[{{308.40000000000003`, 301.14000000000004`}, {
          308.40000000000003`, 302.40000000000003`}}], 
         LineBox[{{318.4, 301.14000000000004`}, {318.4, 
          302.40000000000003`}}], 
         LineBox[{{328.4, 301.14000000000004`}, {328.4, 
          302.40000000000003`}}], 
         LineBox[{{338.4, 299.88000000000005`}, {338.4, 
          302.40000000000003`}}], 
         LineBox[{{348.40000000000003`, 301.14000000000004`}, {
          348.40000000000003`, 302.40000000000003`}}], 
         LineBox[{{358.4, 301.14000000000004`}, {358.4, 
          302.40000000000003`}}], 
         LineBox[{{368.4, 301.14000000000004`}, {368.4, 
          302.40000000000003`}}], 
         LineBox[{{378.4, 299.88000000000005`}, {378.4, 
          302.40000000000003`}}], 
         LineBox[{{388.40000000000003`, 301.14000000000004`}, {
          388.40000000000003`, 302.40000000000003`}}], 
         LineBox[{{398.4, 301.14000000000004`}, {398.4, 
          302.40000000000003`}}], 
         LineBox[{{408.4, 301.14000000000004`}, {408.4, 
          302.40000000000003`}}], 
         LineBox[{{418.4, 299.88000000000005`}, {418.4, 
          302.40000000000003`}}], 
         LineBox[{{428.40000000000003`, 301.14000000000004`}, {
          428.40000000000003`, 302.40000000000003`}}], 
         LineBox[{{438.4000000000001, 301.14000000000004`}, {
          438.4000000000001, 302.40000000000003`}}], 
         LineBox[{{448.4, 301.14000000000004`}, {448.4, 
          302.40000000000003`}}], 
         LineBox[{{458.4, 299.88000000000005`}, {458.4, 
          302.40000000000003`}}], 
         LineBox[{{468.4, 301.14000000000004`}, {468.4, 
          302.40000000000003`}}], 
         LineBox[{{478.4, 301.14000000000004`}, {478.4, 
          302.40000000000003`}}], 
         LineBox[{{488.4, 301.14000000000004`}, {488.4, 
          302.40000000000003`}}], 
         LineBox[{{498.4, 299.88000000000005`}, {498.4, 
          302.40000000000003`}}], 
         LineBox[{{508.4000000000001, 301.14000000000004`}, {
          508.4000000000001, 302.40000000000003`}}], 
         LineBox[{{518.4000000000001, 301.14000000000004`}, {
          518.4000000000001, 302.40000000000003`}}]}},
       Frame->False,
       ImageSize->{662.4, 446.40000000000003`},
       PlotRange->{{-72., 590.4}, {-72., 
        374.40000000000003`}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], 
      RectangleBox[{-72., -72.}, {590.4, 374.40000000000003`}]}, InsetBox[
      GraphicsBox[
       {EdgeForm[None], FaceForm[RGBColor[1., 0.894101, 0.709799]], 
        RectangleBox[{0., 0.}, {144., 144.}]},
       Frame->False,
       ImageSize->{662.4, 446.40000000000003`},
       PlotRange->{{-72., 590.4}, {-72., 
        374.40000000000003`}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {144., 144.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJwkm3k41N/bx4WEJO0lpCJKqTSYMYN3dmMfzAwz86kk+ZYsaVFJiiRKiBYh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          "]]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}},
       Frame->False,
       ImageSize->{144., 144.},
       PlotRange->{{0., 144.}, {0., 144.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], 
      RectangleBox[{-72., -72.}, {590.4, 374.40000000000003`}]}, InsetBox[
      GraphicsBox[{InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{"\"(\"","\"c\"","\")\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->RGBColor[1., 0.894101, 0.709799],
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {15., 129.}, {0, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{"\"(\"","\"c\"","\")\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {15., 129.}, {0, 0}, Automatic, {1, 0}]},
       Frame->False,
       ImageSize->{662.4, 446.40000000000003`},
       PlotRange->{{-72., 590.4}, {-72., 
        374.40000000000003`}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], 
      RectangleBox[{-72., -72.}, {590.4, 374.40000000000003`}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {0., 144.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0.72, 0.}, {0., 0.}}], 
         LineBox[{{0.72, 10.285714285714285`}, {0., 10.285714285714285`}}], 
         LineBox[{{1.44, 20.57142857142857}, {0., 20.57142857142857}}], 
         LineBox[{{0.72, 30.857142857142854`}, {0., 30.857142857142854`}}], 
         LineBox[{{0.72, 41.14285714285714}, {0., 41.14285714285714}}], 
         LineBox[{{0.72, 51.42857142857143}, {0., 51.42857142857143}}], 
         LineBox[{{0.72, 61.714285714285715`}, {0., 61.714285714285715`}}], 
         LineBox[{{1.44, 72.}, {0., 72.}}], 
         LineBox[{{0.72, 82.28571428571429}, {0., 82.28571428571429}}], 
         LineBox[{{0.72, 92.57142857142857}, {0., 92.57142857142857}}], 
         LineBox[{{0.72, 102.85714285714286`}, {0., 102.85714285714286`}}], 
         LineBox[{{0.72, 113.14285714285714`}, {0., 113.14285714285714`}}], 
         LineBox[{{1.44, 123.42857142857143`}, {0., 123.42857142857143`}}], 
         LineBox[{{0.72, 133.71428571428572`}, {0., 133.71428571428572`}}], 
         LineBox[{{0.72, 144.}, {0., 144.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{144., 0.}, {144., 144.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{143.28, 0.}, {144., 0.}}], 
         LineBox[{{143.28, 10.285714285714285`}, {144., 
          10.285714285714285`}}], 
         LineBox[{{142.56, 20.57142857142857}, {144., 20.57142857142857}}], 
         LineBox[{{143.28, 30.857142857142854`}, {144., 
          30.857142857142854`}}], 
         LineBox[{{143.28, 41.14285714285714}, {144., 41.14285714285714}}], 
         LineBox[{{143.28, 51.42857142857143}, {144., 51.42857142857143}}], 
         LineBox[{{143.28, 61.714285714285715`}, {144., 
          61.714285714285715`}}], LineBox[{{142.56, 72.}, {144., 72.}}], 
         LineBox[{{143.28, 82.28571428571429}, {144., 82.28571428571429}}], 
         LineBox[{{143.28, 92.57142857142857}, {144., 92.57142857142857}}], 
         LineBox[{{143.28, 102.85714285714286`}, {144., 
          102.85714285714286`}}], 
         LineBox[{{143.28, 113.14285714285714`}, {144., 
          113.14285714285714`}}], 
         LineBox[{{142.56, 123.42857142857143`}, {144., 
          123.42857142857143`}}], 
         LineBox[{{143.28, 133.71428571428572`}, {144., 
          133.71428571428572`}}], LineBox[{{143.28, 144.}, {144., 144.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {144., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{4.800000000000011, 0.72}, {4.800000000000011, 0.}}], 
         LineBox[{{14.400000000000006`, 0.72}, {14.400000000000006`, 0.}}], 
         LineBox[{{24., 1.44}, {24., 0.}}], 
         LineBox[{{33.599999999999994`, 0.72}, {33.599999999999994`, 0.}}], 
         LineBox[{{43.2, 0.72}, {43.2, 0.}}], 
         LineBox[{{52.8, 0.72}, {52.8, 0.}}], 
         LineBox[{{62.4, 0.72}, {62.4, 0.}}], 
         LineBox[{{72., 1.44}, {72., 0.}}], 
         LineBox[{{81.6, 0.72}, {81.6, 0.}}], 
         LineBox[{{91.2, 0.72}, {91.2, 0.}}], 
         LineBox[{{100.8, 0.72}, {100.8, 0.}}], 
         LineBox[{{110.4, 0.72}, {110.4, 0.}}], 
         LineBox[{{120., 1.44}, {120., 0.}}], 
         LineBox[{{129.6, 0.72}, {129.6, 0.}}], 
         LineBox[{{139.2, 0.72}, {139.2, 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 144.}, {144., 144.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{4.800000000000011, 143.28}, {4.800000000000011, 144.}}], 
         LineBox[{{14.400000000000006`, 143.28}, {14.400000000000006`, 
          144.}}], LineBox[{{24., 142.56}, {24., 144.}}], 
         LineBox[{{33.599999999999994`, 143.28}, {33.599999999999994`, 
          144.}}], LineBox[{{43.2, 143.28}, {43.2, 144.}}], 
         LineBox[{{52.8, 143.28}, {52.8, 144.}}], 
         LineBox[{{62.4, 143.28}, {62.4, 144.}}], 
         LineBox[{{72., 142.56}, {72., 144.}}], 
         LineBox[{{81.6, 143.28}, {81.6, 144.}}], 
         LineBox[{{91.2, 143.28}, {91.2, 144.}}], 
         LineBox[{{100.8, 143.28}, {100.8, 144.}}], 
         LineBox[{{110.4, 143.28}, {110.4, 144.}}], 
         LineBox[{{120., 142.56}, {120., 144.}}], 
         LineBox[{{129.6, 143.28}, {129.6, 144.}}], 
         LineBox[{{139.2, 143.28}, {139.2, 144.}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 20.57142857142857}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 72.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 123.42857142857143`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              StyleBox["\<\"y\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-13., 72.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {24., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {72., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {120., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              StyleBox["\<\"x\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {72., -15.}, {0, 1}, Automatic, {1., 0.}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 20.57142857142857}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 72.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 123.42857142857143`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             StyleBox["\<\"y\"\>",
              FontSlant->"Italic"],
             StyleForm[#, FontSlant -> "Italic"]& ],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-13., 72.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {24., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {72., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {120., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             StyleBox["\<\"x\"\>",
              FontSlant->"Italic"],
             StyleForm[#, FontSlant -> "Italic"]& ],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {72., -15.}, {0, 1}, Automatic, {1., 0.}]},
       Frame->False,
       ImageSize->{662.4, 446.40000000000003`},
       PlotRange->{{-72., 590.4}, {-72., 
        374.40000000000003`}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], 
      RectangleBox[{-72., -72.}, {590.4, 374.40000000000003`}]}, InsetBox[
      GraphicsBox[
       {EdgeForm[None], FaceForm[RGBColor[1., 0.894101, 0.709799]], 
        RectangleBox[{158.4, 0.}, {518.4000000000001, 144.}]},
       Frame->False,
       ImageSize->{662.4, 446.40000000000003`},
       PlotRange->{{-72., 590.4}, {-72., 
        374.40000000000003`}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{158.4, 0.}, {518.4000000000001, 144.}]}, 
     InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[4], CapForm[
         None], JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJw9nHk8VP/3x1WSKJVkS5uKkiTN2OllTXaym7lJso1ljBnDGGOJ+qQSkSRJ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          "]]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJwUWnk41F8fVaGUUsmSaJVKkpixL4eQbMm+zExEzAxmH0tZSqhUsitJKpES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          "]]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}},
       Frame->False,
       ImageSize->{360.0000000000001, 144.},
       PlotRange->{{158.4, 518.4000000000001}, {0., 
        144.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], 
      RectangleBox[{-72., -72.}, {590.4, 374.40000000000003`}]}, InsetBox[
      GraphicsBox[{InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{"\"(\"","\"d\"","\")\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->RGBColor[1., 0.894101, 0.709799],
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {173.4, 129.}, {0, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{"\"(\"","\"d\"","\")\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {173.4, 129.}, {0, 0}, Automatic, {1, 0}]},
       Frame->False,
       ImageSize->{662.4, 446.40000000000003`},
       PlotRange->{{-72., 590.4}, {-72., 
        374.40000000000003`}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], 
      RectangleBox[{-72., -72.}, {590.4, 374.40000000000003`}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{158.4, 0.}, {158.4, 144.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{159.66, 0.}, {158.4, 0.}}], 
         LineBox[{{159.66, 10.285714285714285`}, {158.4, 
          10.285714285714285`}}], 
         LineBox[{{160.92000000000002`, 20.57142857142857}, {158.4, 
          20.57142857142857}}], 
         LineBox[{{159.66, 30.857142857142854`}, {158.4, 
          30.857142857142854`}}], 
         LineBox[{{159.66, 41.14285714285714}, {158.4, 41.14285714285714}}], 
         LineBox[{{159.66, 51.42857142857143}, {158.4, 51.42857142857143}}], 
         LineBox[{{159.66, 61.714285714285715`}, {158.4, 
          61.714285714285715`}}], 
         LineBox[{{160.92000000000002`, 72.}, {158.4, 72.}}], 
         LineBox[{{159.66, 82.28571428571429}, {158.4, 82.28571428571429}}], 
         LineBox[{{159.66, 92.57142857142857}, {158.4, 92.57142857142857}}], 
         LineBox[{{159.66, 102.85714285714286`}, {158.4, 
          102.85714285714286`}}], 
         LineBox[{{159.66, 113.14285714285714`}, {158.4, 
          113.14285714285714`}}], 
         LineBox[{{160.92000000000002`, 123.42857142857143`}, {158.4, 
          123.42857142857143`}}], 
         LineBox[{{159.66, 133.71428571428572`}, {158.4, 
          133.71428571428572`}}], LineBox[{{159.66, 144.}, {158.4, 144.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{518.4000000000001, 0.}, {518.4000000000001, 144.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{517.1400000000001, 0.}, {518.4000000000001, 0.}}], 
         LineBox[{{517.1400000000001, 10.285714285714285`}, {
          518.4000000000001, 10.285714285714285`}}], 
         LineBox[{{515.8800000000001, 20.57142857142857}, {518.4000000000001, 
          20.57142857142857}}], 
         LineBox[{{517.1400000000001, 30.857142857142854`}, {
          518.4000000000001, 30.857142857142854`}}], 
         LineBox[{{517.1400000000001, 41.14285714285714}, {518.4000000000001, 
          41.14285714285714}}], 
         LineBox[{{517.1400000000001, 51.42857142857143}, {518.4000000000001, 
          51.42857142857143}}], 
         LineBox[{{517.1400000000001, 61.714285714285715`}, {
          518.4000000000001, 61.714285714285715`}}], 
         LineBox[{{515.8800000000001, 72.}, {518.4000000000001, 72.}}], 
         LineBox[{{517.1400000000001, 82.28571428571429}, {518.4000000000001, 
          82.28571428571429}}], 
         LineBox[{{517.1400000000001, 92.57142857142857}, {518.4000000000001, 
          92.57142857142857}}], 
         LineBox[{{517.1400000000001, 102.85714285714286`}, {
          518.4000000000001, 102.85714285714286`}}], 
         LineBox[{{517.1400000000001, 113.14285714285714`}, {
          518.4000000000001, 113.14285714285714`}}], 
         LineBox[{{515.8800000000001, 123.42857142857143`}, {
          518.4000000000001, 123.42857142857143`}}], 
         LineBox[{{517.1400000000001, 133.71428571428572`}, {
          518.4000000000001, 133.71428571428572`}}], 
         LineBox[{{517.1400000000001, 144.}, {518.4000000000001, 144.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{158.4, 0.}, {518.4000000000001, 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{158.4, 1.2600000000000002`}, {158.4, 0.}}], 
         LineBox[{{168.4, 1.2600000000000002`}, {168.4, 0.}}], 
         LineBox[{{178.4, 2.5200000000000005`}, {178.4, 0.}}], 
         LineBox[{{188.4, 1.2600000000000002`}, {188.4, 0.}}], 
         LineBox[{{198.4, 1.2600000000000002`}, {198.4, 0.}}], 
         LineBox[{{208.4, 1.2600000000000002`}, {208.4, 0.}}], 
         LineBox[{{218.4, 2.5200000000000005`}, {218.4, 0.}}], 
         LineBox[{{228.4, 1.2600000000000002`}, {228.4, 0.}}], 
         LineBox[{{238.4, 1.2600000000000002`}, {238.4, 0.}}], 
         LineBox[{{248.4, 1.2600000000000002`}, {248.4, 0.}}], 
         LineBox[{{258.4, 2.5200000000000005`}, {258.4, 0.}}], 
         LineBox[{{268.4, 1.2600000000000002`}, {268.4, 0.}}], 
         LineBox[{{278.4, 1.2600000000000002`}, {278.4, 0.}}], 
         LineBox[{{288.4, 1.2600000000000002`}, {288.4, 0.}}], 
         LineBox[{{298.4, 2.5200000000000005`}, {298.4, 0.}}], 
         LineBox[{{308.40000000000003`, 1.2600000000000002`}, {
          308.40000000000003`, 0.}}], 
         LineBox[{{318.4, 1.2600000000000002`}, {318.4, 0.}}], 
         LineBox[{{328.4, 1.2600000000000002`}, {328.4, 0.}}], 
         LineBox[{{338.4, 2.5200000000000005`}, {338.4, 0.}}], 
         LineBox[{{348.40000000000003`, 1.2600000000000002`}, {
          348.40000000000003`, 0.}}], 
         LineBox[{{358.4, 1.2600000000000002`}, {358.4, 0.}}], 
         LineBox[{{368.4, 1.2600000000000002`}, {368.4, 0.}}], 
         LineBox[{{378.4, 2.5200000000000005`}, {378.4, 0.}}], 
         LineBox[{{388.40000000000003`, 1.2600000000000002`}, {
          388.40000000000003`, 0.}}], 
         LineBox[{{398.4, 1.2600000000000002`}, {398.4, 0.}}], 
         LineBox[{{408.4, 1.2600000000000002`}, {408.4, 0.}}], 
         LineBox[{{418.4, 2.5200000000000005`}, {418.4, 0.}}], 
         LineBox[{{428.40000000000003`, 1.2600000000000002`}, {
          428.40000000000003`, 0.}}], 
         LineBox[{{438.4000000000001, 1.2600000000000002`}, {
          438.4000000000001, 0.}}], 
         LineBox[{{448.4, 1.2600000000000002`}, {448.4, 0.}}], 
         LineBox[{{458.4, 2.5200000000000005`}, {458.4, 0.}}], 
         LineBox[{{468.4, 1.2600000000000002`}, {468.4, 0.}}], 
         LineBox[{{478.4, 1.2600000000000002`}, {478.4, 0.}}], 
         LineBox[{{488.4, 1.2600000000000002`}, {488.4, 0.}}], 
         LineBox[{{498.4, 2.5200000000000005`}, {498.4, 0.}}], 
         LineBox[{{508.4000000000001, 1.2600000000000002`}, {
          508.4000000000001, 0.}}], 
         LineBox[{{518.4000000000001, 1.2600000000000002`}, {
          518.4000000000001, 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{158.4, 144.}, {518.4000000000001, 144.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{158.4, 142.74}, {158.4, 144.}}],
          LineBox[{{168.4, 142.74}, {168.4, 144.}}], 
         LineBox[{{178.4, 141.48}, {178.4, 144.}}], 
         LineBox[{{188.4, 142.74}, {188.4, 144.}}], 
         LineBox[{{198.4, 142.74}, {198.4, 144.}}], 
         LineBox[{{208.4, 142.74}, {208.4, 144.}}], 
         LineBox[{{218.4, 141.48}, {218.4, 144.}}], 
         LineBox[{{228.4, 142.74}, {228.4, 144.}}], 
         LineBox[{{238.4, 142.74}, {238.4, 144.}}], 
         LineBox[{{248.4, 142.74}, {248.4, 144.}}], 
         LineBox[{{258.4, 141.48}, {258.4, 144.}}], 
         LineBox[{{268.4, 142.74}, {268.4, 144.}}], 
         LineBox[{{278.4, 142.74}, {278.4, 144.}}], 
         LineBox[{{288.4, 142.74}, {288.4, 144.}}], 
         LineBox[{{298.4, 141.48}, {298.4, 144.}}], 
         LineBox[{{308.40000000000003`, 142.74}, {308.40000000000003`, 
          144.}}], LineBox[{{318.4, 142.74}, {318.4, 144.}}], 
         LineBox[{{328.4, 142.74}, {328.4, 144.}}], 
         LineBox[{{338.4, 141.48}, {338.4, 144.}}], 
         LineBox[{{348.40000000000003`, 142.74}, {348.40000000000003`, 
          144.}}], LineBox[{{358.4, 142.74}, {358.4, 144.}}], 
         LineBox[{{368.4, 142.74}, {368.4, 144.}}], 
         LineBox[{{378.4, 141.48}, {378.4, 144.}}], 
         LineBox[{{388.40000000000003`, 142.74}, {388.40000000000003`, 
          144.}}], LineBox[{{398.4, 142.74}, {398.4, 144.}}], 
         LineBox[{{408.4, 142.74}, {408.4, 144.}}], 
         LineBox[{{418.4, 141.48}, {418.4, 144.}}], 
         LineBox[{{428.40000000000003`, 142.74}, {428.40000000000003`, 
          144.}}], 
         LineBox[{{438.4000000000001, 142.74}, {438.4000000000001, 144.}}], 
         LineBox[{{448.4, 142.74}, {448.4, 144.}}], 
         LineBox[{{458.4, 141.48}, {458.4, 144.}}], 
         LineBox[{{468.4, 142.74}, {468.4, 144.}}], 
         LineBox[{{478.4, 142.74}, {478.4, 144.}}], 
         LineBox[{{488.4, 142.74}, {488.4, 144.}}], 
         LineBox[{{498.4, 141.48}, {498.4, 144.}}], 
         LineBox[{{508.4000000000001, 142.74}, {508.4000000000001, 144.}}], 
         LineBox[{{518.4000000000001, 142.74}, {518.4000000000001, 144.}}]}, 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["0",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {178.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\[Pi]",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {218.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             RowBox[{"2", " ", "\[Pi]"}],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {258.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             RowBox[{"3", " ", "\[Pi]"}],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {298.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             RowBox[{"4", " ", "\[Pi]"}],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {338.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             RowBox[{"5", " ", "\[Pi]"}],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {378.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             RowBox[{"6", " ", "\[Pi]"}],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {418.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             RowBox[{"7", " ", "\[Pi]"}],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {458.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             RowBox[{"8", " ", "\[Pi]"}],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {498.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              StyleBox["\<\"t\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {338.40000000000003`, -15.}, {0, 1}, 
         Automatic, {1., 0.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["0",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {178.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\[Pi]",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {218.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            RowBox[{"2", " ", "\[Pi]"}],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {258.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            RowBox[{"3", " ", "\[Pi]"}],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {298.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            RowBox[{"4", " ", "\[Pi]"}],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {338.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            RowBox[{"5", " ", "\[Pi]"}],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {378.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            RowBox[{"6", " ", "\[Pi]"}],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {418.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            RowBox[{"7", " ", "\[Pi]"}],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {458.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            RowBox[{"8", " ", "\[Pi]"}],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {498.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             StyleBox["\<\"t\"\>",
              FontSlant->"Italic"],
             StyleForm[#, FontSlant -> "Italic"]& ],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {338.40000000000003`, -15.}, {0, 1}, 
         Automatic, {1., 0.}]},
       Frame->False,
       ImageSize->{662.4, 446.40000000000003`},
       PlotRange->{{-72., 590.4}, {-72., 
        374.40000000000003`}}], {0, 0}, {0, 0}]}, InsetBox[
     FrameBox[
      StyleBox[
       StyleBox[
        TagBox["\<\"Lissajous curves\"\>",
         DisplayForm],
        StripOnInput->False,
        ShowAutoStyles->False,
        SingleLetterItalics->False,
        LineColor->GrayLevel[0],
        FrontFaceColor->GrayLevel[0],
        BackFaceColor->GrayLevel[0],
        GraphicsColor->GrayLevel[0],
        FontFamily->"Times",
        FontSize->25,
        FontWeight->Plain,
        FontSlant->Plain,
        FontTracking->Plain,
        FontColor->GrayLevel[0]],
       StripOnInput->False,
       ShowContents->False],
      Background->None,
      ContentPadding->False,
      FrameMargins->{{0, 0}, {0, 0}},
      FrameStyle->None,
      RoundingRadius->{0, 0},
      StripOnInput->False], {259.2, 302.40000000000003`}, {0, -1}, 
     Automatic, {1, 0}], InsetBox[
     FrameBox[
      StyleBox[
       TagBox["\<\"Lissajous curves\"\>",
        DisplayForm],
       StripOnInput->False,
       ShowAutoStyles->False,
       SingleLetterItalics->False,
       LineColor->GrayLevel[0],
       FrontFaceColor->GrayLevel[0],
       BackFaceColor->GrayLevel[0],
       GraphicsColor->GrayLevel[0],
       FontFamily->"Times",
       FontSize->25,
       FontWeight->Plain,
       FontSlant->Plain,
       FontTracking->Plain,
       FontColor->GrayLevel[0]],
      Background->None,
      ContentPadding->False,
      FrameMargins->{{0, 0}, {0, 0}},
      FrameStyle->None,
      RoundingRadius->{0, 0},
      StripOnInput->False], {259.2, 302.40000000000003`}, {0, -1}, 
     Automatic, {1, 0}]}, {}},
  AspectRatio->0.6739130434782609,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{662.4, 446.40000000000003`},
  PlotRange->{{-72., 590.4}, {-72., 374.40000000000003`}}]], "Output",
 CellChangeTimes->{{3.395521504296875*^9, 3.395521533546875*^9}, 
   3.39688018959375*^9, 3.430248063421875*^9, 3.47108972125*^9, {
   3.5837848555086207`*^9, 3.5837849053819084`*^9}, {3.5837849560819974`*^9, 
   3.58378503171093*^9}, 3.5837851234078913`*^9, 3.594304610887678*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Data plot with legend (multiple panels) -- Nuclear mass predictions\
\>", "Section",
 CellChangeTimes->{{3.4990228219375*^9, 3.499022834984375*^9}, {
  3.49903249971875*^9, 3.499032539125*^9}, {3.520946117859375*^9, 
  3.5209461505625*^9}}],

Cell["Experimental data -- entered here as a list", "Text",
 CellChangeTimes->{{3.497533748171875*^9, 3.49753375053125*^9}, {
  3.4990228745625*^9, 3.49902289484375*^9}, {3.499022967578125*^9, 
  3.4990229718125*^9}, {3.506122752222875*^9, 3.506122755910375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ExptData", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", " ", "0.", ",", 
       RowBox[{"Missing", "[", "]"}]}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"1", ",", " ", 
       RowBox[{"-", "7.363"}], ",", " ", "7.363"}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"2", ",", " ", 
       RowBox[{"-", "19.843"}], ",", " ", "12.480"}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"3", ",", " ", 
       RowBox[{"-", "27.776"}], ",", " ", "7.933"}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"4", ",", " ", 
       RowBox[{"-", "38.906"}], ",", " ", "11.13"}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"5", ",", " ", 
       RowBox[{"-", "46.321"}], ",", " ", "7.415"}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"6", ",", " ", 
       RowBox[{"-", "56.715"}], ",", " ", "10.394"}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"7", ",", " ", 
       RowBox[{"-", "63.991"}], ",", " ", "7.276"}], "}"}], ",", " ", 
     RowBox[{"{", 
      RowBox[{"8", ",", " ", 
       RowBox[{"-", "73.936"}], ",", " ", "9.945"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"%", "//", "TableForm"}]}], "Input",
 CellChangeTimes->{{3.497533772515625*^9, 3.4975337860625*^9}, {
   3.499032326171875*^9, 3.499032333359375*^9}, 3.506122816426*^9, {
   3.52474816925*^9, 3.5247481704375*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "0.`", 
     RowBox[{"Missing", "[", "]"}]},
    {"1", 
     RowBox[{"-", "7.363`"}], "7.363`"},
    {"2", 
     RowBox[{"-", "19.843`"}], "12.48`"},
    {"3", 
     RowBox[{"-", "27.776`"}], "7.933`"},
    {"4", 
     RowBox[{"-", "38.906`"}], "11.13`"},
    {"5", 
     RowBox[{"-", "46.321`"}], "7.415`"},
    {"6", 
     RowBox[{"-", "56.715`"}], "10.394`"},
    {"7", 
     RowBox[{"-", "63.991`"}], "7.276`"},
    {"8", 
     RowBox[{"-", "73.936`"}], "9.945`"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.499032330171875*^9, 3.49903233375*^9}, 
   3.506122816926*^9, 3.507512419078125*^9, 3.52053992415625*^9, 
   3.5247481208125*^9, 3.52474817240625*^9, 3.566338712838587*^9, 
   3.5791219012218113`*^9, 3.583784367789364*^9, 3.5943051338473964`*^9}]
}, Open  ]],

Cell["\<\
Theory data -- here we define a formula to calculate the data points\
\>", "Text",
 CellChangeTimes->{{3.497533795484375*^9, 3.497533798359375*^9}, {
  3.499022977921875*^9, 3.4990229785625*^9}, {3.506122759816625*^9, 
  3.506122774441625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"EGSSeniority", "[", 
    RowBox[{"G_", ",", "Omega_", ",", 
     RowBox[{"N_", "?", "EvenQ"}]}], "]"}], "=", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "1"}], "/", "4"}], "*", "G", "*", "N", "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", "*", "Omega"}], "-", "N", "+", "2"}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"EGSSeniority", "[", 
    RowBox[{"G_", ",", "Omega_", ",", 
     RowBox[{"N_", "?", "OddQ"}]}], "]"}], "=", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "1"}], "/", "4"}], "*", "G", "*", 
    RowBox[{"(", 
     RowBox[{"N", "-", "1"}], ")"}], "*", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"2", "*", "Omega"}], "-", "N", "+", "1"}], ")"}]}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"SeniorityData", "[", 
    RowBox[{"epsilon_", ",", "G_"}], "]"}], ":=", 
   RowBox[{"Table", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"N", ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"N", "*", "epsilon"}], "+", 
        RowBox[{"EGSSeniority", "[", 
         RowBox[{"G", ",", "4", ",", "N"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{"N", ">", "0"}], ",", "\[IndentingNewLine]", 
         RowBox[{"-", 
          RowBox[{"(", 
           RowBox[{"epsilon", "+", 
            RowBox[{"EGSSeniority", "[", 
             RowBox[{"G", ",", "4", ",", "N"}], "]"}], "-", 
            RowBox[{"EGSSeniority", "[", 
             RowBox[{"G", ",", "4", ",", 
              RowBox[{"N", "-", "1"}]}], "]"}]}], ")"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Missing", "[", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"N", ",", "0", ",", "8"}], "}"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.497386481109375*^9, 3.49738654365625*^9}, {
   3.499032316546875*^9, 3.499032338875*^9}, 3.506122779504125*^9, {
   3.5247481849375*^9, 3.52474818603125*^9}}],

Cell["And let us store the results...", "Text",
 CellChangeTimes->{{3.50612278101975*^9, 3.506122786316625*^9}, {
  3.506122825801*^9, 3.506122833566625*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"TheoryData", "=", 
   RowBox[{"SeniorityData", "[", 
    RowBox[{
     RowBox[{"-", "9.323"}], ",", "0.75"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"%", "//", "TableForm"}]}], "Input",
 CellChangeTimes->{{3.497386481109375*^9, 3.49738654365625*^9}, {
  3.499032316546875*^9, 3.499032338875*^9}, {3.506122779504125*^9, 
  3.506122809222875*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"0", "0.`", 
     RowBox[{"Missing", "[", "]"}]},
    {"1", 
     RowBox[{"-", "9.323`"}], "9.323`"},
    {"2", 
     RowBox[{"-", "21.646`"}], "12.323`"},
    {"3", 
     RowBox[{"-", "30.219`"}], "8.573`"},
    {"4", 
     RowBox[{"-", "41.792`"}], "11.573`"},
    {"5", 
     RowBox[{"-", "49.615`"}], "7.823`"},
    {"6", 
     RowBox[{"-", "60.438`"}], "10.823`"},
    {"7", 
     RowBox[{"-", "67.511`"}], "7.073`"},
    {"8", 
     RowBox[{"-", "77.584`"}], "10.073`"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[2.0999999999999996`]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.49903231146875*^9, 3.4990323391875*^9}, {
   3.506122809972875*^9, 3.506122834660375*^9}, 3.506122932566625*^9, 
   3.507512419140625*^9, 3.52053992815625*^9, 3.52474812084375*^9, {
   3.524748178546875*^9, 3.524748187609375*^9}, 3.5663387166761937`*^9, 
   3.5791219012608137`*^9, 3.583784188606449*^9, 3.5943051368114014`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "define", " ", "common", " ", "data", " ", "styles", " ", "in", " ", 
     "advance"}], ",", " ", 
    RowBox[{
    "to", " ", "be", " ", "used", " ", "systematically", " ", "across", " ", 
     "the", " ", "plots"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"DefineStyle", "[", 
     RowBox[{"\"\<expt\>\"", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"DataLine", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"LineDashing", "\[Rule]", "2"}], "}"}]}], ",", 
        RowBox[{"DataSymbol", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"SymbolSize", "\[Rule]", "5"}], ",", 
           RowBox[{"SymbolShape", "\[Rule]", "\"\<Cross\>\""}], ",", 
           RowBox[{"LineThickness", "\[Rule]", "1.5"}]}], "}"}]}]}], "}"}]}], 
     "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"DefineStyle", "[", 
     RowBox[{"\"\<theory\>\"", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"DataLine", "\[Rule]", 
         RowBox[{"{", "}"}]}], ",", 
        RowBox[{"DataSymbol", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"SymbolSize", "\[Rule]", "5"}], ",", 
           RowBox[{"FillColor", "\[Rule]", "Firebrick"}]}], "}"}]}]}], 
       "}"}]}], "]"}], ";"}], "\n", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"now", " ", "for", " ", "the", " ", "figure"}], "..."}], " ", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{"Figure", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Multipanel", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"panel", " ", "1"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"DataPlot", "[", 
              RowBox[{"ExptData", ",", 
               RowBox[{"DataColumns", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "2"}], "}"}]}], ",", 
               RowBox[{"Style", "\[Rule]", "\"\<expt\>\""}]}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"DataPlot", "[", 
              RowBox[{"TheoryData", ",", 
               RowBox[{"DataColumns", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "2"}], "}"}]}], ",", 
               RowBox[{"Style", "\[Rule]", "\"\<theory\>\""}]}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"DataLegend", "[", 
              RowBox[{
               RowBox[{"Scaled", "[", 
                RowBox[{"{", 
                 RowBox[{"0.1", ",", "0.45"}], "}"}], "]"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"\"\<expt\>\"", ",", "\"\<Experiment\>\""}], "}"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{"\"\<theory\>\"", ",", "\"\<Theory\>\""}], "}"}]}], 
                "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}], 
             ";"}], "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}]}], "\[IndentingNewLine]", "]"}], 
         ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"panel", " ", "2"}], "  ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"DataPlot", "[", 
              RowBox[{"ExptData", ",", 
               RowBox[{"DataColumns", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "3"}], "}"}]}], ",", 
               RowBox[{"Style", "\[Rule]", "\"\<expt\>\""}]}], "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"DataPlot", "[", 
              RowBox[{"TheoryData", ",", 
               RowBox[{"DataColumns", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"1", ",", "3"}], "}"}]}], ",", 
               RowBox[{"Style", "\[Rule]", "\"\<theory\>\""}]}], "]"}], ";"}],
             "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"2", ",", "1"}], "}"}]}], "\[IndentingNewLine]", "]"}], 
         ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Dimensions", "->", 
        RowBox[{"{", 
         RowBox[{"2", ",", "1"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"XPlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "8"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"XFrameLabel", "\[Rule]", 
        RowBox[{"textit", "[", "\"\<N\>\"", "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"XTicks", "\[Rule]", 
        RowBox[{"LinTicks", "[", 
         RowBox[{"0", ",", "8", ",", "1", ",", "1"}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"YPlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "80"}], ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"6", ",", "13"}], "}"}]}], "}"}]}], ",", 
       RowBox[{"YTicks", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Automatic", ",", 
          RowBox[{"LinTicks", "[", 
           RowBox[{"0", ",", "20", ",", "2", ",", "4"}], "]"}]}], "}"}]}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"ExtendRange", "\[Rule]", "0.03"}], ",", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
           "Here", " ", "is", " ", "an", " ", "example", " ", "of", " ", 
            "how", " ", "Mathematica", " ", "can", " ", "mysteriously", " ", 
            "mangle", " ", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"i", ".", "e", "."}], ",", " ", "recode"}], ")"}], " ", 
            "formatted", " ", "text", " ", "which", " ", "you", " ", "have", 
            " ", "typed", " ", "in", " ", "through", " ", "the", " ", 
            "notebook", " ", "interface"}], "..."}], "  ", "This", " ", "is", 
          " ", "why", " ", "I", " ", "always", " ", "use", " ", "Row"}], ",", 
         " ", "textit", ",", " ", 
         RowBox[{"etc", "."}], ",", " ", 
         RowBox[{"instead", " ", "of", " ", "WYSIWYG", " ", "formatting"}], 
         ",", " ", 
         RowBox[{"as", " ", "discussed", " ", "in", " ", "the", " ", 
          RowBox[{"guide", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"YFrameLabel", "\[Rule]", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
         "\"\<\!\(\*\nStyleBox[\\\"E\\\",\\nFontSlant->\\\"Italic\\\"]\) \
(MeV)\>\"", ",", "\[IndentingNewLine]", 
          "\"\<\!\(\*\nStyleBox[SubscriptBox[\\\"S\\\", \
\\\"n\\\"],\\nFontSlant->\\\"Italic\\\"]\) (MeV)\>\""}], 
         "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"PanelLetterPosition", "\[Rule]", 
        RowBox[{"{", "BottomLeft", "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"Background", "\[Rule]", "Moccasin"}]}], "\[IndentingNewLine]",
       "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"CanvasSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"5", ",", "5"}], "}"}]}]}], "\[IndentingNewLine]", 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.497386370734375*^9, 3.4973864339375*^9}, {
   3.49738655390625*^9, 3.49738663646875*^9}, {3.497386683296875*^9, 
   3.49738679415625*^9}, {3.49738683240625*^9, 3.49738685209375*^9}, {
   3.497386890296875*^9, 3.49738694628125*^9}, 3.49738699465625*^9, {
   3.49738712934375*^9, 3.497387178625*^9}, {3.497387243171875*^9, 
   3.497387299078125*^9}, {3.497533905109375*^9, 3.497534044890625*^9}, {
   3.497534259171875*^9, 3.497534510546875*^9}, {3.497534563609375*^9, 
   3.497534623078125*^9}, {3.497534691515625*^9, 3.49753469965625*^9}, {
   3.499032350640625*^9, 3.499032410609375*^9}, {3.506122840316625*^9, 
   3.506122851129125*^9}, {3.506122922191625*^9, 3.5061229848635*^9}, {
   3.520539933328125*^9, 3.5205401981875*^9}, {3.52054030828125*^9, 
   3.520540329546875*^9}, {3.5205405160625*^9, 3.52054052875*^9}, {
   3.520540572765625*^9, 3.520540627828125*^9}, {3.520946190484375*^9, 
   3.52094619075*^9}, {3.566338640064459*^9, 3.56633874310264*^9}, {
   3.579121905147036*^9, 3.57912191010732*^9}, {3.583784199604469*^9, 
   3.583784199604469*^9}, {3.5943051483242216`*^9, 3.5943051798206773`*^9}, {
   3.59430577749034*^9, 3.5943059113953366`*^9}}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72}, {432, 432}]}, InsetBox[
      GraphicsBox[
       {EdgeForm[None], FaceForm[RGBColor[1., 0.894101, 0.709799]], 
        RectangleBox[{0., 179.99999999999997`}, {360., 359.99999999999994`}]},
       Frame->False,
       ImageSize->{504, 504},
       PlotRange->{{-72, 432}, {-72, 432}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], 
      RectangleBox[{0., 179.99999999999997`}, {360., 359.99999999999994`}]}, 
     InsetBox[
      GraphicsBox[{
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{10.188679245283017`, 354.90566037735846`}, {
          52.64150943396226, 339.2766509433962}, {95.0943396226415, 
          312.78608490566035`}, {137.54716981132074`, 295.94716981132075`}, {
          180., 272.32216981132075`}, {222.45283018867923`, 
          256.58278301886793`}, {264.90566037735846`, 234.5200471698113}, {
          307.35849056603774`, 219.0757075471698}, {349.811320754717, 
          197.96603773584903`}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], {
          {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], 
           CapForm[None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]],
            PolygonBox[{{10.188679245283017`, 354.90566037735846`}, {
            8.067358901723376, 357.0269807209181}, {10.188679245283017`, 
            354.90566037735846`}, {8.067358901723376, 352.7843400337988}, {
            10.188679245283017`, 354.90566037735846`}, {12.30999958884266, 
            352.7843400337988}, {10.188679245283017`, 354.90566037735846`}, {
            12.30999958884266, 357.0269807209181}, {10.188679245283017`, 
            354.90566037735846`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], 
           CapForm[None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]],
            PolygonBox[{{52.64150943396226, 339.2766509433962}, {
            50.52018909040262, 341.39797128695585`}, {52.64150943396226, 
            339.2766509433962}, {50.52018909040262, 337.15533059983653`}, {
            52.64150943396226, 339.2766509433962}, {54.76282977752191, 
            337.15533059983653`}, {52.64150943396226, 339.2766509433962}, {
            54.76282977752191, 341.39797128695585`}, {52.64150943396226, 
            339.2766509433962}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], 
           CapForm[None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]],
            PolygonBox[{{95.0943396226415, 312.78608490566035`}, {
            92.97301927908185, 314.90740524922}, {95.0943396226415, 
            312.78608490566035`}, {92.97301927908185, 310.6647645621007}, {
            95.0943396226415, 312.78608490566035`}, {97.21565996620114, 
            310.6647645621007}, {95.0943396226415, 312.78608490566035`}, {
            97.21565996620114, 314.90740524922}, {95.0943396226415, 
            312.78608490566035`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], 
           CapForm[None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]],
            PolygonBox[{{137.54716981132074`, 295.94716981132075`}, {
            135.4258494677611, 298.0684901548804}, {137.54716981132074`, 
            295.94716981132075`}, {135.4258494677611, 293.8258494677611}, {
            137.54716981132074`, 295.94716981132075`}, {139.66849015488037`, 
            293.8258494677611}, {137.54716981132074`, 295.94716981132075`}, {
            139.66849015488037`, 298.0684901548804}, {137.54716981132074`, 
            295.94716981132075`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], 
           CapForm[None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]],
            PolygonBox[{{180., 272.32216981132075`}, {177.87867965644037`, 
            274.4434901548804}, {180., 272.32216981132075`}, {
            177.87867965644037`, 270.2008494677611}, {180., 
            272.32216981132075`}, {182.12132034355963`, 270.2008494677611}, {
            180., 272.32216981132075`}, {182.12132034355963`, 
            274.4434901548804}, {180., 272.32216981132075`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], 
           CapForm[None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]],
            PolygonBox[{{222.45283018867923`, 256.58278301886793`}, {
            220.3315098451196, 258.7041033624276}, {222.45283018867923`, 
            256.58278301886793`}, {220.3315098451196, 254.4614626753083}, {
            222.45283018867923`, 256.58278301886793`}, {224.57415053223886`, 
            254.4614626753083}, {222.45283018867923`, 256.58278301886793`}, {
            224.57415053223886`, 258.7041033624276}, {222.45283018867923`, 
            256.58278301886793`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], 
           CapForm[None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]],
            PolygonBox[{{264.90566037735846`, 234.5200471698113}, {
            262.7843400337988, 236.64136751337094`}, {264.90566037735846`, 
            234.5200471698113}, {262.7843400337988, 232.39872682625167`}, {
            264.90566037735846`, 234.5200471698113}, {267.0269807209181, 
            232.39872682625167`}, {264.90566037735846`, 234.5200471698113}, {
            267.0269807209181, 236.64136751337094`}, {264.90566037735846`, 
            234.5200471698113}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], 
           CapForm[None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]],
            PolygonBox[{{307.35849056603774`, 219.0757075471698}, {
            305.2371702224781, 221.19702789072943`}, {307.35849056603774`, 
            219.0757075471698}, {305.2371702224781, 216.95438720361017`}, {
            307.35849056603774`, 219.0757075471698}, {309.4798109095974, 
            216.95438720361017`}, {307.35849056603774`, 219.0757075471698}, {
            309.4798109095974, 221.19702789072943`}, {307.35849056603774`, 
            219.0757075471698}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], 
           CapForm[None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]],
            PolygonBox[{{349.811320754717, 197.96603773584903`}, {
            347.6900004111573, 200.08735807940866`}, {349.811320754717, 
            197.96603773584903`}, {347.6900004111573, 195.8447173922894}, {
            349.811320754717, 197.96603773584903`}, {351.93264109827663`, 
            195.8447173922894}, {349.811320754717, 197.96603773584903`}, {
            351.93264109827663`, 200.08735807940866`}, {349.811320754717, 
            197.96603773584903`}}]}}}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{10.188679245283017`, 354.90566037735846`}, {
          52.64150943396226, 335.1162735849056}, {95.0943396226415, 
          308.9589622641509}, {137.54716981132074`, 290.76155660377356`}, {
          180., 266.1962264150943}, {222.45283018867923`, 
          249.59080188679243`}, {264.90566037735846`, 226.61745283018865`}, {
          307.35849056603774`, 211.60400943396226`}, {349.811320754717, 
          190.22264150943394`}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[
         0.698004, 0.133305, 0.133305]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[
           0.698004, 0.133305, 0.133305]], 
           PolygonBox[{{12.498378076561234`, 355.8623689582712}, {
            11.956446198249386`, 356.67342733032484`}, {11.145387826195742`, 
            357.2153592086367}, {10.188679245283017`, 357.40566037735846`}, {
            9.231970664370293, 357.2153592086367}, {8.420912292316649, 
            356.67342733032484`}, {7.8789804140048005`, 355.8623689582712}, {
            7.6886792452830175`, 354.90566037735846`}, {7.8789804140048005`, 
            353.9489517964457}, {8.420912292316649, 353.1378934243921}, {
            9.231970664370293, 352.5959615460802}, {10.188679245283017`, 
            352.40566037735846`}, {11.145387826195742`, 352.5959615460802}, {
            11.956446198249386`, 353.1378934243921}, {12.498378076561234`, 
            353.9489517964457}, {12.688679245283017`, 
            354.90566037735846`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[
           0.698004, 0.133305, 0.133305]], 
           PolygonBox[{{54.95120826524048, 336.07298216581836`}, {
            54.40927638692863, 336.884040537872}, {53.59821801487499, 
            337.42597241618387`}, {52.64150943396226, 337.6162735849056}, {
            51.68480085304954, 337.42597241618387`}, {50.873742480995894`, 
            336.884040537872}, {50.331810602684044`, 336.07298216581836`}, {
            50.14150943396226, 335.1162735849056}, {50.331810602684044`, 
            334.1595650039929}, {50.873742480995894`, 333.34850663193924`}, {
            51.68480085304954, 332.8065747536274}, {52.64150943396226, 
            332.6162735849056}, {53.59821801487499, 332.8065747536274}, {
            54.40927638692863, 333.34850663193924`}, {54.95120826524048, 
            334.1595650039929}, {55.14150943396226, 335.1162735849056}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[
           0.698004, 0.133305, 0.133305]], 
           PolygonBox[{{97.40403845391971, 309.91567084506363`}, {
            96.86210657560787, 310.7267292171173}, {96.05104820355422, 
            311.26866109542914`}, {95.0943396226415, 311.4589622641509}, {
            94.13763104172878, 311.26866109542914`}, {93.32657266967513, 
            310.7267292171173}, {92.78464079136329, 309.91567084506363`}, {
            92.5943396226415, 308.9589622641509}, {92.78464079136329, 
            308.00225368323817`}, {93.32657266967513, 307.1911953111845}, {
            94.13763104172878, 306.64926343287266`}, {95.0943396226415, 
            306.4589622641509}, {96.05104820355422, 306.64926343287266`}, {
            96.86210657560787, 307.1911953111845}, {97.40403845391971, 
            308.00225368323817`}, {97.5943396226415, 308.9589622641509}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[
           0.698004, 0.133305, 0.133305]], 
           PolygonBox[{{139.85686864259895`, 291.7182651846863}, {
            139.3149367642871, 292.52932355673994`}, {138.50387839223347`, 
            293.0712554350518}, {137.54716981132074`, 293.26155660377356`}, {
            136.590461230408, 293.0712554350518}, {135.7794028583544, 
            292.52932355673994`}, {135.23747098004253`, 291.7182651846863}, {
            135.04716981132074`, 290.76155660377356`}, {135.23747098004253`, 
            289.8048480228608}, {135.7794028583544, 288.9937896508072}, {
            136.590461230408, 288.4518577724953}, {137.54716981132074`, 
            288.26155660377356`}, {138.50387839223347`, 288.4518577724953}, {
            139.3149367642871, 288.9937896508072}, {139.85686864259895`, 
            289.8048480228608}, {140.04716981132074`, 
            290.76155660377356`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[
           0.698004, 0.133305, 0.133305]], 
           PolygonBox[{{182.3096988312782, 267.15293499600705`}, {
            181.76776695296635`, 267.9639933680607}, {180.95670858091273`, 
            268.50592524637256`}, {180., 268.6962264150943}, {
            179.04329141908727`, 268.50592524637256`}, {178.23223304703365`, 
            267.9639933680607}, {177.6903011687218, 267.15293499600705`}, {
            177.5, 266.1962264150943}, {177.6903011687218, 
            265.2395178341816}, {178.23223304703365`, 264.42845946212793`}, {
            179.04329141908727`, 263.8865275838161}, {180., 
            263.6962264150943}, {180.95670858091273`, 263.8865275838161}, {
            181.76776695296635`, 264.42845946212793`}, {182.3096988312782, 
            265.2395178341816}, {182.5, 266.1962264150943}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[
           0.698004, 0.133305, 0.133305]], 
           PolygonBox[{{224.76252901995744`, 250.54751046770517`}, {
            224.22059714164558`, 251.3585688397588}, {223.40953876959196`, 
            251.90050071807065`}, {222.45283018867923`, 
            252.09080188679243`}, {221.4961216077665, 251.90050071807065`}, {
            220.68506323571287`, 251.3585688397588}, {220.14313135740102`, 
            250.54751046770517`}, {219.95283018867923`, 
            249.59080188679243`}, {220.14313135740102`, 248.6340933058797}, {
            220.68506323571287`, 247.82303493382608`}, {221.4961216077665, 
            247.28110305551422`}, {222.45283018867923`, 
            247.09080188679243`}, {223.40953876959196`, 
            247.28110305551422`}, {224.22059714164558`, 
            247.82303493382608`}, {224.76252901995744`, 248.6340933058797}, {
            224.95283018867923`, 249.59080188679243`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[
           0.698004, 0.133305, 0.133305]], 
           PolygonBox[{{267.2153592086367, 227.5741614111014}, {
            266.67342733032484`, 228.385219783155}, {265.8623689582712, 
            228.92715166146687`}, {264.90566037735846`, 
            229.11745283018865`}, {263.9489517964457, 228.92715166146687`}, {
            263.1378934243921, 228.385219783155}, {262.5959615460802, 
            227.5741614111014}, {262.40566037735846`, 226.61745283018865`}, {
            262.5959615460802, 225.66074424927592`}, {263.1378934243921, 
            224.8496858772223}, {263.9489517964457, 224.30775399891044`}, {
            264.90566037735846`, 224.11745283018865`}, {265.8623689582712, 
            224.30775399891044`}, {266.67342733032484`, 224.8496858772223}, {
            267.2153592086367, 225.66074424927592`}, {267.40566037735846`, 
            226.61745283018865`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[
           0.698004, 0.133305, 0.133305]], 
           PolygonBox[{{309.668189397316, 212.560718014875}, {
            309.1262575190041, 213.37177638692862`}, {308.3151991469505, 
            213.91370826524047`}, {307.35849056603774`, 
            214.10400943396226`}, {306.401781985125, 213.91370826524047`}, {
            305.59072361307136`, 213.37177638692862`}, {305.0487917347595, 
            212.560718014875}, {304.85849056603774`, 211.60400943396226`}, {
            305.0487917347595, 210.64730085304953`}, {305.59072361307136`, 
            209.8362424809959}, {306.401781985125, 209.29431060268405`}, {
            307.35849056603774`, 209.10400943396226`}, {308.3151991469505, 
            209.29431060268405`}, {309.1262575190041, 209.8362424809959}, {
            309.668189397316, 210.64730085304953`}, {309.85849056603774`, 
            211.60400943396226`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[
           0.698004, 0.133305, 0.133305]], 
           PolygonBox[{{352.1210195859952, 191.17935009034667`}, {
            351.57908770768336`, 191.9904084624003}, {350.7680293356297, 
            192.53234034071215`}, {349.811320754717, 192.72264150943394`}, {
            348.85461217380424`, 192.53234034071215`}, {348.0435538017506, 
            191.9904084624003}, {347.50162192343873`, 191.17935009034667`}, {
            347.311320754717, 190.22264150943394`}, {347.50162192343873`, 
            189.2659329285212}, {348.0435538017506, 188.4548745564676}, {
            348.85461217380424`, 187.91294267815573`}, {349.811320754717, 
            187.72264150943394`}, {350.7680293356297, 187.91294267815573`}, {
            351.57908770768336`, 188.4548745564676}, {352.1210195859952, 
            189.2659329285212}, {352.311320754717, 190.22264150943394`}}]}}}, 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {
                 TagBox[GridBox[{
                    {
                    GraphicsBox[{
                    {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[2], 
                    CapForm[None], JoinForm[{"Miter", 3.25}], 
                    LineBox[{{-10, 0}, {10, 0}}]}, 
                    {EdgeForm[{GrayLevel[0], AbsoluteThickness[1.5], 
                    Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
                    FaceForm[GrayLevel[0]], 
                    PolygonBox[{{0., 0.}, {-2.1213203435596424`, 
                    2.1213203435596424`}, {0., 
                    0.}, {-2.1213203435596424`, -2.1213203435596424`}, {0., 
                    0.}, {2.1213203435596424`, -2.1213203435596424`}, {0., 
                    0.}, {2.1213203435596424`, 2.1213203435596424`}, {0., 
                    0.}}]}},
                    ImageSize->{20, 8.},
                    PlotRange->{{-10, 10}, {-4., 4.}}], 
                    StyleBox[
                    TagBox["\<\"Experiment\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                   },
                   AutoDelete->False,
                   
                   GridBoxAlignment->{
                    "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                   
                   GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                   GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                  "Grid"]},
                {
                 TagBox[GridBox[{
                    {
                    GraphicsBox[{
                    {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
                    None], JoinForm[{"Miter", 3.25}], 
                    LineBox[{{-10, 0}, {10, 0}}]}, 
                    {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], 
                    Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
                    FaceForm[RGBColor[0.698004, 0.133305, 0.133305]], 
                    PolygonBox[{{2.309698831278217, 0.9567085809127245}, {
                    1.7677669529663687`, 1.7677669529663687`}, {
                    0.9567085809127245, 2.309698831278217}, {0., 
                    2.5}, {-0.9567085809127245, 
                    2.309698831278217}, {-1.7677669529663687`, 
                    1.7677669529663687`}, {-2.309698831278217, 
                    0.9567085809127245}, {-2.5, 
                    0.}, {-2.309698831278217, -0.9567085809127245}, \
{-1.7677669529663687`, -1.7677669529663687`}, {-0.9567085809127245, \
-2.309698831278217}, {0., -2.5}, {0.9567085809127245, -2.309698831278217}, {
                    1.7677669529663687`, -1.7677669529663687`}, {
                    2.309698831278217, -0.9567085809127245}, {2.5, 0.}}]}},
                    ImageSize->{20, 7},
                    PlotRange->NCache[{{-10, 10}, {
                    Rational[-7, 2], 
                    Rational[7, 2]}}, {{-10, 10}, {-3.5, 3.5}}]], 
                    StyleBox[
                    TagBox["\<\"Theory\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                   },
                   AutoDelete->False,
                   
                   GridBoxAlignment->{
                    "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                   
                   GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                   GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                  "Grid"]}
               },
               AutoDelete->False,
               GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Center}}},
               
               GridBoxItemSize->{
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
               GridBoxSpacings->{"Columns" -> {{
                    Rational[5, 8]}}, "Rows" -> {{
                    Rational[1, 8]}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {36., 261.}, {-1, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {
                TagBox[GridBox[{
                   {
                    GraphicsBox[{
                    {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[2], 
                    CapForm[None], JoinForm[{"Miter", 3.25}], 
                    LineBox[{{-10, 0}, {10, 0}}]}, 
                    {EdgeForm[{GrayLevel[0], AbsoluteThickness[1.5], 
                    Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
                    FaceForm[GrayLevel[0]], 
                    PolygonBox[{{0., 0.}, {-2.1213203435596424`, 
                    2.1213203435596424`}, {0., 
                    0.}, {-2.1213203435596424`, -2.1213203435596424`}, {0., 
                    0.}, {2.1213203435596424`, -2.1213203435596424`}, {0., 
                    0.}, {2.1213203435596424`, 2.1213203435596424`}, {0., 
                    0.}}]}},
                    ImageSize->{20, 8.},
                    PlotRange->{{-10, 10}, {-4., 4.}}], 
                    StyleBox[
                    TagBox["\<\"Experiment\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                  },
                  AutoDelete->False,
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                  
                  GridBoxItemSize->{
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                  GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                 "Grid"]},
               {
                TagBox[GridBox[{
                   {
                    GraphicsBox[{
                    {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
                    None], JoinForm[{"Miter", 3.25}], 
                    LineBox[{{-10, 0}, {10, 0}}]}, 
                    {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], 
                    Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
                    FaceForm[RGBColor[0.698004, 0.133305, 0.133305]], 
                    PolygonBox[{{2.309698831278217, 0.9567085809127245}, {
                    1.7677669529663687`, 1.7677669529663687`}, {
                    0.9567085809127245, 2.309698831278217}, {0., 
                    2.5}, {-0.9567085809127245, 
                    2.309698831278217}, {-1.7677669529663687`, 
                    1.7677669529663687`}, {-2.309698831278217, 
                    0.9567085809127245}, {-2.5, 
                    0.}, {-2.309698831278217, -0.9567085809127245}, \
{-1.7677669529663687`, -1.7677669529663687`}, {-0.9567085809127245, \
-2.309698831278217}, {0., -2.5}, {0.9567085809127245, -2.309698831278217}, {
                    1.7677669529663687`, -1.7677669529663687`}, {
                    2.309698831278217, -0.9567085809127245}, {2.5, 0.}}]}},
                    ImageSize->{20, 7},
                    PlotRange->NCache[{{-10, 10}, {
                    Rational[-7, 2], 
                    Rational[7, 2]}}, {{-10, 10}, {-3.5, 3.5}}]], 
                    StyleBox[
                    TagBox["\<\"Theory\"\>",
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                  },
                  AutoDelete->False,
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                  
                  GridBoxItemSize->{
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                  GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                 "Grid"]}
              },
              AutoDelete->False,
              GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Center}}},
              
              GridBoxItemSize->{
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
              GridBoxSpacings->{"Columns" -> {{
                   Rational[5, 8]}}, "Rows" -> {{
                   Rational[1, 8]}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {36., 261.}, {-1, 1}, Automatic, {1, 0}]},
       Frame->False,
       ImageSize->{360., 179.99999999999997`},
       PlotRange->{{0., 360.}, {179.99999999999997`, 
        359.99999999999994`}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {432, 432}]}, InsetBox[
      GraphicsBox[{InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{"\"(\"","\"a\"","\")\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {15., 194.99999999999997`}, {0, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{"\"(\"","\"a\"","\")\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {15., 194.99999999999997`}, {0, 0}, 
         Automatic, {1, 0}]},
       Frame->False,
       ImageSize->{504, 504},
       PlotRange->{{-72, 432}, {-72, 432}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {432, 432}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 179.99999999999997`}, {0., 359.99999999999994`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{2.7, 185.0943396226415}, {0., 185.0943396226415}}], 
         LineBox[{{1.35, 195.7075471698113}, {0., 195.7075471698113}}], 
         LineBox[{{1.35, 206.32075471698113`}, {0., 206.32075471698113`}}], 
         LineBox[{{1.35, 216.93396226415092`}, {0., 216.93396226415092`}}], 
         LineBox[{{2.7, 227.54716981132074`}, {0., 227.54716981132074`}}], 
         LineBox[{{1.35, 238.16037735849056`}, {0., 238.16037735849056`}}], 
         LineBox[{{1.35, 248.77358490566036`}, {0., 248.77358490566036`}}], 
         LineBox[{{1.35, 259.38679245283015`}, {0., 259.38679245283015`}}], 
         LineBox[{{2.7, 270.}, {0., 270.}}], 
         LineBox[{{1.35, 280.6132075471698}, {0., 280.6132075471698}}], 
         LineBox[{{1.35, 291.2264150943396}, {0., 291.2264150943396}}], 
         LineBox[{{1.35, 301.83962264150944`}, {0., 301.83962264150944`}}], 
         LineBox[{{2.7, 312.45283018867923`}, {0., 312.45283018867923`}}], 
         LineBox[{{1.35, 323.066037735849}, {0., 323.066037735849}}], 
         LineBox[{{1.35, 333.6792452830188}, {0., 333.6792452830188}}], 
         LineBox[{{1.35, 344.29245283018867`}, {0., 344.29245283018867`}}], 
         LineBox[{{2.7, 354.90566037735846`}, {0., 354.90566037735846`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{360., 179.99999999999997`}, {360., 359.99999999999994`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{357.3, 185.0943396226415}, {360., 185.0943396226415}}], 
         LineBox[{{358.65, 195.7075471698113}, {360., 195.7075471698113}}], 
         LineBox[{{358.65, 206.32075471698113`}, {360., 
          206.32075471698113`}}], 
         LineBox[{{358.65, 216.93396226415092`}, {360., 
          216.93396226415092`}}], 
         LineBox[{{357.3, 227.54716981132074`}, {360., 227.54716981132074`}}],
          LineBox[{{358.65, 238.16037735849056`}, {360., 
          238.16037735849056`}}], 
         LineBox[{{358.65, 248.77358490566036`}, {360., 
          248.77358490566036`}}], 
         LineBox[{{358.65, 259.38679245283015`}, {360., 
          259.38679245283015`}}], LineBox[{{357.3, 270.}, {360., 270.}}], 
         LineBox[{{358.65, 280.6132075471698}, {360., 280.6132075471698}}], 
         LineBox[{{358.65, 291.2264150943396}, {360., 291.2264150943396}}], 
         LineBox[{{358.65, 301.83962264150944`}, {360., 
          301.83962264150944`}}], 
         LineBox[{{357.3, 312.45283018867923`}, {360., 312.45283018867923`}}],
          LineBox[{{358.65, 323.066037735849}, {360., 323.066037735849}}], 
         LineBox[{{358.65, 333.6792452830188}, {360., 333.6792452830188}}], 
         LineBox[{{358.65, 344.29245283018867`}, {360., 
          344.29245283018867`}}], 
         LineBox[{{357.3, 354.90566037735846`}, {360., 
          354.90566037735846`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 179.99999999999997`}, {360., 179.99999999999997`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{10.188679245283017`, 182.69999999999996`}, {
          10.188679245283017`, 179.99999999999997`}}], 
         LineBox[{{52.64150943396226, 182.69999999999996`}, {
          52.64150943396226, 179.99999999999997`}}], 
         LineBox[{{95.0943396226415, 182.69999999999996`}, {95.0943396226415, 
          179.99999999999997`}}], 
         LineBox[{{137.54716981132074`, 182.69999999999996`}, {
          137.54716981132074`, 179.99999999999997`}}], 
         LineBox[{{180., 182.69999999999996`}, {180., 179.99999999999997`}}], 
         LineBox[{{222.45283018867923`, 182.69999999999996`}, {
          222.45283018867923`, 179.99999999999997`}}], 
         LineBox[{{264.90566037735846`, 182.69999999999996`}, {
          264.90566037735846`, 179.99999999999997`}}], 
         LineBox[{{307.35849056603774`, 182.69999999999996`}, {
          307.35849056603774`, 179.99999999999997`}}], 
         LineBox[{{349.811320754717, 182.69999999999996`}, {349.811320754717, 
          179.99999999999997`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 359.99999999999994`}, {360., 359.99999999999994`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{10.188679245283017`, 357.29999999999995`}, {
          10.188679245283017`, 359.99999999999994`}}], 
         LineBox[{{52.64150943396226, 357.29999999999995`}, {
          52.64150943396226, 359.99999999999994`}}], 
         LineBox[{{95.0943396226415, 357.29999999999995`}, {95.0943396226415, 
          359.99999999999994`}}], 
         LineBox[{{137.54716981132074`, 357.29999999999995`}, {
          137.54716981132074`, 359.99999999999994`}}], 
         LineBox[{{180., 357.29999999999995`}, {180., 359.99999999999994`}}], 
         LineBox[{{222.45283018867923`, 357.29999999999995`}, {
          222.45283018867923`, 359.99999999999994`}}], 
         LineBox[{{264.90566037735846`, 357.29999999999995`}, {
          264.90566037735846`, 359.99999999999994`}}], 
         LineBox[{{307.35849056603774`, 357.29999999999995`}, {
          307.35849056603774`, 359.99999999999994`}}], 
         LineBox[{{349.811320754717, 357.29999999999995`}, {349.811320754717, 
          359.99999999999994`}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-80\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 185.0943396226415}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-60\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 227.54716981132074`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-40\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 270.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"-20\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 312.45283018867923`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 354.90566037735846`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"\\!\\(\\*\\nStyleBox[\\\"E\\\",\\nFontSlant->\\\"\
Italic\\\"]\\) (MeV)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-25., 269.99999999999994`}, {0, -1}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-80\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 185.0943396226415}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-60\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 227.54716981132074`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-40\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 270.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"-20\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 312.45283018867923`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 354.90566037735846`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"\\!\\(\\*\\nStyleBox[\\\"E\\\",\\nFontSlant->\\\"\
Italic\\\"]\\) (MeV)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-25., 269.99999999999994`}, {0, -1}, 
         Automatic, {6.123233995736766*^-17, 1.}]},
       Frame->False,
       ImageSize->{504, 504},
       PlotRange->{{-72, 432}, {-72, 432}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {432, 432}]}, InsetBox[
      GraphicsBox[
       {EdgeForm[None], FaceForm[RGBColor[1., 0.894101, 0.709799]], 
        RectangleBox[{0., 0.}, {360., 180.00000000000003`}]},
       Frame->False,
       ImageSize->{504, 504},
       PlotRange->{{-72, 432}, {-72, 432}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {360., 180.00000000000003`}]}, 
     InsetBox[
      GraphicsBox[{
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{52.64150943396226, 38.15902964959571}, {95.0943396226415, 
          162.29110512129378`}, {137.54716981132074`, 51.986522911051225`}, {
          180., 129.54177897574127`}, {222.45283018867923`, 
          39.420485175202174`}, {264.90566037735846`, 111.68733153638814`}, {
          307.35849056603774`, 36.048517520215626`}, {349.811320754717, 
          100.79514824797843`}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], {
          {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], 
           CapForm[None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]],
            PolygonBox[{{52.64150943396226, 38.15902964959571}, {
            50.52018909040262, 40.280349993155355`}, {52.64150943396226, 
            38.15902964959571}, {50.52018909040262, 36.037709306036064`}, {
            52.64150943396226, 38.15902964959571}, {54.76282977752191, 
            36.037709306036064`}, {52.64150943396226, 38.15902964959571}, {
            54.76282977752191, 40.280349993155355`}, {52.64150943396226, 
            38.15902964959571}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], 
           CapForm[None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]],
            PolygonBox[{{95.0943396226415, 162.29110512129378`}, {
            92.97301927908185, 164.4124254648534}, {95.0943396226415, 
            162.29110512129378`}, {92.97301927908185, 160.16978477773415`}, {
            95.0943396226415, 162.29110512129378`}, {97.21565996620114, 
            160.16978477773415`}, {95.0943396226415, 162.29110512129378`}, {
            97.21565996620114, 164.4124254648534}, {95.0943396226415, 
            162.29110512129378`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], 
           CapForm[None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]],
            PolygonBox[{{137.54716981132074`, 51.986522911051225`}, {
            135.4258494677611, 54.10784325461087}, {137.54716981132074`, 
            51.986522911051225`}, {135.4258494677611, 49.86520256749158}, {
            137.54716981132074`, 51.986522911051225`}, {139.66849015488037`, 
            49.86520256749158}, {137.54716981132074`, 51.986522911051225`}, {
            139.66849015488037`, 54.10784325461087}, {137.54716981132074`, 
            51.986522911051225`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], 
           CapForm[None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]],
            PolygonBox[{{180., 129.54177897574127`}, {177.87867965644037`, 
            131.6630993193009}, {180., 129.54177897574127`}, {
            177.87867965644037`, 127.42045863218162`}, {180., 
            129.54177897574127`}, {182.12132034355963`, 
            127.42045863218162`}, {180., 129.54177897574127`}, {
            182.12132034355963`, 131.6630993193009}, {180., 
            129.54177897574127`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], 
           CapForm[None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]],
            PolygonBox[{{222.45283018867923`, 39.420485175202174`}, {
            220.3315098451196, 41.54180551876182}, {222.45283018867923`, 
            39.420485175202174`}, {220.3315098451196, 37.29916483164253}, {
            222.45283018867923`, 39.420485175202174`}, {224.57415053223886`, 
            37.29916483164253}, {222.45283018867923`, 39.420485175202174`}, {
            224.57415053223886`, 41.54180551876182}, {222.45283018867923`, 
            39.420485175202174`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], 
           CapForm[None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]],
            PolygonBox[{{264.90566037735846`, 111.68733153638814`}, {
            262.7843400337988, 113.80865187994779`}, {264.90566037735846`, 
            111.68733153638814`}, {262.7843400337988, 109.5660111928285}, {
            264.90566037735846`, 111.68733153638814`}, {267.0269807209181, 
            109.5660111928285}, {264.90566037735846`, 111.68733153638814`}, {
            267.0269807209181, 113.80865187994779`}, {264.90566037735846`, 
            111.68733153638814`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], 
           CapForm[None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]],
            PolygonBox[{{307.35849056603774`, 36.048517520215626`}, {
            305.2371702224781, 38.16983786377527}, {307.35849056603774`, 
            36.048517520215626`}, {305.2371702224781, 33.92719717665598}, {
            307.35849056603774`, 36.048517520215626`}, {309.4798109095974, 
            33.92719717665598}, {307.35849056603774`, 36.048517520215626`}, {
            309.4798109095974, 38.16983786377527}, {307.35849056603774`, 
            36.048517520215626`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1.5], Dashing[{}], 
           CapForm[None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]],
            PolygonBox[{{349.811320754717, 100.79514824797843`}, {
            347.6900004111573, 102.91646859153808`}, {349.811320754717, 
            100.79514824797843`}, {347.6900004111573, 98.67382790441879}, {
            349.811320754717, 100.79514824797843`}, {351.93264109827663`, 
            98.67382790441879}, {349.811320754717, 100.79514824797843`}, {
            351.93264109827663`, 102.91646859153808`}, {349.811320754717, 
            100.79514824797843`}}]}}}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{52.64150943396226, 85.70619946091645}, {95.0943396226415, 
          158.48247978436657`}, {137.54716981132074`, 67.51212938005392}, {
          180., 140.28840970350407`}, {222.45283018867923`, 
          49.31805929919139}, {264.90566037735846`, 122.09433962264151`}, {
          307.35849056603774`, 31.12398921832886}, {349.811320754717, 
          103.90026954177898`}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[
         0.698004, 0.133305, 0.133305]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[
           0.698004, 0.133305, 0.133305]], 
           PolygonBox[{{54.95120826524048, 86.66290804182917}, {
            54.40927638692863, 87.47396641388282}, {53.59821801487499, 
            88.01589829219466}, {52.64150943396226, 88.20619946091645}, {
            51.68480085304954, 88.01589829219466}, {50.873742480995894`, 
            87.47396641388282}, {50.331810602684044`, 86.66290804182917}, {
            50.14150943396226, 85.70619946091645}, {50.331810602684044`, 
            84.74949088000373}, {50.873742480995894`, 83.93843250795008}, {
            51.68480085304954, 83.39650062963824}, {52.64150943396226, 
            83.20619946091645}, {53.59821801487499, 83.39650062963824}, {
            54.40927638692863, 83.93843250795008}, {54.95120826524048, 
            84.74949088000373}, {55.14150943396226, 85.70619946091645}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[
           0.698004, 0.133305, 0.133305]], 
           PolygonBox[{{97.40403845391971, 159.4391883652793}, {
            96.86210657560787, 160.25024673733293`}, {96.05104820355422, 
            160.7921786156448}, {95.0943396226415, 160.98247978436657`}, {
            94.13763104172878, 160.7921786156448}, {93.32657266967513, 
            160.25024673733293`}, {92.78464079136329, 159.4391883652793}, {
            92.5943396226415, 158.48247978436657`}, {92.78464079136329, 
            157.52577120345384`}, {93.32657266967513, 156.71471283140022`}, {
            94.13763104172878, 156.17278095308836`}, {95.0943396226415, 
            155.98247978436657`}, {96.05104820355422, 156.17278095308836`}, {
            96.86210657560787, 156.71471283140022`}, {97.40403845391971, 
            157.52577120345384`}, {97.5943396226415, 
            158.48247978436657`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[
           0.698004, 0.133305, 0.133305]], 
           PolygonBox[{{139.85686864259895`, 68.46883796096664}, {
            139.3149367642871, 69.27989633302029}, {138.50387839223347`, 
            69.82182821133213}, {137.54716981132074`, 70.01212938005392}, {
            136.590461230408, 69.82182821133213}, {135.7794028583544, 
            69.27989633302029}, {135.23747098004253`, 68.46883796096664}, {
            135.04716981132074`, 67.51212938005392}, {135.23747098004253`, 
            66.5554207991412}, {135.7794028583544, 65.74436242708755}, {
            136.590461230408, 65.20243054877571}, {137.54716981132074`, 
            65.01212938005392}, {138.50387839223347`, 65.20243054877571}, {
            139.3149367642871, 65.74436242708755}, {139.85686864259895`, 
            66.5554207991412}, {140.04716981132074`, 67.51212938005392}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[
           0.698004, 0.133305, 0.133305]], 
           PolygonBox[{{182.3096988312782, 141.2451182844168}, {
            181.76776695296635`, 142.05617665647043`}, {180.95670858091273`, 
            142.59810853478228`}, {180., 142.78840970350407`}, {
            179.04329141908727`, 142.59810853478228`}, {178.23223304703365`, 
            142.05617665647043`}, {177.6903011687218, 141.2451182844168}, {
            177.5, 140.28840970350407`}, {177.6903011687218, 
            139.33170112259134`}, {178.23223304703365`, 
            138.52064275053772`}, {179.04329141908727`, 
            137.97871087222586`}, {180., 137.78840970350407`}, {
            180.95670858091273`, 137.97871087222586`}, {181.76776695296635`, 
            138.52064275053772`}, {182.3096988312782, 139.33170112259134`}, {
            182.5, 140.28840970350407`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[
           0.698004, 0.133305, 0.133305]], 
           PolygonBox[{{224.76252901995744`, 50.274767880104115`}, {
            224.22059714164558`, 51.08582625215776}, {223.40953876959196`, 
            51.62775813046961}, {222.45283018867923`, 51.81805929919139}, {
            221.4961216077665, 51.62775813046961}, {220.68506323571287`, 
            51.08582625215776}, {220.14313135740102`, 50.274767880104115`}, {
            219.95283018867923`, 49.31805929919139}, {220.14313135740102`, 
            48.361350718278665`}, {220.68506323571287`, 47.55029234622502}, {
            221.4961216077665, 47.00836046791317}, {222.45283018867923`, 
            46.81805929919139}, {223.40953876959196`, 47.00836046791317}, {
            224.22059714164558`, 47.55029234622502}, {224.76252901995744`, 
            48.361350718278665`}, {224.95283018867923`, 
            49.31805929919139}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[
           0.698004, 0.133305, 0.133305]], 
           PolygonBox[{{267.2153592086367, 123.05104820355423`}, {
            266.67342733032484`, 123.86210657560788`}, {265.8623689582712, 
            124.40403845391972`}, {264.90566037735846`, 
            124.59433962264151`}, {263.9489517964457, 124.40403845391972`}, {
            263.1378934243921, 123.86210657560788`}, {262.5959615460802, 
            123.05104820355423`}, {262.40566037735846`, 
            122.09433962264151`}, {262.5959615460802, 121.1376310417288}, {
            263.1378934243921, 120.32657266967514`}, {263.9489517964457, 
            119.7846407913633}, {264.90566037735846`, 119.59433962264151`}, {
            265.8623689582712, 119.7846407913633}, {266.67342733032484`, 
            120.32657266967514`}, {267.2153592086367, 121.1376310417288}, {
            267.40566037735846`, 122.09433962264151`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[
           0.698004, 0.133305, 0.133305]], 
           PolygonBox[{{309.668189397316, 32.080697799241584`}, {
            309.1262575190041, 32.89175617129523}, {308.3151991469505, 
            33.43368804960708}, {307.35849056603774`, 33.62398921832886}, {
            306.401781985125, 33.43368804960708}, {305.59072361307136`, 
            32.89175617129523}, {305.0487917347595, 32.080697799241584`}, {
            304.85849056603774`, 31.12398921832886}, {305.0487917347595, 
            30.167280637416134`}, {305.59072361307136`, 29.35622226536249}, {
            306.401781985125, 28.81429038705064}, {307.35849056603774`, 
            28.62398921832886}, {308.3151991469505, 28.81429038705064}, {
            309.1262575190041, 29.35622226536249}, {309.668189397316, 
            30.167280637416134`}, {309.85849056603774`, 
            31.12398921832886}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[RGBColor[
           0.698004, 0.133305, 0.133305]], 
           PolygonBox[{{352.1210195859952, 104.8569781226917}, {
            351.57908770768336`, 105.66803649474535`}, {350.7680293356297, 
            106.2099683730572}, {349.811320754717, 106.40026954177898`}, {
            348.85461217380424`, 106.2099683730572}, {348.0435538017506, 
            105.66803649474535`}, {347.50162192343873`, 104.8569781226917}, {
            347.311320754717, 103.90026954177898`}, {347.50162192343873`, 
            102.94356096086626`}, {348.0435538017506, 102.13250258881261`}, {
            348.85461217380424`, 101.59057071050077`}, {349.811320754717, 
            101.40026954177898`}, {350.7680293356297, 101.59057071050077`}, {
            351.57908770768336`, 102.13250258881261`}, {352.1210195859952, 
            102.94356096086626`}, {352.311320754717, 
            103.90026954177898`}}]}}}},
       Frame->False,
       ImageSize->{360., 180.00000000000003`},
       PlotRange->{{0., 360.}, {0., 180.00000000000003`}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {432, 432}]}, InsetBox[
      GraphicsBox[{InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{"\"(\"","\"b\"","\")\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {15., 15.}, {0, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{"\"(\"","\"b\"","\")\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {15., 15.}, {0, 0}, Automatic, {1, 0}]},
       Frame->False,
       ImageSize->{504, 504},
       PlotRange->{{-72, 432}, {-72, 432}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {432, 432}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 0.}, {0., 180.00000000000003`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{2.7, 5.094339622641513}, {0., 5.094339622641513}}], 
         LineBox[{{1.35, 17.223719676549877`}, {0., 17.223719676549877`}}], 
         LineBox[{{1.35, 29.35309973045824}, {0., 29.35309973045824}}], 
         LineBox[{{1.35, 41.482479784366575`}, {0., 41.482479784366575`}}], 
         LineBox[{{2.7, 53.61185983827494}, {0., 53.61185983827494}}], 
         LineBox[{{1.35, 65.7412398921833}, {0., 65.7412398921833}}], 
         LineBox[{{1.35, 77.87061994609164}, {0., 77.87061994609164}}], 
         LineBox[{{1.35, 90.}, {0., 90.}}], 
         LineBox[{{2.7, 102.12938005390836`}, {0., 102.12938005390836`}}], 
         LineBox[{{1.35, 114.2587601078167}, {0., 114.2587601078167}}], 
         LineBox[{{1.35, 126.38814016172509`}, {0., 126.38814016172509`}}], 
         LineBox[{{1.35, 138.51752021563343`}, {0., 138.51752021563343`}}], 
         LineBox[{{2.7, 150.64690026954176`}, {0., 150.64690026954176`}}], 
         LineBox[{{1.35, 162.77628032345015`}, {0., 162.77628032345015`}}], 
         LineBox[{{1.35, 174.9056603773585}, {0., 174.9056603773585}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{360., 0.}, {360., 180.00000000000003`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{357.3, 5.094339622641513}, {360., 5.094339622641513}}], 
         LineBox[{{358.65, 17.223719676549877`}, {360., 
          17.223719676549877`}}], 
         LineBox[{{358.65, 29.35309973045824}, {360., 29.35309973045824}}], 
         LineBox[{{358.65, 41.482479784366575`}, {360., 
          41.482479784366575`}}], 
         LineBox[{{357.3, 53.61185983827494}, {360., 53.61185983827494}}], 
         LineBox[{{358.65, 65.7412398921833}, {360., 65.7412398921833}}], 
         LineBox[{{358.65, 77.87061994609164}, {360., 77.87061994609164}}], 
         LineBox[{{358.65, 90.}, {360., 90.}}], 
         LineBox[{{357.3, 102.12938005390836`}, {360., 102.12938005390836`}}],
          LineBox[{{358.65, 114.2587601078167}, {360., 114.2587601078167}}], 
         LineBox[{{358.65, 126.38814016172509`}, {360., 
          126.38814016172509`}}], 
         LineBox[{{358.65, 138.51752021563343`}, {360., 
          138.51752021563343`}}], 
         LineBox[{{357.3, 150.64690026954176`}, {360., 150.64690026954176`}}],
          LineBox[{{358.65, 162.77628032345015`}, {360., 
          162.77628032345015`}}], 
         LineBox[{{358.65, 174.9056603773585}, {360., 174.9056603773585}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {360., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{10.188679245283017`, 2.7}, {10.188679245283017`, 0.}}], 
         LineBox[{{52.64150943396226, 2.7}, {52.64150943396226, 0.}}], 
         LineBox[{{95.0943396226415, 2.7}, {95.0943396226415, 0.}}], 
         LineBox[{{137.54716981132074`, 2.7}, {137.54716981132074`, 0.}}], 
         LineBox[{{180., 2.7}, {180., 0.}}], 
         LineBox[{{222.45283018867923`, 2.7}, {222.45283018867923`, 0.}}], 
         LineBox[{{264.90566037735846`, 2.7}, {264.90566037735846`, 0.}}], 
         LineBox[{{307.35849056603774`, 2.7}, {307.35849056603774`, 0.}}], 
         LineBox[{{349.811320754717, 2.7}, {349.811320754717, 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 180.00000000000003`}, {360., 180.00000000000003`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{10.188679245283017`, 177.30000000000004`}, {
          10.188679245283017`, 180.00000000000003`}}], 
         LineBox[{{52.64150943396226, 177.30000000000004`}, {
          52.64150943396226, 180.00000000000003`}}], 
         LineBox[{{95.0943396226415, 177.30000000000004`}, {95.0943396226415, 
          180.00000000000003`}}], 
         LineBox[{{137.54716981132074`, 177.30000000000004`}, {
          137.54716981132074`, 180.00000000000003`}}], 
         LineBox[{{180., 177.30000000000004`}, {180., 180.00000000000003`}}], 
         LineBox[{{222.45283018867923`, 177.30000000000004`}, {
          222.45283018867923`, 180.00000000000003`}}], 
         LineBox[{{264.90566037735846`, 177.30000000000004`}, {
          264.90566037735846`, 180.00000000000003`}}], 
         LineBox[{{307.35849056603774`, 177.30000000000004`}, {
          307.35849056603774`, 180.00000000000003`}}], 
         LineBox[{{349.811320754717, 177.30000000000004`}, {349.811320754717, 
          180.00000000000003`}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 6\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 5.094339622641513}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 8\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 53.61185983827494}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"10\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 102.12938005390836`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"12\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 150.64690026954176`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"\\!\\(\\*\\nStyleBox[SubscriptBox[\\\"S\\\", \
\\\"n\\\"],\\nFontSlant->\\\"Italic\\\"]\\) (MeV)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-16., 90.00000000000001}, {0, -1}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {10.188679245283017`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {52.64150943396226, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {95.0943396226415, 0.}, {0, 1}, Automatic, {1,
          0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"3\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {137.54716981132074`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"4\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {180., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {222.45283018867923`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"6\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {264.90566037735846`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"7\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {307.35849056603774`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"8\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {349.811320754717, 0.}, {0, 1}, Automatic, {1,
          0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              StyleBox["\<\"N\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {180., -15.}, {0, 1}, Automatic, {1., 0.}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 6\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 5.094339622641513}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 8\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 53.61185983827494}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"10\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 102.12938005390836`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"12\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 150.64690026954176`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"\\!\\(\\*\\nStyleBox[SubscriptBox[\\\"S\\\", \
\\\"n\\\"],\\nFontSlant->\\\"Italic\\\"]\\) (MeV)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-16., 90.00000000000001}, {0, -1}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {10.188679245283017`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {52.64150943396226, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {95.0943396226415, 0.}, {0, 1}, Automatic, {1,
          0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"3\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {137.54716981132074`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"4\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {180., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {222.45283018867923`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"6\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {264.90566037735846`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"7\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {307.35849056603774`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"8\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {349.811320754717, 0.}, {0, 1}, Automatic, {1,
          0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             StyleBox["\<\"N\"\>",
              FontSlant->"Italic"],
             StyleForm[#, FontSlant -> "Italic"]& ],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {180., -15.}, {0, 1}, Automatic, {1., 0.}]},
       Frame->False,
       ImageSize->{504, 504},
       PlotRange->{{-72, 432}, {-72, 432}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->1,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{504, 504},
  PlotRange->{{-72, 432}, {-72, 432}}]], "Output",
 CellChangeTimes->{{3.506122965566625*^9, 3.5061229863635*^9}, 
   3.507512420375*^9, {3.520540171109375*^9, 3.520540200015625*^9}, {
   3.520540304421875*^9, 3.5205403203125*^9}, 3.520540383625*^9, {
   3.5205405208125*^9, 3.520540533609375*^9}, {3.520540617140625*^9, 
   3.52054063209375*^9}, 3.5247481218125*^9, 3.5247481929375*^9, {
   3.566338722604204*^9, 3.566338745302244*^9}, {3.5791219013818207`*^9, 
   3.5791219160126576`*^9}, 3.5837843718141713`*^9, 3.5943051813026795`*^9, 
   3.594305802755184*^9, 3.5943059145853415`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Data plot with labeled curves", "Section",
 CellChangeTimes->{{3.5213267283125*^9, 3.5213267291875*^9}, {
  3.521327250859375*^9, 3.52132725453125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"formulas", " ", "for", " ", "data"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"BE2", "[", 
      RowBox[{
       RowBox[{"J1_", "?", "NumericQ"}], ",", 
       RowBox[{"K1_", "?", "NumericQ"}], ",", 
       RowBox[{"J2_", "?", "NumericQ"}], ",", 
       RowBox[{"K2_", "?", "NumericQ"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"ClebschGordan", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"J1", ",", "K1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", 
           RowBox[{"K2", "-", "K1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"J2", ",", "K2"}], "}"}]}], "]"}], ")"}], "^", "2"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"BE2WithCross", "[", 
      RowBox[{
       RowBox[{"J1_", "?", "NumericQ"}], ",", 
       RowBox[{"K1_", "?", "NumericQ"}], ",", 
       RowBox[{"J2_", "?", "NumericQ"}], ",", 
       RowBox[{"K2_", "?", "NumericQ"}], ",", 
       RowBox[{"MERatio_", "?", "NumericQ"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"DiscreteDelta", "[", "K1", "]"}]}], ")"}], "^", 
       RowBox[{"-", "1"}]}], "*", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "+", 
         RowBox[{"DiscreteDelta", "[", "K2", "]"}]}], ")"}], "^", 
       RowBox[{"-", "1"}]}], "*", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"ClebschGordan", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"J1", ",", "K1"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", 
             RowBox[{"K2", "-", "K1"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"J2", ",", "K2"}], "}"}]}], "]"}], "+", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], "^", 
           RowBox[{"(", 
            RowBox[{"J1", "+", "K1"}], ")"}]}], "*", 
          RowBox[{"ClebschGordan", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"J1", ",", 
              RowBox[{"-", "K1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", 
              RowBox[{"K2", "+", "K1"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"J2", ",", "K2"}], "}"}]}], "]"}], "*", "MERatio"}]}], 
        ")"}], "^", "2"}]}]}], ";"}], "\n", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"curve", " ", "styles"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"DefineStyle", "[", 
     RowBox[{"\"\<DeltaJ2\>\"", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"DataLine", "\[Rule]", 
         RowBox[{"{", "}"}]}], ",", 
        RowBox[{"DataSymbol", "->", 
         RowBox[{"{", "}"}]}]}], "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"DefineStyle", "[", 
     RowBox[{"\"\<DeltaJ1\>\"", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"DataLine", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"LineDashing", "\[Rule]", "2"}], "}"}]}], ",", 
        RowBox[{"DataSymbol", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"FillColor", "\[Rule]", "None"}], "}"}]}]}], "}"}]}], "]"}],
     ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"DefineStyle", "[", 
     RowBox[{"\"\<CurveLabel\>\"", ",", 
      RowBox[{"{", 
       RowBox[{"FigLabel", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"TextOrientation", "\[Rule]", "Horizontal"}], ",", 
          RowBox[{"TextBuffer", "\[Rule]", "2"}], ",", 
          RowBox[{"FontSize", "\[Rule]", "12"}]}], "}"}]}], "}"}]}], "]"}], 
    ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "figure", " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"With", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"JMax", "=", "10"}], ",", 
       RowBox[{"MERatio", "=", "0.1"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Figure", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Multipanel", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{"top", " ", "panel"}], " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"(*", " ", 
               RowBox[{"data", " ", "plots", " ", "with", " ", "labels"}], 
               " ", "*)"}], "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Do", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"DataPlot", "\[LeftDoubleBracket]", 
                    RowBox[{"{", 
                    RowBox[{"\"\<data\>\"", ",", "K", ",", "DeltaJ"}], "}"}], 
                    "\[RightDoubleBracket]"}], "[", 
                    RowBox[{
                    RowBox[{"Table", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"J", ",", 
                    RowBox[{"BE2", "[", 
                    RowBox[{"J", ",", "K", ",", 
                    RowBox[{"J", "-", "DeltaJ"}], ",", "K"}], "]"}]}], "}"}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"J", ",", 
                    RowBox[{"K", "+", "DeltaJ"}], ",", "JMax", ",", 
                    RowBox[{"1", "+", 
                    RowBox[{"DiscreteDelta", "[", "K", "]"}]}]}], "}"}]}], 
                    "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Style", "\[Rule]", 
                    RowBox[{"Switch", "[", 
                    RowBox[{
                    "DeltaJ", ",", "1", ",", "\"\<DeltaJ1\>\"", ",", "2", 
                    ",", "\"\<DeltaJ2\>\""}], "]"}]}]}], 
                    "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
                   RowBox[{"FigLabel", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<data\>\"", ",", "K", ",", "DeltaJ"}], "}"}], 
                    ",", "\[IndentingNewLine]", "Tail", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"SolidusFractionize", "[", "K", "]"}], ",", 
                    RowBox[{"(*", " ", 
                    RowBox[{
                    "writes", " ", "fraction", " ", "with", " ", "slash", " ",
                     "as", " ", "\"\<a/b\>\""}], " ", "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"TextOffset", "\[Rule]", 
                    RowBox[{"Switch", "[", 
                    RowBox[{
                    "DeltaJ", ",", "1", ",", "Automatic", ",", "2", ",", 
                    "Top"}], "]"}]}], ",", "\[IndentingNewLine]", 
                    RowBox[{"TextNudge", "\[Rule]", 
                    RowBox[{"Switch", "[", 
                    RowBox[{"DeltaJ", ",", "1", ",", "None", ",", "2", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"+", "2"}], ",", "0"}], "}"}]}], "]"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Style", "->", "\"\<CurveLabel\>\""}]}], 
                    "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
                  "}"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{"K", ",", "0", ",", "2", ",", 
                   RowBox[{"1", "/", "2"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"DeltaJ", ",", 
                   RowBox[{"1", "+", 
                    RowBox[{"DiscreteDelta", "[", "K", "]"}]}], ",", "2"}], 
                  "}"}]}], "\[IndentingNewLine]", "]"}], ";", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"(*", " ", "legend", " ", "*)"}], 
               "\[IndentingNewLine]", 
               RowBox[{"DataLegend", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"Scaled", "[", 
                  RowBox[{"{", 
                   RowBox[{"0.7", ",", "0.6"}], "}"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"\"\<DeltaJ2\>\"", ",", 
                    RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<\[CapitalDelta]\>\"", ",", 
                    RowBox[{"textit", "[", "\"\<J\>\"", "]"}], ",", 
                    "\"\<=2\>\""}], "}"}], "]"}]}], "}"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"\"\<DeltaJ1\>\"", ",", 
                    RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<\[CapitalDelta]\>\"", ",", 
                    RowBox[{"textit", "[", "\"\<J\>\"", "]"}], ",", 
                    "\"\<=1\>\""}], "}"}], "]"}]}], "}"}]}], 
                  "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"Width", "\[Rule]", "25"}]}], "\[IndentingNewLine]", 
                "]"}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
              "}"}], ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"1", ",", "1"}], "}"}]}], "\[IndentingNewLine]", "]"}], 
           ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"bottom", " ", "panel"}], " ", "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"(*", " ", 
               RowBox[{"data", " ", "plots", " ", "with", " ", "labels"}], 
               " ", "*)"}], "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Do", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"{", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"DataPlot", "\[LeftDoubleBracket]", 
                    RowBox[{"{", 
                    RowBox[{"\"\<data2\>\"", ",", "K", ",", "DeltaJ"}], "}"}],
                     "\[RightDoubleBracket]"}], "[", 
                    RowBox[{
                    RowBox[{"Table", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"J", ",", 
                    RowBox[{"BE2WithCross", "[", 
                    RowBox[{"J", ",", "K", ",", 
                    RowBox[{"J", "-", "DeltaJ"}], ",", "K", ",", "MERatio"}], 
                    "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"{", 
                    RowBox[{"J", ",", 
                    RowBox[{"K", "+", "DeltaJ"}], ",", "JMax", ",", 
                    RowBox[{"1", "+", 
                    RowBox[{"DiscreteDelta", "[", "K", "]"}]}]}], "}"}]}], 
                    "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"Style", "\[Rule]", 
                    RowBox[{"Switch", "[", 
                    RowBox[{
                    "DeltaJ", ",", "1", ",", "\"\<DeltaJ1\>\"", ",", "2", 
                    ",", "\"\<DeltaJ2\>\""}], "]"}]}]}], 
                    "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
                   RowBox[{"FigLabel", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<data2\>\"", ",", "K", ",", "DeltaJ"}], "}"}],
                     ",", "\[IndentingNewLine]", 
                    RowBox[{"Switch", "[", 
                    RowBox[{
                    "DeltaJ", ",", "1", ",", "Tail", ",", "2", ",", "Head"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"SolidusFractionize", "[", "K", "]"}], ",", "  ", 
                    "\[IndentingNewLine]", 
                    RowBox[{"Style", "->", "\"\<CurveLabel\>\""}]}], 
                    "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
                  "}"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{"K", ",", 
                   RowBox[{"1", "/", "2"}], ",", "1", ",", 
                   RowBox[{"1", "/", "2"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"DeltaJ", ",", 
                   RowBox[{"1", "+", 
                    RowBox[{"DiscreteDelta", "[", "K", "]"}]}], ",", "2"}], 
                  "}"}]}], "\[IndentingNewLine]", "]"}], ";", 
               "\[IndentingNewLine]", "\[IndentingNewLine]", 
               RowBox[{"(*", " ", 
                RowBox[{
                "panel", " ", "label", " ", "for", " ", "value", " ", "of", 
                 " ", "ratio"}], " ", "*)"}], "\[IndentingNewLine]", 
               RowBox[{"FigLabel", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"Scaled", "[", 
                  RowBox[{"{", 
                   RowBox[{"0.05", ",", "0.95"}], "}"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Row", "[", 
                  RowBox[{"{", 
                   RowBox[{"\"\<\[LeftAngleBracket]\>\"", ",", 
                    RowBox[{"textit", "[", "\"\<K\>\"", "]"}], ",", 
                    "\"\<|\[ScriptCapitalM]|\>\"", ",", 
                    RowBox[{"OverBar", "[", 
                    RowBox[{"textit", "[", "\"\<K\>\"", "]"}], "]"}], ",", 
                    "\"\<\[RightAngleBracket]\>\"", ",", "\"\</\>\"", ",", 
                    "\"\<\[LeftAngleBracket]\>\"", ",", 
                    RowBox[{"textit", "[", "\"\<K\>\"", "]"}], ",", 
                    "\"\<|\[ScriptCapitalM]|\>\"", ",", 
                    RowBox[{"textit", "[", "\"\<K\>\"", "]"}], ",", 
                    "\"\<\[RightAngleBracket]\>\"", ",", "\"\< = \>\"", ",", 
                    "MERatio"}], "}"}], "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"TextOffset", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "1"}], ",", 
                    RowBox[{"+", "1"}]}], "}"}]}]}], "\[IndentingNewLine]", 
                "]"}], ";"}], "\[IndentingNewLine]", "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"2", ",", "1"}], "}"}]}], "\[IndentingNewLine]", "]"}], 
           ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Dimensions", "->", 
          RowBox[{"{", 
           RowBox[{"2", ",", "1"}], "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"XPlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"1", ",", "11"}], "}"}]}], ",", 
         RowBox[{"XFrameLabel", "\[Rule]", 
          RowBox[{"textit", "[", "\"\<J\>\"", "]"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"YPlotRange", "->", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0.4"}], "}"}]}], ",", 
         RowBox[{"YFrameLabel", "\[Rule]", 
          RowBox[{"Row", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"textit", "[", "\"\<B\>\"", "]"}], ",", "\"\<(\>\"", ",", 
             RowBox[{"textit", "[", "\"\<E\>\"", "]"}], ",", "2", ",", 
             "\"\<)\>\""}], "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{"ExtendRange", "\[Rule]", "0.04"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"PanelLetter", "\[Rule]", "None"}]}], "\[IndentingNewLine]", 
        "]"}], ",", " ", 
       RowBox[{"(*", "Multipanel", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"CanvasSize", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"6", ",", "8"}], "}"}]}]}], "\[IndentingNewLine]", "]"}]}], 
    " ", 
    RowBox[{"(*", " ", "Figure", " ", "*)"}], "\[IndentingNewLine]", "]"}], 
   " ", 
   RowBox[{"(*", " ", "With", " ", "*)"}], "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.521304694578125*^9, 3.521304724265625*^9}, {
   3.521304963765625*^9, 3.521305108*^9}, {3.521305664265625*^9, 
   3.52130567084375*^9}, {3.52130925321875*^9, 3.521309268734375*^9}, 
   3.5213093165625*^9, {3.521319169828125*^9, 3.521319203109375*^9}, {
   3.521319551453125*^9, 3.521319737109375*^9}, 3.521319797015625*^9, {
   3.521327177875*^9, 3.52132720290625*^9}, {3.521327263515625*^9, 
   3.52132727684375*^9}, {3.52132732446875*^9, 3.52132736975*^9}, {
   3.521327404625*^9, 3.5213274081875*^9}, {3.521327462578125*^9, 
   3.521327464515625*^9}, 3.521327506578125*^9, 3.522195314890625*^9, {
   3.522195394671875*^9, 3.522195396046875*^9}, {3.522195457859375*^9, 
   3.52219549821875*^9}, {3.522195582984375*^9, 3.52219563171875*^9}, {
   3.566259729288368*^9, 3.5662597317283716`*^9}, {3.5662597623380947`*^9, 
   3.5662598917674975`*^9}, {3.579121957419026*^9, 3.5791219596901555`*^9}, {
   3.583784199682469*^9, 3.583784199682469*^9}}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 648}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 720},
       PlotRange->{{-72, 504}, {-72, 648}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 288.}, {432., 576.}]}, InsetBox[
      GraphicsBox[{
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{56., 432.}, {136., 489.1428571428571}, {216., 
          508.45687645687644`}, {296., 518.2745098039215}, {376., 
          524.2305764411027}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{57.154849415639106`, 432.47835429045637`}, {
            56.883883476483184`, 432.88388347648316`}, {56.47835429045636, 
            433.1548494156391}, {56., 433.25}, {55.52164570954364, 
            433.1548494156391}, {55.116116523516816`, 432.88388347648316`}, {
            54.845150584360894`, 432.47835429045637`}, {54.75, 432.}, {
            54.845150584360894`, 431.52164570954363`}, {55.116116523516816`, 
            431.11611652351684`}, {55.52164570954364, 430.8451505843609}, {
            56., 430.75}, {56.47835429045636, 430.8451505843609}, {
            56.883883476483184`, 431.11611652351684`}, {57.154849415639106`, 
            431.52164570954363`}, {57.25, 432.}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{137.15484941563912`, 489.6212114333135}, {
            136.8838834764832, 490.0267406193403}, {136.47835429045637`, 
            490.2977065584962}, {136., 490.3928571428571}, {
            135.52164570954363`, 490.2977065584962}, {135.1161165235168, 
            490.0267406193403}, {134.84515058436088`, 489.6212114333135}, {
            134.75, 489.1428571428571}, {134.84515058436088`, 
            488.66450285240074`}, {135.1161165235168, 488.25897366637395`}, {
            135.52164570954363`, 487.988007727218}, {136., 
            487.8928571428571}, {136.47835429045637`, 487.988007727218}, {
            136.8838834764832, 488.25897366637395`}, {137.15484941563912`, 
            488.66450285240074`}, {137.25, 489.1428571428571}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{217.15484941563912`, 508.9352307473328}, {
            216.8838834764832, 509.3407599333596}, {216.47835429045637`, 
            509.61172587251554`}, {216., 509.70687645687644`}, {
            215.52164570954363`, 509.61172587251554`}, {215.1161165235168, 
            509.3407599333596}, {214.84515058436088`, 508.9352307473328}, {
            214.75, 508.45687645687644`}, {214.84515058436088`, 
            507.9785221664201}, {215.1161165235168, 507.5729929803933}, {
            215.52164570954363`, 507.30202704123735`}, {216., 
            507.20687645687644`}, {216.47835429045637`, 
            507.30202704123735`}, {216.8838834764832, 507.5729929803933}, {
            217.15484941563912`, 507.9785221664201}, {217.25, 
            508.45687645687644`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{297.1548494156391, 518.7528640943779}, {
            296.88388347648316`, 519.1583932804048}, {296.47835429045637`, 
            519.4293592195606}, {296., 519.5245098039215}, {
            295.52164570954363`, 519.4293592195606}, {295.11611652351684`, 
            519.1583932804048}, {294.8451505843609, 518.7528640943779}, {
            294.75, 518.2745098039215}, {294.8451505843609, 
            517.7961555134652}, {295.11611652351684`, 517.3906263274383}, {
            295.52164570954363`, 517.1196603882825}, {296., 
            517.0245098039215}, {296.47835429045637`, 517.1196603882825}, {
            296.88388347648316`, 517.3906263274383}, {297.1548494156391, 
            517.7961555134652}, {297.25, 518.2745098039215}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{377.1548494156391, 524.708930731559}, {
            376.88388347648316`, 525.1144599175859}, {376.47835429045637`, 
            525.3854258567418}, {376., 525.4805764411027}, {
            375.52164570954363`, 525.3854258567418}, {375.11611652351684`, 
            525.1144599175859}, {374.8451505843609, 524.708930731559}, {
            374.75, 524.2305764411027}, {374.8451505843609, 
            523.7522221506464}, {375.11611652351684`, 523.3466929646195}, {
            375.52164570954363`, 523.0757270254636}, {376., 
            522.9805764411027}, {376.47835429045637`, 523.0757270254636}, {
            376.88388347648316`, 523.3466929646195}, {377.1548494156391, 
            523.7522221506464}, {377.25, 524.2305764411027}}]}}}, 
        {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{36., 432.}, {76., 336.76190476190476`}, {116., 
          317.7142857142857}, {156., 310.2106782106782}, {196., 
          306.4366744366745}, {236., 304.2610722610723}, {276., 
          302.8898944193062}, {316., 301.96904024767804`}, {356., 
          301.32035972283654`}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{37.154849415639106`, 432.47835429045637`}, {
            36.883883476483184`, 432.88388347648316`}, {36.47835429045636, 
            433.1548494156391}, {36., 433.25}, {35.52164570954364, 
            433.1548494156391}, {35.116116523516816`, 432.88388347648316`}, {
            34.845150584360894`, 432.47835429045637`}, {34.75, 432.}, {
            34.845150584360894`, 431.52164570954363`}, {35.116116523516816`, 
            431.11611652351684`}, {35.52164570954364, 430.8451505843609}, {
            36., 430.75}, {36.47835429045636, 430.8451505843609}, {
            36.883883476483184`, 431.11611652351684`}, {37.154849415639106`, 
            431.52164570954363`}, {37.25, 432.}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{77.1548494156391, 337.2402590523611}, {
            76.88388347648318, 337.6457882383879}, {76.47835429045637, 
            337.91675417754385`}, {76., 338.01190476190476`}, {
            75.52164570954363, 337.91675417754385`}, {75.11611652351682, 
            337.6457882383879}, {74.8451505843609, 337.2402590523611}, {74.75,
             336.76190476190476`}, {74.8451505843609, 336.2835504714484}, {
            75.11611652351682, 335.8780212854216}, {75.52164570954363, 
            335.60705534626567`}, {76., 335.51190476190476`}, {
            76.47835429045637, 335.60705534626567`}, {76.88388347648318, 
            335.8780212854216}, {77.1548494156391, 336.2835504714484}, {77.25,
             336.76190476190476`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{117.1548494156391, 318.1926400047421}, {
            116.88388347648318`, 318.5981691907689}, {116.47835429045637`, 
            318.8691351299248}, {116., 318.9642857142857}, {
            115.52164570954363`, 318.8691351299248}, {115.11611652351682`, 
            318.5981691907689}, {114.8451505843609, 318.1926400047421}, {
            114.75, 317.7142857142857}, {114.8451505843609, 
            317.23593142382936`}, {115.11611652351682`, 
            316.83040223780256`}, {115.52164570954363`, 
            316.55943629864663`}, {116., 316.4642857142857}, {
            116.47835429045637`, 316.55943629864663`}, {116.88388347648318`, 
            316.83040223780256`}, {117.1548494156391, 317.23593142382936`}, {
            117.25, 317.7142857142857}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{157.15484941563912`, 310.6890325011346}, {
            156.8838834764832, 311.0945616871614}, {156.47835429045637`, 
            311.3655276263173}, {156., 311.4606782106782}, {
            155.52164570954363`, 311.3655276263173}, {155.1161165235168, 
            311.0945616871614}, {154.84515058436088`, 310.6890325011346}, {
            154.75, 310.2106782106782}, {154.84515058436088`, 
            309.73232392022186`}, {155.1161165235168, 309.32679473419506`}, {
            155.52164570954363`, 309.05582879503913`}, {156., 
            308.9606782106782}, {156.47835429045637`, 309.05582879503913`}, {
            156.8838834764832, 309.32679473419506`}, {157.15484941563912`, 
            309.73232392022186`}, {157.25, 310.2106782106782}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{197.15484941563912`, 306.91502872713085`}, {
            196.8838834764832, 307.32055791315764`}, {196.47835429045637`, 
            307.59152385231357`}, {196., 307.6866744366745}, {
            195.52164570954363`, 307.59152385231357`}, {195.1161165235168, 
            307.32055791315764`}, {194.84515058436088`, 
            306.91502872713085`}, {194.75, 306.4366744366745}, {
            194.84515058436088`, 305.9583201462181}, {195.1161165235168, 
            305.5527909601913}, {195.52164570954363`, 305.2818250210354}, {
            196., 305.1866744366745}, {196.47835429045637`, 
            305.2818250210354}, {196.8838834764832, 305.5527909601913}, {
            197.15484941563912`, 305.9583201462181}, {197.25, 
            306.4366744366745}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{237.15484941563912`, 304.73942655152865`}, {
            236.8838834764832, 305.14495573755545`}, {236.47835429045637`, 
            305.4159216767114}, {236., 305.5110722610723}, {
            235.52164570954363`, 305.4159216767114}, {235.1161165235168, 
            305.14495573755545`}, {234.84515058436088`, 
            304.73942655152865`}, {234.75, 304.2610722610723}, {
            234.84515058436088`, 303.7827179706159}, {235.1161165235168, 
            303.3771887845891}, {235.52164570954363`, 303.1062228454332}, {
            236., 303.0110722610723}, {236.47835429045637`, 
            303.1062228454332}, {236.8838834764832, 303.3771887845891}, {
            237.15484941563912`, 303.7827179706159}, {237.25, 
            304.2610722610723}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{277.1548494156391, 303.36824870976255`}, {
            276.88388347648316`, 303.77377789578935`}, {276.47835429045637`, 
            304.0447438349453}, {276., 304.1398944193062}, {
            275.52164570954363`, 304.0447438349453}, {275.11611652351684`, 
            303.77377789578935`}, {274.8451505843609, 303.36824870976255`}, {
            274.75, 302.8898944193062}, {274.8451505843609, 
            302.4115401288498}, {275.11611652351684`, 302.006010942823}, {
            275.52164570954363`, 301.7350450036671}, {276., 
            301.6398944193062}, {276.47835429045637`, 301.7350450036671}, {
            276.88388347648316`, 302.006010942823}, {277.1548494156391, 
            302.4115401288498}, {277.25, 302.8898944193062}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{317.1548494156391, 302.4473945381344}, {
            316.88388347648316`, 302.8529237241612}, {316.47835429045637`, 
            303.12388966331713`}, {316., 303.21904024767804`}, {
            315.52164570954363`, 303.12388966331713`}, {315.11611652351684`, 
            302.8529237241612}, {314.8451505843609, 302.4473945381344}, {
            314.75, 301.96904024767804`}, {314.8451505843609, 
            301.4906859572217}, {315.11611652351684`, 301.0851567711949}, {
            315.52164570954363`, 300.81419083203895`}, {316., 
            300.71904024767804`}, {316.47835429045637`, 
            300.81419083203895`}, {316.88388347648316`, 301.0851567711949}, {
            317.1548494156391, 301.4906859572217}, {317.25, 
            301.96904024767804`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{357.1548494156391, 301.7987140132929}, {
            356.88388347648316`, 302.2042431993197}, {356.47835429045637`, 
            302.47520913847563`}, {356., 302.57035972283654`}, {
            355.52164570954363`, 302.47520913847563`}, {355.11611652351684`, 
            302.2042431993197}, {354.8451505843609, 301.7987140132929}, {
            354.75, 301.32035972283654`}, {354.8451505843609, 
            300.8420054323802}, {355.11611652351684`, 300.4364762463534}, {
            355.52164570954363`, 300.16551030719745`}, {356., 
            300.07035972283654`}, {356.47835429045637`, 
            300.16551030719745`}, {356.88388347648316`, 300.4364762463534}, {
            357.1548494156391, 300.8420054323802}, {357.25, 
            301.32035972283654`}}]}}}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{76., 432.}, {116., 470.0952380952381}, {156., 
          489.1428571428571}, {196., 500.6868686868687}, {236., 
          508.45687645687644`}, {276., 514.051282051282}, {316., 
          518.2745098039215}, {356., 521.5768833849329}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{77.1548494156391, 432.47835429045637`}, {
            76.88388347648318, 432.88388347648316`}, {76.47835429045637, 
            433.1548494156391}, {76., 433.25}, {75.52164570954363, 
            433.1548494156391}, {75.11611652351682, 432.88388347648316`}, {
            74.8451505843609, 432.47835429045637`}, {74.75, 432.}, {
            74.8451505843609, 431.52164570954363`}, {75.11611652351682, 
            431.11611652351684`}, {75.52164570954363, 430.8451505843609}, {
            76., 430.75}, {76.47835429045637, 430.8451505843609}, {
            76.88388347648318, 431.11611652351684`}, {77.1548494156391, 
            431.52164570954363`}, {77.25, 432.}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{117.1548494156391, 470.57359238569444`}, {
            116.88388347648318`, 470.97912157172124`}, {116.47835429045637`, 
            471.25008751087717`}, {116., 471.3452380952381}, {
            115.52164570954363`, 471.25008751087717`}, {115.11611652351682`, 
            470.97912157172124`}, {114.8451505843609, 470.57359238569444`}, {
            114.75, 470.0952380952381}, {114.8451505843609, 
            469.6168838047817}, {115.11611652351682`, 469.2113546187549}, {
            115.52164570954363`, 468.940388679599}, {116., 
            468.8452380952381}, {116.47835429045637`, 468.940388679599}, {
            116.88388347648318`, 469.2113546187549}, {117.1548494156391, 
            469.6168838047817}, {117.25, 470.0952380952381}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{157.15484941563912`, 489.6212114333135}, {
            156.8838834764832, 490.0267406193403}, {156.47835429045637`, 
            490.2977065584962}, {156., 490.3928571428571}, {
            155.52164570954363`, 490.2977065584962}, {155.1161165235168, 
            490.0267406193403}, {154.84515058436088`, 489.6212114333135}, {
            154.75, 489.1428571428571}, {154.84515058436088`, 
            488.66450285240074`}, {155.1161165235168, 488.25897366637395`}, {
            155.52164570954363`, 487.988007727218}, {156., 
            487.8928571428571}, {156.47835429045637`, 487.988007727218}, {
            156.8838834764832, 488.25897366637395`}, {157.15484941563912`, 
            488.66450285240074`}, {157.25, 489.1428571428571}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{197.15484941563912`, 501.1652229773251}, {
            196.8838834764832, 501.57075216335187`}, {196.47835429045637`, 
            501.8417181025078}, {196., 501.9368686868687}, {
            195.52164570954363`, 501.8417181025078}, {195.1161165235168, 
            501.57075216335187`}, {194.84515058436088`, 501.1652229773251}, {
            194.75, 500.6868686868687}, {194.84515058436088`, 
            500.20851439641234`}, {195.1161165235168, 499.80298521038554`}, {
            195.52164570954363`, 499.5320192712296}, {196., 
            499.4368686868687}, {196.47835429045637`, 499.5320192712296}, {
            196.8838834764832, 499.80298521038554`}, {197.15484941563912`, 
            500.20851439641234`}, {197.25, 500.6868686868687}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{237.15484941563912`, 508.9352307473328}, {
            236.8838834764832, 509.3407599333596}, {236.47835429045637`, 
            509.61172587251554`}, {236., 509.70687645687644`}, {
            235.52164570954363`, 509.61172587251554`}, {235.1161165235168, 
            509.3407599333596}, {234.84515058436088`, 508.9352307473328}, {
            234.75, 508.45687645687644`}, {234.84515058436088`, 
            507.9785221664201}, {235.1161165235168, 507.5729929803933}, {
            235.52164570954363`, 507.30202704123735`}, {236., 
            507.20687645687644`}, {236.47835429045637`, 
            507.30202704123735`}, {236.8838834764832, 507.5729929803933}, {
            237.15484941563912`, 507.9785221664201}, {237.25, 
            508.45687645687644`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{277.1548494156391, 514.5296363417383}, {
            276.88388347648316`, 514.9351655277652}, {276.47835429045637`, 
            515.2061314669211}, {276., 515.301282051282}, {
            275.52164570954363`, 515.2061314669211}, {275.11611652351684`, 
            514.9351655277652}, {274.8451505843609, 514.5296363417383}, {
            274.75, 514.051282051282}, {274.8451505843609, 
            513.5729277608257}, {275.11611652351684`, 513.1673985747988}, {
            275.52164570954363`, 512.8964326356429}, {276., 
            512.801282051282}, {276.47835429045637`, 512.8964326356429}, {
            276.88388347648316`, 513.1673985747988}, {277.1548494156391, 
            513.5729277608257}, {277.25, 514.051282051282}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{317.1548494156391, 518.7528640943779}, {
            316.88388347648316`, 519.1583932804048}, {316.47835429045637`, 
            519.4293592195606}, {316., 519.5245098039215}, {
            315.52164570954363`, 519.4293592195606}, {315.11611652351684`, 
            519.1583932804048}, {314.8451505843609, 518.7528640943779}, {
            314.75, 518.2745098039215}, {314.8451505843609, 
            517.7961555134652}, {315.11611652351684`, 517.3906263274383}, {
            315.52164570954363`, 517.1196603882825}, {316., 
            517.0245098039215}, {316.47835429045637`, 517.1196603882825}, {
            316.88388347648316`, 517.3906263274383}, {317.1548494156391, 
            517.7961555134652}, {317.25, 518.2745098039215}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{357.1548494156391, 522.0552376753892}, {
            356.88388347648316`, 522.4607668614161}, {356.47835429045637`, 
            522.731732800572}, {356., 522.8268833849329}, {
            355.52164570954363`, 522.731732800572}, {355.11611652351684`, 
            522.4607668614161}, {354.8451505843609, 522.0552376753892}, {
            354.75, 521.5768833849329}, {354.8451505843609, 
            521.0985290944766}, {355.11611652351684`, 520.6929999084497}, {
            355.52164570954363`, 520.4220339692938}, {356., 
            520.3268833849329}, {356.47835429045637`, 520.4220339692938}, {
            356.88388347648316`, 520.6929999084497}, {357.1548494156391, 
            521.0985290944766}, {357.25, 521.5768833849329}}]}}}, 
        {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{56., 498.66666666666663`}, {96., 393.9047619047619}, {136.,
           354.22222222222223`}, {176., 335.03030303030306`}, {216., 
          324.3076923076923}, {256., 317.7142857142857}, {296., 
          313.37254901960785`}, {336., 310.3625730994152}, {376., 
          308.1904761904762}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{57.154849415639106`, 499.145020957123}, {
            56.883883476483184`, 499.5505501431498}, {56.47835429045636, 
            499.8215160823057}, {56., 499.91666666666663`}, {
            55.52164570954364, 499.8215160823057}, {55.116116523516816`, 
            499.5505501431498}, {54.845150584360894`, 499.145020957123}, {
            54.75, 498.66666666666663`}, {54.845150584360894`, 
            498.18831237621026`}, {55.116116523516816`, 
            497.78278319018347`}, {55.52164570954364, 497.51181725102754`}, {
            56., 497.41666666666663`}, {56.47835429045636, 
            497.51181725102754`}, {56.883883476483184`, 
            497.78278319018347`}, {57.154849415639106`, 
            498.18831237621026`}, {57.25, 498.66666666666663`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{97.1548494156391, 394.3831161952183}, {
            96.88388347648318, 394.7886453812451}, {96.47835429045637, 
            395.059611320401}, {96., 395.1547619047619}, {95.52164570954363, 
            395.059611320401}, {95.11611652351682, 394.7886453812451}, {
            94.8451505843609, 394.3831161952183}, {94.75, 
            393.9047619047619}, {94.8451505843609, 393.42640761430556`}, {
            95.11611652351682, 393.02087842827876`}, {95.52164570954363, 
            392.74991248912283`}, {96., 392.6547619047619}, {
            96.47835429045637, 392.74991248912283`}, {96.88388347648318, 
            393.02087842827876`}, {97.1548494156391, 393.42640761430556`}, {
            97.25, 393.9047619047619}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{137.15484941563912`, 354.7005765126786}, {
            136.8838834764832, 355.1061056987054}, {136.47835429045637`, 
            355.3770716378613}, {136., 355.47222222222223`}, {
            135.52164570954363`, 355.3770716378613}, {135.1161165235168, 
            355.1061056987054}, {134.84515058436088`, 354.7005765126786}, {
            134.75, 354.22222222222223`}, {134.84515058436088`, 
            353.74386793176586`}, {135.1161165235168, 353.33833874573907`}, {
            135.52164570954363`, 353.06737280658314`}, {136., 
            352.97222222222223`}, {136.47835429045637`, 
            353.06737280658314`}, {136.8838834764832, 353.33833874573907`}, {
            137.15484941563912`, 353.74386793176586`}, {137.25, 
            354.22222222222223`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{177.15484941563912`, 335.5086573207594}, {
            176.8838834764832, 335.9141865067862}, {176.47835429045637`, 
            336.18515244594215`}, {176., 336.28030303030306`}, {
            175.52164570954363`, 336.18515244594215`}, {175.1161165235168, 
            335.9141865067862}, {174.84515058436088`, 335.5086573207594}, {
            174.75, 335.03030303030306`}, {174.84515058436088`, 
            334.5519487398467}, {175.1161165235168, 334.1464195538199}, {
            175.52164570954363`, 333.87545361466397`}, {176., 
            333.78030303030306`}, {176.47835429045637`, 
            333.87545361466397`}, {176.8838834764832, 334.1464195538199}, {
            177.15484941563912`, 334.5519487398467}, {177.25, 
            335.03030303030306`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{217.15484941563912`, 324.7860465981487}, {
            216.8838834764832, 325.1915757841755}, {216.47835429045637`, 
            325.4625417233314}, {216., 325.5576923076923}, {
            215.52164570954363`, 325.4625417233314}, {215.1161165235168, 
            325.1915757841755}, {214.84515058436088`, 324.7860465981487}, {
            214.75, 324.3076923076923}, {214.84515058436088`, 
            323.82933801723595`}, {215.1161165235168, 323.42380883120916`}, {
            215.52164570954363`, 323.15284289205323`}, {216., 
            323.0576923076923}, {216.47835429045637`, 323.15284289205323`}, {
            216.8838834764832, 323.42380883120916`}, {217.15484941563912`, 
            323.82933801723595`}, {217.25, 324.3076923076923}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{257.1548494156391, 318.1926400047421}, {
            256.88388347648316`, 318.5981691907689}, {256.47835429045637`, 
            318.8691351299248}, {256., 318.9642857142857}, {
            255.52164570954363`, 318.8691351299248}, {255.1161165235168, 
            318.5981691907689}, {254.84515058436088`, 318.1926400047421}, {
            254.75, 317.7142857142857}, {254.84515058436088`, 
            317.23593142382936`}, {255.1161165235168, 316.83040223780256`}, {
            255.52164570954363`, 316.55943629864663`}, {256., 
            316.4642857142857}, {256.47835429045637`, 316.55943629864663`}, {
            256.88388347648316`, 316.83040223780256`}, {257.1548494156391, 
            317.23593142382936`}, {257.25, 317.7142857142857}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{297.1548494156391, 313.8509033100642}, {
            296.88388347648316`, 314.256432496091}, {296.47835429045637`, 
            314.52739843524694`}, {296., 314.62254901960785`}, {
            295.52164570954363`, 314.52739843524694`}, {295.11611652351684`, 
            314.256432496091}, {294.8451505843609, 313.8509033100642}, {
            294.75, 313.37254901960785`}, {294.8451505843609, 
            312.8941947291515}, {295.11611652351684`, 312.4886655431247}, {
            295.52164570954363`, 312.21769960396875`}, {296., 
            312.12254901960785`}, {296.47835429045637`, 
            312.21769960396875`}, {296.88388347648316`, 312.4886655431247}, {
            297.1548494156391, 312.8941947291515}, {297.25, 
            313.37254901960785`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{337.1548494156391, 310.8409273898716}, {
            336.88388347648316`, 311.2464565758984}, {336.47835429045637`, 
            311.5174225150543}, {336., 311.6125730994152}, {
            335.52164570954363`, 311.5174225150543}, {335.11611652351684`, 
            311.2464565758984}, {334.8451505843609, 310.8409273898716}, {
            334.75, 310.3625730994152}, {334.8451505843609, 
            309.88421880895885`}, {335.11611652351684`, 
            309.47868962293205`}, {335.52164570954363`, 309.2077236837761}, {
            336., 309.1125730994152}, {336.47835429045637`, 
            309.2077236837761}, {336.88388347648316`, 309.47868962293205`}, {
            337.1548494156391, 309.88421880895885`}, {337.25, 
            310.3625730994152}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{377.1548494156391, 308.66883048093257`}, {
            376.88388347648316`, 309.07435966695937`}, {376.47835429045637`, 
            309.3453256061153}, {376., 309.4404761904762}, {
            375.52164570954363`, 309.3453256061153}, {375.11611652351684`, 
            309.07435966695937`}, {374.8451505843609, 308.66883048093257`}, {
            374.75, 308.1904761904762}, {374.8451505843609, 
            307.71212190001984`}, {375.11611652351684`, 
            307.30659271399304`}, {375.52164570954363`, 307.0356267748371}, {
            376., 306.9404761904762}, {376.47835429045637`, 
            307.0356267748371}, {376.88388347648316`, 307.30659271399304`}, {
            377.1548494156391, 307.71212190001984`}, {377.25, 
            308.1904761904762}}]}}}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{96., 412.95238095238096`}, {136., 457.39682539682536`}, {
          176., 480.48484848484844`}, {216., 494.47086247086247`}, {256., 
          503.79487179487177`}, {296., 510.43137254901956`}, {336., 
          515.3849329205366}, {376., 519.218045112782}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{97.1548494156391, 413.43073524283733`}, {
            96.88388347648318, 413.8362644288641}, {96.47835429045637, 
            414.10723036802005`}, {96., 414.20238095238096`}, {
            95.52164570954363, 414.10723036802005`}, {95.11611652351682, 
            413.8362644288641}, {94.8451505843609, 413.43073524283733`}, {
            94.75, 412.95238095238096`}, {94.8451505843609, 
            412.4740266619246}, {95.11611652351682, 412.0684974758978}, {
            95.52164570954363, 411.7975315367419}, {96., 
            411.70238095238096`}, {96.47835429045637, 411.7975315367419}, {
            96.88388347648318, 412.0684974758978}, {97.1548494156391, 
            412.4740266619246}, {97.25, 412.95238095238096`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{137.15484941563912`, 457.87517968728173`}, {
            136.8838834764832, 458.2807088733085}, {136.47835429045637`, 
            458.55167481246446`}, {136., 458.64682539682536`}, {
            135.52164570954363`, 458.55167481246446`}, {135.1161165235168, 
            458.2807088733085}, {134.84515058436088`, 457.87517968728173`}, {
            134.75, 457.39682539682536`}, {134.84515058436088`, 
            456.918471106369}, {135.1161165235168, 456.5129419203422}, {
            135.52164570954363`, 456.2419759811863}, {136., 
            456.14682539682536`}, {136.47835429045637`, 456.2419759811863}, {
            136.8838834764832, 456.5129419203422}, {137.15484941563912`, 
            456.918471106369}, {137.25, 457.39682539682536`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{177.15484941563912`, 480.9632027753048}, {
            176.8838834764832, 481.3687319613316}, {176.47835429045637`, 
            481.63969790048753`}, {176., 481.73484848484844`}, {
            175.52164570954363`, 481.63969790048753`}, {175.1161165235168, 
            481.3687319613316}, {174.84515058436088`, 480.9632027753048}, {
            174.75, 480.48484848484844`}, {174.84515058436088`, 
            480.0064941943921}, {175.1161165235168, 479.6009650083653}, {
            175.52164570954363`, 479.32999906920935`}, {176., 
            479.23484848484844`}, {176.47835429045637`, 
            479.32999906920935`}, {176.8838834764832, 479.6009650083653}, {
            177.15484941563912`, 480.0064941943921}, {177.25, 
            480.48484848484844`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{217.15484941563912`, 494.94921676131884`}, {
            216.8838834764832, 495.35474594734563`}, {216.47835429045637`, 
            495.62571188650156`}, {216., 495.72086247086247`}, {
            215.52164570954363`, 495.62571188650156`}, {215.1161165235168, 
            495.35474594734563`}, {214.84515058436088`, 
            494.94921676131884`}, {214.75, 494.47086247086247`}, {
            214.84515058436088`, 493.9925081804061}, {215.1161165235168, 
            493.5869789943793}, {215.52164570954363`, 493.3160130552234}, {
            216., 493.22086247086247`}, {216.47835429045637`, 
            493.3160130552234}, {216.8838834764832, 493.5869789943793}, {
            217.15484941563912`, 493.9925081804061}, {217.25, 
            494.47086247086247`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{257.1548494156391, 504.27322608532813`}, {
            256.88388347648316`, 504.67875527135493`}, {256.47835429045637`, 
            504.94972121051086`}, {256., 505.04487179487177`}, {
            255.52164570954363`, 504.94972121051086`}, {255.1161165235168, 
            504.67875527135493`}, {254.84515058436088`, 
            504.27322608532813`}, {254.75, 503.79487179487177`}, {
            254.84515058436088`, 503.3165175044154}, {255.1161165235168, 
            502.9109883183886}, {255.52164570954363`, 502.6400223792327}, {
            256., 502.54487179487177`}, {256.47835429045637`, 
            502.6400223792327}, {256.88388347648316`, 502.9109883183886}, {
            257.1548494156391, 503.3165175044154}, {257.25, 
            503.79487179487177`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{297.1548494156391, 510.9097268394759}, {
            296.88388347648316`, 511.3152560255027}, {296.47835429045637`, 
            511.58622196465865`}, {296., 511.68137254901956`}, {
            295.52164570954363`, 511.58622196465865`}, {295.11611652351684`, 
            511.3152560255027}, {294.8451505843609, 510.9097268394759}, {
            294.75, 510.43137254901956`}, {294.8451505843609, 
            509.9530182585632}, {295.11611652351684`, 509.5474890725364}, {
            295.52164570954363`, 509.27652313338046`}, {296., 
            509.18137254901956`}, {296.47835429045637`, 
            509.27652313338046`}, {296.88388347648316`, 509.5474890725364}, {
            297.1548494156391, 509.9530182585632}, {297.25, 
            510.43137254901956`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{337.1548494156391, 515.8632872109929}, {
            336.88388347648316`, 516.2688163970198}, {336.47835429045637`, 
            516.5397823361757}, {336., 516.6349329205366}, {
            335.52164570954363`, 516.5397823361757}, {335.11611652351684`, 
            516.2688163970198}, {334.8451505843609, 515.8632872109929}, {
            334.75, 515.3849329205366}, {334.8451505843609, 
            514.9065786300803}, {335.11611652351684`, 514.5010494440534}, {
            335.52164570954363`, 514.2300835048975}, {336., 
            514.1349329205366}, {336.47835429045637`, 514.2300835048975}, {
            336.88388347648316`, 514.5010494440534}, {337.1548494156391, 
            514.9065786300803}, {337.25, 515.3849329205366}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{377.1548494156391, 519.6963994032383}, {
            376.88388347648316`, 520.1019285892652}, {376.47835429045637`, 
            520.372894528421}, {376., 520.468045112782}, {375.52164570954363`,
             520.372894528421}, {375.11611652351684`, 520.1019285892652}, {
            374.8451505843609, 519.6963994032383}, {374.75, 
            519.218045112782}, {374.8451505843609, 518.7396908223257}, {
            375.11611652351684`, 518.3341616362987}, {375.52164570954363`, 
            518.0631956971429}, {376., 517.968045112782}, {
            376.47835429045637`, 518.0631956971429}, {376.88388347648316`, 
            518.3341616362987}, {377.1548494156391, 518.7396908223257}, {
            377.25, 519.218045112782}}]}}}, 
        {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{76., 527.2380952380952}, {116., 441.5238095238095}, {156., 
          392.17316017316017`}, {196., 363.93473193473193`}, {236., 
          346.61871461871465`}, {276., 335.3182503770739}, {316., 
          327.562435500516}, {356., 322.01916556096126`}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{77.1548494156391, 527.7164495285515}, {
            76.88388347648318, 528.1219787145784}, {76.47835429045637, 
            528.3929446537343}, {76., 528.4880952380952}, {75.52164570954363, 
            528.3929446537343}, {75.11611652351682, 528.1219787145784}, {
            74.8451505843609, 527.7164495285515}, {74.75, 
            527.2380952380952}, {74.8451505843609, 526.7597409476389}, {
            75.11611652351682, 526.354211761612}, {75.52164570954363, 
            526.0832458224561}, {76., 525.9880952380952}, {76.47835429045637, 
            526.0832458224561}, {76.88388347648318, 526.354211761612}, {
            77.1548494156391, 526.7597409476389}, {77.25, 
            527.2380952380952}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{117.1548494156391, 442.0021638142659}, {
            116.88388347648318`, 442.4076930002927}, {116.47835429045637`, 
            442.6786589394486}, {116., 442.7738095238095}, {
            115.52164570954363`, 442.6786589394486}, {115.11611652351682`, 
            442.4076930002927}, {114.8451505843609, 442.0021638142659}, {
            114.75, 441.5238095238095}, {114.8451505843609, 
            441.04545523335315`}, {115.11611652351682`, 
            440.63992604732636`}, {115.52164570954363`, 440.3689601081704}, {
            116., 440.2738095238095}, {116.47835429045637`, 
            440.3689601081704}, {116.88388347648318`, 440.63992604732636`}, {
            117.1548494156391, 441.04545523335315`}, {117.25, 
            441.5238095238095}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{157.15484941563912`, 392.65151446361654`}, {
            156.8838834764832, 393.05704364964333`}, {156.47835429045637`, 
            393.32800958879926`}, {156., 393.42316017316017`}, {
            155.52164570954363`, 393.32800958879926`}, {155.1161165235168, 
            393.05704364964333`}, {154.84515058436088`, 
            392.65151446361654`}, {154.75, 392.17316017316017`}, {
            154.84515058436088`, 391.6948058827038}, {155.1161165235168, 
            391.289276696677}, {155.52164570954363`, 391.0183107575211}, {
            156., 390.92316017316017`}, {156.47835429045637`, 
            391.0183107575211}, {156.8838834764832, 391.289276696677}, {
            157.15484941563912`, 391.6948058827038}, {157.25, 
            392.17316017316017`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{197.15484941563912`, 364.4130862251883}, {
            196.8838834764832, 364.8186154112151}, {196.47835429045637`, 
            365.089581350371}, {196., 365.18473193473193`}, {
            195.52164570954363`, 365.089581350371}, {195.1161165235168, 
            364.8186154112151}, {194.84515058436088`, 364.4130862251883}, {
            194.75, 363.93473193473193`}, {194.84515058436088`, 
            363.45637764427556`}, {195.1161165235168, 363.05084845824877`}, {
            195.52164570954363`, 362.77988251909284`}, {196., 
            362.68473193473193`}, {196.47835429045637`, 
            362.77988251909284`}, {196.8838834764832, 363.05084845824877`}, {
            197.15484941563912`, 363.45637764427556`}, {197.25, 
            363.93473193473193`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{237.15484941563912`, 347.097068909171}, {
            236.8838834764832, 347.5025980951978}, {236.47835429045637`, 
            347.77356403435374`}, {236., 347.86871461871465`}, {
            235.52164570954363`, 347.77356403435374`}, {235.1161165235168, 
            347.5025980951978}, {234.84515058436088`, 347.097068909171}, {
            234.75, 346.61871461871465`}, {234.84515058436088`, 
            346.1403603282583}, {235.1161165235168, 345.7348311422315}, {
            235.52164570954363`, 345.46386520307556`}, {236., 
            345.36871461871465`}, {236.47835429045637`, 
            345.46386520307556`}, {236.8838834764832, 345.7348311422315}, {
            237.15484941563912`, 346.1403603282583}, {237.25, 
            346.61871461871465`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{277.1548494156391, 335.7966046675303}, {
            276.88388347648316`, 336.2021338535571}, {276.47835429045637`, 
            336.473099792713}, {276., 336.5682503770739}, {
            275.52164570954363`, 336.473099792713}, {275.11611652351684`, 
            336.2021338535571}, {274.8451505843609, 335.7966046675303}, {
            274.75, 335.3182503770739}, {274.8451505843609, 
            334.83989608661756`}, {275.11611652351684`, 
            334.43436690059076`}, {275.52164570954363`, 
            334.16340096143483`}, {276., 334.0682503770739}, {
            276.47835429045637`, 334.16340096143483`}, {276.88388347648316`, 
            334.43436690059076`}, {277.1548494156391, 334.83989608661756`}, {
            277.25, 335.3182503770739}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{317.1548494156391, 328.0407897909724}, {
            316.88388347648316`, 328.4463189769992}, {316.47835429045637`, 
            328.7172849161551}, {316., 328.812435500516}, {
            315.52164570954363`, 328.7172849161551}, {315.11611652351684`, 
            328.4463189769992}, {314.8451505843609, 328.0407897909724}, {
            314.75, 327.562435500516}, {314.8451505843609, 
            327.08408121005965`}, {315.11611652351684`, 
            326.67855202403285`}, {315.52164570954363`, 326.4075860848769}, {
            316., 326.312435500516}, {316.47835429045637`, 
            326.4075860848769}, {316.88388347648316`, 326.67855202403285`}, {
            317.1548494156391, 327.08408121005965`}, {317.25, 
            327.562435500516}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{357.1548494156391, 322.4975198514176}, {
            356.88388347648316`, 322.9030490374444}, {356.47835429045637`, 
            323.17401497660035`}, {356., 323.26916556096126`}, {
            355.52164570954363`, 323.17401497660035`}, {355.11611652351684`, 
            322.9030490374444}, {354.8451505843609, 322.4975198514176}, {
            354.75, 322.01916556096126`}, {354.8451505843609, 
            321.5408112705049}, {355.11611652351684`, 321.1352820844781}, {
            355.52164570954363`, 320.86431614532216`}, {356., 
            320.76916556096126`}, {356.47835429045637`, 
            320.86431614532216`}, {356.88388347648316`, 321.1352820844781}, {
            357.1548494156391, 321.5408112705049}, {357.25, 
            322.01916556096126`}}]}}}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{116., 393.9047619047619}, {156., 441.5238095238095}, {196.,
           468.3636363636363}, {236., 485.1468531468531}, {276., 
          496.46886446886447`}, {316., 504.5490196078431}, {356., 
          510.5689714482284}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{117.1548494156391, 394.3831161952183}, {
            116.88388347648318`, 394.7886453812451}, {116.47835429045637`, 
            395.059611320401}, {116., 395.1547619047619}, {
            115.52164570954363`, 395.059611320401}, {115.11611652351682`, 
            394.7886453812451}, {114.8451505843609, 394.3831161952183}, {
            114.75, 393.9047619047619}, {114.8451505843609, 
            393.42640761430556`}, {115.11611652351682`, 
            393.02087842827876`}, {115.52164570954363`, 
            392.74991248912283`}, {116., 392.6547619047619}, {
            116.47835429045637`, 392.74991248912283`}, {116.88388347648318`, 
            393.02087842827876`}, {117.1548494156391, 393.42640761430556`}, {
            117.25, 393.9047619047619}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{157.15484941563912`, 442.0021638142659}, {
            156.8838834764832, 442.4076930002927}, {156.47835429045637`, 
            442.6786589394486}, {156., 442.7738095238095}, {
            155.52164570954363`, 442.6786589394486}, {155.1161165235168, 
            442.4076930002927}, {154.84515058436088`, 442.0021638142659}, {
            154.75, 441.5238095238095}, {154.84515058436088`, 
            441.04545523335315`}, {155.1161165235168, 440.63992604732636`}, {
            155.52164570954363`, 440.3689601081704}, {156., 
            440.2738095238095}, {156.47835429045637`, 440.3689601081704}, {
            156.8838834764832, 440.63992604732636`}, {157.15484941563912`, 
            441.04545523335315`}, {157.25, 441.5238095238095}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{197.15484941563912`, 468.8419906540927}, {
            196.8838834764832, 469.2475198401195}, {196.47835429045637`, 
            469.5184857792754}, {196., 469.6136363636363}, {
            195.52164570954363`, 469.5184857792754}, {195.1161165235168, 
            469.2475198401195}, {194.84515058436088`, 468.8419906540927}, {
            194.75, 468.3636363636363}, {194.84515058436088`, 
            467.88528207317995`}, {195.1161165235168, 467.47975288715315`}, {
            195.52164570954363`, 467.2087869479972}, {196., 
            467.1136363636363}, {196.47835429045637`, 467.2087869479972}, {
            196.8838834764832, 467.47975288715315`}, {197.15484941563912`, 
            467.88528207317995`}, {197.25, 468.3636363636363}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{237.15484941563912`, 485.6252074373095}, {
            236.8838834764832, 486.0307366233363}, {236.47835429045637`, 
            486.3017025624922}, {236., 486.3968531468531}, {
            235.52164570954363`, 486.3017025624922}, {235.1161165235168, 
            486.0307366233363}, {234.84515058436088`, 485.6252074373095}, {
            234.75, 485.1468531468531}, {234.84515058436088`, 
            484.66849885639675`}, {235.1161165235168, 484.26296967036996`}, {
            235.52164570954363`, 483.992003731214}, {236., 
            483.8968531468531}, {236.47835429045637`, 483.992003731214}, {
            236.8838834764832, 484.26296967036996`}, {237.15484941563912`, 
            484.66849885639675`}, {237.25, 485.1468531468531}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{277.1548494156391, 496.94721875932083`}, {
            276.88388347648316`, 497.35274794534763`}, {276.47835429045637`, 
            497.62371388450356`}, {276., 497.71886446886447`}, {
            275.52164570954363`, 497.62371388450356`}, {275.11611652351684`, 
            497.35274794534763`}, {274.8451505843609, 496.94721875932083`}, {
            274.75, 496.46886446886447`}, {274.8451505843609, 
            495.9905101784081}, {275.11611652351684`, 495.5849809923813}, {
            275.52164570954363`, 495.3140150532254}, {276., 
            495.21886446886447`}, {276.47835429045637`, 495.3140150532254}, {
            276.88388347648316`, 495.5849809923813}, {277.1548494156391, 
            495.9905101784081}, {277.25, 496.46886446886447`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{317.1548494156391, 505.02737389829946`}, {
            316.88388347648316`, 505.43290308432626`}, {316.47835429045637`, 
            505.7038690234822}, {316., 505.7990196078431}, {
            315.52164570954363`, 505.7038690234822}, {315.11611652351684`, 
            505.43290308432626`}, {314.8451505843609, 505.02737389829946`}, {
            314.75, 504.5490196078431}, {314.8451505843609, 
            504.0706653173867}, {315.11611652351684`, 503.66513613135993`}, {
            315.52164570954363`, 503.394170192204}, {316., 
            503.2990196078431}, {316.47835429045637`, 503.394170192204}, {
            316.88388347648316`, 503.66513613135993`}, {317.1548494156391, 
            504.0706653173867}, {317.25, 504.5490196078431}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{357.1548494156391, 511.0473257386848}, {
            356.88388347648316`, 511.4528549247116}, {356.47835429045637`, 
            511.7238208638675}, {356., 511.8189714482284}, {
            355.52164570954363`, 511.7238208638675}, {355.11611652351684`, 
            511.4528549247116}, {354.8451505843609, 511.0473257386848}, {
            354.75, 510.5689714482284}, {354.8451505843609, 
            510.09061715777204`}, {355.11611652351684`, 
            509.68508797174525`}, {355.52164570954363`, 509.4141220325893}, {
            356., 509.3189714482284}, {356.47835429045637`, 
            509.4141220325893}, {356.88388347648316`, 509.68508797174525`}, {
            357.1548494156391, 510.09061715777204`}, {357.25, 
            510.5689714482284}}]}}}, 
        {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{96., 536.7619047619047}, {136., 476.44444444444446`}, {
          176., 425.93939393939394`}, {216., 392.4395604395604}, {256., 
          370.0952380952381}, {296., 354.6890756302521}, {336., 
          343.69590643274853`}, {376., 335.60750360750365`}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{97.1548494156391, 537.240259052361}, {
            96.88388347648318, 537.6457882383879}, {96.47835429045637, 
            537.9167541775438}, {96., 538.0119047619047}, {95.52164570954363, 
            537.9167541775438}, {95.11611652351682, 537.6457882383879}, {
            94.8451505843609, 537.240259052361}, {94.75, 536.7619047619047}, {
            94.8451505843609, 536.2835504714484}, {95.11611652351682, 
            535.8780212854215}, {95.52164570954363, 535.6070553462656}, {96., 
            535.5119047619047}, {96.47835429045637, 535.6070553462656}, {
            96.88388347648318, 535.8780212854215}, {97.1548494156391, 
            536.2835504714484}, {97.25, 536.7619047619047}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{137.15484941563912`, 476.9227987349008}, {
            136.8838834764832, 477.3283279209276}, {136.47835429045637`, 
            477.59929386008355`}, {136., 477.69444444444446`}, {
            135.52164570954363`, 477.59929386008355`}, {135.1161165235168, 
            477.3283279209276}, {134.84515058436088`, 476.9227987349008}, {
            134.75, 476.44444444444446`}, {134.84515058436088`, 
            475.9660901539881}, {135.1161165235168, 475.5605609679613}, {
            135.52164570954363`, 475.28959502880537`}, {136., 
            475.19444444444446`}, {136.47835429045637`, 
            475.28959502880537`}, {136.8838834764832, 475.5605609679613}, {
            137.15484941563912`, 475.9660901539881}, {137.25, 
            476.44444444444446`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{177.15484941563912`, 426.4177482298503}, {
            176.8838834764832, 426.8232774158771}, {176.47835429045637`, 
            427.09424335503303`}, {176., 427.18939393939394`}, {
            175.52164570954363`, 427.09424335503303`}, {175.1161165235168, 
            426.8232774158771}, {174.84515058436088`, 426.4177482298503}, {
            174.75, 425.93939393939394`}, {174.84515058436088`, 
            425.4610396489376}, {175.1161165235168, 425.0555104629108}, {
            175.52164570954363`, 424.78454452375485`}, {176., 
            424.68939393939394`}, {176.47835429045637`, 
            424.78454452375485`}, {176.8838834764832, 425.0555104629108}, {
            177.15484941563912`, 425.4610396489376}, {177.25, 
            425.93939393939394`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{217.15484941563912`, 392.9179147300168}, {
            216.8838834764832, 393.3234439160436}, {216.47835429045637`, 
            393.5944098551995}, {216., 393.6895604395604}, {
            215.52164570954363`, 393.5944098551995}, {215.1161165235168, 
            393.3234439160436}, {214.84515058436088`, 392.9179147300168}, {
            214.75, 392.4395604395604}, {214.84515058436088`, 
            391.96120614910404`}, {215.1161165235168, 391.55567696307725`}, {
            215.52164570954363`, 391.2847110239213}, {216., 
            391.1895604395604}, {216.47835429045637`, 391.2847110239213}, {
            216.8838834764832, 391.55567696307725`}, {217.15484941563912`, 
            391.96120614910404`}, {217.25, 392.4395604395604}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{257.1548494156391, 370.57359238569444`}, {
            256.88388347648316`, 370.97912157172124`}, {256.47835429045637`, 
            371.25008751087717`}, {256., 371.3452380952381}, {
            255.52164570954363`, 371.25008751087717`}, {255.1161165235168, 
            370.97912157172124`}, {254.84515058436088`, 
            370.57359238569444`}, {254.75, 370.0952380952381}, {
            254.84515058436088`, 369.6168838047817}, {255.1161165235168, 
            369.2113546187549}, {255.52164570954363`, 368.940388679599}, {
            256., 368.8452380952381}, {256.47835429045637`, 
            368.940388679599}, {256.88388347648316`, 369.2113546187549}, {
            257.1548494156391, 369.6168838047817}, {257.25, 
            370.0952380952381}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{297.1548494156391, 355.16742992070846`}, {
            296.88388347648316`, 355.57295910673525`}, {296.47835429045637`, 
            355.8439250458912}, {296., 355.9390756302521}, {
            295.52164570954363`, 355.8439250458912}, {295.11611652351684`, 
            355.57295910673525`}, {294.8451505843609, 355.16742992070846`}, {
            294.75, 354.6890756302521}, {294.8451505843609, 
            354.2107213397957}, {295.11611652351684`, 353.8051921537689}, {
            295.52164570954363`, 353.534226214613}, {296., 
            353.4390756302521}, {296.47835429045637`, 353.534226214613}, {
            296.88388347648316`, 353.8051921537689}, {297.1548494156391, 
            354.2107213397957}, {297.25, 354.6890756302521}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{337.1548494156391, 344.1742607232049}, {
            336.88388347648316`, 344.5797899092317}, {336.47835429045637`, 
            344.8507558483876}, {336., 344.94590643274853`}, {
            335.52164570954363`, 344.8507558483876}, {335.11611652351684`, 
            344.5797899092317}, {334.8451505843609, 344.1742607232049}, {
            334.75, 343.69590643274853`}, {334.8451505843609, 
            343.21755214229216`}, {335.11611652351684`, 
            342.81202295626537`}, {335.52164570954363`, 
            342.54105701710944`}, {336., 342.44590643274853`}, {
            336.47835429045637`, 342.54105701710944`}, {336.88388347648316`, 
            342.81202295626537`}, {337.1548494156391, 343.21755214229216`}, {
            337.25, 343.69590643274853`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{377.1548494156391, 336.08585789796}, {
            376.88388347648316`, 336.4913870839868}, {376.47835429045637`, 
            336.76235302314274`}, {376., 336.85750360750365`}, {
            375.52164570954363`, 336.76235302314274`}, {375.11611652351684`, 
            336.4913870839868}, {374.8451505843609, 336.08585789796}, {374.75,
             335.60750360750365`}, {374.8451505843609, 335.1291493170473}, {
            375.11611652351684`, 334.7236201310205}, {375.52164570954363`, 
            334.45265419186455`}, {376., 334.35750360750365`}, {
            376.47835429045637`, 334.45265419186455`}, {376.88388347648316`, 
            334.7236201310205}, {377.1548494156391, 335.1291493170473}, {
            377.25, 335.60750360750365`}}]}}}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{136., 378.031746031746}, {176., 425.93939393939394`}, {
          216., 455.3100233100233}, {256., 474.4908424908425}, {296., 
          487.74229691876747`}, {336., 497.3250773993808}, {376., 
          504.51461988304095`}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{137.15484941563912`, 378.5101003222024}, {
            136.8838834764832, 378.9156295082292}, {136.47835429045637`, 
            379.1865954473851}, {136., 379.281746031746}, {
            135.52164570954363`, 379.1865954473851}, {135.1161165235168, 
            378.9156295082292}, {134.84515058436088`, 378.5101003222024}, {
            134.75, 378.031746031746}, {134.84515058436088`, 
            377.55339174128966`}, {135.1161165235168, 377.14786255526286`}, {
            135.52164570954363`, 376.87689661610693`}, {136., 
            376.781746031746}, {136.47835429045637`, 376.87689661610693`}, {
            136.8838834764832, 377.14786255526286`}, {137.15484941563912`, 
            377.55339174128966`}, {137.25, 378.031746031746}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{177.15484941563912`, 426.4177482298503}, {
            176.8838834764832, 426.8232774158771}, {176.47835429045637`, 
            427.09424335503303`}, {176., 427.18939393939394`}, {
            175.52164570954363`, 427.09424335503303`}, {175.1161165235168, 
            426.8232774158771}, {174.84515058436088`, 426.4177482298503}, {
            174.75, 425.93939393939394`}, {174.84515058436088`, 
            425.4610396489376}, {175.1161165235168, 425.0555104629108}, {
            175.52164570954363`, 424.78454452375485`}, {176., 
            424.68939393939394`}, {176.47835429045637`, 
            424.78454452375485`}, {176.8838834764832, 425.0555104629108}, {
            177.15484941563912`, 425.4610396489376}, {177.25, 
            425.93939393939394`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{217.15484941563912`, 455.7883776004797}, {
            216.8838834764832, 456.1939067865065}, {216.47835429045637`, 
            456.4648727256624}, {216., 456.5600233100233}, {
            215.52164570954363`, 456.4648727256624}, {215.1161165235168, 
            456.1939067865065}, {214.84515058436088`, 455.7883776004797}, {
            214.75, 455.3100233100233}, {214.84515058436088`, 
            454.83166901956696`}, {215.1161165235168, 454.42613983354016`}, {
            215.52164570954363`, 454.15517389438423`}, {216., 
            454.0600233100233}, {216.47835429045637`, 454.15517389438423`}, {
            216.8838834764832, 454.42613983354016`}, {217.15484941563912`, 
            454.83166901956696`}, {217.25, 455.3100233100233}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{257.1548494156391, 474.9691967812989}, {
            256.88388347648316`, 475.3747259673257}, {256.47835429045637`, 
            475.6456919064816}, {256., 475.7408424908425}, {
            255.52164570954363`, 475.6456919064816}, {255.1161165235168, 
            475.3747259673257}, {254.84515058436088`, 474.9691967812989}, {
            254.75, 474.4908424908425}, {254.84515058436088`, 
            474.01248820038614`}, {255.1161165235168, 473.60695901435935`}, {
            255.52164570954363`, 473.3359930752034}, {256., 
            473.2408424908425}, {256.47835429045637`, 473.3359930752034}, {
            256.88388347648316`, 473.60695901435935`}, {257.1548494156391, 
            474.01248820038614`}, {257.25, 474.4908424908425}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{297.1548494156391, 488.22065120922383`}, {
            296.88388347648316`, 488.6261803952506}, {296.47835429045637`, 
            488.89714633440656`}, {296., 488.99229691876747`}, {
            295.52164570954363`, 488.89714633440656`}, {295.11611652351684`, 
            488.6261803952506}, {294.8451505843609, 488.22065120922383`}, {
            294.75, 487.74229691876747`}, {294.8451505843609, 
            487.2639426283111}, {295.11611652351684`, 486.8584134422843}, {
            295.52164570954363`, 486.5874475031284}, {296., 
            486.49229691876747`}, {296.47835429045637`, 486.5874475031284}, {
            296.88388347648316`, 486.8584134422843}, {297.1548494156391, 
            487.2639426283111}, {297.25, 487.74229691876747`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{337.1548494156391, 497.80343168983717`}, {
            336.88388347648316`, 498.20896087586397`}, {336.47835429045637`, 
            498.4799268150199}, {336., 498.5750773993808}, {
            335.52164570954363`, 498.4799268150199}, {335.11611652351684`, 
            498.20896087586397`}, {334.8451505843609, 497.80343168983717`}, {
            334.75, 497.3250773993808}, {334.8451505843609, 
            496.84672310892444`}, {335.11611652351684`, 
            496.44119392289764`}, {335.52164570954363`, 496.1702279837417}, {
            336., 496.0750773993808}, {336.47835429045637`, 
            496.1702279837417}, {336.88388347648316`, 496.44119392289764`}, {
            337.1548494156391, 496.84672310892444`}, {337.25, 
            497.3250773993808}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{377.1548494156391, 504.9929741734973}, {
            376.88388347648316`, 505.3985033595241}, {376.47835429045637`, 
            505.66946929868004`}, {376., 505.76461988304095`}, {
            375.52164570954363`, 505.66946929868004`}, {375.11611652351684`, 
            505.3985033595241}, {374.8451505843609, 504.9929741734973}, {
            374.75, 504.51461988304095`}, {374.8451505843609, 
            504.0362655925846}, {375.11611652351684`, 503.6307364065578}, {
            375.52164570954363`, 503.35977046740186`}, {376., 
            503.26461988304095`}, {376.47835429045637`, 
            503.35977046740186`}, {376.88388347648316`, 503.6307364065578}, {
            377.1548494156391, 504.0362655925846}, {377.25, 
            504.51461988304095`}}]}}}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox["0",
              DisplayForm],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {56.37253305758653, 430.8375236125618}, {0, 1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {"1", "\<\"/\"\>", "2"}
               },
               AutoDelete->False,
               BaselinePosition->{{1, 3}, Baseline},
               
               GridBoxItemSize->{
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
               GridBoxSpacings->{"Columns" -> {{0}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {35.225535031289816`, 433.8439642112147}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {"1", "\<\"/\"\>", "2"}
               },
               AutoDelete->False,
               BaselinePosition->{{1, 3}, Baseline},
               
               GridBoxItemSize->{
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
               GridBoxSpacings->{"Columns" -> {{0}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {76.55172413793103, 430.62068965517244`}, {0, 1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox["1",
              DisplayForm],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {55.28659686873575, 500.53510343902536`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox["1",
              DisplayForm],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {96.6620705367551, 411.46579265988663`}, {0, 1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {"3", "\<\"/\"\>", "2"}
               },
               AutoDelete->False,
               BaselinePosition->{{1, 3}, Baseline},
               
               GridBoxItemSize->{
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
               GridBoxSpacings->{"Columns" -> {{0}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {75.15422906933775, 529.0504615180857}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {"3", "\<\"/\"\>", "2"}
               },
               AutoDelete->False,
               BaselinePosition->{{1, 3}, Baseline},
               
               GridBoxItemSize->{
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
               GridBoxSpacings->{"Columns" -> {{0}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {116.71361582715345`, 392.37335217518273`}, {0, 1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox["2",
              DisplayForm],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {94.89465178587689, 538.4286996879633}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox["2",
              DisplayForm],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {136.71817629441207`, 376.49651706257146`}, {0, 1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {
                 TagBox[GridBox[{
                    {
                    GraphicsBox[{
                    {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
                    None], JoinForm[{"Miter", 3.25}], 
                    LineBox[
                    NCache[{{Rational[-25, 2], 0}, {
                    Rational[25, 2], 0}}, {{-12.5, 0}, {12.5, 0}}]]}, 
                    {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], 
                    Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
                    FaceForm[GrayLevel[0]], 
                    PolygonBox[{{1.1548494156391085`, 0.47835429045636224`}, {
                    0.8838834764831843, 0.8838834764831843}, {
                    0.47835429045636224`, 1.1548494156391085`}, {0., 
                    1.25}, {-0.47835429045636224`, 
                    1.1548494156391085`}, {-0.8838834764831843, 
                    0.8838834764831843}, {-1.1548494156391085`, 
                    0.47835429045636224`}, {-1.25, 
                    0.}, {-1.1548494156391085`, -0.47835429045636224`}, \
{-0.8838834764831843, -0.8838834764831843}, {-0.47835429045636224`, \
-1.1548494156391085`}, {0., -1.25}, {
                    0.47835429045636224`, -1.1548494156391085`}, {
                    0.8838834764831843, -0.8838834764831843}, {
                    1.1548494156391085`, -0.47835429045636224`}, {1.25, 
                    0.}}]}},
                    ImageSize->{25, 4.5},
                    PlotRange->NCache[{{
                    Rational[-25, 2], 
                    Rational[25, 2]}, {-2.25, 2.25}}, {{-12.5, 12.5}, {-2.25, 
                    2.25}}]], 
                    StyleBox[
                    TagBox[
                    TemplateBox[{"\"\[CapitalDelta]\"",TagBox[
                    StyleBox["\"J\"", FontSlant -> "Italic"], 
                    StyleForm[#, FontSlant -> "Italic"]& ],"\"=2\""},
                    "RowDefault"],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                   },
                   AutoDelete->False,
                   
                   GridBoxAlignment->{
                    "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                   
                   GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                   GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                  "Grid"]},
                {
                 TagBox[GridBox[{
                    {
                    GraphicsBox[{
                    {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[2], 
                    CapForm[None], JoinForm[{"Miter", 3.25}], 
                    LineBox[
                    NCache[{{Rational[-25, 2], 0}, {
                    Rational[25, 2], 0}}, {{-12.5, 0}, {12.5, 0}}]]}, 
                    {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], 
                    Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
                    FaceForm[None], 
                    PolygonBox[{{1.1548494156391085`, 0.47835429045636224`}, {
                    0.8838834764831843, 0.8838834764831843}, {
                    0.47835429045636224`, 1.1548494156391085`}, {0., 
                    1.25}, {-0.47835429045636224`, 
                    1.1548494156391085`}, {-0.8838834764831843, 
                    0.8838834764831843}, {-1.1548494156391085`, 
                    0.47835429045636224`}, {-1.25, 
                    0.}, {-1.1548494156391085`, -0.47835429045636224`}, \
{-0.8838834764831843, -0.8838834764831843}, {-0.47835429045636224`, \
-1.1548494156391085`}, {0., -1.25}, {
                    0.47835429045636224`, -1.1548494156391085`}, {
                    0.8838834764831843, -0.8838834764831843}, {
                    1.1548494156391085`, -0.47835429045636224`}, {1.25, 
                    0.}}]}},
                    ImageSize->{25, 4.5},
                    PlotRange->NCache[{{
                    Rational[-25, 2], 
                    Rational[25, 2]}, {-2.25, 2.25}}, {{-12.5, 12.5}, {-2.25, 
                    2.25}}]], 
                    StyleBox[
                    TagBox[
                    TemplateBox[{"\"\[CapitalDelta]\"",TagBox[
                    StyleBox["\"J\"", FontSlant -> "Italic"], 
                    StyleForm[#, FontSlant -> "Italic"]& ],"\"=1\""},
                    "RowDefault"],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                   },
                   AutoDelete->False,
                   
                   GridBoxAlignment->{
                    "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                   
                   GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                   GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                  "Grid"]}
               },
               AutoDelete->False,
               GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Center}}},
               
               GridBoxItemSize->{
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
               GridBoxSpacings->{"Columns" -> {{
                    Rational[5, 8]}}, "Rows" -> {{
                    Rational[1, 8]}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {302.4, 460.79999999999995`}, {-1, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox["0",
             DisplayForm],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {56.37253305758653, 430.8375236125618}, {0, 1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {"1", "\<\"/\"\>", "2"}
              },
              AutoDelete->False,
              BaselinePosition->{{1, 3}, Baseline},
              
              GridBoxItemSize->{
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
              GridBoxSpacings->{"Columns" -> {{0}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {35.225535031289816`, 433.8439642112147}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {"1", "\<\"/\"\>", "2"}
              },
              AutoDelete->False,
              BaselinePosition->{{1, 3}, Baseline},
              
              GridBoxItemSize->{
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
              GridBoxSpacings->{"Columns" -> {{0}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {76.55172413793103, 430.62068965517244`}, {0, 1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox["1",
             DisplayForm],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {55.28659686873575, 500.53510343902536`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox["1",
             DisplayForm],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {96.6620705367551, 411.46579265988663`}, {0, 1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {"3", "\<\"/\"\>", "2"}
              },
              AutoDelete->False,
              BaselinePosition->{{1, 3}, Baseline},
              
              GridBoxItemSize->{
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
              GridBoxSpacings->{"Columns" -> {{0}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {75.15422906933775, 529.0504615180857}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {"3", "\<\"/\"\>", "2"}
              },
              AutoDelete->False,
              BaselinePosition->{{1, 3}, Baseline},
              
              GridBoxItemSize->{
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
              GridBoxSpacings->{"Columns" -> {{0}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {116.71361582715345`, 392.37335217518273`}, {0, 1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox["2",
             DisplayForm],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {94.89465178587689, 538.4286996879633}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox["2",
             DisplayForm],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {136.71817629441207`, 376.49651706257146`}, {0, 1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {
                TagBox[GridBox[{
                   {
                    GraphicsBox[{
                    {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
                    None], JoinForm[{"Miter", 3.25}], 
                    LineBox[
                    NCache[{{Rational[-25, 2], 0}, {
                    Rational[25, 2], 0}}, {{-12.5, 0}, {12.5, 0}}]]}, 
                    {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], 
                    Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
                    FaceForm[GrayLevel[0]], 
                    PolygonBox[{{1.1548494156391085`, 0.47835429045636224`}, {
                    0.8838834764831843, 0.8838834764831843}, {
                    0.47835429045636224`, 1.1548494156391085`}, {0., 
                    1.25}, {-0.47835429045636224`, 
                    1.1548494156391085`}, {-0.8838834764831843, 
                    0.8838834764831843}, {-1.1548494156391085`, 
                    0.47835429045636224`}, {-1.25, 
                    0.}, {-1.1548494156391085`, -0.47835429045636224`}, \
{-0.8838834764831843, -0.8838834764831843}, {-0.47835429045636224`, \
-1.1548494156391085`}, {0., -1.25}, {
                    0.47835429045636224`, -1.1548494156391085`}, {
                    0.8838834764831843, -0.8838834764831843}, {
                    1.1548494156391085`, -0.47835429045636224`}, {1.25, 
                    0.}}]}},
                    ImageSize->{25, 4.5},
                    PlotRange->NCache[{{
                    Rational[-25, 2], 
                    Rational[25, 2]}, {-2.25, 2.25}}, {{-12.5, 12.5}, {-2.25, 
                    2.25}}]], 
                    StyleBox[
                    TagBox[
                    TemplateBox[{"\"\[CapitalDelta]\"",TagBox[
                    StyleBox["\"J\"", FontSlant -> "Italic"], 
                    StyleForm[#, FontSlant -> "Italic"]& ],"\"=2\""},
                    "RowDefault"],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                  },
                  AutoDelete->False,
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                  
                  GridBoxItemSize->{
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                  GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                 "Grid"]},
               {
                TagBox[GridBox[{
                   {
                    GraphicsBox[{
                    {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[2], 
                    CapForm[None], JoinForm[{"Miter", 3.25}], 
                    LineBox[
                    NCache[{{Rational[-25, 2], 0}, {
                    Rational[25, 2], 0}}, {{-12.5, 0}, {12.5, 0}}]]}, 
                    {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], 
                    Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
                    FaceForm[None], 
                    PolygonBox[{{1.1548494156391085`, 0.47835429045636224`}, {
                    0.8838834764831843, 0.8838834764831843}, {
                    0.47835429045636224`, 1.1548494156391085`}, {0., 
                    1.25}, {-0.47835429045636224`, 
                    1.1548494156391085`}, {-0.8838834764831843, 
                    0.8838834764831843}, {-1.1548494156391085`, 
                    0.47835429045636224`}, {-1.25, 
                    0.}, {-1.1548494156391085`, -0.47835429045636224`}, \
{-0.8838834764831843, -0.8838834764831843}, {-0.47835429045636224`, \
-1.1548494156391085`}, {0., -1.25}, {
                    0.47835429045636224`, -1.1548494156391085`}, {
                    0.8838834764831843, -0.8838834764831843}, {
                    1.1548494156391085`, -0.47835429045636224`}, {1.25, 
                    0.}}]}},
                    ImageSize->{25, 4.5},
                    PlotRange->NCache[{{
                    Rational[-25, 2], 
                    Rational[25, 2]}, {-2.25, 2.25}}, {{-12.5, 12.5}, {-2.25, 
                    2.25}}]], 
                    StyleBox[
                    TagBox[
                    TemplateBox[{"\"\[CapitalDelta]\"",TagBox[
                    StyleBox["\"J\"", FontSlant -> "Italic"], 
                    StyleForm[#, FontSlant -> "Italic"]& ],"\"=1\""},
                    "RowDefault"],
                    DisplayForm],
                    StripOnInput->False,
                    ShowAutoStyles->False,
                    SingleLetterItalics->False,
                    LineColor->GrayLevel[0],
                    FrontFaceColor->GrayLevel[0],
                    BackFaceColor->GrayLevel[0],
                    GraphicsColor->GrayLevel[0],
                    FontFamily->"Times",
                    FontSize->16,
                    FontWeight->Plain,
                    FontSlant->Plain,
                    FontTracking->Plain,
                    FontColor->GrayLevel[0]]}
                  },
                  AutoDelete->False,
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Left}}, "Rows" -> {{Center}}},
                  
                  GridBoxItemSize->{
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                  GridBoxSpacings->{"Columns" -> {{
                    Rational[1, 8]}}}],
                 "Grid"]}
              },
              AutoDelete->False,
              GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Center}}},
              
              GridBoxItemSize->{
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
              GridBoxSpacings->{"Columns" -> {{
                   Rational[5, 8]}}, "Rows" -> {{
                   Rational[1, 8]}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {302.4, 460.79999999999995`}, {-1, 1}, 
         Automatic, {1, 0}]},
       Frame->False,
       ImageSize->{432., 288.},
       PlotRange->{{0., 432.}, {288., 576.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 648}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 720},
       PlotRange->{{-72, 504}, {-72, 648}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 648}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 288.}, {0., 576.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{3.6, 298.6666666666667}, {0., 298.6666666666667}}], 
         LineBox[{{1.8, 312.}, {0., 312.}}], 
         LineBox[{{1.8, 325.33333333333337`}, {0., 325.33333333333337`}}], 
         LineBox[{{1.8, 338.6666666666667}, {0., 338.6666666666667}}], 
         LineBox[{{1.8, 352.}, {0., 352.}}], 
         LineBox[{{3.6, 365.33333333333337`}, {0., 365.33333333333337`}}], 
         LineBox[{{1.8, 378.6666666666667}, {0., 378.6666666666667}}], 
         LineBox[{{1.8, 392.}, {0., 392.}}], 
         LineBox[{{1.8, 405.33333333333337`}, {0., 405.33333333333337`}}], 
         LineBox[{{1.8, 418.6666666666667}, {0., 418.6666666666667}}], 
         LineBox[{{3.6, 432.}, {0., 432.}}], 
         LineBox[{{1.8, 445.33333333333337`}, {0., 445.33333333333337`}}], 
         LineBox[{{1.8, 458.66666666666663`}, {0., 458.66666666666663`}}], 
         LineBox[{{1.8, 472.}, {0., 472.}}], 
         LineBox[{{1.8, 485.3333333333333}, {0., 485.3333333333333}}], 
         LineBox[{{3.6, 498.66666666666663`}, {0., 498.66666666666663`}}], 
         LineBox[{{1.8, 512.}, {0., 512.}}], 
         LineBox[{{1.8, 525.3333333333334}, {0., 525.3333333333334}}], 
         LineBox[{{1.8, 538.6666666666666}, {0., 538.6666666666666}}], 
         LineBox[{{1.8, 552.}, {0., 552.}}], 
         LineBox[{{3.6, 565.3333333333333}, {0., 565.3333333333333}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{432., 288.}, {432., 576.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{428.4, 298.6666666666667}, {432., 298.6666666666667}}], 
         LineBox[{{430.2, 312.}, {432., 312.}}], 
         LineBox[{{430.2, 325.33333333333337`}, {432., 325.33333333333337`}}],
          LineBox[{{430.2, 338.6666666666667}, {432., 338.6666666666667}}], 
         LineBox[{{430.2, 352.}, {432., 352.}}], 
         LineBox[{{428.4, 365.33333333333337`}, {432., 365.33333333333337`}}],
          LineBox[{{430.2, 378.6666666666667}, {432., 378.6666666666667}}], 
         LineBox[{{430.2, 392.}, {432., 392.}}], 
         LineBox[{{430.2, 405.33333333333337`}, {432., 405.33333333333337`}}],
          LineBox[{{430.2, 418.6666666666667}, {432., 418.6666666666667}}], 
         LineBox[{{428.4, 432.}, {432., 432.}}], 
         LineBox[{{430.2, 445.33333333333337`}, {432., 445.33333333333337`}}],
          LineBox[{{430.2, 458.66666666666663`}, {432., 
          458.66666666666663`}}], LineBox[{{430.2, 472.}, {432., 472.}}], 
         LineBox[{{430.2, 485.3333333333333}, {432., 485.3333333333333}}], 
         LineBox[{{428.4, 498.66666666666663`}, {432., 498.66666666666663`}}],
          LineBox[{{430.2, 512.}, {432., 512.}}], 
         LineBox[{{430.2, 525.3333333333334}, {432., 525.3333333333334}}], 
         LineBox[{{430.2, 538.6666666666666}, {432., 538.6666666666666}}], 
         LineBox[{{430.2, 552.}, {432., 552.}}], 
         LineBox[{{428.4, 565.3333333333333}, {432., 565.3333333333333}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 288.}, {432., 288.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{16., 289.8}, {16., 288.}}], 
         LineBox[{{36., 289.8}, {36., 288.}}], 
         LineBox[{{56., 291.6}, {56., 288.}}], 
         LineBox[{{76., 289.8}, {76., 288.}}], 
         LineBox[{{96., 289.8}, {96., 288.}}], 
         LineBox[{{116., 289.8}, {116., 288.}}], 
         LineBox[{{136., 291.6}, {136., 288.}}], 
         LineBox[{{156., 289.8}, {156., 288.}}], 
         LineBox[{{176., 289.8}, {176., 288.}}], 
         LineBox[{{196., 289.8}, {196., 288.}}], 
         LineBox[{{216., 291.6}, {216., 288.}}], 
         LineBox[{{236., 289.8}, {236., 288.}}], 
         LineBox[{{256., 289.8}, {256., 288.}}], 
         LineBox[{{276., 289.8}, {276., 288.}}], 
         LineBox[{{296., 291.6}, {296., 288.}}], 
         LineBox[{{316., 289.8}, {316., 288.}}], 
         LineBox[{{336., 289.8}, {336., 288.}}], 
         LineBox[{{356., 289.8}, {356., 288.}}], 
         LineBox[{{376., 291.6}, {376., 288.}}], 
         LineBox[{{396., 289.8}, {396., 288.}}], 
         LineBox[{{416., 289.8}, {416., 288.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 576.}, {432., 576.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{16., 574.2}, {16., 576.}}], 
         LineBox[{{36., 574.2}, {36., 576.}}], 
         LineBox[{{56., 572.4}, {56., 576.}}], 
         LineBox[{{76., 574.2}, {76., 576.}}], 
         LineBox[{{96., 574.2}, {96., 576.}}], 
         LineBox[{{116., 574.2}, {116., 576.}}], 
         LineBox[{{136., 572.4}, {136., 576.}}], 
         LineBox[{{156., 574.2}, {156., 576.}}], 
         LineBox[{{176., 574.2}, {176., 576.}}], 
         LineBox[{{196., 574.2}, {196., 576.}}], 
         LineBox[{{216., 572.4}, {216., 576.}}], 
         LineBox[{{236., 574.2}, {236., 576.}}], 
         LineBox[{{256., 574.2}, {256., 576.}}], 
         LineBox[{{276., 574.2}, {276., 576.}}], 
         LineBox[{{296., 572.4}, {296., 576.}}], 
         LineBox[{{316., 574.2}, {316., 576.}}], 
         LineBox[{{336., 574.2}, {336., 576.}}], 
         LineBox[{{356., 574.2}, {356., 576.}}], 
         LineBox[{{376., 572.4}, {376., 576.}}], 
         LineBox[{{396., 574.2}, {396., 576.}}], 
         LineBox[{{416., 574.2}, {416., 576.}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 298.6666666666667}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 365.33333333333337`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 432.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.3\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 498.66666666666663`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.4\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 565.3333333333333}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"B\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\"(\"",TagBox[
                StyleBox["\"E\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"2","\")\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-20., 432.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 298.6666666666667}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 365.33333333333337`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 432.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.3\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 498.66666666666663`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.4\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 565.3333333333333}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"B\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\"(\"",TagBox[
               StyleBox["\"E\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"2","\")\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-20., 432.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}]},
       Frame->False,
       ImageSize->{576, 720},
       PlotRange->{{-72, 504}, {-72, 648}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 648}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 720},
       PlotRange->{{-72, 504}, {-72, 648}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {432., 288.}]}, InsetBox[
      GraphicsBox[{
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{36., 113.34013676289092`}, {76., 65.90152217640112}, {116.,
           20.383220190804916`}, {156., 32.25220112940782}, {196., 
          13.025022747833471`}, {236., 23.77498678903148}, {276., 
          11.301228295782126`}, {316., 20.14352397686291}, {356., 
          10.80020889462948}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{37.154849415639106`, 113.81849105334729`}, {
            36.883883476483184`, 114.2240202393741}, {36.47835429045636, 
            114.49498617853003`}, {36., 114.59013676289092`}, {
            35.52164570954364, 114.49498617853003`}, {35.116116523516816`, 
            114.2240202393741}, {34.845150584360894`, 113.81849105334729`}, {
            34.75, 113.34013676289092`}, {34.845150584360894`, 
            112.86178247243456`}, {35.116116523516816`, 
            112.45625328640774`}, {35.52164570954364, 112.18528734725182`}, {
            36., 112.09013676289092`}, {36.47835429045636, 
            112.18528734725182`}, {36.883883476483184`, 
            112.45625328640774`}, {37.154849415639106`, 
            112.86178247243456`}, {37.25, 113.34013676289092`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{77.1548494156391, 66.37987646685748}, {
            76.88388347648318, 66.7854056528843}, {76.47835429045637, 
            67.05637159204022}, {76., 67.15152217640112}, {75.52164570954363, 
            67.05637159204022}, {75.11611652351682, 66.7854056528843}, {
            74.8451505843609, 66.37987646685748}, {74.75, 
            65.90152217640112}, {74.8451505843609, 65.42316788594475}, {
            75.11611652351682, 65.01763869991794}, {75.52164570954363, 
            64.74667276076201}, {76., 64.65152217640112}, {76.47835429045637, 
            64.74667276076201}, {76.88388347648318, 65.01763869991794}, {
            77.1548494156391, 65.42316788594475}, {77.25, 
            65.90152217640112}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{117.1548494156391, 20.86157448126128}, {
            116.88388347648318`, 21.2671036672881}, {116.47835429045637`, 
            21.538069606444026`}, {116., 21.633220190804916`}, {
            115.52164570954363`, 21.538069606444026`}, {115.11611652351682`, 
            21.2671036672881}, {114.8451505843609, 20.86157448126128}, {
            114.75, 20.383220190804916`}, {114.8451505843609, 
            19.904865900348554`}, {115.11611652351682`, 
            19.499336714321732`}, {115.52164570954363`, 
            19.228370775165807`}, {116., 19.133220190804916`}, {
            116.47835429045637`, 19.228370775165807`}, {116.88388347648318`, 
            19.499336714321732`}, {117.1548494156391, 19.904865900348554`}, {
            117.25, 20.383220190804916`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{157.15484941563912`, 32.73055541986418}, {
            156.8838834764832, 33.13608460589101}, {156.47835429045637`, 
            33.40705054504693}, {156., 33.50220112940782}, {
            155.52164570954363`, 33.40705054504693}, {155.1161165235168, 
            33.13608460589101}, {154.84515058436088`, 32.73055541986418}, {
            154.75, 32.25220112940782}, {154.84515058436088`, 
            31.77384683895146}, {155.1161165235168, 31.368317652924638`}, {
            155.52164570954363`, 31.097351713768713`}, {156., 
            31.002201129407823`}, {156.47835429045637`, 
            31.097351713768713`}, {156.8838834764832, 31.368317652924638`}, {
            157.15484941563912`, 31.77384683895146}, {157.25, 
            32.25220112940782}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{197.15484941563912`, 13.503377038289834`}, {
            196.8838834764832, 13.908906224316656`}, {196.47835429045637`, 
            14.17987216347258}, {196., 14.275022747833471`}, {
            195.52164570954363`, 14.17987216347258}, {195.1161165235168, 
            13.908906224316656`}, {194.84515058436088`, 
            13.503377038289834`}, {194.75, 13.025022747833471`}, {
            194.84515058436088`, 12.546668457377109`}, {195.1161165235168, 
            12.141139271350287`}, {195.52164570954363`, 
            11.870173332194362`}, {196., 11.775022747833471`}, {
            196.47835429045637`, 11.870173332194362`}, {196.8838834764832, 
            12.141139271350287`}, {197.15484941563912`, 
            12.546668457377109`}, {197.25, 13.025022747833471`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{237.15484941563912`, 24.253341079487843`}, {
            236.8838834764832, 24.658870265514665`}, {236.47835429045637`, 
            24.92983620467059}, {236., 25.02498678903148}, {
            235.52164570954363`, 24.92983620467059}, {235.1161165235168, 
            24.658870265514665`}, {234.84515058436088`, 
            24.253341079487843`}, {234.75, 23.77498678903148}, {
            234.84515058436088`, 23.296632498575118`}, {235.1161165235168, 
            22.891103312548296`}, {235.52164570954363`, 22.62013737339237}, {
            236., 22.52498678903148}, {236.47835429045637`, 
            22.62013737339237}, {236.8838834764832, 22.891103312548296`}, {
            237.15484941563912`, 23.296632498575118`}, {237.25, 
            23.77498678903148}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{277.1548494156391, 11.779582586238488`}, {
            276.88388347648316`, 12.18511177226531}, {276.47835429045637`, 
            12.456077711421234`}, {276., 12.551228295782126`}, {
            275.52164570954363`, 12.456077711421234`}, {275.11611652351684`, 
            12.18511177226531}, {274.8451505843609, 11.779582586238488`}, {
            274.75, 11.301228295782126`}, {274.8451505843609, 
            10.822874005325763`}, {275.11611652351684`, 
            10.417344819298942`}, {275.52164570954363`, 
            10.146378880143018`}, {276., 10.051228295782126`}, {
            276.47835429045637`, 10.146378880143018`}, {276.88388347648316`, 
            10.417344819298942`}, {277.1548494156391, 10.822874005325763`}, {
            277.25, 11.301228295782126`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{317.1548494156391, 20.62187826731927}, {
            316.88388347648316`, 21.027407453346093`}, {316.47835429045637`, 
            21.298373392502018`}, {316., 21.39352397686291}, {
            315.52164570954363`, 21.298373392502018`}, {315.11611652351684`, 
            21.027407453346093`}, {314.8451505843609, 20.62187826731927}, {
            314.75, 20.14352397686291}, {314.8451505843609, 
            19.665169686406546`}, {315.11611652351684`, 
            19.259640500379724`}, {315.52164570954363`, 18.9886745612238}, {
            316., 18.89352397686291}, {316.47835429045637`, 
            18.9886745612238}, {316.88388347648316`, 19.259640500379724`}, {
            317.1548494156391, 19.665169686406546`}, {317.25, 
            20.14352397686291}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{357.1548494156391, 11.278563185085842`}, {
            356.88388347648316`, 11.684092371112664`}, {356.47835429045637`, 
            11.955058310268587`}, {356., 12.05020889462948}, {
            355.52164570954363`, 11.955058310268587`}, {355.11611652351684`, 
            11.684092371112664`}, {354.8451505843609, 11.278563185085842`}, {
            354.75, 10.80020889462948}, {354.8451505843609, 
            10.321854604173117`}, {355.11611652351684`, 9.916325418146295}, {
            355.52164570954363`, 9.645359478990372}, {356., 
            9.55020889462948}, {356.47835429045637`, 9.645359478990372}, {
            356.88388347648316`, 9.916325418146295}, {357.1548494156391, 
            10.321854604173117`}, {357.25, 10.80020889462948}}]}}}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{76., 166.66213104696155`}, {116., 155.24392674914458`}, {
          156., 233.5173300670879}, {196., 181.04390918810532`}, {236., 
          256.11407565664115`}, {276., 192.31501907798508`}, {316., 
          267.60037270479944`}, {356., 198.66186553552342`}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{77.1548494156391, 167.1404853374179}, {
            76.88388347648318, 167.54601452344474`}, {76.47835429045637, 
            167.81698046260067`}, {76., 167.91213104696155`}, {
            75.52164570954363, 167.81698046260067`}, {75.11611652351682, 
            167.54601452344474`}, {74.8451505843609, 167.1404853374179}, {
            74.75, 166.66213104696155`}, {74.8451505843609, 
            166.18377675650518`}, {75.11611652351682, 165.77824757047836`}, {
            75.52164570954363, 165.50728163132243`}, {76., 
            165.41213104696155`}, {76.47835429045637, 165.50728163132243`}, {
            76.88388347648318, 165.77824757047836`}, {77.1548494156391, 
            166.18377675650518`}, {77.25, 166.66213104696155`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{117.1548494156391, 155.72228103960094`}, {
            116.88388347648318`, 156.12781022562777`}, {116.47835429045637`, 
            156.3987761647837}, {116., 156.49392674914458`}, {
            115.52164570954363`, 156.3987761647837}, {115.11611652351682`, 
            156.12781022562777`}, {114.8451505843609, 155.72228103960094`}, {
            114.75, 155.24392674914458`}, {114.8451505843609, 
            154.7655724586882}, {115.11611652351682`, 154.3600432726614}, {
            115.52164570954363`, 154.08907733350546`}, {116., 
            153.99392674914458`}, {116.47835429045637`, 
            154.08907733350546`}, {116.88388347648318`, 154.3600432726614}, {
            117.1548494156391, 154.7655724586882}, {117.25, 
            155.24392674914458`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{157.15484941563912`, 233.99568435754426`}, {
            156.8838834764832, 234.4012135435711}, {156.47835429045637`, 
            234.67217948272702`}, {156., 234.7673300670879}, {
            155.52164570954363`, 234.67217948272702`}, {155.1161165235168, 
            234.4012135435711}, {154.84515058436088`, 233.99568435754426`}, {
            154.75, 233.5173300670879}, {154.84515058436088`, 
            233.03897577663153`}, {155.1161165235168, 232.6334465906047}, {
            155.52164570954363`, 232.36248065144878`}, {156., 
            232.2673300670879}, {156.47835429045637`, 232.36248065144878`}, {
            156.8838834764832, 232.6334465906047}, {157.15484941563912`, 
            233.03897577663153`}, {157.25, 233.5173300670879}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{197.15484941563912`, 181.52226347856168`}, {
            196.8838834764832, 181.9277926645885}, {196.47835429045637`, 
            182.19875860374444`}, {196., 182.29390918810532`}, {
            195.52164570954363`, 182.19875860374444`}, {195.1161165235168, 
            181.9277926645885}, {194.84515058436088`, 181.52226347856168`}, {
            194.75, 181.04390918810532`}, {194.84515058436088`, 
            180.56555489764895`}, {195.1161165235168, 180.16002571162213`}, {
            195.52164570954363`, 179.8890597724662}, {196., 
            179.79390918810532`}, {196.47835429045637`, 179.8890597724662}, {
            196.8838834764832, 180.16002571162213`}, {197.15484941563912`, 
            180.56555489764895`}, {197.25, 181.04390918810532`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{237.15484941563912`, 256.5924299470975}, {
            236.8838834764832, 256.9979591331243}, {236.47835429045637`, 
            257.26892507228024`}, {236., 257.36407565664115`}, {
            235.52164570954363`, 257.26892507228024`}, {235.1161165235168, 
            256.9979591331243}, {234.84515058436088`, 256.5924299470975}, {
            234.75, 256.11407565664115`}, {234.84515058436088`, 
            255.63572136618478`}, {235.1161165235168, 255.23019218015796`}, {
            235.52164570954363`, 254.95922624100203`}, {236., 
            254.86407565664115`}, {236.47835429045637`, 
            254.95922624100203`}, {236.8838834764832, 255.23019218015796`}, {
            237.15484941563912`, 255.63572136618478`}, {237.25, 
            256.11407565664115`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{277.1548494156391, 192.79337336844145`}, {
            276.88388347648316`, 193.19890255446828`}, {276.47835429045637`, 
            193.4698684936242}, {276., 193.56501907798508`}, {
            275.52164570954363`, 193.4698684936242}, {275.11611652351684`, 
            193.19890255446828`}, {274.8451505843609, 192.79337336844145`}, {
            274.75, 192.31501907798508`}, {274.8451505843609, 
            191.83666478752872`}, {275.11611652351684`, 191.4311356015019}, {
            275.52164570954363`, 191.16016966234596`}, {276., 
            191.06501907798508`}, {276.47835429045637`, 
            191.16016966234596`}, {276.88388347648316`, 191.4311356015019}, {
            277.1548494156391, 191.83666478752872`}, {277.25, 
            192.31501907798508`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{317.1548494156391, 268.0787269952558}, {
            316.88388347648316`, 268.4842561812826}, {316.47835429045637`, 
            268.75522212043853`}, {316., 268.85037270479944`}, {
            315.52164570954363`, 268.75522212043853`}, {315.11611652351684`, 
            268.4842561812826}, {314.8451505843609, 268.0787269952558}, {
            314.75, 267.60037270479944`}, {314.8451505843609, 
            267.1220184143431}, {315.11611652351684`, 266.7164892283163}, {
            315.52164570954363`, 266.44552328916035`}, {316., 
            266.35037270479944`}, {316.47835429045637`, 
            266.44552328916035`}, {316.88388347648316`, 266.7164892283163}, {
            317.1548494156391, 267.1220184143431}, {317.25, 
            267.60037270479944`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{357.1548494156391, 199.14021982597978`}, {
            356.88388347648316`, 199.5457490120066}, {356.47835429045637`, 
            199.81671495116254`}, {356., 199.91186553552342`}, {
            355.52164570954363`, 199.81671495116254`}, {355.11611652351684`, 
            199.5457490120066}, {354.8451505843609, 199.14021982597978`}, {
            354.75, 198.66186553552342`}, {354.8451505843609, 
            198.18351124506705`}, {355.11611652351684`, 
            197.77798205904023`}, {355.52164570954363`, 197.5070161198843}, {
            356., 197.41186553552342`}, {356.47835429045637`, 
            197.5070161198843}, {356.88388347648316`, 197.77798205904023`}, {
            357.1548494156391, 198.18351124506705`}, {357.25, 
            198.66186553552342`}}]}}}, 
        {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{56., 179.3401367628909}, {96., 130.66180707412548`}, {136.,
           49.55933523864313}, {176., 63.39084692595865}, {216., 
          25.28466798572729}, {256., 42.156462348877604`}, {296., 
          17.335334342026748`}, {336., 32.53622131970705}, {376., 
          14.001619864180382`}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{57.154849415639106`, 179.81849105334726`}, {
            56.883883476483184`, 180.22402023937408`}, {56.47835429045636, 
            180.49498617853}, {56., 180.5901367628909}, {55.52164570954364, 
            180.49498617853}, {55.116116523516816`, 180.22402023937408`}, {
            54.845150584360894`, 179.81849105334726`}, {54.75, 
            179.3401367628909}, {54.845150584360894`, 178.86178247243453`}, {
            55.116116523516816`, 178.4562532864077}, {55.52164570954364, 
            178.18528734725177`}, {56., 178.0901367628909}, {
            56.47835429045636, 178.18528734725177`}, {56.883883476483184`, 
            178.4562532864077}, {57.154849415639106`, 178.86178247243453`}, {
            57.25, 179.3401367628909}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{97.1548494156391, 131.14016136458184`}, {
            96.88388347648318, 131.54569055060867`}, {96.47835429045637, 
            131.8166564897646}, {96., 131.91180707412548`}, {
            95.52164570954363, 131.8166564897646}, {95.11611652351682, 
            131.54569055060867`}, {94.8451505843609, 131.14016136458184`}, {
            94.75, 130.66180707412548`}, {94.8451505843609, 
            130.1834527836691}, {95.11611652351682, 129.77792359764229`}, {
            95.52164570954363, 129.50695765848636`}, {96., 
            129.41180707412548`}, {96.47835429045637, 129.50695765848636`}, {
            96.88388347648318, 129.77792359764229`}, {97.1548494156391, 
            130.1834527836691}, {97.25, 130.66180707412548`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{137.15484941563912`, 50.03768952909949}, {
            136.8838834764832, 50.443218715126314`}, {136.47835429045637`, 
            50.714184654282235`}, {136., 50.80933523864313}, {
            135.52164570954363`, 50.714184654282235`}, {135.1161165235168, 
            50.443218715126314`}, {134.84515058436088`, 50.03768952909949}, {
            134.75, 49.55933523864313}, {134.84515058436088`, 
            49.08098094818677}, {135.1161165235168, 48.675451762159945`}, {
            135.52164570954363`, 48.40448582300402}, {136., 
            48.30933523864313}, {136.47835429045637`, 48.40448582300402}, {
            136.8838834764832, 48.675451762159945`}, {137.15484941563912`, 
            49.08098094818677}, {137.25, 49.55933523864313}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{177.15484941563912`, 63.86920121641501}, {
            176.8838834764832, 64.27473040244183}, {176.47835429045637`, 
            64.54569634159776}, {176., 64.64084692595864}, {
            175.52164570954363`, 64.54569634159776}, {175.1161165235168, 
            64.27473040244183}, {174.84515058436088`, 63.86920121641501}, {
            174.75, 63.39084692595865}, {174.84515058436088`, 
            62.91249263550229}, {175.1161165235168, 62.506963449475464`}, {
            175.52164570954363`, 62.23599751031954}, {176., 
            62.14084692595865}, {176.47835429045637`, 62.23599751031954}, {
            176.8838834764832, 62.506963449475464`}, {177.15484941563912`, 
            62.91249263550229}, {177.25, 63.39084692595865}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{217.15484941563912`, 25.76302227618365}, {
            216.8838834764832, 26.168551462210473`}, {216.47835429045637`, 
            26.4395174013664}, {216., 26.53466798572729}, {
            215.52164570954363`, 26.4395174013664}, {215.1161165235168, 
            26.168551462210473`}, {214.84515058436088`, 25.76302227618365}, {
            214.75, 25.28466798572729}, {214.84515058436088`, 
            24.806313695270926`}, {215.1161165235168, 24.400784509244104`}, {
            215.52164570954363`, 24.12981857008818}, {216., 
            24.03466798572729}, {216.47835429045637`, 24.12981857008818}, {
            216.8838834764832, 24.400784509244104`}, {217.15484941563912`, 
            24.806313695270926`}, {217.25, 25.28466798572729}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{257.1548494156391, 42.63481663933396}, {
            256.88388347648316`, 43.04034582536079}, {256.47835429045637`, 
            43.31131176451671}, {256., 43.406462348877604`}, {
            255.52164570954363`, 43.31131176451671}, {255.1161165235168, 
            43.04034582536079}, {254.84515058436088`, 42.63481663933396}, {
            254.75, 42.156462348877604`}, {254.84515058436088`, 
            41.678108058421245`}, {255.1161165235168, 41.27257887239442}, {
            255.52164570954363`, 41.0016129332385}, {256., 
            40.906462348877604`}, {256.47835429045637`, 41.0016129332385}, {
            256.88388347648316`, 41.27257887239442}, {257.1548494156391, 
            41.678108058421245`}, {257.25, 42.156462348877604`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{297.1548494156391, 17.81368863248311}, {
            296.88388347648316`, 18.219217818509932`}, {296.47835429045637`, 
            18.490183757665857`}, {296., 18.585334342026748`}, {
            295.52164570954363`, 18.490183757665857`}, {295.11611652351684`, 
            18.219217818509932`}, {294.8451505843609, 17.81368863248311}, {
            294.75, 17.335334342026748`}, {294.8451505843609, 
            16.856980051570385`}, {295.11611652351684`, 
            16.451450865543563`}, {295.52164570954363`, 16.18048492638764}, {
            296., 16.085334342026748`}, {296.47835429045637`, 
            16.18048492638764}, {296.88388347648316`, 16.451450865543563`}, {
            297.1548494156391, 16.856980051570385`}, {297.25, 
            17.335334342026748`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{337.1548494156391, 33.01457561016341}, {
            336.88388347648316`, 33.42010479619024}, {336.47835429045637`, 
            33.69107073534616}, {336., 33.78622131970705}, {
            335.52164570954363`, 33.69107073534616}, {335.11611652351684`, 
            33.42010479619024}, {334.8451505843609, 33.01457561016341}, {
            334.75, 32.53622131970705}, {334.8451505843609, 
            32.057867029250694`}, {335.11611652351684`, 31.65233784322387}, {
            335.52164570954363`, 31.381371904067944`}, {336., 
            31.286221319707053`}, {336.47835429045637`, 
            31.381371904067944`}, {336.88388347648316`, 31.65233784322387}, {
            337.1548494156391, 32.057867029250694`}, {337.25, 
            32.53622131970705}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
           PolygonBox[{{377.1548494156391, 14.479974154636745`}, {
            376.88388347648316`, 14.885503340663567`}, {376.47835429045637`, 
            15.15646927981949}, {376., 15.251619864180382`}, {
            375.52164570954363`, 15.15646927981949}, {375.11611652351684`, 
            14.885503340663567`}, {374.8451505843609, 14.479974154636745`}, {
            374.75, 14.001619864180382`}, {374.8451505843609, 
            13.52326557372402}, {375.11611652351684`, 13.117736387697198`}, {
            375.52164570954363`, 12.846770448541275`}, {376., 
            12.751619864180382`}, {376.47835429045637`, 
            12.846770448541275`}, {376.88388347648316`, 
            13.117736387697198`}, {377.1548494156391, 13.52326557372402}, {
            377.25, 14.001619864180382`}}]}}}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{96., 134.47424663917397`}, {136., 156.70111247204665`}, {
          176., 207.63327116838283`}, {216., 190.80985715665986`}, {256., 
          232.88539995065418`}, {296., 205.49379789407948`}, {336., 
          245.44110237304665`}, {376., 213.5776861015104}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{97.1548494156391, 134.95260092963034`}, {
            96.88388347648318, 135.35813011565716`}, {96.47835429045637, 
            135.6290960548131}, {96., 135.72424663917397`}, {
            95.52164570954363, 135.6290960548131}, {95.11611652351682, 
            135.35813011565716`}, {94.8451505843609, 134.95260092963034`}, {
            94.75, 134.47424663917397`}, {94.8451505843609, 
            133.9958923487176}, {95.11611652351682, 133.59036316269078`}, {
            95.52164570954363, 133.31939722353485`}, {96., 
            133.22424663917397`}, {96.47835429045637, 133.31939722353485`}, {
            96.88388347648318, 133.59036316269078`}, {97.1548494156391, 
            133.9958923487176}, {97.25, 134.47424663917397`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{137.15484941563912`, 157.179466762503}, {
            136.8838834764832, 157.58499594852984`}, {136.47835429045637`, 
            157.85596188768577`}, {136., 157.95111247204665`}, {
            135.52164570954363`, 157.85596188768577`}, {135.1161165235168, 
            157.58499594852984`}, {134.84515058436088`, 157.179466762503}, {
            134.75, 156.70111247204665`}, {134.84515058436088`, 
            156.22275818159028`}, {135.1161165235168, 155.81722899556345`}, {
            135.52164570954363`, 155.54626305640753`}, {136., 
            155.45111247204665`}, {136.47835429045637`, 
            155.54626305640753`}, {136.8838834764832, 155.81722899556345`}, {
            137.15484941563912`, 156.22275818159028`}, {137.25, 
            156.70111247204665`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{177.15484941563912`, 208.1116254588392}, {
            176.8838834764832, 208.51715464486603`}, {176.47835429045637`, 
            208.78812058402195`}, {176., 208.88327116838283`}, {
            175.52164570954363`, 208.78812058402195`}, {175.1161165235168, 
            208.51715464486603`}, {174.84515058436088`, 208.1116254588392}, {
            174.75, 207.63327116838283`}, {174.84515058436088`, 
            207.15491687792647`}, {175.1161165235168, 206.74938769189964`}, {
            175.52164570954363`, 206.4784217527437}, {176., 
            206.38327116838283`}, {176.47835429045637`, 206.4784217527437}, {
            176.8838834764832, 206.74938769189964`}, {177.15484941563912`, 
            207.15491687792647`}, {177.25, 207.63327116838283`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{217.15484941563912`, 191.28821144711623`}, {
            216.8838834764832, 191.69374063314305`}, {216.47835429045637`, 
            191.96470657229898`}, {216., 192.05985715665986`}, {
            215.52164570954363`, 191.96470657229898`}, {215.1161165235168, 
            191.69374063314305`}, {214.84515058436088`, 
            191.28821144711623`}, {214.75, 190.80985715665986`}, {
            214.84515058436088`, 190.3315028662035}, {215.1161165235168, 
            189.92597368017667`}, {215.52164570954363`, 
            189.65500774102074`}, {216., 189.55985715665986`}, {
            216.47835429045637`, 189.65500774102074`}, {216.8838834764832, 
            189.92597368017667`}, {217.15484941563912`, 190.3315028662035}, {
            217.25, 190.80985715665986`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{257.1548494156391, 233.36375424111054`}, {
            256.88388347648316`, 233.76928342713737`}, {256.47835429045637`, 
            234.0402493662933}, {256., 234.13539995065418`}, {
            255.52164570954363`, 234.0402493662933}, {255.1161165235168, 
            233.76928342713737`}, {254.84515058436088`, 
            233.36375424111054`}, {254.75, 232.88539995065418`}, {
            254.84515058436088`, 232.4070456601978}, {255.1161165235168, 
            232.00151647417098`}, {255.52164570954363`, 
            231.73055053501506`}, {256., 231.63539995065418`}, {
            256.47835429045637`, 231.73055053501506`}, {256.88388347648316`, 
            232.00151647417098`}, {257.1548494156391, 232.4070456601978}, {
            257.25, 232.88539995065418`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{297.1548494156391, 205.97215218453584`}, {
            296.88388347648316`, 206.37768137056267`}, {296.47835429045637`, 
            206.6486473097186}, {296., 206.74379789407948`}, {
            295.52164570954363`, 206.6486473097186}, {295.11611652351684`, 
            206.37768137056267`}, {294.8451505843609, 205.97215218453584`}, {
            294.75, 205.49379789407948`}, {294.8451505843609, 
            205.0154436036231}, {295.11611652351684`, 204.6099144175963}, {
            295.52164570954363`, 204.33894847844036`}, {296., 
            204.24379789407948`}, {296.47835429045637`, 
            204.33894847844036`}, {296.88388347648316`, 204.6099144175963}, {
            297.1548494156391, 205.0154436036231}, {297.25, 
            205.49379789407948`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{337.1548494156391, 245.919456663503}, {
            336.88388347648316`, 246.32498584952984`}, {336.47835429045637`, 
            246.59595178868577`}, {336., 246.69110237304665`}, {
            335.52164570954363`, 246.59595178868577`}, {335.11611652351684`, 
            246.32498584952984`}, {334.8451505843609, 245.919456663503}, {
            334.75, 245.44110237304665`}, {334.8451505843609, 
            244.96274808259028`}, {335.11611652351684`, 
            244.55721889656346`}, {335.52164570954363`, 
            244.28625295740753`}, {336., 244.19110237304665`}, {
            336.47835429045637`, 244.28625295740753`}, {336.88388347648316`, 
            244.55721889656346`}, {337.1548494156391, 244.96274808259028`}, {
            337.25, 245.44110237304665`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0]], 
           PolygonBox[{{377.1548494156391, 214.05604039196677`}, {
            376.88388347648316`, 214.4615695779936}, {376.47835429045637`, 
            214.73253551714953`}, {376., 214.8276861015104}, {
            375.52164570954363`, 214.73253551714953`}, {375.11611652351684`, 
            214.4615695779936}, {374.8451505843609, 214.05604039196677`}, {
            374.75, 213.5776861015104}, {374.8451505843609, 
            213.09933181105404`}, {375.11611652351684`, 
            212.69380262502722`}, {375.52164570954363`, 212.4228366858713}, {
            376., 212.3276861015104}, {376.47835429045637`, 
            212.4228366858713}, {376.88388347648316`, 212.69380262502722`}, {
            377.1548494156391, 213.09933181105404`}, {377.25, 
            213.5776861015104}}]}}}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {"1", "\<\"/\"\>", "2"}
               },
               AutoDelete->False,
               BaselinePosition->{{1, 3}, Baseline},
               
               GridBoxItemSize->{
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
               GridBoxSpacings->{"Columns" -> {{0}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {34.71075393876918, 114.8691379380379}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {"1", "\<\"/\"\>", "2"}
               },
               AutoDelete->False,
               BaselinePosition->{{1, 3}, Baseline},
               
               GridBoxItemSize->{
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
               GridBoxSpacings->{"Columns" -> {{0}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {357.0037303187438, 196.9319737911549}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox["1",
              DisplayForm],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {54.73025146756828, 180.88536770497933`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox["1",
              DisplayForm],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {377.564339873401, 212.33155578710193`}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{"\"\[LeftAngleBracket]\"",TagBox[
                StyleBox["\"K\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],
               "\"|\[ScriptCapitalM]|\"",OverscriptBox[
                TagBox[
                 StyleBox["\"K\"", FontSlant -> "Italic"], 
                 StyleForm[#, FontSlant -> "Italic"]& ], "_"],
               "\"\[RightAngleBracket]\"","\"/\"","\"\[LeftAngleBracket]\"",
               TagBox[
                StyleBox["\"K\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],
               "\"|\[ScriptCapitalM]|\"",TagBox[
                StyleBox["\"K\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],
               "\"\[RightAngleBracket]\"","\" = \"","0.1`"},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {21.6, 273.5999999999999}, {-1, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {"1", "\<\"/\"\>", "2"}
              },
              AutoDelete->False,
              BaselinePosition->{{1, 3}, Baseline},
              
              GridBoxItemSize->{
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
              GridBoxSpacings->{"Columns" -> {{0}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {34.71075393876918, 114.8691379380379}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {"1", "\<\"/\"\>", "2"}
              },
              AutoDelete->False,
              BaselinePosition->{{1, 3}, Baseline},
              
              GridBoxItemSize->{
               "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
              GridBoxSpacings->{"Columns" -> {{0}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {357.0037303187438, 196.9319737911549}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox["1",
             DisplayForm],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {54.73025146756828, 180.88536770497933`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox["1",
             DisplayForm],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {377.564339873401, 212.33155578710193`}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{"\"\[LeftAngleBracket]\"",TagBox[
               StyleBox["\"K\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],
              "\"|\[ScriptCapitalM]|\"",OverscriptBox[
               TagBox[
                StyleBox["\"K\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ], "_"],
              "\"\[RightAngleBracket]\"","\"/\"","\"\[LeftAngleBracket]\"",
              TagBox[
               StyleBox["\"K\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],
              "\"|\[ScriptCapitalM]|\"",TagBox[
               StyleBox["\"K\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],
              "\"\[RightAngleBracket]\"","\" = \"","0.1`"},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {21.6, 273.5999999999999}, {-1, 1}, 
         Automatic, {1, 0}]},
       Frame->False,
       ImageSize->{432., 288.},
       PlotRange->{{0., 432.}, {0., 288.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 648}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 720},
       PlotRange->{{-72, 504}, {-72, 648}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 648}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {0., 288.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{3.6, 10.666666666666664`}, {0., 10.666666666666664`}}], 
         LineBox[{{1.8, 23.999999999999996`}, {0., 23.999999999999996`}}], 
         LineBox[{{1.8, 37.33333333333333}, {0., 37.33333333333333}}], 
         LineBox[{{1.8, 50.666666666666664`}, {0., 50.666666666666664`}}], 
         LineBox[{{1.8, 63.99999999999999}, {0., 63.99999999999999}}], 
         LineBox[{{3.6, 77.33333333333331}, {0., 77.33333333333331}}], 
         LineBox[{{1.8, 90.66666666666666}, {0., 90.66666666666666}}], 
         LineBox[{{1.8, 103.99999999999997`}, {0., 103.99999999999997`}}], 
         LineBox[{{1.8, 117.33333333333331`}, {0., 117.33333333333331`}}], 
         LineBox[{{1.8, 130.66666666666666`}, {0., 130.66666666666666`}}], 
         LineBox[{{3.6, 143.99999999999997`}, {0., 143.99999999999997`}}], 
         LineBox[{{1.8, 157.33333333333331`}, {0., 157.33333333333331`}}], 
         LineBox[{{1.8, 170.66666666666663`}, {0., 170.66666666666663`}}], 
         LineBox[{{1.8, 183.99999999999994`}, {0., 183.99999999999994`}}], 
         LineBox[{{1.8, 197.3333333333333}, {0., 197.3333333333333}}], 
         LineBox[{{3.6, 210.66666666666663`}, {0., 210.66666666666663`}}], 
         LineBox[{{1.8, 223.99999999999997`}, {0., 223.99999999999997`}}], 
         LineBox[{{1.8, 237.33333333333331`}, {0., 237.33333333333331`}}], 
         LineBox[{{1.8, 250.66666666666663`}, {0., 250.66666666666663`}}], 
         LineBox[{{1.8, 264.}, {0., 264.}}], 
         LineBox[{{3.6, 277.3333333333333}, {0., 277.3333333333333}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{432., 0.}, {432., 288.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{428.4, 10.666666666666664`}, {432., 10.666666666666664`}}],
          LineBox[{{430.2, 23.999999999999996`}, {432., 
          23.999999999999996`}}], 
         LineBox[{{430.2, 37.33333333333333}, {432., 37.33333333333333}}], 
         LineBox[{{430.2, 50.666666666666664`}, {432., 50.666666666666664`}}],
          LineBox[{{430.2, 63.99999999999999}, {432., 63.99999999999999}}], 
         LineBox[{{428.4, 77.33333333333331}, {432., 77.33333333333331}}], 
         LineBox[{{430.2, 90.66666666666666}, {432., 90.66666666666666}}], 
         LineBox[{{430.2, 103.99999999999997`}, {432., 103.99999999999997`}}],
          LineBox[{{430.2, 117.33333333333331`}, {432., 
          117.33333333333331`}}], 
         LineBox[{{430.2, 130.66666666666666`}, {432., 130.66666666666666`}}],
          LineBox[{{428.4, 143.99999999999997`}, {432., 
          143.99999999999997`}}], 
         LineBox[{{430.2, 157.33333333333331`}, {432., 157.33333333333331`}}],
          LineBox[{{430.2, 170.66666666666663`}, {432., 
          170.66666666666663`}}], 
         LineBox[{{430.2, 183.99999999999994`}, {432., 183.99999999999994`}}],
          LineBox[{{430.2, 197.3333333333333}, {432., 197.3333333333333}}], 
         LineBox[{{428.4, 210.66666666666663`}, {432., 210.66666666666663`}}],
          LineBox[{{430.2, 223.99999999999997`}, {432., 
          223.99999999999997`}}], 
         LineBox[{{430.2, 237.33333333333331`}, {432., 237.33333333333331`}}],
          LineBox[{{430.2, 250.66666666666663`}, {432., 
          250.66666666666663`}}], LineBox[{{430.2, 264.}, {432., 264.}}], 
         LineBox[{{428.4, 277.3333333333333}, {432., 277.3333333333333}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {432., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{16., 1.8}, {16., 0.}}], 
         LineBox[{{36., 1.8}, {36., 0.}}], LineBox[{{56., 3.6}, {56., 0.}}], 
         LineBox[{{76., 1.8}, {76., 0.}}], LineBox[{{96., 1.8}, {96., 0.}}], 
         LineBox[{{116., 1.8}, {116., 0.}}], 
         LineBox[{{136., 3.6}, {136., 0.}}], 
         LineBox[{{156., 1.8}, {156., 0.}}], 
         LineBox[{{176., 1.8}, {176., 0.}}], 
         LineBox[{{196., 1.8}, {196., 0.}}], 
         LineBox[{{216., 3.6}, {216., 0.}}], 
         LineBox[{{236., 1.8}, {236., 0.}}], 
         LineBox[{{256., 1.8}, {256., 0.}}], 
         LineBox[{{276., 1.8}, {276., 0.}}], 
         LineBox[{{296., 3.6}, {296., 0.}}], 
         LineBox[{{316., 1.8}, {316., 0.}}], 
         LineBox[{{336., 1.8}, {336., 0.}}], 
         LineBox[{{356., 1.8}, {356., 0.}}], 
         LineBox[{{376., 3.6}, {376., 0.}}], 
         LineBox[{{396., 1.8}, {396., 0.}}], 
         LineBox[{{416., 1.8}, {416., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 288.}, {432., 288.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{16., 286.2}, {16., 288.}}], 
         LineBox[{{36., 286.2}, {36., 288.}}], 
         LineBox[{{56., 284.4}, {56., 288.}}], 
         LineBox[{{76., 286.2}, {76., 288.}}], 
         LineBox[{{96., 286.2}, {96., 288.}}], 
         LineBox[{{116., 286.2}, {116., 288.}}], 
         LineBox[{{136., 284.4}, {136., 288.}}], 
         LineBox[{{156., 286.2}, {156., 288.}}], 
         LineBox[{{176., 286.2}, {176., 288.}}], 
         LineBox[{{196., 286.2}, {196., 288.}}], 
         LineBox[{{216., 284.4}, {216., 288.}}], 
         LineBox[{{236., 286.2}, {236., 288.}}], 
         LineBox[{{256., 286.2}, {256., 288.}}], 
         LineBox[{{276., 286.2}, {276., 288.}}], 
         LineBox[{{296., 284.4}, {296., 288.}}], 
         LineBox[{{316., 286.2}, {316., 288.}}], 
         LineBox[{{336., 286.2}, {336., 288.}}], 
         LineBox[{{356., 286.2}, {356., 288.}}], 
         LineBox[{{376., 284.4}, {376., 288.}}], 
         LineBox[{{396., 286.2}, {396., 288.}}], 
         LineBox[{{416., 286.2}, {416., 288.}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 10.666666666666664`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 77.33333333333331}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 143.99999999999997`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.3\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 210.66666666666663`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.4\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 277.3333333333333}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TagBox[
                StyleBox["\"B\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\"(\"",TagBox[
                StyleBox["\"E\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"2","\")\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-20., 144.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {56., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 4\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {136., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 6\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {216., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 8\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {296., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"10\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {376., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              StyleBox["\<\"J\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {216., -17.}, {0, 1}, Automatic, {1., 0.}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 10.666666666666664`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 77.33333333333331}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 143.99999999999997`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.3\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 210.66666666666663`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.4\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 277.3333333333333}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TagBox[
               StyleBox["\"B\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\"(\"",TagBox[
               StyleBox["\"E\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"2","\")\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-20., 144.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {56., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 4\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {136., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 6\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {216., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 8\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {296., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"10\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {376., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             StyleBox["\<\"J\"\>",
              FontSlant->"Italic"],
             StyleForm[#, FontSlant -> "Italic"]& ],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {216., -17.}, {0, 1}, Automatic, {1., 0.}]},
       Frame->False,
       ImageSize->{576, 720},
       PlotRange->{{-72, 504}, {-72, 648}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->NCache[
    Rational[5, 4], 1.25],
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{576, 720},
  PlotRange->{{-72, 504}, {-72, 648}}]], "Output",
 CellChangeTimes->{{3.521326994421875*^9, 3.52132701171875*^9}, {
   3.52132704303125*^9, 3.52132714*^9}, 3.52132737578125*^9, 
   3.521327415640625*^9, 3.521327471296875*^9, 3.521400841015625*^9, 
   3.522195331296875*^9, 3.52219540490625*^9, {3.52219548825*^9, 
   3.52219550625*^9}, 3.5221956029375*^9, 3.522195639265625*^9, 
   3.524748147046875*^9, 3.566259734888376*^9, 3.5662597696255116`*^9, {
   3.5662598626918344`*^9, 3.566259894978681*^9}, 3.5662600788141932`*^9, 
   3.566260118734249*^9, {3.566260342754563*^9, 3.566260387154625*^9}, 
   3.566337800283784*^9, 3.579121910682353*^9, 3.579121962456314*^9, 
   3.583784413762645*^9, 3.5943059200053487`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Plotting imported data, plus a complicated diagram -- Shell model basis \
dimension plot\
\>", "Section",
 CellChangeTimes->{{3.4888367863125*^9, 3.48883678853125*^9}, {
  3.491258775640625*^9, 3.491258786375*^9}, {3.49212491759375*^9, 
  3.492124954421875*^9}}],

Cell["\<\
define coordinate system for three-dimensional harmonic oscillator potential
\t(the specific numbers have to do with the quantum mechanics)\
\>", "Text",
 CellChangeTimes->{{3.488837981328125*^9, 3.4888380186875*^9}}],

Cell["First let\[CloseCurlyQuote]s import the data...", "Text",
 CellChangeTimes->{{3.5666653486298018`*^9, 3.566665351989853*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "define", " ", "list", " ", "of", " ", "isotopes", " ", "for", " ", 
    "plot"}], " ", "*)"}], "\n", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"Nuclei", "=", 
     RowBox[{"{", 
      RowBox[{
      "\"\<8Be\>\"", ",", "\"\<12C\>\"", ",", "\"\<16O\>\"", ",", 
       "\"\<20Ne\>\"", ",", "\"\<24Mg\>\""}], "}"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"import", " ", "data"}], " ", "*)"}], "\n", 
   RowBox[{"(*", " ", 
    RowBox[{
    "and", " ", "print", " ", "it", " ", "out", " ", "for", " ", 
     "reference"}], " ", "*)"}], "\n", 
   RowBox[{
    RowBox[{"Do", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"FileName", "=", 
        RowBox[{
        "\"\<SciDraw/ExampleData/dims_\>\"", "<>", "x", "<>", "\"\<_\>\"", "<>",
          "DataSet", "<>", "\"\<.dat\>\""}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Print", "[", "FileName", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DimensionData", "[", 
         RowBox[{"x", ",", "DataSet"}], "]"}], "=", 
        RowBox[{"PrintValue", "@", 
         RowBox[{"Import", "[", "FileName", "]"}]}]}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"x", ",", "Nuclei"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"DataSet", ",", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"x", "\[Equal]", "\"\<12C\>\""}], ",", 
          RowBox[{"{", 
           RowBox[{"\"\<m\>\"", ",", "\"\<j-0\>\""}], "}"}], ",", 
          RowBox[{"{", "\"\<m\>\"", "}"}]}], "]"}]}], "}"}]}], 
     "\[IndentingNewLine]", "]"}], ";"}], "\n"}]}]], "Input",
 CellChangeTimes->{{3.488190852953125*^9, 3.488190857125*^9}, {
  3.566601511240642*^9, 3.566601558539925*^9}, {3.566601653107291*^9, 
  3.566601672950526*^9}, {3.5666650925071173`*^9, 3.566665117862507*^9}, {
  3.566665194768688*^9, 3.5666652739524045`*^9}, {3.5666653221343946`*^9, 
  3.566665335114594*^9}}],

Cell[CellGroupData[{

Cell[BoxData["\<\"SciDraw/ExampleData/dims_8Be_m.dat\"\>"], "Print",
 CellChangeTimes->{3.5666653322920504`*^9, 3.579121912199439*^9, 
  3.583784443667897*^9, 3.5943059227553525`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     \"\>", "\[InvisibleSpace]", "\<\"\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "51"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "5103"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "143792"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "2217754"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "23346724"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "187304858"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"12", ",", "1222330036"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"14", ",", "6770401490"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"16", ",", "32787482114"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"18", ",", "141871838200"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"20", ",", "557615009428"}], "}"}]}], "}"}]}],
  SequenceForm[
  "     ", "", {{0, 51}, {2, 5103}, {4, 143792}, {6, 2217754}, {8, 
   23346724}, {10, 187304858}, {12, 1222330036}, {14, 6770401490}, {16, 
   32787482114}, {18, 141871838200}, {20, 557615009428}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5666653322920504`*^9, 3.579121912199439*^9, 
  3.583784443667897*^9, 3.594305922855353*^9}],

Cell[BoxData["\<\"SciDraw/ExampleData/dims_12C_m.dat\"\>"], "Print",
 CellChangeTimes->{3.5666653322920504`*^9, 3.579121912199439*^9, 
  3.583784443667897*^9, 3.594305922855353*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     \"\>", "\[InvisibleSpace]", "\<\"\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "51"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "17725"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "1118926"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "32598920"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "594496743"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "7830355795"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"12", ",", "80791831793"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"14", ",", "687586662589"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"16", ",", "5000645950810"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"18", ",", "31883820915478"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"20", ",", "181683757394328"}], "}"}]}], "}"}]}],
  SequenceForm[
  "     ", "", {{0, 51}, {2, 17725}, {4, 1118926}, {6, 32598920}, {8, 
   594496743}, {10, 7830355795}, {12, 80791831793}, {14, 687586662589}, {16, 
   5000645950810}, {18, 31883820915478}, {20, 181683757394328}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5666653322920504`*^9, 3.579121912199439*^9, 
  3.583784443667897*^9, 3.594305922875353*^9}],

Cell[BoxData["\<\"SciDraw/ExampleData/dims_12C_j-0.dat\"\>"], "Print",
 CellChangeTimes->{3.5666653322920504`*^9, 3.579121912199439*^9, 
  3.583784443667897*^9, 3.594305922875353*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     \"\>", "\[InvisibleSpace]", "\<\"\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "9"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1223"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "54692"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "1260008"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "19001265"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "212516741"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"12", ",", "1896492709"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"14", ",", "14154420593"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"16", ",", "91266485614"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"18", ",", "520524613808"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"20", ",", "2673031464496"}], "}"}]}], "}"}]}],
  SequenceForm[
  "     ", "", {{0, 9}, {2, 1223}, {4, 54692}, {6, 1260008}, {8, 19001265}, {
   10, 212516741}, {12, 1896492709}, {14, 14154420593}, {16, 91266485614}, {
   18, 520524613808}, {20, 2673031464496}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5666653322920504`*^9, 3.579121912199439*^9, 
  3.583784443667897*^9, 3.594305922895353*^9}],

Cell[BoxData["\<\"SciDraw/ExampleData/dims_16O_m.dat\"\>"], "Print",
 CellChangeTimes->{3.5666653322920504`*^9, 3.579121912199439*^9, 
  3.583784443667897*^9, 3.5943059229053526`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     \"\>", "\[InvisibleSpace]", "\<\"\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "1245"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "345365"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "26483625"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "996878170"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "23709299558"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"12", ",", "406327725468"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"14", ",", "5425818528852"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"16", ",", "59403380960781"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"18", ",", "552459133073711"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"20", ",", "4478768089572347"}], "}"}]}], "}"}]}],
  SequenceForm[
  "     ", "", {{0, 1}, {2, 1245}, {4, 345365}, {6, 26483625}, {8, 
   996878170}, {10, 23709299558}, {12, 406327725468}, {14, 5425818528852}, {
   16, 59403380960781}, {18, 552459133073711}, {20, 4478768089572347}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5666653322920504`*^9, 3.579121912199439*^9, 
  3.583784443667897*^9, 3.594305922925353*^9}],

Cell[BoxData["\<\"SciDraw/ExampleData/dims_20Ne_m.dat\"\>"], "Print",
 CellChangeTimes->{3.5666653322920504`*^9, 3.579121912199439*^9, 
  3.583784443667897*^9, 3.594305922925353*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     \"\>", "\[InvisibleSpace]", "\<\"\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "640"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "542072"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "74668421"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "4392390341"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "152243743459"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "3638757261551"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"12", ",", "65707716312680"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"14", ",", "950734053547124"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"16", ",", "11478322774747285"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"18", ",", "118565877620996657"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"20", ",", "913788212122942315"}], "}"}]}], "}"}]}],
  SequenceForm[
  "     ", "", {{0, 640}, {2, 542072}, {4, 74668421}, {6, 4392390341}, {8, 
   152243743459}, {10, 3638757261551}, {12, 65707716312680}, {14, 
   950734053547124}, {16, 11478322774747285}, {18, 118565877620996657}, {20, 
   913788212122942315}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5666653322920504`*^9, 3.579121912199439*^9, 
  3.583784443667897*^9, 3.5943059229453526`*^9}],

Cell[BoxData["\<\"SciDraw/ExampleData/dims_24Mg_m.dat\"\>"], "Print",
 CellChangeTimes->{3.5666653322920504`*^9, 3.579121912199439*^9, 
  3.583784443667897*^9, 3.5943059229453526`*^9}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"     \"\>", "\[InvisibleSpace]", "\<\"\"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "28503"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "17941903"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"4", ",", "2330225841"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"6", ",", "142516975375"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"8", ",", "5371018298923"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"10", ",", "142772869772281"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"12", ",", "2902084251756085"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"14", ",", "47571333233735467"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"16", ",", "577737308933988851"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"18", ",", "3946162315235158335"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"20", ",", "17360663094100388619"}], "}"}]}], "}"}]}],
  SequenceForm[
  "     ", "", {{0, 28503}, {2, 17941903}, {4, 2330225841}, {6, 
    142516975375}, {8, 5371018298923}, {10, 142772869772281}, {12, 
    2902084251756085}, {14, 47571333233735467}, {16, 577737308933988851}, {18,
     3946162315235158335}, {20, 17360663094100388619}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5666653322920504`*^9, 3.579121912199439*^9, 
  3.583784443667897*^9, 3.5943059229853525`*^9}]
}, Open  ]]
}, Open  ]],

Cell["Now here is the plot itself...", "Text",
 CellChangeTimes->{{3.5666653548373966`*^9, 3.5666653584049516`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "define", " ", "some", " ", "formatting", " ", "for", " ", "each", " ", 
    "for", " ", "each", " ", 
    RowBox[{"isotope", "'"}], "s", " ", "data", " ", "curve"}], " ", "*)"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"NucleusLabels", "=", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\"\<8Be\>\"", "\[Rule]", 
        RowBox[{"Isotope", "[", 
         RowBox[{"8", ",", "\"\<Be\>\""}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<12C\>\"", "\[Rule]", 
        RowBox[{"Isotope", "[", 
         RowBox[{"12", ",", "\"\<C\>\""}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<16O\>\"", "\[Rule]", 
        RowBox[{"Isotope", "[", 
         RowBox[{"16", ",", "\"\<O\>\""}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<20Ne\>\"", "\[Rule]", 
        RowBox[{"Isotope", "[", 
         RowBox[{"20", ",", "\"\<Ne\>\""}], "]"}]}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<24Mg\>\"", "\[Rule]", 
        RowBox[{"Isotope", "[", 
         RowBox[{"24", ",", "\"\<Mg\>\""}], "]"}]}]}], "\[IndentingNewLine]", 
      "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"NucleusPositions", "=", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\"\<8Be\>\"", "\[Rule]", "0.40"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\"\<12C\>\"", "\[Rule]", "0.30"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\"\<16O\>\"", "\[Rule]", "0.53"}], ",", "\[IndentingNewLine]", 
       RowBox[{"\"\<20Ne\>\"", "\[Rule]", "0.29"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"\"\<24Mg\>\"", "\[Rule]", "0.27"}]}], "\[IndentingNewLine]", 
      "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"NucleusColors", "=", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"\"\<12C\>\"", "\[Rule]", "Firebrick"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"_", "\[Rule]", "Black"}]}], "\[IndentingNewLine]", "}"}]}], 
    ";"}], "\[IndentingNewLine]", "\n", 
   RowBox[{"(*", " ", 
    RowBox[{
    "set", " ", "up", " ", "some", " ", "mathematical", " ", "definitions", 
     " ", "related", " ", "to", " ", "the", " ", "shell", " ", "model"}], " ",
     "*)"}], "\n", 
   RowBox[{
    RowBox[{
     RowBox[{"ShellDimension", "[", 
      RowBox[{"N_", "?", "NonNegative"}], "]"}], ":=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"N", "+", "1"}], ")"}], "*", 
      RowBox[{"(", 
       RowBox[{"N", "+", "2"}], ")"}]}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"HOE", "[", 
      RowBox[{"N_", "?", "NonNegative"}], "]"}], ":=", 
     RowBox[{"N", "+", 
      RowBox[{"3", "/", "2"}]}]}], ";"}], "\n", "\n", 
   RowBox[{"(*", " ", 
    RowBox[{
    "set", " ", "up", " ", "function", " ", "for", " ", "drawing", " ", 
     "circles", " ", "in", " ", "schematic", " ", "diagram"}], " ", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"DrawOrbitalCircle", "[", 
      RowBox[{"NShell_Integer", ",", "k_Integer", ",", 
       RowBox[{"ScaleFactor_", "?", "NumericQ"}], ",", 
       RowBox[{"Occupied", ":", 
        RowBox[{"(", 
         RowBox[{"True", "|", "False"}], ")"}]}]}], "]"}], ":=", 
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "y"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"y", "=", 
         RowBox[{"HOE", "[", "NShell", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"x", "=", 
         RowBox[{"ScaleFactor", "*", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"-", "1"}], "/", "2"}], "*", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"ShellDimension", "[", "NShell", "]"}], "-", "1"}], 
              ")"}]}], "+", 
            RowBox[{"(", 
             RowBox[{"k", "-", "1"}], ")"}]}], ")"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"FigCircle", "\[LeftDoubleBracket]", 
          RowBox[{"{", 
           RowBox[{"\"\<orbital\>\"", ",", "NShell", ",", "k"}], "}"}], 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"x", ",", "y"}], "}"}], ",", 
          RowBox[{"ShowFill", "\[Rule]", "Occupied"}]}], "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\n", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", "figure", " ", "*)"}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"Figure", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"SetOptions", "[", 
       RowBox[{"FigObject", ",", 
        RowBox[{"FontSize", "\[Rule]", "12"}]}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"data", " ", "plots"}], " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Do", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"DataPlot", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"DimensionData", "[", 
               RowBox[{"x", ",", "\"\<m\>\""}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"DataLine", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{"Color", "\[Rule]", 
                 RowBox[{"(", 
                  RowBox[{"x", "/.", "NucleusColors"}], ")"}]}], "}"}]}], ",",
               "\[IndentingNewLine]", 
              RowBox[{"DataSymbol", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Color", "\[Rule]", 
                  RowBox[{"(", 
                   RowBox[{"x", "/.", "NucleusColors"}], ")"}]}], ",", 
                 RowBox[{"FillColor", "\[Rule]", "White"}]}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"YAxisScale", "\[Rule]", "Log"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"LeftLabel", "\[Rule]", 
               RowBox[{"(", 
                RowBox[{"x", "/.", "NucleusLabels"}], ")"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"LeftLabelPosition", "\[Rule]", 
               RowBox[{"(", 
                RowBox[{"x", "/.", "NucleusPositions"}], ")"}]}]}], 
             "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"x", ",", "Nuclei"}], "}"}]}], "\[IndentingNewLine]", 
           "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
            RowBox[{
            "special", " ", "data", " ", "plot", " ", "for", " ", "J"}], "=", 
            RowBox[{"0", " ", "curve"}]}], " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{"Block", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"x", "=", "\"\<12C\>\""}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"DataPlot", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"DimensionData", "[", 
               RowBox[{"x", ",", "\"\<j-0\>\""}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"DataLine", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Color", "\[Rule]", 
                  RowBox[{"(", 
                   RowBox[{"x", "/.", "NucleusColors"}], ")"}]}], ",", 
                 RowBox[{"LineDashing", "\[Rule]", "4"}]}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"DataSymbol", "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Color", "\[Rule]", 
                  RowBox[{"(", 
                   RowBox[{"x", "/.", "NucleusColors"}], ")"}]}], ",", 
                 RowBox[{"FillColor", "\[Rule]", "White"}]}], "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"YAxisScale", "\[Rule]", "Log"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"LeftLabel", "\[Rule]", 
               RowBox[{"Row", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"x", "/.", "NucleusLabels"}], ")"}], ",", ",", 
                  "\"\< \>\"", ",", 
                  RowBox[{"textit", "[", "\"\<J\>\"", "]"}], ",", 
                  "\"\<=0\>\""}], "}"}], "]"}]}], ",", "\[IndentingNewLine]", 
              RowBox[{"LeftLabelPosition", "\[Rule]", "0.75"}]}], 
             "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], 
          ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{"inset", " ", "panel"}], " ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"Block", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"NShellMax", "=", "6"}], ",", "\[IndentingNewLine]", 
              "xMax", ",", "yMax", ",", "x", ",", "y"}], 
             "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"yMax", "=", 
              RowBox[{"HOE", "[", 
               RowBox[{"NShellMax", "+", 
                RowBox[{"1", "/", "2"}]}], "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"xMax", "=", 
              RowBox[{"Sqrt", "[", "yMax", "]"}]}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"(*", " ", 
                 RowBox[{"plot", " ", 
                  RowBox[{"levels", " ", "--"}], " ", "behind", " ", 
                  "potential"}], "*)"}], "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"Do", "[", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"y", "=", 
                    RowBox[{"HOE", "[", "NShell", "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{"x", "=", 
                    RowBox[{"Sqrt", "[", "y", "]"}]}], ";", 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"Lev", "\[LeftDoubleBracket]", 
                    RowBox[{"{", 
                    RowBox[{"\"\<shell\>\"", ",", "NShell"}], "}"}], 
                    "\[RightDoubleBracket]"}], "[", 
                    RowBox[{
                    RowBox[{"-", "x"}], ",", "x", ",", "y", ",", 
                    RowBox[{"Color", "\[Rule]", "Gray"}], ",", 
                    RowBox[{"Margin", "\[Rule]", "0"}]}], "]"}]}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"NShell", ",", "0", ",", "NShellMax"}], "}"}]}], 
                  "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
                 "\[IndentingNewLine]", 
                 RowBox[{"(*", " ", 
                  RowBox[{"plot", " ", "potential"}], " ", "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{"FigLine", "[", 
                  RowBox[{
                   RowBox[{"Plot", "[", 
                    RowBox[{
                    RowBox[{"x", "^", "2"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"x", ",", 
                    RowBox[{"-", "xMax"}], ",", 
                    RowBox[{"+", "xMax"}]}], "}"}]}], "]"}], ",", 
                   RowBox[{"LineThickness", "\[Rule]", "2"}]}], "]"}], ";", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"(*", " ", 
                  RowBox[{"show", " ", "nucleons"}], " ", "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{"SetOptions", "[", 
                  RowBox[{"FigCircle", ",", 
                   RowBox[{"Radius", "\[Rule]", 
                    RowBox[{"Canvas", "[", "2", "]"}]}], ",", 
                   RowBox[{"Color", "\[Rule]", "Firebrick"}]}], "]"}], ";", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Do", "[", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"DrawOrbitalCircle", "[", 
                    RowBox[{"NShell", ",", "k", ",", "0.4", ",", 
                    RowBox[{"Switch", "[", 
                    RowBox[{"NShell", ",", "0", ",", "True", ",", "1", ",", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"k", "\[LessEqual]", "4"}], ")"}], "&&", 
                    RowBox[{"(", 
                    RowBox[{"k", "\[NotEqual]", "2"}], ")"}], "&&", 
                    RowBox[{"(", 
                    RowBox[{"k", "\[NotEqual]", "4"}], ")"}]}], ")"}]}], 
                    "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"NShell", ",", "0", ",", "1"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"k", ",", "1", ",", 
                    RowBox[{"ShellDimension", "[", "NShell", "]"}]}], "}"}]}],
                   "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
                 RowBox[{"Do", "[", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"DrawOrbitalCircle", "[", 
                    RowBox[{"NShell", ",", "k", ",", "0.4", ",", "True"}], 
                    "]"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"{", 
                    RowBox[{"NShell", ",", 
                    RowBox[{"{", "3", "}"}]}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"k", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{
                    RowBox[{"ShellDimension", "[", "3", "]"}], "/", "2"}], 
                    "-", "2"}], ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"ShellDimension", "[", "3", "]"}], "/", "2"}], 
                    "+", "2"}]}], "}"}]}], "}"}]}], "\[IndentingNewLine]", 
                  "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"(*", " ", "excitations", " ", "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{"ScopeOptions", "[", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"SetOptions", "[", 
                    RowBox[{"FigArrow", ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ArrowType", "\[Rule]", "\"\<DoubleLine\>\""}], 
                    ",", 
                    RowBox[{"Width", "\[Rule]", "2"}], ",", 
                    RowBox[{"HeadLength", "\[Rule]", "3"}], ",", 
                    RowBox[{"HeadLip", "\[Rule]", "2"}], ",", 
                    RowBox[{"Color", "\[Rule]", "Firebrick"}], ",", 
                    RowBox[{"FillColor", "\[Rule]", "White"}], ",", 
                    RowBox[{"HeadRecess", "\[Rule]", "3"}], ",", 
                    RowBox[{"TailRecess", "\[Rule]", "3"}]}], "}"}]}], "]"}], 
                   ";", "\[IndentingNewLine]", 
                   RowBox[{"FigArrow", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"FigAnchor", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<orbital\>\"", ",", "1", ",", "2"}], "}"}], 
                    ",", "Center"}], "]"}], ",", 
                    RowBox[{"FigAnchor", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<orbital\>\"", ",", "3", ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"ShellDimension", "[", "3", "]"}], "/", "2"}], 
                    "-", "2"}]}], "}"}], ",", "Center"}], "]"}]}], "}"}], 
                    "]"}], ";", "\[IndentingNewLine]", 
                   RowBox[{"FigArrow", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"FigAnchor", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<orbital\>\"", ",", "1", ",", "4"}], "}"}], 
                    ",", "Center"}], "]"}], ",", 
                    RowBox[{"FigAnchor", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<orbital\>\"", ",", "3", ",", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"ShellDimension", "[", "3", "]"}], "/", "2"}], 
                    "+", "2"}]}], "}"}], ",", "Center"}], "]"}]}], "}"}], 
                    "]"}], ";"}], "\[IndentingNewLine]", "]"}], ";", 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"(*", " ", 
                  RowBox[{"mark", " ", "valence", " ", "shell"}], " ", "*)"}],
                  "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"FigArrow", "[", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{
                    RowBox[{"DisplaceHead", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "0"}], "}"}], "]"}], ",", 
                    RowBox[{"FigAnchor", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<shell\>\"", ",", "1"}], "}"}], ",", "Left"}],
                     "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
                   RowBox[{"TailLabel", "\[Rule]", 
                    RowBox[{"Column", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"\"\<Valence\>\"", ",", "\"\<shell\>\""}], "}"}], 
                    ",", "Center", ",", "0"}], "]"}]}], ",", 
                   RowBox[{"TextOrientation", "\[Rule]", "Horizontal"}], ",", 
                   RowBox[{"TextOffset", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"+", "0.75"}], ",", "0"}], "}"}]}], ",", 
                   RowBox[{"FontSize", "\[Rule]", "10"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"HeadLength", "\[Rule]", "3"}], ",", 
                   RowBox[{"HeadLip", "\[Rule]", "2"}], ",", 
                   RowBox[{"HeadRecess", "\[Rule]", "3"}], ",", 
                   RowBox[{"TailRecess", "\[Rule]", "3"}]}], 
                  "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
                "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{"PanelRegion", "->", 
                RowBox[{"Scaled", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"0.5", ",", "1"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "0.60"}], "}"}]}], "}"}], "]"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"PlotRange", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "xMax"}], ",", "xMax"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "yMax"}], "}"}]}], "}"}]}], ",", 
               RowBox[{"ExtendRange", "\[Rule]", "0.2"}], ",", 
               RowBox[{"Frame", "\[Rule]", "False"}]}], "\[IndentingNewLine]",
               "]"}]}]}], "\[IndentingNewLine]", "]"}], ";"}], 
         "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"XPlotRange", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0", ",", "20"}], "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"XFrameLabel", "\[Rule]", "\"\<Excitation quanta\>\""}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"XTicks", "\[Rule]", 
         RowBox[{"LinTicks", "[", 
          RowBox[{"0", ",", "20", ",", "2", ",", "1"}], "]"}]}], ",", 
        RowBox[{"XXShowTicks", "\[Rule]", "False"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"YPlotRange", "->", 
         RowBox[{"{", 
          RowBox[{"0", ",", "12"}], "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"YFrameLabel", "\[Rule]", "\"\<Dimension\>\""}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"YTicks", "->", 
         RowBox[{"LogTicks", "[", 
          RowBox[{"0", ",", "20", ",", 
           RowBox[{"TickLabelStep", "\[Rule]", "2"}]}], "]"}]}], ",", 
        RowBox[{"YYShowTicks", "\[Rule]", "False"}]}], "\[IndentingNewLine]", 
       "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"CanvasSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"4.5", ",", "3.5"}], "}"}]}]}], "\[IndentingNewLine]", 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.488190852953125*^9, 3.488190857125*^9}, {
   3.566601511240642*^9, 3.566601558539925*^9}, {3.566601653107291*^9, 
   3.566601672950526*^9}, {3.5666650925071173`*^9, 3.566665117862507*^9}, {
   3.566665194768688*^9, 3.5666652739524045`*^9}, {3.5666653221343946`*^9, 
   3.566665325889452*^9}, {3.583784199791669*^9, 3.583784199791669*^9}, {
   3.6251801946900096`*^9, 3.625180201288821*^9}, 3.625454736829273*^9}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72., -72.}, {396., 324.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{468., 396.},
       PlotRange->{{-72., 396.}, {-72., 324.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {324., 252.}]}, InsetBox[
      GraphicsBox[{
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, 
        {EdgeForm[None], FaceForm[GrayLevel[0]], PolygonBox[{}]}, {
         {FaceForm[None], RectangleBox[{-72., -72.}, {396., 324.}]}, InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{468., 396.},
           PlotRange->{{-72., 396.}, {-72., 324.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{162., 0.}, {324., 151.2}]}, InsetBox[
          GraphicsBox[{
            {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None],
              JoinForm[{"Miter", 3.25}], 
             LineBox[{{217.94712224766445`, 41.85}, {268.0528777523355, 
              41.85}}]}, 
            {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None],
              JoinForm[{"Miter", 3.25}], 
             LineBox[{{210.65687389687804`, 55.35}, {275.34312610312196`, 
              55.35}}]}, 
            {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None],
              JoinForm[{"Miter", 3.25}], 
             LineBox[{{204.73109710781574`, 68.85}, {281.26890289218426`, 
              68.85}}]}, 
            {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None],
              JoinForm[{"Miter", 3.25}], 
             LineBox[{{199.60714285714286`, 82.35}, {286.3928571428571, 
              82.35}}]}, 
            {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None],
              JoinForm[{"Miter", 3.25}], 
             LineBox[{{195.02739142521654`, 95.85}, {290.97260857478346`, 
              95.85}}]}, 
            {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None],
              JoinForm[{"Miter", 3.25}], 
             LineBox[{{190.8482761941816, 109.35}, {295.1517238058184, 
              109.35}}]}, 
            {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None],
              JoinForm[{"Miter", 3.25}], 
             LineBox[{{186.9800623137856, 122.85}, {299.0199376862144, 
              122.85}}]}, 
            {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJw12Hk4ldvbB3AJURp0hDQhURnK8OxtE74klakoQqYGY/tZm61C4RSNGlCa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              "]]}, 
            {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {EdgeForm[None], FaceForm[RGBColor[0.698004, 0.133305, 0.133305]],
              GeometricTransformationBox[
              DiskBox[{238.90888219456355`, 41.85}, 2, {0., 
               6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             GeometricTransformationBox[
              CircleBox[{238.90888219456355`, 41.85}, 2, {0., 
               6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             LineBox[{{}, {}}]}, 
            {EdgeForm[None], FaceForm[RGBColor[0.698004, 0.133305, 0.133305]],
              GeometricTransformationBox[
              DiskBox[{247.09111780543645`, 41.85}, 2, {0., 
               6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             GeometricTransformationBox[
              CircleBox[{247.09111780543645`, 41.85}, 2, {0., 
               6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             LineBox[{{}, {}}]}, 
            {EdgeForm[None], FaceForm[RGBColor[0.698004, 0.133305, 0.133305]],
              GeometricTransformationBox[
              DiskBox[{222.54441097281773`, 55.35}, 2, {0., 
               6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             GeometricTransformationBox[
              CircleBox[{222.54441097281773`, 55.35}, 2, {0., 
               6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             LineBox[{{}, {}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             GeometricTransformationBox[
              CircleBox[{230.72664658369064`, 55.35}, 2, {0., 
               6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             LineBox[{{}, {}}]}, 
            {EdgeForm[None], FaceForm[RGBColor[0.698004, 0.133305, 0.133305]],
              GeometricTransformationBox[
              DiskBox[{238.90888219456355`, 55.35}, 2, {0., 
               6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             GeometricTransformationBox[
              CircleBox[{238.90888219456355`, 55.35}, 2, {0., 
               6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             LineBox[{{}, {}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             GeometricTransformationBox[
              CircleBox[{247.09111780543645`, 55.35}, 2, {0., 
               6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             LineBox[{{}, {}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             GeometricTransformationBox[
              CircleBox[{255.27335341630936`, 55.35}, 2, {0., 
               6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             LineBox[{{}, {}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             GeometricTransformationBox[
              CircleBox[{263.45558902718227`, 55.35}, 2, {0., 
               6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             LineBox[{{}, {}}]}, 
            {EdgeForm[None], FaceForm[RGBColor[0.698004, 0.133305, 0.133305]],
              GeometricTransformationBox[
              DiskBox[{222.54441097281773`, 82.35}, 2, {0., 
               6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             GeometricTransformationBox[
              CircleBox[{222.54441097281773`, 82.35}, 2, {0., 
               6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             LineBox[{{}, {}}]}, 
            {EdgeForm[None], FaceForm[RGBColor[0.698004, 0.133305, 0.133305]],
              GeometricTransformationBox[
              DiskBox[{255.27335341630936`, 82.35}, 2, {0., 
               6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             GeometricTransformationBox[
              CircleBox[{255.27335341630936`, 82.35}, 2, {0., 
               6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             LineBox[{{}, {}}]}, 
            {EdgeForm[None], FaceForm[GrayLevel[1]], 
             PolygonBox[{{228.89956344571502`, 57.93103994678988}, {
              230.81360404138408`, 58.51108184021729}, {224.66151505750705`, 
              78.81193975537559}, {227.1555975466035, 77.47794105313393}, {
              223.41447381295882`, 79.47893910649641}, {221.41347575959634`, 
              75.73781537285173}, {222.74747446183798`, 78.23189786194818}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             LineBox[{{{230.81360404138408`, 58.51108184021729}, {
              224.66151505750705`, 78.81193975537559}, {227.1555975466035, 
              77.47794105313393}, {223.41447381295882`, 79.47893910649641}, {
              221.41347575959634`, 75.73781537285173}, {222.74747446183798`, 
              78.23189786194818}, {228.89956344571502`, 
              57.93103994678988}}}]}, 
            {EdgeForm[None], FaceForm[GrayLevel[1]], 
             PolygonBox[{{247.004160347743, 58.51108184021729}, {
              248.91820094341207`, 57.93103994678988}, {255.0702899272891, 
              78.23189786194818}, {256.40428862953075`, 75.73781537285173}, {
              254.40329057616827`, 79.47893910649641}, {250.6621668425236, 
              77.47794105313393}, {253.15624933162005`, 78.81193975537559}}]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             LineBox[{{{248.91820094341207`, 57.93103994678988}, {
              255.0702899272891, 78.23189786194818}, {256.40428862953075`, 
              75.73781537285173}, {254.40329057616827`, 79.47893910649641}, {
              250.6621668425236, 77.47794105313393}, {253.15624933162005`, 
              78.81193975537559}, {247.004160347743, 58.51108184021729}}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{193.20128486969577`, 55.35}, {207.65687389687804`, 
              55.35}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{}, {{204.65687389687804`, 57.35}, {207.65687389687804`,
                55.35}, {204.65687389687804`, 53.35}}}]}, InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox[GridBox[{
                   {"Valence"},
                   {"shell"}
                  },
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
                  GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                    "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {193.20128486969577`, 55.35}, {0.75, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox[GridBox[{
                  {"Valence"},
                  {"shell"}
                 },
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
                 GridBoxSpacings->{"Columns" -> {
                    Offset[0.27999999999999997`], {
                    Offset[0.5599999999999999]}, 
                    Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                   "Rows" -> {
                    Offset[0.2], {
                    Offset[0.]}, 
                    Offset[0.2]}, "RowsIndexed" -> {}}],
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {193.20128486969577`, 55.35}, {0.75, 0}, 
             Automatic, {1, 0}]},
           Frame->False,
           ImageSize->{162., 151.2},
           PlotRange->{{162., 324.}, {0., 151.2}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72., -72.}, {396., 324.}]}, InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{468., 396.},
           PlotRange->{{-72., 396.}, {-72., 324.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72., -72.}, {396., 324.}]}, InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{468., 396.},
           PlotRange->{{-72., 396.}, {-72., 324.}}], {0, 0}, {0, 0}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 35.85897369805666}, {32.4, 77.86433693497686}, {64.8, 
          108.31242921127786`}, {97.19999999999999, 133.2641807956952}, {
          129.6, 154.73274493329626`}, {162., 173.72352987202294`}, {
          194.39999999999998`, 190.83095815766455`}, {226.79999999999998`, 
          206.44290289233635`}, {259.2, 220.8298694003883}, {
          291.59999999999997`, 234.18982011228042`}, {324., 
          246.67302355990287`}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{1.1548494156391085`, 36.33732798851302}, {
            0.8838834764831843, 36.74285717453984}, {0.47835429045636224`, 
            37.013823113695764`}, {0., 
            37.10897369805666}, {-0.47835429045636224`, 
            37.013823113695764`}, {-0.8838834764831843, 
            36.74285717453984}, {-1.1548494156391085`, 
            36.33732798851302}, {-1.25, 
            35.85897369805666}, {-1.1548494156391085`, 
            35.3806194076003}, {-0.8838834764831843, 
            34.975090221573474`}, {-0.47835429045636224`, 
            34.70412428241755}, {0., 34.60897369805666}, {
            0.47835429045636224`, 34.70412428241755}, {0.8838834764831843, 
            34.975090221573474`}, {1.1548494156391085`, 35.3806194076003}, {
            1.25, 35.85897369805666}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{33.554849415639104`, 78.34269122543323}, {
            33.28388347648318, 78.74822041146004}, {32.87835429045636, 
            79.01918635061597}, {32.4, 79.11433693497686}, {
            31.921645709543636`, 79.01918635061597}, {31.516116523516814`, 
            78.74822041146004}, {31.24515058436089, 78.34269122543323}, {
            31.15, 77.86433693497686}, {31.24515058436089, 
            77.3859826445205}, {31.516116523516814`, 76.98045345849368}, {
            31.921645709543636`, 76.70948751933776}, {32.4, 
            76.61433693497686}, {32.87835429045636, 76.70948751933776}, {
            33.28388347648318, 76.98045345849368}, {33.554849415639104`, 
            77.3859826445205}, {33.65, 77.86433693497686}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{65.9548494156391, 108.79078350173423`}, {
            65.68388347648317, 109.19631268776104`}, {65.27835429045636, 
            109.46727862691696`}, {64.8, 109.56242921127786`}, {
            64.32164570954363, 109.46727862691696`}, {63.91611652351681, 
            109.19631268776104`}, {63.64515058436089, 108.79078350173423`}, {
            63.55, 108.31242921127786`}, {63.64515058436089, 
            107.8340749208215}, {63.91611652351681, 107.42854573479468`}, {
            64.32164570954363, 107.15757979563875`}, {64.8, 
            107.06242921127786`}, {65.27835429045636, 107.15757979563875`}, {
            65.68388347648317, 107.42854573479468`}, {65.9548494156391, 
            107.8340749208215}, {66.05, 108.31242921127786`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{98.3548494156391, 133.74253508615158`}, {
            98.08388347648317, 134.1480642721784}, {97.67835429045635, 
            134.41903021133433`}, {97.19999999999999, 134.5141807956952}, {
            96.72164570954362, 134.41903021133433`}, {96.31611652351681, 
            134.1480642721784}, {96.04515058436088, 133.74253508615158`}, {
            95.94999999999999, 133.2641807956952}, {96.04515058436088, 
            132.78582650523884`}, {96.31611652351681, 132.38029731921202`}, {
            96.72164570954362, 132.1093313800561}, {97.19999999999999, 
            132.0141807956952}, {97.67835429045635, 132.1093313800561}, {
            98.08388347648317, 132.38029731921202`}, {98.3548494156391, 
            132.78582650523884`}, {98.44999999999999, 133.2641807956952}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{130.75484941563911`, 155.21109922375263`}, {
            130.4838834764832, 155.61662840977945`}, {130.07835429045636`, 
            155.88759434893538`}, {129.6, 155.98274493329626`}, {
            129.12164570954363`, 155.88759434893538`}, {128.7161165235168, 
            155.61662840977945`}, {128.44515058436087`, 
            155.21109922375263`}, {128.35, 154.73274493329626`}, {
            128.44515058436087`, 154.2543906428399}, {128.7161165235168, 
            153.84886145681307`}, {129.12164570954363`, 
            153.57789551765714`}, {129.6, 153.48274493329626`}, {
            130.07835429045636`, 153.57789551765714`}, {130.4838834764832, 
            153.84886145681307`}, {130.75484941563911`, 154.2543906428399}, {
            130.85, 154.73274493329626`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{163.15484941563912`, 174.2018841624793}, {
            162.8838834764832, 174.60741334850613`}, {162.47835429045637`, 
            174.87837928766206`}, {162., 174.97352987202294`}, {
            161.52164570954363`, 174.87837928766206`}, {161.1161165235168, 
            174.60741334850613`}, {160.84515058436088`, 174.2018841624793}, {
            160.75, 173.72352987202294`}, {160.84515058436088`, 
            173.24517558156657`}, {161.1161165235168, 172.83964639553975`}, {
            161.52164570954363`, 172.56868045638382`}, {162., 
            172.47352987202294`}, {162.47835429045637`, 
            172.56868045638382`}, {162.8838834764832, 172.83964639553975`}, {
            163.15484941563912`, 173.24517558156657`}, {163.25, 
            173.72352987202294`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{195.5548494156391, 191.30931244812092`}, {
            195.28388347648317`, 191.71484163414775`}, {194.87835429045634`, 
            191.98580757330367`}, {194.39999999999998`, 
            192.08095815766455`}, {193.9216457095436, 191.98580757330367`}, {
            193.51611652351679`, 191.71484163414775`}, {193.24515058436086`, 
            191.30931244812092`}, {193.14999999999998`, 
            190.83095815766455`}, {193.24515058436086`, 190.3526038672082}, {
            193.51611652351679`, 189.94707468118136`}, {193.9216457095436, 
            189.67610874202543`}, {194.39999999999998`, 
            189.58095815766455`}, {194.87835429045634`, 
            189.67610874202543`}, {195.28388347648317`, 
            189.94707468118136`}, {195.5548494156391, 190.3526038672082}, {
            195.64999999999998`, 190.83095815766455`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{227.9548494156391, 206.92125718279271`}, {
            227.68388347648317`, 207.32678636881954`}, {227.27835429045635`, 
            207.59775230797547`}, {226.79999999999998`, 
            207.69290289233635`}, {226.32164570954362`, 
            207.59775230797547`}, {225.9161165235168, 207.32678636881954`}, {
            225.64515058436086`, 206.92125718279271`}, {225.54999999999998`, 
            206.44290289233635`}, {225.64515058436086`, 
            205.96454860187998`}, {225.9161165235168, 205.55901941585316`}, {
            226.32164570954362`, 205.28805347669723`}, {226.79999999999998`, 
            205.19290289233635`}, {227.27835429045635`, 
            205.28805347669723`}, {227.68388347648317`, 
            205.55901941585316`}, {227.9548494156391, 205.96454860187998`}, {
            228.04999999999998`, 206.44290289233635`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{260.3548494156391, 221.30822369084467`}, {
            260.08388347648315`, 221.7137528768715}, {259.67835429045635`, 
            221.98471881602742`}, {259.2, 222.0798694003883}, {
            258.7216457095436, 221.98471881602742`}, {258.3161165235168, 
            221.7137528768715}, {258.0451505843609, 221.30822369084467`}, {
            257.95, 220.8298694003883}, {258.0451505843609, 
            220.35151510993194`}, {258.3161165235168, 219.9459859239051}, {
            258.7216457095436, 219.67501998474918`}, {259.2, 
            219.5798694003883}, {259.67835429045635`, 219.67501998474918`}, {
            260.08388347648315`, 219.9459859239051}, {260.3548494156391, 
            220.35151510993194`}, {260.45, 220.8298694003883}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{292.75484941563906`, 234.66817440273678`}, {
            292.48388347648313`, 235.0737035887636}, {292.07835429045633`, 
            235.34466952791954`}, {291.59999999999997`, 
            235.43982011228042`}, {291.1216457095436, 235.34466952791954`}, {
            290.7161165235168, 235.0737035887636}, {290.4451505843609, 
            234.66817440273678`}, {290.34999999999997`, 
            234.18982011228042`}, {290.4451505843609, 233.71146582182405`}, {
            290.7161165235168, 233.30593663579722`}, {291.1216457095436, 
            233.0349706966413}, {291.59999999999997`, 232.93982011228042`}, {
            292.07835429045633`, 233.0349706966413}, {292.48388347648313`, 
            233.30593663579722`}, {292.75484941563906`, 
            233.71146582182405`}, {292.84999999999997`, 
            234.18982011228042`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{325.1548494156391, 247.15137785035924`}, {
            324.88388347648316`, 247.55690703638606`}, {324.47835429045637`, 
            247.827872975542}, {324., 247.92302355990287`}, {
            323.52164570954363`, 247.827872975542}, {323.11611652351684`, 
            247.55690703638606`}, {322.8451505843609, 247.15137785035924`}, {
            322.75, 246.67302355990287`}, {322.8451505843609, 
            246.1946692694465}, {323.11611652351684`, 245.78914008341968`}, {
            323.52164570954363`, 245.51817414426375`}, {324., 
            245.42302355990287`}, {324.47835429045637`, 
            245.51817414426375`}, {324.88388347648316`, 
            245.78914008341968`}, {325.1548494156391, 246.1946692694465}, {
            325.25, 246.67302355990287`}}]}}}, 
        {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 35.85897369805666}, {32.4, 89.22031112095718}, {64.8, 
          127.02482867505655`}, {97.19999999999999, 157.77726745535278`}, {
          129.6, 184.25713907249624`}, {162., 207.76941141473486`}, {
          194.39999999999998`, 229.05471655501054`}, {226.79999999999998`, 
          248.58387632193984`}, {259.2, 266.6795482530184}, {
          291.59999999999997`, 283.5749775836593}, {324., 
          299.445638161549}}]}, 
        {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[
         1], Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
         FaceForm[GrayLevel[1]], {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{1.1548494156391085`, 36.33732798851302}, {
            0.8838834764831843, 36.74285717453984}, {0.47835429045636224`, 
            37.013823113695764`}, {0., 
            37.10897369805666}, {-0.47835429045636224`, 
            37.013823113695764`}, {-0.8838834764831843, 
            36.74285717453984}, {-1.1548494156391085`, 
            36.33732798851302}, {-1.25, 
            35.85897369805666}, {-1.1548494156391085`, 
            35.3806194076003}, {-0.8838834764831843, 
            34.975090221573474`}, {-0.47835429045636224`, 
            34.70412428241755}, {0., 34.60897369805666}, {
            0.47835429045636224`, 34.70412428241755}, {0.8838834764831843, 
            34.975090221573474`}, {1.1548494156391085`, 35.3806194076003}, {
            1.25, 35.85897369805666}}]}}, {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{33.554849415639104`, 89.69866541141354}, {
            33.28388347648318, 90.10419459744035}, {32.87835429045636, 
            90.37516053659628}, {32.4, 90.47031112095718}, {
            31.921645709543636`, 90.37516053659628}, {31.516116523516814`, 
            90.10419459744035}, {31.24515058436089, 89.69866541141354}, {
            31.15, 89.22031112095718}, {31.24515058436089, 
            88.74195683050081}, {31.516116523516814`, 88.336427644474}, {
            31.921645709543636`, 88.06546170531807}, {32.4, 
            87.97031112095718}, {32.87835429045636, 88.06546170531807}, {
            33.28388347648318, 88.336427644474}, {33.554849415639104`, 
            88.74195683050081}, {33.65, 89.22031112095718}}]}}, {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{65.9548494156391, 127.50318296551292`}, {
            65.68388347648317, 127.90871215153973`}, {65.27835429045636, 
            128.17967809069566`}, {64.8, 128.27482867505654`}, {
            64.32164570954363, 128.17967809069566`}, {63.91611652351681, 
            127.90871215153973`}, {63.64515058436089, 127.50318296551292`}, {
            63.55, 127.02482867505655`}, {63.64515058436089, 
            126.54647438460019`}, {63.91611652351681, 126.14094519857338`}, {
            64.32164570954363, 125.86997925941745`}, {64.8, 
            125.77482867505655`}, {65.27835429045636, 125.86997925941745`}, {
            65.68388347648317, 126.14094519857338`}, {65.9548494156391, 
            126.54647438460019`}, {66.05, 127.02482867505655`}}]}}, {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{98.3548494156391, 158.25562174580915`}, {
            98.08388347648317, 158.66115093183598`}, {97.67835429045635, 
            158.9321168709919}, {97.19999999999999, 159.02726745535278`}, {
            96.72164570954362, 158.9321168709919}, {96.31611652351681, 
            158.66115093183598`}, {96.04515058436088, 158.25562174580915`}, {
            95.94999999999999, 157.77726745535278`}, {96.04515058436088, 
            157.29891316489642`}, {96.31611652351681, 156.8933839788696}, {
            96.72164570954362, 156.62241803971366`}, {97.19999999999999, 
            156.52726745535278`}, {97.67835429045635, 156.62241803971366`}, {
            98.08388347648317, 156.8933839788696}, {98.3548494156391, 
            157.29891316489642`}, {98.44999999999999, 
            157.77726745535278`}}]}}, {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{130.75484941563911`, 184.7354933629526}, {
            130.4838834764832, 185.14102254897944`}, {130.07835429045636`, 
            185.41198848813536`}, {129.6, 185.50713907249624`}, {
            129.12164570954363`, 185.41198848813536`}, {128.7161165235168, 
            185.14102254897944`}, {128.44515058436087`, 184.7354933629526}, {
            128.35, 184.25713907249624`}, {128.44515058436087`, 
            183.77878478203988`}, {128.7161165235168, 183.37325559601305`}, {
            129.12164570954363`, 183.10228965685712`}, {129.6, 
            183.00713907249624`}, {130.07835429045636`, 
            183.10228965685712`}, {130.4838834764832, 183.37325559601305`}, {
            130.75484941563911`, 183.77878478203988`}, {130.85, 
            184.25713907249624`}}]}}, {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{163.15484941563912`, 208.24776570519123`}, {
            162.8838834764832, 208.65329489121805`}, {162.47835429045637`, 
            208.92426083037398`}, {162., 209.01941141473486`}, {
            161.52164570954363`, 208.92426083037398`}, {161.1161165235168, 
            208.65329489121805`}, {160.84515058436088`, 
            208.24776570519123`}, {160.75, 207.76941141473486`}, {
            160.84515058436088`, 207.2910571242785}, {161.1161165235168, 
            206.88552793825167`}, {161.52164570954363`, 
            206.61456199909574`}, {162., 206.51941141473486`}, {
            162.47835429045637`, 206.61456199909574`}, {162.8838834764832, 
            206.88552793825167`}, {163.15484941563912`, 207.2910571242785}, {
            163.25, 207.76941141473486`}}]}}, {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{195.5548494156391, 229.5330708454669}, {
            195.28388347648317`, 229.93860003149373`}, {194.87835429045634`, 
            230.20956597064966`}, {194.39999999999998`, 
            230.30471655501054`}, {193.9216457095436, 230.20956597064966`}, {
            193.51611652351679`, 229.93860003149373`}, {193.24515058436086`, 
            229.5330708454669}, {193.14999999999998`, 229.05471655501054`}, {
            193.24515058436086`, 228.57636226455418`}, {193.51611652351679`, 
            228.17083307852735`}, {193.9216457095436, 227.89986713937142`}, {
            194.39999999999998`, 227.80471655501054`}, {194.87835429045634`, 
            227.89986713937142`}, {195.28388347648317`, 
            228.17083307852735`}, {195.5548494156391, 228.57636226455418`}, {
            195.64999999999998`, 229.05471655501054`}}]}}, {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{227.9548494156391, 249.0622306123962}, {
            227.68388347648317`, 249.46775979842303`}, {227.27835429045635`, 
            249.73872573757896`}, {226.79999999999998`, 
            249.83387632193984`}, {226.32164570954362`, 
            249.73872573757896`}, {225.9161165235168, 249.46775979842303`}, {
            225.64515058436086`, 249.0622306123962}, {225.54999999999998`, 
            248.58387632193984`}, {225.64515058436086`, 
            248.10552203148347`}, {225.9161165235168, 247.69999284545665`}, {
            226.32164570954362`, 247.42902690630072`}, {226.79999999999998`, 
            247.33387632193984`}, {227.27835429045635`, 
            247.42902690630072`}, {227.68388347648317`, 
            247.69999284545665`}, {227.9548494156391, 248.10552203148347`}, {
            228.04999999999998`, 248.58387632193984`}}]}}, {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{260.3548494156391, 267.1579025434748}, {
            260.08388347648315`, 267.5634317295016}, {259.67835429045635`, 
            267.8343976686575}, {259.2, 267.9295482530184}, {
            258.7216457095436, 267.8343976686575}, {258.3161165235168, 
            267.5634317295016}, {258.0451505843609, 267.1579025434748}, {
            257.95, 266.6795482530184}, {258.0451505843609, 
            266.20119396256206`}, {258.3161165235168, 265.79566477653526`}, {
            258.7216457095436, 265.52469883737933`}, {259.2, 
            265.4295482530184}, {259.67835429045635`, 265.52469883737933`}, {
            260.08388347648315`, 265.79566477653526`}, {260.3548494156391, 
            266.20119396256206`}, {260.45, 266.6795482530184}}]}}, {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{292.75484941563906`, 284.05333187411566`}, {
            292.48388347648313`, 284.45886106014245`}, {292.07835429045633`, 
            284.7298269992984}, {291.59999999999997`, 284.8249775836593}, {
            291.1216457095436, 284.7298269992984}, {290.7161165235168, 
            284.45886106014245`}, {290.4451505843609, 284.05333187411566`}, {
            290.34999999999997`, 283.5749775836593}, {290.4451505843609, 
            283.0966232932029}, {290.7161165235168, 282.6910941071761}, {
            291.1216457095436, 282.4201281680202}, {291.59999999999997`, 
            282.3249775836593}, {292.07835429045633`, 282.4201281680202}, {
            292.48388347648313`, 282.6910941071761}, {292.75484941563906`, 
            283.0966232932029}, {292.84999999999997`, 283.5749775836593}}]}}, {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{325.1548494156391, 299.9239924520054}, {
            324.88388347648316`, 300.3295216380322}, {324.47835429045637`, 
            300.6004875771881}, {324., 300.695638161549}, {
            323.52164570954363`, 300.6004875771881}, {323.11611652351684`, 
            300.3295216380322}, {322.8451505843609, 299.9239924520054}, {
            322.75, 299.445638161549}, {322.8451505843609, 
            298.96728387109266`}, {323.11611652351684`, 
            298.56175468506586`}, {323.52164570954363`, 
            298.29078874590994`}, {324., 298.195638161549}, {
            324.47835429045637`, 298.29078874590994`}, {324.88388347648316`, 
            298.56175468506586`}, {325.1548494156391, 298.96728387109266`}, {
            325.25, 299.445638161549}}]}}}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 0.}, {32.4, 64.99855638006684}, {64.8, 
          116.30384478645844`}, {97.19999999999999, 155.88252602530173`}, {
          129.6, 188.97148380105034`}, {162., 217.87329320062892`}, {
          194.39999999999998`, 243.7864055990192}, {226.79999999999998`, 
          267.42377055066856`}, {259.2, 289.2500344373208}, {
          291.59999999999997`, 309.5883033092699}, {324., 
          328.6743300808053}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{1.1548494156391085`, 0.47835429045636224`}, {
            0.8838834764831843, 0.8838834764831843}, {0.47835429045636224`, 
            1.1548494156391085`}, {0., 1.25}, {-0.47835429045636224`, 
            1.1548494156391085`}, {-0.8838834764831843, 
            0.8838834764831843}, {-1.1548494156391085`, 
            0.47835429045636224`}, {-1.25, 
            0.}, {-1.1548494156391085`, -0.47835429045636224`}, \
{-0.8838834764831843, -0.8838834764831843}, {-0.47835429045636224`, \
-1.1548494156391085`}, {0., -1.25}, {
            0.47835429045636224`, -1.1548494156391085`}, {
            0.8838834764831843, -0.8838834764831843}, {
            1.1548494156391085`, -0.47835429045636224`}, {1.25, 0.}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{33.554849415639104`, 65.47691067052321}, {
            33.28388347648318, 65.88243985655002}, {32.87835429045636, 
            66.15340579570595}, {32.4, 66.24855638006684}, {
            31.921645709543636`, 66.15340579570595}, {31.516116523516814`, 
            65.88243985655002}, {31.24515058436089, 65.47691067052321}, {
            31.15, 64.99855638006684}, {31.24515058436089, 
            64.52020208961048}, {31.516116523516814`, 64.11467290358367}, {
            31.921645709543636`, 63.84370696442774}, {32.4, 
            63.748556380066844`}, {32.87835429045636, 63.84370696442774}, {
            33.28388347648318, 64.11467290358367}, {33.554849415639104`, 
            64.52020208961048}, {33.65, 64.99855638006684}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{65.9548494156391, 116.78219907691481`}, {
            65.68388347648317, 117.18772826294162`}, {65.27835429045636, 
            117.45869420209755`}, {64.8, 117.55384478645844`}, {
            64.32164570954363, 117.45869420209755`}, {63.91611652351681, 
            117.18772826294162`}, {63.64515058436089, 116.78219907691481`}, {
            63.55, 116.30384478645844`}, {63.64515058436089, 
            115.82549049600208`}, {63.91611652351681, 115.41996130997526`}, {
            64.32164570954363, 115.14899537081934`}, {64.8, 
            115.05384478645844`}, {65.27835429045636, 115.14899537081934`}, {
            65.68388347648317, 115.41996130997526`}, {65.9548494156391, 
            115.82549049600208`}, {66.05, 116.30384478645844`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{98.3548494156391, 156.3608803157581}, {
            98.08388347648317, 156.76640950178492`}, {97.67835429045635, 
            157.03737544094085`}, {97.19999999999999, 157.13252602530173`}, {
            96.72164570954362, 157.03737544094085`}, {96.31611652351681, 
            156.76640950178492`}, {96.04515058436088, 156.3608803157581}, {
            95.94999999999999, 155.88252602530173`}, {96.04515058436088, 
            155.40417173484536`}, {96.31611652351681, 154.99864254881854`}, {
            96.72164570954362, 154.7276766096626}, {97.19999999999999, 
            154.63252602530173`}, {97.67835429045635, 154.7276766096626}, {
            98.08388347648317, 154.99864254881854`}, {98.3548494156391, 
            155.40417173484536`}, {98.44999999999999, 
            155.88252602530173`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{130.75484941563911`, 189.4498380915067}, {
            130.4838834764832, 189.85536727753353`}, {130.07835429045636`, 
            190.12633321668946`}, {129.6, 190.22148380105034`}, {
            129.12164570954363`, 190.12633321668946`}, {128.7161165235168, 
            189.85536727753353`}, {128.44515058436087`, 189.4498380915067}, {
            128.35, 188.97148380105034`}, {128.44515058436087`, 
            188.49312951059397`}, {128.7161165235168, 188.08760032456715`}, {
            129.12164570954363`, 187.81663438541122`}, {129.6, 
            187.72148380105034`}, {130.07835429045636`, 
            187.81663438541122`}, {130.4838834764832, 188.08760032456715`}, {
            130.75484941563911`, 188.49312951059397`}, {130.85, 
            188.97148380105034`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{163.15484941563912`, 218.3516474910853}, {
            162.8838834764832, 218.7571766771121}, {162.47835429045637`, 
            219.02814261626804`}, {162., 219.12329320062892`}, {
            161.52164570954363`, 219.02814261626804`}, {161.1161165235168, 
            218.7571766771121}, {160.84515058436088`, 218.3516474910853}, {
            160.75, 217.87329320062892`}, {160.84515058436088`, 
            217.39493891017256`}, {161.1161165235168, 216.98940972414573`}, {
            161.52164570954363`, 216.7184437849898}, {162., 
            216.62329320062892`}, {162.47835429045637`, 216.7184437849898}, {
            162.8838834764832, 216.98940972414573`}, {163.15484941563912`, 
            217.39493891017256`}, {163.25, 217.87329320062892`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{195.5548494156391, 244.26475988947556`}, {
            195.28388347648317`, 244.67028907550238`}, {194.87835429045634`, 
            244.9412550146583}, {194.39999999999998`, 245.0364055990192}, {
            193.9216457095436, 244.9412550146583}, {193.51611652351679`, 
            244.67028907550238`}, {193.24515058436086`, 
            244.26475988947556`}, {193.14999999999998`, 243.7864055990192}, {
            193.24515058436086`, 243.30805130856282`}, {193.51611652351679`, 
            242.902522122536}, {193.9216457095436, 242.63155618338007`}, {
            194.39999999999998`, 242.5364055990192}, {194.87835429045634`, 
            242.63155618338007`}, {195.28388347648317`, 242.902522122536}, {
            195.5548494156391, 243.30805130856282`}, {195.64999999999998`, 
            243.7864055990192}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{227.9548494156391, 267.90212484112493`}, {
            227.68388347648317`, 268.3076540271517}, {227.27835429045635`, 
            268.57861996630766`}, {226.79999999999998`, 
            268.67377055066856`}, {226.32164570954362`, 
            268.57861996630766`}, {225.9161165235168, 268.3076540271517}, {
            225.64515058436086`, 267.90212484112493`}, {225.54999999999998`, 
            267.42377055066856`}, {225.64515058436086`, 266.9454162602122}, {
            225.9161165235168, 266.5398870741854}, {226.32164570954362`, 
            266.2689211350295}, {226.79999999999998`, 266.17377055066856`}, {
            227.27835429045635`, 266.2689211350295}, {227.68388347648317`, 
            266.5398870741854}, {227.9548494156391, 266.9454162602122}, {
            228.04999999999998`, 267.42377055066856`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{260.3548494156391, 289.72838872777714`}, {
            260.08388347648315`, 290.13391791380394`}, {259.67835429045635`, 
            290.40488385295987`}, {259.2, 290.5000344373208}, {
            258.7216457095436, 290.40488385295987`}, {258.3161165235168, 
            290.13391791380394`}, {258.0451505843609, 289.72838872777714`}, {
            257.95, 289.2500344373208}, {258.0451505843609, 
            288.7716801468644}, {258.3161165235168, 288.3661509608376}, {
            258.7216457095436, 288.0951850216817}, {259.2, 
            288.0000344373208}, {259.67835429045635`, 288.0951850216817}, {
            260.08388347648315`, 288.3661509608376}, {260.3548494156391, 
            288.7716801468644}, {260.45, 289.2500344373208}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{292.75484941563906`, 310.0666575997263}, {
            292.48388347648313`, 310.4721867857531}, {292.07835429045633`, 
            310.743152724909}, {291.59999999999997`, 310.8383033092699}, {
            291.1216457095436, 310.743152724909}, {290.7161165235168, 
            310.4721867857531}, {290.4451505843609, 310.0666575997263}, {
            290.34999999999997`, 309.5883033092699}, {290.4451505843609, 
            309.10994901881355`}, {290.7161165235168, 308.70441983278675`}, {
            291.1216457095436, 308.4334538936308}, {291.59999999999997`, 
            308.3383033092699}, {292.07835429045633`, 308.4334538936308}, {
            292.48388347648313`, 308.70441983278675`}, {292.75484941563906`, 
            309.10994901881355`}, {292.84999999999997`, 
            309.5883033092699}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{325.1548494156391, 329.15268437126167`}, {
            324.88388347648316`, 329.55821355728847`}, {324.47835429045637`, 
            329.8291794964444}, {324., 329.9243300808053}, {
            323.52164570954363`, 329.8291794964444}, {323.11611652351684`, 
            329.55821355728847`}, {322.8451505843609, 329.15268437126167`}, {
            322.75, 328.6743300808053}, {322.8451505843609, 
            328.19597579034894`}, {323.11611652351684`, 
            327.79044660432214`}, {323.52164570954363`, 327.5194806651662}, {
            324., 327.4243300808053}, {324.47835429045637`, 
            327.5194806651662}, {324.88388347648316`, 327.79044660432214`}, {
            325.1548494156391, 328.19597579034894`}, {325.25, 
            328.6743300808053}}]}}}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 58.92977945366162}, {32.4, 120.41519647421599`}, {64.8,
           165.33587631699888`}, {97.19999999999999, 202.49671948478218`}, {
          129.6, 234.83332853608405`}, {162., 263.78001478775957`}, {
          194.39999999999998`, 290.1699438423391}, {226.79999999999998`, 
          314.5392400461993}, {259.2, 337.2574470952384}, {
          291.59999999999997`, 358.55315412595314`}, {324., 
          377.17775657840605`}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{1.1548494156391085`, 59.408133744117976`}, {
            0.8838834764831843, 59.8136629301448}, {0.47835429045636224`, 
            60.08462886930072}, {0., 
            60.17977945366162}, {-0.47835429045636224`, 
            60.08462886930072}, {-0.8838834764831843, 
            59.8136629301448}, {-1.1548494156391085`, 
            59.408133744117976`}, {-1.25, 
            58.92977945366162}, {-1.1548494156391085`, 
            58.45142516320526}, {-0.8838834764831843, 
            58.04589597717843}, {-0.47835429045636224`, 57.77493003802251}, {
            0., 57.67977945366162}, {0.47835429045636224`, 
            57.77493003802251}, {0.8838834764831843, 58.04589597717843}, {
            1.1548494156391085`, 58.45142516320526}, {1.25, 
            58.92977945366162}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{33.554849415639104`, 120.89355076467236`}, {
            33.28388347648318, 121.29907995069917`}, {32.87835429045636, 
            121.5700458898551}, {32.4, 121.66519647421599`}, {
            31.921645709543636`, 121.5700458898551}, {31.516116523516814`, 
            121.29907995069917`}, {31.24515058436089, 120.89355076467236`}, {
            31.15, 120.41519647421599`}, {31.24515058436089, 
            119.93684218375962`}, {31.516116523516814`, 
            119.53131299773281`}, {31.921645709543636`, 
            119.26034705857688`}, {32.4, 119.16519647421599`}, {
            32.87835429045636, 119.26034705857688`}, {33.28388347648318, 
            119.53131299773281`}, {33.554849415639104`, 
            119.93684218375962`}, {33.65, 120.41519647421599`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{65.9548494156391, 165.81423060745524`}, {
            65.68388347648317, 166.21975979348207`}, {65.27835429045636, 
            166.490725732638}, {64.8, 166.58587631699888`}, {
            64.32164570954363, 166.490725732638}, {63.91611652351681, 
            166.21975979348207`}, {63.64515058436089, 165.81423060745524`}, {
            63.55, 165.33587631699888`}, {63.64515058436089, 
            164.8575220265425}, {63.91611652351681, 164.4519928405157}, {
            64.32164570954363, 164.18102690135976`}, {64.8, 
            164.08587631699888`}, {65.27835429045636, 164.18102690135976`}, {
            65.68388347648317, 164.4519928405157}, {65.9548494156391, 
            164.8575220265425}, {66.05, 165.33587631699888`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{98.3548494156391, 202.97507377523854`}, {
            98.08388347648317, 203.38060296126537`}, {97.67835429045635, 
            203.6515689004213}, {97.19999999999999, 203.74671948478218`}, {
            96.72164570954362, 203.6515689004213}, {96.31611652351681, 
            203.38060296126537`}, {96.04515058436088, 202.97507377523854`}, {
            95.94999999999999, 202.49671948478218`}, {96.04515058436088, 
            202.0183651943258}, {96.31611652351681, 201.61283600829898`}, {
            96.72164570954362, 201.34187006914306`}, {97.19999999999999, 
            201.24671948478218`}, {97.67835429045635, 201.34187006914306`}, {
            98.08388347648317, 201.61283600829898`}, {98.3548494156391, 
            202.0183651943258}, {98.44999999999999, 202.49671948478218`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{130.75484941563911`, 235.31168282654042`}, {
            130.4838834764832, 235.71721201256724`}, {130.07835429045636`, 
            235.98817795172317`}, {129.6, 236.08332853608405`}, {
            129.12164570954363`, 235.98817795172317`}, {128.7161165235168, 
            235.71721201256724`}, {128.44515058436087`, 
            235.31168282654042`}, {128.35, 234.83332853608405`}, {
            128.44515058436087`, 234.3549742456277}, {128.7161165235168, 
            233.94944505960086`}, {129.12164570954363`, 
            233.67847912044493`}, {129.6, 233.58332853608405`}, {
            130.07835429045636`, 233.67847912044493`}, {130.4838834764832, 
            233.94944505960086`}, {130.75484941563911`, 234.3549742456277}, {
            130.85, 234.83332853608405`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{163.15484941563912`, 264.25836907821594`}, {
            162.8838834764832, 264.66389826424273`}, {162.47835429045637`, 
            264.93486420339866`}, {162., 265.03001478775957`}, {
            161.52164570954363`, 264.93486420339866`}, {161.1161165235168, 
            264.66389826424273`}, {160.84515058436088`, 
            264.25836907821594`}, {160.75, 263.78001478775957`}, {
            160.84515058436088`, 263.3016604973032}, {161.1161165235168, 
            262.8961313112764}, {161.52164570954363`, 262.6251653721205}, {
            162., 262.53001478775957`}, {162.47835429045637`, 
            262.6251653721205}, {162.8838834764832, 262.8961313112764}, {
            163.15484941563912`, 263.3016604973032}, {163.25, 
            263.78001478775957`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{195.5548494156391, 290.64829813279545`}, {
            195.28388347648317`, 291.05382731882224`}, {194.87835429045634`, 
            291.3247932579782}, {194.39999999999998`, 291.4199438423391}, {
            193.9216457095436, 291.3247932579782}, {193.51611652351679`, 
            291.05382731882224`}, {193.24515058436086`, 
            290.64829813279545`}, {193.14999999999998`, 290.1699438423391}, {
            193.24515058436086`, 289.6915895518827}, {193.51611652351679`, 
            289.2860603658559}, {193.9216457095436, 289.0150944267}, {
            194.39999999999998`, 288.9199438423391}, {194.87835429045634`, 
            289.0150944267}, {195.28388347648317`, 289.2860603658559}, {
            195.5548494156391, 289.6915895518827}, {195.64999999999998`, 
            290.1699438423391}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{227.9548494156391, 315.0175943366557}, {
            227.68388347648317`, 315.4231235226825}, {227.27835429045635`, 
            315.6940894618384}, {226.79999999999998`, 315.7892400461993}, {
            226.32164570954362`, 315.6940894618384}, {225.9161165235168, 
            315.4231235226825}, {225.64515058436086`, 315.0175943366557}, {
            225.54999999999998`, 314.5392400461993}, {225.64515058436086`, 
            314.06088575574296`}, {225.9161165235168, 313.65535656971616`}, {
            226.32164570954362`, 313.38439063056023`}, {226.79999999999998`, 
            313.2892400461993}, {227.27835429045635`, 313.38439063056023`}, {
            227.68388347648317`, 313.65535656971616`}, {227.9548494156391, 
            314.06088575574296`}, {228.04999999999998`, 
            314.5392400461993}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{260.3548494156391, 337.73580138569474`}, {
            260.08388347648315`, 338.14133057172154`}, {259.67835429045635`, 
            338.41229651087747`}, {259.2, 338.5074470952384}, {
            258.7216457095436, 338.41229651087747`}, {258.3161165235168, 
            338.14133057172154`}, {258.0451505843609, 337.73580138569474`}, {
            257.95, 337.2574470952384}, {258.0451505843609, 
            336.779092804782}, {258.3161165235168, 336.3735636187552}, {
            258.7216457095436, 336.1025976795993}, {259.2, 
            336.0074470952384}, {259.67835429045635`, 336.1025976795993}, {
            260.08388347648315`, 336.3735636187552}, {260.3548494156391, 
            336.779092804782}, {260.45, 337.2574470952384}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{292.75484941563906`, 359.0315084164095}, {
            292.48388347648313`, 359.4370376024363}, {292.07835429045633`, 
            359.70800354159223`}, {291.59999999999997`, 
            359.80315412595314`}, {291.1216457095436, 359.70800354159223`}, {
            290.7161165235168, 359.4370376024363}, {290.4451505843609, 
            359.0315084164095}, {290.34999999999997`, 358.55315412595314`}, {
            290.4451505843609, 358.0747998354968}, {290.7161165235168, 
            357.66927064947}, {291.1216457095436, 357.39830471031405`}, {
            291.59999999999997`, 357.30315412595314`}, {292.07835429045633`, 
            357.39830471031405`}, {292.48388347648313`, 357.66927064947}, {
            292.75484941563906`, 358.0747998354968}, {292.84999999999997`, 
            358.55315412595314`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{325.1548494156391, 377.6561108688624}, {
            324.88388347648316`, 378.0616400548892}, {324.47835429045637`, 
            378.33260599404514`}, {324., 378.42775657840605`}, {
            323.52164570954363`, 378.33260599404514`}, {323.11611652351684`, 
            378.0616400548892}, {322.8451505843609, 377.6561108688624}, {
            322.75, 377.17775657840605`}, {322.8451505843609, 
            376.6994022879497}, {323.11611652351684`, 376.2938731019229}, {
            323.52164570954363`, 376.02290716276696`}, {324., 
            375.92775657840605`}, {324.47835429045637`, 
            376.02290716276696`}, {324.88388347648316`, 376.2938731019229}, {
            325.1548494156391, 376.6994022879497}, {325.25, 
            377.17775657840605`}}]}}}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 93.55270202903597}, {32.4, 152.33123859246456`}, {64.8,
           196.71535829506007`}, {97.19999999999999, 234.23119853246192`}, {
          129.6, 267.33118927217413`}, {162., 297.24755946983174`}, {
          194.39999999999998`, 324.7169103462814}, {226.79999999999998`, 
          350.22425178559365`}, {259.2, 372.99633869770196`}, {
          291.59999999999997`, 390.51967384226657`}, {324., 
          404.03089249161235`}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{1.1548494156391085`, 94.03105631949234}, {
            0.8838834764831843, 94.43658550551915}, {0.47835429045636224`, 
            94.70755144467508}, {0., 
            94.80270202903597}, {-0.47835429045636224`, 
            94.70755144467508}, {-0.8838834764831843, 
            94.43658550551915}, {-1.1548494156391085`, 
            94.03105631949234}, {-1.25, 
            93.55270202903597}, {-1.1548494156391085`, 
            93.0743477385796}, {-0.8838834764831843, 
            92.66881855255279}, {-0.47835429045636224`, 92.39785261339686}, {
            0., 92.30270202903597}, {0.47835429045636224`, 
            92.39785261339686}, {0.8838834764831843, 92.66881855255279}, {
            1.1548494156391085`, 93.0743477385796}, {1.25, 
            93.55270202903597}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{33.554849415639104`, 152.80959288292092`}, {
            33.28388347648318, 153.21512206894775`}, {32.87835429045636, 
            153.48608800810368`}, {32.4, 153.58123859246456`}, {
            31.921645709543636`, 153.48608800810368`}, {31.516116523516814`, 
            153.21512206894775`}, {31.24515058436089, 152.80959288292092`}, {
            31.15, 152.33123859246456`}, {31.24515058436089, 
            151.8528843020082}, {31.516116523516814`, 151.44735511598137`}, {
            31.921645709543636`, 151.17638917682544`}, {32.4, 
            151.08123859246456`}, {32.87835429045636, 151.17638917682544`}, {
            33.28388347648318, 151.44735511598137`}, {33.554849415639104`, 
            151.8528843020082}, {33.65, 152.33123859246456`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{65.9548494156391, 197.19371258551644`}, {
            65.68388347648317, 197.59924177154326`}, {65.27835429045636, 
            197.8702077106992}, {64.8, 197.96535829506007`}, {
            64.32164570954363, 197.8702077106992}, {63.91611652351681, 
            197.59924177154326`}, {63.64515058436089, 197.19371258551644`}, {
            63.55, 196.71535829506007`}, {63.64515058436089, 
            196.2370040046037}, {63.91611652351681, 195.83147481857688`}, {
            64.32164570954363, 195.56050887942095`}, {64.8, 
            195.46535829506007`}, {65.27835429045636, 195.56050887942095`}, {
            65.68388347648317, 195.83147481857688`}, {65.9548494156391, 
            196.2370040046037}, {66.05, 196.71535829506007`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{98.3548494156391, 234.70955282291828`}, {
            98.08388347648317, 235.1150820089451}, {97.67835429045635, 
            235.38604794810104`}, {97.19999999999999, 235.48119853246192`}, {
            96.72164570954362, 235.38604794810104`}, {96.31611652351681, 
            235.1150820089451}, {96.04515058436088, 234.70955282291828`}, {
            95.94999999999999, 234.23119853246192`}, {96.04515058436088, 
            233.75284424200555`}, {96.31611652351681, 233.34731505597873`}, {
            96.72164570954362, 233.0763491168228}, {97.19999999999999, 
            232.98119853246192`}, {97.67835429045635, 233.0763491168228}, {
            98.08388347648317, 233.34731505597873`}, {98.3548494156391, 
            233.75284424200555`}, {98.44999999999999, 
            234.23119853246192`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{130.75484941563911`, 267.8095435626305}, {
            130.4838834764832, 268.2150727486573}, {130.07835429045636`, 
            268.4860386878132}, {129.6, 268.58118927217413`}, {
            129.12164570954363`, 268.4860386878132}, {128.7161165235168, 
            268.2150727486573}, {128.44515058436087`, 267.8095435626305}, {
            128.35, 267.33118927217413`}, {128.44515058436087`, 
            266.85283498171776`}, {128.7161165235168, 266.44730579569097`}, {
            129.12164570954363`, 266.17633985653504`}, {129.6, 
            266.08118927217413`}, {130.07835429045636`, 
            266.17633985653504`}, {130.4838834764832, 266.44730579569097`}, {
            130.75484941563911`, 266.85283498171776`}, {130.85, 
            267.33118927217413`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{163.15484941563912`, 297.7259137602881}, {
            162.8838834764832, 298.1314429463149}, {162.47835429045637`, 
            298.40240888547083`}, {162., 298.49755946983174`}, {
            161.52164570954363`, 298.40240888547083`}, {161.1161165235168, 
            298.1314429463149}, {160.84515058436088`, 297.7259137602881}, {
            160.75, 297.24755946983174`}, {160.84515058436088`, 
            296.7692051793754}, {161.1161165235168, 296.3636759933486}, {
            161.52164570954363`, 296.09271005419265`}, {162., 
            295.99755946983174`}, {162.47835429045637`, 
            296.09271005419265`}, {162.8838834764832, 296.3636759933486}, {
            163.15484941563912`, 296.7692051793754}, {163.25, 
            297.24755946983174`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{195.5548494156391, 325.19526463673776`}, {
            195.28388347648317`, 325.60079382276456`}, {194.87835429045634`, 
            325.8717597619205}, {194.39999999999998`, 325.9669103462814}, {
            193.9216457095436, 325.8717597619205}, {193.51611652351679`, 
            325.60079382276456`}, {193.24515058436086`, 
            325.19526463673776`}, {193.14999999999998`, 324.7169103462814}, {
            193.24515058436086`, 324.23855605582503`}, {193.51611652351679`, 
            323.83302686979823`}, {193.9216457095436, 323.5620609306423}, {
            194.39999999999998`, 323.4669103462814}, {194.87835429045634`, 
            323.5620609306423}, {195.28388347648317`, 323.83302686979823`}, {
            195.5548494156391, 324.23855605582503`}, {195.64999999999998`, 
            324.7169103462814}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{227.9548494156391, 350.70260607605}, {
            227.68388347648317`, 351.1081352620768}, {227.27835429045635`, 
            351.37910120123274`}, {226.79999999999998`, 
            351.47425178559365`}, {226.32164570954362`, 
            351.37910120123274`}, {225.9161165235168, 351.1081352620768}, {
            225.64515058436086`, 350.70260607605}, {225.54999999999998`, 
            350.22425178559365`}, {225.64515058436086`, 349.7458974951373}, {
            225.9161165235168, 349.3403683091105}, {226.32164570954362`, 
            349.06940236995456`}, {226.79999999999998`, 
            348.97425178559365`}, {227.27835429045635`, 
            349.06940236995456`}, {227.68388347648317`, 349.3403683091105}, {
            227.9548494156391, 349.7458974951373}, {228.04999999999998`, 
            350.22425178559365`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{260.3548494156391, 373.4746929881583}, {
            260.08388347648315`, 373.8802221741851}, {259.67835429045635`, 
            374.15118811334105`}, {259.2, 374.24633869770196`}, {
            258.7216457095436, 374.15118811334105`}, {258.3161165235168, 
            373.8802221741851}, {258.0451505843609, 373.4746929881583}, {
            257.95, 372.99633869770196`}, {258.0451505843609, 
            372.5179844072456}, {258.3161165235168, 372.1124552212188}, {
            258.7216457095436, 371.84148928206287`}, {259.2, 
            371.74633869770196`}, {259.67835429045635`, 
            371.84148928206287`}, {260.08388347648315`, 372.1124552212188}, {
            260.3548494156391, 372.5179844072456}, {260.45, 
            372.99633869770196`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{292.75484941563906`, 390.99802813272294`}, {
            292.48388347648313`, 391.40355731874973`}, {292.07835429045633`, 
            391.67452325790566`}, {291.59999999999997`, 
            391.76967384226657`}, {291.1216457095436, 391.67452325790566`}, {
            290.7161165235168, 391.40355731874973`}, {290.4451505843609, 
            390.99802813272294`}, {290.34999999999997`, 
            390.51967384226657`}, {290.4451505843609, 390.0413195518102}, {
            290.7161165235168, 389.6357903657834}, {291.1216457095436, 
            389.3648244266275}, {291.59999999999997`, 389.26967384226657`}, {
            292.07835429045633`, 389.3648244266275}, {292.48388347648313`, 
            389.6357903657834}, {292.75484941563906`, 390.0413195518102}, {
            292.84999999999997`, 390.51967384226657`}}]}}, {
          {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}], LineBox[{}]}, 
          {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
           None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{325.1548494156391, 404.5092467820687}, {
            324.88388347648316`, 404.9147759680955}, {324.47835429045637`, 
            405.18574190725144`}, {324., 405.28089249161235`}, {
            323.52164570954363`, 405.18574190725144`}, {323.11611652351684`, 
            404.9147759680955}, {322.8451505843609, 404.5092467820687}, {
            322.75, 404.03089249161235`}, {322.8451505843609, 
            403.552538201156}, {323.11611652351684`, 403.1470090151292}, {
            323.52164570954363`, 402.87604307597326`}, {324., 
            402.78089249161235`}, {324.47835429045637`, 
            402.87604307597326`}, {324.88388347648316`, 403.1470090151292}, {
            325.1548494156391, 403.552538201156}, {325.25, 
            404.03089249161235`}}]}}}, 
        {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
         AbsoluteDashing[4], CapForm[None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 20.03909269822582}, {32.4, 64.83595559776198}, {64.8, 
          99.49639990768446}, {97.19999999999999, 128.1078393532159}, {129.6, 
          152.85443281205502`}, {162., 174.8752560926469}, {
          194.39999999999998`, 194.83697472565296`}, {226.79999999999998`, 
          213.16873402333817`}, {259.2, 230.16653787821977`}, {
          291.59999999999997`, 246.04526668292604`}, {324., 
          260.9670854890342}}]}, 
        {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[
         1], Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}]}], 
         FaceForm[GrayLevel[1]], {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{1.1548494156391085`, 20.51744698868218}, {
            0.8838834764831843, 20.922976174709003`}, {0.47835429045636224`, 
            21.193942113864928`}, {0., 
            21.28909269822582}, {-0.47835429045636224`, 
            21.193942113864928`}, {-0.8838834764831843, 
            20.922976174709003`}, {-1.1548494156391085`, 
            20.51744698868218}, {-1.25, 
            20.03909269822582}, {-1.1548494156391085`, 
            19.560738407769456`}, {-0.8838834764831843, 
            19.155209221742634`}, {-0.47835429045636224`, 
            18.88424328258671}, {0., 18.78909269822582}, {
            0.47835429045636224`, 18.88424328258671}, {0.8838834764831843, 
            19.155209221742634`}, {1.1548494156391085`, 
            19.560738407769456`}, {1.25, 20.03909269822582}}]}}, {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{33.554849415639104`, 65.31430988821835}, {
            33.28388347648318, 65.71983907424516}, {32.87835429045636, 
            65.99080501340109}, {32.4, 66.08595559776198}, {
            31.921645709543636`, 65.99080501340109}, {31.516116523516814`, 
            65.71983907424516}, {31.24515058436089, 65.31430988821835}, {
            31.15, 64.83595559776198}, {31.24515058436089, 
            64.35760130730561}, {31.516116523516814`, 63.952072121278796`}, {
            31.921645709543636`, 63.681106182122875`}, {32.4, 
            63.58595559776198}, {32.87835429045636, 63.681106182122875`}, {
            33.28388347648318, 63.952072121278796`}, {33.554849415639104`, 
            64.35760130730561}, {33.65, 64.83595559776198}}]}}, {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{65.9548494156391, 99.97475419814083}, {
            65.68388347648317, 100.38028338416764`}, {65.27835429045636, 
            100.65124932332357`}, {64.8, 100.74639990768446`}, {
            64.32164570954363, 100.65124932332357`}, {63.91611652351681, 
            100.38028338416764`}, {63.64515058436089, 99.97475419814083}, {
            63.55, 99.49639990768446}, {63.64515058436089, 
            99.0180456172281}, {63.91611652351681, 98.61251643120129}, {
            64.32164570954363, 98.34155049204536}, {64.8, 
            98.24639990768446}, {65.27835429045636, 98.34155049204536}, {
            65.68388347648317, 98.61251643120129}, {65.9548494156391, 
            99.0180456172281}, {66.05, 99.49639990768446}}]}}, {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{98.3548494156391, 128.58619364367226`}, {
            98.08388347648317, 128.99172282969909`}, {97.67835429045635, 
            129.262688768855}, {97.19999999999999, 129.3578393532159}, {
            96.72164570954362, 129.262688768855}, {96.31611652351681, 
            128.99172282969909`}, {96.04515058436088, 128.58619364367226`}, {
            95.94999999999999, 128.1078393532159}, {96.04515058436088, 
            127.62948506275953`}, {96.31611652351681, 127.22395587673272`}, {
            96.72164570954362, 126.95298993757679`}, {97.19999999999999, 
            126.8578393532159}, {97.67835429045635, 126.95298993757679`}, {
            98.08388347648317, 127.22395587673272`}, {98.3548494156391, 
            127.62948506275953`}, {98.44999999999999, 128.1078393532159}}]}}, {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{130.75484941563911`, 153.3327871025114}, {
            130.4838834764832, 153.73831628853821`}, {130.07835429045636`, 
            154.00928222769414`}, {129.6, 154.10443281205502`}, {
            129.12164570954363`, 154.00928222769414`}, {128.7161165235168, 
            153.73831628853821`}, {128.44515058436087`, 153.3327871025114}, {
            128.35, 152.85443281205502`}, {128.44515058436087`, 
            152.37607852159866`}, {128.7161165235168, 151.97054933557183`}, {
            129.12164570954363`, 151.6995833964159}, {129.6, 
            151.60443281205502`}, {130.07835429045636`, 151.6995833964159}, {
            130.4838834764832, 151.97054933557183`}, {130.75484941563911`, 
            152.37607852159866`}, {130.85, 152.85443281205502`}}]}}, {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{163.15484941563912`, 175.35361038310327`}, {
            162.8838834764832, 175.7591395691301}, {162.47835429045637`, 
            176.03010550828603`}, {162., 176.1252560926469}, {
            161.52164570954363`, 176.03010550828603`}, {161.1161165235168, 
            175.7591395691301}, {160.84515058436088`, 175.35361038310327`}, {
            160.75, 174.8752560926469}, {160.84515058436088`, 
            174.39690180219054`}, {161.1161165235168, 173.99137261616372`}, {
            161.52164570954363`, 173.7204066770078}, {162., 
            173.6252560926469}, {162.47835429045637`, 173.7204066770078}, {
            162.8838834764832, 173.99137261616372`}, {163.15484941563912`, 
            174.39690180219054`}, {163.25, 174.8752560926469}}]}}, {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{195.5548494156391, 195.31532901610933`}, {
            195.28388347648317`, 195.72085820213616`}, {194.87835429045634`, 
            195.99182414129208`}, {194.39999999999998`, 
            196.08697472565296`}, {193.9216457095436, 195.99182414129208`}, {
            193.51611652351679`, 195.72085820213616`}, {193.24515058436086`, 
            195.31532901610933`}, {193.14999999999998`, 
            194.83697472565296`}, {193.24515058436086`, 194.3586204351966}, {
            193.51611652351679`, 193.95309124916977`}, {193.9216457095436, 
            193.68212531001384`}, {194.39999999999998`, 
            193.58697472565296`}, {194.87835429045634`, 
            193.68212531001384`}, {195.28388347648317`, 
            193.95309124916977`}, {195.5548494156391, 194.3586204351966}, {
            195.64999999999998`, 194.83697472565296`}}]}}, {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{227.9548494156391, 213.64708831379454`}, {
            227.68388347648317`, 214.05261749982137`}, {227.27835429045635`, 
            214.3235834389773}, {226.79999999999998`, 214.41873402333817`}, {
            226.32164570954362`, 214.3235834389773}, {225.9161165235168, 
            214.05261749982137`}, {225.64515058436086`, 
            213.64708831379454`}, {225.54999999999998`, 
            213.16873402333817`}, {225.64515058436086`, 212.6903797328818}, {
            225.9161165235168, 212.28485054685498`}, {226.32164570954362`, 
            212.01388460769905`}, {226.79999999999998`, 
            211.91873402333817`}, {227.27835429045635`, 
            212.01388460769905`}, {227.68388347648317`, 
            212.28485054685498`}, {227.9548494156391, 212.6903797328818}, {
            228.04999999999998`, 213.16873402333817`}}]}}, {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{260.3548494156391, 230.64489216867614`}, {
            260.08388347648315`, 231.05042135470296`}, {259.67835429045635`, 
            231.3213872938589}, {259.2, 231.41653787821977`}, {
            258.7216457095436, 231.3213872938589}, {258.3161165235168, 
            231.05042135470296`}, {258.0451505843609, 230.64489216867614`}, {
            257.95, 230.16653787821977`}, {258.0451505843609, 
            229.6881835877634}, {258.3161165235168, 229.28265440173658`}, {
            258.7216457095436, 229.01168846258065`}, {259.2, 
            228.91653787821977`}, {259.67835429045635`, 
            229.01168846258065`}, {260.08388347648315`, 
            229.28265440173658`}, {260.3548494156391, 229.6881835877634}, {
            260.45, 230.16653787821977`}}]}}, {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{292.75484941563906`, 246.5236209733824}, {
            292.48388347648313`, 246.92915015940923`}, {292.07835429045633`, 
            247.20011609856516`}, {291.59999999999997`, 
            247.29526668292604`}, {291.1216457095436, 247.20011609856516`}, {
            290.7161165235168, 246.92915015940923`}, {290.4451505843609, 
            246.5236209733824}, {290.34999999999997`, 246.04526668292604`}, {
            290.4451505843609, 245.56691239246967`}, {290.7161165235168, 
            245.16138320644285`}, {291.1216457095436, 244.89041726728692`}, {
            291.59999999999997`, 244.79526668292604`}, {292.07835429045633`, 
            244.89041726728692`}, {292.48388347648313`, 
            245.16138320644285`}, {292.75484941563906`, 
            245.56691239246967`}, {292.84999999999997`, 
            246.04526668292604`}}]}}, {
          {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
           Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
           LineBox[{}]}, 
          {EdgeForm[{RGBColor[0.698004, 0.133305, 0.133305], 
           AbsoluteThickness[1], Dashing[{}], CapForm[None], 
           JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
           PolygonBox[{{325.1548494156391, 261.4454397794906}, {
            324.88388347648316`, 261.8509689655174}, {324.47835429045637`, 
            262.1219349046733}, {324., 262.2170854890342}, {
            323.52164570954363`, 262.1219349046733}, {323.11611652351684`, 
            261.8509689655174}, {322.8451505843609, 261.4454397794906}, {
            322.75, 260.9670854890342}, {322.8451505843609, 
            260.48873119857785`}, {323.11611652351684`, 
            260.08320201255106`}, {323.52164570954363`, 259.8122360733951}, {
            324., 259.7170854890342}, {324.47835429045637`, 
            259.8122360733951}, {324.88388347648316`, 260.08320201255106`}, {
            325.1548494156391, 260.48873119857785`}, {325.25, 
            260.9670854890342}}]}}}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             
             TemplateBox[{
              TemplateBox[{"\"\"", "8"}, "Superscript"],
               TemplateBox[{"\"Be\"", "\"\""}, "Superscript"]},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {112.75098696523717`, 143.56842033477523`}, {0, -1},
          Automatic, {0.8336077692668638, 0.5523568475342036}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             
             TemplateBox[{
              TemplateBox[{"\"\"", "12"}, "Superscript"],
               TemplateBox[{"\"C\"", "\"\""}, "Superscript"]},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {75.90489168936631, 137.56502934910156`}, {0, -1},
          Automatic, {0.7253074488612329, 0.6884250900616639}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             
             TemplateBox[{
              TemplateBox[{"\"\"", "16"}, "Superscript"],
               TemplateBox[{"\"O\"", "\"\""}, "Superscript"]},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {143.55937364408626`, 201.42367998620102`}, {0, -1},
          Automatic, {0.7462438086043536, 0.6656727259845253}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             
             TemplateBox[{
              TemplateBox[{"\"\"", "20"}, "Superscript"],
               TemplateBox[{"\"Ne\"", "\"\""}, "Superscript"]},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {70.67247760566264, 172.0712534562072}, {0, -1},
          Automatic, {0.6571740077291941, 0.7537388961471666}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             
             TemplateBox[{
              TemplateBox[{"\"\"", "24"}, "Superscript"],
               TemplateBox[{"\"Mg\"", "\"\""}, "Superscript"]},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {65.71846183283802, 197.7788418563225}, {0, -1},
          Automatic, {0.6536193637602855, 0.7568234452747877}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{TemplateBox[{
                 TemplateBox[{"\"\"", "12"}, "Superscript"], 
                 TemplateBox[{"\"C\"", "\"\""}, "Superscript"]}, 
                "RowDefault"],"","\" \"",TagBox[
                StyleBox["\"J\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\"=0\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {232.0776891523741, 215.9375341782484}, {0, -1},
          Automatic, {0.8855350533780387, 0.46457256617104953`}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            
            TemplateBox[{
             TemplateBox[{"\"\"", "8"}, "Superscript"],
              TemplateBox[{"\"Be\"", "\"\""}, "Superscript"]},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {112.75098696523717`, 143.56842033477523`}, {0, -1},
          Automatic, {0.8336077692668638, 0.5523568475342036}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            
            TemplateBox[{
             TemplateBox[{"\"\"", "12"}, "Superscript"],
              TemplateBox[{"\"C\"", "\"\""}, "Superscript"]},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {75.90489168936631, 137.56502934910156`}, {0, -1},
          Automatic, {0.7253074488612329, 0.6884250900616639}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            
            TemplateBox[{
             TemplateBox[{"\"\"", "16"}, "Superscript"],
              TemplateBox[{"\"O\"", "\"\""}, "Superscript"]},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {143.55937364408626`, 201.42367998620102`}, {0, -1},
          Automatic, {0.7462438086043536, 0.6656727259845253}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            
            TemplateBox[{
             TemplateBox[{"\"\"", "20"}, "Superscript"],
              TemplateBox[{"\"Ne\"", "\"\""}, "Superscript"]},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {70.67247760566264, 172.0712534562072}, {0, -1},
          Automatic, {0.6571740077291941, 0.7537388961471666}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            
            TemplateBox[{
             TemplateBox[{"\"\"", "24"}, "Superscript"],
              TemplateBox[{"\"Mg\"", "\"\""}, "Superscript"]},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {65.71846183283802, 197.7788418563225}, {0, -1},
          Automatic, {0.6536193637602855, 0.7568234452747877}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{TemplateBox[{
                TemplateBox[{"\"\"", "12"}, "Superscript"], 
                TemplateBox[{"\"C\"", "\"\""}, "Superscript"]}, "RowDefault"],
              "","\" \"",TagBox[
               StyleBox["\"J\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\"=0\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {232.0776891523741, 215.9375341782484}, {0, -1},
          Automatic, {0.8855350533780387, 0.46457256617104953`}]},
       Frame->False,
       ImageSize->{324., 252.},
       PlotRange->{{0., 324.}, {0., 252.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72., -72.}, {396., 324.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{468., 396.},
       PlotRange->{{-72., 396.}, {-72., 324.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72., -72.}, {396., 324.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {0., 252.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{2.88, 0.}, {0., 0.}}], 
         LineBox[{{1.44, 6.321629908943604}, {0., 6.321629908943604}}], 
         LineBox[{{1.44, 10.01954634911291}, {0., 10.01954634911291}}], 
         LineBox[{{1.44, 12.643259817887207`}, {0., 12.643259817887207`}}], 
         LineBox[{{1.44, 14.678370091056392`}, {0., 14.678370091056392`}}], 
         LineBox[{{1.44, 16.341176258056514`}, {0., 16.341176258056514`}}], 
         LineBox[{{1.44, 17.747058840299392`}, {0., 17.747058840299392`}}], 
         LineBox[{{1.44, 18.96488972683081}, {0., 18.96488972683081}}], 
         LineBox[{{1.44, 20.03909269822582}, {0., 20.03909269822582}}], 
         LineBox[{{2.88, 21.}, {0., 21.}}], 
         LineBox[{{1.44, 27.321629908943606`}, {0., 27.321629908943606`}}], 
         LineBox[{{1.44, 31.01954634911291}, {0., 31.01954634911291}}], 
         LineBox[{{1.44, 33.643259817887206`}, {0., 33.643259817887206`}}], 
         LineBox[{{1.44, 35.678370091056394`}, {0., 35.678370091056394`}}], 
         LineBox[{{1.44, 37.341176258056514`}, {0., 37.341176258056514`}}], 
         LineBox[{{1.44, 38.74705884029939}, {0., 38.74705884029939}}], 
         LineBox[{{1.44, 39.96488972683081}, {0., 39.96488972683081}}], 
         LineBox[{{1.44, 41.03909269822582}, {0., 41.03909269822582}}], 
         LineBox[{{2.88, 42.}, {0., 42.}}], 
         LineBox[{{1.44, 48.321629908943606`}, {0., 48.321629908943606`}}], 
         LineBox[{{1.44, 52.019546349112915`}, {0., 52.019546349112915`}}], 
         LineBox[{{1.44, 54.64325981788721}, {0., 54.64325981788721}}], 
         LineBox[{{1.44, 56.678370091056394`}, {0., 56.678370091056394`}}], 
         LineBox[{{1.44, 58.341176258056514`}, {0., 58.341176258056514`}}], 
         LineBox[{{1.44, 59.747058840299395`}, {0., 59.747058840299395`}}], 
         LineBox[{{1.44, 60.96488972683081}, {0., 60.96488972683081}}], 
         LineBox[{{1.44, 62.03909269822582}, {0., 62.03909269822582}}], 
         LineBox[{{2.88, 63.}, {0., 63.}}], 
         LineBox[{{1.44, 69.3216299089436}, {0., 69.3216299089436}}], 
         LineBox[{{1.44, 73.01954634911291}, {0., 73.01954634911291}}], 
         LineBox[{{1.44, 75.64325981788721}, {0., 75.64325981788721}}], 
         LineBox[{{1.44, 77.6783700910564}, {0., 77.6783700910564}}], 
         LineBox[{{1.44, 79.3411762580565}, {0., 79.3411762580565}}], 
         LineBox[{{1.44, 80.74705884029939}, {0., 80.74705884029939}}], 
         LineBox[{{1.44, 81.9648897268308}, {0., 81.9648897268308}}], 
         LineBox[{{1.44, 83.03909269822582}, {0., 83.03909269822582}}], 
         LineBox[{{2.88, 84.}, {0., 84.}}], 
         LineBox[{{1.44, 90.3216299089436}, {0., 90.3216299089436}}], 
         LineBox[{{1.44, 94.01954634911291}, {0., 94.01954634911291}}], 
         LineBox[{{1.44, 96.64325981788721}, {0., 96.64325981788721}}], 
         LineBox[{{1.44, 98.6783700910564}, {0., 98.6783700910564}}], 
         LineBox[{{1.44, 100.34117625805652`}, {0., 100.34117625805652`}}], 
         LineBox[{{1.44, 101.74705884029939`}, {0., 101.74705884029939`}}], 
         LineBox[{{1.44, 102.96488972683082`}, {0., 102.96488972683082`}}], 
         LineBox[{{1.44, 104.03909269822583`}, {0., 104.03909269822583`}}], 
         LineBox[{{2.88, 105.}, {0., 105.}}], 
         LineBox[{{1.44, 111.3216299089436}, {0., 111.3216299089436}}], 
         LineBox[{{1.44, 115.01954634911291`}, {0., 115.01954634911291`}}], 
         LineBox[{{1.44, 117.64325981788721`}, {0., 117.64325981788721`}}], 
         LineBox[{{1.44, 119.6783700910564}, {0., 119.6783700910564}}], 
         LineBox[{{1.44, 121.34117625805652`}, {0., 121.34117625805652`}}], 
         LineBox[{{1.44, 122.74705884029939`}, {0., 122.74705884029939`}}], 
         LineBox[{{1.44, 123.96488972683082`}, {0., 123.96488972683082`}}], 
         LineBox[{{1.44, 125.03909269822583`}, {0., 125.03909269822583`}}], 
         LineBox[{{2.88, 126.}, {0., 126.}}], 
         LineBox[{{1.44, 132.3216299089436}, {0., 132.3216299089436}}], 
         LineBox[{{1.44, 136.01954634911291`}, {0., 136.01954634911291`}}], 
         LineBox[{{1.44, 138.6432598178872}, {0., 138.6432598178872}}], 
         LineBox[{{1.44, 140.6783700910564}, {0., 140.6783700910564}}], 
         LineBox[{{1.44, 142.34117625805652`}, {0., 142.34117625805652`}}], 
         LineBox[{{1.44, 143.7470588402994}, {0., 143.7470588402994}}], 
         LineBox[{{1.44, 144.96488972683082`}, {0., 144.96488972683082`}}], 
         LineBox[{{1.44, 146.03909269822583`}, {0., 146.03909269822583`}}], 
         LineBox[{{2.88, 147.}, {0., 147.}}], 
         LineBox[{{1.44, 153.3216299089436}, {0., 153.3216299089436}}], 
         LineBox[{{1.44, 157.01954634911291`}, {0., 157.01954634911291`}}], 
         LineBox[{{1.44, 159.6432598178872}, {0., 159.6432598178872}}], 
         LineBox[{{1.44, 161.6783700910564}, {0., 161.6783700910564}}], 
         LineBox[{{1.44, 163.34117625805652`}, {0., 163.34117625805652`}}], 
         LineBox[{{1.44, 164.7470588402994}, {0., 164.7470588402994}}], 
         LineBox[{{1.44, 165.96488972683082`}, {0., 165.96488972683082`}}], 
         LineBox[{{1.44, 167.03909269822583`}, {0., 167.03909269822583`}}], 
         LineBox[{{2.88, 168.}, {0., 168.}}], 
         LineBox[{{1.44, 174.3216299089436}, {0., 174.3216299089436}}], 
         LineBox[{{1.44, 178.01954634911291`}, {0., 178.01954634911291`}}], 
         LineBox[{{1.44, 180.6432598178872}, {0., 180.6432598178872}}], 
         LineBox[{{1.44, 182.6783700910564}, {0., 182.6783700910564}}], 
         LineBox[{{1.44, 184.34117625805652`}, {0., 184.34117625805652`}}], 
         LineBox[{{1.44, 185.7470588402994}, {0., 185.7470588402994}}], 
         LineBox[{{1.44, 186.96488972683082`}, {0., 186.96488972683082`}}], 
         LineBox[{{1.44, 188.03909269822583`}, {0., 188.03909269822583`}}], 
         LineBox[{{2.88, 189.}, {0., 189.}}], 
         LineBox[{{1.44, 195.3216299089436}, {0., 195.3216299089436}}], 
         LineBox[{{1.44, 199.01954634911291`}, {0., 199.01954634911291`}}], 
         LineBox[{{1.44, 201.6432598178872}, {0., 201.6432598178872}}], 
         LineBox[{{1.44, 203.6783700910564}, {0., 203.6783700910564}}], 
         LineBox[{{1.44, 205.34117625805652`}, {0., 205.34117625805652`}}], 
         LineBox[{{1.44, 206.7470588402994}, {0., 206.7470588402994}}], 
         LineBox[{{1.44, 207.96488972683082`}, {0., 207.96488972683082`}}], 
         LineBox[{{1.44, 209.03909269822583`}, {0., 209.03909269822583`}}], 
         LineBox[{{2.88, 210.}, {0., 210.}}], 
         LineBox[{{1.44, 216.3216299089436}, {0., 216.3216299089436}}], 
         LineBox[{{1.44, 220.01954634911291`}, {0., 220.01954634911291`}}], 
         LineBox[{{1.44, 222.6432598178872}, {0., 222.6432598178872}}], 
         LineBox[{{1.44, 224.6783700910564}, {0., 224.6783700910564}}], 
         LineBox[{{1.44, 226.34117625805652`}, {0., 226.34117625805652`}}], 
         LineBox[{{1.44, 227.7470588402994}, {0., 227.7470588402994}}], 
         LineBox[{{1.44, 228.96488972683082`}, {0., 228.96488972683082`}}], 
         LineBox[{{1.44, 230.03909269822583`}, {0., 230.03909269822583`}}], 
         LineBox[{{2.88, 231.}, {0., 231.}}], 
         LineBox[{{1.44, 237.3216299089436}, {0., 237.3216299089436}}], 
         LineBox[{{1.44, 241.01954634911291`}, {0., 241.01954634911291`}}], 
         LineBox[{{1.44, 243.6432598178872}, {0., 243.6432598178872}}], 
         LineBox[{{1.44, 245.6783700910564}, {0., 245.6783700910564}}], 
         LineBox[{{1.44, 247.34117625805652`}, {0., 247.34117625805652`}}], 
         LineBox[{{1.44, 248.7470588402994}, {0., 248.7470588402994}}], 
         LineBox[{{1.44, 249.96488972683082`}, {0., 249.96488972683082`}}], 
         LineBox[{{1.44, 251.03909269822583`}, {0., 251.03909269822583`}}], 
         LineBox[{{2.88, 252.}, {0., 252.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{324., 0.}, {324., 252.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {324., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 2.88}, {0., 0.}}], 
         LineBox[{{32.4, 2.88}, {32.4, 0.}}], 
         LineBox[{{64.8, 2.88}, {64.8, 0.}}], 
         LineBox[{{97.19999999999999, 2.88}, {97.19999999999999, 0.}}], 
         LineBox[{{129.6, 2.88}, {129.6, 0.}}], 
         LineBox[{{162., 2.88}, {162., 0.}}], 
         LineBox[{{194.39999999999998`, 2.88}, {194.39999999999998`, 0.}}], 
         LineBox[{{226.79999999999998`, 2.88}, {226.79999999999998`, 0.}}], 
         LineBox[{{259.2, 2.88}, {259.2, 0.}}], 
         LineBox[{{291.59999999999997`, 2.88}, {291.59999999999997`, 0.}}], 
         LineBox[{{324., 2.88}, {324., 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 252.}, {324., 252.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              SuperscriptBox["10", "0"],
              DisplayForm],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10.2,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {1, 0}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              SuperscriptBox["10", "2"],
              DisplayForm],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10.2,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 42.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              SuperscriptBox["10", "4"],
              DisplayForm],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10.2,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 84.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              SuperscriptBox["10", "6"],
              DisplayForm],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10.2,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 126.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              SuperscriptBox["10", "8"],
              DisplayForm],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10.2,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 168.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              SuperscriptBox["10", "10"],
              DisplayForm],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10.2,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 210.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              SuperscriptBox["10", "12"],
              DisplayForm],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10.2,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 252.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Dimension\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-23., 126.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10.2,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {0, 1}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10.2,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {32.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 4\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10.2,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {64.8, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 6\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10.2,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {97.19999999999999, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 8\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10.2,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {129.6, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"10\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10.2,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {162., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"12\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10.2,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {194.39999999999998`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"14\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10.2,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {226.79999999999998`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"16\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10.2,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {259.2, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"18\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10.2,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {291.59999999999997`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"20\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->10.2,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {324., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Excitation quanta\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {162., -15.}, {0, 1}, Automatic, {1., 0.}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             SuperscriptBox["10", "0"],
             DisplayForm],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10.2,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {1, 0}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             SuperscriptBox["10", "2"],
             DisplayForm],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10.2,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 42.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             SuperscriptBox["10", "4"],
             DisplayForm],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10.2,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 84.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             SuperscriptBox["10", "6"],
             DisplayForm],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10.2,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 126.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             SuperscriptBox["10", "8"],
             DisplayForm],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10.2,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 168.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             SuperscriptBox["10", "10"],
             DisplayForm],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10.2,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 210.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             SuperscriptBox["10", "12"],
             DisplayForm],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10.2,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 252.}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Dimension\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-23., 126.}, {0, -1}, Automatic, {
         6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10.2,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 0.}, {0, 1}, Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10.2,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {32.4, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 4\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10.2,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {64.8, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 6\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10.2,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {97.19999999999999, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 8\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10.2,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {129.6, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"10\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10.2,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {162., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"12\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10.2,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {194.39999999999998`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"14\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10.2,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {226.79999999999998`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"16\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10.2,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {259.2, 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"18\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10.2,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {291.59999999999997`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"20\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->10.2,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {324., 0.}, {0, 1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Excitation quanta\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {162., -15.}, {0, 1}, Automatic, {1., 0.}]},
       Frame->False,
       ImageSize->{468., 396.},
       PlotRange->{{-72., 396.}, {-72., 324.}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->0.8461538461538463,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{468., 396.},
  PlotRange->{{-72., 396.}, {-72., 324.}}]], "Output",
 CellChangeTimes->{
  3.5666023596329317`*^9, {3.566602452281495*^9, 3.5666024927323656`*^9}, 
   3.566602568142898*^9, 3.566602651135044*^9, 3.5666026952831216`*^9, {
   3.566602877148241*^9, 3.5666029698436036`*^9}, {3.566603021370494*^9, 
   3.5666030598557615`*^9}, {3.566603096453426*^9, 3.5666031409915047`*^9}, 
   3.566603191816394*^9, 3.5666033216966057`*^9, 3.5666033865166965`*^9, 
   3.566603441466773*^9, {3.566604649058464*^9, 3.566604672818497*^9}, 
   3.5666049645973625`*^9, {3.566605218917719*^9, 3.5666052781978016`*^9}, {
   3.5666054259480085`*^9, 3.56660545572305*^9}, {3.5666055505181828`*^9, 
   3.566605577558221*^9}, 3.566665222360362*^9, 3.566665286951354*^9, 
   3.566665342394706*^9, 3.5791219146955824`*^9, 3.583784447458704*^9, 
   3.5943059274153595`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Gamma-ray spectrum", "Section",
 CellChangeTimes->{{3.518469242984375*^9, 3.518469247234375*^9}, {
  3.518471338859375*^9, 3.518471367*^9}, {3.51847485421875*^9, 
  3.518474854984375*^9}, {3.5209457115625*^9, 3.520945713421875*^9}}],

Cell["\<\
This illustrates...
\t- \[OpenCurlyDoubleQuote]step\[CloseCurlyDoubleQuote] curve shape
\t- fill under step curve
\t- scaled linear axis
\t- inset panel
\t- giving a panel a name and using its anchors as the endpoints of lines
\t- using a named style to define plot properties\
\>", "Text",
 CellChangeTimes->{{3.518474856609375*^9, 3.5184749304375*^9}, {
  3.5209457343125*^9, 3.52094578390625*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "define", " ", "style", " ", "for", " ", "spectrum", " ", "plots"}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"DefineStyle", "[", 
     RowBox[{"\"\<spectrumplot\>\"", ",", "\[IndentingNewLine]", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DataPlot", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"YAxisScale", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"Scaled", ",", 
             RowBox[{"10", "^", "3"}]}], "}"}]}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"DataLine", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"CurveShape", "\[Rule]", "\"\<Step\>\""}], ",", 
           RowBox[{"Color", "\[Rule]", "Firebrick"}]}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"DataSymbol", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"Show", "->", "False"}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"DataFill", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Filling", "\[Rule]", "Axis"}], ",", 
           RowBox[{"Color", "\[Rule]", "LightGray"}]}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"DataLegend", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"TextFrame", "\[Rule]", "True"}], ",", 
           RowBox[{"TextMargin", "\[Rule]", "4"}], ",", 
           RowBox[{"TextRoundingRadius", "\[Rule]", "2"}], ",", 
           RowBox[{"TextBackground", "\[Rule]", "LightGray"}]}], "}"}]}]}], 
       "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"import", " ", "data", " ", "set", " ", "for", " ", "plot"}], " ",
     "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Data", "=", 
     RowBox[{
     "Import", "[", "\"\<SciDraw/ExampleData/156dy_jul00_ba_tot.dat\>\"", 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"generate", " ", "figure"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{"Figure", "[", "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SetOptions", "[", 
          RowBox[{"DataPlot", ",", 
           RowBox[{"Style", "\[Rule]", "\"\<spectrumplot\>\""}]}], "]"}], ";",
          "\[IndentingNewLine]", 
         RowBox[{"SetOptions", "[", 
          RowBox[{"DataLegend", ",", 
           RowBox[{"Style", "\[Rule]", "\"\<spectrumplot\>\""}]}], "]"}], ";",
          "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"DataPlot", "[", "Data", "]"}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"inset", " ", "panel"}], " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"DataPlot", "[", "Data", "]"}], ";"}], 
            "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"PanelRegion", "->", 
            RowBox[{"Scaled", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"0.2", ",", "0.7"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"0.55", ",", 
                 RowBox[{"1", "-", "0.05"}]}], "}"}]}], "}"}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"XPlotRange", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"205", ",", "245"}], "}"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"YPlotRange", "->", 
            RowBox[{"{", 
             RowBox[{"0", ",", "1.0*^2"}], "}"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"YFrameLabel", "\[Rule]", 
            RowBox[{"Row", "[", 
             RowBox[{"{", 
              RowBox[{
              "\"\<Counts\>\"", ",", "\"\<  \>\"", ",", "\"\<(\>\"", ",", 
               RowBox[{"Superscript", "[", 
                RowBox[{"10", ",", "3"}], "]"}], ",", "\"\<)\>\""}], "}"}], 
             "]"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"FontSize", "\[Rule]", "12"}], ",", "  ", 
           RowBox[{"(*", " ", 
            RowBox[{
            "reduced", " ", "relative", " ", "to", " ", "big", " ", "panel"}],
             " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"ObjectName", "\[Rule]", "\"\<insetpanel\>\""}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"magnification", " ", "marker"}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"FigRectangle", "[", 
           RowBox[{"[", "\"\<zoombox\>\"", "]"}], "]"}], "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"205", ",", "245"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "1.0*^2"}], "}"}]}], "}"}], ",", 
           RowBox[{"ShowFill", "\[Rule]", "False"}], ",", 
           RowBox[{"LineDashing", "\[Rule]", "2"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"ScopeOptions", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"SetOptions", "[", 
            RowBox[{"FigLine", ",", 
             RowBox[{"LineDashing", "\[Rule]", "2"}], ",", 
             RowBox[{"Layer", "\[Rule]", "0"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"FigLine", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"FigAnchor", "[", 
               RowBox[{"\"\<insetpanel\>\"", ",", "BottomLeft"}], "]"}], ",", 
              RowBox[{"FigAnchor", "[", 
               RowBox[{"\"\<zoombox\>\"", ",", "TopLeft"}], "]"}]}], "}"}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"FigLine", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"FigAnchor", "[", 
               RowBox[{"\"\<insetpanel\>\"", ",", "BottomRight"}], "]"}], ",", 
              RowBox[{"FigAnchor", "[", 
               RowBox[{"\"\<zoombox\>\"", ",", "TopRight"}], "]"}]}], "}"}], 
            "]"}], ";"}], "\[IndentingNewLine]", "]"}]}], 
        "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"XPlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"0", ",", "650"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"XFrameLabel", "\[Rule]", "\"\<Channel\>\""}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"YPlotRange", "->", 
        RowBox[{"{", 
         RowBox[{"0", ",", "1.5*^3"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"YFrameLabel", "\[Rule]", 
        RowBox[{"Row", "[", 
         RowBox[{"{", 
          RowBox[{"\"\<Counts\>\"", ",", "\"\<  \>\"", ",", "\"\<(\>\"", ",", 
           RowBox[{"Superscript", "[", 
            RowBox[{"10", ",", "3"}], "]"}], ",", "\"\<)\>\""}], "}"}], 
         "]"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"ExtendRange", "\[Rule]", "0.02"}]}], "\[IndentingNewLine]", 
      "]"}], "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.518118989375*^9, 3.51811900096875*^9}, {
   3.518119070828125*^9, 3.518119080140625*^9}, 3.518434829484375*^9, {
   3.518434975890625*^9, 3.51843500028125*^9}, {3.5184377235*^9, 
   3.518437729046875*^9}, 3.518438256265625*^9, {3.51843828675*^9, 
   3.518438315203125*^9}, 3.5184383755*^9, {3.51843951065625*^9, 
   3.51843951134375*^9}, {3.5184634049375*^9, 3.51846340696875*^9}, 
   3.518464317515625*^9, 3.518468703859375*^9, {3.518469036125*^9, 
   3.51846906240625*^9}, {3.518469211125*^9, 3.518469221234375*^9}, {
   3.518469342765625*^9, 3.5184695138125*^9}, {3.51846993853125*^9, 
   3.518470013984375*^9}, {3.51847007728125*^9, 3.518470467390625*^9}, {
   3.518471377734375*^9, 3.51847139825*^9}, {3.518471440046875*^9, 
   3.518471509015625*^9}, 3.5184718695*^9, {3.518473290390625*^9, 
   3.51847329678125*^9}, {3.51847335740625*^9, 3.518473459453125*^9}, {
   3.518473889875*^9, 3.51847396071875*^9}, {3.51847468821875*^9, 
   3.51847472528125*^9}, 3.51847477034375*^9, {3.518474994390625*^9, 
   3.518475109671875*^9}, {3.52044876621875*^9, 3.5204487666875*^9}, {
   3.5209458044375*^9, 3.520945860875*^9}, {3.566338366330778*^9, 
   3.5663384814433804`*^9}, {3.566338517463844*^9, 3.5663385211298504`*^9}, {
   3.5666113236260443`*^9, 3.5666113258412485`*^9}, 3.5837841996356688`*^9}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], 
      RectangleBox[{0., 0.}, {431.99999999999994`, 305.99999999999994`}]}, 
     InsetBox[
      GraphicsBox[{
        {EdgeForm[None], FaceForm[GrayLevel[0.85]], PolygonBox[CompressedData["
1:eJx03QOUHAvC9vHY1vRMMs5MJjOxnYpt27Zt27Zt23ZurBvbTm7wdT1Vz57T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          "]]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], 
          RectangleBox[{86.39999999999998, 168.3}, \
{302.39999999999975`, 290.7}]}, InsetBox[
          GraphicsBox[{
            {EdgeForm[None], FaceForm[GrayLevel[0.85]], 
             PolygonBox[CompressedData["
1:eJx03QVQVd0axnE7scXCRrG7E+zuxMIkFQO7O7G7Gwv1s1vsDmyxuxs7L6yz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              "]]}, 
            {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
             Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
             LineBox[CompressedData["
1:eJx03XVQVVsbx3E7scXCRrG7E+zuxMIkFQO7O7G7Gwv12i12B7bY3Y2dL6yz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              "]]}},
           Frame->False,
           ImageSize->{215.99999999999977`, 122.39999999999998`},
           
           PlotRange->{{86.39999999999998, 302.39999999999975`}, {168.3, 
            290.7}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
         {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
          GraphicsBox[{
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{86.39999999999998, 168.3}, {86.39999999999998, 
              290.7}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{88.09199999999997, 168.3}, {86.39999999999998, 
              168.3}}], 
             LineBox[{{87.24599999999998, 174.42000000000002`}, {
              86.39999999999998, 174.42000000000002`}}], 
             LineBox[{{87.24599999999998, 180.54000000000002`}, {
              86.39999999999998, 180.54000000000002`}}], 
             LineBox[{{87.24599999999998, 186.66}, {86.39999999999998, 
              186.66}}], 
             LineBox[{{88.09199999999997, 192.78}, {86.39999999999998, 
              192.78}}], 
             LineBox[{{87.24599999999998, 198.9}, {86.39999999999998, 
              198.9}}], 
             LineBox[{{87.24599999999998, 205.02}, {86.39999999999998, 
              205.02}}], 
             LineBox[{{87.24599999999998, 211.14}, {86.39999999999998, 
              211.14}}], 
             LineBox[{{88.09199999999997, 217.26}, {86.39999999999998, 
              217.26}}], 
             LineBox[{{87.24599999999998, 223.38}, {86.39999999999998, 
              223.38}}], 
             LineBox[{{87.24599999999998, 229.5}, {86.39999999999998, 
              229.5}}], 
             LineBox[{{87.24599999999998, 235.62}, {86.39999999999998, 
              235.62}}], 
             LineBox[{{88.09199999999997, 241.74}, {86.39999999999998, 
              241.74}}], 
             LineBox[{{87.24599999999998, 247.86}, {86.39999999999998, 
              247.86}}], 
             LineBox[{{87.24599999999998, 253.98}, {86.39999999999998, 
              253.98}}], 
             LineBox[{{87.24599999999998, 260.1}, {86.39999999999998, 
              260.1}}], 
             LineBox[{{88.09199999999997, 266.22}, {86.39999999999998, 
              266.22}}], 
             LineBox[{{87.24599999999998, 272.34}, {86.39999999999998, 
              272.34}}], 
             LineBox[{{87.24599999999998, 278.46}, {86.39999999999998, 
              278.46}}], 
             LineBox[{{87.24599999999998, 284.58}, {86.39999999999998, 
              284.58}}], 
             LineBox[{{88.09199999999997, 290.7}, {86.39999999999998, 
              290.7}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{302.39999999999975`, 168.3}, {302.39999999999975`, 
              290.7}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{300.70799999999974`, 168.3}, {302.39999999999975`, 
              168.3}}], 
             LineBox[{{301.55399999999975`, 174.42000000000002`}, {
              302.39999999999975`, 174.42000000000002`}}], 
             LineBox[{{301.55399999999975`, 180.54000000000002`}, {
              302.39999999999975`, 180.54000000000002`}}], 
             LineBox[{{301.55399999999975`, 186.66}, {302.39999999999975`, 
              186.66}}], 
             LineBox[{{300.70799999999974`, 192.78}, {302.39999999999975`, 
              192.78}}], 
             LineBox[{{301.55399999999975`, 198.9}, {302.39999999999975`, 
              198.9}}], 
             LineBox[{{301.55399999999975`, 205.02}, {302.39999999999975`, 
              205.02}}], 
             LineBox[{{301.55399999999975`, 211.14}, {302.39999999999975`, 
              211.14}}], 
             LineBox[{{300.70799999999974`, 217.26}, {302.39999999999975`, 
              217.26}}], 
             LineBox[{{301.55399999999975`, 223.38}, {302.39999999999975`, 
              223.38}}], 
             LineBox[{{301.55399999999975`, 229.5}, {302.39999999999975`, 
              229.5}}], 
             LineBox[{{301.55399999999975`, 235.62}, {302.39999999999975`, 
              235.62}}], 
             LineBox[{{300.70799999999974`, 241.74}, {302.39999999999975`, 
              241.74}}], 
             LineBox[{{301.55399999999975`, 247.86}, {302.39999999999975`, 
              247.86}}], 
             LineBox[{{301.55399999999975`, 253.98}, {302.39999999999975`, 
              253.98}}], 
             LineBox[{{301.55399999999975`, 260.1}, {302.39999999999975`, 
              260.1}}], 
             LineBox[{{300.70799999999974`, 266.22}, {302.39999999999975`, 
              266.22}}], 
             LineBox[{{301.55399999999975`, 272.34}, {302.39999999999975`, 
              272.34}}], 
             LineBox[{{301.55399999999975`, 278.46}, {302.39999999999975`, 
              278.46}}], 
             LineBox[{{301.55399999999975`, 284.58}, {302.39999999999975`, 
              284.58}}], 
             LineBox[{{300.70799999999974`, 290.7}, {302.39999999999975`, 
              290.7}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{86.39999999999998, 168.3}, {302.39999999999975`, 
              168.3}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{91.79999999999984, 169.14600000000002`}, {
              91.79999999999984, 168.3}}], 
             LineBox[{{102.60000000000002`, 169.14600000000002`}, {
              102.60000000000002`, 168.3}}], 
             LineBox[{{113.39999999999998`, 169.99200000000002`}, {
              113.39999999999998`, 168.3}}], 
             LineBox[{{124.19999999999993`, 169.14600000000002`}, {
              124.19999999999993`, 168.3}}], 
             LineBox[{{134.9999999999999, 169.14600000000002`}, {
              134.9999999999999, 168.3}}], 
             LineBox[{{145.79999999999984`, 169.14600000000002`}, {
              145.79999999999984`, 168.3}}], 
             LineBox[{{156.5999999999998, 169.14600000000002`}, {
              156.5999999999998, 168.3}}], 
             LineBox[{{167.39999999999998`, 169.99200000000002`}, {
              167.39999999999998`, 168.3}}], 
             LineBox[{{178.19999999999993`, 169.14600000000002`}, {
              178.19999999999993`, 168.3}}], 
             LineBox[{{188.9999999999999, 169.14600000000002`}, {
              188.9999999999999, 168.3}}], 
             LineBox[{{199.79999999999984`, 169.14600000000002`}, {
              199.79999999999984`, 168.3}}], 
             LineBox[{{210.5999999999998, 169.14600000000002`}, {
              210.5999999999998, 168.3}}], 
             LineBox[{{221.39999999999998`, 169.99200000000002`}, {
              221.39999999999998`, 168.3}}], 
             LineBox[{{232.19999999999993`, 169.14600000000002`}, {
              232.19999999999993`, 168.3}}], 
             LineBox[{{242.9999999999999, 169.14600000000002`}, {
              242.9999999999999, 168.3}}], 
             LineBox[{{253.79999999999984`, 169.14600000000002`}, {
              253.79999999999984`, 168.3}}], 
             LineBox[{{264.5999999999998, 169.14600000000002`}, {
              264.5999999999998, 168.3}}], 
             LineBox[{{275.39999999999975`, 169.99200000000002`}, {
              275.39999999999975`, 168.3}}], 
             LineBox[{{286.19999999999993`, 169.14600000000002`}, {
              286.19999999999993`, 168.3}}], 
             LineBox[{{296.9999999999999, 169.14600000000002`}, {
              296.9999999999999, 168.3}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{86.39999999999998, 290.7}, {302.39999999999975`, 
              290.7}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
            {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
             JoinForm[{"Miter", 3.25}], 
             LineBox[{{91.79999999999984, 289.854}, {91.79999999999984, 
              290.7}}], 
             LineBox[{{102.60000000000002`, 289.854}, {102.60000000000002`, 
              290.7}}], 
             LineBox[{{113.39999999999998`, 289.008}, {113.39999999999998`, 
              290.7}}], 
             LineBox[{{124.19999999999993`, 289.854}, {124.19999999999993`, 
              290.7}}], 
             LineBox[{{134.9999999999999, 289.854}, {134.9999999999999, 
              290.7}}], 
             LineBox[{{145.79999999999984`, 289.854}, {145.79999999999984`, 
              290.7}}], 
             LineBox[{{156.5999999999998, 289.854}, {156.5999999999998, 
              290.7}}], 
             LineBox[{{167.39999999999998`, 289.008}, {167.39999999999998`, 
              290.7}}], 
             LineBox[{{178.19999999999993`, 289.854}, {178.19999999999993`, 
              290.7}}], 
             LineBox[{{188.9999999999999, 289.854}, {188.9999999999999, 
              290.7}}], 
             LineBox[{{199.79999999999984`, 289.854}, {199.79999999999984`, 
              290.7}}], 
             LineBox[{{210.5999999999998, 289.854}, {210.5999999999998, 
              290.7}}], 
             LineBox[{{221.39999999999998`, 289.008}, {221.39999999999998`, 
              290.7}}], 
             LineBox[{{232.19999999999993`, 289.854}, {232.19999999999993`, 
              290.7}}], 
             LineBox[{{242.9999999999999, 289.854}, {242.9999999999999, 
              290.7}}], 
             LineBox[{{253.79999999999984`, 289.854}, {253.79999999999984`, 
              290.7}}], 
             LineBox[{{264.5999999999998, 289.854}, {264.5999999999998, 
              290.7}}], 
             LineBox[{{275.39999999999975`, 289.008}, {275.39999999999975`, 
              290.7}}], 
             LineBox[{{286.19999999999993`, 289.854}, {286.19999999999993`, 
              290.7}}], 
             LineBox[{{296.9999999999999, 289.854}, {296.9999999999999, 
              290.7}}]}, InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"  0\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {86.39999999999998, 168.3}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\" 20\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {86.39999999999998, 192.78}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\" 40\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {86.39999999999998, 217.26}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\" 60\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {86.39999999999998, 241.74}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\" 80\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {86.39999999999998, 266.22}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"100\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {86.39999999999998, 290.7}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox[
                 
                 TemplateBox[{
                  "\"Counts\"","\"  \"","\"(\"",
                   TemplateBox[{"10", "3"}, "Superscript"],"\")\""},
                  "RowDefault"],
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->12,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {69.39999999999998, 229.5}, {0, -1}, 
             Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"210\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {113.39999999999998`, 168.3}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"220\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {167.39999999999998`, 168.3}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"230\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {221.39999999999998`, 168.3}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               StyleBox[
                TagBox["\<\"240\"\>",
                 DisplayForm],
                StripOnInput->False,
                ShowAutoStyles->False,
                SingleLetterItalics->False,
                LineColor->GrayLevel[0],
                FrontFaceColor->GrayLevel[0],
                BackFaceColor->GrayLevel[0],
                GraphicsColor->GrayLevel[0],
                FontFamily->"Times",
                FontSize->10.2,
                FontWeight->Plain,
                FontSlant->Plain,
                FontTracking->Plain,
                FontColor->GrayLevel[0]],
               StripOnInput->False,
               ShowContents->False],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {275.39999999999975`, 168.3}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"  0\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {86.39999999999998, 168.3}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\" 20\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {86.39999999999998, 192.78}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\" 40\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {86.39999999999998, 217.26}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\" 60\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {86.39999999999998, 241.74}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\" 80\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {86.39999999999998, 266.22}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"100\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {86.39999999999998, 290.7}, {1, 0}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox[
                
                TemplateBox[{
                 "\"Counts\"","\"  \"","\"(\"",
                  TemplateBox[{"10", "3"}, "Superscript"],"\")\""},
                 "RowDefault"],
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->12,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {69.39999999999998, 229.5}, {0, -1}, 
             Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"210\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {113.39999999999998`, 168.3}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"220\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {167.39999999999998`, 168.3}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"230\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {221.39999999999998`, 168.3}, {0, 1}, 
             Automatic, {1, 0}], InsetBox[
             FrameBox[
              StyleBox[
               TagBox["\<\"240\"\>",
                DisplayForm],
               StripOnInput->False,
               ShowAutoStyles->False,
               SingleLetterItalics->False,
               LineColor->GrayLevel[0],
               FrontFaceColor->GrayLevel[0],
               BackFaceColor->GrayLevel[0],
               GraphicsColor->GrayLevel[0],
               FontFamily->"Times",
               FontSize->10.2,
               FontWeight->Plain,
               FontSlant->Plain,
               FontTracking->Plain,
               FontColor->GrayLevel[0]],
              Background->None,
              ContentPadding->False,
              FrameMargins->{{0, 0}, {0, 0}},
              FrameStyle->None,
              RoundingRadius->{0, 0},
              StripOnInput->False], {275.39999999999975`, 168.3}, {0, 1}, 
             Automatic, {1, 0}]},
           Frame->False,
           ImageSize->{576, 450.},
           PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, 
        {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{86.39999999999998, 168.3}, {139.3136094674556, 25.5}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{302.39999999999975`, 168.3}, {164.8757396449704, 25.5}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {RGBColor[0.698004, 0.133305, 0.133305], AbsoluteThickness[1], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         LineBox[CompressedData["
1:eJx03QOUHInCxfHYVvdMkmFmMpmJ7VRs27Zt27Ztc7OxrY21se1kg6/rVt13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          "]]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[2], 
         CapForm[None], JoinForm[{"Miter", 3.25}]}], FaceForm[None], 
         GeometricTransformationBox[
          RectangleBox[{139.3136094674556, 5.884615384615383}, {164.8757396449704, 25.5},
           RoundingRadius->{0., 0.}], {{{1, 0}, {0, 1}}, {0., 0.}}]}},
       Frame->False,
       ImageSize->{431.99999999999994`, 305.99999999999994`},
       PlotRange->{{0., 431.99999999999994`}, {0., 
        305.99999999999994`}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72.}, {504, 378.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 0.}, {0., 305.99999999999994`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{3.6899999999999995`, 5.884615384615384}, {0., 
          5.884615384615384}}], 
         LineBox[{{1.8449999999999998`, 15.692307692307693`}, {0., 
          15.692307692307693`}}], 
         LineBox[{{1.8449999999999998`, 25.5}, {0., 25.5}}], 
         LineBox[{{1.8449999999999998`, 35.30769230769231}, {0., 
          35.30769230769231}}], 
         LineBox[{{3.6899999999999995`, 45.11538461538462}, {0., 
          45.11538461538462}}], 
         LineBox[{{1.8449999999999998`, 54.92307692307693}, {0., 
          54.92307692307693}}], 
         LineBox[{{1.8449999999999998`, 64.73076923076923}, {0., 
          64.73076923076923}}], 
         LineBox[{{1.8449999999999998`, 74.53846153846153}, {0., 
          74.53846153846153}}], 
         LineBox[{{3.6899999999999995`, 84.34615384615385}, {0., 
          84.34615384615385}}], 
         LineBox[{{1.8449999999999998`, 94.15384615384616}, {0., 
          94.15384615384616}}], 
         LineBox[{{1.8449999999999998`, 103.96153846153847`}, {0., 
          103.96153846153847`}}], 
         LineBox[{{1.8449999999999998`, 113.76923076923077`}, {0., 
          113.76923076923077`}}], 
         LineBox[{{3.6899999999999995`, 123.57692307692308`}, {0., 
          123.57692307692308`}}], 
         LineBox[{{1.8449999999999998`, 133.3846153846154}, {0., 
          133.3846153846154}}], 
         LineBox[{{1.8449999999999998`, 143.19230769230768`}, {0., 
          143.19230769230768`}}], 
         LineBox[{{1.8449999999999998`, 153.}, {0., 153.}}], 
         LineBox[{{3.6899999999999995`, 162.80769230769232`}, {0., 
          162.80769230769232`}}], 
         LineBox[{{1.8449999999999998`, 172.6153846153846}, {0., 
          172.6153846153846}}], 
         LineBox[{{1.8449999999999998`, 182.42307692307693`}, {0., 
          182.42307692307693`}}], 
         LineBox[{{1.8449999999999998`, 192.23076923076923`}, {0., 
          192.23076923076923`}}], 
         LineBox[{{3.6899999999999995`, 202.03846153846155`}, {0., 
          202.03846153846155`}}], 
         LineBox[{{1.8449999999999998`, 211.84615384615384`}, {0., 
          211.84615384615384`}}], 
         LineBox[{{1.8449999999999998`, 221.65384615384616`}, {0., 
          221.65384615384616`}}], 
         LineBox[{{1.8449999999999998`, 231.46153846153845`}, {0., 
          231.46153846153845`}}], 
         LineBox[{{3.6899999999999995`, 241.26923076923077`}, {0., 
          241.26923076923077`}}], 
         LineBox[{{1.8449999999999998`, 251.07692307692307`}, {0., 
          251.07692307692307`}}], 
         LineBox[{{1.8449999999999998`, 260.88461538461536`}, {0., 
          260.88461538461536`}}], 
         LineBox[{{1.8449999999999998`, 270.6923076923077}, {0., 
          270.6923076923077}}], 
         LineBox[{{3.6899999999999995`, 280.49999999999994`}, {0., 
          280.49999999999994`}}], 
         LineBox[{{1.8449999999999998`, 290.30769230769226`}, {0., 
          290.30769230769226`}}], 
         LineBox[{{1.8449999999999998`, 300.1153846153846}, {0., 
          300.1153846153846}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{431.99999999999994`, 0.}, {431.99999999999994`, 
          305.99999999999994`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{428.30999999999995`, 5.884615384615384}, {
          431.99999999999994`, 5.884615384615384}}], 
         LineBox[{{430.1549999999999, 15.692307692307693`}, {
          431.99999999999994`, 15.692307692307693`}}], 
         LineBox[{{430.1549999999999, 25.5}, {431.99999999999994`, 25.5}}], 
         LineBox[{{430.1549999999999, 35.30769230769231}, {
          431.99999999999994`, 35.30769230769231}}], 
         LineBox[{{428.30999999999995`, 45.11538461538462}, {
          431.99999999999994`, 45.11538461538462}}], 
         LineBox[{{430.1549999999999, 54.92307692307693}, {
          431.99999999999994`, 54.92307692307693}}], 
         LineBox[{{430.1549999999999, 64.73076923076923}, {
          431.99999999999994`, 64.73076923076923}}], 
         LineBox[{{430.1549999999999, 74.53846153846153}, {
          431.99999999999994`, 74.53846153846153}}], 
         LineBox[{{428.30999999999995`, 84.34615384615385}, {
          431.99999999999994`, 84.34615384615385}}], 
         LineBox[{{430.1549999999999, 94.15384615384616}, {
          431.99999999999994`, 94.15384615384616}}], 
         LineBox[{{430.1549999999999, 103.96153846153847`}, {
          431.99999999999994`, 103.96153846153847`}}], 
         LineBox[{{430.1549999999999, 113.76923076923077`}, {
          431.99999999999994`, 113.76923076923077`}}], 
         LineBox[{{428.30999999999995`, 123.57692307692308`}, {
          431.99999999999994`, 123.57692307692308`}}], 
         LineBox[{{430.1549999999999, 133.3846153846154}, {
          431.99999999999994`, 133.3846153846154}}], 
         LineBox[{{430.1549999999999, 143.19230769230768`}, {
          431.99999999999994`, 143.19230769230768`}}], 
         LineBox[{{430.1549999999999, 153.}, {431.99999999999994`, 153.}}], 
         LineBox[{{428.30999999999995`, 162.80769230769232`}, {
          431.99999999999994`, 162.80769230769232`}}], 
         LineBox[{{430.1549999999999, 172.6153846153846}, {
          431.99999999999994`, 172.6153846153846}}], 
         LineBox[{{430.1549999999999, 182.42307692307693`}, {
          431.99999999999994`, 182.42307692307693`}}], 
         LineBox[{{430.1549999999999, 192.23076923076923`}, {
          431.99999999999994`, 192.23076923076923`}}], 
         LineBox[{{428.30999999999995`, 202.03846153846155`}, {
          431.99999999999994`, 202.03846153846155`}}], 
         LineBox[{{430.1549999999999, 211.84615384615384`}, {
          431.99999999999994`, 211.84615384615384`}}], 
         LineBox[{{430.1549999999999, 221.65384615384616`}, {
          431.99999999999994`, 221.65384615384616`}}], 
         LineBox[{{430.1549999999999, 231.46153846153845`}, {
          431.99999999999994`, 231.46153846153845`}}], 
         LineBox[{{428.30999999999995`, 241.26923076923077`}, {
          431.99999999999994`, 241.26923076923077`}}], 
         LineBox[{{430.1549999999999, 251.07692307692307`}, {
          431.99999999999994`, 251.07692307692307`}}], 
         LineBox[{{430.1549999999999, 260.88461538461536`}, {
          431.99999999999994`, 260.88461538461536`}}], 
         LineBox[{{430.1549999999999, 270.6923076923077}, {
          431.99999999999994`, 270.6923076923077}}], 
         LineBox[{{428.30999999999995`, 280.49999999999994`}, {
          431.99999999999994`, 280.49999999999994`}}], 
         LineBox[{{430.1549999999999, 290.30769230769226`}, {
          431.99999999999994`, 290.30769230769226`}}], 
         LineBox[{{430.1549999999999, 300.1153846153846}, {
          431.99999999999994`, 300.1153846153846}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 0.}, {431.99999999999994`, 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{8.307692307692307, 3.6899999999999995`}, {
          8.307692307692307, 0.}}], 
         LineBox[{{21.0887573964497, 1.8449999999999998`}, {21.0887573964497, 
          0.}}], LineBox[{{33.869822485207095`, 1.8449999999999998`}, {
          33.869822485207095`, 0.}}], 
         LineBox[{{46.65088757396449, 1.8449999999999998`}, {
          46.65088757396449, 0.}}], 
         LineBox[{{59.43195266272188, 1.8449999999999998`}, {
          59.43195266272188, 0.}}], 
         LineBox[{{72.21301775147928, 3.6899999999999995`}, {
          72.21301775147928, 0.}}], 
         LineBox[{{84.99408284023667, 1.8449999999999998`}, {
          84.99408284023667, 0.}}], 
         LineBox[{{97.77514792899407, 1.8449999999999998`}, {
          97.77514792899407, 0.}}], 
         LineBox[{{110.55621301775146`, 1.8449999999999998`}, {
          110.55621301775146`, 0.}}], 
         LineBox[{{123.33727810650886`, 1.8449999999999998`}, {
          123.33727810650886`, 0.}}], 
         LineBox[{{136.11834319526628`, 3.6899999999999995`}, {
          136.11834319526628`, 0.}}], 
         LineBox[{{148.89940828402365`, 1.8449999999999998`}, {
          148.89940828402365`, 0.}}], 
         LineBox[{{161.68047337278102`, 1.8449999999999998`}, {
          161.68047337278102`, 0.}}], 
         LineBox[{{174.46153846153845`, 1.8449999999999998`}, {
          174.46153846153845`, 0.}}], 
         LineBox[{{187.24260355029583`, 1.8449999999999998`}, {
          187.24260355029583`, 0.}}], 
         LineBox[{{200.02366863905326`, 3.6899999999999995`}, {
          200.02366863905326`, 0.}}], 
         LineBox[{{212.80473372781063`, 1.8449999999999998`}, {
          212.80473372781063`, 0.}}], 
         LineBox[{{225.585798816568, 1.8449999999999998`}, {225.585798816568, 
          0.}}], LineBox[{{238.36686390532543`, 1.8449999999999998`}, {
          238.36686390532543`, 0.}}], 
         LineBox[{{251.1479289940828, 1.8449999999999998`}, {
          251.1479289940828, 0.}}], 
         LineBox[{{263.92899408284023`, 3.6899999999999995`}, {
          263.92899408284023`, 0.}}], 
         LineBox[{{276.7100591715976, 1.8449999999999998`}, {
          276.7100591715976, 0.}}], 
         LineBox[{{289.49112426035504`, 1.8449999999999998`}, {
          289.49112426035504`, 0.}}], 
         LineBox[{{302.2721893491124, 1.8449999999999998`}, {
          302.2721893491124, 0.}}], 
         LineBox[{{315.0532544378698, 1.8449999999999998`}, {
          315.0532544378698, 0.}}], 
         LineBox[{{327.8343195266272, 3.6899999999999995`}, {
          327.8343195266272, 0.}}], 
         LineBox[{{340.6153846153846, 1.8449999999999998`}, {
          340.6153846153846, 0.}}], 
         LineBox[{{353.396449704142, 1.8449999999999998`}, {353.396449704142, 
          0.}}], LineBox[{{366.1775147928994, 1.8449999999999998`}, {
          366.1775147928994, 0.}}], 
         LineBox[{{378.95857988165676`, 1.8449999999999998`}, {
          378.95857988165676`, 0.}}], 
         LineBox[{{391.7396449704142, 3.6899999999999995`}, {
          391.7396449704142, 0.}}], 
         LineBox[{{404.52071005917156`, 1.8449999999999998`}, {
          404.52071005917156`, 0.}}], 
         LineBox[{{417.30177514792894`, 1.8449999999999998`}, {
          417.30177514792894`, 0.}}], 
         LineBox[{{430.08284023668637`, 1.8449999999999998`}, {
          430.08284023668637`, 0.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 305.99999999999994`}, {431.99999999999994`, 
          305.99999999999994`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{8.307692307692307, 302.30999999999995`}, {
          8.307692307692307, 305.99999999999994`}}], 
         LineBox[{{21.0887573964497, 304.1549999999999}, {21.0887573964497, 
          305.99999999999994`}}], 
         LineBox[{{33.869822485207095`, 304.1549999999999}, {
          33.869822485207095`, 305.99999999999994`}}], 
         LineBox[{{46.65088757396449, 304.1549999999999}, {46.65088757396449, 
          305.99999999999994`}}], 
         LineBox[{{59.43195266272188, 304.1549999999999}, {59.43195266272188, 
          305.99999999999994`}}], 
         LineBox[{{72.21301775147928, 302.30999999999995`}, {
          72.21301775147928, 305.99999999999994`}}], 
         LineBox[{{84.99408284023667, 304.1549999999999}, {84.99408284023667, 
          305.99999999999994`}}], 
         LineBox[{{97.77514792899407, 304.1549999999999}, {97.77514792899407, 
          305.99999999999994`}}], 
         LineBox[{{110.55621301775146`, 304.1549999999999}, {
          110.55621301775146`, 305.99999999999994`}}], 
         LineBox[{{123.33727810650886`, 304.1549999999999}, {
          123.33727810650886`, 305.99999999999994`}}], 
         LineBox[{{136.11834319526628`, 302.30999999999995`}, {
          136.11834319526628`, 305.99999999999994`}}], 
         LineBox[{{148.89940828402365`, 304.1549999999999}, {
          148.89940828402365`, 305.99999999999994`}}], 
         LineBox[{{161.68047337278102`, 304.1549999999999}, {
          161.68047337278102`, 305.99999999999994`}}], 
         LineBox[{{174.46153846153845`, 304.1549999999999}, {
          174.46153846153845`, 305.99999999999994`}}], 
         LineBox[{{187.24260355029583`, 304.1549999999999}, {
          187.24260355029583`, 305.99999999999994`}}], 
         LineBox[{{200.02366863905326`, 302.30999999999995`}, {
          200.02366863905326`, 305.99999999999994`}}], 
         LineBox[{{212.80473372781063`, 304.1549999999999}, {
          212.80473372781063`, 305.99999999999994`}}], 
         LineBox[{{225.585798816568, 304.1549999999999}, {225.585798816568, 
          305.99999999999994`}}], 
         LineBox[{{238.36686390532543`, 304.1549999999999}, {
          238.36686390532543`, 305.99999999999994`}}], 
         LineBox[{{251.1479289940828, 304.1549999999999}, {251.1479289940828, 
          305.99999999999994`}}], 
         LineBox[{{263.92899408284023`, 302.30999999999995`}, {
          263.92899408284023`, 305.99999999999994`}}], 
         LineBox[{{276.7100591715976, 304.1549999999999}, {276.7100591715976, 
          305.99999999999994`}}], 
         LineBox[{{289.49112426035504`, 304.1549999999999}, {
          289.49112426035504`, 305.99999999999994`}}], 
         LineBox[{{302.2721893491124, 304.1549999999999}, {302.2721893491124, 
          305.99999999999994`}}], 
         LineBox[{{315.0532544378698, 304.1549999999999}, {315.0532544378698, 
          305.99999999999994`}}], 
         LineBox[{{327.8343195266272, 302.30999999999995`}, {
          327.8343195266272, 305.99999999999994`}}], 
         LineBox[{{340.6153846153846, 304.1549999999999}, {340.6153846153846, 
          305.99999999999994`}}], 
         LineBox[{{353.396449704142, 304.1549999999999}, {353.396449704142, 
          305.99999999999994`}}], 
         LineBox[{{366.1775147928994, 304.1549999999999}, {366.1775147928994, 
          305.99999999999994`}}], 
         LineBox[{{378.95857988165676`, 304.1549999999999}, {
          378.95857988165676`, 305.99999999999994`}}], 
         LineBox[{{391.7396449704142, 302.30999999999995`}, {
          391.7396449704142, 305.99999999999994`}}], 
         LineBox[{{404.52071005917156`, 304.1549999999999}, {
          404.52071005917156`, 305.99999999999994`}}], 
         LineBox[{{417.30177514792894`, 304.1549999999999}, {
          417.30177514792894`, 305.99999999999994`}}], 
         LineBox[{{430.08284023668637`, 304.1549999999999}, {
          430.08284023668637`, 305.99999999999994`}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"   0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 5.884615384615384}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 200\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 45.11538461538462}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 400\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 84.34615384615385}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 600\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 123.57692307692308`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\" 800\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 162.80769230769232`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1000\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 202.03846153846155`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1200\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 241.26923076923077`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1400\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 280.49999999999994`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             
             TemplateBox[{
              "\"Counts\"","\"  \"","\"(\"",
               TemplateBox[{"10", "3"}, "Superscript"],"\")\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-30., 152.99999999999997`}, {0, -1}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"  0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {8.307692307692307, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"100\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {72.21301775147928, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"200\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {136.11834319526628`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"300\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {200.02366863905326`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"400\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {263.92899408284023`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"500\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {327.8343195266272, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"600\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->13.6,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {391.7396449704142, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"Channel\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {215.99999999999997`, -17.}, {0, 1}, 
         Automatic, {1., 0.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"   0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 5.884615384615384}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 200\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 45.11538461538462}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 400\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 84.34615384615385}, {1, 0}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 600\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 123.57692307692308`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\" 800\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 162.80769230769232`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1000\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 202.03846153846155`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1200\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 241.26923076923077`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1400\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {0., 280.49999999999994`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            
            TemplateBox[{
             "\"Counts\"","\"  \"","\"(\"",
              TemplateBox[{"10", "3"}, "Superscript"],"\")\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {-30., 152.99999999999997`}, {0, -1}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"  0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {8.307692307692307, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"100\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {72.21301775147928, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"200\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {136.11834319526628`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"300\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {200.02366863905326`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"400\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {263.92899408284023`, 0.}, {0, 1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"500\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {327.8343195266272, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"600\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->13.6,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {391.7396449704142, 0.}, {0, 1}, Automatic, {
         1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"Channel\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {215.99999999999997`, -17.}, {0, 1}, 
         Automatic, {1., 0.}]},
       Frame->False,
       ImageSize->{576, 450.},
       PlotRange->{{-72, 504}, {-72., 378.}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->0.78125,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{576, 450.},
  PlotRange->{{-72, 504}, {-72., 378.}}]], "Output",
 CellChangeTimes->{
  3.5209453050625*^9, 3.520945630140625*^9, 3.524748133828125*^9, {
   3.5663384431453133`*^9, 3.5663384867005897`*^9}, 3.566338532907871*^9, {
   3.5666113354508653`*^9, 3.566611346121284*^9}, 3.5791219104273376`*^9, 
   3.583784401048622*^9, {3.594305936415372*^9, 3.5943059482653885`*^9}}]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->None,
WindowSize->{1912, 1092},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
DockedCells->(FrontEndExecute[{
   FrontEnd`NotebookApply[
    FrontEnd`InputNotebook[], #, Placeholder]}]& ),
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic},
PageHeaders->{{None, None, None}, {None, None, None}},
PrintingOptions->{"FacingPages"->False,
"FirstPageHeader"->True,
"PrintCellBrackets"->False,
"PrintMultipleHorizontalPages"->False,
"PrintRegistrationMarks"->False,
"PrintingMargins"->{{71.875, 71.875}, {53.875, 53.875}}},
ShowSelection->True,
Magnification->1.25,
FrontEndVersion->"10.0 for Microsoft Windows (64-bit) (September 9, 2014)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 96, 1, 35, "Input"],
Cell[644, 23, 351, 7, 69, "Text"],
Cell[998, 32, 838, 14, 55, "Text"],
Cell[CellGroupData[{
Cell[1861, 50, 41, 0, 88, "Section"],
Cell[1905, 52, 569, 12, 34, "Text"],
Cell[CellGroupData[{
Cell[2499, 68, 224, 4, 35, "Input"],
Cell[2726, 74, 42419, 786, 133, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[45194, 866, 397, 5, 88, "Section"],
Cell[45594, 873, 298, 6, 35, "Text"],
Cell[CellGroupData[{
Cell[45917, 883, 305, 4, 46, "Subsection"],
Cell[46225, 889, 322, 10, 34, "Text"],
Cell[CellGroupData[{
Cell[46572, 903, 822, 22, 124, "Input"],
Cell[47397, 927, 2069, 43, 320, "Output"]
}, Open  ]],
Cell[49481, 973, 1590, 36, 300, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[51108, 1014, 98, 1, 57, "Subsection"],
Cell[51209, 1017, 131, 1, 101, "Text"],
Cell[CellGroupData[{
Cell[51365, 1022, 733, 14, 712, "Input"],
Cell[52101, 1038, 55140, 1188, 1770, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[107290, 2232, 163, 2, 43, "Subsection"],
Cell[107456, 2236, 369, 9, 293, "Text"],
Cell[CellGroupData[{
Cell[107850, 2249, 3357, 66, 1047, "Input"],
Cell[111210, 2317, 59385, 1331, 1770, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[170644, 3654, 222, 3, 43, "Subsection"],
Cell[170869, 3659, 631, 12, 366, "Text"],
Cell[CellGroupData[{
Cell[171525, 3675, 3955, 80, 1727, "Input"],
Cell[175483, 3757, 75000, 1684, 2212, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[250532, 5447, 255, 3, 43, "Subsection"],
Cell[250790, 5452, 1158, 18, 198, "Text"],
Cell[CellGroupData[{
Cell[251973, 5474, 7753, 172, 1310, "Input"],
Cell[259729, 5648, 78055, 1668, 726, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[337833, 7322, 187, 3, 43, "Subsection"],
Cell[338023, 7327, 477, 9, 206, "Text"],
Cell[CellGroupData[{
Cell[338525, 7340, 1438, 29, 127, "Input"],
Cell[339966, 7371, 2317, 64, 303, "Output"]
}, Open  ]],
Cell[342298, 7438, 255, 5, 126, "Text"],
Cell[CellGroupData[{
Cell[342578, 7447, 2668, 52, 1308, "Input"],
Cell[345249, 7501, 45305, 1053, 2212, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[390603, 8560, 301, 4, 43, "Subsection"],
Cell[390907, 8566, 145, 1, 81, "Text"],
Cell[CellGroupData[{
Cell[391077, 8571, 1361, 26, 82, "Input"],
Cell[392441, 8599, 2301, 67, 140, "Output"]
}, Open  ]],
Cell[394757, 8669, 101, 1, 81, "Text"],
Cell[CellGroupData[{
Cell[394883, 8674, 2209, 44, 625, "Input"],
Cell[397095, 8720, 57190, 1166, 1416, "Output"]
}, Open  ]],
Cell[454300, 9889, 125, 1, 81, "Text"],
Cell[CellGroupData[{
Cell[454450, 9894, 2291, 45, 625, "Input"],
Cell[456744, 9941, 56785, 1160, 581, "Output"]
}, Open  ]],
Cell[513544, 11104, 149, 2, 34, "Text"],
Cell[CellGroupData[{
Cell[513718, 11110, 1480, 29, 35, "Input"],
Cell[515201, 11141, 2120, 61, 58, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[517358, 11207, 2603, 53, 278, "Input"],
Cell[519964, 11262, 81459, 1514, 581, "Output"]
}, Open  ]],
Cell[601438, 12779, 359, 6, 34, "Text"],
Cell[601800, 12787, 674, 10, 55, "Text"],
Cell[CellGroupData[{
Cell[602499, 12801, 3940, 81, 344, "Input"],
Cell[606442, 12884, 83631, 1573, 581, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[690122, 14463, 358, 5, 46, "Subsection"],
Cell[690483, 14470, 178, 2, 81, "Text"],
Cell[CellGroupData[{
Cell[690686, 14476, 1077, 22, 570, "Input"],
Cell[691766, 14500, 55561, 1199, 1416, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[747388, 15706, 145, 1, 88, "Section"],
Cell[747536, 15709, 459, 8, 34, "Text"],
Cell[747998, 15719, 103, 1, 34, "Text"],
Cell[748104, 15722, 3091, 95, 190, "Input"],
Cell[751198, 15819, 93, 1, 34, "Text"],
Cell[CellGroupData[{
Cell[751316, 15824, 4866, 109, 586, "Input"],
Cell[756185, 15935, 68030, 1545, 697, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[824264, 17486, 112, 1, 110, "Section"],
Cell[824379, 17489, 164, 2, 42, "Text"],
Cell[824546, 17493, 120, 1, 42, "Text"],
Cell[824669, 17496, 2716, 86, 182, "Input"],
Cell[827388, 17584, 109, 1, 42, "Text"],
Cell[CellGroupData[{
Cell[827522, 17589, 857, 25, 127, "Input"],
Cell[828382, 17616, 350, 7, 43, "Output"],
Cell[828735, 17625, 484, 13, 77, "Output"],
Cell[829222, 17640, 450, 12, 77, "Output"]
}, Open  ]],
Cell[829687, 17655, 362, 11, 43, "Input"],
Cell[830052, 17668, 2572, 69, 292, "Input"],
Cell[CellGroupData[{
Cell[832649, 17741, 7536, 168, 1117, "Input"],
Cell[840188, 17911, 1034, 17, 33, "Message"],
Cell[841225, 17930, 86703, 2102, 726, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[927977, 20038, 116, 1, 110, "Section"],
Cell[928096, 20041, 395, 7, 68, "Text"],
Cell[CellGroupData[{
Cell[928516, 20052, 8053, 192, 1475, "Input"],
Cell[936572, 20246, 236602, 4610, 1125, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1173223, 24862, 250, 5, 171, "Section"],
Cell[1173476, 24869, 263, 3, 65, "Text"],
Cell[CellGroupData[{
Cell[1173764, 24876, 1418, 36, 156, "Input"],
Cell[1175185, 24914, 1250, 36, 345, "Output"]
}, Open  ]],
Cell[1176450, 24953, 254, 5, 65, "Text"],
Cell[1176707, 24960, 2121, 59, 541, "Input"],
Cell[1178831, 25021, 158, 2, 126, "Text"],
Cell[CellGroupData[{
Cell[1179014, 25027, 394, 10, 218, "Input"],
Cell[1179411, 25039, 1335, 37, 345, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1180783, 25081, 8936, 192, 2346, "Input"],
Cell[1189722, 25275, 103045, 2236, 1265, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1292816, 27517, 158, 2, 171, "Section"],
Cell[CellGroupData[{
Cell[1292999, 27523, 17446, 372, 2214, "Input"],
Cell[1310448, 27897, 210849, 4152, 918, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1521346, 32055, 272, 6, 88, "Section"],
Cell[1521621, 32063, 227, 4, 55, "Text"],
Cell[1521851, 32069, 131, 1, 34, "Text"],
Cell[CellGroupData[{
Cell[1522007, 32074, 2036, 50, 300, "Input"],
Cell[CellGroupData[{
Cell[1524068, 32128, 183, 2, 27, "Print"],
Cell[1524254, 32132, 1292, 34, 27, "Print"],
Cell[1525549, 32168, 181, 2, 27, "Print"],
Cell[1525733, 32172, 1322, 34, 27, "Print"],
Cell[1527058, 32208, 183, 2, 27, "Print"],
Cell[1527244, 32212, 1292, 34, 27, "Print"],
Cell[1528539, 32248, 183, 2, 27, "Print"],
Cell[1528725, 32252, 1328, 34, 27, "Print"],
Cell[1530056, 32288, 182, 2, 27, "Print"],
Cell[1530241, 32292, 1384, 35, 50, "Print"],
Cell[1531628, 32329, 184, 2, 27, "Print"],
Cell[1531815, 32333, 1425, 35, 50, "Print"]
}, Open  ]]
}, Open  ]],
Cell[1533267, 32372, 116, 1, 34, "Text"],
Cell[CellGroupData[{
Cell[1533408, 32377, 21676, 465, 2896, "Input"],
Cell[1555087, 32844, 159647, 3143, 513, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[1714783, 35993, 238, 3, 88, "Section"],
Cell[1715024, 35998, 410, 10, 159, "Text"],
Cell[CellGroupData[{
Cell[1715459, 36012, 8767, 187, 1180, "Input"],
Cell[1724229, 36201, 230189, 4445, 907, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
