(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 6.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    471124,      11788]
NotebookOptionsPosition[    468551,      11701]
NotebookOutlinePosition[    469418,      11731]
CellTagsIndexPosition[    469375,      11728]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[TextData[StyleBox["SciDraw examples: Level schemes",
 FontFamily->"Times New Roman",
 FontSize->36]], "Text",
 CellChangeTimes->{{3.4912582924375*^9, 3.4912582936875*^9}, {
  3.4912586879375*^9, 3.49125868853125*^9}, {3.4990222156875*^9, 
  3.499022216765625*^9}, {3.51812290828125*^9, 3.518122909421875*^9}, {
  3.5197650775625*^9, 3.519765079140625*^9}},
 FontSize->10],

Cell[TextData[{
 StyleBox["M. A. Caprio, ", "SmallText",
  FontFamily->"Times New Roman",
  FontSize->12],
 "Department of Physics, University of Notre Dame\nrev. October 12, 2014"
}], "Text",
 CellChangeTimes->{{3.39552255203125*^9, 3.3955225581875*^9}, {
   3.396878383875*^9, 3.39687838403125*^9}, 3.397586352671875*^9, {
   3.39854548165625*^9, 3.398545486203125*^9}, {3.430247945015625*^9, 
   3.430247947875*^9}, {3.436820309328125*^9, 3.436820313328125*^9}, {
   3.443996368375*^9, 3.443996375046875*^9}, {3.47108965090625*^9, 
   3.471089655984375*^9}, {3.49722506396875*^9, 3.4972250644375*^9}, {
   3.5666826928464565`*^9, 3.566682722751709*^9}, {3.584054215605587*^9, 
   3.5840542182575912`*^9}, {3.622158280465792*^9, 3.622158282977397*^9}}],

Cell[CellGroupData[{

Cell["Package initialization", "Section"],

Cell[TextData[{
 "If you have not already loaded the SciDraw package since starting this ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " session, you must do so now.  See the user guide for information first on \
installing the package and then on loading it at the beginning of each ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " session."
}], "Text",
 CellChangeTimes->{{3.4921245209375*^9, 3.492124756234375*^9}, {
  3.492124799609375*^9, 3.492124838453125*^9}, {3.495659733515625*^9, 
  3.495659808359375*^9}, {3.5181229165*^9, 3.51812291978125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", "\"\<SciDraw`\>\"", "]"}], ";"}]], "Input",
 CellChangeTimes->{{3.492124284765625*^9, 3.49212429721875*^9}, 
   3.492124551328125*^9, {3.51812292428125*^9, 3.51812292534375*^9}}],

Cell[BoxData[
 FrameBox[
  TemplateBox[{TagBox[
     GridBox[{{
        StyleBox[
         TemplateBox[{
           StyleBox[
           "\"\[ScriptCapitalS]\[ScriptC]\[ScriptI]\[ScriptCapitalD]\[ScriptR]\
\[ScriptA]\[ScriptW]:\"", StripOnInput -> False, FontFamily -> "Times", 
            FontWeight -> "Bold"], 
           "\" Publication\[Dash]quality scientific figures with \
Mathematica\""}, "RowDefault"], StripOnInput -> False, FontFamily -> 
         "Courier"]}, {
        StyleBox[
        "\"M. A. Caprio, University of Notre Dame\"", StripOnInput -> False, 
         FontFamily -> "Courier"]}, {
        StyleBox[
        "\"Version 0.0.0 (November 24, 2013)\"", StripOnInput -> False, 
         FontFamily -> "Courier"]}, {
        RowBox[{
          ButtonBox[
           StyleBox[
            RowBox[{"View", " ", "color", " ", "palette"}], FontFamily -> 
            "Times"], Active -> True, Appearance -> {Automatic, "DialogBox"}, 
           ButtonFunction :> (NamedColors`NamedColorPalette[]& ), ButtonNote -> 
           "Named color palette", Evaluator -> Automatic, ImageSize -> 
           Automatic], 
          TagBox[
           ButtonBox[
            StyleBox[
             RowBox[{"Visit", " ", "home", " ", "page"}], FontFamily -> 
             "Times"], Active -> True, Appearance -> {Automatic, "DialogBox"},
             ButtonData :> {
              URL["http://scidraw.nd.edu/landing/scidraw-0.0.0.html"], None}, 
            ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookLocate[#2]}]& ), ButtonNote -> 
            "http://scidraw.nd.edu/landing/scidraw-0.0.0.html", ImageSize -> 
            Automatic], DisplayForm]}]}}, 
      GridBoxAlignment -> {
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}}], DisplayForm],"\"  \"",GraphicsBox[{{{
        FaceForm[None], 
        RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
        InsetBox[
         GraphicsBox[{
           EdgeForm[None], 
           FaceForm[
            RGBColor[1., 0.894101, 0.709799]], 
           RectangleBox[{0., 0.}, {93.1764705882353, 72.}]}, Frame -> False, 
          ImageSize -> {95.1764705882353, 74.}, 
          PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0, 
         0}]}, {
        FaceForm[None], 
        RectangleBox[{0., 0.}, {93.1764705882353, 72.}], 
        InsetBox[
         GraphicsBox[{{
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             GraphicsBox[{{
                GrayLevel[0], 
                AbsoluteThickness[1], 
                Dashing[{}], 
                CapForm[None], 
                JoinForm[{"Miter", 3.25}], 
                
                LineBox[{{14.782805429864256`, 46.24615384615386}, {
                 43.58047834518423, 46.24615384615386}}]}, {
                GrayLevel[0], 
                AbsoluteThickness[1], 
                Dashing[{}], 
                CapForm[None], 
                JoinForm[{"Miter", 3.25}], 
                
                LineBox[{{20.54234001292825, 36.150000000000006`}, {
                 23.54234001292825, 36.150000000000006`}, {25.54234001292825, 
                 32.400000000000006`}, {44.34001292824823, 
                 32.400000000000006`}, {46.34001292824823, 
                 36.150000000000006`}, {49.34001292824823, 
                 36.150000000000006`}}]}, {
                GrayLevel[0], 
                AbsoluteThickness[1], 
                Dashing[{}], 
                CapForm[None], 
                JoinForm[{"Miter", 3.25}], 
                
                LineBox[{{26.301874595992246`, 18.553846153846155`}, {
                 55.099547511312224`, 18.553846153846155`}}]}, {
                EdgeForm[{
                  GrayLevel[0], 
                  AbsoluteThickness[1], 
                  Dashing[{}], 
                  CapForm[None], 
                  JoinForm[{"Miter", 3.25}]}], 
                FaceForm[
                 GrayLevel[0.5]], 
                
                PolygonBox[{{34.418791692075665`, 46.24615384615386}, {
                 29.704026666036818`, 46.24615384615386}, {
                 37.415840042594645`, 33.886479882377664`}, {
                 36.90680088862935, 33.568865116143016`}, {
                 40.700711053652235`, 32.400000000000006`}, {
                 41.31847355632861, 36.321526423509994`}, {40.80943440236331, 
                 36.00391165727534}}]}, {
                EdgeForm[{
                  GrayLevel[0], 
                  AbsoluteThickness[1], 
                  Dashing[{}], 
                  CapForm[None], 
                  JoinForm[{"Miter", 3.25}]}], 
                FaceForm[
                 GrayLevel[0.5]], 
                
                PolygonBox[{{32.97890804630967, 32.400000000000006`}, {
                 28.26414302027082, 32.400000000000006`}, {35.97595639682864, 
                 20.040326036223817`}, {35.466917242863346`, 
                 19.722711269989166`}, {39.26082740788623, 
                 18.553846153846155`}, {39.87858991056261, 
                 22.47537257735614}, {39.369550756597306`, 
                 22.157757811121492`}}]}}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{0., 0.}, {93.17647058823529, 72.}], 
            InsetBox[
             GraphicsBox[{{
                EdgeForm[None], 
                FaceForm[
                 RGBColor[0.5, 0.539994, 0.53]], 
                PolygonBox[CompressedData["
1:eJx13Xk0F9//B3B7CG1SSqgkpCxFRZpRoYVIUrQoaaNFIoqkQiupT4lKpLK0
p53qI9FClsrSinxK2oXeFOk38/6e1/uP3/NMx+d8zuOce+4+d+7c9507A73X
uC6RkZKSklHk/uP+P9//zDz/Mx3Meu+h3J+I+f/+0J50ZuouKVbIc7aNSFvT
LCfoh8r/phyYpyTosfudj9wsUBV0hUrj1DV9egg6xmXMQ2nHXoK2PxBhdyCi
t6A7qx7m6V/tAz69K/TVfs7X+vdgb37UFPRqL4/b07S1wL1eDU5r5jz0xHGr
aldt8H+hgdZXDUSMf3PL3BsTdcH3gi/nOhqLGMfeiYelFwwEv/L5fErBTMQY
jLZ5MTVkEDiuUCdnhqWIkfN42+fA/sHg0r+bgo5MEDFvN0a5vzmrB67X3K9T
4ilibh81PKj/YAg4ZPF22bLVrUzineJna97qg8/1CI0fc7aNWV+7tufN9qHg
z8GF1UHJMqyrjMYMGQ1D8L6Dmj7/hXYwI/Sy904zNQLL1Bsf2XxfnlW2X1By
YOow8EY5z8EiY1m2fpmMarWPMbhnbHLCyRA5Nm9n2rShm4eDPYd2FX0epsQe
43q7f+IIcLnHcb+Hl+XZjcXfHt68bAJOKNw1NCZCnj0T/Gib9DJT8InMOUa5
Zsps4o7+g/Vb0OcX/D2xfa46uz1xVd7ULWbgA1fvnr35gGXXn/530Ro1c/CT
kj0f0udKsT45PaQPHEH7txzeX3pAmnV9vDjlhsFIMJOQsvjYQCmWfXOVeXMV
3ZGvV2D9Xycz4luXGumJo8Cvh5VFDTjxl9H66xGuX4Z+fC6yh0+IFKvc/eyA
afMtwG6pCz++/yzFtul23lrzCW3vW7qpubs0W2/mMu9AsCX4iv0Xj7qL0mzF
hNT2G3KjwXq9g4zv7pNh781sOfxmH3pr3YOEnHhZ9pKPvZWMzhjwp/AD//3p
lGWTgxJe6J9FH53/yObEZjk2JvpTyLSxY8EJXXK6/3grx4YeGtfX/z46TOv5
i8qB8uyKjNjrB2ZagaPSWscVhMmzs2/Wut+sRcc7pFh4l8qzdoXmojerrMEa
FTdHvOimwI58FXlQph09btHLH27PFdhBXypHDd0xDqy3O9dCbUsXtvsfg/Jp
vW3A1Qb9p3bvo8h2qoau809Fn79r6/TaX5H9ol3c86DJeHCq3FpbnRRF9qWJ
TtbNW+iSkPDsn7eV2Ifs2hnVUxjwoKp3V783KLPXZtxrlKlCfx84VPvvtK6s
6yXlh73MWfDwyEVJd/26stzF3CctBF2xuynasK4by+bNWzbmX3TQXlnrV1Yq
7PVCee7PFtz03j1P0VyZHfHsvMJ8R3RaJN+gSmzaq9nu3/ej65dcS76Qp8Rq
vZNK2/ICbVf+irvilNgDXzJ/9tKdAP60bH32rhlKrPJPV7u0pegSY08rdXcl
duuf9gNjzqGf6jfm/bJRYtvkT70rbEbHhFnrHmSUWH+16aPmW00E59vnmXvY
KbH1Gq3bvkegu8t9Pv5jmRK7QCfl2ZYH6GMFETa1F5TY8qFTBqurTQJbBj0P
2MzZ0bQpIM0NHTykdU8nV595Y45wf+gLrelmNwKUWCvbST2L3qKLVXtuPiOt
xF6c8nXRfAM78CaDPhYOR7uwBq7xl76vRku9/Mp0c1RgUzwZ6a1X0f5dTjY9
WC3PaixucFHvQKvuKLwyXUOejfXbl5I2wR68OFe7cXaMHCsXaNU4ZidaXXzD
kmPDwv5jikrRFx3dn3Q87MI2Re7ZO1/DAWyx9l6m3GtZ1jfGoub7PLTpnPdc
j5Rlaw9Wj9h6Ap22akfJoz6y7Jxj28PVP6GLewydrF8hw5akmXJ/k8GrTf2+
FZyXYe0vvBgwNhi9e0JuwHhfGfbW9a2rim6jh5v22v1pngw7KnfY7flyU8B+
9oa7itRl2NMPy7kZJzpffW2fNg0ZdtCTTfO27kP3Uz9t3ldKhuXvBurP0S+7
2SjkvZRmu9eVtqdpTwVX78i4PjtFmhXfLpagCw8qzN22TZrtbBp4pOgMerRX
v6oNU6TZwPbCT/Ob0Gu2yBXsNZNmv8jyHWIaOF9+U8RG7n66WGXArq2b0a3X
hjg3vpBiX6rff6F+H53b81KH1g551nXAGsN0FUew5zDdf5f+1WYfDum7YexM
dPPxeeVaa7n5xoi7D4sS0eYqd9+Xj5Zir1n69l1Qi369XIorkhQ7gum1vFHf
CZzSzaXboGd/mZMOfI9Al2kcPabWyM1XXJZ06X0F7bfSeuqth3+Z/XPUZqf/
Rs+1n3nJLeIvo7zoetpY2+ng8TscmctcehErFoqKtqNNZEffXzvFgm1bq8TN
aNG+5rlHlzTLsKs3Zh1sVHcGf+t8lNhfr5Op3zr3/da56ErNW/az7/9h5u2W
s+idir77tKjqzOE/zLN/zkWmN6Bd6z2rnpz9wwyZPuzT0T4u4P89D/xhFj79
26PeCn2qvIZNlPrDHHUvH2uyAB3dfuq10rMO5vnLjEUhW9A/SsYkHozsYHp5
bdp59yT6xVifvcO9O5jp/83g7ujoiv9meYfmdzC7lum/mPkZfX6H/vDmunbm
/uffUklqM8A13vGtS7+0M9L+pQb1Zmgb8YS9nRnXcsLFZBbaa3jtC9vYdiZE
/A9tN2Ca/8lF7cyVDseUu0fQb8JWzPswpJ35HjGQe6RGu2QULpSS+8MYyYu+
z6xDn9Q5OVL1uBO7dGdhnyR5V7C72vCspO/ybKpqMlNvgB6yo+tvqZ9tTPW+
dctMHNFzR06dMS+tjdHUmLw3ZA1a0Wj/z7QnbYzbYa3rd/ejm5IcuqYm/WLi
tH9UK19DBxuquG9I/MU8Ti1QcHuBNj3Y27mf9C+my9DDI5I60Lod8Q0Bs9qY
CWdWu9frzASfW1G9dldsGxNuMpH7Q195tVk7oWUwm81PB5eifXb3Tfz49Dfz
c/SX4rs70WGX/I7tWdLKmN7K/al8Dn3M9GuI0cpWZiV7cIBbGfpgWnHvcT1a
mYz8FXZJzejH+alWVUNamf8mj19Vr+EGdpLZ9umHUSsjnm5boa/zw3mfVsZz
xodbIfPRw8QLDq1MfEXOu7sR6D/TX+R8axYxTzziVLqeRHeb/H7vG4NWRqXa
Z5TbA7S4u09pZSZ7j52X9Al9sNP0RwwXX2S9Kvc3C5w/v3bu4yYRk+tbd8bE
DO27XH+L7U8R0/7t2rMQN7TdkdyuH1pFjOW63e13g9FFx+2uNf8RMQGtXoO7
HhH2+dBR09zuoP+z7Jc7V7eV+fhXcV3SW3Sm/ouTZYW/GL3IN4fr5dzBiz0e
bNpxUsQsVMzKMzFA+/m79Bp9VMQc3cPPGNA5z3Lb3hwSMVXd5/bMW41u63ms
+dZeEcP3hq770eV8cC6+6Zpy3m5X0Tpz8x86cvHtSnq+M+k52val3YlPSSKm
YOC5S/Xt6G8Rbp3PY0QM/zRjojMbfE1Zq/NzvIgZZ+QuvWECmtILOW9kmLcE
Ld9ctG3+DhFz2fyvS9ed6FgHi0f6USJG3B3OoqtPnzpfHCFijKwzUpJK0Y+l
nw223i5ilv4b9rC+CX3v05TYPVx9pk6c0WiiMQd86ubZ6Wc2i5g3D/gJEbrz
/FJDy00ipq/jbyZvHnrOSV25uxtFjFtZybKuEejcloclA0NFTJzbib1uJ9D9
Pm3NPBsiYoqeB19Puo8OrBkXOXq9iOEeVmvqP6I3Dk6tXrBFxEx4q9vFVNUD
PGWKufrnYBETvuTniA2maL2wx8fiuPze/PjIPW8metlftZZ4rrwtq46Fdw1G
TxQP2CJG/Lh3WNgr1zuUJN1Gr9FI2GkXJGLSf/cX1deihxZeHOu0VsTUhTcO
MJXzBBv/M2sUEyBitGUL7DYMRfs6NcfODBQxnuIFPbTTIY0L6atFzMGuq7k/
dJuvdKkaF1/Z3gm33fahw0QFmvWrRIyKep/3SVfQ3d6EuP2zUsRMTvis8qEK
7Rk8iZm8TMRs08odZdqOXv7U3ETbV8Twq/kbtOeCtW6nvRu5RMT81lsRmWeL
tt2l4hnrzY2nmTZnuy5BU3oBw3uWu+1Af+zWq2bMGhHDjxZJZ9DcZPPvhoUi
psEiZ/CHEvT8AoOXcgtEjHg5uQk9kivNDS9uPB3vs25D73lgWg8/Il4wQG/b
H+vsNVfEVNqr3us6D0356Vn09pPbZvQeveeTJs7nxlPnaz2PpaLvOhqfXsd5
57NdVh8K0FOPH/w+jstP/mwvb9OPaMtNMvJB7tx4+nrkrg0q88GPFl9lBs3i
xlPxDQUdHBX5285ZxAS/e/2i60y0zKzzyZO4+LKWX5KetR79+FLiy+pp3Hj6
JcrwWCI6tf9e3/1O3Hi6lp9xoLtZvDZ5P13EiIeLWjSV5/gGWe5vAfhEvHPh
g9ki5vUf/gcf9CCPNf3OuXLj6dazjV2nomdvubf5DWc3hS19Z61CP/vZOUqB
i2/vrlnssTh0Onc1RHL5LVQzWv7hMpqvbc8Z3Hj6T+de0yp01g+b7CSuPSf0
eXZ9w2/0+AO7Dw/m4tt0JL0mb4CXoG/ohHVRsUU7fd+w65cLN57yjys+6LDp
hj9HczY1GDL72Ha08ecb3fa5iRi/s7/CP5xGv1LhF6xEjHg5pwQ9sPp8dvBk
bjy9klqy4Qd6WuBNo3x7rj6PWocuUl4IpvjOVQ/ppqCFHubfdmHuVK6+dbuf
OD0crbxytEUz198avH9bOjPoBw0tNV+48Ar8cqcLenWzlbw3F17vQ8mCBG80
jScTDG82jQtEa/VWzo1y4MYbvxPRb6PQp1ask3eexN0vz8X0iz6EjleL6r3B
lhuPvgefN8pEZ03hBwTufmrmPaE0G31/1aiI6yw3H1znWLnuMZpvbX3OLVct
fftWo93EC27ceMb/YPMdPXL7FjvlCVx/4WaTi6QXgam9p4f9HKLQC+2jFDvK
eAV3v75Tc/O0HvpIlWF3Py6+nVKFTs6W6L8L+Adu7n4+4crbZgf0Z6vDP3tw
+S2IPBaU4IH+33o21x/v71Cy8UMvu1Bx2opLT0qJm86Hoam/ak+bbxYdi24K
/+s8dgo33sY4FBiloOVP7LeS5vqTZ6mZR+kl9L6vYYwFdz8L7qH1dd09dPIQ
tTNDx3LziZncgFWBpt+LLx9sVL9dj9ZuGN6uMop7nqt6mbGoDb1ljVlR6Ehu
PNcsGKeg7A2+eijK9CxnlXkXyk73R7f1exiVxaVndCzRx3k4el5q0ayBnCfX
bmtrHo9eJH7g4ebbg1bvSXBBP8rp2z+Q8zafObo23mjqr8fTuA6xDl15xP6M
uik332kwnhwdhdbU2SnVnyvPa6M+r40OCfv3Smn/0gx00mmnaU0juPvNhc+y
gdloafMZ/RdxtvxRcajvY7Ry/uHudlx+3EbmDrv9Bh3y5kPFITMRszbo9L+L
vqNrh8eltHHee/3ATAXpxeDUdU1270y48ZQfznuiKb1C6xWhznpoCt+waWa3
Fgs0tZdCrs2JBAe0fPvP3jO58HoyBqNtPIQ9gf+5xhc97OHc3eeMufE0umNB
dBiawm/intaMYtGU3yPKT6JLk9HUHjcdc/oFXkJTfJWxp873vYfuFsN0Hc3V
dws/oS9HU3/r2Wtj5aJ69GOlP1dNufRMZ/n4KrSh08cdYiu58NMPTe88reQD
pvT8XozZ79wfTeXdyW9XMEZPvPqP/zIufPp81eyE8Wjqz/nJrU42Lmjaz1L3
lvu3CE3lldJ7HBS9Dm3heSpiHxef9tJrSsOi0A/YOTnjh3PjKf+4Ho+m+vL4
tMssMEPYwcZBBX2z0VQfB/kNQUXodeoTX53i8nuZ/8HwDXr1tGO1l7nwZU0j
tyh8R1N5v43S7n1GagmYrjeVYMVM557ohLcZLlJcfo246UbLYGFPbn9dlmCB
pviW2DzwsXFAWw2eGrqNy++2zZfa3s5Bm+6Tik7m6vv43SN7on3RT54evziI
C39HNlp3WJiwX9v5XymNQVN+f2/3nByYjKb26ls46XXfS2iKz1LFxP92Hpr6
y0x+wascTeHXxskmKNSjW5O76G/ixpu9T78OO9OK/qevnLsaF99Z9ef/Oist
BVN9FbrnzWzph6bwDQlnPyQYoym/Cq/iQ23Goyk+vQFbutU5o6m+JnhxE9JF
aLrevI7PGj1sHbpj+VndNVx8m/ifmyPRVF9Hhhh5Bcaj/zUsHRJnwT2vLFNv
7puBpv5YmdkZffsm2uem2+dSLr2Wzw39vIvQNB735DdkvEFTfZr6355w5hua
+ptTVnqls9QyMN0P/Fr2+bb0QFN5d1qGdSYMRlN/SQtZut/GAr1i66/3d/nx
NNtFv84eTe1Z12GVHT0HTf1Biv9FzxdN4bW57lAaiqbw1vd+BQXGCNtD/p2S
ZjKa4gvml+Muoqk+D+68YeadJ+ysotQChXI0pVemGuNx5j2a0vvmHPzVuRVN
/Vll/6ItLYrLwd93hMeVcPNho/JpvRP7oSk/DhqWmTbGaNrvuYSbjtbZoKm/
bTvMTTic0RRfyusWn2GL0DffryhabsSNp9o1baUBaOqPrxc+2hMYifZqvND4
hsvP79TLuprxaMpP3/dJV26noym8xdAdk71voqk/z1wR8FqhCE31sZbfrvwa
TffL2K/2ci7f0NSeZ03MElr+oim9wrX9jRN7rAD/bz8oN55els+1GYyWjKf8
z62j0JRfvTEvP0Tbo2k+ZLsxP3TYHDS1p9et893KVqCbKr2H7ebys6kz4URg
KJrSO8xuG60ZI+wb/HaZY8Ku5BcUL6KpvVsUJjQr5KGpPnpOMd5+5hl6oGXP
+EdcfzTZrdHf5T1a/++1uByuPE7FUhdaRGjKj1+3zxMSFX3B1N47ZlRU2vRD
86u1Wvx4+s+/vnXD0BRffgV3Q7FB0/NEXZ8D+4c5o6k/SXmG65ctRNN8ecDR
5dmBAWi6X1pXu07XjERTf/TghovbB9FUXvG+93Q0lffAyR7KXW6iKb0sfrm9
EE3plRnUm7m8RkvGU9+ygpavaKovlXPZHol/0ZQfw+8nv9r08APPWrC0/RfX
XxzM9m6pG4Sm8WbJug29t49CXyqptcg2FzFbry7OHGaPpvZK4R5XymajKT93
xo55ErgCTf39deigJZqhaLpef99W+XV7D5rqu49U6x7vY8K24H9wu4im/MyM
LLpy5i568KWnPzu5+5X//auTXZ6hqb/HKnJ3lHdoiu8sv11ehKb6LtwTKDde
cSWY7qcNJQsS6jTRNN7J9+AGjGFoao/BM0fmDrNBU3q2/HaK6WgaT7yqujQE
LkTTeBSm2RSqGYCm/n547utud7YJ+0bS/RPeB9F0v62suTi6Szqa8tPCb/e7
gab89PCJ8nIpRFN4k7Q1zS2vhO3U4LE98Sua+qOv0aT+4/+i75xXu+/JecfK
ERfquq8C03w07XzfidsHoak98htlqoaNQlN/qzP/6ltmh6b7zd/Aqs7A2Wga
TwZcv7tfcwWa0rP+dUb/zkb0rujshUZceeZYx2d770FTf1+/KWJ6l2PoiBZ/
P3tDbjzlbidnLqApfJb0rPUud9GUXtlERvnnUzTVxzf+57R3aKqPrg97mY8X
oak9DZU7C+q6rAbTeOLgyHUITTSNtz6x3APtMDSlt7Xs1payceivqndME7nw
KT3TewdNR0vGU7d9mZoL0dRfX3OPs3fWCvvX8yVPvLehqbx9+rss6XIQTc+L
FvOtfp1JQ9PzmmuyXozLDTRdj/5v1Qb+fISm/MQO/nUl8RWarqezS/6bPP4r
Oup276VjuPgK04tf13WiaTz88PG6//bua8BU3/LGqXLGg9B0vQxevSehbCSa
2tv24nrjIDu01qpVR6q4/r6gaWGu5mw0pRfGb5dajqbyHl5v0eC9Ee1y8K6U
Ihf+Bv+D5h70+C/fgoL49YDfSt3PJqGpPZr5DZsX0FSeHpurR//MRdP1aMJv
V36KpvI4yl72Gv8OTderr11Sc91PNJUn/x73T9YfTPOVp+9uqMaroKk/1cmf
n728N5qup0b9E8ettNFXtArK1nPt9dch4bPKUDQ9T6qtiLGoMUE3TNK0TOfC
a+3auvnSGDT1V2P+hTlbNNW31eOVvdynoqk+pvKvY8xEOz7WUtDg0hNv156L
7nPyYcp7AxGz3MTxx2MfNOV3vYutdfIqNNVn1FrLqLXr0dTfuaeB0omb0XS/
4R+nNXagqb6zynsvbohDU33zu0mzE9HU38o0uAljKprKy/Vm1usMmuL7NufT
LrMraKrPjg015bK30dQeykfKtSsL0FSefrceLc8oQVN4gzd3sjZWoWm8HtN5
ucOxFk3Xs71Opr3ORzS1lzt7LO7HDzTF57Pon5f3fqNDhz32d+PqK3DrDr14
2bVgGq+2nti0erkKmsbjuPyAG1a90VSfKe+Xyahqoy/M1K2M5NLj3yar0UdT
fd4Z6hp/yQRN/fHxZIfabWPQ1B9erxhn5G6Lpvbgfy4xmIqm+Q4/nfrtiqb+
qFjcX7F4Lpri0/jW3TXZB03l0e+mcHTtKjTV9yjT9vcT16OpvJP47Zib0fS+
tmvA+w0N29GUnjfXHbLj0FRe/yulqjGJaCpPeEX+bK9UNKUXK7p53OwMmuI7
2ufCZ9kraLpez445aVF5C03l5Z62N2cUoKm9CzfGPtpYgqb8Pj+yrZdTFZr6
a8OtkPk6tcIWvVmV/qMBTeWV++v9494PNN0v1HW5GflvNNXHIFunqOWyAWDq
b+beE0qtVNDhA51M/x0nYvjlMtXe6Fnu41bIRYoYl5PGi2sGoKk/LOA3POuj
KT+r+BciTdBUXn63lvsYNLXXLgPp3Qa2aBoPDk8Rlf+egqb2zPD9rF3siqbz
DG7srl2ePBftIBvSVY8Lf/9sRdZaHzTFV1lc2DFxFZrGy3ff/rXXWI+m8E3d
rsY1hKOpPmTMTr/M3o6m/tSdn5DHoak8uusOrPZKFPaIAztvmKWiKT/jr4bL
yJ1B0/3GsXKdY+VlNIWf17o8PuOWsPm33TYWCDtk7EwjpxI0XQ87PCcH6lSh
qb74x6UfNcJOO2qumN+Apv505TZ3Q/mBpvbMr9Y6uvw3muITvy4muw5M7SXe
Tq6Cpuul0ZabcaijKb5Obri4NABN+VHjXyjRR1N5tE69mu1ugqb+bny/7LjB
GDSlZ/Wh4PNvFk3xTVXMsSiegqbyzDG8uDnZFU39cdnUU4/WzkVTfa33O9xr
kg+a+ov4dd9VaMrPAf51wCB0dVYpe49Lj9+tmR2OpvJmfV9tHbMdTfWd290n
yisOTfkpM/MoNUtEU3z8crhcKpr6+5d1ExdXnkZTfXYcGHMu4zKaxlPla8Nb
N95CU3v3q+LuKAVoag+Dtj67dUrQlN8xmqoVPyrRlB/+NIr8GjTV96y53IDR
gKb7jU/Yl6zlP9CU34Cktx1Wv9HUHlvvVNqrygaCqT/E1RTF1XRF0/NSitTd
l5fU0ZTe+YHX9CIHoCm+O/wLe/rCFh9nYiJs8XEXo9FUn59O7XIsZtF0vbTd
3xyfPAVN8Sk2BNaudUVTe2oo+RpNmoum/qBv5BWo4YOm+PjlkIaVaAo/aeUU
xZwgYbvGjHeNCUdTey48P/Ko13a05Lwi/nXXODTVl/h1mEQ0tWdsj14bK4+j
KT7+dpJxGk35OTvzj2roZWFnBzbNdrqFpvOaCg9+OK5TgKb0nl97/flHMZrq
q77qiUV+JZrSE/EdogZN7SXHP9A2oCm8uvWlXtY/0JTeoHlp81V/o6k+zfkN
/zJBguYfZy91RVN9OP8bZR2pjqbw3Gwjyn0AmvLLb2c10EfTeB02aIlm+wg0
jVe7JnouLh4t7MM+zueSWTS1V0bUpNa1U9CU3xtpY20nuaIpP/cfjNitMRdN
5SlvGFzRsBhN633vlDR1claiabxoMlJbEROElsxX+QXBcDSl131VW4fZdjSV
R5ff8BCHpv424kJdXGUCmupzfFnVy4zjaOpvjj8e64WeRlN4z555q50uoym8
78jrN3RuoSk/IW5nZZry0TSe7Ag67phfjKbfy+P5f5Voul+nXeceWGrQkvnq
8wgj6wY0tQe/nUn1B5rq+2k/vzs1v9DUXrXWCxWzZNaDqb4a581yjewq7M5N
U4+6q6Ml81X+df0BaMqP+HW+IcI2fmu4sXgEmtLjpxvJo4XNn8YTwAp7ziSl
OZOmoCm/S5d0HtdwRVN+1kc3f27wFDY3G7XIWYyW/N728M3mmJVoCp/68ekj
ryA09dcs/riocDT1B/FxMtvRFF+JY1Z65V409bfqVek/MhLQFN+X2KPWocfR
lJ+OC/uinE6jKT5+u7rOZTSNd/2aQjWbctDUXga91i7Oz0dT+NGjlp6LL0ZT
evb8hLQSTeHd+AX1GjTVl88hu92qDWjKT8ANq4qaRjTdz7a+MNHJ+oWm+ozj
X1iVCQZTflL697vs3hVN9X1+XLc/BurC5nqDQ7sWmvL7OPxXXPEQNF0PL5O/
vUwegab4PuX+pxcwGk3laXv7fPUkFk3pKcqW3NCYgqb61tC7J/NxBpryo293
wzHHE031zXeHmMVo6g8TtqfWeq1EU35cMw4ZmQeh6TxPfruiXDia8uv/acud
ymg05Te8a7Bi5l60ZL5qvNI1NAFN9X3UadFRp+NoKu9Z/riR02gqj/h15Cw0
xffwIrsxPwdN8T3npqPx+WjJfJWfcBSjqTyiXrpzrCvRFJ4/LUi1Bk3h1d2V
v9R8QFN9Dgr+a5HVKGyzhJbNkb/QVB8sfyCATAiYyjv9ZXUvw65oim9B+7P5
7b3QNB9bqfUovVgLTeUNs7nzI3kIWjJfXXDZOmAEmvJzeDM3Ix0tbP51FA0W
TfV57e5+zY+T0ZSf+3XbF+fMEHa57KZzMZ7CfqcX0Oq1GE3pNdktszVfiabw
Msvm7ZYLQkvmq/yGy01oyXw1014nMxpN9TmCf6Fsr7DHfTa97JSAlsxXVfT/
6BxHU317Du/v0JSJpvz4Tu++Lz8LTemFrJF/FZ+Dpvh28DeUfDTFx58WaF2M
pvo6xf+gX4mm8FeaX8jUVqMpvTz1UsesD8J+yg0XkY1oKg9/2qj7LzTVZ2Pw
eSNDmQ1gyg+/HbldGU3xqWUn3CnuhZbMV1/FKKZooSm/wzq2ugYMQdP9wGpA
yNFJI9CUnvi4pNFoim8Of5wCg6bwSyNmb8yZjJbMV7nHlZgZaAofmWerttAT
Tekd+M9yjvlitGS9Vc44VW4lmsJfHDLwS2Ugmtor117DMnOTsPnTZEKj0VSe
6h1ShU570ZSe+DjSBGF38McVpqCpPNzdJD0/E0354ZdL47PQkvkqP2DkoCk9
S37BIx8tma/yP9gWo6k/8dvRaivQlB+frGOLs6rRkvVW/sC9D2jK79aWHa3u
jWjKb1zvcFvDX2ha703mD7SS3gim8eT87OUVxcpoyi//c21KL7RkvTXRdUWA
lrBfZjtcnjQETeX99GrcH40RaMl8tcPM4aMlmsqrqD10Xw6DpvrS4EeMyWgq
j97CHkMWzkBT+FFbFNaYe6Ipv+LjphejKT+u/HHEfmgKv/Dde8fMQDSl58/d
TkI3oSXzVf2yWqdotOS8fIcCI929aMl8dXl2YNMhNLXX6Z0X7uSnoCXz1dMn
FQ9lCvthEdchstBU3uf8A20OmupLfNxbPpryK+KPg3mMpvqQc1m9MasCTfnh
H2cjq9GS9Vb+wM8PaMoPN9uYY9gobLac6xFtaEpvOn9goHQomNprgcZwyxRl
NIVfOXpQREAvNKUXNqdP4SQttGS+ukFFvc8QNJU34bD0go/D0dQfMnJE6TmW
aFoP5ZfTYxi0ZL/An1rrhZPRlN9y7coo8xloyu87pqhUzhNN+eW3m1Z5oym/
MvwLH35oiq/7idPnQgPRFF6bf6F9E5rKM+L9AVvdaLRkvqqwa3dTrLAdh26u
yD+Epv7M/5x/KAVN9eW7gvuXiab6COEfWLLQlN/tZ2b+Uc1BU/h4fsPYPTT1
15NfbfZlPUZTea6ojXwVWSHsPBODIbOr0ZTeU5cBaww/oKm84s9RfBd24/4u
siVtaIqP306YIh0GpvpW4aYbAcrC1hLV107qhaby8MeF9NESttWYJ4Ef9dDU
HpM97t/JGY6m/M7ZmKMYa4mWzFePXHRdyKCpPtbfOnXUfDJaMl/lj6ucgab8
7OePs/JAU35SdaI2ZnqjKT5+uSPUT9i5i9aoTQ9EU35LtvrM0d2EpvDVJzxS
m6LQkvlq/vQv+bFoKk/7+4mWhw4JW7nL2IgVKWgqb19+QpqJlsxX+QX1LDTF
Jz4OO1vY9rtVM7LuoSk9/ueWyMfC9ilutZ5dgab6COAPdKtGU3r86+Lt9Wgq
T5xplWbJdzTFd2zG48UpbWjJfDXg7rkA6U1gyXz1n2utk5TRkvXWK2ds+/RC
U/iXFSm7P/ZH03j/SXSwIkcPTfHx2z1ih6OpPhS47rDQEk3paXgGXTZn0FQf
eqG+f+QmoyXz1aNeDlUuaIqPP00y00PYrtVTXoV6C3vh3/FDpvuhKb01uqPW
6AaiKb/c08rNpjBh7/HWli2IQlN9H93Wy+lQLJryw09HVxxCU3zZBdyEIwUt
+Z4Vv2CaiabyPO/SEFh7CS1Zb+U3rGejKb2fU54qRt1DS9Zb/R64zn6Mpv7e
c8+to4YVaMrvIP7AzDdoyq/4OL56NIVnvx/ZmPIdTf2VXw4LaENTfheYRavZ
SYcLeqVr6Jw+ymiqj43r/FM/9kRL5qsHlnzJ6Y+m/CZc9bSM1UNTehmVzhEL
h6Ml662tkwrNLdFU3/f7WqnLM2gKz592X+WApvK889TLyHRBU375n+NCPdBU
XqkktXHTvYXdnT9Qxw9N8fHHQTStE/YIqW+aBWFoqq9xA/9bfCgKLZmvTnh+
bkUsWrLeupi7oRwSNn+arFqKsENOXd9dm4Gm9KL5DcmX0JL56ofjOlHZaMl8
lRsuZt9DS+arhnsuGz5GU/i8qVv+tJejJfNVv/UOJW/QFL52j9++lHo0lffb
uYWvAr4Lu7Nk1hC7NjTFJ/7cnvRmQWvxn8NTQlN8RuYWsrd6oiXrrTONnGL7
oyk8/7iyUA8tma8eVH9rPhxN4fnjvuQt0XS98a8DV41HU34i25rvZDqgqT33
a35UDHMRdqpVtet0D2FfnPvsqK43mtLL5Y8L90VT+JKk26YF64TNvw51KAxN
8fHLpSui0BSe/9rFuFg01bcyv+BxCE3x9Z24PbU2GS2Zr/IbTjPQFN6Sf2Hu
Epra0z5tacTsbDTF5/ZgbqHhPTTFJ/6cUpGwA/jPrZSjKb4I/sD3N2jJeus0
06aAejTFd2zlkHF234V9PqZfdJ82NMW3gD+PQCoCTOHF3zuUQ1N+V/MLpkpo
io9fTr6oKmzxeQc9hS13+kvKVg00XW/8adWf+6Epv+LzsHXQ9D6e+DyFwWh6
33Ug/706A7RkP2DYE484YzSlZ6r6OPyXKZrKIz6vwULYDP+9orFoqm/uafzr
qPFoSk983vcENMVXwZ8H4YCm+Obx33Odhqb4xJ+Lc0ZTfCv5z4m5oSl8M3/e
xBxhiz9HNF/YMhPjeocvEvYu/jzzJcLmXwdw8UVTfvntAjdXoym8btTGzEHr
hJ3eO6hkd7Cw+a/dtoQKW/w9qghhj3/gY/MgUtji89p3oqk8/HELiTHCLuc3
TO4X9lwl5yd+8WhKry5xiqj8MFqyXsif95GMpvBN2ePZ9BPC3jBt7JLuGcIW
n0d/Vtji80QuCrsb/z3Kq2i6HuJjBv+6chNN4bX5f3eELT6vJE/Yw/nvjd0X
Nv+6p0eRsMXn7Zeiqb7F56GUoyk8P5088FzYT3u06Xa+FrZnapPdsrfCfsuf
t/IeTflZfu/D3rGf0BS+cWbdldRvwg7hvyfQLGzxeS6two6Wfzq4ul3YavyC
tNQWQR/Uf7Dqopyw+a9VaSoJW/w9OVVhG/MvFPQQ9mX+ewkawrbiX5juJ2zx
94x1hD2l33H/uMHCLjt95OCvocIWn3djLOzaoriaIlNh89uBLCyELf4exFhh
i8/TGS9s8fdmJwibP879hb2w+eNeJ0wTtvi8Hmdh88fF9HYTdmqtl3H4HGGL
v3cxT9ji84AWCVv8PfUlws4dNDV3kK+wJ1+e9H73amGX8ucNBQhb/Dm/YGGL
P/cVKuyl/Pc8IoT9lT/PKFLYgfyG1J3C7kjTbvCLETb/OnfFPmHz273Hxwtb
/D3Iw8Luxz0udk8Wtvh7JSeEbcCfx5Qu7IuH2z5NOyvslrqgTRHnhf1/q7yk
ww==
                 "]]}, {
                RGBColor[1, 0, 0], 
                AbsoluteThickness[1], 
                Dashing[{}], 
                CapForm[None], 
                JoinForm[{"Miter", 3.25}], 
                LineBox[CompressedData["
1:eJx13XlUD9//B/B2lcpSIlIhSaKFQslMqCylJGlBJFtZkiJKQmUt8VEKKSFl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                 "]]}}, Frame -> False, ImageSize -> {93.17647058823529, 72.},
               PlotRange -> {{0., 93.17647058823529}, {0., 72.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, 
           InsetBox[
            FrameBox[
             StyleBox[
              StyleBox[
               TagBox[
               "\"\[ScriptCapitalS]\[ScriptC]\[ScriptI]\[ScriptCapitalD]\
\[ScriptR]\[ScriptA]\[ScriptW]\"", DisplayForm], StripOnInput -> False, 
               ShowAutoStyles -> False, SingleLetterItalics -> False, 
               FontFamily -> "Times", FontSize -> 14.5, FontWeight -> Bold, 
               FontSlant -> Plain, FontTracking -> "Extended"], StripOnInput -> 
              False, ShowContents -> False], Background -> None, 
             ContentPadding -> False, FrameMargins -> {{0, 0}, {0, 0}}, 
             FrameStyle -> None, RoundingRadius -> {0, 0}, StripOnInput -> 
             False], {4.658823529411765, 64.8}, {-1, 1}, Automatic, {1, 0}], 
           InsetBox[
            FrameBox[
             StyleBox[
              TagBox[
              "\"\[ScriptCapitalS]\[ScriptC]\[ScriptI]\[ScriptCapitalD]\
\[ScriptR]\[ScriptA]\[ScriptW]\"", DisplayForm], StripOnInput -> False, 
              ShowAutoStyles -> False, SingleLetterItalics -> False, 
              FontFamily -> "Times", FontSize -> 14.5, FontWeight -> Bold, 
              FontSlant -> Plain, FontTracking -> "Extended"], Background -> 
             None, ContentPadding -> False, FrameMargins -> {{0, 0}, {0, 0}}, 
             FrameStyle -> None, RoundingRadius -> {0, 0}, StripOnInput -> 
             False], {4.658823529411765, 64.8}, {-1, 1}, Automatic, {1, 0}]}, 
          Frame -> False, ImageSize -> {93.1764705882353, 72.}, 
          PlotRange -> {{0., 93.1764705882353}, {0., 72.}}], {0, 0}, {0, 
         0}]}, {
        FaceForm[None], 
        RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
        InsetBox[
         GraphicsBox[{}, Frame -> False, ImageSize -> {95.1764705882353, 74.},
           PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0, 
         0}]}, {
        FaceForm[None], 
        RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
        InsetBox[
         GraphicsBox[{{
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{0., 0.}, {0., 72.}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{}, {}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{93.1764705882353, 0.}, {93.1764705882353, 72.}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{}, {}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{0., 0.}, {93.1764705882353, 0.}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{}, {}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{0., 72.}, {93.1764705882353, 72.}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{}, {}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}]}}, Frame -> False, 
          ImageSize -> {95.1764705882353, 74.}, 
          PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0, 
         0}]}}, {}}, AspectRatio -> 0.7775030902348578, Background -> None, 
     DisplayFunction -> Identity, Frame -> False, 
     ImageSize -> {95.1764705882353, 74.}, 
     PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}]},
   "RowDefault"],
  Background->GrayLevel[0.85],
  FrameMargins->10,
  FrameStyle->None,
  StripOnInput->False]], "Print",
 CellChangeTimes->{3.5210621598125*^9, 3.52474831359375*^9, 
  3.5663331813812294`*^9, 3.5663395453522186`*^9, 3.579122011724132*^9, 
  3.5837817961953487`*^9, 3.594305965095412*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Schemes with transitions", "Section",
 CellChangeTimes->{{3.5837823015860567`*^9, 3.583782334596103*^9}, {
  3.6221582482517357`*^9, 3.6221582512469406`*^9}}],

Cell[CellGroupData[{

Cell["Two-panel level scheme", "Subsection",
 CellChangeTimes->{3.583782337781108*^9}],

Cell["\<\
Adapted from M. A. Caprio, Ph.D. thesis, Yale University (2003), \
arXiv:nucl-ex/0502004.\
\>", "Text",
 FontSize->8],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Figure", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"FigurePanel", "[", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "set", " ", "default", " ", "styles", " ", "for", " ", "level", " ", 
         "scheme", " ", "objects"}], " ", "*)"}], "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"SetOptions", "[", 
         RowBox[{"FigObject", ",", 
          RowBox[{"FontSize", "\[Rule]", "20"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SetOptions", "[", 
         RowBox[{"Lev", ",", 
          RowBox[{"RightLabel", "\[Rule]", "Automatic"}], ",", 
          RowBox[{"LeftTextOffset", "\[Rule]", "BottomLeft"}], ",", 
          RowBox[{"RightTextOffset", "\[Rule]", "BottomRight"}]}], "]"}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"SetOptions", "[", 
         RowBox[{"Trans", ",", 
          RowBox[{"ArrowType", "\[Rule]", "\"\<Block\>\""}], ",", 
          RowBox[{"HeadLength", "\[Rule]", "9"}], ",", 
          RowBox[{"HeadLip", "\[Rule]", "10"}], ",", 
          RowBox[{"Width", "\[Rule]", "30"}], ",", "\[IndentingNewLine]", 
          RowBox[{"CenterTextOrientation", "\[Rule]", "Horizontal"}], ",", 
          RowBox[{"CenterTextBackground", "\[Rule]", "Automatic"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"DefineStyle", "[", 
         RowBox[{"\"\<timing\>\"", ",", 
          RowBox[{"{", 
           RowBox[{"Trans", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"FillColor", "\[Rule]", "Gray"}], ",", 
              RowBox[{"CenterLabel", "\[Rule]", "\"\<TIMING\>\""}], ",", 
              RowBox[{"CenterTextColor", "\[Rule]", "Firebrick"}]}], "}"}]}], 
           "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"DefineStyle", "[", 
         RowBox[{"\"\<gate\>\"", ",", 
          RowBox[{"{", 
           RowBox[{"Trans", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"FillColor", "\[Rule]", "White"}], ",", 
              RowBox[{"CenterLabel", "\[Rule]", "\"\<GATE\>\""}], ",", 
              RowBox[{"CenterTextColor", "\[Rule]", "DarkGreen"}]}], "}"}]}], 
           "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"DefineStyle", "[", 
         RowBox[{"\"\<lifetime\>\"", ",", 
          RowBox[{"{", 
           RowBox[{"FigLabel", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Displacement", "->", 
               RowBox[{"Canvas", "[", 
                RowBox[{"{", 
                 RowBox[{"10", ",", "0"}], "}"}], "]"}]}], ",", 
              RowBox[{"TextColor", "\[Rule]", "Firebrick"}]}], "}"}]}], 
           "}"}]}], "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"draw", " ", "cascade", " ", "from", " ", "4"}], "+", " ", 
          "level"}], " ", "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
         RowBox[{"0", ",", "\[IndentingNewLine]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"FigLabel", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", ".4"}], ",", "850"}], "}"}], ",", "\"\<(a)\>\"",
                ",", 
               RowBox[{"TextOffset", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "1"}], ",", "1"}], "}"}]}]}], "]"}], ";"}], 
            "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{
             "Lev", "\[LeftDoubleBracket]", "\"\<lev0a\>\"", 
              "\[RightDoubleBracket]"}], "[", 
             RowBox[{"0", ",", "2", ",", "\"\<0\>\"", ",", 
              RowBox[{"LeftLabel", "\[Rule]", 
               RowBox[{"LabelJP", "[", "0", "]"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
             "Lev", "\[LeftDoubleBracket]", "\"\<lev335a\>\"", 
              "\[RightDoubleBracket]"}], "[", 
             RowBox[{"0", ",", "2", ",", "\"\<335\>\"", ",", 
              RowBox[{"LeftLabel", "\[Rule]", 
               RowBox[{"LabelJP", "[", "2", "]"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"FigLabel", "[", 
             RowBox[{
             "\"\<lev335a\>\"", ",", "Right", ",", "\"\<27 ps\>\"", ",", 
              RowBox[{"Style", "\[Rule]", "\"\<lifetime\>\""}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
             "Lev", "\[LeftDoubleBracket]", "\"\<lev661a\>\"", 
              "\[RightDoubleBracket]"}], "[", 
             RowBox[{"0", ",", "2", ",", "\"\<661\>\"", ",", 
              RowBox[{"LeftLabel", "\[Rule]", 
               RowBox[{"LabelJP", "[", "0", "]"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
             "Lev", "\[LeftDoubleBracket]", "\"\<lev747a\>\"", 
              "\[RightDoubleBracket]"}], "[", 
             RowBox[{"0", ",", "2", ",", "\"\<747\>\"", ",", 
              RowBox[{"LeftLabel", "\[Rule]", 
               RowBox[{"LabelJP", "[", "4", "]"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"FigLabel", "[", 
             RowBox[{
             "\"\<lev747a\>\"", ",", "Right", ",", "\"\<  6 ps\>\"", ",", 
              RowBox[{"Style", "\[Rule]", "\"\<lifetime\>\""}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"Trans", "[", 
             RowBox[{
             "\"\<lev335a\>\"", ",", "1.3", ",", "\"\<lev0a\>\"", ",", 
              "Automatic", ",", 
              RowBox[{"Style", "\[Rule]", "\"\<timing\>\""}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"Trans", "[", 
             RowBox[{
             "\"\<lev747a\>\"", ",", ".7", ",", "\"\<lev335a\>\"", ",", 
              "Automatic", ",", 
              RowBox[{"Style", "\[Rule]", "\"\<gate\>\""}]}], "]"}], ";"}], 
           "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"draw", " ", "cascade", " ", "from", " ", "0"}], "+", " ", 
          "level"}], " ", "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
         RowBox[{"3.5", ",", "\[IndentingNewLine]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"FigLabel", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", ".4"}], ",", "850"}], "}"}], ",", "\"\<(b)\>\"",
                ",", 
               RowBox[{"TextOffset", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "1"}], ",", "1"}], "}"}]}]}], "]"}], ";"}], 
            "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{
             "Lev", "\[LeftDoubleBracket]", "\"\<lev0b\>\"", 
              "\[RightDoubleBracket]"}], "[", 
             RowBox[{"0", ",", "2", ",", "\"\<0\>\"", ",", 
              RowBox[{"LeftLabel", "\[Rule]", 
               RowBox[{"LabelJP", "[", "0", "]"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
             "Lev", "\[LeftDoubleBracket]", "\"\<lev335b\>\"", 
              "\[RightDoubleBracket]"}], "[", 
             RowBox[{"0", ",", "2", ",", "\"\<335\>\"", ",", 
              RowBox[{"LeftLabel", "\[Rule]", 
               RowBox[{"LabelJP", "[", "2", "]"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"FigLabel", "[", 
             RowBox[{
             "\"\<lev335b\>\"", ",", "Right", ",", "\"\<27 ps\>\"", ",", 
              RowBox[{"Style", "\[Rule]", "\"\<lifetime\>\""}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
             "Lev", "\[LeftDoubleBracket]", "\"\<lev661b\>\"", 
              "\[RightDoubleBracket]"}], "[", 
             RowBox[{"0", ",", "2", ",", "\"\<661\>\"", ",", 
              RowBox[{"LeftLabel", "\[Rule]", 
               RowBox[{"LabelJP", "[", "0", "]"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"FigLabel", "[", 
             RowBox[{"\"\<lev661b\>\"", ",", "Right", ",", 
              RowBox[{"Row", "[", 
               RowBox[{"{", 
                RowBox[{"\"\<\[Tau](\>\"", ",", 
                 RowBox[{"hspace", "[", 
                  RowBox[{"-", "0.2"}], "]"}], ",", 
                 RowBox[{"LabelJiP", "[", 
                  RowBox[{"0", ",", "2"}], "]"}], ",", "\"\<)\>\""}], "}"}], 
               "]"}], ",", 
              RowBox[{"Style", "\[Rule]", "\"\<lifetime\>\""}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
             "Lev", "\[LeftDoubleBracket]", "\"\<lev747b\>\"", 
              "\[RightDoubleBracket]"}], "[", 
             RowBox[{"0", ",", "2", ",", "\"\<747\>\"", ",", 
              RowBox[{"LeftLabel", "\[Rule]", 
               RowBox[{"LabelJP", "[", "4", "]"}]}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"Trans", "[", 
             RowBox[{
             "\"\<lev335b\>\"", ",", "1.3", ",", "\"\<lev0b\>\"", ",", 
              "Automatic", ",", 
              RowBox[{"Style", "\[Rule]", "\"\<timing\>\""}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"Trans", "[", 
             RowBox[{
             "\"\<lev661b\>\"", ",", ".9", ",", "\"\<lev335b\>\"", ",", 
              "Automatic", ",", 
              RowBox[{"Style", "\[Rule]", "\"\<gate\>\""}]}], "]"}], ";"}], 
           "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}], 
        ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", ".8"}], ",", "6.3"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "100"}], ",", "900"}], "}"}]}], "}"}]}], ",", 
      RowBox[{"Frame", "\[Rule]", "False"}]}], "\[IndentingNewLine]", "]"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{"CanvasSize", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"8", ",", "4"}], "}"}]}]}], "\[IndentingNewLine]", "]"}], 
  "\[IndentingNewLine]"}]], "Input",
 CellChangeTimes->{
  3.395093707578125*^9, {3.395093919203125*^9, 3.39509391990625*^9}, {
   3.39509411065625*^9, 3.395094113046875*^9}, {3.395094284578125*^9, 
   3.395094292078125*^9}, 3.395095437171875*^9, {3.3955211378125*^9, 
   3.395521138484375*^9}, {3.471089714921875*^9, 3.471089716375*^9}, {
   3.519835807359375*^9, 3.5198358344375*^9}, {3.520031140390625*^9, 
   3.520031331640625*^9}, {3.520031371109375*^9, 3.520031471328125*^9}, {
   3.520031515671875*^9, 3.520031577453125*^9}, {3.520031753578125*^9, 
   3.520031802421875*^9}, {3.520031853390625*^9, 3.520031857625*^9}, {
   3.520032675984375*^9, 3.5200329290625*^9}, {3.520032970921875*^9, 
   3.52003303753125*^9}, {3.5200345799375*^9, 3.52003459953125*^9}, {
   3.566333132185543*^9, 3.5663331719968133`*^9}, {3.566333288241417*^9, 
   3.5663333625755477`*^9}, {3.566333394555604*^9, 3.5663334207168493`*^9}, {
   3.56633346060612*^9, 3.5663335057369995`*^9}, {3.5666826463583746`*^9, 
   3.566682679009232*^9}, {3.584044295682214*^9, 3.5840443189938216`*^9}, {
   3.5840453556171036`*^9, 3.5840453833695526`*^9}, 3.5840541797099237`*^9}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72}, {648, 360}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{720, 432},
       PlotRange->{{-72, 648}, {-72, 360}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {576., 288.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{73.01408450704227, 28.799999999999997`}, {
          219.04225352112678`, 28.799999999999997`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{73.01408450704227, 125.27999999999999`}, {
          219.04225352112678`, 125.27999999999999`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{73.01408450704227, 219.168}, {219.04225352112678`, 
          219.168}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{73.01408450704227, 243.93599999999998`}, {
          219.04225352112678`, 243.93599999999998`}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0.5]], 
         PolygonBox[{{185.36619718309862`, 125.27999999999999`}, {
          155.36619718309862`, 125.27999999999999`}, {155.36619718309862`, 
          37.8}, {145.36619718309862`, 37.8}, {170.36619718309862`, 
          28.799999999999997`}, {195.36619718309862`, 37.8}, {
          185.36619718309862`, 37.8}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
         PolygonBox[{{136.69014084507043`, 243.93599999999998`}, {
          106.69014084507043`, 243.93599999999998`}, {106.69014084507043`, 
          134.27999999999997`}, {96.69014084507043, 134.27999999999997`}, {
          121.69014084507043`, 125.27999999999999`}, {146.69014084507043`, 
          134.27999999999997`}, {136.69014084507043`, 134.27999999999997`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{356.95774647887333`, 28.799999999999997`}, {
          502.9859154929578, 28.799999999999997`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{356.95774647887333`, 125.27999999999999`}, {
          502.9859154929578, 125.27999999999999`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{356.95774647887333`, 219.168}, {502.9859154929578, 
          219.168}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{356.95774647887333`, 243.93599999999998`}, {
          502.9859154929578, 243.93599999999998`}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0.5]], 
         PolygonBox[{{469.30985915492965`, 125.27999999999999`}, {
          439.30985915492965`, 125.27999999999999`}, {439.30985915492965`, 
          37.8}, {429.30985915492965`, 37.8}, {454.30985915492965`, 
          28.799999999999997`}, {479.30985915492965`, 37.8}, {
          469.30985915492965`, 37.8}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
         PolygonBox[{{436.8591549295775, 219.168}, {406.8591549295775, 
          219.168}, {406.8591549295775, 134.27999999999997`}, {
          396.8591549295775, 134.27999999999997`}, {421.8591549295775, 
          125.27999999999999`}, {446.8591549295775, 134.27999999999997`}, {
          436.8591549295775, 134.27999999999997`}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SuperscriptBox["0", "+"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {73.01408450704227, 28.799999999999997`}, {-1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {219.04225352112678`, 28.799999999999997`}, {1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SuperscriptBox["2", "+"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {73.01408450704227, 125.27999999999999`}, {-1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"335\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {219.04225352112678`, 125.27999999999999`}, {1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"27 ps\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[0.698004, 0.133305, 0.133305],
            FrontFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
            BackFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
            GraphicsColor->RGBColor[0.698004, 0.133305, 0.133305],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[0.698004, 0.133305, 0.133305]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {229.04225352112678`, 125.27999999999999`}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SuperscriptBox["0", "+"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {73.01408450704227, 219.168}, {-1, -1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"661\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {219.04225352112678`, 219.168}, {1, -1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SuperscriptBox["4", "+"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {73.01408450704227, 243.93599999999998`}, {-1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"747\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {219.04225352112678`, 243.93599999999998`}, {1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"  6 ps\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[0.698004, 0.133305, 0.133305],
            FrontFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
            BackFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
            GraphicsColor->RGBColor[0.698004, 0.133305, 0.133305],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[0.698004, 0.133305, 0.133305]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {229.04225352112678`, 243.93599999999998`}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"TIMING\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[0.698004, 0.133305, 0.133305],
            FrontFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
            BackFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
            GraphicsColor->RGBColor[0.698004, 0.133305, 0.133305],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[0.698004, 0.133305, 0.133305]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {170.36619718309862`, 77.03999999999999}, {0, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"GATE\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[0., 0.392193, 0.],
            FrontFaceColor->RGBColor[0., 0.392193, 0.],
            BackFaceColor->RGBColor[0., 0.392193, 0.],
            GraphicsColor->RGBColor[0., 0.392193, 0.],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[0., 0.392193, 0.]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {121.69014084507043`, 184.60799999999998`}, {0, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SuperscriptBox["0", "+"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {356.95774647887333`, 28.799999999999997`}, {-1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {502.9859154929578, 28.799999999999997`}, {1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SuperscriptBox["2", "+"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {356.95774647887333`, 125.27999999999999`}, {-1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"335\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {502.9859154929578, 125.27999999999999`}, {1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"27 ps\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[0.698004, 0.133305, 0.133305],
            FrontFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
            BackFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
            GraphicsColor->RGBColor[0.698004, 0.133305, 0.133305],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[0.698004, 0.133305, 0.133305]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {512.9859154929578, 125.27999999999999`}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SuperscriptBox["0", "+"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {356.95774647887333`, 219.168}, {-1, -1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"661\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {502.9859154929578, 219.168}, {1, -1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             
             TemplateBox[{
              "\"\[Tau](\"",AdjustmentBox[
               "", BoxMargins -> {{0, -0.2}, {0, 0}}],SubsuperscriptBox[
               "0", "2", "+"],"\")\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[0.698004, 0.133305, 0.133305],
            FrontFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
            BackFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
            GraphicsColor->RGBColor[0.698004, 0.133305, 0.133305],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[0.698004, 0.133305, 0.133305]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {512.9859154929578, 219.168}, {-1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SuperscriptBox["4", "+"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {356.95774647887333`, 243.93599999999998`}, {-1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"747\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {502.9859154929578, 243.93599999999998`}, {1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"TIMING\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[0.698004, 0.133305, 0.133305],
            FrontFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
            BackFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
            GraphicsColor->RGBColor[0.698004, 0.133305, 0.133305],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[0.698004, 0.133305, 0.133305]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {454.30985915492965`, 77.03999999999999}, {0, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"GATE\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[0., 0.392193, 0.],
            FrontFaceColor->RGBColor[0., 0.392193, 0.],
            BackFaceColor->RGBColor[0., 0.392193, 0.],
            GraphicsColor->RGBColor[0., 0.392193, 0.],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[0., 0.392193, 0.]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {421.8591549295775, 172.224}, {0, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SuperscriptBox["0", "+"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {73.01408450704227, 28.799999999999997`}, {-1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {219.04225352112678`, 28.799999999999997`}, {1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SuperscriptBox["2", "+"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {73.01408450704227, 125.27999999999999`}, {-1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"335\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {219.04225352112678`, 125.27999999999999`}, {1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"27 ps\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[0.698004, 0.133305, 0.133305],
           FrontFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
           BackFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
           GraphicsColor->RGBColor[0.698004, 0.133305, 0.133305],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[0.698004, 0.133305, 0.133305]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {229.04225352112678`, 125.27999999999999`}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SuperscriptBox["0", "+"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {73.01408450704227, 219.168}, {-1, -1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"661\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {219.04225352112678`, 219.168}, {1, -1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SuperscriptBox["4", "+"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {73.01408450704227, 243.93599999999998`}, {-1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"747\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {219.04225352112678`, 243.93599999999998`}, {1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"  6 ps\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[0.698004, 0.133305, 0.133305],
           FrontFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
           BackFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
           GraphicsColor->RGBColor[0.698004, 0.133305, 0.133305],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[0.698004, 0.133305, 0.133305]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {229.04225352112678`, 243.93599999999998`}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"TIMING\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[0.698004, 0.133305, 0.133305],
           FrontFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
           BackFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
           GraphicsColor->RGBColor[0.698004, 0.133305, 0.133305],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[0.698004, 0.133305, 0.133305]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {170.36619718309862`, 77.03999999999999}, {0, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"GATE\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[0., 0.392193, 0.],
           FrontFaceColor->RGBColor[0., 0.392193, 0.],
           BackFaceColor->RGBColor[0., 0.392193, 0.],
           GraphicsColor->RGBColor[0., 0.392193, 0.],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[0., 0.392193, 0.]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {121.69014084507043`, 184.60799999999998`}, {0, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SuperscriptBox["0", "+"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {356.95774647887333`, 28.799999999999997`}, {-1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {502.9859154929578, 28.799999999999997`}, {1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SuperscriptBox["2", "+"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {356.95774647887333`, 125.27999999999999`}, {-1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"335\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {502.9859154929578, 125.27999999999999`}, {1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"27 ps\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[0.698004, 0.133305, 0.133305],
           FrontFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
           BackFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
           GraphicsColor->RGBColor[0.698004, 0.133305, 0.133305],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[0.698004, 0.133305, 0.133305]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {512.9859154929578, 125.27999999999999`}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SuperscriptBox["0", "+"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {356.95774647887333`, 219.168}, {-1, -1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"661\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {502.9859154929578, 219.168}, {1, -1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            
            TemplateBox[{
             "\"\[Tau](\"",AdjustmentBox[
              "", BoxMargins -> {{0, -0.2}, {0, 0}}],SubsuperscriptBox[
              "0", "2", "+"],"\")\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[0.698004, 0.133305, 0.133305],
           FrontFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
           BackFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
           GraphicsColor->RGBColor[0.698004, 0.133305, 0.133305],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[0.698004, 0.133305, 0.133305]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {512.9859154929578, 219.168}, {-1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SuperscriptBox["4", "+"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {356.95774647887333`, 243.93599999999998`}, {-1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"747\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {502.9859154929578, 243.93599999999998`}, {1, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"TIMING\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[0.698004, 0.133305, 0.133305],
           FrontFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
           BackFaceColor->RGBColor[0.698004, 0.133305, 0.133305],
           GraphicsColor->RGBColor[0.698004, 0.133305, 0.133305],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[0.698004, 0.133305, 0.133305]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {454.30985915492965`, 77.03999999999999}, {0, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"GATE\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[0., 0.392193, 0.],
           FrontFaceColor->RGBColor[0., 0.392193, 0.],
           BackFaceColor->RGBColor[0., 0.392193, 0.],
           GraphicsColor->RGBColor[0., 0.392193, 0.],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[0., 0.392193, 0.]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {421.8591549295775, 172.224}, {0, 0}, 
         Automatic, {1, 0}]},
       Frame->False,
       ImageSize->{576., 288.},
       PlotRange->{{0., 576.}, {0., 288.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {648, 360}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{720, 432},
       PlotRange->{{-72, 648}, {-72, 360}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {648, 360}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{720, 432},
       PlotRange->{{-72, 648}, {-72, 360}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->NCache[
    Rational[3, 5], 0.6],
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{720, 432},
  PlotRange->{{-72, 648}, {-72, 360}}]], "Output",
 CellChangeTimes->{
  3.583782324246089*^9, 3.5840443254239206`*^9, {3.584045363323517*^9, 
   3.584045384913955*^9}, 3.584054181987528*^9, 3.5943059949054537`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Level scheme combining various styles of transition arrow", "Subsection"],

Cell["\<\
Adapted from M. A. Caprio, Ph.D. thesis, Yale University (2003), \
arXiv:nucl-ex/0502004.\
\>", "Text",
 FontSize->8],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"Figure", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"SetOptions", "[", 
         RowBox[{"FigObject", ",", 
          RowBox[{"FontSize", "\[Rule]", "14"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SetOptions", "[", 
         RowBox[{"Lev", ",", 
          RowBox[{"LeftTextOffset", "\[Rule]", "BottomLeft"}], ",", 
          RowBox[{"RightTextOffset", "\[Rule]", "BottomRight"}]}], "]"}], ";",
         "\[IndentingNewLine]", 
        RowBox[{"SetOptions", "[", 
         RowBox[{"Trans", ",", 
          RowBox[{"HeadLength", "\[Rule]", "9"}], ",", " ", 
          RowBox[{"HeadLip", "\[Rule]", "3"}], ",", 
          RowBox[{"ArrowType", "\[Rule]", "Block"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "Lev", "\[LeftDoubleBracket]", "\"\<lev100\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"0", ",", "1", ",", "0", ",", 
          RowBox[{"LeftLabel", "\[Rule]", 
           RowBox[{"LabelJP", "[", "0", "]"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "Lev", "\[LeftDoubleBracket]", "\"\<lev112\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"0", ",", "1", ",", "556", ",", 
          RowBox[{"LeftLabel", "\[Rule]", 
           RowBox[{"LabelJP", "[", "2", "]"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "Lev", "\[LeftDoubleBracket]", "\"\<lev124\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"0", ",", "1", ",", "1276", ",", 
          RowBox[{"LeftLabel", "\[Rule]", 
           RowBox[{"LabelJP", "[", "4", "]"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "Lev", "\[LeftDoubleBracket]", "\"\<lev122\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"1", ",", "2", ",", "1534", ",", 
          RowBox[{"LeftLabel", "\[Rule]", 
           RowBox[{"LabelJP", "[", "2", "]"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "Lev", "\[LeftDoubleBracket]", "\"\<lev136\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"0", ",", "1", ",", "2110.9", ",", 
          RowBox[{"LeftLabel", "\[Rule]", 
           RowBox[{"LabelJP", "[", "6", "]"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "Lev", "\[LeftDoubleBracket]", "\"\<lev134\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"1", ",", "2", ",", "2138", ",", 
          RowBox[{"LeftLabel", "\[Rule]", 
           RowBox[{"LabelJP", "[", "4", "]"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "Lev", "\[LeftDoubleBracket]", "\"\<lev133\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"2", ",", "3", ",", "2111.5", ",", 
          RowBox[{"LeftLabel", "\[Rule]", 
           RowBox[{"LabelJP", "[", "3", "]"}]}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
         RowBox[{"3.25", ",", "\[IndentingNewLine]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{
             "Lev", "\[LeftDoubleBracket]", "\"\<lev01\>\"", 
              "\[RightDoubleBracket]"}], "[", 
             RowBox[{"0", ",", "1", ",", "1593", ",", 
              RowBox[{"LeftLabel", "\[Rule]", 
               RowBox[{"LabelJP", "[", "0", "]"}]}], ",", 
              RowBox[{"RightLabel", "\[Rule]", "Automatic"}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"ExtensionLine", "[", 
             RowBox[{"\"\<lev100\>\"", ",", "Right", ",", "2"}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"Trans", "[", 
             RowBox[{
             "\"\<lev01\>\"", ",", ".6", ",", "\"\<lev100\>\"", ",", "2.4", 
              ",", 
              RowBox[{"Width", "\[Rule]", "20"}], ",", 
              RowBox[{"FillColor", "\[Rule]", "White"}], ",", 
              RowBox[{"CenterLabel", "\[Rule]", 
               RowBox[{"Row", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Superscript", "[", 
                   RowBox[{"\"\<\[Rho]\>\"", ",", "2"}], "]"}], ",", 
                  "\"\<(\>\"", ",", 
                  RowBox[{"textit", "[", "\"\<E\>\"", "]"}], ",", 
                  "\"\<0)=4.0(15)\[Cross]\>\"", ",", 
                  RowBox[{"Superscript", "[", 
                   RowBox[{"10", ",", 
                    RowBox[{"-", "3"}]}], "]"}]}], "}"}], "]"}]}], ",", 
              RowBox[{"CenterLabelPosition", "\[Rule]", "0.6"}]}], "]"}], ";",
             "\[IndentingNewLine]", 
            RowBox[{"Trans", "[", 
             RowBox[{
             "\"\<lev01\>\"", ",", ".4", ",", "\"\<lev112\>\"", ",", ".5", 
              ",", 
              RowBox[{"ArrowType", "\[Rule]", "Line"}], ",", 
              RowBox[{"LineDashing", "\[Rule]", "2"}], ",", 
              RowBox[{"RightLabel", "->", "\"\<<0.0004 W.u.\>\""}]}], "]"}], 
            ";", "\[IndentingNewLine]", 
            RowBox[{"Trans", "[", 
             RowBox[{
             "\"\<lev01\>\"", ",", ".05", ",", "\"\<lev122\>\"", ",", ".95", 
              ",", 
              RowBox[{"TailFlush", "\[Rule]", "False"}], ",", 
              RowBox[{"Width", "\[Rule]", "20"}], ",", 
              RowBox[{"FillColor", "\[Rule]", "Gray"}], ",", 
              RowBox[{"LeftLabel", "->", "\"\<96(40) W.u.\>\""}]}], "]"}], 
            ";"}], "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
         RowBox[{"4.5", ",", "\[IndentingNewLine]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{
             "Lev", "\[LeftDoubleBracket]", "\"\<lev02\>\"", 
              "\[RightDoubleBracket]"}], "[", 
             RowBox[{"0", ",", "1", ",", "1658", ",", 
              RowBox[{"LeftLabel", "\[Rule]", 
               RowBox[{"LabelJP", "[", "0", "]"}]}], ",", 
              RowBox[{"RightLabel", "\[Rule]", "Automatic"}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"Trans", "[", 
             RowBox[{
             "\"\<lev02\>\"", ",", "0.5", ",", "\"\<lev112\>\"", ",", "0.8", 
              ",", 
              RowBox[{"Width", "\[Rule]", "3"}], ",", 
              RowBox[{"FillColor", "\[Rule]", "Gray"}], ",", 
              RowBox[{"LeftLabel", "->", "\"\<13(3) W.u.\>\""}], ",", 
              RowBox[{"LeftLabelPosition", "\[Rule]", "0.2"}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"Trans", "[", 
             RowBox[{
             "\"\<lev02\>\"", ",", "0.6", ",", "\"\<lev100\>\"", ",", "2.75", 
              ",", 
              RowBox[{"ArrowType", "\[Rule]", "Line"}], ",", 
              RowBox[{"LineDashing", "\[Rule]", "2"}], ",", 
              RowBox[{"LeftLabel", "->", 
               RowBox[{"Row", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"Superscript", "[", 
                   RowBox[{"\"\<\[Rho]\>\"", ",", "2"}], "]"}], ",", 
                  "\"\<(\>\"", ",", 
                  RowBox[{"textit", "[", "\"\<E\>\"", "]"}], ",", 
                  "\"\<0)<0.3\[Cross]\>\"", ",", 
                  RowBox[{"Superscript", "[", 
                   RowBox[{"10", ",", 
                    RowBox[{"-", "3"}]}], "]"}]}], "}"}], "]"}]}], ",", 
              RowBox[{"RightTextBuffer", "\[Rule]", "1.5"}]}], "]"}], ";"}], 
           "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}], 
        ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"PlotRange", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "0.5"}], ",", "7"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "100"}], ",", "2300"}], "}"}]}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Frame", "\[Rule]", "False"}]}], "\[IndentingNewLine]", "]"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{"CanvasSize", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"7.5", ",", "4.5"}], "}"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.395095465359375*^9, 3.395095465890625*^9}, {
  3.395520788125*^9, 3.3955208513125*^9}, {3.39552113928125*^9, 
  3.395521139921875*^9}, {3.519835710296875*^9, 3.51983588359375*^9}, {
  3.519835921765625*^9, 3.519836008109375*^9}, {3.519836075703125*^9, 
  3.519836237890625*^9}, {3.5200331673125*^9, 3.5200331716875*^9}, {
  3.520033214234375*^9, 3.520033258421875*^9}, {3.5663333655395527`*^9, 
  3.566333369127559*^9}, {3.5663334216996517`*^9, 3.566333456066512*^9}, {
  3.566333521883027*^9, 3.566333652096456*^9}, {3.5666827322521257`*^9, 
  3.566682757212169*^9}}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72., -72.}, {612., 396.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{684., 468.},
       PlotRange->{{-72., 612.}, {-72., 396.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {540., 324.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{43.2, 13.5}, {100.8, 13.5}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{43.2, 88.56}, {100.8, 88.56}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{43.2, 185.76000000000002`}, {100.8, 
          185.76000000000002`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{115.2, 220.59}, {172.79999999999998`, 220.59}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{43.2, 298.47150000000005`}, {100.8, 
          298.47150000000005`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{115.2, 302.13}, {172.79999999999998`, 302.13}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{187.20000000000002`, 298.5525}, {244.79999999999998`, 
          298.5525}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{277.2, 228.555}, {334.8, 228.555}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{100.8, 13.5}, {244.79999999999998`, 13.5}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[1]], 
         PolygonBox[{{324.31606360814, 228.555}, {302.08393639186, 228.555}, {
          203.73446122574612`, 25.96355956083697}, {201.03566414635267`, 
          27.27371005763396}, {208.79999999999998`, 13.5}, {
          224.42523883442922`, 15.919072418726735`}, {221.72644175503578`, 
          17.229222915523724`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{298.8, 228.555}, {72., 88.56}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{81.23426731571841, 90.73446709376223}, {72., 88.56}, {
           78.0827335963174, 95.84013406444083}}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0.5]], 
         PolygonBox[{{274.416706982614, 218.58840631386283`}, {
          272.78329301738603`, 238.52159368613718`}, {184.55322733490942`, 
          231.2916299704898}, {184.3082152401252, 234.28160807633094`}, {
          176.39999999999998`, 220.59}, {186.43165339492165`, 
          208.3684644923743}, {186.18664130013747`, 211.35844259821545`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{367.2, 237.33}, {424.8, 237.33}}]}, 
        {EdgeForm[{GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[
         None], JoinForm[{"Miter", 3.25}]}], FaceForm[GrayLevel[0.5]], 
         PolygonBox[{{399.3980011870442, 237.33}, {392.6019988129558, 
          237.33}, {101.01348073390488`, 93.87886298075264}, {
          99.68917277981781, 96.57074121773546}, {93.6, 88.56}, {
          103.66209664207905`, 88.49510650678702}, {102.33778868799197`, 
          91.18698474376984}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{403.2, 237.33}, {234., 13.5}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{241.82038278209654`, 18.870438822059896`}, {234., 
           13.5}, {237.03404293244128`, 22.488580726905838`}}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SuperscriptBox["0", "+"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->14,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {43.2, 13.5}, {-1, -1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SuperscriptBox["2", "+"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->14,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {43.2, 88.56}, {-1, -1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SuperscriptBox["4", "+"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->14,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {43.2, 185.76000000000002`}, {-1, -1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SuperscriptBox["2", "+"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->14,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {115.2, 220.59}, {-1, -1}, Automatic, {1, 0}],
         InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SuperscriptBox["6", "+"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->14,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {43.2, 298.47150000000005`}, {-1, -1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SuperscriptBox["4", "+"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->14,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {115.2, 302.13}, {-1, -1}, Automatic, {1, 0}],
         InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SuperscriptBox["3", "+"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->14,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {187.20000000000002`, 298.5525}, {-1, -1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SuperscriptBox["0", "+"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->14,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {277.2, 228.555}, {-1, -1}, Automatic, {1, 
         0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["1593",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->14,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {334.8, 228.555}, {1, -1}, Automatic, {1, 0}],
         InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             
             TemplateBox[{
              TemplateBox[{"\"\[Rho]\"", "2"}, "Superscript"],"\"(\"",TagBox[
                StyleBox["\"E\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],
               "\"0)=4.0(15)\[Cross]\"",TemplateBox[{"10", 
                 RowBox[{"-", "3"}]}, "Superscript"]},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->14,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {250.56, 99.522}, {0, 0}, Automatic, {
         0.4367168322656623, 0.8995990264644829}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"<0.0004 W.u.\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->14,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {185.4, 158.5575}, {0, -1}, Automatic, {
         0.8509444951131, 0.5252556199001696}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"96(40) W.u.\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->14,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {225.816706982614, 214.60590631386282`}, {0, 1},
          Automatic, {0.9966593686137181, 0.08167069826140162}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             SuperscriptBox["0", "+"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->14,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {367.2, 237.33}, {-1, -1}, Automatic, {1, 0}],
         InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["1658",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->14,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {424.8, 237.33}, {1, -1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"13(3) W.u.\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->14,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.1821539770435, 206.23006088150862`}, {0, 1},
          Automatic, {0.8972927456609373, 0.4414359846956934}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             
             TemplateBox[{
              TemplateBox[{"\"\[Rho]\"", "2"}, "Superscript"],"\"(\"",TagBox[
                StyleBox["\"E\"", FontSlant -> "Italic"], 
                StyleForm[#, FontSlant -> "Italic"]& ],"\"0)<0.3\[Cross]\"",
               TemplateBox[{"10", 
                 RowBox[{"-", "3"}]}, "Superscript"]},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->14,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {318.6, 125.415}, {0, 1}, Automatic, {
         0.6030236508076571, 0.7977233082758739}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SuperscriptBox["0", "+"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->14,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {43.2, 13.5}, {-1, -1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SuperscriptBox["2", "+"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->14,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {43.2, 88.56}, {-1, -1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SuperscriptBox["4", "+"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->14,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {43.2, 185.76000000000002`}, {-1, -1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SuperscriptBox["2", "+"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->14,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {115.2, 220.59}, {-1, -1}, Automatic, {1, 0}],
         InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SuperscriptBox["6", "+"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->14,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {43.2, 298.47150000000005`}, {-1, -1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SuperscriptBox["4", "+"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->14,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {115.2, 302.13}, {-1, -1}, Automatic, {1, 0}],
         InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SuperscriptBox["3", "+"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->14,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {187.20000000000002`, 298.5525}, {-1, -1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SuperscriptBox["0", "+"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->14,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {277.2, 228.555}, {-1, -1}, Automatic, {1, 
         0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["1593",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->14,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {334.8, 228.555}, {1, -1}, Automatic, {1, 0}],
         InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            
            TemplateBox[{
             TemplateBox[{"\"\[Rho]\"", "2"}, "Superscript"],"\"(\"",TagBox[
               StyleBox["\"E\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],
              "\"0)=4.0(15)\[Cross]\"",TemplateBox[{"10", 
                RowBox[{"-", "3"}]}, "Superscript"]},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->14,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {250.56, 99.522}, {0, 0}, Automatic, {
         0.4367168322656623, 0.8995990264644829}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"<0.0004 W.u.\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->14,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {185.4, 158.5575}, {0, -1}, Automatic, {
         0.8509444951131, 0.5252556199001696}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"96(40) W.u.\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->14,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {225.816706982614, 214.60590631386282`}, {0, 1},
          Automatic, {0.9966593686137181, 0.08167069826140162}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            SuperscriptBox["0", "+"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->14,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {367.2, 237.33}, {-1, -1}, Automatic, {1, 0}],
         InsetBox[
         FrameBox[
          StyleBox[
           TagBox["1658",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->14,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {424.8, 237.33}, {1, -1}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"13(3) W.u.\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->14,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.1821539770435, 206.23006088150862`}, {0, 1},
          Automatic, {0.8972927456609373, 0.4414359846956934}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            
            TemplateBox[{
             TemplateBox[{"\"\[Rho]\"", "2"}, "Superscript"],"\"(\"",TagBox[
               StyleBox["\"E\"", FontSlant -> "Italic"], 
               StyleForm[#, FontSlant -> "Italic"]& ],"\"0)<0.3\[Cross]\"",
              TemplateBox[{"10", 
                RowBox[{"-", "3"}]}, "Superscript"]},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->14,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {318.6, 125.415}, {0, 1}, Automatic, {
         0.6030236508076571, 0.7977233082758739}]},
       Frame->False,
       ImageSize->{540., 324.},
       PlotRange->{{0., 540.}, {0., 324.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72., -72.}, {612., 396.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{684., 468.},
       PlotRange->{{-72., 612.}, {-72., 396.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72., -72.}, {612., 396.}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{684., 468.},
       PlotRange->{{-72., 612.}, {-72., 396.}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->0.6842105263157894,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{684., 468.},
  PlotRange->{{-72., 612.}, {-72., 396.}}]], "Output",
 CellChangeTimes->{
  3.497225087421875*^9, 3.507513554265625*^9, 3.51983597759375*^9, {
   3.51983615021875*^9, 3.519836222328125*^9}, 3.51983633375*^9, 
   3.5200331130625*^9, 3.5200332301875*^9, 3.52003326225*^9, 
   3.521062179453125*^9, 3.52474833315625*^9, 3.566333655029261*^9, 
   3.566340339510333*^9, 3.566682760316575*^9, 3.5791220170184345`*^9, 
   3.583782352501128*^9, 3.5943059963554554`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Beta decay scheme", "Subsection"],

Cell["\<\
Note: The SciDraw layered drawing system is necessary to prevent the \
white-out boxes behind the labels from obstructing the neighboring labels.  \
To see what would happen if there were no layered drawing system, temporarily \
disable layering by including
\tSetOptions[FigObject,Layer\[Rule]0].
at the beginning of the scheme.\
\>", "Text",
 CellChangeTimes->{{3.51984599315625*^9, 3.519845993578125*^9}, {
  3.5837873312905755`*^9, 3.5837873362201843`*^9}}],

Cell[TextData[{
 "Adapted from E. A. McCutchan ",
 StyleBox["et al.",
  FontSlant->"Italic"],
 ", Phys. Rev. C ",
 StyleBox["71",
  FontWeight->"Bold"],
 ", 024309 (2005).\nCourtesy of E. A. McCutchan."
}], "Text",
 FontSize->9],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"FigurePanel", "[", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"SetOptions", "[", 
        RowBox[{"FigObject", ",", 
         RowBox[{"FontSize", "\[Rule]", "20"}], ",", 
         RowBox[{"LineThickness", "\[Rule]", "2"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"SetOptions", "[", 
         RowBox[{"Lev", ",", 
          RowBox[{"RightLabel", "\[Rule]", "Automatic"}], ",", 
          RowBox[{"WingSlopeWidth", "\[Rule]", "10"}], ",", 
          RowBox[{"WingTipWidth", "\[Rule]", "60"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"SetOptions", "[", 
         RowBox[{"Trans", ",", 
          RowBox[{"HeadLength", "\[Rule]", "6"}], ",", 
          RowBox[{"HeadLip", "\[Rule]", "3"}], ",", 
          RowBox[{"TextBackground", "\[Rule]", "Automatic"}], ",", 
          RowBox[{"TextMargin", "\[Rule]", "2"}], ",", 
          RowBox[{"TailTextNudge", "\[Rule]", "2"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", "title", " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"FigLabel", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"7", ",", 
            RowBox[{"-", "100"}]}], "}"}], ",", 
          "\"\<\!\(\*SuperscriptBox[\(\[InvisiblePrefixScriptBase]\), \
\(166\)]\)Hf\>\"", ",", 
          RowBox[{"FontSize", "\[Rule]", "35"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", "levels", " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "Lev", "\[LeftDoubleBracket]", "\"\<lev0\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"0", ",", "14", ",", "\"\<0.0\>\"", ",", 
          RowBox[{
          "LeftLabel", "\[Rule]", 
           "\"\<\!\(\*SuperscriptBox[\(0\), \(+\)]\)\>\""}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "Lev", "\[LeftDoubleBracket]", "\"\<lev159\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"0", ",", "14", ",", "\"\<158.6\>\"", ",", 
          RowBox[{
          "LeftLabel", "\[Rule]", 
           "\"\<\!\(\*SuperscriptBox[\(2\), \(+\)]\)\>\""}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "Lev", "\[LeftDoubleBracket]", "\"\<lev470\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"0", ",", "14", ",", "\"\<470.5\>\"", ",", 
          RowBox[{
          "LeftLabel", "\[Rule]", 
           "\"\<\!\(\*SuperscriptBox[\(4\), \(+\)]\)\>\""}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "Lev", "\[LeftDoubleBracket]", "\"\<lev810\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"0", ",", "14", ",", "\"\<809.9\>\"", ",", 
          RowBox[{"WingHeight", "\[Rule]", 
           RowBox[{"-", "5"}]}], ",", 
          RowBox[{
          "LeftLabel", "\[Rule]", 
           "\"\<\!\(\*SuperscriptBox[\(2\), \(+\)]\)\>\""}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "Lev", "\[LeftDoubleBracket]", "\"\<lev897\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"0", ",", "14", ",", "\"\<897.2\>\"", ",", " ", 
          RowBox[{
          "LeftLabel", "\[Rule]", 
           "\"\<\!\(\*SuperscriptBox[\(6\), \(+\)]\)\>\""}], ",", 
          RowBox[{"WingHeight", "\[Rule]", 
           RowBox[{"-", "3"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "Lev", "\[LeftDoubleBracket]", "\"\<lev1006\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"0", ",", "14", ",", "\"\<1007.1\>\"", ",", 
          RowBox[{"WingHeight", "\[Rule]", 
           RowBox[{"-", "7"}]}], ",", " ", 
          RowBox[{
          "LeftLabel", "\[Rule]", 
           "\"\<\!\(\*SuperscriptBox[\(3\), \(+\)]\)\>\""}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "Lev", "\[LeftDoubleBracket]", "\"\<lev1065\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"0", ",", "14", ",", "\"\<1065.0\>\"", ",", 
          RowBox[{"WingHeight", "\[Rule]", 
           RowBox[{"+", "5"}]}], ",", " ", 
          RowBox[{
          "LeftLabel", "\[Rule]", 
           "\"\<(\!\(\*SuperscriptBox[\(0\), \(+\)]\))\>\""}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "Lev", "\[LeftDoubleBracket]", "\"\<lev1164\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"0", ",", "14", ",", "\"\<1162.7\>\""}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "Lev", "\[LeftDoubleBracket]", "\"\<lev1219\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"0", ",", "14", ",", "\"\<1218.8\>\"", ",", 
          RowBox[{"WingHeight", "\[Rule]", 
           RowBox[{"+", "8"}]}], ",", " ", 
          RowBox[{
          "LeftLabel", "\[Rule]", 
           "\"\<(\!\(\*SuperscriptBox[\(2\), \(+\)]\))\>\""}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "Lev", "\[LeftDoubleBracket]", "\"\<lev1332\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"0", ",", "14", ",", "\"\<1332.4\>\""}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "Lev", "\[LeftDoubleBracket]", "\"\<lev1405\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"0", " ", ",", "14", ",", "\"\<1404.6\>\""}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "Lev", "\[LeftDoubleBracket]", "\"\<lev1551\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"0", ",", "14", ",", "\"\<1551.4\>\"", ",", " ", 
          RowBox[{
          "LeftLabel", "\[Rule]", 
           "\"\<(\!\(\*SuperscriptBox[\(5\), \(+\)]\))\>\""}], ",", 
          RowBox[{"WingHeight", " ", "\[Rule]", 
           RowBox[{"-", "7"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
         "Lev", "\[LeftDoubleBracket]", "\"\<lev1603\>\"", 
          "\[RightDoubleBracket]"}], "[", 
         RowBox[{"0", ",", "14", ",", "\"\<1603.2\>\""}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", "transitions", " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"AutoLevelInit", "[", 
         RowBox[{"12.2", ",", 
          RowBox[{"-", "0.5"}], ",", 
          RowBox[{"-", "0.5"}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"AutoLevel", "[", "\"\<lev159\>\"", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoTrans", "[", 
         RowBox[{"\"\<lev0\>\"", ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<159  \!\(\*
StyleBox[\"100\",
FontSlant->\"Italic\",
FontTracking->\"Plain\",
FontVariations->{\"CompatibilityType\"->0,
\"Masked\"->False,
\"Outline\"->False,
\"RotationAngle\"->0,
\"Shadow\"->False,
\"StrikeThrough\"->False,
\"Underline\"->False}]\)\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoLevel", "[", "\"\<lev470\>\"", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoTrans", "[", 
         RowBox[{"\"\<lev159\>\"", ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<312  \!\(\*
StyleBox[\"44.7\",
FontSlant->\"Italic\",
FontTracking->\"Plain\",
FontVariations->{\"CompatibilityType\"->0,
\"Masked\"->False,
\"Outline\"->False,
\"RotationAngle\"->0,
\"Shadow\"->False,
\"StrikeThrough\"->False,
\"Underline\"->False}]\)\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoLevel", "[", "\"\<lev810\>\"", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoTrans", "[", 
         RowBox[{"\"\<lev0\>\"", ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<810  \!\(\*
StyleBox[\"20.2\",
FontSlant->\"Italic\",
FontTracking->\"Plain\",
FontVariations->{\"CompatibilityType\"->0,
\"Masked\"->False,
\"Outline\"->False,
\"RotationAngle\"->0,
\"Shadow\"->False,
\"StrikeThrough\"->False,
\"Underline\"->False}]\)\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"AutoTrans", "[", 
         RowBox[{"\"\<lev159\>\"", ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<651  \!\(\*
StyleBox[\"18.9\",
FontSlant->\"Italic\",
FontTracking->\"Plain\",
FontVariations->{\"CompatibilityType\"->0,
\"Masked\"->False,
\"Outline\"->False,
\"RotationAngle\"->0,
\"Shadow\"->False,
\"StrikeThrough\"->False,
\"Underline\"->False}]\)\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoLevel", "[", "\"\<lev897\>\"", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoTrans", "[", 
         RowBox[{"\"\<lev470\>\"", ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<427  \!\(\*
StyleBox[\"1.2\",
FontSlant->\"Italic\",
FontTracking->\"Plain\",
FontVariations->{\"CompatibilityType\"->0,
\"Masked\"->False,
\"Outline\"->False,
\"RotationAngle\"->0,
\"Shadow\"->False,
\"StrikeThrough\"->False,
\"Underline\"->False}]\)\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoLevel", "[", "\"\<lev1006\>\"", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoTrans", "[", 
         RowBox[{"\"\<lev159\>\"", ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<848  \!\(\*
StyleBox[\"12.7\",
FontSlant->\"Italic\",
FontTracking->\"Plain\",
FontVariations->{\"CompatibilityType\"->0,
\"Masked\"->False,
\"Outline\"->False,
\"RotationAngle\"->0,
\"Shadow\"->False,
\"StrikeThrough\"->False,
\"Underline\"->False}]\)\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"AutoTrans", "[", 
         RowBox[{"\"\<lev470\>\"", ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<537  \!\(\*
StyleBox[\"2.0\",
FontSlant->\"Italic\",
FontTracking->\"Plain\",
FontVariations->{\"CompatibilityType\"->0,
\"Masked\"->False,
\"Outline\"->False,
\"RotationAngle\"->0,
\"Shadow\"->False,
\"StrikeThrough\"->False,
\"Underline\"->False}]\)\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoLevel", "[", "\"\<lev1065\>\"", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoTrans", "[", 
         RowBox[{"\"\<lev159\>\"", ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<906  \!\(\*
StyleBox[\"2.1\",
FontSlant->\"Italic\",
FontTracking->\"Plain\",
FontVariations->{\"CompatibilityType\"->0,
\"Masked\"->False,
\"Outline\"->False,
\"RotationAngle\"->0,
\"Shadow\"->False,
\"StrikeThrough\"->False,
\"Underline\"->False}]\)\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoLevel", "[", "\"\<lev1164\>\"", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoTrans", "[", 
         RowBox[{"\"\<lev470\>\"", ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<692  \!\(\*
StyleBox[\"4.4\",
FontSlant->\"Italic\"]\)\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoLevel", "[", "\"\<lev1219\>\"", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoTrans", "[", 
         RowBox[{"\"\<lev0\>\"", ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<1219  \!\(\*
StyleBox[\"1.0\",
FontSlant->\"Italic\"]\)\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"AutoTrans", "[", 
         RowBox[{"\"\<lev159\>\"", ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<1060  \!\(\*
StyleBox[\"2.3\",
FontSlant->\"Italic\"]\)\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"AutoTrans", "[", 
         RowBox[{"\"\<lev470\>\"", ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<748  \!\(\*
StyleBox[\"3.0\",
FontSlant->\"Italic\"]\)\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoLevel", "[", "\"\<lev1332\>\"", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoTrans", "[", 
         RowBox[{"\"\<lev159\>\"", ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<1174  \!\(\*
StyleBox[\"5.9\",
FontSlant->\"Italic\"]\)\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"AutoTrans", "[", 
         RowBox[{"\"\<lev470\>\"", ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<862  \!\(\*
StyleBox[\"5.4\",
FontSlant->\"Italic\"]\)\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoLevel", "[", "\"\<lev1405\>\"", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoTrans", "[", 
         RowBox[{"\"\<lev159\>\"", ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<1246  \!\(\*
StyleBox[\"5.4\",
FontSlant->\"Italic\"]\)\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"AutoTrans", "[", 
         RowBox[{"\"\<lev810\>\"", ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<595  \!\(\*
StyleBox[\"5.7\",
FontSlant->\"Italic\"]\)\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"AutoTrans", "[", 
         RowBox[{"\"\<lev1006\>\"", ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<398  \!\(\*
StyleBox[\"2.9\",
FontSlant->\"Italic\"]\)\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoLevel", "[", "\"\<lev1551\>\"", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoTrans", "[", 
         RowBox[{"\"\<lev470\>\"", ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<1081  \!\(\*
StyleBox[\"1.6\",
FontSlant->\"Italic\"]\)\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"AutoTrans", "[", 
         RowBox[{"\"\<lev1006\>\"", ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<544  \!\(\*
StyleBox[\"0.9\",
FontSlant->\"Italic\"]\)\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoLevel", "[", "\"\<lev1603\>\"", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"AutoTrans", "[", 
         RowBox[{"\"\<lev159\>\"", ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<1444  \!\(\*
StyleBox[\"2.3\",
FontSlant->\"Italic\"]\)\>\""}]}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"AutoTrans", "[", 
         RowBox[{"\"\<lev470\>\"", ",", 
          RowBox[{"TailLabel", "\[Rule]", "\"\<1134  \!\(\*
StyleBox[\"2.5\",
FontSlant->\"Italic\"]\)\>\""}]}], " ", "]"}], ";"}]}], "\[IndentingNewLine]",
       "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"PlotRange", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", "16"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "200"}], ",", "1910"}], "}"}]}], "}"}]}], ",", 
     RowBox[{"Frame", "\[Rule]", "False"}]}], "\[IndentingNewLine]", "]"}], 
   ",", "\[IndentingNewLine]", 
   RowBox[{"CanvasSize", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"8.5", ",", "8"}], "}"}]}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellChangeTimes->{
  3.395095505203125*^9, 3.50751344778125*^9, {3.519835806671875*^9, 
   3.519835820625*^9}, {3.5198459096875*^9, 3.51984612875*^9}, {
   3.519848258609375*^9, 3.51984834015625*^9}, {3.51984915571875*^9, 
   3.519849222234375*^9}, {3.519849376703125*^9, 3.519849450421875*^9}, {
   3.51984948415625*^9, 3.519849549390625*^9}, {3.519849719875*^9, 
   3.51984975184375*^9}, {3.5198497876875*^9, 3.51984979134375*^9}, {
   3.566333370749962*^9, 3.5663333739323673`*^9}, {3.566333427690062*^9, 
   3.566333431527669*^9}, {3.56633369972334*^9, 3.5663338504508047`*^9}, {
   3.5663338843496637`*^9, 3.5663339599473968`*^9}}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72., -72}, {684., 648}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{756., 720},
       PlotRange->{{-72., 684.}, {-72, 648}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {612., 576.}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{39.6, 54.59715639810426}, {536.4000000000001, 
          54.59715639810426}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{39.6, 97.89270142180094}, {536.4000000000001, 
          97.89270142180094}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{39.6, 183.03696682464454`}, {536.4000000000001, 
          183.03696682464454`}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{39.6, 270.68834123222746`}, {99.6, 270.68834123222746`}, {
          109.6, 275.68834123222746`}, {466.4000000000001, 
          275.68834123222746`}, {476.4000000000001, 270.68834123222746`}, {
          536.4000000000001, 270.68834123222746`}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{39.6, 296.52}, {99.6, 296.52}, {109.6, 299.52}, {
          466.4000000000001, 299.52}, {476.4000000000001, 296.52}, {
          536.4000000000001, 296.52}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{39.6, 322.52113744075825`}, {99.6, 322.52113744075825`}, {
          109.6, 329.52113744075825`}, {466.4000000000001, 
          329.52113744075825`}, {476.4000000000001, 322.52113744075825`}, {
          536.4000000000001, 322.52113744075825`}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{39.6, 350.3270142180095}, {99.6, 350.3270142180095}, {
          109.6, 345.3270142180095}, {466.4000000000001, 345.3270142180095}, {
          476.4000000000001, 350.3270142180095}, {536.4000000000001, 
          350.3270142180095}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{39.6, 371.99772511848346`}, {536.4000000000001, 
          371.99772511848346`}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{39.6, 395.3122274881516}, {99.6, 395.3122274881516}, {
          109.6, 387.3122274881516}, {466.4000000000001, 387.3122274881516}, {
          476.4000000000001, 395.3122274881516}, {536.4000000000001, 
          395.3122274881516}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{39.6, 418.32341232227486`}, {536.4000000000001, 
          418.32341232227486`}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{39.6, 438.0329857819904}, {536.4000000000001, 
          438.0329857819904}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{39.6, 471.1072985781991}, {99.6, 471.1072985781991}, {
          109.6, 478.1072985781991}, {466.4000000000001, 478.1072985781991}, {
          476.4000000000001, 471.1072985781991}, {536.4000000000001, 
          471.1072985781991}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{39.6, 492.247962085308}, {536.4000000000001, 
          492.247962085308}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{475.19999999999993`, 97.89270142180094}, {
          475.19999999999993`, 54.59715639810426}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{478.19999999999993`, 60.59715639810426}, {
           475.19999999999993`, 54.59715639810426}, {472.19999999999993`, 
           60.59715639810426}}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{457.19999999999993`, 183.03696682464454`}, {
          457.19999999999993`, 97.89270142180094}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{460.19999999999993`, 103.89270142180094`}, {
           457.19999999999993`, 97.89270142180094}, {454.19999999999993`, 
           103.89270142180094`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{439.2, 275.68834123222746`}, {439.2, 54.59715639810426}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{442.2, 60.59715639810426}, {439.2, 
           54.59715639810426}, {436.2, 60.59715639810426}}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{421.2, 275.68834123222746`}, {421.2, 97.89270142180094}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{424.2, 103.89270142180092`}, {421.2, 
           97.89270142180092}, {418.2, 103.89270142180092`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{403.19999999999993`, 299.52}, {403.19999999999993`, 
          183.03696682464454`}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{406.19999999999993`, 189.03696682464454`}, {
           403.19999999999993`, 183.03696682464454`}, {400.19999999999993`, 
           189.03696682464454`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{385.19999999999993`, 329.52113744075825`}, {
          385.19999999999993`, 97.89270142180094}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{388.19999999999993`, 103.89270142180094`}, {
           385.19999999999993`, 97.89270142180094}, {382.19999999999993`, 
           103.89270142180094`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{367.19999999999993`, 329.52113744075825`}, {
          367.19999999999993`, 183.03696682464454`}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{370.19999999999993`, 189.03696682464454`}, {
           367.19999999999993`, 183.03696682464454`}, {364.19999999999993`, 
           189.03696682464454`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{349.19999999999993`, 345.3270142180095}, {
          349.19999999999993`, 97.89270142180094}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{352.19999999999993`, 103.89270142180094`}, {
           349.19999999999993`, 97.89270142180094}, {346.19999999999993`, 
           103.89270142180094`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{331.19999999999993`, 371.99772511848346`}, {
          331.19999999999993`, 183.03696682464454`}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{334.19999999999993`, 189.03696682464454`}, {
           331.19999999999993`, 183.03696682464454`}, {328.19999999999993`, 
           189.03696682464454`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{313.2, 387.3122274881516}, {313.2, 54.59715639810426}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{316.2, 60.59715639810426}, {313.2, 
           54.59715639810426}, {310.2, 60.59715639810426}}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{295.2, 387.3122274881516}, {295.2, 97.89270142180094}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{298.2, 103.89270142180094`}, {295.2, 
           97.89270142180094}, {292.2, 103.89270142180094`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{277.19999999999993`, 387.3122274881516}, {
          277.19999999999993`, 183.03696682464454`}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{280.19999999999993`, 189.03696682464454`}, {
           277.19999999999993`, 183.03696682464454`}, {274.19999999999993`, 
           189.03696682464454`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{259.19999999999993`, 418.32341232227486`}, {
          259.19999999999993`, 97.89270142180094}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{262.19999999999993`, 103.89270142180094`}, {
           259.19999999999993`, 97.89270142180094}, {256.19999999999993`, 
           103.89270142180094`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{241.19999999999996`, 418.32341232227486`}, {
          241.19999999999996`, 183.03696682464454`}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{244.19999999999996`, 189.03696682464454`}, {
           241.19999999999996`, 183.03696682464454`}, {238.19999999999996`, 
           189.03696682464454`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{223.19999999999996`, 438.0329857819904}, {
          223.19999999999996`, 97.89270142180094}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{226.19999999999996`, 103.89270142180094`}, {
           223.19999999999996`, 97.89270142180094}, {220.19999999999996`, 
           103.89270142180094`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{205.19999999999996`, 438.0329857819904}, {
          205.19999999999996`, 275.68834123222746`}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{208.19999999999996`, 281.68834123222746`}, {
           205.19999999999996`, 275.68834123222746`}, {202.19999999999996`, 
           281.68834123222746`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{187.19999999999996`, 438.0329857819904}, {
          187.19999999999996`, 329.52113744075825`}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{190.19999999999996`, 335.52113744075825`}, {
           187.19999999999996`, 329.52113744075825`}, {184.19999999999996`, 
           335.52113744075825`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{169.2, 478.1072985781991}, {169.2, 183.03696682464454`}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{172.2, 189.03696682464454`}, {169.2, 
           183.03696682464454`}, {166.2, 189.03696682464454`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{151.2, 478.1072985781991}, {151.2, 329.52113744075825`}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{154.2, 335.52113744075825`}, {151.2, 
           329.52113744075825`}, {148.2, 335.52113744075825`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{133.19999999999996`, 492.247962085308}, {
          133.19999999999996`, 97.89270142180094}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{136.19999999999996`, 103.89270142180094`}, {
           133.19999999999996`, 97.89270142180094}, {130.19999999999996`, 
           103.89270142180094`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{115.19999999999997`, 492.247962085308}, {
          115.19999999999997`, 183.03696682464454`}}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{118.19999999999997`, 189.03696682464454`}, {
           115.19999999999997`, 183.03696682464454`}, {112.19999999999997`, 
           189.03696682464454`}}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"\\!\\(\\*SuperscriptBox[\\(\
\[InvisiblePrefixScriptBase]\\), \\(166\\)]\\)Hf\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->35,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {288., 27.29857819905213}, {0, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"\\!\\(\\*SuperscriptBox[\\(0\\), \\(+\\)]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {39.6, 54.59715639810426}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"0.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 54.59715639810426}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"\\!\\(\\*SuperscriptBox[\\(2\\), \\(+\\)]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {39.6, 97.89270142180094}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"158.6\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 97.89270142180094}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"\\!\\(\\*SuperscriptBox[\\(4\\), \\(+\\)]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {39.6, 183.03696682464454`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"470.5\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 183.03696682464454`}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"\\!\\(\\*SuperscriptBox[\\(2\\), \\(+\\)]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {39.6, 270.68834123222746`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"809.9\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 270.68834123222746`}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"\\!\\(\\*SuperscriptBox[\\(6\\), \\(+\\)]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {39.6, 296.52}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"897.2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 296.52}, {-1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"\\!\\(\\*SuperscriptBox[\\(3\\), \\(+\\)]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {39.6, 322.52113744075825`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1007.1\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 322.52113744075825`}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"(\\!\\(\\*SuperscriptBox[\\(0\\), \\(+\\)]\\))\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {39.6, 350.3270142180095}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1065.0\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 350.3270142180095}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1162.7\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 371.99772511848346`}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"(\\!\\(\\*SuperscriptBox[\\(2\\), \\(+\\)]\\))\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {39.6, 395.3122274881516}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1218.8\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 395.3122274881516}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1332.4\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 418.32341232227486`}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1404.6\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 438.0329857819904}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"(\\!\\(\\*SuperscriptBox[\\(5\\), \\(+\\)]\\))\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {39.6, 471.1072985781991}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1551.4\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 471.1072985781991}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"1603.2\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 492.247962085308}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"159  \
\\!\\(\\*\\nStyleBox[\\\"100\\\",\\nFontSlant->\\\"Italic\\\",\\nFontTracking-\
>\\\"Plain\\\",\\nFontVariations->{\\\"CompatibilityType\\\"->0,\\n\\\"Masked\
\\\"->False,\\n\\\"Outline\\\"->False,\\n\\\"RotationAngle\\\"->0,\\n\\\"\
Shadow\\\"->False,\\n\\\"StrikeThrough\\\"->False,\\n\\\"Underline\\\"->False}\
]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {475.19999999999993`, 99.89270142180094}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"312  \\!\\(\\*\\nStyleBox[\\\"44.7\\\",\\nFontSlant->\
\\\"Italic\\\",\\nFontTracking->\\\"Plain\\\",\\nFontVariations->{\\\"\
CompatibilityType\\\"->0,\\n\\\"Masked\\\"->False,\\n\\\"Outline\\\"->False,\\\
n\\\"RotationAngle\\\"->0,\\n\\\"Shadow\\\"->False,\\n\\\"StrikeThrough\\\"->\
False,\\n\\\"Underline\\\"->False}]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {457.19999999999993`, 185.03696682464454`}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"810  \\!\\(\\*\\nStyleBox[\\\"20.2\\\",\\nFontSlant->\
\\\"Italic\\\",\\nFontTracking->\\\"Plain\\\",\\nFontVariations->{\\\"\
CompatibilityType\\\"->0,\\n\\\"Masked\\\"->False,\\n\\\"Outline\\\"->False,\\\
n\\\"RotationAngle\\\"->0,\\n\\\"Shadow\\\"->False,\\n\\\"StrikeThrough\\\"->\
False,\\n\\\"Underline\\\"->False}]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {439.2, 277.68834123222746`}, {-1, 0}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"651  \\!\\(\\*\\nStyleBox[\\\"18.9\\\",\\nFontSlant->\
\\\"Italic\\\",\\nFontTracking->\\\"Plain\\\",\\nFontVariations->{\\\"\
CompatibilityType\\\"->0,\\n\\\"Masked\\\"->False,\\n\\\"Outline\\\"->False,\\\
n\\\"RotationAngle\\\"->0,\\n\\\"Shadow\\\"->False,\\n\\\"StrikeThrough\\\"->\
False,\\n\\\"Underline\\\"->False}]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {421.2, 277.68834123222746`}, {-1, 0}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"427  \
\\!\\(\\*\\nStyleBox[\\\"1.2\\\",\\nFontSlant->\\\"Italic\\\",\\nFontTracking-\
>\\\"Plain\\\",\\nFontVariations->{\\\"CompatibilityType\\\"->0,\\n\\\"Masked\
\\\"->False,\\n\\\"Outline\\\"->False,\\n\\\"RotationAngle\\\"->0,\\n\\\"\
Shadow\\\"->False,\\n\\\"StrikeThrough\\\"->False,\\n\\\"Underline\\\"->False}\
]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {403.19999999999993`, 301.52}, {-1, 0}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"848  \\!\\(\\*\\nStyleBox[\\\"12.7\\\",\\nFontSlant->\
\\\"Italic\\\",\\nFontTracking->\\\"Plain\\\",\\nFontVariations->{\\\"\
CompatibilityType\\\"->0,\\n\\\"Masked\\\"->False,\\n\\\"Outline\\\"->False,\\\
n\\\"RotationAngle\\\"->0,\\n\\\"Shadow\\\"->False,\\n\\\"StrikeThrough\\\"->\
False,\\n\\\"Underline\\\"->False}]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {385.19999999999993`, 331.52113744075825`}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"537  \
\\!\\(\\*\\nStyleBox[\\\"2.0\\\",\\nFontSlant->\\\"Italic\\\",\\nFontTracking-\
>\\\"Plain\\\",\\nFontVariations->{\\\"CompatibilityType\\\"->0,\\n\\\"Masked\
\\\"->False,\\n\\\"Outline\\\"->False,\\n\\\"RotationAngle\\\"->0,\\n\\\"\
Shadow\\\"->False,\\n\\\"StrikeThrough\\\"->False,\\n\\\"Underline\\\"->False}\
]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {367.19999999999993`, 331.52113744075825`}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"906  \
\\!\\(\\*\\nStyleBox[\\\"2.1\\\",\\nFontSlant->\\\"Italic\\\",\\nFontTracking-\
>\\\"Plain\\\",\\nFontVariations->{\\\"CompatibilityType\\\"->0,\\n\\\"Masked\
\\\"->False,\\n\\\"Outline\\\"->False,\\n\\\"RotationAngle\\\"->0,\\n\\\"\
Shadow\\\"->False,\\n\\\"StrikeThrough\\\"->False,\\n\\\"Underline\\\"->False}\
]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {349.19999999999993`, 347.3270142180095}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"692  \
\\!\\(\\*\\nStyleBox[\\\"4.4\\\",\\nFontSlant->\\\"Italic\\\"]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {331.19999999999993`, 373.99772511848346`}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"1219  \\!\\(\\*\\nStyleBox[\\\"1.0\\\",\\nFontSlant->\
\\\"Italic\\\"]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {313.2, 389.3122274881516}, {-1, 0}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"1060  \\!\\(\\*\\nStyleBox[\\\"2.3\\\",\\nFontSlant->\
\\\"Italic\\\"]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {295.2, 389.3122274881516}, {-1, 0}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"748  \
\\!\\(\\*\\nStyleBox[\\\"3.0\\\",\\nFontSlant->\\\"Italic\\\"]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {277.19999999999993`, 389.3122274881516}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"1174  \\!\\(\\*\\nStyleBox[\\\"5.9\\\",\\nFontSlant->\
\\\"Italic\\\"]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {259.19999999999993`, 420.32341232227486`}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"862  \
\\!\\(\\*\\nStyleBox[\\\"5.4\\\",\\nFontSlant->\\\"Italic\\\"]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {241.19999999999996`, 420.32341232227486`}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"1246  \\!\\(\\*\\nStyleBox[\\\"5.4\\\",\\nFontSlant->\
\\\"Italic\\\"]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {223.19999999999996`, 440.0329857819904}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"595  \
\\!\\(\\*\\nStyleBox[\\\"5.7\\\",\\nFontSlant->\\\"Italic\\\"]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {205.19999999999996`, 440.0329857819904}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"398  \
\\!\\(\\*\\nStyleBox[\\\"2.9\\\",\\nFontSlant->\\\"Italic\\\"]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {187.19999999999996`, 440.0329857819904}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"1081  \\!\\(\\*\\nStyleBox[\\\"1.6\\\",\\nFontSlant->\
\\\"Italic\\\"]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {169.2, 480.1072985781991}, {-1, 0}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"544  \
\\!\\(\\*\\nStyleBox[\\\"0.9\\\",\\nFontSlant->\\\"Italic\\\"]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {151.2, 480.1072985781991}, {-1, 0}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"1444  \\!\\(\\*\\nStyleBox[\\\"2.3\\\",\\nFontSlant->\
\\\"Italic\\\"]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {133.19999999999996`, 494.247962085308}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            
            TagBox["\<\"1134  \\!\\(\\*\\nStyleBox[\\\"2.5\\\",\\nFontSlant->\
\\\"Italic\\\"]\\)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->GrayLevel[1],
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {115.19999999999997`, 494.247962085308}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"\\!\\(\\*SuperscriptBox[\\(\[InvisiblePrefixScriptBase]\
\\), \\(166\\)]\\)Hf\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->35,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {288., 27.29857819905213}, {0, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"\\!\\(\\*SuperscriptBox[\\(0\\), \\(+\\)]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {39.6, 54.59715639810426}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"0.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 54.59715639810426}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"\\!\\(\\*SuperscriptBox[\\(2\\), \\(+\\)]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {39.6, 97.89270142180094}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"158.6\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 97.89270142180094}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"\\!\\(\\*SuperscriptBox[\\(4\\), \\(+\\)]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {39.6, 183.03696682464454`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"470.5\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 183.03696682464454`}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"\\!\\(\\*SuperscriptBox[\\(2\\), \\(+\\)]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {39.6, 270.68834123222746`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"809.9\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 270.68834123222746`}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"\\!\\(\\*SuperscriptBox[\\(6\\), \\(+\\)]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {39.6, 296.52}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"897.2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 296.52}, {-1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"\\!\\(\\*SuperscriptBox[\\(3\\), \\(+\\)]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {39.6, 322.52113744075825`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1007.1\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 322.52113744075825`}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"(\\!\\(\\*SuperscriptBox[\\(0\\), \\(+\\)]\\))\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {39.6, 350.3270142180095}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1065.0\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 350.3270142180095}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1162.7\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 371.99772511848346`}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"(\\!\\(\\*SuperscriptBox[\\(2\\), \\(+\\)]\\))\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {39.6, 395.3122274881516}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1218.8\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 395.3122274881516}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1332.4\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 418.32341232227486`}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1404.6\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 438.0329857819904}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"(\\!\\(\\*SuperscriptBox[\\(5\\), \\(+\\)]\\))\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {39.6, 471.1072985781991}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1551.4\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 471.1072985781991}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"1603.2\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {536.4000000000001, 492.247962085308}, {-1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"159  \\!\\(\\*\\nStyleBox[\\\"100\\\",\\nFontSlant->\\\
\"Italic\\\",\\nFontTracking->\\\"Plain\\\",\\nFontVariations->{\\\"\
CompatibilityType\\\"->0,\\n\\\"Masked\\\"->False,\\n\\\"Outline\\\"->False,\\\
n\\\"RotationAngle\\\"->0,\\n\\\"Shadow\\\"->False,\\n\\\"StrikeThrough\\\"->\
False,\\n\\\"Underline\\\"->False}]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {475.19999999999993`, 99.89270142180094}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"312  \
\\!\\(\\*\\nStyleBox[\\\"44.7\\\",\\nFontSlant->\\\"Italic\\\",\\\
nFontTracking->\\\"Plain\\\",\\nFontVariations->{\\\"CompatibilityType\\\"->0,\
\\n\\\"Masked\\\"->False,\\n\\\"Outline\\\"->False,\\n\\\"RotationAngle\\\"->\
0,\\n\\\"Shadow\\\"->False,\\n\\\"StrikeThrough\\\"->False,\\n\\\"Underline\\\
\"->False}]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {457.19999999999993`, 185.03696682464454`}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"810  \
\\!\\(\\*\\nStyleBox[\\\"20.2\\\",\\nFontSlant->\\\"Italic\\\",\\\
nFontTracking->\\\"Plain\\\",\\nFontVariations->{\\\"CompatibilityType\\\"->0,\
\\n\\\"Masked\\\"->False,\\n\\\"Outline\\\"->False,\\n\\\"RotationAngle\\\"->\
0,\\n\\\"Shadow\\\"->False,\\n\\\"StrikeThrough\\\"->False,\\n\\\"Underline\\\
\"->False}]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {439.2, 277.68834123222746`}, {-1, 0}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"651  \
\\!\\(\\*\\nStyleBox[\\\"18.9\\\",\\nFontSlant->\\\"Italic\\\",\\\
nFontTracking->\\\"Plain\\\",\\nFontVariations->{\\\"CompatibilityType\\\"->0,\
\\n\\\"Masked\\\"->False,\\n\\\"Outline\\\"->False,\\n\\\"RotationAngle\\\"->\
0,\\n\\\"Shadow\\\"->False,\\n\\\"StrikeThrough\\\"->False,\\n\\\"Underline\\\
\"->False}]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {421.2, 277.68834123222746`}, {-1, 0}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"427  \\!\\(\\*\\nStyleBox[\\\"1.2\\\",\\nFontSlant->\\\
\"Italic\\\",\\nFontTracking->\\\"Plain\\\",\\nFontVariations->{\\\"\
CompatibilityType\\\"->0,\\n\\\"Masked\\\"->False,\\n\\\"Outline\\\"->False,\\\
n\\\"RotationAngle\\\"->0,\\n\\\"Shadow\\\"->False,\\n\\\"StrikeThrough\\\"->\
False,\\n\\\"Underline\\\"->False}]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {403.19999999999993`, 301.52}, {-1, 0}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"848  \
\\!\\(\\*\\nStyleBox[\\\"12.7\\\",\\nFontSlant->\\\"Italic\\\",\\\
nFontTracking->\\\"Plain\\\",\\nFontVariations->{\\\"CompatibilityType\\\"->0,\
\\n\\\"Masked\\\"->False,\\n\\\"Outline\\\"->False,\\n\\\"RotationAngle\\\"->\
0,\\n\\\"Shadow\\\"->False,\\n\\\"StrikeThrough\\\"->False,\\n\\\"Underline\\\
\"->False}]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {385.19999999999993`, 331.52113744075825`}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"537  \\!\\(\\*\\nStyleBox[\\\"2.0\\\",\\nFontSlant->\\\
\"Italic\\\",\\nFontTracking->\\\"Plain\\\",\\nFontVariations->{\\\"\
CompatibilityType\\\"->0,\\n\\\"Masked\\\"->False,\\n\\\"Outline\\\"->False,\\\
n\\\"RotationAngle\\\"->0,\\n\\\"Shadow\\\"->False,\\n\\\"StrikeThrough\\\"->\
False,\\n\\\"Underline\\\"->False}]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {367.19999999999993`, 331.52113744075825`}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"906  \\!\\(\\*\\nStyleBox[\\\"2.1\\\",\\nFontSlant->\\\
\"Italic\\\",\\nFontTracking->\\\"Plain\\\",\\nFontVariations->{\\\"\
CompatibilityType\\\"->0,\\n\\\"Masked\\\"->False,\\n\\\"Outline\\\"->False,\\\
n\\\"RotationAngle\\\"->0,\\n\\\"Shadow\\\"->False,\\n\\\"StrikeThrough\\\"->\
False,\\n\\\"Underline\\\"->False}]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {349.19999999999993`, 347.3270142180095}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"692  \\!\\(\\*\\nStyleBox[\\\"4.4\\\",\\nFontSlant->\\\
\"Italic\\\"]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {331.19999999999993`, 373.99772511848346`}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"1219  \
\\!\\(\\*\\nStyleBox[\\\"1.0\\\",\\nFontSlant->\\\"Italic\\\"]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {313.2, 389.3122274881516}, {-1, 0}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"1060  \
\\!\\(\\*\\nStyleBox[\\\"2.3\\\",\\nFontSlant->\\\"Italic\\\"]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {295.2, 389.3122274881516}, {-1, 0}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"748  \\!\\(\\*\\nStyleBox[\\\"3.0\\\",\\nFontSlant->\\\
\"Italic\\\"]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {277.19999999999993`, 389.3122274881516}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"1174  \
\\!\\(\\*\\nStyleBox[\\\"5.9\\\",\\nFontSlant->\\\"Italic\\\"]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {259.19999999999993`, 420.32341232227486`}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"862  \\!\\(\\*\\nStyleBox[\\\"5.4\\\",\\nFontSlant->\\\
\"Italic\\\"]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {241.19999999999996`, 420.32341232227486`}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"1246  \
\\!\\(\\*\\nStyleBox[\\\"5.4\\\",\\nFontSlant->\\\"Italic\\\"]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {223.19999999999996`, 440.0329857819904}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"595  \\!\\(\\*\\nStyleBox[\\\"5.7\\\",\\nFontSlant->\\\
\"Italic\\\"]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {205.19999999999996`, 440.0329857819904}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"398  \\!\\(\\*\\nStyleBox[\\\"2.9\\\",\\nFontSlant->\\\
\"Italic\\\"]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {187.19999999999996`, 440.0329857819904}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"1081  \
\\!\\(\\*\\nStyleBox[\\\"1.6\\\",\\nFontSlant->\\\"Italic\\\"]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {169.2, 480.1072985781991}, {-1, 0}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"544  \\!\\(\\*\\nStyleBox[\\\"0.9\\\",\\nFontSlant->\\\
\"Italic\\\"]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {151.2, 480.1072985781991}, {-1, 0}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"1444  \
\\!\\(\\*\\nStyleBox[\\\"2.3\\\",\\nFontSlant->\\\"Italic\\\"]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {133.19999999999996`, 494.247962085308}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           
           TagBox["\<\"1134  \
\\!\\(\\*\\nStyleBox[\\\"2.5\\\",\\nFontSlant->\\\"Italic\\\"]\\)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{2, 2}, {2, 2}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {115.19999999999997`, 494.247962085308}, {-1, 0},
          Automatic, {6.123233995736766*^-17, 1.}]},
       Frame->False,
       ImageSize->{612., 576.},
       PlotRange->{{0., 612.}, {0., 576.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72., -72}, {684., 648}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{756., 720},
       PlotRange->{{-72., 684.}, {-72, 648}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72., -72}, {684., 648}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{756., 720},
       PlotRange->{{-72., 684.}, {-72, 648}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->0.9523809523809523,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{756., 720},
  PlotRange->{{-72., 684.}, {-72, 648}}]], "Output",
 CellChangeTimes->{
  3.497225112109375*^9, 3.507513558015625*^9, 3.519849150921875*^9, {
   3.519849202140625*^9, 3.51984922571875*^9}, {3.51984936778125*^9, 
   3.51984942796875*^9}, 3.519849463484375*^9, {3.519849504140625*^9, 
   3.51984955871875*^9}, {3.519849728265625*^9, 3.519849746484375*^9}, {
   3.51984977696875*^9, 3.519849798984375*^9}, 3.521062187609375*^9, 
   3.524748341203125*^9, 3.5663338547408123`*^9, {3.5663339090913076`*^9, 
   3.566333962817802*^9}, 3.566340345280341*^9, 3.579122019529578*^9, 
   3.583782361481141*^9, 3.5943060005654616`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Diagrams involving level schemes", "Section",
 CellChangeTimes->{{3.6221582602637568`*^9, 3.622158275302183*^9}}],

Cell[CellGroupData[{

Cell["Nuclear shell model diagram", "Subsection",
 CellChangeTimes->{{3.49226220584375*^9, 3.492262216140625*^9}, 
   3.492288068421875*^9, {3.4922886865625*^9, 3.49228868796875*^9}}],

Cell["\<\
Example of writing simple functions to automatically create the list of \
levels to plot, calcule the level energies, generate the labels, etc.\
\>", "Text",
 CellChangeTimes->{{3.492288075203125*^9, 3.49228809359375*^9}, {
  3.49228846959375*^9, 3.492288548359375*^9}}],

Cell["\<\
Labeling -- spectroscopic notation and color scheme for levels

Note: The letter \[HBar] is \[OpenCurlyDoubleQuote]HBar\
\[CloseCurlyDoubleQuote], entered as Escape - h - b - Escape.\
\>", "Text",
 CellChangeTimes->{{3.492288107703125*^9, 3.492288130859375*^9}, {
  3.566334372169321*^9, 3.5663343924805565`*^9}}],

Cell["\<\
(* SciDraw provides the following definitions for spdfg... spectroscopic \
notation: *)
SpectroscopicLetter[0] = \"s\";
SpectroscopicLetter[1] = \"p\";
SpectroscopicLetter[2] = \"d\";
SpectroscopicLetter[3] = \"f\";
SpectroscopicLetter[4] = \"g\";
SpectroscopicLetter[5] = \"h\";
SpectroscopicLetter[6] = \"i\";
SpectroscopicLetter[7] = \"j\";
SpectroscopicLetter[8] = \"k\";
ShellLabel[{n_,l_,j_}]:=Row[{n,Subscript[SpectroscopicLetter[l],\
SolidusFractionize[j]]}];\
\>", "Program",
 CellChangeTimes->{{3.49226469321875*^9, 3.492264755703125*^9}, {
  3.5662620041170654`*^9, 3.566262014767229*^9}, {3.56633416075095*^9, 
  3.566334163824155*^9}, {3.5663393834219923`*^9, 3.5663393861419954`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "define", " ", "functions", " ", "for", " ", "coloring", " ", "orbitals", 
    " ", "by", " ", "parity", " ", "of", " ", "major", " ", "shell"}], " ", 
   "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"ShellGrade", "[", 
      RowBox[{"{", 
       RowBox[{"n_", ",", "l_", ",", "j_"}], "}"}], "]"}], ":=", 
     RowBox[{"Mod", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"2", "*", "n"}], "+", "l"}], ",", "2"}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ShellColor", "[", 
      RowBox[{"{", 
       RowBox[{"n_", ",", "l_", ",", "j_"}], "}"}], "]"}], ":=", 
     RowBox[{"Switch", "[", 
      RowBox[{
       RowBox[{"ShellGrade", "[", 
        RowBox[{"{", 
         RowBox[{"n", ",", "l", ",", "j"}], "}"}], "]"}], ",", "0", ",", 
       "Blue", ",", "1", ",", "Red"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
   "\n", 
   RowBox[{"(*", " ", 
    RowBox[{"define", " ", "energy", " ", "function"}], " ", "*)"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ESM", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"ho_", ",", "D_", ",", "xi_"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"n_", ",", "l_", ",", "j_"}], "}"}]}], "]"}], ":=", 
     RowBox[{
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", "*", "n"}], "+", "l", "+", 
         RowBox[{"3", "/", "2"}]}], ")"}], "*", "ho"}], "+", 
      RowBox[{"D", "*", "l", "*", 
       RowBox[{"(", 
        RowBox[{"l", "+", "1"}], ")"}]}], "+", 
      RowBox[{
       RowBox[{"1", "/", "2"}], "*", "xi", "*", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"+", "l"}], "*", 
          RowBox[{"KroneckerDelta", "[", 
           RowBox[{"j", ",", 
            RowBox[{"l", "+", 
             RowBox[{"1", "/", "2"}]}]}], "]"}]}], "-", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"l", "+", "1"}], ")"}], "*", 
          RowBox[{"KroneckerDelta", "[", 
           RowBox[{"j", ",", 
            RowBox[{"l", "-", 
             RowBox[{"1", "/", "2"}]}]}], "]"}]}]}], ")"}]}]}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "define", " ", "function", " ", "to", " ", "generate", " ", "set", " ", 
     "of", " ", "orbitals", " ", "by", " ", "major", " ", "shell"}], " ", 
    "*)"}], "\n", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"LevelSetOrbital", "[", "N_", "]"}], ":=", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"1", "/", "2"}], "*", 
          RowBox[{"(", 
           RowBox[{"N", "-", "l"}], ")"}]}], ",", "l"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"l", ",", 
         RowBox[{"Mod", "[", 
          RowBox[{"N", ",", "2"}], "]"}], ",", "N", ",", "2"}], "}"}]}], 
      "]"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"LevelSetSpinOrbit", "[", "NMax_", "]"}], ":=", 
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"n", ",", "l", ",", "j"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Last", "[", 
        RowBox[{"Last", "[", 
         RowBox[{"Reap", "[", "\[IndentingNewLine]", 
          RowBox[{"Do", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"{", 
               RowBox[{"n", ",", "l"}], "}"}], "=", "nl"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"j", "=", 
              RowBox[{"l", "+", 
               RowBox[{"sigma", "*", 
                RowBox[{"1", "/", "2"}]}]}]}], ";", "\[IndentingNewLine]", 
             RowBox[{"If", "[", 
              RowBox[{
               RowBox[{"j", ">", "0"}], ",", 
               RowBox[{"Sow", "[", 
                RowBox[{"{", 
                 RowBox[{"n", ",", "l", ",", "j"}], "}"}], "]"}]}], "]"}]}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"N", ",", "0", ",", "NMax"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"nl", ",", 
              RowBox[{"LevelSetOrbital", "[", "N", "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"sigma", ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"-", "1"}], ",", 
                RowBox[{"+", "1"}]}], "}"}]}], "}"}]}], "\[IndentingNewLine]",
            "]"}], "\[IndentingNewLine]", "]"}], "]"}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], ";"}], "\n", "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
     RowBox[{"define", " ", "level", " ", "set", " ", "to", " ", 
      RowBox[{"plot", ":", " ", 
       RowBox[{"levels", " ", "through", " ", "N"}]}]}], "=", 
     RowBox[{"3", " ", "plus", " ", 
      RowBox[{"g9", "/", "2"}], " ", "orbit"}]}], " ", "*)"}], 
   "\[IndentingNewLine]", "\n", 
   RowBox[{
    RowBox[{"PlotLevelSet", "=", 
     RowBox[{"Append", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"LevelSetSpinOrbit", "[", "3", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "4", ",", 
         RowBox[{"9", "/", "2"}]}], "}"}]}], "\[IndentingNewLine]", "]"}]}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Print", "[", 
     RowBox[{"\"\<Level set: \>\"", ",", "PlotLevelSet"}], "]"}], ";"}], "\n",
    "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{"make", " ", "figure"}], " ", "*)"}], "\n", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"HOParams", "=", 
     RowBox[{"{", 
      RowBox[{"6.9", ",", 
       RowBox[{"-", "0.3"}], ",", 
       RowBox[{"-", "0.6"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"HOParams0", "=", 
     RowBox[{"HOParams", "*", 
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0"}], "}"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"HOParams1", "=", 
     RowBox[{"HOParams", "*", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "0"}], "}"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"HOParams2", "=", 
     RowBox[{"HOParams", "*", 
      RowBox[{"{", 
       RowBox[{"1", ",", "1", ",", "1"}], "}"}]}]}], ";"}], 
   "\[IndentingNewLine]", 
   RowBox[{"Figure", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"SetOptions", "[", 
          RowBox[{"Lev", ",", 
           RowBox[{"LineThickness", "\[Rule]", "2"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"SetOptions", "[", 
          RowBox[{"Connector", ",", 
           RowBox[{"LineDashing", "\[Rule]", "2"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
          RowBox[{"0", ",", "\[IndentingNewLine]", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"Lev", "\[LeftDoubleBracket]", 
                 RowBox[{"{", 
                  RowBox[{"\"\<lev\>\"", ",", "nlj", ",", "0"}], "}"}], 
                 "\[RightDoubleBracket]"}], "[", 
                RowBox[{"0", ",", "1", ",", 
                 RowBox[{"ESM", "[", 
                  RowBox[{"HOParams0", ",", "nlj"}], "]"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Color", "\[Rule]", 
                  RowBox[{"ShellColor", "[", "nlj", "]"}]}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"LeftTextOffset", "\[Rule]", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"+", "1"}], ",", "0"}], "}"}]}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"Switch", "[", "\[IndentingNewLine]", 
                  RowBox[{"nlj", ",", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "l_", ",", "j_"}], "}"}], "/;", 
                    RowBox[{"(", 
                    RowBox[{"j", "\[Equal]", 
                    RowBox[{"l", "+", 
                    RowBox[{"1", "/", "2"}]}]}], ")"}]}], ",", 
                   RowBox[{"LeftLabel", "\[Rule]", 
                    RowBox[{"Row", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"nlj", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", 
                    "\"\<\[ThinSpace]\[HBar]\[Omega]\>\""}], "}"}], "]"}]}], 
                   ",", "\[IndentingNewLine]", "_", ",", 
                   RowBox[{"{", "}"}]}], "\[IndentingNewLine]", "]"}]}], 
                "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"nlj", ",", "PlotLevelSet"}], "}"}]}], 
              "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
            "}"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]",
          "\[IndentingNewLine]", 
         RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
          RowBox[{"1", ",", "\[IndentingNewLine]", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{"Table", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"Lev", "\[LeftDoubleBracket]", 
                  RowBox[{"{", 
                   RowBox[{"\"\<lev\>\"", ",", "nlj", ",", "1"}], "}"}], 
                  "\[RightDoubleBracket]"}], "[", 
                 RowBox[{"0", ",", "1", ",", 
                  RowBox[{"ESM", "[", 
                   RowBox[{"HOParams1", ",", "nlj"}], "]"}], ",", 
                  RowBox[{"Color", "\[Rule]", 
                   RowBox[{"ShellColor", "[", "nlj", "]"}]}]}], "]"}], ",", 
                "\[IndentingNewLine]", 
                RowBox[{"Connector", "[", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"\"\<lev\>\"", ",", "nlj", ",", "0"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"\"\<lev\>\"", ",", "nlj", ",", "1"}], "}"}], ",", 
                  RowBox[{"Color", "\[Rule]", 
                   RowBox[{"ShellColor", "[", "nlj", "]"}]}]}], "]"}]}], 
               "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"nlj", ",", "PlotLevelSet"}], "}"}]}], 
             "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "}"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"WithOrigin", "[", "\[IndentingNewLine]", 
          RowBox[{"2", ",", "\[IndentingNewLine]", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"SetOptionOverrides", "[", "\[IndentingNewLine]", 
              RowBox[{"{", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"\"\<lev\>\"", ",", 
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", 
                    RowBox[{"3", "/", "2"}]}], "}"}], ",", "2"}], "}"}], "->", 
                 RowBox[{"{", 
                  RowBox[{"RightTextNudge", "\[Rule]", 
                   RowBox[{"-", "6"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"\"\<lev\>\"", ",", 
                   RowBox[{"{", 
                    RowBox[{"0", ",", "4", ",", 
                    RowBox[{"9", "/", "2"}]}], "}"}], ",", "2"}], "}"}], "->", 
                 RowBox[{"{", 
                  RowBox[{"RightTextNudge", "\[Rule]", 
                   RowBox[{"-", "3"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"\"\<lev\>\"", ",", 
                   RowBox[{"{", 
                    RowBox[{"1", ",", "1", ",", 
                    RowBox[{"1", "/", "2"}]}], "}"}], ",", "2"}], "}"}], "->", 
                 RowBox[{"{", 
                  RowBox[{"RightTextNudge", "\[Rule]", 
                   RowBox[{"+", "6"}]}], "}"}]}]}], "\[IndentingNewLine]", 
               "}"}], "\[IndentingNewLine]", "]"}], ";", 
             "\[IndentingNewLine]", 
             RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{
                  RowBox[{"Lev", "\[LeftDoubleBracket]", 
                   RowBox[{"{", 
                    RowBox[{"\"\<lev\>\"", ",", "nlj", ",", "2"}], "}"}], 
                   "\[RightDoubleBracket]"}], "[", 
                  RowBox[{"0", ",", "1", ",", 
                   RowBox[{"ESM", "[", 
                    RowBox[{"HOParams2", ",", "nlj"}], "]"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Color", "\[Rule]", 
                    RowBox[{"ShellColor", "[", "nlj", "]"}]}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"RightLabel", "\[Rule]", 
                    RowBox[{"Grid", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"ShellLabel", "[", "nlj", "]"}], ",", 
                    RowBox[{"FixedPointForm", "[", 
                    RowBox[{
                    RowBox[{"ESM", "[", 
                    RowBox[{"HOParams2", ",", "nlj"}], "]"}], ",", "2"}], 
                    "]"}]}], "}"}], "}"}], ",", 
                    RowBox[{"ItemSize", "\[Rule]", "3"}], ",", 
                    RowBox[{"Spacings", "\[Rule]", "0"}]}], "]"}]}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"RightTextOffset", "->", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], 
                  "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
                 RowBox[{"Connector", "[", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"\"\<lev\>\"", ",", "nlj", ",", "1"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"\"\<lev\>\"", ",", "nlj", ",", "2"}], "}"}], ",", 
                   RowBox[{"Color", "\[Rule]", 
                    RowBox[{"ShellColor", "[", "nlj", "]"}]}]}], "]"}]}], 
                "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"nlj", ",", "PlotLevelSet"}], "}"}]}], 
              "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "}"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", 
         RowBox[{"SetOptions", "[", 
          RowBox[{"BandLabel", ",", 
           RowBox[{"TextOffset", "\[Rule]", "Bottom"}], ",", 
           RowBox[{"TextNudge", "\[Rule]", 
            RowBox[{"-", "25"}]}]}], "]"}], ";", "  ", 
         RowBox[{"(*", " ", 
          RowBox[{
          "align", " ", "bottoms", " ", "rather", " ", "than", " ", "top", 
           " ", "of", " ", "subscript"}], " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"BandLabel", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"\"\<lev\>\"", ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", 
               RowBox[{"1", "/", "2"}]}], "}"}], ",", "0"}], "}"}], ",", 
           "\"\<HO\>\""}], "]"}], ";", "\[IndentingNewLine]", 
         RowBox[{"BandLabel", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"\"\<lev\>\"", ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", 
               RowBox[{"1", "/", "2"}]}], "}"}], ",", "1"}], "}"}], ",", 
           RowBox[{"Row", "[", 
            RowBox[{"{", 
             RowBox[{"\"\<HO+\>\"", ",", 
              RowBox[{"Superscript", "[", 
               RowBox[{
                RowBox[{"textbf", "[", "\"\<\[ScriptL]\>\"", "]"}], ",", 
                "2"}], "]"}]}], "}"}], "]"}]}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"BandLabel", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"\"\<lev\>\"", ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0", ",", 
               RowBox[{"1", "/", "2"}]}], "}"}], ",", "2"}], "}"}], ",", 
           RowBox[{"Row", "[", 
            RowBox[{"{", 
             RowBox[{"\"\<HO+\>\"", ",", 
              RowBox[{"Superscript", "[", 
               RowBox[{
                RowBox[{"textbf", "[", "\"\<\[ScriptL]\>\"", "]"}], ",", 
                "2"}], "]"}], ",", "\"\<+\>\"", ",", 
              RowBox[{"textbf", "[", "\"\<\[ScriptL]\>\"", "]"}], ",", 
              "\"\<\[CenterDot]\>\"", ",", 
              RowBox[{"textbf", "[", "\"\<s\>\"", "]"}]}], "}"}], "]"}]}], 
          "]"}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "4"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"5", ",", "35"}], "}"}]}], "}"}]}], ",", 
       RowBox[{"Frame", "\[Rule]", "False"}]}], "\[IndentingNewLine]", "]"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"CanvasSize", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"6", ",", "6"}], "}"}]}]}], "\[IndentingNewLine]", 
    "]"}]}]}]], "Input",
 CellChangeTimes->{{3.492264649796875*^9, 3.4922646850625*^9}, {
   3.492264779640625*^9, 3.492264836*^9}, {3.49226632103125*^9, 
   3.49226639190625*^9}, {3.566262040827629*^9, 3.5662620494877625`*^9}, 
   3.5663393818319893`*^9, {3.566682852006736*^9, 3.5666828665771613`*^9}, {
   3.566682906341631*^9, 3.5666829623145294`*^9}, {3.5666829948249865`*^9, 
   3.5666830053082047`*^9}}],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Level set: \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", 
       FractionBox["1", "2"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", 
       FractionBox["1", "2"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", 
       FractionBox["3", "2"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", 
       FractionBox["1", "2"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", 
       FractionBox["3", "2"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "2", ",", 
       FractionBox["5", "2"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", 
       FractionBox["1", "2"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1", ",", 
       FractionBox["3", "2"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "3", ",", 
       FractionBox["5", "2"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "3", ",", 
       FractionBox["7", "2"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "4", ",", 
       FractionBox["9", "2"]}], "}"}]}], "}"}]}],
  SequenceForm["Level set: ", {{0, 0, 
     Rational[1, 2]}, {0, 1, 
     Rational[1, 2]}, {0, 1, 
     Rational[3, 2]}, {1, 0, 
     Rational[1, 2]}, {0, 2, 
     Rational[3, 2]}, {0, 2, 
     Rational[5, 2]}, {1, 1, 
     Rational[1, 2]}, {1, 1, 
     Rational[3, 2]}, {0, 3, 
     Rational[5, 2]}, {0, 3, 
     Rational[7, 2]}, {0, 4, 
     Rational[9, 2]}}],
  Editable->False]], "Print",
 CellChangeTimes->{3.5666830060882063`*^9, 3.5791220196395845`*^9, 
  3.583782383616172*^9, 3.5943060026254644`*^9}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 504}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 576},
       PlotRange->{{-72, 504}, {-72, 504}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0, 0}, {432, 432}]}, InsetBox[
      GraphicsBox[{
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{95.04, 77.04000000000002}, {164.16000000000003`, 
          77.04000000000002}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{95.04, 176.4}, {164.16000000000003`, 176.4}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{95.04, 176.4}, {164.16000000000003`, 176.4}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{95.04, 275.76000000000005`}, {164.16000000000003`, 
          275.76000000000005`}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{95.04, 275.76000000000005`}, {164.16000000000003`, 
          275.76000000000005`}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{95.04, 275.76000000000005`}, {164.16000000000003`, 
          275.76000000000005`}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{95.04, 375.12}, {164.16000000000003`, 375.12}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{95.04, 375.12}, {164.16000000000003`, 375.12}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{95.04, 375.12}, {164.16000000000003`, 375.12}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{95.04, 375.12}, {164.16000000000003`, 375.12}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{95.04, 474.48}, {164.16000000000003`, 474.48}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{181.44, 77.04000000000002}, {250.56, 77.04000000000002}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{164.16000000000003`, 77.04000000000002}, {181.44, 
          77.04000000000002}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{181.44, 167.76}, {250.56, 167.76}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{164.16000000000003`, 176.4}, {181.44, 167.76}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{181.44, 167.76}, {250.56, 167.76}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{164.16000000000003`, 176.4}, {181.44, 167.76}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{181.44, 275.76000000000005`}, {250.56, 
          275.76000000000005`}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{164.16000000000003`, 275.76000000000005`}, {181.44, 
          275.76000000000005`}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{181.44, 249.84000000000003`}, {250.56, 
          249.84000000000003`}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{164.16000000000003`, 275.76000000000005`}, {181.44, 
          249.84000000000003`}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{181.44, 249.84000000000003`}, {250.56, 
          249.84000000000003`}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{164.16000000000003`, 275.76000000000005`}, {181.44, 
          249.84000000000003`}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{181.44, 366.48}, {250.56, 366.48}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{164.16000000000003`, 375.12}, {181.44, 366.48}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{181.44, 366.48}, {250.56, 366.48}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{164.16000000000003`, 375.12}, {181.44, 366.48}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{181.44, 323.28000000000003`}, {250.56, 
          323.28000000000003`}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{164.16000000000003`, 375.12}, {181.44, 
          323.28000000000003`}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{181.44, 323.28000000000003`}, {250.56, 
          323.28000000000003`}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{164.16000000000003`, 375.12}, {181.44, 
          323.28000000000003`}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{181.44, 388.08000000000004`}, {250.56, 
          388.08000000000004`}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{164.16000000000003`, 474.48}, {181.44, 
          388.08000000000004`}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{267.84, 77.04000000000002}, {336.96, 77.04000000000002}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{250.56, 77.04000000000002}, {267.84, 77.04000000000002}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{267.84, 176.4}, {336.96, 176.4}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{250.56, 167.76}, {267.84, 176.4}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{267.84, 163.43999999999997`}, {336.96, 
          163.43999999999997`}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{250.56, 167.76}, {267.84, 163.43999999999997`}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{267.84, 275.76000000000005`}, {336.96, 
          275.76000000000005`}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{250.56, 275.76000000000005`}, {267.84, 
          275.76000000000005`}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{267.84, 262.8}, {336.96, 262.8}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{250.56, 249.84000000000003`}, {267.84, 262.8}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{267.84, 241.2}, {336.96, 241.2}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{250.56, 249.84000000000003`}, {267.84, 241.2}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{267.84, 375.12}, {336.96, 375.12}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{250.56, 366.48}, {267.84, 375.12}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{267.84, 362.15999999999997`}, {336.96, 
          362.15999999999997`}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{250.56, 366.48}, {267.84, 362.15999999999997`}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{267.84, 340.56000000000006`}, {336.96, 
          340.56000000000006`}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{250.56, 323.28000000000003`}, {267.84, 
          340.56000000000006`}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{267.84, 310.32000000000005`}, {336.96, 
          310.32000000000005`}}]}, 
        {RGBColor[1, 0, 0], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{250.56, 323.28000000000003`}, {267.84, 
          310.32000000000005`}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{267.84, 370.80000000000007`}, {336.96, 
          370.80000000000007`}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[1], AbsoluteDashing[2], CapForm[
         None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{250.56, 388.08000000000004`}, {267.84, 
          370.80000000000007`}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{"0","\"\[ThinSpace]\[HBar]\[Omega]\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[0, 0, 1],
            FrontFaceColor->RGBColor[0, 0, 1],
            BackFaceColor->RGBColor[0, 0, 1],
            GraphicsColor->RGBColor[0, 0, 1],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[0, 0, 1]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {95.04, 77.04000000000002}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{"1","\"\[ThinSpace]\[HBar]\[Omega]\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[1, 0, 0],
            FrontFaceColor->RGBColor[1, 0, 0],
            BackFaceColor->RGBColor[1, 0, 0],
            GraphicsColor->RGBColor[1, 0, 0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[1, 0, 0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {95.04, 176.4}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{"2","\"\[ThinSpace]\[HBar]\[Omega]\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[0, 0, 1],
            FrontFaceColor->RGBColor[0, 0, 1],
            BackFaceColor->RGBColor[0, 0, 1],
            GraphicsColor->RGBColor[0, 0, 1],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[0, 0, 1]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {95.04, 275.76000000000005`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{"3","\"\[ThinSpace]\[HBar]\[Omega]\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[1, 0, 0],
            FrontFaceColor->RGBColor[1, 0, 0],
            BackFaceColor->RGBColor[1, 0, 0],
            GraphicsColor->RGBColor[1, 0, 0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[1, 0, 0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {95.04, 375.12}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{"4","\"\[ThinSpace]\[HBar]\[Omega]\""},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[0, 0, 1],
            FrontFaceColor->RGBColor[0, 0, 1],
            BackFaceColor->RGBColor[0, 0, 1],
            GraphicsColor->RGBColor[0, 0, 1],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[0, 0, 1]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {95.04, 474.48}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {
                 TemplateBox[{"0",SubscriptBox["\"s\"", 
                    TagBox[
                    
                    GridBox[{{"1", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                  "RowDefault"], "\<\" 10.35\"\>"}
               },
               AutoDelete->False,
               GridBoxItemSize->{"Columns" -> {{3}}},
               GridBoxSpacings->{"Columns" -> {{0}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[0, 0, 1],
            FrontFaceColor->RGBColor[0, 0, 1],
            BackFaceColor->RGBColor[0, 0, 1],
            GraphicsColor->RGBColor[0, 0, 1],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[0, 0, 1]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 77.04000000000002}, {-1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {
                 TemplateBox[{"0",SubscriptBox["\"p\"", 
                    TagBox[
                    
                    GridBox[{{"1", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                  "RowDefault"], "\<\" 17.25\"\>"}
               },
               AutoDelete->False,
               GridBoxItemSize->{"Columns" -> {{3}}},
               GridBoxSpacings->{"Columns" -> {{0}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[1, 0, 0],
            FrontFaceColor->RGBColor[1, 0, 0],
            BackFaceColor->RGBColor[1, 0, 0],
            GraphicsColor->RGBColor[1, 0, 0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[1, 0, 0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 176.4}, {-1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {
                 TemplateBox[{"0",SubscriptBox["\"p\"", 
                    TagBox[
                    
                    GridBox[{{"3", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                  "RowDefault"], "\<\" 16.35\"\>"}
               },
               AutoDelete->False,
               GridBoxItemSize->{"Columns" -> {{3}}},
               GridBoxSpacings->{"Columns" -> {{0}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[1, 0, 0],
            FrontFaceColor->RGBColor[1, 0, 0],
            BackFaceColor->RGBColor[1, 0, 0],
            GraphicsColor->RGBColor[1, 0, 0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[1, 0, 0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 163.43999999999997`}, {-1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {
                 TemplateBox[{"1",SubscriptBox["\"s\"", 
                    TagBox[
                    
                    GridBox[{{"1", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                  "RowDefault"], "\<\" 24.15\"\>"}
               },
               AutoDelete->False,
               GridBoxItemSize->{"Columns" -> {{3}}},
               GridBoxSpacings->{"Columns" -> {{0}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[0, 0, 1],
            FrontFaceColor->RGBColor[0, 0, 1],
            BackFaceColor->RGBColor[0, 0, 1],
            GraphicsColor->RGBColor[0, 0, 1],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[0, 0, 1]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 275.76000000000005`}, {-1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {
                 TemplateBox[{"0",SubscriptBox["\"d\"", 
                    TagBox[
                    
                    GridBox[{{"3", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                  "RowDefault"], "\<\" 23.25\"\>"}
               },
               AutoDelete->False,
               GridBoxItemSize->{"Columns" -> {{3}}},
               GridBoxSpacings->{"Columns" -> {{0}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[0, 0, 1],
            FrontFaceColor->RGBColor[0, 0, 1],
            BackFaceColor->RGBColor[0, 0, 1],
            GraphicsColor->RGBColor[0, 0, 1],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[0, 0, 1]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 262.8}, {-1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {
                 TemplateBox[{"0",SubscriptBox["\"d\"", 
                    TagBox[
                    
                    GridBox[{{"5", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                  "RowDefault"], "\<\" 21.75\"\>"}
               },
               AutoDelete->False,
               GridBoxItemSize->{"Columns" -> {{3}}},
               GridBoxSpacings->{"Columns" -> {{0}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[0, 0, 1],
            FrontFaceColor->RGBColor[0, 0, 1],
            BackFaceColor->RGBColor[0, 0, 1],
            GraphicsColor->RGBColor[0, 0, 1],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[0, 0, 1]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 241.2}, {-1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {
                 TemplateBox[{"1",SubscriptBox["\"p\"", 
                    TagBox[
                    
                    GridBox[{{"1", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                  "RowDefault"], "\<\" 31.05\"\>"}
               },
               AutoDelete->False,
               GridBoxItemSize->{"Columns" -> {{3}}},
               GridBoxSpacings->{"Columns" -> {{0}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[1, 0, 0],
            FrontFaceColor->RGBColor[1, 0, 0],
            BackFaceColor->RGBColor[1, 0, 0],
            GraphicsColor->RGBColor[1, 0, 0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[1, 0, 0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 381.12}, {-1, 0}, Automatic, {1, 0}],
         InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {
                 TemplateBox[{"1",SubscriptBox["\"p\"", 
                    TagBox[
                    
                    GridBox[{{"3", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                  "RowDefault"], "\<\" 30.15\"\>"}
               },
               AutoDelete->False,
               GridBoxItemSize->{"Columns" -> {{3}}},
               GridBoxSpacings->{"Columns" -> {{0}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[1, 0, 0],
            FrontFaceColor->RGBColor[1, 0, 0],
            BackFaceColor->RGBColor[1, 0, 0],
            GraphicsColor->RGBColor[1, 0, 0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[1, 0, 0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 356.15999999999997`}, {-1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {
                 TemplateBox[{"0",SubscriptBox["\"f\"", 
                    TagBox[
                    
                    GridBox[{{"5", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                  "RowDefault"], "\<\" 28.65\"\>"}
               },
               AutoDelete->False,
               GridBoxItemSize->{"Columns" -> {{3}}},
               GridBoxSpacings->{"Columns" -> {{0}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[1, 0, 0],
            FrontFaceColor->RGBColor[1, 0, 0],
            BackFaceColor->RGBColor[1, 0, 0],
            GraphicsColor->RGBColor[1, 0, 0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[1, 0, 0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 340.56000000000006`}, {-1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {
                 TemplateBox[{"0",SubscriptBox["\"f\"", 
                    TagBox[
                    
                    GridBox[{{"7", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                  "RowDefault"], "\<\" 26.55\"\>"}
               },
               AutoDelete->False,
               GridBoxItemSize->{"Columns" -> {{3}}},
               GridBoxSpacings->{"Columns" -> {{0}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[1, 0, 0],
            FrontFaceColor->RGBColor[1, 0, 0],
            BackFaceColor->RGBColor[1, 0, 0],
            GraphicsColor->RGBColor[1, 0, 0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[1, 0, 0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 310.32000000000005`}, {-1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[GridBox[{
                {
                 TemplateBox[{"0",SubscriptBox["\"g\"", 
                    TagBox[
                    
                    GridBox[{{"9", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                  "RowDefault"], "\<\" 30.75\"\>"}
               },
               AutoDelete->False,
               GridBoxItemSize->{"Columns" -> {{3}}},
               GridBoxSpacings->{"Columns" -> {{0}}}],
              "Grid"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->RGBColor[0, 0, 1],
            FrontFaceColor->RGBColor[0, 0, 1],
            BackFaceColor->RGBColor[0, 0, 1],
            GraphicsColor->RGBColor[0, 0, 1],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->RGBColor[0, 0, 1]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 367.80000000000007`}, {-1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"HO\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {129.60000000000002`, 49.04000000000002}, {0, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{"\"HO+\"",TemplateBox[{
                 TagBox[
                  StyleBox["\"\[ScriptL]\"", FontWeight -> "Bold"], 
                  StyleForm[#, FontWeight -> "Bold"]& ], "2"}, "Superscript"]},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {216., 49.04000000000002}, {0, -1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TemplateBox[{"\"HO+\"",TemplateBox[{
                 TagBox[
                  StyleBox["\"\[ScriptL]\"", FontWeight -> "Bold"], 
                  StyleForm[#, FontWeight -> "Bold"]& ], "2"}, "Superscript"],
               "\"+\"",TagBox[
                StyleBox["\"\[ScriptL]\"", FontWeight -> "Bold"], 
                StyleForm[#, FontWeight -> "Bold"]& ],"\"\[CenterDot]\"",
               TagBox[
                StyleBox["\"s\"", FontWeight -> "Bold"], 
                StyleForm[#, FontWeight -> "Bold"]& ]},
              "RowDefault"],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->16,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {302.4, 49.04000000000002}, {0, -1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{"0","\"\[ThinSpace]\[HBar]\[Omega]\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[0, 0, 1],
           FrontFaceColor->RGBColor[0, 0, 1],
           BackFaceColor->RGBColor[0, 0, 1],
           GraphicsColor->RGBColor[0, 0, 1],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[0, 0, 1]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {95.04, 77.04000000000002}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{"1","\"\[ThinSpace]\[HBar]\[Omega]\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[1, 0, 0],
           FrontFaceColor->RGBColor[1, 0, 0],
           BackFaceColor->RGBColor[1, 0, 0],
           GraphicsColor->RGBColor[1, 0, 0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[1, 0, 0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {95.04, 176.4}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{"2","\"\[ThinSpace]\[HBar]\[Omega]\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[0, 0, 1],
           FrontFaceColor->RGBColor[0, 0, 1],
           BackFaceColor->RGBColor[0, 0, 1],
           GraphicsColor->RGBColor[0, 0, 1],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[0, 0, 1]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {95.04, 275.76000000000005`}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{"3","\"\[ThinSpace]\[HBar]\[Omega]\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[1, 0, 0],
           FrontFaceColor->RGBColor[1, 0, 0],
           BackFaceColor->RGBColor[1, 0, 0],
           GraphicsColor->RGBColor[1, 0, 0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[1, 0, 0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {95.04, 375.12}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{"4","\"\[ThinSpace]\[HBar]\[Omega]\""},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[0, 0, 1],
           FrontFaceColor->RGBColor[0, 0, 1],
           BackFaceColor->RGBColor[0, 0, 1],
           GraphicsColor->RGBColor[0, 0, 1],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[0, 0, 1]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {95.04, 474.48}, {1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {
                TemplateBox[{"0",SubscriptBox["\"s\"", 
                   TagBox[
                    
                    GridBox[{{"1", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                 "RowDefault"], "\<\" 10.35\"\>"}
              },
              AutoDelete->False,
              GridBoxItemSize->{"Columns" -> {{3}}},
              GridBoxSpacings->{"Columns" -> {{0}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[0, 0, 1],
           FrontFaceColor->RGBColor[0, 0, 1],
           BackFaceColor->RGBColor[0, 0, 1],
           GraphicsColor->RGBColor[0, 0, 1],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[0, 0, 1]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 77.04000000000002}, {-1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {
                TemplateBox[{"0",SubscriptBox["\"p\"", 
                   TagBox[
                    
                    GridBox[{{"1", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                 "RowDefault"], "\<\" 17.25\"\>"}
              },
              AutoDelete->False,
              GridBoxItemSize->{"Columns" -> {{3}}},
              GridBoxSpacings->{"Columns" -> {{0}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[1, 0, 0],
           FrontFaceColor->RGBColor[1, 0, 0],
           BackFaceColor->RGBColor[1, 0, 0],
           GraphicsColor->RGBColor[1, 0, 0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[1, 0, 0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 176.4}, {-1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {
                TemplateBox[{"0",SubscriptBox["\"p\"", 
                   TagBox[
                    
                    GridBox[{{"3", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                 "RowDefault"], "\<\" 16.35\"\>"}
              },
              AutoDelete->False,
              GridBoxItemSize->{"Columns" -> {{3}}},
              GridBoxSpacings->{"Columns" -> {{0}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[1, 0, 0],
           FrontFaceColor->RGBColor[1, 0, 0],
           BackFaceColor->RGBColor[1, 0, 0],
           GraphicsColor->RGBColor[1, 0, 0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[1, 0, 0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 163.43999999999997`}, {-1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {
                TemplateBox[{"1",SubscriptBox["\"s\"", 
                   TagBox[
                    
                    GridBox[{{"1", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                 "RowDefault"], "\<\" 24.15\"\>"}
              },
              AutoDelete->False,
              GridBoxItemSize->{"Columns" -> {{3}}},
              GridBoxSpacings->{"Columns" -> {{0}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[0, 0, 1],
           FrontFaceColor->RGBColor[0, 0, 1],
           BackFaceColor->RGBColor[0, 0, 1],
           GraphicsColor->RGBColor[0, 0, 1],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[0, 0, 1]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 275.76000000000005`}, {-1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {
                TemplateBox[{"0",SubscriptBox["\"d\"", 
                   TagBox[
                    
                    GridBox[{{"3", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                 "RowDefault"], "\<\" 23.25\"\>"}
              },
              AutoDelete->False,
              GridBoxItemSize->{"Columns" -> {{3}}},
              GridBoxSpacings->{"Columns" -> {{0}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[0, 0, 1],
           FrontFaceColor->RGBColor[0, 0, 1],
           BackFaceColor->RGBColor[0, 0, 1],
           GraphicsColor->RGBColor[0, 0, 1],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[0, 0, 1]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 262.8}, {-1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {
                TemplateBox[{"0",SubscriptBox["\"d\"", 
                   TagBox[
                    
                    GridBox[{{"5", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                 "RowDefault"], "\<\" 21.75\"\>"}
              },
              AutoDelete->False,
              GridBoxItemSize->{"Columns" -> {{3}}},
              GridBoxSpacings->{"Columns" -> {{0}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[0, 0, 1],
           FrontFaceColor->RGBColor[0, 0, 1],
           BackFaceColor->RGBColor[0, 0, 1],
           GraphicsColor->RGBColor[0, 0, 1],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[0, 0, 1]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 241.2}, {-1, 0}, Automatic, {1, 0}], 
        InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {
                TemplateBox[{"1",SubscriptBox["\"p\"", 
                   TagBox[
                    
                    GridBox[{{"1", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                 "RowDefault"], "\<\" 31.05\"\>"}
              },
              AutoDelete->False,
              GridBoxItemSize->{"Columns" -> {{3}}},
              GridBoxSpacings->{"Columns" -> {{0}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[1, 0, 0],
           FrontFaceColor->RGBColor[1, 0, 0],
           BackFaceColor->RGBColor[1, 0, 0],
           GraphicsColor->RGBColor[1, 0, 0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[1, 0, 0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 381.12}, {-1, 0}, Automatic, {1, 0}],
         InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {
                TemplateBox[{"1",SubscriptBox["\"p\"", 
                   TagBox[
                    
                    GridBox[{{"3", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                 "RowDefault"], "\<\" 30.15\"\>"}
              },
              AutoDelete->False,
              GridBoxItemSize->{"Columns" -> {{3}}},
              GridBoxSpacings->{"Columns" -> {{0}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[1, 0, 0],
           FrontFaceColor->RGBColor[1, 0, 0],
           BackFaceColor->RGBColor[1, 0, 0],
           GraphicsColor->RGBColor[1, 0, 0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[1, 0, 0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 356.15999999999997`}, {-1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {
                TemplateBox[{"0",SubscriptBox["\"f\"", 
                   TagBox[
                    
                    GridBox[{{"5", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                 "RowDefault"], "\<\" 28.65\"\>"}
              },
              AutoDelete->False,
              GridBoxItemSize->{"Columns" -> {{3}}},
              GridBoxSpacings->{"Columns" -> {{0}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[1, 0, 0],
           FrontFaceColor->RGBColor[1, 0, 0],
           BackFaceColor->RGBColor[1, 0, 0],
           GraphicsColor->RGBColor[1, 0, 0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[1, 0, 0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 340.56000000000006`}, {-1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {
                TemplateBox[{"0",SubscriptBox["\"f\"", 
                   TagBox[
                    
                    GridBox[{{"7", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                 "RowDefault"], "\<\" 26.55\"\>"}
              },
              AutoDelete->False,
              GridBoxItemSize->{"Columns" -> {{3}}},
              GridBoxSpacings->{"Columns" -> {{0}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[1, 0, 0],
           FrontFaceColor->RGBColor[1, 0, 0],
           BackFaceColor->RGBColor[1, 0, 0],
           GraphicsColor->RGBColor[1, 0, 0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[1, 0, 0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 310.32000000000005`}, {-1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[GridBox[{
               {
                TemplateBox[{"0",SubscriptBox["\"g\"", 
                   TagBox[
                    
                    GridBox[{{"9", "\"/\"", "2"}}, AutoDelete -> False, 
                    BaselinePosition -> {{1, 3}, Baseline}, 
                    GridBoxItemSize -> {
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
                    GridBoxSpacings -> {"Columns" -> {{0}}}], "Grid"]]},
                 "RowDefault"], "\<\" 30.75\"\>"}
              },
              AutoDelete->False,
              GridBoxItemSize->{"Columns" -> {{3}}},
              GridBoxSpacings->{"Columns" -> {{0}}}],
             "Grid"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->RGBColor[0, 0, 1],
           FrontFaceColor->RGBColor[0, 0, 1],
           BackFaceColor->RGBColor[0, 0, 1],
           GraphicsColor->RGBColor[0, 0, 1],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->RGBColor[0, 0, 1]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {336.96, 367.80000000000007`}, {-1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"HO\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {129.60000000000002`, 49.04000000000002}, {0, -1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{"\"HO+\"",TemplateBox[{
                TagBox[
                 StyleBox["\"\[ScriptL]\"", FontWeight -> "Bold"], 
                 StyleForm[#, FontWeight -> "Bold"]& ], "2"}, "Superscript"]},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {216., 49.04000000000002}, {0, -1}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TemplateBox[{"\"HO+\"",TemplateBox[{
                TagBox[
                 StyleBox["\"\[ScriptL]\"", FontWeight -> "Bold"], 
                 StyleForm[#, FontWeight -> "Bold"]& ], "2"}, "Superscript"],
              "\"+\"",TagBox[
               StyleBox["\"\[ScriptL]\"", FontWeight -> "Bold"], 
               StyleForm[#, FontWeight -> "Bold"]& ],"\"\[CenterDot]\"",TagBox[
               StyleBox["\"s\"", FontWeight -> "Bold"], 
               StyleForm[#, FontWeight -> "Bold"]& ]},
             "RowDefault"],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->16,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {302.4, 49.04000000000002}, {0, -1}, 
         Automatic, {1, 0}]},
       Frame->False,
       ImageSize->{432, 432},
       PlotRange->{{0, 432}, {0, 432}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 504}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 576},
       PlotRange->{{-72, 504}, {-72, 504}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 504}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 576},
       PlotRange->{{-72, 504}, {-72, 504}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->1,
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{576, 576},
  PlotRange->{{-72, 504}, {-72, 504}}]], "Output",
 CellChangeTimes->{{3.492288406125*^9, 3.492288434921875*^9}, 
   3.492288666953125*^9, 3.5075135591875*^9, 3.507513641671875*^9, 
   3.52003374996875*^9, 3.52003592215625*^9, 3.52003603728125*^9, 
   3.52003612378125*^9, {3.52003617915625*^9, 3.52003620384375*^9}, 
   3.52003623434375*^9, 3.520036320625*^9, 3.520036434859375*^9, {
   3.5200364706875*^9, 3.52003648371875*^9}, {3.5200365795*^9, 
   3.52003660678125*^9}, 3.52003665159375*^9, 3.520036702796875*^9, 
   3.52106219840625*^9, 3.524748348875*^9, {3.5663343113448143`*^9, 
   3.566334324121237*^9}, 3.5663366682988997`*^9, 3.5663367539430504`*^9, 
   3.566336820898368*^9, 3.566337229088781*^9, 3.56633956036224*^9, 
   3.5663395958722897`*^9, 3.566340357430358*^9, 3.5666828399947147`*^9, {
   3.5666829877893744`*^9, 3.56668300856861*^9}, 3.579122021335682*^9, 
   3.5837823855911746`*^9, 3.5943060042454667`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Molecular potentials and spectra: Combining plots and level schemes in one \
figure\
\>", "Subsection",
 CellChangeTimes->{{3.492288566921875*^9, 3.4922886273125*^9}}],

Cell["\<\
This figure illustrates several possibilities for drawing a figure:

\t1. Creating multipanel plots with unequal panel sizes, gaps between panels, \
and colored frames
\t
\t2. Including functions in a plot, and controlling their appearance through \
FigLine
\t
\t3. Drawing axes with FigAxis
\t
\t4. Annotating plots with drawing objects, here FigCircle
\t
\t5. Defining functions (here U2Lev and SO3Lev) to draw levels based on \
energy formulas
\t
\t6. Using Table to construct level schemes with many levels automatically\t
\t
Note: The letter \[ScriptCapitalE] is \[OpenCurlyDoubleQuote]ScriptCapitalE\
\[CloseCurlyDoubleQuote], entered as Escape - s - c - E - Escape.\
\>", "Text",
 CellChangeTimes->{{3.520535579734375*^9, 3.5205355894375*^9}, {
  3.520535669125*^9, 3.52053570528125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"U2Lev", "[", 
    RowBox[{"k_", ",", "n_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Lev", "\[LeftDoubleBracket]", 
     RowBox[{"{", 
      RowBox[{"\"\<lev\>\"", ",", "\"\<U2\>\"", ",", "k", ",", "n"}], "}"}], 
     "\[RightDoubleBracket]"}], "[", 
    RowBox[{"k", ",", 
     RowBox[{"k", "+", "1"}], ",", 
     RowBox[{"epsilon", "*", "n"}], ",", 
     RowBox[{"LeftLabel", "\[Rule]", 
      RowBox[{"n", "-", 
       RowBox[{"2", "*", "k"}]}]}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SO3Lev", "[", 
     RowBox[{"v_", ",", "l_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"Lev", "\[LeftDoubleBracket]", 
      RowBox[{"{", 
       RowBox[{"\"\<lev\>\"", ",", "\"\<SO3\>\"", ",", "v", ",", "l"}], "}"}],
       "\[RightDoubleBracket]"}], "[", 
     RowBox[{"v", ",", 
      RowBox[{"v", "+", "1"}], ",", 
      RowBox[{"v", "+", 
       RowBox[{"b", "*", 
        RowBox[{"l", "^", "2"}]}]}], ",", 
      RowBox[{"LeftLabel", "\[Rule]", "l"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]"}], "\n", 
 RowBox[{"Figure", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"Multipanel", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"set", " ", "up", " ", "drawing", " ", "options"}], " ", 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"SetOptions", "[", 
        RowBox[{"FigObject", ",", 
         RowBox[{"FontSize", "\[Rule]", "12"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SetOptions", "[", 
        RowBox[{"Lev", ",", 
         RowBox[{"LeftTextOffset", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"+", "1"}], ",", "0"}], "}"}]}], ",", 
         RowBox[{"LineThickness", "\[Rule]", "2"}], ",", 
         RowBox[{"Margin", "\[Rule]", "0.2"}], ",", 
         RowBox[{"WingTipWidth", "\[Rule]", "10"}], ",", 
         RowBox[{"WingSlopeWidth", "\[Rule]", "5"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SetOptions", "[", 
        RowBox[{"FigLine", ",", 
         RowBox[{"LineThickness", "\[Rule]", "2"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"SetOptions", "[", 
        RowBox[{"FigAxis", ",", 
         RowBox[{"HeadExtension", "\[Rule]", "0"}], ",", 
         RowBox[{"FontSize", "\[Rule]", "15"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"DefineStyle", "[", 
        RowBox[{"\"\<panellabel\>\"", ",", 
         RowBox[{"{", 
          RowBox[{"FigLabel", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Point", "\[Rule]", 
              RowBox[{"Scaled", "[", 
               RowBox[{"{", 
                RowBox[{"0.7", ",", "0.2"}], "}"}], "]"}]}], ",", 
             RowBox[{"FontSize", "\[Rule]", "20"}]}], "}"}]}], "}"}]}], "]"}],
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"set", " ", "up", " ", "multipanel", " ", "plot"}], " ", 
        "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"draw", " ", "functions"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"FigAxis", "[", 
            RowBox[{"Bottom", ",", "0", ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "3.2"}], "}"}], ",", 
             RowBox[{"AxisLabel", "\[Rule]", 
              RowBox[{"textit", "[", "\"\<r\>\"", "]"}]}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"FigAxis", "[", 
            RowBox[{"Left", ",", "0", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "0.1"}], ",", "1"}], "}"}], ",", 
             RowBox[{"AxisLabel", "\[Rule]", "\"\<\[ScriptCapitalE]\>\""}]}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"FigLine", "[", 
            RowBox[{"Plot", "[", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  RowBox[{"r", "^", "2"}]}], ")"}], "^", 
                RowBox[{"(", 
                 RowBox[{"-", "1"}], ")"}]}], "*", 
               RowBox[{"r", "^", "2"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"r", ",", "0", ",", "3"}], "}"}]}], "]"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"FigCircle", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}], ",", 
             RowBox[{"Radius", "->", 
              RowBox[{"Canvas", "[", "3", "]"}]}], ",", 
             RowBox[{"Color", "\[Rule]", "VenetianRed"}]}], "]"}], ";"}], 
          "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "1"}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"XPlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "0.6"}], ",", "3.5"}], "}"}]}], ",", 
         RowBox[{"YPlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "0.4"}], ",", "1.3"}], "}"}]}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"FigAxis", "[", 
            RowBox[{"Bottom", ",", "0", ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "3.2"}], "}"}], ",", 
             RowBox[{"AxisLabel", "\[Rule]", 
              RowBox[{"textit", "[", "\"\<r\>\"", "]"}]}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"FigAxis", "[", 
            RowBox[{"Left", ",", "0", ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1.1"}], ",", "0.2"}], "}"}], ",", 
             RowBox[{"AxisLabel", "\[Rule]", "\"\<\[ScriptCapitalE]\>\""}]}], 
            "]"}], ";", "\[IndentingNewLine]", 
           RowBox[{"FigLine", "[", 
            RowBox[{"Plot", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"-", "4"}], "*", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  RowBox[{"r", "^", "2"}]}], ")"}], "^", 
                RowBox[{"(", 
                 RowBox[{"-", "2"}], ")"}]}], "*", 
               RowBox[{"r", "^", "2"}]}], ",", 
              RowBox[{"{", 
               RowBox[{"r", ",", "0", ",", "3"}], "}"}]}], "]"}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"FigCircle", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", 
               RowBox[{"-", "1"}]}], "}"}], ",", 
             RowBox[{"Radius", "->", 
              RowBox[{"Canvas", "[", "3", "]"}]}], ",", 
             RowBox[{"Color", "\[Rule]", "Blue"}]}], "]"}], ";"}], 
          "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"2", ",", "1"}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"XPlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "0.6"}], ",", "3.5"}], "}"}]}], ",", 
         RowBox[{"YPlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1.5"}], ",", "0.5"}], "}"}]}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"draw", " ", "level", " ", "schemes"}], " ", "*)"}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"SetOptions", "[", 
            RowBox[{"Lev", ",", 
             RowBox[{"LineColor", "\[Rule]", "VenetianRed"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"epsilon", "=", "0.6"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"U2Lev", "[", 
              RowBox[{"k", ",", "n"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"k", ",", "0", ",", "2"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", 
               RowBox[{"2", "*", "k"}], ",", "4"}], "}"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"FigLabel", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                "\"\<lev\>\"", ",", "\"\<U2\>\"", ",", "0", ",", "n"}], "}"}],
                ",", "Left", ",", 
               RowBox[{"RowBox", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"textit", "[", "\"\<n\>\"", "]"}], ",", "\"\<=\>\"",
                   ",", "n"}], "}"}], "]"}], ",", 
               RowBox[{"Displacement", "\[Rule]", 
                RowBox[{"Canvas", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"-", "15"}], ",", "0"}], "}"}], "]"}]}]}], "]"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"n", ",", "0", ",", "4"}], "}"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"FigLabel", "[", 
            RowBox[{"\"\<U(2)\>\"", ",", 
             RowBox[{"Style", "\[Rule]", "\"\<panellabel\>\""}]}], "]"}]}], 
          "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2"}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"XPlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "0.8"}], ",", "3.2"}], "}"}]}], ",", 
         RowBox[{"YPlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "0.5"}], ",", "3"}], "}"}]}]}], 
        "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"SetOptions", "[", 
            RowBox[{"Lev", ",", 
             RowBox[{"LineColor", "\[Rule]", "Blue"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"b", "=", "0.15"}], ";", "\[IndentingNewLine]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"SO3Lev", "[", 
              RowBox[{"0", ",", "l"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", "0", ",", "4"}], "}"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"SO3Lev", "[", 
              RowBox[{"1", ",", "l"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", "0", ",", "3"}], "}"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"SO3Lev", "[", 
              RowBox[{"2", ",", "l"}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"l", ",", "0", ",", "2"}], "}"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"Table", "[", 
            RowBox[{
             RowBox[{"BandLabel", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                "\"\<lev\>\"", ",", "\"\<SO3\>\"", ",", "v", ",", "0"}], 
                "}"}], ",", 
               RowBox[{"RowBox", "[", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"textit", "[", "\"\<v\>\"", "]"}], ",", "\"\<=\>\"",
                   ",", "v"}], "}"}], "]"}]}], "]"}], ",", 
             RowBox[{"{", 
              RowBox[{"v", ",", "0", ",", "2"}], "}"}]}], "]"}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"FigLabel", "[", 
            RowBox[{"\"\<SO(3)\>\"", ",", 
             RowBox[{"Style", "\[Rule]", "\"\<panellabel\>\""}]}], "]"}]}], 
          "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"2", ",", "2"}], "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"XPlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "0.2"}], ",", "3.2"}], "}"}]}], ",", 
         RowBox[{"YPlotRange", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "0.5"}], ",", "3"}], "}"}]}]}], 
        "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Dimensions", "->", 
      RowBox[{"{", 
       RowBox[{"2", ",", "2"}], "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"panel", " ", "appearance"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"LineColor", "\[Rule]", "Gray"}], ",", 
     RowBox[{"ShowTicks", "\[Rule]", "False"}], ",", "\[IndentingNewLine]", 
     RowBox[{"PanelLetter", "\[Rule]", "None"}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"panel", " ", "array", " ", "geometry"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"XPanelSizes", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0.6", ",", "1"}], "}"}]}], ",", 
     RowBox[{"XPanelGaps", "\[Rule]", "0.1"}], ",", "\[IndentingNewLine]", 
     RowBox[{"YPanelGaps", "\[Rule]", "0.1"}]}], "\[IndentingNewLine]", "]"}],
    ",", "\[IndentingNewLine]", 
   RowBox[{"CanvasSize", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"6", ",", "7"}], "}"}]}]}], "\[IndentingNewLine]", 
  "]"}]}], "Input",
 CellChangeTimes->{{3.3950955260625*^9, 3.395095541375*^9}, 
   3.3950956338125*^9, 3.3955211409375*^9, {3.3955214840625*^9, 
   3.39552148421875*^9}, {3.430248040421875*^9, 3.430248068375*^9}, {
   3.519835807015625*^9, 3.5198358070625*^9}, 3.5200358898125*^9, {
   3.520533935734375*^9, 3.520534170546875*^9}, {3.5205342393125*^9, 
   3.520534253625*^9}, {3.5205342901875*^9, 3.520534338375*^9}, {
   3.520534411484375*^9, 3.5205344344375*^9}, {3.520534475625*^9, 
   3.520534760046875*^9}, {3.5205347905625*^9, 3.520534860375*^9}, {
   3.5205349490625*^9, 3.520535006921875*^9}, {3.520535043140625*^9, 
   3.520535044046875*^9}, {3.5205351023125*^9, 3.520535135484375*^9}, {
   3.52053521353125*^9, 3.52053521375*^9}, {3.520535251125*^9, 
   3.5205352515*^9}, {3.52053532665625*^9, 3.520535359765625*^9}, {
   3.5205356554375*^9, 3.520535664859375*^9}, {3.520537931375*^9, 
   3.52053797815625*^9}, {3.524748375953125*^9, 3.5247483784375*^9}, {
   3.566339637592348*^9, 3.5663397257824717`*^9}, {3.579122026343968*^9, 
   3.579122027919058*^9}}],

Cell[BoxData[
 GraphicsBox[{{{
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 576}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 648},
       PlotRange->{{-72, 504}, {-72, 576}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 264.}, {152.47058823529412`, 504.}]}, 
     InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{22.31276901004304, 320.47058823529414`}, {
          141.3142037302726, 320.47058823529414`}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{135.3142037302726, 323.47058823529414`}, {
           141.3142037302726, 320.47058823529414`}, {135.3142037302726, 
           317.47058823529414`}}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{22.31276901004304, 306.3529411764706}, {22.31276901004304, 
          461.6470588235294}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{19.31276901004304, 455.6470588235294}, {
           22.31276901004304, 461.6470588235294}, {25.31276901004304, 
           455.6470588235294}}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJwV1Hk4lekbB/Bj0tCiUllaDTUJMRVzNg5fS3Y5llC2d2hRUZYX55yXhrKV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          "]]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {EdgeForm[None], FaceForm[RGBColor[0.829997, 0.099994, 0.119999]], 
         GeometricTransformationBox[
          DiskBox[{22.31276901004304, 320.47058823529414`}, 3, {0., 
           6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
        {RGBColor[0.829997, 0.099994, 0.119999], AbsoluteThickness[1], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         GeometricTransformationBox[
          CircleBox[{22.31276901004304, 320.47058823529414`}, 3, {0., 
           6.283185307179586}], {{{1, 0}, {0, 1}}, {0., 0.}}]}, 
        {RGBColor[0.829997, 0.099994, 0.119999], AbsoluteThickness[1], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              StyleBox["\<\"r\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->15,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {81.81348637015782, 320.47058823529414`}, {0, 1},
          Automatic, {1., 0.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"\[ScriptCapitalE]\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->15,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {22.31276901004304, 384.}, {0, -1}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             StyleBox["\<\"r\"\>",
              FontSlant->"Italic"],
             StyleForm[#, FontSlant -> "Italic"]& ],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->15,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {81.81348637015782, 320.47058823529414`}, {0, 1},
          Automatic, {1., 0.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"\[ScriptCapitalE]\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->15,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {22.31276901004304, 384.}, {0, -1}, 
         Automatic, {6.123233995736766*^-17, 1.}]},
       Frame->False,
       ImageSize->{152.47058823529412`, 240.},
       PlotRange->{{0., 152.47058823529412`}, {264., 
        504.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 576}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 648},
       PlotRange->{{-72, 504}, {-72, 576}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 576}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 264.}, {0., 504.}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{152.47058823529412`, 264.}, {152.47058823529412`, 504.}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 264.}, {152.47058823529412`, 264.}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 504.}, {152.47058823529412`, 504.}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}},
       Frame->False,
       ImageSize->{576, 648},
       PlotRange->{{-72, 504}, {-72, 576}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 576}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 648},
       PlotRange->{{-72, 504}, {-72, 576}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{0., 0.}, {152.47058823529412`, 240.}]}, 
     InsetBox[
      GraphicsBox[{
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{22.31276901004304, 180.}, {141.3142037302726, 180.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{135.3142037302726, 183.}, {141.3142037302726, 180.}, {
           135.3142037302726, 177.}}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{22.31276901004304, 48.}, {22.31276901004304, 204.}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{}, {{19.31276901004304, 198.}, {22.31276901004304, 204.}, {
           25.31276901004304, 198.}}}]}, 
        {GrayLevel[0], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[CompressedData["
1:eJwV1nk8VF0YB3CklFJKliRbskaL3hkk/bIzM3dm7MkyYxleS0gbWpVKSbso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          "]]}, 
        {GrayLevel[0], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {EdgeForm[None], FaceForm[RGBColor[0, 0, 1]], 
         GeometricTransformationBox[
          DiskBox[{59.50071736011478, 60.}, 3, {0., 6.283185307179586}], {{{1,
            0}, {0, 1}}, {0., 0.}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         GeometricTransformationBox[
          CircleBox[{59.50071736011478, 60.}, 3, {0., 6.283185307179586}], {{{
           1, 0}, {0, 1}}, {0., 0.}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             TagBox[
              StyleBox["\<\"r\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->15,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {81.81348637015782, 180.}, {0, 1}, 
         Automatic, {1., 0.}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"\[ScriptCapitalE]\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->15,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {22.31276901004304, 126.}, {0, -1}, 
         Automatic, {6.123233995736766*^-17, 1.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            TagBox[
             StyleBox["\<\"r\"\>",
              FontSlant->"Italic"],
             StyleForm[#, FontSlant -> "Italic"]& ],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->15,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {81.81348637015782, 180.}, {0, 1}, 
         Automatic, {1., 0.}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"\[ScriptCapitalE]\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->15,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {22.31276901004304, 126.}, {0, -1}, 
         Automatic, {6.123233995736766*^-17, 1.}]},
       Frame->False,
       ImageSize->{152.47058823529412`, 240.},
       PlotRange->{{0., 152.47058823529412`}, {0., 240.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 576}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 648},
       PlotRange->{{-72, 504}, {-72, 576}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 576}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{0., 0.}, {0., 240.}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{152.47058823529412`, 0.}, {152.47058823529412`, 240.}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 0.}, {152.47058823529412`, 0.}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{0., 240.}, {152.47058823529412`, 240.}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}},
       Frame->False,
       ImageSize->{576, 648},
       PlotRange->{{-72, 504}, {-72, 576}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 576}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 648},
       PlotRange->{{-72, 504}, {-72, 576}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], 
      RectangleBox[{177.88235294117644`, 264.}, {431.99999999999994`, 504.}]},
      InsetBox[
      GraphicsBox[{
        {RGBColor[0.829997, 0.099994, 0.119999], AbsoluteThickness[2], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{241.41176470588232`, 298.2857142857143}, {
          279.52941176470586`, 298.2857142857143}}]}, 
        {RGBColor[0.829997, 0.099994, 0.119999], AbsoluteThickness[2], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{241.41176470588232`, 339.42857142857144`}, {
          279.52941176470586`, 339.42857142857144`}}]}, 
        {RGBColor[0.829997, 0.099994, 0.119999], AbsoluteThickness[2], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{241.41176470588232`, 380.57142857142856`}, {
          279.52941176470586`, 380.57142857142856`}}]}, 
        {RGBColor[0.829997, 0.099994, 0.119999], AbsoluteThickness[2], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{241.41176470588232`, 421.71428571428567`}, {
          279.52941176470586`, 421.71428571428567`}}]}, 
        {RGBColor[0.829997, 0.099994, 0.119999], AbsoluteThickness[2], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{241.41176470588232`, 462.85714285714283`}, {
          279.52941176470586`, 462.85714285714283`}}]}, 
        {RGBColor[0.829997, 0.099994, 0.119999], AbsoluteThickness[2], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{304.9411764705882, 380.57142857142856`}, {
          343.0588235294117, 380.57142857142856`}}]}, 
        {RGBColor[0.829997, 0.099994, 0.119999], AbsoluteThickness[2], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{304.9411764705882, 421.71428571428567`}, {
          343.0588235294117, 421.71428571428567`}}]}, 
        {RGBColor[0.829997, 0.099994, 0.119999], AbsoluteThickness[2], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{304.9411764705882, 462.85714285714283`}, {
          343.0588235294117, 462.85714285714283`}}]}, 
        {RGBColor[0.829997, 0.099994, 0.119999], AbsoluteThickness[2], 
         Dashing[{}], CapForm[None], JoinForm[{"Miter", 3.25}], 
         LineBox[{{368.47058823529403`, 462.85714285714283`}, {
          406.58823529411757`, 462.85714285714283`}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["0",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {241.41176470588232`, 298.2857142857143}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["1",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {241.41176470588232`, 339.42857142857144`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["2",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {241.41176470588232`, 380.57142857142856`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["3",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {241.41176470588232`, 421.71428571428567`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["4",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {241.41176470588232`, 462.85714285714283`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["0",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {304.9411764705882, 380.57142857142856`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["1",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {304.9411764705882, 421.71428571428567`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["2",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {304.9411764705882, 462.85714285714283`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["0",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {368.47058823529403`, 462.85714285714283`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             RowBox[{
              TagBox[
               StyleBox["\<\"n\"\>",
                FontSlant->"Italic"],
               StyleForm[#, FontSlant -> "Italic"]& ], "=", "0"}],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {226.41176470588232`, 298.2857142857143}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             RowBox[{
              TagBox[
               StyleBox["\<\"n\"\>",
                FontSlant->"Italic"],
               StyleForm[#, FontSlant -> "Italic"]& ], "=", "1"}],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {226.41176470588232`, 339.42857142857144`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             RowBox[{
              TagBox[
               StyleBox["\<\"n\"\>",
                FontSlant->"Italic"],
               StyleForm[#, FontSlant -> "Italic"]& ], "=", "2"}],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {226.41176470588232`, 380.57142857142856`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             RowBox[{
              TagBox[
               StyleBox["\<\"n\"\>",
                FontSlant->"Italic"],
               StyleForm[#, FontSlant -> "Italic"]& ], "=", "3"}],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {226.41176470588232`, 421.71428571428567`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             RowBox[{
              TagBox[
               StyleBox["\<\"n\"\>",
                FontSlant->"Italic"],
               StyleForm[#, FontSlant -> "Italic"]& ], "=", "4"}],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {226.41176470588232`, 462.85714285714283`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"U(2)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {355.76470588235287`, 312.}, {0, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["0",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {241.41176470588232`, 298.2857142857143}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["1",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {241.41176470588232`, 339.42857142857144`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["2",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {241.41176470588232`, 380.57142857142856`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["3",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {241.41176470588232`, 421.71428571428567`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["4",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {241.41176470588232`, 462.85714285714283`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["0",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {304.9411764705882, 380.57142857142856`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["1",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {304.9411764705882, 421.71428571428567`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["2",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {304.9411764705882, 462.85714285714283`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["0",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {368.47058823529403`, 462.85714285714283`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            RowBox[{
             TagBox[
              StyleBox["\<\"n\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ], "=", "0"}],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {226.41176470588232`, 298.2857142857143}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            RowBox[{
             TagBox[
              StyleBox["\<\"n\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ], "=", "1"}],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {226.41176470588232`, 339.42857142857144`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            RowBox[{
             TagBox[
              StyleBox["\<\"n\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ], "=", "2"}],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {226.41176470588232`, 380.57142857142856`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            RowBox[{
             TagBox[
              StyleBox["\<\"n\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ], "=", "3"}],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {226.41176470588232`, 421.71428571428567`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            RowBox[{
             TagBox[
              StyleBox["\<\"n\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ], "=", "4"}],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {226.41176470588232`, 462.85714285714283`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"U(2)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {355.76470588235287`, 312.}, {0, 0}, 
         Automatic, {1, 0}]},
       Frame->False,
       ImageSize->{254.1176470588235, 240.},
       PlotRange->{{177.88235294117644`, 431.99999999999994`}, {264., 
        504.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 576}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 648},
       PlotRange->{{-72, 504}, {-72, 576}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 576}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{177.88235294117644`, 264.}, {177.88235294117644`, 504.}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{431.99999999999994`, 264.}, {431.99999999999994`, 504.}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{177.88235294117644`, 264.}, {431.99999999999994`, 264.}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{177.88235294117644`, 504.}, {431.99999999999994`, 504.}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}},
       Frame->False,
       ImageSize->{576, 648},
       PlotRange->{{-72, 504}, {-72, 576}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 576}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 648},
       PlotRange->{{-72, 504}, {-72, 576}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], 
      RectangleBox[{177.88235294117644`, 0.}, {431.99999999999994`, 240.}]}, 
     InsetBox[
      GraphicsBox[{
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{207.77854671280275`, 34.285714285714285`}, {
          252.62283737024217`, 34.285714285714285`}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{207.77854671280275`, 44.57142857142857}, {
          252.62283737024217`, 44.57142857142857}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{207.77854671280275`, 75.42857142857142}, {
          252.62283737024217`, 75.42857142857142}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{207.77854671280275`, 126.85714285714283`}, {
          252.62283737024217`, 126.85714285714283`}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{207.77854671280275`, 198.85714285714283`}, {
          252.62283737024217`, 198.85714285714283`}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{282.5190311418685, 102.85714285714286`}, {
          327.3633217993079, 102.85714285714286`}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{282.5190311418685, 113.14285714285714`}, {
          327.3633217993079, 113.14285714285714`}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{282.5190311418685, 144.}, {327.3633217993079, 144.}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{282.5190311418685, 195.4285714285714}, {327.3633217993079, 
          195.4285714285714}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{357.25951557093424`, 171.42857142857142`}, {
          402.1038062283736, 171.42857142857142`}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{357.25951557093424`, 181.7142857142857}, {
          402.1038062283736, 181.7142857142857}}]}, 
        {RGBColor[0, 0, 1], AbsoluteThickness[2], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{357.25951557093424`, 212.57142857142856`}, {
          402.1038062283736, 212.57142857142856`}}]}, InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["0",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {207.77854671280275`, 34.285714285714285`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["1",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {207.77854671280275`, 44.57142857142857}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["2",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {207.77854671280275`, 75.42857142857142}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["3",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {207.77854671280275`, 126.85714285714283`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["4",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {207.77854671280275`, 198.85714285714283`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["0",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {282.5190311418685, 102.85714285714286`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["1",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {282.5190311418685, 113.14285714285714`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["2",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {282.5190311418685, 144.}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["3",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {282.5190311418685, 195.4285714285714}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["0",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {357.25951557093424`, 171.42857142857142`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["1",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {357.25951557093424`, 181.7142857142857}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["2",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {357.25951557093424`, 212.57142857142856`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             RowBox[{
              TagBox[
               StyleBox["\<\"v\"\>",
                FontSlant->"Italic"],
               StyleForm[#, FontSlant -> "Italic"]& ], "=", "0"}],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {230.20069204152247`, 31.285714285714285`}, {0, 1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             RowBox[{
              TagBox[
               StyleBox["\<\"v\"\>",
                FontSlant->"Italic"],
               StyleForm[#, FontSlant -> "Italic"]& ], "=", "1"}],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {304.9411764705882, 99.85714285714286}, {0, 1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox[
             RowBox[{
              TagBox[
               StyleBox["\<\"v\"\>",
                FontSlant->"Italic"],
               StyleForm[#, FontSlant -> "Italic"]& ], "=", "2"}],
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->12,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {379.68166089965393`, 168.42857142857142`}, {0, 1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           StyleBox[
            TagBox["\<\"SO(3)\"\>",
             DisplayForm],
            StripOnInput->False,
            ShowAutoStyles->False,
            SingleLetterItalics->False,
            LineColor->GrayLevel[0],
            FrontFaceColor->GrayLevel[0],
            BackFaceColor->GrayLevel[0],
            GraphicsColor->GrayLevel[0],
            FontFamily->"Times",
            FontSize->20,
            FontWeight->Plain,
            FontSlant->Plain,
            FontTracking->Plain,
            FontColor->GrayLevel[0]],
           StripOnInput->False,
           ShowContents->False],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {355.76470588235287`, 48.}, {0, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["0",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {207.77854671280275`, 34.285714285714285`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["1",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {207.77854671280275`, 44.57142857142857}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["2",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {207.77854671280275`, 75.42857142857142}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["3",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {207.77854671280275`, 126.85714285714283`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["4",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {207.77854671280275`, 198.85714285714283`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["0",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {282.5190311418685, 102.85714285714286`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["1",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {282.5190311418685, 113.14285714285714`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["2",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {282.5190311418685, 144.}, {1, 0}, 
         Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["3",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {282.5190311418685, 195.4285714285714}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["0",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {357.25951557093424`, 171.42857142857142`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["1",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {357.25951557093424`, 181.7142857142857}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["2",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {357.25951557093424`, 212.57142857142856`}, {1, 0},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            RowBox[{
             TagBox[
              StyleBox["\<\"v\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ], "=", "0"}],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {230.20069204152247`, 31.285714285714285`}, {0, 1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            RowBox[{
             TagBox[
              StyleBox["\<\"v\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ], "=", "1"}],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {304.9411764705882, 99.85714285714286}, {0, 1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox[
            RowBox[{
             TagBox[
              StyleBox["\<\"v\"\>",
               FontSlant->"Italic"],
              StyleForm[#, FontSlant -> "Italic"]& ], "=", "2"}],
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->12,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {379.68166089965393`, 168.42857142857142`}, {0, 1},
          Automatic, {1, 0}], InsetBox[
         FrameBox[
          StyleBox[
           TagBox["\<\"SO(3)\"\>",
            DisplayForm],
           StripOnInput->False,
           ShowAutoStyles->False,
           SingleLetterItalics->False,
           LineColor->GrayLevel[0],
           FrontFaceColor->GrayLevel[0],
           BackFaceColor->GrayLevel[0],
           GraphicsColor->GrayLevel[0],
           FontFamily->"Times",
           FontSize->20,
           FontWeight->Plain,
           FontSlant->Plain,
           FontTracking->Plain,
           FontColor->GrayLevel[0]],
          Background->None,
          ContentPadding->False,
          FrameMargins->{{0, 0}, {0, 0}},
          FrameStyle->None,
          RoundingRadius->{0, 0},
          StripOnInput->False], {355.76470588235287`, 48.}, {0, 0}, 
         Automatic, {1, 0}]},
       Frame->False,
       ImageSize->{254.1176470588235, 240.},
       PlotRange->{{177.88235294117644`, 431.99999999999994`}, {0., 
        240.}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 576}]}, InsetBox[
      GraphicsBox[{},
       Frame->False,
       ImageSize->{576, 648},
       PlotRange->{{-72, 504}, {-72, 576}}], {0, 0}, {0, 0}]}, {
     {FaceForm[None], RectangleBox[{-72, -72}, {504, 576}]}, InsetBox[
      GraphicsBox[{
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{177.88235294117644`, 0.}, {177.88235294117644`, 240.}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{431.99999999999994`, 0.}, {431.99999999999994`, 240.}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{177.88235294117644`, 0.}, {431.99999999999994`, 0.}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], 
         LineBox[{{177.88235294117644`, 240.}, {431.99999999999994`, 240.}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}], LineBox[{{}, {}}]}, 
        {GrayLevel[0.5], AbsoluteThickness[1], Dashing[{}], CapForm[None], 
         JoinForm[{"Miter", 3.25}]}},
       Frame->False,
       ImageSize->{576, 648},
       PlotRange->{{-72, 504}, {-72, 576}}], {0, 0}, {0, 0}]}}, {}},
  AspectRatio->NCache[
    Rational[9, 8], 1.125],
  Background->None,
  DisplayFunction->Identity,
  Frame->False,
  ImageSize->{576, 648},
  PlotRange->{{-72, 504}, {-72, 576}}]], "Output",
 CellChangeTimes->{{3.395095614546875*^9, 3.395095635125*^9}, 
   3.39552099134375*^9, 3.39552117603125*^9, 3.395521489640625*^9, 
   3.39688018203125*^9, {3.43024802521875*^9, 3.430248070125*^9}, 
   3.47108971571875*^9, 3.507513560921875*^9, 3.520534186421875*^9, 
   3.5205342604375*^9, 3.520534347203125*^9, 3.52053444678125*^9, {
   3.520534615453125*^9, 3.52053464309375*^9}, 3.520534770109375*^9, 
   3.520534810203125*^9, 3.520534869515625*^9, {3.52053496221875*^9, 
   3.520534990234375*^9}, {3.520535119390625*^9, 3.520535144796875*^9}, 
   3.5205352230625*^9, 3.52053526175*^9, 3.52053537384375*^9, 
   3.52053572165625*^9, 3.520537990859375*^9, 3.521062211140625*^9, 
   3.52474835771875*^9, 3.524748388375*^9, 3.566339683262412*^9, {
   3.566339716902459*^9, 3.566339730092478*^9}, 3.5663403649703684`*^9, {
   3.579122021553694*^9, 3.579122030484205*^9}, 3.583782395246188*^9, 
   3.5943060098554745`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->None,
WindowSize->{1912, 1092},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
DockedCells->(FrontEndExecute[{
   FrontEnd`NotebookApply[
    FrontEnd`InputNotebook[], #, Placeholder]}]& ),
PrintingCopies->1,
PrintingPageRange->{Automatic, Automatic},
PageHeaders->{{None, None, None}, {None, None, None}},
PrintingOptions->{"FacingPages"->False,
"FirstPageHeader"->True,
"PrintCellBrackets"->False,
"PrintMultipleHorizontalPages"->False,
"PrintRegistrationMarks"->False,
"PrintingMargins"->{{71.875, 71.875}, {53.875, 53.875}}},
ShowSelection->True,
Magnification->1.25,
FrontEndVersion->"10.0 for Microsoft Windows (64-bit) (September 9, 2014)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[545, 20, 376, 7, 69, "Text"],
Cell[924, 29, 754, 13, 55, "Text"],
Cell[CellGroupData[{
Cell[1703, 46, 41, 0, 88, "Section"],
Cell[1747, 48, 569, 12, 34, "Text"],
Cell[CellGroupData[{
Cell[2341, 64, 224, 4, 35, "Input"],
Cell[2568, 70, 42320, 785, 133, "Print"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[44937, 861, 164, 2, 88, "Section"],
Cell[CellGroupData[{
Cell[45126, 867, 86, 1, 46, "Subsection"],
Cell[45215, 870, 127, 4, 29, "Text"],
Cell[CellGroupData[{
Cell[45367, 878, 12029, 257, 1290, "Input"],
Cell[57399, 1137, 49977, 1343, 558, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[107425, 2486, 79, 0, 46, "Subsection"],
Cell[107507, 2488, 127, 4, 29, "Text"],
Cell[CellGroupData[{
Cell[107659, 2496, 9283, 201, 938, "Input"],
Cell[116945, 2699, 35438, 966, 603, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[152432, 3671, 39, 0, 46, "Subsection"],
Cell[152474, 3673, 471, 9, 76, "Text"],
Cell[152948, 3684, 228, 9, 49, "Text"],
Cell[CellGroupData[{
Cell[153201, 3697, 15760, 388, 1743, "Input"],
Cell[168964, 4087, 102444, 2664, 918, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[271469, 6758, 119, 1, 88, "Section"],
Cell[CellGroupData[{
Cell[271613, 6763, 183, 2, 46, "Subsection"],
Cell[271799, 6767, 280, 5, 34, "Text"],
Cell[272082, 6774, 323, 7, 76, "Text"],
Cell[272408, 6783, 708, 17, 231, "Program"],
Cell[CellGroupData[{
Cell[273141, 6804, 18286, 427, 2412, "Input"],
Cell[291430, 7233, 1722, 52, 45, "Print"],
Cell[293155, 7287, 64268, 1604, 738, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[357472, 8897, 177, 4, 46, "Subsection"],
Cell[357652, 8903, 805, 22, 325, "Text"],
Cell[CellGroupData[{
Cell[358482, 8929, 14910, 350, 1752, "Input"],
Cell[373395, 9281, 95116, 2415, 828, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
