(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     16006,        501]
NotebookOptionsPosition[     12946,        388]
NotebookOutlinePosition[     13312,        404]
CellTagsIndexPosition[     13269,        401]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Header comments", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", "Common"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "SciDraw`"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "Common", " ", "global", " ", "constants", " ", "and", " ", "flag", " ", 
      "variables"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Author", ":", " ", 
      RowBox[{"Mark", " ", 
       RowBox[{"A", ".", " ", "Caprio"}]}]}]}], ",", " ", 
    RowBox[{"Department", " ", "of", " ", "Physics"}], ",", " ", 
    RowBox[{"University", " ", "of", " ", "Notre", " ", "Dame"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "FIGYEAR"}]}]}], ",", " ", 
    RowBox[{"Mark", " ", 
     RowBox[{"A", ".", " ", "Caprio"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "FIGVERSION"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "MATHVERSION"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Discussion", ":", " ", "FIGDISCUSSION"}]}], " ", "*)"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"See", " ", "package", " ", "information", " ", 
      RowBox[{"file", "."}]}]}]}], " ", "*)"}]}]], "Input",
 InitializationCell->True,
 AutoIndent->False,
 CellChangeTimes->{{3.395093723328125*^9, 3.39509375184375*^9}, {
   3.398545735296875*^9, 3.39854574365625*^9}, 3.398799700609375*^9, {
   3.43024739209375*^9, 3.43024739990625*^9}, 3.430247813015625*^9, {
   3.436819738734375*^9, 3.436819746828125*^9}, 3.436820195484375*^9, {
   3.4439959535*^9, 3.4439959773125*^9}, {3.471089562875*^9, 
   3.471089568359375*^9}, {3.471089636203125*^9, 3.471089639046875*^9}, {
   3.48681044459375*^9, 3.4868104458125*^9}, {3.489687811140625*^9, 
   3.489687812484375*^9}, {3.497222348765625*^9, 3.497222354953125*^9}, 
   3.497224390546875*^9, {3.497299514859375*^9, 3.497299515046875*^9}, {
   3.49903536659375*^9, 3.49903536784375*^9}, {3.503265433671875*^9, 
   3.5032654415*^9}, {3.50612390383225*^9, 3.5061239087385*^9}, 
   3.507509920109375*^9, {3.51481857221875*^9, 3.514818754140625*^9}, 
   3.514822657671875*^9, {3.514823216234375*^9, 3.51482323709375*^9}, {
   3.51482326921875*^9, 3.514823311671875*^9}, {3.514823375546875*^9, 
   3.514823396890625*^9}, {3.5150157685*^9, 3.51501576865625*^9}, {
   3.515017470890625*^9, 3.515017494609375*^9}, 3.515102664828125*^9, 
   3.515276987671875*^9, 3.51527712378125*^9, {3.515278127734375*^9, 
   3.515278142734375*^9}, 3.515422905594125*^9, 3.5154229468285*^9},
 LanguageCategory->"NaturalLanguage"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin package", "Section"],

Cell[CellGroupData[{

Cell["Package context definition", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<SciDraw`\>\"", ",", "SciDraw`Private`$ExternalContexts"}], 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.395087747453125*^9, 3.39508775096875*^9}, {
   3.39509064290625*^9, 3.395090643234375*^9}, 3.395090710546875*^9, {
   3.395091175015625*^9, 3.395091179703125*^9}, {3.395093472375*^9, 
   3.39509347784375*^9}, {3.395093608140625*^9, 3.3950936085*^9}, {
   3.395519039875*^9, 3.395519061546875*^9}, {3.495041989453125*^9, 
   3.495042010953125*^9}, {3.495042158078125*^9, 3.495042163671875*^9}, {
   3.497222416421875*^9, 3.497222462578125*^9}, {3.497222963890625*^9, 
   3.497222994640625*^9}, 3.497223030953125*^9, {3.514818766734375*^9, 
   3.514818800625*^9}, {3.5148197104375*^9, 3.514819710671875*^9}, {
   3.514819841546875*^9, 3.51481994284375*^9}, {3.514819979578125*^9, 
   3.514820025046875*^9}, {3.5148201316875*^9, 3.514820154671875*^9}, {
   3.51482025234375*^9, 3.514820275171875*^9}, {3.514820309703125*^9, 
   3.514820406921875*^9}, {3.51482051775*^9, 3.514820571328125*^9}, {
   3.514820843296875*^9, 3.51482087146875*^9}, 3.51482140903125*^9, {
   3.514821446859375*^9, 3.514821449890625*^9}, 3.514821641390625*^9, {
   3.514821674609375*^9, 3.514821798390625*^9}, {3.514823407859375*^9, 
   3.514823433140625*^9}, 3.51501104184375*^9, 3.515275343*^9, {
   3.515276331390625*^9, 3.51527633303125*^9}, {3.51542275479725*^9, 
   3.515422755141*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Unprotect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}], ";"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin private context", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.514823442859375*^9, 3.5148234431875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dependencies", "Subsection",
 CellChangeTimes->{{3.514821147359375*^9, 3.51482114978125*^9}}],

Cell[BoxData[""], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51482113128125*^9, 3.514821158515625*^9}, {
  3.514823452421875*^9, 3.51482349575*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Global constant initialization", "Section",
 CellChangeTimes->{{3.5148213233125*^9, 3.514821325859375*^9}}],

Cell["\<\
These global constants are in the private context.

Note: These variables are meant to be accessible in the core infrastructure \
subpackages, but they are not directly needed by subpackages which define \
figure object classes.\
\>", "Text",
 CellChangeTimes->{{3.515093819484375*^9, 3.515093882375*^9}, {
  3.5151026675*^9, 3.515102726640625*^9}, {3.5152771535625*^9, 
  3.515277184453125*^9}}],

Cell[CellGroupData[{

Cell["Drawing layers", "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"$FigBackgroundLayer", "=", "0"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"$FigDrawingLayer", "=", "1"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"$FigBlankingLayer", "=", "2"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"$FigTextLayer", "=", "3"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.514821355125*^9, 3.514821356265625*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Low-level graphics adjustment", "Subsection",
 CellChangeTimes->{{3.5962861681172504`*^9, 3.5962861730936594`*^9}}],

Cell["\<\
Value used for TextBaseBuffer if left as Automatic\
\>", "Text",
 CellChangeTimes->{{3.596286188288086*^9, 3.596286197866503*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"$FigTextBaseBuffer", "=", "1"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5962861764632654`*^9, 3.5962861820324755`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Option override rules", "Subsection",
 CellChangeTimes->{{3.51510391240625*^9, 3.515103915078125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"$FigOptionRules", "=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51510391696875*^9, 3.515103917625*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Flag to prevent evaluation of figure objects outside of a figure\
\>", "Subsection",
 CellChangeTimes->{{3.514823199625*^9, 3.514823203046875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"$InFigure", "=", "False"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.514821356796875*^9, {3.51501745803125*^9, 3.5150174581875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Figure-wide base style", "Subsection",
 CellChangeTimes->{{3.51570099103125*^9, 3.515700999375*^9}}],

Cell[BoxData[
 RowBox[{"$FigBaseStyle", ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51570102240625*^9, 3.515701044171875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Figure element accumulator", "Subsection",
 CellChangeTimes->{{3.514823199625*^9, 3.514823203046875*^9}, {
  3.515180696734375*^9, 3.515180700453125*^9}}],

Cell[BoxData[
 RowBox[{"$GraphicalElementList", ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.514821356796875*^9, {3.51501745803125*^9, 3.5150174581875*^9}, {
   3.51518071240625*^9, 3.515180717015625*^9}, {3.51535829784375*^9, 
   3.51535830515625*^9}, 3.515686507421875*^9, {3.51568722125*^9, 
   3.515687238671875*^9}, {3.515687270609375*^9, 3.51568727115625*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Page dimensions", "Subsection",
 CellChangeTimes->{{3.515024448828125*^9, 3.515024452265625*^9}}],

Cell[BoxData[{
 RowBox[{"$CanvasBaseRange", ";"}], "\[IndentingNewLine]", 
 RowBox[{"$CanvasFullRange", ";"}], "\[IndentingNewLine]", 
 RowBox[{"$CanvasDimensions", ";"}], "\[IndentingNewLine]", 
 RowBox[{"$TickScaleFactor", ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51502445615625*^9, 3.5150245025625*^9}, {
  3.515093790421875*^9, 3.51509379196875*^9}, {3.515355552359375*^9, 
  3.51535555625*^9}, {3.51535564965625*^9, 3.51535565190625*^9}, {
  3.515356514046875*^9, 3.515356516828125*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Windows", "Subsection",
 CellChangeTimes->{{3.515011849875*^9, 3.515011856171875*^9}, {
  3.515356136421875*^9, 3.5153561374375*^9}}],

Cell["Object references to canvas and current windows.", "Text",
 CellChangeTimes->{{3.51535618028125*^9, 3.5153561953125*^9}}],

Cell[BoxData[{
 RowBox[{"$CanvasWindow", ";"}], "\[IndentingNewLine]", 
 RowBox[{"$CurrentWindow", ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515012158328125*^9, 3.5150121605*^9}, {
  3.515012197359375*^9, 3.515012207359375*^9}, {3.515356147203125*^9, 
  3.515356156890625*^9}, {3.515534506078125*^9, 3.5155345080625*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Multipanel", "Subsection",
 CellChangeTimes->{{3.515784373828125*^9, 3.515784375484375*^9}}],

Cell["Object reference to current multipanel environment", "Text",
 CellChangeTimes->{{3.515784410515625*^9, 3.515784417640625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"$Multipanel", "=", "None"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51578438953125*^9, 3.515784395671875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Background color", "Subsection",
 CellChangeTimes->{{3.51553451015625*^9, 3.515534512203125*^9}}],

Cell[BoxData[{
 RowBox[{"$CanvasBackground", ";"}], "\[IndentingNewLine]", 
 RowBox[{"$CurrentBackground", ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515534517171875*^9, 3.5155345386875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Profiling and debugging control\
\>", "Subsection",
 CellChangeTimes->{{3.51553451015625*^9, 3.515534512203125*^9}, {
  3.5791173258329067`*^9, 3.5791173284069114`*^9}, {3.5875994521442547`*^9, 
  3.5875994552234306`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"$PrintTiming", "=", "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"$DebugOptionOverrides", "=", "False"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515534517171875*^9, 3.5155345386875*^9}, {
  3.579117339623331*^9, 3.579117348094146*^9}, {3.587599457416556*^9, 
  3.587599464408956*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["End package", "Section",
 CellChangeTimes->{{3.514823047703125*^9, 3.51482305353125*^9}}],

Cell[CellGroupData[{

Cell["Exit private context", "Subsection",
 CellChangeTimes->{{3.514823086015625*^9, 3.5148231094375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Exit package context", "Subsection",
 CellChangeTimes->{{3.514823092890625*^9, 3.51482312965625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Unprotect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<$*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EndPackage", "[", "]"}], ";"}]}], "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1672, 928},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowFrame->"Normal",
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 34, 0, 71, "Section"],
Cell[616, 24, 3092, 71, 192, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[3745, 100, 32, 0, 71, "Section"],
Cell[CellGroupData[{
Cell[3802, 104, 48, 0, 36, "Subsection"],
Cell[3853, 106, 1472, 24, 31, "Input",
 InitializationCell->True],
Cell[5328, 132, 184, 5, 31, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[5549, 142, 43, 0, 36, "Subsection"],
Cell[5595, 144, 183, 4, 31, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[5815, 153, 99, 1, 36, "Subsection"],
Cell[5917, 156, 163, 3, 31, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[6129, 165, 113, 1, 71, "Section"],
Cell[6245, 168, 406, 9, 65, "Text"],
Cell[CellGroupData[{
Cell[6676, 181, 36, 0, 36, "Subsection"],
Cell[6715, 183, 424, 10, 92, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[7176, 198, 121, 1, 36, "Subsection"],
Cell[7300, 201, 140, 3, 29, "Text"],
Cell[7443, 206, 181, 4, 31, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[7661, 215, 108, 1, 36, "Subsection"],
Cell[7772, 218, 189, 5, 31, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[7998, 228, 157, 3, 36, "Subsection"],
Cell[8158, 233, 194, 5, 31, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[8389, 243, 106, 1, 36, "Subsection"],
Cell[8498, 246, 148, 3, 31, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[8683, 254, 160, 2, 36, "Subsection"],
Cell[8846, 258, 389, 7, 31, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[9272, 270, 103, 1, 36, "Subsection"],
Cell[9378, 273, 518, 9, 92, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[9933, 287, 139, 2, 36, "Subsection"],
Cell[10075, 291, 127, 1, 29, "Text"],
Cell[10205, 294, 346, 6, 52, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[10588, 305, 98, 1, 36, "Subsection"],
Cell[10689, 308, 132, 1, 29, "Text"],
Cell[10824, 311, 172, 4, 31, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[11033, 320, 103, 1, 36, "Subsection"],
Cell[11139, 323, 215, 4, 52, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[11391, 332, 232, 5, 36, "Subsection"],
Cell[11626, 339, 365, 8, 52, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[12040, 353, 95, 1, 71, "Section"],
Cell[CellGroupData[{
Cell[12160, 358, 106, 1, 36, "Subsection"],
Cell[12269, 361, 96, 3, 31, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[12402, 369, 107, 1, 36, "Subsection"],
Cell[12512, 372, 406, 12, 72, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
