(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 5.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    267853,       6387]
NotebookOptionsPosition[    255050,       5980]
NotebookOutlinePosition[    256465,       6025]
CellTagsIndexPosition[    256422,       6022]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Header comments", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", "FigData"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "SciDraw`"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{"Data", " ", "plotting"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Author", ":", " ", 
      RowBox[{"Mark", " ", 
       RowBox[{"A", ".", " ", "Caprio"}]}]}]}], ",", " ", 
    RowBox[{"Department", " ", "of", " ", "Physics"}], ",", " ", 
    RowBox[{"University", " ", "of", " ", "Notre", " ", "Dame"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "FIGYEAR"}]}]}], ",", " ", 
    RowBox[{"Mark", " ", 
     RowBox[{"A", ".", " ", "Caprio"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "FIGVERSION"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "MATHVERSION"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Discussion", ":", " ", "FIGDISCUSSION"}]}], " ", "*)"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"See", " ", "package", " ", "information", " ", 
      RowBox[{"file", "."}]}]}]}], " ", "*)"}]}]], "Input",
 InitializationCell->True,
 AutoIndent->False,
 CellChangeTimes->{{3.395093723328125*^9, 3.39509375184375*^9}, {
   3.398545735296875*^9, 3.39854574365625*^9}, 3.398799700609375*^9, {
   3.43024739209375*^9, 3.43024739990625*^9}, 3.430247813015625*^9, {
   3.436819738734375*^9, 3.436819746828125*^9}, 3.436820195484375*^9, {
   3.4439959535*^9, 3.4439959773125*^9}, {3.471089562875*^9, 
   3.471089568359375*^9}, {3.471089636203125*^9, 3.471089639046875*^9}, {
   3.48681044459375*^9, 3.4868104458125*^9}, {3.489687811140625*^9, 
   3.489687812484375*^9}, {3.497222348765625*^9, 3.497222354953125*^9}, 
   3.497224390546875*^9, {3.497299514859375*^9, 3.497299515046875*^9}, {
   3.49903536659375*^9, 3.49903536784375*^9}, {3.503265433671875*^9, 
   3.5032654415*^9}, {3.50612390383225*^9, 3.5061239087385*^9}, 
   3.507509920109375*^9, {3.51481857221875*^9, 3.514818754140625*^9}, 
   3.514822657671875*^9, {3.514823216234375*^9, 3.51482323709375*^9}, {
   3.51482326921875*^9, 3.514823311671875*^9}, {3.514823375546875*^9, 
   3.514823396890625*^9}, {3.5150157685*^9, 3.51501576865625*^9}, 
   3.515275347609375*^9, {3.51542285160975*^9, 3.515422853937875*^9}, {
   3.51655779771875*^9, 3.516557812578125*^9}},
 LanguageCategory->"NaturalLanguage"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin package", "Section"],

Cell[CellGroupData[{

Cell["Package context definition", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<SciDraw`\>\"", ",", "SciDraw`Private`$ExternalContexts"}], 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.395087747453125*^9, 3.39508775096875*^9}, {
   3.39509064290625*^9, 3.395090643234375*^9}, 3.395090710546875*^9, {
   3.395091175015625*^9, 3.395091179703125*^9}, {3.395093472375*^9, 
   3.39509347784375*^9}, {3.395093608140625*^9, 3.3950936085*^9}, {
   3.395519039875*^9, 3.395519061546875*^9}, {3.495041989453125*^9, 
   3.495042010953125*^9}, {3.495042158078125*^9, 3.495042163671875*^9}, {
   3.497222416421875*^9, 3.497222462578125*^9}, {3.497222963890625*^9, 
   3.497222994640625*^9}, 3.497223030953125*^9, {3.514818766734375*^9, 
   3.514818800625*^9}, {3.5148197104375*^9, 3.514819710671875*^9}, {
   3.514819841546875*^9, 3.51481994284375*^9}, {3.514819979578125*^9, 
   3.514820025046875*^9}, {3.5148201316875*^9, 3.514820154671875*^9}, {
   3.51482025234375*^9, 3.514820275171875*^9}, {3.514820309703125*^9, 
   3.514820406921875*^9}, {3.51482051775*^9, 3.514820571328125*^9}, {
   3.514820843296875*^9, 3.51482087146875*^9}, 3.51482140903125*^9, {
   3.514821446859375*^9, 3.514821449890625*^9}, 3.514821641390625*^9, {
   3.514821674609375*^9, 3.514821798390625*^9}, {3.514823407859375*^9, 
   3.514823433140625*^9}, 3.51501104184375*^9, 3.515275343*^9, {
   3.515276331390625*^9, 3.51527633303125*^9}, {3.51542275479725*^9, 
   3.515422755141*^9}, {3.51542391860975*^9, 3.51542393423475*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Unprotect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}], ";"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Object usage", "Subsection",
 CellChangeTimes->{{3.516563469859375*^9, 3.516563471765625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DataPlot", "::", "usage"}], "=", 
   "\"\<FIGURE OBJECT: DataPlot[data] produces customizable data \
plots.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DataLegend", "::", "usage"}], "=", 
   "\"\<FIGURE OBJECT: DataLegend[point,{{dataset1,label1},...}] generates a \
data plot legend.\>\""}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515429606016*^9, 3.5154296174535*^9}, {
   3.515429686281625*^9, 3.515429784531625*^9}, {3.515449185687875*^9, 
   3.5154492152035*^9}, {3.51544974992225*^9, 3.51544978429725*^9}, {
   3.51544992735975*^9, 3.515449931437875*^9}, {3.515529961828125*^9, 
   3.5155300071875*^9}, {3.5155300671875*^9, 3.51553013075*^9}, {
   3.51553223328125*^9, 3.5155322396875*^9}, {3.51578136028125*^9, 
   3.515781439671875*^9}, {3.515781479515625*^9, 3.515781552421875*^9}, {
   3.515781973671875*^9, 3.51578204590625*^9}, {3.5157850370625*^9, 
   3.515785100078125*^9}, {3.5157882448125*^9, 3.51578826228125*^9}, {
   3.516298963453125*^9, 3.51629897953125*^9}, {3.51655797084375*^9, 
   3.516558003421875*^9}, {3.516558107359375*^9, 3.5165581601875*^9}, {
   3.516558214015625*^9, 3.516558252515625*^9}, {3.516558324515625*^9, 
   3.516558374609375*^9}, 3.516558549828125*^9, {3.518018291234375*^9, 
   3.518018291890625*^9}, {3.5182888784375*^9, 3.518288878703125*^9}, 
   3.51828892621875*^9, 3.519722125828125*^9, {3.521568080421875*^9, 
   3.521568081671875*^9}, {3.528229812828004*^9, 3.528229845062379*^9}, {
   3.53031038959375*^9, 3.53031039453125*^9}, 3.530310510125*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DataLine", "::", "usage"}], "=", 
   "\"\<The option values for DataLine affect the appearance of data plots.\>\
\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DataSymbol", "::", "usage"}], "=", 
   "\"\<The option values for DataSymbol affect the appearance of data plots.\
\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DataFill", "::", "usage"}], "=", 
   "\"\<The option values for DataFill affect the appearance of data plots.\>\
\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DataDrop", "::", "usage"}], "=", 
   "\"\<The option values for DataFill affect the appearance of data plots.\>\
\""}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->CompressedData["
1:eJxTTMoPSmViYGCQBGIQLdR8IEbN8JWjULNeHJhmPpkGoQWLIbTZG32w/LP3
EHqvkQGY5jSH0K89wDRznieIZmiwig0H0QzPkiB0WhaEjiiC0JqVEWD6G5Tm
lLsE1vdVHUJ/0IHQvGYQemsWmGbYWwyhF728DBZv+gimGWZVXQXTJ2vAdEPe
rXNGIH7hHQgdHeRrDBLPDYPQ2clgmoEtC8I/UAChJ5RC6ToIfbkFQu+aBaG7
5kDoIwwBYPo5E5hmUHWF0PJeEHpm3EtTEH0CSkv5PDED88H0rK03zqzdiKDL
jFNd7/x55TiD+RaYBgAmS6H9
  "]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Other usage", "Subsection",
 CellChangeTimes->{{3.51656348159375*^9, 3.516563483421875*^9}}],

Cell["Registration functions", "Text",
 CellChangeTimes->{{3.51656348628125*^9, 3.516563495203125*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"$DataLineShapeRegistry", "::", "usage"}], "=", 
   "\"\<Global registry of curve shapes for use with DataPlot.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DefineDataLineShape", "::", "usage"}], "=", 
   "\"\<DefineDataLineShape[name,function] defines a new value to be accepted \
for the DataLineShape option.  The function should take a list of two or more \
{x,y} points (as canvas coordinates) and return a new list of points.\>\""}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5165589935625*^9, 3.516559010375*^9}, {
   3.516559075390625*^9, 3.516559129828125*^9}, {3.516560106625*^9, 
   3.5165601464375*^9}, {3.516560390203125*^9, 3.5165605001875*^9}, {
   3.51792613684375*^9, 3.51792613884375*^9}, {3.51843435353125*^9, 
   3.518434356734375*^9}, {3.51853608621875*^9, 3.518536092796875*^9}, 
   3.519722191453125*^9, {3.582815846772168*^9, 3.5828158467877684`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"$DataSymbolShapeRegistry", "::", "usage"}], "=", 
   "\"\<Global registry of symbol shapes for use with DataPlot.\>\""}], ";", 
  RowBox[{
   RowBox[{"DefineDataSymbolShape", "::", "usage"}], "=", 
   "\"\<DefineDataSymbolShape[name,points] defines a new value to be accepted \
for the DataSymbol option.  The argument points should be an expression which \
evaluates to a list of points.  These would describe the symbol centered on \
the origin and contained in the box covering the coordinate intervals \
[-1,+1].\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5165589935625*^9, 3.516559010375*^9}, {
  3.516559075390625*^9, 3.516559129828125*^9}, {3.516560106625*^9, 
  3.5165601464375*^9}, {3.516560390203125*^9, 3.5165605001875*^9}, {
  3.51792613684375*^9, 3.51792613884375*^9}, {3.51843435353125*^9, 
  3.518434361984375*^9}, {3.5185333344375*^9, 3.51853337640625*^9}, {
  3.518534169859375*^9, 3.518534347703125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"$DataAxisScaleRegistry", "::", "usage"}], "=", 
   "\"\<Global registry of axis scale functions for use with DataPlot.\>\""}],
   ";", 
  RowBox[{
   RowBox[{"DefineAxisScale", "::", "usage"}], "=", 
   "\"\<DefineAxisScale[name,function] defines a new value to be accepted for \
the XAxisScale and YAxisScale options.  The function f[x] should take an \
unscaled value of x and return the scaled value.  It should always return a \
numeric value (possibly -Infinity or Infinity).\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5165589935625*^9, 3.516559010375*^9}, {
   3.516559075390625*^9, 3.516559129828125*^9}, {3.516560106625*^9, 
   3.5165601464375*^9}, {3.516560390203125*^9, 3.5165605001875*^9}, {
   3.51792613684375*^9, 3.51792613884375*^9}, {3.51843435353125*^9, 
   3.518434477765625*^9}, {3.51843581615625*^9, 3.518435822484375*^9}, 
   3.51972220365625*^9}],

Cell["Options", "Text",
 CellChangeTimes->{{3.516563497953125*^9, 3.5165634986875*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"CurveShape", "::", "usage"}], "=", 
    "\"\<Option name for use with DataPlot.\>\""}], ";"}], 
  " "}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymbolShape", "::", "usage"}], "=", 
   "\"\<Option name for use with DataPlot.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymbolSize", "::", "usage"}], "=", 
   "\"\<Option name for use with DataPlot.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymbolSizeScale", "::", "usage"}], "=", 
   "\"\<Option name for use with DataPlot.\>\""}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516563503609375*^9, 3.516563511625*^9}, {
   3.516564956703125*^9, 3.516564973484375*^9}, {3.516568247328125*^9, 
   3.516568254109375*^9}, {3.517775737375*^9, 3.5177757386875*^9}, 
   3.5181231075625*^9, {3.6027876073465867`*^9, 3.6027876097465897`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DataColumns", "::", "usage"}], "=", 
   "\"\<Option name for use with DataPlot.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ColumnNames", "::", "usage"}], "=", 
   "\"\<Option name for use with DataPlot.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"XErrorColumn", "::", "usage"}], "=", 
   "\"\<Option name for use with DataPlot.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"YErrorColumn", "::", "usage"}], "=", 
   "\"\<Option name for use with DataPlot.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"XAxisScale", "::", "usage"}], "=", 
   "\"\<Option name for use with DataPlot.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"YAxisScale", "::", "usage"}], "=", 
   "\"\<Option name for use with DataPlot.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DataFilters", "::", "usage"}], "=", 
   "\"\<Option name for use with DataPlot.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SymbolOptionColumns", "::", "usage"}], "=", 
   "\"\<Option name for use with DataPlot.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"InternalSeparation", "::", "usage"}], "=", 
   "\"\<Option name for use with DataLegend.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"EntrySpacing", "::", "usage"}], "=", 
   "\"\<Option name for use with DataLegend.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RowLimit", "::", "usage"}], "=", 
   "\"\<Option name for use with DataLegend.\>\""}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516563503609375*^9, 3.516563511625*^9}, {
   3.516564956703125*^9, 3.516564973484375*^9}, {3.516568247328125*^9, 
   3.516568254109375*^9}, {3.516569223140625*^9, 3.5165692314375*^9}, {
   3.517775670875*^9, 3.517775674484375*^9}, {3.5177757393125*^9, 
   3.517775757609375*^9}, {3.517942634421875*^9, 3.517942644265625*^9}, {
   3.517943057*^9, 3.517943060359375*^9}, {3.51843363565625*^9, 
   3.51843364578125*^9}, {3.518433706328125*^9, 3.51843370671875*^9}, {
   3.518551335861*^9, 3.51855133782975*^9}, {3.518551502439125*^9, 
   3.518551513751625*^9}, {3.53031473921875*^9, 3.53031474678125*^9}, {
   3.537381088765625*^9, 3.53738110771875*^9}, 3.537391241953125*^9, {
   3.597089087617425*^9, 3.5970890917624307`*^9}}],

Cell["Utility functions", "Text",
 CellChangeTimes->{{3.516566929484375*^9, 3.516566935609375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DataSymbolVerticesFunction", "::", "usage"}], "=", 
   "\"\<DataSymbolVerticesFunction[symbolname] returns a function \
f[{{x,y},s}] which takes a canvas point into a list of canvas \
vertices.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516566938203125*^9, 3.516566987734375*^9}, {
  3.5303155665625*^9, 3.53031557375*^9}, {3.53031711875*^9, 
  3.530317148296875*^9}}],

Cell["Data utilities", "Text",
 CellChangeTimes->{{3.521907330640625*^9, 3.521907335859375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AttachIndex", "::", "usage"}], "=", 
   "\"\<AttachIndex[data] or AttachIndex[start,data] or \
AttachIndex[start,step,data] prepends a column to data, containing a running \
index.  The data may either be a vector (list of values) or a matrix (data \
set).\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.521907390046875*^9, 3.521907454546875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SelectByColumn", "::", "usage"}], "=", 
   "\"\<SelectByColumn[data,c,patt] selects those rows of a data set for \
which the value in column c matches the pattern (or value) patt.  \
SelectByColumn[data,{c1,patt1},{c2,patt2},...] applies the conjunction of \
pattern tests on the entries in columns c1, c2, ..., of each row.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.521907390046875*^9, 3.521907454546875*^9}, {
  3.5233943703125*^9, 3.523394432140625*^9}, {3.527765639546875*^9, 
  3.527765695296875*^9}, {3.527765741109375*^9, 3.52776579253125*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DataEntry", "::", "usage"}], "=", 
   "\"\<Dummy argument for MakeDataSet\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeDataSet", "::", "usage"}], "=", 
   "\"\<MakeDataSet[expr,data] or MakeDataSet[expr,{data1,data2,...}] returns \
a data set in which each row is obtained from corresponding rows of data1, \
data2, etc. by evaluating expr, which should be a list and which may invoke \
DataEntry[column], DataEntry[{row,column}], DataEntry[set,column], \
DataEntry[set,{row,column}], or Row.\>\""}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.527770010140625*^9, 3.52777012246875*^9}, {
  3.527770614484375*^9, 3.5277706154375*^9}, {3.527770997015625*^9, 
  3.52777103325*^9}, {3.530139824734375*^9, 3.530139832828125*^9}, {
  3.5301410885*^9, 3.5301410909375*^9}, {3.559843660578125*^9, 
  3.5598436764375*^9}, {3.6110969671648808`*^9, 3.6110969674048843`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DataSetPattern", "::", "usage"}], "=", 
   "\"\<Pattern matching a valid rectangular data set or null set.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DataColumnNamePattern", "::", "usage"}], "=", 
   "\"\<Pattern matching a positive integer or proper column name (i.e., \
string or {string,...}).\>\""}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.537388463453125*^9, 3.5373884909375*^9}, {
  3.597091324058113*^9, 3.597091366100187*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin private context", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.514823442859375*^9, 3.5148234431875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dependencies", "Subsection",
 CellChangeTimes->{{3.514821147359375*^9, 3.51482114978125*^9}}],

Cell[BoxData[""], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51482113128125*^9, 3.514821158515625*^9}, {
  3.514823452421875*^9, 3.51482349575*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Curve shapes", "Section",
 CellChangeTimes->{{3.51655885659375*^9, 3.516558859421875*^9}, {
  3.51655997825*^9, 3.516559980765625*^9}, {3.518433569859375*^9, 
  3.51843357053125*^9}}],

Cell[CellGroupData[{

Cell["Curve shape registration", "Subsection",
 CellChangeTimes->{{3.516558980796875*^9, 3.51655898225*^9}, {
  3.518433567234375*^9, 3.518433568*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"$DataLineShapeRegistry", "=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5165589234375*^9, 3.516558937640625*^9}, 
   3.517926140375*^9, 3.518433497484375*^9, 3.5828158468033686`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"DefineDataLineShape", ",", 
    RowBox[{"{", "HoldRest", "}"}]}], "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.518534759703125*^9, 3.518534767765625*^9}, {
   3.566248677186368*^9, 3.566248678652771*^9}, 3.5828158468033686`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineDataLineShape", "[", 
    RowBox[{"Name_", ",", "Function_"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"AppendTo", "[", 
       RowBox[{"$DataLineShapeRegistry", ",", "Name"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"DataLineShapeFunction", "[", "Name", "]"}], ":=", 
       "Function"}], ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.516558901109375*^9, 3.516558972765625*^9}, {
   3.51792614103125*^9, 3.517926142046875*^9}, {3.518433494015625*^9, 
   3.518433502578125*^9}, 3.518434572921875*^9, {3.518536123515625*^9, 
   3.518536126921875*^9}, {3.582815846818969*^9, 3.582815846818969*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Predefined curve shapes", "Subsection",
 CellChangeTimes->{{3.516559141375*^9, 3.51655914471875*^9}, {
  3.518433574453125*^9, 3.518433575140625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineDataLineShape", "[", "\[IndentingNewLine]", 
   RowBox[{"\"\<Straight\>\"", ",", "\[IndentingNewLine]", "Identity"}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516559153921875*^9, 3.516559204328125*^9}, {
   3.51655929659375*^9, 3.516559320453125*^9}, {3.516560586890625*^9, 
   3.51656058940625*^9}, 3.517926142640625*^9, {3.518536161765625*^9, 
   3.518536162609375*^9}, 3.582815846818969*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineDataLineShape", "[", "\[IndentingNewLine]", 
   RowBox[{"\"\<Step\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"Function", "[", 
     RowBox[{"Points", ",", "\[IndentingNewLine]", 
      RowBox[{"Join", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Points", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Table", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"First", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], "+", 
                   RowBox[{"First", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]}], ")"}], 
                 "/", "2"}], ",", 
                RowBox[{"Last", "[", 
                 RowBox[{"Points", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"First", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], "+", 
                   RowBox[{"First", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]}], ")"}], 
                 "/", "2"}], ",", 
                RowBox[{"Last", "[", 
                 RowBox[{"Points", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]}], "}"}]}], 
             "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{
               RowBox[{"Length", "[", "Points", "]"}], "-", "1"}]}], "}"}]}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "1"}], 
         "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"Points", "[", 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}], "]"}], "}"}]}], "\[IndentingNewLine]", 
       "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516559153921875*^9, 3.516559204328125*^9}, 
   3.5165593278125*^9, {3.51655980034375*^9, 3.51655980921875*^9}, 
   3.51656058596875*^9, 3.517926143296875*^9, 3.518536167171875*^9, 
   3.582815846818969*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineDataLineShape", "[", "\[IndentingNewLine]", 
   RowBox[{"\"\<SideStep\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"Function", "[", 
     RowBox[{"Points", ",", "\[IndentingNewLine]", 
      RowBox[{"Join", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Points", "[", 
          RowBox[{"[", "1", "]"}], "]"}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Table", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"First", "[", 
                 RowBox[{"Points", "[", 
                  RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Last", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], "+", 
                   RowBox[{"Last", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]}], ")"}], 
                 "/", "2"}]}], "}"}], ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"First", "[", 
                 RowBox[{"Points", "[", 
                  RowBox[{"[", 
                   RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"Last", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], "+", 
                   RowBox[{"Last", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]}], ")"}], 
                 "/", "2"}]}], "}"}]}], "\[IndentingNewLine]", "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"i", ",", "1", ",", 
              RowBox[{
               RowBox[{"Length", "[", "Points", "]"}], "-", "1"}]}], "}"}]}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "1"}], 
         "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"Points", "[", 
          RowBox[{"[", 
           RowBox[{"-", "1"}], "]"}], "]"}], "}"}]}], "\[IndentingNewLine]", 
       "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516559153921875*^9, 3.516559204328125*^9}, 
   3.5165593278125*^9, {3.51655980034375*^9, 3.5165598886875*^9}, 
   3.516560584265625*^9, 3.517926143859375*^9, 3.518536169078125*^9, 
   3.582815846818969*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineDataLineShape", "[", "\[IndentingNewLine]", 
   RowBox[{"\"\<Histogram\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"Function", "[", 
     RowBox[{"Points", ",", "\[IndentingNewLine]", 
      RowBox[{"Module", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"CanvasBase", "=", 
          RowBox[{"FigResolveCoordinate", "[", 
           RowBox[{"0", ",", "Vertical"}], "]"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Join", "[", "\[IndentingNewLine]", 
         RowBox[{"Join", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"3", "/", "2"}], "*", 
                  RowBox[{"First", "[", 
                   RowBox[{"Points", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "-", 
                 RowBox[{
                  RowBox[{"1", "/", "2"}], "*", 
                  RowBox[{"First", "[", 
                   RowBox[{"Points", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}]}], ")"}], ",", 
               "CanvasBase"}], "}"}], ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"3", "/", "2"}], "*", 
                  RowBox[{"First", "[", 
                   RowBox[{"Points", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "-", 
                 RowBox[{
                  RowBox[{"1", "/", "2"}], "*", 
                  RowBox[{"First", "[", 
                   RowBox[{"Points", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}]}], ")"}], ",", 
               RowBox[{"Last", "[", 
                RowBox[{"Points", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "}"}]}], 
            "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"First", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], "+", 
                    RowBox[{"First", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]}], ")"}], 
                    "/", "2"}], ",", 
                   RowBox[{"Last", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}]}], "}"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"First", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], "+", 
                    RowBox[{"First", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]}], ")"}], 
                    "/", "2"}], ",", "CanvasBase"}], "}"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"First", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], "+", 
                    RowBox[{"First", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]}], ")"}], 
                    "/", "2"}], ",", 
                   RowBox[{"Last", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]}], "}"}]}], 
                "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", 
                 RowBox[{
                  RowBox[{"Length", "[", "Points", "]"}], "-", "1"}]}], 
                "}"}]}], "\[IndentingNewLine]", "]"}], ",", 
             "\[IndentingNewLine]", "1"}], "\[IndentingNewLine]", "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"3", "/", "2"}], "*", 
                  RowBox[{"First", "[", 
                   RowBox[{"Points", "[", 
                    RowBox[{"[", 
                    RowBox[{"-", "1"}], "]"}], "]"}], "]"}]}], "-", 
                 RowBox[{
                  RowBox[{"1", "/", "2"}], "*", 
                  RowBox[{"First", "[", 
                   RowBox[{"Points", "[", 
                    RowBox[{"[", 
                    RowBox[{"-", "2"}], "]"}], "]"}], "]"}]}]}], ")"}], ",", 
               RowBox[{"Last", "[", 
                RowBox[{"Points", "[", 
                 RowBox[{"[", 
                  RowBox[{"-", "1"}], "]"}], "]"}], "]"}]}], "}"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"3", "/", "2"}], "*", 
                  RowBox[{"First", "[", 
                   RowBox[{"Points", "[", 
                    RowBox[{"[", 
                    RowBox[{"-", "1"}], "]"}], "]"}], "]"}]}], "-", 
                 RowBox[{
                  RowBox[{"1", "/", "2"}], "*", 
                  RowBox[{"First", "[", 
                   RowBox[{"Points", "[", 
                    RowBox[{"[", 
                    RowBox[{"-", "2"}], "]"}], "]"}], "]"}]}]}], ")"}], ",", 
               "CanvasBase"}], "}"}]}], "\[IndentingNewLine]", "}"}]}], 
          "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51655920784375*^9, 3.516559209203125*^9}, {
   3.51655947053125*^9, 3.516559497984375*^9}, {3.51655957684375*^9, 
   3.5165596208125*^9}, {3.51655969371875*^9, 3.516559712890625*^9}, 
   3.51656058278125*^9, 3.517926144359375*^9, 3.518536170203125*^9, 
   3.521908228875*^9, 3.5828158468345685`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineDataLineShape", "[", "\[IndentingNewLine]", 
   RowBox[{"\"\<SideHistogram\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"Function", "[", 
     RowBox[{"Points", ",", "\[IndentingNewLine]", 
      RowBox[{"Module", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"CanvasBase", "=", 
          RowBox[{"FigResolveCoordinate", "[", 
           RowBox[{"0", ",", "Horizontal"}], "]"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Join", "[", "\[IndentingNewLine]", 
         RowBox[{"Join", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"CanvasBase", ",", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"3", "/", "2"}], "*", 
                  RowBox[{"Last", "[", 
                   RowBox[{"Points", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "-", 
                 RowBox[{
                  RowBox[{"1", "/", "2"}], "*", 
                  RowBox[{"Last", "[", 
                   RowBox[{"Points", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}]}], ")"}]}], "}"}],
              ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"First", "[", 
                RowBox[{"Points", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"3", "/", "2"}], "*", 
                  RowBox[{"Last", "[", 
                   RowBox[{"Points", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "]"}]}], "-", 
                 RowBox[{
                  RowBox[{"1", "/", "2"}], "*", 
                  RowBox[{"Last", "[", 
                   RowBox[{"Points", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "]"}]}]}], ")"}]}], 
              "}"}]}], "\[IndentingNewLine]", "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"First", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Last", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], "+", 
                    RowBox[{"Last", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]}], ")"}], 
                    "/", "2"}]}], "}"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{"CanvasBase", ",", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Last", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], "+", 
                    RowBox[{"Last", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]}], ")"}], 
                    "/", "2"}]}], "}"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"First", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}], ",", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"Last", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", "i", "]"}], "]"}], "]"}], "+", 
                    RowBox[{"Last", "[", 
                    RowBox[{"Points", "[", 
                    RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "]"}]}], ")"}], 
                    "/", "2"}]}], "}"}]}], "\[IndentingNewLine]", "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", 
                 RowBox[{
                  RowBox[{"Length", "[", "Points", "]"}], "-", "1"}]}], 
                "}"}]}], "\[IndentingNewLine]", "]"}], ",", 
             "\[IndentingNewLine]", "1"}], "\[IndentingNewLine]", "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"First", "[", 
                RowBox[{"Points", "[", 
                 RowBox[{"[", 
                  RowBox[{"-", "1"}], "]"}], "]"}], "]"}], ",", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"3", "/", "2"}], "*", 
                  RowBox[{"Last", "[", 
                   RowBox[{"Points", "[", 
                    RowBox[{"[", 
                    RowBox[{"-", "1"}], "]"}], "]"}], "]"}]}], "-", 
                 RowBox[{
                  RowBox[{"1", "/", "2"}], "*", 
                  RowBox[{"Last", "[", 
                   RowBox[{"Points", "[", 
                    RowBox[{"[", 
                    RowBox[{"-", "2"}], "]"}], "]"}], "]"}]}]}], ")"}]}], 
              "}"}], ",", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"CanvasBase", ",", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"3", "/", "2"}], "*", 
                  RowBox[{"Last", "[", 
                   RowBox[{"Points", "[", 
                    RowBox[{"[", 
                    RowBox[{"-", "1"}], "]"}], "]"}], "]"}]}], "-", 
                 RowBox[{
                  RowBox[{"1", "/", "2"}], "*", 
                  RowBox[{"Last", "[", 
                   RowBox[{"Points", "[", 
                    RowBox[{"[", 
                    RowBox[{"-", "2"}], "]"}], "]"}], "]"}]}]}], ")"}]}], 
              "}"}]}], "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", 
          "]"}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
       "]"}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51655920784375*^9, 3.516559209203125*^9}, {
   3.51655947053125*^9, 3.516559497984375*^9}, {3.51655957684375*^9, 
   3.5165596208125*^9}, {3.51655966634375*^9, 3.516559666875*^9}, {
   3.5165597310625*^9, 3.516559775359375*^9}, {3.5165599159375*^9, 
   3.516559959015625*^9}, 3.516560581328125*^9, 3.517926144875*^9, 
   3.518536171*^9, 3.521908232609375*^9, 3.5828158468345685`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Symbols", "Section",
 CellChangeTimes->{{3.51655885659375*^9, 3.516558859421875*^9}, {
  3.51655998828125*^9, 3.516560012953125*^9}}],

Cell[CellGroupData[{

Cell["Symbol registration", "Subsection",
 CellChangeTimes->{{3.516558980796875*^9, 3.51655898225*^9}, {3.5165599925*^9,
   3.5165600103125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"$DataSymbolShapeRegistry", "=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5165589234375*^9, 3.516558937640625*^9}, {
   3.51655999684375*^9, 3.516560008*^9}, 3.51843342615625*^9, 
   3.518433536890625*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"DefineDataSymbolShape", ",", 
    RowBox[{"{", "HoldRest", "}"}]}], "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.518534759703125*^9, 3.518534767765625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineDataSymbolShape", "[", 
    RowBox[{"Name_", ",", "Function_"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"AppendTo", "[", 
       RowBox[{"$DataSymbolShapeRegistry", ",", "Name"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"DataSymbolShapeFunction", "[", "Name", "]"}], ":=", 
       "Function"}], ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.516558901109375*^9, 3.516558972765625*^9}, {
   3.516560001609375*^9, 3.516560030328125*^9}, {3.518432546015625*^9, 
   3.5184325503125*^9}, {3.518432697015625*^9, 3.518432699125*^9}, 
   3.518433427890625*^9, 3.518433537640625*^9, {3.5184345505625*^9, 
   3.518434577984375*^9}, 3.518533365734375*^9, {3.518534357921875*^9, 
   3.51853438428125*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Predefined data symbols", "Subsection",
 CellChangeTimes->{{3.516560685375*^9, 3.516560688890625*^9}}],

Cell["\<\
With[{n = 16}, Table[{Cos[2*Pi*i/n], Sin[2*Pi*i/n]}, {i, 1, n}]] // N // \
InputForm\
\>", "Program",
 CellChangeTimes->{{3.51656029353125*^9, 3.516560327125*^9}, 
   3.516560515078125*^9}],

Cell["\<\
{{0.9238795325112867, 0.3826834323650898}, {0.7071067811865475, \
0.7071067811865475}, 
 {0.3826834323650898, 0.9238795325112867}, {0., 1.}, {-0.3826834323650898, \
0.9238795325112867}, 
 {-0.7071067811865475, 0.7071067811865475}, {-0.9238795325112867, \
0.3826834323650898}, {-1., 0.}, 
 {-0.9238795325112867, -0.3826834323650898}, {-0.7071067811865475, \
-0.7071067811865475}, 
 {-0.3826834323650898, -0.9238795325112867}, {0., -1.}, {0.3826834323650898, \
-0.9238795325112867}, 
 {0.7071067811865475, -0.7071067811865475}, {0.9238795325112867, \
-0.3826834323650898}, {1., 0.}}\
\>", "Output",
 CellChangeTimes->{{3.51656029065625*^9, 3.516560327421875*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", "circle", " ", "*)"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.608055604272093*^9, 3.6080556073608985`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineDataSymbolShape", "[", "\[IndentingNewLine]", 
   RowBox[{"\"\<Circle\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0.9238795325112867", ",", "0.3826834323650898"}], "}"}], ",", 
      
      RowBox[{"{", 
       RowBox[{"0.7071067811865475", ",", "0.7071067811865475"}], "}"}], ",", 
      
      RowBox[{"{", 
       RowBox[{"0.3826834323650898", ",", "0.9238795325112867"}], "}"}], ",", 
      
      RowBox[{"{", 
       RowBox[{"0.", ",", "1."}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.3826834323650898"}], ",", "0.9238795325112867"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.7071067811865475"}], ",", "0.7071067811865475"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.9238795325112867"}], ",", "0.3826834323650898"}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1."}], ",", "0."}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.9238795325112867"}], ",", 
        RowBox[{"-", "0.3826834323650898"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.7071067811865475"}], ",", 
        RowBox[{"-", "0.7071067811865475"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.3826834323650898"}], ",", 
        RowBox[{"-", "0.9238795325112867"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0.", ",", 
        RowBox[{"-", "1."}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0.3826834323650898", ",", 
        RowBox[{"-", "0.9238795325112867"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0.7071067811865475", ",", 
        RowBox[{"-", "0.7071067811865475"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0.9238795325112867", ",", 
        RowBox[{"-", "0.3826834323650898"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"1.", ",", "0."}], "}"}]}], "}"}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5165602460625*^9, 3.516560289*^9}, {3.5165603365625*^9, 
   3.51656034128125*^9}, 3.516560577203125*^9, 3.51853336703125*^9, 
   3.51853439278125*^9}],

Cell[BoxData[
 RowBox[{"(*", " ", "quadrilaterals", " ", "*)"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.608055616330914*^9, 3.6080556236629267`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DefineDataSymbolShape", "[", "\[IndentingNewLine]", 
   RowBox[{"\"\<Square\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"1.2", "*", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.7071067811865476"}], ",", "0.7071067811865476"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.7071067811865476"}], ",", 
         RowBox[{"-", "0.7071067811865476"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.7071067811865476", ",", 
         RowBox[{"-", "0.7071067811865476"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.7071067811865476", ",", "0.7071067811865476"}], "}"}]}], 
      "}"}]}]}], "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineDataSymbolShape", "[", "\[IndentingNewLine]", 
   RowBox[{"\"\<Diamond\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"1.2", "*", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.", ",", "1."}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1."}], ",", "0."}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.", ",", 
         RowBox[{"-", "1."}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1.", ",", "0."}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5165605469375*^9, 3.5165605474375*^9}, {
   3.51656061840625*^9, 3.51656063234375*^9}, {3.51853336775*^9, 
   3.51853336834375*^9}, 3.518534394484375*^9, 3.518535269703125*^9}],

Cell[BoxData[
 RowBox[{"(*", " ", "triangles", " ", "*)"}]], "Input",
 CellChangeTimes->{{3.6080556286393356`*^9, 3.608055632991743*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DefineDataSymbolShape", "[", "\[IndentingNewLine]", 
   RowBox[{"\"\<UpTriangle\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"1.2", "*", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.", ",", "1."}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.8660254037844386"}], ",", 
         RowBox[{"-", "0.5"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.8660254037844386", ",", 
         RowBox[{"-", "0.4999999999999999"}]}], "}"}]}], "}"}]}]}], 
   "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineDataSymbolShape", "[", "\[IndentingNewLine]", 
   RowBox[{"\"\<LeftTriangle\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"1.2", "*", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1."}], ",", "0."}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.5", ",", 
         RowBox[{"-", "0.8660254037844386"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.4999999999999999", ",", "0.8660254037844386"}], "}"}]}], 
      "}"}]}]}], "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineDataSymbolShape", "[", "\[IndentingNewLine]", 
   RowBox[{"\"\<DownTriangle\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"1.2", "*", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0.", ",", 
         RowBox[{"-", "1."}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.8660254037844386", ",", "0.5"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.8660254037844386"}], ",", "0.4999999999999999"}], 
        "}"}]}], "}"}]}]}], "\[IndentingNewLine]", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineDataSymbolShape", "[", "\[IndentingNewLine]", 
   RowBox[{"\"\<RightTriangle\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"1.2", "*", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"1.", ",", "0."}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.5"}], ",", "0.8660254037844386"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.4999999999999999"}], ",", 
         RowBox[{"-", "0.8660254037844386"}]}], "}"}]}], "}"}]}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51656054471875*^9, 3.516560612015625*^9}, {
  3.518533369078125*^9, 3.518533371015625*^9}, {3.5185343980625*^9, 
  3.51853440575*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"line", "-", "only"}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.608055637156951*^9, 3.6080556496837726`*^9}, {
  3.6080556825218306`*^9, 3.6080556829430313`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DefineDataSymbolShape", "[", "\[IndentingNewLine]", 
   RowBox[{"\"\<Plus\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"1.2", "*", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineDataSymbolShape", "[", "\[IndentingNewLine]", 
   RowBox[{"\"\<Horizontal\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"1.2", "*", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineDataSymbolShape", "[", "\[IndentingNewLine]", 
   RowBox[{"\"\<Vertical\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"1.2", "*", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"DefineDataSymbolShape", "[", "\[IndentingNewLine]", 
   RowBox[{"\"\<Cross\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"1.2", "*", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.7071067811865476"}], ",", "0.7071067811865476"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.7071067811865476"}], ",", 
         RowBox[{"-", "0.7071067811865476"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.7071067811865476", ",", 
         RowBox[{"-", "0.7071067811865476"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.7071067811865476", ",", "0.7071067811865476"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineDataSymbolShape", "[", "\[IndentingNewLine]", 
   RowBox[{"\"\<Asterisk\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"1.2", "*", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.7071067811865476"}], ",", "0.7071067811865476"}], 
        "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "0.7071067811865476"}], ",", 
         RowBox[{"-", "0.7071067811865476"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.7071067811865476", ",", 
         RowBox[{"-", "0.7071067811865476"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0.7071067811865476", ",", "0.7071067811865476"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]", 
   "]"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.49738316709375*^9, 3.4973832105625*^9}, 
   3.5165605488125*^9, {3.51656063478125*^9, 3.516560643640625*^9}, 
   3.518533371890625*^9, {3.51853440903125*^9, 3.518534413125*^9}, {
   3.541867149546875*^9, 3.541867188515625*^9}, {3.608035703426339*^9, 
   3.608035767838852*^9}, {3.608038871464303*^9, 3.608038904692362*^9}, {
   3.6080555762544436`*^9, 3.608055581730053*^9}, {3.608055654316981*^9, 
   3.608055678840224*^9}, {3.6080557369347258`*^9, 3.6080558861177883`*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"general", " ", "polygon"}], " ", "*)"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.608055691039445*^9, 3.6080556956882534`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineDataSymbolShape", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\"\<Polygon\>\"", ",", "n_"}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"N", "[", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Cos", "[", 
          RowBox[{
           RowBox[{"2", "*", "Pi", "*", 
            RowBox[{"i", "/", "n"}]}], "+", 
           RowBox[{"Pi", "/", "2"}]}], "]"}], ",", 
         RowBox[{"Sin", "[", 
          RowBox[{
           RowBox[{"2", "*", "Pi", "*", 
            RowBox[{"i", "/", "n"}]}], "+", 
           RowBox[{"Pi", "/", "2"}]}], "]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "1", ",", "n"}], "}"}]}], "]"}], "]"}]}], 
   "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51853443684375*^9, 3.518534475609375*^9}, {
  3.518534605453125*^9, 3.518534627671875*^9}, {3.5185346606875*^9, 
  3.518534668140625*^9}, {3.51853528390625*^9, 3.518535288703125*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Symbol construction", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DataSymbolVerticesFunction", "[", "SymbolShape_", "]"}], ":=", 
   RowBox[{"With", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"BasicShape", "=", 
       RowBox[{"N", "[", 
        RowBox[{"DataSymbolShapeFunction", "[", "SymbolShape", "]"}], "]"}]}],
       "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"validate", " ", "symbol", " ", "vertices"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{
       "must", " ", "be", " ", "list", " ", "of", " ", "points", " ", 
        RowBox[{"(", 
         RowBox[{"at", " ", "least", " ", "2", " ", "points"}], ")"}], " ", 
        "or", " ", "list", " ", "of", " ", "lists", " ", "of", " ", "points", 
        " ", 
        RowBox[{"(", 
         RowBox[{"at", " ", "least", " ", "2", " ", "points"}], ")"}]}], ",", 
       " ", 
       RowBox[{
       "as", " ", "suitable", " ", "for", " ", "Line", " ", "and", " ", 
        "Polygon"}]}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FigCheckValue", "[", 
       RowBox[{"SciDraw", ",", "BasicShape", ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Repeated", "[", 
           RowBox[{"NumericalPairPattern", ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "Infinity"}], "}"}]}], "]"}], "}"}], "|", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Repeated", "[", 
             RowBox[{"NumericalPairPattern", ",", 
              RowBox[{"{", 
               RowBox[{"2", ",", "Infinity"}], "}"}]}], "]"}], "}"}], ".."}], 
          "}"}]}], ",", "\[IndentingNewLine]", 
        "\"\<calculated symbol shape\>\""}], "\[IndentingNewLine]", "]"}], 
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "translate", " ", "and", " ", "scale", " ", "symbol", " ", "point"}], 
       " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", " ", "\[IndentingNewLine]", 
       RowBox[{"Function", "[", 
        RowBox[{"Ps", ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Ps", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "+", "#"}], ")"}], "&"}], "/@", 
          
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Ps", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "/", "2"}], "*", "BasicShape"}],
            ")"}]}]}], "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Function", "[", 
       RowBox[{"Ps", ",", "\[IndentingNewLine]", 
        RowBox[{"Map", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Ps", "[", 
              RowBox[{"[", "1", "]"}], "]"}], "+", "#"}], ")"}], "&"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"Ps", "[", 
              RowBox[{"[", "2", "]"}], "]"}], "/", "2"}], "*", "BasicShape"}],
            ")"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Depth", "[", "BasicShape", "]"}], "-", "2"}], "}"}]}], 
         "  ", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
            RowBox[{
            "allow", " ", "for", " ", "list", " ", "of", " ", "lists", " ", 
             "of", " ", "points"}], ";", " ", 
            RowBox[{
            "map", " ", "at", " ", "level", " ", "1", " ", "or", " ", "2", 
             " ", "for", " ", "list", " ", "or", " ", "list", " ", "of", " ", 
             "lists"}]}], ",", " ", "respectively"}], " ", "*)"}], 
         "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.464451674765625*^9, 3.4644517430625*^9}, {
   3.516564345109375*^9, 3.516564448359375*^9}, {3.51656450778125*^9, 
   3.516564612953125*^9}, {3.516566441765625*^9, 3.51656648125*^9}, {
   3.51656655578125*^9, 3.516566584734375*^9}, {3.51656664528125*^9, 
   3.5165666460625*^9}, {3.516566919609375*^9, 3.51656692065625*^9}, {
   3.518430989109375*^9, 3.5184309933125*^9}, 3.518432657109375*^9, 
   3.518434551546875*^9, 3.51853480740625*^9, {3.518535028328125*^9, 
   3.51853505821875*^9}, 3.518535218375*^9, {3.5303156291875*^9, 
   3.530315633765625*^9}, {3.530315667546875*^9, 3.530315672125*^9}, 
   3.53031570903125*^9, {3.530315739390625*^9, 3.53031577615625*^9}, {
   3.627334621663884*^9, 3.6273346493539333`*^9}, {3.6273347465577035`*^9, 
   3.6273348238870397`*^9}, {3.627334968109293*^9, 3.6273349733353024`*^9}, {
   3.6273350111497684`*^9, 3.6273350651570635`*^9}, {3.627335104406732*^9, 
   3.627335128305974*^9}, {3.6273358195275884`*^9, 3.6273358199487886`*^9}, {
   3.6273358621312633`*^9, 3.6273358635196657`*^9}, {3.627335897434125*^9, 
   3.6273359441874075`*^9}, {3.627335998678303*^9, 3.6273360470695877`*^9}, {
   3.6273360924656677`*^9, 3.627336100031681*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DataSymbolVerticesFunction", "[", "\"\<Square\>\"", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"%", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", "1"}], "]"}]}], "Input",
 CellChangeTimes->{{3.627335661748911*^9, 3.6273357157406063`*^9}, {
  3.627335964935444*^9, 3.6273359653722444`*^9}}],

Cell[BoxData[
 RowBox[{"Function", "[", 
  RowBox[{"SciDraw`Private`Ps$", ",", 
   RowBox[{"Map", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
       "SciDraw`Private`Ps$", "\[LeftDoubleBracket]", "1", 
        "\[RightDoubleBracket]"}], "+", "#1"}], "&"}], ",", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{
      "SciDraw`Private`Ps$", "\[LeftDoubleBracket]", "2", 
       "\[RightDoubleBracket]"}], " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "0.848528137423857`"}], ",", "0.848528137423857`"}], 
         "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "0.848528137423857`"}], ",", 
          RowBox[{"-", "0.848528137423857`"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0.848528137423857`", ",", 
          RowBox[{"-", "0.848528137423857`"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0.848528137423857`", ",", "0.848528137423857`"}], "}"}]}], 
       "}"}]}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Depth", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "0.848528137423857`"}], ",", "0.848528137423857`"}], 
           "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "0.848528137423857`"}], ",", 
            RowBox[{"-", "0.848528137423857`"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0.848528137423857`", ",", 
            RowBox[{"-", "0.848528137423857`"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0.848528137423857`", ",", "0.848528137423857`"}], "}"}]}],
          "}"}], "]"}], "-", "2"}], "}"}]}], "]"}]}], "]"}]], "Output",
 CellChangeTimes->{
  3.6273358242699966`*^9, {3.627335908634945*^9, 3.6273359663706465`*^9}, 
   3.6273360181315374`*^9, 3.6273360499243927`*^9, 3.6273361043060884`*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.5757359312880714`", ",", "1.4242640687119286`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.5757359312880714`", ",", "0.5757359312880714`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.4242640687119286`", ",", "0.5757359312880714`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.4242640687119286`", ",", "1.4242640687119286`"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.6273358242699966`*^9, {3.627335908634945*^9, 3.6273359663706465`*^9}, 
   3.6273360181315374`*^9, 3.6273360499243927`*^9, 3.6273361043060884`*^9}]
}, Open  ]],

Cell["\<\
construct error bars from one row of output of ExtractCanvasErrorPoints
\tshould normally be given standard symbol size given by SymbolSize option of \
whole plot, rather than size given by symbol size override option column, to \
determine error bar cap widths\
\>", "Text",
 CellChangeTimes->{{3.5165729068125*^9, 3.516572945796875*^9}, {
  3.53031779228125*^9, 3.53031781515625*^9}, {3.537384575140625*^9, 
  3.537384644703125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"ErrorBarLinesFunction", "=", 
   RowBox[{"Function", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"p", ",", "CanvasErrorCapCenters", ",", "s0"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Join", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ListQ", "[", 
          RowBox[{"CanvasErrorCapCenters", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "1"}], "]"}], "]"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"p", ",", 
             RowBox[{"CanvasErrorCapCenters", "[", 
              RowBox[{"[", 
               RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"CanvasErrorCapCenters", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "1"}], "]"}], "]"}], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"s0", "/", "2"}], ")"}], "*", 
               RowBox[{"{", 
                RowBox[{"0", ",", 
                 RowBox[{"-", "1"}]}], "}"}]}]}], ",", 
             RowBox[{
              RowBox[{"CanvasErrorCapCenters", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "1"}], "]"}], "]"}], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"s0", "/", "2"}], ")"}], "*", 
               RowBox[{"{", 
                RowBox[{"0", ",", 
                 RowBox[{"+", "1"}]}], "}"}]}]}]}], "}"}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", "}"}]}], "\[IndentingNewLine]", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ListQ", "[", 
          RowBox[{"CanvasErrorCapCenters", "[", 
           RowBox[{"[", 
            RowBox[{"1", ",", "2"}], "]"}], "]"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"p", ",", 
             RowBox[{"CanvasErrorCapCenters", "[", 
              RowBox[{"[", 
               RowBox[{"1", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"CanvasErrorCapCenters", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "2"}], "]"}], "]"}], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"s0", "/", "2"}], ")"}], "*", 
               RowBox[{"{", 
                RowBox[{"0", ",", 
                 RowBox[{"-", "1"}]}], "}"}]}]}], ",", 
             RowBox[{
              RowBox[{"CanvasErrorCapCenters", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "2"}], "]"}], "]"}], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"s0", "/", "2"}], ")"}], "*", 
               RowBox[{"{", 
                RowBox[{"0", ",", 
                 RowBox[{"+", "1"}]}], "}"}]}]}]}], "}"}]}], "}"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", "}"}]}], "\[IndentingNewLine]", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ListQ", "[", 
          RowBox[{"CanvasErrorCapCenters", "[", 
           RowBox[{"[", 
            RowBox[{"2", ",", "1"}], "]"}], "]"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"p", ",", 
             RowBox[{"CanvasErrorCapCenters", "[", 
              RowBox[{"[", 
               RowBox[{"2", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"CanvasErrorCapCenters", "[", 
               RowBox[{"[", 
                RowBox[{"2", ",", "1"}], "]"}], "]"}], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"s0", "/", "2"}], ")"}], "*", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], ",", 
             RowBox[{
              RowBox[{"CanvasErrorCapCenters", "[", 
               RowBox[{"[", 
                RowBox[{"2", ",", "1"}], "]"}], "]"}], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"s0", "/", "2"}], ")"}], "*", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"+", "1"}], ",", "0"}], "}"}]}]}]}], "}"}]}], "}"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"{", "}"}]}], "\[IndentingNewLine]", "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"ListQ", "[", 
          RowBox[{"CanvasErrorCapCenters", "[", 
           RowBox[{"[", 
            RowBox[{"2", ",", "2"}], "]"}], "]"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"p", ",", 
             RowBox[{"CanvasErrorCapCenters", "[", 
              RowBox[{"[", 
               RowBox[{"2", ",", "2"}], "]"}], "]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"CanvasErrorCapCenters", "[", 
               RowBox[{"[", 
                RowBox[{"2", ",", "2"}], "]"}], "]"}], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"s0", "/", "2"}], ")"}], "*", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"-", "1"}], ",", "0"}], "}"}]}]}], ",", 
             RowBox[{
              RowBox[{"CanvasErrorCapCenters", "[", 
               RowBox[{"[", 
                RowBox[{"2", ",", "2"}], "]"}], "]"}], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"s0", "/", "2"}], ")"}], "*", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"+", "1"}], ",", "0"}], "}"}]}]}]}], "}"}]}], "}"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"{", "}"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516566740984375*^9, 3.51656689890625*^9}, {
   3.516571893265625*^9, 3.51657189915625*^9}, {3.51657195234375*^9, 
   3.516572037796875*^9}, {3.51657207103125*^9, 3.51657215678125*^9}, {
   3.5165721915*^9, 3.516572196984375*^9}, {3.516572250359375*^9, 
   3.516572323734375*^9}, {3.516572364125*^9, 3.51657244178125*^9}, {
   3.516573096828125*^9, 3.51657313771875*^9}, {3.516573411609375*^9, 
   3.516573442171875*^9}, {3.53031561078125*^9, 3.530315610921875*^9}, {
   3.530316000765625*^9, 3.530316032015625*^9}, {3.53031771284375*^9, 
   3.530317749484375*^9}, {3.53738461240625*^9, 3.53738461875*^9}, {
   3.537385227546875*^9, 3.537385252359375*^9}, {3.53738545309375*^9, 
   3.53738552796875*^9}, {3.537389087109375*^9, 3.5373890974375*^9}, 
   3.537389220484375*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Data plot appearance options", "Section",
 CellChangeTimes->{{3.51656272828125*^9, 3.516562740078125*^9}, {
  3.51846700184375*^9, 3.51846700684375*^9}}],

Cell["\<\
No instances will ever be created, but DeclareFigClass registers these \
symbols as figure object class names, so that their options are scoped.\
\>", "Text",
 CellChangeTimes->{{3.516562890890625*^9, 3.516562934859375*^9}, {
  3.51656335671875*^9, 3.51656335846875*^9}, {3.51776889340625*^9, 
  3.517768915390625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DeclareFigClass", "[", 
   RowBox[{"DataLine", ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineFigClassOptions", "[", "\[IndentingNewLine]", 
   RowBox[{"DataLine", ",", "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{"CurveShape", "\[Rule]", "\"\<Straight\>\""}], 
     "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516562858703125*^9, 3.516562887765625*^9}, {
   3.5165630033125*^9, 3.516563006125*^9}, {3.516564087359375*^9, 
   3.516564095296875*^9}, {3.517926146546875*^9, 3.51792614725*^9}, 
   3.518123109984375*^9, {3.5828158468501687`*^9, 3.5828158468501687`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DeclareFigClass", "[", 
   RowBox[{"DataSymbol", ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineFigClassOptions", "[", "\[IndentingNewLine]", 
   RowBox[{"DataSymbol", ",", "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"SymbolShape", "\[Rule]", "\"\<Circle\>\""}], ",", 
      RowBox[{"SymbolSize", "\[Rule]", "2.5"}], ",", 
      RowBox[{"SymbolSizeScale", "\[Rule]", "1.0"}]}], "\[IndentingNewLine]", 
     "}"}]}], "\[IndentingNewLine]", "]"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516562858703125*^9, 3.516562887765625*^9}, {
  3.5165630033125*^9, 3.51656309096875*^9}, {3.602787640296633*^9, 
  3.602787646791642*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DeclareFigClass", "[", 
   RowBox[{"DataFill", ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineFigClassOptions", "[", "\[IndentingNewLine]", 
   RowBox[{"DataFill", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"ShowLine", "\[Rule]", "False"}], ",", 
      RowBox[{"Layer", "\[Rule]", "$FigBackgroundLayer"}]}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Direction", "\[Rule]", "Vertical"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Filling", "\[Rule]", "None"}]}], "\[IndentingNewLine]", 
     "}"}]}], "\[IndentingNewLine]", "]"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516562858703125*^9, 3.516562887765625*^9}, {
  3.5165630033125*^9, 3.51656309096875*^9}, {3.516564067671875*^9, 
  3.516564074859375*^9}, {3.517777298546875*^9, 3.51777730228125*^9}, {
  3.51844005640625*^9, 3.51844006440625*^9}, {3.518440185484375*^9, 
  3.51844018640625*^9}, {3.518465141*^9, 3.518465149609375*^9}, {
  3.518467009703125*^9, 3.51846702696875*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DeclareFigClass", "[", 
   RowBox[{"DataDrop", ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "}"}], ",", 
    RowBox[{"{", "}"}]}], "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineFigClassOptions", "[", "\[IndentingNewLine]", 
   RowBox[{"DataDrop", ",", "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Direction", "\[Rule]", "Vertical"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Filling", "\[Rule]", "None"}]}], "\[IndentingNewLine]", 
     "}"}]}], "\[IndentingNewLine]", "]"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516562858703125*^9, 3.516562887765625*^9}, {
  3.5165630033125*^9, 3.51656309096875*^9}, {3.516564067671875*^9, 
  3.516564074859375*^9}, {3.517777298546875*^9, 3.51777730228125*^9}, {
  3.51844005640625*^9, 3.51844006440625*^9}, {3.518440185484375*^9, 
  3.51844018640625*^9}, {3.518465141*^9, 3.518465149609375*^9}, {
  3.518467009703125*^9, 3.51846702696875*^9}, {3.6222326373053637`*^9, 
  3.6222326587866015`*^9}, {3.622232887139803*^9, 3.622232898917824*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Infinity handling", "Section",
 CellChangeTimes->{{3.518463153609375*^9, 3.518463156796875*^9}}],

Cell[CellGroupData[{

Cell["Quasi-infinite region", "Subsection",
 CellChangeTimes->{{3.5184631609375*^9, 3.5184631728125*^9}}],

Cell["\<\
SuperRegion[] returns a (user coordinate) region which safely circumscribes \
the present panel region.
\tThis allows us to convert \[OpenCurlyDoubleQuote]Infinity\
\[CloseCurlyDoubleQuote] coordinates to safely-usable coordinates.
\tThe factor of 10000 is to make the point effectively infinitely far away, \
so that lines in the direction of a point with an infinite coordinate will be \
almost horizontal or almost vertical.\
\>", "Text",
 CellChangeTimes->{{3.518462884203125*^9, 3.518462944515625*^9}, {
  3.518463044578125*^9, 3.51846311103125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"QuasiInfinity", "=", "10000"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51846319196875*^9, 3.518463196765625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SuperRegion", "[", "]"}], ":=", 
   RowBox[{"ExtendRegion", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"CurrentWindow", "[", "]"}], "@", 
      RowBox[{"UserRegion", "[", "]"}]}], ",", 
     RowBox[{"QuasiInfinity", "*", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}]}], "}"}]}], ",", "Scaled"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.518462831515625*^9, 3.5184628400625*^9}, {
  3.518462951828125*^9, 3.51846303965625*^9}, {3.5184631130625*^9, 
  3.51846312184375*^9}, {3.518463175453125*^9, 3.51846320440625*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Clipping of point to quasi-infinite region", "Subsection",
 CellChangeTimes->{{3.51846317934375*^9, 3.518463186046875*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SuperClipPoint", "[", 
    RowBox[{"{", 
     RowBox[{"x_", ",", "y_"}], "}"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Clip", "[", 
      RowBox[{"x", ",", 
       RowBox[{"First", "[", 
        RowBox[{"SuperRegion", "[", "]"}], "]"}]}], "]"}], ",", 
     RowBox[{"Clip", "[", 
      RowBox[{"y", ",", 
       RowBox[{"Last", "[", 
        RowBox[{"SuperRegion", "[", "]"}], "]"}]}], "]"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SuperClipCoordinate", "[", 
    RowBox[{"x_", ",", 
     RowBox[{"CoordinateIndex", ":", 
      RowBox[{"(", 
       RowBox[{"1", "|", "2"}], ")"}]}]}], "]"}], ":=", 
   RowBox[{"Clip", "[", 
    RowBox[{"x", ",", 
     RowBox[{
      RowBox[{"SuperRegion", "[", "]"}], "[", 
      RowBox[{"[", "CoordinateIndex", "]"}], "]"}]}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.518462831515625*^9, 3.5184628400625*^9}, {
   3.518462951828125*^9, 3.51846303965625*^9}, {3.5184631130625*^9, 
   3.51846312184375*^9}, 3.518463175453125*^9, {3.51846347121875*^9, 
   3.518463473*^9}, {3.51846489440625*^9, 3.51846492678125*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Axis scale", "Section",
 CellChangeTimes->{{3.518434275578125*^9, 3.518434277*^9}}],

Cell["\<\
Note: We require that transformation functions return -Infinity or +Infinity \
for out of range values (instead of, say, None or Missing[]) so that \
meaninfgul directed error bars may be drawn.
However, data points with infinite return values for (x,y) will be omitted.\
\>", "Text",
 CellChangeTimes->{{3.518437924328125*^9, 3.5184380444375*^9}}],

Cell[CellGroupData[{

Cell["Transformation allowing for missing values", "Subsection",
 CellChangeTimes->{{3.51843572903125*^9, 3.51843573528125*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ApplyNotMissing", "[", "f_", "]"}], "[", 
    RowBox[{"x_", "?", "NumericQ"}], "]"}], ":=", 
   RowBox[{"f", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ApplyNotMissing", "[", "f_", "]"}], "[", "x_Missing", "]"}], ":=",
    "x"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.518435692109375*^9, 3.518435714484375*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Symbol registration", "Subsection",
 CellChangeTimes->{{3.516558980796875*^9, 3.51655898225*^9}, {3.5165599925*^9,
   3.5165600103125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"$DataAxisScaleRegistry", "=", 
   RowBox[{"{", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5165589234375*^9, 3.516558937640625*^9}, {
   3.51655999684375*^9, 3.516560008*^9}, 3.51843342615625*^9, 
   3.518433536890625*^9, {3.51843433971875*^9, 3.518434341234375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"DefineAxisScale", ",", 
    RowBox[{"{", "HoldRest", "}"}]}], "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.518534759703125*^9, 3.518534767765625*^9}, {
  3.566248677186368*^9, 3.566248705828018*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DefineAxisScale", "[", 
    RowBox[{"Name_", ",", "Function_"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"AppendTo", "[", 
       RowBox[{"$DataAxisScaleRegistry", ",", "Name"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"DataAxisScaleFunction", "[", "Name", "]"}], ":=", 
       "Function"}], ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.516558901109375*^9, 3.516558972765625*^9}, {
   3.516560001609375*^9, 3.516560030328125*^9}, {3.518432546015625*^9, 
   3.5184325503125*^9}, {3.518432697015625*^9, 3.518432699125*^9}, 
   3.518433427890625*^9, 3.518433537640625*^9, {3.51843450328125*^9, 
   3.51843453034375*^9}, 3.518434585453125*^9, {3.51843478928125*^9, 
   3.518434810125*^9}, 3.51843488775*^9, 3.5184711881875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Predefined axis scalings", "Subsection",
 CellChangeTimes->{{3.518434607578125*^9, 3.518434612390625*^9}}],

Cell["Linear axis", "Text",
 CellChangeTimes->{{3.51847112003125*^9, 3.518471121609375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineAxisScale", "[", 
   RowBox[{"None", ",", "Identity"}], "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516558901109375*^9, 3.516558972765625*^9}, {
   3.516560001609375*^9, 3.516560030328125*^9}, {3.518432546015625*^9, 
   3.5184325503125*^9}, {3.518432697015625*^9, 3.518432699125*^9}, 
   3.518433427890625*^9, 3.518433537640625*^9, {3.51843450328125*^9, 
   3.51843453034375*^9}, 3.518434585453125*^9, {3.51843462353125*^9, 
   3.51843466515625*^9}, 3.5184357870625*^9}],

Cell["Scaled linear axis", "Text",
 CellChangeTimes->{{3.518471124765625*^9, 3.518471126953125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineAxisScale", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Scaled", ",", 
      RowBox[{"ScaleUnits_", "?", "NumericQ"}]}], "}"}], ",", 
    RowBox[{"Function", "[", 
     RowBox[{"x", ",", 
      RowBox[{"x", "/", "ScaleUnits"}]}], "]"}]}], "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516558901109375*^9, 3.516558972765625*^9}, {
   3.516560001609375*^9, 3.516560030328125*^9}, {3.518432546015625*^9, 
   3.5184325503125*^9}, {3.518432697015625*^9, 3.518432699125*^9}, 
   3.518433427890625*^9, 3.518433537640625*^9, {3.51843450328125*^9, 
   3.51843453034375*^9}, 3.518434585453125*^9, {3.51843462353125*^9, 
   3.51843466515625*^9}, 3.5184357870625*^9, {3.518471134609375*^9, 
   3.518471166671875*^9}, {3.51847120846875*^9, 3.518471217484375*^9}, {
   3.51847141421875*^9, 3.518471428984375*^9}, {3.52763083996875*^9, 
   3.527630840140625*^9}}],

Cell["Linear transformation including offset", "Text",
 CellChangeTimes->{{3.518471124765625*^9, 3.518471126953125*^9}, {
  3.527630728640625*^9, 3.527630733125*^9}, {3.5276308701875*^9, 
  3.527630877171875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineAxisScale", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"\"\<Linear\>\"", ",", 
      RowBox[{"a_", "?", "NumericQ"}], ",", 
      RowBox[{"b_", "?", "NumericQ"}]}], "}"}], ",", 
    RowBox[{"Function", "[", 
     RowBox[{"x", ",", 
      RowBox[{
       RowBox[{"a", "*", "x"}], "+", "b"}]}], "]"}]}], "]"}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.516558901109375*^9, 3.516558972765625*^9}, {
   3.516560001609375*^9, 3.516560030328125*^9}, {3.518432546015625*^9, 
   3.5184325503125*^9}, {3.518432697015625*^9, 3.518432699125*^9}, 
   3.518433427890625*^9, 3.518433537640625*^9, {3.51843450328125*^9, 
   3.51843453034375*^9}, 3.518434585453125*^9, {3.51843462353125*^9, 
   3.51843466515625*^9}, 3.5184357870625*^9, {3.518471134609375*^9, 
   3.518471166671875*^9}, {3.51847120846875*^9, 3.518471217484375*^9}, {
   3.51847141421875*^9, 3.518471428984375*^9}, {3.527630737078125*^9, 
   3.52763077203125*^9}, {3.52763082096875*^9, 3.52763085615625*^9}}],

Cell["Logarithmic axis", "Text",
 CellChangeTimes->{{3.51847122065625*^9, 3.5184712298125*^9}, 
   3.51847128815625*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"LimitedLog", "[", 
    RowBox[{
     RowBox[{"b_:", "E"}], ",", 
     RowBox[{"x_", "?", "Positive"}]}], "]"}], "=", 
   RowBox[{"Log", "[", 
    RowBox[{"b", ",", "x"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LimitedLog", "[", 
    RowBox[{
     RowBox[{"b_:", "E"}], ",", 
     RowBox[{"_", "?", "NonPositive"}]}], "]"}], "=", 
   RowBox[{"-", "Infinity"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516558901109375*^9, 3.516558972765625*^9}, {
   3.516560001609375*^9, 3.516560030328125*^9}, {3.518432546015625*^9, 
   3.5184325503125*^9}, {3.518432697015625*^9, 3.518432699125*^9}, 
   3.518433427890625*^9, 3.518433537640625*^9, {3.51843450328125*^9, 
   3.51843453034375*^9}, 3.518434585453125*^9, {3.51843462353125*^9, 
   3.51843466515625*^9}, {3.5184357870625*^9, 3.518435787609375*^9}, {
   3.518471234265625*^9, 3.51847123521875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineAxisScale", "[", 
   RowBox[{"Log", ",", 
    RowBox[{
     RowBox[{"LimitedLog", "[", 
      RowBox[{"10", ",", "#"}], "]"}], "&"}]}], "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516558901109375*^9, 3.516558972765625*^9}, {
   3.516560001609375*^9, 3.516560030328125*^9}, {3.518432546015625*^9, 
   3.5184325503125*^9}, {3.518432697015625*^9, 3.518432699125*^9}, 
   3.518433427890625*^9, 3.518433537640625*^9, {3.51843450328125*^9, 
   3.51843453034375*^9}, 3.518434585453125*^9, {3.51843462353125*^9, 
   3.51843466515625*^9}, {3.5184357870625*^9, 3.518435787609375*^9}, {
   3.518471234265625*^9, 3.51847123521875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineAxisScale", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Log", ",", "Base_"}], "}"}], ",", 
    RowBox[{
     RowBox[{"LimitedLog", "[", 
      RowBox[{"Base", ",", "#"}], "]"}], "&"}]}], "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516558901109375*^9, 3.516558972765625*^9}, {
   3.516560001609375*^9, 3.516560030328125*^9}, {3.518432546015625*^9, 
   3.5184325503125*^9}, {3.518432697015625*^9, 3.518432699125*^9}, 
   3.518433427890625*^9, 3.518433537640625*^9, {3.51843450328125*^9, 
   3.51843453034375*^9}, 3.518434585453125*^9, {3.51843462353125*^9, 
   3.51843466515625*^9}, {3.5184357870625*^9, 3.518435787609375*^9}, {
   3.518471234265625*^9, 3.51847123521875*^9}, {3.5184712990625*^9, 
   3.51847130846875*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["DataPlot", "Section",
 CellChangeTimes->{{3.51542982092225*^9, 3.515429824641*^9}, {
  3.516558648140625*^9, 3.5165586494375*^9}}],

Cell[CellGroupData[{

Cell["Object declaration", "Subsection",
 CellChangeTimes->{{3.515429830437875*^9, 3.515429833266*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DeclareFigClass", "[", "\[IndentingNewLine]", 
   RowBox[{"DataPlot", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Points\>\"", ",", "\"\<CurvePoints\>\"", ",", 
      "\"\<StyleRules\>\""}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "Center", ",", "Left", ",", "Right", ",", "Tail", ",", "Head", ",", 
      "Point"}], "}"}]}], "\[IndentingNewLine]", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineFigClassOptions", "[", "\[IndentingNewLine]", 
   RowBox[{"DataPlot", ",", "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{"graphical", " ", "options", " ", "pass"}], "-", "through"}], 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"DataLine", "\[Rule]", 
       RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"DataSymbol", "\[Rule]", 
       RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"DataFill", "\[Rule]", 
       RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"DataDrop", "\[Rule]", 
       RowBox[{"{", "}"}]}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"data", " ", "processing"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"DataColumns", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"1", ",", "2"}], "}"}]}], ",", "\[IndentingNewLine]", 
      RowBox[{"ColumnNames", "\[Rule]", "None"}], ",", "\[IndentingNewLine]", 
      
      RowBox[{"SymbolOptionColumns", "\[Rule]", "None"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"XErrorColumn", "\[Rule]", "None"}], ",", "\[IndentingNewLine]", 
      RowBox[{"YErrorColumn", "\[Rule]", "None"}], ",", "\[IndentingNewLine]", 
      RowBox[{"XAxisScale", "\[Rule]", "None"}], ",", "\[IndentingNewLine]", 
      RowBox[{"YAxisScale", "\[Rule]", "None"}], ",", "\[IndentingNewLine]", 
      RowBox[{"DataFilters", "\[Rule]", "None"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"attached", " ", "label", " ", "default", " ", "overrides"}], 
       " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "see", " ", "comments", " ", "at", " ", "DefineFigClassOptions"}], " ",
        "*)"}], "\[IndentingNewLine]", 
      RowBox[{"SciDraw`TailTextOrientation", "\[Rule]", "Horizontal"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"SciDraw`HeadTextOrientation", "\[Rule]", "Horizontal"}], ",", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"data", " ", "archiving"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Print", "\[Rule]", "False"}]}], "\[IndentingNewLine]", "}"}]}],
    "\[IndentingNewLine]", "]"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515100688734375*^9, 3.515100745765625*^9}, {
   3.515101427609375*^9, 3.5151014280625*^9}, {3.51510147303125*^9, 
   3.515101489109375*^9}, {3.515160263390625*^9, 3.51516026428125*^9}, {
   3.51516080484375*^9, 3.51516081109375*^9}, {3.515429856500375*^9, 
   3.515429878125375*^9}, {3.5154307895785*^9, 3.515430808375375*^9}, {
   3.51543131279725*^9, 3.51543134560975*^9}, {3.515611505515625*^9, 
   3.5156115174375*^9}, 3.51577560334375*^9, {3.5159617146875*^9, 
   3.515961775921875*^9}, {3.515962042546875*^9, 3.515962049828125*^9}, {
   3.51628840765625*^9, 3.51628841396875*^9}, {3.51628943834375*^9, 
   3.516289439171875*^9}, 3.516291009*^9, {3.516558652265625*^9, 
   3.5165586536875*^9}, {3.5165586879375*^9, 3.51655872140625*^9}, {
   3.516562760828125*^9, 3.51656276265625*^9}, {3.516563367765625*^9, 
   3.51656340665625*^9}, {3.51656396684375*^9, 3.516564001375*^9}, {
   3.516567519390625*^9, 3.516567527234375*^9}, {3.51656820415625*^9, 
   3.516568208734375*^9}, {3.516569302640625*^9, 3.5165693143125*^9}, 
   3.51657050221875*^9, {3.51777561840625*^9, 3.517775647625*^9}, {
   3.517777788*^9, 3.5177777891875*^9}, 3.51792614784375*^9, {
   3.51793094434375*^9, 3.517930973359375*^9}, {3.51843359321875*^9, 
   3.5184336233125*^9}, {3.518433707078125*^9, 3.5184337075*^9}, 
   3.51846956296875*^9, {3.51846969028125*^9, 3.51846969396875*^9}, 
   3.521557450859375*^9, {3.525965476328125*^9, 3.52596547734375*^9}, {
   3.53031485621875*^9, 3.53031486528125*^9}, {3.533410504625*^9, 
   3.53341051409375*^9}, {3.5373810635*^9, 3.5373810700625*^9}, 
   3.53738115503125*^9, 3.5373912429375*^9, {3.5662578774695005`*^9, 
   3.5662578781871014`*^9}, 3.5828158468813686`*^9, {3.584618118754898*^9, 
   3.584618157832967*^9}, {3.584618212698263*^9, 3.584618218829074*^9}, {
   3.584618468181512*^9, 3.5846184810983343`*^9}, {3.584618887276248*^9, 
   3.5846188932042584`*^9}, {3.5846190286436963`*^9, 3.584619039158115*^9}, {
   3.597089102782446*^9, 3.597089110572457*^9}, {3.6222326867886505`*^9, 
   3.622232690251857*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Error bar parameter resolution function", "Subsection",
 CellChangeTimes->{{3.517777116515625*^9, 3.517777121703125*^9}}],

Cell["\<\
modeled after ResolveEdgeOption
but with {X,Y} upgrade order swapped
\t{x,y} -> {{x,X},{y,X}}    no mirroring
\t\tor {{x,x},{y,y}}    mirroring\
\>", "Text",
 CellChangeTimes->{{3.5177771329375*^9, 3.517777200890625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ResolveEdgeOptionSwap", "[", "\[IndentingNewLine]", 
    RowBox[{"Self_Object", ",", "\[IndentingNewLine]", "Option_Symbol", ",", 
     RowBox[{"XYOption", ":", 
      RowBox[{"{", 
       RowBox[{"XOption_Symbol", ",", "YOption_Symbol"}], "}"}]}], ",", 
     "\[IndentingNewLine]", "EntryPattern_", ",", "Filler_", ",", 
     RowBox[{"XYUnique", ":", "LogicalPattern"}], ",", 
     RowBox[{"Mirror", ":", "LogicalPattern"}], ",", "\[IndentingNewLine]", 
     "FullOptions_List"}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"FullPattern", ",", "Result"}], "}"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"validate", " ", "options"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{
       "for", " ", "options", " ", "where", " ", "propagating", " ", "a", " ",
         "single", " ", "value", " ", "to", " ", "both", " ", "X", " ", "and",
         " ", "Y", " ", "is", " ", "nonsense"}], ",", " ", 
       RowBox[{
       "except", " ", "in", " ", "the", " ", "case", " ", "of", " ", "None"}],
        ",", " ", 
       RowBox[{
       "only", " ", "allow", " ", "\"\<None\>\"", " ", "as", " ", "a", " ", 
        "single", " ", "value"}]}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FullPattern", "=", 
       RowBox[{"Default", "|", 
        RowBox[{"If", "[", 
         RowBox[{"XYUnique", ",", "None", ",", "EntryPattern"}], "]"}], "|", 
        RowBox[{"{", 
         RowBox[{"EntryPattern", ",", "EntryPattern"}], "}"}], "|", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"EntryPattern", ",", "EntryPattern"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"EntryPattern", ",", "EntryPattern"}], "}"}]}], "}"}], "|", 
        RowBox[{"{", 
         RowBox[{
         "EntryPattern", ",", "EntryPattern", ",", "EntryPattern", ",", 
          "EntryPattern"}], "}"}]}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"Print", "[", 
         RowBox[{
         "Option", ",", "\"\< \>\"", ",", "XYOption", ",", "\"\< \>\"", ",", 
          "EntryPattern", ",", "\"\< \>\"", ",", "Filler", ",", "\"\< \>\"", 
          ",", "XYUnique", ",", "\"\< \>\"", ",", "Mirror"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<      \>\"", ",", "FullPattern"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{"\"\<      \>\"", ",", 
          RowBox[{"Option", "/.", "FullOptions"}], ",", "\"\< \>\"", ",", 
          RowBox[{"XYOption", "/.", "FullOptions"}]}], "]"}], ";"}], "*)"}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{
       "Self", ",", "Option", ",", "FullPattern", ",", "FullOptions"}], "]"}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{
       "Self", ",", "XOption", ",", "EntryPattern", ",", "FullOptions"}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{
       "Self", ",", "YOption", ",", "EntryPattern", ",", "FullOptions"}], 
       "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "resolve", " ", "XY", " ", "fallthrough", " ", "and", " ", "upgrade", 
        " ", "to", " ", "all", " ", "four", " ", "edges"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"Result", "=", 
       RowBox[{"ResolveOption", "[", "\[IndentingNewLine]", 
        RowBox[{"Option", ",", "\[IndentingNewLine]", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
           "If", " ", "is", " ", "needed", " ", "so", " ", "that", " ", 
            "patterns", " ", "which", " ", "can", " ", "match", " ", "flat", 
            " ", "lists", " ", "or", " ", "special", " ", "values", " ", "do",
             " ", "not", " ", "here", " ", "match", " ", "the", " ", 
            RowBox[{"{", 
             RowBox[{"X", ",", "Y"}], "}"}], " ", "list", " ", "from", " ", 
            "the", " ", "Default", " ", "fallthrough"}], " ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"Option", "/.", "FullOptions"}], ")"}], "===", 
              "Default"}], ",", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{"Default", " ", "as", " ", "XY", " ", "fallthrough"}], 
              " ", "*)"}], "\[IndentingNewLine]", 
             RowBox[{"Default", "\[RuleDelayed]", 
              RowBox[{"(", 
               RowBox[{"XYOption", "/.", "FullOptions"}], ")"}]}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{
               RowBox[{"upgrade", " ", "single", " ", "value"}], ",", " ", 
               RowBox[{
                RowBox[{"as", " ", "U"}], "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"U", ",", "U"}], "}"}]}], ",", " ", 
               RowBox[{
               "if", " ", "it", " ", "survived", " ", "the", " ", "option", 
                " ", "validation"}]}], " ", "*)"}], "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"u", ":", "EntryPattern"}], "\[RuleDelayed]", 
              RowBox[{"{", 
               RowBox[{"u", ",", "u"}], "}"}]}]}], "\[IndentingNewLine]", 
            "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{
             "upgrade", " ", "XY", " ", "pair", " ", "to", " ", "all", " ", 
              "edges"}], ",", " ", 
             RowBox[{
              RowBox[{"using", " ", "either", " ", "mirroring", " ", 
               RowBox[{"{", 
                RowBox[{"B", ",", "L"}], "}"}]}], "\[Rule]", 
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"L", ",", "L"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"B", ",", "B"}], "}"}]}], "}"}], " ", "or", " ", 
                "filler", " ", 
                RowBox[{"{", 
                 RowBox[{"B", ",", "L"}], "}"}]}], "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"L", ",", "X"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"B", ",", "X"}], "}"}]}], "}"}]}]}]}], " ", "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"x", ":", "EntryPattern"}], ",", 
              RowBox[{"y", ":", "EntryPattern"}]}], "}"}], "\[RuleDelayed]", 
            RowBox[{"Reverse", "@", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"y", ",", 
                 RowBox[{"If", "[", 
                  RowBox[{"Mirror", ",", "y", ",", "Filler"}], "]"}]}], "}"}],
                ",", 
               RowBox[{"{", 
                RowBox[{"x", ",", 
                 RowBox[{"If", "[", 
                  RowBox[{"Mirror", ",", "x", ",", "Filler"}], "]"}]}], 
                "}"}]}], "}"}]}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{
              RowBox[{"gracefully", " ", "accept", " ", "pre"}], "-", 
              RowBox[{
              "6", " ", "legacy", " ", "edge", " ", "parameter", " ", 
               "specification"}]}], ",", " ", 
             RowBox[{
              RowBox[{"as", " ", 
               RowBox[{"{", 
                RowBox[{"B", ",", "L", ",", "T", ",", "R"}], "}"}]}], 
              "\[Rule]", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"L", ",", "R"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"B", ",", "T"}], "}"}]}], "}"}]}]}], " ", "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"b", ":", "EntryPattern"}], ",", 
              RowBox[{"l", ":", "EntryPattern"}], ",", 
              RowBox[{"t", ":", "EntryPattern"}], ",", 
              RowBox[{"r", ":", "EntryPattern"}]}], "}"}], ":>", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"l", ",", "r"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"b", ",", "t"}], "}"}]}], "}"}]}]}], 
          "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
         "FullOptions"}], "\[IndentingNewLine]", "]"}]}]}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"Print", "[", "Result", "]"}], ";", "Result"}], "*)"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516459161984375*^9, 3.51645935721875*^9}, {
   3.5164593899375*^9, 3.516459414359375*^9}, {3.516459460890625*^9, 
   3.516459693671875*^9}, {3.51645973840625*^9, 3.516460003375*^9}, {
   3.5164600734375*^9, 3.516460127875*^9}, {3.51646129403125*^9, 
   3.516461314984375*^9}, {3.516461433328125*^9, 3.516461447125*^9}, 
   3.516461548546875*^9, {3.516464352453125*^9, 3.51646435684375*^9}, {
   3.51646440728125*^9, 3.51646440871875*^9}, {3.516464477734375*^9, 
   3.516464500875*^9}, {3.516464548671875*^9, 3.516464560875*^9}, {
   3.51646524184375*^9, 3.51646525515625*^9}, {3.51646570828125*^9, 
   3.516465708828125*^9}, {3.5164657470625*^9, 3.51646576484375*^9}, {
   3.516465928125*^9, 3.516465932265625*^9}, {3.516470813671875*^9, 
   3.5164708525*^9}, {3.51647095953125*^9, 3.516470974546875*^9}, {
   3.516471235546875*^9, 3.516471267296875*^9}, {3.5164716085*^9, 
   3.5164716218125*^9}, {3.516471926359375*^9, 3.516471927546875*^9}, {
   3.51647275378125*^9, 3.516472754921875*^9}, {3.516472829140625*^9, 
   3.516472871484375*^9}, {3.51647309690625*^9, 3.51647309878125*^9}, 
   3.51647314103125*^9, {3.516473266765625*^9, 3.516473421921875*^9}, {
   3.516473525984375*^9, 3.516473646734375*^9}, {3.51777712678125*^9, 
   3.517777128546875*^9}, {3.5177772110625*^9, 3.517777212375*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Data processing", "Subsection",
 CellChangeTimes->{{3.51656997934375*^9, 3.51656998171875*^9}}],

Cell["\<\
Extract {{x,x1,x2},{y,y1,y2},{options}} data
\twhere x1=x-dx1, x2=x+dx2, etc.
\tand these error values may be Missing[]
\trows with nonmissing (x,y) values only
\tforce to floating point data (for efficiency -- note therefore that NumberQ \
may be used as test)
\tnote N is applied to all entries, including option entries
\tnote grouping is by x-quantities then y-quantities to facilitate data \
scaling to canvas points\
\>", "Text",
 CellChangeTimes->{{3.5184360924375*^9, 3.518436096984375*^9}, {
  3.518436130421875*^9, 3.518436146421875*^9}, {3.51843620275*^9, 
  3.51843621215625*^9}, {3.51843691909375*^9, 3.518436929953125*^9}, {
  3.51843764153125*^9, 3.518437690484375*^9}, {3.518438054015625*^9, 
  3.518438063125*^9}, {3.51843810909375*^9, 3.518438131015625*^9}, {
  3.51843859771875*^9, 3.5184386109375*^9}, {3.530314964515625*^9, 
  3.5303149673125*^9}, {3.53031683065625*^9, 3.530316832046875*^9}, {
  3.53738213303125*^9, 3.537382148203125*^9}, {3.53738218025*^9, 
  3.537382188546875*^9}, {3.53738373946875*^9, 3.537383758671875*^9}, {
  3.5373838271875*^9, 3.537383827875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExtractData", "[", "\[IndentingNewLine]", 
    RowBox[{"DataSet_List", ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"cx_Integer", ",", "cy_Integer"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cdx1", ":", 
          RowBox[{
           RowBox[{"(", "_Integer", ")"}], "|", "None"}]}], ",", 
         RowBox[{"cdx2", ":", 
          RowBox[{
           RowBox[{"(", "_Integer", ")"}], "|", "None"}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"cdy1", ":", 
          RowBox[{
           RowBox[{"(", "_Integer", ")"}], "|", "None"}]}], ",", 
         RowBox[{"cdy2", ":", 
          RowBox[{
           RowBox[{"(", "_Integer", ")"}], "|", "None"}]}]}], "}"}]}], "}"}], 
     ",", "\[IndentingNewLine]", "OptionColumnRules_List"}], 
    "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Cases", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"N", "[", "DataSet", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"(", "Row_List", ")"}], "/;", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"NumberQ", "[", 
            RowBox[{"Row", "[", 
             RowBox[{"[", "cx", "]"}], "]"}], "]"}], "&&", 
           RowBox[{"NumberQ", "[", 
            RowBox[{"Row", "[", 
             RowBox[{"[", "cy", "]"}], "]"}], "]"}]}], ")"}]}], 
        "\[RuleDelayed]", 
        RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"x", " ", "data"}], " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Row", "[", 
             RowBox[{"[", "cx", "]"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"cdx1", "===", "None"}], ")"}], "||", 
               RowBox[{"!", 
                RowBox[{"NumericQ", "[", 
                 RowBox[{"Row", "[", 
                  RowBox[{"[", "cdx1", "]"}], "]"}], "]"}]}]}], ",", 
              RowBox[{"Missing", "[", "]"}], ",", 
              RowBox[{
               RowBox[{"Row", "[", 
                RowBox[{"[", "cx", "]"}], "]"}], "-", 
               RowBox[{"Row", "[", 
                RowBox[{"[", "cdx1", "]"}], "]"}]}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"cdx2", "===", "None"}], ")"}], "||", 
               RowBox[{"!", 
                RowBox[{"NumericQ", "[", 
                 RowBox[{"Row", "[", 
                  RowBox[{"[", "cdx2", "]"}], "]"}], "]"}]}]}], ",", 
              RowBox[{"Missing", "[", "]"}], ",", 
              RowBox[{
               RowBox[{"Row", "[", 
                RowBox[{"[", "cx", "]"}], "]"}], "+", 
               RowBox[{"Row", "[", 
                RowBox[{"[", "cdx2", "]"}], "]"}]}]}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{"y", " ", "data"}], " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Row", "[", 
             RowBox[{"[", "cy", "]"}], "]"}], ",", "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"cdy1", "===", "None"}], ")"}], "||", 
               RowBox[{"!", 
                RowBox[{"NumericQ", "[", 
                 RowBox[{"Row", "[", 
                  RowBox[{"[", "cdy1", "]"}], "]"}], "]"}]}]}], ",", 
              RowBox[{"Missing", "[", "]"}], ",", 
              RowBox[{
               RowBox[{"Row", "[", 
                RowBox[{"[", "cy", "]"}], "]"}], "-", 
               RowBox[{"Row", "[", 
                RowBox[{"[", "cdy1", "]"}], "]"}]}]}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{"cdy2", "===", "None"}], ")"}], "||", 
               RowBox[{"!", 
                RowBox[{"NumericQ", "[", 
                 RowBox[{"Row", "[", 
                  RowBox[{"[", "cdy2", "]"}], "]"}], "]"}]}]}], ",", 
              RowBox[{"Missing", "[", "]"}], ",", 
              RowBox[{
               RowBox[{"Row", "[", 
                RowBox[{"[", "cy", "]"}], "]"}], "+", 
               RowBox[{"Row", "[", 
                RowBox[{"[", "cdy2", "]"}], "]"}]}]}], "]"}]}], 
           "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
          "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{"option", " ", "data"}], " ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"Cases", "[", "\[IndentingNewLine]", 
           RowBox[{"OptionColumnRules", ",", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"Rule", "[", 
               RowBox[{"OptionName_Symbol", ",", "c_Integer"}], "]"}], "/;", 
              RowBox[{"(", 
               RowBox[{"!", 
                RowBox[{"MatchQ", "[", 
                 RowBox[{
                  RowBox[{"Row", "[", 
                   RowBox[{"[", "c", "]"}], "]"}], ",", 
                  RowBox[{
                   RowBox[{"(", "_Missing", ")"}], "|", "Default"}]}], 
                 "]"}]}], ")"}]}], "\[RuleDelayed]", 
             RowBox[{"Rule", "[", 
              RowBox[{"OptionName", ",", 
               RowBox[{"Row", "[", 
                RowBox[{"[", "c", "]"}], "]"}]}], "]"}]}]}], 
           "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "}"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51656856559375*^9, 3.516568616859375*^9}, {
   3.516568647515625*^9, 3.5165686559375*^9}, {3.5165686895*^9, 
   3.5165687394375*^9}, {3.5165688061875*^9, 3.516568936*^9}, {
   3.516569007609375*^9, 3.516569191984375*^9}, {3.5165696386875*^9, 
   3.516569639609375*^9}, {3.51657113696875*^9, 3.51657113746875*^9}, {
   3.5184361614375*^9, 3.518436225984375*^9}, 3.51843655365625*^9, {
   3.51843807021875*^9, 3.51843810609375*^9}, {3.5303149850625*^9, 
   3.530315042828125*^9}, {3.530315079734375*^9, 3.530315088140625*^9}, {
   3.53031591503125*^9, 3.530315930734375*^9}, {3.53031666425*^9, 
   3.53031666521875*^9}, {3.537382044453125*^9, 3.537382058234375*^9}, {
   3.537382991984375*^9, 3.537382998875*^9}, {3.537384450625*^9, 
   3.537384469375*^9}, {3.537388119296875*^9, 3.5373881376875*^9}, {
   3.537388207859375*^9, 3.537388255734375*^9}}],

Cell["\<\
Rescale {{x,x-dx1,x+dx2},{y,y-dy1,y+dy2},{options}} data by x-axis and y-axis \
scalings\
\>", "Text",
 CellChangeTimes->{{3.518436825640625*^9, 3.5184368394375*^9}, {
  3.51843753421875*^9, 3.518437541796875*^9}, {3.518437824734375*^9, 
  3.51843786340625*^9}, {3.53031509878125*^9, 3.53031509975*^9}, {
  3.53031682546875*^9, 3.530316826859375*^9}, {3.5373838348125*^9, 
  3.53738383540625*^9}}],

Cell["\<\
(MapThread[Map, {{f, g, h}, #}] &)[{{1, 2, 3}, {4, 5, 6}, {7}}]\
\>", "Program",
 CellChangeTimes->{{3.530316707078125*^9, 3.530316745984375*^9}, 
   3.537383803671875*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f", "[", "1", "]"}], ",", 
     RowBox[{"f", "[", "2", "]"}], ",", 
     RowBox[{"f", "[", "3", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"g", "[", "4", "]"}], ",", 
     RowBox[{"g", "[", "5", "]"}], ",", 
     RowBox[{"g", "[", "6", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"h", "[", "7", "]"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.53031674684375*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RescaleData", "[", 
    RowBox[{"CoordinateData_List", ",", 
     RowBox[{"f", ":", 
      RowBox[{"{", 
       RowBox[{"fx_", ",", "fy_"}], "}"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "RescaledData", "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"rescale", " ", "all", " ", "coordinates"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"RescaledData", "=", 
       RowBox[{"Map", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"MapThread", "[", 
           RowBox[{"Map", ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"ApplyNotMissing", "[", "fx", "]"}], ",", 
                RowBox[{"ApplyNotMissing", "[", "fy", "]"}], ",", 
                "Identity"}], "}"}], ",", "#"}], "}"}]}], "]"}], "&"}], ",", 
         "\[IndentingNewLine]", "CoordinateData"}], "\[IndentingNewLine]", 
        "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "keep", " ", "only", " ", "cases", " ", "with", " ", "finite", " ", 
        RowBox[{"(", 
         RowBox[{"x", ",", "y"}], ")"}], " ", "data", " ", "point", " ", 
        "value"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Cases", "[", 
       RowBox[{"RescaledData", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"_", "?", "NumberQ"}], ",", "_", ",", "_"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"_", "?", "NumberQ"}], ",", "_", ",", "_"}], "}"}], ",", 
          RowBox[{"{", "___", "}"}]}], "}"}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51843684471875*^9, 3.5184368803125*^9}, {
   3.518436953125*^9, 3.51843695346875*^9}, {3.518437052328125*^9, 
   3.518437119296875*^9}, {3.518437190171875*^9, 3.51843719071875*^9}, {
   3.518437301640625*^9, 3.51843730540625*^9}, {3.518438148921875*^9, 
   3.51843823278125*^9}, {3.530315152*^9, 3.530315210078125*^9}, {
   3.530316786421875*^9, 3.53031681934375*^9}, {3.53031685103125*^9, 
   3.53031689496875*^9}, {3.537387588109375*^9, 3.537387617046875*^9}, 
   3.53738933440625*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"NumericOrInfiniteQ", "[", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"_", "?", "NumericQ"}], ")"}], "|", 
     RowBox[{"(", "_DirectedInfinity", ")"}]}], "]"}], "=", "True"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NumericOrInfiniteQ", "[", 
    RowBox[{"Except", "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"_", "?", "NumericQ"}], ")"}], "|", 
      RowBox[{"(", "_DirectedInfinity", ")"}]}], "]"}], "]"}], "=", "False"}],
   ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51843873384375*^9, 3.51843881728125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MakeDataCanvasPoint", "[", 
    RowBox[{"DataPoint", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x_", ",", "x1_", ",", "x2_"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y_", ",", "y1_", ",", "y2_"}], "}"}], ",", 
       "DataPointOptions_List"}], "}"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"CurrentWindow", "[", "]"}], "@", 
      RowBox[{"TFunction", "[", "]"}]}], ")"}], "[", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.53738624021875*^9, 3.537386242859375*^9}, {
  3.537386789203125*^9, 3.537386798421875*^9}, {3.5373869445*^9, 
  3.537386948265625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MakeDataSymbolPrimatives", "[", 
    RowBox[{
     RowBox[{"DataPoint", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"x_", ",", "x1_", ",", "x2_"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"y_", ",", "y1_", ",", "y2_"}], "}"}], ",", 
        "DataPointOptions_List"}], "}"}]}], ",", "DataSymbolOptions_List"}], 
    "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"FullDataPointOptions", "=", 
        RowBox[{"Join", "[", 
         RowBox[{"DataPointOptions", ",", "DataSymbolOptions"}], "]"}]}], ",",
        "LineDirectives", ",", "FillDirectives", ",", "\[IndentingNewLine]", 
       "CanvasPoint", ",", "CanvasErrorCapCenters", ",", "tf"}], 
      "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"calculate", " ", "canvas", " ", "point", " ", "geometry"}], 
      " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"tf", "=", 
       RowBox[{
        RowBox[{"CurrentWindow", "[", "]"}], "@", 
        RowBox[{"TFunction", "[", "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"CanvasPoint", "=", 
       RowBox[{"tf", "@", 
        RowBox[{"{", 
         RowBox[{"x", ",", "y"}], "}"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "extract", " ", "data", " ", "point", " ", "and", " ", "error", " ", 
         "cap", " ", "center", " ", "points", " ", 
         RowBox[{"(", 
          RowBox[{"or", " ", "None"}], ")"}], " ", "as", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"x", ",", "y"}], "}"}], ",", "px1", ",", "px2", ",", 
           "py1", ",", "py2", ",", "size"}], "}"}]}], ";", " ", 
        RowBox[{
        "infinite", " ", "error", " ", "bars", " ", "are", " ", "clipped", 
         " ", "to", " ", "finite", " ", "values", " ", 
         "\"\<a bit outside the region\>\"", " ", "so", " ", "as", " ", "not",
          " ", "to", " ", "befuddle", " ", "the", " ", "window", " ", 
         "transformation", " ", "function"}]}], "*)"}], "\[IndentingNewLine]", 
      RowBox[{"CanvasErrorCapCenters", "=", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"NumericOrInfiniteQ", "[", "x1", "]"}], ",", 
             RowBox[{"tf", "@", 
              RowBox[{"SuperClipPoint", "[", 
               RowBox[{"{", 
                RowBox[{"x1", ",", "y"}], "}"}], "]"}]}], ",", "None"}], 
            "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"NumericOrInfiniteQ", "[", "x2", "]"}], ",", 
             RowBox[{"tf", "@", 
              RowBox[{"SuperClipPoint", "[", 
               RowBox[{"{", 
                RowBox[{"x2", ",", "y"}], "}"}], "]"}]}], ",", "None"}], 
            "]"}]}], "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"NumericOrInfiniteQ", "[", "y1", "]"}], ",", 
             RowBox[{"tf", "@", 
              RowBox[{"SuperClipPoint", "[", 
               RowBox[{"{", 
                RowBox[{"x", ",", "y1"}], "}"}], "]"}]}], ",", "None"}], 
            "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"NumericOrInfiniteQ", "[", "y2", "]"}], ",", 
             RowBox[{"tf", "@", 
              RowBox[{"SuperClipPoint", "[", 
               RowBox[{"{", 
                RowBox[{"x", ",", "y2"}], "}"}], "]"}]}], ",", "None"}], 
            "]"}]}], "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", 
        "}"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"generate", " ", "primatives"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"error", " ", 
         RowBox[{"bar", " ", "--"}], " ", "lines", " ", "function", " ", 
         "takes", " ", 
         RowBox[{"{", 
          RowBox[{
          "p", ",", "px1", ",", "px2", ",", "py1", ",", "py2", ",", "s0"}], 
          "}"}]}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"LineDirectives", "=", 
          RowBox[{"MakeLineDirectives", "[", "FullDataPointOptions", "]"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"FillDirectives", "=", 
          RowBox[{"MakeFillDirectives", "[", "FullDataPointOptions", "]"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"LineDirectives", "=!=", "None"}], ")"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Flatten", "[", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{"LineDirectives", ",", "\[IndentingNewLine]", 
              RowBox[{"Line", "[", "\[IndentingNewLine]", 
               RowBox[{"ErrorBarLinesFunction", "[", "\[IndentingNewLine]", 
                RowBox[{
                "CanvasPoint", ",", "\[IndentingNewLine]", 
                 "CanvasErrorCapCenters", ",", "\[IndentingNewLine]", 
                 RowBox[{"(", 
                  RowBox[{"SymbolSize", "/.", "DataSymbolOptions"}], ")"}]}], 
                "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "]"}]}], 
             "\[IndentingNewLine]", "}"}], "]"}], ",", "\[IndentingNewLine]", 
           
           RowBox[{"{", "}"}]}], "\[IndentingNewLine]", "]"}]}], ",", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"symbol", " ", "--"}], " ", "data", " ", "symbol", " ", 
          "vertices", " ", "function", " ", "takes", " ", "canvas", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"x", ",", "y"}], "}"}], ",", "s"}], "}"}]}], "  ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"LineDirectives", ",", "FillDirectives"}], "}"}], "=!=", 
           RowBox[{"{", 
            RowBox[{"None", ",", "None"}], "}"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Flatten", "[", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"EdgeForm", "[", "LineDirectives", "]"}], ",", 
               RowBox[{"FaceForm", "[", "FillDirectives", "]"}]}], "}"}], ",",
              "\[IndentingNewLine]", 
             RowBox[{"Polygon", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"DataSymbolVerticesFunction", "[", 
                RowBox[{"(", 
                 RowBox[{"SymbolShape", "/.", "FullDataPointOptions"}], ")"}],
                 "]"}], "[", 
               RowBox[{"{", 
                RowBox[{"CanvasPoint", ",", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"SymbolSize", "/.", "FullDataPointOptions"}], 
                   ")"}], "*", 
                  RowBox[{"(", 
                   RowBox[{"SymbolSizeScale", "/.", "FullDataPointOptions"}], 
                   ")"}]}]}], "}"}], "]"}], "\[IndentingNewLine]", "]"}]}], 
            "\[IndentingNewLine]", "}"}], "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", "}"}]}], "\[IndentingNewLine]", "]"}]}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.53738164090625*^9, 3.537381671078125*^9}, {
   3.537384299046875*^9, 3.5373843475*^9}, {3.537384480375*^9, 
   3.537384507265625*^9}, {3.53738467525*^9, 3.537384688046875*^9}, {
   3.537384742640625*^9, 3.537384859859375*^9}, {3.537384950734375*^9, 
   3.537385029109375*^9}, {3.537385066265625*^9, 3.5373851454375*^9}, {
   3.53738532115625*^9, 3.537385393*^9}, {3.537385567359375*^9, 
   3.537385801296875*^9}, {3.537386257875*^9, 3.537386261390625*^9}, {
   3.537386742453125*^9, 3.5373867774375*^9}, {3.537387281421875*^9, 
   3.537387284015625*^9}, {3.5373874214375*^9, 3.537387482390625*^9}, {
   3.53738763928125*^9, 3.53738764540625*^9}, {3.537387770171875*^9, 
   3.53738781828125*^9}, {3.537387862671875*^9, 3.537387920359375*^9}, {
   3.537388644109375*^9, 3.537388649546875*^9}, {3.53738869484375*^9, 
   3.53738873746875*^9}, {3.5373888328125*^9, 3.5373888821875*^9}, {
   3.537388924140625*^9, 3.537388927890625*^9}, 3.53738904165625*^9, {
   3.537389140046875*^9, 3.53738914159375*^9}, {3.537389184515625*^9, 
   3.537389200171875*^9}, {3.537389235515625*^9, 3.5373892384375*^9}, {
   3.580051552880581*^9, 3.580051637496881*^9}, {3.580051677743664*^9, 
   3.580051698733693*^9}, {3.602787672681678*^9, 3.602787675556682*^9}, {
   3.6080602700953555`*^9, 3.6080602770841675`*^9}, 3.622041756489787*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructor", "Subsection",
 CellChangeTimes->{{3.51543192685975*^9, 3.5154319283285*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"DataSetPattern", "=", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"_", "?", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"ArrayQ", "[", 
           RowBox[{"#", ",", "2"}], "]"}], "&"}], ")"}]}], ")"}], "|", 
      RowBox[{"{", "}"}]}]}], ";"}], "*)"}], 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "chokes", " ", "if", " ", "data", " ", "entries", " ", "are", " ", 
     "lists"}], ",", " ", 
    RowBox[{"e", ".", "g", "."}], ",", " ", 
    RowBox[{"for", " ", "symbol", " ", "specifier"}]}], "*)"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51657046878125*^9, 3.516570482671875*^9}, {
  3.521568328765625*^9, 3.521568389171875*^9}, {3.5340126*^9, 
  3.534012603828125*^9}, {3.537388414125*^9, 3.5373884391875*^9}, {
  3.557864412390625*^9, 3.557864435296875*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Replace", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", ",", "y"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", "0"}], "}"}], ",", 
   RowBox[{"{", "1", "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Replace", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", "y"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "y"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", "0"}], "}"}], ",", 
   RowBox[{"{", "2", "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Replace", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", "\[Rule]", "x"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", "\[Rule]", "0"}], "}"}], ",", 
   RowBox[{"{", "2", "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.5970901436271553`*^9, 3.5970901603799124`*^9}},
 CellID->370757339],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", "y"}], "}"}]], "Output",
 CellChangeTimes->{{3.597090140127101*^9, 3.597090160722418*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "y"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "y"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.597090140127101*^9, 3.5970901607249174`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"a", "\[Rule]", "0"}], "}"}]], "Output",
 CellChangeTimes->{{3.597090140127101*^9, 3.597090160727418*^9}}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DataSetPattern", "=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"_", "?", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"ArrayDepth", "[", "#", "]"}], "\[GreaterEqual]", "2"}], 
        "&"}], ")"}]}], ")"}], "|", 
    RowBox[{"{", "}"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DataColumnNamePattern", "=", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"(", "_Integer", ")"}], "?", "Positive"}], ")"}], "|", 
     RowBox[{"(", "_String", ")"}], "|", 
     RowBox[{"{", 
      RowBox[{"_String", ",", "___"}], "}"}]}]}], ";"}], "  ", 
  RowBox[{"(*", " ", 
   RowBox[{"excludes", " ", "None"}], " ", "*)"}]}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.55786444778125*^9, 3.557864457140625*^9}, {
   3.5970911651250334`*^9, 3.5970912104587135`*^9}, {3.59709126532401*^9, 
   3.5970912698324175`*^9}, 3.5970913958494387`*^9, {3.597091657649099*^9, 
   3.597091659645902*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"First", "/@", 
  RowBox[{"Options", "@", "DataSymbol"}]}]], "Input",
 CellChangeTimes->{{3.6042701320041237`*^9, 3.6042701399601374`*^9}, {
  3.6042702676619616`*^9, 3.604270268863164*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "Color", ",", "Debug", ",", "Directives", ",", "Epilog", ",", "FillColor", 
   ",", "FillDirectives", ",", "FillOpacity", ",", "FontFamily", ",", 
   "FontSize", ",", "FontSlant", ",", "FontTracking", ",", "FontVariations", 
   ",", "FontWeight", ",", "Layer", ",", "LineCapForm", ",", "LineColor", ",",
    "LineDashing", ",", "LineDirectives", ",", "LineJoinForm", ",", 
   "LineOpacity", ",", "LineThickness", ",", "Opacity", ",", "PointColor", 
   ",", "PointDirectives", ",", "PointOpacity", ",", "PointSize", ",", 
   "Prolog", ",", "Show", ",", "ShowFill", ",", "ShowLine", ",", "ShowPoint", 
   ",", "ShowText", ",", "Style", ",", "SymbolShape", ",", "SymbolSize", ",", 
   "SymbolSizeScale", ",", "TextBackground", ",", "TextBaseBuffer", ",", 
   "TextBuffer", ",", "TextColor", ",", "TextFrame", ",", "TextFrameColor", 
   ",", "TextMargin", ",", "TextNudge", ",", "TextOffset", ",", "TextOpacity",
    ",", "TextOrientation", ",", "TextPadding", ",", "TextRectify", ",", 
   "TextRoundingRadius", ",", "TextStyleOptions"}], "}"}]], "Output",
 CellChangeTimes->{{3.6042701359041305`*^9, 3.604270140272138*^9}, 
   3.6042702692531643`*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DataPlot", "::", "columnname"}], "=", 
   "\"\<Encountered undefined column name `1`.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Constructor", "[", 
     RowBox[{
      RowBox[{"Class", ":", "DataPlot"}], ",", "Self_Object"}], "]"}], "[", 
    RowBox[{"DataSet_", ",", 
     RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"FigObjectWrapper", "[", 
    RowBox[{"Class", ",", "Self", ",", 
     RowBox[{"{", "Opts", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
        "DataStyle", ",", "DataLineOptions", ",", "DataSymbolOptions", ",", 
         "DataFillOptions", ",", "DataDropOptions", ",", 
         "\[IndentingNewLine]", "UsedColumnNames", ",", "UsedDataColumns", 
         ",", "ColumnResolutionRules", ",", "\[IndentingNewLine]", 
         "PointData", ",", "CanvasPoints", ",", "CurvePoints", ",", 
         "UsedDataSymbolVerticesFunction", ",", "CanvasErrorPoints", ",", 
         "UsedErrorColumns", ",", "UsedAxisScales", ",", 
         "\[IndentingNewLine]", "UsedSymbolOptionColumns"}], 
        "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"validate", " ", "extra", " ", "options"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "DataLine", ",", "_List", ",", "FigOptions"}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "DataSymbol", ",", "_List", ",", "FigOptions"}],
          "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "DataColumns", ",", 
          RowBox[{"{", 
           RowBox[{"DataColumnNamePattern", ",", "DataColumnNamePattern"}], 
           "}"}], ",", "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "ColumnNames", ",", 
          RowBox[{"None", "|", 
           RowBox[{"{", 
            RowBox[{"DataColumnNamePattern", "..."}], "}"}]}], ",", 
          "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "XErrorColumn", ",", 
          RowBox[{"None", "|", "DataColumnNamePattern", "|", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"None", "|", "DataColumnNamePattern"}], ",", 
             RowBox[{"None", "|", "DataColumnNamePattern"}]}], "}"}]}], ",", 
          "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "YErrorColumn", ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"None", "|", "DataColumnNamePattern"}], ")"}], "|", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"None", "|", "DataColumnNamePattern"}], ",", 
             RowBox[{"None", "|", "DataColumnNamePattern"}]}], "}"}]}], ",", 
          "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"FigCheckOption", "[", 
           RowBox[{"Self", ",", "SymbolOptionColumns", ",", 
            RowBox[{"None", "|", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"Rule", "[", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                  "SymbolShape", "|", "SymbolSize", "|", "SymbolSizeScale", 
                   "|", "Color", "|", "FillColor", "|", "LineColor", "|", 
                   "LineThickness"}], ")"}], ",", "DataColumnNamePattern"}], 
                "]"}], "..."}], "}"}]}], ",", "FigOptions"}], "]"}], ";"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "SymbolOptionColumns", ",", 
          RowBox[{"None", "|", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Rule", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                "Color", "|", "Directives", "|", "FillColor", "|", 
                 "FillDirectives", "|", "FillOpacity", "|", "LineCapForm", 
                 "|", "LineColor", "|", "LineDashing", "|", "LineDirectives", 
                 "|", "LineJoinForm", "|", "LineOpacity", "|", 
                 "LineThickness", "|", "Opacity", "|", "Show", "|", 
                 "ShowFill", "|", "ShowLine", "|", "SymbolShape", "|", 
                 "SymbolSize", "|", "SymbolSizeScale"}], ")"}], ",", 
               "\[IndentingNewLine]", "DataColumnNamePattern"}], "]"}], 
             "..."}], "}"}]}], ",", "FigOptions"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "XAxisScale", ",", 
          RowBox[{"Alternatives", "@@", "$DataAxisScaleRegistry"}], ",", 
          "FigOptions"}], "]"}], ";", "  ", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "YAxisScale", ",", 
          RowBox[{"Alternatives", "@@", "$DataAxisScaleRegistry"}], ",", 
          "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "DataFilters", ",", "_", ",", "FigOptions"}], 
         "]"}], ";", "  ", 
        RowBox[{"(*", " ", 
         RowBox[{
         "TODO", " ", "tighten", " ", "validation", " ", "pattern", " ", 
          "once", " ", "implemented"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{
         "Self", ",", "Print", ",", "LogicalPattern", ",", "FigOptions"}], 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"validate", " ", "plot", " ", "data"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"FigCheckValue", "[", 
         RowBox[{
         "Self", ",", "DataSet", ",", "DataSetPattern", ",", 
          "\"\<given data set\>\""}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"apply", " ", "plot", " ", "style"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"WithStyle", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Style", "/.", "FigOptions"}], ")"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"DataLineOptions", "=", 
            RowBox[{"FigRealizeOptions", "[", 
             RowBox[{"Self", ",", "DataLine", ",", 
              RowBox[{"(", 
               RowBox[{"DataLine", "/.", "FigOptions"}], ")"}]}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"DataSymbolOptions", "=", 
            RowBox[{"FigRealizeOptions", "[", 
             RowBox[{"Self", ",", "DataSymbol", ",", 
              RowBox[{"(", 
               RowBox[{"DataSymbol", "/.", "FigOptions"}], ")"}]}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"DataFillOptions", "=", 
            RowBox[{"FigRealizeOptions", "[", 
             RowBox[{"Self", ",", "DataFill", ",", 
              RowBox[{"(", 
               RowBox[{"DataFill", "/.", "FigOptions"}], ")"}]}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"DataDropOptions", "=", 
            RowBox[{"FigRealizeOptions", "[", 
             RowBox[{"Self", ",", "DataDrop", ",", 
              RowBox[{"(", 
               RowBox[{"DataDrop", "/.", "FigOptions"}], ")"}]}], "]"}]}]}]}],
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"save", " ", "plot", " ", "style", " ", "rules"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"Self", "@", 
         RowBox[{"SetStyleRules", "[", "\[IndentingNewLine]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"DataLine", "->", "DataLineOptions"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"DataSymbol", "->", "DataSymbolOptions"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"DataFill", "->", "DataFillOptions"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"DataDrop", "->", "DataDropOptions"}]}], 
           "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"impose", " ", "DataPlot", " ", "Show"}], "\[Rule]", 
          RowBox[{"False", " ", "override"}]}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"DataLineOptions", "=", 
         RowBox[{"OptionsUnion", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Show", "\[Rule]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"Show", "/.", "FigOptions"}], ")"}], "&&", 
              RowBox[{"(", 
               RowBox[{"Show", "/.", "DataLineOptions"}], ")"}]}], ")"}]}], 
           ",", "\[IndentingNewLine]", "DataLineOptions"}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"DataSymbolOptions", "=", 
         RowBox[{"OptionsUnion", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Show", "\[Rule]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"Show", "/.", "FigOptions"}], ")"}], "&&", 
              RowBox[{"(", 
               RowBox[{"Show", "/.", "DataSymbolOptions"}], ")"}]}], ")"}]}], 
           ",", "\[IndentingNewLine]", "DataSymbolOptions"}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"DataFillOptions", "=", 
         RowBox[{"OptionsUnion", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Show", "\[Rule]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"Show", "/.", "FigOptions"}], ")"}], "&&", 
              RowBox[{"(", 
               RowBox[{"Show", "/.", "DataFillOptions"}], ")"}]}], ")"}]}], 
           ",", "\[IndentingNewLine]", "DataFillOptions"}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"DataDropOptions", "=", 
         RowBox[{"OptionsUnion", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Show", "\[Rule]", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"Show", "/.", "FigOptions"}], ")"}], "&&", 
              RowBox[{"(", 
               RowBox[{"Show", "/.", "DataDropOptions"}], ")"}]}], ")"}]}], 
           ",", "\[IndentingNewLine]", "DataDropOptions"}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "validate", " ", "data", " ", "plot", " ", "style", " ", "options"}],
          " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"FigCheckBaseOptions", "[", 
         RowBox[{"Self", ",", "DataLineOptions"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "CurveShape", ",", 
          RowBox[{"Alternatives", "@@", "$DataLineShapeRegistry"}], ",", 
          "DataLineOptions"}], "]"}], ";", 
        RowBox[{"FigCheckBaseOptions", "[", 
         RowBox[{"Self", ",", "DataSymbolOptions"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "SymbolShape", ",", 
          RowBox[{"Alternatives", "@@", "$DataSymbolShapeRegistry"}], ",", 
          "DataSymbolOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "SymbolSize", ",", 
          RowBox[{"_", "?", "Positive"}], ",", "DataSymbolOptions"}], "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "SymbolSizeScale", ",", 
          RowBox[{"_", "?", "Positive"}], ",", "DataSymbolOptions"}], "]"}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckBaseOptions", "[", 
         RowBox[{"Self", ",", "DataFillOptions"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "Direction", ",", 
          RowBox[{"Horizontal", "|", "Vertical"}], ",", "DataFillOptions"}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "Filling", ",", 
          RowBox[{"None", "|", "Axis", "|", 
           RowBox[{"(", 
            RowBox[{"_", "?", "NumericQ"}], ")"}], "|", 
           RowBox[{"(", "_DirectedInfinity", ")"}], "|", 
           RowBox[{"ObjectNamePattern", "[", "DataPlot", "]"}]}], ",", 
          "DataFillOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckBaseOptions", "[", 
         RowBox[{"Self", ",", "DataDropOptions"}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "Direction", ",", 
          RowBox[{"Horizontal", "|", "Vertical"}], ",", "DataDropOptions"}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "Filling", ",", 
          RowBox[{"None", "|", "Axis", "|", 
           RowBox[{"(", 
            RowBox[{"_", "?", "NumericQ"}], ")"}], "|", 
           RowBox[{"(", "_DirectedInfinity", ")"}]}], ",", 
          "DataDropOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"generate", " ", "data", " ", "archive", " ", "cell"}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Print", "/.", "FigOptions"}], ")"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"CellPrintValue", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"TableForm", "[", "DataSet", "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"Label", "\[Rule]", "\"\<FigData plot data\>\""}]}], 
           "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"define", " ", "columns"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"UsedColumnNames", "=", 
         RowBox[{"ResolveOption", "[", 
          RowBox[{"ColumnNames", ",", 
           RowBox[{"{", 
            RowBox[{"None", "\[Rule]", 
             RowBox[{"{", "}"}]}], "}"}], ",", "FigOptions"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"ColumnResolutionRules", "=", "\[IndentingNewLine]", 
         RowBox[{"Join", "[", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
           "preserve", " ", "integer", " ", "literal", " ", "column", " ", 
            RowBox[{"(", 
             RowBox[{"or", " ", "None"}], ")"}]}], " ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"None", "\[Rule]", "None"}], ",", 
             RowBox[{
              RowBox[{"(", "c_Integer", ")"}], "\[RuleDelayed]", "c"}]}], 
            "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"make", " ", "named", " ", "column", " ", "rules"}], " ", 
            "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Table", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"UsedColumnNames", "[", 
               RowBox[{"[", "c", "]"}], "]"}], "\[Rule]", "c"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"c", ",", "1", ",", 
               RowBox[{"Length", "[", "UsedColumnNames", "]"}]}], "}"}]}], 
            "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", "fallthrough", " ", "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"x_", "\[RuleDelayed]", 
             RowBox[{"FigError", "[", 
              RowBox[{"DataPlot", ",", "\"\<columnname\>\"", ",", "x"}], 
              "]"}]}], "}"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"UsedDataColumns", "=", 
         RowBox[{"Replace", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"DataColumns", "/.", "FigOptions"}], ")"}], ",", 
           "ColumnResolutionRules", ",", 
           RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "  ", 
        RowBox[{"(*", " ", 
         RowBox[{"replace", " ", "at", " ", "level", " ", 
          RowBox[{"{", "1", "}"}], " ", "for", " ", 
          RowBox[{"{", 
           RowBox[{"x", ",", "y"}], "}"}]}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"UsedErrorColumns", "=", 
         RowBox[{"Replace", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"UpgradePair", "[", 
              RowBox[{"(", 
               RowBox[{"XErrorColumn", "/.", "FigOptions"}], ")"}], "]"}], 
             ",", 
             RowBox[{"UpgradePair", "[", 
              RowBox[{"(", 
               RowBox[{"YErrorColumn", "/.", "FigOptions"}], ")"}], "]"}]}], 
            "}"}], ",", "ColumnResolutionRules", ",", 
           RowBox[{"{", "2", "}"}]}], "]"}]}], ";", " ", 
        RowBox[{"(*", " ", 
         RowBox[{"replace", " ", "at", " ", "level", " ", 
          RowBox[{"{", "2", "}"}], " ", "for", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"xm", ",", "xp"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"ym", ",", "ym"}], "}"}]}], "}"}]}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"UsedSymbolOptionColumns", "=", 
         RowBox[{"Cases", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"ResolveOption", "[", 
            RowBox[{"SymbolOptionColumns", ",", 
             RowBox[{"{", 
              RowBox[{"None", "\[Rule]", 
               RowBox[{"{", "}"}]}], "}"}], ",", "FigOptions"}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"opt_", "\[Rule]", "c_"}], ")"}], "\[RuleDelayed]", 
            RowBox[{"(", 
             RowBox[{"opt", "\[Rule]", 
              RowBox[{"Replace", "[", 
               RowBox[{"c", ",", "ColumnResolutionRules"}], "]"}]}], 
             ")"}]}]}], "\[IndentingNewLine]", "]"}]}], ";", " ", 
        RowBox[{"(*", " ", 
         RowBox[{"replace", " ", "via", " ", "cases", " ", "for", " ", 
          RowBox[{"{", 
           RowBox[{"option", "\[Rule]", "c"}], "}"}]}], " ", "*)"}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"extract", " ", "nonmissing", " ", "data"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"PointData", "=", 
         RowBox[{"ExtractData", "[", "\[IndentingNewLine]", 
          RowBox[{
          "DataSet", ",", "\[IndentingNewLine]", "UsedDataColumns", ",", 
           "UsedErrorColumns", ",", "\[IndentingNewLine]", 
           "UsedSymbolOptionColumns"}], "\[IndentingNewLine]", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Debug", "/.", "FigOptions"}], ")"}], ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<  \>\"", ",", "\"\<PointData: \>\"", ",", "PointData"}], 
           "]"}]}], "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "rescale", " ", "data", " ", "by", " ", "data", " ", "axis", " ", 
           "scales", " ", "and", " ", "re"}], "-", 
          RowBox[{"prune", " ", 
           RowBox[{"values", " ", "--"}], " ", "result", " ", "is", " ", "in",
            " ", "user", " ", "coordinates"}]}], "  ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"UsedAxisScales", "=", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"XAxisScale", "/.", "FigOptions"}], ",", 
           RowBox[{"YAxisScale", "/.", "FigOptions"}]}], "}"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"PointData", "=", 
         RowBox[{"RescaleData", "[", 
          RowBox[{"PointData", ",", 
           RowBox[{"DataAxisScaleFunction", "/@", "UsedAxisScales"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Debug", "/.", "FigOptions"}], ")"}], ",", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<  \>\"", ",", "\"\<PointData (rescaled): \>\"", ",", 
            "PointData"}], "]"}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "save", " ", "data", " ", "needed", " ", "for", " ", "anchor", " ", 
          "generation"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"CanvasPoints", "=", 
         RowBox[{"MakeDataCanvasPoint", "/@", "PointData"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"CurvePoints", "=", 
         RowBox[{
          RowBox[{"DataLineShapeFunction", "[", 
           RowBox[{"(", 
            RowBox[{"CurveShape", "/.", "DataLineOptions"}], ")"}], "]"}], 
          "[", "CanvasPoints", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Self", "@", 
         RowBox[{"SetPoints", "[", "CanvasPoints", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Self", "@", 
         RowBox[{"SetCurvePoints", "[", "CurvePoints", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"make", " ", "graphics", " ", "elements"}], " ", "*)"}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", "fill", " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"Filling", "/.", "DataFillOptions"}], ")"}], "=!=", 
           "None"}], ",", "  ", 
          RowBox[{"(*", " ", 
           RowBox[{"short", " ", "circuit"}], " ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"FigPolygonElement", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Polygon", "[", 
              RowBox[{"FillPoints", "[", 
               RowBox[{"CurvePoints", ",", 
                RowBox[{"(", 
                 RowBox[{"Filling", "/.", "DataFillOptions"}], ")"}], ",", 
                RowBox[{"(", 
                 RowBox[{"Direction", "/.", "DataFillOptions"}], ")"}]}], 
               "]"}], "]"}], "}"}], ",", "\[IndentingNewLine]", 
            "DataFillOptions"}], "\[IndentingNewLine]", "]"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", "drop", " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"(", 
            RowBox[{"Filling", "/.", "DataDropOptions"}], ")"}], "=!=", 
           "None"}], ",", "  ", 
          RowBox[{"(*", " ", 
           RowBox[{"short", " ", "circuit"}], " ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"FigLineElement", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Line", "[", 
              RowBox[{"DropSegments", "[", 
               RowBox[{"CurvePoints", ",", 
                RowBox[{"(", 
                 RowBox[{"Filling", "/.", "DataDropOptions"}], ")"}], ",", 
                RowBox[{"(", 
                 RowBox[{"Direction", "/.", "DataDropOptions"}], ")"}]}], 
               "]"}], "]"}], "}"}], ",", "\[IndentingNewLine]", 
            "DataDropOptions"}], "\[IndentingNewLine]", "]"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", "curve", " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"FigLineElement", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Line", "[", "CurvePoints", "]"}], "}"}], ",", 
          "\[IndentingNewLine]", "DataLineOptions"}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"symbol", " ", "and", " ", "error", " ", "bars"}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"FigPolygonElement", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Map", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"MakeDataSymbolPrimatives", "[", 
              RowBox[{"#", ",", "DataSymbolOptions"}], "]"}], "&"}], ",", 
            "\[IndentingNewLine]", "PointData"}], "\[IndentingNewLine]", 
           "]"}], ",", "\[IndentingNewLine]", "DataSymbolOptions"}], 
         "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51510150784375*^9, 3.51510165284375*^9}, {
   3.5151018264375*^9, 3.515101837625*^9}, {3.515160729234375*^9, 
   3.5151607388125*^9}, {3.515160815109375*^9, 3.515160905421875*^9}, {
   3.515429900281625*^9, 3.5154299283285*^9}, {3.515432005344125*^9, 
   3.51543202310975*^9}, {3.515432080625375*^9, 3.515432260875375*^9}, {
   3.515432559875375*^9, 3.515432618141*^9}, {3.515432654812875*^9, 
   3.515432706531625*^9}, {3.515433020406625*^9, 3.515433023781625*^9}, {
   3.515442053016*^9, 3.5154420783285*^9}, {3.51544252460975*^9, 
   3.515442586281625*^9}, {3.5154469192035*^9, 3.515446929391*^9}, {
   3.5154471764535*^9, 3.515447183094125*^9}, {3.515447219250375*^9, 
   3.515447220250375*^9}, {3.515447301531625*^9, 3.5154473044535*^9}, 
   3.515448155969125*^9, 3.515450489000375*^9, {3.515609990484375*^9, 
   3.51561000875*^9}, {3.515617766265625*^9, 3.5156177708125*^9}, {
   3.5156826745625*^9, 3.51568274115625*^9}, {3.515683305421875*^9, 
   3.5156833216875*^9}, {3.515883868671875*^9, 3.51588387675*^9}, 
   3.515885261171875*^9, {3.51603966277075*^9, 3.516039663630125*^9}, {
   3.516289394203125*^9, 3.516289467015625*^9}, {3.5162896060625*^9, 
   3.51628970440625*^9}, {3.516289953640625*^9, 3.516289954671875*^9}, {
   3.51629102003125*^9, 3.516291020703125*^9}, {3.516558731296875*^9, 
   3.516558753484375*^9}, {3.5165607958125*^9, 3.516560798640625*^9}, {
   3.516562768078125*^9, 3.516562769296875*^9}, {3.516565113203125*^9, 
   3.5165651174375*^9}, {3.516565301359375*^9, 3.5165654051875*^9}, {
   3.516565471453125*^9, 3.51656550984375*^9}, {3.51656567846875*^9, 
   3.516565679671875*^9}, {3.516566077453125*^9, 3.51656634890625*^9}, {
   3.516567269578125*^9, 3.516567294421875*^9}, {3.516567540890625*^9, 
   3.516567771765625*^9}, {3.516567806875*^9, 3.516567864671875*^9}, 
   3.5165679088125*^9, {3.5165680369375*^9, 3.516568037546875*^9}, 
   3.516568139625*^9, {3.51656821725*^9, 3.516568267921875*^9}, {
   3.516569262078125*^9, 3.516569288453125*^9}, {3.5165693883125*^9, 
   3.516569570203125*^9}, {3.51656963028125*^9, 3.516569666625*^9}, {
   3.516570236296875*^9, 3.516570239328125*^9}, 3.516570527296875*^9, {
   3.516570625828125*^9, 3.516570659390625*^9}, {3.51657070759375*^9, 
   3.51657075309375*^9}, {3.516570791546875*^9, 3.516570867203125*^9}, {
   3.51657096725*^9, 3.516570967515625*^9}, {3.51657109103125*^9, 
   3.516571104640625*^9}, {3.51657143115625*^9, 3.516571706515625*^9}, {
   3.51657247790625*^9, 3.516572542875*^9}, 3.516572604296875*^9, {
   3.516572646171875*^9, 3.516572665203125*^9}, 3.51657272625*^9, {
   3.516572959796875*^9, 3.516572994328125*^9}, {3.516573056625*^9, 
   3.516573089953125*^9}, {3.516573154515625*^9, 3.516573154640625*^9}, {
   3.51657318753125*^9, 3.516573190859375*^9}, {3.5165732460625*^9, 
   3.51657327378125*^9}, {3.5165734633125*^9, 3.51657347221875*^9}, {
   3.516573509078125*^9, 3.516573526765625*^9}, {3.516573589234375*^9, 
   3.51657362221875*^9}, {3.516573665625*^9, 3.516573682578125*^9}, {
   3.516573753859375*^9, 3.516573756359375*^9}, {3.516573802296875*^9, 
   3.516573805984375*^9}, {3.51657391465625*^9, 3.5165739444375*^9}, {
   3.51657402653125*^9, 3.516574037078125*^9}, {3.51657413053125*^9, 
   3.516574133125*^9}, {3.5165742701875*^9, 3.51657428096875*^9}, {
   3.517771094625*^9, 3.517771105109375*^9}, {3.517771225875*^9, 
   3.517771232015625*^9}, {3.517771401125*^9, 3.517771407609375*^9}, {
   3.5177714413125*^9, 3.51777148546875*^9}, 3.517771522421875*^9, {
   3.51777157003125*^9, 3.517771612875*^9}, {3.51777165009375*^9, 
   3.517771651328125*^9}, {3.517771814921875*^9, 3.517771855421875*^9}, {
   3.51777198121875*^9, 3.517772015625*^9}, {3.517772133796875*^9, 
   3.51777218690625*^9}, {3.517775323625*^9, 3.517775436765625*^9}, {
   3.51777557734375*^9, 3.51777559865625*^9}, {3.51777577484375*^9, 
   3.517775797734375*^9}, {3.517775971671875*^9, 3.517775973515625*^9}, 
   3.5177760046875*^9, {3.51777684665625*^9, 3.5177768815625*^9}, {
   3.517777225328125*^9, 3.517777255171875*^9}, {3.517777360828125*^9, 
   3.5177773615625*^9}, {3.51777742878125*^9, 3.517777503015625*^9}, {
   3.51777833875*^9, 3.5177783786875*^9}, 3.51792594521875*^9, {
   3.5179261499375*^9, 3.517926157484375*^9}, {3.517930919484375*^9, 
   3.517930920203125*^9}, {3.517930992203125*^9, 3.517930996546875*^9}, {
   3.518018305359375*^9, 3.51801830825*^9}, 3.518117905296875*^9, 
   3.518123114421875*^9, {3.518123216609375*^9, 3.518123219625*^9}, {
   3.5181232660625*^9, 3.518123305421875*^9}, {3.518123371875*^9, 
   3.51812341565625*^9}, {3.518124162953125*^9, 3.518124182390625*^9}, {
   3.5184309679375*^9, 3.518430968828125*^9}, 3.518432715921875*^9, 
   3.51843343003125*^9, 3.51843349565625*^9, 3.518433538828125*^9, {
   3.518433762671875*^9, 3.518433795046875*^9}, {3.51843384884375*^9, 
   3.518433900203125*^9}, {3.518433964109375*^9, 3.518434030234375*^9}, {
   3.518434137265625*^9, 3.518434229375*^9}, {3.51843589146875*^9, 
   3.518435893578125*^9}, {3.51843594240625*^9, 3.518435975421875*^9}, {
   3.5184365755625*^9, 3.518436772953125*^9}, {3.51843733203125*^9, 
   3.51843741471875*^9}, {3.518437484234375*^9, 3.518437513140625*^9}, {
   3.518438411921875*^9, 3.51843841834375*^9}, {3.518439600921875*^9, 
   3.518439603421875*^9}, {3.518439845703125*^9, 3.518439862921875*^9}, {
   3.518439895453125*^9, 3.5184399505*^9}, {3.518439998546875*^9, 
   3.51844001128125*^9}, {3.518463364234375*^9, 3.518463397328125*^9}, {
   3.5184644020625*^9, 3.518464526703125*^9}, {3.51846467496875*^9, 
   3.51846467575*^9}, 3.5184650498125*^9, {3.51846655309375*^9, 
   3.51846656134375*^9}, {3.518469596265625*^9, 3.51846967278125*^9}, {
   3.518469767109375*^9, 3.518469768484375*^9}, 3.51846982140625*^9, {
   3.518470697078125*^9, 3.518470707828125*^9}, {3.51847095253125*^9, 
   3.518470969578125*^9}, {3.51847105496875*^9, 3.518471085890625*^9}, {
   3.518534874078125*^9, 3.518534886609375*^9}, 3.5185365585625*^9, 
   3.52105931684375*^9, {3.521568219375*^9, 3.521568253078125*^9}, {
   3.52156843240625*^9, 3.52156844546875*^9}, {3.530314612484375*^9, 
   3.53031465765625*^9}, {3.530315483*^9, 3.530315529359375*^9}, {
   3.530315842296875*^9, 3.53031587546875*^9}, {3.53031605896875*^9, 
   3.5303160636875*^9}, {3.530316360640625*^9, 3.5303163813125*^9}, {
   3.530316448125*^9, 3.530316477125*^9}, {3.530316509515625*^9, 
   3.530316518109375*^9}, {3.53031655065625*^9, 3.530316556140625*^9}, {
   3.53031700484375*^9, 3.53031700646875*^9}, 3.530317438375*^9, {
   3.530317678875*^9, 3.530317691046875*^9}, {3.5303177864375*^9, 
   3.53031778725*^9}, {3.53107994609375*^9, 3.53108003325*^9}, {
   3.531080067390625*^9, 3.5310801603125*^9}, {3.533410405265625*^9, 
   3.533410466125*^9}, {3.53341091659375*^9, 3.533410927671875*^9}, {
   3.533411037234375*^9, 3.53341107109375*^9}, {3.53341124975*^9, 
   3.533411255328125*^9}, {3.534012539984375*^9, 3.534012540703125*^9}, 
   3.53401261503125*^9, {3.537381169046875*^9, 3.53738126640625*^9}, {
   3.53738130384375*^9, 3.53738130978125*^9}, {3.53738137765625*^9, 
   3.53738138615625*^9}, {3.537385847703125*^9, 3.537385859421875*^9}, {
   3.537386022875*^9, 3.537386055859375*^9}, {3.537386104859375*^9, 
   3.53738610815625*^9}, {3.537386140734375*^9, 3.53738616084375*^9}, {
   3.53738627959375*^9, 3.53738631971875*^9}, {3.53738696778125*^9, 
   3.537387009359375*^9}, {3.537387106765625*^9, 3.53738710709375*^9}, {
   3.53738713934375*^9, 3.537387201484375*^9}, {3.537387246015625*^9, 
   3.537387251765625*^9}, {3.537391244734375*^9, 3.5373912534375*^9}, {
   3.5662574435703382`*^9, 3.5662575130840607`*^9}, {3.5662578162393928`*^9, 
   3.566257831168619*^9}, {3.5662578986667376`*^9, 3.566257899431139*^9}, {
   3.582815846912569*^9, 3.582815846990569*^9}, {3.5970891300824842`*^9, 
   3.5970891487025104`*^9}, {3.5970892552326593`*^9, 
   3.5970893151277432`*^9}, {3.59708936976782*^9, 3.5970894108028774`*^9}, {
   3.5970895189030285`*^9, 3.597089531958047*^9}, {3.597089809038435*^9, 
   3.597089846563487*^9}, {3.5970898973285584`*^9, 3.597090035938752*^9}, {
   3.597090133104493*^9, 3.597090134457014*^9}, {3.597090185412797*^9, 
   3.5970901922204013`*^9}, {3.5970905439081106`*^9, 
   3.5970905951301475`*^9}, {3.5970906340894957`*^9, 
   3.5970907581201506`*^9}, {3.597090859146703*^9, 3.5970909096512284`*^9}, {
   3.5970909405754533`*^9, 3.5970909683358793`*^9}, {3.597090999052602*^9, 
   3.5970910654564586`*^9}, {3.597091219210329*^9, 3.5970913055564804`*^9}, {
   3.5970913932286344`*^9, 3.5970913955686383`*^9}, 3.5970945718938184`*^9, {
   3.599442300593812*^9, 3.5994423527638855`*^9}, {3.599442459969035*^9, 
   3.599442536199142*^9}, {3.6027876855066957`*^9, 3.602787697714216*^9}, {
   3.6042702287554936`*^9, 3.6042702370391083`*^9}, {3.6042703850833683`*^9, 
   3.6042703904809775`*^9}, 3.621629420172001*^9, {3.622232700079874*^9, 
   3.622232795115241*^9}, {3.6222328502925377`*^9, 3.622232871321375*^9}, {
   3.6222330382260685`*^9, 3.6222331697030993`*^9}, {3.6222337523953223`*^9, 
   3.622233753955325*^9}, {3.622233864122719*^9, 3.6222338679915257`*^9}, 
   3.622233901406784*^9, {3.622234510135453*^9, 3.6222345522399273`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Table", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a", ",", "b", ",", "c"}], "}"}], ",", 
    RowBox[{"{", "4", "}"}]}], "]"}], "[", 
  RowBox[{"[", 
   RowBox[{"All", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], "]"}], "]"}]], "Input",
 CellChangeTimes->{{3.530315433015625*^9, 3.53031544859375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "c"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "c"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "c"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "c"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.53031543815625*^9, 3.530315448890625*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"DataSymbolVerticesFunction", "[", "\"\<Square\>\"", "]"}], "@", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}], ",", "2"}], "}"}]}]], "Input",
 CellChangeTimes->{{3.530316957265625*^9, 3.53031699059375*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.15147186257614298`", ",", "1.8485281374238571`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"0.15147186257614298`", ",", "0.15147186257614298`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.8485281374238571`", ",", "0.15147186257614298`"}], "}"}], ",", 
   
   RowBox[{"{", 
    RowBox[{"1.8485281374238571`", ",", "1.8485281374238571`"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.530316960296875*^9, 3.530316991*^9, {3.530317284765625*^9, 
   3.530317304625*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Methods", "Subsection",
 CellChangeTimes->{{3.5151660264375*^9, 3.515166028765625*^9}, {
  3.515449067344125*^9, 3.51544909085975*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakeAnchor", "[", 
     RowBox[{
      RowBox[{"Class", ":", "DataPlot"}], ",", "Self_Object"}], "]"}], "[", 
    RowBox[{"Name_", ",", "Arg_"}], "]"}], ":=", 
   RowBox[{"FigMakeAnchorWrapper", "[", 
    RowBox[{
    "Class", ",", "Self", ",", "Name", ",", "Arg", ",", "\[IndentingNewLine]", 
     RowBox[{"FigCurveAnchorFromPoints", "[", 
      RowBox[{
       RowBox[{"Self", "@", 
        RowBox[{"GetCurvePoints", "[", "]"}]}], ",", "Name", ",", "Arg"}], 
      "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakeBoundingBox", "[", 
     RowBox[{
      RowBox[{"Class", ":", "DataPlot"}], ",", "Self_Object"}], "]"}], "[", 
    "]"}], ":=", 
   RowBox[{"FigCurveBoundingBox", "[", 
    RowBox[{"Self", "@", 
     RowBox[{"GetCurvePoints", "[", "]"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51517464803125*^9, 3.515174666234375*^9}, {
  3.5151749220625*^9, 3.515174944015625*^9}, {3.51525866915625*^9, 
  3.515258669703125*^9}, {3.51544000385975*^9, 3.5154400110785*^9}, {
  3.515448814344125*^9, 3.515448817391*^9}, {3.516289741796875*^9, 
  3.51628977209375*^9}, {3.51628986878125*^9, 3.516289871453125*^9}, {
  3.51629102875*^9, 3.516291040484375*^9}, {3.5162911275625*^9, 
  3.516291135671875*^9}, {3.51629151184375*^9, 3.51629151703125*^9}, {
  3.516560806625*^9, 3.5165608115*^9}, {3.5182889110625*^9, 
  3.518288918953125*^9}, {3.51846968034375*^9, 3.51846968425*^9}, {
  3.519647986640625*^9, 3.519647993734375*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Filling", "Section",
 CellChangeTimes->{{3.5184400964375*^9, 3.518440097609375*^9}, {
  3.528229934671754*^9, 3.528229945656129*^9}}],

Cell[CellGroupData[{

Cell["Fill point generation", "Subsection",
 CellChangeTimes->{{3.5184400995*^9, 3.51844010215625*^9}}],

Cell["Interpret Horizontal/Vertical as arguments", "Text",
 CellChangeTimes->{{3.516047836130125*^9, 3.51604784989575*^9}}],

Cell["\<\
Debugging: Must come after DataPlot class definition for access to methods\
\>", "Text",
 CellChangeTimes->{{3.520278633359375*^9, 3.520278658125*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FillPoints", "[", 
    RowBox[{"CurvePoints_", ",", "x_", ",", "Horizontal"}], "]"}], ":=", 
   RowBox[{"FillPoints", "[", 
    RowBox[{"CurvePoints", ",", "x", ",", "1"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FillPoints", "[", 
    RowBox[{"CurvePoints_", ",", "x_", ",", "Vertical"}], "]"}], ":=", 
   RowBox[{"FillPoints", "[", 
    RowBox[{"CurvePoints", ",", "x", ",", "2"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516046467942625*^9, 3.5160465244895*^9}, 
   3.516047415177*^9, {3.516047556192625*^9, 3.51604755827075*^9}, 
   3.516047601661375*^9, {3.516047804473875*^9, 3.5160478323645*^9}, {
   3.518461861625*^9, 3.51846188078125*^9}, {3.5184647445*^9, 
   3.518464774484375*^9}, {3.51846979940625*^9, 3.518469801546875*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FillPoints", "[", 
    RowBox[{"CurvePoints_List", ",", 
     RowBox[{"Filling", ":", "None"}], ",", 
     RowBox[{"CoordinateIndex", ":", 
      RowBox[{"(", 
       RowBox[{"1", "|", "2"}], ")"}]}]}], "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FillPoints", "[", 
    RowBox[{"CurvePoints_List", ",", 
     RowBox[{"Filling", ":", "Axis"}], ",", 
     RowBox[{"CoordinateIndex", ":", 
      RowBox[{"(", 
       RowBox[{"1", "|", "2"}], ")"}]}]}], "]"}], ":=", 
   RowBox[{"FillPoints", "[", 
    RowBox[{"CurvePoints", ",", "0", ",", "CoordinateIndex"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FillPoints", "[", 
    RowBox[{"CurvePoints_List", ",", 
     RowBox[{"Filling", ":", "_DirectedInfinity"}], ",", 
     RowBox[{"CoordinateIndex", ":", 
      RowBox[{"(", 
       RowBox[{"1", "|", "2"}], ")"}]}]}], "]"}], ":=", 
   RowBox[{"FillPoints", "[", 
    RowBox[{"CurvePoints", ",", 
     RowBox[{"SuperClipCoordinate", "[", 
      RowBox[{"Filling", ",", "1"}], "]"}], ",", "CoordinateIndex"}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FillPoints", "[", 
    RowBox[{"CurvePoints_List", ",", 
     RowBox[{"Filling_", "?", "NumericQ"}], ",", 
     RowBox[{"CoordinateIndex", ":", 
      RowBox[{"(", 
       RowBox[{"1", "|", "2"}], ")"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "CanvasCoordinate", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"CanvasCoordinate", "=", 
       RowBox[{"FigResolveCoordinate", "[", 
        RowBox[{"Filling", ",", "CoordinateIndex"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Join", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"First", "[", "CurvePoints", "]"}], "*", 
           RowBox[{"UnitVector", "[", 
            RowBox[{"AntiCoordinateIndex", "[", "CoordinateIndex", "]"}], 
            "]"}]}], "+", 
          RowBox[{"CanvasCoordinate", "*", 
           RowBox[{"UnitVector", "[", "CoordinateIndex", "]"}]}]}], "}"}], 
        ",", "\[IndentingNewLine]", "CurvePoints", ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"Last", "[", "CurvePoints", "]"}], "*", 
           RowBox[{"UnitVector", "[", 
            RowBox[{"AntiCoordinateIndex", "[", "CoordinateIndex", "]"}], 
            "]"}]}], "+", 
          RowBox[{"CanvasCoordinate", "*", 
           RowBox[{"UnitVector", "[", "CoordinateIndex", "]"}]}]}], "}"}]}], 
       "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FillPoints", "[", 
    RowBox[{"CurvePoints_List", ",", 
     RowBox[{"Filling", ":", 
      RowBox[{"ObjectNamePattern", "[", "DataPlot", "]"}]}], ",", 
     RowBox[{"CoordinateIndex", ":", 
      RowBox[{"(", 
       RowBox[{"1", "|", "2"}], ")"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "OtherCurve", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"OtherCurve", "=", 
       RowBox[{
        RowBox[{"Object", "[", "Filling", "]"}], "@", 
        RowBox[{"GetCurvePoints", "[", "]"}]}]}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"Join", "[", "\[IndentingNewLine]", 
       RowBox[{"CurvePoints", ",", "\[IndentingNewLine]", 
        RowBox[{"Reverse", "[", "OtherCurve", "]"}]}], "\[IndentingNewLine]", 
       "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.518440112984375*^9, 3.518440292984375*^9}, {
   3.518440447796875*^9, 3.51844045421875*^9}, {3.518461775484375*^9, 
   3.518461801078125*^9}, {3.518461902796875*^9, 3.51846196765625*^9}, {
   3.51846201053125*^9, 3.518462033875*^9}, 3.518462401375*^9, {
   3.518462632703125*^9, 3.518462800046875*^9}, 3.51846457228125*^9, {
   3.518464615828125*^9, 3.51846462478125*^9}, {3.518464701140625*^9, 
   3.5184647086875*^9}, {3.518464849453125*^9, 3.518464864484375*^9}, {
   3.5184649386875*^9, 3.518464973578125*^9}, {3.518466721796875*^9, 
   3.51846682065625*^9}, {3.518469707828125*^9, 3.518469708625*^9}, {
   3.518469802046875*^9, 3.518469812703125*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Drop segment generation", "Subsection",
 CellChangeTimes->{{3.5184400995*^9, 3.51844010215625*^9}, {
  3.622233200793954*^9, 3.6222332023071566`*^9}}],

Cell["Interpret Horizontal/Vertical as arguments", "Text",
 CellChangeTimes->{{3.516047836130125*^9, 3.51604784989575*^9}}],

Cell["\<\
Debugging: Must come after DataPlot class definition for access to methods\
\>", "Text",
 CellChangeTimes->{{3.520278633359375*^9, 3.520278658125*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DropSegments", "[", 
    RowBox[{"CurvePoints_", ",", "x_", ",", "Horizontal"}], "]"}], ":=", 
   RowBox[{"DropSegments", "[", 
    RowBox[{"CurvePoints", ",", "x", ",", "1"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DropSegments", "[", 
    RowBox[{"CurvePoints_", ",", "x_", ",", "Vertical"}], "]"}], ":=", 
   RowBox[{"DropSegments", "[", 
    RowBox[{"CurvePoints", ",", "x", ",", "2"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516046467942625*^9, 3.5160465244895*^9}, 
   3.516047415177*^9, {3.516047556192625*^9, 3.51604755827075*^9}, 
   3.516047601661375*^9, {3.516047804473875*^9, 3.5160478323645*^9}, {
   3.518461861625*^9, 3.51846188078125*^9}, {3.5184647445*^9, 
   3.518464774484375*^9}, {3.51846979940625*^9, 3.518469801546875*^9}, {
   3.622233224147195*^9, 3.6222332252703967`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DropSegments", "[", 
    RowBox[{"CurvePoints_List", ",", 
     RowBox[{"Filling", ":", "None"}], ",", 
     RowBox[{"CoordinateIndex", ":", 
      RowBox[{"(", 
       RowBox[{"1", "|", "2"}], ")"}]}]}], "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DropSegments", "[", 
    RowBox[{"CurvePoints_List", ",", 
     RowBox[{"Filling", ":", "Axis"}], ",", 
     RowBox[{"CoordinateIndex", ":", 
      RowBox[{"(", 
       RowBox[{"1", "|", "2"}], ")"}]}]}], "]"}], ":=", 
   RowBox[{"DropSegments", "[", 
    RowBox[{"CurvePoints", ",", "0", ",", "CoordinateIndex"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DropSegments", "[", 
    RowBox[{"CurvePoints_List", ",", 
     RowBox[{"Filling", ":", "_DirectedInfinity"}], ",", 
     RowBox[{"CoordinateIndex", ":", 
      RowBox[{"(", 
       RowBox[{"1", "|", "2"}], ")"}]}]}], "]"}], ":=", 
   RowBox[{"DropSegments", "[", 
    RowBox[{"CurvePoints", ",", 
     RowBox[{"SuperClipCoordinate", "[", 
      RowBox[{"Filling", ",", "1"}], "]"}], ",", "CoordinateIndex"}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DropSegments", "[", 
    RowBox[{"CurvePoints_List", ",", 
     RowBox[{"Filling_", "?", "NumericQ"}], ",", 
     RowBox[{"CoordinateIndex", ":", 
      RowBox[{"(", 
       RowBox[{"1", "|", "2"}], ")"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "CanvasCoordinate", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"CanvasCoordinate", "=", 
       RowBox[{"FigResolveCoordinate", "[", 
        RowBox[{"Filling", ",", "CoordinateIndex"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Table", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"p", "*", 
            RowBox[{"UnitVector", "[", 
             RowBox[{"AntiCoordinateIndex", "[", "CoordinateIndex", "]"}], 
             "]"}]}], "+", 
           RowBox[{"CanvasCoordinate", "*", 
            RowBox[{"UnitVector", "[", "CoordinateIndex", "]"}]}]}], ",", 
          "p"}], "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"p", ",", "CurvePoints"}], "}"}]}], "\[IndentingNewLine]", 
       "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.518440112984375*^9, 3.518440292984375*^9}, {
   3.518440447796875*^9, 3.51844045421875*^9}, {3.518461775484375*^9, 
   3.518461801078125*^9}, {3.518461902796875*^9, 3.51846196765625*^9}, {
   3.51846201053125*^9, 3.518462033875*^9}, 3.518462401375*^9, {
   3.518462632703125*^9, 3.518462800046875*^9}, 3.51846457228125*^9, {
   3.518464615828125*^9, 3.51846462478125*^9}, {3.518464701140625*^9, 
   3.5184647086875*^9}, {3.518464849453125*^9, 3.518464864484375*^9}, {
   3.5184649386875*^9, 3.518464973578125*^9}, {3.518466721796875*^9, 
   3.51846682065625*^9}, {3.518469707828125*^9, 3.518469708625*^9}, {
   3.518469802046875*^9, 3.518469812703125*^9}, {3.622233225629197*^9, 
   3.6222332349268136`*^9}, {3.62223336933665*^9, 3.6222334920776653`*^9}, {
   3.622233678092392*^9, 3.6222336796055946`*^9}, 3.622233911624802*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["DataLegend", "Section",
 CellChangeTimes->{{3.517777703203125*^9, 3.517777730765625*^9}}],

Cell[CellGroupData[{

Cell["Object declaration", "Subsection",
 CellChangeTimes->{{3.517853980959999*^9, 3.5178539834605265`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DeclareFigClass", "[", "\[IndentingNewLine]", 
   RowBox[{"DataLegend", ",", "\[IndentingNewLine]", 
    RowBox[{"{", "\"\<TextElement\>\"", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "}"}]}], "\[IndentingNewLine]", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineFigClassOptions", "[", "\[IndentingNewLine]", 
   RowBox[{"DataLegend", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"TextOffset", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "1"}], ",", 
        RowBox[{"+", "1"}]}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"given", " ", "position"}], " ", "*)"}], "\[IndentingNewLine]", 
     
     RowBox[{
      RowBox[{"Point", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}]}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"legend", " ", "formatting"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"Width", "\[Rule]", "20"}], ",", 
      RowBox[{"InternalSeparation", "\[Rule]", "2"}], ",", 
      RowBox[{"EntrySpacing", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"10", ",", "2"}], "}"}]}], ",", 
      RowBox[{"RowLimit", "\[Rule]", "None"}]}], "\[IndentingNewLine]", 
     "}"}]}], "\[IndentingNewLine]", "]"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515100688734375*^9, 3.515100745765625*^9}, {
   3.515101427609375*^9, 3.5151014280625*^9}, {3.51510147303125*^9, 
   3.515101489109375*^9}, {3.515160263390625*^9, 3.51516026428125*^9}, {
   3.51516080484375*^9, 3.51516081109375*^9}, {3.515429856500375*^9, 
   3.515429878125375*^9}, {3.5154307895785*^9, 3.515430808375375*^9}, {
   3.51543131279725*^9, 3.51543134560975*^9}, {3.515611505515625*^9, 
   3.5156115174375*^9}, 3.51577560334375*^9, {3.5159617146875*^9, 
   3.515961775921875*^9}, {3.515962042546875*^9, 3.515962049828125*^9}, {
   3.51628840765625*^9, 3.51628841396875*^9}, {3.51628943834375*^9, 
   3.516289439171875*^9}, 3.516291009*^9, {3.516558652265625*^9, 
   3.5165586536875*^9}, {3.5165586879375*^9, 3.51655872140625*^9}, {
   3.516562760828125*^9, 3.51656276265625*^9}, {3.516563367765625*^9, 
   3.51656340665625*^9}, {3.51656396684375*^9, 3.516564001375*^9}, {
   3.516567519390625*^9, 3.516567527234375*^9}, {3.51656820415625*^9, 
   3.516568208734375*^9}, {3.516569302640625*^9, 3.5165693143125*^9}, 
   3.51657050221875*^9, {3.51777561840625*^9, 3.517775647625*^9}, {
   3.517777788*^9, 3.5177777891875*^9}, {3.517777907125*^9, 
   3.5177779088125*^9}, {3.51777795225*^9, 3.51777798328125*^9}, 
   3.51777804009375*^9, {3.517932970015625*^9, 3.51793297246875*^9}, {
   3.5179393760625*^9, 3.51793940021875*^9}, {3.5179413030625*^9, 
   3.5179413124375*^9}, {3.517942431671875*^9, 3.51794243490625*^9}, {
   3.5179426550625*^9, 3.51794265834375*^9}, {3.517943081828125*^9, 
   3.51794308975*^9}, {3.517943375140625*^9, 3.51794339740625*^9}, 
   3.518551089532875*^9, {3.518551225345375*^9, 3.5185512314235*^9}, 
   3.518551351470375*^9, {3.544721089078125*^9, 3.544721097359375*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructor", "Subsection",
 CellChangeTimes->{{3.5177782035*^9, 3.517778205203125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"DataSetInfoPattern", "=", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"_", ",", "_"}], "}"}], "|", 
         RowBox[{"{", 
          RowBox[{"_", ",", "_", ",", "DataPlot"}], "}"}], "|", 
         RowBox[{"{", 
          RowBox[{"_", ",", "_", ",", "SciDraw`FigLine"}], "}"}]}], ")"}], 
       "..."}], "}"}]}], ";"}], "  ", "*)"}], 
  RowBox[{"(*", " ", 
   RowBox[{
   "must", " ", "explicitly", " ", "provide", " ", "context", " ", "for", " ",
     "FigLine", " ", "if", " ", "FigShape", " ", "comes", " ", "after", " ", 
    "FigData", " ", "in", " ", "loading", " ", "order"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"DataSetInfoPattern", "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}], "|", 
        RowBox[{"{", 
         RowBox[{"_", ",", "_", ",", "DataPlot"}], "}"}], "|", 
        RowBox[{"{", 
         RowBox[{"_", ",", "_", ",", "_Symbol"}], "}"}]}], ")"}], "..."}], 
     "}"}]}], ";"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.592951747926846*^9, 3.592951757006859*^9}, 
   3.593005391618534*^9, 3.59300893928752*^9, {3.5930089744875693`*^9, 
   3.593009000487606*^9}, {3.593009852251875*^9, 3.5930098754569073`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BasicDataLegend", "[", "Self_Object", "]"}], "[", 
    RowBox[{"GivenAnchor_Object", ",", 
     RowBox[{"DataSetInfo", ":", "DataSetInfoPattern"}]}], "]"}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
      "UsedDimensions", ",", "UsedRows", ",", "UsedColumns", ",", 
       "\[IndentingNewLine]", "CurrentStyleName", ",", "CurrentText", ",", 
       "CurrentEntryStyleMode", ",", "CurrentStyleOptions", ",", 
       "\[IndentingNewLine]", "DataLineOptions", ",", "DataFillOptions", ",", 
       "DataSymbolOptions", ",", "FigLineOptions", ",", "\[IndentingNewLine]",
        "P0", ",", "\[IndentingNewLine]", "LineEndpoints", ",", 
       "UsedDataSymbolVerticesFunction", ",", "Index", ",", 
       "\[IndentingNewLine]", "EntryGraphicalElements", ",", "EntryGraphics", 
       ",", "EntryWidth", ",", "EntryHeight", ",", "EntryText", ",", 
       "\[IndentingNewLine]", "LegendContents", ",", "TextElement", ",", 
       "DataDescriptorWindow"}], "\[IndentingNewLine]", "}"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"validate", " ", "extra", " ", "options"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FigCheckOption", "[", 
       RowBox[{"Self", ",", "Width", ",", 
        RowBox[{"_", "?", "NonNegative"}], ",", "FigOptions"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{
       "Self", ",", "InternalSeparation", ",", 
        "NonNegativeScalarParameterPattern", ",", "FigOptions"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{
       "Self", ",", "EntrySpacing", ",", 
        "NonNegativeIntervalParametersPattern", ",", "FigOptions"}], "]"}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{"Self", ",", "RowLimit", ",", 
        RowBox[{"None", "|", 
         RowBox[{"(", "_Integer", ")"}]}], ",", "FigOptions"}], "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"validate", " ", "list", " ", "of", " ", "styles"}], " ", 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"FigCheckValueList", "[", 
       RowBox[{"Self", ",", 
        RowBox[{"First", "/@", "DataSetInfo"}], ",", "StyleSpecifierPattern", 
        ",", "\"\<style identifiers\>\""}], "]"}], ";", "\[IndentingNewLine]",
       "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{"row", "/", "column"}], " ", "dimension", " ", 
        "calculations"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"UsedDimensions", "=", 
       RowBox[{"Switch", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"RowLimit", "/.", "FigOptions"}], ")"}], ",", 
         "\[IndentingNewLine]", "None", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Length", "[", "DataSetInfo", "]"}], ",", "1"}], "}"}], 
         ",", "\[IndentingNewLine]", "_Integer", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"RowLimit", "/.", "FigOptions"}], ")"}], ",", 
           RowBox[{"Max", "[", 
            RowBox[{
             RowBox[{"Ceiling", "[", 
              RowBox[{
               RowBox[{"Length", "[", "DataSetInfo", "]"}], "/", 
               RowBox[{"(", 
                RowBox[{"RowLimit", "/.", "FigOptions"}], ")"}]}], "]"}], ",",
              "1"}], "]"}]}], "}"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"UsedRows", ",", "UsedColumns"}], "}"}], "=", 
       "UsedDimensions"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      
      RowBox[{"(*", " ", 
       RowBox[{"geometry", " ", "calculations"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"P0", "=", "GivenAnchor"}], ";", " ", "\[IndentingNewLine]", 
      RowBox[{"EntryWidth", "=", 
       RowBox[{"(", 
        RowBox[{"Width", "/.", "FigOptions"}], ")"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"LineEndpoints", "=", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"+", "1"}], ",", "0"}], "}"}]}], "}"}], "*", 
        RowBox[{"(", 
         RowBox[{"EntryWidth", "/", "2"}], ")"}]}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"assemble", " ", "legend", " ", "contents"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"LegendContents", "=", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"Show", "/.", "FigOptions"}], ")"}], ",", " ", 
         RowBox[{"(*", " ", 
          RowBox[{
          "otherwise", " ", "overridden", " ", "by", " ", "Show", " ", "in", 
           " ", "DataLineOpts", " ", "or", " ", "DataSymbolOpts"}], " ", 
          "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"Grid", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Table", "[", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{"retrieve", " ", "entry", " ", "information"}], " ", 
             "*)"}], "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"Index", "=", 
               RowBox[{"r", "+", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"s", "-", "1"}], ")"}], "*", "UsedRows"}]}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"If", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"Index", ">", 
                 RowBox[{"Length", "[", "DataSetInfo", "]"}]}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"(*", " ", 
                 RowBox[{"no", " ", "entry"}], " ", "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"EntryGraphics", ",", "EntryText"}], "}"}], "=", 
                 RowBox[{"{", 
                  RowBox[{"Null", ",", "Null"}], "}"}]}], ",", 
                "\[IndentingNewLine]", "\[IndentingNewLine]", 
                RowBox[{"(*", " ", "entry", " ", "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"(*", " ", 
                 RowBox[{
                 "force", " ", "current", " ", "entry", " ", "mode", " ", 
                  "to", " ", "DataPlot", " ", "if", " ", "not", " ", 
                  "specified"}], " ", "*)"}], "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                   "CurrentStyleName", ",", "CurrentText", ",", 
                    "CurrentEntryStyleMode"}], "}"}], "=", 
                  RowBox[{"Replace", "[", 
                   RowBox[{
                    RowBox[{"DataSetInfo", "[", 
                    RowBox[{"[", "Index", "]"}], "]"}], ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"a_", ",", "b_"}], "}"}], "\[RuleDelayed]", 
                    RowBox[{"{", 
                    RowBox[{"a", ",", "b", ",", "DataPlot"}], "}"}]}]}], 
                   "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"If", "[", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"CurrentStyleName", "=!=", "None"}], ",", 
                   "\[IndentingNewLine]", "\[IndentingNewLine]", 
                   RowBox[{"(*", " ", 
                    RowBox[{"obtain", " ", "plot", " ", "style"}], " ", 
                    "*)"}], "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{"WithStyle", "[", "\[IndentingNewLine]", 
                    RowBox[{"CurrentStyleName", ",", "\[IndentingNewLine]", 
                    RowBox[{"Switch", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    "CurrentEntryStyleMode", ",", "\[IndentingNewLine]", 
                    "DataPlot", ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", " ", 
                    RowBox[{
                    "take", " ", "plot", " ", "options", " ", "from", " ", 
                    "usual", " ", "DataPlot", " ", "option", " ", "sets"}], 
                    " ", "*)"}], "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"DataLineOptions", "=", 
                    RowBox[{"FigRealizeOptions", "[", 
                    RowBox[{"Self", ",", "DataLine", ",", 
                    RowBox[{"Options", "[", "DataLine", "]"}]}], "]"}]}], ";",
                     "\[IndentingNewLine]", 
                    RowBox[{"DataSymbolOptions", "=", 
                    RowBox[{"FigRealizeOptions", "[", 
                    RowBox[{"Self", ",", "DataSymbol", ",", 
                    RowBox[{"Options", "[", "DataSymbol", "]"}]}], "]"}]}]}], 
                    ",", "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"DataFillOptions", "=", 
                    RowBox[{"FigRealizeOptions", "[", 
                    RowBox[{"Self", ",", "DataFill", ",", 
                    RowBox[{"Options", "[", "DataFill", "]"}]}], "]"}]}], 
                    ";"}], "*)"}], "\[IndentingNewLine]", "_", ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", " ", 
                    RowBox[{
                    RowBox[{
                    "take", " ", "plot", " ", "line", " ", "options", " ", 
                    "from", " ", "given", " ", "object"}], ",", " ", 
                    RowBox[{"e", ".", "g", "."}], ",", " ", 
                    RowBox[{"FigLine", " ", "or", " ", "FigRule"}], ",", " ", 
                    
                    RowBox[{
                    "and", " ", "do", " ", "not", " ", "provide", " ", "data",
                     " ", "symbol", " ", "options"}]}], " ", "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"DataLineOptions", "=", 
                    RowBox[{"FigRealizeOptions", "[", 
                    RowBox[{"Self", ",", "CurrentEntryStyleMode", ",", 
                    RowBox[{"Options", "[", "CurrentEntryStyleMode", "]"}]}], 
                    "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}]}], 
                    "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", " ", 
                    RowBox[{
                    "make", " ", "entry", " ", "graphical", " ", "elements"}],
                     " ", "*)"}], "\[IndentingNewLine]", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", " ", 
                    RowBox[{
                    "record", " ", "symbol", " ", "size", " ", "with", " ", 
                    "safe", " ", 
                    RowBox[{"(", "double", ")"}], " ", "line", " ", 
                    "thickness", " ", "allowance"}], " ", "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"EntryHeight", "=", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"SymbolSize", "/.", "DataSymbolOptions"}], ")"}], 
                    "*", 
                    RowBox[{"(", 
                    RowBox[{"SymbolSizeScale", "/.", "DataSymbolOptions"}], 
                    ")"}]}], "+", 
                    RowBox[{"2", "*", 
                    RowBox[{"(", 
                    RowBox[{"LineThickness", "/.", "DataSymbolOptions"}], 
                    ")"}]}]}]}], ";", "\[IndentingNewLine]", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", " ", 
                    RowBox[{
                    "make", " ", "window", " ", "in", " ", "which", " ", "to",
                     " ", "draw", " ", 
                    RowBox[{"curve", "/", "symbol"}]}], " ", "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"DataDescriptorWindow", "=", 
                    RowBox[{"FigWindow", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", 
                    RowBox[{"+", "1"}]}], "}"}], "*", "EntryWidth"}], ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", 
                    RowBox[{"+", "1"}]}], "}"}], "*", 
                    RowBox[{"EntryHeight", "/", "2"}]}]}], "}"}], "]"}]}], 
                    ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"(*", " ", 
                    RowBox[{"make", " ", 
                    RowBox[{"curve", "/", "symbol"}], " ", "elements"}], " ", 
                    "*)"}], "\[IndentingNewLine]", 
                    RowBox[{"(*", 
                    RowBox[{
                    RowBox[{"Note", ":", 
                    RowBox[{
                    "draw", " ", "a", " ", "legend", " ", "symbol", " ", 
                    "using", " ", "DataLine", " ", "and", " ", "DataSymbol", 
                    " ", "options", " ", "defined", " ", "by", " ", 
                    "style"}]}], ",", 
                    RowBox[{
                    "in", " ", "a", " ", "box", " ", "spanning", " ", 
                    "internal", " ", "coordinates", " ", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "EntryWidth"}], "/", "2"}], ",", 
                    RowBox[{"EntryWidth", "/", "2"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", "EntryHeight"}], "/", "2"}], ",", 
                    RowBox[{"EntryHeight", "/", "2"}]}], "}"}]}], "}"}], " ", 
                    "and", " ", "of", " ", "size", " ", 
                    RowBox[{"{", 
                    RowBox[{"EntryWidth", ",", "EntryHeight"}], "}"}], " ", 
                    "in", " ", 
                    RowBox[{"printer", "'"}], "s", " ", 
                    RowBox[{"points", "."}]}]}], "*)"}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    RowBox[{"EntryGraphicalElements", "=", 
                    RowBox[{
                    "CollectGraphicalElements", "[", "\[IndentingNewLine]", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", " ", "curve", " ", "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"FigLineElement", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"Line", "[", "LineEndpoints", "]"}], "}"}], ",", 
                    "\[IndentingNewLine]", "DataLineOptions"}], 
                    "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
                    "\[IndentingNewLine]", 
                    RowBox[{"(*", " ", "symbol", " ", "*)"}], 
                    "\[IndentingNewLine]", 
                    RowBox[{"Switch", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    "CurrentEntryStyleMode", ",", "\[IndentingNewLine]", 
                    "DataPlot", ",", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"UsedDataSymbolVerticesFunction", "=", 
                    RowBox[{"DataSymbolVerticesFunction", "[", 
                    RowBox[{"(", 
                    RowBox[{"SymbolShape", "/.", "DataSymbolOptions"}], ")"}],
                     "]"}]}], ";", "\[IndentingNewLine]", 
                    RowBox[{"FigPolygonElement", "[", "\[IndentingNewLine]", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Composition", "[", 
                    RowBox[{
                    "Polygon", ",", "UsedDataSymbolVerticesFunction"}], "]"}],
                     "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"SymbolSize", "/.", "DataSymbolOptions"}], ")"}], 
                    "*", 
                    RowBox[{"(", 
                    RowBox[{"SymbolSizeScale", "/.", "DataSymbolOptions"}], 
                    ")"}]}]}], "}"}], "]"}], "}"}], ",", 
                    "\[IndentingNewLine]", "DataSymbolOptions"}], 
                    "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
                    "]"}]}], ",", "\[IndentingNewLine]", 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", 
                    "DataDescriptorWindow", ",", 
                    RowBox[{"CurrentBackground", "[", "]"}]}], " ", 
                    RowBox[{"(*", " ", 
                    RowBox[{"background", " ", "irrelevant"}], " ", "*)"}], 
                    "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}]}], 
                   ",", " ", 
                   RowBox[{"(*", " ", "CollectGraphicalEleents", " ", "*)"}], 
                   "\[IndentingNewLine]", 
                   RowBox[{"EntryGraphicalElements", "=", 
                    RowBox[{"{", "}"}]}]}], "\[IndentingNewLine]", "]"}], ";",
                  " ", 
                 RowBox[{"(*", " ", 
                  RowBox[{"If", " ", "CurrentStyleName"}], " ", "*)"}], 
                 "\[IndentingNewLine]", "\[IndentingNewLine]", 
                 RowBox[{"(*", " ", 
                  RowBox[{
                  "consolidate", " ", "entry", " ", "graphical", " ", 
                   "elements", " ", "into", " ", "Graphics"}], " ", "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{"EntryGraphics", "=", 
                  RowBox[{"Graphics", "[", "\[IndentingNewLine]", 
                   RowBox[{
                    RowBox[{
                    "FigAssemblePrimatives", "[", "EntryGraphicalElements", 
                    "]"}], ",", "\[IndentingNewLine]", 
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", 
                    RowBox[{"+", "1"}]}], "}"}], "*", 
                    RowBox[{"EntryWidth", "/", "2"}]}], ",", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", 
                    RowBox[{"+", "1"}]}], "}"}], "*", 
                    RowBox[{"EntryHeight", "/", "2"}]}]}], "}"}]}], ",", 
                    "\[IndentingNewLine]", 
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"EntryWidth", ",", "EntryHeight"}], "}"}]}]}], 
                   "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
                 RowBox[{"If", "[", "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"Debug", "/.", "FigOptions"}], ")"}], ",", 
                   "\[IndentingNewLine]", 
                   RowBox[{"Print", "[", 
                    RowBox[{"EntryGraphics", "//", "FullForm"}], "]"}]}], 
                  "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
                 "\[IndentingNewLine]", 
                 RowBox[{"(*", " ", 
                  RowBox[{"produce", " ", "text"}], " ", "*)"}], 
                 "\[IndentingNewLine]", 
                 RowBox[{"EntryText", "=", 
                  RowBox[{"FigStyledText", "[", 
                   RowBox[{"CurrentText", ",", "FigOptions"}], "]"}]}], 
                 ";"}]}], "\[IndentingNewLine]", "]"}], ";", " ", 
              RowBox[{"(*", " ", 
               RowBox[{"If", " ", "entry"}], " ", "*)"}], 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"(*", " ", 
               RowBox[{"produce", " ", "entry", " ", "from", " ", 
                RowBox[{"graphics", "/", "text"}]}], " ", "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{"Grid", "[", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"{", 
                  RowBox[{"EntryGraphics", ",", "EntryText"}], "}"}], "}"}], 
                ",", 
                RowBox[{"Alignment", "\[Rule]", 
                 RowBox[{"{", 
                  RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
                RowBox[{"Spacings", "\[Rule]", 
                 RowBox[{
                  RowBox[{"UpgradeScalar", "[", 
                   RowBox[{"(", 
                    RowBox[{"InternalSeparation", "/.", "FigOptions"}], ")"}],
                    "]"}], "/", 
                  RowBox[{"(", 
                   RowBox[{"FontSize", "/.", "FigOptions"}], ")"}]}]}]}], 
               "]"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"{", 
              RowBox[{"r", ",", "1", ",", "UsedRows"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"s", ",", "1", ",", "UsedColumns"}], "}"}]}], 
            "\[IndentingNewLine]", "]"}], ",", " ", 
           RowBox[{"(*", " ", "Table", " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"Alignment", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"Left", ",", "Center"}], "}"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Spacings", "\[Rule]", 
            RowBox[{
             RowBox[{"UpgradePair", "[", 
              RowBox[{"(", 
               RowBox[{"EntrySpacing", "/.", "FigOptions"}], ")"}], "]"}], 
             "/", 
             RowBox[{"(", 
              RowBox[{"FontSize", "/.", "FigOptions"}], ")"}]}]}]}], 
          "\[IndentingNewLine]", "]"}], ",", " ", 
         RowBox[{"(*", " ", "Grid", " ", "*)"}], "\[IndentingNewLine]", 
         "None"}], "\[IndentingNewLine]", "]"}]}], " ", ";", 
      RowBox[{"(*", " ", 
       RowBox[{"If", " ", "show"}], " ", "*)"}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"emit", " ", "legend"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"TextElement", "=", 
       RowBox[{"FigTextElement", "[", 
        RowBox[{"P0", ",", "LegendContents", ",", "FigOptions"}], "]"}]}], 
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "save", " ", "references", " ", "to", " ", "spawned", " ", "objects"}],
        " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Self", "@", 
       RowBox[{"SetTextElement", "[", "TextElement", "]"}]}], ";"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51510150784375*^9, 3.51510165284375*^9}, {
   3.5151018264375*^9, 3.515101837625*^9}, {3.515160729234375*^9, 
   3.5151607388125*^9}, {3.515160815109375*^9, 3.515160905421875*^9}, {
   3.515429900281625*^9, 3.5154299283285*^9}, {3.515432005344125*^9, 
   3.51543202310975*^9}, {3.515432080625375*^9, 3.515432260875375*^9}, {
   3.515432559875375*^9, 3.515432618141*^9}, {3.515432654812875*^9, 
   3.515432706531625*^9}, {3.515433020406625*^9, 3.515433023781625*^9}, {
   3.515442053016*^9, 3.5154420783285*^9}, {3.51544252460975*^9, 
   3.515442586281625*^9}, {3.5154469192035*^9, 3.515446929391*^9}, {
   3.5154471764535*^9, 3.515447183094125*^9}, {3.515447219250375*^9, 
   3.515447220250375*^9}, {3.515447301531625*^9, 3.5154473044535*^9}, 
   3.515448155969125*^9, 3.515450489000375*^9, {3.515609990484375*^9, 
   3.51561000875*^9}, {3.515617766265625*^9, 3.5156177708125*^9}, {
   3.5156826745625*^9, 3.51568274115625*^9}, {3.515683305421875*^9, 
   3.5156833216875*^9}, {3.515883868671875*^9, 3.51588387675*^9}, 
   3.515885261171875*^9, {3.51603966277075*^9, 3.516039663630125*^9}, {
   3.516289394203125*^9, 3.516289467015625*^9}, {3.5162896060625*^9, 
   3.51628970440625*^9}, {3.516289953640625*^9, 3.516289954671875*^9}, {
   3.51629102003125*^9, 3.516291020703125*^9}, {3.516558731296875*^9, 
   3.516558753484375*^9}, {3.5165607958125*^9, 3.516560798640625*^9}, {
   3.516562768078125*^9, 3.516562769296875*^9}, {3.516565113203125*^9, 
   3.5165651174375*^9}, {3.516565301359375*^9, 3.5165654051875*^9}, {
   3.516565471453125*^9, 3.51656550984375*^9}, {3.51656567846875*^9, 
   3.516565679671875*^9}, {3.516566077453125*^9, 3.51656634890625*^9}, {
   3.516567269578125*^9, 3.516567294421875*^9}, {3.516567540890625*^9, 
   3.516567771765625*^9}, {3.516567806875*^9, 3.516567864671875*^9}, 
   3.5165679088125*^9, {3.5165680369375*^9, 3.516568037546875*^9}, 
   3.516568139625*^9, {3.51656821725*^9, 3.516568267921875*^9}, {
   3.516569262078125*^9, 3.516569288453125*^9}, {3.5165693883125*^9, 
   3.516569570203125*^9}, {3.51656963028125*^9, 3.516569666625*^9}, {
   3.516570236296875*^9, 3.516570239328125*^9}, 3.516570527296875*^9, {
   3.516570625828125*^9, 3.516570659390625*^9}, {3.51657070759375*^9, 
   3.51657075309375*^9}, {3.516570791546875*^9, 3.516570867203125*^9}, {
   3.51657096725*^9, 3.516570967515625*^9}, {3.51657109103125*^9, 
   3.516571104640625*^9}, {3.51657143115625*^9, 3.516571706515625*^9}, {
   3.51657247790625*^9, 3.516572542875*^9}, 3.516572604296875*^9, {
   3.516572646171875*^9, 3.516572665203125*^9}, 3.51657272625*^9, {
   3.516572959796875*^9, 3.516572994328125*^9}, {3.516573056625*^9, 
   3.516573089953125*^9}, {3.516573154515625*^9, 3.516573154640625*^9}, {
   3.51657318753125*^9, 3.516573190859375*^9}, {3.5165732460625*^9, 
   3.51657327378125*^9}, {3.5165734633125*^9, 3.51657347221875*^9}, {
   3.516573509078125*^9, 3.516573526765625*^9}, {3.516573589234375*^9, 
   3.51657362221875*^9}, {3.516573665625*^9, 3.516573682578125*^9}, {
   3.516573753859375*^9, 3.516573756359375*^9}, {3.516573802296875*^9, 
   3.516573805984375*^9}, {3.51657391465625*^9, 3.5165739444375*^9}, {
   3.51657402653125*^9, 3.516574037078125*^9}, {3.51657413053125*^9, 
   3.516574133125*^9}, {3.5165742701875*^9, 3.51657428096875*^9}, {
   3.517771094625*^9, 3.517771105109375*^9}, {3.517771225875*^9, 
   3.517771232015625*^9}, {3.517771401125*^9, 3.517771407609375*^9}, {
   3.5177714413125*^9, 3.51777148546875*^9}, 3.517771522421875*^9, {
   3.51777157003125*^9, 3.517771612875*^9}, {3.51777165009375*^9, 
   3.517771651328125*^9}, {3.517771814921875*^9, 3.517771855421875*^9}, {
   3.51777198121875*^9, 3.517772015625*^9}, {3.517772133796875*^9, 
   3.51777218690625*^9}, {3.517775323625*^9, 3.517775436765625*^9}, {
   3.51777557734375*^9, 3.51777559865625*^9}, {3.51777577484375*^9, 
   3.517775797734375*^9}, {3.517775971671875*^9, 3.517775973515625*^9}, 
   3.5177760046875*^9, {3.51777684665625*^9, 3.5177768815625*^9}, {
   3.517777225328125*^9, 3.517777255171875*^9}, {3.517777360828125*^9, 
   3.5177773615625*^9}, {3.51777742878125*^9, 3.517777503015625*^9}, {
   3.517778211875*^9, 3.517778244015625*^9}, {3.517778274203125*^9, 
   3.517778320875*^9}, {3.517852889303201*^9, 3.5178529632601023`*^9}, {
   3.51785304787605*^9, 3.517853053033653*^9}, 3.517853381744884*^9, {
   3.5178534150036087`*^9, 3.5178534357121663`*^9}, {3.5178535343630457`*^9, 
   3.5178535461317577`*^9}, {3.5178535952071323`*^9, 3.517853685308893*^9}, {
   3.5178537591876493`*^9, 3.517853806371902*^9}, {3.517853905991044*^9, 
   3.5178539075382457`*^9}, {3.517926160328125*^9, 3.51792616609375*^9}, 
   3.517926214453125*^9, {3.51792684246875*^9, 3.51792690209375*^9}, {
   3.517927028*^9, 3.51792714115625*^9}, {3.51792757540625*^9, 
   3.517927615890625*^9}, {3.517930489234375*^9, 3.517930502984375*^9}, {
   3.517930542296875*^9, 3.517930586546875*^9}, {3.517930795015625*^9, 
   3.517930896328125*^9}, {3.517931015640625*^9, 3.517931065578125*^9}, {
   3.51793176828125*^9, 3.5179318769375*^9}, {3.5179319180625*^9, 
   3.51793205325*^9}, {3.517932228109375*^9, 3.517932254953125*^9}, {
   3.517932364375*^9, 3.51793237334375*^9}, {3.517932405109375*^9, 
   3.51793247440625*^9}, {3.517932571765625*^9, 3.517932602890625*^9}, {
   3.517932647421875*^9, 3.5179327916875*^9}, {3.51793283296875*^9, 
   3.517933011515625*^9}, {3.517936900984375*^9, 3.517936915859375*^9}, {
   3.5179370433125*^9, 3.517937086140625*^9}, {3.517937877453125*^9, 
   3.517937891828125*^9}, {3.517938060921875*^9, 3.517938076734375*^9}, {
   3.5179381245625*^9, 3.517938240328125*^9}, {3.5179382726875*^9, 
   3.517938290265625*^9}, {3.5179383243125*^9, 3.517938360875*^9}, {
   3.517938398078125*^9, 3.517938501015625*^9}, {3.517938709875*^9, 
   3.517938718265625*^9}, {3.51793907325*^9, 3.5179392170625*^9}, {
   3.517939315265625*^9, 3.517939332625*^9}, 3.517939513609375*^9, {
   3.517939605203125*^9, 3.5179396699375*^9}, {3.517939703828125*^9, 
   3.51793974015625*^9}, {3.5179397985*^9, 3.517939802859375*^9}, {
   3.517939882171875*^9, 3.5179400755625*^9}, {3.51794027490625*^9, 
   3.51794033178125*^9}, 3.517940365421875*^9, 3.517940432859375*^9, {
   3.517940518671875*^9, 3.51794055615625*^9}, {3.517941215796875*^9, 
   3.517941221765625*^9}, {3.517941412828125*^9, 3.517941415140625*^9}, {
   3.517941688125*^9, 3.51794170221875*^9}, {3.5179417994375*^9, 
   3.517941819234375*^9}, {3.517942055828125*^9, 3.517942060859375*^9}, {
   3.51794210934375*^9, 3.517942133984375*^9}, {3.51794229459375*^9, 
   3.5179424070625*^9}, {3.517942491890625*^9, 3.517942523515625*^9}, {
   3.517942666125*^9, 3.5179426950625*^9}, {3.51794289196875*^9, 
   3.51794290571875*^9}, {3.517942991859375*^9, 3.5179430463125*^9}, {
   3.517943189890625*^9, 3.517943213296875*^9}, {3.517943250484375*^9, 
   3.517943277375*^9}, 3.517943330578125*^9, {3.518018321984375*^9, 
   3.51801832990625*^9}, 3.51810514884375*^9, {3.518117246625*^9, 
   3.518117249390625*^9}, {3.51811745825*^9, 3.518117581953125*^9}, {
   3.518117778859375*^9, 3.518117835203125*^9}, 3.518118422*^9, {
   3.518118477875*^9, 3.5181186715625*^9}, 3.51811871046875*^9, {
   3.518433114828125*^9, 3.51843320940625*^9}, 3.518433249140625*^9, {
   3.518551352814125*^9, 3.518551452251625*^9}, 3.5200240450625*^9, {
   3.520024110796875*^9, 3.520024114015625*^9}, {3.5210593174375*^9, 
   3.521059318046875*^9}, {3.53031739921875*^9, 3.530317414890625*^9}, {
   3.53295747328125*^9, 3.532957542796875*^9}, {3.544721162328125*^9, 
   3.5447212075*^9}, {3.566257624093855*^9, 3.566257629522665*^9}, {
   3.5662577246048317`*^9, 3.5662577935413527`*^9}, {3.5662579085903544`*^9, 
   3.5662579109403577`*^9}, {3.5662585787783155`*^9, 3.56625861493397*^9}, {
   3.566260067119177*^9, 3.5662600704491816`*^9}, 3.566260103649228*^9, {
   3.5662601754093285`*^9, 3.566260205554371*^9}, {3.5662602720494637`*^9, 
   3.566260379774615*^9}, {3.580745952290375*^9, 3.580745954950379*^9}, {
   3.5807460175904665`*^9, 3.5807460424655013`*^9}, {3.5807462149907427`*^9, 
   3.5807462888658466`*^9}, {3.5807463340159097`*^9, 3.580746454124079*^9}, {
   3.580746500509144*^9, 3.5807465235991764`*^9}, {3.580746560559228*^9, 
   3.5807465616542296`*^9}, {3.582815847021769*^9, 3.582815847052969*^9}, {
   3.582824488556753*^9, 3.5828245764785075`*^9}, {3.58282466328946*^9, 
   3.5828246641162615`*^9}, {3.5828247101519423`*^9, 
   3.5828247145667505`*^9}, {3.587649558666479*^9, 3.5876495679796953`*^9}, {
   3.592951682346754*^9, 3.5929517147067995`*^9}, {3.5929517553168564`*^9, 
   3.5929517612068644`*^9}, {3.592951838836973*^9, 3.5929520195672264`*^9}, {
   3.5929525206579275`*^9, 3.5929525219879293`*^9}, {3.5930082780663157`*^9, 
   3.593008294009544*^9}, {3.593008328470004*^9, 3.593008332182811*^9}, {
   3.5930089517675376`*^9, 3.593008956877545*^9}, {3.5930091568528247`*^9, 
   3.5930091703128433`*^9}, {3.5930099144469614`*^9, 
   3.5930099248869762`*^9}, {3.5930099720320425`*^9, 3.593010140743271*^9}, {
   3.5930101971516376`*^9, 3.593010198741662*^9}, {3.593010242309831*^9, 
   3.5930102428698397`*^9}, {3.602787718264532*^9, 3.602787737869833*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Constructor", "[", 
     RowBox[{
      RowBox[{"Class", ":", "DataLegend"}], ",", "Self_Object"}], "]"}], "[", 
    
    RowBox[{
     RowBox[{"p", ":", "FigPointPattern"}], ",", 
     RowBox[{"DataSetInfo", ":", "DataSetInfoPattern"}], ",", 
     RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"FigObjectWrapper", "[", 
    RowBox[{"Class", ",", "Self", ",", 
     RowBox[{"{", "Opts", "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"BasicDataLegend", "[", "Self", "]"}], "[", 
      RowBox[{
       RowBox[{"FigAnchor", "[", "p", "]"}], ",", "DataSetInfo"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51510150784375*^9, 3.51510165284375*^9}, {
   3.5151018264375*^9, 3.515101837625*^9}, {3.515160729234375*^9, 
   3.5151607388125*^9}, {3.515160815109375*^9, 3.515160905421875*^9}, {
   3.515429900281625*^9, 3.5154299283285*^9}, {3.515432005344125*^9, 
   3.51543202310975*^9}, {3.515432080625375*^9, 3.515432260875375*^9}, {
   3.515432559875375*^9, 3.515432618141*^9}, {3.515432654812875*^9, 
   3.515432706531625*^9}, {3.515433020406625*^9, 3.515433023781625*^9}, {
   3.515442053016*^9, 3.5154420783285*^9}, {3.51544252460975*^9, 
   3.515442586281625*^9}, {3.5154469192035*^9, 3.515446929391*^9}, {
   3.5154471764535*^9, 3.515447183094125*^9}, {3.515447219250375*^9, 
   3.515447220250375*^9}, {3.515447301531625*^9, 3.5154473044535*^9}, 
   3.515448155969125*^9, {3.515449235594125*^9, 3.515449253000375*^9}, {
   3.515449888469125*^9, 3.515449967281625*^9}, {3.51545049042225*^9, 
   3.515450513625375*^9}, 3.515450672875375*^9, {3.515450879375375*^9, 
   3.51545089279725*^9}, {3.515451270625375*^9, 3.515451273781625*^9}, {
   3.51545137210975*^9, 3.515451372812875*^9}, {3.51553024203125*^9, 
   3.51553028875*^9}, {3.51553077315625*^9, 3.51553082103125*^9}, {
   3.515531150046875*^9, 3.5155311765*^9}, {3.515532114828125*^9, 
   3.5155321876875*^9}, {3.5155322465*^9, 3.515532248484375*^9}, {
   3.515532482875*^9, 3.515532515453125*^9}, {3.515533282421875*^9, 
   3.51553328884375*^9}, 3.515535928515625*^9, {3.5155390385625*^9, 
   3.51553904040625*^9}, 3.515604950640625*^9, {3.51586676828125*^9, 
   3.515866810640625*^9}, {3.515866842046875*^9, 3.515866957640625*^9}, {
   3.515867205265625*^9, 3.51586723075*^9}, {3.515867446203125*^9, 
   3.51586754646875*^9}, {3.515867955875*^9, 3.515867958390625*^9}, {
   3.515868208015625*^9, 3.51586820834375*^9}, {3.515868409890625*^9, 
   3.515868496421875*^9}, {3.51586937865625*^9, 3.515869403046875*^9}, {
   3.515950901984375*^9, 3.5159509108125*^9}, {3.515951377234375*^9, 
   3.515951383609375*^9}, {3.515957184375*^9, 3.515957196*^9}, 
   3.5180189549375*^9, 3.51810509440625*^9, 3.520029453359375*^9, {
   3.52003245621875*^9, 3.520032499875*^9}, {3.5200326980625*^9, 
   3.5200327025*^9}, {3.5200341704375*^9, 3.52003425715625*^9}, {
   3.520034298015625*^9, 3.520034299828125*^9}, {3.544721040125*^9, 
   3.544721060046875*^9}, 3.59295177247688*^9, {3.593008374302885*^9, 
   3.593008380230895*^9}, {3.59300857437117*^9, 3.5930085753411713`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Constructor", "[", 
     RowBox[{
      RowBox[{"Class", ":", "DataLegend"}], ",", "Self_Object"}], "]"}], "[", 
    
    RowBox[{
     RowBox[{"DataSetInfo", ":", "DataSetInfoPattern"}], ",", 
     RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"FigObjectWrapper", "[", 
    RowBox[{"Class", ",", "Self", ",", 
     RowBox[{"{", "Opts", "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"validate", " ", "special", " ", "option"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FigCheckOption", "[", 
       RowBox[{
       "Self", ",", "Point", ",", "FigPointPattern", ",", "FigOptions"}], 
       "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"BasicDataLegend", "[", "Self", "]"}], "[", 
       RowBox[{
        RowBox[{"FigAnchor", "[", 
         RowBox[{"(", 
          RowBox[{"Point", "/.", "FigOptions"}], ")"}], "]"}], ",", 
        "DataSetInfo"}], "]"}]}]}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51510150784375*^9, 3.51510165284375*^9}, {
   3.5151018264375*^9, 3.515101837625*^9}, {3.515160729234375*^9, 
   3.5151607388125*^9}, {3.515160815109375*^9, 3.515160905421875*^9}, {
   3.515429900281625*^9, 3.5154299283285*^9}, {3.515432005344125*^9, 
   3.51543202310975*^9}, {3.515432080625375*^9, 3.515432260875375*^9}, {
   3.515432559875375*^9, 3.515432618141*^9}, {3.515432654812875*^9, 
   3.515432706531625*^9}, {3.515433020406625*^9, 3.515433023781625*^9}, {
   3.515442053016*^9, 3.5154420783285*^9}, {3.51544252460975*^9, 
   3.515442586281625*^9}, {3.5154469192035*^9, 3.515446929391*^9}, {
   3.5154471764535*^9, 3.515447183094125*^9}, {3.515447219250375*^9, 
   3.515447220250375*^9}, {3.515447301531625*^9, 3.5154473044535*^9}, 
   3.515448155969125*^9, {3.515449235594125*^9, 3.515449253000375*^9}, {
   3.515449888469125*^9, 3.515449967281625*^9}, {3.51545049042225*^9, 
   3.515450513625375*^9}, 3.515450672875375*^9, {3.515450879375375*^9, 
   3.51545089279725*^9}, {3.515451270625375*^9, 3.515451273781625*^9}, {
   3.51545137210975*^9, 3.515451372812875*^9}, {3.51553024203125*^9, 
   3.51553028875*^9}, {3.51553077315625*^9, 3.51553082103125*^9}, {
   3.515531150046875*^9, 3.5155311765*^9}, {3.515532114828125*^9, 
   3.5155321876875*^9}, {3.5155322465*^9, 3.515532248484375*^9}, {
   3.515532482875*^9, 3.515532515453125*^9}, {3.515533282421875*^9, 
   3.51553328884375*^9}, 3.515535928515625*^9, {3.5155390385625*^9, 
   3.51553904040625*^9}, 3.515604950640625*^9, {3.51586676828125*^9, 
   3.515866810640625*^9}, {3.515866842046875*^9, 3.515866957640625*^9}, {
   3.515867205265625*^9, 3.51586723075*^9}, {3.515867446203125*^9, 
   3.51586754646875*^9}, {3.515867955875*^9, 3.515867958390625*^9}, {
   3.515868208015625*^9, 3.51586820834375*^9}, {3.515868409890625*^9, 
   3.515868496421875*^9}, {3.51586937865625*^9, 3.515869403046875*^9}, {
   3.515950901984375*^9, 3.5159509108125*^9}, {3.515951377234375*^9, 
   3.515951383609375*^9}, {3.515957184375*^9, 3.515957196*^9}, 
   3.5180189549375*^9, 3.51810509440625*^9, 3.520029453359375*^9, {
   3.52003245621875*^9, 3.520032499875*^9}, {3.5200326980625*^9, 
   3.5200327025*^9}, {3.5200341704375*^9, 3.520034284203125*^9}, {
   3.520034859171875*^9, 3.52003486265625*^9}, {3.54472096340625*^9, 
   3.544721003390625*^9}, 3.544721061796875*^9, 3.592951775226884*^9, {
   3.5930083564408536`*^9, 3.593008362368864*^9}, {3.5930085770711737`*^9, 
   3.5930085773211746`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Methods", "Subsection",
 CellChangeTimes->{{3.5151660264375*^9, 3.515166028765625*^9}, {
  3.515449067344125*^9, 3.51544909085975*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakeAnchor", "[", 
     RowBox[{
      RowBox[{"Class", ":", "DataLegend"}], ",", "Self_Object"}], "]"}], "[", 
    
    RowBox[{"Name_", ",", "Arg_"}], "]"}], ":=", 
   RowBox[{"FigMakeAnchorWrapper", "[", 
    RowBox[{
    "Class", ",", "Self", ",", "Name", ",", "Arg", ",", "\[IndentingNewLine]", 
     RowBox[{"FigRectangleAnchor", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"Self", "@", 
          RowBox[{"GetTextElement", "[", "]"}]}], ")"}], "@", 
        RowBox[{"GetCenter", "[", "]"}]}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"Self", "@", 
          RowBox[{"GetTextElement", "[", "]"}]}], ")"}], "@", 
        RowBox[{"GetRadius", "[", "]"}]}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"Self", "@", 
          RowBox[{"GetTextElement", "[", "]"}]}], ")"}], "@", 
        RowBox[{"GetPivot", "[", "]"}]}], ",", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"Self", "@", 
          RowBox[{"GetTextElement", "[", "]"}]}], ")"}], "@", 
        RowBox[{"GetRotation", "[", "]"}]}], ",", "\[IndentingNewLine]", 
       "Name", ",", "Arg"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakeBoundingBox", "[", 
     RowBox[{
      RowBox[{"Class", ":", "DataLegend"}], ",", "Self_Object"}], "]"}], "[", 
    "]"}], ":=", 
   RowBox[{"FigRectangleBoundingBox", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"Self", "@", 
        RowBox[{"GetTextElement", "[", "]"}]}], ")"}], "@", 
      RowBox[{"GetCenter", "[", "]"}]}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"Self", "@", 
        RowBox[{"GetTextElement", "[", "]"}]}], ")"}], "@", 
      RowBox[{"GetRadius", "[", "]"}]}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"Self", "@", 
        RowBox[{"GetTextElement", "[", "]"}]}], ")"}], "@", 
      RowBox[{"GetPivot", "[", "]"}]}], ",", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"Self", "@", 
        RowBox[{"GetTextElement", "[", "]"}]}], ")"}], "@", 
      RowBox[{"GetRotation", "[", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51517464803125*^9, 3.515174666234375*^9}, {
  3.5151749220625*^9, 3.515174944015625*^9}, {3.51525866915625*^9, 
  3.515258669703125*^9}, {3.51544000385975*^9, 3.5154400110785*^9}, {
  3.515448814344125*^9, 3.515448817391*^9}, {3.515449256562875*^9, 
  3.5154492602035*^9}, {3.515619221734375*^9, 3.5156192485*^9}, {
  3.515623072796875*^9, 3.51562312778125*^9}, {3.515682229453125*^9, 
  3.515682254765625*^9}, {3.51585771184375*^9, 3.515857765078125*^9}, {
  3.515860020453125*^9, 3.5158600291875*^9}, {3.515864057984375*^9, 
  3.51586407546875*^9}, {3.515864169703125*^9, 3.51586417290625*^9}, {
  3.515864272359375*^9, 3.51586427425*^9}, {3.51586758203125*^9, 
  3.515867584203125*^9}, {3.51586941340625*^9, 3.51586946234375*^9}, {
  3.51793927565625*^9, 3.51793928415625*^9}, {3.51964799978125*^9, 
  3.519648005375*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Data utilities", "Section",
 CellChangeTimes->{{3.52190734584375*^9, 3.521907348734375*^9}}],

Cell[CellGroupData[{

Cell["AttachIndex", "Subsection",
 CellChangeTimes->{{3.521907351328125*^9, 3.52190735346875*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Default", "[", "AttachIndex", "]"}], "=", "1"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"AttachIndex", "[", 
    RowBox[{"Start_.", ",", "Step_.", ",", 
     RowBox[{"DataArray_", "?", "MatrixQ"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "Indices", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Indices", "=", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"Start", "+", 
          RowBox[{"i", "*", "Step"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", "0", ",", 
           RowBox[{
            RowBox[{"Length", "[", "DataArray", "]"}], "-", "1"}]}], "}"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"ArrayFlatten", "[", 
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Transpose", "[", 
           RowBox[{"{", "Indices", "}"}], "]"}], ",", "DataArray"}], "}"}], 
        "}"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"AttachIndex", "[", 
    RowBox[{"Start_.", ",", "Step_.", ",", 
     RowBox[{"DataList_", "?", "VectorQ"}]}], "]"}], ":=", 
   RowBox[{"AttachIndex", "[", 
    RowBox[{"Start", ",", "Step", ",", 
     RowBox[{"Transpose", "[", 
      RowBox[{"{", "DataList", "}"}], "]"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.52190716484375*^9, 3.5219071764375*^9}, 
   3.52190730028125*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DeclareFigFallThroughError", "[", "AttachIndex", "]"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.527971053828125*^9, 3.5279710664375*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["SelectByColumn", "Subsection",
 CellChangeTimes->{{3.521907351328125*^9, 3.52190735346875*^9}, {
  3.523394455734375*^9, 3.5233944594375*^9}}],

Cell["Flat syntax (single condition)", "Text",
 CellChangeTimes->{{3.527765609703125*^9, 3.527765616359375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SelectByColumn", "[", 
    RowBox[{
     RowBox[{"DataArray_", "?", "MatrixQ"}], ",", "c_Integer", ",", "patt_"}],
     "]"}], ":=", 
   RowBox[{"Select", "[", 
    RowBox[{"DataArray", ",", 
     RowBox[{
      RowBox[{"MatchQ", "[", 
       RowBox[{
        RowBox[{"Part", "[", 
         RowBox[{"#", ",", "c"}], "]"}], ",", "patt"}], "]"}], "&"}]}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.52190716484375*^9, 3.5219071764375*^9}, 
   3.52190730028125*^9, {3.523394462265625*^9, 3.5233945511875*^9}}],

Cell["List syntax (unlimited conditions)", "Text",
 CellChangeTimes->{{3.52776561946875*^9, 3.52776562565625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectByColumn", "[", 
      RowBox[{
       RowBox[{"DataArray_", "?", "MatrixQ"}], ",", 
       RowBox[{"{", 
        RowBox[{"c_Integer", ",", "patt_"}], "}"}]}], "]"}], ":=", 
     RowBox[{"Select", "[", 
      RowBox[{"DataArray", ",", 
       RowBox[{
        RowBox[{"MatchQ", "[", 
         RowBox[{
          RowBox[{"Part", "[", 
           RowBox[{"#", ",", "c"}], "]"}], ",", "patt"}], "]"}], "&"}]}], 
      "]"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"SelectByColumn", "[", 
      RowBox[{"DataArray_", "?", "MatrixQ"}], "]"}], ":=", "DataArray"}], 
    ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"SelectByColumn", "[", 
      RowBox[{
       RowBox[{"DataArray_", "?", "MatrixQ"}], ",", 
       RowBox[{"{", 
        RowBox[{"c_Integer", ",", "patt_"}], "}"}], ",", 
       RowBox[{"RestSeq", ":", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"_Integer", ",", "_"}], "}"}], "..."}], ")"}]}]}], "]"}], ":=", 
     RowBox[{"Select", "[", 
      RowBox[{
       RowBox[{"SelectByColumn", "[", 
        RowBox[{"DataArray", ",", "RestSeq"}], "]"}], ",", 
       RowBox[{
        RowBox[{"MatchQ", "[", 
         RowBox[{
          RowBox[{"Part", "[", 
           RowBox[{"#", ",", "c"}], "]"}], ",", "patt"}], "]"}], "&"}]}], 
      "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.52190716484375*^9, 3.5219071764375*^9}, 
   3.52190730028125*^9, {3.523394462265625*^9, 3.5233945511875*^9}, {
   3.52344820371875*^9, 3.523448207203125*^9}, {3.52344825828125*^9, 
   3.523448357875*^9}, 3.52344853475*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DeclareFigFallThroughError", "[", "SelectByColumn", "]"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.527971053828125*^9, 3.527971056390625*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["MakeDataSet", "Subsection",
 CellChangeTimes->{{3.527770143328125*^9, 3.527770145*^9}, 
   3.530141093046875*^9}],

Cell["TODO -- validation on indices in Span", "Text",
 CellChangeTimes->{{3.527770310640625*^9, 3.527770318921875*^9}, {
  3.528196579203125*^9, 3.528196582890625*^9}}],

Cell["\<\
uniquifying Missing avoids algebraic fallacies, such as Missing[]-Missing[] \
-> 0 not counted as missing\
\>", "Text",
 CellChangeTimes->{{3.527865729296875*^9, 3.52786576228125*^9}, {
  3.5281966174375*^9, 3.5281966354375*^9}}],

Cell["MissingQ", "Text",
 CellChangeTimes->{{3.527864455578125*^9, 3.527864456640625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MissingQ", "[", "expr_", "]"}], ":=", 
   RowBox[{"!", 
    RowBox[{"FreeQ", "[", 
     RowBox[{"expr", ",", "Missing"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.527864427171875*^9, 3.5278644439375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"MissingQ", "[", 
  RowBox[{"2", "*", 
   RowBox[{"Missing", "[", "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"MissingQ", "[", "2", "]"}]}], "Input",
 CellChangeTimes->{{3.527864461734375*^9, 3.527864471578125*^9}}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{{3.527864466609375*^9, 3.527864471984375*^9}, 
   3.53446770759375*^9}],

Cell[BoxData["False"], "Output",
 CellChangeTimes->{{3.527864466609375*^9, 3.527864471984375*^9}, 
   3.534467707640625*^9}]
}, Open  ]],

Cell["\<\
Missingify
\tFlag any non-numeric or complex number as Missing[].
\tEliminates pesky Infinity values, and *most* results of arithmetic on a \
Missing[].
\tCaveat possibility of algebraic cancellation of Missing[] values.\
\>", "Text",
 CellChangeTimes->{{3.5278650089375*^9, 3.527865010484375*^9}, {
  3.5341872016875*^9, 3.53418726790625*^9}, {3.53418730228125*^9, 
  3.534187375484375*^9}, {3.53446767521875*^9, 3.53446767940625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Missingify", "[", "expr_", "]"}], ":=", 
   RowBox[{"Replace", "[", 
    RowBox[{"expr", ",", 
     RowBox[{
      RowBox[{
       RowBox[{"(", "_Complex", ")"}], "|", 
       RowBox[{"Except", "[", 
        RowBox[{"_", "?", "NumericQ"}], "]"}]}], "\[Rule]", 
      RowBox[{"Missing", "[", "]"}]}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.527865013625*^9, 3.52786503975*^9}, {
  3.534187090609375*^9, 3.534187092203125*^9}, {3.53418717278125*^9, 
  3.534187193796875*^9}, {3.53418738784375*^9, 3.534187392734375*^9}, {
  3.534467686578125*^9, 3.534467690953125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Missingify", "[", 
  RowBox[{"2", "*", 
   RowBox[{"Missing", "[", "]"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Missingify", "[", "2", "]"}]}], "Input",
 CellChangeTimes->{{3.527865043265625*^9, 3.527865057125*^9}}],

Cell[BoxData[
 RowBox[{"Missing", "[", "]"}]], "Output",
 CellChangeTimes->{3.527865057453125*^9, 3.53446769909375*^9}],

Cell[BoxData["2"], "Output",
 CellChangeTimes->{3.527865057453125*^9, 3.534467699125*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MakeDataSet", "::", "length"}], "=", 
   "\"\<Data sets have differing lengths `1`.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeDataSet", "::", "nodata"}], "=", 
   "\"\<MakeDataSet has been given an empty data set (possibly by accident?).\
\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeDataSet", "::", "outofrange"}], "=", 
   "\"\<Encountered a reference to an entry DataEntry[`1`,`2`] with \
out-of-range indices, inconsistent with the given data sets.  (The indices \
shown here as the arguments to DataEntry are the full, explicit indices, \
including data set number, row number, and column number or range.  You may \
have actually specified the entry in abbreviated form.)\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeDataSet", "::", "badexpr"}], "=", 
   "\"\<Expression for row gave non-list data.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "MakeDataSet", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Range", "\[Rule]", "All"}], ",", 
     RowBox[{"Number", "\[Rule]", "True"}], ",", 
     RowBox[{"Select", "\[Rule]", "True"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetAttributes", "[", 
    RowBox[{"MakeDataSet", ",", "HoldFirst"}], "]"}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "HoldFirst", " ", "to", " ", "prevent", " ", "premature", " ", 
    "evaluation", " ", "of", " ", "conditionals", " ", "in", " ", "row", " ", 
    "expression"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeDataSet", "[", 
    RowBox[{"Expr_", ",", 
     RowBox[{"DataSet", ":", 
      RowBox[{"{", "}"}]}], ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Message", "[", 
      RowBox[{"MakeDataSet", "::", "nodata"}], "]"}], ";", 
     RowBox[{"{", "}"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeDataSet", "[", 
    RowBox[{"Expr_", ",", 
     RowBox[{"DataSet", ":", 
      RowBox[{"(", 
       RowBox[{"_", "?", "MatrixQ"}], ")"}]}], ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"MakeDataSet", "[", 
    RowBox[{"Expr", ",", 
     RowBox[{"{", "DataSet", "}"}], ",", "Opts"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MakeDataSet", "[", 
    RowBox[{"Expr_", ",", 
     RowBox[{"DataSets", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"_", "?", "MatrixQ"}], ")"}], ".."}], "}"}]}], ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "RowsToUse", ",", "RawTable", ",", "DataSetDimensions", ",", 
       "DataEntryExtractor", ",", "ExtractedData", ",", "NullRow"}], "}"}], 
     ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"check", " ", "for", " ", "consistent", " ", "lengths"}], " ", 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"DataSetDimensions", "=", 
       RowBox[{"Dimensions", "/@", "DataSets"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"Equal", "@@", 
          RowBox[{"(", 
           RowBox[{"First", "/@", "DataSetDimensions"}], ")"}]}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"FigError", "[", 
         RowBox[{"MakeDataSet", ",", "\"\<length\>\"", ",", 
          RowBox[{"(", 
           RowBox[{"First", "/@", "DataSetDimensions"}], ")"}]}], "]"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"define", " ", "extractor", " ", "functions"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"define", " ", "single", " ", "entry"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"DataEntryExtractor", "[", 
        RowBox[{
         RowBox[{"s", ":", 
          RowBox[{"_Integer", ":", "1"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"r_Integer", ",", "c_Integer"}], "}"}]}], "]"}], ":=", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "\[LessEqual]", "s"}], ")"}], "&&", 
            RowBox[{"(", 
             RowBox[{"s", "\[LessEqual]", 
              RowBox[{"Length", "[", "DataSets", "]"}]}], ")"}]}], ")"}], 
          "\[IndentingNewLine]", "&&", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "\[LessEqual]", 
              RowBox[{"Abs", "[", "r", "]"}]}], ")"}], "&&", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Abs", "[", "r", "]"}], "\[LessEqual]", 
              RowBox[{"DataSetDimensions", "[", 
               RowBox[{"[", 
                RowBox[{"s", ",", "1"}], "]"}], "]"}]}], ")"}]}], ")"}], 
          "\[IndentingNewLine]", "&&", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "\[LessEqual]", 
              RowBox[{"Abs", "[", "c", "]"}]}], ")"}], "&&", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Abs", "[", "c", "]"}], "\[LessEqual]", 
              RowBox[{"DataSetDimensions", "[", 
               RowBox[{"[", 
                RowBox[{"s", ",", "2"}], "]"}], "]"}]}], ")"}]}], ")"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ExtractedData", "=", 
           RowBox[{"DataSets", "[", 
            RowBox[{"[", 
             RowBox[{"s", ",", "r", ",", "c"}], "]"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"ExtractedData", "/.", 
           RowBox[{"(", 
            RowBox[{"_Missing", "\[Rule]", 
             RowBox[{"Missing", "[", 
              RowBox[{"Unique", "[", "]"}], "]"}]}], ")"}]}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"FigError", "[", 
          RowBox[{"MakeDataSet", ",", "\"\<outofrange\>\"", ",", "s", ",", 
           RowBox[{"{", 
            RowBox[{"r", ",", "c"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"define", " ", "span", " ", "entry"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"DataEntryExtractor", "[", 
        RowBox[{
         RowBox[{"s", ":", 
          RowBox[{"_Integer", ":", "1"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"r_Integer", ",", 
           RowBox[{"c", ":", 
            RowBox[{"(", 
             RowBox[{"All", "|", "_Span"}], ")"}]}]}], "}"}]}], "]"}], ":=", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "\[LessEqual]", "s"}], ")"}], "&&", 
            RowBox[{"(", 
             RowBox[{"s", "\[LessEqual]", 
              RowBox[{"Length", "[", "DataSets", "]"}]}], ")"}]}], ")"}], 
          "\[IndentingNewLine]", "&&", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"1", "\[LessEqual]", 
              RowBox[{"Abs", "[", "r", "]"}]}], ")"}], "&&", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"Abs", "[", "r", "]"}], "\[LessEqual]", 
              RowBox[{"DataSetDimensions", "[", 
               RowBox[{"[", 
                RowBox[{"s", ",", "1"}], "]"}], "]"}]}], ")"}]}], ")"}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"ExtractedData", "=", 
           RowBox[{"DataSets", "[", 
            RowBox[{"[", 
             RowBox[{"s", ",", "r", ",", "c"}], "]"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"If", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"Head", "[", "ExtractedData", "]"}], "===", "Part"}], 
            ",", "\[IndentingNewLine]", 
            RowBox[{"FigError", "[", 
             RowBox[{
             "MakeDataSet", ",", "\"\<outofrange\>\"", ",", "s", ",", 
              RowBox[{"{", 
               RowBox[{"r", ",", "c"}], "}"}]}], "]"}]}], 
           "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Sequence", "@@", 
           RowBox[{"(", 
            RowBox[{"ExtractedData", "/.", 
             RowBox[{"(", 
              RowBox[{"_Missing", "\[Rule]", 
               RowBox[{"Missing", "[", 
                RowBox[{"Unique", "[", "]"}], "]"}]}], ")"}]}], ")"}]}]}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"FigError", "[", 
          RowBox[{"MakeDataSet", ",", "\"\<outofrange\>\"", ",", "s", ",", 
           RowBox[{"{", 
            RowBox[{"r", ",", "c"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "define", " ", "entry", " ", "with", " ", "implicit", " ", "row"}], 
       " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"DataEntryExtractor", "[", 
        RowBox[{
         RowBox[{"s", ":", 
          RowBox[{"_Integer", ":", "1"}]}], ",", 
         RowBox[{"c", ":", 
          RowBox[{"(", 
           RowBox[{"_Integer", "|", "All", "|", "_Span"}], ")"}]}]}], "]"}], ":=", 
       RowBox[{"DataEntry", "[", 
        RowBox[{"s", ",", 
         RowBox[{"{", 
          RowBox[{"Row", ",", "c"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"construct", " ", "new", " ", "data", " ", "set"}], " ", 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"RowsToUse", "=", 
       RowBox[{"Take", "[", 
        RowBox[{
         RowBox[{"Range", "[", 
          RowBox[{"Length", "[", 
           RowBox[{"First", "[", "DataSets", "]"}], "]"}], "]"}], ",", 
         RowBox[{"OptionValue", "[", "Range", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{
        RowBox[{"RowsToUse", "=", 
         RowBox[{"Part", "[", 
          RowBox[{
           RowBox[{"Range", "[", 
            RowBox[{"Length", "[", 
             RowBox[{"First", "[", "DataSets", "]"}], "]"}], "]"}], ",", 
           RowBox[{"OptionValue", "[", "Range", "]"}]}], "]"}]}], ";", " ", 
        RowBox[{
         RowBox[{"--", " ", "this"}], " ", "was", " ", "used", " ", "but", 
         " ", "is", " ", "not", " ", "consistent", " ", "with", " ", 
         "documented", " ", "meaning"}]}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Block", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"Row", ",", 
          RowBox[{"DataEntry", "=", "DataEntryExtractor"}], ",", "RowData"}], 
         "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"RawTable", "=", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"TrueQ", "[", 
              RowBox[{"OptionValue", "[", "Select", "]"}], "]"}], ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"RowData", "=", "Expr"}], ";", "\[IndentingNewLine]", 
              RowBox[{"If", "[", "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"!", 
                 RowBox[{"ListQ", "[", 
                  RowBox[{"First", "[", 
                   RowBox[{"{", "RowData", "}"}], "]"}], "]"}]}], ",", "  ", 
                RowBox[{"(*", " ", 
                 RowBox[{
                  RowBox[{
                  "contortion", " ", "necessary", " ", "to", " ", "trap", " ",
                    "possible", " ", "RowData"}], "=", 
                  RowBox[{"Sequence", "[", "...", "]"}]}], " ", "*)"}], 
                "\[IndentingNewLine]", 
                RowBox[{"FigError", "[", 
                 RowBox[{"MakeDataSet", ",", "\"\<badexpr\>\""}], "]"}]}], 
               "]"}], ";", "\[IndentingNewLine]", "RowData"}], ",", 
             "\[IndentingNewLine]", "NullRow"}], "\[IndentingNewLine]", "]"}],
            ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"Row", ",", "RowsToUse"}], "}"}]}], "\[IndentingNewLine]",
           "]"}]}]}], "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"RawTable", "=", 
       RowBox[{"Cases", "[", 
        RowBox[{"RawTable", ",", 
         RowBox[{"Except", "[", "NullRow", "]"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"simplify", " ", "\"\<missing\>\"", " ", "entries"}], " ", 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Map", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"TrueQ", "[", 
           RowBox[{"OptionValue", "[", "Number", "]"}], "]"}], ",", 
          "Missingify", ",", "Identity"}], "]"}], ",", "\[IndentingNewLine]", 
        "RawTable", ",", "\[IndentingNewLine]", 
        RowBox[{"{", "2", "}"}]}], "\[IndentingNewLine]", "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.527770146015625*^9, 3.5277703048125*^9}, {
   3.527770479265625*^9, 3.527770516078125*^9}, {3.527770550171875*^9, 
   3.52777060515625*^9}, {3.52777069415625*^9, 3.52777072175*^9}, {
   3.527770968671875*^9, 3.527770985796875*^9}, {3.5277710511875*^9, 
   3.527771072234375*^9}, {3.52777139178125*^9, 3.527771413109375*^9}, {
   3.527771790890625*^9, 3.527771845984375*^9}, {3.527771909578125*^9, 
   3.527771963890625*^9}, {3.52777202775*^9, 3.5277720320625*^9}, {
   3.52786553653125*^9, 3.527865569578125*^9}, {3.527866527125*^9, 
   3.52786657628125*^9}, {3.5279631535*^9, 3.527963232140625*^9}, {
   3.527963304734375*^9, 3.527963447265625*^9}, {3.527963499625*^9, 
   3.527963785640625*^9}, {3.527964445109375*^9, 3.5279644776875*^9}, {
   3.528196249328125*^9, 3.5281962505625*^9}, 3.528196313984375*^9, {
   3.5281963771875*^9, 3.52819640284375*^9}, {3.528196473921875*^9, 
   3.528196509*^9}, {3.528196548984375*^9, 3.528196550046875*^9}, {
   3.52819668375*^9, 3.528196696546875*^9}, {3.528196941234375*^9, 
   3.528196950359375*^9}, {3.528196987015625*^9, 3.52819709853125*^9}, {
   3.52819714028125*^9, 3.52819732459375*^9}, {3.52819737778125*^9, 
   3.528197395578125*^9}, {3.528197507234375*^9, 3.5281975995625*^9}, {
   3.528197661484375*^9, 3.52819772003125*^9}, {3.52819776540625*^9, 
   3.528197777*^9}, {3.5281979480625*^9, 3.528197953625*^9}, {
   3.530141096046875*^9, 3.530141125265625*^9}, {3.5337431484375*^9, 
   3.533743205328125*^9}, {3.533743236234375*^9, 3.53374327946875*^9}, {
   3.534186646625*^9, 3.534186662671875*^9}, {3.540494150515625*^9, 
   3.54049423565625*^9}, {3.55725300384375*^9, 3.5572530795625*^9}, {
   3.557253116140625*^9, 3.5572531276875*^9}, {3.5572535378125*^9, 
   3.5572535439375*^9}, {3.557253770046875*^9, 3.5572538895*^9}, {
   3.557253946921875*^9, 3.55725397684375*^9}, {3.55725401221875*^9, 
   3.557254023765625*^9}, {3.6110970375109615`*^9, 3.6110970909042816`*^9}, {
   3.611097272967078*^9, 3.6110972942149043`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DeclareFigFallThroughError", "[", "MakeDataSet", "]"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.527971040328125*^9, 3.5279710441875*^9}, 
   3.5301411273125*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["End package", "Section",
 CellChangeTimes->{{3.514823047703125*^9, 3.51482305353125*^9}}],

Cell[CellGroupData[{

Cell["Exit private context", "Subsection",
 CellChangeTimes->{{3.514823086015625*^9, 3.5148231094375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Exit package context", "Subsection",
 CellChangeTimes->{{3.514823092890625*^9, 3.51482312965625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Unprotect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<$*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EndPackage", "[", "]"}], ";"}]}], "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowToolbars->"RulerBar",
WindowSize->{1912, 1065},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
DockedCells->(FrontEndExecute[{
   FrontEnd`NotebookApply[
    FrontEnd`InputNotebook[], #, Placeholder]}]& ),
PrintingCopies->1,
PrintingPageRange->{1, 2},
PageHeaders->{{
   Cell[
    TextData[{
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"], " ", 
      Cell[
      " ", "Header", CellFrame -> {{0.5, 0}, {0, 0}}, CellFrameMargins -> 4], 
      
      Cell[
       TextData[{
         ValueBox["FileName"]}], "Header"]}], 
    CellMargins -> {{0, Inherited}, {Inherited, Inherited}}], None, None}, {
   Cell[
    TextData[{"LevelScheme 3.45 source code"}], "Header"], None, 
   "\"\"Cell[TextData[{Cell[TextData[{ValueBox[\"FileName\"]}], \"Header\"], \
Cell[\" \", \"Header\", CellFrame -> {{0, 0.5}, {0, 0}}, CellFrameMargins -> \
4], \" \", Cell[TextData[{CounterBox[\"Page\"]}], \"PageNumber\"]}], \
CellMargins -> {{Inherited, 0}, {Inh"}},
PrintingOptions->{"FirstPageFooter"->False,
"PrintingMargins"->{{36, 36}, {19.125, 36}}},
ShowSelection->True,
Magnification->1.25,
FrontEndVersion->"10.0 for Microsoft Windows (64-bit) (September 9, 2014)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 34, 0, 88, "Section"],
Cell[604, 24, 2931, 69, 212, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[3572, 98, 32, 0, 88, "Section"],
Cell[CellGroupData[{
Cell[3629, 102, 48, 0, 46, "Subsection"],
Cell[3680, 104, 1516, 24, 35, "Input",
 InitializationCell->True],
Cell[5199, 130, 184, 5, 35, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[5420, 140, 100, 1, 46, "Subsection"],
Cell[5523, 143, 1603, 28, 58, "Input",
 InitializationCell->True],
Cell[7129, 173, 1141, 29, 102, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[8307, 207, 98, 1, 46, "Subsection"],
Cell[8408, 210, 103, 1, 34, "Text"],
Cell[8514, 213, 980, 19, 102, "Input",
 InitializationCell->True],
Cell[9497, 234, 1000, 18, 102, "Input",
 InitializationCell->True],
Cell[10500, 254, 946, 18, 102, "Input",
 InitializationCell->True],
Cell[11449, 274, 87, 1, 34, "Text"],
Cell[11539, 277, 946, 25, 102, "Input",
 InitializationCell->True],
Cell[12488, 304, 2497, 66, 256, "Input",
 InitializationCell->True],
Cell[14988, 372, 99, 1, 34, "Text"],
Cell[15090, 375, 446, 10, 35, "Input",
 InitializationCell->True],
Cell[15539, 387, 96, 1, 34, "Text"],
Cell[15638, 390, 421, 9, 80, "Input",
 InitializationCell->True],
Cell[16062, 401, 633, 12, 80, "Input",
 InitializationCell->True],
Cell[16698, 415, 966, 18, 102, "Input",
 InitializationCell->True],
Cell[17667, 435, 542, 13, 58, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[18246, 453, 43, 0, 46, "Subsection"],
Cell[18292, 455, 183, 4, 35, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[18512, 464, 99, 1, 46, "Subsection"],
Cell[18614, 467, 163, 3, 35, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[18826, 476, 189, 3, 88, "Section"],
Cell[CellGroupData[{
Cell[19040, 483, 151, 2, 46, "Subsection"],
Cell[19194, 487, 267, 6, 35, "Input",
 InitializationCell->True],
Cell[19464, 495, 325, 7, 35, "Input",
 InitializationCell->True],
Cell[19792, 504, 864, 20, 124, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[20693, 529, 156, 2, 46, "Subsection"],
Cell[20852, 533, 494, 9, 102, "Input",
 InitializationCell->True],
Cell[21349, 544, 2915, 67, 410, "Input",
 InitializationCell->True],
Cell[24267, 613, 2939, 67, 432, "Input",
 InitializationCell->True],
Cell[27209, 682, 7024, 161, 696, "Input",
 InitializationCell->True],
Cell[34236, 845, 7078, 161, 696, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[41363, 1012, 139, 2, 88, "Section"],
Cell[CellGroupData[{
Cell[41527, 1018, 145, 2, 46, "Subsection"],
Cell[41675, 1022, 290, 7, 35, "Input",
 InitializationCell->True],
Cell[41968, 1031, 253, 6, 35, "Input",
 InitializationCell->True],
Cell[42224, 1039, 961, 22, 124, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[43222, 1066, 108, 1, 46, "Subsection"],
Cell[43333, 1069, 199, 5, 48, "Program"],
Cell[43535, 1076, 671, 14, 127, "Output"],
Cell[44209, 1092, 161, 3, 35, "Input",
 InitializationCell->True],
Cell[44373, 1097, 2270, 62, 146, "Input",
 InitializationCell->True],
Cell[46646, 1161, 169, 3, 35, "Input",
 InitializationCell->True],
Cell[46818, 1166, 1596, 41, 190, "Input",
 InitializationCell->True],
Cell[48417, 1209, 137, 2, 35, "Input"],
Cell[48557, 1213, 2545, 67, 366, "Input",
 InitializationCell->True],
Cell[51105, 1282, 211, 4, 35, "Input"],
Cell[51319, 1288, 5082, 137, 498, "Input",
 InitializationCell->True],
Cell[56404, 1427, 191, 4, 35, "Input",
 InitializationCell->True],
Cell[56598, 1433, 1063, 28, 102, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[57698, 1466, 41, 0, 46, "Subsection"],
Cell[57742, 1468, 5314, 118, 608, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[63081, 1590, 343, 8, 58, "Input"],
Cell[63427, 1600, 1921, 52, 86, "Output"],
Cell[65351, 1654, 607, 14, 35, "Output"]
}, Open  ]],
Cell[65973, 1671, 445, 8, 55, "Text"],
Cell[66421, 1681, 7180, 179, 564, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[73650, 1866, 159, 2, 88, "Section"],
Cell[73812, 1870, 329, 6, 34, "Text"],
Cell[74144, 1878, 834, 18, 168, "Input",
 InitializationCell->True],
Cell[74981, 1898, 846, 19, 168, "Input",
 InitializationCell->True],
Cell[75830, 1919, 1219, 27, 212, "Input",
 InitializationCell->True],
Cell[77052, 1948, 1130, 23, 190, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[78219, 1976, 102, 1, 171, "Section"],
Cell[CellGroupData[{
Cell[78346, 1981, 105, 1, 88, "Subsection"],
Cell[78454, 1984, 565, 10, 76, "Text"],
Cell[79022, 1996, 175, 4, 35, "Input",
 InitializationCell->True],
Cell[79200, 2002, 727, 20, 35, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[79964, 2027, 129, 1, 46, "Subsection"],
Cell[80096, 2030, 1192, 34, 58, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[81337, 2070, 89, 1, 171, "Section"],
Cell[81429, 2073, 358, 6, 106, "Text"],
Cell[CellGroupData[{
Cell[81812, 2083, 128, 1, 46, "Subsection"],
Cell[81943, 2086, 454, 13, 58, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[82434, 2104, 145, 2, 46, "Subsection"],
Cell[82582, 2108, 333, 7, 35, "Input",
 InitializationCell->True],
Cell[82918, 2117, 296, 7, 35, "Input",
 InitializationCell->True],
Cell[83217, 2126, 986, 22, 124, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[84240, 2153, 112, 1, 88, "Subsection"],
Cell[84355, 2156, 92, 1, 34, "Text"],
Cell[84450, 2159, 540, 10, 35, "Input",
 InitializationCell->True],
Cell[84993, 2171, 100, 1, 34, "Text"],
Cell[85096, 2174, 922, 19, 35, "Input",
 InitializationCell->True],
Cell[86021, 2195, 213, 3, 34, "Text"],
Cell[86237, 2200, 1031, 22, 35, "Input",
 InitializationCell->True],
Cell[87271, 2224, 120, 2, 34, "Text"],
Cell[87394, 2228, 954, 23, 58, "Input",
 InitializationCell->True],
Cell[88351, 2253, 693, 14, 35, "Input",
 InitializationCell->True],
Cell[89047, 2269, 797, 17, 35, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[89893, 2292, 136, 2, 171, "Section"],
Cell[CellGroupData[{
Cell[90054, 2298, 103, 1, 46, "Subsection"],
Cell[90160, 2301, 5016, 93, 762, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[95213, 2399, 127, 1, 88, "Subsection"],
Cell[95343, 2402, 231, 6, 97, "Text"],
Cell[95577, 2410, 10554, 229, 982, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[106168, 2644, 101, 1, 88, "Subsection"],
Cell[106272, 2647, 1106, 20, 159, "Text"],
Cell[107381, 2669, 7029, 164, 740, "Input",
 InitializationCell->True],
Cell[114413, 2835, 407, 8, 65, "Text"],
Cell[114823, 2845, 182, 4, 93, "Program"],
Cell[115008, 2851, 482, 15, 35, "Output"],
Cell[115493, 2868, 2456, 57, 300, "Input",
 InitializationCell->True],
Cell[117952, 2927, 626, 19, 58, "Input",
 InitializationCell->True],
Cell[118581, 2948, 773, 22, 35, "Input",
 InitializationCell->True],
Cell[119357, 2972, 9320, 198, 1268, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[128714, 3175, 96, 1, 46, "Subsection"],
Cell[128813, 3178, 879, 24, 35, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[129717, 3206, 869, 27, 156, "Input",
 CellID->370757339],
Cell[130589, 3235, 139, 3, 66, "Output"],
Cell[130731, 3240, 239, 7, 66, "Output"],
Cell[130973, 3249, 145, 3, 35, "Output"]
}, Open  ]],
Cell[131133, 3255, 999, 28, 58, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[132157, 3287, 213, 4, 66, "Input"],
Cell[132373, 3293, 1190, 18, 102, "Output"]
}, Open  ]],
Cell[133578, 3314, 34857, 682, 3732, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[168460, 4000, 383, 12, 66, "Input"],
Cell[168846, 4014, 354, 11, 66, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[169237, 4030, 278, 7, 66, "Input"],
Cell[169518, 4039, 556, 16, 66, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[170123, 4061, 141, 2, 46, "Subsection"],
Cell[170267, 4065, 1582, 36, 102, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[171898, 4107, 139, 2, 171, "Section"],
Cell[CellGroupData[{
Cell[172062, 4113, 103, 1, 88, "Subsection"],
Cell[172168, 4116, 123, 1, 65, "Text"],
Cell[172294, 4119, 161, 3, 34, "Text"],
Cell[172458, 4124, 859, 19, 58, "Input",
 InitializationCell->True],
Cell[173320, 4145, 4396, 105, 454, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[177753, 4255, 156, 2, 88, "Subsection"],
Cell[177912, 4259, 123, 1, 65, "Text"],
Cell[178038, 4262, 161, 3, 34, "Text"],
Cell[178202, 4267, 919, 20, 58, "Input",
 InitializationCell->True],
Cell[179124, 4289, 3310, 77, 256, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[182483, 4372, 95, 1, 171, "Section"],
Cell[CellGroupData[{
Cell[182603, 4377, 108, 1, 46, "Subsection"],
Cell[182714, 4380, 3236, 61, 388, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[185987, 4446, 94, 1, 46, "Subsection"],
Cell[186084, 4449, 1402, 38, 58, "Input",
 InitializationCell->True],
Cell[187489, 4489, 32615, 614, 3116, "Input",
 InitializationCell->True],
Cell[220107, 5105, 3213, 56, 102, "Input",
 InitializationCell->True],
Cell[223323, 5163, 3646, 67, 190, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[227006, 5235, 141, 2, 46, "Subsection"],
Cell[227150, 5239, 3170, 79, 212, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[230369, 5324, 98, 1, 332, "Section"],
Cell[CellGroupData[{
Cell[230492, 5329, 98, 1, 46, "Subsection"],
Cell[230593, 5332, 1506, 41, 168, "Input",
 InitializationCell->True],
Cell[232102, 5375, 201, 5, 35, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[232340, 5385, 148, 2, 171, "Subsection"],
Cell[232491, 5389, 112, 1, 34, "Text"],
Cell[232606, 5392, 590, 17, 35, "Input",
 InitializationCell->True],
Cell[233199, 5411, 114, 1, 34, "Text"],
Cell[233316, 5414, 1744, 50, 80, "Input",
 InitializationCell->True],
Cell[235063, 5466, 206, 5, 35, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[235306, 5476, 119, 2, 171, "Subsection"],
Cell[235428, 5480, 168, 2, 126, "Text"],
Cell[235599, 5484, 239, 5, 126, "Text"],
Cell[235841, 5491, 90, 1, 34, "Text"],
Cell[235934, 5494, 287, 8, 35, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[236246, 5506, 244, 5, 218, "Input"],
Cell[236493, 5513, 122, 2, 127, "Output"],
Cell[236618, 5517, 124, 2, 127, "Output"]
}, Open  ]],
Cell[236757, 5522, 446, 9, 97, "Text"],
Cell[237206, 5533, 651, 16, 35, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[237882, 5553, 245, 5, 218, "Input"],
Cell[238130, 5560, 119, 2, 127, "Output"],
Cell[238252, 5564, 89, 1, 35, "Output"]
}, Open  ]],
Cell[238356, 5568, 15511, 363, 1576, "Input",
 InitializationCell->True],
Cell[253870, 5933, 225, 6, 35, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[254144, 5945, 95, 1, 332, "Section"],
Cell[CellGroupData[{
Cell[254264, 5950, 106, 1, 46, "Subsection"],
Cell[254373, 5953, 96, 3, 35, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[254506, 5961, 107, 1, 46, "Subsection"],
Cell[254616, 5964, 406, 12, 80, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
