(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    293393,       7758]
NotebookOptionsPosition[    274214,       7142]
NotebookOutlinePosition[    274668,       7161]
CellTagsIndexPosition[    274625,       7158]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Header comments", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", "FigGeometry"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "SciDraw`"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{
     "Geometry", " ", "utilities", " ", "needed", " ", "by", " ", "figure", 
      " ", "objects"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Author", ":", " ", 
      RowBox[{"Mark", " ", 
       RowBox[{"A", ".", " ", "Caprio"}]}]}]}], ",", " ", 
    RowBox[{"Department", " ", "of", " ", "Physics"}], ",", " ", 
    RowBox[{"University", " ", "of", " ", "Notre", " ", "Dame"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "FIGYEAR"}]}]}], ",", " ", 
    RowBox[{"Mark", " ", 
     RowBox[{"A", ".", " ", "Caprio"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "FIGVERSION"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "MATHVERSION"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Discussion", ":", " ", "FIGDISCUSSION"}]}], " ", "*)"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"See", " ", "main", " ", "package", " ", 
      RowBox[{"file", "."}]}]}]}], " ", "*)"}]}]], "Input",
 InitializationCell->True,
 AutoIndent->False,
 CellChangeTimes->{{3.395093723328125*^9, 3.39509375184375*^9}, {
   3.398545735296875*^9, 3.39854574365625*^9}, 3.398799700609375*^9, {
   3.43024739209375*^9, 3.43024739990625*^9}, 3.430247813015625*^9, {
   3.436819738734375*^9, 3.436819746828125*^9}, 3.436820195484375*^9, {
   3.4439959535*^9, 3.4439959773125*^9}, {3.471089562875*^9, 
   3.471089568359375*^9}, {3.471089636203125*^9, 3.471089639046875*^9}, {
   3.48681044459375*^9, 3.4868104458125*^9}, {3.489687811140625*^9, 
   3.489687812484375*^9}, {3.497222348765625*^9, 3.497222354953125*^9}, 
   3.497224390546875*^9, {3.497299514859375*^9, 3.497299515046875*^9}, {
   3.49903536659375*^9, 3.49903536784375*^9}, {3.503265433671875*^9, 
   3.5032654415*^9}, {3.50612390383225*^9, 3.5061239087385*^9}, 
   3.507509920109375*^9, {3.51481857221875*^9, 3.514818754140625*^9}, 
   3.514822657671875*^9, {3.514823216234375*^9, 3.51482323709375*^9}, {
   3.51482326921875*^9, 3.514823311671875*^9}, {3.514823375546875*^9, 
   3.514823396890625*^9}, {3.5150157615*^9, 3.515015802921875*^9}, 
   3.515278625625*^9, {3.515611052734375*^9, 3.515611062421875*^9}},
 LanguageCategory->"NaturalLanguage"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin package", "Section"],

Cell[CellGroupData[{

Cell["Package context definition", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<SciDraw`\>\"", ",", "SciDraw`Private`$ExternalContexts"}], 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.395087747453125*^9, 3.39508775096875*^9}, {
   3.39509064290625*^9, 3.395090643234375*^9}, 3.395090710546875*^9, {
   3.395091175015625*^9, 3.395091179703125*^9}, {3.395093472375*^9, 
   3.39509347784375*^9}, {3.395093608140625*^9, 3.3950936085*^9}, {
   3.395519039875*^9, 3.395519061546875*^9}, {3.495041989453125*^9, 
   3.495042010953125*^9}, {3.495042158078125*^9, 3.495042163671875*^9}, {
   3.497222416421875*^9, 3.497222462578125*^9}, {3.497222963890625*^9, 
   3.497222994640625*^9}, 3.497223030953125*^9, {3.514818766734375*^9, 
   3.514818800625*^9}, {3.5148197104375*^9, 3.514819710671875*^9}, {
   3.514819841546875*^9, 3.51481994284375*^9}, {3.514819979578125*^9, 
   3.514820025046875*^9}, {3.5148201316875*^9, 3.514820154671875*^9}, {
   3.51482025234375*^9, 3.514820275171875*^9}, {3.514820309703125*^9, 
   3.514820406921875*^9}, {3.51482051775*^9, 3.514820571328125*^9}, {
   3.514820843296875*^9, 3.51482087146875*^9}, 3.51482140903125*^9, {
   3.514821446859375*^9, 3.514821449890625*^9}, 3.514821641390625*^9, {
   3.514821674609375*^9, 3.514821798390625*^9}, {3.514823407859375*^9, 
   3.514823433140625*^9}, 3.51501104184375*^9, 3.515275343*^9, {
   3.515276331390625*^9, 3.51527633303125*^9}, {3.51542275479725*^9, 
   3.515422755141*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Unprotect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}], ";"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin private context", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.514823442859375*^9, 3.5148234431875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dependencies", "Subsection",
 CellChangeTimes->{{3.514821147359375*^9, 3.51482114978125*^9}}],

Cell[BoxData[""], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51482113128125*^9, 3.514821158515625*^9}, {
  3.514823452421875*^9, 3.51482349575*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Scalar/range/region arithmetic", "Section",
 CellChangeTimes->{{3.515362381890625*^9, 3.51536238459375*^9}, {
  3.51536254696875*^9, 3.515362547921875*^9}, {3.5154385657035*^9, 
  3.515438597937875*^9}, {3.5160372882395*^9, 3.516037292661375*^9}}],

Cell[CellGroupData[{

Cell["Single parameter upgrades", "Subsection",
 CellChangeTimes->{{3.51552677265625*^9, 3.515526788390625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ScalarParameterPattern", "=", 
   RowBox[{"None", "|", 
    RowBox[{"(", 
     RowBox[{"_", "?", "NumericQ"}], ")"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NonNegativeScalarParameterPattern", "=", 
   RowBox[{"None", "|", "NonNegativePattern"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5156118653125*^9, 3.515611897578125*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UpgradeScalar", "[", "None", "]"}], ":=", "0"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UpgradeScalar", "[", 
    RowBox[{"x_", "?", "NumericQ"}], "]"}], ":=", "x"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515526790796875*^9, 3.51552681421875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Interval rescaling", "Subsection",
 CellChangeTimes->{{3.51568050853125*^9, 3.515680510921875*^9}}],

Cell["\<\
lambda wrapper for Rescale[u,{u1,u2},{v1,v2}]
   returns v1+(u-u1)/(u2-u1)*(v2-v1)\
\>", "Text",
 CellChangeTimes->{{3.518435352046875*^9, 3.51843535471875*^9}, {
  3.51843540059375*^9, 3.518435438921875*^9}, {3.5830763298686514`*^9, 
  3.5830763309086523`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"RescaleInterval", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"u1_", "?", "NumericQ"}], ",", 
        RowBox[{"u2_", "?", "NumericQ"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"v1_", "?", "NumericQ"}], ",", 
        RowBox[{"v2_", "?", "NumericQ"}]}], "}"}]}], "]"}], "[", 
    RowBox[{"u_", "?", "NumericQ"}], "]"}], ":=", 
   RowBox[{"Rescale", "[", 
    RowBox[{"u", ",", 
     RowBox[{"{", 
      RowBox[{"u1", ",", "u2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"v1", ",", "v2"}], "}"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515680514625*^9, 3.515680567875*^9}, {
  3.518435429171875*^9, 3.51843543103125*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Range testing", "Subsection",
 CellChangeTimes->{{3.5155270585625*^9, 3.51552706028125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InRange", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x1_", ",", "x2_"}], "}"}], ",", "x_"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"x1", "\[LessEqual]", "x"}], ")"}], "&&", 
    RowBox[{"(", 
     RowBox[{"x", "\[LessEqual]", "x2"}], ")"}]}]}], ";"}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"InRange", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x1_", ",", "x2_"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"y1_", ",", "y2_"}], "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x_", ",", "y_"}], "}"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"InRange", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x1", ",", "x2"}], "}"}], ",", "x"}], "]"}], "&&", 
    RowBox[{"InRange", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"y1", ",", "y2"}], "}"}], ",", "y"}], "]"}]}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5155270635*^9, 3.51552707109375*^9}, {
  3.52045229409375*^9, 3.52045229459375*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Interval extension by coordinate amount", "Subsection",
 CellChangeTimes->{{3.51536255090625*^9, 3.515362566421875*^9}, {
  3.51536267196875*^9, 3.515362677078125*^9}, {3.51604182739575*^9, 
  3.516041828661375*^9}}],

Cell["1-dimensional", "Text",
 CellChangeTimes->{{3.515796781015625*^9, 3.515796782875*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ExtendInterval", "[", 
    RowBox[{
     RowBox[{"PRange", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"PDiff", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"Mode", ":", "Absolute"}]}], "]"}], ":=", 
   RowBox[{"PRange", "+", 
    RowBox[{"PDiff", "*", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"+", "1"}]}], "}"}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExtendInterval", "[", 
    RowBox[{
     RowBox[{"PRange", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"PFrac", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"Mode", ":", "Scaled"}]}], "]"}], ":=", 
   RowBox[{"PRange", "+", 
    RowBox[{"PFrac", "*", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"+", "1"}]}], "}"}], "*", 
     RowBox[{"-", 
      RowBox[{"Subtract", "@@", "PRange"}]}]}]}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515362576421875*^9, 3.515362581484375*^9}, {
  3.51536268640625*^9, 3.51536270134375*^9}, {3.515362838828125*^9, 
  3.51536286996875*^9}, {3.515797065078125*^9, 3.515797076484375*^9}, {
  3.516456354671875*^9, 3.51645636353125*^9}, {3.5830783443606825`*^9, 
  3.5830783447356834`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Vector geometry", "Section",
 CellChangeTimes->{{3.515617733140625*^9, 3.51561773625*^9}}],

Cell[CellGroupData[{

Cell["Trigonometry for 2D vectors", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"VectorLength", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x_", "?", "NumericQ"}], ",", 
      RowBox[{"y_", "?", "NumericQ"}]}], "}"}], "]"}], ":=", 
   RowBox[{"Sqrt", "[", 
    RowBox[{
     RowBox[{"x", "^", "2"}], "+", 
     RowBox[{"y", "^", "2"}]}], "]"}]}], ";", 
  RowBox[{
   RowBox[{"VectorArcTan", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x_", "?", "NumericQ"}], ",", 
      RowBox[{"y_", "?", "NumericQ"}]}], "}"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x", ",", "y"}], "}"}], "==", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}]}], ",", "0.", ",", 
     RowBox[{"ArcTan", "[", 
      RowBox[{"x", ",", "y"}], "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51516775459375*^9, 3.5151677566875*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SegmentLength", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"p1", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], ",", 
         RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
      RowBox[{"p2", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], ",", 
         RowBox[{"_", "?", "NumericQ"}]}], "}"}]}]}], "}"}], "]"}], ":=", 
   RowBox[{"VectorLength", "[", 
    RowBox[{"p2", "-", "p1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SegmentTangent", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"p1", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], ",", 
         RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
      RowBox[{"p2", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], ",", 
         RowBox[{"_", "?", "NumericQ"}]}], "}"}]}]}], "}"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"p2", "-", "p1"}], ")"}], "/", 
    RowBox[{"VectorLength", "[", 
     RowBox[{"p2", "-", "p1"}], "]"}]}]}], ";", 
  RowBox[{
   RowBox[{"SegmentArcTan", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"p1", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], ",", 
         RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
      RowBox[{"p2", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], ",", 
         RowBox[{"_", "?", "NumericQ"}]}], "}"}]}]}], "}"}], "]"}], ":=", 
   RowBox[{"VectorArcTan", "[", 
    RowBox[{"p2", "-", "p1"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51516811021875*^9, 3.51516814440625*^9}, {
  3.519724204109375*^9, 3.519724222421875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FromPolar", "[", 
    RowBox[{"{", 
     RowBox[{"rho_", ",", "phi_"}], "}"}], "]"}], ":=", 
   RowBox[{"rho", "*", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Cos", "[", "phi", "]"}], ",", 
      RowBox[{"Sin", "[", "phi", "]"}]}], "}"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51553846121875*^9, 3.515538463828125*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Segment interpolation", "Subsection",
 CellChangeTimes->{{3.515854402640625*^9, 3.51585440940625*^9}}],

Cell["Null segment", "Text",
 CellChangeTimes->{{3.51585465534375*^9, 3.515854656921875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"InterpolateSegment", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"s", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"p1", ":", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"_", "?", "NumericQ"}], ",", 
            RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
         RowBox[{"p2", ":", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"_", "?", "NumericQ"}], ",", 
            RowBox[{"_", "?", "NumericQ"}]}], "}"}]}]}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Reference", ":", 
       RowBox[{"(", 
        RowBox[{"Tail", "|", "Center", "|", "Head"}], ")"}]}], ",", 
      RowBox[{"Mode", ":", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"Absolute", "|", "Scaled"}], ")"}], ":", "Scaled"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"x_", "?", "NumericQ"}]}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Chop", "[", 
       RowBox[{"SegmentLength", "[", "s", "]"}], "]"}], "\[Equal]", "0"}], 
     ")"}]}], ":=", "p1"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515854413203125*^9, 3.515854436390625*^9}, {
  3.515854482703125*^9, 3.515854538578125*^9}, {3.51585457090625*^9, 
  3.51585464740625*^9}, {3.5158546831875*^9, 3.515854702359375*^9}}],

Cell["\<\
Generic segment
\tCurve parameter is always in the *forward* direction (tail to head).
\tMappings for scaled coordinates:
\t\tTail [0,+1] -> [p1,p2]
\t\tCenter [-1,+1] -> [p1,p2] -- so units are scaled by factor of two \
relative to other cases, consistent with \[OpenCurlyDoubleQuote]offset\
\[CloseCurlyDoubleQuote] relative position
\t\tHead [-1,0] -> [p1,p2]\
\>", "Text",
 CellChangeTimes->{{3.515854660328125*^9, 3.51585466196875*^9}, {
  3.515854857609375*^9, 3.5158549445625*^9}, {3.515855273109375*^9, 
  3.515855285484375*^9}, {3.516554483421875*^9, 3.51655449028125*^9}, {
  3.5195627235625*^9, 3.5195627449375*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"InterpolateSegment", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"s", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"p1", ":", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"_", "?", "NumericQ"}], ",", 
            RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
         RowBox[{"p2", ":", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"_", "?", "NumericQ"}], ",", 
            RowBox[{"_", "?", "NumericQ"}]}], "}"}]}]}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Reference", ":", "Tail"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Mode", ":", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"Absolute", "|", "Scaled"}], ")"}], ":", "Scaled"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"x_", "?", "NumericQ"}]}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Chop", "[", 
       RowBox[{"SegmentLength", "[", "s", "]"}], "]"}], "!=", "0"}], ")"}]}], 
   ":=", 
   RowBox[{"p1", "+", 
    RowBox[{"x", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"p2", "-", "p1"}], ")"}], "/", 
      RowBox[{"Switch", "[", 
       RowBox[{"Mode", ",", "Absolute", ",", 
        RowBox[{"SegmentLength", "[", "s", "]"}], ",", "Scaled", ",", "1"}], 
       "]"}]}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"InterpolateSegment", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"s", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"p1", ":", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"_", "?", "NumericQ"}], ",", 
            RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
         RowBox[{"p2", ":", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"_", "?", "NumericQ"}], ",", 
            RowBox[{"_", "?", "NumericQ"}]}], "}"}]}]}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Reference", ":", "Center"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Mode", ":", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"Absolute", "|", "Scaled"}], ")"}], ":", "Scaled"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"x_", "?", "NumericQ"}]}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Chop", "[", 
       RowBox[{"SegmentLength", "[", "s", "]"}], "]"}], "!=", "0"}], ")"}]}], 
   ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"(", 
      RowBox[{"p2", "+", "p1"}], ")"}], "/", "2"}], "+", 
    RowBox[{"x", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"p2", "-", "p1"}], ")"}], "/", 
      RowBox[{"Switch", "[", 
       RowBox[{"Mode", ",", "Absolute", ",", 
        RowBox[{"SegmentLength", "[", "s", "]"}], ",", "Scaled", ",", "2"}], 
       "]"}]}]}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"InterpolateSegment", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"s", ":", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"p1", ":", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"_", "?", "NumericQ"}], ",", 
            RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
         RowBox[{"p2", ":", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"_", "?", "NumericQ"}], ",", 
            RowBox[{"_", "?", "NumericQ"}]}], "}"}]}]}], "}"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Reference", ":", "Head"}], ",", "\[IndentingNewLine]", 
      RowBox[{"Mode", ":", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"Absolute", "|", "Scaled"}], ")"}], ":", "Scaled"}]}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"x_", "?", "NumericQ"}]}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Chop", "[", 
       RowBox[{"SegmentLength", "[", "s", "]"}], "]"}], "!=", "0"}], ")"}]}], 
   ":=", 
   RowBox[{"p2", "+", 
    RowBox[{"x", "*", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"p2", "-", "p1"}], ")"}], "/", 
      RowBox[{"Switch", "[", 
       RowBox[{"Mode", ",", "Absolute", ",", 
        RowBox[{"SegmentLength", "[", "s", "]"}], ",", "Scaled", ",", "1"}], 
       "]"}]}]}]}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51585466671875*^9, 3.515854669828125*^9}, {
   3.515854709953125*^9, 3.515854849453125*^9}, {3.515854962953125*^9, 
   3.5158550233125*^9}, 3.51655450759375*^9, {3.519562752203125*^9, 
   3.519562757796875*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["XY pair geometry", "Section",
 CellChangeTimes->{{3.516037254661375*^9, 3.5160372584895*^9}}],

Cell[CellGroupData[{

Cell["Numerical pair pattern", "Subsection",
 CellChangeTimes->{{3.515438631812875*^9, 3.515438636281625*^9}, {
  3.516037225848875*^9, 3.516037231598875*^9}}],

Cell["\<\
Explicit numerical {x,y} pair
Note: Text should use FigTextOffsetPattern instead, which allows the value \
Automatic as well.\
\>", "Text",
 CellChangeTimes->{{3.51568165675*^9, 3.515681698171875*^9}, {
  3.5156817973125*^9, 3.515681809296875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"NumericalPairPattern", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"_", "?", "NumericQ"}], ",", 
     RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515681661859375*^9, 3.51568166925*^9}, {
   3.51568173871875*^9, 3.515681740046875*^9}, 3.515681791296875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Pair parameter upgrades", "Subsection",
 CellChangeTimes->{3.516037234848875*^9}],

Cell["\<\
Generic upgrade to equal values -- appropriate for radii and most types of \
nonnumeric parameters\
\>", "Text",
 CellChangeTimes->{{3.515525280671875*^9, 3.515525299515625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UpgradePair", "[", 
    RowBox[{"a", ":", "NonListPattern"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"a", ",", "a"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UpgradePair", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x", ":", "NonListPattern"}], ",", 
      RowBox[{"y", ":", "NonListPattern"}]}], "}"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y"}], "}"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515438642625375*^9, 3.51543870473475*^9}, 
   3.51544740729725*^9, {3.51552508746875*^9, 3.5155250899375*^9}, {
   3.515610756890625*^9, 3.51561077403125*^9}}],

Cell["\<\
Upgrade to default horizontal or default vertical numerical pair -- as in \
classic Nudge behavior\
\>", "Text",
 CellChangeTimes->{{3.51552530759375*^9, 3.515525343234375*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"IntervalParametersPattern", "=", 
   RowBox[{"(", 
    RowBox[{"None", "|", 
     RowBox[{"(", 
      RowBox[{"_", "?", "NumericQ"}], ")"}], "|", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"_", "?", "NumericQ"}], ")"}], ",", 
       RowBox[{"(", 
        RowBox[{"_", "?", "NumericQ"}], ")"}]}], "}"}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NonNegativeIntervalParametersPattern", "=", 
   RowBox[{"(", 
    RowBox[{"None", "|", "NonNegativePattern", "|", 
     RowBox[{"{", 
      RowBox[{"NonNegativePattern", ",", "NonNegativePattern"}], "}"}]}], 
    ")"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515527647796875*^9, 3.51552765653125*^9}, {
  3.51561045678125*^9, 3.515610472046875*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UpgradePairEqual", "[", "None", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UpgradePairEqual", "[", 
    RowBox[{"x_", "?", "NumericQ"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"x", ",", "x"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UpgradePairEqual", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x_", "?", "NumericQ"}], ",", 
      RowBox[{"y_", "?", "NumericQ"}]}], "}"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y"}], "}"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515438642625375*^9, 3.51543870473475*^9}, 
   3.51544740729725*^9, {3.515525069765625*^9, 3.515525171546875*^9}, {
   3.515610823484375*^9, 3.515610835984375*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UpgradePairHorizontal", "[", "None", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UpgradePairHorizontal", "[", 
    RowBox[{"x_", "?", "NumericQ"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UpgradePairHorizontal", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x_", "?", "NumericQ"}], ",", 
      RowBox[{"y_", "?", "NumericQ"}]}], "}"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y"}], "}"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515438642625375*^9, 3.51543870473475*^9}, 
   3.51544740729725*^9, {3.515525069765625*^9, 3.515525171546875*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UpgradePairVertical", "[", "None", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UpgradePairVertical", "[", 
    RowBox[{"y_", "?", "NumericQ"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "y"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UpgradePairVertical", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x_", "?", "NumericQ"}], ",", 
      RowBox[{"y_", "?", "NumericQ"}]}], "}"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y"}], "}"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515438642625375*^9, 3.51543870473475*^9}, 
   3.51544740729725*^9, {3.515525069765625*^9, 3.5155250950625*^9}, {
   3.51552514259375*^9, 3.51552518078125*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Point/anchor geometry", "Section",
 CellChangeTimes->{{3.51516648646875*^9, 3.5151664916875*^9}, {
  3.515450145094125*^9, 3.515450145766*^9}, {3.515956528703125*^9, 
  3.515956529765625*^9}}],

Cell[CellGroupData[{

Cell["Point pattern", "Subsection",
 CellChangeTimes->{{3.51543946635975*^9, 3.515439471687875*^9}, 
   3.515439602219125*^9, {3.515450693812875*^9, 3.515450694531625*^9}, {
   3.51561552875*^9, 3.515615530546875*^9}, 3.515953613125*^9, 
   3.515956525796875*^9}],

Cell["\<\
Point specification (including anchor name or object anchor generation).\
\>", "Text",
 CellChangeTimes->{{3.515439488187875*^9, 3.5154395102035*^9}, {
  3.515530327703125*^9, 3.515530335078125*^9}, {3.51553036696875*^9, 
  3.515530367734375*^9}, {3.515530668171875*^9, 3.515530676734375*^9}, {
  3.515608246390625*^9, 3.515608283140625*^9}, {3.515685208359375*^9, 
  3.515685209734375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FigCoordinatePointPattern", "=", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"_", "?", "NumericQ"}], ")"}], "|", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"Scaled", "|", "Canvas"}], ")"}], "[", 
         RowBox[{"(", 
          RowBox[{"_", "?", "NumericQ"}], ")"}], "]"}]}], ")"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"_", "?", "NumericQ"}], ")"}], "|", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"Scaled", "|", "Canvas"}], ")"}], "[", 
         RowBox[{"(", 
          RowBox[{"_", "?", "NumericQ"}], ")"}], "]"}]}], ")"}]}], 
     "\[IndentingNewLine]", "}"}], "|", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"Scaled", "|", "Canvas"}], ")"}], "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"_", "?", "NumericQ"}], ",", 
       RowBox[{"_", "?", "NumericQ"}]}], "}"}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.53653109659375*^9, 3.5365311166875*^9}, {
  3.53653196265625*^9, 3.536531987046875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FigPointPattern", "=", 
   RowBox[{"(", 
    RowBox[{"FigCoordinatePointPattern", "|", 
     RowBox[{"ObjectPattern", "[", "FigAnchor", "]"}], "|", 
     RowBox[{"ObjectNamePattern", "[", "FigAnchor", "]"}]}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515439472969125*^9, 3.51543948604725*^9}, {
   3.515450698281625*^9, 3.515450701687875*^9}, {3.515530339265625*^9, 
   3.5155303765*^9}, {3.515530557765625*^9, 3.515530569203125*^9}, {
   3.5155975314375*^9, 3.51559754925*^9}, {3.515597792984375*^9, 
   3.51559779728125*^9}, {3.515598279671875*^9, 3.515598286234375*^9}, {
   3.515613950328125*^9, 3.51561395671875*^9}, 3.515615579109375*^9, {
   3.515615903859375*^9, 3.515615912078125*^9}, {3.51561688265625*^9, 
   3.5156168859375*^9}, {3.515685177828125*^9, 3.515685200484375*^9}, 
   3.515883397828125*^9, 3.51810490809375*^9, {3.53653113275*^9, 
   3.5365311334375*^9}, {3.53653207609375*^9, 3.536532076421875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Point resolution", "Subsection",
 CellChangeTimes->{{3.5155389481875*^9, 3.5155389531875*^9}, {
  3.515616414640625*^9, 3.515616416671875*^9}}],

Cell["\<\
Resolves a point/anchor specification into canvas coordinates.

Note: This function is technically not necessary, since any valid point \
specification can be converted to an anchor with FigAnchor[p], and then the \
point part of the anchor can be extracted.  However, this function is more \
direct for ordinary numerical points, in that it avoids unnecessary creation \
of anchors for these points.\
\>", "Text",
 CellChangeTimes->{{3.515541825421875*^9, 3.515541838140625*^9}, {
   3.5156001483125*^9, 3.515600176546875*^9}, {3.515600221875*^9, 
   3.515600281890625*^9}, {3.51560485615625*^9, 3.515604856515625*^9}, {
   3.515861223421875*^9, 3.51586124259375*^9}, 3.51801844496875*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FigResolvePoint", "[", 
    RowBox[{"p", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"_", "?", "NumericQ"}], ",", 
       RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"CurrentWindow", "[", "]"}], "@", 
      RowBox[{"TFunction", "[", "]"}]}], ")"}], "@", "p"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolvePoint", "[", 
    RowBox[{"Canvas", "[", 
     RowBox[{"p", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "]"}], "]"}], ":=", "p"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolvePoint", "[", 
    RowBox[{"Scaled", "[", 
     RowBox[{"p", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "]"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"CurrentWindow", "[", "]"}], "@", 
      RowBox[{"ScaledTFunction", "[", "]"}]}], ")"}], "@", "p"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolvePoint", "[", 
    RowBox[{"a", ":", 
     RowBox[{"ObjectPattern", "[", "FigAnchor", "]"}]}], "]"}], ":=", 
   RowBox[{"a", "@", 
    RowBox[{"GetPoint", "[", "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolvePoint", "[", 
    RowBox[{"n", ":", 
     RowBox[{"ObjectNamePattern", "[", "FigAnchor", "]"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"Object", "[", "n", "]"}], "@", 
    RowBox[{"GetPoint", "[", "]"}]}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.515541817625*^9, {3.515541908421875*^9, 3.515541912828125*^9}, {
   3.515541996375*^9, 3.515541998203125*^9}, {3.515597628171875*^9, 
   3.51559764675*^9}, {3.5155978139375*^9, 3.5155978360625*^9}, {
   3.51559791015625*^9, 3.515597910953125*^9}, 3.51560013915625*^9, 
   3.51560485446875*^9, {3.51561594209375*^9, 3.51561595153125*^9}, {
   3.515616120734375*^9, 3.515616383671875*^9}, {3.51578413475*^9, 
   3.515784134765625*^9}, 3.518018521875*^9, 3.5180188034375*^9}],

Cell["Ad hoc treatment of hybrid coordinates", "Text",
 CellChangeTimes->{{3.5365308433125*^9, 3.536530862453125*^9}, 
   3.577552241511182*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigResolvePoint", "[", "\[IndentingNewLine]", 
    RowBox[{"p", ":", 
     RowBox[{"Except", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], ",", 
         RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", "\[IndentingNewLine]", 
       
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"x", ":", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"_", "?", "NumericQ"}], ")"}], "|", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"Scaled", "|", "Canvas"}], ")"}], "[", 
             RowBox[{"(", 
              RowBox[{"_", "?", "NumericQ"}], ")"}], "]"}]}], ")"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"y", ":", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"_", "?", "NumericQ"}], ")"}], "|", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"Scaled", "|", "Canvas"}], ")"}], "[", 
             RowBox[{"(", 
              RowBox[{"_", "?", "NumericQ"}], ")"}], "]"}]}], ")"}]}]}], 
        "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"FigResolveCoordinate", "[", 
      RowBox[{"x", ",", "1"}], "]"}], ",", 
     RowBox[{"FigResolveCoordinate", "[", 
      RowBox[{"y", ",", "2"}], "]"}]}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.53653087075*^9, 3.536530887890625*^9}, {
  3.536530960421875*^9, 3.536530998171875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generic bounding box generation for point-like objects", "Subsection",
 CellChangeTimes->{{3.515166674140625*^9, 3.515166694546875*^9}, {
  3.51545023029725*^9, 3.5154502318285*^9}, {3.515616428796875*^9, 
  3.515616447625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigPointBoundingBox", "[", 
    RowBox[{"p", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"x_", "?", "NumericQ"}], ",", 
       RowBox[{"y_", "?", "NumericQ"}]}], "}"}]}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x", ",", "x"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", "y"}], "}"}]}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51516616575*^9, 3.51516620196875*^9}, {
   3.515166363734375*^9, 3.51516642103125*^9}, {3.5151665123125*^9, 
   3.51516652478125*^9}, 3.515167326484375*^9, {3.515167359171875*^9, 
   3.515167378671875*^9}, {3.515167540625*^9, 3.515167556453125*^9}, {
   3.51545042535975*^9, 3.515450461031625*^9}, 3.516039158067625*^9, 
   3.524070974171875*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Displacement geometry", "Section",
 CellChangeTimes->{{3.515615972609375*^9, 3.515615975328125*^9}, {
  3.51568593528125*^9, 3.51568594096875*^9}}],

Cell["\<\
A \[OpenCurlyDoubleQuote]displacement\[CloseCurlyDoubleQuote] is a difference \
of positions, i.e., a vector describing a translation\
\>", "Text",
 CellChangeTimes->{{3.5830761548684063`*^9, 3.58307619338846*^9}}],

Cell[CellGroupData[{

Cell["Displacement patterns", "Subsection",
 CellChangeTimes->{{3.5156155039375*^9, 3.515615508109375*^9}, 
   3.515615550390625*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"FigDisplacementPattern", "=", 
   RowBox[{"None", "|", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}], "|", 
      RowBox[{"Scaled", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], ",", 
         RowBox[{"_", "?", "NumericQ"}]}], "}"}], "]"}], "|", 
      RowBox[{"Canvas", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], ",", 
         RowBox[{"_", "?", "NumericQ"}]}], "}"}], "]"}]}], ")"}], "|", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"_", "?", "NumericQ"}], ")"}], "|", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"Scaled", "|", "Canvas"}], ")"}], "[", 
         RowBox[{"(", 
          RowBox[{"_", "?", "NumericQ"}], ")"}], "]"}]}], ")"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"_", "?", "NumericQ"}], ")"}], "|", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"Scaled", "|", "Canvas"}], ")"}], "[", 
         RowBox[{"(", 
          RowBox[{"_", "?", "NumericQ"}], ")"}], "]"}]}], ")"}]}], 
     "\[IndentingNewLine]", "}"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigDisplacementSequencePattern", "[", "n_Integer", "]"}], ":=", 
   RowBox[{"Repeated", "[", 
    RowBox[{
     RowBox[{"_", "?", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"MatchQ", "[", 
         RowBox[{"#", ",", "FigDisplacementPattern"}], "]"}], "&"}], ")"}]}], 
     ",", 
     RowBox[{"{", 
      RowBox[{"n", ",", "Infinity"}], "}"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigDisplacementSetPattern", "[", "n_Integer", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"Repeated", "[", 
     RowBox[{
      RowBox[{"_", "?", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"#", ",", "FigDisplacementPattern"}], "]"}], "&"}], ")"}]}],
       ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "Infinity"}], "}"}]}], "]"}], "}"}]}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51561556428125*^9, 3.515615591890625*^9}, {
  3.51561568934375*^9, 3.515615695046875*^9}, {3.51561684240625*^9, 
  3.515616847796875*^9}, {3.516284387*^9, 3.516284407734375*^9}, {
  3.520031935078125*^9, 3.520031936015625*^9}, {3.5775526127767015`*^9, 
  3.5775526158517056`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["FigResolveDisplacement", "Subsection",
 CellChangeTimes->{{3.5155389481875*^9, 3.5155389531875*^9}, {
  3.51561598071875*^9, 3.51561598290625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveDisplacement", "[", "None", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveDisplacement", "[", 
    RowBox[{"d", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"_", "?", "NumericQ"}], ",", 
       RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"CurrentWindow", "[", "]"}], "@", 
      RowBox[{"DeltaTFunction", "[", "]"}]}], ")"}], "@", "d"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveDisplacement", "[", 
    RowBox[{"Canvas", "[", 
     RowBox[{"d", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "]"}], "]"}], ":=", "d"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveDisplacement", "[", 
    RowBox[{"Scaled", "[", 
     RowBox[{"d", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "]"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"CurrentWindow", "[", "]"}], "@", 
      RowBox[{"ScaledDeltaTFunction", "[", "]"}]}], ")"}], "@", "d"}]}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.515541817625*^9, {3.515541908421875*^9, 3.515541912828125*^9}, {
   3.515541996375*^9, 3.515541998203125*^9}, {3.515597628171875*^9, 
   3.51559764675*^9}, {3.5155978139375*^9, 3.5155978360625*^9}, {
   3.51559791015625*^9, 3.515597910953125*^9}, 3.51560013915625*^9, 
   3.51560485446875*^9, {3.51561594209375*^9, 3.51561595153125*^9}, {
   3.515615986265625*^9, 3.5156160985*^9}, {3.51578413478125*^9, 
   3.5157841348125*^9}, {3.5200319503125*^9, 3.52003195840625*^9}}],

Cell["Ad hoc treatment of hybrid coordinates", "Text",
 CellChangeTimes->{{3.5365308433125*^9, 3.536530862453125*^9}, 
   3.577552241511182*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveDisplacement", "[", "\[IndentingNewLine]", 
    RowBox[{"p", ":", 
     RowBox[{"Except", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], ",", 
         RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", "\[IndentingNewLine]", 
       
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"x", ":", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"_", "?", "NumericQ"}], ")"}], "|", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"Scaled", "|", "Canvas"}], ")"}], "[", 
             RowBox[{"(", 
              RowBox[{"_", "?", "NumericQ"}], ")"}], "]"}]}], ")"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"y", ":", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"_", "?", "NumericQ"}], ")"}], "|", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"Scaled", "|", "Canvas"}], ")"}], "[", 
             RowBox[{"(", 
              RowBox[{"_", "?", "NumericQ"}], ")"}], "]"}]}], ")"}]}]}], 
        "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"FigResolveCoordinateDisplacement", "[", 
      RowBox[{"x", ",", "1"}], "]"}], ",", 
     RowBox[{"FigResolveCoordinateDisplacement", "[", 
      RowBox[{"y", ",", "2"}], "]"}]}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.53653087075*^9, 3.536530887890625*^9}, {
  3.536530960421875*^9, 3.536530998171875*^9}, {3.577552251676196*^9, 
  3.5775522636462126`*^9}, {3.625166579988096*^9, 3.625166581813299*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Offset geometry", "Section",
 CellChangeTimes->{{3.519492514984375*^9, 3.519492516859375*^9}}],

Cell["An \[OpenCurlyDoubleQuote]offset\[CloseCurlyDoubleQuote] is a relative \
position within a rectangle", "Text",
 CellChangeTimes->{{3.583076204708476*^9, 3.5830762239985027`*^9}}],

Cell[CellGroupData[{

Cell["Named point offsets", "Subsection",
 CellChangeTimes->{{3.51585667196875*^9, 3.51585667590625*^9}}],

Cell[TextData[{
 "Note: These are the offsets ",
 StyleBox["to",
  FontSlant->"Italic"],
 " the point.  The offset of text attached to the point should be the \
negative of this."
}], "Text",
 CellChangeTimes->{{3.515856679296875*^9, 3.515856701953125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"NamedPointPattern", "=", 
   RowBox[{
   "Center", "|", "Left", "|", "Right", "|", "Bottom", "|", "Top", "|", 
    "TopLeft", "|", "TopRight", "|", "BottomLeft", "|", "BottomRight"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51847362190625*^9, 3.518473625921875*^9}, {
  3.518473733375*^9, 3.518473772203125*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"NamedPointOffset", "[", "Center", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", "0"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NamedPointOffset", "[", "Left", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "0"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NamedPointOffset", "[", "Right", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"+", "1"}], ",", "0"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NamedPointOffset", "[", "Bottom", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "1"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NamedPointOffset", "[", "Top", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"+", "1"}]}], "}"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51585658321875*^9, 3.51585664778125*^9}, {
  3.51585670484375*^9, 3.5158567275625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"NamedPointOffset", "[", "TopLeft", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"+", "1"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NamedPointOffset", "[", "TopRight", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"+", "1"}], ",", 
     RowBox[{"+", "1"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NamedPointOffset", "[", "BottomLeft", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1"}], ",", 
     RowBox[{"-", "1"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NamedPointOffset", "[", "BottomRight", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"+", "1"}], ",", 
     RowBox[{"-", "1"}]}], "}"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51847356375*^9, 3.518473604984375*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Realizing offset", "Subsection",
 CellChangeTimes->{{3.5194922451875*^9, 3.519492247734375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FigOffsetPattern", "=", 
   RowBox[{"NamedPointPattern", "|", "NumericalPairPattern"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.519492311796875*^9, 3.519492321453125*^9}, {
  3.519492469*^9, 3.5194924740625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveOffset", "[", 
    RowBox[{"Offset", ":", "NamedPointPattern"}], "]"}], ":=", 
   RowBox[{"NamedPointOffset", "[", "Offset", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveOffset", "[", 
    RowBox[{"Offset", ":", "NumericalPairPattern"}], "]"}], ":=", "Offset"}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.519492248640625*^9, 3.519492290796875*^9}, {
  3.519492486625*^9, 3.519492493421875*^9}, {3.519495312078125*^9, 
  3.519495316453125*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Window/panel geometry", "Section",
 CellChangeTimes->{{3.51516648646875*^9, 3.5151664916875*^9}, {
  3.515617659953125*^9, 3.515617686125*^9}, {3.515782122671875*^9, 
  3.515782123171875*^9}, {3.51578499628125*^9, 3.515784997953125*^9}}],

Cell[CellGroupData[{

Cell["Generic numerical region pattern", "Subsection",
 CellChangeTimes->{{3.515342045546875*^9, 3.515342048015625*^9}, {
  3.515342428203125*^9, 3.515342429546875*^9}, {3.51603713177075*^9, 
  3.5160371333645*^9}, {3.516037165036375*^9, 3.516037205192625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"RangeParametersPattern", "=", 
   RowBox[{"(", 
    RowBox[{"None", "|", 
     RowBox[{"(", 
      RowBox[{"_", "?", "NumericQ"}], ")"}], "|", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"_", "?", "NumericQ"}], ")"}], ",", 
       RowBox[{"(", 
        RowBox[{"_", "?", "NumericQ"}], ")"}]}], "}"}], "|", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"_", "?", "NumericQ"}], ")"}], ",", 
         RowBox[{"(", 
          RowBox[{"_", "?", "NumericQ"}], ")"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"_", "?", "NumericQ"}], ")"}], ",", 
         RowBox[{"(", 
          RowBox[{"_", "?", "NumericQ"}], ")"}]}], "}"}]}], "}"}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NonNegativeRangeParametersPattern", "=", 
   RowBox[{"(", 
    RowBox[{"None", "|", "NonNegativePattern", "|", 
     RowBox[{"{", 
      RowBox[{"NonNegativePattern", ",", "NonNegativePattern"}], "}"}], "|", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"NonNegativePattern", ",", "NonNegativePattern"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"NonNegativePattern", ",", "NonNegativePattern"}], "}"}]}], 
      "}"}]}], ")"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"NumericalRegionPattern", "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"_", "?", "NumericQ"}], ")"}], ",", 
       RowBox[{"(", 
        RowBox[{"_", "?", "NumericQ"}], ")"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"_", "?", "NumericQ"}], ")"}], ",", 
       RowBox[{"(", 
        RowBox[{"_", "?", "NumericQ"}], ")"}]}], "}"}]}], "}"}]}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515353469921875*^9, 3.5153535245625*^9}, {
  3.515353653453125*^9, 3.515353654515625*^9}, {3.515353694734375*^9, 
  3.5153537149375*^9}, {3.515353797671875*^9, 3.515353826796875*^9}, {
  3.51603798577075*^9, 3.516038001177*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Generic numerical region upgrade", "Subsection",
 CellChangeTimes->{{3.5160371906145*^9, 3.51603720895825*^9}}],

Cell["\<\
for numeric data

general rules
\tx -> {x,x}
\t{x,y} -> {{x,x},{y,y}}
\t{{x1,x2},{y1,y2}} left unchanged
\t
special case
\tNone -> {{0,0},{0,0}}\
\>", "Text",
 CellChangeTimes->{{3.428181708328125*^9, 3.428181714515625*^9}, {
  3.459546646359375*^9, 3.45954666640625*^9}, {3.461090186078125*^9, 
  3.461090206421875*^9}, {3.461090554328125*^9, 3.461090557796875*^9}, {
  3.46694655503125*^9, 3.466946556640625*^9}, {3.515342181828125*^9, 
  3.51534226246875*^9}, {3.515342351140625*^9, 3.515342395984375*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UpgradeRangeParameters", "[", 
    RowBox[{"xy_", "?", "NumericQ"}], "]"}], ":=", 
   RowBox[{"UpgradeRangeParameters", "[", 
    RowBox[{"{", 
     RowBox[{"xy", ",", "xy"}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UpgradeRangeParameters", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x_", "?", "NumericQ"}], ",", 
      RowBox[{"y_", "?", "NumericQ"}]}], "}"}], "]"}], ":=", 
   RowBox[{"UpgradeRangeParameters", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"x", ",", "x"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", "y"}], "}"}]}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UpgradeRangeParameters", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"x1_", "?", "NumericQ"}], ",", 
        RowBox[{"x2_", "?", "NumericQ"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"y1_", "?", "NumericQ"}], ",", 
        RowBox[{"y2_", "?", "NumericQ"}]}], "}"}]}], "}"}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x1", ",", "x2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y1", ",", "y2"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UpgradeRangeParameters", "[", "None", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.428181740703125*^9, 3.4281817943125*^9}, {
   3.428181880328125*^9, 3.428181908125*^9}, {3.428182150109375*^9, 
   3.428182171484375*^9}, {3.42818246159375*^9, 3.42818248540625*^9}, 
   3.466946390578125*^9, 3.51534217165625*^9, {3.51534228034375*^9, 
   3.515342342328125*^9}, {3.5153424063125*^9, 3.515342420765625*^9}, 
   3.515353680546875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Region extension by coordinate amount", "Subsection",
 CellChangeTimes->{{3.516041839880125*^9, 3.516041844802*^9}}],

Cell["2-dimensional", "Text",
 CellChangeTimes->{{3.51579679171875*^9, 3.515796793390625*^9}, {
  3.5669433672474875`*^9, 3.5669433913275213`*^9}, {3.5669434945076656`*^9, 
  3.5669435408777304`*^9}, {3.5669436014378157`*^9, 3.566943650347884*^9}, {
  3.5830783778607297`*^9, 3.5830783793657317`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ExtendRegion", "[", 
    RowBox[{
     RowBox[{"PRange", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "}"}]}], ",", 
     RowBox[{"PDiff", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "}"}]}], ",", 
     RowBox[{"Mode", ":", "Absolute"}]}], "]"}], ":=", 
   RowBox[{"PRange", "+", 
    RowBox[{"PDiff", "*", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", 
         RowBox[{"+", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", 
         RowBox[{"+", "1"}]}], "}"}]}], "}"}]}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExtendRegion", "[", 
    RowBox[{
     RowBox[{"PRange", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "}"}]}], ",", 
     RowBox[{"PFrac", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "}"}]}], ",", 
     RowBox[{"Mode", ":", "Scaled"}]}], "]"}], ":=", 
   RowBox[{"PRange", "+", 
    RowBox[{"PFrac", "*", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", 
         RowBox[{"+", "1"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", 
         RowBox[{"+", "1"}]}], "}"}]}], "}"}], "*", 
     RowBox[{"-", 
      RowBox[{"Subtract", "@@@", "PRange"}]}]}]}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.470920245828125*^9, 3.470920252046875*^9}, {
   3.515362535484375*^9, 3.51536253778125*^9}, {3.515362583265625*^9, 
   3.51536260653125*^9}, {3.515362687484375*^9, 3.515362709484375*^9}, 
   3.51536284434375*^9, {3.515362895421875*^9, 3.515362906125*^9}, 
   3.51536299653125*^9, {3.515797038171875*^9, 3.51579705753125*^9}, {
   3.51645637384375*^9, 3.51645638003125*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Window region specification pattern", "Subsection",
 CellChangeTimes->{{3.515782275453125*^9, 3.515782279703125*^9}, 
   3.51578499171875*^9}],

Cell["\<\
Note: Pattern excludes case {_Integer,_Integer}, for panel in multipanel \
array, since this case requires special treatment.\
\>", "Text",
 CellChangeTimes->{{3.5157847563125*^9, 3.515784790640625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FigRegionPattern", "=", 
   RowBox[{"(", 
    RowBox[{"All", "|", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], ",", 
         RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], ",", 
         RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "}"}], "|", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"Scaled", "|", "Canvas"}], ")"}], "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "}"}], "]"}]}], ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515782131515625*^9, 3.515782173640625*^9}, {
   3.51578220403125*^9, 3.51578225421875*^9}, {3.51578477109375*^9, 
   3.515784771390625*^9}, 3.515784983671875*^9, 3.51628696821875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Region resolution", "Subsection",
 CellChangeTimes->{{3.5155389481875*^9, 3.5155389531875*^9}, {
   3.515616414640625*^9, 3.515616416671875*^9}, {3.515784677796875*^9, 
   3.515784694203125*^9}, 3.515784985390625*^9, {3.5162867565625*^9, 
   3.516286756890625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveRegion", "[", 
    RowBox[{"r", ":", "All"}], "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"CurrentWindow", "[", "]"}], "@", 
     RowBox[{"CanvasRegion", "[", "]"}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveRegion", "[", 
    RowBox[{"r", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], ",", 
         RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], ",", 
         RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "}"}]}], "]"}], ":=", 
   RowBox[{"TransformRegion", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"CurrentWindow", "[", "]"}], "@", 
      RowBox[{"TFunction", "[", "]"}]}], ",", "r"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveRegion", "[", 
    RowBox[{"Canvas", "[", 
     RowBox[{"r", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "}"}]}], "]"}], "]"}], ":=",
    "r"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveRegion", "[", 
    RowBox[{"Scaled", "[", 
     RowBox[{"r", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "}"}]}], "]"}], "]"}], ":=", 
   RowBox[{"TransformRegion", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"CurrentWindow", "[", "]"}], "@", 
      RowBox[{"ScaledTFunction", "[", "]"}]}], ",", "r"}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.515541817625*^9, {3.515541908421875*^9, 3.515541912828125*^9}, {
   3.515541996375*^9, 3.515541998203125*^9}, {3.515597628171875*^9, 
   3.51559764675*^9}, {3.5155978139375*^9, 3.5155978360625*^9}, {
   3.51559791015625*^9, 3.515597910953125*^9}, 3.51560013915625*^9, 
   3.51560485446875*^9, {3.51561594209375*^9, 3.51561595153125*^9}, {
   3.515616120734375*^9, 3.515616383671875*^9}, {3.515782289078125*^9, 
   3.51578232515625*^9}, {3.515784012125*^9, 3.5157840259375*^9}, {
   3.5157841345625*^9, 3.51578425153125*^9}, {3.515784491796875*^9, 
   3.51578457575*^9}, {3.515784696953125*^9, 3.5157847003125*^9}, {
   3.515784985828125*^9, 3.5157849881875*^9}, {3.51628696884375*^9, 
   3.51628697021875*^9}, {3.5334151966875*^9, 3.533415201578125*^9}, 
   3.5334152335625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Region extension", "Subsection",
 CellChangeTimes->{{3.5162860230625*^9, 3.51628602884375*^9}, {
  3.51628675059375*^9, 3.5162867515625*^9}}],

Cell["\<\
Programmer level functions -- working in canvas coordinates
Serve to resolve \[OpenCurlyDoubleQuote]delta region patterns\
\[CloseCurlyDoubleQuote] to adjustments which can be handled arithmetically \
by ExtendRegion
Here \[OpenCurlyDoubleQuote]Scaled\[CloseCurlyDoubleQuote] refers to a \
fraction of the region which is being expanded, not of the current window.\
\>", "Text",
 CellChangeTimes->{{3.516286740265625*^9, 3.51628679584375*^9}, {
  3.516286830875*^9, 3.51628684359375*^9}, {3.520528652796875*^9, 
  3.520528657046875*^9}, {3.5830801838869057`*^9, 3.5830801912501187`*^9}, {
  3.5830810836947255`*^9, 3.5830811069387665`*^9}}],

Cell["\<\
FigResolveRegionExtension converts a user-acceptable region extension and \
returns arguments {{{x1,x2},{y1,y2}},{dx1,dx2},{dy1,dy2},Absolute|Scaled}  \
for use with ExtendRegion.\
\>", "Text",
 CellChangeTimes->{{3.6228398100573626`*^9, 3.6228398648914585`*^9}, {
  3.6228414516326456`*^9, 3.6228414565622544`*^9}, {3.6228415244535737`*^9, 
  3.6228415522216225`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveRegionExtension", "[", 
    RowBox[{
     RowBox[{"r", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "}"}]}], ",", 
     RowBox[{"d", ":", "None"}]}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"r", ",", 
     RowBox[{"UpgradeRangeParameters", "[", "0", "]"}], ",", "Absolute"}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveRegionExtension", "[", 
    RowBox[{
     RowBox[{"r", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "}"}]}], ",", 
     RowBox[{"d", ":", "Automatic"}]}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"r", ",", 
     RowBox[{"UpgradeRangeParameters", "[", "0.02", "]"}], ",", "Scaled"}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveRegionExtension", "[", 
    RowBox[{
     RowBox[{"r", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "}"}]}], ",", 
     RowBox[{"d", ":", "RangeParametersPattern"}]}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"r", ",", 
     RowBox[{"TransformRegion", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"CurrentWindow", "[", "]"}], "@", 
        RowBox[{"DeltaTFunction", "[", "]"}]}], ",", 
       RowBox[{"UpgradeRangeParameters", "[", "d", "]"}]}], "]"}], ",", 
     "Absolute"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveRegionExtension", "[", 
    RowBox[{
     RowBox[{"r", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "}"}]}], ",", 
     RowBox[{"Canvas", "[", 
      RowBox[{"d", ":", "RangeParametersPattern"}], "]"}]}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"r", ",", 
     RowBox[{"UpgradeRangeParameters", "[", "d", "]"}], ",", "Absolute"}], 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveRegionExtension", "[", 
    RowBox[{
     RowBox[{"r", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], "}"}]}], ",", 
     RowBox[{"Scaled", "[", 
      RowBox[{"d", ":", "RangeParametersPattern"}], "]"}]}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"r", ",", 
     RowBox[{"UpgradeRangeParameters", "[", "d", "]"}], ",", "Scaled"}], 
    "}"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516286496359375*^9, 3.51628649825*^9}, {
  3.516286544375*^9, 3.51628656809375*^9}, {3.5162866254375*^9, 
  3.516286687359375*^9}, {3.516286803796875*^9, 3.516286875703125*^9}, {
  3.51628823759375*^9, 3.516288243828125*^9}, {3.5181196755625*^9, 
  3.518119676328125*^9}, {3.51811982978125*^9, 3.51811985040625*^9}, {
  3.5181199225625*^9, 3.51811992603125*^9}, {3.566943272207354*^9, 
  3.5669432722373543`*^9}, {3.5830811196371884`*^9, 3.583081141695627*^9}, {
  3.6228396474582767`*^9, 3.6228397313708243`*^9}, {3.622841387235733*^9, 
  3.622841432990613*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["General adjustment of region", "Subsection",
 CellChangeTimes->{{3.58308020895615*^9, 3.583080223167775*^9}}],

Cell["\<\
User-level wrapper
\tReturns result as valid region specification, wrapped in Canvas[]\
\>", "Text",
 CellChangeTimes->{{3.516286908109375*^9, 3.516286915203125*^9}, {
  3.518124271375*^9, 3.518124278109375*^9}, {3.52052866159375*^9, 
  3.52052868296875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FigDeltaRegionPattern", "=", 
   RowBox[{"Automatic", "|", "None", "|", "RangeParametersPattern", "|", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"Scaled", "|", "Canvas"}], ")"}], "[", "RangeParametersPattern",
      "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515782131515625*^9, 3.515782173640625*^9}, {
   3.51578220403125*^9, 3.51578225421875*^9}, {3.51578477109375*^9, 
   3.515784771390625*^9}, 3.515784983671875*^9, {3.51628624659375*^9, 
   3.516286258796875*^9}, {3.516286295140625*^9, 3.51628630284375*^9}, {
   3.516286340328125*^9, 3.516286342234375*^9}, {3.5830810733363075`*^9, 
   3.583081074334709*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "AdjustRegion", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"RegionExtension", "\[Rule]", "None"}], ",", 
     RowBox[{"RegionDisplacement", "\[Rule]", "None"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AdjustRegion", "[", 
    RowBox[{
     RowBox[{"r", ":", "FigRegionPattern"}], ",", 
     RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"FullOptions", "=", 
        RowBox[{"Flatten", "[", 
         RowBox[{"{", 
          RowBox[{"Opts", ",", 
           RowBox[{"Options", "[", "AdjustRegion", "]"}]}], "}"}], "]"}]}], 
       ",", "CanvasRegion"}], "\[IndentingNewLine]", "}"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"validate", " ", "options"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FigCheckOption", "[", 
       RowBox[{
       "AdjustRegion", ",", "RegionDisplacement", ",", 
        "FigDisplacementPattern", ",", "FullOptions"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{
       "AdjustRegion", ",", "RegionExtension", ",", "FigDeltaRegionPattern", 
        ",", "FullOptions"}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "resolve", " ", "given", " ", "region", " ", "to", " ", "canvas", " ", 
        "coordinates"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"CanvasRegion", "=", 
       RowBox[{"FigResolveRegion", "[", "r", "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"do", " ", "displacement"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"CanvasRegion", "=", 
       RowBox[{"CanvasRegion", "+", 
        RowBox[{"FigResolveDisplacement", "[", 
         RowBox[{"(", 
          RowBox[{"RegionDisplacement", "/.", "FullOptions"}], ")"}], 
         "]"}]}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"do", " ", "extension"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"CanvasRegion", "=", 
       RowBox[{"ExtendRegion", "@@", 
        RowBox[{"FigResolveRegionExtension", "[", 
         RowBox[{"CanvasRegion", ",", 
          RowBox[{"(", 
           RowBox[{"RegionExtension", "/.", "FullOptions"}], ")"}]}], 
         "]"}]}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", "return", " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Canvas", "[", "CanvasRegion", "]"}]}]}], "\[IndentingNewLine]",
     "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DeclareFigFallThroughError", "[", "AdjustRegion", "]"}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5830791169805884`*^9, 3.583079133858348*^9}, {
  3.583079202241898*^9, 3.5830793635706263`*^9}, {3.5830795570882845`*^9, 
  3.583079561313526*^9}, {3.583079885104046*^9, 3.5830800708646708`*^9}, {
  3.583081516002678*^9, 3.5830815210726852`*^9}, {3.583081673146535*^9, 
  3.5830816749405384`*^9}, {3.5836974442451077`*^9, 3.5836974601051297`*^9}, {
  3.6228397932249327`*^9, 3.62283980306855*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Region points", "Subsection",
 CellChangeTimes->{{3.51827685290625*^9, 3.518276860484375*^9}}],

Cell["User-level region point extraction", "Text",
 CellChangeTimes->{{3.518276874921875*^9, 3.51827688321875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RegionPoint", "[", 
    RowBox[{
     RowBox[{"r", ":", "FigRegionPattern"}], ",", 
     RowBox[{"Offset", ":", "FigOffsetPattern"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "UsedOffset", ",", "CanvasRegion", ",", "CanvasCenter", ",", 
       "CanvasRadius"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"resolve", " ", "geometry"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"UsedOffset", "=", 
       RowBox[{"FigResolveOffset", "[", "Offset", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"CanvasRegion", "=", 
       RowBox[{"FigResolveRegion", "[", "r", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"CanvasCenter", "=", 
       RowBox[{"Mean", "/@", "CanvasRegion"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"CanvasRadius", "=", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{"Subtract", "@@@", "CanvasRegion"}], ")"}]}], "/", "2"}]}], 
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"return", " ", "offset", " ", "point"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"Canvas", "[", 
       RowBox[{"CanvasCenter", "+", 
        RowBox[{"UsedOffset", "*", "CanvasRadius"}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.518276869859375*^9, 3.518276948953125*^9}, {
  3.518276992453125*^9, 3.518277104421875*^9}, {3.51951058934375*^9, 
  3.51951061803125*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Object set bounding box", "Subsection",
 CellChangeTimes->{{3.51603589645825*^9, 3.516035901380125*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ExtractBoundingBox", "[", 
    RowBox[{
     RowBox[{"Object", "[", 
      RowBox[{"n", ":", 
       RowBox[{"ObjectNamePattern", "[", "FigAnchor", "]"}]}], "]"}], "|", 
     RowBox[{"(", 
      RowBox[{"n", ":", 
       RowBox[{"ObjectNamePattern", "[", "FigAnchor", "]"}]}], ")"}]}], "]"}],
    ":=", 
   RowBox[{"FigPointBoundingBox", "[", 
    RowBox[{
     RowBox[{"Object", "[", "n", "]"}], "@", 
     RowBox[{"GetPoint", "[", "]"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExtractBoundingBox", "[", 
    RowBox[{
     RowBox[{"Object", "[", 
      RowBox[{"n", ":", 
       RowBox[{"ObjectNamePattern", "[", "FigObject", "]"}]}], "]"}], "|", 
     RowBox[{"(", 
      RowBox[{"n", ":", 
       RowBox[{"ObjectNamePattern", "[", "FigObject", "]"}]}], ")"}]}], "]"}],
    ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Object", "[", "n", "]"}], "@", 
     RowBox[{"MakeBoundingBox", "[", "]"}]}], ")"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51603773045825*^9, 3.516037752630125*^9}, {
  3.51603778345825*^9, 3.516037850130125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ObjectCanvasBox", "[", 
    RowBox[{"ObjectList", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"ObjectPattern", "[", "FigAnchor", "]"}], "|", 
         RowBox[{"ObjectNamePattern", "[", "FigAnchor", "]"}], "|", 
         RowBox[{"ObjectPattern", "[", "FigObject", "]"}], "|", 
         RowBox[{"ObjectNamePattern", "[", "FigObject", "]"}]}], ")"}], 
       ".."}], "}"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"RegionList", ",", "ExtremumLists"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"RegionList", "=", 
       RowBox[{"(", 
        RowBox[{"ExtractBoundingBox", "/@", "ObjectList"}], ")"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ExtremumLists", "=", 
       RowBox[{"MapThread", "[", 
        RowBox[{"List", ",", "RegionList", ",", "2"}], "]"}]}], ";", " ", 
      RowBox[{"(*", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"xminlist", ",", "xmaxlist"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"yminlist", ",", "ymaxlist"}], "}"}]}], "}"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"MapAt", "[", 
       RowBox[{"Max", ",", 
        RowBox[{"MapAt", "[", 
         RowBox[{"Min", ",", "ExtremumLists", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"2", ",", "1"}], "}"}]}], "}"}]}], "]"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "2"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"2", ",", "2"}], "}"}]}], "}"}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516037549973875*^9, 3.516037630848875*^9}, {
   3.516037863911375*^9, 3.516037898255125*^9}, {3.51603849195825*^9, 
   3.5160386641145*^9}, {3.516038847942625*^9, 3.516038848848875*^9}, {
   3.516038953223875*^9, 3.516038959161375*^9}, 3.51604321702075*^9, {
   3.516043256630125*^9, 3.51604328527075*^9}}],

Cell["User-level bounding region function", "Text",
 CellChangeTimes->{{3.583082700711568*^9, 3.583082710455468*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"BoundingRegion", "[", "\[IndentingNewLine]", 
    RowBox[{"ObjectList", ":", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"ObjectPattern", "[", "FigAnchor", "]"}], "|", 
         RowBox[{"ObjectNamePattern", "[", "FigAnchor", "]"}], "|", 
         RowBox[{"ObjectPattern", "[", "FigObject", "]"}], "|", 
         RowBox[{"ObjectNamePattern", "[", "FigObject", "]"}]}], ")"}], 
       ".."}], "}"}]}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FigCheckInFigure", "[", "BoundingRegion", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Canvas", "[", 
       RowBox[{"ObjectCanvasBox", "[", "ObjectList", "]"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"BoundingRegion", "[", "\[IndentingNewLine]", 
    RowBox[{"obj", ":", 
     RowBox[{"(", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"ObjectPattern", "[", "FigAnchor", "]"}], "|", 
        RowBox[{"ObjectNamePattern", "[", "FigAnchor", "]"}], "|", 
        RowBox[{"ObjectPattern", "[", "FigObject", "]"}], "|", 
        RowBox[{"ObjectNamePattern", "[", "FigObject", "]"}]}], ")"}], 
      ")"}]}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"BoundingRegion", "[", 
    RowBox[{"{", "obj", "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DeclareFigFallThroughError", "[", "BoundingRegion", "]"}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516037549973875*^9, 3.516037630848875*^9}, {
  3.516037863911375*^9, 3.516037898255125*^9}, {3.51603849195825*^9, 
  3.5160386641145*^9}, {3.516038847942625*^9, 3.516038848848875*^9}, {
  3.516038953223875*^9, 3.516038959161375*^9}, {3.51604318177075*^9, 
  3.516043185630125*^9}, {3.516285789828125*^9, 3.516285817*^9}, {
  3.51827666221875*^9, 3.518276690953125*^9}, {3.518277205515625*^9, 
  3.51827721*^9}, {3.518277416671875*^9, 3.518277417234375*^9}, {
  3.583082644399453*^9, 3.583082692317689*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Edge-type parameter list interpretation", "Section",
 CellChangeTimes->{{3.515342435171875*^9, 3.515342438984375*^9}, {
  3.516037020661375*^9, 3.5160370247395*^9}, {3.516037068927*^9, 
  3.516037072755125*^9}}],

Cell[TextData[{
 "modeled on FrameLabel, etc.\n\ngeneral rules\n\t[B -> {B,B} -- contrary to ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " FrameLabel behavior {B,X}]\n\t\tThis case is usually only reasonable a \
boolean parameter or a style parameter.  \n\t\t\tPattern: \
EdgeXYSameParametersPattern[patt]\n\t\tOther properties are XY properties, \
and a value appropriate to X should never propagate to Y, except perhaps the \
value None.\n\t\t\tPatterns: EdgeXYUniqueParametersPattern[patt]\n\t\tIt is \
up to the *pattern* to exclude other possibilities, such as AxisLabel->\
\[CloseCurlyDoubleQuote]x\[CloseCurlyDoubleQuote].\n\t{B,L} -> {{L,X},{B,X}}  \
  no mirroring\n\t\tor {{L,L},{B,B}}    mirroring\n\t{{L,R},{B,T}} left \
unchanged\nlegacy list format rules\n\t{B} was legitimate legacy case but is \
disallowed in present conversion\n\t{B,L,T} was legitimate legacy case but is \
disallowed in present conversion\n\t{B,L,T,R}->{{L,R},{B,T}}\nwhere X is \
given filler\n\nNo special treatment is imposed on the value None.  For \
instance, it is not translated into Filler."
}], "Text",
 CellChangeTimes->{{3.428181708328125*^9, 3.428181714515625*^9}, {
   3.459546646359375*^9, 3.45954666640625*^9}, {3.461090186078125*^9, 
   3.461090206421875*^9}, {3.461090554328125*^9, 3.461090557796875*^9}, {
   3.46694655503125*^9, 3.466946556640625*^9}, {3.515342181828125*^9, 
   3.51534226246875*^9}, {3.515342351140625*^9, 3.515342395984375*^9}, {
   3.515342455484375*^9, 3.515342456296875*^9}, {3.5153424865625*^9, 
   3.515342722703125*^9}, {3.515343454640625*^9, 3.51534347678125*^9}, {
   3.515343518859375*^9, 3.51534356825*^9}, {3.515352454421875*^9, 
   3.515352461703125*^9}, 3.515352506265625*^9, {3.515353016171875*^9, 
   3.5153530378125*^9}, 3.516037036317625*^9, {3.5163893819375*^9, 
   3.516389413859375*^9}, {3.516389500359375*^9, 3.516389507171875*^9}, {
   3.516389546109375*^9, 3.516389573234375*^9}, {3.516389608390625*^9, 
   3.51638961084375*^9}, {3.516389642671875*^9, 3.516389692671875*^9}, {
   3.516389761671875*^9, 3.51638995615625*^9}, {3.516390130078125*^9, 
   3.5163901309375*^9}, {3.5163909391875*^9, 3.5163909453125*^9}, {
   3.5163911913125*^9, 3.516391221421875*^9}, {3.51639199809375*^9, 
   3.51639202265625*^9}, {3.516461558421875*^9, 3.516461601984375*^9}}],

Cell["\<\
example usage: 
\tEdgeParametersPattern[NonListPattern]) -- includes None as allowable case
\tNone|EdgeParametersPattern[FlatListPattern]\
\>", "Text",
 CellChangeTimes->{{3.51579191709375*^9, 3.515791919203125*^9}, {
  3.515791977453125*^9, 3.51579200184375*^9}, {3.51579204621875*^9, 
  3.51579205353125*^9}, {3.515792145578125*^9, 3.5157921623125*^9}}],

Cell[CellGroupData[{

Cell["Masking of edge options", "Subsection",
 CellChangeTimes->{{3.5163955378125*^9, 3.516395540625*^9}}],

Cell["\<\
EdgeMaskingFunction[DataEntry_,MaskEntry_,ExteriorEdgeMaskEntry_,Filler_] \
masks DataEntry, i.e., returning either DataEntry or Filler.  DataEntry is \
returned if the mask value is True or is Exterior on an exterior edge (as \
indicated by ExteriorEdgeMaskEntry).\
\>", "Text",
 CellChangeTimes->{{3.579102750238942*^9, 3.5791028246354723`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EdgeMaskingFunction", "[", 
    RowBox[{
    "DataEntry_", ",", "MaskEntry_", ",", "ExteriorEdgeMaskEntry_", ",", 
     "Filler_"}], "]"}], ":=", 
   RowBox[{"If", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"MaskEntry", "===", "True"}], ")"}], "||", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"MaskEntry", "===", "Exterior"}], ")"}], "&&", 
        "ExteriorEdgeMaskEntry"}], ")"}]}], ",", "\[IndentingNewLine]", 
     "DataEntry", ",", "\[IndentingNewLine]", "Filler"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5164602644375*^9, 3.51646040815625*^9}, {
  3.516460634953125*^9, 3.516460635828125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MaskEdgeOption", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Data", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}]}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Mask", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Exterior", "|", "LogicalPattern"}], ",", 
          RowBox[{"Exterior", "|", "LogicalPattern"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Exterior", "|", "LogicalPattern"}], ",", 
          RowBox[{"Exterior", "|", "LogicalPattern"}]}], "}"}]}], "}"}]}], 
     ",", 
     RowBox[{"ExteriorEdgeMask", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"LogicalPattern", ",", "LogicalPattern"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"LogicalPattern", ",", "LogicalPattern"}], "}"}]}], "}"}]}], 
     ",", "\[IndentingNewLine]", "Filler_"}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"MapThread", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"EdgeMaskingFunction", "[", 
       RowBox[{"##", ",", "Filler"}], "]"}], "&"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Data", ",", "Mask", ",", "ExteriorEdgeMask"}], "}"}], ",", 
     "\[IndentingNewLine]", "2"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516395320109375*^9, 3.51639548109375*^9}, {
  3.516460135921875*^9, 3.51646021159375*^9}, {3.516460251640625*^9, 
  3.51646026215625*^9}, {3.516460507125*^9, 3.516460513171875*^9}, {
  3.516460636296875*^9, 3.516460643921875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Automatic values for edge options", "Subsection",
 CellChangeTimes->{{3.5163955378125*^9, 3.516395540625*^9}, {
  3.579102839549099*^9, 3.579102845289909*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ResolveAutomaticEdgeOption", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Data", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}]}], "}"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Defaults", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"_", ",", "_"}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]", 
    "]"}], ":=", 
   RowBox[{"MapThread", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"Replace", "[", 
       RowBox[{"#1", ",", 
        RowBox[{"{", 
         RowBox[{"Automatic", "\[Rule]", "#2"}], "}"}]}], "]"}], "&"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Data", ",", "Defaults"}], "}"}], ",", "\[IndentingNewLine]", 
     "2"}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516395320109375*^9, 3.51639548109375*^9}, {
   3.516460135921875*^9, 3.51646021159375*^9}, {3.516460251640625*^9, 
   3.51646026215625*^9}, {3.516460507125*^9, 3.516460513171875*^9}, {
   3.516460636296875*^9, 3.516460643921875*^9}, {3.5791028530431223`*^9, 
   3.5791029554261026`*^9}, 3.5791044306453896`*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ResolveAutomaticEdgeOption", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", "Automatic"}], "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"5", ",", "6"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"7", ",", "8"}], "}"}]}], "}"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.579104379115317*^9, 3.579104394875339*^9}, {
  3.579104437145398*^9, 3.5791044381253996`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "8"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.579104396425341*^9, {3.5791044338453937`*^9, 3.5791044385053997`*^9}}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Single-coordinate geometry", "Section",
 CellChangeTimes->{{3.516047466036375*^9, 3.51604747252075*^9}}],

Cell[CellGroupData[{

Cell["Single-coordinate pattern", "Subsection",
 CellChangeTimes->{{3.51604749777075*^9, 3.51604750070825*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FigCoordinatePattern", "=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"_", "?", "NumericQ"}], ")"}], "|", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"Scaled", "|", "Canvas"}], ")"}], "[", 
      RowBox[{"(", 
       RowBox[{"_", "?", "NumericQ"}], ")"}], "]"}], "|", "FigPointPattern"}],
     ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516047483817625*^9, 3.516047488973875*^9}, {
  3.51604754014575*^9, 3.516047540927*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Complementary coordinate index", "Subsection",
 CellChangeTimes->{{3.51846246559375*^9, 3.518462470828125*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"AntiCoordinateIndex", "[", "1", "]"}], "=", "2"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AntiCoordinateIndex", "[", "2", "]"}], "=", "1"}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.518462472265625*^9, 3.518462495203125*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Interpret Horizontal/Vertical as coordinate indices", "Subsection",
 CellChangeTimes->{{3.516047836130125*^9, 3.51604784989575*^9}, {
  3.5833521853867435`*^9, 3.5833521882167473`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveCoordinateIndex", "[", "Horizontal", "]"}], "=", "1"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveCoordinateIndex", "[", "Vertical", "]"}], "=", "2"}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516046467942625*^9, 3.5160465244895*^9}, 
   3.516047415177*^9, {3.516047556192625*^9, 3.51604755827075*^9}, 
   3.516047601661375*^9, {3.516047804473875*^9, 3.5160478323645*^9}, {
   3.5833521912667513`*^9, 3.5833522121567802`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Conversion of coordinate system for individual coordinate", "Subsection",
 CellChangeTimes->{{3.5160473852395*^9, 3.516047397802*^9}}],

Cell["\<\
must come *after* point geometry, since uses FigPointPattern
can be used eith to convert a single coordinate to canvas coordinates or to \
extract canvas coordinate from a point\
\>", "Text",
 CellChangeTimes->{{3.516293167375*^9, 3.5162931786875*^9}, {
  3.5184615730625*^9, 3.51846158109375*^9}, {3.5184616460625*^9, 
  3.518461646640625*^9}, {3.518461720234375*^9, 3.518461752*^9}}],

Cell["Conversions", "Text",
 CellChangeTimes->{{3.516047858411375*^9, 3.516047864598875*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveCoordinate", "[", 
    RowBox[{
     RowBox[{"x_", "?", "NumericQ"}], ",", 
     RowBox[{"CoordinateIndex", ":", 
      RowBox[{"(", 
       RowBox[{"1", "|", "2"}], ")"}]}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"FigResolvePoint", "[", 
     RowBox[{"x", "*", 
      RowBox[{"UnitVector", "[", "CoordinateIndex", "]"}]}], "]"}], "[", 
    RowBox[{"[", "CoordinateIndex", "]"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveCoordinate", "[", 
    RowBox[{
     RowBox[{"Scaled", "[", 
      RowBox[{"x_", "?", "NumericQ"}], "]"}], ",", 
     RowBox[{"CoordinateIndex", ":", 
      RowBox[{"(", 
       RowBox[{"1", "|", "2"}], ")"}]}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"FigResolvePoint", "[", 
     RowBox[{"Scaled", "[", 
      RowBox[{"x", "*", 
       RowBox[{"UnitVector", "[", "CoordinateIndex", "]"}]}], "]"}], "]"}], 
    "[", 
    RowBox[{"[", "CoordinateIndex", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveCoordinate", "[", 
    RowBox[{
     RowBox[{"Canvas", "[", 
      RowBox[{"x_", "?", "NumericQ"}], "]"}], ",", 
     RowBox[{"CoordinateIndex", ":", 
      RowBox[{"(", 
       RowBox[{"1", "|", "2"}], ")"}]}]}], "]"}], ":=", "x"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveCoordinate", "[", 
    RowBox[{
     RowBox[{"p", ":", "FigPointPattern"}], ",", 
     RowBox[{"CoordinateIndex", ":", 
      RowBox[{"(", 
       RowBox[{"1", "|", "2"}], ")"}]}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"FigResolvePoint", "[", "p", "]"}], "[", 
    RowBox[{"[", "CoordinateIndex", "]"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516046467942625*^9, 3.5160465244895*^9}, 
   3.516047415177*^9, {3.516047556192625*^9, 3.51604755827075*^9}, 
   3.516047601661375*^9, {3.516047804473875*^9, 3.5160478323645*^9}, {
   3.5184621599375*^9, 3.518462185796875*^9}}],

Cell["Interpret Horizontal/Vertical as arguments", "Text",
 CellChangeTimes->{{3.516047836130125*^9, 3.51604784989575*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveCoordinate", "[", 
    RowBox[{"x_", ",", "Horizontal"}], "]"}], ":=", 
   RowBox[{"FigResolveCoordinate", "[", 
    RowBox[{"x", ",", "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveCoordinate", "[", 
    RowBox[{"x_", ",", "Vertical"}], "]"}], ":=", 
   RowBox[{"FigResolveCoordinate", "[", 
    RowBox[{"x", ",", "2"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516046467942625*^9, 3.5160465244895*^9}, 
   3.516047415177*^9, {3.516047556192625*^9, 3.51604755827075*^9}, 
   3.516047601661375*^9, {3.516047804473875*^9, 3.5160478323645*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Conversion of coordinate system for individual coordinate", "Subsection",
 CellChangeTimes->{{3.5160473852395*^9, 3.516047397802*^9}}],

Cell["Conversions", "Text",
 CellChangeTimes->{{3.516047858411375*^9, 3.516047864598875*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveCoordinateDisplacement", "[", 
    RowBox[{
     RowBox[{"x_", "?", "NumericQ"}], ",", 
     RowBox[{"CoordinateIndex", ":", 
      RowBox[{"(", 
       RowBox[{"1", "|", "2"}], ")"}]}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"FigResolveDisplacement", "[", 
     RowBox[{"x", "*", 
      RowBox[{"UnitVector", "[", "CoordinateIndex", "]"}]}], "]"}], "[", 
    RowBox[{"[", "CoordinateIndex", "]"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveCoordinateDisplacement", "[", 
    RowBox[{
     RowBox[{"Scaled", "[", 
      RowBox[{"x_", "?", "NumericQ"}], "]"}], ",", 
     RowBox[{"CoordinateIndex", ":", 
      RowBox[{"(", 
       RowBox[{"1", "|", "2"}], ")"}]}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"FigResolveDisplacement", "[", 
     RowBox[{"Scaled", "[", 
      RowBox[{"x", "*", 
       RowBox[{"UnitVector", "[", "CoordinateIndex", "]"}]}], "]"}], "]"}], 
    "[", 
    RowBox[{"[", "CoordinateIndex", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveCoordinateDisplacement", "[", 
    RowBox[{
     RowBox[{"Canvas", "[", 
      RowBox[{"x_", "?", "NumericQ"}], "]"}], ",", 
     RowBox[{"CoordinateIndex", ":", 
      RowBox[{"(", 
       RowBox[{"1", "|", "2"}], ")"}]}]}], "]"}], ":=", "x"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveCoordinateDisplacement", "[", 
    RowBox[{
     RowBox[{"p", ":", "FigPointPattern"}], ",", 
     RowBox[{"CoordinateIndex", ":", 
      RowBox[{"(", 
       RowBox[{"1", "|", "2"}], ")"}]}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"FigResolveDisplacement", "[", "p", "]"}], "[", 
    RowBox[{"[", "CoordinateIndex", "]"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516046467942625*^9, 3.5160465244895*^9}, 
   3.516047415177*^9, {3.516047556192625*^9, 3.51604755827075*^9}, 
   3.516047601661375*^9, {3.516047804473875*^9, 3.5160478323645*^9}, {
   3.5184621599375*^9, 3.518462185796875*^9}, {3.5775521056959915`*^9, 
   3.5775521493110523`*^9}}],

Cell["Interpret Horizontal/Vertical as arguments", "Text",
 CellChangeTimes->{{3.516047836130125*^9, 3.51604784989575*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveCoordinateDisplacement", "[", 
    RowBox[{"x_", ",", "Horizontal"}], "]"}], ":=", 
   RowBox[{"FigResolveCoordinateDisplacement", "[", 
    RowBox[{"x", ",", "1"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveCoordinateDisplacement", "[", 
    RowBox[{"x_", ",", "Vertical"}], "]"}], ":=", 
   RowBox[{"FigResolveCoordinateDisplacement", "[", 
    RowBox[{"x", ",", "2"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516046467942625*^9, 3.5160465244895*^9}, 
   3.516047415177*^9, {3.516047556192625*^9, 3.51604755827075*^9}, 
   3.516047601661375*^9, {3.516047804473875*^9, 3.5160478323645*^9}, {
   3.577552122316015*^9, 3.5775521265760207`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Point set geometry", "Section",
 CellChangeTimes->{{3.515953547734375*^9, 3.515953550140625*^9}}],

Cell[CellGroupData[{

Cell["Point set pattern", "Subsection",
 CellChangeTimes->{{3.515883408046875*^9, 3.515883414421875*^9}, {
  3.5159535560625*^9, 3.515953556546875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigPointSetPattern", "[", "n_Integer", "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{"Repeated", "[", 
     RowBox[{"FigPointPattern", ",", 
      RowBox[{"{", 
       RowBox[{"n", ",", "Infinity"}], "}"}]}], "]"}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515439472969125*^9, 3.51543948604725*^9}, {
   3.515450698281625*^9, 3.515450701687875*^9}, {3.515530339265625*^9, 
   3.5155303765*^9}, {3.515530557765625*^9, 3.515530569203125*^9}, {
   3.5155975314375*^9, 3.51559754925*^9}, {3.515597792984375*^9, 
   3.51559779728125*^9}, {3.515598279671875*^9, 3.515598286234375*^9}, {
   3.515613950328125*^9, 3.51561395671875*^9}, 3.515615579109375*^9, {
   3.515615903859375*^9, 3.515615912078125*^9}, {3.51561688265625*^9, 
   3.5156168859375*^9}, {3.515685177828125*^9, 3.515685200484375*^9}, {
   3.515883397828125*^9, 3.51588342459375*^9}, {3.515953558234375*^9, 
   3.51595355859375*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Centroid of point set", "Subsection",
 CellChangeTimes->{{3.515605128859375*^9, 3.51560513228125*^9}}],

Cell["\<\
Note: Returns a Canvas point specification, rather than just a canvas \
coordinate pair.  This is so the user can use PointCentroid[] as a point \
specification.\
\>", "Text",
 CellChangeTimes->{{3.515614705796875*^9, 3.515614728171875*^9}, {
  3.515953573375*^9, 3.5159536025625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CentroidPoint", "[", 
    RowBox[{"PointSet", ":", 
     RowBox[{"FigPointSetPattern", "[", "1", "]"}]}], "]"}], ":=", 
   RowBox[{"Canvas", "[", 
    RowBox[{"Mean", "[", 
     RowBox[{"FigResolvePoint", "/@", "PointSet"}], "]"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51560881140625*^9, 3.51560881715625*^9}, {
  3.515608865109375*^9, 3.515608866390625*^9}, {3.5156164674375*^9, 
  3.515616468625*^9}, {3.516035884848875*^9, 3.516035886973875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Bounding box of point set", "Subsection",
 CellChangeTimes->{{3.515166674140625*^9, 3.515166694546875*^9}, {
  3.51545023029725*^9, 3.5154502318285*^9}, {3.515616428796875*^9, 
  3.515616447625*^9}, {3.5240709911875*^9, 3.52407099534375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigPointSetBoundingBox", "[", 
    RowBox[{"PointSet", ":", 
     RowBox[{"FigPointSetPattern", "[", "1", "]"}]}], "]"}], ":=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Min", "[", 
        RowBox[{"First", "/@", "PointSet"}], "]"}], ",", 
       RowBox[{"Max", "[", 
        RowBox[{"First", "/@", "PointSet"}], "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Min", "[", 
        RowBox[{"Last", "/@", "PointSet"}], "]"}], ",", 
       RowBox[{"Max", "[", 
        RowBox[{"Last", "/@", "PointSet"}], "]"}]}], "}"}]}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51516616575*^9, 3.51516620196875*^9}, {
   3.515166363734375*^9, 3.51516642103125*^9}, {3.5151665123125*^9, 
   3.51516652478125*^9}, 3.515167326484375*^9, {3.515167359171875*^9, 
   3.515167378671875*^9}, {3.515167540625*^9, 3.515167556453125*^9}, {
   3.51545042535975*^9, 3.515450461031625*^9}, 3.516039158067625*^9, 
   3.524070974171875*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Rectangle/ellipse geometry", "Section",
 CellChangeTimes->{{3.515612120984375*^9, 3.515612123390625*^9}, {
  3.515615859109375*^9, 3.515615859828125*^9}, {3.515619430953125*^9, 
  3.515619431921875*^9}, {3.515854053390625*^9, 3.515854054609375*^9}, {
  3.5194943288125*^9, 3.519494332171875*^9}}],

Cell[CellGroupData[{

Cell["Radius pattern", "Subsection",
 CellChangeTimes->{{3.515610554171875*^9, 3.51561055915625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FigRadiusPattern", "=", 
   RowBox[{"NonNegativeIntervalParametersPattern", "|", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"Horizontal", "|", "Vertical", "|", "Canvas", "|", "Scaled"}], 
       ")"}], "[", "NonNegativeIntervalParametersPattern", "]"}], ")"}], "|", 
    
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"_", "?", "NonNegative"}], ")"}], "|", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"Scaled", "|", "Canvas"}], ")"}], "[", 
         RowBox[{"(", 
          RowBox[{"_", "?", "NonNegative"}], ")"}], "]"}]}], ")"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"_", "?", "NonNegative"}], ")"}], "|", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"Scaled", "|", "Canvas"}], ")"}], "[", 
         RowBox[{"(", 
          RowBox[{"_", "?", "NonNegative"}], ")"}], "]"}]}], ")"}]}], 
     "\[IndentingNewLine]", "}"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51561057296875*^9, 3.515610592296875*^9}, {
  3.515611154578125*^9, 3.515611156109375*^9}, {3.515611416296875*^9, 
  3.515611429078125*^9}, {3.515612473546875*^9, 3.5156124871875*^9}, {
  3.515612659125*^9, 3.515612676546875*^9}, {3.5775525711766434`*^9, 
  3.577552576796651*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Geometry calculations", "Subsection",
 CellChangeTimes->{{3.519494339390625*^9, 3.519494341953125*^9}}],

Cell["\<\
calculate {CanvasCenter,CanvasRadius,CanvasPivot,RotationAngle} for a rectangle
this function takes care of point resolution for the argumentsbut does no \
option validation\
\>", "Text",
 CellChangeTimes->{{3.5666623228196354`*^9, 3.566662336259654*^9}, {
  3.566662531059927*^9, 3.5666625458299475`*^9}}],

Cell["given center (with option Radius)", "Text",
 CellChangeTimes->{{3.515857538046875*^9, 3.515857549203125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MakeRectangleGeometry", "[", 
    RowBox[{
     RowBox[{"p", ":", "FigPointPattern"}], ",", "FullOptions_List"}], "]"}], 
   ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "Anchor", ",", "UsedAnchorOffset", ",", "UsedPivotOffset", ",", 
       "\[IndentingNewLine]", "CanvasCenter", ",", "CanvasRadius", ",", 
       "CanvasPivot", ",", "RotationAngle"}], "}"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"resolve", " ", "arguments"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Anchor", "=", 
       RowBox[{"FigAnchor", "[", "p", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"CanvasRadius", "=", 
       RowBox[{"FigResolveRadius", "[", 
        RowBox[{"(", 
         RowBox[{"Radius", "/.", "FullOptions"}], ")"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"UsedAnchorOffset", "=", 
       RowBox[{"FigResolveOffset", "[", 
        RowBox[{"(", 
         RowBox[{"AnchorOffset", "/.", "FullOptions"}], ")"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"UsedPivotOffset", "=", 
       RowBox[{"FigResolveOffset", "[", 
        RowBox[{"ResolveOption", "[", 
         RowBox[{"PivotOffset", ",", 
          RowBox[{"{", 
           RowBox[{"Automatic", "\[Rule]", "UsedAnchorOffset"}], "}"}], ",", 
          "FullOptions"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"RotationAngle", "=", 
       RowBox[{"UpgradeScalar", "[", 
        RowBox[{"ResolveOption", "[", 
         RowBox[{"Rotate", ",", 
          RowBox[{"{", 
           RowBox[{"Automatic", "\[Rule]", 
            RowBox[{"AnchorAngle", "[", "Anchor", "]"}]}], "}"}], ",", 
          "FullOptions"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"derived", " ", "geometry"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"CanvasCenter", "=", 
       RowBox[{
        RowBox[{"FigResolvePoint", "[", "Anchor", "]"}], "-", 
        RowBox[{"UsedAnchorOffset", "*", "CanvasRadius"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"CanvasPivot", "=", 
       RowBox[{"CanvasCenter", "+", 
        RowBox[{"UsedPivotOffset", "*", "CanvasRadius"}]}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"combined", " ", "answer"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
       "CanvasCenter", ",", "CanvasRadius", ",", "CanvasPivot", ",", 
        "RotationAngle"}], "}"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51949340609375*^9, 3.51949361109375*^9}, 
   3.519493832640625*^9, {3.51949386959375*^9, 3.519493884828125*^9}, {
   3.5194939371875*^9, 3.5194941966875*^9}, {3.51949431403125*^9, 
   3.51949431565625*^9}, 3.519497099984375*^9}],

Cell["given diametric corners", "Text",
 CellChangeTimes->{{3.5158575525*^9, 3.515857557328125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MakeRectangleGeometry", "[", 
    RowBox[{
     RowBox[{"p1", ":", "FigPointPattern"}], ",", 
     RowBox[{"p2", ":", "FigPointPattern"}], ",", "FullOptions_List"}], "]"}],
    ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "CanvasCorner1", ",", "CanvasCorner2", ",", "CanvasCenter", ",", 
       "CanvasPivot", ",", "CanvasRadius", ",", "RotationAngle", ",", 
       "UsedRoundingRadius"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"generate", " ", "geometry"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"CanvasCorner1", "=", 
       RowBox[{"FigResolvePoint", "[", "p1", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"CanvasCorner2", "=", 
       RowBox[{"FigResolvePoint", "[", "p2", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"CanvasCenter", "=", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"CanvasCorner2", "+", "CanvasCorner1"}], ")"}], "/", "2"}]}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"CanvasRadius", "=", 
       RowBox[{"Abs", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"CanvasCorner2", "-", "CanvasCorner1"}], ")"}], "/", "2"}], 
        "]"}]}], ";", "  ", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "Abs", " ", "allows", " ", "any", " ", "two", " ", "points", " ", 
         "to", " ", "be", " ", "taken"}], ",", " ", 
        RowBox[{
        "not", " ", "just", " ", "lower", " ", "left", " ", "to", " ", 
         "upper", " ", "right"}]}], " ", "*)"}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"invoke", " ", "base", " ", "form"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"MakeRectangleGeometry", " ", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Canvas", "[", "CanvasCenter", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"AnchorOffset", "\[Rule]", "Center"}], ",", 
            RowBox[{"Radius", "\[Rule]", 
             RowBox[{"Canvas", "[", "CanvasRadius", "]"}]}]}], "}"}], ",", 
          "FullOptions"}], "]"}]}], "\[IndentingNewLine]", "]"}]}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51510150784375*^9, 3.51510165284375*^9}, {
   3.5151018264375*^9, 3.515101837625*^9}, {3.515160729234375*^9, 
   3.5151607388125*^9}, {3.515160815109375*^9, 3.515160905421875*^9}, {
   3.515429900281625*^9, 3.5154299283285*^9}, {3.515432005344125*^9, 
   3.51543202310975*^9}, {3.515432080625375*^9, 3.515432260875375*^9}, {
   3.515432559875375*^9, 3.515432618141*^9}, {3.515432654812875*^9, 
   3.515432706531625*^9}, {3.515433020406625*^9, 3.515433023781625*^9}, {
   3.515442053016*^9, 3.5154420783285*^9}, {3.51544252460975*^9, 
   3.515442586281625*^9}, {3.5154469192035*^9, 3.515446929391*^9}, {
   3.5154471764535*^9, 3.515447183094125*^9}, {3.515447219250375*^9, 
   3.515447220250375*^9}, {3.515447301531625*^9, 3.5154473044535*^9}, 
   3.515448155969125*^9, {3.515449235594125*^9, 3.515449253000375*^9}, 
   3.51545048954725*^9, {3.51545052173475*^9, 3.5154505228285*^9}, {
   3.51561162565625*^9, 3.51561168884375*^9}, {3.515613185078125*^9, 
   3.51561321028125*^9}, {3.515618454140625*^9, 3.51561845509375*^9}, {
   3.515618558328125*^9, 3.5156186138125*^9}, {3.515618681625*^9, 
   3.51561873415625*^9}, {3.51561877528125*^9, 3.515618818671875*^9}, {
   3.51561889240625*^9, 3.515618944546875*^9}, {3.515618982953125*^9, 
   3.515619023359375*^9}, {3.515619092859375*^9, 3.515619138140625*^9}, {
   3.515619171359375*^9, 3.515619215109375*^9}, {3.51562323090625*^9, 
   3.515623257734375*^9}, {3.51562330753125*^9, 3.515623308109375*^9}, {
   3.515681444234375*^9, 3.515681508125*^9}, 3.51568187259375*^9, {
   3.515682018390625*^9, 3.51568221309375*^9}, {3.51568226515625*^9, 
   3.5156822661875*^9}, {3.515682919375*^9, 3.5156829705625*^9}, {
   3.51568384184375*^9, 3.515683846484375*^9}, {3.515684146515625*^9, 
   3.51568417878125*^9}, {3.515684224390625*^9, 3.515684240109375*^9}, {
   3.515684273125*^9, 3.515684274734375*^9}, {3.515684459265625*^9, 
   3.515684461609375*^9}, {3.51568454121875*^9, 3.515684560484375*^9}, {
   3.51568461046875*^9, 3.515684631296875*^9}, {3.51568532846875*^9, 
   3.515685330359375*^9}, {3.5156861304375*^9, 3.515686149703125*^9}, 
   3.515686398875*^9, {3.515857189484375*^9, 3.515857194375*^9}, {
   3.515857228125*^9, 3.515857237625*^9}, {3.51585727684375*^9, 
   3.515857366875*^9}, 3.515857417078125*^9, {3.515857447453125*^9, 
   3.5158575215625*^9}, {3.51585999478125*^9, 3.515860005375*^9}, {
   3.51586171846875*^9, 3.515861718828125*^9}, 3.5158652513125*^9, {
   3.5158655109375*^9, 3.51586551628125*^9}, 3.51595888284375*^9, {
   3.516291600171875*^9, 3.5162916071875*^9}, 3.51949437234375*^9, {
   3.51949474809375*^9, 3.519494849203125*^9}, {3.5666623714097033`*^9, 
   3.5666624079497547`*^9}, {3.5666624573398237`*^9, 
   3.5666624854498625`*^9}, {3.566662564779974*^9, 3.5666625688899794`*^9}, {
   3.624758806941062*^9, 3.6247588594050627`*^9}}],

Cell["given region specification", "Text",
 CellChangeTimes->{{3.515857562734375*^9, 3.515857567828125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MakeRectangleGeometry", "[", 
    RowBox[{
     RowBox[{"r", ":", "FigRegionPattern"}], ",", "FullOptions_List"}], "]"}],
    ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "CanvasRegion", ",", "CanvasCorner1", ",", "CanvasCorner2", ",", 
       "CanvasCenter", ",", "CanvasPivot", ",", "CanvasRadius", ",", 
       "RotationAngle", ",", "UsedRoundingRadius"}], "}"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"generate", " ", "geometry"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"CanvasRegion", "=", 
       RowBox[{"FigResolveRegion", "[", "r", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"CanvasCorner1", ",", "CanvasCorner2"}], "}"}], "=", 
       RowBox[{"Transpose", "@", "CanvasRegion"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"CanvasCenter", "=", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"CanvasCorner2", "+", "CanvasCorner1"}], ")"}], "/", "2"}]}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"CanvasRadius", "=", 
       RowBox[{"Abs", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"CanvasCorner2", "-", "CanvasCorner1"}], ")"}], "/", "2"}], 
        "]"}]}], ";", " ", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "Abs", " ", "allows", " ", "any", " ", "two", " ", "points", " ", 
         "to", " ", "be", " ", "taken"}], ",", " ", 
        RowBox[{
        "not", " ", "just", " ", "lower", " ", "left", " ", "to", " ", 
         "upper", " ", "right"}]}], " ", "*)"}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"invoke", " ", "base", " ", "form"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"MakeRectangleGeometry", " ", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Canvas", "[", "CanvasCenter", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"AnchorOffset", "\[Rule]", "Center"}], ",", 
            RowBox[{"Radius", "\[Rule]", 
             RowBox[{"Canvas", "[", "CanvasRadius", "]"}]}]}], "}"}], ",", 
          "FullOptions"}], "]"}]}], "\[IndentingNewLine]", "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51510150784375*^9, 3.51510165284375*^9}, {
   3.5151018264375*^9, 3.515101837625*^9}, {3.515160729234375*^9, 
   3.5151607388125*^9}, {3.515160815109375*^9, 3.515160905421875*^9}, {
   3.515429900281625*^9, 3.5154299283285*^9}, {3.515432005344125*^9, 
   3.51543202310975*^9}, {3.515432080625375*^9, 3.515432260875375*^9}, {
   3.515432559875375*^9, 3.515432618141*^9}, {3.515432654812875*^9, 
   3.515432706531625*^9}, {3.515433020406625*^9, 3.515433023781625*^9}, {
   3.515442053016*^9, 3.5154420783285*^9}, {3.51544252460975*^9, 
   3.515442586281625*^9}, {3.5154469192035*^9, 3.515446929391*^9}, {
   3.5154471764535*^9, 3.515447183094125*^9}, {3.515447219250375*^9, 
   3.515447220250375*^9}, {3.515447301531625*^9, 3.5154473044535*^9}, 
   3.515448155969125*^9, {3.515449235594125*^9, 3.515449253000375*^9}, 
   3.51545048954725*^9, {3.51545052173475*^9, 3.5154505228285*^9}, {
   3.51561162565625*^9, 3.51561168884375*^9}, {3.515613185078125*^9, 
   3.51561321028125*^9}, {3.515618454140625*^9, 3.51561845509375*^9}, {
   3.515618558328125*^9, 3.5156186138125*^9}, {3.515618681625*^9, 
   3.51561873415625*^9}, {3.51561877528125*^9, 3.515618818671875*^9}, {
   3.51561889240625*^9, 3.515618944546875*^9}, {3.515618982953125*^9, 
   3.515619023359375*^9}, {3.515619092859375*^9, 3.515619138140625*^9}, {
   3.515619171359375*^9, 3.515619215109375*^9}, {3.51562323090625*^9, 
   3.515623257734375*^9}, {3.51562330753125*^9, 3.515623308109375*^9}, {
   3.515681444234375*^9, 3.515681508125*^9}, 3.51568187259375*^9, {
   3.515682018390625*^9, 3.51568221309375*^9}, {3.51568226515625*^9, 
   3.5156822661875*^9}, {3.515682919375*^9, 3.5156829705625*^9}, {
   3.51568384184375*^9, 3.515683846484375*^9}, {3.515684146515625*^9, 
   3.51568417878125*^9}, {3.515684224390625*^9, 3.515684240109375*^9}, {
   3.515684273125*^9, 3.515684274734375*^9}, {3.515684459265625*^9, 
   3.515684461609375*^9}, {3.51568454121875*^9, 3.515684560484375*^9}, {
   3.51568461046875*^9, 3.515684631296875*^9}, {3.51568532846875*^9, 
   3.515685330359375*^9}, {3.5156861304375*^9, 3.515686149703125*^9}, 
   3.515686398875*^9, {3.515857189484375*^9, 3.515857194375*^9}, {
   3.515857228125*^9, 3.515857237625*^9}, {3.51585727684375*^9, 
   3.515857366875*^9}, 3.515857417078125*^9, {3.515857447453125*^9, 
   3.5158575215625*^9}, {3.515857619859375*^9, 3.515857621234375*^9}, {
   3.51585765746875*^9, 3.51585769365625*^9}, 3.515860007921875*^9, {
   3.5158617195625*^9, 3.51586172084375*^9}, 3.515865255828125*^9, {
   3.515865521609375*^9, 3.515865535234375*^9}, {3.515865578796875*^9, 
   3.51586557909375*^9}, 3.5159588880625*^9, {3.516287250515625*^9, 
   3.516287251265625*^9}, {3.516291610375*^9, 3.516291614703125*^9}, 
   3.519494373265625*^9, 3.51949488159375*^9, {3.5666624992798824`*^9, 
   3.5666625195499105`*^9}, {3.566662556219962*^9, 3.5666625840300007`*^9}, {
   3.624758850125532*^9, 3.6247588647333674`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Make region given rectangle specification", "Subsection",
 CellChangeTimes->{{3.566663311151019*^9, 3.566663316491027*^9}}],

Cell["\<\
User-level function to convert a rectangle specification to a Canvas region \
specification
For rotated rectangle, circumscribing bounding box is used\
\>", "Text",
 CellChangeTimes->{{3.566663356801083*^9, 3.5666633970411396`*^9}}],

Cell["TODO option resultion and validation", "Text",
 CellChangeTimes->{{3.566663736575616*^9, 3.566663741215622*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
    RowBox[{"RectangleRegion", "[", "Args___", "]"}], ":=", 
    RowBox[{"Canvas", "[", 
     RowBox[{"FigRectangleBoundingBox", "@@", 
      RowBox[{"MakeRectangleGeometry", "[", "Args", "]"}]}], "]"}]}], ";"}], 
  "*)"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5666633238710375`*^9, 3.5666633755211096`*^9}, {
  3.566663408181155*^9, 3.566663420321172*^9}, {3.5666637340006123`*^9, 
  3.566663734625613*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Standard rectangle geometry options", "Subsection",
 CellChangeTimes->{{3.5154308919535*^9, 3.515430894656625*^9}, {
  3.51543111848475*^9, 3.51543111998475*^9}, {3.515681194203125*^9, 
  3.515681195296875*^9}, {3.51949454353125*^9, 3.5194945450625*^9}, {
  3.519557889453125*^9, 3.519557891640625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FigRectangleOptions", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", "geometry", " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Radius", "\[Rule]", "1"}], ",", 
     RowBox[{"AnchorOffset", "\[Rule]", "Center"}], ",", 
     RowBox[{"PivotOffset", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"Rotate", "\[Rule]", "None"}]}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515430903687875*^9, 3.515430989031625*^9}, {
   3.515431026844125*^9, 3.515431030625375*^9}, {3.515431105094125*^9, 
   3.5154311113285*^9}, 3.515609867390625*^9, {3.515610068609375*^9, 
   3.51561007096875*^9}, {3.5156102813125*^9, 3.515610326796875*^9}, {
   3.515611182890625*^9, 3.515611184453125*^9}, {3.51561123521875*^9, 
   3.5156112356875*^9}, {3.5156812055*^9, 3.51568120890625*^9}, {
   3.515681963703125*^9, 3.515681982015625*^9}, {3.519493122078125*^9, 
   3.519493136890625*^9}, {3.519493371640625*^9, 3.519493373203125*^9}, {
   3.519493924953125*^9, 3.519493929265625*^9}, 3.519494362*^9, {
   3.519557624046875*^9, 3.519557624578125*^9}, 3.519557847625*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigCheckRectangleOptions", "[", "Self_Object", "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FigCheckOption", "[", 
       RowBox[{
       "Self", ",", "Radius", ",", "FigRadiusPattern", ",", "FigOptions"}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{
       "Self", ",", "AnchorOffset", ",", "FigOffsetPattern", ",", 
        "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{"Self", ",", "PivotOffset", ",", 
        RowBox[{"Automatic", "|", "FigOffsetPattern"}], ",", "FigOptions"}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{"Self", ",", "Rotate", ",", 
        RowBox[{"Automatic", "|", "ScalarParameterPattern"}], ",", 
        "FigOptions"}], "]"}], ";"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5156100370625*^9, 3.515610074328125*^9}, {
   3.515610247703125*^9, 3.515610278484375*^9}, {3.51561033215625*^9, 
   3.5156103411875*^9}, {3.51561118840625*^9, 3.515611213953125*^9}, {
   3.515681221765625*^9, 3.515681251484375*^9}, {3.515681835359375*^9, 
   3.515681860875*^9}, {3.515681987921875*^9, 3.515681996453125*^9}, {
   3.515708374421875*^9, 3.51570837446875*^9}, {3.51570843621875*^9, 
   3.5157084375*^9}, {3.519493202875*^9, 3.519493243390625*^9}, {
   3.519493366375*^9, 3.519493367765625*^9}, {3.519493918171875*^9, 
   3.51949392159375*^9}, 3.5194943625*^9, 3.51955788621875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["FigResolveRadius", "Subsection",
 CellChangeTimes->{{3.515612142890625*^9, 3.515612146890625*^9}}],

Cell["\<\
closely related to FigResolveDisplacement:
\t-- upgrades single radius argument
\t-- allows for \[OpenCurlyDoubleQuote]vertical\[CloseCurlyDoubleQuote] or \
\[OpenCurlyDoubleQuote]horizontal\[CloseCurlyDoubleQuote] units
\t-- requires nonnegative arguments\
\>", "Text",
 CellChangeTimes->{{3.577552303241268*^9, 3.577552386006384*^9}}],

Cell["User coordinates: None or r or {rx,ry}", "Text",
 CellChangeTimes->{{3.515612317875*^9, 3.515612350390625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveRadius", "[", 
    RowBox[{"r", ":", "NonNegativeIntervalParametersPattern"}], "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"CurrentWindow", "[", "]"}], "@", 
      RowBox[{"DeltaTFunction", "[", "]"}]}], ")"}], "@", 
    RowBox[{"UpgradePairEqual", "[", "r", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515612152828125*^9, 3.515612227046875*^9}, {
   3.51561228878125*^9, 3.515612301140625*^9}, 3.515784134828125*^9}],

Cell["\<\
Horizontal user coordinates: Horizontal[None] or Horizontal[r] or \
Horizontal[{rx,ry}]\
\>", "Text",
 CellChangeTimes->{{3.515612317875*^9, 3.51561238440625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveRadius", "[", 
    RowBox[{"Horizontal", "[", 
     RowBox[{"r", ":", "NonNegativeIntervalParametersPattern"}], "]"}], "]"}],
    ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "LengthUnit", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"LengthUnit", "=", 
       RowBox[{"First", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"CurrentWindow", "[", "]"}], "@", 
           RowBox[{"DeltaTFunction", "[", "]"}]}], ")"}], "@", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"LengthUnit", "*", 
       RowBox[{"UpgradePairEqual", "[", "r", "]"}]}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515612401*^9, 3.51561246034375*^9}, {3.5156125289375*^9,
    3.515612549875*^9}, 3.51578413484375*^9}],

Cell["\<\
Vertical user coordinates: Vertical[None] or Vertical[r] or Vertical[{rx,ry}]\
\
\>", "Text",
 CellChangeTimes->{{3.515612317875*^9, 3.51561238440625*^9}, {
  3.515612588296875*^9, 3.5156125901875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveRadius", "[", 
    RowBox[{"Vertical", "[", 
     RowBox[{"r", ":", "NonNegativeIntervalParametersPattern"}], "]"}], "]"}],
    ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "LengthUnit", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"LengthUnit", "=", 
       RowBox[{"Last", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"CurrentWindow", "[", "]"}], "@", 
           RowBox[{"DeltaTFunction", "[", "]"}]}], ")"}], "@", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"LengthUnit", "*", 
       RowBox[{"UpgradePairEqual", "[", "r", "]"}]}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515612401*^9, 3.51561246034375*^9}, {3.5156125289375*^9,
    3.51561259175*^9}, 3.515784134859375*^9}],

Cell["\<\
Canvas coordinates: Canvas[None] or Canvas[r] or Canvas[{rx,ry}]\
\>", "Text",
 CellChangeTimes->{{3.515612317875*^9, 3.51561238440625*^9}, {
  3.515612588296875*^9, 3.515612626015625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveRadius", "[", 
    RowBox[{"Canvas", "[", 
     RowBox[{"r", ":", "NonNegativeIntervalParametersPattern"}], "]"}], "]"}],
    ":=", 
   RowBox[{"UpgradePairEqual", "[", "r", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515612401*^9, 3.51561246034375*^9}, {3.5156125289375*^9,
   3.51561259175*^9}, {3.51561262853125*^9, 3.515612638796875*^9}}],

Cell["\<\
Scaled coordinates: Scaled[None] or Scaled[r] or Scaled[{rx,ry}]\
\>", "Text",
 CellChangeTimes->{{3.515612317875*^9, 3.51561238440625*^9}, {
  3.515612588296875*^9, 3.515612626015625*^9}, {3.515612721078125*^9, 
  3.515612722625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveRadius", "[", 
    RowBox[{"Scaled", "[", 
     RowBox[{"r", ":", "NonNegativeIntervalParametersPattern"}], "]"}], "]"}],
    ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"CurrentWindow", "[", "]"}], "@", 
      RowBox[{"ScaledDeltaTFunction", "[", "]"}]}], ")"}], "@", 
    RowBox[{"UpgradePairEqual", "[", "r", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515612401*^9, 3.51561246034375*^9}, {3.5156125289375*^9,
    3.51561259175*^9}, {3.51561262853125*^9, 3.515612638796875*^9}, {
   3.5156127235*^9, 3.51561273265625*^9}, {3.515612774234375*^9, 
   3.51561277878125*^9}, 3.515784134890625*^9}],

Cell["Ad hoc treatment of hybrid coordinates", "Text",
 CellChangeTimes->{{3.5365308433125*^9, 3.536530862453125*^9}, 
   3.5775516678053784`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveRadius", "[", "\[IndentingNewLine]", 
    RowBox[{"p", ":", 
     RowBox[{"Except", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], ",", 
         RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", "\[IndentingNewLine]", 
       
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"x", ":", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"_", "?", "NonNegative"}], ")"}], "|", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"Scaled", "|", "Canvas"}], ")"}], "[", 
             RowBox[{"(", 
              RowBox[{"_", "?", "NonNegative"}], ")"}], "]"}]}], ")"}]}], ",",
          "\[IndentingNewLine]", 
         RowBox[{"y", ":", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"_", "?", "NonNegative"}], ")"}], "|", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"Scaled", "|", "Canvas"}], ")"}], "[", 
             RowBox[{"(", 
              RowBox[{"_", "?", "NonNegative"}], ")"}], "]"}]}], ")"}]}]}], 
        "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"FigResolveDisplacement", "[", "p", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.53653087075*^9, 3.536530887890625*^9}, {
   3.536530960421875*^9, 3.536530998171875*^9}, 3.5775516748953886`*^9, {
   3.5775517490554924`*^9, 3.577551751385495*^9}, {3.5775524291664443`*^9, 
   3.577552473066506*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Rectangle \[OpenCurlyDoubleQuote]circumference\[CloseCurlyDoubleQuote] \
points", "Subsection",
 CellChangeTimes->{{3.51585621278125*^9, 3.51585621846875*^9}}],

Cell["used also for circle geometry", "Text",
 CellChangeTimes->{{3.5158562263125*^9, 3.515856232375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RectangleOffsetPoint", "[", 
    RowBox[{
     RowBox[{"CanvasCenter", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasRadius", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasPivot", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"RotationAngle_", "?", "NumericQ"}], ",", 
     RowBox[{"Offset", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}]}], "]"}], ":=", 
   RowBox[{
    RowBox[{"RotationTransform", "[", 
     RowBox[{"RotationAngle", ",", "CanvasPivot"}], "]"}], "@", 
    RowBox[{"(", 
     RowBox[{"CanvasCenter", "+", 
      RowBox[{"CanvasRadius", "*", "Offset"}]}], ")"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51585567546875*^9, 3.515855770515625*^9}, {
   3.51585585721875*^9, 3.515855861734375*^9}, {3.5158563874375*^9, 
   3.515856391078125*^9}, {3.515857048875*^9, 3.515857049875*^9}, 
   3.5158570894375*^9}],

Cell["\<\
segments orientations are in the \[OpenCurlyDoubleQuote]upward\
\[CloseCurlyDoubleQuote] and \[OpenCurlyDoubleQuote]rightward\
\[CloseCurlyDoubleQuote] directions (with respect to the original unrotated \
rectangle)\
\>", "Text",
 CellChangeTimes->{{3.515856289578125*^9, 3.515856317984375*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RectangleSideSegment", "[", 
    RowBox[{
     RowBox[{"CanvasCenter", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasRadius", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasPivot", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"RotationAngle_", "?", "NumericQ"}], ",", 
     RowBox[{"Side", ":", "Left"}]}], "]"}], ":=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"RectangleOffsetPoint", "[", 
      RowBox[{
      "CanvasCenter", ",", "CanvasRadius", ",", "CanvasPivot", ",", 
       "RotationAngle", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", 
         RowBox[{"-", "1"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"RectangleOffsetPoint", "[", 
      RowBox[{
      "CanvasCenter", ",", "CanvasRadius", ",", "CanvasPivot", ",", 
       "RotationAngle", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", 
         RowBox[{"+", "1"}]}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RectangleSideSegment", "[", 
    RowBox[{
     RowBox[{"CanvasCenter", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasRadius", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasPivot", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"RotationAngle_", "?", "NumericQ"}], ",", 
     RowBox[{"Side", ":", "Right"}]}], "]"}], ":=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"RectangleOffsetPoint", "[", 
      RowBox[{
      "CanvasCenter", ",", "CanvasRadius", ",", "CanvasPivot", ",", 
       "RotationAngle", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"+", "1"}], ",", 
         RowBox[{"-", "1"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"RectangleOffsetPoint", "[", 
      RowBox[{
      "CanvasCenter", ",", "CanvasRadius", ",", "CanvasPivot", ",", 
       "RotationAngle", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"+", "1"}], ",", 
         RowBox[{"+", "1"}]}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RectangleSideSegment", "[", 
    RowBox[{
     RowBox[{"CanvasCenter", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasRadius", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasPivot", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"RotationAngle_", "?", "NumericQ"}], ",", 
     RowBox[{"Side", ":", "Bottom"}]}], "]"}], ":=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"RectangleOffsetPoint", "[", 
      RowBox[{
      "CanvasCenter", ",", "CanvasRadius", ",", "CanvasPivot", ",", 
       "RotationAngle", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", 
         RowBox[{"-", "1"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"RectangleOffsetPoint", "[", 
      RowBox[{
      "CanvasCenter", ",", "CanvasRadius", ",", "CanvasPivot", ",", 
       "RotationAngle", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"+", "1"}], ",", 
         RowBox[{"-", "1"}]}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
    "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RectangleSideSegment", "[", 
    RowBox[{
     RowBox[{"CanvasCenter", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasRadius", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasPivot", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"RotationAngle_", "?", "NumericQ"}], ",", 
     RowBox[{"Side", ":", "Top"}]}], "]"}], ":=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"RectangleOffsetPoint", "[", 
      RowBox[{
      "CanvasCenter", ",", "CanvasRadius", ",", "CanvasPivot", ",", 
       "RotationAngle", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"-", "1"}], ",", 
         RowBox[{"+", "1"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"RectangleOffsetPoint", "[", 
      RowBox[{
      "CanvasCenter", ",", "CanvasRadius", ",", "CanvasPivot", ",", 
       "RotationAngle", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"+", "1"}], ",", 
         RowBox[{"+", "1"}]}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
    "}"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51585567546875*^9, 3.515855770515625*^9}, {
  3.51585585721875*^9, 3.515855861734375*^9}, {3.5158562369375*^9, 
  3.515856285171875*^9}, {3.515856320421875*^9, 3.5158564296875*^9}, {
  3.51585708996875*^9, 3.515857093671875*^9}, {3.515864340796875*^9, 
  3.51586434390625*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Rectangle anchors", "Subsection",
 CellChangeTimes->{{3.515619435859375*^9, 3.515619463203125*^9}, {
  3.515854266515625*^9, 3.5158542678125*^9}}],

Cell["A \[OpenCurlyDoubleQuote]rectangle\[CloseCurlyDoubleQuote] here more \
generally means a tilted rectangle", "Text",
 CellChangeTimes->{{3.51561946596875*^9, 3.51561947509375*^9}, {
  3.51585427165625*^9, 3.515854275765625*^9}}],

Cell["\<\
Named points: Center (default), Left/Right, Bottom/Top
\tidentical to circle, sans AngleRange parameter\
\>", "Text",
 CellChangeTimes->{{3.515683659515625*^9, 3.51568367915625*^9}, {
   3.515854295015625*^9, 3.515854314734375*^9}, 3.5665957020770273`*^9, 
   3.5665958654805136`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigRectangleAnchor", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"CanvasCenter", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasRadius", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasPivot", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"RotationAngle_", "?", "NumericQ"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"Name", ":", "NamedPointPattern"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Arg", ":", "None"}]}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"FigAnchor", "[", 
    RowBox[{
     RowBox[{"Canvas", "[", 
      RowBox[{"RectangleOffsetPoint", "[", 
       RowBox[{
       "CanvasCenter", ",", "CanvasRadius", ",", "CanvasPivot", ",", 
        "RotationAngle", ",", 
        RowBox[{"NamedPointOffset", "[", "Name", "]"}]}], "]"}], "]"}], ",", 
     RowBox[{"-", 
      RowBox[{"NamedPointOffset", "[", "Name", "]"}]}], ",", 
     "RotationAngle"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51561947978125*^9, 3.51561955340625*^9}, 
   3.51561961984375*^9, 3.51568066303125*^9, {3.51568074428125*^9, 
   3.5156807529375*^9}, {3.5156833859375*^9, 3.515683449140625*^9}, {
   3.515683529125*^9, 3.51568352978125*^9}, {3.515683574328125*^9, 
   3.51568360171875*^9}, 3.515686652203125*^9, 3.515855486375*^9, {
   3.51585589378125*^9, 3.51585589428125*^9}, {3.515856060390625*^9, 
   3.5158560630625*^9}, 3.515856410328125*^9, {3.51585677471875*^9, 
   3.51585680621875*^9}, {3.515856858390625*^9, 3.515856863640625*^9}, 
   3.51585709596875*^9, 3.518018926578125*^9, {3.51847384828125*^9, 
   3.518473851484375*^9}, {3.519647287125*^9, 3.519647328328125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigRectangleAnchor", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"CanvasCenter", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasRadius", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasPivot", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"RotationAngle_", "?", "NumericQ"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"Name", ":", "Offset"}], ",", "\[IndentingNewLine]", 
     RowBox[{"OffsetValue", ":", "FigOffsetPattern"}]}], 
    "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"FigAnchor", "[", 
    RowBox[{
     RowBox[{"Canvas", "[", 
      RowBox[{"RectangleOffsetPoint", "[", 
       RowBox[{
       "CanvasCenter", ",", "CanvasRadius", ",", "CanvasPivot", ",", 
        "RotationAngle", ",", 
        RowBox[{"FigResolveOffset", "[", "OffsetValue", "]"}]}], "]"}], "]"}],
      ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], ",", "RotationAngle"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51956759509375*^9, 3.51956769671875*^9}, 
   3.519647303921875*^9, {3.51964747875*^9, 3.519647479515625*^9}}],

Cell["\<\
Side interpolations: {Left|Right|Bottom|Top,x}
Note: Simple side points could be absorbed as special case by making x \
default to 0 but are already handled as named points above.
Reference:(Tail|Center|Head):Center,Mode:(Absolute|Scaled):Scaled\
\>", "Text",
 CellChangeTimes->{{3.515683659515625*^9, 3.51568367915625*^9}, {
  3.515854295015625*^9, 3.515854314734375*^9}, {3.515855561890625*^9, 
  3.515855625140625*^9}, {3.515864215734375*^9, 3.51586424396875*^9}, {
  3.51964565225*^9, 3.519645675921875*^9}, {3.51964740409375*^9, 
  3.5196474663125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigRectangleAnchor", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"CanvasCenter", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasRadius", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasPivot", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"RotationAngle_", "?", "NumericQ"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"Name", ":", 
      RowBox[{"(", 
       RowBox[{"Left", "|", "Right", "|", "Bottom", "|", "Top"}], ")"}]}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"x_", "?", "NumericQ"}]}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"FigAnchor", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Canvas", "[", "\[IndentingNewLine]", 
      RowBox[{"InterpolateSegment", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"RectangleSideSegment", "[", 
         RowBox[{
         "CanvasCenter", ",", "CanvasRadius", ",", "CanvasPivot", ",", 
          "RotationAngle", ",", "Name"}], "]"}], ",", "\[IndentingNewLine]", 
        "Center", ",", "Scaled", ",", "x"}], "\[IndentingNewLine]", "]"}], 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"-", 
      RowBox[{"NamedPointOffset", "[", "Name", "]"}]}], ",", 
     "\[IndentingNewLine]", "RotationAngle"}], "\[IndentingNewLine]", "]"}]}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51561947978125*^9, 3.51561955340625*^9}, {
   3.51561962175*^9, 3.515619730953125*^9}, {3.515619773140625*^9, 
   3.515619811484375*^9}, {3.51562215609375*^9, 3.5156221565*^9}, {
   3.51562352409375*^9, 3.51562353096875*^9}, {3.515680635890625*^9, 
   3.515680669921875*^9}, {3.5156807540625*^9, 3.51568075928125*^9}, {
   3.51568342634375*^9, 3.51568345734375*^9}, {3.515683530296875*^9, 
   3.515683533984375*^9}, {3.51568357875*^9, 3.51568360446875*^9}, {
   3.51585429221875*^9, 3.51585434665625*^9}, {3.515855461015625*^9, 
   3.51585546246875*^9}, {3.515855507375*^9, 3.51585551225*^9}, {
   3.51585587759375*^9, 3.51585588034375*^9}, {3.515855985375*^9, 
   3.5158560140625*^9}, {3.515856116921875*^9, 3.515856171609375*^9}, {
   3.5158564421875*^9, 3.515856445046875*^9}, {3.515856475828125*^9, 
   3.51585657578125*^9}, {3.515856889671875*^9, 3.51585690059375*^9}, {
   3.515863975046875*^9, 3.515863983828125*^9}, {3.515864204734375*^9, 
   3.515864207421875*^9}, 3.518018928671875*^9, {3.51964734409375*^9, 
   3.51964734834375*^9}, {3.51964739053125*^9, 3.51964739146875*^9}, {
   3.51964745184375*^9, 3.5196474560625*^9}, {3.52002508840625*^9, 
   3.520025093484375*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Rectangle bounding box", "Subsection",
 CellChangeTimes->{{3.515619435859375*^9, 3.515619463203125*^9}, {
  3.515854266515625*^9, 3.5158542678125*^9}, {3.5158594105625*^9, 
  3.515859412515625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigRectangleBoundingBox", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"CanvasCenter", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasRadius", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasPivot", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"RotationAngle_", "?", "NumericQ"}]}], "\[IndentingNewLine]", 
    "]"}], ":=", 
   RowBox[{"FigPointSetBoundingBox", "[", 
    RowBox[{"Table", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"RectangleOffsetPoint", "[", 
       RowBox[{
       "CanvasCenter", ",", "CanvasRadius", ",", "CanvasPivot", ",", 
        "RotationAngle", ",", "Offset"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"Offset", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", 
            RowBox[{"+", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"+", "1"}], ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"+", "1"}], ",", 
            RowBox[{"+", "1"}]}], "}"}]}], "}"}]}], "}"}]}], 
     "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51585942346875*^9, 3.5158595128125*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Circle anchors", "Subsection",
 CellChangeTimes->{{3.515619435859375*^9, 3.515619463203125*^9}}],

Cell["A \[OpenCurlyDoubleQuote]circle\[CloseCurlyDoubleQuote] here more \
generally means a tilted ellipse", "Text",
 CellChangeTimes->{{3.51561946596875*^9, 3.51561947509375*^9}}],

Cell["Named points: Center (default), Left/Right, Bottom/Top", "Text",
 CellChangeTimes->{{3.515683659515625*^9, 3.51568367915625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigCircleAnchor", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"CanvasCenter", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasRadius", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"AngleRange", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"theta1_", "?", "NumericQ"}], ",", 
        RowBox[{"theta2_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasPivot", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"RotationAngle_", "?", "NumericQ"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"Name", ":", 
      RowBox[{"(", 
       RowBox[{
       "Center", "|", "Left", "|", "Right", "|", "Bottom", "|", "Top"}], 
       ")"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Arg", ":", "None"}]}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"FigAnchor", "[", 
    RowBox[{
     RowBox[{"Canvas", "[", 
      RowBox[{"RectangleOffsetPoint", "[", 
       RowBox[{
       "CanvasCenter", ",", "CanvasRadius", ",", "CanvasPivot", ",", 
        "RotationAngle", ",", 
        RowBox[{"NamedPointOffset", "[", "Name", "]"}]}], "]"}], "]"}], ",", 
     RowBox[{"-", 
      RowBox[{"NamedPointOffset", "[", "Name", "]"}]}], ",", 
     "RotationAngle"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51561947978125*^9, 3.51561955340625*^9}, 
   3.51561961984375*^9, 3.51568066303125*^9, {3.51568074428125*^9, 
   3.5156807529375*^9}, {3.5156833859375*^9, 3.515683449140625*^9}, {
   3.515683529125*^9, 3.51568352978125*^9}, {3.515683574328125*^9, 
   3.51568360171875*^9}, 3.515686652203125*^9, 3.515855486375*^9, {
   3.51585589378125*^9, 3.51585589428125*^9}, {3.515856060390625*^9, 
   3.5158560630625*^9}, 3.515856410328125*^9, {3.51585677471875*^9, 
   3.51585680621875*^9}, 3.5158570951875*^9, 3.518018907359375*^9, {
   3.519647305734375*^9, 3.519647306796875*^9}, {3.519651750765625*^9, 
   3.519651753296875*^9}, 3.5202765048125*^9, 3.566595702638628*^9, 
   3.566595865496114*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigCircleAnchor", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"CanvasCenter", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasRadius", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"AngleRange", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"theta1_", "?", "NumericQ"}], ",", 
        RowBox[{"theta2_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasPivot", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"RotationAngle_", "?", "NumericQ"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"Name", ":", "Offset"}], ",", "\[IndentingNewLine]", 
     RowBox[{"OffsetValue", ":", "FigOffsetPattern"}]}], 
    "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"FigAnchor", "[", 
    RowBox[{
     RowBox[{"Canvas", "[", 
      RowBox[{"RectangleOffsetPoint", "[", 
       RowBox[{
       "CanvasCenter", ",", "CanvasRadius", ",", "CanvasPivot", ",", 
        "RotationAngle", ",", 
        RowBox[{"FigResolveOffset", "[", "OffsetValue", "]"}]}], "]"}], "]"}],
      ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}], ",", "RotationAngle"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51956759509375*^9, 3.519567659296875*^9}, 
   3.519647307984375*^9, 3.566595703106629*^9, 3.566595865496114*^9}],

Cell[TextData[{
 "For a circle, the conventional direction is the \"positive theta\" \
direction from polar coordinates, i.e., CCW.  For instance, this is the \
convention followed by the ordering of the arc angle arguments \
{theta1,theta2} in the ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " Circle and Disk primatives.  However, it is more natural for the text \
baseline to follow the \"negative theta\" tangent, so that the text \"sits on\
\" the outside of the circle.  This is the convention adopted with the \
anchors for Point, for instance.  For the most part, TextRectify renders this \
problem irrelevant.  However, the orientation of the tangent also affect \
arrowheads.  "
}], "Text",
 CellChangeTimes->{{3.51568368459375*^9, 3.515683699953125*^9}, {
  3.51596956909375*^9, 3.5159695745625*^9}, {3.566596935201379*^9, 
  3.566597008631481*^9}}],

Cell["\<\
Curve anchors:
\tNormal/Tangent, t|Scaled[t]\
\>", "Text",
 CellChangeTimes->{{3.51568370453125*^9, 3.51568372775*^9}, {
   3.515683799265625*^9, 3.51568382240625*^9}, {3.51596953903125*^9, 
   3.515969565*^9}, 3.5195646395625*^9, {3.51964578821875*^9, 
   3.519645812046875*^9}, {3.566597123661642*^9, 3.566597125991646*^9}, {
   3.5665971672317033`*^9, 3.5665971689217057`*^9}}],

Cell["\<\
Previously: FigCircle sorted the AngleRange angles to *enforce* a CCW curve.  \
The solution was to use the \"negative theta\" tangent, but still have the \
scaled curve parameter run from 0=Tail to 1=Head going CCW, and then flip the \
tangent used in drawing arrowheads (with \
RotateAnchor[Self@MakeAnchor[Tail,None],Pi],RotateAnchor[Self@MakeAnchor[Head,\
None],Pi]).\
\>", "Text",
 CellChangeTimes->{{3.51568368459375*^9, 3.515683699953125*^9}, {
  3.51596956909375*^9, 3.5159695745625*^9}, {3.566596935201379*^9, 
  3.5665969941814613`*^9}, {3.5665977351724987`*^9, 3.5665977436225104`*^9}}],

Cell["\<\
FigCircleAnchor[
   CanvasCenter : {_?NumericQ, _?NumericQ}, CanvasRadius : {_?NumericQ, \
_?NumericQ}, AngleRange : {theta1_?NumericQ, theta2_?NumericQ}, CanvasPivot : \
{_?NumericQ, _?NumericQ}, RotationAngle_?NumericQ,
   OrthoMode : (Normal | Tangent), Arg : ((t_?NumericQ) | \
Scaled[t_?NumericQ])
   ] := Module[
   {theta, AnchorPoint, TangentAngle, AnchorAngle, AnchorOffset},
   
   theta = Switch[
     Arg,
     _?NumericQ, t, (* literal angle, before rotation *)
     Scaled[_?NumericQ], RescaleInterval[{0, 1}, {theta1, theta2}][t]  (* \
scaled from 0 to 1 on displayed arc *)
     ];
   AnchorPoint = RotationTransform[RotationAngle, CanvasPivot]@(CanvasCenter \
+ CanvasRadius*{Cos[theta], Sin[theta]});
   AnchorOffset = Switch[OrthoMode, Normal, {-1, 0}, Tangent, {0, -1}];
   TangentAngle = VectorArcTan[CanvasRadius*{Sin[theta], -Cos[theta]}] + \
RotationAngle; (* tangent vector in negative theta sense *)
   AnchorAngle = TangentAngle + Switch[OrthoMode, Normal, +Pi/2, Tangent, 0];
   
   FigAnchor[Canvas[AnchorPoint], AnchorOffset, AnchorAngle]
   ];\
\>", "Program",
 CellChangeTimes->{{3.51562248925*^9, 3.515622550609375*^9}, {
   3.51562259421875*^9, 3.515622770515625*^9}, {3.515622819828125*^9, 
   3.51562290796875*^9}, {3.515623667421875*^9, 3.515623667875*^9}, {
   3.51562374040625*^9, 3.5156238078125*^9}, 3.515623878640625*^9, {
   3.515623915140625*^9, 3.515623923640625*^9}, 3.515624255578125*^9, 
   3.515624289046875*^9, 3.515624322640625*^9, {3.515680598203125*^9, 
   3.515680612328125*^9}, 3.515680671671875*^9, {3.5156808*^9, 
   3.515680806640625*^9}, {3.515683432125*^9, 3.51568353646875*^9}, {
   3.51568358396875*^9, 3.51568360671875*^9}, {3.515683790921875*^9, 
   3.515683817*^9}, {3.515855906578125*^9, 3.515855910234375*^9}, 
   3.5180189155*^9, 3.519564636328125*^9, 3.519565432015625*^9, {
   3.519645741390625*^9, 3.51964577971875*^9}, {3.519645824046875*^9, 
   3.519645841515625*^9}, 3.5665957046978316`*^9, 3.566595865511714*^9, 
   3.583516245635868*^9}],

Cell["\<\
Revised: FigCircle leaves the angles unsorted, so curve sense can be either \
way.  The d(theta) for the tangent is in the same sense as the delta(theta) \
of the angles.  The scaled curve parameter runs from 0=Tail to 1=Head.\
\>", "Text",
 CellChangeTimes->{{3.51568368459375*^9, 3.515683699953125*^9}, {
   3.51596956909375*^9, 3.5159695745625*^9}, {3.566596935201379*^9, 
   3.5665969941814613`*^9}, {3.56659702876151*^9, 3.5665970707915688`*^9}, {
   3.5665974743421335`*^9, 3.566597481462143*^9}, {3.584015739599758*^9, 
   3.584015825337509*^9}, 3.5840158901400228`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FigCircleAnchor", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"CanvasCenter", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasRadius", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"AngleRange", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"theta1_", "?", "NumericQ"}], ",", 
        RowBox[{"theta2_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasPivot", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"RotationAngle_", "?", "NumericQ"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"OrthoMode", ":", 
      RowBox[{"(", 
       RowBox[{"Normal", "|", "Tangent"}], ")"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Arg", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"t_", "?", "NumericQ"}], ")"}], "|", 
        RowBox[{"{", 
         RowBox[{"\"\<Angle\>\"", ",", 
          RowBox[{"t_", "?", "NumericQ"}]}], "}"}]}], ")"}]}]}], 
    "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "theta", ",", "AnchorPoint", ",", "TangentAngle", ",", "AnchorAngle", 
       ",", "AnchorOffset", ",", "ArcSense"}], "}"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"arc", " ", 
       RowBox[{"sense", ":", " ", 
        RowBox[{
         RowBox[{
          RowBox[{"+", "1"}], " ", "for", " ", "CCW", " ", "or"}], " ", "-", 
         RowBox[{"1", " ", "for", " ", "CW"}]}]}]}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"ArcSense", "=", 
       RowBox[{"Sign", "[", 
        RowBox[{"theta2", "-", "theta1"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"theta", "=", 
       RowBox[{"Switch", "[", "\[IndentingNewLine]", 
        RowBox[{"Arg", ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"\"\<Angle\>\"", ",", 
           RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", "t", ",", " ", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{"literal", " ", "angle"}], ",", " ", 
           RowBox[{"before", " ", "rotation"}]}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"_", "?", "NumericQ"}], ",", 
         RowBox[{
          RowBox[{"RescaleInterval", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"0", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"theta1", ",", "theta2"}], "}"}]}], "]"}], "[", "t", 
          "]"}]}], "  ", 
        RowBox[{"(*", " ", 
         RowBox[{
         "scaled", " ", "from", " ", "0", " ", "to", " ", "1", " ", "on", " ",
           "displayed", " ", "arc"}], " ", "*)"}], "\[IndentingNewLine]", 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"AnchorPoint", "=", 
       RowBox[{
        RowBox[{"RotationTransform", "[", 
         RowBox[{"RotationAngle", ",", "CanvasPivot"}], "]"}], "@", 
        RowBox[{"(", 
         RowBox[{"CanvasCenter", "+", 
          RowBox[{"CanvasRadius", "*", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Cos", "[", "theta", "]"}], ",", 
             RowBox[{"Sin", "[", "theta", "]"}]}], "}"}]}]}], ")"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"AnchorOffset", "=", 
       RowBox[{
        RowBox[{"Switch", "[", 
         RowBox[{"OrthoMode", ",", "Normal", ",", 
          RowBox[{"{", 
           RowBox[{"1", ",", "0"}], "}"}], ",", "Tangent", ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1"}], "}"}]}], "]"}], "*", "ArcSense"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "trig", " ", "gives", " ", "tangent", " ", "vector", " ", "in", " ", 
         "negative", " ", "theta", " ", 
         RowBox[{"sense", " ", "--"}], " ", "for", " ", "arc", " ", 
         "tangent"}], ",", " ", 
        RowBox[{
         RowBox[{
         "this", " ", "must", " ", "be", " ", "flipped", " ", "if", " ", 
          "delta", " ", "theta", " ", "is", " ", "positive"}], ";", " ", 
         RowBox[{"for", " ", "outward", " ", "normal"}]}], ",", " ", 
        RowBox[{"this", " ", "must", " ", "have", " ", 
         RowBox[{"Pi", "/", "2"}], " ", "added"}]}], "  ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"TangentAngle", "=", 
       RowBox[{
        RowBox[{"VectorArcTan", "[", 
         RowBox[{"CanvasRadius", "*", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Sin", "[", "theta", "]"}], ",", 
            RowBox[{"-", 
             RowBox[{"Cos", "[", "theta", "]"}]}]}], "}"}]}], "]"}], "+", 
        "RotationAngle"}]}], ";", " ", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
        "trig", " ", "gives", " ", "tangent", " ", "vector", " ", "in", " ", 
         "negative", " ", "theta", " ", "sense"}], ",", " ", 
        RowBox[{"which", " ", "y"}]}], "  ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"AnchorAngle", "=", 
       RowBox[{"TangentAngle", "+", 
        RowBox[{"Switch", "[", 
         RowBox[{"OrthoMode", ",", "Normal", ",", 
          RowBox[{
           RowBox[{"+", "Pi"}], "/", "2"}], ",", "Tangent", ",", 
          RowBox[{"Switch", "[", 
           RowBox[{"ArcSense", ",", 
            RowBox[{"+", "1"}], ",", "Pi", ",", 
            RowBox[{
             RowBox[{"-", "1"}], "|", "0"}], ",", "0"}], "]"}]}], "]"}]}]}], 
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"FigAnchor", "[", 
       RowBox[{
        RowBox[{"Canvas", "[", "AnchorPoint", "]"}], ",", "AnchorOffset", ",",
         "AnchorAngle"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigCircleAnchor", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"CanvasCenter", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasRadius", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"AngleRange", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"theta1_", "?", "NumericQ"}], ",", 
        RowBox[{"theta2_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasPivot", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"RotationAngle_", "?", "NumericQ"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"OrthoMode", ":", 
      RowBox[{"(", 
       RowBox[{"Normal", "|", "Tangent"}], ")"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Arg", ":", "None"}]}], "]"}], ":=", 
   RowBox[{"FigCircleAnchor", "[", 
    RowBox[{
    "CanvasCenter", ",", "CanvasRadius", ",", "AngleRange", ",", 
     "CanvasPivot", ",", "RotationAngle", ",", "\[IndentingNewLine]", 
     "OrthoMode", ",", "0.5"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51562248925*^9, 3.515622550609375*^9}, {
   3.51562259421875*^9, 3.515622770515625*^9}, {3.515622819828125*^9, 
   3.51562290796875*^9}, {3.515623667421875*^9, 3.515623667875*^9}, {
   3.51562374040625*^9, 3.5156238078125*^9}, 3.515623878640625*^9, {
   3.515623915140625*^9, 3.515623923640625*^9}, 3.515624255578125*^9, 
   3.515624289046875*^9, 3.515624322640625*^9, {3.515680598203125*^9, 
   3.515680612328125*^9}, 3.515680671671875*^9, {3.5156808*^9, 
   3.515680806640625*^9}, {3.515683432125*^9, 3.51568353646875*^9}, {
   3.51568358396875*^9, 3.51568360671875*^9}, {3.515683790921875*^9, 
   3.515683817*^9}, {3.515855906578125*^9, 3.515855910234375*^9}, 
   3.5180189155*^9, 3.519564636328125*^9, 3.519565432015625*^9, {
   3.519645741390625*^9, 3.51964577971875*^9}, {3.519645824046875*^9, 
   3.519645841515625*^9}, 3.5665957046978316`*^9, 3.566595865511714*^9, {
   3.5665973726719913`*^9, 3.5665974943121614`*^9}, {3.56659753637222*^9, 
   3.5665975511922407`*^9}, 3.566597867942684*^9, {3.5665979308827724`*^9, 
   3.566597934757778*^9}, {3.56659813875869*^9, 3.5665981489767084`*^9}, {
   3.5665993598066673`*^9, 3.566599415370021*^9}, {3.5835189416845284`*^9, 
   3.5835189595465593`*^9}, {3.5835189946310205`*^9, 3.583519007329443*^9}, {
   3.5835191977785077`*^9, 3.5835192222705507`*^9}, {3.5840161439056683`*^9, 
   3.5840162685678873`*^9}, {3.5840163089095583`*^9, 3.5840163956301107`*^9}}],

Cell["Head/Tail anchors -- tangent at endpoint of arc", "Text",
 CellChangeTimes->{{3.5665971736917124`*^9, 3.566597184201727*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FigCircleAnchor", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"CanvasCenter", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasRadius", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"AngleRange", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"theta1_", "?", "NumericQ"}], ",", 
        RowBox[{"theta2_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasPivot", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"RotationAngle_", "?", "NumericQ"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"Name", ":", "Tail"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Arg", ":", "None"}]}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"FigCircleAnchor", "[", 
    RowBox[{
    "CanvasCenter", ",", "CanvasRadius", ",", "AngleRange", ",", 
     "CanvasPivot", ",", "RotationAngle", ",", "Tangent", ",", "0"}], "]"}]}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigCircleAnchor", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"CanvasCenter", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasRadius", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"AngleRange", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"theta1_", "?", "NumericQ"}], ",", 
        RowBox[{"theta2_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasPivot", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"RotationAngle_", "?", "NumericQ"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"Name", ":", "Head"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Arg", ":", "None"}]}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"FigCircleAnchor", "[", 
    RowBox[{
    "CanvasCenter", ",", "CanvasRadius", ",", "AngleRange", ",", 
     "CanvasPivot", ",", "RotationAngle", ",", "Tangent", ",", "1"}], "]"}]}],
   ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515683625984375*^9, 3.515683646890625*^9}, {
  3.515683810796875*^9, 3.515683811484375*^9}, {3.515855497171875*^9, 
  3.515855498296875*^9}, {3.515855899234375*^9, 3.51585590309375*^9}, {
  3.519647308984375*^9, 3.51964730965625*^9}, {3.519651832625*^9, 
  3.519651837796875*^9}, {3.520277971359375*^9, 3.520277976140625*^9}, {
  3.5665957034654293`*^9, 3.5665957044170313`*^9}, {3.566595865511714*^9, 
  3.566595865511714*^9}, {3.5665970146014895`*^9, 3.5665970159614916`*^9}, {
  3.5835269632193575`*^9, 3.583526965619361*^9}}],

Cell["\<\
Bounding radii
\tdefault text offset chosen to put labels outside if arc is in CCW \
(positive) sense\
\>", "Text",
 CellChangeTimes->{{3.5767712565270863`*^9, 3.576771257542088*^9}, {
   3.576771409782301*^9, 3.5767714113873034`*^9}, 3.576771869080945*^9, {
   3.5767731940498266`*^9, 3.576773217232682*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FigCircleAnchor", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"CanvasCenter", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasRadius", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"AngleRange", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"theta1_", "?", "NumericQ"}], ",", 
        RowBox[{"theta2_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasPivot", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"RotationAngle_", "?", "NumericQ"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"Name", ":", 
      RowBox[{"(", 
       RowBox[{"HeadRadius", "|", "TailRadius"}], ")"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Arg", ":", 
      RowBox[{"(", 
       RowBox[{"p_", "?", "NumericQ"}], ")"}]}]}], "\[IndentingNewLine]", 
    "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"CenterPoint", ",", "EndPoint"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"CenterPoint", "=", 
       RowBox[{"FigResolvePoint", "[", 
        RowBox[{"FigCircleAnchor", "[", 
         RowBox[{
         "CanvasCenter", ",", "CanvasRadius", ",", "AngleRange", ",", 
          "CanvasPivot", ",", "RotationAngle", ",", "Center", ",", "None"}], 
         "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"EndPoint", "=", 
       RowBox[{"FigResolvePoint", "[", 
        RowBox[{"FigCircleAnchor", "[", 
         RowBox[{
         "CanvasCenter", ",", "CanvasRadius", ",", "AngleRange", ",", 
          "CanvasPivot", ",", "RotationAngle", ",", 
          RowBox[{"Switch", "[", 
           RowBox[{
           "Name", ",", "HeadRadius", ",", "Head", ",", "TailRadius", ",", 
            "Tail"}], "]"}], ",", "None"}], "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"FigCurveAnchorFromPoints", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"CenterPoint", ",", "EndPoint"}], "}"}], ",", 
        RowBox[{"Switch", "[", 
         RowBox[{
         "Name", ",", "HeadRadius", ",", "Left", ",", "TailRadius", ",", 
          "Right"}], "]"}], ",", "p"}], "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigCircleAnchor", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"CanvasCenter", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasRadius", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"AngleRange", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"theta1_", "?", "NumericQ"}], ",", 
        RowBox[{"theta2_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasPivot", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"RotationAngle_", "?", "NumericQ"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"Name", ":", 
      RowBox[{"(", 
       RowBox[{"HeadRadius", "|", "TailRadius"}], ")"}]}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Arg", ":", "None"}]}], "]"}], ":=", 
   RowBox[{"FigCircleAnchor", "[", 
    RowBox[{
    "CanvasCenter", ",", "CanvasRadius", ",", "AngleRange", ",", 
     "CanvasPivot", ",", "RotationAngle", ",", "\[IndentingNewLine]", "Name", 
     ",", "0.5"}], "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51561947978125*^9, 3.51561955340625*^9}, 
   3.51561961984375*^9, 3.51568066303125*^9, {3.51568074428125*^9, 
   3.5156807529375*^9}, {3.5156833859375*^9, 3.515683449140625*^9}, {
   3.515683529125*^9, 3.51568352978125*^9}, {3.515683574328125*^9, 
   3.51568360171875*^9}, 3.515686652203125*^9, 3.515855486375*^9, {
   3.51585589378125*^9, 3.51585589428125*^9}, {3.515856060390625*^9, 
   3.5158560630625*^9}, 3.515856410328125*^9, {3.51585677471875*^9, 
   3.51585680621875*^9}, 3.5158570951875*^9, 3.518018907359375*^9, {
   3.519647305734375*^9, 3.519647306796875*^9}, {3.519651750765625*^9, 
   3.519651753296875*^9}, 3.5202765048125*^9, 3.566595702638628*^9, 
   3.566595865496114*^9, {3.5767713637272367`*^9, 3.576771460347372*^9}, {
   3.5767715066124363`*^9, 3.5767715190674543`*^9}, {3.576771807910859*^9, 
   3.576771942791048*^9}, {3.5767730199921527`*^9, 3.5767730241197166`*^9}, {
   3.5767731004908895`*^9, 3.5767731037684393`*^9}, {3.5767731912397833`*^9, 
   3.576773191564788*^9}, {3.5767732407155433`*^9, 3.5767732522657204`*^9}, {
   3.576773359907374*^9, 3.57677337270757*^9}, {3.576773476491665*^9, 
   3.576773513160978*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Circle bounding box", "Subsection",
 CellChangeTimes->{{3.515619435859375*^9, 3.515619463203125*^9}, {
  3.515854266515625*^9, 3.5158542678125*^9}, {3.5158594105625*^9, 
  3.515859412515625*^9}, {3.515860078078125*^9, 3.515860079015625*^9}}],

Cell["\<\
currently just calculated as bounding box of principal axis end points
\t-- works for nonrotated ellipse
\t-- will underestimage bounding box for tilted ellipse
\t-- neglects possible restriction to arc\
\>", "Text",
 CellChangeTimes->{{3.51586008065625*^9, 3.5158601953125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigCircleBoundingBox", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"CanvasCenter", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasRadius", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"AngleRange", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"theta1_", "?", "NumericQ"}], ",", 
        RowBox[{"theta2_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"CanvasPivot", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ",", 
        RowBox[{"_", "?", "NumericQ"}]}], "}"}]}], ",", 
     RowBox[{"RotationAngle_", "?", "NumericQ"}]}], "\[IndentingNewLine]", 
    "]"}], ":=", 
   RowBox[{"FigPointSetBoundingBox", "[", 
    RowBox[{"Table", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"RectangleOffsetPoint", "[", 
       RowBox[{
       "CanvasCenter", ",", "CanvasRadius", ",", "CanvasPivot", ",", 
        "RotationAngle", ",", "Offset"}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"Offset", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"-", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"+", "1"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"+", "1"}], ",", "0"}], "}"}]}], "}"}]}], "}"}]}], 
     "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51585942346875*^9, 3.5158595128125*^9}, 
   3.5158601023125*^9, {3.515860177234375*^9, 3.51586020246875*^9}, 
   3.566595704978632*^9, 3.5665958655273137`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Anchor manipulation and retrieval", "Section",
 CellChangeTimes->{{3.516036002505125*^9, 3.516036006911375*^9}, {
   3.516039281380125*^9, 3.51603928558325*^9}, 3.519492527984375*^9, {
   3.566665386039364*^9, 3.566665401733261*^9}, {3.625170085020852*^9, 
   3.625170088624459*^9}}],

Cell[CellGroupData[{

Cell["Anchor translation (displacement)", "Subsection",
 CellChangeTimes->{{3.51595657415625*^9, 3.51595657834375*^9}, {
  3.51603597177075*^9, 3.516035974786375*^9}}],

Cell["\<\
\tNote: These functions return an anchor *object*, not an anchor name.
\tThese definitions must come after all relevant argument patterns have been \
defined above.\
\>", "Text",
 CellChangeTimes->{{3.515614705796875*^9, 3.51561471359375*^9}, {
   3.51595655615625*^9, 3.51595657075*^9}, {3.51603599058325*^9, 
   3.516035997661375*^9}, {3.516285088953125*^9, 3.516285121140625*^9}, {
   3.516285172265625*^9, 3.5162852559375*^9}, {3.516285722578125*^9, 
   3.5162857229375*^9}, 3.518105071890625*^9, {3.518200813046875*^9, 
   3.5182008155*^9}, {3.625169911673348*^9, 3.62516991273415*^9}, {
   3.6251700170359335`*^9, 3.625170039999173*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"DisplacePoint", "[", 
    RowBox[{
     RowBox[{"p", ":", "FigPointPattern"}], ",", 
     RowBox[{"Args", ":", 
      RowBox[{"FigDisplacementSequencePattern", "[", "0", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", "CanvasPoint"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FigCheckInFigure", "[", "DisplacePoint", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"a", "=", 
       RowBox[{"FigAnchor", "[", "p", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"CanvasPoint", "=", 
       RowBox[{
        RowBox[{"a", "@", 
         RowBox[{"GetPoint", "[", "]"}]}], "+", 
        RowBox[{"Plus", "@@", 
         RowBox[{"(", 
          RowBox[{"FigResolveDisplacement", "/@", 
           RowBox[{"{", "Args", "}"}]}], ")"}]}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"FigAnchor", "[", 
       RowBox[{
        RowBox[{"Canvas", "[", "CanvasPoint", "]"}], ",", 
        RowBox[{"a", "@", 
         RowBox[{"GetOffset", "[", "]"}]}], ",", 
        RowBox[{"a", "@", 
         RowBox[{"GetAngle", "[", "]"}]}]}], "]"}]}]}], "\[IndentingNewLine]",
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DeclareFigFallThroughError", "[", "DisplacePoint", "]"}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515614060921875*^9, 3.515614136234375*^9}, {
   3.51561417790625*^9, 3.515614185953125*^9}, {3.515614559984375*^9, 
   3.51561470015625*^9}, {3.515615311875*^9, 3.515615339796875*^9}, {
   3.515616562359375*^9, 3.51561656303125*^9}, 3.515618218171875*^9, {
   3.515861009296875*^9, 3.515861025171875*^9}, {3.515861290765625*^9, 
   3.515861293328125*^9}, 3.51586143853125*^9, 3.516283558390625*^9, {
   3.516284480625*^9, 3.516284488890625*^9}, 3.516284603328125*^9, {
   3.51628507803125*^9, 3.516285083796875*^9}, {3.5162857265625*^9, 
   3.516285736234375*^9}, {3.5162880086875*^9, 3.516288009328125*^9}, 
   3.51801887934375*^9, 3.51810507484375*^9, {3.625164428242117*^9, 
   3.6251644282577167`*^9}, {3.6251673547790565`*^9, 
   3.6251673708158855`*^9}, {3.6251687134498434`*^9, 3.625168718488652*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ProjectPoint", "[", 
    RowBox[{
     RowBox[{"p", ":", "FigPointPattern"}], ",", 
     RowBox[{"CoordinateIndexName", ":", 
      RowBox[{"(", 
       RowBox[{"Horizontal", "|", "Vertical"}], ")"}]}], ",", 
     RowBox[{"x", ":", "FigCoordinatePattern"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"CoordinateIndex", ",", "xc", ",", "a", ",", "CanvasPoint"}], 
      "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FigCheckInFigure", "[", "ProjectPoint", "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"resolve", " ", "coordinate"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"CoordinateIndex", "=", 
       RowBox[{
       "FigResolveCoordinateIndex", "[", "CoordinateIndexName", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"xc", "=", 
       RowBox[{"FigResolveCoordinate", "[", 
        RowBox[{"x", ",", "CoordinateIndex"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"substitute", " ", "coordinate"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"a", "=", 
       RowBox[{"FigAnchor", "[", "p", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"CanvasPoint", "=", 
       RowBox[{"ReplacePart", "[", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"a", "@", 
           RowBox[{"GetPoint", "[", "]"}]}], ")"}], ",", 
         RowBox[{"CoordinateIndex", "\[Rule]", "xc"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"FigAnchor", "[", 
       RowBox[{
        RowBox[{"Canvas", "[", "CanvasPoint", "]"}], ",", 
        RowBox[{"a", "@", 
         RowBox[{"GetOffset", "[", "]"}]}], ",", 
        RowBox[{"a", "@", 
         RowBox[{"GetAngle", "[", "]"}]}]}], "]"}]}]}], "\[IndentingNewLine]",
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DeclareFigFallThroughError", "[", "ProjectPoint", "]"}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515614060921875*^9, 3.515614136234375*^9}, {
   3.51561417790625*^9, 3.515614185953125*^9}, {3.515614559984375*^9, 
   3.51561470015625*^9}, {3.515615311875*^9, 3.515615339796875*^9}, {
   3.515616562359375*^9, 3.51561656303125*^9}, 3.515618218171875*^9, {
   3.515861009296875*^9, 3.515861025171875*^9}, {3.515861290765625*^9, 
   3.515861293328125*^9}, 3.51586143853125*^9, 3.516283558390625*^9, {
   3.516284480625*^9, 3.516284488890625*^9}, 3.516284603328125*^9, {
   3.51628507803125*^9, 3.516285083796875*^9}, {3.5162857265625*^9, 
   3.516285736234375*^9}, {3.5162880086875*^9, 3.516288009328125*^9}, 
   3.51801887934375*^9, 3.51810507484375*^9, {3.625164428242117*^9, 
   3.6251644282577167`*^9}, {3.625166974029188*^9, 3.6251670039968405`*^9}, 
   3.625167098985408*^9, {3.625167163787922*^9, 3.625167340895033*^9}, {
   3.625167407397949*^9, 3.625167412514758*^9}, {3.6251687219674587`*^9, 
   3.625168727630268*^9}, 3.6251687709359446`*^9, {3.62534276399308*^9, 
   3.6253427669414854`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DisplaceAlongAnchor", "[", 
     RowBox[{
      RowBox[{"p", ":", "FigPointPattern"}], ",", 
      RowBox[{"d_", "?", "NumericQ"}]}], "]"}], "/;", 
    RowBox[{"(", "SciDraw`Private`$InFigure", ")"}]}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", "theta", ",", "CanvasPoint"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FigCheckInFigure", "[", "DisplacePoint", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"a", "=", 
       RowBox[{"FigAnchor", "[", "p", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"theta", "=", 
       RowBox[{"a", "@", 
        RowBox[{"GetAngle", "[", "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"CanvasPoint", "=", 
       RowBox[{
        RowBox[{"a", "@", 
         RowBox[{"GetPoint", "[", "]"}]}], "+", 
        RowBox[{"d", "*", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Cos", "[", "theta", "]"}], ",", 
           RowBox[{"Sin", "[", "theta", "]"}]}], "}"}]}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"FigAnchor", "[", 
       RowBox[{
        RowBox[{"Canvas", "[", "CanvasPoint", "]"}], ",", 
        RowBox[{"a", "@", 
         RowBox[{"GetOffset", "[", "]"}]}], ",", 
        RowBox[{"a", "@", 
         RowBox[{"GetAngle", "[", "]"}]}]}], "]"}]}]}], "\[IndentingNewLine]",
     "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DeclareFigFallThroughError", "[", "DisplaceAlongAnchor", "]"}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515614060921875*^9, 3.515614136234375*^9}, {
   3.51561417790625*^9, 3.515614185953125*^9}, {3.515614559984375*^9, 
   3.51561470015625*^9}, {3.515615311875*^9, 3.515615339796875*^9}, {
   3.515616562359375*^9, 3.51561656303125*^9}, 3.515618218171875*^9, {
   3.515861009296875*^9, 3.515861025171875*^9}, {3.515861290765625*^9, 
   3.515861293328125*^9}, 3.51586143853125*^9, {3.516036046130125*^9, 
   3.516036154380125*^9}, 3.51628355946875*^9, 3.51628512365625*^9, {
   3.516285739765625*^9, 3.516285740015625*^9}, {3.51628801021875*^9, 
   3.516288010859375*^9}, 3.518018887046875*^9, 3.518105077640625*^9, {
   3.51820080809375*^9, 3.51820080990625*^9}, 3.6251644282577167`*^9, 
   3.625166611780952*^9, {3.625167381252303*^9, 3.625167392609123*^9}, {
   3.625168730126273*^9, 3.6251687344942803`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Anchor rotation", "Subsection",
 CellChangeTimes->{{3.515956585390625*^9, 3.515956604296875*^9}, {
  3.51603601983325*^9, 3.51603602120825*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"RotateAnchor", "[", 
     RowBox[{
      RowBox[{"p", ":", "FigPointPattern"}], ",", 
      RowBox[{"theta", ":", "ScalarParameterPattern"}]}], "]"}], "/;", 
    RowBox[{"(", "SciDraw`Private`$InFigure", ")"}]}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Anchor", ",", "CanvasPoint"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FigCheckInFigure", "[", "RotateAnchor", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Anchor", "=", 
       RowBox[{"FigAnchor", "[", "p", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"FigAnchor", "[", 
       RowBox[{
        RowBox[{"Canvas", "[", 
         RowBox[{"Anchor", "@", 
          RowBox[{"GetPoint", "[", "]"}]}], "]"}], ",", 
        RowBox[{"Anchor", "@", 
         RowBox[{"GetOffset", "[", "]"}]}], ",", 
        RowBox[{
         RowBox[{"Anchor", "@", 
          RowBox[{"GetAngle", "[", "]"}]}], "+", 
         RowBox[{"UpgradeScalar", "[", "theta", "]"}]}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515614060921875*^9, 3.515614136234375*^9}, {
   3.51561417790625*^9, 3.515614185953125*^9}, {3.515614559984375*^9, 
   3.51561470015625*^9}, {3.515615311875*^9, 3.515615339796875*^9}, {
   3.515616562359375*^9, 3.51561656303125*^9}, 3.515618218171875*^9, {
   3.515685960203125*^9, 3.515686035375*^9}, {3.515861301453125*^9, 
   3.5158613055625*^9}, 3.516285140375*^9, {3.51628576609375*^9, 
   3.516285771078125*^9}, 3.518018893609375*^9, 3.5181050800625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Anchor angle retrieval", "Subsection",
 CellChangeTimes->{{3.516039288677*^9, 3.516039293942625*^9}}],

Cell["User-level anchor retrieval functions", "Text",
 CellChangeTimes->{{3.5666646506490803`*^9, 3.5666646614492464`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AnchorAngle", "[", 
    RowBox[{"p", ":", "FigPointPattern"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "Anchor", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FigCheckInFigure", "[", "AnchorAngle", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Anchor", "=", 
       RowBox[{"FigAnchor", "[", "p", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Anchor", "@", 
       RowBox[{"GetAngle", "[", "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.51603926645825*^9, {3.51603929883325*^9, 3.5160393302395*^9}, 
   3.516285143046875*^9, {3.516285773984375*^9, 3.516285778828125*^9}, 
   3.518105080953125*^9, 3.566664649116557*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Anchor offset retrieval", "Subsection",
 CellChangeTimes->{{3.516039288677*^9, 3.516039293942625*^9}, {
  3.5796312984017916`*^9, 3.5796312992317924`*^9}}],

Cell["User-level anchor retrieval functions", "Text",
 CellChangeTimes->{{3.5666646506490803`*^9, 3.5666646614492464`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AnchorOffset", "[", 
    RowBox[{"p", ":", "FigPointPattern"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "Anchor", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FigCheckInFigure", "[", "AnchorAngle", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Anchor", "=", 
       RowBox[{"FigAnchor", "[", "p", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Anchor", "@", 
       RowBox[{"GetOffset", "[", "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.51603926645825*^9, {3.51603929883325*^9, 3.5160393302395*^9}, 
   3.516285143046875*^9, {3.516285773984375*^9, 3.516285778828125*^9}, 
   3.518105080953125*^9, 3.566664649116557*^9, {3.579631303651799*^9, 
   3.5796313111218095`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Anchor point retrieval -- in user coordinates", "Subsection",
 CellChangeTimes->{{3.516039288677*^9, 3.516039293942625*^9}, {
  3.5666102060712814`*^9, 3.566610206695283*^9}, {3.5666646658668146`*^9, 
  3.5666646686168566`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AnchorCoordinates", "[", 
    RowBox[{"p", ":", "FigPointPattern"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Anchor", ",", "CanvasCoordinates"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FigCheckInFigure", "[", "AnchorCoordinates", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Anchor", "=", 
       RowBox[{"FigAnchor", "[", "p", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"CanvasCoordinates", "=", 
       RowBox[{"Anchor", "@", 
        RowBox[{"GetPoint", "[", "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"CurrentWindow", "[", "]"}], "@", 
         RowBox[{"InverseTFunction", "[", "]"}]}], ")"}], "@", 
       "CanvasCoordinates"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.566664353770233*^9, 3.5666644346382627`*^9}, {
  3.566664523324625*^9, 3.5666645890531344`*^9}, {3.5666646332613134`*^9, 
  3.5666646423814535`*^9}, {3.5666818751319184`*^9, 3.5666818859895377`*^9}, {
  3.566935770248131*^9, 3.5669357994481716`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Canvas angle for ray between anchors", "Subsection",
 CellChangeTimes->{{3.5666656315404053`*^9, 3.5666656346595836`*^9}, {
  3.5666656767709923`*^9, 3.566665680659215*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CanvasRayAngle", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"p1", ":", "FigPointPattern"}], ",", 
      RowBox[{"p2", ":", "FigPointPattern"}]}], "}"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"CanvasCoordinates1", ",", "CanvasCoordinates2"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FigCheckInFigure", "[", "CanvasAngle", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"VectorArcTan", "[", 
       RowBox[{
        RowBox[{"FigResolvePoint", "[", "p2", "]"}], "-", 
        RowBox[{"FigResolvePoint", "[", "p1", "]"}]}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.566664353770233*^9, 3.5666644346382627`*^9}, {
  3.566664523324625*^9, 3.5666645890531344`*^9}, {3.5666646332613134`*^9, 
  3.5666646423814535`*^9}, {3.5666656481193533`*^9, 3.5666657733325157`*^9}, {
  3.5666658778294926`*^9, 3.566665878212514*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Curve geometry", "Section",
 CellChangeTimes->{{3.51516648646875*^9, 3.5151664916875*^9}, {
  3.515617659953125*^9, 3.515617686125*^9}}],

Cell[CellGroupData[{

Cell["Curve pattern", "Subsection",
 CellChangeTimes->{{3.515883408046875*^9, 3.515883414421875*^9}, {
  3.51595348815625*^9, 3.5159534889375*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"FigCurvePointPattern", "=", 
   RowBox[{"FigPointPattern", "|", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"DisplaceTail", "|", "DisplaceHead"}], ")"}], "[", 
     RowBox[{"FigDisplacementSequencePattern", "[", "0", "]"}], "]"}], "|", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"DisplaceAlongTail", "|", "DisplaceAlongHead"}], ")"}], "[", 
     RowBox[{"(", 
      RowBox[{"_", "?", "NumericQ"}], ")"}], "]"}], "|", 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"ProjectTail", "|", "ProjectHead"}], ")"}], "[", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"Horizontal", "|", "Vertical"}], ")"}], ",", 
      "FigCoordinatePattern"}], "]"}]}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FigCurvePointSetPattern", "=", 
   RowBox[{"{", 
    RowBox[{"Repeated", "[", 
     RowBox[{"FigCurvePointPattern", ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", "Infinity"}], "}"}]}], "]"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FigCurvePattern", "=", 
   RowBox[{"FigCurvePointSetPattern", "|", 
    RowBox[{"(", "_Graphics", ")"}], "|", 
    RowBox[{"(", "_ContourGraphics", ")"}]}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516283186265625*^9, 3.51628318815625*^9}, {
  3.5162832189375*^9, 3.51628329253125*^9}, {3.5162835826875*^9, 
  3.5162836025*^9}, {3.5162837275625*^9, 3.51628374403125*^9}, {
  3.516283788109375*^9, 3.51628381334375*^9}, {3.516284513390625*^9, 
  3.5162845241875*^9}, {3.6253416716323614`*^9, 3.6253417003364115`*^9}, {
  3.6254525300423994`*^9, 3.625452557186447*^9}, {3.6254530234556665`*^9, 
  3.625453035951288*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Standard curve options", "Subsection",
 CellChangeTimes->{{3.51568126209375*^9, 3.515681269890625*^9}, {
  3.516046314177*^9, 3.5160463161145*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FigCurveOptions", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{"curve", " ", "geometry"}], " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TailRecess", "\[Rule]", "None"}], ",", 
     RowBox[{"HeadRecess", "\[Rule]", "None"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"curve", " ", "extraction"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      StyleBox["Line",
       InitializationCell->True], 
      StyleBox["\[Rule]",
       InitializationCell->True], "1"}]}], 
    StyleBox["\[IndentingNewLine]",
     InitializationCell->True], "\[IndentingNewLine]", "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515430903687875*^9, 3.515430989031625*^9}, {
   3.515431026844125*^9, 3.515431030625375*^9}, {3.515431105094125*^9, 
   3.5154311113285*^9}, 3.515609867390625*^9, {3.515610068609375*^9, 
   3.51561007096875*^9}, {3.515787829515625*^9, 3.515787850234375*^9}, {
   3.5160413966145*^9, 3.516041420942625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigCheckCurveOptions", "[", "Self_Object", "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FigCheckOption", "[", 
       RowBox[{
       "Self", ",", "TailRecess", ",", "ScalarParameterPattern", ",", 
        "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{
       "Self", ",", "HeadRecess", ",", "ScalarParameterPattern", ",", 
        "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
      StyleBox[
       RowBox[{"FigCheckOption", "[", 
        RowBox[{"Self", ",", "Line", ",", 
         RowBox[{"Join", "|", "All", "|", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", "_Integer", ")"}], "?", "Positive"}], ")"}]}], ",", 
         "FigOptions"}], "]"}],
       InitializationCell->True], 
      StyleBox[";",
       InitializationCell->True]}]}], 
    StyleBox["\[IndentingNewLine]",
     InitializationCell->True], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5156100370625*^9, 3.515610074328125*^9}, {
   3.515610247703125*^9, 3.515610248765625*^9}, 3.515611180921875*^9, 
   3.5157083741875*^9, {3.515708423828125*^9, 3.515708423953125*^9}, {
   3.51578785253125*^9, 3.51578789315625*^9}, {3.51604140527075*^9, 
   3.51604141270825*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Curve resolution -- point set", "Subsection",
 CellChangeTimes->{{3.5155389481875*^9, 3.5155389531875*^9}, {
  3.515616414640625*^9, 3.515616416671875*^9}, {3.515883295578125*^9, 
  3.5158832963125*^9}, {3.516039564177*^9, 3.51603956602075*^9}}],

Cell["\<\
Resolves list of two or more points into canvas coordinates, making use of \
the special curve options for head and tail positioning.\
\>", "Text",
 CellChangeTimes->{{3.515541825421875*^9, 3.515541838140625*^9}, {
  3.5156001483125*^9, 3.515600176546875*^9}, {3.515600221875*^9, 
  3.515600281890625*^9}, {3.51560485615625*^9, 3.515604856515625*^9}, {
  3.515861223421875*^9, 3.51586124259375*^9}, {3.515883302390625*^9, 
  3.515883324203125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"General", "::", "figcurveref"}], "=", 
   "\"\<Circular reference in curve specification, with tail point `1` and \
head point `2`.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5162839851875*^9, 3.51628400759375*^9}, 
   3.51628776475*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveCurve", "[", 
    RowBox[{"Self_Object", ",", 
     RowBox[{"Points", ":", "FigCurvePointSetPattern"}], ",", 
     "FullOptions_List"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "p1", ",", "p2", ",", "DereferencedPoints", ",", "CanvasPoints", ",", 
       "CanvasHead", ",", "CanvasTail"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "resolve", " ", "tail", " ", "and", " ", "head", " ", "displacement", 
       " ", "references"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"p1", "=", 
       RowBox[{"First", "[", "Points", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"p2", "=", 
       RowBox[{"Last", "[", "Points", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
         RowBox[{"sanity", " ", 
          RowBox[{"checks", " ", "--"}], " ", "head", " ", "cannot", " ", 
          "be", " ", "relative", " ", "to", " ", "head"}], ",", " ", 
         RowBox[{
         "tail", " ", "cannot", " ", "be", " ", "relative", " ", "to", " ", 
          "tail"}], ",", " ", 
         RowBox[{"and", " ", "head", " ", 
          RowBox[{"can", "'"}], "t", " ", "be", " ", "chasing", " ", "tail", 
          " ", "circularly"}]}], " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"MatchQ", "[", 
          RowBox[{"p1", ",", 
           RowBox[{
            RowBox[{"(", "_DisplaceTail", ")"}], "|", 
            RowBox[{"(", "_DisplaceAlongTail", ")"}], "|", 
            RowBox[{"(", "_ProjectTail", ")"}]}]}], "]"}], "||", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"p2", ",", 
           RowBox[{
            RowBox[{"(", "_DisplaceHead", ")"}], "|", 
            RowBox[{"(", "_DisplaceAlongHead", ")"}], "|", 
            RowBox[{"(", "_ProjectHead", ")"}]}]}], "]"}], "||", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"MatchQ", "[", 
            RowBox[{"p1", ",", 
             RowBox[{
              RowBox[{"(", "_DisplaceHead", ")"}], "|", 
              RowBox[{"(", "_DisplaceAlongHead", ")"}], "|", 
              RowBox[{"(", "_ProjectHead", ")"}]}]}], "]"}], "&&", 
           RowBox[{"MatchQ", "[", 
            RowBox[{"p2", ",", 
             RowBox[{
              RowBox[{"(", "_DisplaceTail", ")"}], "|", 
              RowBox[{"(", "_DisplaceAlongTail", ")"}], "|", 
              RowBox[{"(", "_ProjectTail", ")"}]}]}], "]"}]}], ")"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"FigError", "[", 
         RowBox[{"Self", ",", "\"\<figcurveref\>\"", ",", "p1", ",", "p2"}], 
         "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"DereferencedPoints", "=", 
       RowBox[{"Replace", "[", 
        RowBox[{"Points", ",", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"DisplaceTail", "[", "ArgSeq___", "]"}], "\[RuleDelayed]", 
            RowBox[{"DisplacePoint", "[", 
             RowBox[{"p1", ",", "ArgSeq"}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ProjectTail", "[", "ArgSeq___", "]"}], "\[RuleDelayed]", 
            
            RowBox[{"ProjectPoint", "[", 
             RowBox[{"p1", ",", "ArgSeq"}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"DisplaceAlongTail", "[", "ArgSeq___", "]"}], 
            "\[RuleDelayed]", 
            RowBox[{"DisplaceAlongAnchor", "[", 
             RowBox[{"p1", ",", "ArgSeq"}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"DisplaceHead", "[", "ArgSeq___", "]"}], "\[RuleDelayed]", 
            RowBox[{"DisplacePoint", "[", 
             RowBox[{"p2", ",", "ArgSeq"}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ProjectHead", "[", "ArgSeq___", "]"}], "\[RuleDelayed]", 
            
            RowBox[{"ProjectPoint", "[", 
             RowBox[{"p2", ",", "ArgSeq"}], "]"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"DisplaceAlongHead", "[", "ArgSeq___", "]"}], 
            "\[RuleDelayed]", 
            RowBox[{"DisplaceAlongAnchor", "[", 
             RowBox[{"p2", ",", "ArgSeq"}], "]"}]}]}], "\[IndentingNewLine]", 
          "}"}], ",", 
         RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"resolve", " ", "points"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"CanvasPoints", "=", 
       RowBox[{"FigResolvePoint", "/@", "DereferencedPoints"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"do", " ", "tail", " ", "and", " ", "head", " ", "recess"}], 
       " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"CanvasTail", "=", 
       RowBox[{"InterpolateSegment", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Take", "[", 
          RowBox[{"CanvasPoints", ",", "2"}], "]"}], ",", 
         "\[IndentingNewLine]", "Tail", ",", "Absolute", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"UpgradeScalar", "[", 
          RowBox[{"(", 
           RowBox[{"TailRecess", "/.", "FullOptions"}], ")"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"CanvasHead", "=", 
       RowBox[{"InterpolateSegment", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Take", "[", 
          RowBox[{"CanvasPoints", ",", 
           RowBox[{"-", "2"}]}], "]"}], ",", "\[IndentingNewLine]", "Head", 
         ",", "Absolute", ",", "\[IndentingNewLine]", 
         RowBox[{"-", 
          RowBox[{"UpgradeScalar", "[", 
           RowBox[{"(", 
            RowBox[{"HeadRecess", "/.", "FullOptions"}], ")"}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"ReplacePart", "[", 
       RowBox[{"CanvasPoints", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "CanvasTail"}], ",", 
          RowBox[{
           RowBox[{"-", "1"}], "\[Rule]", "CanvasHead"}]}], "}"}]}], 
       "]"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.515541817625*^9, {3.515541908421875*^9, 3.515541912828125*^9}, {
   3.515541996375*^9, 3.515541998203125*^9}, {3.515597628171875*^9, 
   3.51559764675*^9}, {3.5155978139375*^9, 3.5155978360625*^9}, {
   3.51559791015625*^9, 3.515597910953125*^9}, 3.51560013915625*^9, 
   3.51560485446875*^9, {3.51561594209375*^9, 3.51561595153125*^9}, {
   3.515616120734375*^9, 3.515616383671875*^9}, {3.51578413475*^9, 
   3.515784134765625*^9}, {3.5158833268125*^9, 3.515883339609375*^9}, {
   3.5158834336875*^9, 3.515883664703125*^9}, {3.515883697390625*^9, 
   3.515883702359375*^9}, {3.515883763125*^9, 3.5158837834375*^9}, {
   3.516039730223875*^9, 3.516039733067625*^9}, 3.516041458442625*^9, {
   3.516283690546875*^9, 3.516283692015625*^9}, {3.5162837529375*^9, 
   3.516283782609375*^9}, {3.51628382984375*^9, 3.516283855359375*^9}, {
   3.51628388653125*^9, 3.5162839798125*^9}, {3.5162840126875*^9, 
   3.516284094875*^9}, {3.516284135125*^9, 3.51628416175*^9}, {
   3.516287709125*^9, 3.516287721984375*^9}, {3.51628800634375*^9, 
   3.516288007140625*^9}, {3.51951355859375*^9, 3.519513605671875*^9}, {
   3.6251644284293165`*^9, 3.6251644284293165`*^9}, {3.6251666043865385`*^9, 
   3.62516660490134*^9}, {3.625341741504884*^9, 3.625341886117138*^9}, {
   3.6254525703528705`*^9, 3.62545263868099*^9}, {3.625452676947858*^9, 
   3.6254527487235837`*^9}, {3.6254530179020567`*^9, 3.6254530487901106`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Curve resolution -- from graphics", "Subsection",
 CellChangeTimes->{{3.51543991717225*^9, 3.515439949641*^9}, 
   3.515449053281625*^9, {3.515449138891*^9, 3.515449139687875*^9}, {
   3.516039575130125*^9, 3.516039577067625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigResolveCurve", "[", 
    RowBox[{"Self_Object", ",", 
     RowBox[{"G", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"(", "_Graphics", ")"}], "|", 
        RowBox[{"(", "_ContourGraphics", ")"}]}], ")"}]}], ",", 
     "FullOptions_List"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "GrabbedPoints", ",", "CanvasPoints", ",", "CanvasTail", ",", 
       "CanvasHead"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"resolve", " ", "points"}], " ", "*)"}], "\[IndentingNewLine]", 
     
     RowBox[{
      RowBox[{"GrabbedPoints", "=", 
       RowBox[{"GrabPoints", "[", 
        RowBox[{"G", ",", 
         RowBox[{"FilterRules", "[", 
          RowBox[{"FullOptions", ",", 
           RowBox[{"Options", "[", "GrabPoints", "]"}]}], "]"}]}], "]"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"flatten", " ", "a", " ", "list", " ", "of", " ", "curves"}], 
       " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"Line", "/.", "FullOptions"}], ")"}], "\[Equal]", "All"}],
           ")"}], "&&", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"Length", "[", "GrabbedPoints", "]"}], "\[NotEqual]", 
           "0"}], ")"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"GrabbedPoints", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{"GrabbedPoints", ",", "1"}], "]"}]}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"FigCheckValue", "[", 
       RowBox[{"Self", ",", "GrabbedPoints", ",", 
        RowBox[{"{", 
         RowBox[{"Repeated", "[", 
          RowBox[{"NumericalPairPattern", ",", 
           RowBox[{"{", 
            RowBox[{"2", ",", "Infinity"}], "}"}]}], "]"}], "}"}], ",", 
        "\"\<list of extracted points\>\""}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"CanvasPoints", "=", 
       RowBox[{"FigResolvePoint", "/@", "GrabbedPoints"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"do", " ", "tail", " ", "and", " ", "head", " ", "recess"}], 
       " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"CanvasTail", "=", 
       RowBox[{"InterpolateSegment", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Take", "[", 
          RowBox[{"CanvasPoints", ",", "2"}], "]"}], ",", 
         "\[IndentingNewLine]", "Tail", ",", "Absolute", ",", 
         "\[IndentingNewLine]", 
         RowBox[{"UpgradeScalar", "[", 
          RowBox[{"(", 
           RowBox[{"TailRecess", "/.", "FullOptions"}], ")"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"CanvasHead", "=", 
       RowBox[{"InterpolateSegment", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Take", "[", 
          RowBox[{"CanvasPoints", ",", 
           RowBox[{"-", "2"}]}], "]"}], ",", "\[IndentingNewLine]", "Head", 
         ",", "Absolute", ",", "\[IndentingNewLine]", 
         RowBox[{"-", 
          RowBox[{"UpgradeScalar", "[", 
           RowBox[{"(", 
            RowBox[{"HeadRecess", "/.", "FullOptions"}], ")"}], "]"}]}]}], 
        "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"ReplacePart", "[", 
       RowBox[{"CanvasPoints", ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"1", "\[Rule]", "CanvasTail"}], ",", 
          RowBox[{
           RowBox[{"-", "1"}], "\[Rule]", "CanvasHead"}]}], "}"}]}], 
       "]"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.515541817625*^9, {3.515541908421875*^9, 3.515541912828125*^9}, {
   3.515541996375*^9, 3.515541998203125*^9}, {3.515597628171875*^9, 
   3.51559764675*^9}, {3.5155978139375*^9, 3.5155978360625*^9}, {
   3.51559791015625*^9, 3.515597910953125*^9}, 3.51560013915625*^9, 
   3.51560485446875*^9, {3.51561594209375*^9, 3.51561595153125*^9}, {
   3.515616120734375*^9, 3.515616383671875*^9}, {3.51578413475*^9, 
   3.515784134765625*^9}, {3.5158833268125*^9, 3.515883339609375*^9}, {
   3.5158834336875*^9, 3.515883664703125*^9}, {3.515883697390625*^9, 
   3.515883702359375*^9}, {3.515883763125*^9, 3.5158837834375*^9}, {
   3.516039730223875*^9, 3.516039733067625*^9}, {3.5160414647395*^9, 
   3.516041467536375*^9}, {3.516041517348875*^9, 3.5160415202395*^9}, {
   3.516041566880125*^9, 3.516041684411375*^9}, {3.516283659921875*^9, 
   3.516283666140625*^9}, {3.516554463296875*^9, 3.516554471078125*^9}, {
   3.538849781453125*^9, 3.538849801171875*^9}, {3.53884989434375*^9, 
   3.538849897390625*^9}, {3.570135398645577*^9, 3.570135481438099*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Curve point geometry", "Subsection",
 CellChangeTimes->{{3.515166674140625*^9, 3.515166694546875*^9}, {
  3.519648423203125*^9, 3.519648429890625*^9}, {3.583350744594946*^9, 
  3.58335074693495*^9}}],

Cell["\<\
Generation of underlying interpolation functions
Returns: {fRx,fRy} where fRx and fRy are scalar-valued functions of the \
scaled arc-length parameter [0,1]
\tfRx: u -> Rx
\tfRy: u -> Ry
The curve which these functions interpolate along is the simple \
segment-by-segment linear interpolation of the given curve points.\t\
\>", "Text",
 CellChangeTimes->{{3.5833503929560165`*^9, 3.5833504365241857`*^9}, {
  3.583350514875389*^9, 3.583350681352435*^9}, {3.583353219847192*^9, 
  3.5833532803422766`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
   "LinearInterpolationFunctionsRxRy", "[", "CanvasPoints_List", "]"}], ":=", 
   
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
      "Segments", ",", "SegmentLengths", ",", "TotalLength", ",", 
       "CurveParameterValues", ",", "\[IndentingNewLine]", "XFunction", ",", 
       "YFunction", ",", "DXFunction", ",", "DYFunction"}], 
      "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Segments", "=", 
       RowBox[{"Partition", "[", 
        RowBox[{"CanvasPoints", ",", "2", ",", "1"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"SegmentLengths", "=", 
       RowBox[{"SegmentLength", "/@", "Segments"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"CurveParameterValues", "=", 
       RowBox[{"Prepend", "[", 
        RowBox[{
         RowBox[{"Accumulate", "[", "SegmentLengths", "]"}], ",", "0"}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"TotalLength", "=", 
       RowBox[{"Last", "[", "CurveParameterValues", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"CurveParameterValues", "=", 
       RowBox[{"CurveParameterValues", "/", "TotalLength"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"set", " ", "up", " ", "curve", " ", "interpolation"}], " ", 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{"functions", " ", "for", " ", 
         RowBox[{"x", "[", "d", "]"}]}], ",", " ", 
        RowBox[{"y", "[", "d", "]"}], ",", " ", 
        RowBox[{"theta", "[", "d", "]"}]}], " ", "*)"}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"XFunction", "=", 
       RowBox[{"Interpolation", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"CurveParameterValues", ",", 
            RowBox[{"First", "/@", "CanvasPoints"}]}], "}"}], "]"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"YFunction", "=", 
       RowBox[{"Interpolation", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"{", 
           RowBox[{"CurveParameterValues", ",", 
            RowBox[{"Last", "/@", "CanvasPoints"}]}], "}"}], "]"}], ",", 
         RowBox[{"InterpolationOrder", "\[Rule]", "1"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"XFunction", ",", "YFunction"}], "}"}]}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5162908211875*^9, 3.51629085715625*^9}, {
   3.520541559109375*^9, 3.520541560109375*^9}, {3.52054178821875*^9, 
   3.52054179059375*^9}, {3.5205420005*^9, 3.520542162859375*^9}, {
   3.520542347953125*^9, 3.520542355609375*^9}, {3.520542426984375*^9, 
   3.520542468265625*^9}, {3.520542553875*^9, 3.520542644640625*^9}, 
   3.5205427534375*^9, {3.5205428831875*^9, 3.520542895140625*^9}, {
   3.5833531409770813`*^9, 3.5833531853271437`*^9}}],

Cell["\<\
Interpolation functions -- LEGACY packaging

Generation of underlying interpolation functions
\tfor curve itself and for tangent
Returns: {R,T} where R and T are vector-valued functions of the scaled \
arc-length parameter [0,1]
\tR: u -> {Rx,Ry}
\tT: u -> {Tx,Ty}
The curve which these functions interpolate along is the simple \
segment-by-segment linear interpolation of the given curve points.\t\
\>", "Text",
 CellChangeTimes->{{3.5833503929560165`*^9, 3.5833504365241857`*^9}, {
   3.583350514875389*^9, 3.583350681352435*^9}, 3.583353219847192*^9, {
   3.583353307672315*^9, 3.5833533299723463`*^9}, {3.58335353976764*^9, 
   3.583353550262655*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"LinearInterpolationFunctionPair", "[", "CanvasPoints_List", "]"}],
    ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
      "XFunction", ",", "YFunction", ",", "DXFunction", ",", "DYFunction"}], 
      "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"{", 
        RowBox[{"XFunction", ",", "YFunction"}], "}"}], "=", 
       RowBox[{
       "LinearInterpolationFunctionsRxRy", "[", "CanvasPoints", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"DXFunction", ",", "DYFunction"}], "}"}], "=", 
       RowBox[{
        RowBox[{"Derivative", "[", "1", "]"}], "/@", 
        RowBox[{"{", 
         RowBox[{"XFunction", ",", "YFunction"}], "}"}]}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"construct", " ", "functions"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{"note", ":", " ", 
         RowBox[{
         "use", " ", "of", " ", "With", " ", "is", " ", "necessary", " ", 
          "to", " ", "force", " ", "correct", " ", "functions", " ", "into", 
          " ", "pure", " ", "function", " ", "definitions"}]}], ",", " ", 
        RowBox[{
        "rather", " ", "than", " ", "just", " ", "leaving", " ", "references",
          " ", "to", " ", "the", " ", "local", " ", "symbols", " ", 
         "XFunction"}], ",", " ", 
        RowBox[{"etc", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"With", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"x", "=", "XFunction"}], ",", 
          RowBox[{"y", "=", "YFunction"}], ",", 
          RowBox[{"dx", "=", "DXFunction"}], ",", 
          RowBox[{"dy", "=", "DYFunction"}]}], "}"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"x", "[", "#", "]"}], ",", 
             RowBox[{"y", "[", "#", "]"}]}], "}"}], "&"}], ",", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"dx", "[", "#", "]"}], ",", 
             RowBox[{"dy", "[", "#", "]"}]}], "}"}], "&"}]}], "}"}]}], 
       "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5162908211875*^9, 3.51629085715625*^9}, {
   3.520541559109375*^9, 3.520541560109375*^9}, {3.52054178821875*^9, 
   3.52054179059375*^9}, {3.5205420005*^9, 3.520542162859375*^9}, {
   3.520542347953125*^9, 3.520542355609375*^9}, {3.520542426984375*^9, 
   3.520542468265625*^9}, {3.520542553875*^9, 3.520542644640625*^9}, 
   3.5205427534375*^9, {3.5205428831875*^9, 3.520542895140625*^9}, {
   3.5833534722875457`*^9, 3.583353524507619*^9}}],

Cell["Segment extraction", "Text",
 CellChangeTimes->{{3.583350737060133*^9, 3.5833507393689365`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CurveSegment", "::", "badsegment"}], "=", 
   "\"\<A curve with `1` points does not have a segment numbered `2`.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CurveSegment", "::", "badsegmentzero"}], "=", 
   "\"\<Zero is not a valid segment number.\>\""}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51949611628125*^9, 3.5194961466875*^9}, {
  3.519496259609375*^9, 3.519496286515625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CurveSegment", "[", 
    RowBox[{"Points_List", ",", "s_Integer"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", "=", 
       RowBox[{"Length", "[", "Points", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Which", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"s", ">", 
        RowBox[{"n", "-", "1"}]}], ",", 
       RowBox[{"FigError", "[", 
        RowBox[{
        "CurveSegment", ",", "\"\<badsegment\>\"", ",", "n", ",", "s"}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"s", "<", 
        RowBox[{"-", 
         RowBox[{"(", 
          RowBox[{"n", "-", "1"}], ")"}]}]}], ",", 
       RowBox[{"FigError", "[", 
        RowBox[{
        "CurveSegment", ",", "\"\<badsegment\>\"", ",", "n", ",", "s"}], 
        "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"s", "\[Equal]", "0"}], ",", 
       RowBox[{"FigError", "[", 
        RowBox[{"CurveSegment", ",", "\"\<badsegmentzero\>\""}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"s", ">", "0"}], ",", 
       RowBox[{"Points", "[", 
        RowBox[{"[", 
         RowBox[{"s", ";;", 
          RowBox[{"s", "+", "1"}]}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"s", "<", "0"}], ",", 
       RowBox[{"Points", "[", 
        RowBox[{"[", 
         RowBox[{
          RowBox[{"s", "-", "1"}], ";;", "s"}], "]"}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.519496050109375*^9, 3.519496102953125*^9}, {
  3.519496179078125*^9, 3.51949624621875*^9}, {3.519496300828125*^9, 
  3.51949637259375*^9}, {3.51949663690625*^9, 3.519496638390625*^9}, {
  3.583351136951235*^9, 3.5833511436592464`*^9}}],

Cell["Point extraction", "Text",
 CellChangeTimes->{{3.583351542285843*^9, 3.583351544415846*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CurvePoint", "::", "badpoint"}], "=", 
   "\"\<A curve with `1` points does not have a point numbered `2`.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"CurvePoint", "::", "badpointzero"}], "=", 
   "\"\<Zero is not a valid segment number.\>\""}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516289231890625*^9, 3.516289257859375*^9}, {
  3.5195154558125*^9, 3.51951546165625*^9}, {3.519515525296875*^9, 
  3.51951554675*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CurvePoint", "[", 
    RowBox[{"Points_List", ",", "k_Integer"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n", "=", 
       RowBox[{"Length", "[", "Points", "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Which", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"k", ">", "n"}], ",", 
       RowBox[{"FigError", "[", 
        RowBox[{"CurvePoint", ",", "\"\<badsegment\>\"", ",", "n", ",", "k"}],
         "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"k", "<", 
        RowBox[{"-", "n"}]}], ",", 
       RowBox[{"FigError", "[", 
        RowBox[{"CurvePoint", ",", "\"\<badsegment\>\"", ",", "n", ",", "k"}],
         "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"k", "\[Equal]", "0"}], ",", 
       RowBox[{"FigError", "[", 
        RowBox[{"CurvePoint", ",", "\"\<badsegmentzero\>\""}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"k", ">", "0"}], ",", 
       RowBox[{"Points", "[", 
        RowBox[{"[", "k", "]"}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"k", "<", "0"}], ",", 
       RowBox[{"Points", "[", 
        RowBox[{"[", "k", "]"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51951551075*^9, 3.519515576375*^9}, 3.5195156611875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["\<\
Wrapper for case where interpolation should be linear interpolation of points\
\
\>", "Subsection",
 CellChangeTimes->{3.5833516185259495`*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigCurveAnchorFromPoints", "[", 
    RowBox[{"Points_List", ",", "Name_", ",", "Arg_"}], "]"}], ":=", 
   RowBox[{"FigCurveAnchor", "[", 
    RowBox[{"Points", ",", 
     RowBox[{"LinearInterpolationFunctionPair", "[", "Points", "]"}], ",", 
     "Name", ",", "Arg"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516291345609375*^9, 3.516291394421875*^9}, {
   3.519651488390625*^9, 3.519651500046875*^9}, {3.520542242359375*^9, 
   3.520542245453125*^9}, 3.52054276134375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Curve anchor -- on a segment", "Subsection",
 CellChangeTimes->{{3.5833509859585695`*^9, 3.5833509965665884`*^9}}],

Cell["\<\
wraps recursive call to FigCurveAnchor zooming on given segment

Argument: {s,...} -- within segment s\
\>", "Text",
 CellChangeTimes->{{3.583351000107795*^9, 3.5833510130558176`*^9}, {
  3.5833511783069077`*^9, 3.5833511814425135`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigCurveAnchor", "[", 
    RowBox[{"Points_List", ",", 
     RowBox[{"InterpolationFunctionPair", ":", 
      RowBox[{"{", 
       RowBox[{"InterpolationFunction_", ",", "TangentFunction_"}], "}"}]}], 
     ",", "Name_", ",", 
     RowBox[{"{", 
      RowBox[{"s_Integer", ",", "Arg_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"FigCurveAnchorFromPoints", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"CurveSegment", "[", 
      RowBox[{"Points", ",", "s"}], "]"}], ",", "\[IndentingNewLine]", "Name",
      ",", "\[IndentingNewLine]", "Arg"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5833510296854467`*^9, 3.583351127372818*^9}, {
  3.5833511866529226`*^9, 3.5833512856654835`*^9}, {3.5833516349259725`*^9, 
  3.5833516758560295`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Curve anchors relative to full curve -- Left/Center/Right", "Subsection",
 CellChangeTimes->{{3.5833507512405577`*^9, 3.5833507735017967`*^9}, {
  3.5833508423759174`*^9, 3.5833508476487265`*^9}, {3.5833513293755445`*^9, 
  3.583351331005547*^9}, {3.583351391005631*^9, 3.583351403445648*^9}}],

Cell["Argument: None -- resolves to scaled arc length 0.5", "Text",
 CellChangeTimes->{{3.583351359635587*^9, 3.5833513791356144`*^9}, {
  3.5833514463657084`*^9, 3.5833514477557106`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigCurveAnchor", "[", 
    RowBox[{"Points_List", ",", 
     RowBox[{"InterpolationFunctionPair", ":", 
      RowBox[{"{", 
       RowBox[{"InterpolationFunction_", ",", "TangentFunction_"}], "}"}]}], 
     ",", 
     RowBox[{"Side", ":", 
      RowBox[{"(", 
       RowBox[{"Left", "|", "Center", "|", "Right"}], ")"}]}], ",", "None"}], 
    "]"}], ":=", 
   RowBox[{"FigCurveAnchor", "[", 
    RowBox[{
    "Points", ",", "InterpolationFunctionPair", ",", "Side", ",", "0.5"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.519651668*^9, 3.519651695421875*^9}, {3.5205421875*^9, 
  3.5205422019375*^9}, {3.520542682296875*^9, 3.52054269153125*^9}, {
  3.520542754921875*^9, 3.520542755796875*^9}}],

Cell["Argument: u -- scaled arc length", "Text",
 CellChangeTimes->{{3.583350856259942*^9, 3.5833508748863745`*^9}, {
   3.583350912622841*^9, 3.583350957004919*^9}, {3.5833511762633038`*^9, 
   3.5833511765285044`*^9}, 3.583351449765713*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigCurveAnchor", "[", 
    RowBox[{"Points_List", ",", 
     RowBox[{"InterpolationFunctionPair", ":", 
      RowBox[{"{", 
       RowBox[{"InterpolationFunction_", ",", "TangentFunction_"}], "}"}]}], 
     ",", 
     RowBox[{"Side", ":", 
      RowBox[{"(", 
       RowBox[{"Left", "|", "Center", "|", "Right"}], ")"}]}], ",", 
     RowBox[{"u", ":", 
      RowBox[{"(", 
       RowBox[{"_", "?", "NumericQ"}], ")"}]}]}], "]"}], ":=", 
   RowBox[{"Quiet", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"FigAnchor", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Canvas", "[", 
        RowBox[{"InterpolationFunction", "[", "u", "]"}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Switch", "[", 
        RowBox[{"Side", ",", "Right", ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"+", "1"}]}], "}"}], ",", "Center", ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0"}], "}"}], ",", "Left", ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", "1"}]}], "}"}]}], "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"VectorArcTan", "[", 
        RowBox[{"TangentFunction", "[", "u", "]"}], "]"}]}], " ", 
      "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"InterpolatingFunction", "::", "dmval"}], "}"}]}], "  ", 
    RowBox[{"(*", " ", 
     RowBox[{
     "allow", " ", "anchors", " ", "past", " ", "end", " ", "of", " ", 
      "line"}], " ", "*)"}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516288605859375*^9, 3.516288606140625*^9}, 
   3.5162887196875*^9, {3.5162888203125*^9, 3.516288864875*^9}, {
   3.516288997890625*^9, 3.51628899990625*^9}, {3.51629023153125*^9, 
   3.51629023346875*^9}, {3.516290271109375*^9, 3.516290273875*^9}, {
   3.5162903079375*^9, 3.516290309765625*^9}, 3.516290356953125*^9, 
   3.51801893303125*^9, 3.5194957400625*^9, {3.519651547234375*^9, 
   3.519651610390625*^9}, 3.519651659203125*^9, {3.519728616296875*^9, 
   3.51972864125*^9}, 3.5197287649375*^9, {3.5205421776875*^9, 
   3.520542206140625*^9}, 3.52054275425*^9, {3.6347579621728563`*^9, 
   3.63475797547968*^9}}],

Cell["\<\
Arg: {DisplaceAlongHead|DisplaceAlongTail,d} -- tangent displacement from \
tail/head\
\>", "Text",
 CellChangeTimes->{{3.522196309140625*^9, 3.5221963134375*^9}, {
  3.5833477625915565`*^9, 3.5833477711966887`*^9}, {3.5833488139100037`*^9, 
  3.583348827702716*^9}, {3.5833517009260645`*^9, 3.5833517444261255`*^9}, {
  3.58335185457628*^9, 3.5833518620162907`*^9}, {3.583351920496372*^9, 
  3.583351920826373*^9}, {3.625454537216856*^9, 3.625454537652881*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FigCurveAnchor", "[", 
    RowBox[{"Points_List", ",", 
     RowBox[{"InterpolationFunctionPair", ":", 
      RowBox[{"{", 
       RowBox[{"InterpolationFunction_", ",", "TangentFunction_"}], "}"}]}], 
     ",", 
     RowBox[{"Side", ":", 
      RowBox[{"(", 
       RowBox[{"Left", "|", "Center", "|", "Right"}], ")"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"DisplaceAlongTail", ",", 
       RowBox[{"d_", "?", "NumericQ"}]}], "}"}]}], "]"}], ":=", 
   RowBox[{"DisplaceAlongAnchor", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"FigCurveAnchor", "[", 
      RowBox[{
      "Points", ",", "InterpolationFunctionPair", ",", "Center", ",", "0"}], 
      "]"}], ",", "\[IndentingNewLine]", "d"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"FigCurveAnchor", "[", 
    RowBox[{"Points_List", ",", 
     RowBox[{"InterpolationFunctionPair", ":", 
      RowBox[{"{", 
       RowBox[{"InterpolationFunction_", ",", "TangentFunction_"}], "}"}]}], 
     ",", 
     RowBox[{"Side", ":", 
      RowBox[{"(", 
       RowBox[{"Left", "|", "Center", "|", "Right"}], ")"}]}], ",", 
     RowBox[{"{", 
      RowBox[{"DisplaceAlongHead", ",", 
       RowBox[{"d_", "?", "NumericQ"}]}], "}"}]}], "]"}], ":=", 
   RowBox[{"DisplaceAlongAnchor", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"FigCurveAnchor", "[", 
      RowBox[{
      "Points", ",", "InterpolationFunctionPair", ",", "Center", ",", "1"}], 
      "]"}], ",", "\[IndentingNewLine]", "d"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.52219633125*^9, 3.522196341078125*^9}, {
  3.522196396234375*^9, 3.522196469515625*^9}, {3.522196565890625*^9, 
  3.52219656940625*^9}, {3.583347774771744*^9, 3.58334778885196*^9}, {
  3.625166606976144*^9, 3.625166610064949*^9}, {3.625454538728943*^9, 
  3.625454539519988*^9}}],

Cell["\<\
Arg: {Horizontal|Vertical,x} -- at given horizontal/vertical coordinate (with \
x in general syntax for individual coordinate)\
\>", "Text",
 CellChangeTimes->{{3.522196309140625*^9, 3.5221963134375*^9}, {
  3.5833477625915565`*^9, 3.5833477711966887`*^9}, {3.5833488139100037`*^9, 
  3.583348827702716*^9}, {3.5833517009260645`*^9, 3.5833517444261255`*^9}, {
  3.58335185457628*^9, 3.5833518620162907`*^9}, {3.583351941816402*^9, 
  3.5833519766564507`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigCurveAnchor", "[", 
    RowBox[{"Points_List", ",", 
     RowBox[{"InterpolationFunctionPair", ":", 
      RowBox[{"{", 
       RowBox[{"InterpolationFunction_", ",", "TangentFunction_"}], "}"}]}], 
     ",", 
     RowBox[{"Side", ":", 
      RowBox[{"(", 
       RowBox[{"Left", "|", "Center", "|", "Right"}], ")"}]}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"CoordinateIndexName", ":", 
        RowBox[{"(", 
         RowBox[{"Horizontal", "|", "Vertical"}], ")"}]}], ",", 
       RowBox[{"x", ":", "FigCoordinatePattern"}]}], "}"}]}], 
    "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "fRc", ",", "xc", ",", "uRule", ",", "u", ",", "CoordinateIndex", ",", 
       "CanvasPoint"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"fRc", "=", 
       RowBox[{"LinearInterpolationFunctionsRxRy", "[", "Points", "]"}]}], 
      ";", "  ", 
      RowBox[{"(*", " ", 
       RowBox[{"AD", " ", 
        RowBox[{"HOC", " ", "--"}], " ", "perhaps", " ", "to", " ", "be", " ",
         "revised", " ", "if", " ", "these", " ", "become", " ", "the", " ", 
        "stored", " ", "interpolation", " ", "functions"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"CoordinateIndex", "=", 
       RowBox[{
       "FigResolveCoordinateIndex", "[", "CoordinateIndexName", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"xc", "=", 
       RowBox[{"FigResolveCoordinate", "[", 
        RowBox[{"x", ",", "CoordinateIndex"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"recover", " ", "curve", " ", "parameter"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"Quiet", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"uRule", "=", "\[IndentingNewLine]", 
          RowBox[{"FindRoot", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"fRc", "[", 
               RowBox[{"[", "CoordinateIndex", "]"}], "]"}], "[", "u", "]"}], 
             "-", "xc"}], ",", 
            RowBox[{"{", 
             RowBox[{"u", ",", "0", ",", "1"}], "}"}]}], "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"u", "=", 
          RowBox[{"Last", "@", 
           RowBox[{"Last", "@", "uRule"}]}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"CanvasPoint", "=", 
          RowBox[{"InterpolationFunction", "[", "u", "]"}]}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"FigAnchor", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Canvas", "[", "CanvasPoint", "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Switch", "[", 
            RowBox[{"Side", ",", "Right", ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", 
               RowBox[{"+", "1"}]}], "}"}], ",", "Center", ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}], ",", "Left", ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", 
               RowBox[{"-", "1"}]}], "}"}]}], "]"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"VectorArcTan", "[", 
            RowBox[{"TangentFunction", "[", "u", "]"}], "]"}]}], " ", 
          "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"InterpolatingFunction", "::", "dmval"}], "}"}]}], "  ", 
       RowBox[{"(*", " ", 
        RowBox[{
        "allow", " ", "anchors", " ", "past", " ", "end", " ", "of", " ", 
         "line"}], " ", "*)"}], "\[IndentingNewLine]", "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.52219633125*^9, 3.522196341078125*^9}, {
   3.522196396234375*^9, 3.522196469515625*^9}, {3.522196565890625*^9, 
   3.52219656940625*^9}, {3.583347774771744*^9, 3.58334778885196*^9}, {
   3.5833520134765024`*^9, 3.583352026736521*^9}, {3.5833520943366156`*^9, 
   3.5833521264766607`*^9}, {3.58335591533827*^9, 3.58335592922829*^9}, {
   3.583355961678335*^9, 3.583355987418371*^9}, {3.5835089821272354`*^9, 
   3.58350899404392*^9}, {3.5913934729327726`*^9, 3.591393668213916*^9}, {
   3.5913937186956043`*^9, 3.5913938085361624`*^9}, {3.5913938508278365`*^9, 
   3.591393876193481*^9}, {3.591394001368101*^9, 3.5913940030061035`*^9}, {
   3.5913940370297637`*^9, 3.591394118071906*^9}, {3.5913942191600833`*^9, 
   3.591394249564537*^9}, {3.5913942930886135`*^9, 3.5913943096246424`*^9}, {
   3.634757018542799*^9, 3.634757032146023*^9}, {3.6347571925455046`*^9, 
   3.634757295677286*^9}, 3.634757853144265*^9, {3.634757939038016*^9, 
   3.6347579427820225`*^9}, 3.634758044993402*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Curve anchors at ends of curve -- Tail/Head", "Subsection",
 CellChangeTimes->{{3.5833507512405577`*^9, 3.5833507735017967`*^9}, {
  3.5833508423759174`*^9, 3.5833508476487265`*^9}, {3.5833513293755445`*^9, 
  3.583351331005547*^9}, {3.583351391005631*^9, 3.583351403445648*^9}, {
  3.5833514363856945`*^9, 3.5833514429457035`*^9}}],

Cell["Argument: None", "Text",
 CellChangeTimes->{{3.5162890259375*^9, 3.5162890281875*^9}, {
  3.583351454075719*^9, 3.583351455265721*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FigCurveAnchor", "[", 
    RowBox[{"Points_List", ",", 
     RowBox[{"InterpolationFunctionPair", ":", 
      RowBox[{"{", 
       RowBox[{"InterpolationFunction_", ",", "TangentFunction_"}], "}"}]}], 
     ",", "Tail", ",", "None"}], "]"}], ":=", 
   RowBox[{"FigAnchor", "[", 
    RowBox[{
     RowBox[{"FigCurveAnchor", "[", 
      RowBox[{
      "Points", ",", "InterpolationFunctionPair", ",", "Center", ",", "0"}], 
      "]"}], ",", "Right"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigCurveAnchor", "[", 
    RowBox[{"Points_List", ",", 
     RowBox[{"InterpolationFunctionPair", ":", 
      RowBox[{"{", 
       RowBox[{"InterpolationFunction_", ",", "TangentFunction_"}], "}"}]}], 
     ",", "Head", ",", "None"}], "]"}], ":=", 
   RowBox[{"FigAnchor", "[", 
    RowBox[{
     RowBox[{"FigCurveAnchor", "[", 
      RowBox[{
      "Points", ",", "InterpolationFunctionPair", ",", "Center", ",", "1"}], 
      "]"}], ",", "Left"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51517464803125*^9, 3.515174666234375*^9}, {
  3.5151749220625*^9, 3.515174944015625*^9}, {3.51525866915625*^9, 
  3.515258669703125*^9}, {3.51544000385975*^9, 3.5154400110785*^9}, {
  3.515448814344125*^9, 3.515448817391*^9}, {3.515885061484375*^9, 
  3.515885123609375*^9}, {3.515885158765625*^9, 3.515885177*^9}, {
  3.51588520975*^9, 3.515885211890625*^9}, {3.515885305546875*^9, 
  3.515885334171875*^9}, {3.5159692698125*^9, 3.515969316375*^9}, {
  3.5162888859375*^9, 3.516288899609375*^9}, {3.51628900478125*^9, 
  3.516289008140625*^9}, {3.51628907375*^9, 3.516289104984375*^9}, {
  3.518105316125*^9, 3.518105318203125*^9}, {3.51949590825*^9, 
  3.51949591465625*^9}, {3.519648480609375*^9, 3.5196484845625*^9}, {
  3.520542224234375*^9, 3.520542228875*^9}, {3.52054273165625*^9, 
  3.520542759203125*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Curve anchor at enumerated point -- Point", "Subsection",
 CellChangeTimes->{{3.5833507512405577`*^9, 3.5833507735017967`*^9}, {
  3.5833508423759174`*^9, 3.5833508476487265`*^9}, {3.5833513293755445`*^9, 
  3.583351331005547*^9}, {3.583351391005631*^9, 3.583351403445648*^9}, {
  3.5833514363856945`*^9, 3.5833514429457035`*^9}, {3.583351498095781*^9, 
  3.583351526495821*^9}}],

Cell["Argument: None", "Text",
 CellChangeTimes->{{3.516289165328125*^9, 3.51628916840625*^9}, 
   3.516289318390625*^9, {3.5833515305258265`*^9, 3.58335153331583*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigCurveAnchor", "[", 
    RowBox[{"Points_List", ",", 
     RowBox[{"InterpolationFunctionPair", ":", 
      RowBox[{"{", 
       RowBox[{"InterpolationFunction_", ",", "TangentFunction_"}], "}"}]}], 
     ",", "Point", ",", "k_Integer"}], "]"}], ":=", 
   RowBox[{"FigAnchor", "[", 
    RowBox[{"Canvas", "[", 
     RowBox[{"CurvePoint", "[", 
      RowBox[{"Points", ",", "k"}], "]"}], "]"}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51628918009375*^9, 3.516289224453125*^9}, {
   3.51628926325*^9, 3.516289308546875*^9}, 3.5180189345625*^9, {
   3.5195154745625*^9, 3.5195154914375*^9}, {3.519515589265625*^9, 
   3.51951559771875*^9}, {3.51951568890625*^9, 3.519515698796875*^9}, {
   3.519515875859375*^9, 3.519515890453125*^9}, {3.519591909765625*^9, 
   3.519591910703125*^9}, 3.520542236609375*^9, 3.52054276034375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Bounding box (extremal values)", "Subsection",
 CellChangeTimes->{{3.515166499828125*^9, 3.515166506484375*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"FigCurveBoundingBox", "[", 
     RowBox[{"CanvasCurve", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}], "..."}], "}"}]}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Length", "[", "CanvasCurve", "]"}], "<", "1"}], ")"}]}], ":=", 
   "None"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"FigCurveBoundingBox", "[", 
     RowBox[{"CanvasCurve", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"_", "?", "NumericQ"}], ",", 
          RowBox[{"_", "?", "NumericQ"}]}], "}"}], "..."}], "}"}]}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Length", "[", "CanvasCurve", "]"}], "\[GreaterEqual]", "1"}], 
     ")"}]}], ":=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Min", "[", 
        RowBox[{"First", "/@", "CanvasCurve"}], "]"}], ",", 
       RowBox[{"Max", "[", 
        RowBox[{"First", "/@", "CanvasCurve"}], "]"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Min", "[", 
        RowBox[{"Last", "/@", "CanvasCurve"}], "]"}], ",", 
       RowBox[{"Max", "[", 
        RowBox[{"Last", "/@", "CanvasCurve"}], "]"}]}], "}"}]}], 
    "\[IndentingNewLine]", "}"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51516616575*^9, 3.51516620196875*^9}, {
   3.515166363734375*^9, 3.51516642103125*^9}, {3.5151665123125*^9, 
   3.51516652478125*^9}, 3.515167326484375*^9, {3.515167359171875*^9, 
   3.515167378671875*^9}, {3.515167540625*^9, 3.515167556453125*^9}, {
   3.515450416844125*^9, 3.515450418844125*^9}, {3.515683051140625*^9, 
   3.51568305628125*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Standard arrowhead options", "Subsection",
 CellChangeTimes->{{3.51568126209375*^9, 3.515681269890625*^9}, {
  3.5160463231145*^9, 3.516046323411375*^9}}],

Cell["\<\
End-tagged versions are for bracket, with default equal head and tail \
parameters EndLength and EndLip\
\>", "Text",
 CellChangeTimes->{{3.5670374626436653`*^9, 3.567037476106489*^9}, {
  3.5670940329812355`*^9, 3.5670940443692555`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FigArrowheadOptions", "[", 
    RowBox[{
     RowBox[{"st", ":", "LogicalPattern"}], ",", 
     RowBox[{"sh", ":", "LogicalPattern"}], ",", 
     RowBox[{"len_:", "6"}], ",", 
     RowBox[{"lip_:", "3"}]}], "]"}], ":=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TailLength", "\[Rule]", "len"}], ",", 
     RowBox[{"TailLip", "\[Rule]", "lip"}], ",", 
     RowBox[{"ShowTail", "\[Rule]", "st"}], ",", "\[IndentingNewLine]", 
     RowBox[{"HeadLength", "\[Rule]", "len"}], ",", 
     RowBox[{"HeadLip", "\[Rule]", "lip"}], ",", 
     RowBox[{"ShowHead", "\[Rule]", "sh"}]}], "\[IndentingNewLine]", "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigArrowheadOptions", "[", 
    RowBox[{
     RowBox[{"show", ":", "LogicalPattern"}], ",", "len_", ",", "lip_", ",", 
     "End"}], "]"}], ":=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TailLength", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"TailLip", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"ShowTail", "\[Rule]", "Automatic"}], ",", "\[IndentingNewLine]", 
     RowBox[{"HeadLength", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"HeadLip", "\[Rule]", "Automatic"}], ",", 
     RowBox[{"ShowHead", "\[Rule]", "Automatic"}], ",", "\[IndentingNewLine]", 
     RowBox[{"EndLength", "\[Rule]", "len"}], ",", 
     RowBox[{"EndLip", "\[Rule]", "lip"}], ",", 
     RowBox[{"ShowEnd", "\[Rule]", "show"}]}], "\[IndentingNewLine]", "}"}]}],
   ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515430903687875*^9, 3.515430989031625*^9}, {
   3.515431026844125*^9, 3.515431030625375*^9}, {3.515431105094125*^9, 
   3.5154311113285*^9}, 3.515609867390625*^9, {3.516046331536375*^9, 
   3.516046383911375*^9}, {3.516299224796875*^9, 3.516299225890625*^9}, {
   3.56703744241043*^9, 3.567037487322909*^9}, {3.567094048596863*^9, 
   3.567094080374119*^9}, {3.5670941662054696`*^9, 3.567094199573928*^9}, {
   3.567094579270195*^9, 3.5670945796913958`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigCheckArrowheadOptions", "[", "Self_Object", "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FigCheckOption", "[", 
       RowBox[{"Self", ",", "TailLength", ",", 
        RowBox[{"_", "?", "NumericQ"}], ",", "FigOptions"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{"Self", ",", "HeadLength", ",", 
        RowBox[{"_", "?", "NumericQ"}], ",", "FigOptions"}], "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{"Self", ",", "TailLip", ",", 
        RowBox[{"NonNegativePattern", "|", 
         RowBox[{"{", 
          RowBox[{"NonNegativePattern", ",", "NonNegativePattern"}], "}"}]}], 
        ",", "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{"Self", ",", "HeadLip", ",", 
        RowBox[{"NonNegativePattern", "|", 
         RowBox[{"{", 
          RowBox[{"NonNegativePattern", ",", "NonNegativePattern"}], "}"}]}], 
        ",", "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{
       "Self", ",", "ShowTail", ",", "LogicalPattern", ",", "FigOptions"}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{
       "Self", ",", "ShowHead", ",", "LogicalPattern", ",", "FigOptions"}], 
       "]"}], ";"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515609878875*^9, 3.515609880859375*^9}, {
  3.515609969484375*^9, 3.51560997471875*^9}, {3.51561002109375*^9, 
  3.515610021390625*^9}, {3.515708373859375*^9, 3.515708374140625*^9}, {
  3.515708405015625*^9, 3.5157084079375*^9}, {3.567094109078169*^9, 
  3.567094113258977*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigCheckArrowheadOptions", "[", 
    RowBox[{"Self_Object", ",", "End"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FigCheckOption", "[", 
       RowBox[{"Self", ",", "EndLength", ",", 
        RowBox[{"_", "?", "NumericQ"}], ",", "FigOptions"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{"Self", ",", "TailLength", ",", 
        RowBox[{"Automatic", "|", 
         RowBox[{"(", 
          RowBox[{"_", "?", "NumericQ"}], ")"}]}], ",", "FigOptions"}], "]"}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{"Self", ",", "HeadLength", ",", 
        RowBox[{"Automatic", "|", 
         RowBox[{"(", 
          RowBox[{"_", "?", "NumericQ"}], ")"}]}], ",", "FigOptions"}], "]"}],
       ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{"Self", ",", "EndLip", ",", 
        RowBox[{"NonNegativePattern", "|", 
         RowBox[{"{", 
          RowBox[{"NonNegativePattern", ",", "NonNegativePattern"}], "}"}]}], 
        ",", "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{"Self", ",", "TailLip", ",", 
        RowBox[{"Automatic", "|", "NonNegativePattern", "|", 
         RowBox[{"{", 
          RowBox[{"NonNegativePattern", ",", "NonNegativePattern"}], "}"}]}], 
        ",", "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{"Self", ",", "HeadLip", ",", 
        RowBox[{"Automatic", "|", "NonNegativePattern", "|", 
         RowBox[{"{", 
          RowBox[{"NonNegativePattern", ",", "NonNegativePattern"}], "}"}]}], 
        ",", "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{
       "Self", ",", "ShowEnd", ",", "LogicalPattern", ",", "FigOptions"}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{"Self", ",", "ShowTail", ",", 
        RowBox[{"Automatic", "|", "LogicalPattern"}], ",", "FigOptions"}], 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"FigCheckOption", "[", 
       RowBox[{"Self", ",", "ShowHead", ",", 
        RowBox[{"Automatic", "|", "LogicalPattern"}], ",", "FigOptions"}], 
       "]"}], ";"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515609878875*^9, 3.515609880859375*^9}, {
  3.515609969484375*^9, 3.51560997471875*^9}, {3.51561002109375*^9, 
  3.515610021390625*^9}, {3.515708373859375*^9, 3.515708374140625*^9}, {
  3.515708405015625*^9, 3.5157084079375*^9}, {3.567037274023734*^9, 
  3.567037355939478*^9}, {3.567037393348344*^9, 3.567037437200021*^9}, {
  3.56709408645813*^9, 3.5670941397946234`*^9}, {3.567094211305149*^9, 
  3.567094258011631*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Arrowhead generation", "Subsection",
 CellChangeTimes->{{3.51543692048475*^9, 3.515436924094125*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
    RowBox[{"BasicArrowheadPoints", "::", "usage"}], "=", 
    "\"\<BasicArrowheadPoints[anchor,headlength,{headlipl,headlipr},sense] \
generates the points for an arrowhead with location and orientation given by \
anchor.\>\""}], ";"}], "*)"}]], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"BasicArrowheadPoints", "[", 
    RowBox[{
     RowBox[{"a", ":", 
      RowBox[{"ObjectPattern", "[", "FigAnchor", "]"}]}], ",", 
     RowBox[{"HeadLength_", "?", "NumericQ"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"HeadLipL_", "?", "NumericQ"}], ",", 
       RowBox[{"HeadLipR_", "?", "NumericQ"}]}], "}"}], ",", 
     RowBox[{"Sense", ":", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "|", "1"}], ")"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"P", ",", "theta"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"P", "=", 
       RowBox[{"(", 
        RowBox[{"a", "@", 
         RowBox[{"GetPoint", "[", "]"}]}], ")"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"theta", "=", 
       RowBox[{"(", 
        RowBox[{"a", "@", 
         RowBox[{"GetAngle", "[", "]"}]}], ")"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"P", "+", 
         RowBox[{
          RowBox[{"RotationTransform", "[", 
           RowBox[{"N", "@", "theta"}], "]"}], "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"HeadLength", ",", "HeadLipL"}], "}"}], "*", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "Sense"}], ",", 
             RowBox[{"+", "1"}]}], "}"}], "*", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"HeadLipL", ">", "0"}], ",", "1", ",", "0"}], "]"}]}], 
          "]"}]}], ",", "\[IndentingNewLine]", "P", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"P", "+", 
         RowBox[{
          RowBox[{"RotationTransform", "[", 
           RowBox[{"N", "@", "theta"}], "]"}], "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"HeadLength", ",", "HeadLipR"}], "}"}], "*", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", "Sense"}], ",", 
             RowBox[{"-", "1"}]}], "}"}], "*", 
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{"HeadLipR", ">", "0"}], ",", "1", ",", "0"}], "]"}]}], 
          "]"}]}]}], "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515433515266*^9, 3.515433532406625*^9}, {
   3.51543358142225*^9, 3.51543369329725*^9}, {3.515436948812875*^9, 
   3.515436980016*^9}, {3.51543703835975*^9, 3.51543713579725*^9}, {
   3.515437198344125*^9, 3.515437203437875*^9}, {3.515437434594125*^9, 
   3.51543759873475*^9}, {3.515437720187875*^9, 3.515437721656625*^9}, {
   3.515437809937875*^9, 3.51543781460975*^9}, 3.51568263378125*^9, {
   3.515682783328125*^9, 3.515682784953125*^9}, {3.51951328603125*^9, 
   3.519513362078125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigCurveArrowheadPoints", "[", 
    RowBox[{
     RowBox[{"TailAnchor", ":", 
      RowBox[{"ObjectPattern", "[", "FigAnchor", "]"}]}], ",", 
     RowBox[{"HeadAnchor", ":", 
      RowBox[{"ObjectPattern", "[", "FigAnchor", "]"}]}], ",", 
     "FullOptions_List"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", "tail", " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"ShowTail", "/.", "FullOptions"}], ")"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"BasicArrowheadPoints", "[", 
          RowBox[{"TailAnchor", ",", 
           RowBox[{"(", 
            RowBox[{"TailLength", "/.", "FullOptions"}], ")"}], ",", 
           RowBox[{"UpgradePair", "[", 
            RowBox[{"(", 
             RowBox[{"TailLip", "/.", "FullOptions"}], ")"}], "]"}], ",", 
           RowBox[{"-", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", "}"}]}], "\[IndentingNewLine]", "]"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "head", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"ShowHead", "/.", "FullOptions"}], ")"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"BasicArrowheadPoints", "[", 
          RowBox[{"HeadAnchor", ",", 
           RowBox[{"(", 
            RowBox[{"HeadLength", "/.", "FullOptions"}], ")"}], ",", 
           RowBox[{"UpgradePair", "[", 
            RowBox[{"(", 
             RowBox[{"HeadLip", "/.", "FullOptions"}], ")"}], "]"}], ",", 
           RowBox[{"+", "1"}]}], "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", "}"}]}], "\[IndentingNewLine]", "]"}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51543307960975*^9, 3.5154332384535*^9}, {
  3.51543331317225*^9, 3.515433417641*^9}, {3.51543349635975*^9, 
  3.515433497281625*^9}, {3.515437939750375*^9, 3.515438047656625*^9}, {
  3.515438849906625*^9, 3.515438850625375*^9}, {3.51544736198475*^9, 
  3.515447362531625*^9}, {3.51544749329725*^9, 3.515447497312875*^9}, {
  3.515447902156625*^9, 3.5154479028285*^9}, {3.51553712946875*^9, 
  3.515537154546875*^9}, {3.51560043484375*^9, 3.515600446765625*^9}, {
  3.51560995946875*^9, 3.515609960328125*^9}, {3.515682415078125*^9, 
  3.515682442609375*^9}, {3.51568250925*^9, 3.515682521015625*^9}, {
  3.515682551234375*^9, 3.5156826011875*^9}, {3.51568278784375*^9, 
  3.5156827915*^9}, {3.515708374296875*^9, 3.51570837440625*^9}, {
  3.5670375679438505`*^9, 3.5670375855094814`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigCurveArrowheadPoints", "[", 
    RowBox[{
     RowBox[{"TailAnchor", ":", 
      RowBox[{"ObjectPattern", "[", "FigAnchor", "]"}]}], ",", 
     RowBox[{"HeadAnchor", ":", 
      RowBox[{"ObjectPattern", "[", "FigAnchor", "]"}]}], ",", 
     RowBox[{"ReversedSide", ":", "LogicalPattern"}], ",", "FullOptions_List",
      ",", "End"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "UsedTailLength", ",", "UsedHeadLength", ",", "UsedTailLip", ",", 
       "UsedHeadLip", ",", "UsedShowTail", ",", "UsedShowHead"}], "}"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", "tail", " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"UsedShowTail", "=", 
         RowBox[{"ResolveOption", "[", 
          RowBox[{"ShowTail", ",", 
           RowBox[{"{", 
            RowBox[{"Automatic", "\[RuleDelayed]", 
             RowBox[{"(", 
              RowBox[{"ShowEnd", "/.", "FullOptions"}], ")"}]}], "}"}], ",", 
           "FullOptions"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{"UsedShowTail", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"UsedTailLength", "=", 
            RowBox[{"ResolveOption", "[", 
             RowBox[{"TailLength", ",", 
              RowBox[{"{", 
               RowBox[{"Automatic", "\[RuleDelayed]", 
                RowBox[{"-", 
                 RowBox[{"(", 
                  RowBox[{"EndLength", "/.", "FullOptions"}], ")"}]}]}], 
               "}"}], ",", "FullOptions"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"UsedTailLip", "=", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{"ReversedSide", ",", "Reverse", ",", "Identity"}], 
              "]"}], "@", 
             RowBox[{"UpgradePair", "[", 
              RowBox[{"ResolveOption", "[", 
               RowBox[{"TailLip", ",", 
                RowBox[{"{", 
                 RowBox[{"Automatic", "\[RuleDelayed]", 
                  RowBox[{"(", 
                   RowBox[{"EndLip", "/.", "FullOptions"}], ")"}]}], "}"}], 
                ",", "FullOptions"}], "]"}], "]"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"BasicArrowheadPoints", "[", 
            RowBox[{
            "TailAnchor", ",", "UsedTailLength", ",", "UsedTailLip", ",", 
             RowBox[{"-", "1"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", "}"}]}], "\[IndentingNewLine]", "]"}]}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", "head", " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"UsedShowHead", "=", 
         RowBox[{"ResolveOption", "[", 
          RowBox[{"ShowHead", ",", 
           RowBox[{"{", 
            RowBox[{"Automatic", "\[RuleDelayed]", 
             RowBox[{"(", 
              RowBox[{"ShowEnd", "/.", "FullOptions"}], ")"}]}], "}"}], ",", 
           "FullOptions"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{"UsedShowHead", ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"UsedHeadLength", "=", 
            RowBox[{"ResolveOption", "[", 
             RowBox[{"HeadLength", ",", 
              RowBox[{"{", 
               RowBox[{"Automatic", "\[RuleDelayed]", 
                RowBox[{"-", 
                 RowBox[{"(", 
                  RowBox[{"EndLength", "/.", "FullOptions"}], ")"}]}]}], 
               "}"}], ",", "FullOptions"}], "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"UsedHeadLip", "=", 
            RowBox[{
             RowBox[{"If", "[", 
              RowBox[{"ReversedSide", ",", "Reverse", ",", "Identity"}], 
              "]"}], "@", 
             RowBox[{"UpgradePair", "[", 
              RowBox[{"ResolveOption", "[", 
               RowBox[{"HeadLip", ",", 
                RowBox[{"{", 
                 RowBox[{"Automatic", "\[RuleDelayed]", 
                  RowBox[{"(", 
                   RowBox[{"EndLip", "/.", "FullOptions"}], ")"}]}], "}"}], 
                ",", "FullOptions"}], "]"}], "]"}]}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{"BasicArrowheadPoints", "[", 
            RowBox[{
            "HeadAnchor", ",", "UsedHeadLength", ",", "UsedHeadLip", ",", 
             RowBox[{"+", "1"}]}], "]"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", "}"}]}], "\[IndentingNewLine]", "]"}]}]}], 
      "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51543307960975*^9, 3.5154332384535*^9}, {
   3.51543331317225*^9, 3.515433417641*^9}, {3.51543349635975*^9, 
   3.515433497281625*^9}, {3.515437939750375*^9, 3.515438047656625*^9}, {
   3.515438849906625*^9, 3.515438850625375*^9}, {3.51544736198475*^9, 
   3.515447362531625*^9}, {3.51544749329725*^9, 3.515447497312875*^9}, {
   3.515447902156625*^9, 3.5154479028285*^9}, {3.51553712946875*^9, 
   3.515537154546875*^9}, {3.51560043484375*^9, 3.515600446765625*^9}, {
   3.51560995946875*^9, 3.515609960328125*^9}, {3.515682415078125*^9, 
   3.515682442609375*^9}, {3.51568250925*^9, 3.515682521015625*^9}, {
   3.515682551234375*^9, 3.5156826011875*^9}, {3.51568278784375*^9, 
   3.5156827915*^9}, {3.515708374296875*^9, 3.51570837440625*^9}, {
   3.5670375679438505`*^9, 3.5670375855094814`*^9}, {3.567037680591648*^9, 
   3.5670377900258403`*^9}, {3.5670937497783384`*^9, 3.567093837232092*^9}, {
   3.5670938814269695`*^9, 3.5670940214684153`*^9}, {3.567094276404063*^9, 
   3.567094349817792*^9}, {3.567094810509401*^9, 3.567094811585803*^9}, {
   3.5670948550318794`*^9, 3.56709486119389*^9}, 3.5670949372128234`*^9, {
   3.5670950192221675`*^9, 3.567095034385394*^9}, 3.5670951692788305`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Curve extraction from graphics", "Subsection",
 CellChangeTimes->{{3.51603981358325*^9, 3.516039817817625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"GrabPoints", "::", "nocurve"}], "=", "\"\<No curves found.\>\""}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GrabPoints", "::", "fewcurve"}], "=", 
   "\"\<Requested Line->`1` is greater than the number `2` of curves found.\>\
\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"GrabPoints", "::", "shortcurve"}], "=", 
   "\"\<Curve obtained `1` has fewer than two points and therefore may be \
unsuitable for use as an argument to functions or objects.\>\""}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516040455755125*^9, 3.5160405058645*^9}, {
   3.516040619067625*^9, 3.516040684473875*^9}, {3.51604075527075*^9, 
   3.516040808692625*^9}, {3.51604095052075*^9, 3.516040967442625*^9}, 
   3.516041153973875*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Point2D3DPattern", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"_", "?", "NumericQ"}], ",", 
      RowBox[{"_", "?", "NumericQ"}]}], "}"}], "|", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"_", "?", "NumericQ"}], ",", 
      RowBox[{"_", "?", "NumericQ"}], ",", 
      RowBox[{"_", "?", "NumericQ"}]}], "}"}]}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "GrabPoints", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Line", "\[Rule]", "1"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"GrabPoints", "[", 
    RowBox[{
     RowBox[{"G", ":", 
      RowBox[{"(", 
       RowBox[{"_Graphics", "|", "_Graphics3D"}], ")"}]}], ",", 
     RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"FullOptions", "=", 
        RowBox[{"Flatten", "[", 
         RowBox[{"{", 
          RowBox[{"Opts", ",", 
           RowBox[{"Options", "[", "GrabPoints", "]"}]}], "}"}], "]"}]}], ",",
        "LineSet", ",", "CurveSet", ",", "Curve"}], "}"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{"validate", " ", "options"}], "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FigCheckOption", "[", 
       RowBox[{"GrabPoints", ",", "Line", ",", 
        RowBox[{"Join", "|", "All", "|", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"(", "_Integer", ")"}], "?", "Positive"}], ")"}]}], ",", 
        "FullOptions"}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"grab", " ", "all", " ", "curves"}], "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "use", " ", "Normal", " ", "to", " ", "resolve", " ", 
        "GraphicsComplex", " ", "into", " ", "Line", " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"e", ".", "g", "."}], ",", " ", 
          RowBox[{"in", " ", "output", " ", "of", " ", "ContourPlot"}]}], 
         ")"}]}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"LineSet", "=", 
       RowBox[{"Cases", "[", 
        RowBox[{
         RowBox[{"Normal", "[", "G", "]"}], ",", 
         RowBox[{
          RowBox[{"Line", "[", 
           RowBox[{"{", 
            RowBox[{"Point2D3DPattern", ".."}], "}"}], "]"}], "|", 
          RowBox[{"Line", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"Point2D3DPattern", ".."}], "}"}], ".."}], "}"}], 
           "]"}]}], ",", "Infinity"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"CurveSet", "=", 
       RowBox[{"Replace", "[", 
        RowBox[{"LineSet", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"Line", "[", 
             RowBox[{"c", ":", 
              RowBox[{"{", 
               RowBox[{"Point2D3DPattern", ".."}], "}"}]}], "]"}], 
            "\[RuleDelayed]", 
            RowBox[{"{", "c", "}"}]}], ",", 
           RowBox[{
            RowBox[{"Line", "[", 
             RowBox[{"cc", ":", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"Point2D3DPattern", ".."}], "}"}], ".."}], "}"}]}], 
             "]"}], "\[RuleDelayed]", "cc"}]}], "}"}], ",", 
         RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"CurveSet", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"CurveSet", ",", "1"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "CurveSet", "]"}], "\[Equal]", "0"}], ",", 
        RowBox[{
         RowBox[{"FigMessage", "[", 
          RowBox[{"GrabPoints", ",", "\"\<nocurve\>\""}], "]"}], ";", 
         "\[IndentingNewLine]", 
         RowBox[{"Return", "[", 
          RowBox[{"{", "}"}], "]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", 
       RowBox[{"process", " ", "resulting", " ", "curve", " ", "set"}], 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Switch", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"Line", "/.", "FullOptions"}], ")"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"case", ":", 
          RowBox[{"grab", " ", "specific", " ", "curve"}]}], "*)"}], 
        "\[IndentingNewLine]", "_Integer", ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"If", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "CurveSet", "]"}], "<", 
            RowBox[{"(", 
             RowBox[{"Line", "/.", "FullOptions"}], ")"}]}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"FigMessage", "[", 
             RowBox[{"GrabPoints", ",", "\"\<fewcurve\>\"", ",", 
              RowBox[{"(", 
               RowBox[{"Line", "/.", "FullOptions"}], ")"}], ",", 
              RowBox[{"Length", "[", "CurveSet", "]"}]}], "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"Return", "[", 
             RowBox[{"{", "}"}], "]"}]}]}], "\[IndentingNewLine]", "]"}], ";",
          "\[IndentingNewLine]", 
         RowBox[{"Curve", "=", 
          RowBox[{"CurveSet", "[", 
           RowBox[{"[", 
            RowBox[{"(", 
             RowBox[{"Line", "/.", "FullOptions"}], ")"}], "]"}], "]"}]}], 
         ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "Curve", "]"}], "<", "2"}], ",", 
           RowBox[{"FigMessage", "[", 
            RowBox[{"GrabPoints", ",", "\"\<shortcurve\>\"", ",", "Curve"}], 
            "]"}]}], "]"}], ";", "\[IndentingNewLine]", "Curve"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"case", ":", 
          RowBox[{"merge", " ", "all", " ", "curves"}]}], "*)"}], 
        "\[IndentingNewLine]", "Join", ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Curve", "=", 
          RowBox[{"Join", "@@", "CurveSet"}]}], ";", "\[IndentingNewLine]", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"Length", "[", "Curve", "]"}], "<", "2"}], ",", 
           RowBox[{"FigMessage", "[", 
            RowBox[{"GrabPoints", ",", "\"\<shortcurve\>\"", ",", "Curve"}], 
            "]"}]}], "]"}], ";", "\[IndentingNewLine]", "Curve"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{"case", ":", 
          RowBox[{"return", " ", "curve", " ", "list"}]}], "*)"}], 
        "\[IndentingNewLine]", "All", ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Do", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"If", "[", 
            RowBox[{
             RowBox[{
              RowBox[{"Length", "[", "Curve", "]"}], "<", "2"}], ",", 
             RowBox[{"FigMessage", "[", 
              RowBox[{"GrabPoints", ",", "\"\<shortcurve\>\"", ",", "Curve"}],
               "]"}]}], "]"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"Curve", ",", "CurveSet"}], "}"}]}], 
          "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
         "CurveSet"}]}], "\[IndentingNewLine]", "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"GrabPoints", "[", 
    RowBox[{
     RowBox[{"CG", ":", 
      RowBox[{"(", "_ContourGraphics", ")"}]}], ",", 
     RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"GrabPoints", "[", 
    RowBox[{
     RowBox[{"Graphics", "[", "CG", "]"}], ",", "Opts"}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5182738013125*^9, 3.518273890390625*^9}, {
  3.538849909703125*^9, 3.538849945859375*^9}, {3.538862665125*^9, 
  3.53886271709375*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["List manipulation for curves", "Section",
 CellChangeTimes->{{3.56650866302003*^9, 3.5665086673568373`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SplitByDelimiter", "[", 
    RowBox[{"l_List", ",", "d_Symbol"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "SplitList", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"SplitList", "=", 
       RowBox[{"Split", "[", 
        RowBox[{"l", ",", 
         RowBox[{
          RowBox[{"!", 
           RowBox[{"MemberQ", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"#1", ",", "#2"}], "}"}], ",", "d"}], "]"}]}], "&"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Cases", "[", 
       RowBox[{"SplitList", ",", 
        RowBox[{"Except", "[", 
         RowBox[{"{", "d", "}"}], "]"}]}], "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PurgeOfDelimiter", "[", 
    RowBox[{"l_List", ",", "d_Symbol"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Cases", "[", 
      RowBox[{"l", ",", 
       RowBox[{"Except", "[", "d", "]"}]}], "]"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5665084698292904`*^9, 3.5665086055027285`*^9}, {
  3.5665087929994583`*^9, 3.5665088313599253`*^9}, {3.566508929983299*^9, 
  3.5665089701533694`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"SplitByDelimiter", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "2", ",", "Split", ",", "4", ",", "Split", ",", "Split"}], 
    "}"}], ",", "Split"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"PurgeOfDelimiter", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "1", ",", "2", ",", "Split", ",", "4", ",", "Split", ",", "Split"}], 
    "}"}], ",", "Split"}], "]"}]}], "Input",
 CellChangeTimes->{{3.566508838598338*^9, 3.5665088580515723`*^9}, {
  3.5665099813471456`*^9, 3.566509984576351*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", "4", "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.5665088584571733`*^9, {3.5665089365197105`*^9, 3.566508973382575*^9}, 
   3.566509984841552*^9}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "4"}], "}"}]], "Output",
 CellChangeTimes->{
  3.5665088584571733`*^9, {3.5665089365197105`*^9, 3.566508973382575*^9}, 
   3.566509984841552*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"AppendFirst", "[", "l_List", "]"}], ":=", 
   RowBox[{"Append", "[", 
    RowBox[{"l", ",", 
     RowBox[{"First", "[", "l", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.566509986058354*^9, 3.5665100052619877`*^9}, {
  3.566510035744441*^9, 3.5665100359160414`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"AppendFirst", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.5665100133428016`*^9, 3.5665100210648155`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1", ",", "2", ",", "3", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{{3.5665100212832155`*^9, 3.566510037944045*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["End package", "Section",
 CellChangeTimes->{{3.514823047703125*^9, 3.51482305353125*^9}}],

Cell[CellGroupData[{

Cell["Exit private context", "Subsection",
 CellChangeTimes->{{3.514823086015625*^9, 3.5148231094375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Exit package context", "Subsection",
 CellChangeTimes->{{3.514823092890625*^9, 3.51482312965625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Unprotect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<$*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EndPackage", "[", "]"}], ";"}]}], "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
},
WindowToolbars->"EditBar",
WindowSize->{1912, 1145},
WindowMargins->{{-2, Automatic}, {1, Automatic}},
WindowFrame->"Normal",
ShowSelection->True,
Magnification->1.2000000476837158`,
FrontEndVersion->"10.0 for Microsoft Windows (64-bit) (September 9, 2014)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 34, 0, 85, "Section"],
Cell[616, 24, 2950, 69, 195, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[3603, 98, 32, 0, 85, "Section"],
Cell[CellGroupData[{
Cell[3660, 102, 48, 0, 43, "Subsection"],
Cell[3711, 104, 1472, 24, 34, "Input",
 InitializationCell->True],
Cell[5186, 130, 184, 5, 34, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[5407, 140, 43, 0, 43, "Subsection"],
Cell[5453, 142, 183, 4, 34, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[5673, 151, 99, 1, 43, "Subsection"],
Cell[5775, 154, 163, 3, 34, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5987, 163, 253, 3, 85, "Section"],
Cell[CellGroupData[{
Cell[6265, 170, 112, 1, 43, "Subsection"],
Cell[6380, 173, 413, 11, 58, "Input",
 InitializationCell->True],
Cell[6796, 186, 352, 10, 55, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[7185, 201, 105, 1, 43, "Subsection"],
Cell[7293, 204, 272, 6, 52, "Text"],
Cell[7568, 212, 777, 23, 34, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[8382, 240, 98, 1, 43, "Subsection"],
Cell[8483, 243, 364, 12, 34, "Input",
 InitializationCell->True],
Cell[8850, 257, 758, 25, 34, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[9645, 287, 222, 3, 43, "Subsection"],
Cell[9870, 292, 92, 1, 32, "Text"],
Cell[9965, 295, 1713, 50, 66, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11727, 351, 96, 1, 102, "Section"],
Cell[CellGroupData[{
Cell[11848, 356, 49, 0, 51, "Subsection"],
Cell[11900, 358, 889, 28, 40, "Input",
 InitializationCell->True],
Cell[12792, 388, 1824, 56, 90, "Input",
 InitializationCell->True],
Cell[14619, 446, 403, 12, 40, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[15059, 463, 108, 1, 51, "Subsection"],
Cell[15170, 466, 93, 1, 38, "Text"],
Cell[15266, 469, 1384, 37, 141, "Input",
 InitializationCell->True],
Cell[16653, 508, 637, 13, 157, "Text"],
Cell[17293, 523, 4507, 128, 460, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[21849, 657, 99, 1, 122, "Section"],
Cell[CellGroupData[{
Cell[21973, 662, 159, 2, 61, "Subsection"],
Cell[22135, 666, 258, 6, 62, "Text"],
Cell[22396, 674, 361, 9, 40, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[22794, 688, 87, 1, 61, "Subsection"],
Cell[22884, 691, 188, 4, 38, "Text"],
Cell[23075, 697, 693, 19, 66, "Input",
 InitializationCell->True],
Cell[23771, 718, 187, 4, 38, "Text"],
Cell[23961, 724, 813, 23, 69, "Input",
 InitializationCell->True],
Cell[24777, 749, 857, 24, 90, "Input",
 InitializationCell->True],
Cell[25637, 775, 822, 23, 90, "Input",
 InitializationCell->True],
Cell[26462, 800, 862, 24, 90, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[27373, 830, 198, 3, 175, "Section"],
Cell[CellGroupData[{
Cell[27596, 837, 263, 4, 87, "Subsection"],
Cell[27862, 843, 401, 7, 38, "Text"],
Cell[28266, 852, 1190, 35, 121, "Input",
 InitializationCell->True],
Cell[29459, 889, 995, 18, 43, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[30491, 912, 149, 2, 87, "Subsection"],
Cell[30643, 916, 700, 12, 109, "Text"],
Cell[31346, 930, 2225, 63, 138, "Input",
 InitializationCell->True],
Cell[33574, 995, 144, 2, 38, "Text"],
Cell[33721, 999, 1664, 45, 240, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[35422, 1049, 234, 3, 51, "Subsection"],
Cell[35659, 1054, 816, 21, 40, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[36524, 1081, 153, 2, 175, "Section"],
Cell[36680, 1085, 224, 4, 64, "Text"],
Cell[CellGroupData[{
Cell[36929, 1093, 133, 2, 51, "Subsection"],
Cell[37065, 1097, 2593, 76, 169, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[39695, 1178, 153, 2, 51, "Subsection"],
Cell[39851, 1182, 1900, 53, 114, "Input",
 InitializationCell->True],
Cell[41754, 1237, 144, 2, 38, "Text"],
Cell[41901, 1241, 1792, 46, 240, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[43742, 1293, 100, 1, 175, "Section"],
Cell[43845, 1296, 184, 2, 64, "Text"],
Cell[CellGroupData[{
Cell[44054, 1302, 105, 1, 87, "Subsection"],
Cell[44162, 1305, 257, 7, 38, "Text"],
Cell[44422, 1314, 378, 9, 43, "Input",
 InitializationCell->True],
Cell[44803, 1325, 1046, 32, 138, "Input",
 InitializationCell->True],
Cell[45852, 1359, 934, 30, 114, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[46823, 1394, 102, 1, 51, "Subsection"],
Cell[46928, 1397, 278, 7, 43, "Input",
 InitializationCell->True],
Cell[47209, 1406, 570, 15, 66, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[47828, 1427, 243, 3, 175, "Section"],
Cell[CellGroupData[{
Cell[48096, 1434, 261, 3, 51, "Subsection"],
Cell[48360, 1439, 2144, 62, 94, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[50541, 1506, 117, 1, 87, "Subsection"],
Cell[50661, 1509, 519, 15, 226, "Text"],
Cell[51183, 1526, 1982, 59, 114, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[53202, 1590, 122, 1, 87, "Subsection"],
Cell[53327, 1593, 301, 4, 38, "Text"],
Cell[53631, 1599, 2929, 88, 66, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[56597, 1692, 148, 2, 124, "Subsection"],
Cell[56748, 1696, 213, 4, 38, "Text"],
Cell[56964, 1702, 1115, 32, 43, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[58116, 1739, 271, 4, 51, "Subsection"],
Cell[58390, 1745, 2901, 80, 114, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[61328, 1830, 147, 2, 124, "Subsection"],
Cell[61478, 1834, 650, 11, 211, "Text"],
Cell[62131, 1847, 379, 7, 38, "Text"],
Cell[62513, 1856, 4182, 117, 138, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[66732, 1978, 115, 1, 124, "Subsection"],
Cell[66850, 1981, 269, 6, 62, "Text"],
Cell[67122, 1989, 691, 14, 43, "Input",
 InitializationCell->True],
Cell[67816, 2005, 3392, 77, 594, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[71245, 2087, 100, 1, 124, "Subsection"],
Cell[71348, 2090, 115, 1, 38, "Text"],
Cell[71466, 2093, 1682, 42, 306, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[73185, 2140, 110, 1, 51, "Subsection"],
Cell[73298, 2143, 1158, 34, 69, "Input",
 InitializationCell->True],
Cell[74459, 2179, 2229, 57, 164, "Input",
 InitializationCell->True],
Cell[76691, 2238, 117, 1, 38, "Text"],
Cell[76811, 2241, 2172, 48, 289, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[79032, 2295, 217, 3, 175, "Section"],
Cell[79252, 2300, 2312, 34, 796, "Text"],
Cell[81567, 2336, 365, 7, 147, "Text"],
Cell[CellGroupData[{
Cell[81957, 2347, 106, 1, 87, "Subsection"],
Cell[82066, 2350, 357, 6, 38, "Text"],
Cell[82426, 2358, 792, 21, 138, "Input",
 InitializationCell->True],
Cell[83221, 2381, 1793, 47, 237, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[85051, 2433, 165, 2, 51, "Subsection"],
Cell[85219, 2437, 1397, 37, 210, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[86641, 2478, 537, 16, 68, "Input"],
Cell[87181, 2496, 266, 8, 72, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[87508, 2511, 110, 1, 175, "Section"],
Cell[CellGroupData[{
Cell[87643, 2516, 111, 1, 51, "Subsection"],
Cell[87757, 2519, 520, 15, 43, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[88314, 2539, 117, 1, 51, "Subsection"],
Cell[88434, 2542, 330, 10, 66, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[88801, 2557, 191, 2, 51, "Subsection"],
Cell[88995, 2561, 548, 13, 66, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[89580, 2579, 140, 1, 87, "Subsection"],
Cell[89723, 2582, 395, 7, 105, "Text"],
Cell[90121, 2591, 93, 1, 38, "Text"],
Cell[90217, 2594, 1972, 56, 122, "Input",
 InitializationCell->True],
Cell[92192, 2652, 123, 1, 38, "Text"],
Cell[92318, 2655, 678, 16, 66, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[93033, 2676, 140, 1, 87, "Subsection"],
Cell[93176, 2679, 93, 1, 38, "Text"],
Cell[93272, 2682, 2095, 57, 122, "Input",
 InitializationCell->True],
Cell[95370, 2741, 123, 1, 38, "Text"],
Cell[95496, 2744, 778, 17, 66, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[96323, 2767, 103, 1, 175, "Section"],
Cell[CellGroupData[{
Cell[96451, 2772, 152, 2, 51, "Subsection"],
Cell[96606, 2776, 972, 20, 40, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[97615, 2801, 108, 1, 87, "Subsection"],
Cell[97726, 2804, 295, 6, 38, "Text"],
Cell[98024, 2812, 537, 13, 40, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[98598, 2830, 248, 3, 51, "Subsection"],
Cell[98849, 2835, 1054, 27, 40, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[99952, 2868, 302, 4, 175, "Section"],
Cell[CellGroupData[{
Cell[100279, 2876, 101, 1, 51, "Subsection"],
Cell[100383, 2879, 1420, 37, 121, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[101840, 2921, 109, 1, 87, "Subsection"],
Cell[101952, 2924, 316, 6, 105, "Text"],
Cell[102271, 2932, 115, 1, 38, "Text"],
Cell[102389, 2935, 3005, 71, 450, "Input",
 InitializationCell->True],
Cell[105397, 3008, 100, 1, 38, "Text"],
Cell[105500, 3011, 5320, 103, 402, "Input",
 InitializationCell->True],
Cell[110823, 3116, 108, 1, 38, "Text"],
Cell[110934, 3119, 5426, 105, 378, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[116397, 3229, 129, 1, 104, "Subsection"],
Cell[116529, 3232, 242, 5, 126, "Text"],
Cell[116774, 3239, 118, 1, 38, "Text"],
Cell[116895, 3242, 483, 12, 40, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[117415, 3259, 309, 4, 51, "Subsection"],
Cell[117727, 3265, 1148, 20, 90, "Input",
 InitializationCell->True],
Cell[118878, 3287, 1689, 34, 192, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[120604, 3326, 104, 1, 104, "Subsection"],
Cell[120711, 3329, 346, 7, 224, "Text"],
Cell[121060, 3338, 117, 1, 38, "Text"],
Cell[121180, 3341, 535, 13, 40, "Input",
 InitializationCell->True],
Cell[121718, 3356, 173, 4, 38, "Text"],
Cell[121894, 3362, 989, 26, 138, "Input",
 InitializationCell->True],
Cell[122886, 3390, 212, 5, 38, "Text"],
Cell[123101, 3397, 986, 26, 138, "Input",
 InitializationCell->True],
Cell[124090, 3425, 199, 4, 38, "Text"],
Cell[124292, 3431, 430, 10, 40, "Input",
 InitializationCell->True],
Cell[124725, 3443, 245, 5, 38, "Text"],
Cell[124973, 3450, 707, 17, 40, "Input",
 InitializationCell->True],
Cell[125683, 3469, 146, 2, 38, "Text"],
Cell[125832, 3473, 1653, 42, 240, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[127522, 3520, 165, 2, 148, "Subsection"],
Cell[127690, 3524, 106, 1, 38, "Text"],
Cell[127799, 3527, 1342, 36, 66, "Input",
 InitializationCell->True],
Cell[129144, 3565, 305, 6, 38, "Text"],
Cell[129452, 3573, 5970, 166, 402, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[135459, 3744, 152, 2, 177, "Subsection"],
Cell[135614, 3748, 233, 3, 130, "Text"],
Cell[135850, 3753, 294, 6, 62, "Text"],
Cell[136147, 3761, 2024, 45, 138, "Input",
 InitializationCell->True],
Cell[138174, 3808, 1474, 39, 138, "Input",
 InitializationCell->True],
Cell[139651, 3849, 568, 10, 86, "Text"],
Cell[140222, 3861, 2917, 60, 357, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[143176, 3926, 204, 3, 51, "Subsection"],
Cell[143383, 3931, 1843, 52, 186, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[145263, 3988, 102, 1, 177, "Subsection"],
Cell[145368, 3991, 180, 2, 130, "Text"],
Cell[145551, 3995, 135, 1, 38, "Text"],
Cell[145689, 3998, 2334, 55, 141, "Input",
 InitializationCell->True],
Cell[148026, 4055, 1658, 44, 138, "Input",
 InitializationCell->True],
Cell[149687, 4101, 869, 16, 217, "Text"],
Cell[150559, 4119, 390, 8, 217, "Text"],
Cell[150952, 4129, 607, 10, 217, "Text"],
Cell[151562, 4141, 2023, 39, 738, "Program"],
Cell[153588, 4182, 587, 9, 38, "Text"],
Cell[154178, 4193, 8902, 211, 751, "Input",
 InitializationCell->True],
Cell[163083, 4406, 131, 1, 38, "Text"],
Cell[163217, 4409, 3080, 75, 258, "Input",
 InitializationCell->True],
Cell[166300, 4486, 319, 7, 62, "Text"],
Cell[166622, 4495, 5109, 121, 409, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[171768, 4621, 247, 3, 73, "Subsection"],
Cell[172018, 4626, 289, 6, 109, "Text"],
Cell[172310, 4634, 2031, 55, 186, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[174390, 4695, 289, 4, 146, "Section"],
Cell[CellGroupData[{
Cell[174704, 4703, 167, 2, 73, "Subsection"],
Cell[174874, 4707, 653, 11, 62, "Text"],
Cell[175530, 4720, 2231, 49, 210, "Input",
 InitializationCell->True],
Cell[177764, 4771, 3156, 68, 380, "Input",
 InitializationCell->True],
Cell[180923, 4841, 2437, 55, 234, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[183397, 4901, 150, 2, 51, "Subsection"],
Cell[183550, 4905, 1654, 38, 162, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[185241, 4948, 107, 1, 61, "Subsection"],
Cell[185351, 4951, 123, 1, 38, "Text"],
Cell[185477, 4954, 828, 20, 162, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[186342, 4979, 161, 2, 61, "Subsection"],
Cell[186506, 4983, 123, 1, 38, "Text"],
Cell[186632, 4986, 882, 21, 162, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[187551, 5012, 234, 3, 51, "Subsection"],
Cell[187788, 5017, 1228, 29, 186, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[189053, 5051, 179, 2, 51, "Subsection"],
Cell[189235, 5055, 1053, 25, 138, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[190337, 5086, 142, 2, 122, "Section"],
Cell[CellGroupData[{
Cell[190504, 5092, 147, 2, 51, "Subsection"],
Cell[190654, 5096, 1654, 40, 121, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[192345, 5141, 153, 2, 51, "Subsection"],
Cell[192501, 5145, 1103, 26, 210, "Input",
 InitializationCell->True],
Cell[193607, 5173, 1442, 35, 189, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[195086, 5213, 251, 3, 61, "Subsection"],
Cell[195340, 5218, 458, 8, 38, "Text"],
Cell[195801, 5228, 315, 8, 40, "Input",
 InitializationCell->True],
Cell[196119, 5238, 7924, 169, 936, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[204080, 5412, 236, 3, 51, "Subsection"],
Cell[204319, 5417, 4950, 111, 668, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[209306, 5533, 205, 3, 61, "Subsection"],
Cell[209514, 5538, 515, 11, 133, "Text"],
Cell[210032, 5551, 3205, 71, 498, "Input",
 InitializationCell->True],
Cell[213240, 5624, 666, 15, 170, "Text"],
Cell[213909, 5641, 3010, 71, 315, "Input",
 InitializationCell->True],
Cell[216922, 5714, 102, 1, 32, "Text"],
Cell[217027, 5717, 491, 12, 55, "Input",
 InitializationCell->True],
Cell[217521, 5731, 1854, 47, 215, "Input",
 InitializationCell->True],
Cell[219378, 5780, 98, 1, 32, "Text"],
Cell[219479, 5783, 526, 13, 55, "Input",
 InitializationCell->True],
Cell[220008, 5798, 1430, 34, 215, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[221475, 5837, 153, 4, 43, "Subsection"],
Cell[221631, 5843, 555, 12, 34, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[222223, 5860, 120, 1, 43, "Subsection"],
Cell[222346, 5863, 247, 6, 72, "Text"],
Cell[222596, 5871, 848, 20, 115, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[223481, 5896, 299, 3, 43, "Subsection"],
Cell[223783, 5901, 188, 2, 32, "Text"],
Cell[223974, 5905, 780, 20, 36, "Input",
 InitializationCell->True],
Cell[224757, 5927, 242, 3, 32, "Text"],
Cell[225002, 5932, 2266, 51, 177, "Input",
 InitializationCell->True],
Cell[227271, 5985, 472, 8, 32, "Text"],
Cell[227746, 5995, 1931, 48, 180, "Input",
 InitializationCell->True],
Cell[229680, 6045, 469, 8, 32, "Text"],
Cell[230152, 6055, 4785, 105, 437, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[234974, 6165, 338, 4, 43, "Subsection"],
Cell[235315, 6171, 141, 2, 32, "Text"],
Cell[235459, 6175, 1913, 42, 55, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[237409, 6222, 385, 5, 43, "Subsection"],
Cell[237797, 6229, 168, 2, 32, "Text"],
Cell[237968, 6233, 909, 19, 34, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[238914, 6257, 118, 1, 43, "Subsection"],
Cell[239035, 6260, 1901, 53, 115, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[240973, 6318, 160, 2, 43, "Subsection"],
Cell[241136, 6322, 248, 5, 32, "Text"],
Cell[241387, 6329, 2044, 43, 195, "Input",
 InitializationCell->True],
Cell[243434, 6374, 1987, 42, 260, "Input",
 InitializationCell->True],
Cell[245424, 6418, 3072, 64, 352, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[248533, 6487, 107, 1, 51, "Subsection"],
Cell[248643, 6490, 335, 8, 40, "Input",
 InitializationCell->True],
Cell[248981, 6500, 2868, 74, 284, "Input",
 InitializationCell->True],
Cell[251852, 6576, 3006, 60, 546, "Input",
 InitializationCell->True],
Cell[254861, 6638, 6063, 124, 690, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[260961, 6767, 117, 1, 51, "Subsection"],
Cell[261081, 6770, 836, 20, 90, "Input",
 InitializationCell->True],
Cell[261920, 6792, 7967, 202, 1087, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[269936, 7000, 114, 1, 102, "Section"],
Cell[270053, 7003, 1421, 38, 234, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[271499, 7045, 536, 14, 66, "Input"],
Cell[272038, 7061, 267, 8, 42, "Output"],
Cell[272308, 7071, 204, 5, 42, "Output"]
}, Open  ]],
Cell[272527, 7079, 352, 9, 40, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[272904, 7092, 191, 4, 40, "Input"],
Cell[273098, 7098, 161, 3, 42, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[273308, 7107, 95, 1, 102, "Section"],
Cell[CellGroupData[{
Cell[273428, 7112, 106, 1, 51, "Subsection"],
Cell[273537, 7115, 96, 3, 40, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[273670, 7123, 107, 1, 51, "Subsection"],
Cell[273780, 7126, 406, 12, 90, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
