(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 5.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     42481,       1001]
NotebookOptionsPosition[     38514,        867]
NotebookOutlinePosition[     39927,        912]
CellTagsIndexPosition[     39884,        909]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Header comments", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", "FigGraphics"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "SciDraw`"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{"Graphics", " ", "and", " ", "image", " ", "inclusion"}]}]}], 
   " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Author", ":", " ", 
      RowBox[{"Mark", " ", 
       RowBox[{"A", ".", " ", "Caprio"}]}]}]}], ",", " ", 
    RowBox[{"Department", " ", "of", " ", "Physics"}], ",", " ", 
    RowBox[{"University", " ", "of", " ", "Notre", " ", "Dame"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "FIGYEAR"}]}]}], ",", " ", 
    RowBox[{"Mark", " ", 
     RowBox[{"A", ".", " ", "Caprio"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "FIGVERSION"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "MATHVERSION"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Discussion", ":", " ", "FIGDISCUSSION"}]}], " ", "*)"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"See", " ", "package", " ", "information", " ", 
      RowBox[{"file", "."}]}]}]}], " ", "*)"}]}]], "Input",
 InitializationCell->True,
 AutoIndent->False,
 CellChangeTimes->{{3.395093723328125*^9, 3.39509375184375*^9}, {
   3.398545735296875*^9, 3.39854574365625*^9}, 3.398799700609375*^9, {
   3.43024739209375*^9, 3.43024739990625*^9}, 3.430247813015625*^9, {
   3.436819738734375*^9, 3.436819746828125*^9}, 3.436820195484375*^9, {
   3.4439959535*^9, 3.4439959773125*^9}, {3.471089562875*^9, 
   3.471089568359375*^9}, {3.471089636203125*^9, 3.471089639046875*^9}, {
   3.48681044459375*^9, 3.4868104458125*^9}, {3.489687811140625*^9, 
   3.489687812484375*^9}, {3.497222348765625*^9, 3.497222354953125*^9}, 
   3.497224390546875*^9, {3.497299514859375*^9, 3.497299515046875*^9}, {
   3.49903536659375*^9, 3.49903536784375*^9}, {3.503265433671875*^9, 
   3.5032654415*^9}, {3.50612390383225*^9, 3.5061239087385*^9}, 
   3.507509920109375*^9, {3.51481857221875*^9, 3.514818754140625*^9}, 
   3.514822657671875*^9, {3.514823216234375*^9, 3.51482323709375*^9}, {
   3.51482326921875*^9, 3.514823311671875*^9}, {3.514823375546875*^9, 
   3.514823396890625*^9}, {3.5150157685*^9, 3.51501576865625*^9}, 
   3.515275347609375*^9, {3.51542285160975*^9, 3.515422853937875*^9}, {
   3.515509659671875*^9, 3.51550966715625*^9}, {3.51578134215625*^9, 
   3.5157813479375*^9}, {3.52063375875*^9, 3.520633770125*^9}},
 LanguageCategory->"NaturalLanguage"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin package", "Section"],

Cell[CellGroupData[{

Cell["Package context definition", "Subsection",
 CellChangeTimes->{{3.5156004945*^9, 3.515600496921875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<SciDraw`\>\"", ",", "SciDraw`Private`$ExternalContexts"}], 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.395087747453125*^9, 3.39508775096875*^9}, {
   3.39509064290625*^9, 3.395090643234375*^9}, 3.395090710546875*^9, {
   3.395091175015625*^9, 3.395091179703125*^9}, {3.395093472375*^9, 
   3.39509347784375*^9}, {3.395093608140625*^9, 3.3950936085*^9}, {
   3.395519039875*^9, 3.395519061546875*^9}, {3.495041989453125*^9, 
   3.495042010953125*^9}, {3.495042158078125*^9, 3.495042163671875*^9}, {
   3.497222416421875*^9, 3.497222462578125*^9}, {3.497222963890625*^9, 
   3.497222994640625*^9}, 3.497223030953125*^9, {3.514818766734375*^9, 
   3.514818800625*^9}, {3.5148197104375*^9, 3.514819710671875*^9}, {
   3.514819841546875*^9, 3.51481994284375*^9}, {3.514819979578125*^9, 
   3.514820025046875*^9}, {3.5148201316875*^9, 3.514820154671875*^9}, {
   3.51482025234375*^9, 3.514820275171875*^9}, {3.514820309703125*^9, 
   3.514820406921875*^9}, {3.51482051775*^9, 3.514820571328125*^9}, {
   3.514820843296875*^9, 3.51482087146875*^9}, 3.51482140903125*^9, {
   3.514821446859375*^9, 3.514821449890625*^9}, 3.514821641390625*^9, {
   3.514821674609375*^9, 3.514821798390625*^9}, {3.514823407859375*^9, 
   3.514823433140625*^9}, 3.51501104184375*^9, 3.515275343*^9, {
   3.515276331390625*^9, 3.51527633303125*^9}, {3.51542275479725*^9, 
   3.515422755141*^9}, {3.51542391860975*^9, 3.51542393423475*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Unprotect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}], ";"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Object usage", "Subsection",
 CellChangeTimes->{{3.515788239328125*^9, 3.5157882413125*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FigGraphics", "::", "usage"}], "=", 
   "\"\<FIGURE OBJECT: FigGraphics[graphics] includes Mathematica graphics in \
a figure, drawn with respect to the current panel coordinate system.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigInset", "::", "usage"}], "=", 
   "\"\<FIGURE OBJECT: FigInset[graphics,region] displays Mathematica \
graphics inset within the current panel or the given region, as it would be \
displayed by Show.\>\""}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515429606016*^9, 3.5154296174535*^9}, {
   3.515429686281625*^9, 3.515429784531625*^9}, {3.515449185687875*^9, 
   3.5154492152035*^9}, {3.51544974992225*^9, 3.51544978429725*^9}, {
   3.51544992735975*^9, 3.515449931437875*^9}, {3.515529961828125*^9, 
   3.5155300071875*^9}, {3.5155300671875*^9, 3.51553013075*^9}, {
   3.51553223328125*^9, 3.5155322396875*^9}, {3.51578136028125*^9, 
   3.515781439671875*^9}, {3.515781479515625*^9, 3.515781552421875*^9}, {
   3.515781973671875*^9, 3.51578204590625*^9}, {3.5157850370625*^9, 
   3.515785100078125*^9}, {3.5157882448125*^9, 3.51578826228125*^9}, {
   3.516298963453125*^9, 3.51629897953125*^9}, {3.5166391005506773`*^9, 
   3.5166391265506773`*^9}, 3.518018985*^9, {3.520021725265625*^9, 
   3.520021752859375*^9}, {3.520446151015625*^9, 3.52044623325*^9}, {
   3.52063378484375*^9, 3.52063390753125*^9}, {3.520634215828125*^9, 
   3.52063422490625*^9}, {3.520635072796875*^9, 3.520635078390625*^9}, {
   3.5206386810625*^9, 3.52063872121875*^9}, {3.5206794330625*^9, 
   3.52067944296875*^9}, {3.520679473109375*^9, 3.520679545375*^9}, {
   3.520679611359375*^9, 3.5206796420625*^9}, 3.579121733070574*^9}]
}, Open  ]],

Cell["Other usage", "Subsection",
 CellChangeTimes->{{3.5157909549375*^9, 3.51579095871875*^9}}],

Cell[CellGroupData[{

Cell["Begin private context", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.514823442859375*^9, 3.5148234431875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dependencies", "Subsection",
 CellChangeTimes->{{3.514821147359375*^9, 3.51482114978125*^9}}],

Cell[BoxData[""], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51482113128125*^9, 3.514821158515625*^9}, {
  3.514823452421875*^9, 3.51482349575*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["FigGraphics", "Section",
 CellChangeTimes->{{3.51542982092225*^9, 3.515429824641*^9}, {
  3.51544915248475*^9, 3.51544915367225*^9}, {3.52067750371875*^9, 
  3.52067750475*^9}}],

Cell[CellGroupData[{

Cell["Object declaration", "Subsection",
 CellChangeTimes->{{3.515429830437875*^9, 3.515429833266*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DeclareFigClass", "[", "\[IndentingNewLine]", 
   RowBox[{"FigGraphics", ",", "\[IndentingNewLine]", 
    RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "}"}]}], "\[IndentingNewLine]", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineFigClassOptions", "[", "\[IndentingNewLine]", 
   RowBox[{"FigGraphics", ",", "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}],
   ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515100688734375*^9, 3.515100745765625*^9}, {
   3.515101427609375*^9, 3.5151014280625*^9}, {3.51510147303125*^9, 
   3.515101489109375*^9}, {3.515160263390625*^9, 3.51516026428125*^9}, {
   3.51516080484375*^9, 3.51516081109375*^9}, {3.515429856500375*^9, 
   3.515429878125375*^9}, {3.5154307895785*^9, 3.515430808375375*^9}, {
   3.51543131279725*^9, 3.51543134560975*^9}, {3.5154491619535*^9, 
   3.515449178391*^9}, {3.515611522671875*^9, 3.515611522859375*^9}, 
   3.515775603875*^9, {3.515961819421875*^9, 3.515961847453125*^9}, 
   3.5159619110625*^9, {3.5159620578125*^9, 3.515962089953125*^9}, {
   3.516054142927*^9, 3.516054161536375*^9}, {3.5161261685*^9, 
   3.51612621325*^9}, {3.51629154571875*^9, 3.516291546375*^9}, {
   3.5206775131875*^9, 3.5206775636875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructor", "Subsection",
 CellChangeTimes->{{3.51543192685975*^9, 3.5154319283285*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BasicGraphics", "[", "Self_Object", "]"}], "[", "g_Graphics", 
    "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"GraphicsPrimatives", ",", "TransformedPrimatives"}], 
      "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "transform", " ", "graphics", " ", "to", " ", "canvas", " ", 
       "coordinates"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{"note", ":", " ", 
        RowBox[{"quietly", " ", "handles", " ", "null", " ", 
         RowBox[{"Graphics", "[", "]"}]}]}], ",", " ", 
       RowBox[{
        RowBox[{
        "since", " ", "Mathematica", " ", "provides", " ", "nonstandard", " ",
          "evaluation", " ", 
         RowBox[{"First", "[", 
          RowBox[{"Graphics", "[", "]"}], "]"}]}], " ", "\[Rule]", " ", 
        RowBox[{"{", "}"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{"note", ":", " ", 
        RowBox[{
        "also", " ", "quietly", " ", "handles", " ", "nonlist", " ", "first", 
         " ", "argument", " ", "to", " ", 
         RowBox[{"Graphics", "[", "]"}]}]}], ",", " ", 
       RowBox[{
       "since", " ", "GeometricTransformation", " ", "accepts", " ", "an", 
        " ", "unwrapped", " ", "single", " ", "primative", " ", "for", " ", 
        "its", " ", "primatives", " ", "argument"}]}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"GraphicsPrimatives", "=", 
       RowBox[{"First", "[", "g", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"TransformedPrimatives", "=", 
       RowBox[{"{", 
        RowBox[{"GeometricTransformation", "[", 
         RowBox[{"GraphicsPrimatives", ",", 
          RowBox[{
           RowBox[{"CurrentWindow", "[", "]"}], "@", 
           RowBox[{"TFunction", "[", "]"}]}]}], "]"}], "}"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"Debug", "/.", "FigOptions"}], ")"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<Transformed primatives: \>\"", ",", "TransformedPrimatives"}], 
         "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"emit", " ", "graphics"}], " ", "*)"}], "\[IndentingNewLine]", 
      
      RowBox[{"FigVerbatimElement", "[", 
       RowBox[{"TransformedPrimatives", ",", 
        RowBox[{"FilterRules", "[", 
         RowBox[{"FigOptions", ",", 
          RowBox[{"{", 
           RowBox[{"Show", ",", "Layer"}], "}"}]}], "]"}]}], "]"}], ";"}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.520021245828125*^9, 3.520021255953125*^9}, {
   3.520021288609375*^9, 3.520021300921875*^9}, 3.520021895890625*^9, 
   3.520021960078125*^9, {3.52002360203125*^9, 3.5200236070625*^9}, {
   3.520023763625*^9, 3.520023811515625*^9}, 3.5200241691875*^9, {
   3.52002429309375*^9, 3.5200243315625*^9}, {3.52002438028125*^9, 
   3.520024394515625*^9}, {3.52002451228125*^9, 3.520024541828125*^9}, {
   3.5200252991875*^9, 3.52002531325*^9}, {3.52002815584375*^9, 
   3.52002816153125*^9}, {3.520028930546875*^9, 3.52002893146875*^9}, {
   3.520634261390625*^9, 3.520634275125*^9}, {3.52063433753125*^9, 
   3.520634338484375*^9}, {3.520634679046875*^9, 3.520634699734375*^9}, {
   3.520634920203125*^9, 3.520634935921875*^9}, {3.52063521471875*^9, 
   3.5206352591875*^9}, {3.52063532484375*^9, 3.52063533896875*^9}, {
   3.52063558615625*^9, 3.52063558784375*^9}, {3.520635750078125*^9, 
   3.5206357581875*^9}, {3.5206362234375*^9, 3.52063622509375*^9}, {
   3.5206363783125*^9, 3.520636408546875*^9}, {3.520637019171875*^9, 
   3.520637024796875*^9}, {3.52063959296875*^9, 3.520639614609375*^9}, {
   3.520639690328125*^9, 3.5206399630625*^9}, {3.52064001325*^9, 
   3.520640052671875*^9}, {3.520640279390625*^9, 3.520640326625*^9}, {
   3.52064118271875*^9, 3.5206411846875*^9}, {3.520641236546875*^9, 
   3.52064126021875*^9}, {3.520641346203125*^9, 3.5206413480625*^9}, {
   3.520641760171875*^9, 3.520641763078125*^9}, {3.520677605984375*^9, 
   3.520677675484375*^9}, {3.520677715921875*^9, 3.52067778928125*^9}, {
   3.5206786445625*^9, 3.520678666421875*^9}, {3.5206787116875*^9, 
   3.520678768890625*^9}, {3.52067888096875*^9, 3.5206789380625*^9}, {
   3.583782922887636*^9, 3.583782958119427*^9}}],

Cell["Standard graphics", "Text",
 CellChangeTimes->{{3.520678504921875*^9, 3.520678507*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Constructor", "[", 
     RowBox[{
      RowBox[{"Class", ":", "FigGraphics"}], ",", "Self_Object"}], "]"}], "[", 
    RowBox[{"g_Graphics", ",", 
     RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"FigObjectWrapper", "[", 
    RowBox[{"Class", ",", "Self", ",", 
     RowBox[{"{", "Opts", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"BasicGraphics", "[", "Self", "]"}], "[", "g", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51510150784375*^9, 3.51510165284375*^9}, {
   3.5151018264375*^9, 3.515101837625*^9}, {3.515160729234375*^9, 
   3.5151607388125*^9}, {3.515160815109375*^9, 3.515160905421875*^9}, {
   3.515429900281625*^9, 3.5154299283285*^9}, {3.515432005344125*^9, 
   3.51543202310975*^9}, {3.515432080625375*^9, 3.515432260875375*^9}, {
   3.515432559875375*^9, 3.515432618141*^9}, {3.515432654812875*^9, 
   3.515432706531625*^9}, {3.515433020406625*^9, 3.515433023781625*^9}, {
   3.515442053016*^9, 3.5154420783285*^9}, {3.51544252460975*^9, 
   3.515442586281625*^9}, {3.5154469192035*^9, 3.515446929391*^9}, {
   3.5154471764535*^9, 3.515447183094125*^9}, {3.515447219250375*^9, 
   3.515447220250375*^9}, {3.515447301531625*^9, 3.5154473044535*^9}, 
   3.515448155969125*^9, {3.515449235594125*^9, 3.515449253000375*^9}, 
   3.51545048954725*^9, {3.51545052173475*^9, 3.5154505228285*^9}, {
   3.5156116164375*^9, 3.5156116188125*^9}, 3.515617820796875*^9, 
   3.515885267046875*^9, {3.516054175880125*^9, 3.5160541838645*^9}, {
   3.516126281046875*^9, 3.516126353890625*^9}, {3.5162915419375*^9, 
   3.516291542609375*^9}, {3.5162951236875*^9, 3.516295158296875*^9}, 
   3.518019035421875*^9, {3.519496808296875*^9, 3.5194968685625*^9}, {
   3.51949692540625*^9, 3.519496925984375*^9}, {3.520677571609375*^9, 
   3.520677572640625*^9}, {3.520678453140625*^9, 3.5206785016875*^9}}],

Cell["\<\
Allow single graphics to be enclosed in List
\tto gracefully accept Import result for PDF\
\>", "Text",
 CellChangeTimes->{{3.52067852603125*^9, 3.5206785505*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Constructor", "[", 
     RowBox[{
      RowBox[{"Class", ":", "FigGraphics"}], ",", "Self_Object"}], "]"}], "[", 
    RowBox[{
     RowBox[{"{", "g_Graphics", "}"}], ",", 
     RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"FigObjectWrapper", "[", 
    RowBox[{"Class", ",", "Self", ",", 
     RowBox[{"{", "Opts", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"BasicGraphics", "[", "Self", "]"}], "[", "g", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51510150784375*^9, 3.51510165284375*^9}, {
   3.5151018264375*^9, 3.515101837625*^9}, {3.515160729234375*^9, 
   3.5151607388125*^9}, {3.515160815109375*^9, 3.515160905421875*^9}, {
   3.515429900281625*^9, 3.5154299283285*^9}, {3.515432005344125*^9, 
   3.51543202310975*^9}, {3.515432080625375*^9, 3.515432260875375*^9}, {
   3.515432559875375*^9, 3.515432618141*^9}, {3.515432654812875*^9, 
   3.515432706531625*^9}, {3.515433020406625*^9, 3.515433023781625*^9}, {
   3.515442053016*^9, 3.5154420783285*^9}, {3.51544252460975*^9, 
   3.515442586281625*^9}, {3.5154469192035*^9, 3.515446929391*^9}, {
   3.5154471764535*^9, 3.515447183094125*^9}, {3.515447219250375*^9, 
   3.515447220250375*^9}, {3.515447301531625*^9, 3.5154473044535*^9}, 
   3.515448155969125*^9, {3.515449235594125*^9, 3.515449253000375*^9}, 
   3.51545048954725*^9, {3.51545052173475*^9, 3.5154505228285*^9}, {
   3.5156116164375*^9, 3.5156116188125*^9}, 3.515617820796875*^9, 
   3.515885267046875*^9, {3.516054175880125*^9, 3.5160541838645*^9}, {
   3.516126281046875*^9, 3.516126353890625*^9}, {3.5162915419375*^9, 
   3.516291542609375*^9}, {3.5162951236875*^9, 3.516295158296875*^9}, 
   3.518019035421875*^9, {3.519496808296875*^9, 3.5194968685625*^9}, {
   3.51949692540625*^9, 3.519496925984375*^9}, {3.520677571609375*^9, 
   3.520677572640625*^9}, {3.520678453140625*^9, 3.5206785016875*^9}, {
   3.52067855690625*^9, 3.520678559046875*^9}}],

Cell["Cast ContourGraphics or DensityGraphics to Graphics", "Text",
 CellChangeTimes->{{3.5206355701875*^9, 3.520635578625*^9}, {
   3.5206385708125*^9, 3.520638591765625*^9}, {3.52063877609375*^9, 
   3.5206388083125*^9}, {3.520678576015625*^9, 3.5206785765*^9}, 
   3.520678608890625*^9, 3.520678798625*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Constructor", "[", 
     RowBox[{
      RowBox[{"Class", ":", "FigGraphics"}], ",", "Self_Object"}], "]"}], "[", 
    RowBox[{
     RowBox[{"g", ":", 
      RowBox[{"(", 
       RowBox[{"_ContourGraphics", "|", "_DensityGraphics"}], ")"}]}], ",", 
     RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"FigObjectWrapper", "[", 
    RowBox[{"Class", ",", "Self", ",", 
     RowBox[{"{", "Opts", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"BasicGraphics", "[", "Self", "]"}], "[", 
      RowBox[{"Graphics", "[", "g", "]"}], "]"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51510150784375*^9, 3.51510165284375*^9}, {
   3.5151018264375*^9, 3.515101837625*^9}, {3.515160729234375*^9, 
   3.5151607388125*^9}, {3.515160815109375*^9, 3.515160905421875*^9}, {
   3.515429900281625*^9, 3.5154299283285*^9}, {3.515432005344125*^9, 
   3.51543202310975*^9}, {3.515432080625375*^9, 3.515432260875375*^9}, {
   3.515432559875375*^9, 3.515432618141*^9}, {3.515432654812875*^9, 
   3.515432706531625*^9}, {3.515433020406625*^9, 3.515433023781625*^9}, {
   3.515442053016*^9, 3.5154420783285*^9}, {3.51544252460975*^9, 
   3.515442586281625*^9}, {3.5154469192035*^9, 3.515446929391*^9}, {
   3.5154471764535*^9, 3.515447183094125*^9}, {3.515447219250375*^9, 
   3.515447220250375*^9}, {3.515447301531625*^9, 3.5154473044535*^9}, 
   3.515448155969125*^9, {3.515449235594125*^9, 3.515449253000375*^9}, 
   3.51545048954725*^9, {3.51545052173475*^9, 3.5154505228285*^9}, {
   3.5156116164375*^9, 3.5156116188125*^9}, 3.515617820796875*^9, 
   3.515885267046875*^9, {3.516054175880125*^9, 3.5160541838645*^9}, {
   3.516126281046875*^9, 3.516126353890625*^9}, {3.5162915419375*^9, 
   3.516291542609375*^9}, {3.5162951236875*^9, 3.516295158296875*^9}, 
   3.518019035421875*^9, {3.519496808296875*^9, 3.5194968685625*^9}, {
   3.51949692540625*^9, 3.519496925984375*^9}, {3.520677571609375*^9, 
   3.520677572640625*^9}, {3.520678453140625*^9, 3.5206785016875*^9}, {
   3.52067855690625*^9, 3.520678559046875*^9}, {3.520678619921875*^9, 
   3.520678626015625*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Methods", "Subsection",
 CellChangeTimes->{{3.5151660264375*^9, 3.515166028765625*^9}, {
  3.515449067344125*^9, 3.51544909085975*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakeAnchor", "[", 
     RowBox[{
      RowBox[{"Class", ":", "FigGraphics"}], ",", "Self_Object"}], "]"}], "[", 
    RowBox[{"Name_", ",", "Arg_"}], "]"}], ":=", 
   RowBox[{"FigMakeAnchorWrapper", "[", 
    RowBox[{
    "Class", ",", "Self", ",", "Name", ",", "Arg", ",", "\[IndentingNewLine]",
      "Null"}], "\[IndentingNewLine]", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakeBoundingBox", "[", 
     RowBox[{
      RowBox[{"Class", ":", "FigGraphics"}], ",", "Self_Object"}], "]"}], "[",
     "]"}], ":=", 
   RowBox[{"FigMakeBoundingBoxWrapper", "[", 
    RowBox[{"Class", ",", "Self", ",", "Null"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51517464803125*^9, 3.515174666234375*^9}, {
  3.5151749220625*^9, 3.515174944015625*^9}, {3.51525866915625*^9, 
  3.515258669703125*^9}, {3.51544000385975*^9, 3.5154400110785*^9}, {
  3.515448814344125*^9, 3.515448817391*^9}, {3.515449256562875*^9, 
  3.5154492602035*^9}, {3.51629152640625*^9, 3.51629153790625*^9}, {
  3.519646775296875*^9, 3.5196467861875*^9}, {3.5206779050625*^9, 
  3.520677946484375*^9}, {3.520678367*^9, 3.52067837796875*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["FigInset", "Section",
 CellChangeTimes->{{3.51542982092225*^9, 3.515429824641*^9}, {
  3.51544915248475*^9, 3.51544915367225*^9}, {3.52067750371875*^9, 
  3.52067750475*^9}, {3.520678972296875*^9, 3.520678972921875*^9}}],

Cell[CellGroupData[{

Cell["Object declaration", "Subsection",
 CellChangeTimes->{{3.515429830437875*^9, 3.515429833266*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DeclareFigClass", "[", "\[IndentingNewLine]", 
   RowBox[{"FigInset", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"\"\<Center\>\"", ",", "\"\<Radius\>\""}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "}"}]}], "\[IndentingNewLine]", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineFigClassOptions", "[", "\[IndentingNewLine]", 
   RowBox[{"FigInset", ",", "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"RegionExtension", "\[Rule]", "None"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"RegionDisplacement", "\[Rule]", "None"}]}], 
     "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515100688734375*^9, 3.515100745765625*^9}, {
   3.515101427609375*^9, 3.5151014280625*^9}, {3.51510147303125*^9, 
   3.515101489109375*^9}, {3.515160263390625*^9, 3.51516026428125*^9}, {
   3.51516080484375*^9, 3.51516081109375*^9}, {3.515429856500375*^9, 
   3.515429878125375*^9}, {3.5154307895785*^9, 3.515430808375375*^9}, {
   3.51543131279725*^9, 3.51543134560975*^9}, {3.5154491619535*^9, 
   3.515449178391*^9}, {3.515611522671875*^9, 3.515611522859375*^9}, 
   3.515775603875*^9, {3.515961819421875*^9, 3.515961847453125*^9}, 
   3.5159619110625*^9, {3.5159620578125*^9, 3.515962089953125*^9}, {
   3.516054142927*^9, 3.516054161536375*^9}, {3.5161261685*^9, 
   3.51612621325*^9}, {3.51629154571875*^9, 3.516291546375*^9}, {
   3.5206775131875*^9, 3.5206775636875*^9}, {3.520678986203125*^9, 
   3.52067899059375*^9}, {3.520679258859375*^9, 3.520679266828125*^9}, {
   3.520680192125*^9, 3.52068019475*^9}, {3.5669431608371983`*^9, 
   3.566943165137204*^9}, {3.5669437051029606`*^9, 3.5669437069779634`*^9}, {
   3.566944173533616*^9, 3.5669442049736605`*^9}, {3.583080849476093*^9, 
   3.5830808707389297`*^9}, {3.5830812115057497`*^9, 3.58308121701256*^9}, {
   3.5836974770751534`*^9, 3.5836974778151546`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructor", "Subsection",
 CellChangeTimes->{{3.51543192685975*^9, 3.5154319283285*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BasicInset", "[", "Self_Object", "]"}], "[", 
    RowBox[{"g_", ",", "r_"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
      "TransformedPrimatives", ",", "CanvasRegion", ",", "CanvasCenter", ",", 
       "CanvasSize", ",", "CanvasRadius"}], "\[IndentingNewLine]", "}"}], ",",
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"force", " ", "graphics", " ", "into", " ", "inset"}], " ", 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"CanvasRegion", "=", 
       RowBox[{"FigResolveRegion", "@", 
        RowBox[{"AdjustRegion", "[", 
         RowBox[{"r", ",", 
          RowBox[{"FilterRules", "[", 
           RowBox[{"FigOptions", ",", 
            RowBox[{"{", 
             RowBox[{"RegionExtension", ",", "RegionDisplacement"}], "}"}]}], 
           "]"}]}], "]"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"CanvasCenter", "=", 
       RowBox[{"Mean", "/@", "CanvasRegion"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"CanvasSize", "=", 
       RowBox[{"-", 
        RowBox[{"Subtract", "@@@", "CanvasRegion"}]}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"TransformedPrimatives", "=", 
       RowBox[{"{", 
        RowBox[{"Inset", "[", 
         RowBox[{"g", ",", "CanvasCenter", ",", "Center", ",", "CanvasSize"}],
          "]"}], "}"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"Debug", "/.", "FigOptions"}], ")"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Print", "[", 
         RowBox[{
         "\"\<Given region \>\"", ",", "r", ",", "\"\<Canvas region: \>\"", 
          ",", "CanvasRegion"}], "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"save", " ", "box", " ", "information"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"CanvasRadius", "=", 
       RowBox[{"CanvasSize", "/", "2"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Self", "@", 
       RowBox[{"SetCenter", "[", "CanvasCenter", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Self", "@", 
       RowBox[{"SetRadius", "[", "CanvasRadius", "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"emit", " ", "graphics"}], " ", "*)"}], "\[IndentingNewLine]", 
      
      RowBox[{"FigVerbatimElement", "[", 
       RowBox[{"TransformedPrimatives", ",", 
        RowBox[{"FilterRules", "[", 
         RowBox[{"FigOptions", ",", 
          RowBox[{"{", 
           RowBox[{"Show", ",", "Layer"}], "}"}]}], "]"}]}], "]"}], ";"}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.520021245828125*^9, 3.520021255953125*^9}, {
   3.520021288609375*^9, 3.520021300921875*^9}, 3.520021895890625*^9, 
   3.520021960078125*^9, {3.52002360203125*^9, 3.5200236070625*^9}, {
   3.520023763625*^9, 3.520023811515625*^9}, 3.5200241691875*^9, {
   3.52002429309375*^9, 3.5200243315625*^9}, {3.52002438028125*^9, 
   3.520024394515625*^9}, {3.52002451228125*^9, 3.520024541828125*^9}, {
   3.5200252991875*^9, 3.52002531325*^9}, {3.52002815584375*^9, 
   3.52002816153125*^9}, {3.520028930546875*^9, 3.52002893146875*^9}, {
   3.520634261390625*^9, 3.520634275125*^9}, {3.52063433753125*^9, 
   3.520634338484375*^9}, {3.520634679046875*^9, 3.520634699734375*^9}, {
   3.520634920203125*^9, 3.520634935921875*^9}, {3.52063521471875*^9, 
   3.5206352591875*^9}, {3.52063532484375*^9, 3.52063533896875*^9}, {
   3.52063558615625*^9, 3.52063558784375*^9}, {3.520635750078125*^9, 
   3.5206357581875*^9}, {3.5206362234375*^9, 3.52063622509375*^9}, {
   3.5206363783125*^9, 3.520636408546875*^9}, {3.520637019171875*^9, 
   3.520637024796875*^9}, {3.52063959296875*^9, 3.520639614609375*^9}, {
   3.520639690328125*^9, 3.5206399630625*^9}, {3.52064001325*^9, 
   3.520640052671875*^9}, {3.520640279390625*^9, 3.520640326625*^9}, {
   3.52064118271875*^9, 3.5206411846875*^9}, {3.520641236546875*^9, 
   3.52064126021875*^9}, {3.520641346203125*^9, 3.5206413480625*^9}, {
   3.520641760171875*^9, 3.520641763078125*^9}, {3.520677605984375*^9, 
   3.520677675484375*^9}, {3.520677715921875*^9, 3.52067773034375*^9}, {
   3.520677810859375*^9, 3.52067787321875*^9}, {3.520679182453125*^9, 
   3.520679204796875*^9}, {3.520680226828125*^9, 3.520680227125*^9}, 
   3.520680895671875*^9, {3.583080974238312*^9, 3.5830809759075146`*^9}, {
   3.583698841276664*^9, 3.5836988415666647`*^9}, {3.5836988817117205`*^9, 
   3.583698891086734*^9}, {3.5836989785768557`*^9, 3.5836989840968637`*^9}, {
   3.583699178460137*^9, 3.583699184075145*^9}}],

Cell["\<\
All forms of directly insettable graphics
\talso allow single graphics to be enclosed in List to gracefully accept \
Import result for PDF

Problem:
(g:(_Graphics|_ContourGraphics|_DensityGraphics|_Image|_Graphics3D))|{g_\
Graphics}
excludes new \[OpenCurlyDoubleQuote]graphics\[CloseCurlyDoubleQuote] types, \
such as PointLegend,
so allow all objects to be passed through, but with special case trap for \
{_Graphics}.  Ugly since is special case trap and relaxes argument type \
checking.\
\>", "Text",
 CellChangeTimes->{{3.520678504921875*^9, 3.520678507*^9}, {
  3.520679039359375*^9, 3.520679044359375*^9}, {3.5669442683137493`*^9, 
  3.5669442737537565`*^9}, {3.6011462654300175`*^9, 3.601146321630096*^9}, {
  3.6011467763789434`*^9, 3.601146790028967*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Constructor", "[", 
     RowBox[{
      RowBox[{"Class", ":", "FigInset"}], ",", "Self_Object"}], "]"}], "[", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"g", ":", 
        RowBox[{"(", 
         RowBox[{
         "_Graphics", "|", "_ContourGraphics", "|", "_DensityGraphics", "|", 
          "_Image", "|", "_Graphics3D"}], ")"}]}], ")"}], "|", 
      RowBox[{"{", "g_Graphics", "}"}]}], ",", 
     RowBox[{"r", ":", "FigRegionPattern", ":", "All"}], ",", 
     RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"FigObjectWrapper", "[", 
    RowBox[{"Class", ",", "Self", ",", 
     RowBox[{"{", "Opts", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", "UsedCanvasRegion", "}"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"FigCheckOption", "[", 
         RowBox[{
         "Self", ",", "RegionExtension", ",", "FigDeltaRegionPattern", ",", 
          "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{
         "Self", ",", "RegionDisplacement", ",", "FigDisplacementPattern", 
          ",", "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"BasicInset", "[", "Self", "]"}], "[", 
         RowBox[{"g", ",", "r"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51510150784375*^9, 3.51510165284375*^9}, {
   3.5151018264375*^9, 3.515101837625*^9}, {3.515160729234375*^9, 
   3.5151607388125*^9}, {3.515160815109375*^9, 3.515160905421875*^9}, {
   3.515429900281625*^9, 3.5154299283285*^9}, {3.515432005344125*^9, 
   3.51543202310975*^9}, {3.515432080625375*^9, 3.515432260875375*^9}, {
   3.515432559875375*^9, 3.515432618141*^9}, {3.515432654812875*^9, 
   3.515432706531625*^9}, {3.515433020406625*^9, 3.515433023781625*^9}, {
   3.515442053016*^9, 3.5154420783285*^9}, {3.51544252460975*^9, 
   3.515442586281625*^9}, {3.5154469192035*^9, 3.515446929391*^9}, {
   3.5154471764535*^9, 3.515447183094125*^9}, {3.515447219250375*^9, 
   3.515447220250375*^9}, {3.515447301531625*^9, 3.5154473044535*^9}, 
   3.515448155969125*^9, {3.515449235594125*^9, 3.515449253000375*^9}, 
   3.51545048954725*^9, {3.51545052173475*^9, 3.5154505228285*^9}, {
   3.5156116164375*^9, 3.5156116188125*^9}, 3.515617820796875*^9, 
   3.515885267046875*^9, {3.516054175880125*^9, 3.5160541838645*^9}, {
   3.516126281046875*^9, 3.516126353890625*^9}, {3.5162915419375*^9, 
   3.516291542609375*^9}, {3.5162951236875*^9, 3.516295158296875*^9}, 
   3.518019035421875*^9, {3.519496808296875*^9, 3.5194968685625*^9}, {
   3.51949692540625*^9, 3.519496925984375*^9}, {3.520677571609375*^9, 
   3.520677572640625*^9}, {3.520678453140625*^9, 3.5206785016875*^9}, {
   3.52067900346875*^9, 3.520679024265625*^9}, {3.520679085171875*^9, 
   3.520679095203125*^9}, {3.520680148921875*^9, 3.52068015428125*^9}, {
   3.5206803019375*^9, 3.520680304515625*^9}, {3.520680774921875*^9, 
   3.520680776359375*^9}, {3.566943770943053*^9, 3.5669438392831483`*^9}, {
   3.5669439629433217`*^9, 3.5669440173283978`*^9}, 3.5669440569434533`*^9, {
   3.566944088158497*^9, 3.566944106223522*^9}, {3.566944146833579*^9, 
   3.5669441649136047`*^9}, {3.566944242398713*^9, 3.5669442588787355`*^9}, {
   3.583080850068894*^9, 3.5830808723145328`*^9}, {3.5830809437158585`*^9, 
   3.583080954386277*^9}, 3.583080985907132*^9, {3.5836974841651635`*^9, 
   3.583697485465165*^9}, {3.5836975550152626`*^9, 3.583697558755268*^9}, {
   3.5836988052966137`*^9, 3.583698837281658*^9}, {3.583699041566944*^9, 
   3.5836990560469646`*^9}, {3.5836991655501184`*^9, 
   3.5836991923951564`*^9}, {3.583783796849599*^9, 3.583783797969663*^9}, 
   3.60114625309*^9, 3.6011467729781375`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Methods", "Subsection",
 CellChangeTimes->{{3.5151660264375*^9, 3.515166028765625*^9}, {
  3.515449067344125*^9, 3.51544909085975*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakeAnchor", "[", 
     RowBox[{
      RowBox[{"Class", ":", "FigInset"}], ",", "Self_Object"}], "]"}], "[", 
    RowBox[{"Name_", ",", "Arg_"}], "]"}], ":=", 
   RowBox[{"FigMakeAnchorWrapper", "[", 
    RowBox[{
    "Class", ",", "Self", ",", "Name", ",", "Arg", ",", "\[IndentingNewLine]", 
     RowBox[{"FigRectangleAnchor", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Self", "@", 
        RowBox[{"GetCenter", "[", "]"}]}], ",", 
       RowBox[{"Self", "@", 
        RowBox[{"GetRadius", "[", "]"}]}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", "0", ",", "\[IndentingNewLine]", 
       "Name", ",", "Arg"}], "\[IndentingNewLine]", "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakeBoundingBox", "[", 
     RowBox[{
      RowBox[{"Class", ":", "FigInset"}], ",", "Self_Object"}], "]"}], "[", 
    "]"}], ":=", 
   RowBox[{"FigMakeBoundingBoxWrapper", "[", 
    RowBox[{"Class", ",", "Self", ",", "\[IndentingNewLine]", 
     RowBox[{"FigRectangleBoundingBox", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Self", "@", 
        RowBox[{"GetCenter", "[", "]"}]}], ",", 
       RowBox[{"Self", "@", 
        RowBox[{"GetRadius", "[", "]"}]}], ",", 
       RowBox[{"Self", "@", 
        RowBox[{"GetPivot", "[", "]"}]}], ",", 
       RowBox[{"Self", "@", 
        RowBox[{"GetRotation", "[", "]"}]}]}], "\[IndentingNewLine]", "]"}]}],
     "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51517464803125*^9, 3.515174666234375*^9}, {
  3.5151749220625*^9, 3.515174944015625*^9}, {3.51525866915625*^9, 
  3.515258669703125*^9}, {3.51544000385975*^9, 3.5154400110785*^9}, {
  3.515448814344125*^9, 3.515448817391*^9}, {3.515449256562875*^9, 
  3.5154492602035*^9}, {3.51629152640625*^9, 3.51629153790625*^9}, {
  3.519646775296875*^9, 3.5196467861875*^9}, {3.5206779050625*^9, 
  3.520677946484375*^9}, {3.520678367*^9, 3.52067837796875*^9}, {
  3.520679117515625*^9, 3.520679118328125*^9}, {3.52067936646875*^9, 
  3.520679413078125*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["End package", "Section",
 CellChangeTimes->{{3.514823047703125*^9, 3.51482305353125*^9}}],

Cell[CellGroupData[{

Cell["Exit private context", "Subsection",
 CellChangeTimes->{{3.514823086015625*^9, 3.5148231094375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Exit package context", "Subsection",
 CellChangeTimes->{{3.514823092890625*^9, 3.51482312965625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Unprotect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<$*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EndPackage", "[", "]"}], ";"}]}], "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowToolbars->"RulerBar",
WindowSize->{1912, 1092},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
DockedCells->(FrontEndExecute[{
   FrontEnd`NotebookApply[
    FrontEnd`InputNotebook[], #, Placeholder]}]& ),
PrintingCopies->1,
PrintingPageRange->{1, 2},
PageHeaders->{{
   Cell[
    TextData[{
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"], " ", 
      Cell[
      " ", "Header", CellFrame -> {{0.5, 0}, {0, 0}}, CellFrameMargins -> 4], 
      
      Cell[
       TextData[{
         ValueBox["FileName"]}], "Header"]}], 
    CellMargins -> {{0, Inherited}, {Inherited, Inherited}}], None, None}, {
   Cell[
    TextData[{"LevelScheme 3.45 source code"}], "Header"], None, 
   "\"\"Cell[TextData[{Cell[TextData[{ValueBox[\"FileName\"]}], \"Header\"], \
Cell[\" \", \"Header\", CellFrame -> {{0, 0.5}, {0, 0}}, CellFrameMargins -> \
4], \" \", Cell[TextData[{CounterBox[\"Page\"]}], \"PageNumber\"]}], \
CellMargins -> {{Inherited, 0}, {Inh"}},
PrintingOptions->{"FirstPageFooter"->False,
"PrintingMargins"->{{36, 36}, {19.125, 36}}},
ShowSelection->True,
Magnification->1.25,
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 34, 0, 88, "Section"],
Cell[604, 24, 3053, 70, 212, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[3694, 99, 32, 0, 88, "Section"],
Cell[CellGroupData[{
Cell[3751, 103, 109, 1, 46, "Subsection"],
Cell[3863, 106, 1516, 24, 35, "Input",
 InitializationCell->True],
Cell[5382, 132, 184, 5, 35, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[5603, 142, 98, 1, 46, "Subsection"],
Cell[5704, 145, 1747, 30, 58, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[7466, 178, 96, 1, 46, "Subsection"],
Cell[CellGroupData[{
Cell[7587, 183, 43, 0, 35, "Subsection"],
Cell[7633, 185, 183, 4, 35, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[7853, 194, 99, 1, 46, "Subsection"],
Cell[7955, 197, 163, 3, 35, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8167, 206, 183, 3, 88, "Section"],
Cell[CellGroupData[{
Cell[8375, 213, 103, 1, 46, "Subsection"],
Cell[8481, 216, 1391, 25, 256, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[9909, 246, 96, 1, 46, "Subsection"],
Cell[10008, 249, 4696, 95, 432, "Input",
 InitializationCell->True],
Cell[14707, 346, 93, 1, 34, "Text"],
Cell[14803, 349, 1966, 35, 80, "Input",
 InitializationCell->True],
Cell[16772, 386, 173, 4, 55, "Text"],
Cell[16948, 392, 2041, 37, 80, "Input",
 InitializationCell->True],
Cell[18992, 431, 309, 4, 34, "Text"],
Cell[19304, 437, 2206, 41, 84, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[21547, 483, 141, 2, 46, "Subsection"],
Cell[21691, 487, 1222, 28, 102, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[22962, 521, 226, 3, 88, "Section"],
Cell[CellGroupData[{
Cell[23213, 528, 103, 1, 46, "Subsection"],
Cell[23319, 531, 2085, 38, 300, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[25441, 574, 96, 1, 46, "Subsection"],
Cell[25540, 577, 4912, 96, 564, "Input",
 InitializationCell->True],
Cell[30455, 675, 776, 17, 159, "Text"],
Cell[31234, 694, 3978, 73, 260, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[35249, 772, 141, 2, 46, "Subsection"],
Cell[35393, 776, 2166, 50, 256, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[37608, 832, 95, 1, 88, "Section"],
Cell[CellGroupData[{
Cell[37728, 837, 106, 1, 46, "Subsection"],
Cell[37837, 840, 96, 3, 35, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[37970, 848, 107, 1, 46, "Subsection"],
Cell[38080, 851, 406, 12, 80, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
