(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 5.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[    364536,       8002]
NotebookOptionsPosition[    353004,       7635]
NotebookOutlinePosition[    354419,       7680]
CellTagsIndexPosition[    354376,       7677]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Header comments", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", "FigPanel"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "SciDraw`"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{"Panel", " ", "object"}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Author", ":", " ", 
      RowBox[{"Mark", " ", 
       RowBox[{"A", ".", " ", "Caprio"}]}]}]}], ",", " ", 
    RowBox[{"Department", " ", "of", " ", "Physics"}], ",", " ", 
    RowBox[{"University", " ", "of", " ", "Notre", " ", "Dame"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "FIGYEAR"}]}]}], ",", " ", 
    RowBox[{"Mark", " ", 
     RowBox[{"A", ".", " ", "Caprio"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "FIGVERSION"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "MATHVERSION"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Discussion", ":", " ", "FIGDISCUSSION"}]}], " ", "*)"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"See", " ", "package", " ", "information", " ", 
      RowBox[{"file", "."}]}]}]}], " ", "*)"}]}]], "Input",
 InitializationCell->True,
 AutoIndent->False,
 CellChangeTimes->{{3.395093723328125*^9, 3.39509375184375*^9}, {
   3.398545735296875*^9, 3.39854574365625*^9}, 3.398799700609375*^9, {
   3.43024739209375*^9, 3.43024739990625*^9}, 3.430247813015625*^9, {
   3.436819738734375*^9, 3.436819746828125*^9}, 3.436820195484375*^9, {
   3.4439959535*^9, 3.4439959773125*^9}, {3.471089562875*^9, 
   3.471089568359375*^9}, {3.471089636203125*^9, 3.471089639046875*^9}, {
   3.48681044459375*^9, 3.4868104458125*^9}, {3.489687811140625*^9, 
   3.489687812484375*^9}, {3.497222348765625*^9, 3.497222354953125*^9}, 
   3.497224390546875*^9, {3.497299514859375*^9, 3.497299515046875*^9}, {
   3.49903536659375*^9, 3.49903536784375*^9}, {3.503265433671875*^9, 
   3.5032654415*^9}, {3.50612390383225*^9, 3.5061239087385*^9}, 
   3.507509920109375*^9, {3.51481857221875*^9, 3.514818754140625*^9}, 
   3.514822657671875*^9, {3.514823216234375*^9, 3.51482323709375*^9}, {
   3.51482326921875*^9, 3.514823311671875*^9}, {3.514823375546875*^9, 
   3.514823396890625*^9}, {3.5150157685*^9, 3.51501576865625*^9}, 
   3.515275347609375*^9, {3.51542285160975*^9, 3.515422853937875*^9}, {
   3.515509659671875*^9, 3.51550966715625*^9}, {3.51578134215625*^9, 
   3.5157813479375*^9}, {3.5929464626424336`*^9, 3.592946507977497*^9}},
 LanguageCategory->"NaturalLanguage"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin package", "Section"],

Cell[CellGroupData[{

Cell["Package context definition", "Subsection",
 CellChangeTimes->{{3.5156004945*^9, 3.515600496921875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<SciDraw`\>\"", ",", "SciDraw`Private`$ExternalContexts"}], 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.395087747453125*^9, 3.39508775096875*^9}, {
   3.39509064290625*^9, 3.395090643234375*^9}, 3.395090710546875*^9, {
   3.395091175015625*^9, 3.395091179703125*^9}, {3.395093472375*^9, 
   3.39509347784375*^9}, {3.395093608140625*^9, 3.3950936085*^9}, {
   3.395519039875*^9, 3.395519061546875*^9}, {3.495041989453125*^9, 
   3.495042010953125*^9}, {3.495042158078125*^9, 3.495042163671875*^9}, {
   3.497222416421875*^9, 3.497222462578125*^9}, {3.497222963890625*^9, 
   3.497222994640625*^9}, 3.497223030953125*^9, {3.514818766734375*^9, 
   3.514818800625*^9}, {3.5148197104375*^9, 3.514819710671875*^9}, {
   3.514819841546875*^9, 3.51481994284375*^9}, {3.514819979578125*^9, 
   3.514820025046875*^9}, {3.5148201316875*^9, 3.514820154671875*^9}, {
   3.51482025234375*^9, 3.514820275171875*^9}, {3.514820309703125*^9, 
   3.514820406921875*^9}, {3.51482051775*^9, 3.514820571328125*^9}, {
   3.514820843296875*^9, 3.51482087146875*^9}, 3.51482140903125*^9, {
   3.514821446859375*^9, 3.514821449890625*^9}, 3.514821641390625*^9, {
   3.514821674609375*^9, 3.514821798390625*^9}, {3.514823407859375*^9, 
   3.514823433140625*^9}, 3.51501104184375*^9, 3.515275343*^9, {
   3.515276331390625*^9, 3.51527633303125*^9}, {3.51542275479725*^9, 
   3.515422755141*^9}, {3.51542391860975*^9, 3.51542393423475*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Unprotect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}], ";"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Object usage", "Subsection",
 CellChangeTimes->{{3.515788239328125*^9, 3.5157882413125*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FigAxis", "::", "usage"}], "=", 
   "\"\<FIGURE OBJECT: FigAxis[side,coordinate,range] generates an standalone \
axis.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigurePanel", "::", "usage"}], "=", 
   "\"\<FIGURE OBJECT: FigurePanel[body] generates a figure panel.  A region \
option may be specified as (1) PanelRegion->All for the full current window \
(default), (2) PanelRegion->{{x1,x2},{y1,y2}} for a coordinate region, (3) \
PanelRegion->Scaled[{{xs1,xs2},{ys1,ys2}}] for scaled coordinates relative to \
the current window, or (4) PanelRegion->Canvas[{{xc1,xc2},{yc1,yc2}}] for \
canvas coordinates.  Within a Multipanel array, FigurePanel[body,{row,col}] \
generates a panel with the given with row and column indices.  The argument \
{row,col} may be a pattern or All, for iteration over multipanel \
array.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Multipanel", "::", "usage"}], "=", 
   "\"\<FIGURE OBJECT: Multpanel[body] generates a multipanel array.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PanelRegion", "::", "usage"}], "=", 
   "\"\<Option name for use with FigurePanel and Multipanel.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LockPanelScale", "::", "usage"}], "=", 
   "\"\<Option name for use with FigurePanel and Multipanel.\>\""}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515429606016*^9, 3.5154296174535*^9}, {
   3.515429686281625*^9, 3.515429784531625*^9}, {3.515449185687875*^9, 
   3.5154492152035*^9}, {3.51544974992225*^9, 3.51544978429725*^9}, {
   3.51544992735975*^9, 3.515449931437875*^9}, {3.515529961828125*^9, 
   3.5155300071875*^9}, {3.5155300671875*^9, 3.51553013075*^9}, {
   3.51553223328125*^9, 3.5155322396875*^9}, {3.51578136028125*^9, 
   3.515781439671875*^9}, {3.515781479515625*^9, 3.515781552421875*^9}, {
   3.515781973671875*^9, 3.51578204590625*^9}, {3.5157850370625*^9, 
   3.515785100078125*^9}, {3.5157882448125*^9, 3.51578826228125*^9}, {
   3.516298963453125*^9, 3.51629897953125*^9}, {3.5166391005506773`*^9, 
   3.5166391265506773`*^9}, 3.518018985*^9, {3.520021725265625*^9, 
   3.520021752859375*^9}, {3.520446151015625*^9, 3.52044623325*^9}, {
   3.53140173665625*^9, 3.531401746328125*^9}, {3.53140190434375*^9, 
   3.531401910015625*^9}, {3.549723530765625*^9, 3.54972354178125*^9}, {
   3.549726817171875*^9, 3.549726840015625*^9}, {3.583099235527495*^9, 
   3.5830992480575123`*^9}, {3.5830992895275707`*^9, 
   3.5830993785226955`*^9}, {3.622841768328802*^9, 3.622841774553213*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Other usage", "Subsection",
 CellChangeTimes->{{3.5157909549375*^9, 3.51579095871875*^9}}],

Cell["Utilities", "Text",
 CellChangeTimes->{{3.520452358453125*^9, 3.520452360390625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"CurrentMultipanel", "::", "usage"}], "=", 
   "\"\<CurrentMultipanel[] returns the current multipanel object (or None if \
none).\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetByPanelRow", "::", "usage"}], "=", 
   "\"\<SetByPanelRow[var,{value1,...}] sets variable values according to the \
current multipanel row.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetByPanelColumn", "::", "usage"}], "=", 
   "\"\<SetByPanelColumn[var,{value1,...}] sets variable values according to \
the current multipanel column.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetByPanelIndices", "::", "usage"}], "=", 
   "\"\<SetByPanelIndices[var,{value1,...}] or \
SetByPanelIndices[var,{patt1->val1,...}] sets variable values according to \
the current multipanel (row,column) indices.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SetByPanelSequence", "::", "usage"}], "=", 
    "\"\<SetByPanelSequence[var,{value1,...}] sets variable values according \
to the current multipanel sequence number.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ByPanelRow", "::", "usage"}], "=", 
   "\"\<ByPanelRow[{value1,...}] returns values according to the current \
multipanel row.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ByPanelColumn", "::", "usage"}], "=", 
   "\"\<ByPanelColumn[{value1,...}] returns values according to the current \
multipanel column.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ByPanelIndices", "::", "usage"}], "=", 
   "\"\<ByPanelIndices[{value1,...}] or ByPanelIndices[{patt1->val1,...}] \
returns values according to the current multipanel (row,column) \
indices.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ByPanelSequence", "::", "usage"}], "=", 
   "\"\<ByPanelSequence[{value1,...}] returns values according to the current \
multipanel sequence number.\>\""}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.520452377296875*^9, 3.52045240034375*^9}, {
  3.526574573015625*^9, 3.526574650828125*^9}, {3.527710976109375*^9, 
  3.527710990265625*^9}, {3.5738213571718636`*^9, 3.57382138938592*^9}, {
  3.583188482490713*^9, 3.5831884959134197`*^9}, {3.5854246699643087`*^9, 
  3.585424706884361*^9}, {3.609419456018732*^9, 3.6094195063788033`*^9}}],

Cell["Options", "Text",
 CellChangeTimes->{{3.516459075765625*^9, 3.516459076515625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"TailExtension", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.  Specifies the distance a \
figure object curve's tail should be extended from the given endpoint.\>\""}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"HeadExtension", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.  Specifies the distance a \
figure object curve's head should be extended from the given endpoint.\>\""}],
   ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ShowTicks", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TickFontSizeFactor", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TickLengthReference", "::", "usage"}], "=", 
    "\"\<Option name for use with figure objects.\>\""}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"TickLengthScale", "::", "usage"}], "=", 
     "\"\<Option name for use with figure objects. -- taken from \
CustomTicks\>\""}], ";"}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TickLabelAllowance", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.516294993484375*^9, {3.516296090390625*^9, 3.51629610525*^9}, {
   3.516296371578125*^9, 3.516296382125*^9}, {3.516297369140625*^9, 
   3.516297375890625*^9}, {3.5163006489375*^9, 3.516300654984375*^9}, {
   3.533750923171875*^9, 3.5337509313125*^9}, {3.596284661263804*^9, 
   3.5962846660998125`*^9}, {3.596582765054302*^9, 3.5965827817307315`*^9}, {
   3.5965828854085135`*^9, 3.596582890899723*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"BackgroundOpacity", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"BackgroundDirectives", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"XPlotRange", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"YPlotRange", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ExtendRange", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"XExtendRange", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"YExtendRange", "::", "usage"}], "=", 
    "\"\<Option name for use with figure objects.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PanelLetter", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PanelLetterPosition", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PanelLetterBase", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PanelLetterOrigin", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PanelLetterDimensions", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PanelLetterCorrection", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PanelLetterDelimiters", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PanelLetterDirection", "::", "usage"}], "=", 
    "\"\<Option name for use with figure objects.\>\""}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"Frame", "::", "usage"}], "=."}], ".."}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"XFrame", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"YFrame", "::", "usage"}], "=", 
    "\"\<Option name for use with figure objects.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"PanelEdgeExterior", "::", "usage"}], "=", 
    "\"\<Option name for use with figure objects.\>\""}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"FrameLabel", "::", "usage"}], "=."}], ".."}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"XFrameLabel", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"YFrameLabel", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ShowFrameLabel", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"XShowFrameLabel", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"YShowFrameLabel", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FrameLabelPosition", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"XFrameLabelPosition", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"YFrameLabelPosition", "::", "usage"}], "=", 
    "\"\<Option name for use with figure objects.\>\""}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
     RowBox[{"Ticks", "::", "usage"}], "=."}], ".."}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"XTicks", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"YTicks", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ShowTicks", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"XShowTicks", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"YShowTicks", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ShowTickLabels", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"XShowTickLabels", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"YShowTickLabels", "::", "usage"}], "=", 
    "\"\<Option name for use with figure objects.\>\""}], ";"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ExteriorEdgeMask", "::", "usage"}], "=", 
    "\"\<Option name for use with figure objects.  (DEPRECATED)\>\""}], ";"}],
   "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"XPanelSizes", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"YPanelSizes", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"XPanelGaps", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"YPanelGaps", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"XPanelGapsExterior", "::", "usage"}], "=", 
   "\"\<Option name for use with figure objects.\>\""}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"YPanelGapsExterior", "::", "usage"}], "=", 
    "\"\<Option name for use with figure objects.\>\""}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"TickListSpecificationPattern", "::", "usage"}], "=", 
   "\"\<Pattern which matches possible tick list specifications -- a list \
which is recognizably a list of ticks or any nonlist expression (which could \
conceivably be None, Automatic, the name of a tick generation function, or a \
lambda function).\>\""}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515790961484375*^9, 3.515790978484375*^9}, {
   3.515791292734375*^9, 3.515791302234375*^9}, {3.5157917800625*^9, 
   3.515791795109375*^9}, {3.515792397765625*^9, 3.515792400921875*^9}, {
   3.51586605378125*^9, 3.51586606121875*^9}, {3.515879989578125*^9, 
   3.515879995296875*^9}, {3.515880116671875*^9, 3.515880121453125*^9}, {
   3.51639061096875*^9, 3.516390617234375*^9}, {3.5163950143125*^9, 
   3.516395017890625*^9}, {3.5163961373125*^9, 3.51639615334375*^9}, {
   3.51639623853125*^9, 3.516396242109375*^9}, {3.51639637028125*^9, 
   3.516396373875*^9}, {3.516397184328125*^9, 3.516397283421875*^9}, {
   3.516399545765625*^9, 3.516399552109375*^9}, {3.51639960103125*^9, 
   3.516399607578125*^9}, {3.5163997420625*^9, 3.51639980390625*^9}, {
   3.516400443890625*^9, 3.5164004521875*^9}, {3.51640148046875*^9, 
   3.516401489796875*^9}, {3.5164018345*^9, 3.516401845765625*^9}, {
   3.516456061265625*^9, 3.516456085484375*^9}, {3.51645669125*^9, 
   3.51645669696875*^9}, {3.516458892359375*^9, 3.5164589480625*^9}, {
   3.516461795734375*^9, 3.5164617965625*^9}, {3.516555318671875*^9, 
   3.51655533378125*^9}, {3.516556175859375*^9, 3.51655618909375*^9}, {
   3.516556785875*^9, 3.51655678996875*^9}, {3.516561973265625*^9, 
   3.516561984078125*^9}, 3.517776363140625*^9, 3.5177766925625*^9, 
   3.518474503359375*^9, {3.52046216809375*^9, 3.520462202671875*^9}, {
   3.520524544984375*^9, 3.520524565953125*^9}, {3.520526075484375*^9, 
   3.520526111703125*^9}, {3.52052615725*^9, 3.520526161078125*^9}, {
   3.520526217671875*^9, 3.520526220390625*^9}, 3.520526756671875*^9, {
   3.520527522578125*^9, 3.520527526421875*^9}, {3.520528392375*^9, 
   3.52052840346875*^9}, {3.520529053640625*^9, 3.520529054765625*^9}, {
   3.557255362546875*^9, 3.55725537309375*^9}, {3.583080615245263*^9, 
   3.5830806311104913`*^9}, {3.585077641581234*^9, 3.585077646883816*^9}, {
   3.611083023749121*^9, 3.6110830312815523`*^9}, {3.6216347624910393`*^9, 
   3.621634764572158*^9}}],

Cell["Global variables", "Text",
 CellChangeTimes->{{3.5258830746875*^9, 3.525883078078125*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"PanelColumnIndex", "::", "usage"}], "=", 
   "\"\<Parameter defined within FigPanel.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PanelRowIndex", "::", "usage"}], "=", 
   "\"\<Parameter defined within FigPanel.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PanelIndices", "::", "usage"}], "=", 
   "\"\<Parameter defined within FigPanel.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PanelSequenceNumber", "::", "usage"}], "=", 
   "\"\<Parameter defined within FigPanel.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PanelColumns", "::", "usage"}], "=", 
   "\"\<Parameter defined within Multipanel.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"PanelRows", "::", "usage"}], "=", 
   "\"\<Parameter defined within Multipanel.\>\""}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.52588308359375*^9, 3.52588310721875*^9}, {
  3.5258833040625*^9, 3.525883318265625*^9}, {3.5264813415*^9, 
  3.52648136290625*^9}, {3.527276198484375*^9, 3.52727620334375*^9}, {
  3.527710901*^9, 3.527710907421875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin private context", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.514823442859375*^9, 3.5148234431875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Dependencies", "Subsection",
 CellChangeTimes->{{3.514821147359375*^9, 3.51482114978125*^9}}],

Cell[BoxData[""], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51482113128125*^9, 3.514821158515625*^9}, {
  3.514823452421875*^9, 3.51482349575*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Utilities", "Section",
 CellChangeTimes->{{3.516464242875*^9, 3.516464244875*^9}}],

Cell[CellGroupData[{

Cell["Tick matching", "Subsection",
 CellChangeTimes->{{3.516464246890625*^9, 3.516464248984375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"TickListSpecificationPattern", "=", 
   RowBox[{"NonListPattern", "|", 
    RowBox[{"(", 
     RowBox[{"_", "?", "TickListQ"}], ")"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5164642513125*^9, 3.51646426575*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Extraction of option from array", "Subsection",
 CellChangeTimes->{{3.520458454453125*^9, 3.520458461703125*^9}}],

Cell["Retrieval of individual edge or panel options", "Text",
 CellChangeTimes->{{3.520454114046875*^9, 3.520454121296875*^9}, {
  3.520458467265625*^9, 3.520458468671875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ExtractOptionsEntry", "[", 
    RowBox[{"CompositeOptions_", ",", 
     RowBox[{"{", 
      RowBox[{"r_Integer", ",", "s_Integer"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Replace", "[", 
    RowBox[{"CompositeOptions", ",", 
     RowBox[{
      RowBox[{"Rule", "[", 
       RowBox[{"Option_", ",", "Value_"}], "]"}], ":>", 
      RowBox[{"Rule", "[", 
       RowBox[{"Option", ",", 
        RowBox[{"Value", "[", 
         RowBox[{"[", 
          RowBox[{"r", ",", "s"}], "]"}], "]"}]}], "]"}]}], ",", 
     RowBox[{"{", "1", "}"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.520458380921875*^9, 3.520458406390625*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["FigurePanel option set", "Section",
 CellChangeTimes->{{3.52042991503125*^9, 3.5204299163125*^9}, {
  3.52043862846875*^9, 3.520438630359375*^9}, {3.5205243418125*^9, 
  3.52052434253125*^9}}],

Cell[CellGroupData[{

Cell["FigurePanel option notes", "Subsection",
 CellChangeTimes->{{3.520429918703125*^9, 3.520429921125*^9}, {
  3.52045163140625*^9, 3.52045163228125*^9}, {3.520524345078125*^9, 
  3.52052434571875*^9}}],

Cell["\<\
Whole-panel options
\tFigObject options
\tPanelRegion
\tbackground options
\t...\
\>", "Text",
 CellChangeTimes->{{3.5204298285*^9, 3.52042986403125*^9}, {
  3.520429931578125*^9, 3.520429937234375*^9}, {3.54972356784375*^9, 
  3.549723613234375*^9}}],

Cell["\<\
Option\t\t\t# values\tSame/Unique\tMirroring\t\tDefault\tFiller\t\tAxis analog

PlotRange\t\t\t2\t
PlotRangePadding\t\t2x2 special handling\t\t\t\t

Frame\t\t\t\t2x2\tS\t{XY}->{{YY}{XX}}\tTrue\t\t--\t\tShow\t\t\t

FrameLabel\t\t\t2x2\tU\t{XY}->{{YY}{XX}}    \tNone\t\tNone\t\tAxisLabel\t\t\
CONVENIENCE
ShowFrameLabel\t\t2x2\tS\t{XY}->{{Y-}{X-}}\t\tExterior\t--\t\t\t\t\tMASK
\tnominally \[OpenCurlyDoubleQuote]redundant\[CloseCurlyDoubleQuote] to \
FrameShowText, but convenient for multipanel exterior masking
FrameLabelPosition\t\t2x2\tS\t{XY}->{{YY}{XX}}\t{}\t\t--\t\tAxisLabelPosition\
\tCONVENIENCE
FrameShowText, etc.\t\t2x2\tS\t{XY}->{{YY}{XX}}\tDefault\t--\t\tAxisShowText\t\
\tCONVENIENCE

[Frame]Ticks\t\t\t2x2\tU\t{XY}->{{YY}{XX}}\tAutomatic\tNone\t\tTicks
TickLabelRange\t\t2x2\tU\t{XY}->{{YY}{XX}}\tAutomatic\t--\t\tTickLabelRange
Show[Frame]Ticks\t\t2x2\tS\t{XY}->{{YY}{XX}}\tTrue\t\t--\t\t(ShowTicks)\t\tMASK
Show[Frame]TickLabels\t2x2\tS\t{XY}->{{Y-}{X-}}\t\tTrue\t\tFalse\t\t\
ShowTickLabels
FrameTickShowText, etc.

PanelEdgeExterior                 2x2     S\t{XY}->{{YY}{XX}}           \
Automatic\t--\t\t\t\tMASK 

-- for Filler indicates mirroring for secondary axis

Alternate scenario:
\tPro -- allows user to immediately specify right and top frame labels, \
without changing the ShowFrameLabel mask
\tCon -- doesn\[CloseCurlyQuote]t allow those labels to come from XFrameLabel \
and YFrameLabel and is nonparallel to the treatment of ShowTickLabels by \
boolean masking
FrameLabel\t\t\t2x2\tU\t{XY}->{{Y-}{X-}}    \tNone\t\tNone\t\tAxisLabel\t\t\
CONVENIENCE
ShowFrameLabel\t\t2x2\tS\t{XY}->{{YY}{XX}}\tExterior\t--\t\t\t\t\tMASK


Filler is irrelevant for S-style parameters with mirroring.
A single value None (if allowed by pattern) will propagate automatically.\
\>", "Text",
 CellChangeTimes->{{3.51639510321875*^9, 3.51639525675*^9}, {
   3.516395969125*^9, 3.516395969890625*^9}, {3.51639609078125*^9, 
   3.516396108625*^9}, {3.51639625365625*^9, 3.51639625859375*^9}, {
   3.51639634984375*^9, 3.516396353546875*^9}, {3.51639649340625*^9, 
   3.516396706671875*^9}, {3.5163967530625*^9, 3.51639691665625*^9}, {
   3.5163971496875*^9, 3.516397152375*^9}, {3.51639732721875*^9, 
   3.5163973625625*^9}, {3.5163974015625*^9, 3.51639740434375*^9}, {
   3.516397448546875*^9, 3.516397611546875*^9}, {3.51639768715625*^9, 
   3.51639784946875*^9}, 3.51640011790625*^9, {3.516401969640625*^9, 
   3.5164019746875*^9}, {3.516402193125*^9, 3.516402194734375*^9}, {
   3.516404136203125*^9, 3.51640415540625*^9}, {3.51646705271875*^9, 
   3.516467199734375*^9}, {3.51655498196875*^9, 3.516555012609375*^9}, {
   3.51655511671875*^9, 3.516555156265625*^9}, 3.5165553451875*^9, {
   3.5165618978125*^9, 3.5165619055625*^9}, {3.516562008*^9, 
   3.5165620181875*^9}, {3.52053050403125*^9, 3.520530531765625*^9}, {
   3.579103553494161*^9, 3.5791035753341913`*^9}, {3.579103621334256*^9, 
   3.579103623344259*^9}, {3.579103715184387*^9, 3.5791037451544294`*^9}, {
   3.5791037778044753`*^9, 3.5791037943744984`*^9}, {3.6110824824935617`*^9, 
   3.6110825105639935`*^9}, 3.6110825424419827`*^9, {3.6110826448923063`*^9, 
   3.6110826786365747`*^9}, {3.611082777620595*^9, 3.611082810939857*^9}, {
   3.6110829428594947`*^9, 3.6110829436985426`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Option descriptor list", "Subsection",
 CellChangeTimes->{{3.52043001965625*^9, 3.52043002121875*^9}, {
  3.520438636984375*^9, 3.52043864134375*^9}}],

Cell["\<\
Each entry is of the form:
\t{option,default,1,pattern} -- option which applies to whole panel (no \
derived suboptions)
\t{option,default,2,pattern,xymode} -- option which applies to \
horizontal/vertical directions (suboptions X and Y)
\t{option,default,4,pattern,xymode,mirror} -- option which applies to each \
edge (suboptions X, Y, XX, and YY)

xymode:
\tPanelOptionXYUnique -- separate values must be given for X and Y (except \
the single value None may be given, presuming that is a legitimate value)
\tPanelOptionXYSame -- if a single value is given, it is used for both X and \
Y
\tPanelOptionXYRange -- special treatment for region extension parameters

mirror:
\tPanelOptionMirror -- if no value is given for the XX and YY axes, value is \
taken from X and Y axes
\tvalue -- if no value is given for the XX and YY axes, this given value is \
used\
\>", "Text",
 CellChangeTimes->{{3.520526240515625*^9, 3.520526563234375*^9}, {
  3.549727040921875*^9, 3.54972704153125*^9}, {3.5791034784340563`*^9, 
  3.5791034837040634`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FigurePanelOptionSet", "=", 
   RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"**", "**", " ", "whole"}], "-", 
      RowBox[{"panel", " ", "options"}]}], " ", "*****)"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{"INHERITED", ":", " ", 
      RowBox[{"all", " ", "FigObject", " ", "options"}]}], " ", "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"SPECIAL", ":", " ", 
        RowBox[{"object", " ", 
         RowBox[{"name", " ", "--"}], " ", "default", " ", "effectively", " ",
          "ObjectName"}]}], " ", "\[Rule]", " ", "None"}], ",", " ", 
      RowBox[{"but", " ", "given", " ", "special", " ", "handling"}], ",", 
      " ", 
      RowBox[{"not", " ", "in", " ", 
       RowBox[{"Options", "[", "FigurePanel", "]"}]}]}], " ", "*)"}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{"(*", " ", "region", " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"PanelRegion", ",", "All", ",", "1", ",", "FigRegionPattern"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "LockPanelScale", ",", "False", ",", "1", ",", "LogicalPattern"}], 
      "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", "background", " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Background", ",", "None", ",", "1", ",", 
       RowBox[{"None", "|", "ColorDirectivePattern"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"BackgroundOpacity", ",", "None", ",", "1", ",", 
       RowBox[{"None", "|", "UnitIntervalPattern"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"BackgroundDirectives", ",", 
       RowBox[{"{", "}"}], ",", "1", ",", "_List"}], "}"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"panel", " ", "letter", " ", "label"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"PanelLetter", ",", "Automatic", ",", "1", ",", "_"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"PanelLetterPosition", ",", "Automatic", ",", "1", ",", 
       RowBox[{"Automatic", "|", 
        RowBox[{"_", "?", "NumericQ"}], "|", "_List"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Sequence", "@@", 
      RowBox[{"Replace", "[", "\[IndentingNewLine]", 
       RowBox[{"BaseTextOptionList", ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Option_", ",", "Patt_"}], "}"}], "\[RuleDelayed]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"SidifyOptionName", "[", "\"\<PanelLetter\>\"", "]"}], 
            "[", "Option", "]"}], ",", "Default", ",", "1", ",", 
           RowBox[{"Default", "|", "Patt"}]}], "}"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", "1", "}"}]}], "\[IndentingNewLine]", "]"}]}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"panel", " ", "letter", " ", "sequence"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"PanelLetterBase", ",", "\"\<a\>\"", ",", "1", ",", 
       RowBox[{
        RowBox[{"(", "s_String", ")"}], "/;", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"StringLength", "[", "s", "]"}], "\[Equal]", "1"}], 
         ")"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"PanelLetterOrigin", ",", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}], ",", "1", ",", 
       RowBox[{"{", 
        RowBox[{"_Integer", ",", "_Integer"}], "}"}]}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"PanelLetterDimensions", ",", "Automatic", ",", "1", ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"_Integer", ",", "_Integer"}], "}"}], "|", "Automatic"}]}], 
      "}"}], ",", "  ", 
     RowBox[{"(*", " ", "TODO", " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"PanelLetterCorrection", ",", "0", ",", "1", ",", "_Integer"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"PanelLetterDelimiters", ",", 
       RowBox[{"{", 
        RowBox[{"\"\<(\>\"", ",", "\"\<)\>\""}], "}"}], ",", "1", ",", 
       RowBox[{"{", 
        RowBox[{"_", ",", "_"}], "}"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"PanelLetterDirection", ",", "Horizontal", ",", "1", ",", 
       RowBox[{"Horizontal", "|", "Vertical"}]}], "}"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"exterior", " ", "edge", " ", "mask"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"ExteriorEdgeMask", ",", "Automatic", ",", "1", ",", 
       RowBox[{"Automatic", "|", "LogicalPattern", "|", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"LogicalPattern", ",", "LogicalPattern"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"LogicalPattern", ",", "LogicalPattern"}], "}"}]}], 
         "}"}]}]}], "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     
     RowBox[{"(*", " ", 
      RowBox[{"panel", " ", "content", " ", "rendering"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"note", ":", " ", 
       RowBox[{"options", " ", "for", " ", "FigCompositeElement"}]}], " ", 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Clip", ",", "True", ",", "1", ",", "LogicalPattern"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Rasterize", ",", "False", ",", "1", ",", "LogicalPattern"}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"ImageResolution", ",", "300", ",", "1", ",", 
       RowBox[{"_", "?", "Positive"}]}], "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"panel", " ", "geometry"}], " ", "*)"}], "\[IndentingNewLine]", 
     
     RowBox[{"{", 
      RowBox[{
      "RegionExtension", ",", "None", ",", "1", ",", 
       "FigDeltaRegionPattern"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "RegionDisplacement", ",", "None", ",", "1", ",", 
       "FigDisplacementPattern"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"**", "**", " ", "plot"}], " ", "range", " ", "options"}], " ",
       "*****)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"PlotRange", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", "2", ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"_", "?", "NumericQ"}], ",", 
         RowBox[{"_", "?", "NumericQ"}]}], "}"}], ",", 
       "PanelOptionXYUnique"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "ExtendRange", ",", "None", ",", "2", ",", "IntervalParametersPattern", 
       ",", "PanelOptionXYRange"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", 
      RowBox[{
       RowBox[{"**", "**", " ", "edge"}], " ", "options"}], " ", "*****)"}], 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"frame", " ", "edge", " ", "rendering"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "Frame", ",", "True", ",", "4", ",", "LogicalPattern", ",", 
       "PanelOptionXYSame", ",", "PanelOptionMirror"}], "}"}], ",", " ", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"frame", " ", "edge", " ", "masking"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"PanelEdgeExterior", ",", "Automatic", ",", "4", ",", 
       RowBox[{"Automatic", "|", "LogicalPattern"}], ",", "PanelOptionXYSame",
        ",", "PanelOptionMirror"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"frame", " ", "labels"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{"note", ":", " ", 
        RowBox[{
        "List", " ", "forbidden", " ", "as", " ", "frame", " ", "label", " ", 
         "to", " ", "improve", " ", "option", " ", "validation", " ", "in", 
         " ", "Multipanel"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{
       "Rule", " ", "and", " ", "RuleDelayed", " ", "forbidden", " ", "to", 
        " ", "allow", " ", "list", " ", "of", " ", "rule", " ", "values", " ",
         "to", " ", "work", " ", "for", " ", "FrameLabel"}]}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"FrameLabel", ",", "None", ",", "4", ",", 
       RowBox[{"Except", "[", 
        RowBox[{"_List", "|", "_Rule", "|", "_RuleDelayed"}], "]"}], ",", 
       "PanelOptionXYUnique", ",", "PanelOptionMirror"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"ShowFrameLabel", ",", "Exterior", ",", "4", ",", 
       RowBox[{"Exterior", "|", "LogicalPattern"}], ",", "PanelOptionXYSame", 
       ",", "False"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"FrameLabelPosition", ",", "Automatic", ",", "4", ",", 
       RowBox[{"Automatic", "|", 
        RowBox[{"(", 
         RowBox[{"_", "?", "NumericQ"}], ")"}]}], ",", "PanelOptionXYSame", 
       ",", "PanelOptionMirror"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"TickLabelAllowance", ",", "Automatic", ",", "4", ",", 
       RowBox[{"Automatic", "|", "NonNegativePattern"}], ",", 
       "PanelOptionXYSame", ",", "PanelOptionMirror"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{"...", " ", 
        RowBox[{"FrameTextXXXX", "/", "FrameFontXXXX"}]}], " ", "..."}], " ", 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{"Sequence", "@@", 
      RowBox[{"Replace", "[", "\[IndentingNewLine]", 
       RowBox[{"BaseTextOptionList", ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Option_", ",", "Patt_"}], "}"}], "\[RuleDelayed]", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{
            RowBox[{"SidifyOptionName", "[", "\"\<Frame\>\"", "]"}], "[", 
            "Option", "]"}], ",", "Default", ",", "4", ",", 
           RowBox[{"Default", "|", "Patt"}], ",", "PanelOptionXYSame", ",", 
           "PanelOptionMirror"}], "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{"{", "1", "}"}]}], "\[IndentingNewLine]", "]"}]}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"frame", " ", "ticks"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "Ticks", ",", "Automatic", ",", "4", ",", 
       "TickListSpecificationPattern", ",", "PanelOptionXYUnique", ",", 
       "PanelOptionMirror"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"TickLabelRange", ",", "Automatic", ",", "4", ",", 
       RowBox[{"Automatic", "|", "All", "|", "NumericalPairPattern"}], ",", 
       "PanelOptionXYUnique", ",", "PanelOptionMirror"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "ShowTicks", ",", "True", ",", "4", ",", "LogicalPattern", ",", 
       "PanelOptionXYSame", ",", "PanelOptionMirror"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"ShowTickLabels", ",", "Exterior", ",", "4", ",", 
       RowBox[{"Exterior", "|", "LogicalPattern"}], ",", "PanelOptionXYSame", 
       ",", "False"}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "TickFontSizeFactor", ",", "0.85", ",", "4", ",", "NonNegativePattern", 
       ",", "PanelOptionXYSame", ",", "PanelOptionMirror"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"TickLengthReference", ",", "Automatic", ",", "4", ",", 
       RowBox[{"Automatic", "|", "NonNegativePattern"}], ",", 
       "PanelOptionXYSame", ",", "PanelOptionMirror"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "TickLengthScale", ",", "1", ",", "4", ",", "NonNegativePattern", ",", 
       "PanelOptionXYSame", ",", "PanelOptionMirror"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{"...", " ", 
        RowBox[{"TickTextXXXX", "/", "TickFontXXXX"}]}], " ", "..."}], " ", 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"note", ":", " ", 
       RowBox[{"special", " ", "treatment", " ", "of", " ", "font", " ", 
        RowBox[{"size", " ", "--"}], " ", "Automatic", " ", "for", " ", 
        "reduced", " ", "tick", " ", "font", " ", "size"}]}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"Sequence", "@@", 
      RowBox[{"Replace", "[", "\[IndentingNewLine]", 
       RowBox[{"BaseTextOptionList", ",", "\[IndentingNewLine]", 
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Option", ":", "FontSize"}], ",", "Patt_"}], "}"}], 
           "\[RuleDelayed]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"SidifyOptionName", "[", "\"\<Tick\>\"", "]"}], "[", 
              "Option", "]"}], ",", "Automatic", ",", "4", ",", 
             RowBox[{"Automatic", "|", "Default", "|", "Patt"}], ",", 
             "PanelOptionXYSame", ",", "PanelOptionMirror"}], "}"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Option_", ",", "Patt_"}], "}"}], "\[RuleDelayed]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"SidifyOptionName", "[", "\"\<Tick\>\"", "]"}], "[", 
              "Option", "]"}], ",", "Default", ",", "4", ",", 
             RowBox[{"Default", "|", "Patt"}], ",", "PanelOptionXYSame", ",", 
             "PanelOptionMirror"}], "}"}]}]}], "\[IndentingNewLine]", "}"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"{", "1", "}"}]}], "\[IndentingNewLine]", "]"}]}]}], 
    "\[IndentingNewLine]", "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515100688734375*^9, 3.515100745765625*^9}, {
   3.515101427609375*^9, 3.5151014280625*^9}, {3.51510147303125*^9, 
   3.515101489109375*^9}, {3.515160263390625*^9, 3.51516026428125*^9}, {
   3.51516080484375*^9, 3.51516081109375*^9}, {3.515429856500375*^9, 
   3.515429878125375*^9}, {3.5154307895785*^9, 3.515430808375375*^9}, {
   3.51543131279725*^9, 3.51543134560975*^9}, {3.5154491619535*^9, 
   3.515449178391*^9}, {3.51544979217225*^9, 3.51544979648475*^9}, {
   3.515449839641*^9, 3.5154498768285*^9}, {3.51553014021875*^9, 
   3.515530194296875*^9}, {3.5155325434375*^9, 3.515532544421875*^9}, 
   3.515775615828125*^9, {3.515781907078125*^9, 3.515781955484375*^9}, {
   3.515785111484375*^9, 3.515785137171875*^9}, {3.515787491671875*^9, 
   3.515787494125*^9}, 3.515787973390625*^9, {3.515788030765625*^9, 
   3.515788034984375*^9}, 3.51578807775*^9, {3.515789660203125*^9, 
   3.5157896656875*^9}, {3.51579082725*^9, 3.515790854546875*^9}, {
   3.515791196484375*^9, 3.515791236609375*^9}, {3.51579127559375*^9, 
   3.515791278578125*^9}, {3.51579172553125*^9, 3.515791766015625*^9}, {
   3.515792386890625*^9, 3.51579238759375*^9}, {3.51579310334375*^9, 
   3.5157931064375*^9}, {3.515793228515625*^9, 3.515793235359375*^9}, 
   3.515793569828125*^9, {3.515794869609375*^9, 3.51579491990625*^9}, {
   3.515794987296875*^9, 3.515794994890625*^9}, {3.515865914984375*^9, 
   3.5158659499375*^9}, 3.51586609284375*^9, {3.515879872984375*^9, 
   3.5158799764375*^9}, {3.515885702375*^9, 3.515885709515625*^9}, {
   3.51595165553125*^9, 3.51595165659375*^9}, {3.515951814296875*^9, 
   3.515951815125*^9}, {3.51595316746875*^9, 3.515953168234375*^9}, {
   3.51596242746875*^9, 3.515962433015625*^9}, {3.5161284025*^9, 
   3.516128433421875*^9}, {3.516128474109375*^9, 3.51612851975*^9}, {
   3.51612930540625*^9, 3.51612934609375*^9}, 3.51628470390625*^9, 
   3.516388384578125*^9, {3.51639057609375*^9, 3.516390595046875*^9}, {
   3.516390639859375*^9, 3.516390742125*^9}, {3.516390772171875*^9, 
   3.516390773125*^9}, {3.516396164515625*^9, 3.51639618221875*^9}, {
   3.516396216234375*^9, 3.516396221203125*^9}, {3.516396466015625*^9, 
   3.516396493015625*^9}, 3.5163971651875*^9, {3.516401868546875*^9, 
   3.516401907265625*^9}, {3.516402070265625*^9, 3.516402128515625*^9}, {
   3.516402935296875*^9, 3.51640293940625*^9}, {3.516403414171875*^9, 
   3.516403426234375*^9}, {3.51645597753125*^9, 3.51645601459375*^9}, {
   3.51645877271875*^9, 3.51645887209375*^9}, {3.516461816890625*^9, 
   3.516461817796875*^9}, {3.516467257359375*^9, 3.516467309109375*^9}, {
   3.5164689965625*^9, 3.516469007921875*^9}, {3.516469096640625*^9, 
   3.51646914309375*^9}, {3.516554682828125*^9, 3.51655471*^9}, {
   3.51655535225*^9, 3.5165553615*^9}, {3.516556071578125*^9, 
   3.516556098921875*^9}, {3.5165561339375*^9, 3.516556152890625*^9}, {
   3.516556314078125*^9, 3.516556314828125*^9}, {3.516556364609375*^9, 
   3.51655639021875*^9}, {3.5165564440625*^9, 3.51655645075*^9}, {
   3.516556566953125*^9, 3.51655656778125*^9}, {3.516556770703125*^9, 
   3.51655677925*^9}, {3.516561988109375*^9, 3.516561997921875*^9}, {
   3.5178587497949*^9, 3.5178587499042854`*^9}, 3.5184726993125*^9, {
   3.518472743890625*^9, 3.5184727483125*^9}, 3.518472802328125*^9, {
   3.5184744941875*^9, 3.518474495328125*^9}, {3.518560927845375*^9, 
   3.51856094714225*^9}, {3.518561824689125*^9, 3.518561834486*^9}, {
   3.52002242178125*^9, 3.52002242803125*^9}, {3.520023463578125*^9, 
   3.520023488625*^9}, {3.520430036140625*^9, 3.520430088234375*^9}, {
   3.5204301603125*^9, 3.520430202296875*^9}, {3.520430260875*^9, 
   3.520430310296875*^9}, {3.520430445421875*^9, 3.520430459890625*^9}, {
   3.52043049128125*^9, 3.520430498515625*^9}, {3.52043056840625*^9, 
   3.520430580203125*^9}, {3.520430637390625*^9, 3.5204306733125*^9}, {
   3.520430728765625*^9, 3.520430782796875*^9}, {3.5204308828125*^9, 
   3.52043094846875*^9}, {3.5204310258125*^9, 3.520431120234375*^9}, {
   3.52043115696875*^9, 3.5204312093125*^9}, {3.52043126596875*^9, 
   3.520431283359375*^9}, {3.520431740921875*^9, 3.52043179253125*^9}, {
   3.520431827890625*^9, 3.520431873078125*^9}, {3.520431940484375*^9, 
   3.520432089984375*^9}, {3.520432185265625*^9, 3.52043220678125*^9}, {
   3.52043224228125*^9, 3.520432318640625*^9}, {3.5204325555*^9, 
   3.52043258984375*^9}, {3.52043262359375*^9, 3.5204326335*^9}, {
   3.520432728375*^9, 3.520432729375*^9}, {3.520432774234375*^9, 
   3.520432780046875*^9}, {3.5204329066875*^9, 3.520432925921875*^9}, {
   3.520433043953125*^9, 3.52043305953125*^9}, {3.520433213*^9, 
   3.52043326946875*^9}, {3.520433378203125*^9, 3.5204335379375*^9}, {
   3.520433581578125*^9, 3.520433603765625*^9}, {3.520433746671875*^9, 
   3.520433843328125*^9}, {3.520433883*^9, 3.520433886390625*^9}, {
   3.520434022140625*^9, 3.52043411884375*^9}, 3.5204341796875*^9, {
   3.520434308125*^9, 3.520434334015625*^9}, {3.52043437796875*^9, 
   3.520434483796875*^9}, {3.5204345703125*^9, 3.52043467584375*^9}, {
   3.52043476465625*^9, 3.520434781140625*^9}, {3.52043493709375*^9, 
   3.520435005375*^9}, 3.52043542959375*^9, {3.5204357191875*^9, 
   3.52043576646875*^9}, {3.520435831375*^9, 3.520435841109375*^9}, {
   3.520435898578125*^9, 3.520436059859375*^9}, {3.52043615925*^9, 
   3.520436160109375*^9}, {3.52043620790625*^9, 3.52043629228125*^9}, {
   3.52043809190625*^9, 3.520438204921875*^9}, {3.52044015221875*^9, 
   3.52044017684375*^9}, {3.52044488909375*^9, 3.5204448899375*^9}, {
   3.52044652634375*^9, 3.52044655146875*^9}, {3.520459224734375*^9, 
   3.520459266109375*^9}, {3.52052436659375*^9, 3.52052452803125*^9}, {
   3.5205245755*^9, 3.520524576796875*^9}, {3.520526204625*^9, 
   3.52052623378125*^9}, 3.520526757265625*^9, {3.520527773734375*^9, 
   3.520527812328125*^9}, {3.5205282948125*^9, 3.520528356515625*^9}, 
   3.520529063203125*^9, {3.520530635546875*^9, 3.52053063603125*^9}, {
   3.520533106859375*^9, 3.520533116234375*^9}, {3.5206374899375*^9, 
   3.520637497546875*^9}, {3.53375153890625*^9, 3.533751566140625*^9}, {
   3.54687458084375*^9, 3.546874634390625*^9}, {3.549723631546875*^9, 
   3.549723687171875*^9}, {3.579039280395591*^9, 3.579039288563216*^9}, 
   3.57903933827773*^9, {3.5791019442223034`*^9, 3.579101972739153*^9}, {
   3.5791035215341167`*^9, 3.5791035221441174`*^9}, {3.579103807054516*^9, 
   3.5791038083245177`*^9}, {3.583080639050905*^9, 3.5830806642761493`*^9}, {
   3.583191469781225*^9, 3.583191480295644*^9}, {3.583191785410164*^9, 
   3.583191787890568*^9}, {3.583697969490443*^9, 3.5836979724304476`*^9}, {
   3.5840134854089994`*^9, 3.584013488248204*^9}, {3.585077583037835*^9, 
   3.5850776237109594`*^9}, {3.5962846818402405`*^9, 3.596284687986651*^9}, 
   3.5962856426303277`*^9, 3.5965828152863903`*^9, {3.6110828644670105`*^9, 
   3.6110828955477886`*^9}, 3.6110829575733366`*^9, {3.622841673574236*^9, 
   3.6228416861790576`*^9}, {3.6228417207955184`*^9, 3.622841725413127*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Derived: List of default option rules", "Subsection",
 CellChangeTimes->{{3.520438651828125*^9, 3.52043865528125*^9}, {
  3.520440714296875*^9, 3.5204407246875*^9}, {3.592947372725133*^9, 
  3.592947373595146*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FigurePanelOptionRules", "=", 
   RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
    RowBox[{"Replace", "[", "\[IndentingNewLine]", 
     RowBox[{"FigurePanelOptionSet", ",", "\[IndentingNewLine]", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Option_", ",", "Value_", ",", "1", ",", "Patt_"}], "}"}], 
         "\[RuleDelayed]", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"Option", "\[Rule]", "Value"}], "\[IndentingNewLine]", 
          "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "Option_", ",", "Value_", ",", "2", ",", "Patt_", ",", "XYMode_"}], 
          "}"}], "\[RuleDelayed]", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"SidifyOptionName", "[", "\"\<X\>\"", "]"}], "[", 
             "Option", "]"}], "\[Rule]", "Value"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"SidifyOptionName", "[", "\"\<Y\>\"", "]"}], "[", 
             "Option", "]"}], "\[Rule]", "Value"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Option", "\[Rule]", "Default"}]}], "\[IndentingNewLine]", 
          "}"}]}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
          "Option_", ",", "Value_", ",", "4", ",", "Patt_", ",", "XYMode_", 
           ",", "MirrorOption_"}], "}"}], "\[RuleDelayed]", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"SidifyOptionName", "[", "\"\<X\>\"", "]"}], "[", 
             "Option", "]"}], "\[Rule]", "Value"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"SidifyOptionName", "[", "\"\<Y\>\"", "]"}], "[", 
             "Option", "]"}], "\[Rule]", "Value"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"SidifyOptionName", "[", "\"\<XX\>\"", "]"}], "[", 
             "Option", "]"}], "\[Rule]", "Default"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"SidifyOptionName", "[", "\"\<YY\>\"", "]"}], "[", 
             "Option", "]"}], "\[Rule]", "Default"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Option", "\[Rule]", "Default"}]}], "\[IndentingNewLine]", 
          "}"}]}]}], "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"{", "1", "}"}]}], "\[IndentingNewLine]", "]"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.52043506715625*^9, 3.520435071796875*^9}, {
   3.520435125765625*^9, 3.52043540228125*^9}, 3.52043545765625*^9, {
   3.520439189984375*^9, 3.5204391908125*^9}, 3.520440204296875*^9, {
   3.592947131888488*^9, 3.592947131898488*^9}}],

Cell["For easy inspection...", "Text",
 CellChangeTimes->{{3.549723720953125*^9, 3.54972372540625*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"SciDraw`Private`FigurePanelOptionRules", 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Cases", "[", 
  RowBox[{"%", ",", 
   RowBox[{
    RowBox[{"_", "[", 
     RowBox[{"ShowTicks", ",", "_"}], "]"}], "|", 
    RowBox[{"_", "[", 
     RowBox[{"XShowTicks", ",", "_"}], "]"}]}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.549723726796875*^9, 3.5497237298125*^9}, {
  3.5929468904480324`*^9, 3.592946927118084*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"XShowTicks", "\[Rule]", "True"}], ",", 
   RowBox[{"ShowTicks", "\[Rule]", "Default"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.5929468729930077`*^9, {3.592946916633069*^9, 3.5929469276830845`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Derived: List of validation patterns", "Subsection",
 CellChangeTimes->{{3.52043879034375*^9, 3.52043880584375*^9}, {
  3.52044073165625*^9, 3.520440733578125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FigurePanelOptionTests", "=", 
   RowBox[{"Flatten", "[", 
    RowBox[{
     RowBox[{"Replace", "[", "\[IndentingNewLine]", 
      RowBox[{"FigurePanelOptionSet", ",", "\[IndentingNewLine]", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Option_", ",", "Value_", ",", "1", ",", "Patt_"}], "}"}], 
          "\[RuleDelayed]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"Option", ",", "Patt"}], "}"}], "\[IndentingNewLine]", 
           "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "Option_", ",", "Value_", ",", "2", ",", "Patt_", ",", "XYMode_"}],
            "}"}], "\[RuleDelayed]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"SidifyOptionName", "[", "\"\<X\>\"", "]"}], "[", 
               "Option", "]"}], ",", "Patt"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"SidifyOptionName", "[", "\"\<Y\>\"", "]"}], "[", 
               "Option", "]"}], ",", "Patt"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"Option", ",", 
              RowBox[{"Default", "|", 
               RowBox[{"Switch", "[", 
                RowBox[{"XYMode", ",", "PanelOptionXYUnique", ",", 
                 RowBox[{"{", 
                  RowBox[{"Patt", ",", "Patt"}], "}"}], ",", 
                 "PanelOptionXYRange", ",", 
                 RowBox[{"Automatic", "|", "RangeParametersPattern"}]}], 
                "]"}]}]}], "}"}]}], "\[IndentingNewLine]", "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "Option_", ",", "Value_", ",", "4", ",", "Patt_", ",", "XYMode_", 
            ",", "MirrorOption_"}], "}"}], "\[RuleDelayed]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"SidifyOptionName", "[", "\"\<X\>\"", "]"}], "[", 
               "Option", "]"}], ",", "Patt"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"SidifyOptionName", "[", "\"\<Y\>\"", "]"}], "[", 
               "Option", "]"}], ",", "Patt"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"SidifyOptionName", "[", "\"\<XX\>\"", "]"}], "[", 
               "Option", "]"}], ",", 
              RowBox[{"Default", "|", "Patt"}]}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"SidifyOptionName", "[", "\"\<YY\>\"", "]"}], "[", 
               "Option", "]"}], ",", 
              RowBox[{"Default", "|", "Patt"}]}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{
              "for", " ", "options", " ", "where", " ", "propagating", " ", 
               "a", " ", "single", " ", "value", " ", "to", " ", "both", " ", 
               "X", " ", "and", " ", "Y", " ", "is", " ", "nonsense"}], ",", 
              " ", 
              RowBox[{
              "except", " ", "in", " ", "the", " ", "case", " ", "of", " ", 
               "None"}], ",", " ", 
              RowBox[{
              "only", " ", "allow", " ", "None", " ", "as", " ", "a", " ", 
               "single", " ", "value"}]}], " ", "*)"}], "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"Option", ",", 
              RowBox[{"Default", "|", 
               RowBox[{"Switch", "[", 
                RowBox[{
                "XYMode", ",", "PanelOptionXYUnique", ",", "None", ",", 
                 "PanelOptionXYSame", ",", "Patt"}], "]"}], "|", 
               RowBox[{"{", 
                RowBox[{"Patt", ",", "Patt"}], "}"}], "|", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"Patt", ",", "Patt"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"Patt", ",", "Patt"}], "}"}]}], "}"}], "|", 
               RowBox[{"{", 
                RowBox[{"Patt", ",", "Patt", ",", "Patt", ",", "Patt"}], 
                "}"}]}]}], "\[IndentingNewLine]", "}"}]}], 
           "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"{", "1", "}"}]}], "\[IndentingNewLine]", "]"}], ",", 
     "\[IndentingNewLine]", "1"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.52043506715625*^9, 3.520435071796875*^9}, {
   3.520435125765625*^9, 3.52043540228125*^9}, 3.52043545765625*^9, {
   3.5204355570625*^9, 3.520435601765625*^9}, {3.520438333375*^9, 
   3.520438349046875*^9}, 3.520438827796875*^9, {3.520438860625*^9, 
   3.520439057265625*^9}, {3.520439093203125*^9, 3.52043909703125*^9}, {
   3.520439182265625*^9, 3.520439208765625*^9}, {3.52043995925*^9, 
   3.5204399598125*^9}, {3.520440057921875*^9, 3.5204401341875*^9}, {
   3.520637818765625*^9, 3.52063782071875*^9}, {3.5929471319159884`*^9, 
   3.592947131920988*^9}, {3.600201102895274*^9, 3.6002011041120763`*^9}}],

Cell["For easy inspection...", "Text",
 CellChangeTimes->{{3.549723720953125*^9, 3.54972372540625*^9}}],

Cell[BoxData["SciDraw`Private`FigurePanelOptionTests"], "Input",
 CellChangeTimes->{{3.520454497578125*^9, 3.520454504484375*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Derived: List of option resolution descriptors", "Subsection",
 CellChangeTimes->{{3.52043879034375*^9, 3.52043880584375*^9}, {
  3.52044073165625*^9, 3.520440790078125*^9}}],

Cell["\<\
original option specification plus sidified option names, for option types 2 \
and 4 only\
\>", "Text",
 CellChangeTimes->{{3.52044316740625*^9, 3.520443176375*^9}, {
  3.520443749390625*^9, 3.520443756203125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FigurePanelOptionResolution", "=", 
   RowBox[{"Replace", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Cases", "[", 
      RowBox[{"FigurePanelOptionSet", ",", 
       RowBox[{"{", 
        RowBox[{"_", ",", "_", ",", 
         RowBox[{"2", "|", "4"}], ",", "___"}], "}"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "Option_", ",", "Value_", ",", "2", ",", "Patt_", ",", "XYMode_"}], 
         "}"}], "\[RuleDelayed]", 
        RowBox[{"{", 
         RowBox[{
         "Option", ",", "Value", ",", "2", ",", "Patt", ",", "XYMode", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{
             RowBox[{"SidifyOptionName", "[", "\"\<X\>\"", "]"}], "[", 
             "Option", "]"}], ",", 
            RowBox[{
             RowBox[{"SidifyOptionName", "[", "\"\<Y\>\"", "]"}], "[", 
             "Option", "]"}]}], "}"}]}], "}"}]}], ",", "\[IndentingNewLine]", 
       
       RowBox[{
        RowBox[{"{", 
         RowBox[{
         "Option_", ",", "Value_", ",", "4", ",", "Patt_", ",", "XYMode_", 
          ",", "MirrorOption_"}], "}"}], "\[RuleDelayed]", 
        RowBox[{"{", 
         RowBox[{
         "Option", ",", "Value", ",", "4", ",", "Patt", ",", "XYMode", ",", 
          "MirrorOption", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"SidifyOptionName", "[", "\"\<Y\>\"", "]"}], "[", 
               "Option", "]"}], ",", 
              RowBox[{
               RowBox[{"SidifyOptionName", "[", "\"\<YY\>\"", "]"}], "[", 
               "Option", "]"}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"SidifyOptionName", "[", "\"\<X\>\"", "]"}], "[", 
               "Option", "]"}], ",", 
              RowBox[{
               RowBox[{"SidifyOptionName", "[", "\"\<XX\>\"", "]"}], "[", 
               "Option", "]"}]}], "}"}]}], "}"}]}], "\[IndentingNewLine]", 
         "}"}]}]}], "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     
     RowBox[{"{", "1", "}"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.52043506715625*^9, 3.520435071796875*^9}, {
   3.520435125765625*^9, 3.52043540228125*^9}, 3.52043545765625*^9, {
   3.5204355570625*^9, 3.520435601765625*^9}, {3.520438333375*^9, 
   3.520438349046875*^9}, 3.520438827796875*^9, {3.520438860625*^9, 
   3.520439057265625*^9}, {3.520439093203125*^9, 3.52043909703125*^9}, {
   3.520439182265625*^9, 3.520439208765625*^9}, {3.52043995925*^9, 
   3.5204399598125*^9}, {3.520440057921875*^9, 3.5204401341875*^9}, {
   3.520440793953125*^9, 3.520440822203125*^9}, {3.52044088865625*^9, 
   3.52044100171875*^9}, {3.52044293653125*^9, 3.52044298153125*^9}, {
   3.520443026*^9, 3.520443121828125*^9}, {3.5204436463125*^9, 
   3.5204436485*^9}, {3.52044368278125*^9, 3.520443684296875*^9}, {
   3.52044372271875*^9, 3.520443744234375*^9}, {3.520447156734375*^9, 
   3.520447158375*^9}, {3.5929471319284887`*^9, 3.592947131933489*^9}}],

Cell["For easy inspection...", "Text",
 CellChangeTimes->{{3.549723720953125*^9, 3.54972372540625*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"SciDraw`Private`FigurePanelOptionResolution", 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"Cases", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{"ShowTicks", ",", "___"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.520454477375*^9, 3.52045447878125*^9}, {
  3.592946580312598*^9, 3.592946594472618*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"ShowTicks", ",", "True", ",", "4", ",", 
    RowBox[{"True", "|", "False"}], ",", "SciDraw`Private`PanelOptionXYSame", 
    ",", "SciDraw`Private`PanelOptionMirror", ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"YShowTicks", ",", "YYShowTicks"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"XShowTicks", ",", "XXShowTicks"}], "}"}]}], "}"}]}], "}"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.592946553762561*^9, {3.592946591592614*^9, 3.5929465946976185`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Derived: List of option array upgrading descriptors", "Subsection",
 CellChangeTimes->{{3.520438651828125*^9, 3.52043865528125*^9}, {
  3.520440714296875*^9, 3.5204407246875*^9}, {3.520454175328125*^9, 
  3.5204541798125*^9}}],

Cell["\<\
Entries:
\t{option,sense}

sense:
\t1 -- horizontal axis option
\t2 -- vertical axis option
\tAll -- undirected or true singlet option\
\>", "Text",
 CellChangeTimes->{{3.5204542450625*^9, 3.5204542821875*^9}, 
   3.520454931875*^9, {3.600202089795761*^9, 3.6002021080657873`*^9}, {
   3.600202223725949*^9, 3.600202228225955*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"FigurePanelOptionUpgrading", "=", 
   RowBox[{"Flatten", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Replace", "[", "\[IndentingNewLine]", 
      RowBox[{"FigurePanelOptionSet", ",", "\[IndentingNewLine]", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Option_", ",", "Value_", ",", "1", ",", "Patt_"}], "}"}],
            "\[RuleDelayed]", 
           RowBox[{"{", "}"}]}], ","}], "*)"}], "  ", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"PREVIOUSLY", " ", "--"}], " ", "to", " ", "ignore", " ", 
          "singlet", " ", "options"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Option_", ",", "Value_", ",", "1", ",", "Patt_"}], "}"}], 
          "\[RuleDelayed]", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"Option", ",", "All", ",", "Patt"}], "}"}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "Option_", ",", "Value_", ",", "2", ",", "Patt_", ",", "XYMode_"}],
            "}"}], "\[RuleDelayed]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Option", ",", "All", ",", 
              RowBox[{"Default", "|", "Patt"}]}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"SidifyOptionName", "[", "\"\<X\>\"", "]"}], "[", 
               "Option", "]"}], ",", "1", ",", "Patt"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"SidifyOptionName", "[", "\"\<Y\>\"", "]"}], "[", 
               "Option", "]"}], ",", "2", ",", "Patt"}], "}"}]}], 
           "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
           "Option_", ",", "Value_", ",", "4", ",", "Patt_", ",", "XYMode_", 
            ",", "MirrorOption_"}], "}"}], "\[RuleDelayed]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Option", ",", "All", ",", 
              RowBox[{"Default", "|", "Patt"}]}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"SidifyOptionName", "[", "\"\<X\>\"", "]"}], "[", 
               "Option", "]"}], ",", "1", ",", "Patt"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"SidifyOptionName", "[", "\"\<Y\>\"", "]"}], "[", 
               "Option", "]"}], ",", "2", ",", "Patt"}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"SidifyOptionName", "[", "\"\<XX\>\"", "]"}], "[", 
               "Option", "]"}], ",", "1", ",", 
              RowBox[{"Default", "|", "Patt"}]}], "}"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{
               RowBox[{"SidifyOptionName", "[", "\"\<YY\>\"", "]"}], "[", 
               "Option", "]"}], ",", "2", ",", 
              RowBox[{"Default", "|", "Patt"}]}], "}"}]}], 
           "\[IndentingNewLine]", "}"}]}]}], "\[IndentingNewLine]", "}"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"{", "1", "}"}]}], "\[IndentingNewLine]", "]"}], ",", 
     "\[IndentingNewLine]", "1"}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.52043506715625*^9, 3.520435071796875*^9}, {
   3.520435125765625*^9, 3.52043540228125*^9}, 3.52043545765625*^9, {
   3.520439189984375*^9, 3.5204391908125*^9}, 3.520440204296875*^9, {
   3.520454185296875*^9, 3.520454241390625*^9}, {3.520454303796875*^9, 
   3.520454357515625*^9}, {3.520454388171875*^9, 3.520454388875*^9}, {
   3.520454600640625*^9, 3.520454610484375*^9}, {3.52045493759375*^9, 
   3.520454947203125*^9}, {3.520458813234375*^9, 3.52045881771875*^9}, {
   3.585079292425744*^9, 3.5850793397406273`*^9}, {3.585080256763838*^9, 
   3.58508028050708*^9}, {3.5850805445650954`*^9, 3.5850805458598976`*^9}, {
   3.592947131933489*^9, 3.5929471319359884`*^9}, {3.592949352546347*^9, 
   3.5929493569923553`*^9}, {3.5929494936017947`*^9, 
   3.5929495047090144`*^9}, {3.5929500954664516`*^9, 
   3.5929500990388584`*^9}, {3.5929502049162445`*^9, 3.5929502084886503`*^9}}],

Cell["For easy inspection...", "Text",
 CellChangeTimes->{{3.549723720953125*^9, 3.54972372540625*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{"SciDraw`Private`FigurePanelOptionUpgrading", "\
\[IndentingNewLine]", 
 RowBox[{"Cases", "[", 
  RowBox[{"%", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ShowTicks", "|", "XShowTicks"}], ",", "___"}], "}"}]}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.520454368921875*^9, 3.520454373171875*^9}, {
   3.520454451109375*^9, 3.52045446775*^9}, {3.592946677792735*^9, 
   3.592946682222741*^9}, {3.5929468137029247`*^9, 3.5929468168079295`*^9}, {
   3.592949277822216*^9, 3.5929492900994377`*^9}, 3.592950118117692*^9}],

Cell[BoxData["SciDraw`Private`FigurePanelOptionUpgrading"], "Output",
 CellChangeTimes->{{3.592946678792736*^9, 3.5929466826227417`*^9}, 
   3.5929468171679296`*^9, {3.592949280708221*^9, 3.592949290567438*^9}, {
   3.5929501037188663`*^9, 3.592950123515301*^9}}],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output",
 CellChangeTimes->{{3.592946678792736*^9, 3.5929466826227417`*^9}, 
   3.5929468171679296`*^9, {3.592949280708221*^9, 3.592949290567438*^9}, {
   3.5929501037188663`*^9, 3.592950123530901*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Derived: List of remaining singlet options", "Subsection",
 CellChangeTimes->{{3.520438651828125*^9, 3.52043865528125*^9}, {
  3.520440714296875*^9, 3.5204407246875*^9}, {3.520454175328125*^9, 
  3.5204541798125*^9}, {3.520454976578125*^9, 3.520454978671875*^9}, {
  3.5850806864485164`*^9, 3.585080687838518*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{"FigurePanelOptionSinglets", "=", 
     RowBox[{"Join", "[", 
      RowBox[{
       RowBox[{"First", "/@", "FigurePanelOptionSet"}], ",", 
       RowBox[{"First", "/@", 
        RowBox[{"Options", "[", "FigObject", "]"}]}]}], "]"}]}], ";"}], 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"FigurePanelOptionSinglets", "=", 
    RowBox[{"Replace", "[", 
     RowBox[{
      RowBox[{"Options", "[", "FigObject", "]"}], ",", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{"Option_", "\[Rule]", "_"}], ")"}], "|", 
         RowBox[{"(", 
          RowBox[{"Option_", ":>", "_"}], ")"}]}], ")"}], "\[RuleDelayed]", 
       RowBox[{"{", 
        RowBox[{"Option", ",", "All", ",", "_"}], "}"}]}], ",", 
      RowBox[{"{", "1", "}"}]}], "]"}]}], ";"}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.52043506715625*^9, 3.520435071796875*^9}, {
   3.520435125765625*^9, 3.52043540228125*^9}, 3.52043545765625*^9, {
   3.520439189984375*^9, 3.5204391908125*^9}, 3.520440204296875*^9, {
   3.520454185296875*^9, 3.520454241390625*^9}, {3.520454303796875*^9, 
   3.520454357515625*^9}, {3.520454388171875*^9, 3.520454388875*^9}, {
   3.520454600640625*^9, 3.520454610484375*^9}, {3.52045493759375*^9, 
   3.520454947203125*^9}, {3.52045499003125*^9, 3.520455073953125*^9}, {
   3.5850806949285283`*^9, 3.5850807010585365`*^9}, {3.5850807479386024`*^9, 
   3.5850807854286547`*^9}, {3.5850819045694585`*^9, 3.5850819111194677`*^9}}],

Cell["For easy inspection...", "Text",
 CellChangeTimes->{{3.549723720953125*^9, 3.54972372540625*^9}}],

Cell[CellGroupData[{

Cell[BoxData["SciDraw`Private`FigurePanelOptionSinglets"], "Input",
 CellChangeTimes->{{3.520455084703125*^9, 3.520455085921875*^9}, {
  3.5929466555027037`*^9, 3.5929466665677195`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"Color", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"Debug", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"Directives", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"Epilog", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"FillColor", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"FillDirectives", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"FillOpacity", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"FontFamily", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"FontSize", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"FontSlant", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"FontTracking", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"FontVariations", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"FontWeight", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"Layer", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"LineCapForm", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"LineColor", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"LineDashing", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"LineDirectives", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"LineJoinForm", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"LineOpacity", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"LineThickness", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"Opacity", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"PointColor", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"PointDirectives", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"PointOpacity", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"PointSize", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"Prolog", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"Show", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"ShowFill", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"ShowLine", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"ShowPoint", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"ShowText", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"Style", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"TextBackground", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"TextBuffer", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"TextColor", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"TextFrame", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"TextFrameColor", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"TextMargin", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"TextNudge", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"TextOffset", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"TextOpacity", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"TextOrientation", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"TextPadding", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"TextRectify", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"TextRoundingRadius", ",", "All", ",", "_"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"TextStyleOptions", ",", "All", ",", "_"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.592946656322705*^9, 3.59294666695772*^9}, 
   3.592949954972605*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["FigurePanel and Multipanel forward object declarations", "Section",
 CellChangeTimes->{{3.520460536015625*^9, 3.52046054521875*^9}}],

Cell["\<\
Interdependence:
\tPanel constructor needs Multipanel methods
\tMultipanel inherits options from Panel
\tMultipanel inherits data members from Panel -- though most currently ignored\
\>", "Text",
 CellChangeTimes->{{3.52046055340625*^9, 3.520460584890625*^9}, {
  3.52046444846875*^9, 3.520464504859375*^9}}],

Cell[CellGroupData[{

Cell["Object declaration -- FigurePanel", "Subsection",
 CellChangeTimes->{{3.5157879655*^9, 3.5157879669375*^9}, {3.5157882753125*^9,
   3.51578827803125*^9}, {3.520460532015625*^9, 3.520460533609375*^9}, {
  3.520524328765625*^9, 3.520524331015625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DeclareFigClass", "[", "\[IndentingNewLine]", 
   RowBox[{"FigurePanel", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Window\>\"", ",", "\"\<Background\>\"", ",", "\"\<PanelLayer\>\"", 
      ",", "\"\<Ticks\>\""}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"Center", ",", "Left", ",", "Right", ",", "Bottom", ",", "Top"}],
      "}"}]}], "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515100688734375*^9, 3.515100745765625*^9}, {
   3.515101427609375*^9, 3.5151014280625*^9}, {3.51510147303125*^9, 
   3.515101489109375*^9}, {3.515160263390625*^9, 3.51516026428125*^9}, {
   3.51516080484375*^9, 3.51516081109375*^9}, {3.515429856500375*^9, 
   3.515429878125375*^9}, {3.5154307895785*^9, 3.515430808375375*^9}, {
   3.51543131279725*^9, 3.51543134560975*^9}, {3.5154491619535*^9, 
   3.515449178391*^9}, {3.51544979217225*^9, 3.51544979648475*^9}, {
   3.515449839641*^9, 3.5154498768285*^9}, {3.51553014021875*^9, 
   3.515530194296875*^9}, {3.5155325434375*^9, 3.515532544421875*^9}, 
   3.515775615828125*^9, {3.515781907078125*^9, 3.515781955484375*^9}, {
   3.515785111484375*^9, 3.515785137171875*^9}, {3.515787491671875*^9, 
   3.515787494125*^9}, 3.515787973390625*^9, {3.515879696671875*^9, 
   3.515879700609375*^9}, 3.515880357875*^9, {3.51596241259375*^9, 
   3.51596242121875*^9}, {3.515962641796875*^9, 3.5159626445*^9}, 
   3.51655576553125*^9, {3.5178579737043877`*^9, 3.517857978314294*^9}, 
   3.52750197021875*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineFigClassOptions", "[", "\[IndentingNewLine]", 
   RowBox[{"FigurePanel", ",", "\[IndentingNewLine]", 
    RowBox[{"Join", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
      "options", " ", "which", " ", "will", " ", "receive", " ", 
       "standardized", " ", "treatment", " ", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"pattern", " ", "checking"}], ",", " ", 
         RowBox[{"XY", " ", "upgrades"}], ",", " ", 
         RowBox[{"etc", "."}]}], ")"}]}], " ", "*)"}], "\[IndentingNewLine]", 
     
     RowBox[{
     "FigurePanelOptionRules", ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"alternative", " ", "object", " ", "naming", " ", "syntax"}], 
       " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"note", ":", " ", 
        RowBox[{
        "this", " ", "default", " ", "value", " ", "is", " ", "ignored", " ", 
         "but", " ", "is", " ", "included", " ", "in", " ", "Options", " ", 
         "so", " ", "that", " ", "ObjectName", " ", "is", " ", "a", " ", 
         "recognized", " ", "option", " ", "for", " ", "FigurePanel", " ", 
         "when", " ", "option", " ", "lists", " ", "are", " ", 
         "validated"}]}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"ObjectName", "\[Rule]", "None"}], "}"}]}], 
     "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515100688734375*^9, 3.515100745765625*^9}, {
   3.515101427609375*^9, 3.5151014280625*^9}, {3.51510147303125*^9, 
   3.515101489109375*^9}, {3.515160263390625*^9, 3.51516026428125*^9}, {
   3.51516080484375*^9, 3.51516081109375*^9}, {3.515429856500375*^9, 
   3.515429878125375*^9}, {3.5154307895785*^9, 3.515430808375375*^9}, {
   3.51543131279725*^9, 3.51543134560975*^9}, {3.5154491619535*^9, 
   3.515449178391*^9}, {3.51544979217225*^9, 3.51544979648475*^9}, {
   3.515449839641*^9, 3.5154498768285*^9}, {3.51553014021875*^9, 
   3.515530194296875*^9}, {3.5155325434375*^9, 3.515532544421875*^9}, 
   3.515775615828125*^9, {3.515781907078125*^9, 3.515781955484375*^9}, {
   3.515785111484375*^9, 3.515785137171875*^9}, {3.515787491671875*^9, 
   3.515787494125*^9}, 3.515787973390625*^9, {3.515788030765625*^9, 
   3.515788034984375*^9}, 3.51578807775*^9, {3.515789660203125*^9, 
   3.5157896656875*^9}, {3.51579082725*^9, 3.515790854546875*^9}, {
   3.515791196484375*^9, 3.515791236609375*^9}, {3.51579127559375*^9, 
   3.515791278578125*^9}, {3.51579172553125*^9, 3.515791766015625*^9}, {
   3.515792386890625*^9, 3.51579238759375*^9}, {3.51579310334375*^9, 
   3.5157931064375*^9}, {3.515793228515625*^9, 3.515793235359375*^9}, 
   3.515793569828125*^9, {3.515794869609375*^9, 3.51579491990625*^9}, {
   3.515794987296875*^9, 3.515794994890625*^9}, {3.515865914984375*^9, 
   3.5158659499375*^9}, 3.51586609284375*^9, {3.515879872984375*^9, 
   3.5158799764375*^9}, {3.515885702375*^9, 3.515885709515625*^9}, {
   3.51595165553125*^9, 3.51595165659375*^9}, {3.515951814296875*^9, 
   3.515951815125*^9}, {3.51595316746875*^9, 3.515953168234375*^9}, {
   3.51596242746875*^9, 3.515962433015625*^9}, {3.5161284025*^9, 
   3.516128433421875*^9}, {3.516128474109375*^9, 3.51612851975*^9}, {
   3.51612930540625*^9, 3.51612934609375*^9}, 3.51628470390625*^9, 
   3.516388384578125*^9, {3.51639057609375*^9, 3.516390595046875*^9}, {
   3.516390639859375*^9, 3.516390742125*^9}, {3.516390772171875*^9, 
   3.516390773125*^9}, {3.516396164515625*^9, 3.51639618221875*^9}, {
   3.516396216234375*^9, 3.516396221203125*^9}, {3.516396466015625*^9, 
   3.516396493015625*^9}, 3.5163971651875*^9, {3.516401868546875*^9, 
   3.516401907265625*^9}, {3.516402070265625*^9, 3.516402128515625*^9}, {
   3.516402935296875*^9, 3.51640293940625*^9}, {3.516403414171875*^9, 
   3.516403426234375*^9}, {3.51645597753125*^9, 3.51645601459375*^9}, {
   3.51645877271875*^9, 3.51645887209375*^9}, {3.516461816890625*^9, 
   3.516461817796875*^9}, {3.516467257359375*^9, 3.516467309109375*^9}, {
   3.5164689965625*^9, 3.516469007921875*^9}, {3.516469096640625*^9, 
   3.51646914309375*^9}, {3.516554682828125*^9, 3.51655471*^9}, {
   3.51655535225*^9, 3.5165553615*^9}, {3.516556071578125*^9, 
   3.516556098921875*^9}, {3.5165561339375*^9, 3.516556152890625*^9}, {
   3.516556314078125*^9, 3.516556314828125*^9}, {3.516556364609375*^9, 
   3.51655639021875*^9}, {3.5165564440625*^9, 3.51655645075*^9}, {
   3.516556566953125*^9, 3.51655656778125*^9}, {3.516556770703125*^9, 
   3.51655677925*^9}, {3.516561988109375*^9, 3.516561997921875*^9}, {
   3.5178587497949*^9, 3.5178587499042854`*^9}, 3.5184726993125*^9, {
   3.518472743890625*^9, 3.5184727483125*^9}, 3.518472802328125*^9, {
   3.5184744941875*^9, 3.518474495328125*^9}, {3.518560927845375*^9, 
   3.51856094714225*^9}, {3.518561824689125*^9, 3.518561834486*^9}, {
   3.52002242178125*^9, 3.52002242803125*^9}, {3.520023463578125*^9, 
   3.520023488625*^9}, {3.520439291890625*^9, 3.520439295625*^9}, {
   3.520945353890625*^9, 3.52094541959375*^9}, {3.520945543796875*^9, 
   3.52094560725*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Object declaration -- Multipanel", "Subsection",
 CellChangeTimes->{{3.5157879655*^9, 3.5157879669375*^9}, {3.5157882753125*^9,
   3.51578827803125*^9}, {3.520460520546875*^9, 3.520460522703125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DeclareFigClass", "[", "\[IndentingNewLine]", 
   RowBox[{
   "Multipanel", ",", "\[IndentingNewLine]", "FigurePanel", ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<PanelRegionArray\>\"", ",", "\"\<PanelGapsExteriorArray\>\"", ",", 
      "\"\<PanelOptionsArrayList\>\"", ",", "\"\<PanelUnit\>\"", ",", 
      "\"\<CanvasRegion\>\"", ",", "\"\<Dimensions\>\""}], "}"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{"Center", ",", "Left", ",", "Right", ",", "Bottom", ",", "Top"}],
      "}"}]}], "\[IndentingNewLine]", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515100688734375*^9, 3.515100745765625*^9}, {
   3.515101427609375*^9, 3.5151014280625*^9}, {3.51510147303125*^9, 
   3.515101489109375*^9}, {3.515160263390625*^9, 3.51516026428125*^9}, {
   3.51516080484375*^9, 3.51516081109375*^9}, {3.515429856500375*^9, 
   3.515429878125375*^9}, {3.5154307895785*^9, 3.515430808375375*^9}, {
   3.51543131279725*^9, 3.51543134560975*^9}, {3.5154491619535*^9, 
   3.515449178391*^9}, {3.51544979217225*^9, 3.51544979648475*^9}, {
   3.515449839641*^9, 3.5154498768285*^9}, {3.51553014021875*^9, 
   3.515530194296875*^9}, {3.5155325434375*^9, 3.515532544421875*^9}, 
   3.515775615828125*^9, {3.515781907078125*^9, 3.515781955484375*^9}, {
   3.515785111484375*^9, 3.515785137171875*^9}, {3.515787491671875*^9, 
   3.515787494125*^9}, 3.515787973390625*^9, {3.515879696671875*^9, 
   3.515879700609375*^9}, 3.515880357875*^9, {3.51596241259375*^9, 
   3.51596242121875*^9}, {3.515962641796875*^9, 3.5159626445*^9}, 
   3.51655576553125*^9, {3.5178579737043877`*^9, 3.517857978314294*^9}, {
   3.5203410315*^9, 3.520341060265625*^9}, {3.520451570875*^9, 
   3.520451594453125*^9}, {3.520451846*^9, 3.520451848828125*^9}, {
   3.520453362921875*^9, 3.520453366296875*^9}, {3.5204585594375*^9, 
   3.520458567203125*^9}, {3.520464393*^9, 3.520464407296875*^9}, 
   3.52750197859375*^9, {3.55725608471875*^9, 3.557256098125*^9}, {
   3.557256140859375*^9, 3.557256143390625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DefineFigClassOptions", "[", "\[IndentingNewLine]", 
   RowBox[{"Multipanel", ",", "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"array", " ", "geometry"}], " ", "*)"}], "\[IndentingNewLine]", 
     
     RowBox[{
      RowBox[{"XPanelSizes", "\[Rule]", "1"}], ",", 
      RowBox[{"YPanelSizes", "\[Rule]", "1"}], ",", "\[IndentingNewLine]", 
      RowBox[{"XPanelGaps", "\[Rule]", "0"}], ",", 
      RowBox[{"YPanelGaps", "\[Rule]", "0"}], ",", "\[IndentingNewLine]", 
      RowBox[{"XPanelGapsExterior", "\[Rule]", "False"}], ",", 
      RowBox[{"YPanelGapsExterior", "\[Rule]", "False"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Dimensions", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{"1", ",", "1"}], "}"}]}]}], "\[IndentingNewLine]", 
     "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515100688734375*^9, 3.515100745765625*^9}, {
   3.515101427609375*^9, 3.5151014280625*^9}, {3.51510147303125*^9, 
   3.515101489109375*^9}, {3.515160263390625*^9, 3.51516026428125*^9}, {
   3.51516080484375*^9, 3.51516081109375*^9}, {3.515429856500375*^9, 
   3.515429878125375*^9}, {3.5154307895785*^9, 3.515430808375375*^9}, {
   3.51543131279725*^9, 3.51543134560975*^9}, {3.5154491619535*^9, 
   3.515449178391*^9}, {3.51544979217225*^9, 3.51544979648475*^9}, {
   3.515449839641*^9, 3.5154498768285*^9}, {3.51553014021875*^9, 
   3.515530194296875*^9}, {3.5155325434375*^9, 3.515532544421875*^9}, 
   3.515775615828125*^9, {3.515781907078125*^9, 3.515781955484375*^9}, {
   3.515785111484375*^9, 3.515785137171875*^9}, {3.515787491671875*^9, 
   3.515787494125*^9}, 3.515787973390625*^9, {3.515788030765625*^9, 
   3.515788034984375*^9}, 3.51578807775*^9, {3.515789660203125*^9, 
   3.5157896656875*^9}, {3.51579082725*^9, 3.515790854546875*^9}, {
   3.515791196484375*^9, 3.515791236609375*^9}, {3.51579127559375*^9, 
   3.515791278578125*^9}, {3.51579172553125*^9, 3.515791766015625*^9}, {
   3.515792386890625*^9, 3.51579238759375*^9}, {3.51579310334375*^9, 
   3.5157931064375*^9}, {3.515793228515625*^9, 3.515793235359375*^9}, 
   3.515793569828125*^9, {3.515794869609375*^9, 3.51579491990625*^9}, {
   3.515794987296875*^9, 3.515794994890625*^9}, {3.515865914984375*^9, 
   3.5158659499375*^9}, 3.51586609284375*^9, {3.515879872984375*^9, 
   3.5158799764375*^9}, {3.515885702375*^9, 3.515885709515625*^9}, {
   3.51595165553125*^9, 3.51595165659375*^9}, {3.515951814296875*^9, 
   3.515951815125*^9}, {3.51595316746875*^9, 3.515953168234375*^9}, {
   3.51596242746875*^9, 3.515962433015625*^9}, {3.5161284025*^9, 
   3.516128433421875*^9}, {3.516128474109375*^9, 3.51612851975*^9}, {
   3.51612930540625*^9, 3.51612934609375*^9}, 3.51628470390625*^9, 
   3.516388384578125*^9, {3.51639057609375*^9, 3.516390595046875*^9}, {
   3.516390639859375*^9, 3.516390742125*^9}, {3.516390772171875*^9, 
   3.516390773125*^9}, {3.516396164515625*^9, 3.51639618221875*^9}, {
   3.516396216234375*^9, 3.516396221203125*^9}, {3.516396466015625*^9, 
   3.516396493015625*^9}, 3.5163971651875*^9, {3.516401868546875*^9, 
   3.516401907265625*^9}, {3.516402070265625*^9, 3.516402128515625*^9}, {
   3.516402935296875*^9, 3.51640293940625*^9}, {3.516403414171875*^9, 
   3.516403426234375*^9}, {3.51645597753125*^9, 3.51645601459375*^9}, {
   3.51645877271875*^9, 3.51645887209375*^9}, {3.516461816890625*^9, 
   3.516461817796875*^9}, {3.516467257359375*^9, 3.516467309109375*^9}, {
   3.5164689965625*^9, 3.516469007921875*^9}, {3.516469096640625*^9, 
   3.51646914309375*^9}, {3.516554682828125*^9, 3.51655471*^9}, {
   3.51655535225*^9, 3.5165553615*^9}, {3.516556071578125*^9, 
   3.516556098921875*^9}, {3.5165561339375*^9, 3.516556152890625*^9}, {
   3.516556314078125*^9, 3.516556314828125*^9}, {3.516556364609375*^9, 
   3.51655639021875*^9}, {3.5165564440625*^9, 3.51655645075*^9}, {
   3.516556566953125*^9, 3.51655656778125*^9}, {3.516556770703125*^9, 
   3.51655677925*^9}, {3.516561988109375*^9, 3.516561997921875*^9}, {
   3.5178587497949*^9, 3.5178587499042854`*^9}, 3.5184726993125*^9, {
   3.518472743890625*^9, 3.5184727483125*^9}, 3.518472802328125*^9, {
   3.5184744941875*^9, 3.518474495328125*^9}, {3.518560927845375*^9, 
   3.51856094714225*^9}, {3.518561824689125*^9, 3.518561834486*^9}, {
   3.52002242178125*^9, 3.52002242803125*^9}, {3.520023463578125*^9, 
   3.520023488625*^9}, {3.52034106615625*^9, 3.520341086453125*^9}, {
   3.520341237640625*^9, 3.52034126865625*^9}, {3.5204499253125*^9, 
   3.520449938234375*^9}, {3.520462256703125*^9, 3.5204622640625*^9}, {
   3.5205243196875*^9, 3.520524320671875*^9}, 3.520527709640625*^9, {
   3.557255391625*^9, 3.5572554038125*^9}, {3.5774714845855913`*^9, 
   3.5774715144596443`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["FigAxis", "Section",
 CellChangeTimes->{{3.51542982092225*^9, 3.515429824641*^9}, {
  3.5160453259895*^9, 3.516045326911375*^9}, {3.516294682421875*^9, 
  3.516294683890625*^9}}],

Cell["\<\
similar to FigBracket, with following differences:
\tarrowheads default ShowTail->False and standard arrowhead dimension
\tconvenience label named \[OpenCurlyDoubleQuote]AxisLabel\
\[CloseCurlyDoubleQuote]
\tadd TailExtension/HeadExtension
\tadd ticks
\trange should be specified *numerically* (though positioning coordinate can \
still be specified in generic fashion)\
\>", "Text",
 CellChangeTimes->{{3.516294700328125*^9, 3.5162947061875*^9}, {
  3.51629474909375*^9, 3.516294794296875*^9}, {3.5162958235625*^9, 
  3.516295850234375*^9}, {3.51630522134375*^9, 3.51630525896875*^9}}],

Cell["Note: FigAxis declaration must come before FigurePanel code", "Text",
 CellChangeTimes->{{3.51640507884375*^9, 3.516405090359375*^9}}],

Cell[CellGroupData[{

Cell["Object declaration", "Subsection",
 CellChangeTimes->{{3.515429830437875*^9, 3.515429833266*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"DeclareFigClass", "[", "\[IndentingNewLine]", 
   RowBox[{"FigAxis", ",", "\[IndentingNewLine]", 
    RowBox[{"{", 
     RowBox[{
     "\"\<Points\>\"", ",", "\"\<Side\>\"", ",", 
      "\"\<TickLabelAllowance\>\""}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"{", "\"\<Axis\>\"", "}"}]}], "\[IndentingNewLine]", "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"DefineFigClassOptions", "[", "\[IndentingNewLine]", 
   RowBox[{"FigAxis", ",", "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"curve", "/", "arrowhead"}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FigArrowheadOptions", "[", 
       RowBox[{"False", ",", "True"}], "]"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"axis", " ", "special"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"TailExtension", "\[Rule]", "None"}], ",", 
      RowBox[{"HeadExtension", "\[Rule]", "10"}], ",", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"tick", " ", "control"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Ticks", "\[Rule]", "None"}], ",", "\[IndentingNewLine]", 
      RowBox[{"TickLabelRange", "\[Rule]", "Automatic"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ShowTicks", " ", "\[Rule]", " ", "True"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ShowTickLabels", "\[Rule]", "True"}], ",", "  ", 
      RowBox[{"(*", " ", 
       RowBox[{"symbol", " ", "from", " ", "CustomTicks"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"TickFontSizeFactor", "\[Rule]", "0.85"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"TickLengthReference", "\[Rule]", "Automatic"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"TickLengthScale", "\[Rule]", "1"}], ",", "\[IndentingNewLine]", 
      RowBox[{"TickLabelAllowance", "\[Rule]", "Automatic"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"FigDerivedLabelOptions", "[", 
       RowBox[{"\"\<Tick\>\"", ",", "False", ",", "Automatic"}], "]"}]}], 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"TODO", " ", 
       RowBox[{"FigDerivedOutlineOptions", "[", "\"\<Tick\>\"", "]"}]}], " ", 
      "*)"}], "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515100688734375*^9, 3.515100745765625*^9}, {
   3.515101427609375*^9, 3.5151014280625*^9}, {3.51510147303125*^9, 
   3.515101489109375*^9}, {3.515160263390625*^9, 3.51516026428125*^9}, {
   3.51516080484375*^9, 3.51516081109375*^9}, {3.515429856500375*^9, 
   3.515429878125375*^9}, {3.5154307895785*^9, 3.515430808375375*^9}, {
   3.51543131279725*^9, 3.51543134560975*^9}, {3.515611505515625*^9, 
   3.5156115174375*^9}, 3.51577560334375*^9, {3.5159617146875*^9, 
   3.515961775921875*^9}, {3.515962042546875*^9, 3.515962049828125*^9}, {
   3.516045343723875*^9, 3.51604543889575*^9}, {3.516046392567625*^9, 
   3.516046401942625*^9}, {3.51604818527075*^9, 3.516048198411375*^9}, {
   3.516048927177*^9, 3.516048931880125*^9}, {3.516048992161375*^9, 
   3.51604899464575*^9}, {3.516290534421875*^9, 3.51629053528125*^9}, {
   3.51629471553125*^9, 3.51629474571875*^9}, {3.51629486359375*^9, 
   3.516294889921875*^9}, {3.516295869625*^9, 3.516295880953125*^9}, {
   3.516295918390625*^9, 3.516296024109375*^9}, {3.516296071078125*^9, 
   3.516296077203125*^9}, {3.516296117984375*^9, 3.5162961314375*^9}, {
   3.516297355015625*^9, 3.516297361109375*^9}, {3.516298119890625*^9, 
   3.516298121046875*^9}, {3.51629906659375*^9, 3.516299071375*^9}, {
   3.516300674359375*^9, 3.516300682703125*^9}, {3.516303293234375*^9, 
   3.516303297390625*^9}, 3.51630339096875*^9, {3.516303925140625*^9, 
   3.516303925453125*^9}, 3.518472325078125*^9, 3.518472681234375*^9, 
   3.518472794828125*^9, 3.520535189265625*^9, {3.533751192078125*^9, 
   3.533751195078125*^9}, {3.579100954244175*^9, 3.579100966944193*^9}, {
   3.5791011136748047`*^9, 3.5791011147200065`*^9}, {3.5839542328728657`*^9, 
   3.5839542336878667`*^9}, {3.5962846960362654`*^9, 3.5962847024010763`*^9}, 
   3.596582816378392*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructor", "Subsection",
 CellChangeTimes->{{3.51543192685975*^9, 3.5154319283285*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Constructor", "[", 
     RowBox[{
      RowBox[{"Class", ":", "FigAxis"}], ",", "Self_Object"}], "]"}], "[", 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Side", ":", 
      RowBox[{"(", 
       RowBox[{"Left", "|", "Right", "|", "Bottom", "|", "Top"}], ")"}]}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"Coordinate", ":", "FigCoordinatePattern"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Range", ":", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"FigCoordinatePattern", ",", "FigCoordinatePattern"}], "}"}], 
       "|", "FigRegionPattern"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Opts___", "?", "OptionQ"}]}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"FigObjectWrapper", "[", 
    RowBox[{"Class", ",", "Self", ",", 
     RowBox[{"{", "Opts", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
        "CoordinateIndex", ",", "CanvasCoordinate", ",", "CanvasInterval", 
         ",", "CanvasPoints", ",", "CanvasTail", ",", "CanvasHead", ",", 
         "RangeUseableForTicks", ",", "\[IndentingNewLine]", 
         "UsedTickFontSize", ",", "TickOptions", ",", "UsedTickLabelRange", 
         ",", "UsedTickLengthReference", ",", "UsedTickLengthScale", ",", 
         "TickList", ",", "\[IndentingNewLine]", "TickPosn", ",", "TickText", 
         ",", "TickLengths", ",", "TickAttributes", ",", 
         "\[IndentingNewLine]", "TickLineArt", ",", "TickPoint", ",", 
         "TickEndPoints", ",", "TickOffset", ",", "TickLabelAnchor", ",", 
         "\[IndentingNewLine]", "ComputedTickLabelAllowance", ",", 
         "TextElement"}], "\[IndentingNewLine]", "}"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"validate", " ", "extra", " ", "options"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"FigCheckArrowheadOptions", "[", "Self", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "TickLabelRange", ",", 
          RowBox[{"Automatic", "|", "All", "|", "NumericalPairPattern"}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{
         "Self", ",", "TailExtension", ",", "ScalarParameterPattern", ",", 
          "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{
         "Self", ",", "HeadExtension", ",", "ScalarParameterPattern", ",", 
          "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{
         "Self", ",", "ShowTicks", ",", "LogicalPattern", ",", "FigOptions"}],
          "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{
         "Self", ",", "ShowTickLabels", ",", "LogicalPattern", ",", 
          "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{
         "Self", ",", "TickFontSizeFactor", ",", "NonNegativePattern", ",", 
          "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "TickLengthReference", ",", 
          RowBox[{"Automatic", "|", "NonNegativePattern"}], ",", 
          "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{
         "Self", ",", "TickLengthScale", ",", "NonNegativePattern", ",", 
          "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "TickFontSize", ",", 
          RowBox[{"Automatic", "|", "FontSizePattern", "|", "Default"}], ",", 
          "FigOptions"}], "]"}], ";", "  ", 
        RowBox[{"(*", " ", 
         RowBox[{
         "allow", " ", "TickFontSize", " ", "special", " ", "value", " ", 
          "Automatic"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Self", ",", "TickLabelAllowance", ",", 
          RowBox[{"Automatic", "|", "NonNegativePattern"}], ",", 
          "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckDerivedLabelOptions", "[", 
         RowBox[{
         "Self", ",", "\"\<Tick\>\"", ",", "False", ",", "Automatic", ",", 
          RowBox[{"Flatten", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"TickFontSize", "\[Rule]", "999"}], ",", "FigOptions"}], 
            "}"}], "]"}]}], "]"}], ";", "  ", 
        RowBox[{"(*", " ", 
         RowBox[{
         "...", " ", "which", " ", "would", " ", "fail", " ", "standard", " ",
           "test"}], " ", "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"determine", " ", 
          RowBox[{"horizontal", "/", "vertical"}], " ", "direction"}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"CoordinateIndex", " ", "--"}], " ", "coordinate", " ", 
          "for", " ", "*", "positioning", "*", " ", "axis"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"CoordinateIndex", "=", 
         RowBox[{"Switch", "[", "\[IndentingNewLine]", 
          RowBox[{"Side", ",", "\[IndentingNewLine]", 
           RowBox[{"Left", "|", "Right"}], ",", "1", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Bottom", "|", "Top"}], ",", "2"}], "\[IndentingNewLine]", 
          "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "convert", " ", "coordinate", " ", "and", " ", "interval", " ", "to",
           " ", "canvas", " ", "values"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"CanvasCoordinate", "=", 
         RowBox[{"FigResolveCoordinate", "[", 
          RowBox[{"Coordinate", ",", "CoordinateIndex"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"CanvasInterval", "=", 
         RowBox[{"Sort", "@", 
          RowBox[{"Replace", "[", "\[IndentingNewLine]", 
           RowBox[{"Range", ",", "\[IndentingNewLine]", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"x1", ":", "FigCoordinatePattern"}], ",", 
                 RowBox[{"x2", ":", "FigCoordinatePattern"}]}], "}"}], 
               "\[RuleDelayed]", 
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"FigResolveCoordinate", "[", 
                  RowBox[{"x1", ",", 
                   RowBox[{
                   "AntiCoordinateIndex", "[", "CoordinateIndex", "]"}]}], 
                  "]"}], ",", "\[IndentingNewLine]", 
                 RowBox[{"FigResolveCoordinate", "[", 
                  RowBox[{"x2", ",", 
                   RowBox[{
                   "AntiCoordinateIndex", "[", "CoordinateIndex", "]"}]}], 
                  "]"}]}], "\[IndentingNewLine]", "}"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"r", ":", "FigRegionPattern"}], ":>", 
               RowBox[{
                RowBox[{"FigResolveRegion", "[", "r", "]"}], "[", 
                RowBox[{"[", 
                 RowBox[{"AntiCoordinateIndex", "[", "CoordinateIndex", "]"}],
                  "]"}], "]"}]}]}], "\[IndentingNewLine]", "}"}]}], 
           "\[IndentingNewLine]", "]"}]}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"generate", " ", "curve", " ", "points"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "curve", " ", "always", " ", "goes", " ", "in", " ", 
          "\"\<positive\>\"", " ", "coordinate", " ", "direction"}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"CanvasPoints", "=", 
         RowBox[{"Switch", "[", "\[IndentingNewLine]", 
          RowBox[{"Side", ",", "\[IndentingNewLine]", 
           RowBox[{"Left", "|", "Right"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"CanvasCoordinate", ",", 
               RowBox[{"CanvasInterval", "[", 
                RowBox[{"[", "1", "]"}], "]"}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"CanvasCoordinate", ",", 
               RowBox[{"CanvasInterval", "[", 
                RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"Bottom", "|", "Top"}], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"CanvasInterval", "[", 
                RowBox[{"[", "1", "]"}], "]"}], ",", "CanvasCoordinate"}], 
              "}"}], ",", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"CanvasInterval", "[", 
                RowBox[{"[", "2", "]"}], "]"}], ",", "CanvasCoordinate"}], 
              "}"}]}], "}"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "do", " ", "tail", " ", "and", " ", "head", " ", "extension"}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"CanvasTail", "=", 
         RowBox[{"InterpolateSegment", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Take", "[", 
            RowBox[{"CanvasPoints", ",", "2"}], "]"}], ",", 
           "\[IndentingNewLine]", "Tail", ",", "Absolute", ",", 
           "\[IndentingNewLine]", 
           RowBox[{"-", 
            RowBox[{"UpgradeScalar", "[", 
             RowBox[{"(", 
              RowBox[{"TailExtension", "/.", "FigOptions"}], ")"}], "]"}]}]}],
           "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"CanvasHead", "=", 
         RowBox[{"InterpolateSegment", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Take", "[", 
            RowBox[{"CanvasPoints", ",", 
             RowBox[{"-", "2"}]}], "]"}], ",", "\[IndentingNewLine]", "Head", 
           ",", "Absolute", ",", "\[IndentingNewLine]", 
           RowBox[{"+", 
            RowBox[{"UpgradeScalar", "[", 
             RowBox[{"(", 
              RowBox[{"HeadExtension", "/.", "FigOptions"}], ")"}], "]"}]}]}],
           "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"CanvasPoints", "=", 
         RowBox[{"ReplacePart", "[", 
          RowBox[{"CanvasPoints", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"1", "\[Rule]", "CanvasTail"}], ",", 
             RowBox[{
              RowBox[{"-", "1"}], "\[Rule]", "CanvasHead"}]}], "}"}]}], 
          "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"save", " ", "curve", " ", "data"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"Self", "@", 
         RowBox[{"SetPoints", "[", "CanvasPoints", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Self", "@", 
         RowBox[{"SetSide", "[", "Side", "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"make", " ", "curve", " ", "line"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"FigLineElement", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Line", "[", "CanvasPoints", "]"}], "}"}], ",", 
          "\[IndentingNewLine]", "FigOptions"}], "\[IndentingNewLine]", "]"}],
         ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"make", " ", "arrowhead", " ", "lines"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"FigLineElement", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Line", "[", "\[IndentingNewLine]", 
            RowBox[{"FigCurveArrowheadPoints", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Self", "@", 
               RowBox[{"MakeAnchor", "[", 
                RowBox[{"Tail", ",", "None"}], "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Self", "@", 
               RowBox[{"MakeAnchor", "[", 
                RowBox[{"Head", ",", "None"}], "]"}]}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Flatten", "[", 
               RowBox[{
               "{", "\[IndentingNewLine]", "FigOptions", 
                "\[IndentingNewLine]", "}"}], "]"}]}], "\[IndentingNewLine]", 
             "]"}], "\[IndentingNewLine]", "]"}], "}"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Flatten", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Dashing", "\[Rule]", "None"}], ",", "FigOptions"}], 
            "}"}], "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"resolve", " ", "tick", " ", "text", " ", "options"}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
           RowBox[{
           "first", " ", "we", " ", "need", " ", "to", " ", "resolve", " ", 
            "the", " ", "tick"}], "-", 
           RowBox[{"specific", " ", "options"}]}], ",", " ", 
          RowBox[{
          "now", " ", "renamed", " ", "as", " ", "generic", " ", "text", " ", 
           "options"}]}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TickOptions", "=", 
         RowBox[{"Last", "[", 
          RowBox[{"FigResolveDerivedLabelOptions", "[", 
           RowBox[{"\"\<Tick\>\"", ",", "False", ",", "FigOptions"}], "]"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "automatic", " ", "determination", " ", "of", " ", "tick", " ", 
           "font", " ", 
           RowBox[{"size", " ", "--"}], " ", "must", " ", "be", " ", "done", 
           " ", "using", " ", "FigOptions"}], ",", " ", 
          RowBox[{
          "since", " ", "in", " ", "TickOptions", " ", "TickFontSize", " ", 
           "is", " ", "\"\<upgraded\>\"", " ", "to", " ", "FontSize"}]}], " ",
          "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"cases", ":", " ", "\[IndentingNewLine]", "TickFontSize"}], 
          "->", 
          RowBox[{
           RowBox[{
            RowBox[{"Automatic", " ", "--"}], " ", "calculate", " ", 
            "FontSize", " ", "from", " ", "old", " ", "FontSize", " ", 
            "times", " ", "TickFontSizeFactor", " ", "\[IndentingNewLine]", 
            "TickFontSize"}], "\[Rule]", 
           RowBox[{
            RowBox[{
             RowBox[{"Default", " ", "--"}], " ", "use", " ", "FontSize", 
             "\[IndentingNewLine]", "TickFontSize"}], "\[Rule]", 
            RowBox[{
             RowBox[{"value", " ", "--"}], " ", "set", " ", "FontSize", " ", 
             "to", " ", "TickFontSize"}]}]}]}], "\[IndentingNewLine]", "*)"}],
         "\[IndentingNewLine]", 
        RowBox[{"TickOptions", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
            "the", " ", "final", " ", "decision", " ", "on", " ", "tick", " ",
              "font", " ", "size"}], " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"FontSize", "\[Rule]", 
             RowBox[{"ResolveOption", "[", 
              RowBox[{"FontSize", ",", 
               RowBox[{"{", 
                RowBox[{"Automatic", "\[RuleDelayed]", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"TickFontSizeFactor", "/.", "FigOptions"}], ")"}], 
                  "*", 
                  RowBox[{"(", 
                   RowBox[{"FontSize", "/.", "FigOptions"}], ")"}]}]}], "}"}],
                ",", "TickOptions"}], "]"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
             "the", " ", "rest", " ", "of", " ", "the", " ", "resolved", " ", 
              "text", " ", "options"}], " ", "*)"}], "\[IndentingNewLine]", 
            "TickOptions", ",", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
             "and", " ", "fall", " ", "through", " ", "to", " ", "all", " ", 
              "other", " ", "options", " ", "from", " ", "FigOptions"}], " ", 
             "*)"}], "\[IndentingNewLine]", "FigOptions"}], 
           "\[IndentingNewLine]", "}"}], "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"resolve", " ", "tick", " ", "list"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"determine", " ", "basic", " ", "tick", " ", 
          RowBox[{"list", " ", "--"}], " ", "given", " ", "or", " ", 
          "computed", " ", "from", " ", "range"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{
         "Self", ",", "Ticks", ",", "TickListSpecificationPattern", ",", 
          "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"RangeUseableForTicks", "=", 
         RowBox[{"MatchQ", "[", 
          RowBox[{"Range", ",", "NumericalPairPattern"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"resolving", " ", "tick", " ", "label", " ", 
           RowBox[{"range", " ", "--"}], " ", "tick", " ", "label", " ", 
           "range", " ", "may", " ", "be", " ", "given", " ", "explicitly"}], 
          ",", " ", 
          RowBox[{
          "else", " ", "if", " ", "left", " ", "as", " ", "Automatic", " ", 
           "the", " ", "nominal", " ", "axis", " ", "Range", " ", "is", " ", 
           "used"}], ",", " ", 
          RowBox[{
          "if", " ", "this", " ", "was", " ", "given", " ", "explicitly", " ",
            "as", " ", "a", " ", "range", " ", "of", " ", "coordinates"}], 
          ",", " ", 
          RowBox[{
          "else", " ", "the", " ", "flag", " ", "value", " ", "All", " ", 
           "is", " ", "used"}], ",", " ", 
          RowBox[{
          "meaning", " ", "no", " ", "clipping", " ", "of", " ", "tick", " ", 
           "labels", " ", "will", " ", "be", " ", "imposed"}]}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"UsedTickLabelRange", "=", 
         RowBox[{"ResolveOption", "[", 
          RowBox[{"TickLabelRange", ",", 
           RowBox[{"{", 
            RowBox[{"Automatic", "\[Rule]", 
             RowBox[{"If", "[", 
              RowBox[{"RangeUseableForTicks", ",", "Range", ",", "All"}], 
              "]"}]}], "}"}], ",", "FigOptions"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"TickList", "=", 
         RowBox[{"Switch", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"Ticks", "/.", "FigOptions"}], ")"}], ",", 
           "\[IndentingNewLine]", "None", ",", 
           RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", "_List", ",", 
           RowBox[{"(", 
            RowBox[{"Ticks", "/.", "FigOptions"}], ")"}], ",", 
           "\[IndentingNewLine]", "Automatic", ",", 
           RowBox[{"If", "[", 
            RowBox[{"RangeUseableForTicks", ",", 
             RowBox[{"LinTicks", "@@", "Range"}], ",", 
             RowBox[{"{", "}"}]}], "]"}], ",", "\[IndentingNewLine]", "_", 
           ",", 
           RowBox[{"If", "[", 
            RowBox[{"RangeUseableForTicks", ",", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"Ticks", "/.", "FigOptions"}], ")"}], "@@", "Range"}], 
             ",", 
             RowBox[{"{", "}"}]}], "]"}]}], "\[IndentingNewLine]", "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckValue", "[", 
         RowBox[{"Self", ",", "TickList", ",", 
          RowBox[{"_", "?", "TickListQ"}], ",", 
          "\"\<deduced set of tick marks\>\""}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "upgrade", " ", "tick", " ", "list", " ", "to", " ", "standard", " ",
           "form"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TickList", "=", 
         RowBox[{"AugmentTicks", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"0.0075", ",", "0"}], "}"}], ",", 
           RowBox[{"{", "}"}], ",", "TickList"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "suppress", " ", "tick", " ", "list", " ", "if", " ", "no"}], "-", 
          "show"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TickList", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"ShowTicks", "/.", "FigOptions"}], ",", "TickList", ",", 
           RowBox[{"{", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "suppress", " ", "tick", " ", "labels", " ", "if", " ", "labels", 
           " ", "no"}], "-", "show"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TickList", "=", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"ShowTickLabels", "/.", "FigOptions"}], ",", "TickList", 
           ",", 
           RowBox[{"StripTickLabels", "[", "TickList", "]"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"limit", " ", "ticks", " ", "to", " ", "originally"}], "-", 
          
          RowBox[{"specified", " ", "coordinate", " ", "range"}]}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{"RangeUseableForTicks", ",", "\[IndentingNewLine]", 
          RowBox[{"TickList", "=", 
           RowBox[{"LimitTickRange", "[", 
            RowBox[{"Range", ",", "TickList"}], "]"}]}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "limit", " ", "tick", " ", "labels", " ", "to", " ", "specified", 
          " ", "coordinate", " ", "range"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"UsedTickLabelRange", "=!=", "All"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"TickList", "=", 
           RowBox[{"LimitTickLabelRange", "[", 
            RowBox[{"UsedTickLabelRange", ",", "TickList"}], "]"}]}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Debug", "/.", "FigOptions"}], ")"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Print", "[", 
            RowBox[{"\"\<Axis ticks...\>\"", ",", "\"\< Given: \>\"", ",", 
             RowBox[{"(", 
              RowBox[{"Ticks", "/.", "FigOptions"}], ")"}], ",", 
             "\"\< Label range: \>\"", ",", " ", "UsedTickLabelRange", ",", 
             "\"\< Final tick list: \>\"", ",", "TickList"}], "]"}], ";"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "convert", " ", "ticks", " ", "to", " ", "canvas", " ", 
          "coordinates"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
           StyleBox["Mathematica",
            FontSlant->"Italic"], " ", "uses", " ", "scaled", " ", 
           "coordinates", " ", "for", " ", "tick", " ", 
           RowBox[{"lengths", ".", " ", "Here"}], " ", "we", " ", "use", " ", 
           "an", " ", "averaged", " ", "scaled", " ", "coordinate", " ", 
           "based", " ", "upon", " ", "the", " ", "average", " ", "of", " ", 
           "the", " ", "full", " ", 
           RowBox[{"plot", "'"}], "s", " ", "horizontal", " ", "and", " ", 
           "vertical", " ", "sizes"}], ",", " ", 
          RowBox[{
          "to", " ", "ensure", " ", "consistent", " ", "tick", " ", "lengths",
            " ", "between", " ", "horizontal", " ", "and", " ", "vertical", 
           " ", "axes", " ", "and", " ", "between", " ", 
           RowBox[{"panels", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"UsedTickLengthReference", "=", 
         RowBox[{"ResolveOption", "[", 
          RowBox[{"TickLengthReference", ",", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{"Automatic", "\[RuleDelayed]", 
             RowBox[{"Mean", "[", 
              RowBox[{"-", 
               RowBox[{"Subtract", "@@@", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"CurrentWindow", "[", "]"}], "@", 
                  RowBox[{"CanvasRegion", "[", "]"}]}], ")"}]}]}], "]"}]}], 
            "\[IndentingNewLine]", "}"}], ",", "FigOptions"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"UsedTickLengthScale", "=", 
         RowBox[{"(", 
          RowBox[{"TickLengthScale", "/.", "FigOptions"}], ")"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"TickList", "=", 
         RowBox[{"TransformTicks", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"FigResolveCoordinate", "[", 
              RowBox[{"#", ",", 
               RowBox[{"AntiCoordinateIndex", "[", "CoordinateIndex", "]"}]}],
               "]"}], "&"}], ")"}], "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{"With", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"UsedAntiCoordinateIndex", "=", 
                RowBox[{
                "AntiCoordinateIndex", "[", "CoordinateIndex", "]"}]}], "}"}],
               ",", "\[IndentingNewLine]", 
              RowBox[{"(", 
               RowBox[{
                RowBox[{"FigResolveCoordinate", "[", 
                 RowBox[{"#", ",", "UsedAntiCoordinateIndex"}], "]"}], "&"}], 
               ")"}]}], "\[IndentingNewLine]", "]"}], "*)"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
             "UsedTickLengthReference", "*", "UsedTickLengthScale", "*", 
              "#"}], "&"}], ")"}], ",", "\[IndentingNewLine]", "TickList"}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"iterate", " ", "over", " ", "ticks"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"accumulating", " ", "line", " ", "directives"}], ",", " ", 
          
          RowBox[{"emitting", " ", "labels"}], ",", " ", 
          RowBox[{"and", " ", "retaining", " ", "label", " ", "sizes"}]}], 
         " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"TickLineArt", "=", 
         RowBox[{"{", "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"ComputedTickLabelAllowance", "=", "0"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Do", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"extract", " ", "tick", " ", "parameters"}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{
             "TickPosn", ",", "TickText", ",", "TickLengths", ",", 
              "TickAttributes"}], "}"}], "=", "TickData"}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"compute", " ", "tick", " ", "geometry"}], " ", "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"Switch", "[", "\[IndentingNewLine]", 
            RowBox[{
            "Side", ",", "\[IndentingNewLine]", "Left", ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"TickPoint", "=", 
               RowBox[{"{", 
                RowBox[{"CanvasCoordinate", ",", "TickPosn"}], "}"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"TickEndPoints", "=", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"TickPoint", "+", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"TickLengths", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "0"}], "}"}]}], ",", 
                 
                 RowBox[{"TickPoint", "-", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"TickLengths", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "0"}], "}"}]}]}], 
                "}"}]}]}], ",", "\[IndentingNewLine]", "Right", ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"TickPoint", "=", 
               RowBox[{"{", 
                RowBox[{"CanvasCoordinate", ",", "TickPosn"}], "}"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"TickEndPoints", "=", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"TickPoint", "-", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"TickLengths", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ",", "0"}], "}"}]}], ",", 
                 
                 RowBox[{"TickPoint", "+", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"TickLengths", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "0"}], "}"}]}]}], 
                "}"}]}]}], ",", "\[IndentingNewLine]", "Bottom", ",", 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"TickPoint", "=", 
               RowBox[{"{", 
                RowBox[{"TickPosn", ",", "CanvasCoordinate"}], "}"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"TickEndPoints", "=", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"TickPoint", "+", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", 
                    RowBox[{"TickLengths", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], ",", 
                 RowBox[{"TickPoint", "-", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", 
                    RowBox[{"TickLengths", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}], "}"}]}]}], 
             ",", "\[IndentingNewLine]", "Top", ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"TickPoint", "=", 
               RowBox[{"{", 
                RowBox[{"TickPosn", ",", "CanvasCoordinate"}], "}"}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"TickEndPoints", "=", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"TickPoint", "-", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", 
                    RowBox[{"TickLengths", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], ",", 
                 RowBox[{"TickPoint", "+", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", 
                    RowBox[{"TickLengths", "[", 
                    RowBox[{"[", "2", "]"}], "]"}]}], "}"}]}]}], "}"}]}]}]}], 
            "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"accumulate", " ", "tick", " ", "lines", " ", 
             RowBox[{"(", 
              RowBox[{
              "with", " ", "any", " ", "style", " ", "directive", " ", 
               "overrides"}], ")"}]}], " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
            "suppressed", " ", "if", " ", "line", " ", "length", " ", "is", 
             " ", "null"}], " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{"Chop", "[", 
               RowBox[{"Subtract", "@@", "TickEndPoints"}], "]"}], "!=", 
              RowBox[{"{", 
               RowBox[{"0", ",", "0"}], "}"}]}], ",", "\[IndentingNewLine]", 
             RowBox[{"AppendTo", "[", 
              RowBox[{"TickLineArt", ",", 
               RowBox[{"Join", "[", 
                RowBox[{"TickAttributes", ",", 
                 RowBox[{"{", 
                  RowBox[{"Line", "[", "TickEndPoints", "]"}], "}"}]}], 
                "]"}]}], "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"process", " ", "text"}], " ", "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
            "suppressed", " ", "if", " ", "label", " ", "text", " ", "is", 
             " ", "None", " ", "or", " ", "null", " ", "string"}], " ", 
            "*)"}], "\[IndentingNewLine]", 
           RowBox[{"TickText", "=", 
            RowBox[{"Replace", "[", 
             RowBox[{"TickText", ",", 
              RowBox[{"{", 
               RowBox[{"\"\<\>\"", "\[Rule]", "None"}], "}"}]}], "]"}]}], ";",
            "\[IndentingNewLine]", 
           RowBox[{"If", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"TickText", "=!=", "None"}], ")"}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{"emit", " ", "text"}], " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"TickOffset", "=", 
               RowBox[{"-", 
                RowBox[{"NamedPointOffset", "[", "Side", "]"}]}]}], ";", 
              "\[IndentingNewLine]", 
              RowBox[{"TickLabelAnchor", "=", 
               RowBox[{"FigAnchor", "[", 
                RowBox[{
                 RowBox[{"Canvas", "[", "TickPoint", "]"}], ",", "TickOffset",
                  ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"TextElement", "=", 
               RowBox[{"FigTextElement", "[", 
                RowBox[{
                "TickLabelAnchor", ",", "TickText", ",", "TickOptions"}], 
                "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"(*", " ", 
               RowBox[{"retain", " ", "dimension", " ", "information"}], " ", 
               "*)"}], "\[IndentingNewLine]", 
              RowBox[{"(*", " ", 
               RowBox[{
               "allow", " ", "for", " ", "height", " ", "on", " ", 
                "horizontal", " ", "axis", " ", "or", " ", "width", " ", "on",
                 " ", "vertical", " ", "axis"}], " ", "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{"ComputedTickLabelAllowance", "=", 
               RowBox[{"Max", "[", 
                RowBox[{"ComputedTickLabelAllowance", ",", 
                 RowBox[{"2", "*", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"TextElement", "@", 
                    RowBox[{"GetRadius", "[", "]"}]}], ")"}], "[", 
                   RowBox[{"[", "CoordinateIndex", "]"}], "]"}]}]}], 
                "]"}]}]}]}], "\[IndentingNewLine]", "]"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"TickData", ",", "TickList"}], "}"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"ComputedTickLabelAllowance", "=", 
         RowBox[{"GetAutoOption", "[", 
          RowBox[{
          "TickLabelAllowance", ",", "ComputedTickLabelAllowance", ",", 
           "FigOptions"}], "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "save", " ", "allowance", " ", "for", " ", "tick", " ", "labels"}], 
         " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Self", "@", 
         RowBox[{
         "SetTickLabelAllowance", "[", "ComputedTickLabelAllowance", "]"}]}], 
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "emit", " ", "tick", " ", "lines", " ", "all", " ", "together"}], 
         " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"FigLineElement", "[", 
         RowBox[{"TickLineArt", ",", 
          RowBox[{"Flatten", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Dashing", "\[Rule]", "None"}], ",", "FigOptions"}], 
            "}"}], "]"}]}], "]"}], ";"}]}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51510150784375*^9, 3.51510165284375*^9}, {
   3.5151018264375*^9, 3.515101837625*^9}, {3.515160729234375*^9, 
   3.5151607388125*^9}, {3.515160815109375*^9, 3.515160905421875*^9}, {
   3.515429900281625*^9, 3.5154299283285*^9}, {3.515432005344125*^9, 
   3.51543202310975*^9}, {3.515432080625375*^9, 3.515432260875375*^9}, {
   3.515432559875375*^9, 3.515432618141*^9}, {3.515432654812875*^9, 
   3.515432706531625*^9}, {3.515433020406625*^9, 3.515433023781625*^9}, {
   3.515442053016*^9, 3.5154420783285*^9}, {3.51544252460975*^9, 
   3.515442586281625*^9}, {3.5154469192035*^9, 3.515446929391*^9}, {
   3.5154471764535*^9, 3.515447183094125*^9}, {3.515447219250375*^9, 
   3.515447220250375*^9}, {3.515447301531625*^9, 3.5154473044535*^9}, 
   3.515448155969125*^9, 3.515450489000375*^9, {3.515609990484375*^9, 
   3.51561000875*^9}, {3.515617766265625*^9, 3.5156177708125*^9}, {
   3.5156826745625*^9, 3.51568274115625*^9}, {3.515683305421875*^9, 
   3.5156833216875*^9}, {3.515883868671875*^9, 3.51588387675*^9}, 
   3.515885261171875*^9, {3.51603966277075*^9, 3.516039663630125*^9}, {
   3.516045450927*^9, 3.5160454624895*^9}, {3.5160455218645*^9, 
   3.516045539223875*^9}, {3.516045652817625*^9, 3.516045717552*^9}, {
   3.516045752286375*^9, 3.516045784536375*^9}, {3.5160458634895*^9, 
   3.516046002130125*^9}, {3.516046033536375*^9, 3.516046216630125*^9}, {
   3.516046532567625*^9, 3.516046942630125*^9}, {3.5160470881145*^9, 
   3.516047147380125*^9}, {3.51604745283325*^9, 3.516047456567625*^9}, {
   3.51604788533325*^9, 3.516048041442625*^9}, {3.516048214427*^9, 
   3.5160482212395*^9}, {3.516287252234375*^9, 3.5162872574375*^9}, {
   3.5162905426875*^9, 3.516290543296875*^9}, {3.516291682984375*^9, 
   3.516291683828125*^9}, {3.51629173628125*^9, 3.5162917448125*^9}, {
   3.51629192509375*^9, 3.51629214496875*^9}, {3.516292176953125*^9, 
   3.516292210546875*^9}, {3.51629247725*^9, 3.516292481359375*^9}, {
   3.516292593859375*^9, 3.51629259490625*^9}, {3.516292634265625*^9, 
   3.516292665984375*^9}, {3.51629506915625*^9, 3.51629511221875*^9}, {
   3.516295189765625*^9, 3.516295211640625*^9}, {3.5162954033125*^9, 
   3.516295437625*^9}, 3.516295556359375*^9, {3.51629651965625*^9, 
   3.5162965336875*^9}, {3.51629739659375*^9, 3.516297715625*^9}, {
   3.5162977495625*^9, 3.516297783984375*^9}, {3.516297827359375*^9, 
   3.51629783871875*^9}, {3.51629787203125*^9, 3.516297898609375*^9}, {
   3.51629805425*^9, 3.51629808940625*^9}, {3.51629812540625*^9, 
   3.516298148953125*^9}, {3.516298687046875*^9, 3.51629868796875*^9}, {
   3.516298774046875*^9, 3.516298777109375*^9}, {3.516299102609375*^9, 
   3.516299115140625*^9}, {3.516299289359375*^9, 3.516299301234375*^9}, {
   3.51629933459375*^9, 3.5162993771875*^9}, {3.51629946625*^9, 
   3.51629946646875*^9}, {3.51629950028125*^9, 3.51629950065625*^9}, {
   3.516299535015625*^9, 3.516299539890625*^9}, {3.51629981090625*^9, 
   3.516299812015625*^9}, {3.51629984578125*^9, 3.516299920828125*^9}, {
   3.516299980453125*^9, 3.516300092703125*^9}, {3.5163001245625*^9, 
   3.51630014696875*^9}, {3.516300197*^9, 3.51630024590625*^9}, {
   3.516300465359375*^9, 3.516300584296875*^9}, {3.5163006343125*^9, 
   3.516300643546875*^9}, {3.51630073709375*^9, 3.5163007574375*^9}, {
   3.51630082103125*^9, 3.516300863546875*^9}, {3.5163009275*^9, 
   3.51630094215625*^9}, {3.516301059671875*^9, 3.516301087765625*^9}, {
   3.516301163953125*^9, 3.516301201640625*^9}, {3.516301489984375*^9, 
   3.516301537671875*^9}, {3.516301568328125*^9, 3.51630158128125*^9}, {
   3.51630166578125*^9, 3.51630202090625*^9}, {3.5163021098125*^9, 
   3.516302157078125*^9}, {3.5163021915625*^9, 3.5163026446875*^9}, {
   3.516302782734375*^9, 3.5163029114375*^9}, {3.51630294834375*^9, 
   3.51630301946875*^9}, {3.516303100515625*^9, 3.516303167390625*^9}, {
   3.516303203875*^9, 3.516303222921875*^9}, {3.5163032564375*^9, 
   3.51630326453125*^9}, {3.516303312078125*^9, 3.51630341321875*^9}, {
   3.5163035395625*^9, 3.516303608046875*^9}, {3.51630364353125*^9, 
   3.51630364675*^9}, {3.5163037315625*^9, 3.516303748*^9}, {
   3.516303966625*^9, 3.516303969875*^9}, 3.51630418134375*^9, {
   3.516304217203125*^9, 3.51630421809375*^9}, 3.516304418421875*^9, {
   3.5163044751875*^9, 3.51630455909375*^9}, {3.516304597625*^9, 
   3.5163047205*^9}, {3.516304753625*^9, 3.516304852640625*^9}, 
   3.516305101*^9, 3.516305201296875*^9, {3.516305281296875*^9, 
   3.516305297984375*^9}, {3.516305436453125*^9, 3.51630548896875*^9}, {
   3.516305575671875*^9, 3.51630557628125*^9}, {3.516305620234375*^9, 
   3.51630562521875*^9}, {3.5163057005*^9, 3.5163057540625*^9}, {
   3.51630581734375*^9, 3.516305827578125*^9}, {3.516305873359375*^9, 
   3.51630588571875*^9}, {3.516306785296875*^9, 3.516306785625*^9}, {
   3.51640016484375*^9, 3.516400178359375*^9}, {3.51646238065625*^9, 
   3.516462382453125*^9}, {3.516464183078125*^9, 3.51646420428125*^9}, {
   3.516471946265625*^9, 3.516471956109375*^9}, 3.516473731078125*^9, {
   3.518018986671875*^9, 3.518018991890625*^9}, {3.518472445296875*^9, 
   3.518472499796875*^9}, {3.51964804725*^9, 3.519648050203125*^9}, {
   3.520026377265625*^9, 3.5200263805625*^9}, {3.520026438703125*^9, 
   3.52002644540625*^9}, {3.5204325151875*^9, 3.52043253821875*^9}, {
   3.524072880953125*^9, 3.524072896765625*^9}, {3.524072943140625*^9, 
   3.52407295690625*^9}, {3.524073112625*^9, 3.524073124828125*^9}, {
   3.524073306625*^9, 3.524073329453125*^9}, 3.52407337215625*^9, {
   3.524073412984375*^9, 3.524073419421875*^9}, {3.524073469546875*^9, 
   3.52407348071875*^9}, {3.5240735446875*^9, 3.524073578203125*^9}, {
   3.524073612390625*^9, 3.52407363225*^9}, {3.524073835359375*^9, 
   3.524073888640625*^9}, {3.52407392225*^9, 3.524073934078125*^9}, {
   3.524073977765625*^9, 3.524073980734375*^9}, {3.524074190578125*^9, 
   3.5240742885*^9}, {3.52407434975*^9, 3.5240743550625*^9}, {
   3.524074509453125*^9, 3.52407451971875*^9}, {3.533750961375*^9, 
   3.53375103309375*^9}, {3.533751067125*^9, 3.533751137984375*^9}, {
   3.551355090140625*^9, 3.551355091984375*^9}, 3.551355213328125*^9, 
   3.551355243921875*^9, {3.551355279953125*^9, 3.55135532921875*^9}, {
   3.5513553921875*^9, 3.551355398796875*^9}, {3.55135573984375*^9, 
   3.551355755375*^9}, {3.5790396993632765`*^9, 3.5790397142647552`*^9}, {
   3.579101123034821*^9, 3.5791011384632483`*^9}, {3.579101218101388*^9, 
   3.579101231299011*^9}, {3.5791012804078975`*^9, 3.5791013245403748`*^9}, {
   3.5791013597184367`*^9, 3.579101533658742*^9}, {3.5791015990696573`*^9, 
   3.579101735382696*^9}, {3.579103856374585*^9, 3.579103885034625*^9}, {
   3.579103967644741*^9, 3.5791039696947436`*^9}, {3.5791040472748528`*^9, 
   3.5791040496048555`*^9}, 3.579104591915615*^9, {3.579105102908331*^9, 
   3.5791051483483944`*^9}, {3.579105197288463*^9, 3.579105210458482*^9}, {
   3.579105375903713*^9, 3.5791054314137907`*^9}, {3.5839542382678733`*^9, 
   3.5839542433928804`*^9}, {3.5962847082198863`*^9, 
   3.5962847703235955`*^9}, {3.596284840024518*^9, 3.596284849400134*^9}, {
   3.5962848954046154`*^9, 3.5962849058878336`*^9}, {3.596285144958254*^9, 
   3.596285146799057*^9}, 3.5962852308676043`*^9, {3.5965828170023937`*^9, 
   3.5965828194203978`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Methods", "Subsection",
 CellChangeTimes->{{3.5151660264375*^9, 3.515166028765625*^9}, {
  3.515449067344125*^9, 3.51544909085975*^9}}],

Cell["convenience label \[OpenCurlyDoubleQuote]Axis\[CloseCurlyDoubleQuote] \
allows for width of tick labels", "Text",
 CellChangeTimes->{{3.516047265911375*^9, 3.516047276411375*^9}, {
  3.516048895005125*^9, 3.516048919130125*^9}, {3.516292391578125*^9, 
  3.5162923965625*^9}, {3.516298171390625*^9, 3.51629820209375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"MakeAnchor", "[", 
      RowBox[{
       RowBox[{"Class", ":", "FigAxis"}], ",", "Self_Object"}], "]"}], "[", 
     RowBox[{
      RowBox[{"Name", ":", "\"\<Axis\>\""}], ",", "Arg_"}], "]"}], ":=", 
    RowBox[{"FigMakeAnchorWrapper", "[", 
     RowBox[{
     "Class", ",", "Self", ",", "Name", ",", "Arg", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"DisplacePoint", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"FigCurveAnchorFromPoints", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Self", "@", 
           RowBox[{"GetPoints", "[", "]"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"Switch", "[", 
           RowBox[{
            RowBox[{"Self", "@", 
             RowBox[{"GetSide", "[", "]"}]}], ",", 
            RowBox[{"Left", "|", "Top"}], ",", "Left", ",", 
            RowBox[{"Bottom", "|", "Right"}], ",", "Right"}], "]"}], ",", 
          "\[IndentingNewLine]", "Arg"}], "\[IndentingNewLine]", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Canvas", "[", 
         RowBox[{
          RowBox[{"NamedPointOffset", "[", 
           RowBox[{"Self", "@", 
            RowBox[{"GetSide", "[", "]"}]}], "]"}], "*", 
          RowBox[{"(", 
           RowBox[{"Self", "@", 
            RowBox[{"GetTickLabelAllowance", "[", "]"}]}], ")"}]}], "]"}]}], 
       "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  " "}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51517464803125*^9, 3.515174666234375*^9}, {
   3.5151749220625*^9, 3.515174944015625*^9}, {3.51525866915625*^9, 
   3.515258669703125*^9}, {3.51544000385975*^9, 3.5154400110785*^9}, {
   3.515448814344125*^9, 3.515448817391*^9}, {3.51604721477075*^9, 
   3.516047279348875*^9}, {3.516048287473875*^9, 3.516048288302*^9}, {
   3.51604888733325*^9, 3.5160489227395*^9}, {3.516049255973875*^9, 
   3.5160492564895*^9}, {3.516291116875*^9, 3.516291118375*^9}, {
   3.516291150203125*^9, 3.51629118646875*^9}, {3.51629147759375*^9, 
   3.51629149828125*^9}, {3.51629241059375*^9, 3.516292469296875*^9}, {
   3.516298298734375*^9, 3.51629829946875*^9}, {3.51629840534375*^9, 
   3.516298516703125*^9}, {3.516298573390625*^9, 3.51629865590625*^9}, {
   3.5163034258125*^9, 3.516303478125*^9}, {3.5196480723125*^9, 
   3.51964808265625*^9}, {3.519648149390625*^9, 3.519648150453125*^9}, 
   3.5196521300625*^9, 3.6251645090502586`*^9}],

Cell["define standard curve anchors (needed, e.g., for arrowheads)", "Text",
 CellChangeTimes->{{3.516291781984375*^9, 3.5162917921875*^9}, {
   3.516291836703125*^9, 3.516291844625*^9}, 3.516298649390625*^9, {
   3.519648116546875*^9, 3.519648118453125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakeAnchor", "[", 
     RowBox[{
      RowBox[{"Class", ":", "FigAxis"}], ",", "Self_Object"}], "]"}], "[", 
    RowBox[{
     RowBox[{"Name", ":", 
      RowBox[{"Except", "[", "\"\<Axis\>\"", "]"}]}], ",", "Arg_"}], "]"}], ":=", 
   RowBox[{"FigMakeAnchorWrapper", "[", 
    RowBox[{
    "Class", ",", "Self", ",", "Name", ",", "Arg", ",", "\[IndentingNewLine]", 
     RowBox[{"FigCurveAnchorFromPoints", "[", 
      RowBox[{
       RowBox[{"Self", "@", 
        RowBox[{"GetPoints", "[", "]"}]}], ",", "Name", ",", "Arg"}], "]"}]}],
     "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51517464803125*^9, 3.515174666234375*^9}, {
  3.5151749220625*^9, 3.515174944015625*^9}, {3.51525866915625*^9, 
  3.515258669703125*^9}, {3.51544000385975*^9, 3.5154400110785*^9}, {
  3.515448814344125*^9, 3.515448817391*^9}, {3.51604721477075*^9, 
  3.516047279348875*^9}, {3.516048292161375*^9, 3.5160482936145*^9}, {
  3.516290548953125*^9, 3.51629056646875*^9}, {3.516291798546875*^9, 
  3.516291799953125*^9}, {3.516298658828125*^9, 3.516298659328125*^9}, {
  3.5196481323125*^9, 3.519648147015625*^9}}],

Cell["define standard bounding box", "Text",
 CellChangeTimes->{{3.516290567921875*^9, 3.516290574703125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakeBoundingBox", "[", 
     RowBox[{
      RowBox[{"Class", ":", "FigAxis"}], ",", "Self_Object"}], "]"}], "[", 
    "]"}], ":=", 
   RowBox[{"FigCurveBoundingBox", "[", 
    RowBox[{"Self", "@", 
     RowBox[{"GetPoints", "[", "]"}]}], "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51517464803125*^9, 3.515174666234375*^9}, {
  3.5151749220625*^9, 3.515174944015625*^9}, {3.51525866915625*^9, 
  3.515258669703125*^9}, {3.51544000385975*^9, 3.5154400110785*^9}, {
  3.515448814344125*^9, 3.515448817391*^9}, {3.51604721477075*^9, 
  3.516047279348875*^9}, {3.516048292161375*^9, 3.5160482936145*^9}, {
  3.516290548953125*^9, 3.51629056646875*^9}, {3.516298662046875*^9, 
  3.51629866265625*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["FigurePanel", "Section",
 CellChangeTimes->{{3.51542982092225*^9, 3.515429824641*^9}, {
  3.51544915248475*^9, 3.51544915367225*^9}, {3.515449711844125*^9, 
  3.515449712266*^9}, {3.51553005596875*^9, 3.515530058015625*^9}, {
  3.51578190328125*^9, 3.515781903984375*^9}, {3.5163905604375*^9, 
  3.51639056059375*^9}}],

Cell[CellGroupData[{

Cell["Special constructor interface ", "Subsection",
 CellChangeTimes->{{3.51543192685975*^9, 3.5154319283285*^9}, {
   3.515787465640625*^9, 3.5157874870625*^9}, 3.52045397378125*^9, {
   3.520945460546875*^9, 3.520945462046875*^9}}],

Cell["\<\
Initial approach: Uniformity would suggest defining figure panels through an \
object FigPanel.  The natural syntax would be FigPanel[body,...].

Problem: Unfortunately, since FigPanel is not the head symbol here, there is \
no mechanism for \[OpenCurlyDoubleQuote]holding\[CloseCurlyDoubleQuote] the \
evaluation of body until inside the FigPanel constructor.

Constraints: On the other hand, it is indispensable that FigPanel be derived \
from FigObject in the InheritOptions sense (so that it inherits *options* \
from FigObject) and it also be a derived class of FigObject in the MathObject \
sense (critically, so that it respects FigStyle styles, and for convenience \
so that the usual anchor methods can be used on it).

Solution: The compromise is to define a nonstandard \
\[OpenCurlyDoubleQuote]wrapper\[CloseCurlyDoubleQuote] function \
FigurePanel[body,...] for invocation by the user, in lieu of the standard \
constructor.  This wrapper will have attribute HoldFirst.  The wrapper then \
calls the standard constructor wrapper and thus in turn the standard \
constructor, which will be responsible for the usual object-ish tasks (like \
saving the panel\[CloseCurlyQuote]s parameters as member data) but not for \
evaluating the body, which will happen last.

Nomenclature: To provide a reminder the nonstandard syntax, we will use a \
name which does not conform to the usual FigXxxx pattern, instead retaining \
the LevelScheme name FigurePanel.  By its resemblance to Figure[], this is \
distanced from being an \[OpenCurlyDoubleQuote]object\[CloseCurlyDoubleQuote] \
and appears more like a \[OpenCurlyDoubleQuote]scoping structure\
\[CloseCurlyDoubleQuote] like Figure[].

Object instance name argument: We still want to be able to define a name for \
the panel.  This will be passed as an optional parameter in the nonstandard \
wrapper\[CloseCurlyQuote]s argument sequence.
\tFigurePanel[
\t\tbody,
\t\toptions...
\t\t];
\t\t
The required argument $PrivateConstructorMarker is extra insurance against \
the object constructor ever being directly executed by the user.
The explicit reference to ConstructorWrapper is needed since the standard \
FigurePanel[name][...] syntax can conflict with the present nonstandard \
wrapper.\
\>", "Text",
 CellChangeTimes->{{3.515785348171875*^9, 3.5157854691875*^9}, {
   3.51578586934375*^9, 3.51578590575*^9}, {3.515785953796875*^9, 
   3.515786303578125*^9}, {3.515786340703125*^9, 3.515786722984375*^9}, {
   3.515786769890625*^9, 3.515786959171875*^9}, {3.51578744971875*^9, 
   3.515787457921875*^9}, {3.51579904684375*^9, 3.515799106796875*^9}, {
   3.515799439484375*^9, 3.515799517671875*^9}, {3.515799748359375*^9, 
   3.515799769859375*^9}, 3.515866198890625*^9, 3.51801900346875*^9, {
   3.5200203974375*^9, 3.52002040778125*^9}, {3.549727111984375*^9, 
   3.549727141890625*^9}}],

Cell["General attributes", "Text",
 CellChangeTimes->{{3.52648176496875*^9, 3.526481767921875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"FigurePanel", ",", 
    RowBox[{"{", "HoldFirst", "}"}]}], "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515785185953125*^9, 3.51578519690625*^9}, {
   3.51578749946875*^9, 3.51578749959375*^9}, {3.51578753015625*^9, 
   3.51578772209375*^9}, {3.515789771671875*^9, 3.515789794328125*^9}, {
   3.515790736046875*^9, 3.51579074071875*^9}, {3.51579580096875*^9, 
   3.5157958099375*^9}, {3.5157958426875*^9, 3.515795844734375*^9}, {
   3.515795968875*^9, 3.515795971796875*^9}, {3.515796146546875*^9, 
   3.515796148234375*^9}, 3.515797228203125*^9, {3.51579732215625*^9, 
   3.51579732790625*^9}, {3.515798195484375*^9, 3.515798216515625*^9}, {
   3.515798939734375*^9, 3.515798949078125*^9}, {3.5157990341875*^9, 
   3.515799036015625*^9}, {3.515799193078125*^9, 3.51579919928125*^9}, {
   3.5157993895*^9, 3.515799431546875*^9}, 3.515799616359375*^9, {
   3.515799674703125*^9, 3.515799683703125*^9}, {3.515799736984375*^9, 
   3.515799741625*^9}, {3.51586596171875*^9, 3.51586600884375*^9}, {
   3.515866132609375*^9, 3.515866229171875*^9}, {3.515879605765625*^9, 
   3.51587963259375*^9}, {3.515879666125*^9, 3.515879669421875*^9}, {
   3.516287238671875*^9, 3.51628723915625*^9}, {3.51785831470626*^9, 
   3.517858335239481*^9}, {3.5178583843223176`*^9, 3.5178583904947853`*^9}, {
   3.518024101234375*^9, 3.518024111515625*^9}, {3.51847451375*^9, 
   3.51847452234375*^9}, 3.52045068065625*^9, {3.520450730546875*^9, 
   3.5204507385*^9}, {3.520450914015625*^9, 3.5204509496875*^9}, {
   3.520451991765625*^9, 3.52045199765625*^9}, {3.5204674345625*^9, 
   3.52046743615625*^9}, {3.520524663515625*^9, 3.520524664453125*^9}, 
   3.526481757453125*^9}],

Cell["Standalone (or inset) panel", "Text",
 CellChangeTimes->{{3.520450964921875*^9, 3.520450975765625*^9}, {
  3.5663422104837227`*^9, 3.5663422121137476`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
    RowBox[{"Body_List", ",", "\[IndentingNewLine]", 
     RowBox[{"Opts___", "?", "OptionQ"}]}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Name", ",", "Self"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"extract", " ", "object", " ", "name", " ", "option"}], " ", 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Name", "=", 
       RowBox[{"Replace", "[", 
        RowBox[{"ObjectName", ",", 
         RowBox[{"Flatten", "[", 
          RowBox[{"{", 
           RowBox[{"Opts", ",", 
            RowBox[{"ObjectName", "\[Rule]", "None"}]}], "}"}], "]"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Self", "=", 
       RowBox[{"Object", "[", "Name", "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"do", " ", "ordinary", " ", "construction"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ConstructorWrapper", "[", 
        RowBox[{"FigurePanel", ",", "Self"}], "]"}], "[", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"HoldComplete", "[", "Body", "]"}], ",", "None", ",", 
        "\[IndentingNewLine]", 
        RowBox[{"FilterRules", "[", 
         RowBox[{
          RowBox[{"{", "Opts", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Except", "[", "Name", "]"}], "}"}]}], "]"}], ",", " ", 
        "\[IndentingNewLine]", "$PrivateConstructorMarker"}], 
       "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515785185953125*^9, 3.51578519690625*^9}, {
   3.51578749946875*^9, 3.51578749959375*^9}, {3.51578753015625*^9, 
   3.51578772209375*^9}, {3.515789771671875*^9, 3.515789794328125*^9}, {
   3.515790736046875*^9, 3.51579074071875*^9}, {3.51579580096875*^9, 
   3.5157958099375*^9}, {3.5157958426875*^9, 3.515795844734375*^9}, {
   3.515795968875*^9, 3.515795971796875*^9}, {3.515796146546875*^9, 
   3.515796148234375*^9}, 3.515797228203125*^9, {3.51579732215625*^9, 
   3.51579732790625*^9}, {3.515798195484375*^9, 3.515798216515625*^9}, {
   3.515798939734375*^9, 3.515798949078125*^9}, {3.5157990341875*^9, 
   3.515799036015625*^9}, {3.515799193078125*^9, 3.51579919928125*^9}, {
   3.5157993895*^9, 3.515799431546875*^9}, 3.515799616359375*^9, {
   3.515799674703125*^9, 3.515799683703125*^9}, {3.515799736984375*^9, 
   3.515799741625*^9}, {3.51586596171875*^9, 3.51586600884375*^9}, {
   3.515866132609375*^9, 3.515866229171875*^9}, {3.515879605765625*^9, 
   3.51587963259375*^9}, {3.515879666125*^9, 3.515879669421875*^9}, {
   3.516287238671875*^9, 3.51628723915625*^9}, {3.51785831470626*^9, 
   3.517858335239481*^9}, {3.5178583843223176`*^9, 3.5178583904947853`*^9}, {
   3.518024101234375*^9, 3.518024111515625*^9}, {3.51847451375*^9, 
   3.51847452234375*^9}, 3.52045068065625*^9, {3.520450730546875*^9, 
   3.5204507385*^9}, {3.520450914015625*^9, 3.5204509496875*^9}, {
   3.520451991765625*^9, 3.52045199765625*^9}, {3.5204674345625*^9, 
   3.52046743615625*^9}, {3.520524663515625*^9, 3.520524664453125*^9}, 
   3.526481757453125*^9, 3.531423576265625*^9, 3.54972420071875*^9, {
   3.549724486234375*^9, 3.549724494109375*^9}, {3.5663401821144323`*^9, 
   3.5663401827044325`*^9}, 3.566342228151494*^9, {3.566342265069561*^9, 
   3.566342266064576*^9}}],

Cell["Panel in array", "Text",
 CellChangeTimes->{{3.520450979140625*^9, 3.52045098515625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"FigurePanel", "::", "nomulti"}], "=", 
   "\"\<The second argument for FigurePanel was specified as `1`, which has \
the form of a pair of indices (or All), but no multipanel array is currently \
defined.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"FigurePanel", "::", "badindices"}], "=", 
   "\"\<The given {row,column} index pair `1` is out of range, or, if it is \
meant as a pattern, it does not match any panel indices in the current \
multipanel array's range.  The current multipanel array has dimensions `2`.\>\
\""}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51578867853125*^9, 3.515788682109375*^9}, {
  3.52045281346875*^9, 3.520452854703125*^9}, {3.520452896109375*^9, 
  3.520452958515625*^9}, {3.520453186671875*^9, 3.52045322434375*^9}, {
  3.520460618703125*^9, 3.52046061965625*^9}, {3.549725196609375*^9, 
  3.54972524328125*^9}, {3.5663421495277863`*^9, 3.5663421713656216`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigurePanel", "[", "\[IndentingNewLine]", 
    RowBox[{"Body_List", ",", "\[IndentingNewLine]", 
     RowBox[{"GivenPanelIndexPattern", ":", 
      RowBox[{"Except", "[", 
       RowBox[{"_", "?", "OptionQ"}], "]"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Opts___", "?", "OptionQ"}]}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "Name", ",", "Self", ",", "CurrentPanelRegion", ",", 
       "CurrentPanelOptions", ",", "MadeMatch", ",", "PanelIndexPattern"}], 
      "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"check", " ", "multipanel", " ", "sanity"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"note", ":", " ", 
       RowBox[{
       "must", " ", "use", " ", "class", " ", "rather", " ", "than", " ", 
        "object", " ", "in", " ", "FigError", " ", "since", " ", "object", 
        " ", "metadata", " ", "has", " ", "not", " ", "yet", " ", "been", " ",
         "registered"}]}], " ", "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"CurrentMultipanel", "[", "]"}], "===", "None"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"FigError", "[", 
         RowBox[{
         "FigurePanel", ",", "\"\<nomulti\>\"", ",", 
          "GivenPanelIndexPattern"}], "]"}]}], "\[IndentingNewLine]", "]"}], 
      ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"process", " ", "panel", " ", "index", " ", "pattern"}], " ", 
       "*)"}], "\[IndentingNewLine]", 
      RowBox[{"PanelIndexPattern", "=", 
       RowBox[{"ReplaceSequential", "[", 
        RowBox[{"GivenPanelIndexPattern", ",", 
         RowBox[{"{", 
          RowBox[{"All", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"_", ",", "_"}], "}"}]}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"do", " ", "ordinary", " ", "construction"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"MadeMatch", "=", "False"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Do", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"MatchQ", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"r", ",", "s"}], "}"}], ",", "PanelIndexPattern"}], 
           "]"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{"record", " ", "match"}], " ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"MadeMatch", "=", "True"}], ";", "\[IndentingNewLine]", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
            "retrieve", " ", "multipanel", " ", "parameters", " ", "for", " ",
              "this", " ", "individual", " ", "panel"}], "  ", "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"note", ":", " ", 
              RowBox[{
              "option", " ", "retrieval", " ", "must", " ", "be", " ", "done",
                " ", "here"}]}], ",", " ", 
             RowBox[{
             "before", " ", "options", " ", "are", " ", "used", " ", "in", 
              " ", "FigObjectWrapper"}], ",", " ", 
             RowBox[{"rather", " ", "than", " ", "in", " ", "constructor"}]}],
             " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"CurrentPanelOptions", "=", 
            RowBox[{"ExtractOptionsEntry", "[", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{"CurrentMultipanel", "[", "]"}], "@", 
                RowBox[{"GetPanelOptionsArrayList", "[", "]"}]}], ")"}], ",", 
              
              RowBox[{"{", 
               RowBox[{"r", ",", "s"}], "}"}]}], "]"}]}], ";", 
           "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{
             "provide", " ", "access", " ", "to", " ", "global", " ", 
              "variables", " ", "PanelRowIndex"}], ",", " ", 
             "PanelColumnIndex", ",", " ", 
             RowBox[{"and", " ", "PanelIndices"}]}], " ", "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"Block", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"PanelRowIndex", "=", "r"}], ",", 
               RowBox[{"PanelColumnIndex", "=", "s"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"PanelIndices", "=", 
                RowBox[{"{", 
                 RowBox[{"r", ",", "s"}], "}"}]}], ",", "\[IndentingNewLine]", 
               RowBox[{"PanelSequenceNumber", " ", "=", 
                RowBox[{
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"r", ",", "s"}], "}"}], "-", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "1"}], "}"}]}], ")"}], ".", 
                  RowBox[{"{", 
                   RowBox[{"PanelColumns", ",", "1"}], "}"}]}], "+", 
                 "1"}]}]}], "\[IndentingNewLine]", "}"}], ",", 
             "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{"extract", " ", "object", " ", "name", " ", 
               RowBox[{"option", " ", "--"}], " ", "here", " ", "for", " ", 
               "possible", " ", "access", " ", "to", " ", "panel", " ", 
               "variables"}], "*)"}], "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"Name", "=", 
               RowBox[{"Replace", "[", 
                RowBox[{"ObjectName", ",", 
                 RowBox[{"Flatten", "[", 
                  RowBox[{"{", 
                   RowBox[{"Opts", ",", 
                    RowBox[{"ObjectName", "\[Rule]", "None"}]}], "}"}], 
                  "]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
              RowBox[{"Self", "=", 
               RowBox[{"Object", "[", "Name", "]"}]}], ";", 
              "\[IndentingNewLine]", "\[IndentingNewLine]", 
              RowBox[{"(*", " ", 
               RowBox[{"call", " ", "constructor"}], " ", "*)"}], 
              "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"ConstructorWrapper", "[", 
                RowBox[{"FigurePanel", ",", "Self"}], "]"}], "[", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"HoldComplete", "[", "Body", "]"}], ",", 
                "PanelIndices", ",", "\[IndentingNewLine]", 
                RowBox[{"FilterRules", "[", 
                 RowBox[{
                  RowBox[{"{", "Opts", "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"Except", "[", "Name", "]"}], "}"}]}], "]"}], ",", 
                " ", "\[IndentingNewLine]", "CurrentPanelOptions", ",", 
                "\[IndentingNewLine]", "$PrivateConstructorMarker"}], 
               "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
            "]"}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", "]"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"r", ",", "PanelRows"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"s", ",", "PanelColumns"}], "}"}]}], "\[IndentingNewLine]", 
       "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"!", "MadeMatch"}], ",", "\[IndentingNewLine]", 
        RowBox[{"FigError", "[", 
         RowBox[{
         "FigurePanel", ",", "\"\<badindices\>\"", ",", 
          "GivenPanelIndexPattern", ",", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"CurrentMultipanel", "[", "]"}], "@", 
            RowBox[{"GetDimensions", "[", "]"}]}], ")"}]}], "]"}]}], 
       "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515785185953125*^9, 3.51578519690625*^9}, {
   3.51578749946875*^9, 3.51578749959375*^9}, {3.51578753015625*^9, 
   3.51578772209375*^9}, {3.515789771671875*^9, 3.515789794328125*^9}, {
   3.515790736046875*^9, 3.51579074071875*^9}, {3.51579580096875*^9, 
   3.5157958099375*^9}, {3.5157958426875*^9, 3.515795844734375*^9}, {
   3.515795968875*^9, 3.515795971796875*^9}, {3.515796146546875*^9, 
   3.515796148234375*^9}, 3.515797228203125*^9, {3.51579732215625*^9, 
   3.51579732790625*^9}, {3.515798195484375*^9, 3.515798216515625*^9}, {
   3.515798939734375*^9, 3.515798949078125*^9}, {3.5157990341875*^9, 
   3.515799036015625*^9}, {3.515799193078125*^9, 3.51579919928125*^9}, {
   3.5157993895*^9, 3.515799431546875*^9}, 3.515799616359375*^9, {
   3.515799674703125*^9, 3.515799683703125*^9}, {3.515799736984375*^9, 
   3.515799741625*^9}, {3.51586596171875*^9, 3.51586600884375*^9}, {
   3.515866132609375*^9, 3.515866229171875*^9}, {3.515879605765625*^9, 
   3.51587963259375*^9}, {3.515879666125*^9, 3.515879669421875*^9}, {
   3.516287238671875*^9, 3.51628723915625*^9}, {3.51785831470626*^9, 
   3.517858335239481*^9}, {3.5178583843223176`*^9, 3.5178583904947853`*^9}, {
   3.518024101234375*^9, 3.518024111515625*^9}, {3.51847451375*^9, 
   3.51847452234375*^9}, 3.52045068065625*^9, {3.520450730546875*^9, 
   3.5204507385*^9}, {3.520450914015625*^9, 3.52045095996875*^9}, {
   3.520450991453125*^9, 3.52045113575*^9}, {3.520451191765625*^9, 
   3.520451301484375*^9}, {3.5204516589375*^9, 3.520451662140625*^9}, {
   3.520451866171875*^9, 3.52045198315625*^9}, {3.5204520178125*^9, 
   3.520452055859375*^9}, {3.52045216459375*^9, 3.520452174421875*^9}, {
   3.52045231296875*^9, 3.520452347390625*^9}, {3.520452866609375*^9, 
   3.520452887578125*^9}, {3.520453088359375*^9, 3.520453134390625*^9}, 
   3.5204532186875*^9, {3.520458517875*^9, 3.52045852728125*^9}, {
   3.520458608921875*^9, 3.520458609421875*^9}, 3.52046744534375*^9, {
   3.52046847121875*^9, 3.520468472921875*^9}, {3.520524677125*^9, 
   3.520524679515625*^9}, {3.525883174203125*^9, 3.525883232421875*^9}, {
   3.525883304125*^9, 3.525883318359375*^9}, 3.5264817715*^9, {
   3.527276223140625*^9, 3.52727623025*^9}, 3.527276266171875*^9, {
   3.52727666434375*^9, 3.5272766755*^9}, {3.52727673975*^9, 
   3.527276740453125*^9}, {3.527710921765625*^9, 3.52771093440625*^9}, {
   3.54972468521875*^9, 3.549724694671875*^9}, {3.549724876875*^9, 
   3.549724893140625*^9}, {3.549724942828125*^9, 3.5497250739375*^9}, {
   3.549725117515625*^9, 3.54972516434375*^9}, {3.5497252645625*^9, 
   3.549725352421875*^9}, {3.549725605*^9, 3.549725696796875*^9}, {
   3.549725944078125*^9, 3.5497259986875*^9}, {3.5497260625*^9, 
   3.54972609328125*^9}, {3.549726182703125*^9, 3.5497261911875*^9}, {
   3.54972742753125*^9, 3.549727431546875*^9}, 3.549727462953125*^9, {
   3.566340187154439*^9, 3.56634018770444*^9}, {3.5663424273245535`*^9, 
   3.566342435003172*^9}, {3.5774719057395315`*^9, 3.577471908438336*^9}, {
   3.577471939887991*^9, 3.577471941494794*^9}, {3.5850816074494076`*^9, 
   3.5850816240394306`*^9}, 3.5850819992515917`*^9, {3.6050375185846944`*^9, 
   3.605037537449721*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Edge option resolution", "Subsection",
 CellChangeTimes->{{3.520447427484375*^9, 3.520447430515625*^9}, {
  3.520454017296875*^9, 3.5204540185625*^9}}],

Cell["Resolution of PlotRange-like option", "Text",
 CellChangeTimes->{{3.520454060875*^9, 3.5204540765*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ResolvePanelOption", "[", "\[IndentingNewLine]", 
    RowBox[{"Self_Object", ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Option_", ",", "Value_", ",", "2", ",", "Patt_", ",", 
       RowBox[{"XYMode", ":", "PanelOptionXYUnique"}], ",", 
       RowBox[{"XYOption", ":", 
        RowBox[{"{", 
         RowBox[{"XOption_", ",", "YOption_"}], "}"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", "FullOptions_List"}], "\[IndentingNewLine]", 
    "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{"Option", "->", 
     RowBox[{"ResolveOption", "[", 
      RowBox[{"Option", ",", 
       RowBox[{"{", 
        RowBox[{"Default", "\[RuleDelayed]", 
         RowBox[{"(", 
          RowBox[{"XYOption", "/.", "FullOptions"}], ")"}]}], "}"}], ",", 
       "FullOptions"}], "]"}]}], "\[IndentingNewLine]", ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516459161984375*^9, 3.51645935721875*^9}, {
   3.5164593899375*^9, 3.516459414359375*^9}, {3.516459460890625*^9, 
   3.516459693671875*^9}, {3.51645973840625*^9, 3.516460003375*^9}, {
   3.5164600734375*^9, 3.516460127875*^9}, {3.51646129403125*^9, 
   3.516461314984375*^9}, {3.516461433328125*^9, 3.516461447125*^9}, 
   3.516461548546875*^9, {3.516464352453125*^9, 3.51646435684375*^9}, {
   3.51646440728125*^9, 3.51646440871875*^9}, {3.516464477734375*^9, 
   3.516464500875*^9}, {3.516464548671875*^9, 3.516464560875*^9}, {
   3.51646524184375*^9, 3.51646525515625*^9}, {3.51646570828125*^9, 
   3.516465708828125*^9}, {3.5164657470625*^9, 3.51646576484375*^9}, {
   3.516465928125*^9, 3.516465932265625*^9}, {3.516470813671875*^9, 
   3.5164708525*^9}, {3.51647095953125*^9, 3.516470974546875*^9}, {
   3.516471235546875*^9, 3.516471267296875*^9}, {3.5164716085*^9, 
   3.5164716218125*^9}, {3.516471926359375*^9, 3.516471927546875*^9}, {
   3.51647275378125*^9, 3.516472754921875*^9}, {3.516472829140625*^9, 
   3.516472871484375*^9}, {3.51647309690625*^9, 3.51647309878125*^9}, 
   3.51647314103125*^9, {3.516473266765625*^9, 3.516473421921875*^9}, {
   3.516473525984375*^9, 3.516473646734375*^9}, {3.520441162578125*^9, 
   3.520441233421875*^9}, {3.52044139190625*^9, 3.5204414268125*^9}, {
   3.520441568796875*^9, 3.5204416189375*^9}, {3.52044166965625*^9, 
   3.52044168340625*^9}, {3.5204417194375*^9, 3.5204417209375*^9}, {
   3.5204419009375*^9, 3.52044190984375*^9}, 3.592947131938489*^9}],

Cell["Resolution of ExtendRange-like option", "Text",
 CellChangeTimes->{{3.520454060875*^9, 3.520454084609375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ResolvePanelOption", "[", "\[IndentingNewLine]", 
    RowBox[{"Self_Object", ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{"Option_", ",", "Value_", ",", "2", ",", "Patt_", ",", 
       RowBox[{"XYMode", ":", "PanelOptionXYRange"}], ",", 
       RowBox[{"XYOption", ":", 
        RowBox[{"{", 
         RowBox[{"XOption_", ",", "YOption_"}], "}"}]}]}], "}"}], ",", 
     "\[IndentingNewLine]", "FullOptions_List"}], "\[IndentingNewLine]", 
    "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{"Option", "->", 
     RowBox[{"ResolveOption", "[", 
      RowBox[{"Option", ",", "\[IndentingNewLine]", 
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"process", " ", "special", " ", "single"}], "-", 
          RowBox[{"symbol", " ", "values"}]}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"None", "\[RuleDelayed]", "0"}], ",", "\[IndentingNewLine]", 
         
         RowBox[{"Automatic", "\[RuleDelayed]", "0.02"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{"Default", ":", " ", 
           RowBox[{"take", " ", "XY", " ", "values"}]}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"Default", "\[RuleDelayed]", 
          RowBox[{"(", 
           RowBox[{"XYOption", "/.", "FullOptions"}], ")"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{
           "then", " ", "upgrade", " ", "None", " ", "or", " ", "single"}], 
           "-", 
           RowBox[{
           "number", " ", "values", " ", "for", " ", "the", " ", "X", " ", 
            "and", " ", "Y", " ", "values", " ", "to", " ", "pairs"}]}], " ", 
          "*)"}], "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"x_", ",", "y_"}], "}"}], "\[RuleDelayed]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"UpgradePairEqual", "[", "x", "]"}], ",", 
            RowBox[{"UpgradePairEqual", "[", "y", "]"}]}], "}"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"(*", " ", 
          RowBox[{
           RowBox[{"or", " ", "upgrade", " ", "a", " ", "single"}], "-", 
           RowBox[{"number", " ", 
            RowBox[{"(", 
             RowBox[{"any", " ", 
              RowBox[{"{", 
               RowBox[{"x", ",", "y"}], "}"}], " ", "pair", " ", "values", 
              " ", "will", " ", "have", " ", "already", " ", "been", " ", 
              "handled", " ", "above"}], ")"}], " ", "given", " ", "directly",
             " ", "for", " ", "ExtendRange"}]}], " ", "*)"}], 
         "\[IndentingNewLine]", 
         RowBox[{"d_", ":>", 
          RowBox[{"UpgradeRangeParameters", "[", "d", "]"}]}]}], 
        "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
       "FullOptions"}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]",
     ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516459161984375*^9, 3.51645935721875*^9}, {
   3.5164593899375*^9, 3.516459414359375*^9}, {3.516459460890625*^9, 
   3.516459693671875*^9}, {3.51645973840625*^9, 3.516460003375*^9}, {
   3.5164600734375*^9, 3.516460127875*^9}, {3.51646129403125*^9, 
   3.516461314984375*^9}, {3.516461433328125*^9, 3.516461447125*^9}, 
   3.516461548546875*^9, {3.516464352453125*^9, 3.51646435684375*^9}, {
   3.51646440728125*^9, 3.51646440871875*^9}, {3.516464477734375*^9, 
   3.516464500875*^9}, {3.516464548671875*^9, 3.516464560875*^9}, {
   3.51646524184375*^9, 3.51646525515625*^9}, {3.51646570828125*^9, 
   3.516465708828125*^9}, {3.5164657470625*^9, 3.51646576484375*^9}, {
   3.516465928125*^9, 3.516465932265625*^9}, {3.516470813671875*^9, 
   3.5164708525*^9}, {3.51647095953125*^9, 3.516470974546875*^9}, {
   3.516471235546875*^9, 3.516471267296875*^9}, {3.5164716085*^9, 
   3.5164716218125*^9}, {3.516471926359375*^9, 3.516471927546875*^9}, {
   3.51647275378125*^9, 3.516472754921875*^9}, {3.516472829140625*^9, 
   3.516472871484375*^9}, {3.51647309690625*^9, 3.51647309878125*^9}, 
   3.51647314103125*^9, {3.516473266765625*^9, 3.516473421921875*^9}, {
   3.516473525984375*^9, 3.516473646734375*^9}, {3.520441162578125*^9, 
   3.520441233421875*^9}, {3.52044139190625*^9, 3.5204414268125*^9}, {
   3.520441568796875*^9, 3.520441634640625*^9}, 3.520441739265625*^9, {
   3.52044181509375*^9, 3.520441875875*^9}, {3.5204419205*^9, 
   3.520441922390625*^9}, {3.5204474991875*^9, 3.520447527171875*^9}, {
   3.52063808184375*^9, 3.520638168453125*^9}, 3.592947131938489*^9}],

Cell["Resolution of edge option", "Text",
 CellChangeTimes->{{3.520454102625*^9, 3.52045410928125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"ResolvePanelOption", "[", "\[IndentingNewLine]", 
    RowBox[{"Self_Object", ",", "\[IndentingNewLine]", 
     RowBox[{"{", 
      RowBox[{
      "Option_", ",", "Value_", ",", "4", ",", "Patt_", ",", "XYMode_", ",", 
       "MirrorOption_", ",", 
       RowBox[{"XXYYOption", ":", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"YOption_", ",", "YYOption_"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"XOption_", ",", "XXOption_"}], "}"}]}], "}"}]}]}], "}"}], 
     ",", "\[IndentingNewLine]", "FullOptions_List"}], "\[IndentingNewLine]", 
    "]"}], ":=", 
   RowBox[{"(", "\[IndentingNewLine]", 
    RowBox[{"Option", "\[Rule]", 
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "UsedXOption", ",", "UsedXXOption", ",", "UsedYOption", ",", 
         "UsedYYOption"}], "}"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"primary", " ", 
         RowBox[{"edges", ":", " ", 
          RowBox[{"get", " ", "given", " ", "option", " ", "values"}]}]}], 
        " ", "*)"}], "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"UsedXOption", "=", 
         RowBox[{"ResolveOption", "[", 
          RowBox[{"XOption", ",", 
           RowBox[{"{", "}"}], ",", "FullOptions"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"UsedYOption", "=", 
         RowBox[{"ResolveOption", "[", 
          RowBox[{"YOption", ",", 
           RowBox[{"{", "}"}], ",", "FullOptions"}], "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"secondary", " ", 
           RowBox[{"edges", ":", " ", 
            RowBox[{"get", " ", "given", " ", "option", " ", "value"}]}]}], 
          ",", " ", 
          RowBox[{
          "then", " ", "apply", " ", "mirroring", " ", "on", " ", "value", 
           " ", "Default"}]}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"UsedXXOption", "=", 
         RowBox[{"ResolveOption", "[", 
          RowBox[{"XXOption", ",", 
           RowBox[{"{", 
            RowBox[{"Default", "\[RuleDelayed]", 
             RowBox[{"Switch", "[", 
              RowBox[{
              "MirrorOption", ",", "PanelOptionMirror", ",", "UsedXOption", 
               ",", "_", ",", "MirrorOption"}], "]"}]}], "}"}], ",", 
           "FullOptions"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"UsedYYOption", "=", 
         RowBox[{"ResolveOption", "[", 
          RowBox[{"YYOption", ",", 
           RowBox[{"{", 
            RowBox[{"Default", "\[RuleDelayed]", 
             RowBox[{"Switch", "[", 
              RowBox[{
              "MirrorOption", ",", "PanelOptionMirror", ",", "UsedYOption", 
               ",", "_", ",", "MirrorOption"}], "]"}]}], "}"}], ",", 
           "FullOptions"}], "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"master", " ", "2", "x3", " ", 
           RowBox[{"list", ":", " ", 
            RowBox[{
            "get", " ", "given", " ", "value", " ", "for", " ", "singlet", 
             " ", "option"}]}]}], ",", " ", 
          RowBox[{
           RowBox[{"then", " ", "process", " ", "fall"}], "-", "throughs"}]}],
          " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Replace", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Option", "/.", "FullOptions"}], ")"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"Default", " ", "as", " ", "XY", " ", "fallthrough"}], 
            " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Default", "->", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"UsedYOption", ",", "UsedYYOption"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"UsedXOption", ",", "UsedXXOption"}], "}"}]}], 
              "}"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{
              "upgrade", " ", "singlet", " ", "value", " ", "to", " ", "all", 
               " ", "edges"}], ",", " ", 
              RowBox[{
              "if", " ", "it", " ", "survived", " ", "the", " ", "option", 
               " ", "validation"}], ",", " ", 
              RowBox[{
               RowBox[{"using", " ", "either", " ", "mirroring", " ", "u"}], 
               "\[Rule]", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"u", ",", "u"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"u", ",", "u"}], "}"}]}], "}"}], " ", "or", " ", 
                 "filler", " ", "u"}], "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"u", ",", "X"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"u", ",", "X"}], "}"}]}], "}"}]}]}]}], " ", " ", 
             "*)"}], "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"u", ":", "Patt"}], ")"}], "\[RuleDelayed]", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"u", ",", 
                 RowBox[{"Switch", "[", 
                  RowBox[{
                  "MirrorOption", ",", "PanelOptionMirror", ",", "u", ",", 
                   "_", ",", "MirrorOption"}], "]"}]}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"u", ",", 
                 RowBox[{"Switch", "[", 
                  RowBox[{
                  "MirrorOption", ",", "PanelOptionMirror", ",", "u", ",", 
                   "_", ",", "MirrorOption"}], "]"}]}], "}"}]}], 
              "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{
              "upgrade", " ", "XY", " ", "pair", " ", "to", " ", "all", " ", 
               "edges"}], ",", " ", 
              RowBox[{
               RowBox[{"using", " ", "either", " ", "mirroring", " ", 
                RowBox[{"{", 
                 RowBox[{"B", ",", "L"}], "}"}]}], "\[Rule]", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"L", ",", "L"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"B", ",", "B"}], "}"}]}], "}"}], " ", "or", " ", 
                 "filler", " ", 
                 RowBox[{"{", 
                  RowBox[{"B", ",", "L"}], "}"}]}], "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"L", ",", "X"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"B", ",", "X"}], "}"}]}], "}"}]}]}]}], " ", "*)"}],
             "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"x", ":", "Patt"}], ",", 
               RowBox[{"y", ":", "Patt"}]}], "}"}], "\[RuleDelayed]", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"y", ",", 
                 RowBox[{"Switch", "[", 
                  RowBox[{
                  "MirrorOption", ",", "PanelOptionMirror", ",", "y", ",", 
                   "_", ",", "MirrorOption"}], "]"}]}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"x", ",", 
                 RowBox[{"Switch", "[", 
                  RowBox[{
                  "MirrorOption", ",", "PanelOptionMirror", ",", "x", ",", 
                   "_", ",", "MirrorOption"}], "]"}]}], "}"}]}], 
              "\[IndentingNewLine]", "}"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{
               RowBox[{"gracefully", " ", "accept", " ", "pre"}], "-", 
               RowBox[{
               "6", " ", "legacy", " ", "edge", " ", "parameter", " ", 
                "specification"}]}], ",", " ", 
              RowBox[{
               RowBox[{"as", " ", 
                RowBox[{"{", 
                 RowBox[{"B", ",", "L", ",", "T", ",", "R"}], "}"}]}], 
               "\[Rule]", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"L", ",", "R"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"B", ",", "T"}], "}"}]}], "}"}]}]}], " ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"b", ":", "Patt"}], ",", 
               RowBox[{"l", ":", "Patt"}], ",", 
               RowBox[{"t", ":", "Patt"}], ",", 
               RowBox[{"r", ":", "Patt"}]}], "}"}], ":>", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"l", ",", "r"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"b", ",", "t"}], "}"}]}], "}"}]}]}], 
           "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", ")"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516459161984375*^9, 3.51645935721875*^9}, {
   3.5164593899375*^9, 3.516459414359375*^9}, {3.516459460890625*^9, 
   3.516459693671875*^9}, {3.51645973840625*^9, 3.516460003375*^9}, {
   3.5164600734375*^9, 3.516460127875*^9}, {3.51646129403125*^9, 
   3.516461314984375*^9}, {3.516461433328125*^9, 3.516461447125*^9}, 
   3.516461548546875*^9, {3.516464352453125*^9, 3.51646435684375*^9}, {
   3.51646440728125*^9, 3.51646440871875*^9}, {3.516464477734375*^9, 
   3.516464500875*^9}, {3.516464548671875*^9, 3.516464560875*^9}, {
   3.51646524184375*^9, 3.51646525515625*^9}, {3.51646570828125*^9, 
   3.516465708828125*^9}, {3.5164657470625*^9, 3.51646576484375*^9}, {
   3.516465928125*^9, 3.516465932265625*^9}, {3.516470813671875*^9, 
   3.5164708525*^9}, {3.51647095953125*^9, 3.516470974546875*^9}, {
   3.516471235546875*^9, 3.516471267296875*^9}, {3.5164716085*^9, 
   3.5164716218125*^9}, {3.516471926359375*^9, 3.516471927546875*^9}, {
   3.51647275378125*^9, 3.516472754921875*^9}, {3.516472829140625*^9, 
   3.516472871484375*^9}, {3.51647309690625*^9, 3.51647309878125*^9}, 
   3.51647314103125*^9, {3.516473266765625*^9, 3.516473421921875*^9}, {
   3.516473525984375*^9, 3.516473646734375*^9}, {3.520441162578125*^9, 
   3.520441260140625*^9}, {3.520441962796875*^9, 3.520442000234375*^9}, {
   3.520442098734375*^9, 3.52044212428125*^9}, {3.520442177546875*^9, 
   3.520442210359375*^9}, {3.520442294078125*^9, 3.520442367953125*^9}, {
   3.520442432671875*^9, 3.52044244921875*^9}, {3.520442660703125*^9, 
   3.520442823921875*^9}, {3.520442865921875*^9, 3.520442881625*^9}, {
   3.52044318896875*^9, 3.5204431973125*^9}, {3.5204432419375*^9, 
   3.520443273234375*^9}, 3.520447559609375*^9, {3.520448534296875*^9, 
   3.52044853746875*^9}, {3.520530810953125*^9, 3.520530848015625*^9}, 
   3.592947131943489*^9, {3.6110852220612984`*^9, 3.6110852855222096`*^9}, {
   3.611085335738698*^9, 3.6110854108216295`*^9}, {3.6110855695363083`*^9, 
   3.6110856581288643`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructor", "Subsection",
 CellChangeTimes->{{3.515790608640625*^9, 3.51579061009375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FigurePanel", "::", "prange"}], "=", 
   "\"\<The panel plot range `1` has zero width or height.  (This plot range \
was obtained after applying the options PlotRange, XPlotRange, YPlotRange, \
ExtendRange, XExtendRange, and YExtendRange.)\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5164581311875*^9, 3.5164581425625*^9}, {
   3.516458213578125*^9, 3.5164582325625*^9}, 3.51645830084375*^9, {
   3.51645841528125*^9, 3.51645846371875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Constructor", "[", 
     RowBox[{
      RowBox[{"Class", ":", "FigurePanel"}], ",", "Self_Object"}], "]"}], "[", 
    RowBox[{"HeldBody_", ",", 
     RowBox[{"PanelIndices", ":", 
      RowBox[{"(", 
       RowBox[{"None", "|", 
        RowBox[{"{", 
         RowBox[{"r_Integer", ",", "s_Integer"}], "}"}]}], ")"}]}], ",", 
     RowBox[{"Opts___", "?", "OptionQ"}], ",", "$PrivateConstructorMarker"}], 
    "]"}], ":=", 
   RowBox[{"FigObjectWrapper", "[", 
    RowBox[{"Class", ",", "Self", ",", 
     RowBox[{"{", "Opts", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
        "ResolvedCompositeOptions", ",", "\[IndentingNewLine]", 
         "UsedCanvasRegion", ",", "ExtendedPlotRange", ",", "UsedPlotRange", 
         ",", "BaseExteriorEdgeMask", ",", "DerivedExteriorEdgeMask", ",", 
         "UsedExteriorEdgeMask", ",", "\[IndentingNewLine]", 
         "EffectiveBackground", ",", "Window", ",", "\[IndentingNewLine]", 
         "CommonAxisOptions", ",", "CompositeAxisOptions", ",", 
         "\[IndentingNewLine]", "UsedPanelLetter", ",", 
         "UsedPanelLetterDimensions", ",", "UsedPanelLetterPosition", ",", 
         "PanelLayer", ",", "\[IndentingNewLine]", "StartLetterCode", ",", 
         "DerivedPanelLetterCode", ",", "DerivedPanelLetter", ",", 
         "\[IndentingNewLine]", "WindowGraphicalElementList", ",", "Rows", 
         ",", "Columns", ",", "GivenPanelRegion", ",", "\[IndentingNewLine]", 
         "PanelGapsExteriorArray", ",", "NominalCanvasRegion", ",", 
         "NominalWindow"}], "\[IndentingNewLine]", "}"}], ",", 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"automated", " ", "option", " ", "handling"}], " ", "*)"}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{"validate", " ", "options"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           RowBox[{"FigCheckOption", "[", 
            RowBox[{"Self", ",", "#1", ",", "#2", ",", "FigOptions"}], "]"}], 
           "&"}], ")"}], "@@@", "FigurePanelOptionTests"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "realize", " ", "composite", " ", "options", " ", "as", " ", 
          RowBox[{"{", 
           RowBox[{"x", ",", "y"}], "}"}], " ", "or", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"l", ",", "r"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"t", ",", "b"}], "}"}]}], "}"}], " ", "values"}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"ResolvedCompositeOptions", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"ResolvePanelOption", "[", 
             RowBox[{"Self", ",", "#", ",", "FigOptions"}], "]"}], "&"}], 
           ")"}], "/@", "FigurePanelOptionResolution"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Debug", "/.", "FigOptions"}], ")"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<  \>\"", ",", "\"\<Panel composite options: \>\"", ",", 
            "ResolvedCompositeOptions"}], "]"}]}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"option", " ", "postprocessing"}], " ", "*)"}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"derive", " ", "region"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"GivenPanelRegion", "=", 
         RowBox[{"If", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"PanelIndices", "===", "None"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"(", 
            RowBox[{"PanelRegion", "/.", "FigOptions"}], ")"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"CurrentMultipanel", "[", "]"}], "@", 
              RowBox[{"GetPanelRegionArray", "[", "]"}]}], ")"}], "[", 
            RowBox[{"[", 
             RowBox[{"r", ",", "s"}], "]"}], "]"}]}], "\[IndentingNewLine]", 
          "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"UsedCanvasRegion", "=", 
         RowBox[{"FigResolveRegion", "@", 
          RowBox[{"AdjustRegion", "[", 
           RowBox[{"GivenPanelRegion", ",", 
            RowBox[{"FilterRules", "[", 
             RowBox[{"FigOptions", ",", 
              RowBox[{"{", 
               RowBox[{"RegionExtension", ",", "RegionDisplacement"}], 
               "}"}]}], "]"}]}], "]"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Debug", "/.", "FigOptions"}], ")"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Print", "[", 
           RowBox[{
           "\"\<Region diagnostics:\>\"", ",", "\"\< indices \>\"", ",", 
            "PanelIndices", ",", "\"\< given region \>\"", ",", 
            "GivenPanelRegion", ",", "\"\< panel extension \>\"", ",", 
            RowBox[{"(", 
             RowBox[{"RegionExtension", "/.", "FigOptions"}], ")"}], ",", 
            "\"\< panel displacement \>\"", ",", 
            RowBox[{"(", 
             RowBox[{"RegionDisplacement", "/.", "FigOptions"}], ")"}], ",", 
            "\"\< adjusted region \>\"", ",", "UsedCanvasRegion"}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"derive", " ", "plot", " ", "range"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"ExtendedPlotRange", "=", 
         RowBox[{"ExtendRegion", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"PlotRange", "/.", "ResolvedCompositeOptions"}], ")"}], 
           ",", 
           RowBox[{"(", 
            RowBox[{"ExtendRange", "/.", "ResolvedCompositeOptions"}], ")"}], 
           ",", "Scaled"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "if", " ", "scale", " ", "is", " ", "locked", " ", "against", " ", 
           "canvas", " ", "region", " ", "extension"}], ",", " ", 
          RowBox[{"then", " ", "true", " ", "coordinate", " ", "range", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"i", ".", "e", "."}], ",", " ", 
             RowBox[{
             "extended", " ", "from", " ", "nominal", " ", "coordinates", " ",
               "according", " ", "to", " ", "ExtendRange", " ", "option"}]}], 
            ")"}], " ", "must", " ", "then", " ", "also", " ", "be", " ", 
           "extended", " ", "by", " ", "same", " ", "fractional", " ", 
           "amounts", " ", "as", " ", "canvas", " ", 
           RowBox[{"region", " ", "--"}], " ", "but", " ", "this", " ", "is", 
           " ", "hard", " ", "to", " ", "calculate"}], ",", " ", 
          RowBox[{
           RowBox[{
           "since", " ", "region", " ", "extension", " ", "may", " ", "be", 
            " ", "expressed", " ", "in", " ", "either", " ", "absolute", " ", 
            "or", " ", "relative", " ", "form"}], ";", " ", "also"}], ",", 
          " ", 
          RowBox[{
          "we", " ", "might", " ", "want", " ", "to", " ", "lock", " ", 
           "origin", " ", "against", " ", "a", " ", "canvas", " ", "region", 
           " ", "displacement"}]}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"so", ",", " ", "instead", ",", " ", 
          RowBox[{
          "rely", " ", "upon", " ", "existing", " ", "window", " ", 
           "transformation", " ", 
           RowBox[{"machinery", " ", "--"}], " ", "create", " ", "a", " ", 
           "window", " ", "based", " ", "on", " ", "the", " ", "unmodified", 
           " ", "canvas", " ", "region"}], ",", " ", 
          RowBox[{
          "then", " ", "see", " ", "what", " ", "user", " ", "coordinates", 
           " ", "would", " ", "cover", " ", "modified", " ", "canvas", " ", 
           "region"}]}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"XYLockingMask", "=", 
           RowBox[{"{", 
            RowBox[{"1", ",", "1"}], "}"}]}], ";", " ", 
          RowBox[{"(*", " ", 
           RowBox[{"TODO", " ", "make", " ", "controllable"}], " ", "*)"}], 
          "\[IndentingNewLine]", 
          RowBox[{"UsedPlotRange", "=", 
           RowBox[{"ExtendRegion", "[", 
            RowBox[{"UsedPlotRange", ",", 
             RowBox[{"XYLockingMask", "*", 
              RowBox[{"(", 
               RowBox[{"RegionExtension", "/.", "FigOptions"}], ")"}]}], ",", 
             "Scaled"}], "]"}]}], ";"}], "*)"}], "\[IndentingNewLine]", 
        RowBox[{"UsedPlotRange", "=", 
         RowBox[{"If", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"LockPanelScale", "/.", "FigOptions"}], ")"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"NominalCanvasRegion", "=", 
             RowBox[{"FigResolveRegion", "[", "GivenPanelRegion", "]"}]}], 
            ";", "\[IndentingNewLine]", 
            RowBox[{"NominalWindow", "=", 
             RowBox[{"FigWindow", "[", 
              RowBox[{"NominalCanvasRegion", ",", "ExtendedPlotRange"}], 
              "]"}]}], ";", "\[IndentingNewLine]", 
            RowBox[{"TransformRegion", "[", 
             RowBox[{
              RowBox[{"NominalWindow", "@", 
               RowBox[{"InverseTFunction", "[", "]"}]}], ",", 
              "UsedCanvasRegion"}], "]"}]}], ",", "\[IndentingNewLine]", 
           "ExtendedPlotRange"}], "\[IndentingNewLine]", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"trap", " ", "zero"}], "-", 
          RowBox[{
          "sized", " ", "range", " ", "as", " ", "error", " ", 
           "condition"}]}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"Chop", "[", 
            RowBox[{"Min", "[", 
             RowBox[{"Abs", "[", 
              RowBox[{"Subtract", "@@@", "UsedPlotRange"}], "]"}], "]"}], 
            "]"}], "==", "0"}], ",", "\[IndentingNewLine]", 
          RowBox[{"FigError", "[", 
           RowBox[{
           "FigurePanel", ",", "\"\<prange\>\"", ",", "UsedPlotRange"}], 
           "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"define", " ", "window"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"Window", "=", 
         RowBox[{"FigWindow", "[", 
          RowBox[{"UsedCanvasRegion", ",", "UsedPlotRange"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Self", "@", 
         RowBox[{"SetWindow", "[", "Window", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "retrieve", " ", "multipanel", " ", "array", " ", "dimensions"}], 
         " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"PanelIndices", "=!=", "None"}], ",", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Rows", ",", "Columns"}], "}"}], "=", 
           RowBox[{
            RowBox[{"CurrentMultipanel", "[", "]"}], "@", 
            RowBox[{"GetDimensions", "[", "]"}]}]}]}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "define", " ", "effective", " ", "background", " ", "for", " ", 
          "objects", " ", "displayed", " ", "in", " ", "this", " ", "panel"}],
          " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"EffectiveBackground", "=", 
         RowBox[{"If", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"(", 
             RowBox[{"Show", "/.", "FigOptions"}], ")"}], "&&", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"Background", "/.", "FigOptions"}], ")"}], "=!=", 
              "None"}], ")"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"(", 
            RowBox[{"Background", "/.", "FigOptions"}], ")"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"CurrentBackground", "[", "]"}]}], "\[IndentingNewLine]", 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Self", "@", 
         RowBox[{"SetBackground", "[", "EffectiveBackground", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"choose", " ", "layer", " ", "for", " ", "panel"}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"CAVEAT", ":", " ", 
           RowBox[{
           "if", " ", "predefined", " ", "labels", " ", "are", " ", "ever", 
            " ", "declared", " ", "for", " ", "the", " ", "panel", " ", "as", 
            " ", "a", " ", "whole"}]}], ",", " ", 
          RowBox[{
          "they", " ", "will", " ", "not", " ", "respect", " ", "this", " ", 
           RowBox[{"layer", "."}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"PanelLayer", "=", 
         RowBox[{"ResolveOption", "[", 
          RowBox[{"Layer", ",", 
           RowBox[{"{", 
            RowBox[{"Automatic", ":>", "$FigBackgroundLayer"}], "}"}], ",", 
           "FigOptions"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Self", "@", 
         RowBox[{"SetPanelLayer", "[", "Layer", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "set", " ", "up", " ", "option", " ", "handling", " ", "for", " ", 
          "frame", " ", "edges"}], " ", "*)"}], "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "first", " ", "handle", " ", "a", " ", "few", " ", "options", " ", 
          "with", " ", "values", " ", "which", " ", "are", " ", "shared", " ",
           "by", " ", "all", " ", "edges"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"CommonAxisOptions", "=", 
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{"(*", " ", 
           RowBox[{
           "override", " ", "of", " ", "FigAxis", " ", "special", " ", 
            "options", " ", "to", " ", "be", " ", "appropriate", " ", "to", 
            " ", "frame"}], " ", "*)"}], "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"ShowTicks", " ", "\[Rule]", " ", "True"}], ",", " ", 
           RowBox[{"(*", 
            RowBox[{
            "already", " ", "implemented", " ", "as", " ", "mask", " ", "on", 
             " ", "Ticks"}], " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"ShowHead", "\[Rule]", "False"}], ",", 
           RowBox[{"ShowTail", "\[Rule]", "False"}], ",", 
           RowBox[{"HeadExtension", "\[Rule]", "None"}], ",", 
           RowBox[{"TailExtension", "\[Rule]", "None"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
            "override", " ", "of", " ", "FigAxis", " ", "special", " ", 
             "options", " ", "by", " ", "FigurePanel", " ", "options"}], " ", 
            "*)"}], "\[IndentingNewLine]", 
           RowBox[{"FilterRules", "[", 
            RowBox[{"FigOptions", ",", 
             RowBox[{"Options", "[", "FigAxis", "]"}]}], "]"}]}], 
          "\[IndentingNewLine]", "}"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "identify", " ", "edges", " ", "which", " ", "should", " ", "count", 
          " ", "as", " ", "\"\<exterior\>\"", " ", "edges", " ", "of", " ", 
          "panel"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"(", "1", ")"}], " ", "Base", " ", "values", " ", 
            RowBox[{"(", "BaseExteriorEdgeMask", ")"}]}], ":", " ", 
           RowBox[{"For", " ", "standalone", " ", "panel"}]}], ",", " ", 
          RowBox[{"all", " ", "edges", " ", "are", " ", 
           RowBox[{"exterior", ".", "  ", "For"}], " ", "multipanel", " ", 
           "array"}], ",", " ", 
          RowBox[{
           RowBox[{
           "takes", " ", "into", " ", "account", " ", "position", " ", "in", 
            " ", "array", " ", "and", " ", "XYPanelGapsExterior", " ", 
            RowBox[{
            "options", ".", "  ", "\[IndentingNewLine]", 
             "\[IndentingNewLine]", 
             RowBox[{"(", "2", ")"}]}], " ", "Derived", " ", "value", " ", 
            RowBox[{"(", "DerivedExteriorEdgeMask", ")"}]}], ":", " ", 
           RowBox[{"Respect", " ", "XYPanelEdgeExterior", " ", "options"}]}], 
          ",", " ", 
          RowBox[{
           RowBox[{
           "where", " ", "value", " ", "Automatic", " ", "for", " ", "an", 
            " ", "edge", " ", "means", " ", "to", " ", "use", " ", "base", 
            " ", 
            RowBox[{
            "value", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", 
             RowBox[{"(", "3", ")"}]}], " ", "Final", " ", "value", " ", 
            RowBox[{"(", "UsedExteriorEdgeMask", ")"}]}], ":", " ", 
           RowBox[{"Respect", " ", "legacy", " ", "ExteriorEdgeMask", " ", 
            RowBox[{"option", ".", "  ", "Automatic"}], " ", "means", " ", 
            "to", " ", "use", " ", "above", " ", "derived", " ", 
            RowBox[{"value", ".", "  ", "Single"}], " ", "logical", " ", 
            "value", " ", "oapplies", " ", "to", " ", "all", " ", 
            RowBox[{"edges", ".", "  ", "Or"}], " ", "full", " ", "2", "x2", 
            " ", "list", " ", "of", " ", "logical", " ", "values", " ", "is", 
            " ", "used", " ", 
            RowBox[{"verbatim", "."}]}]}]}], "\[IndentingNewLine]", " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"PanelGapsExteriorArray", "=", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"CurrentMultipanel", "[", "]"}], "@", 
           RowBox[{"GetPanelGapsExteriorArray", "[", "]"}]}], ")"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"BaseExteriorEdgeMask", "=", 
         RowBox[{"If", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"PanelIndices", "===", "None"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"standalone", " ", "panel"}], " ", "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"True", ",", "True"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"True", ",", "True"}], "}"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{"panel", " ", "in", " ", "array"}], " ", "*)"}], 
           "\[IndentingNewLine]", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"s", "\[Equal]", "1"}], ")"}], "||", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"s", ">", "1"}], ")"}], "&&", 
                  RowBox[{
                   RowBox[{"PanelGapsExteriorArray", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                   RowBox[{"[", 
                    RowBox[{"s", "-", "1"}], "]"}], "]"}]}], ")"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"s", "\[Equal]", "Columns"}], ")"}], "||", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"s", "<", "Columns"}], ")"}], "&&", 
                  RowBox[{
                   RowBox[{"PanelGapsExteriorArray", "[", 
                    RowBox[{"[", "1", "]"}], "]"}], "[", 
                   RowBox[{"[", "s", "]"}], "]"}]}], ")"}]}]}], 
              "\[IndentingNewLine]", "}"}], ",", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"r", "\[Equal]", "Rows"}], ")"}], "||", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"r", "<", "Rows"}], ")"}], "&&", 
                  RowBox[{
                   RowBox[{"PanelGapsExteriorArray", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", "r", "]"}], "]"}]}], ")"}]}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"r", "\[Equal]", "1"}], ")"}], "||", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{"r", ">", "1"}], ")"}], "&&", 
                  RowBox[{
                   RowBox[{"PanelGapsExteriorArray", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], "[", 
                   RowBox[{"[", 
                    RowBox[{"r", "-", "1"}], "]"}], "]"}]}], ")"}]}]}], 
              "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "}"}]}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"Print", "[", "BaseExteriorEdgeMask", "]"}], ";"}], "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"DerivedExteriorEdgeMask", "=", 
         RowBox[{"ResolveAutomaticEdgeOption", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"PanelEdgeExterior", "/.", "ResolvedCompositeOptions"}], 
            ")"}], ",", "\[IndentingNewLine]", "BaseExteriorEdgeMask"}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"Print", "[", "DerivedExteriorEdgeMask", "]"}], ";"}], 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"UsedExteriorEdgeMask", "=", 
         RowBox[{"ResolveOption", "[", 
          RowBox[{"ExteriorEdgeMask", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"(", 
               RowBox[{"x", ":", "LogicalPattern"}], ")"}], "\[RuleDelayed]", 
              
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"x", ",", "x"}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"x", ",", "x"}], "}"}]}], "}"}]}], ",", 
             RowBox[{"Automatic", "->", "DerivedExteriorEdgeMask"}]}], "}"}], 
           ",", "FigOptions"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", 
         RowBox[{
          RowBox[{"Print", "[", "UsedExteriorEdgeMask", "]"}], ";"}], "*)"}], 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "deduce", " ", "option", " ", "values", " ", "for", " ", "the", " ",
            "four", " ", "edges", " ", "and", " ", "bundle", " ", "them", " ",
            "as", " ", "arrays", "\[IndentingNewLine]", "\t", "option"}], 
          "\[Rule]", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"left", ",", "right"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"bottom", ",", "top"}], "}"}]}], "}"}]}], 
         "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"CompositeAxisOptions", "=", 
         RowBox[{"Flatten", "[", 
          RowBox[{"{", "\[IndentingNewLine]", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
             RowBox[{"Show", " ", "--"}], " ", "edge", " ", "display", " ", 
             "control"}], " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"Show", "->", 
             RowBox[{"If", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"Show", "/.", "FigOptions"}], ")"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"(", 
                RowBox[{"Frame", "/.", "ResolvedCompositeOptions"}], ")"}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{"Table", "[", 
                RowBox[{"False", ",", 
                 RowBox[{"{", "2", "}"}], ",", 
                 RowBox[{"{", "2", "}"}]}], "]"}]}], "\[IndentingNewLine]", 
              "]"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{"AxisLabel", " ", "--"}], " ", "validate", " ", "and", 
              " ", "process", " ", "frame", " ", "labels"}], " ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"AxisLabel", "->", 
             RowBox[{"MaskEdgeOption", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"FrameLabel", "/.", "ResolvedCompositeOptions"}], 
                ")"}], ",", "\[IndentingNewLine]", 
               RowBox[{"(", 
                RowBox[{"ShowFrameLabel", "/.", "ResolvedCompositeOptions"}], 
                ")"}], ",", "\[IndentingNewLine]", "UsedExteriorEdgeMask", 
               ",", "None"}], "\[IndentingNewLine]", "]"}]}], ",", 
            "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{"AxisLabelPosition", " ", "--"}], " ", "validate", " ", 
              "and", " ", "process", " ", "frame", " ", "label", " ", 
              "positions"}], " ", "*)"}], "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{
              "each", " ", "position", " ", "*", "must", "*", " ", "be", " ", 
               "Automatic", " ", "or", " ", "a", " ", "number"}], ",", " ", 
              RowBox[{"not", " ", "a", " ", "list"}], ",", " ", 
              RowBox[{"for", " ", "meaningful", " ", "upgrading"}]}], " ", 
             "*)"}], "\[IndentingNewLine]", 
            RowBox[{"AxisLabelPosition", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{
              "FrameLabelPosition", "/.", "ResolvedCompositeOptions"}], 
              ")"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"TickLabelAllowance", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{
              "TickLabelAllowance", "/.", "ResolvedCompositeOptions"}], 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{"AxisTextXXXX", "/", 
               RowBox[{"AxisFontXXXX", " ", "--"}]}], " ", "validate", " ", 
              "and", " ", "process", " ", "base", " ", "text", " ", "options",
               " ", "for", " ", "axis", " ", "labels"}], " ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"Map", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"SidifyOptionName", "[", "\"\<Axis\>\"", "]"}], "[",
                   "#1", "]"}], "->", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"SidifyOptionName", "[", "\"\<Frame\>\"", "]"}], 
                    "[", "#1", "]"}], "/.", "ResolvedCompositeOptions"}], 
                  ")"}]}], ")"}], "&"}], ",", "\[IndentingNewLine]", 
              RowBox[{"(", 
               RowBox[{"First", "/@", "BaseTextOptionList"}], ")"}]}], 
             "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{"Ticks", " ", "--"}], " ", "validate", " ", "and", " ", 
              "process", " ", "frame", " ", "ticks"}], " ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"Ticks", "->", 
             RowBox[{"MaskEdgeOption", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"Ticks", "/.", "ResolvedCompositeOptions"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"ShowTicks", "/.", "ResolvedCompositeOptions"}], ",", 
               "\[IndentingNewLine]", "UsedExteriorEdgeMask", ",", "None"}], 
              "\[IndentingNewLine]", "]"}]}], ",", "\[IndentingNewLine]", 
            "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{"TickLabelRange", " ", "--"}], " ", "resolve", " ", 
              "Automatic", " ", "values", " ", "as", " ", "given", " ", 
              "plot", " ", "range", " ", "before", " ", "extension"}], " ", 
             "*)"}], "\[IndentingNewLine]", 
            RowBox[{"TickLabelRange", "\[Rule]", 
             RowBox[{"ResolveAutomaticEdgeOption", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"TickLabelRange", "/.", "ResolvedCompositeOptions"}], 
               ",", "\[IndentingNewLine]", 
               RowBox[{"(*", " ", 
                RowBox[{
                "array", " ", "trick", " ", "to", " ", "double", " ", "up", 
                 " ", "entries", " ", "as", " ", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"{", 
                    RowBox[{"yrange", ",", "yrange"}], "}"}], ",", 
                   RowBox[{"{", 
                    RowBox[{"xrange", ",", "xrange"}], "}"}]}], "}"}]}], " ", 
                "*)"}], "\[IndentingNewLine]", 
               RowBox[{"Reverse", "@", 
                RowBox[{"Transpose", "[", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{"PlotRange", "/.", "ResolvedCompositeOptions"}], 
                    ")"}], ",", 
                   RowBox[{"(", 
                    RowBox[{"PlotRange", "/.", "ResolvedCompositeOptions"}], 
                    ")"}]}], "}"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}],
             ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{"ShowTickLabels", " ", "--"}], " ", "validate", " ", 
              "and", " ", "process", " ", "frame", " ", "tick", " ", "label", 
              " ", "masking"}], " ", "*)"}], "\[IndentingNewLine]", 
            RowBox[{"ShowTickLabels", "->", 
             RowBox[{"MaskEdgeOption", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"True", ",", "True"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"True", ",", "True"}], "}"}]}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"ShowTickLabels", "/.", "ResolvedCompositeOptions"}], 
               ",", "\[IndentingNewLine]", "UsedExteriorEdgeMask", ",", 
               "\[IndentingNewLine]", "False"}], "\[IndentingNewLine]", 
              "]"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"TickFontSizeFactor", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{
              "TickFontSizeFactor", "/.", "ResolvedCompositeOptions"}], 
              ")"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"TickLengthReference", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{
              "TickLengthReference", "/.", "ResolvedCompositeOptions"}], 
              ")"}]}], ",", "\[IndentingNewLine]", 
            RowBox[{"TickLengthScale", "\[Rule]", 
             RowBox[{"(", 
              RowBox[{"TickLengthScale", "/.", "ResolvedCompositeOptions"}], 
              ")"}]}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
            RowBox[{"(*", " ", 
             RowBox[{
              RowBox[{"TickTextXXXX", "/", 
               RowBox[{"TickFontXXXX", " ", "--"}]}], " ", "validate", " ", 
              "and", " ", "process", " ", "base", " ", "text", " ", "options",
               " ", "for", " ", "tick", " ", "labels"}], " ", "*)"}], 
            "\[IndentingNewLine]", 
            RowBox[{"Map", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{
                  RowBox[{"SidifyOptionName", "[", "\"\<Tick\>\"", "]"}], "[",
                   "#1", "]"}], "->", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"SidifyOptionName", "[", "\"\<Tick\>\"", "]"}], 
                    "[", "#1", "]"}], "/.", "ResolvedCompositeOptions"}], 
                  ")"}]}], ")"}], "&"}], ",", "\[IndentingNewLine]", 
              RowBox[{"(", 
               RowBox[{"First", "/@", "BaseTextOptionList"}], ")"}]}], 
             "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
           "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"graphical", " ", "element", " ", "generation"}], " ", 
         "*)"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"panel", " ", "background"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"FigCompositeElement", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"CollectGraphicalElements", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"FigPolygonElement", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"Rectangle", "@@", 
                RowBox[{"Transpose", "[", 
                 RowBox[{"Window", "@", 
                  RowBox[{"CanvasRegion", "[", "]"}]}], "]"}]}], "}"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"Flatten", "[", 
               RowBox[{"{", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"Layer", "\[Rule]", "$FigBackgroundLayer"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"ShowLine", "\[Rule]", "False"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"ShowFill", "\[Rule]", "True"}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"FillColor", "\[Rule]", 
                  RowBox[{"(", 
                   RowBox[{"Background", "/.", "FigOptions"}], ")"}]}], ",", 
                 "\[IndentingNewLine]", 
                 RowBox[{"FillOpacity", "\[Rule]", 
                  RowBox[{"(", 
                   RowBox[{"BackgroundOpacity", "/.", "FigOptions"}], ")"}]}],
                  ",", "\[IndentingNewLine]", 
                 RowBox[{"FillDirectives", "\[Rule]", 
                  RowBox[{"(", 
                   RowBox[{"BackgroundDirectives", "/.", "FigOptions"}], 
                   ")"}]}], ",", "\[IndentingNewLine]", "FigOptions"}], 
                "\[IndentingNewLine]", "}"}], "]"}]}], "\[IndentingNewLine]", 
             "]"}], ",", "\[IndentingNewLine]", "Window", ",", 
            "EffectiveBackground"}], "\[IndentingNewLine]", "]"}], ",", 
          "\[IndentingNewLine]", "Window", ",", "PanelLayer", ",", 
          "\[IndentingNewLine]", 
          RowBox[{"Clip", "\[Rule]", "False"}], ",", 
          RowBox[{"Debug", "\[Rule]", "True"}]}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"evaluate", " ", "body"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"option", " ", "scoping"}], ",", " ", 
          RowBox[{"origin", " ", "scoping"}], ",", " ", 
          RowBox[{"and", " ", "all", " ", "that", " ", "wonderfull", " ", 
           RowBox[{
            RowBox[{"flattening", "/", "clipping"}], "/", "rasterization"}], 
           " ", "is", " ", "imposed"}]}], " ", "*)"}], "\[IndentingNewLine]", 
        
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"note", ":", " ", 
           RowBox[{
           "could", " ", "be", " ", "elegant", " ", "to", " ", "use", " ", 
            "FigureGroup"}]}], ",", " ", 
          RowBox[{
          "but", " ", "then", " ", "must", " ", "set", " ", "$CurrentWindow", 
           " ", "and", " ", "$CurrentBackground", " ", "separately"}]}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"FigCompositeElement", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"CollectGraphicalElements", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"ScopeOptions", "[", 
             RowBox[{"ScopeOptionOverrides", "[", "\[IndentingNewLine]", 
              RowBox[{"ReleaseHold", "[", "HeldBody", "]"}], 
              "\[IndentingNewLine]", "]"}], "]"}], ",", "\[IndentingNewLine]",
             "Window", ",", "EffectiveBackground"}], "\[IndentingNewLine]", 
           "]"}], ",", "\[IndentingNewLine]", "Window", ",", "PanelLayer", 
          ",", "\[IndentingNewLine]", 
          RowBox[{"FilterRules", "[", 
           RowBox[{"FigOptions", ",", 
            RowBox[{"Options", "[", "FigCompositeElement", "]"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"panel", " ", "letter"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{
          "note", " ", "that", " ", "this", " ", "cannot", " ", "easily", " ",
            "be", " ", "done", " ", "as", " ", "an", " ", "automatic", " ", 
           "predefined", " ", "label"}], ",", " ", 
          RowBox[{
          "since", " ", "it", " ", "would", " ", "then", " ", "show", " ", 
           "up", " ", "in", " ", "the", " ", "parent", " ", 
           RowBox[{"panel", "'"}], "s", " ", "layer"}]}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"also", ",", " ", 
          RowBox[{
          "we", " ", "override", " ", "the", " ", "name", " ", "PanelLetter", 
           
           RowBox[{"(", "Label", ")"}], " ", "and", " ", "position", " ", 
           "PanelLetter", 
           RowBox[{"(", "Label", ")"}], "Position"}]}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "and", " ", "want", " ", "to", " ", "allow", " ", "for", " ", 
          "Automatic", " ", "label", " ", "content"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"StartLetterCode", "=", 
         RowBox[{"First", "[", 
          RowBox[{"ToCharacterCode", "[", 
           RowBox[{"PanelLetterBase", "/.", "FigOptions"}], "]"}], "]"}]}], 
        ";", "\[IndentingNewLine]", 
        RowBox[{"UsedPanelLetterDimensions", "=", 
         RowBox[{"ResolveOption", "[", 
          RowBox[{"PanelLetterDimensions", ",", 
           RowBox[{"{", 
            RowBox[{"Automatic", "\[RuleDelayed]", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"Rows", ",", "Columns"}], "}"}], "-", 
               RowBox[{"(", 
                RowBox[{"PanelLetterOrigin", "/.", "FigOptions"}], ")"}], "+", 
               RowBox[{"{", 
                RowBox[{"1", ",", "1"}], "}"}]}], ")"}]}], "}"}], ",", 
           "FigOptions"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"DerivedPanelLetter", "=", 
         RowBox[{"If", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"PanelIndices", "===", "None"}], ",", 
           "\[IndentingNewLine]", "None", ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"DerivedPanelLetterCode", "=", 
             RowBox[{"StartLetterCode", "+", 
              RowBox[{"(", 
               RowBox[{"PanelLetterCorrection", "/.", "FigOptions"}], ")"}], 
              "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"r", ",", "s"}], "}"}], "-", 
                 RowBox[{"(", 
                  RowBox[{"PanelLetterOrigin", "/.", "FigOptions"}], ")"}]}], 
                ")"}], ".", 
               RowBox[{"Switch", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{"PanelLetterDirection", "/.", "FigOptions"}], ")"}],
                  ",", "\[IndentingNewLine]", "Horizontal", ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"UsedPanelLetterDimensions", "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ",", "1"}], "}"}], ",", 
                 "\[IndentingNewLine]", "Vertical", ",", 
                 RowBox[{"{", 
                  RowBox[{"1", ",", 
                   RowBox[{"UsedPanelLetterDimensions", "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], "}"}]}], 
                "\[IndentingNewLine]", "]"}]}]}]}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"Row", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"First", "[", 
                RowBox[{"PanelLetterDelimiters", "/.", "FigOptions"}], "]"}], 
               ",", 
               RowBox[{
               "FromCharacterCode", "[", "DerivedPanelLetterCode", "]"}], ",", 
               RowBox[{"Last", "[", 
                RowBox[{"PanelLetterDelimiters", "/.", "FigOptions"}], 
                "]"}]}], "}"}], "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"UsedPanelLetter", "=", 
         RowBox[{"ResolveOption", "[", 
          RowBox[{"PanelLetter", ",", 
           RowBox[{"{", 
            RowBox[{"Automatic", "\[Rule]", "DerivedPanelLetter"}], "}"}], 
           ",", "FigOptions"}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"UsedPanelLetterPosition", "=", 
         RowBox[{"ResolveOption", "[", 
          RowBox[{"PanelLetterPosition", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Automatic", "\[Rule]", 
              RowBox[{"{", "}"}]}], ",", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{"x_", "?", "NumericQ"}], ")"}], "\[RuleDelayed]", 
              RowBox[{"{", "x", "}"}]}]}], "}"}], ",", "FigOptions"}], 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCompositeElement", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"CollectGraphicalElements", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"FigSpawnAttachedLabel", "[", "\[IndentingNewLine]", 
             RowBox[{
             "Self", ",", "\"\<PanelLetter\>\"", ",", "\[IndentingNewLine]", 
              RowBox[{"{", 
               RowBox[{"UsedPanelLetter", ",", "UsedPanelLetterPosition", ",", 
                RowBox[{"Last", "@", 
                 RowBox[{"FigResolveDerivedLabelOptions", "[", 
                  RowBox[{
                  "\"\<PanelLetter\>\"", ",", "False", ",", "FigOptions"}], 
                  "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
              "FigOptions"}], "\[IndentingNewLine]", "]"}], ",", 
            "\[IndentingNewLine]", "Window", ",", "EffectiveBackground"}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", "Window",
           ",", "PanelLayer", ",", "\[IndentingNewLine]", 
          RowBox[{"Clip", "\[Rule]", "False"}]}], "\[IndentingNewLine]", 
         "]"}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"panel", " ", "frame"}], " ", "*)"}], "\[IndentingNewLine]", 
        
        RowBox[{"FigCompositeElement", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"CollectGraphicalElements", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{"(*", " ", 
              RowBox[{"spawn", " ", "frame", " ", "edges"}], " ", "*)"}], 
             "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"FigAxis", "[", "\[IndentingNewLine]", 
               RowBox[{"Left", ",", 
                RowBox[{"UsedPlotRange", "[", 
                 RowBox[{"[", 
                  RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", 
                RowBox[{"UsedPlotRange", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"ExtractOptionsEntry", "[", 
                 RowBox[{"CompositeAxisOptions", ",", 
                  RowBox[{"{", 
                   RowBox[{"1", ",", "1"}], "}"}]}], "]"}], ",", 
                "\[IndentingNewLine]", "CommonAxisOptions"}], 
               "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
              RowBox[{"FigAxis", "[", "\[IndentingNewLine]", 
               RowBox[{"Right", ",", 
                RowBox[{"UsedPlotRange", "[", 
                 RowBox[{"[", 
                  RowBox[{"1", ",", "2"}], "]"}], "]"}], ",", 
                RowBox[{"UsedPlotRange", "[", 
                 RowBox[{"[", "2", "]"}], "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"ExtractOptionsEntry", "[", 
                 RowBox[{"CompositeAxisOptions", ",", 
                  RowBox[{"{", 
                   RowBox[{"1", ",", "2"}], "}"}]}], "]"}], ",", 
                "\[IndentingNewLine]", "CommonAxisOptions"}], 
               "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
              RowBox[{"FigAxis", "[", "\[IndentingNewLine]", 
               RowBox[{"Bottom", ",", 
                RowBox[{"UsedPlotRange", "[", 
                 RowBox[{"[", 
                  RowBox[{"2", ",", "1"}], "]"}], "]"}], ",", 
                RowBox[{"UsedPlotRange", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"ExtractOptionsEntry", "[", 
                 RowBox[{"CompositeAxisOptions", ",", 
                  RowBox[{"{", 
                   RowBox[{"2", ",", "1"}], "}"}]}], "]"}], ",", 
                "\[IndentingNewLine]", "CommonAxisOptions"}], 
               "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
              RowBox[{"FigAxis", "[", "\[IndentingNewLine]", 
               RowBox[{"Top", ",", 
                RowBox[{"UsedPlotRange", "[", 
                 RowBox[{"[", 
                  RowBox[{"2", ",", "2"}], "]"}], "]"}], ",", 
                RowBox[{"UsedPlotRange", "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", "\[IndentingNewLine]", 
                RowBox[{"ExtractOptionsEntry", "[", 
                 RowBox[{"CompositeAxisOptions", ",", 
                  RowBox[{"{", 
                   RowBox[{"2", ",", "2"}], "}"}]}], "]"}], ",", 
                "\[IndentingNewLine]", "CommonAxisOptions"}], 
               "\[IndentingNewLine]", "]"}], ";"}], "\[IndentingNewLine]", 
             "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
            "Window", ",", 
            RowBox[{"CurrentBackground", "[", "]"}]}], "\[IndentingNewLine]", 
           "]"}], ",", "\[IndentingNewLine]", "Window", ",", "PanelLayer", 
          ",", "\[IndentingNewLine]", 
          RowBox[{"Clip", "\[Rule]", "False"}]}], "\[IndentingNewLine]", 
         "]"}], ";"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
      "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51510150784375*^9, 3.51510165284375*^9}, {
   3.5151018264375*^9, 3.515101837625*^9}, {3.515160729234375*^9, 
   3.5151607388125*^9}, {3.515160815109375*^9, 3.515160905421875*^9}, {
   3.515429900281625*^9, 3.5154299283285*^9}, {3.515432005344125*^9, 
   3.51543202310975*^9}, {3.515432080625375*^9, 3.515432260875375*^9}, {
   3.515432559875375*^9, 3.515432618141*^9}, {3.515432654812875*^9, 
   3.515432706531625*^9}, {3.515433020406625*^9, 3.515433023781625*^9}, {
   3.515442053016*^9, 3.5154420783285*^9}, {3.51544252460975*^9, 
   3.515442586281625*^9}, {3.5154469192035*^9, 3.515446929391*^9}, {
   3.5154471764535*^9, 3.515447183094125*^9}, {3.515447219250375*^9, 
   3.515447220250375*^9}, {3.515447301531625*^9, 3.5154473044535*^9}, 
   3.515448155969125*^9, {3.515449235594125*^9, 3.515449253000375*^9}, {
   3.515449888469125*^9, 3.515449967281625*^9}, {3.51545049042225*^9, 
   3.515450513625375*^9}, 3.515450672875375*^9, {3.515450879375375*^9, 
   3.51545089279725*^9}, {3.515451270625375*^9, 3.515451273781625*^9}, {
   3.51545137210975*^9, 3.515451372812875*^9}, {3.51553024203125*^9, 
   3.51553028875*^9}, {3.51553077315625*^9, 3.51553082103125*^9}, {
   3.515531150046875*^9, 3.5155311765*^9}, {3.515532114828125*^9, 
   3.5155321876875*^9}, {3.5155322465*^9, 3.515532248484375*^9}, {
   3.515532482875*^9, 3.515532515453125*^9}, {3.515533282421875*^9, 
   3.51553328884375*^9}, 3.515535928515625*^9, {3.5155390385625*^9, 
   3.51553904040625*^9}, 3.515604950640625*^9, {3.5157850151875*^9, 
   3.515785024890625*^9}, {3.515785176578125*^9, 3.51578517725*^9}, {
   3.51578841665625*^9, 3.515788564609375*^9}, {3.515789921984375*^9, 
   3.515789953453125*^9}, {3.515790026953125*^9, 3.515790040265625*^9}, {
   3.515790697421875*^9, 3.51579075728125*^9}, {3.5157910345625*^9, 
   3.515791093203125*^9}, {3.51579118321875*^9, 3.515791189*^9}, {
   3.51579146740625*^9, 3.515791514671875*^9}, {3.515791548375*^9, 
   3.515791585546875*^9}, {3.515791705546875*^9, 3.515791714828125*^9}, {
   3.515792420203125*^9, 3.515792444578125*^9}, {3.515792527890625*^9, 
   3.515792595984375*^9}, {3.51579263221875*^9, 3.515792769953125*^9}, {
   3.515796567125*^9, 3.515796572796875*^9}, {3.515796605921875*^9, 
   3.5157966124375*^9}, 3.5157966709375*^9, {3.515797444234375*^9, 
   3.5157974605625*^9}, {3.5157978125*^9, 3.51579782590625*^9}, {
   3.515797900375*^9, 3.515797940859375*^9}, {3.515798163265625*^9, 
   3.515798184*^9}, {3.515798331015625*^9, 3.515798342921875*^9}, {
   3.515798762625*^9, 3.515798793375*^9}, {3.515798988796875*^9, 
   3.5157989945625*^9}, {3.51579902740625*^9, 3.5157990280625*^9}, {
   3.51587973046875*^9, 3.515879788953125*^9}, {3.515879826140625*^9, 
   3.515879864328125*^9}, {3.51588013771875*^9, 3.51588023940625*^9}, {
   3.515880274609375*^9, 3.515880314375*^9}, {3.515950759390625*^9, 
   3.515950825640625*^9}, {3.515951688484375*^9, 3.515951694765625*^9}, {
   3.51595192565625*^9, 3.5159519265*^9}, {3.51603647233325*^9, 
   3.516036490755125*^9}, {3.51603652852075*^9, 3.516036528927*^9}, 
   3.516036642067625*^9, {3.5162872364375*^9, 3.5162872373125*^9}, {
   3.516295340703125*^9, 3.516295349875*^9}, {3.51630497665625*^9, 
   3.5163049768125*^9}, {3.516305024515625*^9, 3.51630504096875*^9}, 
   3.516305080984375*^9, {3.51639238834375*^9, 3.516392417484375*^9}, {
   3.516392627359375*^9, 3.516392637640625*^9}, {3.516392679234375*^9, 
   3.516392716390625*^9}, {3.5163928331875*^9, 3.51639283428125*^9}, {
   3.5163949899375*^9, 3.516394999296875*^9}, {3.516395035484375*^9, 
   3.516395086015625*^9}, {3.51639527934375*^9, 3.516395307453125*^9}, {
   3.516395981890625*^9, 3.516396053328125*^9}, {3.516396114390625*^9, 
   3.51639611484375*^9}, {3.516396274796875*^9, 3.51639627653125*^9}, {
   3.516396496625*^9, 3.516396509484375*^9}, {3.516399630109375*^9, 
   3.51639965109375*^9}, {3.51639969146875*^9, 3.516399730609375*^9}, {
   3.516399815515625*^9, 3.516399875234375*^9}, {3.516399913453125*^9, 
   3.5163999934375*^9}, {3.516400039890625*^9, 3.5164001085*^9}, {
   3.51640033696875*^9, 3.51640042803125*^9}, {3.51640090778125*^9, 
   3.516400911953125*^9}, {3.516401238578125*^9, 3.516401472328125*^9}, {
   3.51640158059375*^9, 3.516401604796875*^9}, {3.516401643421875*^9, 
   3.516401644359375*^9}, {3.51640167775*^9, 3.516401824859375*^9}, {
   3.516403011578125*^9, 3.5164031456875*^9}, {3.516403178171875*^9, 
   3.516403184734375*^9}, {3.516403300484375*^9, 3.516403375109375*^9}, {
   3.516403444390625*^9, 3.516403472234375*^9}, {3.516403507296875*^9, 
   3.516403529421875*^9}, {3.516403616515625*^9, 3.51640373575*^9}, {
   3.51640384865625*^9, 3.516403860046875*^9}, {3.51640389515625*^9, 
   3.516403946515625*^9}, {3.516403988484375*^9, 3.516404123265625*^9}, {
   3.516404172109375*^9, 3.516404236546875*^9}, {3.51640429121875*^9, 
   3.516404294234375*^9}, {3.5164043391875*^9, 3.516404342171875*^9}, {
   3.51640439953125*^9, 3.516404471125*^9}, {3.516404523984375*^9, 
   3.516404538890625*^9}, {3.516404581640625*^9, 3.516404632078125*^9}, {
   3.516404834171875*^9, 3.5164048789375*^9}, {3.516405217859375*^9, 
   3.51640523890625*^9}, {3.516457185640625*^9, 3.516457230484375*^9}, {
   3.516457280453125*^9, 3.516457683703125*^9}, {3.516457741484375*^9, 
   3.51645776375*^9}, {3.516457804078125*^9, 3.5164578731875*^9}, {
   3.51645811546875*^9, 3.516458115828125*^9}, {3.51645824353125*^9, 
   3.516458367828125*^9}, 3.516458486171875*^9, 3.516458742640625*^9, {
   3.51646101896875*^9, 3.5164610946875*^9}, {3.516461128515625*^9, 
   3.51646118553125*^9}, {3.516461223984375*^9, 3.51646127840625*^9}, {
   3.516461325953125*^9, 3.516461369078125*^9}, {3.516461690765625*^9, 
   3.516461784125*^9}, {3.51646183475*^9, 3.516461873765625*^9}, {
   3.516461920140625*^9, 3.5164619704375*^9}, {3.51646249265625*^9, 
   3.516462560234375*^9}, {3.516462608421875*^9, 3.51646284496875*^9}, {
   3.516463442625*^9, 3.516463447234375*^9}, {3.516463499953125*^9, 
   3.516463508796875*^9}, {3.516463787578125*^9, 3.51646381875*^9}, {
   3.516463933671875*^9, 3.5164639465625*^9}, {3.51646428709375*^9, 
   3.516464288984375*^9}, {3.5164659444375*^9, 3.51646594671875*^9}, {
   3.516466968796875*^9, 3.516466973171875*^9}, {3.516467026859375*^9, 
   3.51646702709375*^9}, {3.516467214390625*^9, 3.51646722046875*^9}, 
   3.5164673955*^9, {3.5164692631875*^9, 3.51646926803125*^9}, {
   3.516469316203125*^9, 3.516469317359375*^9}, {3.516469422*^9, 
   3.516469428375*^9}, {3.516469458671875*^9, 3.51646968075*^9}, {
   3.51646971940625*^9, 3.51646973515625*^9}, {3.516469794*^9, 
   3.516469832578125*^9}, {3.516469863203125*^9, 3.516469913359375*^9}, {
   3.516469958859375*^9, 3.516470152203125*^9}, {3.516470311375*^9, 
   3.516470558578125*^9}, {3.51647059259375*^9, 3.5164706295625*^9}, {
   3.516470660625*^9, 3.51647073296875*^9}, {3.516471489859375*^9, 
   3.516471561125*^9}, {3.516471637296875*^9, 3.51647167328125*^9}, {
   3.516473672640625*^9, 3.51647367703125*^9}, {3.516554743515625*^9, 
   3.51655474603125*^9}, {3.516554807265625*^9, 3.51655489728125*^9}, {
   3.516554972046875*^9, 3.5165549755625*^9}, {3.5165550271875*^9, 
   3.516555038765625*^9}, {3.516555179296875*^9, 3.516555247828125*^9}, {
   3.516555370125*^9, 3.516555423890625*^9}, {3.5165558205*^9, 
   3.516555869765625*^9}, {3.516555947703125*^9, 3.5165559875*^9}, {
   3.516556273375*^9, 3.51655627475*^9}, {3.516556541234375*^9, 
   3.516556543765625*^9}, {3.516556675796875*^9, 3.516556678203125*^9}, {
   3.51655736515625*^9, 3.516557621328125*^9}, {3.516562019484375*^9, 
   3.516562032421875*^9}, 3.517775529984375*^9, {3.5177765424375*^9, 
   3.5177765445625*^9}, {3.51777673196875*^9, 3.51777673278125*^9}, {
   3.51785616730397*^9, 3.517856175383232*^9}, 3.517856242548938*^9, {
   3.5178572959075646`*^9, 3.51785729768902*^9}, {3.51785738754312*^9, 
   3.5178574824759297`*^9}, {3.5178575179643927`*^9, 3.517857554374837*^9}, {
   3.517857693031433*^9, 3.5178577047827864`*^9}, {3.5178577494285545`*^9, 
   3.517857749584822*^9}, {3.5178578635041943`*^9, 3.5178579098845367`*^9}, {
   3.517858237230073*^9, 3.517858255856861*^9}, {3.5178584260450726`*^9, 
   3.5178584634549136`*^9}, {3.5178588524453783`*^9, 
   3.5178588961214457`*^9}, {3.5178589339219494`*^9, 3.5178591363766613`*^9}, 
   3.517859228149334*^9, {3.517928958296875*^9, 3.517929023*^9}, {
   3.5179290699375*^9, 3.51792909503125*^9}, {3.517929127875*^9, 
   3.517929229859375*^9}, {3.517929354390625*^9, 3.5179294279375*^9}, {
   3.51792948221875*^9, 3.517929492390625*^9}, {3.5179295949375*^9, 
   3.51792960221875*^9}, {3.51793021296875*^9, 3.51793021328125*^9}, 
   3.517930257625*^9, {3.518018993375*^9, 3.51801900084375*^9}, {
   3.518024447*^9, 3.5180244621875*^9}, {3.51812123878125*^9, 
   3.51812126128125*^9}, {3.5181213655*^9, 3.51812137071875*^9}, 
   3.518121426671875*^9, {3.518121496375*^9, 3.518121528359375*^9}, {
   3.51812160646875*^9, 3.518121652234375*^9}, {3.5181221139375*^9, 
   3.518122118578125*^9}, {3.5181227149375*^9, 3.51812272671875*^9}, {
   3.518122766640625*^9, 3.518122767828125*^9}, {3.518124365796875*^9, 
   3.5181243659375*^9}, {3.51812441440625*^9, 3.518124468234375*^9}, {
   3.518201025359375*^9, 3.518201075796875*^9}, {3.518556990032875*^9, 
   3.518557010861*^9}, {3.51856107739225*^9, 3.518561163345375*^9}, 
   3.519646364625*^9, {3.519648332828125*^9, 3.51964836171875*^9}, {
   3.520020619421875*^9, 3.5200207503125*^9}, {3.52002189553125*^9, 
   3.520021895796875*^9}, {3.520021957578125*^9, 3.520021959984375*^9}, {
   3.520022482234375*^9, 3.5200224908125*^9}, {3.52002256121875*^9, 
   3.52002265509375*^9}, {3.52002269403125*^9, 3.52002271325*^9}, {
   3.520023022171875*^9, 3.520023117171875*^9}, {3.5200232299375*^9, 
   3.5200232725625*^9}, {3.520024172390625*^9, 3.520024175578125*^9}, {
   3.520024733703125*^9, 3.520024735984375*^9}, {3.520024909953125*^9, 
   3.520024941125*^9}, {3.52002830778125*^9, 3.52002840040625*^9}, {
   3.52002898253125*^9, 3.520029045078125*^9}, {3.52043931003125*^9, 
   3.520439355875*^9}, {3.520439403578125*^9, 3.520439416609375*^9}, {
   3.520439462640625*^9, 3.520439536328125*^9}, {3.520440240015625*^9, 
   3.52044025675*^9}, {3.520440298890625*^9, 3.520440302734375*^9}, {
   3.5204403866875*^9, 3.520440393640625*^9}, {3.520440448171875*^9, 
   3.520440450015625*^9}, 3.52044180665625*^9, {3.520443304703125*^9, 
   3.520443491078125*^9}, {3.520443531625*^9, 3.52044355728125*^9}, {
   3.52044377821875*^9, 3.52044421859375*^9}, {3.520444259671875*^9, 
   3.5204442654375*^9}, {3.520444321046875*^9, 3.520444388703125*^9}, {
   3.520444567703125*^9, 3.52044457159375*^9}, 3.520444610828125*^9, {
   3.520444650578125*^9, 3.520444733390625*^9}, {3.52044491725*^9, 
   3.52044500728125*^9}, {3.52044505775*^9, 3.520445074609375*^9}, {
   3.52044514634375*^9, 3.520445157359375*^9}, 3.520445208359375*^9, {
   3.520445310515625*^9, 3.520445382421875*^9}, {3.52044542834375*^9, 
   3.52044544175*^9}, {3.52044547359375*^9, 3.520445574203125*^9}, {
   3.5204456455*^9, 3.52044568990625*^9}, {3.520445820578125*^9, 
   3.52044583615625*^9}, {3.52044586815625*^9, 3.5204458755*^9}, {
   3.520445915109375*^9, 3.520445940203125*^9}, {3.520446767265625*^9, 
   3.5204468286875*^9}, {3.52044687778125*^9, 3.520446879484375*^9}, {
   3.520447717765625*^9, 3.520447723546875*^9}, {3.520447778109375*^9, 
   3.520447812140625*^9}, {3.52045044525*^9, 3.52045046175*^9}, {
   3.520450493265625*^9, 3.5204505190625*^9}, 3.520452491046875*^9, {
   3.52045843290625*^9, 3.520458436171875*^9}, {3.520524686109375*^9, 
   3.52052476325*^9}, {3.520524802796875*^9, 3.520524920859375*^9}, {
   3.52052661325*^9, 3.520526614234375*^9}, {3.520526650125*^9, 
   3.520526704140625*^9}, {3.5205267586875*^9, 3.52052676959375*^9}, {
   3.52052683346875*^9, 3.52052691425*^9}, {3.520526958046875*^9, 
   3.52052696584375*^9}, {3.520527091484375*^9, 3.520527105296875*^9}, {
   3.52052716665625*^9, 3.520527197265625*^9}, {3.52052724578125*^9, 
   3.52052724928125*^9}, {3.520527339453125*^9, 3.5205275049375*^9}, {
   3.520527620828125*^9, 3.520527622328125*^9}, 3.520527845*^9, {
   3.520528471515625*^9, 3.52052848646875*^9}, {3.520528523265625*^9, 
   3.5205285891875*^9}, {3.52052998253125*^9, 3.520529999828125*^9}, {
   3.520533151984375*^9, 3.520533226109375*^9}, {3.52053329084375*^9, 
   3.520533304875*^9}, {3.52053333625*^9, 3.520533426515625*^9}, {
   3.52063743696875*^9, 3.520637441*^9}, {3.52771061846875*^9, 
   3.527710637703125*^9}, {3.527710690140625*^9, 3.527710696375*^9}, {
   3.533751785578125*^9, 3.533751798328125*^9}, {3.54972433003125*^9, 
   3.549724356234375*^9}, {3.54972439296875*^9, 3.549724412140625*^9}, {
   3.54972620353125*^9, 3.549726227265625*^9}, {3.549727536546875*^9, 
   3.549727536859375*^9}, {3.5572561665*^9, 3.557256247953125*^9}, {
   3.557256327296875*^9, 3.557256422609375*^9}, {3.5572564604375*^9, 
   3.55725652721875*^9}, {3.557256557234375*^9, 3.557256577265625*^9}, {
   3.557256862484375*^9, 3.557256862796875*^9}, {3.557256904515625*^9, 
   3.557256906015625*^9}, {3.557256971296875*^9, 3.557257034359375*^9}, {
   3.566335465079641*^9, 3.5663354716628523`*^9}, {3.56634191558554*^9, 
   3.5663419630406065`*^9}, {3.5663420004806585`*^9, 
   3.5663420152282233`*^9}, {3.5666629229104757`*^9, 
   3.5666629240804777`*^9}, {3.577637351187902*^9, 3.577637387769966*^9}, {
   3.577637421887226*^9, 3.5776374226984277`*^9}, 3.5776374675173063`*^9, {
   3.5776376630948496`*^9, 3.5776377123909364`*^9}, {3.577645130860719*^9, 
   3.577645144822744*^9}, {3.5776451852424145`*^9, 3.577645208626856*^9}, {
   3.577645258749744*^9, 3.5776452625093503`*^9}, {3.5791023707198753`*^9, 
   3.5791025627094126`*^9}, {3.57910309558352*^9, 3.579103115773548*^9}, 
   3.5791031980536633`*^9, {3.579103228453706*^9, 3.5791032587137485`*^9}, {
   3.579103291483794*^9, 3.5791032956837997`*^9}, {3.579104117524951*^9, 
   3.579104119604954*^9}, {3.579104217635091*^9, 3.5791042460451307`*^9}, {
   3.579104297125202*^9, 3.5791043289252467`*^9}, {3.5791044950754795`*^9, 
   3.5791044959554806`*^9}, {3.5791056215790567`*^9, 3.579105635214076*^9}, {
   3.5791162088093452`*^9, 3.5791162208525667`*^9}, {3.5830804585097885`*^9, 
   3.5830804599137907`*^9}, {3.5830805031882668`*^9, 
   3.5830805706739855`*^9}, {3.583080786859583*^9, 3.5830807937703953`*^9}, {
   3.5830809080697956`*^9, 3.583080910940201*^9}, {3.583081475629814*^9, 
   3.583081492124643*^9}, {3.5836977948955984`*^9, 3.583697799390605*^9}, {
   3.5836979888804703`*^9, 3.5836980198205137`*^9}, {3.5836980974406223`*^9, 
   3.5836981115306425`*^9}, {3.583698232665812*^9, 3.5836982348258147`*^9}, {
   3.583698318090932*^9, 3.5836983202959347`*^9}, {3.5836983787510166`*^9, 
   3.5836984009560475`*^9}, {3.58369848139116*^9, 3.5836985274362245`*^9}, {
   3.5836985721712875`*^9, 3.583698575591292*^9}, {3.58395425043289*^9, 
   3.583954251132891*^9}, {3.58401355999273*^9, 3.5840135749843564`*^9}, {
   3.5840139706010513`*^9, 3.584013972254654*^9}, {3.58401400426591*^9, 
   3.5840140129083257`*^9}, 3.5840140793956423`*^9, {3.5840141200961137`*^9, 
   3.5840141506409674`*^9}, {3.585077781625885*^9, 3.585077834356695*^9}, {
   3.5850778858949866`*^9, 3.585077990107837*^9}, {3.5962857305832825`*^9, 
   3.5962857672589464`*^9}, {3.596285827771453*^9, 3.5962858285826545`*^9}, {
   3.596582820091199*^9, 3.5965828205591993`*^9}, 3.597693029787896*^9, {
   3.611083097110317*^9, 3.611083217057178*^9}, {3.611083524350754*^9, 
   3.611083592513443*^9}, {3.6110836376755223`*^9, 3.6110837402301025`*^9}, {
   3.6110841074391475`*^9, 3.611084168060854*^9}, {3.6110843237803273`*^9, 
   3.611084599900812*^9}, {3.6110846521921043`*^9, 3.6110846718949385`*^9}, {
   3.611085693946527*^9, 3.611085701964941*^9}, {3.62283811486014*^9, 
   3.6228381951534805`*^9}, {3.6228382931216526`*^9, 3.622838401526243*^9}, {
   3.6228384535055346`*^9, 3.6228384699479637`*^9}, {3.6228407870558786`*^9, 
   3.6228408514371915`*^9}, {3.622840881467244*^9, 3.622840959732582*^9}, {
   3.622841037779519*^9, 3.6228413112167993`*^9}, {3.622841786986435*^9, 
   3.6228418196996922`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Syntax fallthrough", "Subsection",
 CellChangeTimes->{{3.516473953875*^9, 3.51647395690625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DeclareFigFallThroughError", "[", "FigurePanel", "]"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516474358203125*^9, 3.516474372703125*^9}, {
  3.51776949659375*^9, 3.517769500078125*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Methods", "Subsection",
 CellChangeTimes->{{3.5151660264375*^9, 3.515166028765625*^9}, {
  3.515449067344125*^9, 3.51544909085975*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakeAnchor", "[", 
     RowBox[{
      RowBox[{"Class", ":", "FigurePanel"}], ",", "Self_Object"}], "]"}], "[", 
    RowBox[{
     RowBox[{"Name", ":", "\"\<PanelLetter\>\""}], ",", 
     RowBox[{"Arg", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Corner", ":", 
         RowBox[{"FigOffsetPattern", ":", "TopLeft"}]}], ",", 
        RowBox[{"Indent", ":", 
         RowBox[{"NonNegativeIntervalParametersPattern", ":", "15"}]}]}], 
       "}"}]}]}], "]"}], ":=", 
   RowBox[{"FigMakeAnchorWrapper", "[", 
    RowBox[{
    "Class", ",", "Self", ",", "Name", ",", "Arg", ",", "\[IndentingNewLine]", 
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "CanvasCorner", ",", "CanvasInset", ",", "CanvasPoint", ",", 
         "UsedOffset"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"UsedOffset", "=", 
         RowBox[{"FigResolveOffset", "[", "Corner", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"CanvasCorner", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{"Self", "@", 
              RowBox[{"GetWindow", "[", "]"}]}], ")"}], "@", 
            RowBox[{"ScaledTFunction", "[", "]"}]}], ")"}], "@", 
          RowBox[{"(", 
           RowBox[{
            RowBox[{"RescalingTransform", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "1"}], ",", 
                  RowBox[{"+", "1"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"-", "1"}], ",", 
                  RowBox[{"+", "1"}]}], "}"}]}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"0", ",", 
                  RowBox[{"+", "1"}]}], "}"}], ",", 
                RowBox[{"{", 
                 RowBox[{"0", ",", 
                  RowBox[{"+", "1"}]}], "}"}]}], "}"}]}], "]"}], "@", 
            "UsedOffset"}], ")"}]}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"CanvasInset", "=", 
         RowBox[{
          RowBox[{"-", "UsedOffset"}], "*", 
          RowBox[{"UpgradePairEqual", "[", "Indent", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"CanvasPoint", "=", 
         RowBox[{"CanvasCorner", "+", "CanvasInset"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"FigAnchor", "[", 
         RowBox[{"Canvas", "[", "CanvasPoint", "]"}], "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51517464803125*^9, 3.515174666234375*^9}, {
   3.5151749220625*^9, 3.515174944015625*^9}, {3.51525866915625*^9, 
   3.515258669703125*^9}, {3.51544000385975*^9, 3.5154400110785*^9}, {
   3.515448814344125*^9, 3.515448817391*^9}, {3.515449256562875*^9, 
   3.5154492602035*^9}, {3.51544997092225*^9, 3.515449989531625*^9}, {
   3.515532556546875*^9, 3.515532620578125*^9}, {3.515868381078125*^9, 
   3.51586839175*^9}, {3.515962683828125*^9, 3.515962690125*^9}, {
   3.51596276009375*^9, 3.51596278825*^9}, {3.51596291190625*^9, 
   3.51596291896875*^9}, {3.515962997265625*^9, 3.515963064765625*^9}, {
   3.515963133125*^9, 3.5159632166875*^9}, {3.51596326353125*^9, 
   3.51596330090625*^9}, {3.51596335503125*^9, 3.5159633551875*^9}, {
   3.51596339346875*^9, 3.515963419015625*^9}, {3.515963592125*^9, 
   3.515963597515625*^9}, {3.515963660859375*^9, 3.515963663796875*^9}, {
   3.51596389425*^9, 3.515964029625*^9}, 3.51801900215625*^9, {
   3.519648186328125*^9, 3.51964821746875*^9}, {3.52054026290625*^9, 
   3.5205402896875*^9}, {3.520540352140625*^9, 3.5205403695*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakeAnchor", "[", 
     RowBox[{
      RowBox[{"Class", ":", "FigurePanel"}], ",", "Self_Object"}], "]"}], "[", 
    RowBox[{"Name_", ",", "Arg_"}], "]"}], ":=", 
   RowBox[{"FigMakeAnchorWrapper", "[", 
    RowBox[{
    "Class", ",", "Self", ",", "Name", ",", "Arg", ",", "\[IndentingNewLine]", 
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", "Region", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Region", "=", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Self", "@", 
            RowBox[{"GetWindow", "[", "]"}]}], ")"}], "@", 
          RowBox[{"CanvasRegion", "[", "]"}]}]}], ";", "\[IndentingNewLine]", 
        
        RowBox[{"FigRectangleAnchor", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Mean", "/@", "Region"}], ",", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{"Subtract", "@@@", "Region"}], ")"}]}], "/", "2"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", "0", ",", 
          "\[IndentingNewLine]", "Name", ",", "Arg"}], "\[IndentingNewLine]", 
         "]"}]}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51847432009375*^9, 3.518474412671875*^9}, {
  3.518474586078125*^9, 3.51847459671875*^9}, {3.518474647421875*^9, 
  3.51847465640625*^9}, {3.519648222078125*^9, 3.519648232859375*^9}}],

Cell["Bounding box is canvas region of frame proper (not labels)", "Text",
 CellChangeTimes->{{3.51596333025*^9, 3.515963340140625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakeBoundingBox", "[", 
     RowBox[{
      RowBox[{"Class", ":", "FigurePanel"}], ",", "Self_Object"}], "]"}], "[",
     "]"}], ":=", 
   RowBox[{
    RowBox[{"(", 
     RowBox[{"Self", "@", 
      RowBox[{"GetWindow", "[", "]"}]}], ")"}], "@", 
    RowBox[{"CanvasRegion", "[", "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51517464803125*^9, 3.515174666234375*^9}, {
   3.5151749220625*^9, 3.515174944015625*^9}, {3.51525866915625*^9, 
   3.515258669703125*^9}, {3.51544000385975*^9, 3.5154400110785*^9}, {
   3.515448814344125*^9, 3.515448817391*^9}, {3.515449256562875*^9, 
   3.5154492602035*^9}, {3.51544997092225*^9, 3.515449989531625*^9}, {
   3.515532556546875*^9, 3.515532620578125*^9}, {3.515868381078125*^9, 
   3.51586839175*^9}, {3.515962683828125*^9, 3.515962690125*^9}, {
   3.515963304171875*^9, 3.515963353078125*^9}, 3.52002424928125*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Multipanel", "Section",
 CellChangeTimes->{{3.51542982092225*^9, 3.515429824641*^9}, {
  3.51544915248475*^9, 3.51544915367225*^9}, {3.515449711844125*^9, 
  3.515449712266*^9}, {3.51553005596875*^9, 3.515530058015625*^9}, {
  3.51578190328125*^9, 3.515781903984375*^9}, {3.5163905604375*^9, 
  3.51639056059375*^9}, {3.5203410260625*^9, 3.520341026828125*^9}}],

Cell[CellGroupData[{

Cell["CurrentMultipanel", "Subsection",
 CellChangeTimes->{{3.520451773875*^9, 3.520451775125*^9}, 
   3.520460475296875*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"$CurrentMultipanel", "=", "None"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.52045179103125*^9, 3.520451796046875*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"CurrentMultipanel", "[", "]"}], ":=", "$CurrentMultipanel"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.520451776171875*^9, 3.520451789125*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructor interface ", "Subsection",
 CellChangeTimes->{{3.51543192685975*^9, 3.5154319283285*^9}, {
   3.515787465640625*^9, 3.5157874870625*^9}, 3.520453978796875*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"Multipanel", ",", 
    RowBox[{"{", "HoldFirst", "}"}]}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Multipanel", "[", "\[IndentingNewLine]", 
    RowBox[{"Body_", ",", "\[IndentingNewLine]", 
     RowBox[{"Opts___", "?", "OptionQ"}]}], "\[IndentingNewLine]", "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Name", ",", "Self"}], "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"extract", " ", "object", " ", "name", " ", "option"}], " ", 
      "*)"}], "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Name", "=", 
       RowBox[{"Replace", "[", 
        RowBox[{"ObjectName", ",", 
         RowBox[{"Flatten", "[", 
          RowBox[{"{", 
           RowBox[{"Opts", ",", 
            RowBox[{"ObjectName", "\[Rule]", "None"}]}], "}"}], "]"}]}], 
        "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"do", " ", "ordinary", " ", "construction"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"ConstructorWrapper", "[", 
        RowBox[{"Multipanel", ",", 
         RowBox[{"Object", "[", "Name", "]"}]}], "]"}], "[", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"HoldComplete", "[", "Body", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"FilterRules", "[", 
         RowBox[{
          RowBox[{"{", "Opts", "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Except", "[", "Name", "]"}], "}"}]}], "]"}], ",", " ", 
        "\[IndentingNewLine]", "$PrivateConstructorMarker"}], 
       "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.515785185953125*^9, 3.51578519690625*^9}, {
   3.51578749946875*^9, 3.51578749959375*^9}, {3.51578753015625*^9, 
   3.51578772209375*^9}, {3.515789771671875*^9, 3.515789794328125*^9}, {
   3.515790736046875*^9, 3.51579074071875*^9}, {3.51579580096875*^9, 
   3.5157958099375*^9}, {3.5157958426875*^9, 3.515795844734375*^9}, {
   3.515795968875*^9, 3.515795971796875*^9}, {3.515796146546875*^9, 
   3.515796148234375*^9}, 3.515797228203125*^9, {3.51579732215625*^9, 
   3.51579732790625*^9}, {3.515798195484375*^9, 3.515798216515625*^9}, {
   3.515798939734375*^9, 3.515798949078125*^9}, {3.5157990341875*^9, 
   3.515799036015625*^9}, {3.515799193078125*^9, 3.51579919928125*^9}, {
   3.5157993895*^9, 3.515799431546875*^9}, 3.515799616359375*^9, {
   3.515799674703125*^9, 3.515799683703125*^9}, {3.515799736984375*^9, 
   3.515799741625*^9}, {3.51586596171875*^9, 3.51586600884375*^9}, {
   3.515866132609375*^9, 3.515866229171875*^9}, {3.515879605765625*^9, 
   3.51587963259375*^9}, {3.515879666125*^9, 3.515879669421875*^9}, {
   3.516287238671875*^9, 3.51628723915625*^9}, {3.51785831470626*^9, 
   3.517858335239481*^9}, {3.5178583843223176`*^9, 3.5178583904947853`*^9}, {
   3.518024101234375*^9, 3.518024111515625*^9}, {3.51847451375*^9, 
   3.51847452234375*^9}, {3.5203412854375*^9, 3.520341321859375*^9}, 
   3.520446044203125*^9, {3.520446293*^9, 3.520446311984375*^9}, {
   3.520467413453125*^9, 3.520467416703125*^9}, {3.526481385375*^9, 
   3.5264814125*^9}, {3.5497264243125*^9, 3.549726427015625*^9}, 
   3.5663402140944767`*^9, 3.566596478726712*^9, {3.577471622068633*^9, 
   3.5774716252354383`*^9}, {3.577472086543849*^9, 3.5774720885406523`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Option array assembly", "Subsection",
 CellChangeTimes->{{3.520454728703125*^9, 3.52045473225*^9}, {
  3.520455373984375*^9, 3.5204553770625*^9}}],

Cell["\<\
Note:
\tAxis\tSense\tDimension
\tX\t1\t2 (columns)
\tY\t2\t1 (rows)
All -- undirected or true singlet option\
\>", "Text",
 CellChangeTimes->{{3.520459417578125*^9, 3.520459450625*^9}, {
  3.6002021489358444`*^9, 3.600202167935871*^9}, {3.6002022081859274`*^9, 
  3.6002022117359324`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"VectorOfQ", "[", 
    RowBox[{"x_", ",", "p_"}], "]"}], ":=", 
   RowBox[{"VectorQ", "[", 
    RowBox[{"x", ",", 
     RowBox[{
      RowBox[{"MatchQ", "[", 
       RowBox[{"#", ",", "p"}], "]"}], "&"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"MatrixOfQ", "[", 
    RowBox[{"x_", ",", "p_"}], "]"}], ":=", 
   RowBox[{"MatrixQ", "[", 
    RowBox[{"x", ",", 
     RowBox[{
      RowBox[{"MatchQ", "[", 
       RowBox[{"#", ",", "p"}], "]"}], "&"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"VectorPattern", "[", "p_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{"_", "?", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"VectorOfQ", "[", 
        RowBox[{"#", ",", "p"}], "]"}], "&"}], ")"}]}], ")"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"MatrixPattern", "[", "p_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{"_", "?", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"MatrixOfQ", "[", 
        RowBox[{"#", ",", "p"}], "]"}], "&"}], ")"}]}], ")"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"RulePattern", "[", "p_", "]"}], ":=", 
    RowBox[{
     RowBox[{"Rule", "[", 
      RowBox[{"_", ",", "p"}], "]"}], "|", 
     RowBox[{"(", "_RuleDelayed", ")"}]}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "RHS", " ", "of", " ", "RuleDelayed", " ", "not", " ", "forced", " ", 
     "to", " ", "match", " ", "p"}], ",", " ", 
    RowBox[{
    "since", " ", "may", " ", "only", " ", "evaluate", " ", "to", " ", 
     "p"}]}], "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"RuleListPattern", "[", "p_", "]"}], "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"RulePattern", "[", "p", "]"}], ".."}], "}"}]}], ";"}], "    ", 
  
  RowBox[{"(*", " ", 
   RowBox[{"rule", " ", "list", " ", "cannot", " ", "be", " ", "null"}], " ", 
   "*)"}]}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"MultipanelArrayPattern", "[", "p_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"RuleListPattern", "[", "p", "]"}], "|", "p", "|", 
     RowBox[{"VectorPattern", "[", "p", "]"}], "|", 
     RowBox[{"MatrixPattern", "[", "p", "]"}]}], ")"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.47992947440625*^9, 3.4799294788125*^9}, {
   3.47992954340625*^9, 3.479929637640625*^9}, {3.479929732390625*^9, 
   3.47992973425*^9}, {3.479931825875*^9, 3.479931876515625*^9}, {
   3.47993247390625*^9, 3.479932480140625*^9}, {3.5204558935625*^9, 
   3.5204558938125*^9}, 3.520455980484375*^9, {3.546873643359375*^9, 
   3.5468737819375*^9}, {3.546874042203125*^9, 3.546874067515625*^9}, {
   3.546874435828125*^9, 3.546874454578125*^9}}],

Cell["Directed or singlet option -- given single value", "Text",
 CellChangeTimes->{
  3.520456210703125*^9, {3.520456286515625*^9, 3.520456291984375*^9}, {
   3.520456346796875*^9, 3.520456355359375*^9}, {3.5929488089945927`*^9, 
   3.5929488142362013`*^9}, {3.600202175615882*^9, 3.6002021771058836`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakePanelOptionArray", "[", "\[IndentingNewLine]", 
     RowBox[{"Self_Object", ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"Option_", ",", 
        RowBox[{"Sense", ":", 
         RowBox[{"(", 
          RowBox[{"1", "|", "2", "|", "All"}], ")"}]}], ",", "Patt_"}], "}"}],
       ",", "\[IndentingNewLine]", 
      RowBox[{"ArrayDimensions", ":", 
       RowBox[{"{", 
        RowBox[{"Rows_Integer", ",", "Columns_Integer"}], "}"}]}], ",", 
      "\[IndentingNewLine]", "Data_"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{"Data", ",", "Patt"}], "]"}]}], ":=", 
   RowBox[{"Option", "->", 
    RowBox[{"Table", "[", 
     RowBox[{"Data", ",", 
      RowBox[{"{", "Rows", "}"}], ",", 
      RowBox[{"{", "Columns", "}"}]}], "]"}]}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5204553936875*^9, 3.520455461171875*^9}, {
   3.520456155109375*^9, 3.520456155859375*^9}, {3.520456201*^9, 
   3.520456257109375*^9}, {3.520457534765625*^9, 3.52045753625*^9}, 
   3.520457946828125*^9, 3.520457998109375*^9, 3.520458084984375*^9, 
   3.585079402327937*^9, {3.585079729904113*^9, 3.585079731027315*^9}}],

Cell["Directed option -- given vector", "Text",
 CellChangeTimes->{
  3.520456210703125*^9, {3.520456286515625*^9, 3.520456299140625*^9}, {
   3.520456358875*^9, 3.520456365203125*^9}, {3.520456648921875*^9, 
   3.520456669171875*^9}, {3.5929488165294056`*^9, 3.592948817215807*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Multipanel", "::", "optvector"}], "=", 
   "\"\<Expecting a list of `3` values for option `1`, but given `2`.\>\""}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.520457613484375*^9, 3.520457755109375*^9}, 
   3.520458988875*^9, {3.520459900125*^9, 3.520459911765625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakePanelOptionArray", "[", "\[IndentingNewLine]", 
     RowBox[{"Self_Object", ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"Option_", ",", 
        RowBox[{"Sense", ":", 
         RowBox[{"(", 
          RowBox[{"1", "|", "2"}], ")"}]}], ",", "Patt_"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ArrayDimensions", ":", 
       RowBox[{"{", 
        RowBox[{"Rows_Integer", ",", "Columns_Integer"}], "}"}]}], ",", 
      "\[IndentingNewLine]", "Data_"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{"Data", ",", 
      RowBox[{"VectorPattern", "[", "Patt", "]"}]}], "]"}]}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "Data", "]"}], "\[NotEqual]", 
         RowBox[{"ArrayDimensions", "[", 
          RowBox[{"[", 
           RowBox[{"AntiCoordinateIndex", "[", "Sense", "]"}], "]"}], "]"}]}],
         ",", "\[IndentingNewLine]", 
        RowBox[{"FigError", "[", 
         RowBox[{"Self", ",", "\"\<optvector\>\"", ",", "Option", ",", 
          RowBox[{"Length", "[", "Data", "]"}], ",", 
          RowBox[{"ArrayDimensions", "[", 
           RowBox[{"[", 
            RowBox[{"AntiCoordinateIndex", "[", "Sense", "]"}], "]"}], 
           "]"}]}], "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Option", "->", 
       RowBox[{
        RowBox[{"Switch", "[", 
         RowBox[{
         "Sense", ",", "1", ",", "Identity", ",", "2", ",", "Transpose"}], 
         "]"}], "@", 
        RowBox[{"Table", "[", 
         RowBox[{"Data", ",", 
          RowBox[{"{", 
           RowBox[{"ArrayDimensions", "[", 
            RowBox[{"[", "Sense", "]"}], "]"}], "}"}]}], "]"}]}]}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5204553936875*^9, 3.520455461171875*^9}, {
   3.520456155109375*^9, 3.520456155859375*^9}, {3.520456201*^9, 
   3.520456257109375*^9}, {3.5204566935625*^9, 3.520456699171875*^9}, {
   3.5204567813125*^9, 3.520456852734375*^9}, {3.520457589953125*^9, 
   3.52045759159375*^9}, {3.520457770171875*^9, 3.52045784378125*^9}, {
   3.520457931140625*^9, 3.520457941265625*^9}, {3.5204579769375*^9, 
   3.5204579941875*^9}, 3.52045808196875*^9, {3.5204594576875*^9, 
   3.520459472921875*^9}, 3.5850794028583384`*^9}],

Cell["\<\
Directed or singlet option -- given array
\tNote: However, array of true singlet options falls afoul of argument \
checking. (?)\
\>", "Text",
 CellChangeTimes->{
  3.520456210703125*^9, {3.520456286515625*^9, 3.520456299140625*^9}, {
   3.520456358875*^9, 3.520456365203125*^9}, {3.520456648921875*^9, 
   3.520456669171875*^9}, {3.52045693521875*^9, 3.520456936515625*^9}, {
   3.592948819992612*^9, 3.592948820741413*^9}, {3.6002021940759077`*^9, 
   3.6002021971859117`*^9}, {3.600202288036039*^9, 3.6002023220160866`*^9}, {
   3.6002025799464474`*^9, 3.600202580966449*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Multipanel", "::", "optarray"}], "=", 
   "\"\<Expecting an array of dimensions `3` for option `1`, but given an \
array of dimensions `2`.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.520457613484375*^9, 3.520457755109375*^9}, 
   3.520458988875*^9, {3.52045987771875*^9, 3.520459891390625*^9}, {
   3.520459932609375*^9, 3.52045994228125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakePanelOptionArray", "[", "\[IndentingNewLine]", 
     RowBox[{"Self_Object", ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"Option_", ",", 
        RowBox[{"Sense", ":", 
         RowBox[{"(", 
          RowBox[{"1", "|", "2", "|", "All"}], ")"}]}], ",", "Patt_"}], "}"}],
       ",", "\[IndentingNewLine]", 
      RowBox[{"ArrayDimensions", ":", 
       RowBox[{"{", 
        RowBox[{"Rows_Integer", ",", "Columns_Integer"}], "}"}]}], ",", 
      "\[IndentingNewLine]", "Data_"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{"Data", ",", 
      RowBox[{"MatrixPattern", "[", "Patt", "]"}]}], "]"}]}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Dimensions", "[", 
          RowBox[{"Data", ",", "2"}], "]"}], "\[NotEqual]", 
         "ArrayDimensions"}], ",", "  ", 
        RowBox[{"(*", " ", 
         RowBox[{"need", " ", 
          RowBox[{"Dimension", "[", 
           RowBox[{"...", ",", "2"}], "]"}], " ", "in", " ", "case", " ", 
          "entries", " ", "are", " ", "themselves", " ", "lists"}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"FigError", "[", 
         RowBox[{"Self", ",", "\"\<optarray\>\"", ",", "Option", ",", 
          RowBox[{"Dimensions", "[", "Data", "]"}], ",", "ArrayDimensions"}], 
         "]"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Option", "->", "Data"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5204553936875*^9, 3.520455461171875*^9}, {
   3.520456155109375*^9, 3.520456155859375*^9}, {3.520456201*^9, 
   3.520456257109375*^9}, {3.5204566935625*^9, 3.520456699171875*^9}, {
   3.5204567813125*^9, 3.520456852734375*^9}, {3.52045693975*^9, 
   3.520456949015625*^9}, {3.520457877265625*^9, 3.52045792790625*^9}, 
   3.52045807578125*^9, {3.520459000078125*^9, 3.520459002546875*^9}, {
   3.5204594799375*^9, 3.52045953965625*^9}, {3.520459826609375*^9, 
   3.52045982753125*^9}, {3.55433485625*^9, 3.554334878578125*^9}, 
   3.585079403326339*^9, {3.585079938242479*^9, 3.58507993902248*^9}, {
   3.5850803254351587`*^9, 3.5850803332819724`*^9}, {3.5850819643615427`*^9, 
   3.585081965101544*^9}}],

Cell["Directed or singlet option -- given rule list", "Text",
 CellChangeTimes->{
  3.520456210703125*^9, {3.520456286515625*^9, 3.520456299140625*^9}, {
   3.520456358875*^9, 3.520456365203125*^9}, {3.520456648921875*^9, 
   3.520456669171875*^9}, {3.52045693521875*^9, 3.520456936515625*^9}, {
   3.520457097375*^9, 3.52045709834375*^9}, {3.592948825405821*^9, 
   3.5929488260766225`*^9}, {3.6002023321661005`*^9, 3.6002023335561028`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Multipanel", "::", "optbadrule"}], "=", 
   "\"\<Rule list \\\"`2`\\\" for option `1` yields an array `3` containing \
one or more invalid or undefined values.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakePanelOptionArray", "[", "\[IndentingNewLine]", 
     RowBox[{"Self_Object", ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"Option_", ",", 
        RowBox[{"Sense", ":", 
         RowBox[{"(", 
          RowBox[{"1", "|", "2", "|", "All"}], ")"}]}], ",", "Patt_"}], "}"}],
       ",", "\[IndentingNewLine]", 
      RowBox[{"ArrayDimensions", ":", 
       RowBox[{"{", 
        RowBox[{"Rows_Integer", ",", "Columns_Integer"}], "}"}]}], ",", 
      "\[IndentingNewLine]", "Data_"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{"Data", ",", 
      RowBox[{"RuleListPattern", "[", "Patt", "]"}]}], "]"}]}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ValueArray", ",", "FallThroughRuleList"}], "}"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FallThroughRuleList", "=", 
       RowBox[{"Append", "[", 
        RowBox[{"Data", ",", 
         RowBox[{"_", "\[Rule]", "Undefined"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ValueArray", "=", 
       RowBox[{"Table", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Replace", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"i", ",", "j"}], "}"}], ",", "FallThroughRuleList"}], 
          "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"i", ",", "Rows"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "Columns"}], "}"}]}], "\[IndentingNewLine]", 
        "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "warn", " ", "of", " ", "rule", " ", "list", " ", "not", " ", 
        "covering", " ", "all", " ", 
        RowBox[{"panels", " ", "--"}], " ", "but", " ", "allow", " ", "since",
         " ", "not", " ", "all", " ", "panels", " ", "might", " ", "be", " ", 
        "drawn"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"!", 
          RowBox[{"FreeQ", "[", 
           RowBox[{"ValueArray", ",", "Undefined", ",", 
            RowBox[{"{", "2", "}"}]}], "]"}]}], ")"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"FigMessage", "[", 
          RowBox[{
          "Self", ",", "\"\<optundef\>\"", ",", "Option", ",", "Data", ",", 
           RowBox[{"Position", "[", 
            RowBox[{"ValueArray", ",", "Undefined", ",", 
             RowBox[{"{", "2", "}"}]}], "]"}]}], "]"}], ";"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{"do", " ", "parameter", " ", "validation"}], ",", " ", 
        RowBox[{
        "but", " ", "allowing", " ", "for", " ", "Undefined", " ", 
         "parameters"}]}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"TODO", " ", "--"}], " ", "instead", " ", "fall", " ", 
         "through", " ", "to", " ", "default", " ", "value", " ", "of", " ", 
         "option", " ", "if", " ", "fits", " ", "single"}], "-", 
        RowBox[{"panel", " ", "pattern"}]}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"!", 
          RowBox[{"MatchQ", "[", 
           RowBox[{"ValueArray", ",", 
            RowBox[{"MatrixPattern", "[", 
             RowBox[{"Patt", "|", "Undefined"}], "]"}]}], "]"}]}], ")"}], ",",
         "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"FigError", "[", 
          RowBox[{
          "Self", ",", "\"\<optbad\>\"", ",", "Option", ",", "Data", ",", 
           "ValueArray"}], "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Option", "\[Rule]", "ValueArray"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5204553936875*^9, 3.520455461171875*^9}, {
   3.520456155109375*^9, 3.520456155859375*^9}, {3.520456201*^9, 
   3.520456257109375*^9}, {3.5204566935625*^9, 3.520456699171875*^9}, {
   3.5204567813125*^9, 3.520456852734375*^9}, {3.52045693975*^9, 
   3.520456949015625*^9}, {3.52045708559375*^9, 3.520457092265625*^9}, {
   3.520457160078125*^9, 3.52045717521875*^9}, {3.52045815053125*^9, 
   3.520458151015625*^9}, {3.546873569953125*^9, 3.546873601*^9}, {
   3.54687382171875*^9, 3.54687389325*^9}, {3.546873925*^9, 
   3.54687398140625*^9}, {3.546874085578125*^9, 3.546874164625*^9}, {
   3.54687419953125*^9, 3.546874313109375*^9}, 3.58507940382554*^9, {
   3.585079839931106*^9, 3.585079840835908*^9}, {3.600202412706214*^9, 
   3.6002024399562516`*^9}, {3.600202656626555*^9, 3.6002026647765665`*^9}, {
   3.600202744696678*^9, 3.6002027534066906`*^9}, {3.6002028034267607`*^9, 
   3.600202856006834*^9}, {3.6002028937268867`*^9, 3.6002028942568874`*^9}, 
   3.600202977689106*^9, {3.600203018429163*^9, 3.6002030206791663`*^9}, {
   3.6002030968692727`*^9, 3.6002030978592744`*^9}, {3.6002033536091332`*^9, 
   3.6002033631991463`*^9}, {3.6002035209193673`*^9, 
   3.6002035212693677`*^9}, {3.6052891275469646`*^9, 3.605289179914019*^9}}],

Cell["Directed or singlet option -- fall through errors", "Text",
 CellChangeTimes->{
  3.520456210703125*^9, {3.520456286515625*^9, 3.520456299140625*^9}, {
   3.520456358875*^9, 3.520456365203125*^9}, {3.520456648921875*^9, 
   3.520456669171875*^9}, {3.52045693521875*^9, 3.520456936515625*^9}, {
   3.520457097375*^9, 3.52045709834375*^9}, {3.520458915078125*^9, 
   3.5204589176875*^9}, {3.592948846824659*^9, 3.592948847979061*^9}, {
   3.6002023440261173`*^9, 3.600202345176119*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Multipanel", "::", "optbad"}], "=", 
    "\"\<Given unrecognized value or set of values \\\"`2`\\\" for option \
`1`.\>\""}], ";"}], "  ", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"Could", " ", "dump", " ", "`3`"}], "..."}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Multipanel", "::", "optundef"}], "=", 
   "\"\<The given set of option rules \\\"`2`\\\" for option `1` does not \
provide option values for one or more panels.  The unaccounted for panels \
have indices `3`.  This is okay if those panels are not actually ever drawn \
as part of the multipanel array, but attempting to draw any of these panels \
will result in an error (indicating the option has value \
\\\"Undefined\\\").\>\""}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.520457613484375*^9, 3.520457755109375*^9}, 
   3.520458988875*^9, {3.520459025546875*^9, 3.52045906140625*^9}, {
   3.520459618859375*^9, 3.52045965528125*^9}, {3.6002026713465757`*^9, 
   3.6002026942666073`*^9}, {3.6002027567766953`*^9, 3.600202814616776*^9}, {
   3.600202923799031*^9, 3.6002029251190324`*^9}, {3.600203145869342*^9, 
   3.6002032507139893`*^9}, {3.6002033691891546`*^9, 3.600203472099299*^9}, {
   3.600203509359351*^9, 3.6002035146293583`*^9}, {3.6002035658994303`*^9, 
   3.600203596399473*^9}, {3.605136852204606*^9, 3.6051370326929293`*^9}, {
   3.6052890162540054`*^9, 3.6052890801324863`*^9}, {3.6052892136284246`*^9, 
   3.60528926879358*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakePanelOptionArray", "[", "\[IndentingNewLine]", 
     RowBox[{"Self_Object", ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"Option_", ",", 
        RowBox[{"Sense", ":", 
         RowBox[{"(", 
          RowBox[{"1", "|", "2"}], ")"}]}], ",", "Patt_"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ArrayDimensions", ":", 
       RowBox[{"{", 
        RowBox[{"Rows_Integer", ",", "Columns_Integer"}], "}"}]}], ",", 
      "\[IndentingNewLine]", "Data_"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{"Data", ",", 
      RowBox[{"Except", "[", 
       RowBox[{"Patt", "|", 
        RowBox[{"VectorPattern", "[", "Patt", "]"}], "|", 
        RowBox[{"MatrixPattern", "[", "Patt", "]"}], "|", 
        RowBox[{"RuleListPattern", "[", "Patt", "]"}]}], "]"}]}], "]"}]}], ":=", 
   RowBox[{"FigError", "[", 
    RowBox[{"Self", ",", "\"\<optbad\>\"", ",", "Option", ",", "Data"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.520458953203125*^9, 3.5204589713125*^9}, {
   3.520459066171875*^9, 3.52045907315625*^9}, {3.52045962828125*^9, 
   3.520459628953125*^9}, {3.520459816421875*^9, 3.520459817171875*^9}, 
   3.5850794043871408`*^9, {3.5850798108370547`*^9, 3.5850798112426558`*^9}, {
   3.6002023708061547`*^9, 3.600202371416156*^9}, 3.600202444396258*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakePanelOptionArray", "[", "\[IndentingNewLine]", 
     RowBox[{"Self_Object", ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{"Option_", ",", 
        RowBox[{"Sense", ":", "All"}], ",", "Patt_"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ArrayDimensions", ":", 
       RowBox[{"{", 
        RowBox[{"Rows_Integer", ",", "Columns_Integer"}], "}"}]}], ",", 
      "\[IndentingNewLine]", "Data_"}], "\[IndentingNewLine]", "]"}], "/;", 
    RowBox[{"MatchQ", "[", 
     RowBox[{"Data", ",", 
      RowBox[{"Except", "[", 
       RowBox[{"Patt", "|", 
        RowBox[{"MatrixPattern", "[", "Patt", "]"}], "|", 
        RowBox[{"RuleListPattern", "[", "Patt", "]"}]}], "]"}]}], "]"}]}], ":=", 
   RowBox[{"FigError", "[", 
    RowBox[{"Self", ",", "\"\<optbad\>\"", ",", "Option", ",", "Data"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.520458953203125*^9, 3.5204589713125*^9}, {
   3.520459066171875*^9, 3.52045907315625*^9}, {3.52045962828125*^9, 
   3.520459628953125*^9}, {3.520459816421875*^9, 3.520459817171875*^9}, 
   3.5850794043871408`*^9, {3.5850798108370547`*^9, 3.5850798112426558`*^9}, {
   3.585079880974778*^9, 3.58507989908641*^9}, 3.585080347228397*^9, 
   3.585081977991562*^9, {3.600201920049474*^9, 3.6002019339022985`*^9}, {
   3.60020237447616*^9, 3.6002023749561605`*^9}, 3.600202448006263*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constructor", "Subsection",
 CellChangeTimes->{{3.515790608640625*^9, 3.51579061009375*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"UpgradeVector", "[", 
    RowBox[{
     RowBox[{"u_", "?", "NumericQ"}], ",", "n_Integer"}], "]"}], ":=", 
   RowBox[{"Table", "[", 
    RowBox[{"u", ",", 
     RowBox[{"{", "n", "}"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UpgradeVector", "[", 
    RowBox[{
     RowBox[{"v", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"_", "?", "NumericQ"}], ".."}], "}"}]}], ",", "n_Integer"}], 
    "]"}], ":=", "v"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"UpgradeVector", "[", 
     RowBox[{
      RowBox[{"u", ":", "LogicalPattern"}], ",", "n_Integer"}], "]"}], ":=", 
    RowBox[{"Table", "[", 
     RowBox[{"u", ",", 
      RowBox[{"{", "n", "}"}]}], "]"}]}], ";"}], "  ", 
  RowBox[{"(*", " ", 
   RowBox[{"for", " ", "XYPanelGapsExterior"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"UpgradeVector", "[", 
    RowBox[{
     RowBox[{"v", ":", 
      RowBox[{"{", 
       RowBox[{"LogicalPattern", ".."}], "}"}]}], ",", "n_Integer"}], "]"}], ":=",
    "v"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.520463358890625*^9, 3.520463418796875*^9}, {
  3.557257403609375*^9, 3.557257462265625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Multipanel", "::", "numsizes"}], "=", 
   "\"\<Expecting `3` `1`, but given `2`.\>\""}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.52046156046875*^9, 3.520461594*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Constructor", "[", 
     RowBox[{
      RowBox[{"Class", ":", "Multipanel"}], ",", "Self_Object"}], "]"}], "[", 
    
    RowBox[{"HeldBody_", ",", 
     RowBox[{"Opts___", "?", "OptionQ"}], ",", "$PrivateConstructorMarker"}], 
    "]"}], ":=", 
   RowBox[{"FigObjectWrapper", "[", 
    RowBox[{"Class", ",", "Self", ",", 
     RowBox[{"{", "Opts", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
        "CanvasRegion", ",", "\[IndentingNewLine]", "RegionArray", ",", 
         "OptionsArrayList", ",", "\[IndentingNewLine]", "PanelSizes", ",", 
         "PanelGaps", ",", "PanelGapsExteriorArray", ",", 
         "PanelSizeAccumulator", ",", "PanelGapAccumulator", ",", 
         "PanelIntervals", ",", "TotalInterval", ",", "ReversalFunction", ",",
          "CoordinateRegion", ",", "Window", ",", "\[IndentingNewLine]", 
         "ArrayDimensions", ",", "Rows", ",", "Columns"}], 
        "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", " ", 
        RowBox[{
        "first", " ", "order", " ", "of", " ", "business", " ", "is", " ", 
         "to", " ", "extract", " ", "dimensions"}], " ", "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"Dimensions", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"_Integer", "?", "Positive"}], ",", 
            RowBox[{"_Integer", "?", "Positive"}]}], "}"}], ",", 
          "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"Rows", ",", "Columns"}], "}"}], "=", 
         RowBox[{"ArrayDimensions", "=", 
          RowBox[{"(", 
           RowBox[{"Dimensions", "/.", "FigOptions"}], ")"}]}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"validate", " ", "options"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"XPanelSizes", ",", 
          RowBox[{
           RowBox[{"_", "?", "NumericQ"}], "|", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"_", "?", "NumericQ"}], ".."}], "}"}]}], ",", 
          "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"YPanelSizes", ",", 
          RowBox[{
           RowBox[{"_", "?", "NumericQ"}], "|", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"_", "?", "NumericQ"}], ".."}], "}"}]}], ",", 
          "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"XPanelGaps", ",", 
          RowBox[{
           RowBox[{"_", "?", "NumericQ"}], "|", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"_", "?", "NumericQ"}], ".."}], "}"}]}], ",", 
          "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{"YPanelGaps", ",", 
          RowBox[{
           RowBox[{"_", "?", "NumericQ"}], "|", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"_", "?", "NumericQ"}], ".."}], "}"}]}], ",", 
          "FigOptions"}], "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{
         "XPanelGapsExterior", ",", "LogicalPattern", ",", "FigOptions"}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"FigCheckOption", "[", 
         RowBox[{
         "YPanelGapsExterior", ",", "LogicalPattern", ",", "FigOptions"}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"MatchQ", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"XPanelSizes", "/.", "FigOptions"}], ")"}], ",", 
             "_List"}], "]"}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"(", 
               RowBox[{"XPanelSizes", "/.", "FigOptions"}], ")"}], "]"}], "!=",
              "Columns"}], ")"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"FigError", "[", 
           RowBox[{
           "Self", ",", "\"\<numsizes\>\"", ",", "\"\<X panel sizes\>\"", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"(", 
              RowBox[{"XPanelSizes", "/.", "FigOptions"}], ")"}], "]"}], ",", 
            "Columns"}], "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"MatchQ", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"YPanelSizes", "/.", "FigOptions"}], ")"}], ",", 
             "_List"}], "]"}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"(", 
               RowBox[{"YPanelSizes", "/.", "FigOptions"}], ")"}], "]"}], 
             "\[NotEqual]", "Rows"}], ")"}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"FigError", "[", 
           RowBox[{
           "Self", ",", "\"\<numsizes\>\"", ",", "\"\<Y panel sizes\>\"", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"(", 
              RowBox[{"YPanelSizes", "/.", "FigOptions"}], ")"}], "]"}], ",", 
            "Rows"}], "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"MatchQ", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"XPanelGaps", "/.", "FigOptions"}], ")"}], ",", 
             "_List"}], "]"}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"(", 
               RowBox[{"XPanelGaps", "/.", "FigOptions"}], ")"}], "]"}], 
             "\[NotEqual]", 
             RowBox[{"(", 
              RowBox[{"Columns", "-", "1"}], ")"}]}], ")"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"FigError", "[", 
           RowBox[{
           "Self", ",", "\"\<numsizes\>\"", ",", "\"\<X panel gaps\>\"", ",", 
            
            RowBox[{"Length", "[", 
             RowBox[{"(", 
              RowBox[{"XPanelGaps", "/.", "FigOptions"}], ")"}], "]"}], ",", 
            RowBox[{"(", 
             RowBox[{"Columns", "-", "1"}], ")"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"MatchQ", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"YPanelGaps", "/.", "FigOptions"}], ")"}], ",", 
             "_List"}], "]"}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"(", 
               RowBox[{"YPanelGaps", "/.", "FigOptions"}], ")"}], "]"}], 
             "\[NotEqual]", 
             RowBox[{"(", 
              RowBox[{"Rows", "-", "1"}], ")"}]}], ")"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"FigError", "[", 
           RowBox[{
           "Self", ",", "\"\<numsizes\>\"", ",", "\"\<Y panel gaps\>\"", ",", 
            
            RowBox[{"Length", "[", 
             RowBox[{"(", 
              RowBox[{"YPanelGaps", "/.", "FigOptions"}], ")"}], "]"}], ",", 
            RowBox[{"(", 
             RowBox[{"Rows", "-", "1"}], ")"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"MatchQ", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"XPanelGapsExterior", "/.", "FigOptions"}], ")"}], ",", 
             "_List"}], "]"}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"(", 
               RowBox[{"XPanelGapsExterior", "/.", "FigOptions"}], ")"}], 
              "]"}], "\[NotEqual]", 
             RowBox[{"(", 
              RowBox[{"Columns", "-", "1"}], ")"}]}], ")"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"FigError", "[", 
           RowBox[{
           "Self", ",", "\"\<numsizes\>\"", ",", 
            "\"\<X panel gap interior/exterior flag\>\"", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"(", 
              RowBox[{"XPanelGapsExterior", "/.", "FigOptions"}], ")"}], 
             "]"}], ",", 
            RowBox[{"(", 
             RowBox[{"Columns", "-", "1"}], ")"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"MatchQ", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"YPanelGapsExterior", "/.", "FigOptions"}], ")"}], ",", 
             "_List"}], "]"}], "&&", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Length", "[", 
              RowBox[{"(", 
               RowBox[{"YPanelGapsExterior", "/.", "FigOptions"}], ")"}], 
              "]"}], "\[NotEqual]", 
             RowBox[{"(", 
              RowBox[{"Rows", "-", "1"}], ")"}]}], ")"}]}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"FigError", "[", 
           RowBox[{
           "Self", ",", "\"\<numsizes\>\"", ",", 
            "\"\<Y panel gaps interior/exterior flag\>\"", ",", 
            RowBox[{"Length", "[", 
             RowBox[{"(", 
              RowBox[{"YPanelGapsExterior", "/.", "FigOptions"}], ")"}], 
             "]"}], ",", 
            RowBox[{"(", 
             RowBox[{"Rows", "-", "1"}], ")"}]}], "]"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"store", " ", "global", " ", "information"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Debug", "/.", "FigOptions"}], ")"}], ",", 
          RowBox[{"Print", "[", "\"\<  Setting dimensions...\>\"", "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"Self", "@", 
         RowBox[{"SetDimensions", "[", "ArrayDimensions", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"CanvasRegion", "=", 
         RowBox[{"FigResolveRegion", "[", 
          RowBox[{"(", 
           RowBox[{"PanelRegion", "/.", "FigOptions"}], ")"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Self", "@", 
         RowBox[{"SetCanvasRegion", "[", "CanvasRegion", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"set", " ", "up", " ", "panel", " ", "options"}], " ", 
         "*)"}], "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Debug", "/.", "FigOptions"}], ")"}], ",", 
          RowBox[{
          "Print", "[", "\"\<  Setting up panel options...\>\"", "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"OptionsArrayList", "=", "\[IndentingNewLine]", 
         RowBox[{"Join", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{"MakePanelOptionArray", "[", 
              RowBox[{"Self", ",", "#", ",", "ArrayDimensions", ",", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"First", "[", "#", "]"}], "/.", "FigOptions"}], 
                ")"}]}], "]"}], "&"}], "/@", "FigurePanelOptionUpgrading"}], 
           ",", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{
             RowBox[{"MakePanelOptionArray", "[", 
              RowBox[{"Self", ",", "#", ",", "ArrayDimensions", ",", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"First", "[", "#", "]"}], "/.", "FigOptions"}], 
                ")"}]}], "]"}], "&"}], "/@", "FigurePanelOptionSinglets"}]}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Self", "@", 
         RowBox[{"SetPanelOptionsArrayList", "[", "OptionsArrayList", "]"}]}],
         ";", "\[IndentingNewLine]", 
        RowBox[{"PanelGapsExteriorArray", "=", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"UpgradeVector", "[", "\[IndentingNewLine]", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{"XPanelGapsExterior", ",", "YPanelGapsExterior"}], 
                "}"}], "[", 
               RowBox[{"[", "CoordinateIndex", "]"}], "]"}], "/.", 
              "FigOptions"}], ",", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"ArrayDimensions", "[", 
               RowBox[{"[", 
                RowBox[{"AntiCoordinateIndex", "[", "CoordinateIndex", "]"}], 
                "]"}], "]"}], "-", "1"}]}], "\[IndentingNewLine]", "]"}], ",",
            "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"CoordinateIndex", ",", "1", ",", "2"}], "}"}]}], 
          "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Self", "@", 
         RowBox[{
         "SetPanelGapsExteriorArray", "[", "PanelGapsExteriorArray", "]"}]}], 
        ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"set", " ", "up", " ", "geometry"}], "  ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Debug", "/.", "FigOptions"}], ")"}], ",", 
          RowBox[{"Print", "[", "\"\<  Setting up geometry...\>\"", "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"collect", " ", "relative", " ", "sizes"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"Do", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"PanelSizes", "[", "CoordinateIndex", "]"}], "=", 
            RowBox[{"UpgradeVector", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"XPanelSizes", ",", "YPanelSizes"}], "}"}], "[", 
                RowBox[{"[", "CoordinateIndex", "]"}], "]"}], "/.", 
               "FigOptions"}], ",", "\[IndentingNewLine]", 
              RowBox[{"ArrayDimensions", "[", 
               RowBox[{"[", 
                RowBox[{"AntiCoordinateIndex", "[", "CoordinateIndex", "]"}], 
                "]"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], ";", 
           "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"PanelGaps", "[", "CoordinateIndex", "]"}], "=", 
            RowBox[{"UpgradeVector", "[", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{"{", 
                 RowBox[{"XPanelGaps", ",", "YPanelGaps"}], "}"}], "[", 
                RowBox[{"[", "CoordinateIndex", "]"}], "]"}], "/.", 
               "FigOptions"}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"ArrayDimensions", "[", 
                RowBox[{"[", 
                 RowBox[{"AntiCoordinateIndex", "[", "CoordinateIndex", "]"}],
                  "]"}], "]"}], "-", "1"}]}], "\[IndentingNewLine]", "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"(*", " ", 
            RowBox[{
            "convert", " ", "these", " ", "to", " ", "coordinate", " ", 
             "intervals"}], " ", "*)"}], "\[IndentingNewLine]", 
           RowBox[{"ReversalFunction", "=", 
            RowBox[{"Switch", "[", 
             RowBox[{
             "CoordinateIndex", ",", "1", ",", "Identity", ",", "2", ",", 
              "Reverse"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"PanelSizeAccumulator", "=", 
            RowBox[{"Prepend", "[", 
             RowBox[{
              RowBox[{"Accumulate", "[", 
               RowBox[{"ReversalFunction", "@", 
                RowBox[{"PanelSizes", "[", "CoordinateIndex", "]"}]}], "]"}], 
              ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{"PanelGapAccumulator", "=", 
            RowBox[{"Prepend", "[", 
             RowBox[{
              RowBox[{"Accumulate", "[", 
               RowBox[{"ReversalFunction", "@", 
                RowBox[{"PanelGaps", "[", "CoordinateIndex", "]"}]}], "]"}], 
              ",", "0"}], "]"}]}], ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"PanelIntervals", "[", "CoordinateIndex", "]"}], "=", 
            RowBox[{"ReversalFunction", "@", 
             RowBox[{"Table", "[", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"PanelSizeAccumulator", "[", 
                   RowBox[{"[", "i", "]"}], "]"}], "+", 
                  RowBox[{"PanelGapAccumulator", "[", 
                   RowBox[{"[", "i", "]"}], "]"}]}], ",", 
                 RowBox[{
                  RowBox[{"PanelSizeAccumulator", "[", 
                   RowBox[{"[", 
                    RowBox[{"i", "+", "1"}], "]"}], "]"}], "+", 
                  RowBox[{"PanelGapAccumulator", "[", 
                   RowBox[{"[", "i", "]"}], "]"}]}]}], "}"}], ",", 
               "\[IndentingNewLine]", 
               RowBox[{"{", 
                RowBox[{"i", ",", "1", ",", 
                 RowBox[{"ArrayDimensions", "[", 
                  RowBox[{"[", 
                   RowBox[{
                   "AntiCoordinateIndex", "[", "CoordinateIndex", "]"}], 
                   "]"}], "]"}]}], "}"}]}], "\[IndentingNewLine]", "]"}]}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"TotalInterval", "[", "CoordinateIndex", "]"}], "=", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{
               RowBox[{"Last", "[", "PanelSizeAccumulator", "]"}], "+", 
               RowBox[{"Last", "[", "PanelGapAccumulator", "]"}]}]}], 
             "}"}]}]}], ",", "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"CoordinateIndex", ",", "1", ",", "2"}], "}"}]}], 
         "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "combine", " ", "intervals", " ", "into", " ", "region", " ", 
          "information"}], " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"RegionArray", "=", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"PanelIntervals", "[", "1", "]"}], "[", 
              RowBox[{"[", "s", "]"}], "]"}], ",", 
             RowBox[{
              RowBox[{"PanelIntervals", "[", "2", "]"}], "[", 
              RowBox[{"[", "r", "]"}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"r", ",", "Rows"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"s", ",", "Columns"}], "}"}]}], "\[IndentingNewLine]", 
          "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"Self", "@", 
         RowBox[{"SetPanelRegionArray", "[", "RegionArray", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"CoordinateRegion", "=", 
         RowBox[{"Table", "[", 
          RowBox[{
           RowBox[{"TotalInterval", "[", "CoordinateIndex", "]"}], ",", 
           RowBox[{"{", 
            RowBox[{"CoordinateIndex", ",", "1", ",", "2"}], "}"}]}], "]"}]}],
         ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"define", " ", "window"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
          RowBox[{"note", ":", " ", 
           RowBox[{"permits", " ", "panel", " ", "region"}]}], ",", " ", 
          "shift", ",", " ", 
          RowBox[{
          "and", " ", "adjustments", " ", "to", " ", "be", " ", "in", " ", 
           "natural", " ", "\"\<panel units\>\"", " ", "coordinates"}]}], " ",
          "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Window", "=", 
         RowBox[{"FigWindow", "[", 
          RowBox[{"CanvasRegion", ",", "CoordinateRegion"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Self", "@", 
         RowBox[{"SetWindow", "[", "Window", "]"}]}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{"evaluate", " ", "body"}], " ", "*)"}], 
        "\[IndentingNewLine]", 
        RowBox[{"If", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{"Debug", "/.", "FigOptions"}], ")"}], ",", 
          RowBox[{
          "Print", "[", "\"\<  Evaluating multipanel body...\>\"", "]"}]}], 
         "]"}], ";", "\[IndentingNewLine]", 
        RowBox[{"(*", " ", 
         RowBox[{
         "providing", " ", "access", " ", "to", " ", "global", " ", 
          "variables", " ", "PanelRows", " ", "and", " ", "PanelColumns"}], 
         " ", "*)"}], "\[IndentingNewLine]", 
        RowBox[{"Block", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"{", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"$CurrentWindow", "=", "Window"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"$CurrentMultipanel", "=", "Self"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"PanelRows", "=", "Rows"}], ",", 
            RowBox[{"PanelColumns", "=", "Columns"}]}], "\[IndentingNewLine]",
            "}"}], ",", "\[IndentingNewLine]", 
          RowBox[{"ReleaseHold", "[", "HeldBody", "]"}]}], 
         "\[IndentingNewLine]", "]"}], ";"}]}], "\[IndentingNewLine]", 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51510150784375*^9, 3.51510165284375*^9}, {
   3.5151018264375*^9, 3.515101837625*^9}, {3.515160729234375*^9, 
   3.5151607388125*^9}, {3.515160815109375*^9, 3.515160905421875*^9}, {
   3.515429900281625*^9, 3.5154299283285*^9}, {3.515432005344125*^9, 
   3.51543202310975*^9}, {3.515432080625375*^9, 3.515432260875375*^9}, {
   3.515432559875375*^9, 3.515432618141*^9}, {3.515432654812875*^9, 
   3.515432706531625*^9}, {3.515433020406625*^9, 3.515433023781625*^9}, {
   3.515442053016*^9, 3.5154420783285*^9}, {3.51544252460975*^9, 
   3.515442586281625*^9}, {3.5154469192035*^9, 3.515446929391*^9}, {
   3.5154471764535*^9, 3.515447183094125*^9}, {3.515447219250375*^9, 
   3.515447220250375*^9}, {3.515447301531625*^9, 3.5154473044535*^9}, 
   3.515448155969125*^9, {3.515449235594125*^9, 3.515449253000375*^9}, {
   3.515449888469125*^9, 3.515449967281625*^9}, {3.51545049042225*^9, 
   3.515450513625375*^9}, 3.515450672875375*^9, {3.515450879375375*^9, 
   3.51545089279725*^9}, {3.515451270625375*^9, 3.515451273781625*^9}, {
   3.51545137210975*^9, 3.515451372812875*^9}, {3.51553024203125*^9, 
   3.51553028875*^9}, {3.51553077315625*^9, 3.51553082103125*^9}, {
   3.515531150046875*^9, 3.5155311765*^9}, {3.515532114828125*^9, 
   3.5155321876875*^9}, {3.5155322465*^9, 3.515532248484375*^9}, {
   3.515532482875*^9, 3.515532515453125*^9}, {3.515533282421875*^9, 
   3.51553328884375*^9}, 3.515535928515625*^9, {3.5155390385625*^9, 
   3.51553904040625*^9}, 3.515604950640625*^9, {3.5157850151875*^9, 
   3.515785024890625*^9}, {3.515785176578125*^9, 3.51578517725*^9}, {
   3.51578841665625*^9, 3.515788564609375*^9}, {3.515789921984375*^9, 
   3.515789953453125*^9}, {3.515790026953125*^9, 3.515790040265625*^9}, {
   3.515790697421875*^9, 3.51579075728125*^9}, {3.5157910345625*^9, 
   3.515791093203125*^9}, {3.51579118321875*^9, 3.515791189*^9}, {
   3.51579146740625*^9, 3.515791514671875*^9}, {3.515791548375*^9, 
   3.515791585546875*^9}, {3.515791705546875*^9, 3.515791714828125*^9}, {
   3.515792420203125*^9, 3.515792444578125*^9}, {3.515792527890625*^9, 
   3.515792595984375*^9}, {3.51579263221875*^9, 3.515792769953125*^9}, {
   3.515796567125*^9, 3.515796572796875*^9}, {3.515796605921875*^9, 
   3.5157966124375*^9}, 3.5157966709375*^9, {3.515797444234375*^9, 
   3.5157974605625*^9}, {3.5157978125*^9, 3.51579782590625*^9}, {
   3.515797900375*^9, 3.515797940859375*^9}, {3.515798163265625*^9, 
   3.515798184*^9}, {3.515798331015625*^9, 3.515798342921875*^9}, {
   3.515798762625*^9, 3.515798793375*^9}, {3.515798988796875*^9, 
   3.5157989945625*^9}, {3.51579902740625*^9, 3.5157990280625*^9}, {
   3.51587973046875*^9, 3.515879788953125*^9}, {3.515879826140625*^9, 
   3.515879864328125*^9}, {3.51588013771875*^9, 3.51588023940625*^9}, {
   3.515880274609375*^9, 3.515880314375*^9}, {3.515950759390625*^9, 
   3.515950825640625*^9}, {3.515951688484375*^9, 3.515951694765625*^9}, {
   3.51595192565625*^9, 3.5159519265*^9}, {3.51603647233325*^9, 
   3.516036490755125*^9}, {3.51603652852075*^9, 3.516036528927*^9}, 
   3.516036642067625*^9, {3.5162872364375*^9, 3.5162872373125*^9}, {
   3.516295340703125*^9, 3.516295349875*^9}, {3.51630497665625*^9, 
   3.5163049768125*^9}, {3.516305024515625*^9, 3.51630504096875*^9}, 
   3.516305080984375*^9, {3.51639238834375*^9, 3.516392417484375*^9}, {
   3.516392627359375*^9, 3.516392637640625*^9}, {3.516392679234375*^9, 
   3.516392716390625*^9}, {3.5163928331875*^9, 3.51639283428125*^9}, {
   3.5163949899375*^9, 3.516394999296875*^9}, {3.516395035484375*^9, 
   3.516395086015625*^9}, {3.51639527934375*^9, 3.516395307453125*^9}, {
   3.516395981890625*^9, 3.516396053328125*^9}, {3.516396114390625*^9, 
   3.51639611484375*^9}, {3.516396274796875*^9, 3.51639627653125*^9}, {
   3.516396496625*^9, 3.516396509484375*^9}, {3.516399630109375*^9, 
   3.51639965109375*^9}, {3.51639969146875*^9, 3.516399730609375*^9}, {
   3.516399815515625*^9, 3.516399875234375*^9}, {3.516399913453125*^9, 
   3.5163999934375*^9}, {3.516400039890625*^9, 3.5164001085*^9}, {
   3.51640033696875*^9, 3.51640042803125*^9}, {3.51640090778125*^9, 
   3.516400911953125*^9}, {3.516401238578125*^9, 3.516401472328125*^9}, {
   3.51640158059375*^9, 3.516401604796875*^9}, {3.516401643421875*^9, 
   3.516401644359375*^9}, {3.51640167775*^9, 3.516401824859375*^9}, {
   3.516403011578125*^9, 3.5164031456875*^9}, {3.516403178171875*^9, 
   3.516403184734375*^9}, {3.516403300484375*^9, 3.516403375109375*^9}, {
   3.516403444390625*^9, 3.516403472234375*^9}, {3.516403507296875*^9, 
   3.516403529421875*^9}, {3.516403616515625*^9, 3.51640373575*^9}, {
   3.51640384865625*^9, 3.516403860046875*^9}, {3.51640389515625*^9, 
   3.516403946515625*^9}, {3.516403988484375*^9, 3.516404123265625*^9}, {
   3.516404172109375*^9, 3.516404236546875*^9}, {3.51640429121875*^9, 
   3.516404294234375*^9}, {3.5164043391875*^9, 3.516404342171875*^9}, {
   3.51640439953125*^9, 3.516404471125*^9}, {3.516404523984375*^9, 
   3.516404538890625*^9}, {3.516404581640625*^9, 3.516404632078125*^9}, {
   3.516404834171875*^9, 3.5164048789375*^9}, {3.516405217859375*^9, 
   3.51640523890625*^9}, {3.516457185640625*^9, 3.516457230484375*^9}, {
   3.516457280453125*^9, 3.516457683703125*^9}, {3.516457741484375*^9, 
   3.51645776375*^9}, {3.516457804078125*^9, 3.5164578731875*^9}, {
   3.51645811546875*^9, 3.516458115828125*^9}, {3.51645824353125*^9, 
   3.516458367828125*^9}, 3.516458486171875*^9, 3.516458742640625*^9, {
   3.51646101896875*^9, 3.5164610946875*^9}, {3.516461128515625*^9, 
   3.51646118553125*^9}, {3.516461223984375*^9, 3.51646127840625*^9}, {
   3.516461325953125*^9, 3.516461369078125*^9}, {3.516461690765625*^9, 
   3.516461784125*^9}, {3.51646183475*^9, 3.516461873765625*^9}, {
   3.516461920140625*^9, 3.5164619704375*^9}, {3.51646249265625*^9, 
   3.516462560234375*^9}, {3.516462608421875*^9, 3.51646284496875*^9}, {
   3.516463442625*^9, 3.516463447234375*^9}, {3.516463499953125*^9, 
   3.516463508796875*^9}, {3.516463787578125*^9, 3.51646381875*^9}, {
   3.516463933671875*^9, 3.5164639465625*^9}, {3.51646428709375*^9, 
   3.516464288984375*^9}, {3.5164659444375*^9, 3.51646594671875*^9}, {
   3.516466968796875*^9, 3.516466973171875*^9}, {3.516467026859375*^9, 
   3.51646702709375*^9}, {3.516467214390625*^9, 3.51646722046875*^9}, 
   3.5164673955*^9, {3.5164692631875*^9, 3.51646926803125*^9}, {
   3.516469316203125*^9, 3.516469317359375*^9}, {3.516469422*^9, 
   3.516469428375*^9}, {3.516469458671875*^9, 3.51646968075*^9}, {
   3.51646971940625*^9, 3.51646973515625*^9}, {3.516469794*^9, 
   3.516469832578125*^9}, {3.516469863203125*^9, 3.516469913359375*^9}, {
   3.516469958859375*^9, 3.516470152203125*^9}, {3.516470311375*^9, 
   3.516470558578125*^9}, {3.51647059259375*^9, 3.5164706295625*^9}, {
   3.516470660625*^9, 3.51647073296875*^9}, {3.516471489859375*^9, 
   3.516471561125*^9}, {3.516471637296875*^9, 3.51647167328125*^9}, {
   3.516473672640625*^9, 3.51647367703125*^9}, {3.516554743515625*^9, 
   3.51655474603125*^9}, {3.516554807265625*^9, 3.51655489728125*^9}, {
   3.516554972046875*^9, 3.5165549755625*^9}, {3.5165550271875*^9, 
   3.516555038765625*^9}, {3.516555179296875*^9, 3.516555247828125*^9}, {
   3.516555370125*^9, 3.516555423890625*^9}, {3.5165558205*^9, 
   3.516555869765625*^9}, {3.516555947703125*^9, 3.5165559875*^9}, {
   3.516556273375*^9, 3.51655627475*^9}, {3.516556541234375*^9, 
   3.516556543765625*^9}, {3.516556675796875*^9, 3.516556678203125*^9}, {
   3.51655736515625*^9, 3.516557621328125*^9}, {3.516562019484375*^9, 
   3.516562032421875*^9}, 3.517775529984375*^9, {3.5177765424375*^9, 
   3.5177765445625*^9}, {3.51777673196875*^9, 3.51777673278125*^9}, {
   3.51785616730397*^9, 3.517856175383232*^9}, 3.517856242548938*^9, {
   3.5178572959075646`*^9, 3.51785729768902*^9}, {3.51785738754312*^9, 
   3.5178574824759297`*^9}, {3.5178575179643927`*^9, 3.517857554374837*^9}, {
   3.517857693031433*^9, 3.5178577047827864`*^9}, {3.5178577494285545`*^9, 
   3.517857749584822*^9}, {3.5178578635041943`*^9, 3.5178579098845367`*^9}, {
   3.517858237230073*^9, 3.517858255856861*^9}, {3.5178584260450726`*^9, 
   3.5178584634549136`*^9}, {3.5178588524453783`*^9, 
   3.5178588961214457`*^9}, {3.5178589339219494`*^9, 3.5178591363766613`*^9}, 
   3.517859228149334*^9, {3.517928958296875*^9, 3.517929023*^9}, {
   3.5179290699375*^9, 3.51792909503125*^9}, {3.517929127875*^9, 
   3.517929229859375*^9}, {3.517929354390625*^9, 3.5179294279375*^9}, {
   3.51792948221875*^9, 3.517929492390625*^9}, {3.5179295949375*^9, 
   3.51792960221875*^9}, {3.51793021296875*^9, 3.51793021328125*^9}, 
   3.517930257625*^9, {3.518018993375*^9, 3.51801900084375*^9}, {
   3.518024447*^9, 3.5180244621875*^9}, {3.51812123878125*^9, 
   3.51812126128125*^9}, {3.5181213655*^9, 3.51812137071875*^9}, 
   3.518121426671875*^9, {3.518121496375*^9, 3.518121528359375*^9}, {
   3.51812160646875*^9, 3.518121652234375*^9}, {3.5181221139375*^9, 
   3.518122118578125*^9}, {3.5181227149375*^9, 3.51812272671875*^9}, {
   3.518122766640625*^9, 3.518122767828125*^9}, {3.518124365796875*^9, 
   3.5181243659375*^9}, {3.51812441440625*^9, 3.518124468234375*^9}, {
   3.518201025359375*^9, 3.518201075796875*^9}, {3.518556990032875*^9, 
   3.518557010861*^9}, {3.51856107739225*^9, 3.518561163345375*^9}, 
   3.519646364625*^9, {3.519648332828125*^9, 3.51964836171875*^9}, {
   3.520020619421875*^9, 3.5200207503125*^9}, {3.52002189553125*^9, 
   3.520021895796875*^9}, {3.520021957578125*^9, 3.520021959984375*^9}, {
   3.520022482234375*^9, 3.5200224908125*^9}, {3.52002256121875*^9, 
   3.52002265509375*^9}, {3.52002269403125*^9, 3.52002271325*^9}, {
   3.520023022171875*^9, 3.520023117171875*^9}, {3.5200232299375*^9, 
   3.5200232725625*^9}, {3.520024172390625*^9, 3.520024175578125*^9}, {
   3.520024733703125*^9, 3.520024735984375*^9}, {3.520024909953125*^9, 
   3.520024941125*^9}, {3.52002830778125*^9, 3.52002840040625*^9}, {
   3.52002898253125*^9, 3.520029045078125*^9}, {3.52043931003125*^9, 
   3.520439355875*^9}, {3.520439403578125*^9, 3.520439416609375*^9}, {
   3.520439462640625*^9, 3.520439536328125*^9}, {3.520440240015625*^9, 
   3.52044025675*^9}, {3.520440298890625*^9, 3.520440302734375*^9}, {
   3.5204403866875*^9, 3.520440393640625*^9}, {3.520440448171875*^9, 
   3.520440450015625*^9}, 3.52044180665625*^9, {3.520443304703125*^9, 
   3.520443491078125*^9}, {3.520443531625*^9, 3.52044355728125*^9}, {
   3.52044377821875*^9, 3.52044421859375*^9}, {3.520444259671875*^9, 
   3.5204442654375*^9}, {3.520444321046875*^9, 3.520444388703125*^9}, {
   3.520444567703125*^9, 3.52044457159375*^9}, 3.520444610828125*^9, {
   3.520444650578125*^9, 3.520444733390625*^9}, {3.52044491725*^9, 
   3.52044500728125*^9}, {3.52044505775*^9, 3.520445074609375*^9}, {
   3.52044514634375*^9, 3.520445157359375*^9}, 3.520445208359375*^9, {
   3.520445310515625*^9, 3.520445382421875*^9}, {3.52044542834375*^9, 
   3.52044544175*^9}, {3.52044547359375*^9, 3.520445574203125*^9}, {
   3.5204456455*^9, 3.52044568990625*^9}, {3.520445820578125*^9, 
   3.52044583615625*^9}, {3.52044586815625*^9, 3.5204458755*^9}, {
   3.520445915109375*^9, 3.520445940203125*^9}, {3.520446767265625*^9, 
   3.5204468286875*^9}, {3.52044687778125*^9, 3.520446879484375*^9}, {
   3.520447717765625*^9, 3.520447723546875*^9}, {3.520447778109375*^9, 
   3.520447812140625*^9}, {3.52045044525*^9, 3.52045046175*^9}, {
   3.520450493265625*^9, 3.5204505190625*^9}, {3.520452461359375*^9, 
   3.520452672203125*^9}, {3.52045328271875*^9, 3.52045335809375*^9}, {
   3.520457223375*^9, 3.520457240484375*^9}, {3.520457283515625*^9, 
   3.52045730253125*^9}, {3.520458102796875*^9, 3.520458122171875*^9}, {
   3.52045816453125*^9, 3.520458182953125*^9}, {3.52045825025*^9, 
   3.520458309046875*^9}, {3.52045857765625*^9, 3.520458597203125*^9}, 
   3.52045998146875*^9, {3.520460035921875*^9, 3.520460042515625*^9}, {
   3.520460078046875*^9, 3.520460081765625*^9}, {3.520461499859375*^9, 
   3.520461532421875*^9}, {3.52046166140625*^9, 3.520461731953125*^9}, {
   3.5204617638125*^9, 3.520461772421875*^9}, {3.520461817421875*^9, 
   3.52046193771875*^9}, {3.520461973734375*^9, 3.520462056109375*^9}, {
   3.520462227140625*^9, 3.520462242328125*^9}, {3.520462307484375*^9, 
   3.520462441453125*^9}, {3.520462471890625*^9, 3.520462512921875*^9}, {
   3.520462571515625*^9, 3.52046270971875*^9}, {3.520462745546875*^9, 
   3.520462823046875*^9}, {3.520463189859375*^9, 3.520463296953125*^9}, {
   3.520463431625*^9, 3.52046392278125*^9}, {3.520463953875*^9, 
   3.52046404175*^9}, {3.520464107265625*^9, 3.5204642889375*^9}, {
   3.520464324953125*^9, 3.520464330875*^9}, {3.5204647028125*^9, 
   3.52046472565625*^9}, {3.52046475890625*^9, 3.520464759515625*^9}, {
   3.5204651160625*^9, 3.52046512646875*^9}, {3.5204651834375*^9, 
   3.52046524109375*^9}, {3.52046527775*^9, 3.52046528378125*^9}, {
   3.520465322265625*^9, 3.520465337234375*^9}, {3.520465376078125*^9, 
   3.52046538690625*^9}, {3.5204666104375*^9, 3.520466631015625*^9}, {
   3.52046667978125*^9, 3.520466681421875*^9}, {3.520466808375*^9, 
   3.52046682796875*^9}, {3.5204668926875*^9, 3.520466897015625*^9}, {
   3.520468039625*^9, 3.52046804075*^9}, {3.520468081609375*^9, 
   3.5204682308125*^9}, {3.52046827996875*^9, 3.52046828121875*^9}, {
   3.520468567203125*^9, 3.52046858040625*^9}, 3.520468820765625*^9, {
   3.520468971640625*^9, 3.520469009625*^9}, 3.520524310953125*^9, {
   3.5205332560625*^9, 3.520533279234375*^9}, {3.52233548021875*^9, 
   3.522335516046875*^9}, {3.5223355618125*^9, 3.5223355624375*^9}, {
   3.533414695921875*^9, 3.5334147461875*^9}, {3.53341484665625*^9, 
   3.53341484921875*^9}, {3.533414893875*^9, 3.53341492865625*^9}, {
   3.533414967015625*^9, 3.533415008578125*^9}, {3.533415047890625*^9, 
   3.53341506384375*^9}, {3.53341534959375*^9, 3.533415365546875*^9}, {
   3.5334156488125*^9, 3.53341567246875*^9}, {3.549725420765625*^9, 
   3.54972546834375*^9}, {3.5497265119375*^9, 3.549726513953125*^9}, {
   3.557255417265625*^9, 3.557255534796875*^9}, 3.557255632703125*^9, {
   3.5572558670625*^9, 3.557255870078125*^9}, {3.5572559493125*^9, 
   3.557256041796875*^9}, {3.557257143703125*^9, 3.557257147890625*^9}, {
   3.55725719078125*^9, 3.55725719478125*^9}, {3.55725726184375*^9, 
   3.55725726340625*^9}, 3.557257578046875*^9, {3.57747164891628*^9, 
   3.577471737087635*^9}, {3.5774722012196503`*^9, 3.5774722651485624`*^9}, {
   3.5850812770993433`*^9, 3.5850812913593636`*^9}, {3.5850813956895094`*^9, 
   3.5850813975395117`*^9}, 3.585081926589489*^9, 3.592949194065669*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Syntax fallthrough", "Subsection",
 CellChangeTimes->{{3.516473953875*^9, 3.51647395690625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"DeclareFigFallThroughError", "[", "Multipanel", "]"}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.516474358203125*^9, 3.516474372703125*^9}, {
  3.51776949659375*^9, 3.517769500078125*^9}, {3.520446062234375*^9, 
  3.52044606359375*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Methods", "Subsection",
 CellChangeTimes->{{3.5151660264375*^9, 3.515166028765625*^9}, {
  3.515449067344125*^9, 3.51544909085975*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakeAnchor", "[", 
     RowBox[{
      RowBox[{"Class", ":", "Multipanel"}], ",", "Self_Object"}], "]"}], "[", 
    
    RowBox[{"Name_", ",", "Arg_"}], "]"}], ":=", 
   RowBox[{"FigMakeAnchorWrapper", "[", 
    RowBox[{
    "Class", ",", "Self", ",", "Name", ",", "Arg", ",", "\[IndentingNewLine]", 
     RowBox[{"Module", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", "Region", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Region", "=", 
         RowBox[{"Self", "@", 
          RowBox[{"GetCanvasRegion", "[", "]"}]}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"FigRectangleAnchor", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Mean", "/@", "Region"}], ",", 
          RowBox[{
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{"Subtract", "@@@", "Region"}], ")"}]}], "/", "2"}], ",", 
          
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}], ",", "0", ",", 
          "\[IndentingNewLine]", "Name", ",", "Arg"}], "\[IndentingNewLine]", 
         "]"}]}]}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51847432009375*^9, 3.518474412671875*^9}, {
  3.518474586078125*^9, 3.51847459671875*^9}, {3.518474647421875*^9, 
  3.51847465640625*^9}, {3.519648222078125*^9, 3.519648232859375*^9}, {
  3.52045344309375*^9, 3.520453449734375*^9}}],

Cell["\<\
Bounding box is canvas region of multipanel array proper (not labels)\
\>", "Text",
 CellChangeTimes->{{3.51596333025*^9, 3.515963340140625*^9}, {
  3.520453400703125*^9, 3.5204534030625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"MakeBoundingBox", "[", 
     RowBox[{
      RowBox[{"Class", ":", "Multipanel"}], ",", "Self_Object"}], "]"}], "[", 
    "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{"Self", "@", 
     RowBox[{"GetCanvasRegion", "[", "]"}]}], ")"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.51517464803125*^9, 3.515174666234375*^9}, {
   3.5151749220625*^9, 3.515174944015625*^9}, {3.51525866915625*^9, 
   3.515258669703125*^9}, {3.51544000385975*^9, 3.5154400110785*^9}, {
   3.515448814344125*^9, 3.515448817391*^9}, {3.515449256562875*^9, 
   3.5154492602035*^9}, {3.51544997092225*^9, 3.515449989531625*^9}, {
   3.515532556546875*^9, 3.515532620578125*^9}, {3.515868381078125*^9, 
   3.51586839175*^9}, {3.515962683828125*^9, 3.515962690125*^9}, {
   3.515963304171875*^9, 3.515963353078125*^9}, 3.52002424928125*^9, {
   3.52045338634375*^9, 3.520453414671875*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Value setting utilities", "Section",
 CellChangeTimes->{{3.526574680125*^9, 3.52657468575*^9}}],

Cell[CellGroupData[{

Cell["SetByRow, SetByColumn, etc.", "Subsection",
 CellChangeTimes->{{3.52657160559375*^9, 3.526571614875*^9}, {
  3.52657470071875*^9, 3.52657470346875*^9}, {3.6094195436188555`*^9, 
  3.6094195452488575`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"SetByPanelRow", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetByPanelRow", "::", "values"}], "=", 
   "\"\<Value list for `1` was given as `2`, which is not long enough to \
provide a value for row `3`.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetByPanelRow", "[", 
    RowBox[{
     RowBox[{"Variable", ":", "_Symbol"}], ",", "Values_List"}], "]"}], ":=", 
   
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "Values", "]"}], "<", "PanelRowIndex"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"FigError", "[", 
         RowBox[{"SetByPanelRow", ",", "\"\<values\>\"", ",", 
          RowBox[{"ToString", "[", 
           RowBox[{"HoldForm", "[", "Variable", "]"}], "]"}], ",", "Values", 
          ",", "PanelRowIndex"}], "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{"Variable", "=", 
        RowBox[{"Values", "[", 
         RowBox[{"[", "PanelRowIndex", "]"}], "]"}]}], ")"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.526480278*^9, 3.5264803431875*^9}, {3.52648039515625*^9,
   3.52648042871875*^9}, {3.526480580203125*^9, 3.5264807449375*^9}, {
  3.526480844890625*^9, 3.526480876203125*^9}, {3.526481135625*^9, 
  3.5264811421875*^9}, {3.5738213264086094`*^9, 3.5738213286082134`*^9}, {
  3.5831884425701*^9, 3.583188449032699*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"SetByPanelColumn", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetByPanelColumn", "::", "values"}], "=", 
   "\"\<Value list for `1` was given as `2`, which is not long enough to \
provide a value for column `3`.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetByPanelColumn", "[", 
    RowBox[{
     RowBox[{"Variable", ":", "_Symbol"}], ",", "Values_List"}], "]"}], ":=", 
   
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "Values", "]"}], "<", "PanelColumnIndex"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"FigError", "[", 
         RowBox[{"SetByPanelColumn", ",", "\"\<values\>\"", ",", 
          RowBox[{"ToString", "[", 
           RowBox[{"HoldForm", "[", "Variable", "]"}], "]"}], ",", "Values", 
          ",", "PanelColumnIndex"}], "]"}]}], "\[IndentingNewLine]", "]"}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{"Variable", "=", 
        RowBox[{"Values", "[", 
         RowBox[{"[", "PanelColumnIndex", "]"}], "]"}]}], ")"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.526480278*^9, 3.5264803431875*^9}, {3.52648039515625*^9,
    3.52648042871875*^9}, {3.526480580203125*^9, 3.5264807449375*^9}, {
   3.526480844890625*^9, 3.526480896359375*^9}, 3.526481162171875*^9, {
   3.5738213292166147`*^9, 3.5738213307922173`*^9}, {3.5831884595928617`*^9, 
   3.5831884621204004`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PairLessEqual", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x_", ",", "y_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"a_", ",", "b_"}], "}"}]}], "]"}], ":=", 
   RowBox[{"TrueQ", "[", 
    RowBox[{
     RowBox[{"Min", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"a", ",", "b"}], "}"}], "-", 
       RowBox[{"{", 
        RowBox[{"x", ",", "y"}], "}"}]}], "]"}], "\[GreaterEqual]", "0"}], 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.573821027821685*^9, 3.573821108161826*^9}, {
  3.573821294865354*^9, 3.573821297127358*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"SetByPanelIndices", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetByPanelIndices", "::", "values"}], "=", 
   "\"\<Value list for `1` was given as `2`, which has dimensions `4` and is \
not long or deep enough to provide a value for (row,column) indices \
`3`.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetByPanelIndices", "[", 
    RowBox[{
     RowBox[{"Variable", ":", "_Symbol"}], ",", 
     RowBox[{"Values_", "/;", 
      RowBox[{"MatrixQ", "[", 
       RowBox[{"Values", ",", 
        RowBox[{"True", "&"}]}], "]"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"PairLessEqual", "[", 
          RowBox[{"PanelIndices", ",", 
           RowBox[{"Dimensions", "[", 
            RowBox[{"Values", ",", "2"}], "]"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"FigError", "[", 
         RowBox[{"SetByPanelIndices", ",", "\"\<values\>\"", ",", 
          RowBox[{"ToString", "[", 
           RowBox[{"HoldForm", "[", "Variable", "]"}], "]"}], ",", "Values", 
          ",", "PanelIndices", ",", 
          RowBox[{"Dimensions", "[", 
           RowBox[{"Values", ",", "2"}], "]"}]}], "]"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{"Variable", "=", 
        RowBox[{"Extract", "[", 
         RowBox[{"Values", ",", "PanelIndices"}], "]"}]}], ")"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"SetByPanelIndices", "::", "norule"}], "=", 
   "\"\<Value list for `1` was given as `2`, which does not provide a value \
for (row,column) indices `3`.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetByPanelIndices", "[", 
    RowBox[{
     RowBox[{"Variable", ":", "_Symbol"}], ",", 
     RowBox[{"Rules", ":", 
      RowBox[{"RuleListPattern", "[", "_", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Value", ",", "FallThroughRuleList"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FallThroughRuleList", "=", 
       RowBox[{"Append", "[", 
        RowBox[{"Rules", ",", 
         RowBox[{"_", "\[Rule]", "Undefined"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Value", "=", 
       RowBox[{"Replace", "[", 
        RowBox[{"PanelIndices", ",", "Rules"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Value", "===", "Undefined"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"FigError", "[", 
          RowBox[{"SetByPanelIndices", ",", "\"\<norule\>\"", ",", 
           RowBox[{"ToString", "[", 
            RowBox[{"HoldForm", "[", "Variable", "]"}], "]"}], ",", "Rules", 
           ",", "PanelIndices"}], "]"}], ";"}]}], "\[IndentingNewLine]", 
       "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"Variable", "=", "Value"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.526480278*^9, 3.5264803431875*^9}, {3.52648039515625*^9,
    3.52648042871875*^9}, {3.526480580203125*^9, 3.5264807449375*^9}, {
   3.526480844890625*^9, 3.526480896359375*^9}, 3.526481162171875*^9, {
   3.573820675604266*^9, 3.573820691999895*^9}, {3.5738208322597413`*^9, 
   3.5738208643957977`*^9}, {3.5738209491195464`*^9, 3.573820951740351*^9}, {
   3.5738209912240205`*^9, 3.5738210019880395`*^9}, {3.5738211401754823`*^9, 
   3.573821216693617*^9}, {3.5738212688601084`*^9, 3.573821346579445*^9}, {
   3.574261475953091*^9, 3.574261504984742*^9}, 3.574261547463617*^9, {
   3.5831884699780207`*^9, 3.5831884713055415`*^9}, {3.585424611444227*^9, 
   3.585424613009229*^9}, 3.585424654219287*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"SetByPanelSequence", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetByPanelSequence", "::", "values"}], "=", 
   "\"\<Value list for `1` was given as `2`, which is not long enough to \
provide a value for column `3`.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SetByPanelSequence", "[", 
    RowBox[{
     RowBox[{"Variable", ":", "_Symbol"}], ",", "Values_List"}], "]"}], ":=", 
   
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "Values", "]"}], "<", "PanelSequenceNumber"}],
         ",", "\[IndentingNewLine]", 
        RowBox[{"FigError", "[", 
         RowBox[{"SetByPanelSequence", ",", "\"\<values\>\"", ",", 
          RowBox[{"ToString", "[", 
           RowBox[{"HoldForm", "[", "Variable", "]"}], "]"}], ",", "Values", 
          ",", "PanelSequenceNumber"}], "]"}]}], "\[IndentingNewLine]", "]"}],
       ";", "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{"Variable", "=", 
        RowBox[{"Values", "[", 
         RowBox[{"[", "PanelSequenceNumber", "]"}], "]"}]}], ")"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.526480278*^9, 3.5264803431875*^9}, {3.52648039515625*^9,
    3.52648042871875*^9}, {3.526480580203125*^9, 3.5264807449375*^9}, {
   3.526480844890625*^9, 3.526480896359375*^9}, 3.526481162171875*^9, {
   3.527711012390625*^9, 3.5277110485625*^9}, {3.5738213531782565`*^9, 
   3.573821355877061*^9}, {3.5831884743455877`*^9, 3.583188475720609*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["ByRow, ByColumn, etc.", "Subsection",
 CellChangeTimes->{{3.52657160559375*^9, 3.526571614875*^9}, {
  3.52657470071875*^9, 3.52657470346875*^9}, {3.6094195436188555`*^9, 
  3.609419555778872*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ByPanelRow", "::", "values"}], "=", 
   "\"\<Value list was given as `1`, which is not long enough to provide a \
value for row `2`.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ByPanelRow", "[", "Values_List", "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "Values", "]"}], "<", "PanelRowIndex"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"FigError", "[", 
         RowBox[{
         "ByPanelRow", ",", "\"\<values\>\"", ",", "Values", ",", 
          "PanelRowIndex"}], "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{"Values", "[", 
        RowBox[{"[", "PanelRowIndex", "]"}], "]"}], ")"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.526480278*^9, 3.5264803431875*^9}, {3.52648039515625*^9,
   3.52648042871875*^9}, {3.526480580203125*^9, 3.5264807449375*^9}, {
  3.526480844890625*^9, 3.526480876203125*^9}, {3.526481135625*^9, 
  3.5264811421875*^9}, {3.5738213264086094`*^9, 3.5738213286082134`*^9}, {
  3.5831884425701*^9, 3.583188449032699*^9}, {3.609419569498891*^9, 
  3.60941961137895*^9}, {3.609419648609002*^9, 3.609419703749079*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"ByPanelColumn", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ByPanelColumn", "::", "values"}], "=", 
   "\"\<Value list was given as `1`, which is not long enough to provide a \
value for column `2`.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ByPanelColumn", "[", "Values_List", "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "Values", "]"}], "<", "PanelColumnIndex"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"FigError", "[", 
         RowBox[{
         "ByPanelColumn", ",", "\"\<values\>\"", ",", "Values", ",", 
          "PanelColumnIndex"}], "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{"Values", "[", 
        RowBox[{"[", "PanelColumnIndex", "]"}], "]"}], ")"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.526480278*^9, 3.5264803431875*^9}, {3.52648039515625*^9,
    3.52648042871875*^9}, {3.526480580203125*^9, 3.5264807449375*^9}, {
   3.526480844890625*^9, 3.526480896359375*^9}, 3.526481162171875*^9, {
   3.5738213292166147`*^9, 3.5738213307922173`*^9}, {3.5831884595928617`*^9, 
   3.5831884621204004`*^9}, {3.609419571208894*^9, 3.609419572288895*^9}, {
   3.6094196118389506`*^9, 3.60941970413908*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"ByPanelIndices", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ByPanelIndices", "::", "values"}], "=", 
   "\"\<Value list was given as `1`, which has dimensions `4` and is not long \
or deep enough to provide a value for (row,column) indices `2`.\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ByPanelIndices", "[", 
    RowBox[{"Values_", "/;", 
     RowBox[{"MatrixQ", "[", 
      RowBox[{"Values", ",", 
       RowBox[{"True", "&"}]}], "]"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"PairLessEqual", "[", 
          RowBox[{"PanelIndices", ",", 
           RowBox[{"Dimensions", "[", 
            RowBox[{"Values", ",", "2"}], "]"}]}], "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"FigError", "[", 
         RowBox[{
         "ByPanelIndices", ",", "\"\<values\>\"", ",", "Values", ",", 
          "PanelIndices", ",", 
          RowBox[{"Dimensions", "[", 
           RowBox[{"Values", ",", "2"}], "]"}]}], "]"}]}], 
       "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{"Extract", "[", 
        RowBox[{"Values", ",", "PanelIndices"}], "]"}], ")"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ByPanelIndices", "::", "norule"}], "=", 
   "\"\<Value list was given as `1`, which does not provide a value for \
(row,column) indices `2`.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ByPanelIndices", "[", 
    RowBox[{"Rules", ":", 
     RowBox[{"RuleListPattern", "[", "_", "]"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Value", ",", "FallThroughRuleList"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FallThroughRuleList", "=", 
       RowBox[{"Append", "[", 
        RowBox[{"Rules", ",", 
         RowBox[{"_", "\[Rule]", "Undefined"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Value", "=", 
       RowBox[{"Replace", "[", 
        RowBox[{"PanelIndices", ",", "Rules"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Value", "===", "Undefined"}], ",", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"FigError", "[", 
          RowBox[{
          "ByPanelIndices", ",", "\"\<norule\>\"", ",", "Rules", ",", 
           "PanelIndices"}], "]"}], ";"}]}], "\[IndentingNewLine]", "]"}], 
      ";", "\[IndentingNewLine]", "Value"}]}], "\[IndentingNewLine]", "]"}]}],
   ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.526480278*^9, 3.5264803431875*^9}, {3.52648039515625*^9,
    3.52648042871875*^9}, {3.526480580203125*^9, 3.5264807449375*^9}, {
   3.526480844890625*^9, 3.526480896359375*^9}, 3.526481162171875*^9, {
   3.573820675604266*^9, 3.573820691999895*^9}, {3.5738208322597413`*^9, 
   3.5738208643957977`*^9}, {3.5738209491195464`*^9, 3.573820951740351*^9}, {
   3.5738209912240205`*^9, 3.5738210019880395`*^9}, {3.5738211401754823`*^9, 
   3.573821216693617*^9}, {3.5738212688601084`*^9, 3.573821346579445*^9}, {
   3.574261475953091*^9, 3.574261504984742*^9}, 3.574261547463617*^9, {
   3.5831884699780207`*^9, 3.5831884713055415`*^9}, {3.585424611444227*^9, 
   3.585424613009229*^9}, 3.585424654219287*^9, {3.6094195726688957`*^9, 
   3.6094195754688997`*^9}, {3.609419612318951*^9, 3.6094197049990807`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"ByPanelSequence", ",", "HoldFirst"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ByPanelSequence", "::", "values"}], "=", 
   "\"\<Value list was given as `1`, which is not long enough to provide a \
value for column `2`.\>\""}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ByPanelSequence", "[", "Values_List", "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"If", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "Values", "]"}], "<", "PanelSequenceNumber"}],
         ",", "\[IndentingNewLine]", 
        RowBox[{"FigError", "[", 
         RowBox[{
         "ByPanelSequence", ",", "\"\<values\>\"", ",", "Values", ",", 
          "PanelSequenceNumber"}], "]"}]}], "\[IndentingNewLine]", "]"}], ";",
       "\[IndentingNewLine]", 
      RowBox[{"(", 
       RowBox[{"Values", "[", 
        RowBox[{"[", "PanelSequenceNumber", "]"}], "]"}], ")"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.526480278*^9, 3.5264803431875*^9}, {3.52648039515625*^9,
    3.52648042871875*^9}, {3.526480580203125*^9, 3.5264807449375*^9}, {
   3.526480844890625*^9, 3.526480896359375*^9}, 3.526481162171875*^9, {
   3.527711012390625*^9, 3.5277110485625*^9}, {3.5738213531782565`*^9, 
   3.573821355877061*^9}, {3.5831884743455877`*^9, 3.583188475720609*^9}, {
   3.6094195762989006`*^9, 3.6094195781789036`*^9}, {3.609419614298954*^9, 
   3.6094197063190827`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["End package", "Section",
 CellChangeTimes->{{3.514823047703125*^9, 3.51482305353125*^9}}],

Cell[CellGroupData[{

Cell["Exit private context", "Subsection",
 CellChangeTimes->{{3.514823086015625*^9, 3.5148231094375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Exit package context", "Subsection",
 CellChangeTimes->{{3.514823092890625*^9, 3.51482312965625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Unprotect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<$*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EndPackage", "[", "]"}], ";"}]}], "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
},
AutoGeneratedPackage->Automatic,
WindowToolbars->"RulerBar",
WindowSize->{1912, 1092},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
DockedCells->(FrontEndExecute[{
   FrontEnd`NotebookApply[
    FrontEnd`InputNotebook[], #, Placeholder]}]& ),
PrintingCopies->1,
PrintingPageRange->{1, 2},
PageHeaders->{{
   Cell[
    TextData[{
      Cell[
       TextData[{
         CounterBox["Page"]}], "PageNumber"], " ", 
      Cell[
      " ", "Header", CellFrame -> {{0.5, 0}, {0, 0}}, CellFrameMargins -> 4], 
      
      Cell[
       TextData[{
         ValueBox["FileName"]}], "Header"]}], 
    CellMargins -> {{0, Inherited}, {Inherited, Inherited}}], None, None}, {
   Cell[
    TextData[{"LevelScheme 3.45 source code"}], "Header"], None, 
   "\"\"Cell[TextData[{Cell[TextData[{ValueBox[\"FileName\"]}], \"Header\"], \
Cell[\" \", \"Header\", CellFrame -> {{0, 0.5}, {0, 0}}, CellFrameMargins -> \
4], \" \", Cell[TextData[{CounterBox[\"Page\"]}], \"PageNumber\"]}], \
CellMargins -> {{Inherited, 0}, {Inh"}},
PrintingOptions->{"FirstPageFooter"->False,
"PrintingMargins"->{{36, 36}, {19.125, 36}}},
ShowSelection->True,
Magnification->1.25,
FrontEndVersion->"10.0 for Microsoft Windows (64-bit) (September 9, 2014)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 34, 0, 88, "Section"],
Cell[604, 24, 3023, 69, 212, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[3664, 98, 32, 0, 88, "Section"],
Cell[CellGroupData[{
Cell[3721, 102, 109, 1, 46, "Subsection"],
Cell[3833, 105, 1516, 24, 35, "Input",
 InitializationCell->True],
Cell[5352, 131, 184, 5, 35, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[5573, 141, 98, 1, 46, "Subsection"],
Cell[5674, 144, 2655, 50, 212, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[8366, 199, 96, 1, 46, "Subsection"],
Cell[8465, 202, 91, 1, 34, "Text"],
Cell[8559, 205, 2488, 56, 234, "Input",
 InitializationCell->True],
Cell[11050, 263, 89, 1, 34, "Text"],
Cell[11142, 266, 1885, 46, 168, "Input",
 InitializationCell->True],
Cell[13030, 314, 9878, 263, 1557, "Input",
 InitializationCell->True],
Cell[22911, 579, 96, 1, 42, "Text"],
Cell[23010, 582, 1216, 34, 182, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[24263, 621, 43, 0, 57, "Subsection"],
Cell[24309, 623, 183, 4, 43, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[24529, 632, 99, 1, 57, "Subsection"],
Cell[24631, 635, 163, 3, 43, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[24843, 644, 88, 1, 110, "Section"],
Cell[CellGroupData[{
Cell[24956, 649, 101, 1, 57, "Subsection"],
Cell[25060, 652, 277, 7, 18983900, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[25374, 664, 119, 1, 43, "Subsection"],
Cell[25496, 667, 176, 2, 42, "Text"],
Cell[25675, 671, 697, 19, 43, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[26421, 696, 198, 3, 110, "Section"],
Cell[CellGroupData[{
Cell[26644, 703, 204, 3, 57, "Subsection"],
Cell[26851, 708, 261, 9, 146, "Text"],
Cell[27115, 719, 3281, 64, 847, "Text"]
}, Open  ]],
Cell[CellGroupData[{
Cell[30433, 788, 156, 2, 57, "Subsection"],
Cell[30592, 792, 1050, 24, 353, "Text"],
Cell[31645, 818, 21519, 424, 2602, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[53201, 1247, 220, 3, 57, "Subsection"],
Cell[53424, 1252, 3035, 69, 650, "Input",
 InitializationCell->True],
Cell[56462, 1323, 103, 1, 42, "Text"],
Cell[CellGroupData[{
Cell[56590, 1328, 436, 11, 72, "Input"],
Cell[57029, 1341, 254, 6, 43, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[57332, 1353, 170, 2, 57, "Subsection"],
Cell[57505, 1357, 5586, 125, 705, "Input",
 InitializationCell->True],
Cell[63094, 1484, 103, 1, 52, "Text"],
Cell[63200, 1487, 130, 1, 53, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[63367, 1493, 180, 2, 71, "Subsection"],
Cell[63550, 1497, 224, 5, 42, "Text"],
Cell[63777, 1504, 3225, 74, 292, "Input",
 InitializationCell->True],
Cell[67005, 1580, 103, 1, 52, "Text"],
Cell[CellGroupData[{
Cell[67133, 1585, 343, 8, 90, "Input"],
Cell[67479, 1595, 554, 14, 57, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[68082, 1615, 232, 3, 71, "Subsection"],
Cell[68317, 1620, 341, 11, 198, "Text"],
Cell[68661, 1633, 4722, 105, 650, "Input",
 InitializationCell->True],
Cell[73386, 1740, 103, 1, 52, "Text"],
Cell[CellGroupData[{
Cell[73514, 1745, 537, 11, 90, "Input"],
Cell[74054, 1758, 263, 3, 53, "Output"],
Cell[74320, 1763, 239, 4, 53, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[74608, 1773, 320, 4, 57, "Subsection"],
Cell[74931, 1779, 1558, 35, 72, "Input",
 InitializationCell->True],
Cell[76492, 1816, 103, 1, 52, "Text"],
Cell[CellGroupData[{
Cell[76620, 1821, 186, 2, 53, "Input"],
Cell[76809, 1825, 3914, 99, 227, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[80784, 1931, 138, 1, 137, "Section"],
Cell[80925, 1934, 318, 7, 151, "Text"],
Cell[CellGroupData[{
Cell[81268, 1945, 255, 3, 57, "Subsection"],
Cell[81526, 1950, 1623, 28, 182, "Input",
 InitializationCell->True],
Cell[83152, 1980, 5220, 87, 347, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[88409, 2072, 205, 2, 57, "Subsection"],
Cell[88617, 2076, 2141, 37, 210, "Input",
 InitializationCell->True],
Cell[90761, 2115, 4866, 77, 347, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[95676, 2198, 184, 3, 137, "Section"],
Cell[95863, 2203, 596, 12, 215, "Text"],
Cell[96462, 2217, 140, 1, 52, "Text"],
Cell[CellGroupData[{
Cell[96627, 2222, 103, 1, 57, "Subsection"],
Cell[96733, 2225, 4303, 78, 787, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[101073, 2308, 96, 1, 57, "Subsection"],
Cell[101172, 2311, 44302, 904, 6122, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[145511, 3220, 141, 2, 71, "Subsection"],
Cell[145655, 3224, 326, 4, 34, "Text"],
Cell[145984, 3230, 2471, 52, 234, "Input",
 InitializationCell->True],
Cell[148458, 3284, 259, 3, 42, "Text"],
Cell[148720, 3289, 1207, 26, 100, "Input",
 InitializationCell->True],
Cell[149930, 3317, 110, 1, 42, "Text"],
Cell[150043, 3320, 787, 18, 43, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[150879, 3344, 324, 5, 137, "Section"],
Cell[CellGroupData[{
Cell[151228, 3353, 234, 3, 71, "Subsection"],
Cell[151465, 3358, 2861, 52, 701, "Text"],
Cell[154329, 3412, 99, 1, 42, "Text"],
Cell[154431, 3415, 1752, 28, 43, "Input",
 InitializationCell->True],
Cell[156186, 3445, 162, 2, 42, "Text"],
Cell[156351, 3449, 3600, 70, 512, "Input",
 InitializationCell->True],
Cell[159954, 3521, 95, 1, 42, "Text"],
Cell[160052, 3524, 1001, 19, 127, "Input",
 InitializationCell->True],
Cell[161056, 3545, 11485, 226, 1695, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[172578, 3776, 157, 2, 71, "Subsection"],
Cell[172738, 3780, 109, 1, 42, "Text"],
Cell[172850, 3783, 2464, 45, 210, "Input",
 InitializationCell->True],
Cell[175317, 3830, 116, 1, 42, "Text"],
Cell[175436, 3833, 4650, 93, 567, "Input",
 InitializationCell->True],
Cell[180089, 3928, 103, 1, 42, "Text"],
Cell[180195, 3931, 11698, 259, 1062, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[191930, 4195, 98, 1, 57, "Subsection"],
Cell[192031, 4198, 517, 10, 72, "Input",
 InitializationCell->True],
Cell[192551, 4210, 64321, 1229, 8267, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[256909, 5444, 102, 1, 57, "Subsection"],
Cell[257014, 5447, 251, 6, 17099891, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[257302, 5458, 141, 2, 43, "Subsection"],
Cell[257446, 5462, 3859, 89, 320, "Input",
 InitializationCell->True],
Cell[261308, 5553, 1557, 38, 292, "Input",
 InitializationCell->True],
Cell[262868, 5593, 136, 1, 42, "Text"],
Cell[263007, 5596, 949, 21, 43, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[264005, 5623, 367, 5, 110, "Section"],
Cell[CellGroupData[{
Cell[264397, 5632, 125, 2, 57, "Subsection"],
Cell[264525, 5636, 179, 4, 43, "Input",
 InitializationCell->True],
Cell[264707, 5642, 218, 6, 43, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[264962, 5653, 177, 2, 57, "Subsection"],
Cell[265142, 5657, 3545, 70, 512, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[268724, 5732, 152, 2, 71, "Subsection"],
Cell[268879, 5736, 299, 9, 146, "Text"],
Cell[269181, 5747, 2732, 81, 210, "Input",
 InitializationCell->True],
Cell[271916, 5830, 307, 4, 42, "Text"],
Cell[272226, 5836, 1237, 28, 182, "Input",
 InitializationCell->True],
Cell[273466, 5866, 283, 4, 42, "Text"],
Cell[273752, 5872, 343, 8, 43, "Input",
 InitializationCell->True],
Cell[274098, 5882, 2576, 59, 375, "Input",
 InitializationCell->True],
Cell[276677, 5943, 589, 11, 68, "Text"],
Cell[277269, 5956, 421, 9, 43, "Input",
 InitializationCell->True],
Cell[277693, 5967, 2473, 52, 375, "Input",
 InitializationCell->True],
Cell[280169, 6021, 442, 6, 42, "Text"],
Cell[280614, 6029, 5609, 121, 815, "Input",
 InitializationCell->True],
Cell[286226, 6152, 490, 7, 42, "Text"],
Cell[286719, 6161, 1540, 30, 155, "Input",
 InitializationCell->True],
Cell[288262, 6193, 1421, 31, 182, "Input",
 InitializationCell->True],
Cell[289686, 6226, 1447, 30, 182, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[291170, 6261, 98, 1, 57, "Subsection"],
Cell[291271, 6264, 1282, 40, 127, "Input",
 InitializationCell->True],
Cell[292556, 6306, 238, 6, 43, "Input",
 InitializationCell->True],
Cell[292797, 6314, 36793, 719, 3262, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[329627, 7038, 102, 1, 57, "Subsection"],
Cell[329732, 7041, 298, 7, 17099891, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[330067, 7053, 141, 2, 43, "Subsection"],
Cell[330211, 7057, 1508, 37, 292, "Input",
 InitializationCell->True],
Cell[331722, 7096, 202, 4, 42, "Text"],
Cell[331927, 7102, 940, 20, 43, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[332916, 7128, 101, 1, 137, "Section"],
Cell[CellGroupData[{
Cell[333042, 7133, 211, 3, 57, "Subsection"],
Cell[333256, 7138, 1729, 41, 292, "Input",
 InitializationCell->True],
Cell[334988, 7181, 1744, 41, 292, "Input",
 InitializationCell->True],
Cell[336735, 7224, 637, 20, 43, "Input",
 InitializationCell->True],
Cell[337375, 7246, 4081, 94, 595, "Input",
 InitializationCell->True],
Cell[341459, 7342, 1801, 41, 292, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[343297, 7388, 203, 3, 57, "Subsection"],
Cell[343503, 7393, 1475, 33, 265, "Input",
 InitializationCell->True],
Cell[344981, 7428, 1622, 37, 292, "Input",
 InitializationCell->True],
Cell[346606, 7467, 3752, 87, 595, "Input",
 InitializationCell->True],
Cell[350361, 7556, 1688, 38, 292, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[352098, 7600, 95, 1, 137, "Section"],
Cell[CellGroupData[{
Cell[352218, 7605, 106, 1, 57, "Subsection"],
Cell[352327, 7608, 96, 3, 43, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[352460, 7616, 107, 1, 57, "Subsection"],
Cell[352570, 7619, 406, 12, 100, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
