(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    694753,      14354]
NotebookOptionsPosition[    692569,      14271]
NotebookOutlinePosition[    693084,      14294]
CellTagsIndexPosition[    693009,      14289]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Header comments", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", "FigSplash"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", "Context", ":", " ", "SciDraw`"}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{"Splash", " ", "display"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Author", ":", " ", 
      RowBox[{"Mark", " ", 
       RowBox[{"A", ".", " ", "Caprio"}]}]}]}], ",", " ", 
    RowBox[{"Department", " ", "of", " ", "Physics"}], ",", " ", 
    RowBox[{"University", " ", "of", " ", "Notre", " ", "Dame"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "FIGYEAR"}]}]}], ",", " ", 
    RowBox[{"Mark", " ", 
     RowBox[{"A", ".", " ", "Caprio"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "FIGVERSION"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "MATHVERSION"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"History", ":", " ", 
     RowBox[{"See", " ", "main", " ", "package", " ", 
      RowBox[{"file", "."}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Discussion", ":", " ", "FIGDISCUSSION"}]}], " ", "*)"}], "\n", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"History", ":"}]}], " ", "\[IndentingNewLine]", " ", 
   "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]"}]], "Input",
 InitializationCell->True,
 AutoIndent->False,
 CellChangeTimes->{{3.395093723328125*^9, 3.39509375184375*^9}, {
   3.398545735296875*^9, 3.39854574365625*^9}, 3.398799700609375*^9, {
   3.43024739209375*^9, 3.43024739990625*^9}, 3.430247813015625*^9, {
   3.436819738734375*^9, 3.436819746828125*^9}, 3.436820195484375*^9, {
   3.4439959535*^9, 3.4439959773125*^9}, {3.471089562875*^9, 
   3.471089568359375*^9}, {3.471089636203125*^9, 3.471089639046875*^9}, {
   3.48681044459375*^9, 3.4868104458125*^9}, {3.489687811140625*^9, 
   3.489687812484375*^9}, {3.497222348765625*^9, 3.497222354953125*^9}, 
   3.497224390546875*^9, {3.497299514859375*^9, 3.497299515046875*^9}, {
   3.49903536659375*^9, 3.49903536784375*^9}, {3.503265433671875*^9, 
   3.5032654415*^9}, {3.50612390383225*^9, 3.5061239087385*^9}, 
   3.507509920109375*^9, {3.51481857221875*^9, 3.514818754140625*^9}, 
   3.514822657671875*^9, {3.514823337984375*^9, 3.51482334628125*^9}, 
   3.51527780978125*^9, {3.51527811153125*^9, 3.5152781149375*^9}, {
   3.515441371281625*^9, 3.515441384437875*^9}, 3.5796188749700804`*^9},
 LanguageCategory->"NaturalLanguage"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin package", "Section",
 CellChangeTimes->{{3.51482284528125*^9, 3.514822847265625*^9}, {
  3.514822891953125*^9, 3.51482289296875*^9}}],

Cell[CellGroupData[{

Cell["Package context definition", "Subsection",
 CellChangeTimes->{{3.514822830328125*^9, 3.514822834*^9}, {
  3.514822894546875*^9, 3.514822896078125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<SciDraw`\>\"", ",", "SciDraw`Private`$ExternalContexts"}], 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.395087747453125*^9, 3.39508775096875*^9}, {
   3.39509064290625*^9, 3.395090643234375*^9}, 3.395090710546875*^9, {
   3.395091175015625*^9, 3.395091179703125*^9}, {3.395093472375*^9, 
   3.39509347784375*^9}, {3.395093608140625*^9, 3.3950936085*^9}, {
   3.395519039875*^9, 3.395519061546875*^9}, {3.495041989453125*^9, 
   3.495042010953125*^9}, {3.495042158078125*^9, 3.495042163671875*^9}, {
   3.497222416421875*^9, 3.497222462578125*^9}, {3.497222963890625*^9, 
   3.497222994640625*^9}, 3.497223030953125*^9, {3.514818766734375*^9, 
   3.514818800625*^9}, {3.5148197104375*^9, 3.514819710671875*^9}, {
   3.514819841546875*^9, 3.51481994284375*^9}, {3.514819979578125*^9, 
   3.514820025046875*^9}, {3.5148201316875*^9, 3.514820154671875*^9}, {
   3.51482025234375*^9, 3.514820275171875*^9}, {3.514820309703125*^9, 
   3.514820406921875*^9}, {3.51482051775*^9, 3.514820571328125*^9}, {
   3.514820843296875*^9, 3.51482087146875*^9}, 3.51482140903125*^9, {
   3.514821446859375*^9, 3.514821449890625*^9}, 3.514821641390625*^9, {
   3.514821674609375*^9, 3.514821798390625*^9}, {3.514823407859375*^9, 
   3.514823433140625*^9}, 3.51501104184375*^9, 3.515275343*^9, {
   3.515276331390625*^9, 3.51527633303125*^9}, {3.51542275479725*^9, 
   3.515422755141*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Unprotect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}], ";"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin private context", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5148231761875*^9, 3.514823176515625*^9}}]
}, Open  ]],

Cell["Dependencies", "Subsection",
 CellChangeTimes->{{3.514821147359375*^9, 3.51482114978125*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Splash", "Section",
 CellChangeTimes->{{3.51482137025*^9, 3.514821371671875*^9}}],

Cell[CellGroupData[{

Cell["External configuration flag", "Subsection",
 CellChangeTimes->{{3.443994457375*^9, 3.443994461890625*^9}, 
   3.514821379390625*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"If", "[", 
   RowBox[{
    RowBox[{"!", 
     RowBox[{"ValueQ", "[", "SciDraw`Config`Splash", "]"}]}], ",", 
    RowBox[{"SciDraw`Config`Splash", "=", "True"}]}], "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.443994463125*^9, 3.44399447053125*^9}, {
  3.443994512859375*^9, 3.443994560296875*^9}, {3.497224396421875*^9, 
  3.49722439940625*^9}, {3.497224440125*^9, 3.497224441453125*^9}, {
  3.51482073084375*^9, 3.514820737515625*^9}, {3.579618874977581*^9, 
  3.5796188749800806`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Hyperlink box construction", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"MakeButtonForURL", "[", 
    RowBox[{"Contents_", ",", 
     RowBox[{"URLString_String", "?", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{"StringMatchQ", "[", 
         RowBox[{"#", ",", "\"\<http://*\>\""}], "]"}], "&"}], ")"}]}], ",", 
     RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"DisplayForm", "[", 
    RowBox[{"ButtonBox", "[", "\[IndentingNewLine]", 
     RowBox[{
     "Contents", ",", "\[IndentingNewLine]", "Opts", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"ButtonData", "\[RuleDelayed]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"URL", "[", "URLString", "]"}], ",", "None"}], "}"}]}], ",", 
      
      RowBox[{"ButtonNote", "->", "URLString"}], ",", 
      RowBox[{"ButtonFunction", "\[Rule]", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"FrontEndExecute", "[", 
          RowBox[{"{", 
           RowBox[{"FrontEnd`NotebookLocate", "[", "#2", "]"}], "}"}], "]"}], 
         "&"}], ")"}]}], ",", 
      RowBox[{"Active", "\[Rule]", "True"}]}], "\[IndentingNewLine]", "]"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellTags->"ButtonBox"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Splash logo (CAUTION: cell is large if you open it)", "Subsection",
 CellChangeTimes->{{3.52053940821875*^9, 3.52053941021875*^9}, {
  3.5205394929375*^9, 3.5205395020625*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SplashLogo", "=", 
   RowBox[{"Graphics", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"FaceForm", "[", "None", "]"}], ",", 
           RowBox[{"Rectangle", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1."}], ",", 
               RowBox[{"-", "1."}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"94.1764705882353", ",", "73."}], "}"}]}], "]"}], ",", 
           RowBox[{"Inset", "[", 
            RowBox[{
             RowBox[{"Graphics", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"EdgeForm", "[", "None", "]"}], ",", 
                  RowBox[{"FaceForm", "[", 
                   RowBox[{"{", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"1.", ",", "0.894101", ",", "0.709799"}], "]"}], 
                    "}"}], "]"}], ",", 
                  RowBox[{"Rectangle", "[", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0.", ",", "0."}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"93.1764705882353", ",", "72."}], "}"}]}], 
                   "]"}]}], "}"}], "}"}], ",", 
               RowBox[{"Frame", "\[Rule]", "False"}], ",", 
               RowBox[{"PlotRange", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "1."}], ",", "94.1764705882353"}], "}"}], 
                  ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "1."}], ",", "73."}], "}"}]}], "}"}]}], ",", 
               
               RowBox[{"ImageSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"95.1764705882353", ",", "74."}], "}"}]}]}], "]"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}]}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"FaceForm", "[", "None", "]"}], ",", 
           RowBox[{"Rectangle", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"0.", ",", "0."}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"93.1764705882353", ",", "72."}], "}"}]}], "]"}], ",", 
           RowBox[{"Inset", "[", 
            RowBox[{
             RowBox[{"Graphics", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"FaceForm", "[", "None", "]"}], ",", 
                   RowBox[{"Rectangle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1."}], ",", 
                    RowBox[{"-", "1."}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"94.1764705882353", ",", "73."}], "}"}]}], "]"}], 
                   ",", 
                   RowBox[{"Inset", "[", 
                    RowBox[{
                    RowBox[{"Graphics", "[", 
                    RowBox[{
                    RowBox[{"{", "}"}], ",", 
                    RowBox[{"Frame", "\[Rule]", "False"}], ",", 
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1."}], ",", "94.1764705882353"}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1."}], ",", "73."}], "}"}]}], "}"}]}], ",", 
                    
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"95.1764705882353", ",", "74."}], "}"}]}]}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}]}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"FaceForm", "[", "None", "]"}], ",", 
                   RowBox[{"Rectangle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1."}], ",", 
                    RowBox[{"-", "1."}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"94.1764705882353", ",", "73."}], "}"}]}], "]"}], 
                   ",", 
                   RowBox[{"Inset", "[", 
                    RowBox[{
                    RowBox[{"Graphics", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"GrayLevel", "[", "0", "]"}], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1", "]"}], ",", 
                    RowBox[{"AbsoluteDashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                    RowBox[{"CapForm", "[", "None", "]"}], ",", 
                    RowBox[{"JoinForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<Miter\>\"", ",", "3.25"}], "}"}], "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"14.782805429864256", ",", "46.24615384615386"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"43.58047834518423", ",", "46.24615384615386"}], 
                    "}"}]}], "}"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"GrayLevel", "[", "0", "]"}], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1", "]"}], ",", 
                    RowBox[{"AbsoluteDashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                    RowBox[{"CapForm", "[", "None", "]"}], ",", 
                    RowBox[{"JoinForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<Miter\>\"", ",", "3.25"}], "}"}], "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"20.54234001292825", ",", "36.150000000000006"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"23.54234001292825", ",", "36.150000000000006"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"25.54234001292825", ",", "32.400000000000006"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"44.34001292824823", ",", "32.400000000000006"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"46.34001292824823", ",", "36.150000000000006"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"49.34001292824823", ",", "36.150000000000006"}], 
                    "}"}]}], "}"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"GrayLevel", "[", "0", "]"}], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1", "]"}], ",", 
                    RowBox[{"AbsoluteDashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                    RowBox[{"CapForm", "[", "None", "]"}], ",", 
                    RowBox[{"JoinForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<Miter\>\"", ",", "3.25"}], "}"}], "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"26.301874595992246", ",", "18.553846153846155"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"55.099547511312224", ",", "18.553846153846155"}],
                     "}"}]}], "}"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"EdgeForm", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"GrayLevel", "[", "0", "]"}], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1", "]"}], ",", 
                    RowBox[{"AbsoluteDashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                    RowBox[{"CapForm", "[", "None", "]"}], ",", 
                    RowBox[{"JoinForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<Miter\>\"", ",", "3.25"}], "}"}], "]"}]}], 
                    "}"}], "]"}], ",", 
                    RowBox[{"FaceForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"GrayLevel", "[", "0.5", "]"}], "}"}], "]"}], ",", 
                    RowBox[{"Polygon", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"34.418791692075665", ",", "46.24615384615386"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"29.704026666036818", ",", "46.24615384615386"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"37.415840042594645", ",", "33.886479882377664"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"36.90680088862935", ",", "33.568865116143016"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"40.700711053652235", ",", "32.400000000000006"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"41.31847355632861", ",", "36.321526423509994"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"40.80943440236331", ",", "36.00391165727534"}], 
                    "}"}]}], "}"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"EdgeForm", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"GrayLevel", "[", "0", "]"}], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1", "]"}], ",", 
                    RowBox[{"AbsoluteDashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                    RowBox[{"CapForm", "[", "None", "]"}], ",", 
                    RowBox[{"JoinForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<Miter\>\"", ",", "3.25"}], "}"}], "]"}]}], 
                    "}"}], "]"}], ",", 
                    RowBox[{"FaceForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"GrayLevel", "[", "0.5", "]"}], "}"}], "]"}], ",", 
                    RowBox[{"Polygon", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"32.97890804630967", ",", "32.400000000000006"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"28.26414302027082", ",", "32.400000000000006"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"35.97595639682864", ",", "20.040326036223817"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"35.466917242863346", ",", "19.722711269989166"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"39.26082740788623", ",", "18.553846153846155"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"39.87858991056261", ",", "22.47537257735614"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"39.369550756597306", ",", "22.157757811121492"}],
                     "}"}]}], "}"}], "]"}]}], "}"}]}], "}"}], ",", 
                    RowBox[{"Frame", "\[Rule]", "False"}], ",", 
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1."}], ",", "94.1764705882353"}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1."}], ",", "73."}], "}"}]}], "}"}]}], ",", 
                    
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"95.1764705882353", ",", "74."}], "}"}]}]}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}]}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"FaceForm", "[", "None", "]"}], ",", 
                   RowBox[{"Rectangle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1."}], ",", 
                    RowBox[{"-", "1."}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"94.1764705882353", ",", "73."}], "}"}]}], "]"}], 
                   ",", 
                   RowBox[{"Inset", "[", 
                    RowBox[{
                    RowBox[{"Graphics", "[", 
                    RowBox[{
                    RowBox[{"{", "}"}], ",", 
                    RowBox[{"Frame", "\[Rule]", "False"}], ",", 
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1."}], ",", "94.1764705882353"}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1."}], ",", "73."}], "}"}]}], "}"}]}], ",", 
                    
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"95.1764705882353", ",", "74."}], "}"}]}]}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}]}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"FaceForm", "[", "None", "]"}], ",", 
                   RowBox[{"Rectangle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1."}], ",", 
                    RowBox[{"-", "1."}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"94.1764705882353", ",", "73."}], "}"}]}], "]"}], 
                   ",", 
                   RowBox[{"Inset", "[", 
                    RowBox[{
                    RowBox[{"Graphics", "[", 
                    RowBox[{
                    RowBox[{"{", "}"}], ",", 
                    RowBox[{"Frame", "\[Rule]", "False"}], ",", 
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1."}], ",", "94.1764705882353"}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1."}], ",", "73."}], "}"}]}], "}"}]}], ",", 
                    
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"95.1764705882353", ",", "74."}], "}"}]}]}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}]}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"FaceForm", "[", "None", "]"}], ",", 
                   RowBox[{"Rectangle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1."}], ",", 
                    RowBox[{"-", "1."}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"94.1764705882353", ",", "73."}], "}"}]}], "]"}], 
                   ",", 
                   RowBox[{"Inset", "[", 
                    RowBox[{
                    RowBox[{"Graphics", "[", 
                    RowBox[{
                    RowBox[{"{", "}"}], ",", 
                    RowBox[{"Frame", "\[Rule]", "False"}], ",", 
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1."}], ",", "94.1764705882353"}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1."}], ",", "73."}], "}"}]}], "}"}]}], ",", 
                    
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"95.1764705882353", ",", "74."}], "}"}]}]}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}]}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"FaceForm", "[", "None", "]"}], ",", 
                   RowBox[{"Rectangle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0.", ",", "0."}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"93.17647058823529", ",", "72."}], "}"}]}], "]"}],
                    ",", 
                   RowBox[{"Inset", "[", 
                    RowBox[{
                    RowBox[{"Graphics", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"EdgeForm", "[", "None", "]"}], ",", 
                    RowBox[{"FaceForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"0.5", ",", "0.539994", ",", "0.53"}], "]"}], 
                    "}"}], "]"}], ",", 
                    RowBox[{"Polygon", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1.7918552036199096", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"1.7918552036199096", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"2.0675252349460496", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"2.0675252349460496", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"2.6188652975983295", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"2.6188652975983295", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"3.170205360250609", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"3.170205360250609", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"3.721545422902889", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"3.721545422902889", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"4.272885485555169", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"4.272885485555169", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"4.8242255482074485", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"4.8242255482074485", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"5.375565610859729", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"5.375565610859729", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"5.9269056735120085", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"5.9269056735120085", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"6.478245736164288", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"6.478245736164288", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"7.0295857988165675", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"7.0295857988165675", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"7.580925861468848", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"7.580925861468848", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"8.132265924121128", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"8.132265924121128", ",", "1.3858153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"8.683605986773408", ",", "1.3858153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"8.683605986773408", ",", "1.3869692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"9.234946049425687", ",", "1.3869692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"9.234946049425687", ",", "1.3882615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"9.786286112077967", ",", "1.3882615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"9.786286112077967", ",", "1.3912615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"10.337626174730248", ",", "1.3912615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"10.337626174730248", ",", "1.3971692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"10.888966237382528", ",", "1.3971692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"10.888966237382528", ",", "1.464553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"11.440306300034807", ",", "1.464553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"11.440306300034807", ",", "1.5420461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"11.991646362687089", ",", "1.5420461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"11.991646362687089", ",", "2.3278615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"12.542986425339368", ",", "2.3278615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"12.542986425339368", ",", "1.7802461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"13.094326487991648", ",", "1.7802461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"13.094326487991648", ",", "2.721923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"13.645666550643927", ",", "2.721923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"13.645666550643927", ",", "2.3969538461538464"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"14.197006613296207", ",", "2.3969538461538464"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"14.197006613296207", ",", "2.5589076923076925"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"14.748346675948486", ",", "2.5589076923076925"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"14.748346675948486", ",", "3.1464461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"15.299686738600766", ",", "3.1464461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"15.299686738600766", ",", "2.7127846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"15.851026801253045", ",", "2.7127846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"15.851026801253045", ",", "2.6877692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"16.402366863905325", ",", "2.6877692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"16.402366863905325", ",", "3.2742923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"16.953706926557604", ",", "3.2742923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"16.953706926557604", ",", "5.089384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"17.505046989209884", ",", "5.089384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"17.505046989209884", ",", "33.560353846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"18.056387051862167", ",", "33.560353846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"18.056387051862167", ",", "2.044753846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"18.607727114514446", ",", "2.044753846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"18.607727114514446", ",", "2.1976615384615386"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"19.159067177166726", ",", "2.1976615384615386"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"19.159067177166726", ",", "2.0164153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"19.710407239819006", ",", "2.0164153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"19.710407239819006", ",", "1.930476923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"20.261747302471285", ",", "1.930476923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"20.261747302471285", ",", "1.977323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"20.813087365123565", ",", "1.977323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"20.813087365123565", ",", "2.0587846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"21.364427427775844", ",", "2.0587846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"21.364427427775844", ",", "2.1151846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"21.915767490428124", ",", "2.1151846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"21.915767490428124", ",", "2.133276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"22.467107553080403", ",", "2.133276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"22.467107553080403", ",", "2.2113692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"23.018447615732686", ",", "2.2113692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"23.018447615732686", ",", "2.3211692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"23.569787678384966", ",", "2.3211692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"23.569787678384966", ",", "2.4486"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"24.121127741037245", ",", "2.4486"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"24.121127741037245", ",", "2.4995076923076924"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"24.672467803689525", ",", "2.4995076923076924"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"24.672467803689525", ",", "2.562323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"25.223807866341804", ",", "2.562323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"25.223807866341804", ",", "2.610323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"25.775147928994084", ",", "2.610323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"25.775147928994084", ",", "2.641523076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"26.326487991646363", ",", "2.641523076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"26.326487991646363", ",", "2.685923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"26.877828054298643", ",", "2.685923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"26.877828054298643", ",", "2.7262615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"27.429168116950922", ",", "2.7262615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"27.429168116950922", ",", "2.7577384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"27.980508179603202", ",", "2.7577384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"27.980508179603202", ",", "2.8556307692307694"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"28.531848242255485", ",", "2.8556307692307694"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"28.531848242255485", ",", "2.938015384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"29.083188304907765", ",", "2.938015384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"29.083188304907765", ",", "3.0112615384615387"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"29.634528367560044", ",", "3.0112615384615387"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"29.634528367560044", ",", "3.0551076923076925"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"30.185868430212324", ",", "3.0551076923076925"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"30.185868430212324", ",", "3.0781846153846155"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"30.737208492864603", ",", "3.0781846153846155"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"30.737208492864603", ",", "3.2177538461538466"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"31.288548555516883", ",", "3.2177538461538466"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"31.288548555516883", ",", "3.3637384615384613"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"31.839888618169162", ",", "3.3637384615384613"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"31.839888618169162", ",", "3.4121076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"32.39122868082144", ",", "3.4121076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"32.39122868082144", ",", "3.4276153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"32.942568743473714", ",", "3.4276153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"32.942568743473714", ",", "3.9854307692307693"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"33.493908806126", ",", "3.9854307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"33.493908806126", ",", "3.528738461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"34.04524886877828", ",", "3.528738461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"34.04524886877828", ",", "3.2744307692307695"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"34.59658893143056", ",", "3.2744307692307695"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"34.59658893143056", ",", "3.2213076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"35.14792899408285", ",", "3.2213076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"35.14792899408285", ",", "3.2200615384615388"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"35.69926905673512", ",", "3.2200615384615388"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"35.69926905673512", ",", "3.190338461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"36.250609119387406", ",", "3.190338461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"36.250609119387406", ",", "3.164815384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"36.80194918203968", ",", "3.164815384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"36.80194918203968", ",", "3.1670307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"37.353289244691965", ",", "3.1670307692307693"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"37.353289244691965", ",", "3.155261538461539"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"37.90462930734424", ",", "3.155261538461539"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"37.90462930734424", ",", "3.156046153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"38.455969369996524", ",", "3.156046153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"38.455969369996524", ",", "3.1588615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"39.007309432648796", ",", "3.1588615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"39.007309432648796", ",", "3.175753846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"39.55864949530108", ",", "3.175753846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"39.55864949530108", ",", "3.210876923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"40.109989557953355", ",", "3.210876923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"40.109989557953355", ",", "3.210692307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"40.66132962060564", ",", "3.210692307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"40.66132962060564", ",", "3.2216769230769233"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"41.212669683257914", ",", "3.2216769230769233"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"41.212669683257914", ",", "3.181015384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"41.7640097459102", ",", "3.181015384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"41.7640097459102", ",", "3.1258153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"42.31534980856247", ",", "3.1258153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"42.31534980856247", ",", "2.9513076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"42.86668987121476", ",", "2.9513076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"42.86668987121476", ",", "2.7871384615384613"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"43.41802993386705", ",", "2.7871384615384613"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"43.41802993386705", ",", "2.679092307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"43.96936999651932", ",", "2.679092307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"43.96936999651932", ",", "2.6358923076923078"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"44.520710059171606", ",", "2.6358923076923078"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"44.520710059171606", ",", "2.5690153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"45.07205012182388", ",", "2.5690153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"45.07205012182388", ",", "2.5978615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"45.623390184476165", ",", "2.5978615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"45.623390184476165", ",", "2.9731384615384613"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"46.17473024712844", ",", "2.9731384615384613"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"46.17473024712844", ",", "2.482430769230769"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"46.726070309780724", ",", "2.482430769230769"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"46.726070309780724", ",", "2.452984615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"47.277410372432996", ",", "2.452984615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"47.277410372432996", ",", "2.386615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"47.82875043508528", ",", "2.386615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"47.82875043508528", ",", "2.354076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"48.380090497737555", ",", "2.354076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"48.380090497737555", ",", "2.335338461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"48.93143056038984", ",", "2.335338461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"48.93143056038984", ",", "2.301876923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"49.482770623042114", ",", "2.301876923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"49.482770623042114", ",", "2.295369230769231"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"50.0341106856944", ",", "2.295369230769231"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"50.0341106856944", ",", "2.260153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"50.58545074834667", ",", "2.260153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"50.58545074834667", ",", "2.261215384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"51.13679081099896", ",", "2.261215384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"51.13679081099896", ",", "2.250046153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"51.68813087365123", ",", "2.250046153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"51.68813087365123", ",", "2.231815384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"52.23947093630352", ",", "2.231815384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"52.23947093630352", ",", "2.2032923076923074"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"52.79081099895579", ",", "2.2032923076923074"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"52.79081099895579", ",", "2.189215384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"53.34215106160808", ",", "2.189215384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"53.34215106160808", ",", "2.160876923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"53.89349112426035", ",", "2.160876923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"53.89349112426035", ",", "2.1492"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"54.44483118691264", ",", "2.1492"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"54.44483118691264", ",", "2.133046153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"54.99617124956492", ",", "2.133046153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"54.99617124956492", ",", "2.1064153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"55.547511312217196", ",", "2.1064153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"55.547511312217196", ",", "2.691461538461539"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"56.09885137486948", ",", "2.691461538461539"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"56.09885137486948", ",", "7.749415384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"56.650191437521755", ",", "7.749415384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"56.650191437521755", ",", "2.055230769230769"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"57.20153150017404", ",", "2.055230769230769"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"57.20153150017404", ",", "2.0272615384615387"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"57.752871562826314", ",", "2.0272615384615387"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"57.752871562826314", ",", "2.0022"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"58.3042116254786", ",", "2.0022"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"58.3042116254786", ",", "1.9890461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"58.85555168813087", ",", "1.9890461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"58.85555168813087", ",", "1.9961076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"59.40689175078316", ",", "1.9961076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"59.40689175078316", ",", "1.9865076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"59.95823181343543", ",", "1.9865076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"59.95823181343543", ",", "1.9688307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"60.50957187608772", ",", "1.9688307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"60.50957187608772", ",", "1.9891846153846156"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"61.06091193873999", ",", "1.9891846153846156"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"61.06091193873999", ",", "21.28689230769231"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"61.61225200139228", ",", "21.28689230769231"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"61.61225200139228", ",", "2.368846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"62.16359206404455", ",", "2.368846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"62.16359206404455", ",", "1.8838153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"62.71493212669684", ",", "1.8838153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"62.71493212669684", ",", "1.860923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"63.26627218934911", ",", "1.860923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"63.26627218934911", ",", "1.8502615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"63.81761225200139", ",", "1.8502615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"63.81761225200139", ",", "1.8546923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"64.36895231465367", ",", "1.8546923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"64.36895231465367", ",", "1.839553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"64.92029237730594", ",", "1.839553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"64.92029237730594", ",", "1.8126461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"65.47163243995823", ",", "1.8126461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"65.47163243995823", ",", "1.8015230769230768"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"66.02297250261051", ",", "1.8015230769230768"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"66.02297250261051", ",", "1.7823692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"66.57431256526279", ",", "1.7823692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"66.57431256526279", ",", "1.7739692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"67.12565262791506", ",", "1.7739692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"67.12565262791506", ",", "1.7979692307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"67.67699269056735", ",", "1.7979692307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"67.67699269056735", ",", "1.7429076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"68.22833275321963", ",", "1.7429076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"68.22833275321963", ",", "1.7452153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"68.7796728158719", ",", "1.7452153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"68.7796728158719", ",", "1.7206153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"69.33101287852418", ",", "1.7206153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"69.33101287852418", ",", "1.7222307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"69.88235294117646", ",", "1.7222307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"69.88235294117646", ",", "1.7113384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"70.43369300382875", ",", "1.7113384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"70.43369300382875", ",", "1.696753846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"70.98503306648102", ",", "1.696753846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"70.98503306648102", ",", "1.813476923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"71.5363731291333", ",", "1.813476923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"71.5363731291333", ",", "59.2582153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"72.08771319178558", ",", "59.2582153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"72.08771319178558", ",", "2.742"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"72.63905325443787", ",", "2.742"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"72.63905325443787", ",", "1.5598153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"73.19039331709016", ",", "1.5598153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"73.19039331709016", ",", "1.5406153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"73.74173337974243", ",", "1.5406153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"73.74173337974243", ",", "1.5511846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"74.2930734423947", ",", "1.5511846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"74.2930734423947", ",", "1.6009846153846152"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"74.84441350504699", ",", "1.6009846153846152"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"74.84441350504699", ",", "1.5999692307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"75.39575356769927", ",", "1.5999692307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"75.39575356769927", ",", "1.5627692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"75.94709363035155", ",", "1.5627692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"75.94709363035155", ",", "1.5208615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"76.49843369300382", ",", "1.5208615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"76.49843369300382", ",", "1.5348"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"77.0497737556561", ",", "1.5348"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"77.0497737556561", ",", "9.977723076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"77.60111381830839", ",", "9.977723076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"77.60111381830839", ",", "1.6764923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"78.15245388096066", ",", "1.6764923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"78.15245388096066", ",", "1.4622923076923078"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"78.70379394361294", ",", "1.4622923076923078"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"78.70379394361294", ",", "1.4639076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"79.25513400626522", ",", "1.4639076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"79.25513400626522", ",", "1.4417076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"79.80647406891751", ",", "1.4417076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"79.80647406891751", ",", "1.4467384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"80.35781413156978", ",", "1.4467384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"80.35781413156978", ",", "1.4479846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"80.90915419422205", ",", "1.4479846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"80.90915419422205", ",", "1.443323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"81.46049425687434", ",", "1.443323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"81.46049425687434", ",", "1.439123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"82.01183431952663", ",", "1.439123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"82.01183431952663", ",", "1.434553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"82.5631743821789", ",", "1.434553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"82.5631743821789", ",", "1.447476923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"83.11451444483117", ",", "1.447476923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"83.11451444483117", ",", "1.4554153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"83.66585450748346", ",", "1.4554153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"83.66585450748346", ",", "1.4344615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"84.21719457013575", ",", "1.4344615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"84.21719457013575", ",", "1.434276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"84.76853463278803", ",", "1.434276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"84.76853463278803", ",", "1.434876923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"85.3198746954403", ",", "1.434876923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"85.3198746954403", ",", "1.435523076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"85.87121475809258", ",", "1.435523076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"85.87121475809258", ",", "1.437"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"86.42255482074486", ",", "1.437"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"86.42255482074486", ",", "1.437"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"86.97389488339715", ",", "1.437"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"86.97389488339715", ",", "1.4454"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"87.52523494604942", ",", "1.4454"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"87.52523494604942", ",", "1.6120153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"88.0765750087017", ",", "1.6120153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"88.0765750087017", ",", "1.4151692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"88.62791507135398", ",", "1.4151692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"88.62791507135398", ",", "1.4131384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"89.17925513400627", ",", "1.4131384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"89.17925513400627", ",", "1.412076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"89.73059519665854", ",", "1.412076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"89.73059519665854", ",", "1.4100923076923078"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"90.28193525931081", ",", "1.4100923076923078"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"90.28193525931081", ",", "1.4132307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"90.8332753219631", ",", "1.4132307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"90.8332753219631", ",", "1.4119384615384616"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"91.38461538461539", ",", "1.4119384615384616"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"91.38461538461539", ",", "1.4135538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"91.93595544726766", ",", "1.4135538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"91.93595544726766", ",", "1.4096307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"92.48729550991993", ",", "1.4096307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"92.48729550991993", ",", "1.4118461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"93.03863557257222", ",", "1.4118461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"93.03863557257222", ",", "1.4119384615384616"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"93.5899756352245", ",", "1.4119384615384616"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"93.5899756352245", ",", "1.4082923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"94.14131569787678", ",", "1.4082923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"94.14131569787678", ",", "1.4075076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"94.69265576052905", ",", "1.4075076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"94.69265576052905", ",", "1.406446153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"95.24399582318134", ",", "1.406446153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"95.24399582318134", ",", "1.4080153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"95.79533588583362", ",", "1.4080153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"95.79533588583362", ",", "1.4100461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"96.34667594848591", ",", "1.4100461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"96.34667594848591", ",", "1.4061692307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"96.89801601113818", ",", "1.4061692307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"96.89801601113818", ",", "1.4055692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"97.44935607379045", ",", "1.4055692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"97.44935607379045", ",", "1.4049692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"98.00069613644274", ",", "1.4049692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"98.00069613644274", ",", "1.4050615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"98.55203619909503", ",", "1.4050615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"98.55203619909503", ",", "1.4044615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"99.1033762617473", ",", "1.4044615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"99.1033762617473", ",", "1.4038615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"99.65471632439957", ",", "1.4038615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"99.65471632439957", ",", "1.4065846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"100.20605638705186", ",", "1.4065846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"100.20605638705186", ",", "1.404276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"100.75739644970415", ",", "1.404276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"100.75739644970415", ",", "1.404923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"101.30873651235642", ",", "1.404923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"101.30873651235642", ",", "1.4056615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"101.86007657500869", ",", "1.4056615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"101.86007657500869", ",", "1.4088"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"102.41141663766098", ",", "1.4088"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"102.41141663766098", ",", "1.4088"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"102.96275670031326", ",", "1.4088"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"102.96275670031326", ",", "1.4036307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"103.51409676296554", ",", "1.4036307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"103.51409676296554", ",", "1.4026615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"104.06543682561781", ",", "1.4026615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"104.06543682561781", ",", "1.4028923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"104.6167768882701", ",", "1.4028923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"104.6167768882701", ",", "1.4034"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"105.16811695092238", ",", "1.4034"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"105.16811695092238", ",", "1.4020153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"105.71945701357465", ",", "1.4020153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"105.71945701357465", ",", "1.4028461538461539"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"106.27079707622693", ",", "1.4028461538461539"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"106.27079707622693", ",", "1.4018307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"106.82213713887921", ",", "1.4018307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"106.82213713887921", ",", "1.4015076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"107.3734772015315", ",", "1.4015076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"107.3734772015315", ",", "1.4002153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"107.92481726418377", ",", "1.4002153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"107.92481726418377", ",", "1.4009076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"108.47615732683606", ",", "1.4009076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"108.47615732683606", ",", "1.3997076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"109.02749738948833", ",", "1.3997076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"109.02749738948833", ",", "1.3990615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"109.57883745214062", ",", "1.3990615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"109.57883745214062", ",", "1.4002153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"110.1301775147929", ",", "1.4002153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"110.1301775147929", ",", "1.402153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"110.68151757744518", ",", "1.402153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"110.68151757744518", ",", "1.398553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"111.23285764009745", ",", "1.398553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"111.23285764009745", ",", "1.397953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"111.78419770274974", ",", "1.397953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"111.78419770274974", ",", "1.3983692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"112.33553776540202", ",", "1.3983692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"112.33553776540202", ",", "1.3971692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"112.8868778280543", ",", "1.3971692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"112.8868778280543", ",", "1.3973076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"113.43821789070657", ",", "1.3973076923076924"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"113.43821789070657", ",", "1.398553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"113.98955795335885", ",", "1.398553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"113.98955795335885", ",", "1.3977692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"114.54089801601114", ",", "1.3977692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"114.54089801601114", ",", "1.3978153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"115.09223807866341", ",", "1.3978153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"115.09223807866341", ",", "1.3970307692307693"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"115.64357814131569", ",", "1.3970307692307693"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"115.64357814131569", ",", "1.3961076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"116.19491820396797", ",", "1.3961076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"116.19491820396797", ",", "1.3957846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"116.74625826662026", ",", "1.3957846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"116.74625826662026", ",", "1.394353846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"117.29759832927253", ",", "1.394353846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"117.29759832927253", ",", "1.3960615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"117.8489383919248", ",", "1.3960615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"117.8489383919248", ",", "1.3935230769230769"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"118.40027845457709", ",", "1.3935230769230769"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"118.40027845457709", ",", "1.3939384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"118.95161851722938", ",", "1.3939384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"118.95161851722938", ",", "1.3942615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"119.50295857988165", ",", "1.3942615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"119.50295857988165", ",", "1.3961076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"120.05429864253394", ",", "1.3961076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"120.05429864253394", ",", "1.3964307692307691"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"120.60563870518621", ",", "1.3964307692307691"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"120.60563870518621", ",", "1.3951846153846152"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"121.1569787678385", ",", "1.3951846153846152"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"121.1569787678385", ",", "1.3952307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"121.70831883049078", ",", "1.3952307692307693"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"121.70831883049078", ",", "1.396246153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"122.25965889314305", ",", "1.396246153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"122.25965889314305", ",", "1.3941692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"122.81099895579533", ",", "1.3941692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"122.81099895579533", ",", "1.3948615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"123.36233901844761", ",", "1.3948615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"123.36233901844761", ",", "1.397123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"123.9136790810999", ",", "1.397123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"123.9136790810999", ",", "1.394076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"124.46501914375217", ",", "1.394076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"124.46501914375217", ",", "1.394076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"125.01635920640445", ",", "1.394076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"125.01635920640445", ",", "1.3947692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"125.56769926905673", ",", "1.3947692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"125.56769926905673", ",", "1.3945846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"126.11903933170902", ",", "1.3945846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"126.11903933170902", ",", "1.3956461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"126.67037939436129", ",", "1.3956461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"126.67037939436129", ",", "1.3942153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"127.22171945701356", ",", "1.3942153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"127.22171945701356", ",", "1.3926923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"127.77305951966585", ",", "1.3926923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"127.77305951966585", ",", "1.392276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"128.32439958231814", ",", "1.392276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"128.32439958231814", ",", "1.3942153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"128.87573964497042", ",", "1.3942153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"128.87573964497042", ",", "1.3931538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"129.42707970762268", ",", "1.3931538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"129.42707970762268", ",", "1.3940307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"129.97841977027497", ",", "1.3940307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"129.97841977027497", ",", "1.3932923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"130.52975983292725", ",", "1.3932923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"130.52975983292725", ",", "1.3938923076923078"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"131.08109989557954", ",", "1.3938923076923078"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"131.08109989557954", ",", "1.3983692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"131.63243995823183", ",", "1.3983692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"131.63243995823183", ",", "1.3924615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"132.18378002088411", ",", "1.3924615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"132.18378002088411", ",", "1.391676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"132.7351200835364", ",", "1.391676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"132.7351200835364", ",", "1.3909846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"133.28646014618866", ",", "1.3909846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"133.28646014618866", ",", "1.389876923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"133.83780020884095", ",", "1.389876923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"133.83780020884095", ",", "1.3908"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"134.38914027149323", ",", "1.3908"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"134.38914027149323", ",", "1.3906615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"134.9404803341455", ",", "1.3906615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"134.9404803341455", ",", "1.390246153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"135.49182039679778", ",", "1.390246153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"135.49182039679778", ",", "1.391123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"136.04316045945006", ",", "1.391123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"136.04316045945006", ",", "1.3926923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"136.59450052210235", ",", "1.3926923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"136.59450052210235", ",", "1.4006769230769232"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"137.14584058475464", ",", "1.4006769230769232"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"137.14584058475464", ",", "1.3912153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"137.6971806474069", ",", "1.3912153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"137.6971806474069", ",", "1.391076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"138.24852071005918", ",", "1.391076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"138.24852071005918", ",", "1.390153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"138.79986077271147", ",", "1.390153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"138.79986077271147", ",", "1.390523076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"139.35120083536373", ",", "1.390523076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"139.35120083536373", ",", "1.3911692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"139.902540898016", ",", "1.3911692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"139.902540898016", ",", "1.392276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"140.4538809606683", ",", "1.392276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"140.4538809606683", ",", "1.3928769230769231"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"141.0052210233206", ",", "1.3928769230769231"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"141.0052210233206", ",", "1.3938"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"141.55656108597287", ",", "1.3938"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"141.55656108597287", ",", "1.398"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"142.10790114862513", ",", "1.398"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"142.10790114862513", ",", "1.3889538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"142.65924121127742", ",", "1.3889538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"142.65924121127742", ",", "1.3882615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"143.2105812739297", ",", "1.3882615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"143.2105812739297", ",", "1.3877076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"143.761921336582", ",", "1.3877076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"143.761921336582", ",", "1.3875692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"144.31326139923425", ",", "1.3875692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"144.31326139923425", ",", "1.3876153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"144.86460146188654", ",", "1.3876153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"144.86460146188654", ",", "1.388353846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"145.41594152453882", ",", "1.388353846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"145.41594152453882", ",", "1.3882153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"145.9672815871911", ",", "1.3882153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"145.9672815871911", ",", "1.3884461538461539"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"146.5186216498434", ",", "1.3884461538461539"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"146.5186216498434", ",", "1.3885384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"147.06996171249565", ",", "1.3885384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"147.06996171249565", ",", "1.390246153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"147.62130177514794", ",", "1.390246153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"147.62130177514794", ",", "1.3867384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"148.17264183780023", ",", "1.3867384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"148.17264183780023", ",", "1.387476923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"148.7239819004525", ",", "1.387476923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"148.7239819004525", ",", "1.387476923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"149.27532196310477", ",", "1.387476923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"149.27532196310477", ",", "1.3864615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"149.82666202575706", ",", "1.3864615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"149.82666202575706", ",", "1.386323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"150.37800208840935", ",", "1.386323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"150.37800208840935", ",", "1.3867846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"150.92934215106163", ",", "1.3867846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"150.92934215106163", ",", "1.3871076923076924"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"151.4806822137139", ",", "1.3871076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"151.4806822137139", ",", "1.3872"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"152.03202227636618", ",", "1.3872"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"152.03202227636618", ",", "1.3866923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"152.58336233901846", ",", "1.3866923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"152.58336233901846", ",", "1.3867846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"153.13470240167072", ",", "1.3867846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"153.13470240167072", ",", "1.3866923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"153.686042464323", ",", "1.3866923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"153.686042464323", ",", "1.3884461538461539"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"154.2373825269753", ",", "1.3884461538461539"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"154.2373825269753", ",", "1.386553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"154.78872258962758", ",", "1.386553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"154.78872258962758", ",", "1.386553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"155.34006265227987", ",", "1.386553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"155.34006265227987", ",", "1.3859076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"155.89140271493216", ",", "1.3859076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"155.89140271493216", ",", "1.386553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"156.4427427775844", ",", "1.386553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"156.4427427775844", ",", "1.3866923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"156.9940828402367", ",", "1.3866923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"156.9940828402367", ",", "1.386323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"157.545422902889", ",", "1.386323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"157.545422902889", ",", "1.386553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"158.09676296554125", ",", "1.386553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"158.09676296554125", ",", "1.3870153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"158.64810302819353", ",", "1.3870153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"158.64810302819353", ",", "1.3867384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"159.19944309084582", ",", "1.3867384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"159.19944309084582", ",", "1.386276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"159.7507831534981", ",", "1.386276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"159.7507831534981", ",", "1.386923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"160.3021232161504", ",", "1.386923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"160.3021232161504", ",", "1.3870153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"160.85346327880265", ",", "1.3870153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"160.85346327880265", ",", "1.3866923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"161.40480334145494", ",", "1.3866923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"161.40480334145494", ",", "1.3870615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"161.95614340410722", ",", "1.3870615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"161.95614340410722", ",", "1.3864615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"162.50748346675948", ",", "1.3864615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"162.50748346675948", ",", "1.3869692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"163.05882352941177", ",", "1.3869692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"163.05882352941177", ",", "1.3867384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"163.61016359206405", ",", "1.3867384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"163.61016359206405", ",", "1.3863692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"164.16150365471634", ",", "1.3863692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"164.16150365471634", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"164.71284371736863", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"164.71284371736863", ",", "1.386276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"165.2641837800209", ",", "1.386276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"165.2641837800209", ",", "1.386276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"165.81552384267317", ",", "1.386276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"165.81552384267317", ",", "1.3866923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"166.36686390532546", ",", "1.3866923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"166.36686390532546", ",", "1.3868769230769231"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"166.91820396797775", ",", "1.3868769230769231"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"166.91820396797775", ",", "1.3866461538461539"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"167.46954403063", ",", "1.3866461538461539"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"167.46954403063", ",", "1.3867384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"168.0208840932823", ",", "1.3867384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"168.0208840932823", ",", "1.3867846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"168.57222415593458", ",", "1.3867846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"168.57222415593458", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"169.12356421858686", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"169.12356421858686", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"169.67490428123915", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"169.67490428123915", ",", "1.3867846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"170.2262443438914", ",", "1.3867846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"170.2262443438914", ",", "1.3866"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"170.7775844065437", ",", "1.3866"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"170.7775844065437", ",", "1.3861384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"171.32892446919598", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"171.32892446919598", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"171.88026453184824", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"171.88026453184824", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"172.43160459450053", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"172.43160459450053", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"172.9829446571528", ",", "1.3862307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"172.9829446571528", ",", "1.386276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"173.5342847198051", ",", "1.386276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"173.5342847198051", ",", "1.3865076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"174.0856247824574", ",", "1.3865076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"174.0856247824574", ",", "1.3860461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"174.63696484510965", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"174.63696484510965", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"175.18830490776193", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"175.18830490776193", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"175.73964497041422", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"175.73964497041422", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"176.29098503306648", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"176.29098503306648", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"176.84232509571876", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"176.84232509571876", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"177.39366515837105", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"177.39366515837105", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"177.94500522102334", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"177.94500522102334", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"178.49634528367562", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"178.49634528367562", ",", "1.386276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"179.0476853463279", ",", "1.386276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"179.0476853463279", ",", "1.3863692307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"179.59902540898017", ",", "1.3863692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"179.59902540898017", ",", "1.3860923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"180.15036547163245", ",", "1.3860923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"180.15036547163245", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"180.70170553428474", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"180.70170553428474", ",", "1.388076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"181.253045596937", ",", "1.388076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"181.253045596937", ",", "1.3867846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"181.8043856595893", ",", "1.3867846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"181.8043856595893", ",", "1.3861846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"182.35572572224157", ",", "1.3861846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"182.35572572224157", ",", "1.386553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"182.90706578489386", ",", "1.386553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"182.90706578489386", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"183.45840584754615", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"183.45840584754615", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"184.0097459101984", ",", "1.3862307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"184.0097459101984", ",", "1.386323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"184.5610859728507", ",", "1.386323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"184.5610859728507", ",", "1.3865076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"185.11242603550298", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"185.11242603550298", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"185.66376609815524", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"185.66376609815524", ",", "1.3864153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"186.21510616080752", ",", "1.3864153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"186.21510616080752", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"186.7664462234598", ",", "1.3861384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"186.7664462234598", ",", "1.3860461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"187.3177862861121", ",", "1.3860461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"187.3177862861121", ",", "1.3861384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"187.86912634876438", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"187.86912634876438", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"188.42046641141664", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"188.42046641141664", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"188.97180647406893", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"188.97180647406893", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"189.5231465367212", ",", "1.3861384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"189.5231465367212", ",", "1.3862307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"190.0744865993735", ",", "1.3862307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"190.0744865993735", ",", "1.3862307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"190.62582666202576", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"190.62582666202576", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"191.17716672467805", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"191.17716672467805", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"191.72850678733033", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"191.72850678733033", ",", "1.3863692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"192.27984684998262", ",", "1.3863692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"192.27984684998262", ",", "1.3878923076923078"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"192.8311869126349", ",", "1.3878923076923078"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"192.8311869126349", ",", "1.3862307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"193.38252697528716", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"193.38252697528716", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"193.93386703793945", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"193.93386703793945", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"194.48520710059174", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"194.48520710059174", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"195.036547163244", ",", "1.3862307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"195.036547163244", ",", "1.3853538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"195.58788722589628", ",", "1.3853538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"195.58788722589628", ",", "1.386323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"196.13922728854857", ",", "1.386323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"196.13922728854857", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"196.69056735120085", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"196.69056735120085", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"197.24190741385314", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"197.24190741385314", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"197.7932474765054", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"197.7932474765054", ",", "1.3858615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"198.3445875391577", ",", "1.3858615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"198.3445875391577", ",", "1.3858153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"198.89592760180997", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"198.89592760180997", ",", "1.3866461538461539"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"199.44726766446223", ",", "1.3866461538461539"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"199.44726766446223", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"199.99860772711452", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"199.99860772711452", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"200.5499477897668", ",", "1.3858615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"200.5499477897668", ",", "1.3857230769230768"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"201.1012878524191", ",", "1.3857230769230768"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"201.1012878524191", ",", "1.3860461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"201.65262791507138", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"201.65262791507138", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"202.20396797772366", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"202.20396797772366", ",", "1.3864615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"202.75530804037592", ",", "1.3864615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"202.75530804037592", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"203.3066481030282", ",", "1.3862307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"203.3066481030282", ",", "1.3856307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"203.8579881656805", ",", "1.3856307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"203.8579881656805", ",", "1.3858153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"204.40932822833275", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"204.40932822833275", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"204.96066829098504", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"204.96066829098504", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"205.51200835363733", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"205.51200835363733", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"206.0633484162896", ",", "1.386"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"206.0633484162896", ",", "1.3860461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"206.6146884789419", ",", "1.3860461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"206.6146884789419", ",", "1.3854461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"207.16602854159416", ",", "1.3854461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"207.16602854159416", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"207.71736860424645", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"207.71736860424645", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"208.26870866689873", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"208.26870866689873", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"208.820048729551", ",", "1.3861384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"208.820048729551", ",", "1.3857692307692306"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"209.37138879220328", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"209.37138879220328", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"209.92272885485556", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"209.92272885485556", ",", "1.3859076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"210.47406891750785", ",", "1.3859076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"210.47406891750785", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"211.02540898016014", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"211.02540898016014", ",", "1.3870615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"211.5767490428124", ",", "1.3870615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"211.5767490428124", ",", "1.3860923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"212.12808910546468", ",", "1.3860923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"212.12808910546468", ",", "1.3857230769230768"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"212.67942916811697", ",", "1.3857230769230768"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"212.67942916811697", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"213.23076923076923", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"213.23076923076923", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"213.7821092934215", ",", "1.3857692307692306"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"213.7821092934215", ",", "1.3860923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"214.3334493560738", ",", "1.3860923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"214.3334493560738", ",", "1.3857230769230768"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"214.8847894187261", ",", "1.3857230769230768"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"214.8847894187261", ",", "1.3861384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"215.43612948137837", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"215.43612948137837", ",", "1.3859076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"215.98746954403066", ",", "1.3859076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"215.98746954403066", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"216.53880960668292", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"216.53880960668292", ",", "1.3854923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"217.0901496693352", ",", "1.3854923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"217.0901496693352", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"217.6414897319875", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"217.6414897319875", ",", "1.3873846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"218.19282979463975", ",", "1.3873846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"218.19282979463975", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"218.74416985729204", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"218.74416985729204", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"219.29550991994432", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"219.29550991994432", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"219.8468499825966", ",", "1.3860461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"219.8468499825966", ",", "1.3856307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"220.3981900452489", ",", "1.3856307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"220.3981900452489", ",", "1.3860923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"220.94953010790115", ",", "1.3860923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"220.94953010790115", ",", "1.3860923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"221.50087017055344", ",", "1.3860923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"221.50087017055344", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"222.05221023320573", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"222.05221023320573", ",", "1.3879384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"222.60355029585799", ",", "1.3879384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"222.60355029585799", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"223.15489035851027", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"223.15489035851027", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"223.70623042116256", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"223.70623042116256", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"224.25757048381485", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"224.25757048381485", ",", "1.3863692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"224.80891054646713", ",", "1.3863692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"224.80891054646713", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"225.3602506091194", ",", "1.3862307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"225.3602506091194", ",", "1.3858615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"225.91159067177168", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"225.91159067177168", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"226.46293073442396", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"226.46293073442396", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"227.01427079707625", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"227.01427079707625", ",", "1.3854461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"227.5656108597285", ",", "1.3854461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"227.5656108597285", ",", "1.3857230769230768"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"228.1169509223808", ",", "1.3857230769230768"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"228.1169509223808", ",", "1.3857230769230768"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"228.66829098503308", ",", "1.3857230769230768"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"228.66829098503308", ",", "1.386323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"229.21963104768537", ",", "1.386323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"229.21963104768537", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"229.77097111033765", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"229.77097111033765", ",", "1.3854461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"230.3223111729899", ",", "1.3854461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"230.3223111729899", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"230.8736512356422", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"230.8736512356422", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"231.4249912982945", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"231.4249912982945", ",", "1.3856307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"231.97633136094674", ",", "1.3856307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"231.97633136094674", ",", "1.3855846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"232.52767142359903", ",", "1.3855846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"232.52767142359903", ",", "1.3864153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"233.07901148625132", ",", "1.3864153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"233.07901148625132", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"233.6303515489036", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"233.6303515489036", ",", "1.3858153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"234.1816916115559", ",", "1.3858153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"234.1816916115559", ",", "1.386"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"234.73303167420815", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"234.73303167420815", ",", "1.3859076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"235.28437173686044", ",", "1.3859076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"235.28437173686044", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"235.83571179951272", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"235.83571179951272", ",", "1.3855384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"236.38705186216498", ",", "1.3855384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"236.38705186216498", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"236.93839192481727", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"236.93839192481727", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"237.48973198746955", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"237.48973198746955", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"238.04107205012184", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"238.04107205012184", ",", "1.3855384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"238.59241211277413", ",", "1.3855384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"238.59241211277413", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"239.1437521754264", ",", "1.3858153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"239.1437521754264", ",", "1.386"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"239.69509223807867", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"239.69509223807867", ",", "1.3856307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"240.24643230073096", ",", "1.3856307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"240.24643230073096", ",", "1.3860923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"240.79777236338325", ",", "1.3860923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"240.79777236338325", ",", "1.3854923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"241.3491124260355", ",", "1.3854923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"241.3491124260355", ",", "1.386"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"241.9004524886878", ",", "1.386"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"241.9004524886878", ",", "1.3854"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"242.45179255134008", ",", "1.3854"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"242.45179255134008", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"243.00313261399236", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"243.00313261399236", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"243.55447267664465", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"243.55447267664465", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"244.1058127392969", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"244.1058127392969", ",", "1.3856307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"244.6571528019492", ",", "1.3856307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"244.6571528019492", ",", "1.3861846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"245.20849286460148", ",", "1.3861846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"245.20849286460148", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"245.75983292725374", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"245.75983292725374", ",", "1.3854461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"246.31117298990603", ",", "1.3854461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"246.31117298990603", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"246.8625130525583", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"246.8625130525583", ",", "1.3855846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"247.4138531152106", ",", "1.3855846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"247.4138531152106", ",", "1.3853076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"247.9651931778629", ",", "1.3853076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"247.9651931778629", ",", "1.3858615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"248.51653324051514", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"248.51653324051514", ",", "1.3854"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"249.06787330316743", ",", "1.3854"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"249.06787330316743", ",", "1.3859076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"249.61921336581972", ",", "1.3859076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"249.61921336581972", ",", "1.3854923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"250.170553428472", ",", "1.3854923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"250.170553428472", ",", "1.3852153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"250.72189349112426", ",", "1.3852153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"250.72189349112426", ",", "1.3854"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"251.27323355377655", ",", "1.3854"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"251.27323355377655", ",", "1.3855846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"251.82457361642884", ",", "1.3855846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"251.82457361642884", ",", "1.3852615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"252.37591367908112", ",", "1.3852615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"252.37591367908112", ",", "1.386830769230769"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"252.9272537417334", ",", "1.386830769230769"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"252.9272537417334", ",", "1.3854461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"253.47859380438567", ",", "1.3854461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"253.47859380438567", ",", "1.3854923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"254.02993386703795", ",", "1.3854923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"254.02993386703795", ",", "1.3855384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"254.58127392969024", ",", "1.3855384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"254.58127392969024", ",", "1.3854"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"255.1326139923425", ",", "1.3854"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"255.1326139923425", ",", "1.3858153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"255.68395405499479", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"255.68395405499479", ",", "1.3852615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"256.2352941176471", ",", "1.3852615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"256.2352941176471", ",", "1.3873846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"256.7866341802993", ",", "1.3873846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"256.7866341802993", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"257.33797424295165", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"257.33797424295165", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"257.8893143056039", ",", "1.3857692307692306"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"257.8893143056039", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"258.44065436825616", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"258.44065436825616", ",", "1.3853538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"258.99199443090845", ",", "1.3853538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"258.99199443090845", ",", "1.3851692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"259.5433344935607", ",", "1.3851692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"259.5433344935607", ",", "1.3853076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"260.094674556213", ",", "1.3853076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"260.094674556213", ",", "1.3854923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"260.64601461886525", ",", "1.3854923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"260.64601461886525", ",", "1.3852615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"261.1973546815176", ",", "1.3852615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"261.1973546815176", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"261.7486947441698", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"261.7486947441698", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"262.30003480682217", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"262.30003480682217", ",", "1.3851692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"262.8513748694744", ",", "1.3851692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"262.8513748694744", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"263.4027149321267", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"263.4027149321267", ",", "1.3852153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"263.95405499477897", ",", "1.3852153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"263.95405499477897", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"264.5053950574312", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"264.5053950574312", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"265.05673512008354", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"265.05673512008354", ",", "1.3853538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"265.6080751827358", ",", "1.3853538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"265.6080751827358", ",", "1.3854"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"266.1594152453881", ",", "1.3854"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"266.1594152453881", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"266.71075530804035", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"266.71075530804035", ",", "1.3853538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"267.2620953706927", ",", "1.3853538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"267.2620953706927", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"267.8134354333449", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"267.8134354333449", ",", "1.3852615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"268.36477549599715", ",", "1.3852615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"268.36477549599715", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"268.9161155586495", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"268.9161155586495", ",", "1.3852615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"269.4674556213017", ",", "1.3852615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"269.4674556213017", ",", "1.3856307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"270.01879568395407", ",", "1.3856307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"270.01879568395407", ",", "1.3854461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"270.5701357466063", ",", "1.3854461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"270.5701357466063", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"271.12147580925864", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"271.12147580925864", ",", "1.3856307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"271.67281587191087", ",", "1.3856307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"271.67281587191087", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"272.2241559345632", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"272.2241559345632", ",", "1.3855846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"272.77549599721544", ",", "1.3855846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"272.77549599721544", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"273.3268360598677", ",", "1.3858615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"273.3268360598677", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"273.87817612252", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"273.87817612252", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"274.42951618517225", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"274.42951618517225", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"274.9808562478246", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"274.9808562478246", ",", "1.3852153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"275.5321963104768", ",", "1.3852153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"275.5321963104768", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"276.08353637312916", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"276.08353637312916", ",", "1.3852615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"276.6348764357814", ",", "1.3852615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"276.6348764357814", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"277.1862164984337", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"277.1862164984337", ",", "1.3854"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"277.73755656108597", ",", "1.3854"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"277.73755656108597", ",", "1.3852615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"278.2888966237382", ",", "1.3852615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"278.2888966237382", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"278.84023668639054", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"278.84023668639054", ",", "1.3855846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"279.39157674904277", ",", "1.3855846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"279.39157674904277", ",", "1.3852153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"279.9429168116951", ",", "1.3852153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"279.9429168116951", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"280.49425687434734", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"280.49425687434734", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"281.0455969369997", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"281.0455969369997", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"281.5969369996519", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"281.5969369996519", ",", "1.3852615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"282.14827706230415", ",", "1.3852615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"282.14827706230415", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"282.6996171249565", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"282.6996171249565", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"283.2509571876087", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"283.2509571876087", ",", "1.3853538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"283.80229725026106", ",", "1.3853538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"283.80229725026106", ",", "1.3852153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"284.3536373129133", ",", "1.3852153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"284.3536373129133", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"284.90497737556564", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"284.90497737556564", ",", "1.3852615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"285.45631743821787", ",", "1.3852615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"285.45631743821787", ",", "1.3850307692307693"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"286.0076575008702", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"286.0076575008702", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"286.55899756352244", ",", "1.3850307692307693"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"286.55899756352244", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"287.11033762617467", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"287.11033762617467", ",", "1.3853076923076924"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"287.661677688827", ",", "1.3853076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"287.661677688827", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"288.21301775147924", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"288.21301775147924", ",", "1.3854"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"288.7643578141316", ",", "1.3854"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"288.7643578141316", ",", "1.3898307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"289.3156978767838", ",", "1.3898307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"289.3156978767838", ",", "1.4072307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"289.86703793943616", ",", "1.4072307692307693"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"289.86703793943616", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"290.4183780020884", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"290.4183780020884", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"290.9697180647407", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"290.9697180647407", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"291.52105812739296", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"291.52105812739296", ",", "1.3852153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"292.0723981900452", ",", "1.3852153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"292.0723981900452", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"292.62373825269754", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"292.62373825269754", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"293.17507831534977", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"293.17507831534977", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"293.7264183780021", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"293.7264183780021", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"294.27775844065434", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"294.27775844065434", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"294.8290985033067", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"294.8290985033067", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"295.3804385659589", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"295.3804385659589", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"295.93177862861114", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"295.93177862861114", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"296.4831186912635", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"296.4831186912635", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"297.0344587539157", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"297.0344587539157", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"297.58579881656806", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"297.58579881656806", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"298.1371388792203", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"298.1371388792203", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"298.68847894187263", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"298.68847894187263", ",", "1.3854461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"299.23981900452486", ",", "1.3854461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"299.23981900452486", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"299.7911590671772", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"299.7911590671772", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"300.34249912982943", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"300.34249912982943", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"300.89383919248166", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"300.89383919248166", ",", "1.3853076923076924"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"301.445179255134", ",", "1.3853076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"301.445179255134", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"301.99651931778624", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"301.99651931778624", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"302.5478593804386", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"302.5478593804386", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"303.0991994430908", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"303.0991994430908", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"303.65053950574315", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"303.65053950574315", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"304.2018795683954", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"304.2018795683954", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"304.75321963104767", ",", "1.3850307692307693"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"304.75321963104767", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"305.30455969369996", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"305.30455969369996", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"305.8558997563522", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"305.8558997563522", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"306.40723981900453", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"306.40723981900453", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"306.95857988165676", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"306.95857988165676", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"307.5099199443091", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"307.5099199443091", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"308.06126000696133", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"308.06126000696133", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"308.6126000696137", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"308.6126000696137", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"309.1639401322659", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"309.1639401322659", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"309.7152801949182", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"309.7152801949182", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"310.2666202575705", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"310.2666202575705", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"310.8179603202227", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"310.8179603202227", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"311.36930038287505", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"311.36930038287505", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"311.9206404455273", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"311.9206404455273", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"312.4719805081796", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"312.4719805081796", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"313.02332057083186", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"313.02332057083186", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"313.5746606334842", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"313.5746606334842", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"314.12600069613643", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"314.12600069613643", ",", "1.3853076923076924"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"314.67734075878866", ",", "1.3853076923076924"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"314.67734075878866", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"315.228680821441", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"315.228680821441", ",", "1.3852153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"315.78002088409323", ",", "1.3852153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"315.78002088409323", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"316.3313609467456", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"316.3313609467456", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"316.8827010093978", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"316.8827010093978", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"317.43404107205015", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"317.43404107205015", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"317.9853811347024", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"317.9853811347024", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"318.53672119735467", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"318.53672119735467", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"319.08806126000695", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"319.08806126000695", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"319.6394013226592", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"319.6394013226592", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"320.1907413853115", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"320.1907413853115", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"320.74208144796376", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"320.74208144796376", ",", "1.3851692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"321.2934215106161", ",", "1.3851692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"321.2934215106161", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"321.84476157326833", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"321.84476157326833", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"322.3961016359207", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"322.3961016359207", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"322.9474416985729", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"322.9474416985729", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"323.4987817612252", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"323.4987817612252", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"324.0501218238775", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"324.0501218238775", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"324.6014618865297", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"324.6014618865297", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"325.15280194918205", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"325.15280194918205", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"325.7041420118343", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"325.7041420118343", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"326.2554820744866", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"326.2554820744866", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"326.80682213713885", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"326.80682213713885", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"327.3581621997912", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"327.3581621997912", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"327.9095022624434", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"327.9095022624434", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"328.46084232509565", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"328.46084232509565", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"329.012182387748", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"329.012182387748", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"329.5635224504002", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"329.5635224504002", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"330.11486251305257", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"330.11486251305257", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"330.6662025757048", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"330.6662025757048", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"331.21754263835714", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"331.21754263835714", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"331.7688827010094", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"331.7688827010094", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"332.3202227636617", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"332.3202227636617", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"332.87156282631395", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"332.87156282631395", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"333.4229028889662", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"333.4229028889662", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"333.9742429516185", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"333.9742429516185", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"334.52558301427075", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"334.52558301427075", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"335.0769230769231", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"335.0769230769231", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"335.6282631395753", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"335.6282631395753", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"336.17960320222767", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"336.17960320222767", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"336.7309432648799", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"336.7309432648799", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"337.2822833275322", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"337.2822833275322", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"337.83362339018447", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"337.83362339018447", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"338.3849634528367", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"338.3849634528367", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"338.93630351548904", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"338.93630351548904", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"339.4876435781413", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"339.4876435781413", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"340.0389836407936", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"340.0389836407936", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"340.59032370344585", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"340.59032370344585", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"341.1416637660982", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"341.1416637660982", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"341.6930038287504", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"341.6930038287504", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"342.24434389140265", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"342.24434389140265", ",", "1.3855384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"342.795683954055", ",", "1.3855384615384616"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"342.795683954055", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"343.3470240167072", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"343.3470240167072", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"343.89836407935957", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"343.89836407935957", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"344.4497041420118", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"344.4497041420118", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"345.00104420466414", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"345.00104420466414", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"345.55238426731637", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"345.55238426731637", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"346.1037243299687", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"346.1037243299687", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"346.65506439262094", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"346.65506439262094", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"347.2064044552732", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"347.2064044552732", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"347.7577445179255", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"347.7577445179255", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"348.30908458057775", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"348.30908458057775", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"348.8604246432301", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"348.8604246432301", ",", "1.3870615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"349.4117647058823", ",", "1.3870615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"349.4117647058823", ",", "1.3852153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"349.96310476853466", ",", "1.3852153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"349.96310476853466", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"350.5144448311869", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"350.5144448311869", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"351.0657848938392", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"351.0657848938392", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"351.61712495649147", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"351.61712495649147", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"352.1684650191437", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"352.1684650191437", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"352.71980508179604", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"352.71980508179604", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"353.27114514444827", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"353.27114514444827", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"353.8224852071006", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"353.8224852071006", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"354.37382526975284", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"354.37382526975284", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"354.9251653324052", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"354.9251653324052", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"355.4765053950574", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"355.4765053950574", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"356.0278454577097", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"356.0278454577097", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"356.579185520362", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"356.579185520362", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"357.1305255830142", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"357.1305255830142", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"357.68186564566656", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"357.68186564566656", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"358.2332057083188", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"358.2332057083188", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"358.78454577097114", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"358.78454577097114", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"359.33588583362337", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"359.33588583362337", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"359.8872258962757", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"359.8872258962757", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"360.43856595892794", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"360.43856595892794", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"360.98990602158017", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"360.98990602158017", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"361.5412460842325", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"361.5412460842325", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"362.09258614688474", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"362.09258614688474", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"362.6439262095371", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"362.6439262095371", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"363.1952662721893", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"363.1952662721893", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"363.74660633484166", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"363.74660633484166", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"364.2979463974939", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"364.2979463974939", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"364.8492864601462", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"364.8492864601462", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"365.40062652279846", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"365.40062652279846", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"365.9519665854507", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"365.9519665854507", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"366.50330664810303", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"366.50330664810303", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"367.05464671075526", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"367.05464671075526", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"367.6059867734076", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"367.6059867734076", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"368.15732683605984", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"368.15732683605984", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"368.7086668987122", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"368.7086668987122", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"369.2600069613644", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"369.2600069613644", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"369.8113470240167", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"369.8113470240167", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"370.362687086669", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"370.362687086669", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"370.9140271493212", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"370.9140271493212", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"371.46536721197356", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"371.46536721197356", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"372.0167072746258", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"372.0167072746258", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"372.56804733727813", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"372.56804733727813", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"373.11938739993036", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"373.11938739993036", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"373.6707274625827", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"373.6707274625827", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"374.22206752523493", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"374.22206752523493", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"374.77340758788716", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"374.77340758788716", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"375.3247476505395", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"375.3247476505395", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"375.87608771319174", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"375.87608771319174", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"376.4274277758441", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"376.4274277758441", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"376.9787678384963", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"376.9787678384963", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"377.53010790114865", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"377.53010790114865", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"378.0814479638009", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"378.0814479638009", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"378.6327880264532", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"378.6327880264532", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"379.18412808910546", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"379.18412808910546", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"379.7354681517577", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"379.7354681517577", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"380.28680821441003", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"380.28680821441003", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"380.83814827706226", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"380.83814827706226", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"381.3894883397146", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"381.3894883397146", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"381.94082840236683", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"381.94082840236683", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"382.4921684650192", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"382.4921684650192", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"383.0435085276714", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"383.0435085276714", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"383.5948485903237", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"383.5948485903237", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"384.146188652976", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"384.146188652976", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"384.6975287156282", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"384.6975287156282", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"385.24886877828055", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"385.24886877828055", ",", "1.3850307692307693"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"385.8002088409328", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"385.8002088409328", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"386.3515489035851", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"386.3515489035851", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"386.90288896623736", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"386.90288896623736", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"387.4542290288897", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"387.4542290288897", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"388.00556909154193", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"388.00556909154193", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"388.55690915419416", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"388.55690915419416", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"389.1082492168465", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"389.1082492168465", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"389.65958927949873", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"389.65958927949873", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"390.2109293421511", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"390.2109293421511", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"390.7622694048033", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"390.7622694048033", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"391.31360946745565", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"391.31360946745565", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"391.8649495301079", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"391.8649495301079", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"392.4162895927602", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"392.4162895927602", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"392.96762965541245", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"392.96762965541245", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"393.5189697180647", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"393.5189697180647", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"394.070309780717", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"394.070309780717", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"394.62164984336925", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"394.62164984336925", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"395.1729899060216", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"395.1729899060216", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"395.7243299686738", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"395.7243299686738", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"396.2756700313262", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"396.2756700313262", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"396.8270100939784", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"396.8270100939784", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"397.3783501566307", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"397.3783501566307", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"397.929690219283", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"397.929690219283", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"398.4810302819352", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"398.4810302819352", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"399.03237034458755", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"399.03237034458755", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"399.5837104072398", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"399.5837104072398", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"400.1350504698921", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"400.1350504698921", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"400.68639053254435", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"400.68639053254435", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"401.2377305951967", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"401.2377305951967", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"401.7890706578489", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"401.7890706578489", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"402.3404107205012", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"402.3404107205012", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"402.8917507831535", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"402.8917507831535", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"403.4430908458057", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"403.4430908458057", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"403.99443090845807", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"403.99443090845807", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"404.5457709711103", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"404.5457709711103", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"405.09711103376264", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"405.09711103376264", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"405.6484510964149", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"405.6484510964149", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"406.1997911590672", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"406.1997911590672", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"406.75113122171945", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"406.75113122171945", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"407.3024712843717", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"407.3024712843717", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"407.853811347024", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"407.853811347024", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"408.40515140967625", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"408.40515140967625", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"408.9564914723286", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"408.9564914723286", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"409.5078315349808", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"409.5078315349808", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"410.05917159763317", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"410.05917159763317", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"410.6105116602854", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"410.6105116602854", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"411.1618517229377", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"411.1618517229377", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"411.71319178558997", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"411.71319178558997", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"412.2645318482422", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"412.2645318482422", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"412.81587191089454", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"412.81587191089454", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"413.3672119735468", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"413.3672119735468", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"413.9185520361991", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"413.9185520361991", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"414.46989209885135", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"414.46989209885135", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"415.0212321615037", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"415.0212321615037", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"415.5725722241559", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"415.5725722241559", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"416.1239122868082", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"416.1239122868082", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"416.6752523494605", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"416.6752523494605", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"417.2265924121127", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"417.2265924121127", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"417.77793247476507", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"417.77793247476507", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"418.3292725374173", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"418.3292725374173", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"418.88061260006964", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"418.88061260006964", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"419.43195266272187", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"419.43195266272187", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"419.9832927253742", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"419.9832927253742", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"420.53463278802644", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"420.53463278802644", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"421.0859728506787", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"421.0859728506787", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"421.637312913331", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"421.637312913331", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"422.18865297598325", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"422.18865297598325", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"422.7399930386356", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"422.7399930386356", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"423.2913331012878", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"423.2913331012878", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"423.84267316394016", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"423.84267316394016", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"424.3940132265924", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"424.3940132265924", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"424.9453532892447", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"424.9453532892447", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"425.49669335189697", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"425.49669335189697", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"426.0480334145492", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"426.0480334145492", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"426.59937347720154", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"426.59937347720154", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"427.15071353985377", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"427.15071353985377", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"427.7020536025061", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"427.7020536025061", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"428.25339366515834", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"428.25339366515834", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"428.8047337278107", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"428.8047337278107", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"429.3560737904629", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"429.3560737904629", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"429.9074138531152", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"429.9074138531152", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"430.4587539157675", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"430.4587539157675", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"431.0100939784197", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"431.0100939784197", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"431.56143404107206", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"431.56143404107206", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"432.1127741037243", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"432.1127741037243", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"432.66411416637663", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"432.66411416637663", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"433.21545422902886", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"433.21545422902886", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"433.7667942916812", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"433.7667942916812", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"434.31813435433344", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"434.31813435433344", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"434.86947441698567", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"434.86947441698567", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"435.420814479638", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"435.420814479638", ",", "1.3855384615384616"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"435.97215454229024", ",", "1.3855384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"435.97215454229024", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"436.5234946049426", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"436.5234946049426", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"437.0748346675948", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"437.0748346675948", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"437.62617473024716", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"437.62617473024716", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"438.1775147928994", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"438.1775147928994", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"438.72885485555173", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"438.72885485555173", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"439.28019491820396", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"439.28019491820396", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"439.8315349808562", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"439.8315349808562", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"440.38287504350853", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"440.38287504350853", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"440.93421510616076", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"440.93421510616076", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"441.4855551688131", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"441.4855551688131", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"442.03689523146534", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"442.03689523146534", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"442.5882352941177", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"442.5882352941177", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"443.1395753567699", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"443.1395753567699", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"443.6909154194222", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"443.6909154194222", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"444.2422554820745", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"444.2422554820745", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"444.7935955447267", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"444.7935955447267", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"445.34493560737906", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"445.34493560737906", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"445.8962756700313", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"445.8962756700313", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"446.44761573268363", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"446.44761573268363", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"446.99895579533586", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"446.99895579533586", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"447.5502958579882", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"447.5502958579882", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"448.10163592064043", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"448.10163592064043", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"448.65297598329266", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"448.65297598329266", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"449.204316045945", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"449.204316045945", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"449.75565610859724", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"449.75565610859724", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"450.3069961712496", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"450.3069961712496", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"450.8583362339018", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"450.8583362339018", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"451.40967629655415", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"451.40967629655415", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"451.9610163592064", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"451.9610163592064", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"452.5123564218587", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"452.5123564218587", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"453.06369648451096", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"453.06369648451096", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"453.6150365471632", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"453.6150365471632", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"454.16637660981553", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"454.16637660981553", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"454.71771667246776", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"454.71771667246776", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"455.2690567351201", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"455.2690567351201", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"455.82039679777233", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"455.82039679777233", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"456.3717368604247", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"456.3717368604247", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"456.9230769230769", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"456.9230769230769", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"457.4744169857292", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"457.4744169857292", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"458.0257570483815", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"458.0257570483815", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"458.5770971110337", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"458.5770971110337", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"459.12843717368605", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"459.12843717368605", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"459.6797772363383", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"459.6797772363383", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"460.2311172989906", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"460.2311172989906", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"460.78245736164286", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"460.78245736164286", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"461.3337974242952", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"461.3337974242952", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"461.88513748694743", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"461.88513748694743", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"462.4364775495997", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"462.4364775495997", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"462.987817612252", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"462.987817612252", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"463.53915767490423", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"463.53915767490423", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"464.0904977375566", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"464.0904977375566", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"464.6418378002088", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"464.6418378002088", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"465.19317786286115", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"465.19317786286115", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"465.7445179255134", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"465.7445179255134", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"466.2958579881657", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"466.2958579881657", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"466.84719805081795", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"466.84719805081795", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"467.3985381134702", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"467.3985381134702", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"467.9498781761225", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"467.9498781761225", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"468.50121823877475", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"468.50121823877475", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"469.0525583014271", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"469.0525583014271", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"469.6038983640793", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"469.6038983640793", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"470.15523842673167", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"470.15523842673167", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"470.7065784893839", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"470.7065784893839", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"471.2579185520362", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"471.2579185520362", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"471.8092586146885", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"471.8092586146885", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"472.3605986773407", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"472.3605986773407", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"472.91193873999305", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"472.91193873999305", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"473.4632788026453", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"473.4632788026453", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"474.0146188652976", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"474.0146188652976", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"474.56595892794985", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"474.56595892794985", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"475.1172989906022", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"475.1172989906022", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"475.6686390532544", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"475.6686390532544", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"476.2199791159067", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"476.2199791159067", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"476.771319178559", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"476.771319178559", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"477.3226592412112", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"477.3226592412112", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"477.87399930386357", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"477.87399930386357", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"478.4253393665158", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"478.4253393665158", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"478.97667942916814", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"478.97667942916814", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"479.5280194918204", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"479.5280194918204", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"480.0793595544727", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"480.0793595544727", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"480.63069961712495", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"480.63069961712495", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"481.1820396797772", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"481.1820396797772", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"481.7333797424295", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"481.7333797424295", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"482.28471980508175", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"482.28471980508175", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"482.8360598677341", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"482.8360598677341", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"483.3873999303863", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"483.3873999303863", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"483.93873999303867", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"483.93873999303867", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"484.4900800556909", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"484.4900800556909", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"485.04142011834324", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"485.04142011834324", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"485.59276018099547", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"485.59276018099547", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"486.1441002436477", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"486.1441002436477", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"486.69544030630004", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"486.69544030630004", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"487.2467803689523", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"487.2467803689523", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"487.7981204316046", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"487.7981204316046", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"488.34946049425685", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"488.34946049425685", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"488.9008005569092", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"488.9008005569092", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"489.4521406195614", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"489.4521406195614", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"490.0034806822137", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"490.0034806822137", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"490.554820744866", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"490.554820744866", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"491.1061608075182", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"491.1061608075182", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"491.65750087017057", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"491.65750087017057", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"492.2088409328228", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"492.2088409328228", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"492.76018099547514", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"492.76018099547514", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"493.31152105812737", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"493.31152105812737", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"493.8628611207797", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"493.8628611207797", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"494.41420118343194", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"494.41420118343194", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"494.9655412460842", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"494.9655412460842", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"495.5168813087365", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"495.5168813087365", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"496.06822137138874", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"496.06822137138874", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"496.6195614340411", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"496.6195614340411", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"497.1709014966933", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"497.1709014966933", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"497.72224155934566", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"497.72224155934566", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"498.2735816219979", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"498.2735816219979", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"498.82492168465023", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"498.82492168465023", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"499.37626174730246", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"499.37626174730246", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"499.9276018099547", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"499.9276018099547", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"500.47894187260704", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"500.47894187260704", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"501.03028193525927", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"501.03028193525927", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"501.5816219979116", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"501.5816219979116", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"502.13296206056384", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"502.13296206056384", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"502.6843021232162", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"502.6843021232162", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"503.2356421858684", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"503.2356421858684", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"503.7869822485207", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"503.7869822485207", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"504.338322311173", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"504.338322311173", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"504.8896623738252", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"504.8896623738252", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"505.44100243647756", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"505.44100243647756", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"505.9923424991298", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"505.9923424991298", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"506.54368256178213", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"506.54368256178213", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"507.09502262443436", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"507.09502262443436", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"507.6463626870867", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"507.6463626870867", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"508.19770274973894", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"508.19770274973894", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"508.7490428123912", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"508.7490428123912", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"509.3003828750435", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"509.3003828750435", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"509.85172293769574", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"509.85172293769574", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"510.4030630003481", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"510.4030630003481", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"510.9544030630003", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"510.9544030630003", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"511.50574312565266", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"511.50574312565266", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"512.0570831883049", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"512.0570831883049", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"512.6084232509572", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"512.6084232509572", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"513.1597633136096", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"513.1597633136096", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"513.7111033762617", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"513.7111033762617", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"514.262443438914", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"514.262443438914", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"514.8137835015664", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"514.8137835015664", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"515.3651235642185", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"515.3651235642185", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"515.9164636268708", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"515.9164636268708", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"516.4678036895232", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"516.4678036895232", ",", "1.3873846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"517.0191437521754", ",", "1.3873846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"517.0191437521754", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"517.5704838148276", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"517.5704838148276", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"518.12182387748", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"518.12182387748", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"518.6731639401323", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"518.6731639401323", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"519.2245040027846", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"519.2245040027846", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"519.7758440654368", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"519.7758440654368", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"520.3271841280891", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"520.3271841280891", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"520.8785241907414", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"520.8785241907414", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"521.4298642533936", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"521.4298642533936", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"521.9812043160459", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"521.9812043160459", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"522.5325443786983", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"522.5325443786983", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"523.0838844413505", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"523.0838844413505", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"523.6352245040027", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"523.6352245040027", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"524.1865645666551", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"524.1865645666551", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"524.7379046293074", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"524.7379046293074", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"525.2892446919595", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"525.2892446919595", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"525.8405847546119", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"525.8405847546119", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"526.3919248172642", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"526.3919248172642", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"526.9432648799165", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"526.9432648799165", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"527.4946049425687", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"527.4946049425687", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"528.045945005221", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"528.045945005221", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"528.5972850678734", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"528.5972850678734", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"529.1486251305255", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"529.1486251305255", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"529.6999651931778", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"529.6999651931778", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"530.2513052558302", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"530.2513052558302", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"530.8026453184824", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"530.8026453184824", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"531.3539853811346", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"531.3539853811346", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"531.905325443787", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"531.905325443787", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"532.4566655064393", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"532.4566655064393", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"533.0080055690916", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"533.0080055690916", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"533.5593456317438", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"533.5593456317438", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"534.1106856943961", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"534.1106856943961", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"534.6620257570484", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"534.6620257570484", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"535.2133658197006", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"535.2133658197006", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"535.7647058823529", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"535.7647058823529", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"536.3160459450053", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"536.3160459450053", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"536.8673860076575", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"536.8673860076575", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"537.4187260703097", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"537.4187260703097", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"537.9700661329621", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"537.9700661329621", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"538.5214061956144", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"538.5214061956144", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"539.0727462582665", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"539.0727462582665", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"539.6240863209189", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"539.6240863209189", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"540.1754263835712", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"540.1754263835712", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"540.7267664462235", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"540.7267664462235", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"541.2781065088757", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"541.2781065088757", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"541.829446571528", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"541.829446571528", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"542.3807866341804", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"542.3807866341804", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"542.9321266968326", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"542.9321266968326", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"543.4834667594848", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"543.4834667594848", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"544.0348068221372", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"544.0348068221372", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"544.5861468847894", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"544.5861468847894", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"545.1374869474416", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"545.1374869474416", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"545.688827010094", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"545.688827010094", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"546.2401670727463", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"546.2401670727463", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"546.7915071353985", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"546.7915071353985", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"547.3428471980508", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"547.3428471980508", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"547.8941872607031", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"547.8941872607031", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"548.4455273233553", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"548.4455273233553", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"548.9968673860076", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"548.9968673860076", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"549.5482074486599", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"549.5482074486599", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"550.0995475113123", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"550.0995475113123", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"550.6508875739645", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"550.6508875739645", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"551.2022276366167", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"551.2022276366167", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"551.7535676992691", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"551.7535676992691", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"552.3049077619214", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"552.3049077619214", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"552.8562478245735", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"552.8562478245735", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"553.4075878872259", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"553.4075878872259", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"553.9589279498782", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"553.9589279498782", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"554.5102680125304", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"554.5102680125304", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"555.0616080751827", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"555.0616080751827", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"555.612948137835", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"555.612948137835", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"556.1642882004874", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"556.1642882004874", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"556.7156282631396", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"556.7156282631396", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"557.2669683257918", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"557.2669683257918", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"557.8183083884442", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"557.8183083884442", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"558.3696484510964", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"558.3696484510964", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"558.9209885137486", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"558.9209885137486", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"559.472328576401", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"559.472328576401", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"560.0236686390533", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"560.0236686390533", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"560.5750087017055", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"560.5750087017055", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"561.1263487643578", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"561.1263487643578", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"561.6776888270101", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"561.6776888270101", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"562.2290288896623", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"562.2290288896623", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"562.7803689523146", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"562.7803689523146", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"563.3317090149669", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"563.3317090149669", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"563.8830490776193", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"563.8830490776193", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"564.4343891402715", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"564.4343891402715", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"564.9857292029237", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"564.9857292029237", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"565.5370692655761", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"565.5370692655761", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"565.8127392969022", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"565.8127392969022", ",", "1.3846153846153846"}], 
                    "}"}]}], "}"}], "]"}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"RGBColor", "[", 
                    RowBox[{"1", ",", "0", ",", "0"}], "]"}], ",", 
                    RowBox[{"AbsoluteThickness", "[", "1", "]"}], ",", 
                    RowBox[{"AbsoluteDashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                    RowBox[{"CapForm", "[", "None", "]"}], ",", 
                    RowBox[{"JoinForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<Miter\>\"", ",", "3.25"}], "}"}], "]"}], ",", 
                    RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"1.7918552036199096", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"2.0675252349460496", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"2.0675252349460496", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"2.6188652975983295", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"2.6188652975983295", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"3.170205360250609", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"3.170205360250609", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"3.721545422902889", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"3.721545422902889", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"4.272885485555169", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"4.272885485555169", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"4.8242255482074485", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"4.8242255482074485", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"5.375565610859729", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"5.375565610859729", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"5.9269056735120085", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"5.9269056735120085", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"6.478245736164288", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"6.478245736164288", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"7.0295857988165675", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"7.0295857988165675", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"7.580925861468848", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"7.580925861468848", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"8.132265924121128", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"8.132265924121128", ",", "1.3858153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"8.683605986773408", ",", "1.3858153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"8.683605986773408", ",", "1.3869692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"9.234946049425687", ",", "1.3869692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"9.234946049425687", ",", "1.3882615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"9.786286112077967", ",", "1.3882615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"9.786286112077967", ",", "1.3912615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"10.337626174730248", ",", "1.3912615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"10.337626174730248", ",", "1.3971692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"10.888966237382528", ",", "1.3971692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"10.888966237382528", ",", "1.464553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"11.440306300034807", ",", "1.464553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"11.440306300034807", ",", "1.5420461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"11.991646362687089", ",", "1.5420461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"11.991646362687089", ",", "2.3278615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"12.542986425339368", ",", "2.3278615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"12.542986425339368", ",", "1.7802461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"13.094326487991648", ",", "1.7802461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"13.094326487991648", ",", "2.721923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"13.645666550643927", ",", "2.721923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"13.645666550643927", ",", "2.3969538461538464"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"14.197006613296207", ",", "2.3969538461538464"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"14.197006613296207", ",", "2.5589076923076925"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"14.748346675948486", ",", "2.5589076923076925"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"14.748346675948486", ",", "3.1464461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"15.299686738600766", ",", "3.1464461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"15.299686738600766", ",", "2.7127846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"15.851026801253045", ",", "2.7127846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"15.851026801253045", ",", "2.6877692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"16.402366863905325", ",", "2.6877692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"16.402366863905325", ",", "3.2742923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"16.953706926557604", ",", "3.2742923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"16.953706926557604", ",", "5.089384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"17.505046989209884", ",", "5.089384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"17.505046989209884", ",", "33.560353846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"18.056387051862167", ",", "33.560353846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"18.056387051862167", ",", "2.044753846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"18.607727114514446", ",", "2.044753846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"18.607727114514446", ",", "2.1976615384615386"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"19.159067177166726", ",", "2.1976615384615386"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"19.159067177166726", ",", "2.0164153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"19.710407239819006", ",", "2.0164153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"19.710407239819006", ",", "1.930476923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"20.261747302471285", ",", "1.930476923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"20.261747302471285", ",", "1.977323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"20.813087365123565", ",", "1.977323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"20.813087365123565", ",", "2.0587846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"21.364427427775844", ",", "2.0587846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"21.364427427775844", ",", "2.1151846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"21.915767490428124", ",", "2.1151846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"21.915767490428124", ",", "2.133276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"22.467107553080403", ",", "2.133276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"22.467107553080403", ",", "2.2113692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"23.018447615732686", ",", "2.2113692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"23.018447615732686", ",", "2.3211692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"23.569787678384966", ",", "2.3211692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"23.569787678384966", ",", "2.4486"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"24.121127741037245", ",", "2.4486"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"24.121127741037245", ",", "2.4995076923076924"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"24.672467803689525", ",", "2.4995076923076924"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"24.672467803689525", ",", "2.562323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"25.223807866341804", ",", "2.562323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"25.223807866341804", ",", "2.610323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"25.775147928994084", ",", "2.610323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"25.775147928994084", ",", "2.641523076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"26.326487991646363", ",", "2.641523076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"26.326487991646363", ",", "2.685923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"26.877828054298643", ",", "2.685923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"26.877828054298643", ",", "2.7262615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"27.429168116950922", ",", "2.7262615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"27.429168116950922", ",", "2.7577384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"27.980508179603202", ",", "2.7577384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"27.980508179603202", ",", "2.8556307692307694"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"28.531848242255485", ",", "2.8556307692307694"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"28.531848242255485", ",", "2.938015384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"29.083188304907765", ",", "2.938015384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"29.083188304907765", ",", "3.0112615384615387"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"29.634528367560044", ",", "3.0112615384615387"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"29.634528367560044", ",", "3.0551076923076925"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"30.185868430212324", ",", "3.0551076923076925"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"30.185868430212324", ",", "3.0781846153846155"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"30.737208492864603", ",", "3.0781846153846155"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"30.737208492864603", ",", "3.2177538461538466"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"31.288548555516883", ",", "3.2177538461538466"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"31.288548555516883", ",", "3.3637384615384613"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"31.839888618169162", ",", "3.3637384615384613"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"31.839888618169162", ",", "3.4121076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"32.39122868082144", ",", "3.4121076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"32.39122868082144", ",", "3.4276153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"32.942568743473714", ",", "3.4276153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"32.942568743473714", ",", "3.9854307692307693"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"33.493908806126", ",", "3.9854307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"33.493908806126", ",", "3.528738461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"34.04524886877828", ",", "3.528738461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"34.04524886877828", ",", "3.2744307692307695"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"34.59658893143056", ",", "3.2744307692307695"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"34.59658893143056", ",", "3.2213076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"35.14792899408285", ",", "3.2213076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"35.14792899408285", ",", "3.2200615384615388"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"35.69926905673512", ",", "3.2200615384615388"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"35.69926905673512", ",", "3.190338461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"36.250609119387406", ",", "3.190338461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"36.250609119387406", ",", "3.164815384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"36.80194918203968", ",", "3.164815384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"36.80194918203968", ",", "3.1670307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"37.353289244691965", ",", "3.1670307692307693"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"37.353289244691965", ",", "3.155261538461539"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"37.90462930734424", ",", "3.155261538461539"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"37.90462930734424", ",", "3.156046153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"38.455969369996524", ",", "3.156046153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"38.455969369996524", ",", "3.1588615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"39.007309432648796", ",", "3.1588615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"39.007309432648796", ",", "3.175753846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"39.55864949530108", ",", "3.175753846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"39.55864949530108", ",", "3.210876923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"40.109989557953355", ",", "3.210876923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"40.109989557953355", ",", "3.210692307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"40.66132962060564", ",", "3.210692307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"40.66132962060564", ",", "3.2216769230769233"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"41.212669683257914", ",", "3.2216769230769233"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"41.212669683257914", ",", "3.181015384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"41.7640097459102", ",", "3.181015384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"41.7640097459102", ",", "3.1258153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"42.31534980856247", ",", "3.1258153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"42.31534980856247", ",", "2.9513076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"42.86668987121476", ",", "2.9513076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"42.86668987121476", ",", "2.7871384615384613"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"43.41802993386705", ",", "2.7871384615384613"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"43.41802993386705", ",", "2.679092307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"43.96936999651932", ",", "2.679092307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"43.96936999651932", ",", "2.6358923076923078"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"44.520710059171606", ",", "2.6358923076923078"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"44.520710059171606", ",", "2.5690153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"45.07205012182388", ",", "2.5690153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"45.07205012182388", ",", "2.5978615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"45.623390184476165", ",", "2.5978615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"45.623390184476165", ",", "2.9731384615384613"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"46.17473024712844", ",", "2.9731384615384613"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"46.17473024712844", ",", "2.482430769230769"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"46.726070309780724", ",", "2.482430769230769"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"46.726070309780724", ",", "2.452984615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"47.277410372432996", ",", "2.452984615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"47.277410372432996", ",", "2.386615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"47.82875043508528", ",", "2.386615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"47.82875043508528", ",", "2.354076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"48.380090497737555", ",", "2.354076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"48.380090497737555", ",", "2.335338461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"48.93143056038984", ",", "2.335338461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"48.93143056038984", ",", "2.301876923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"49.482770623042114", ",", "2.301876923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"49.482770623042114", ",", "2.295369230769231"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"50.0341106856944", ",", "2.295369230769231"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"50.0341106856944", ",", "2.260153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"50.58545074834667", ",", "2.260153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"50.58545074834667", ",", "2.261215384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"51.13679081099896", ",", "2.261215384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"51.13679081099896", ",", "2.250046153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"51.68813087365123", ",", "2.250046153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"51.68813087365123", ",", "2.231815384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"52.23947093630352", ",", "2.231815384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"52.23947093630352", ",", "2.2032923076923074"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"52.79081099895579", ",", "2.2032923076923074"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"52.79081099895579", ",", "2.189215384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"53.34215106160808", ",", "2.189215384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"53.34215106160808", ",", "2.160876923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"53.89349112426035", ",", "2.160876923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"53.89349112426035", ",", "2.1492"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"54.44483118691264", ",", "2.1492"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"54.44483118691264", ",", "2.133046153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"54.99617124956492", ",", "2.133046153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"54.99617124956492", ",", "2.1064153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"55.547511312217196", ",", "2.1064153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"55.547511312217196", ",", "2.691461538461539"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"56.09885137486948", ",", "2.691461538461539"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"56.09885137486948", ",", "7.749415384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"56.650191437521755", ",", "7.749415384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"56.650191437521755", ",", "2.055230769230769"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"57.20153150017404", ",", "2.055230769230769"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"57.20153150017404", ",", "2.0272615384615387"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"57.752871562826314", ",", "2.0272615384615387"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"57.752871562826314", ",", "2.0022"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"58.3042116254786", ",", "2.0022"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"58.3042116254786", ",", "1.9890461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"58.85555168813087", ",", "1.9890461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"58.85555168813087", ",", "1.9961076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"59.40689175078316", ",", "1.9961076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"59.40689175078316", ",", "1.9865076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"59.95823181343543", ",", "1.9865076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"59.95823181343543", ",", "1.9688307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"60.50957187608772", ",", "1.9688307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"60.50957187608772", ",", "1.9891846153846156"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"61.06091193873999", ",", "1.9891846153846156"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"61.06091193873999", ",", "21.28689230769231"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"61.61225200139228", ",", "21.28689230769231"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"61.61225200139228", ",", "2.368846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"62.16359206404455", ",", "2.368846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"62.16359206404455", ",", "1.8838153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"62.71493212669684", ",", "1.8838153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"62.71493212669684", ",", "1.860923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"63.26627218934911", ",", "1.860923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"63.26627218934911", ",", "1.8502615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"63.81761225200139", ",", "1.8502615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"63.81761225200139", ",", "1.8546923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"64.36895231465367", ",", "1.8546923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"64.36895231465367", ",", "1.839553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"64.92029237730594", ",", "1.839553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"64.92029237730594", ",", "1.8126461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"65.47163243995823", ",", "1.8126461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"65.47163243995823", ",", "1.8015230769230768"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"66.02297250261051", ",", "1.8015230769230768"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"66.02297250261051", ",", "1.7823692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"66.57431256526279", ",", "1.7823692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"66.57431256526279", ",", "1.7739692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"67.12565262791506", ",", "1.7739692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"67.12565262791506", ",", "1.7979692307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"67.67699269056735", ",", "1.7979692307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"67.67699269056735", ",", "1.7429076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"68.22833275321963", ",", "1.7429076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"68.22833275321963", ",", "1.7452153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"68.7796728158719", ",", "1.7452153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"68.7796728158719", ",", "1.7206153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"69.33101287852418", ",", "1.7206153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"69.33101287852418", ",", "1.7222307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"69.88235294117646", ",", "1.7222307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"69.88235294117646", ",", "1.7113384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"70.43369300382875", ",", "1.7113384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"70.43369300382875", ",", "1.696753846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"70.98503306648102", ",", "1.696753846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"70.98503306648102", ",", "1.813476923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"71.5363731291333", ",", "1.813476923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"71.5363731291333", ",", "59.2582153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"72.08771319178558", ",", "59.2582153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"72.08771319178558", ",", "2.742"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"72.63905325443787", ",", "2.742"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"72.63905325443787", ",", "1.5598153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"73.19039331709016", ",", "1.5598153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"73.19039331709016", ",", "1.5406153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"73.74173337974243", ",", "1.5406153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"73.74173337974243", ",", "1.5511846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"74.2930734423947", ",", "1.5511846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"74.2930734423947", ",", "1.6009846153846152"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"74.84441350504699", ",", "1.6009846153846152"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"74.84441350504699", ",", "1.5999692307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"75.39575356769927", ",", "1.5999692307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"75.39575356769927", ",", "1.5627692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"75.94709363035155", ",", "1.5627692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"75.94709363035155", ",", "1.5208615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"76.49843369300382", ",", "1.5208615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"76.49843369300382", ",", "1.5348"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"77.0497737556561", ",", "1.5348"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"77.0497737556561", ",", "9.977723076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"77.60111381830839", ",", "9.977723076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"77.60111381830839", ",", "1.6764923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"78.15245388096066", ",", "1.6764923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"78.15245388096066", ",", "1.4622923076923078"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"78.70379394361294", ",", "1.4622923076923078"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"78.70379394361294", ",", "1.4639076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"79.25513400626522", ",", "1.4639076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"79.25513400626522", ",", "1.4417076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"79.80647406891751", ",", "1.4417076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"79.80647406891751", ",", "1.4467384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"80.35781413156978", ",", "1.4467384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"80.35781413156978", ",", "1.4479846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"80.90915419422205", ",", "1.4479846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"80.90915419422205", ",", "1.443323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"81.46049425687434", ",", "1.443323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"81.46049425687434", ",", "1.439123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"82.01183431952663", ",", "1.439123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"82.01183431952663", ",", "1.434553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"82.5631743821789", ",", "1.434553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"82.5631743821789", ",", "1.447476923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"83.11451444483117", ",", "1.447476923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"83.11451444483117", ",", "1.4554153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"83.66585450748346", ",", "1.4554153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"83.66585450748346", ",", "1.4344615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"84.21719457013575", ",", "1.4344615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"84.21719457013575", ",", "1.434276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"84.76853463278803", ",", "1.434276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"84.76853463278803", ",", "1.434876923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"85.3198746954403", ",", "1.434876923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"85.3198746954403", ",", "1.435523076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"85.87121475809258", ",", "1.435523076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"85.87121475809258", ",", "1.437"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"86.42255482074486", ",", "1.437"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"86.42255482074486", ",", "1.437"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"86.97389488339715", ",", "1.437"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"86.97389488339715", ",", "1.4454"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"87.52523494604942", ",", "1.4454"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"87.52523494604942", ",", "1.6120153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"88.0765750087017", ",", "1.6120153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"88.0765750087017", ",", "1.4151692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"88.62791507135398", ",", "1.4151692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"88.62791507135398", ",", "1.4131384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"89.17925513400627", ",", "1.4131384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"89.17925513400627", ",", "1.412076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"89.73059519665854", ",", "1.412076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"89.73059519665854", ",", "1.4100923076923078"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"90.28193525931081", ",", "1.4100923076923078"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"90.28193525931081", ",", "1.4132307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"90.8332753219631", ",", "1.4132307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"90.8332753219631", ",", "1.4119384615384616"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"91.38461538461539", ",", "1.4119384615384616"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"91.38461538461539", ",", "1.4135538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"91.93595544726766", ",", "1.4135538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"91.93595544726766", ",", "1.4096307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"92.48729550991993", ",", "1.4096307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"92.48729550991993", ",", "1.4118461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"93.03863557257222", ",", "1.4118461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"93.03863557257222", ",", "1.4119384615384616"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"93.5899756352245", ",", "1.4119384615384616"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"93.5899756352245", ",", "1.4082923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"94.14131569787678", ",", "1.4082923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"94.14131569787678", ",", "1.4075076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"94.69265576052905", ",", "1.4075076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"94.69265576052905", ",", "1.406446153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"95.24399582318134", ",", "1.406446153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"95.24399582318134", ",", "1.4080153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"95.79533588583362", ",", "1.4080153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"95.79533588583362", ",", "1.4100461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"96.34667594848591", ",", "1.4100461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"96.34667594848591", ",", "1.4061692307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"96.89801601113818", ",", "1.4061692307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"96.89801601113818", ",", "1.4055692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"97.44935607379045", ",", "1.4055692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"97.44935607379045", ",", "1.4049692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"98.00069613644274", ",", "1.4049692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"98.00069613644274", ",", "1.4050615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"98.55203619909503", ",", "1.4050615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"98.55203619909503", ",", "1.4044615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"99.1033762617473", ",", "1.4044615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"99.1033762617473", ",", "1.4038615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"99.65471632439957", ",", "1.4038615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"99.65471632439957", ",", "1.4065846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"100.20605638705186", ",", "1.4065846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"100.20605638705186", ",", "1.404276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"100.75739644970415", ",", "1.404276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"100.75739644970415", ",", "1.404923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"101.30873651235642", ",", "1.404923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"101.30873651235642", ",", "1.4056615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"101.86007657500869", ",", "1.4056615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"101.86007657500869", ",", "1.4088"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"102.41141663766098", ",", "1.4088"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"102.41141663766098", ",", "1.4088"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"102.96275670031326", ",", "1.4088"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"102.96275670031326", ",", "1.4036307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"103.51409676296554", ",", "1.4036307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"103.51409676296554", ",", "1.4026615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"104.06543682561781", ",", "1.4026615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"104.06543682561781", ",", "1.4028923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"104.6167768882701", ",", "1.4028923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"104.6167768882701", ",", "1.4034"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"105.16811695092238", ",", "1.4034"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"105.16811695092238", ",", "1.4020153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"105.71945701357465", ",", "1.4020153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"105.71945701357465", ",", "1.4028461538461539"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"106.27079707622693", ",", "1.4028461538461539"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"106.27079707622693", ",", "1.4018307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"106.82213713887921", ",", "1.4018307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"106.82213713887921", ",", "1.4015076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"107.3734772015315", ",", "1.4015076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"107.3734772015315", ",", "1.4002153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"107.92481726418377", ",", "1.4002153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"107.92481726418377", ",", "1.4009076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"108.47615732683606", ",", "1.4009076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"108.47615732683606", ",", "1.3997076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"109.02749738948833", ",", "1.3997076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"109.02749738948833", ",", "1.3990615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"109.57883745214062", ",", "1.3990615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"109.57883745214062", ",", "1.4002153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"110.1301775147929", ",", "1.4002153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"110.1301775147929", ",", "1.402153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"110.68151757744518", ",", "1.402153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"110.68151757744518", ",", "1.398553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"111.23285764009745", ",", "1.398553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"111.23285764009745", ",", "1.397953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"111.78419770274974", ",", "1.397953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"111.78419770274974", ",", "1.3983692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"112.33553776540202", ",", "1.3983692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"112.33553776540202", ",", "1.3971692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"112.8868778280543", ",", "1.3971692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"112.8868778280543", ",", "1.3973076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"113.43821789070657", ",", "1.3973076923076924"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"113.43821789070657", ",", "1.398553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"113.98955795335885", ",", "1.398553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"113.98955795335885", ",", "1.3977692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"114.54089801601114", ",", "1.3977692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"114.54089801601114", ",", "1.3978153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"115.09223807866341", ",", "1.3978153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"115.09223807866341", ",", "1.3970307692307693"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"115.64357814131569", ",", "1.3970307692307693"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"115.64357814131569", ",", "1.3961076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"116.19491820396797", ",", "1.3961076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"116.19491820396797", ",", "1.3957846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"116.74625826662026", ",", "1.3957846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"116.74625826662026", ",", "1.394353846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"117.29759832927253", ",", "1.394353846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"117.29759832927253", ",", "1.3960615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"117.8489383919248", ",", "1.3960615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"117.8489383919248", ",", "1.3935230769230769"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"118.40027845457709", ",", "1.3935230769230769"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"118.40027845457709", ",", "1.3939384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"118.95161851722938", ",", "1.3939384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"118.95161851722938", ",", "1.3942615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"119.50295857988165", ",", "1.3942615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"119.50295857988165", ",", "1.3961076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"120.05429864253394", ",", "1.3961076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"120.05429864253394", ",", "1.3964307692307691"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"120.60563870518621", ",", "1.3964307692307691"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"120.60563870518621", ",", "1.3951846153846152"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"121.1569787678385", ",", "1.3951846153846152"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"121.1569787678385", ",", "1.3952307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"121.70831883049078", ",", "1.3952307692307693"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"121.70831883049078", ",", "1.396246153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"122.25965889314305", ",", "1.396246153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"122.25965889314305", ",", "1.3941692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"122.81099895579533", ",", "1.3941692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"122.81099895579533", ",", "1.3948615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"123.36233901844761", ",", "1.3948615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"123.36233901844761", ",", "1.397123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"123.9136790810999", ",", "1.397123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"123.9136790810999", ",", "1.394076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"124.46501914375217", ",", "1.394076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"124.46501914375217", ",", "1.394076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"125.01635920640445", ",", "1.394076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"125.01635920640445", ",", "1.3947692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"125.56769926905673", ",", "1.3947692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"125.56769926905673", ",", "1.3945846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"126.11903933170902", ",", "1.3945846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"126.11903933170902", ",", "1.3956461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"126.67037939436129", ",", "1.3956461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"126.67037939436129", ",", "1.3942153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"127.22171945701356", ",", "1.3942153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"127.22171945701356", ",", "1.3926923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"127.77305951966585", ",", "1.3926923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"127.77305951966585", ",", "1.392276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"128.32439958231814", ",", "1.392276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"128.32439958231814", ",", "1.3942153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"128.87573964497042", ",", "1.3942153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"128.87573964497042", ",", "1.3931538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"129.42707970762268", ",", "1.3931538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"129.42707970762268", ",", "1.3940307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"129.97841977027497", ",", "1.3940307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"129.97841977027497", ",", "1.3932923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"130.52975983292725", ",", "1.3932923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"130.52975983292725", ",", "1.3938923076923078"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"131.08109989557954", ",", "1.3938923076923078"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"131.08109989557954", ",", "1.3983692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"131.63243995823183", ",", "1.3983692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"131.63243995823183", ",", "1.3924615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"132.18378002088411", ",", "1.3924615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"132.18378002088411", ",", "1.391676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"132.7351200835364", ",", "1.391676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"132.7351200835364", ",", "1.3909846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"133.28646014618866", ",", "1.3909846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"133.28646014618866", ",", "1.389876923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"133.83780020884095", ",", "1.389876923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"133.83780020884095", ",", "1.3908"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"134.38914027149323", ",", "1.3908"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"134.38914027149323", ",", "1.3906615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"134.9404803341455", ",", "1.3906615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"134.9404803341455", ",", "1.390246153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"135.49182039679778", ",", "1.390246153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"135.49182039679778", ",", "1.391123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"136.04316045945006", ",", "1.391123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"136.04316045945006", ",", "1.3926923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"136.59450052210235", ",", "1.3926923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"136.59450052210235", ",", "1.4006769230769232"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"137.14584058475464", ",", "1.4006769230769232"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"137.14584058475464", ",", "1.3912153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"137.6971806474069", ",", "1.3912153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"137.6971806474069", ",", "1.391076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"138.24852071005918", ",", "1.391076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"138.24852071005918", ",", "1.390153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"138.79986077271147", ",", "1.390153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"138.79986077271147", ",", "1.390523076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"139.35120083536373", ",", "1.390523076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"139.35120083536373", ",", "1.3911692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"139.902540898016", ",", "1.3911692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"139.902540898016", ",", "1.392276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"140.4538809606683", ",", "1.392276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"140.4538809606683", ",", "1.3928769230769231"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"141.0052210233206", ",", "1.3928769230769231"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"141.0052210233206", ",", "1.3938"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"141.55656108597287", ",", "1.3938"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"141.55656108597287", ",", "1.398"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"142.10790114862513", ",", "1.398"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"142.10790114862513", ",", "1.3889538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"142.65924121127742", ",", "1.3889538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"142.65924121127742", ",", "1.3882615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"143.2105812739297", ",", "1.3882615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"143.2105812739297", ",", "1.3877076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"143.761921336582", ",", "1.3877076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"143.761921336582", ",", "1.3875692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"144.31326139923425", ",", "1.3875692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"144.31326139923425", ",", "1.3876153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"144.86460146188654", ",", "1.3876153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"144.86460146188654", ",", "1.388353846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"145.41594152453882", ",", "1.388353846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"145.41594152453882", ",", "1.3882153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"145.9672815871911", ",", "1.3882153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"145.9672815871911", ",", "1.3884461538461539"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"146.5186216498434", ",", "1.3884461538461539"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"146.5186216498434", ",", "1.3885384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"147.06996171249565", ",", "1.3885384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"147.06996171249565", ",", "1.390246153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"147.62130177514794", ",", "1.390246153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"147.62130177514794", ",", "1.3867384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"148.17264183780023", ",", "1.3867384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"148.17264183780023", ",", "1.387476923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"148.7239819004525", ",", "1.387476923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"148.7239819004525", ",", "1.387476923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"149.27532196310477", ",", "1.387476923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"149.27532196310477", ",", "1.3864615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"149.82666202575706", ",", "1.3864615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"149.82666202575706", ",", "1.386323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"150.37800208840935", ",", "1.386323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"150.37800208840935", ",", "1.3867846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"150.92934215106163", ",", "1.3867846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"150.92934215106163", ",", "1.3871076923076924"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"151.4806822137139", ",", "1.3871076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"151.4806822137139", ",", "1.3872"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"152.03202227636618", ",", "1.3872"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"152.03202227636618", ",", "1.3866923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"152.58336233901846", ",", "1.3866923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"152.58336233901846", ",", "1.3867846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"153.13470240167072", ",", "1.3867846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"153.13470240167072", ",", "1.3866923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"153.686042464323", ",", "1.3866923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"153.686042464323", ",", "1.3884461538461539"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"154.2373825269753", ",", "1.3884461538461539"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"154.2373825269753", ",", "1.386553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"154.78872258962758", ",", "1.386553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"154.78872258962758", ",", "1.386553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"155.34006265227987", ",", "1.386553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"155.34006265227987", ",", "1.3859076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"155.89140271493216", ",", "1.3859076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"155.89140271493216", ",", "1.386553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"156.4427427775844", ",", "1.386553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"156.4427427775844", ",", "1.3866923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"156.9940828402367", ",", "1.3866923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"156.9940828402367", ",", "1.386323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"157.545422902889", ",", "1.386323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"157.545422902889", ",", "1.386553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"158.09676296554125", ",", "1.386553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"158.09676296554125", ",", "1.3870153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"158.64810302819353", ",", "1.3870153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"158.64810302819353", ",", "1.3867384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"159.19944309084582", ",", "1.3867384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"159.19944309084582", ",", "1.386276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"159.7507831534981", ",", "1.386276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"159.7507831534981", ",", "1.386923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"160.3021232161504", ",", "1.386923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"160.3021232161504", ",", "1.3870153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"160.85346327880265", ",", "1.3870153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"160.85346327880265", ",", "1.3866923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"161.40480334145494", ",", "1.3866923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"161.40480334145494", ",", "1.3870615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"161.95614340410722", ",", "1.3870615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"161.95614340410722", ",", "1.3864615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"162.50748346675948", ",", "1.3864615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"162.50748346675948", ",", "1.3869692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"163.05882352941177", ",", "1.3869692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"163.05882352941177", ",", "1.3867384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"163.61016359206405", ",", "1.3867384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"163.61016359206405", ",", "1.3863692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"164.16150365471634", ",", "1.3863692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"164.16150365471634", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"164.71284371736863", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"164.71284371736863", ",", "1.386276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"165.2641837800209", ",", "1.386276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"165.2641837800209", ",", "1.386276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"165.81552384267317", ",", "1.386276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"165.81552384267317", ",", "1.3866923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"166.36686390532546", ",", "1.3866923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"166.36686390532546", ",", "1.3868769230769231"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"166.91820396797775", ",", "1.3868769230769231"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"166.91820396797775", ",", "1.3866461538461539"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"167.46954403063", ",", "1.3866461538461539"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"167.46954403063", ",", "1.3867384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"168.0208840932823", ",", "1.3867384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"168.0208840932823", ",", "1.3867846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"168.57222415593458", ",", "1.3867846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"168.57222415593458", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"169.12356421858686", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"169.12356421858686", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"169.67490428123915", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"169.67490428123915", ",", "1.3867846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"170.2262443438914", ",", "1.3867846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"170.2262443438914", ",", "1.3866"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"170.7775844065437", ",", "1.3866"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"170.7775844065437", ",", "1.3861384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"171.32892446919598", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"171.32892446919598", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"171.88026453184824", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"171.88026453184824", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"172.43160459450053", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"172.43160459450053", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"172.9829446571528", ",", "1.3862307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"172.9829446571528", ",", "1.386276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"173.5342847198051", ",", "1.386276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"173.5342847198051", ",", "1.3865076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"174.0856247824574", ",", "1.3865076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"174.0856247824574", ",", "1.3860461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"174.63696484510965", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"174.63696484510965", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"175.18830490776193", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"175.18830490776193", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"175.73964497041422", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"175.73964497041422", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"176.29098503306648", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"176.29098503306648", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"176.84232509571876", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"176.84232509571876", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"177.39366515837105", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"177.39366515837105", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"177.94500522102334", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"177.94500522102334", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"178.49634528367562", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"178.49634528367562", ",", "1.386276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"179.0476853463279", ",", "1.386276923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"179.0476853463279", ",", "1.3863692307692308"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"179.59902540898017", ",", "1.3863692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"179.59902540898017", ",", "1.3860923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"180.15036547163245", ",", "1.3860923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"180.15036547163245", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"180.70170553428474", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"180.70170553428474", ",", "1.388076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"181.253045596937", ",", "1.388076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"181.253045596937", ",", "1.3867846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"181.8043856595893", ",", "1.3867846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"181.8043856595893", ",", "1.3861846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"182.35572572224157", ",", "1.3861846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"182.35572572224157", ",", "1.386553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"182.90706578489386", ",", "1.386553846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"182.90706578489386", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"183.45840584754615", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"183.45840584754615", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"184.0097459101984", ",", "1.3862307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"184.0097459101984", ",", "1.386323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"184.5610859728507", ",", "1.386323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"184.5610859728507", ",", "1.3865076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"185.11242603550298", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"185.11242603550298", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"185.66376609815524", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"185.66376609815524", ",", "1.3864153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"186.21510616080752", ",", "1.3864153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"186.21510616080752", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"186.7664462234598", ",", "1.3861384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"186.7664462234598", ",", "1.3860461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"187.3177862861121", ",", "1.3860461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"187.3177862861121", ",", "1.3861384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"187.86912634876438", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"187.86912634876438", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"188.42046641141664", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"188.42046641141664", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"188.97180647406893", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"188.97180647406893", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"189.5231465367212", ",", "1.3861384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"189.5231465367212", ",", "1.3862307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"190.0744865993735", ",", "1.3862307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"190.0744865993735", ",", "1.3862307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"190.62582666202576", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"190.62582666202576", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"191.17716672467805", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"191.17716672467805", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"191.72850678733033", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"191.72850678733033", ",", "1.3863692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"192.27984684998262", ",", "1.3863692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"192.27984684998262", ",", "1.3878923076923078"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"192.8311869126349", ",", "1.3878923076923078"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"192.8311869126349", ",", "1.3862307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"193.38252697528716", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"193.38252697528716", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"193.93386703793945", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"193.93386703793945", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"194.48520710059174", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"194.48520710059174", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"195.036547163244", ",", "1.3862307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"195.036547163244", ",", "1.3853538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"195.58788722589628", ",", "1.3853538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"195.58788722589628", ",", "1.386323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"196.13922728854857", ",", "1.386323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"196.13922728854857", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"196.69056735120085", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"196.69056735120085", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"197.24190741385314", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"197.24190741385314", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"197.7932474765054", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"197.7932474765054", ",", "1.3858615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"198.3445875391577", ",", "1.3858615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"198.3445875391577", ",", "1.3858153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"198.89592760180997", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"198.89592760180997", ",", "1.3866461538461539"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"199.44726766446223", ",", "1.3866461538461539"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"199.44726766446223", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"199.99860772711452", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"199.99860772711452", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"200.5499477897668", ",", "1.3858615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"200.5499477897668", ",", "1.3857230769230768"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"201.1012878524191", ",", "1.3857230769230768"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"201.1012878524191", ",", "1.3860461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"201.65262791507138", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"201.65262791507138", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"202.20396797772366", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"202.20396797772366", ",", "1.3864615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"202.75530804037592", ",", "1.3864615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"202.75530804037592", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"203.3066481030282", ",", "1.3862307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"203.3066481030282", ",", "1.3856307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"203.8579881656805", ",", "1.3856307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"203.8579881656805", ",", "1.3858153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"204.40932822833275", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"204.40932822833275", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"204.96066829098504", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"204.96066829098504", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"205.51200835363733", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"205.51200835363733", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"206.0633484162896", ",", "1.386"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"206.0633484162896", ",", "1.3860461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"206.6146884789419", ",", "1.3860461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"206.6146884789419", ",", "1.3854461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"207.16602854159416", ",", "1.3854461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"207.16602854159416", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"207.71736860424645", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"207.71736860424645", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"208.26870866689873", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"208.26870866689873", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"208.820048729551", ",", "1.3861384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"208.820048729551", ",", "1.3857692307692306"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"209.37138879220328", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"209.37138879220328", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"209.92272885485556", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"209.92272885485556", ",", "1.3859076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"210.47406891750785", ",", "1.3859076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"210.47406891750785", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"211.02540898016014", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"211.02540898016014", ",", "1.3870615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"211.5767490428124", ",", "1.3870615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"211.5767490428124", ",", "1.3860923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"212.12808910546468", ",", "1.3860923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"212.12808910546468", ",", "1.3857230769230768"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"212.67942916811697", ",", "1.3857230769230768"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"212.67942916811697", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"213.23076923076923", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"213.23076923076923", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"213.7821092934215", ",", "1.3857692307692306"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"213.7821092934215", ",", "1.3860923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"214.3334493560738", ",", "1.3860923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"214.3334493560738", ",", "1.3857230769230768"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"214.8847894187261", ",", "1.3857230769230768"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"214.8847894187261", ",", "1.3861384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"215.43612948137837", ",", "1.3861384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"215.43612948137837", ",", "1.3859076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"215.98746954403066", ",", "1.3859076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"215.98746954403066", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"216.53880960668292", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"216.53880960668292", ",", "1.3854923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"217.0901496693352", ",", "1.3854923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"217.0901496693352", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"217.6414897319875", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"217.6414897319875", ",", "1.3873846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"218.19282979463975", ",", "1.3873846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"218.19282979463975", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"218.74416985729204", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"218.74416985729204", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"219.29550991994432", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"219.29550991994432", ",", "1.3860461538461537"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"219.8468499825966", ",", "1.3860461538461537"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"219.8468499825966", ",", "1.3856307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"220.3981900452489", ",", "1.3856307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"220.3981900452489", ",", "1.3860923076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"220.94953010790115", ",", "1.3860923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"220.94953010790115", ",", "1.3860923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"221.50087017055344", ",", "1.3860923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"221.50087017055344", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"222.05221023320573", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"222.05221023320573", ",", "1.3879384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"222.60355029585799", ",", "1.3879384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"222.60355029585799", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"223.15489035851027", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"223.15489035851027", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"223.70623042116256", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"223.70623042116256", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"224.25757048381485", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"224.25757048381485", ",", "1.3863692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"224.80891054646713", ",", "1.3863692307692308"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"224.80891054646713", ",", "1.3862307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"225.3602506091194", ",", "1.3862307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"225.3602506091194", ",", "1.3858615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"225.91159067177168", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"225.91159067177168", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"226.46293073442396", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"226.46293073442396", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"227.01427079707625", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"227.01427079707625", ",", "1.3854461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"227.5656108597285", ",", "1.3854461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"227.5656108597285", ",", "1.3857230769230768"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"228.1169509223808", ",", "1.3857230769230768"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"228.1169509223808", ",", "1.3857230769230768"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"228.66829098503308", ",", "1.3857230769230768"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"228.66829098503308", ",", "1.386323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"229.21963104768537", ",", "1.386323076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"229.21963104768537", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"229.77097111033765", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"229.77097111033765", ",", "1.3854461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"230.3223111729899", ",", "1.3854461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"230.3223111729899", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"230.8736512356422", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"230.8736512356422", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"231.4249912982945", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"231.4249912982945", ",", "1.3856307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"231.97633136094674", ",", "1.3856307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"231.97633136094674", ",", "1.3855846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"232.52767142359903", ",", "1.3855846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"232.52767142359903", ",", "1.3864153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"233.07901148625132", ",", "1.3864153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"233.07901148625132", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"233.6303515489036", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"233.6303515489036", ",", "1.3858153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"234.1816916115559", ",", "1.3858153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"234.1816916115559", ",", "1.386"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"234.73303167420815", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"234.73303167420815", ",", "1.3859076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"235.28437173686044", ",", "1.3859076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"235.28437173686044", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"235.83571179951272", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"235.83571179951272", ",", "1.3855384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"236.38705186216498", ",", "1.3855384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"236.38705186216498", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"236.93839192481727", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"236.93839192481727", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"237.48973198746955", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"237.48973198746955", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"238.04107205012184", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"238.04107205012184", ",", "1.3855384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"238.59241211277413", ",", "1.3855384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"238.59241211277413", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"239.1437521754264", ",", "1.3858153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"239.1437521754264", ",", "1.386"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"239.69509223807867", ",", "1.386"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"239.69509223807867", ",", "1.3856307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"240.24643230073096", ",", "1.3856307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"240.24643230073096", ",", "1.3860923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"240.79777236338325", ",", "1.3860923076923077"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"240.79777236338325", ",", "1.3854923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"241.3491124260355", ",", "1.3854923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"241.3491124260355", ",", "1.386"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"241.9004524886878", ",", "1.386"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"241.9004524886878", ",", "1.3854"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"242.45179255134008", ",", "1.3854"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"242.45179255134008", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"243.00313261399236", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"243.00313261399236", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"243.55447267664465", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"243.55447267664465", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"244.1058127392969", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"244.1058127392969", ",", "1.3856307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"244.6571528019492", ",", "1.3856307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"244.6571528019492", ",", "1.3861846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"245.20849286460148", ",", "1.3861846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"245.20849286460148", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"245.75983292725374", ",", "1.3865076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"245.75983292725374", ",", "1.3854461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"246.31117298990603", ",", "1.3854461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"246.31117298990603", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"246.8625130525583", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"246.8625130525583", ",", "1.3855846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"247.4138531152106", ",", "1.3855846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"247.4138531152106", ",", "1.3853076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"247.9651931778629", ",", "1.3853076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"247.9651931778629", ",", "1.3858615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"248.51653324051514", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"248.51653324051514", ",", "1.3854"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"249.06787330316743", ",", "1.3854"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"249.06787330316743", ",", "1.3859076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"249.61921336581972", ",", "1.3859076923076923"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"249.61921336581972", ",", "1.3854923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"250.170553428472", ",", "1.3854923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"250.170553428472", ",", "1.3852153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"250.72189349112426", ",", "1.3852153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"250.72189349112426", ",", "1.3854"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"251.27323355377655", ",", "1.3854"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"251.27323355377655", ",", "1.3855846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"251.82457361642884", ",", "1.3855846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"251.82457361642884", ",", "1.3852615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"252.37591367908112", ",", "1.3852615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"252.37591367908112", ",", "1.386830769230769"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"252.9272537417334", ",", "1.386830769230769"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"252.9272537417334", ",", "1.3854461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"253.47859380438567", ",", "1.3854461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"253.47859380438567", ",", "1.3854923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"254.02993386703795", ",", "1.3854923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"254.02993386703795", ",", "1.3855384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"254.58127392969024", ",", "1.3855384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"254.58127392969024", ",", "1.3854"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"255.1326139923425", ",", "1.3854"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"255.1326139923425", ",", "1.3858153846153847"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"255.68395405499479", ",", "1.3858153846153847"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"255.68395405499479", ",", "1.3852615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"256.2352941176471", ",", "1.3852615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"256.2352941176471", ",", "1.3873846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"256.7866341802993", ",", "1.3873846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"256.7866341802993", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"257.33797424295165", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"257.33797424295165", ",", "1.3857692307692306"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"257.8893143056039", ",", "1.3857692307692306"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"257.8893143056039", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"258.44065436825616", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"258.44065436825616", ",", "1.3853538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"258.99199443090845", ",", "1.3853538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"258.99199443090845", ",", "1.3851692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"259.5433344935607", ",", "1.3851692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"259.5433344935607", ",", "1.3853076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"260.094674556213", ",", "1.3853076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"260.094674556213", ",", "1.3854923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"260.64601461886525", ",", "1.3854923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"260.64601461886525", ",", "1.3852615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"261.1973546815176", ",", "1.3852615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"261.1973546815176", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"261.7486947441698", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"261.7486947441698", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"262.30003480682217", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"262.30003480682217", ",", "1.3851692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"262.8513748694744", ",", "1.3851692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"262.8513748694744", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"263.4027149321267", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"263.4027149321267", ",", "1.3852153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"263.95405499477897", ",", "1.3852153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"263.95405499477897", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"264.5053950574312", ",", "1.385953846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"264.5053950574312", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"265.05673512008354", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"265.05673512008354", ",", "1.3853538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"265.6080751827358", ",", "1.3853538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"265.6080751827358", ",", "1.3854"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"266.1594152453881", ",", "1.3854"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"266.1594152453881", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"266.71075530804035", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"266.71075530804035", ",", "1.3853538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"267.2620953706927", ",", "1.3853538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"267.2620953706927", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"267.8134354333449", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"267.8134354333449", ",", "1.3852615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"268.36477549599715", ",", "1.3852615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"268.36477549599715", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"268.9161155586495", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"268.9161155586495", ",", "1.3852615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"269.4674556213017", ",", "1.3852615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"269.4674556213017", ",", "1.3856307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"270.01879568395407", ",", "1.3856307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"270.01879568395407", ",", "1.3854461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"270.5701357466063", ",", "1.3854461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"270.5701357466063", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"271.12147580925864", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"271.12147580925864", ",", "1.3856307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"271.67281587191087", ",", "1.3856307692307692"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"271.67281587191087", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"272.2241559345632", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"272.2241559345632", ",", "1.3855846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"272.77549599721544", ",", "1.3855846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"272.77549599721544", ",", "1.3858615384615385"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"273.3268360598677", ",", "1.3858615384615385"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"273.3268360598677", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"273.87817612252", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"273.87817612252", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"274.42951618517225", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"274.42951618517225", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"274.9808562478246", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"274.9808562478246", ",", "1.3852153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"275.5321963104768", ",", "1.3852153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"275.5321963104768", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"276.08353637312916", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"276.08353637312916", ",", "1.3852615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"276.6348764357814", ",", "1.3852615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"276.6348764357814", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"277.1862164984337", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"277.1862164984337", ",", "1.3854"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"277.73755656108597", ",", "1.3854"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"277.73755656108597", ",", "1.3852615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"278.2888966237382", ",", "1.3852615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"278.2888966237382", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"278.84023668639054", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"278.84023668639054", ",", "1.3855846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"279.39157674904277", ",", "1.3855846153846154"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"279.39157674904277", ",", "1.3852153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"279.9429168116951", ",", "1.3852153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"279.9429168116951", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"280.49425687434734", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"280.49425687434734", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"281.0455969369997", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"281.0455969369997", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"281.5969369996519", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"281.5969369996519", ",", "1.3852615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"282.14827706230415", ",", "1.3852615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"282.14827706230415", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"282.6996171249565", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"282.6996171249565", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"283.2509571876087", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"283.2509571876087", ",", "1.3853538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"283.80229725026106", ",", "1.3853538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"283.80229725026106", ",", "1.3852153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"284.3536373129133", ",", "1.3852153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"284.3536373129133", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"284.90497737556564", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"284.90497737556564", ",", "1.3852615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"285.45631743821787", ",", "1.3852615384615383"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"285.45631743821787", ",", "1.3850307692307693"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"286.0076575008702", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"286.0076575008702", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"286.55899756352244", ",", "1.3850307692307693"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"286.55899756352244", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"287.11033762617467", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"287.11033762617467", ",", "1.3853076923076924"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"287.661677688827", ",", "1.3853076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"287.661677688827", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"288.21301775147924", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"288.21301775147924", ",", "1.3854"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"288.7643578141316", ",", "1.3854"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"288.7643578141316", ",", "1.3898307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"289.3156978767838", ",", "1.3898307692307692"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"289.3156978767838", ",", "1.4072307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"289.86703793943616", ",", "1.4072307692307693"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"289.86703793943616", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"290.4183780020884", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"290.4183780020884", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"290.9697180647407", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"290.9697180647407", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"291.52105812739296", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"291.52105812739296", ",", "1.3852153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"292.0723981900452", ",", "1.3852153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"292.0723981900452", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"292.62373825269754", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"292.62373825269754", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"293.17507831534977", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"293.17507831534977", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"293.7264183780021", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"293.7264183780021", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"294.27775844065434", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"294.27775844065434", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"294.8290985033067", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"294.8290985033067", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"295.3804385659589", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"295.3804385659589", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"295.93177862861114", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"295.93177862861114", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"296.4831186912635", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"296.4831186912635", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"297.0344587539157", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"297.0344587539157", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"297.58579881656806", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"297.58579881656806", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"298.1371388792203", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"298.1371388792203", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"298.68847894187263", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"298.68847894187263", ",", "1.3854461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"299.23981900452486", ",", "1.3854461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"299.23981900452486", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"299.7911590671772", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"299.7911590671772", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"300.34249912982943", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"300.34249912982943", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"300.89383919248166", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"300.89383919248166", ",", "1.3853076923076924"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"301.445179255134", ",", "1.3853076923076924"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"301.445179255134", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"301.99651931778624", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"301.99651931778624", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"302.5478593804386", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"302.5478593804386", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"303.0991994430908", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"303.0991994430908", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"303.65053950574315", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"303.65053950574315", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"304.2018795683954", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"304.2018795683954", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"304.75321963104767", ",", "1.3850307692307693"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"304.75321963104767", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"305.30455969369996", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"305.30455969369996", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"305.8558997563522", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"305.8558997563522", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"306.40723981900453", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"306.40723981900453", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"306.95857988165676", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"306.95857988165676", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"307.5099199443091", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"307.5099199443091", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"308.06126000696133", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"308.06126000696133", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"308.6126000696137", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"308.6126000696137", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"309.1639401322659", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"309.1639401322659", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"309.7152801949182", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"309.7152801949182", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"310.2666202575705", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"310.2666202575705", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"310.8179603202227", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"310.8179603202227", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"311.36930038287505", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"311.36930038287505", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"311.9206404455273", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"311.9206404455273", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"312.4719805081796", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"312.4719805081796", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"313.02332057083186", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"313.02332057083186", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"313.5746606334842", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"313.5746606334842", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"314.12600069613643", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"314.12600069613643", ",", "1.3853076923076924"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"314.67734075878866", ",", "1.3853076923076924"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"314.67734075878866", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"315.228680821441", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"315.228680821441", ",", "1.3852153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"315.78002088409323", ",", "1.3852153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"315.78002088409323", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"316.3313609467456", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"316.3313609467456", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"316.8827010093978", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"316.8827010093978", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"317.43404107205015", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"317.43404107205015", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"317.9853811347024", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"317.9853811347024", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"318.53672119735467", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"318.53672119735467", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"319.08806126000695", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"319.08806126000695", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"319.6394013226592", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"319.6394013226592", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"320.1907413853115", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"320.1907413853115", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"320.74208144796376", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"320.74208144796376", ",", "1.3851692307692307"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"321.2934215106161", ",", "1.3851692307692307"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"321.2934215106161", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"321.84476157326833", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"321.84476157326833", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"322.3961016359207", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"322.3961016359207", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"322.9474416985729", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"322.9474416985729", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"323.4987817612252", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"323.4987817612252", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"324.0501218238775", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"324.0501218238775", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"324.6014618865297", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"324.6014618865297", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"325.15280194918205", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"325.15280194918205", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"325.7041420118343", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"325.7041420118343", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"326.2554820744866", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"326.2554820744866", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"326.80682213713885", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"326.80682213713885", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"327.3581621997912", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"327.3581621997912", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"327.9095022624434", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"327.9095022624434", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"328.46084232509565", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"328.46084232509565", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"329.012182387748", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"329.012182387748", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"329.5635224504002", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"329.5635224504002", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"330.11486251305257", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"330.11486251305257", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"330.6662025757048", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"330.6662025757048", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"331.21754263835714", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"331.21754263835714", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"331.7688827010094", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"331.7688827010094", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"332.3202227636617", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"332.3202227636617", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"332.87156282631395", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"332.87156282631395", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"333.4229028889662", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"333.4229028889662", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"333.9742429516185", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"333.9742429516185", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"334.52558301427075", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"334.52558301427075", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"335.0769230769231", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"335.0769230769231", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"335.6282631395753", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"335.6282631395753", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"336.17960320222767", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"336.17960320222767", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"336.7309432648799", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"336.7309432648799", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"337.2822833275322", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"337.2822833275322", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"337.83362339018447", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"337.83362339018447", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"338.3849634528367", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"338.3849634528367", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"338.93630351548904", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"338.93630351548904", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"339.4876435781413", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"339.4876435781413", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"340.0389836407936", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"340.0389836407936", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"340.59032370344585", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"340.59032370344585", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"341.1416637660982", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"341.1416637660982", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"341.6930038287504", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"341.6930038287504", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"342.24434389140265", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"342.24434389140265", ",", "1.3855384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"342.795683954055", ",", "1.3855384615384616"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"342.795683954055", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"343.3470240167072", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"343.3470240167072", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"343.89836407935957", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"343.89836407935957", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"344.4497041420118", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"344.4497041420118", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"345.00104420466414", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"345.00104420466414", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"345.55238426731637", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"345.55238426731637", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"346.1037243299687", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"346.1037243299687", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"346.65506439262094", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"346.65506439262094", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"347.2064044552732", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"347.2064044552732", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"347.7577445179255", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"347.7577445179255", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"348.30908458057775", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"348.30908458057775", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"348.8604246432301", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"348.8604246432301", ",", "1.3870615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"349.4117647058823", ",", "1.3870615384615383"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"349.4117647058823", ",", "1.3852153846153845"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"349.96310476853466", ",", "1.3852153846153845"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"349.96310476853466", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"350.5144448311869", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"350.5144448311869", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"351.0657848938392", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"351.0657848938392", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"351.61712495649147", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"351.61712495649147", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"352.1684650191437", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"352.1684650191437", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"352.71980508179604", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"352.71980508179604", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"353.27114514444827", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"353.27114514444827", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"353.8224852071006", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"353.8224852071006", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"354.37382526975284", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"354.37382526975284", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"354.9251653324052", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"354.9251653324052", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"355.4765053950574", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"355.4765053950574", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"356.0278454577097", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"356.0278454577097", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"356.579185520362", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"356.579185520362", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"357.1305255830142", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"357.1305255830142", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"357.68186564566656", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"357.68186564566656", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"358.2332057083188", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"358.2332057083188", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"358.78454577097114", ",", "1.385076923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"358.78454577097114", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"359.33588583362337", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"359.33588583362337", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"359.8872258962757", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"359.8872258962757", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"360.43856595892794", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"360.43856595892794", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"360.98990602158017", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"360.98990602158017", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"361.5412460842325", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"361.5412460842325", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"362.09258614688474", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"362.09258614688474", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"362.6439262095371", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"362.6439262095371", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"363.1952662721893", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"363.1952662721893", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"363.74660633484166", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"363.74660633484166", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"364.2979463974939", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"364.2979463974939", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"364.8492864601462", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"364.8492864601462", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"365.40062652279846", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"365.40062652279846", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"365.9519665854507", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"365.9519665854507", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"366.50330664810303", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"366.50330664810303", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"367.05464671075526", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"367.05464671075526", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"367.6059867734076", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"367.6059867734076", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"368.15732683605984", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"368.15732683605984", ",", "1.3849846153846153"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"368.7086668987122", ",", "1.3849846153846153"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"368.7086668987122", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"369.2600069613644", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"369.2600069613644", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"369.8113470240167", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"369.8113470240167", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"370.362687086669", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"370.362687086669", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"370.9140271493212", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"370.9140271493212", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"371.46536721197356", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"371.46536721197356", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"372.0167072746258", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"372.0167072746258", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"372.56804733727813", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"372.56804733727813", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"373.11938739993036", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"373.11938739993036", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"373.6707274625827", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"373.6707274625827", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"374.22206752523493", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"374.22206752523493", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"374.77340758788716", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"374.77340758788716", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"375.3247476505395", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"375.3247476505395", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"375.87608771319174", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"375.87608771319174", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"376.4274277758441", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"376.4274277758441", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"376.9787678384963", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"376.9787678384963", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"377.53010790114865", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"377.53010790114865", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"378.0814479638009", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"378.0814479638009", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"378.6327880264532", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"378.6327880264532", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"379.18412808910546", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"379.18412808910546", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"379.7354681517577", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"379.7354681517577", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"380.28680821441003", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"380.28680821441003", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"380.83814827706226", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"380.83814827706226", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"381.3894883397146", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"381.3894883397146", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"381.94082840236683", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"381.94082840236683", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"382.4921684650192", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"382.4921684650192", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"383.0435085276714", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"383.0435085276714", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"383.5948485903237", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"383.5948485903237", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"384.146188652976", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"384.146188652976", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"384.6975287156282", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"384.6975287156282", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"385.24886877828055", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"385.24886877828055", ",", "1.3850307692307693"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"385.8002088409328", ",", "1.3850307692307693"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"385.8002088409328", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"386.3515489035851", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"386.3515489035851", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"386.90288896623736", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"386.90288896623736", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"387.4542290288897", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"387.4542290288897", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"388.00556909154193", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"388.00556909154193", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"388.55690915419416", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"388.55690915419416", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"389.1082492168465", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"389.1082492168465", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"389.65958927949873", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"389.65958927949873", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"390.2109293421511", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"390.2109293421511", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"390.7622694048033", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"390.7622694048033", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"391.31360946745565", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"391.31360946745565", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"391.8649495301079", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"391.8649495301079", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"392.4162895927602", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"392.4162895927602", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"392.96762965541245", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"392.96762965541245", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"393.5189697180647", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"393.5189697180647", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"394.070309780717", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"394.070309780717", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"394.62164984336925", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"394.62164984336925", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"395.1729899060216", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"395.1729899060216", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"395.7243299686738", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"395.7243299686738", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"396.2756700313262", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"396.2756700313262", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"396.8270100939784", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"396.8270100939784", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"397.3783501566307", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"397.3783501566307", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"397.929690219283", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"397.929690219283", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"398.4810302819352", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"398.4810302819352", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"399.03237034458755", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"399.03237034458755", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"399.5837104072398", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"399.5837104072398", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"400.1350504698921", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"400.1350504698921", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"400.68639053254435", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"400.68639053254435", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"401.2377305951967", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"401.2377305951967", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"401.7890706578489", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"401.7890706578489", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"402.3404107205012", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"402.3404107205012", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"402.8917507831535", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"402.8917507831535", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"403.4430908458057", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"403.4430908458057", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"403.99443090845807", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"403.99443090845807", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"404.5457709711103", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"404.5457709711103", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"405.09711103376264", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"405.09711103376264", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"405.6484510964149", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"405.6484510964149", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"406.1997911590672", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"406.1997911590672", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"406.75113122171945", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"406.75113122171945", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"407.3024712843717", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"407.3024712843717", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"407.853811347024", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"407.853811347024", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"408.40515140967625", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"408.40515140967625", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"408.9564914723286", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"408.9564914723286", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"409.5078315349808", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"409.5078315349808", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"410.05917159763317", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"410.05917159763317", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"410.6105116602854", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"410.6105116602854", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"411.1618517229377", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"411.1618517229377", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"411.71319178558997", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"411.71319178558997", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"412.2645318482422", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"412.2645318482422", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"412.81587191089454", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"412.81587191089454", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"413.3672119735468", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"413.3672119735468", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"413.9185520361991", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"413.9185520361991", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"414.46989209885135", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"414.46989209885135", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"415.0212321615037", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"415.0212321615037", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"415.5725722241559", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"415.5725722241559", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"416.1239122868082", ",", "1.385123076923077"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"416.1239122868082", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"416.6752523494605", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"416.6752523494605", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"417.2265924121127", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"417.2265924121127", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"417.77793247476507", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"417.77793247476507", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"418.3292725374173", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"418.3292725374173", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"418.88061260006964", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"418.88061260006964", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"419.43195266272187", ",", "1.3849384615384615"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"419.43195266272187", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"419.9832927253742", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"419.9832927253742", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"420.53463278802644", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"420.53463278802644", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"421.0859728506787", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"421.0859728506787", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"421.637312913331", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"421.637312913331", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"422.18865297598325", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"422.18865297598325", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"422.7399930386356", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"422.7399930386356", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"423.2913331012878", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"423.2913331012878", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"423.84267316394016", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"423.84267316394016", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"424.3940132265924", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"424.3940132265924", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"424.9453532892447", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"424.9453532892447", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"425.49669335189697", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"425.49669335189697", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"426.0480334145492", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"426.0480334145492", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"426.59937347720154", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"426.59937347720154", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"427.15071353985377", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"427.15071353985377", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"427.7020536025061", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"427.7020536025061", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"428.25339366515834", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"428.25339366515834", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"428.8047337278107", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"428.8047337278107", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"429.3560737904629", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"429.3560737904629", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"429.9074138531152", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"429.9074138531152", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"430.4587539157675", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"430.4587539157675", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"431.0100939784197", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"431.0100939784197", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"431.56143404107206", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"431.56143404107206", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"432.1127741037243", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"432.1127741037243", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"432.66411416637663", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"432.66411416637663", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"433.21545422902886", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"433.21545422902886", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"433.7667942916812", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"433.7667942916812", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"434.31813435433344", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"434.31813435433344", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"434.86947441698567", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"434.86947441698567", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"435.420814479638", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"435.420814479638", ",", "1.3855384615384616"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"435.97215454229024", ",", "1.3855384615384616"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"435.97215454229024", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"436.5234946049426", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"436.5234946049426", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"437.0748346675948", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"437.0748346675948", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"437.62617473024716", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"437.62617473024716", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"438.1775147928994", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"438.1775147928994", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"438.72885485555173", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"438.72885485555173", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"439.28019491820396", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"439.28019491820396", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"439.8315349808562", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"439.8315349808562", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"440.38287504350853", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"440.38287504350853", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"440.93421510616076", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"440.93421510616076", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"441.4855551688131", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"441.4855551688131", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"442.03689523146534", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"442.03689523146534", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"442.5882352941177", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"442.5882352941177", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"443.1395753567699", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"443.1395753567699", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"443.6909154194222", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"443.6909154194222", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"444.2422554820745", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"444.2422554820745", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"444.7935955447267", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"444.7935955447267", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"445.34493560737906", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"445.34493560737906", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"445.8962756700313", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"445.8962756700313", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"446.44761573268363", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"446.44761573268363", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"446.99895579533586", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"446.99895579533586", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"447.5502958579882", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"447.5502958579882", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"448.10163592064043", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"448.10163592064043", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"448.65297598329266", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"448.65297598329266", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"449.204316045945", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"449.204316045945", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"449.75565610859724", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"449.75565610859724", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"450.3069961712496", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"450.3069961712496", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"450.8583362339018", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"450.8583362339018", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"451.40967629655415", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"451.40967629655415", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"451.9610163592064", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"451.9610163592064", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"452.5123564218587", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"452.5123564218587", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"453.06369648451096", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"453.06369648451096", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"453.6150365471632", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"453.6150365471632", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"454.16637660981553", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"454.16637660981553", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"454.71771667246776", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"454.71771667246776", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"455.2690567351201", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"455.2690567351201", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"455.82039679777233", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"455.82039679777233", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"456.3717368604247", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"456.3717368604247", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"456.9230769230769", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"456.9230769230769", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"457.4744169857292", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"457.4744169857292", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"458.0257570483815", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"458.0257570483815", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"458.5770971110337", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"458.5770971110337", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"459.12843717368605", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"459.12843717368605", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"459.6797772363383", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"459.6797772363383", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"460.2311172989906", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"460.2311172989906", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"460.78245736164286", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"460.78245736164286", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"461.3337974242952", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"461.3337974242952", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"461.88513748694743", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"461.88513748694743", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"462.4364775495997", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"462.4364775495997", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"462.987817612252", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"462.987817612252", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"463.53915767490423", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"463.53915767490423", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"464.0904977375566", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"464.0904977375566", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"464.6418378002088", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"464.6418378002088", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"465.19317786286115", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"465.19317786286115", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"465.7445179255134", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"465.7445179255134", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"466.2958579881657", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"466.2958579881657", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"466.84719805081795", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"466.84719805081795", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"467.3985381134702", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"467.3985381134702", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"467.9498781761225", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"467.9498781761225", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"468.50121823877475", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"468.50121823877475", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"469.0525583014271", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"469.0525583014271", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"469.6038983640793", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"469.6038983640793", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"470.15523842673167", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"470.15523842673167", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"470.7065784893839", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"470.7065784893839", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"471.2579185520362", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"471.2579185520362", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"471.8092586146885", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"471.8092586146885", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"472.3605986773407", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"472.3605986773407", ",", "1.3848923076923076"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"472.91193873999305", ",", "1.3848923076923076"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"472.91193873999305", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"473.4632788026453", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"473.4632788026453", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"474.0146188652976", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"474.0146188652976", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"474.56595892794985", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"474.56595892794985", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"475.1172989906022", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"475.1172989906022", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"475.6686390532544", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"475.6686390532544", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"476.2199791159067", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"476.2199791159067", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"476.771319178559", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"476.771319178559", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"477.3226592412112", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"477.3226592412112", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"477.87399930386357", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"477.87399930386357", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"478.4253393665158", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"478.4253393665158", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"478.97667942916814", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"478.97667942916814", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"479.5280194918204", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"479.5280194918204", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"480.0793595544727", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"480.0793595544727", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"480.63069961712495", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"480.63069961712495", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"481.1820396797772", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"481.1820396797772", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"481.7333797424295", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"481.7333797424295", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"482.28471980508175", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"482.28471980508175", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"482.8360598677341", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"482.8360598677341", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"483.3873999303863", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"483.3873999303863", ",", "1.3848461538461538"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"483.93873999303867", ",", "1.3848461538461538"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"483.93873999303867", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"484.4900800556909", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"484.4900800556909", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"485.04142011834324", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"485.04142011834324", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"485.59276018099547", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"485.59276018099547", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"486.1441002436477", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"486.1441002436477", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"486.69544030630004", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"486.69544030630004", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"487.2467803689523", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"487.2467803689523", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"487.7981204316046", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"487.7981204316046", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"488.34946049425685", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"488.34946049425685", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"488.9008005569092", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"488.9008005569092", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"489.4521406195614", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"489.4521406195614", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"490.0034806822137", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"490.0034806822137", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"490.554820744866", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"490.554820744866", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"491.1061608075182", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"491.1061608075182", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"491.65750087017057", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"491.65750087017057", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"492.2088409328228", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"492.2088409328228", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"492.76018099547514", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"492.76018099547514", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"493.31152105812737", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"493.31152105812737", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"493.8628611207797", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"493.8628611207797", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"494.41420118343194", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"494.41420118343194", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"494.9655412460842", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"494.9655412460842", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"495.5168813087365", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"495.5168813087365", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"496.06822137138874", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"496.06822137138874", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"496.6195614340411", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"496.6195614340411", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"497.1709014966933", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"497.1709014966933", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"497.72224155934566", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"497.72224155934566", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"498.2735816219979", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"498.2735816219979", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"498.82492168465023", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"498.82492168465023", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"499.37626174730246", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"499.37626174730246", ",", "1.3848"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"499.9276018099547", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"499.9276018099547", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"500.47894187260704", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"500.47894187260704", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"501.03028193525927", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"501.03028193525927", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"501.5816219979116", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"501.5816219979116", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"502.13296206056384", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"502.13296206056384", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"502.6843021232162", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"502.6843021232162", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"503.2356421858684", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"503.2356421858684", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"503.7869822485207", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"503.7869822485207", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"504.338322311173", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"504.338322311173", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"504.8896623738252", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"504.8896623738252", ",", "1.3847538461538462"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"505.44100243647756", ",", "1.3847538461538462"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"505.44100243647756", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"505.9923424991298", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"505.9923424991298", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"506.54368256178213", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"506.54368256178213", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"507.09502262443436", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"507.09502262443436", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"507.6463626870867", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"507.6463626870867", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"508.19770274973894", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"508.19770274973894", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"508.7490428123912", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"508.7490428123912", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"509.3003828750435", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"509.3003828750435", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"509.85172293769574", ",", "1.3847076923076922"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"509.85172293769574", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"510.4030630003481", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"510.4030630003481", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"510.9544030630003", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"510.9544030630003", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"511.50574312565266", ",", "1.3846153846153846"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"511.50574312565266", ",", "1.3846615384615384"}],
                     "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"512.0570831883049", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"512.0570831883049", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"512.6084232509572", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"512.6084232509572", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"513.1597633136096", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"513.1597633136096", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"513.7111033762617", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"513.7111033762617", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"514.262443438914", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"514.262443438914", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"514.8137835015664", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"514.8137835015664", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"515.3651235642185", ",", "1.3848"}], "}"}], ",", 
                    
                    RowBox[{"{", 
                    RowBox[{"515.3651235642185", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"515.9164636268708", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"515.9164636268708", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"516.4678036895232", ",", "1.385676923076923"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"516.4678036895232", ",", "1.3873846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"517.0191437521754", ",", "1.3873846153846154"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"517.0191437521754", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"517.5704838148276", ",", "1.3849384615384615"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"517.5704838148276", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"518.12182387748", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"518.12182387748", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"518.6731639401323", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"518.6731639401323", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"519.2245040027846", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"519.2245040027846", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"519.7758440654368", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"519.7758440654368", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"520.3271841280891", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"520.3271841280891", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"520.8785241907414", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"520.8785241907414", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"521.4298642533936", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"521.4298642533936", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"521.9812043160459", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"521.9812043160459", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"522.5325443786983", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"522.5325443786983", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"523.0838844413505", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"523.0838844413505", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"523.6352245040027", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"523.6352245040027", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"524.1865645666551", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"524.1865645666551", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"524.7379046293074", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"524.7379046293074", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"525.2892446919595", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"525.2892446919595", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"525.8405847546119", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"525.8405847546119", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"526.3919248172642", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"526.3919248172642", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"526.9432648799165", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"526.9432648799165", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"527.4946049425687", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"527.4946049425687", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"528.045945005221", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"528.045945005221", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"528.5972850678734", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"528.5972850678734", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"529.1486251305255", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"529.1486251305255", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"529.6999651931778", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"529.6999651931778", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"530.2513052558302", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"530.2513052558302", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"530.8026453184824", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"530.8026453184824", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"531.3539853811346", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"531.3539853811346", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"531.905325443787", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"531.905325443787", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"532.4566655064393", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"532.4566655064393", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"533.0080055690916", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"533.0080055690916", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"533.5593456317438", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"533.5593456317438", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"534.1106856943961", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"534.1106856943961", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"534.6620257570484", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"534.6620257570484", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"535.2133658197006", ",", "1.3847076923076922"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"535.2133658197006", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"535.7647058823529", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"535.7647058823529", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"536.3160459450053", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"536.3160459450053", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"536.8673860076575", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"536.8673860076575", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"537.4187260703097", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"537.4187260703097", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"537.9700661329621", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"537.9700661329621", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"538.5214061956144", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"538.5214061956144", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"539.0727462582665", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"539.0727462582665", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"539.6240863209189", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"539.6240863209189", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"540.1754263835712", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"540.1754263835712", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"540.7267664462235", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"540.7267664462235", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"541.2781065088757", ",", "1.3846615384615384"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"541.2781065088757", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"541.829446571528", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"541.829446571528", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"542.3807866341804", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"542.3807866341804", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"542.9321266968326", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"542.9321266968326", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"543.4834667594848", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"543.4834667594848", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"544.0348068221372", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"544.0348068221372", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"544.5861468847894", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"544.5861468847894", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"545.1374869474416", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"545.1374869474416", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"545.688827010094", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"545.688827010094", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"546.2401670727463", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"546.2401670727463", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"546.7915071353985", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"546.7915071353985", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"547.3428471980508", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"547.3428471980508", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"547.8941872607031", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"547.8941872607031", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"548.4455273233553", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"548.4455273233553", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"548.9968673860076", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"548.9968673860076", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"549.5482074486599", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"549.5482074486599", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"550.0995475113123", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"550.0995475113123", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"550.6508875739645", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"550.6508875739645", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"551.2022276366167", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"551.2022276366167", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"551.7535676992691", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"551.7535676992691", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"552.3049077619214", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"552.3049077619214", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"552.8562478245735", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"552.8562478245735", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"553.4075878872259", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"553.4075878872259", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"553.9589279498782", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"553.9589279498782", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"554.5102680125304", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"554.5102680125304", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"555.0616080751827", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"555.0616080751827", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"555.612948137835", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"555.612948137835", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"556.1642882004874", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"556.1642882004874", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"556.7156282631396", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"556.7156282631396", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"557.2669683257918", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"557.2669683257918", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"557.8183083884442", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"557.8183083884442", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"558.3696484510964", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"558.3696484510964", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"558.9209885137486", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"558.9209885137486", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"559.472328576401", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"559.472328576401", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"560.0236686390533", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"560.0236686390533", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"560.5750087017055", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"560.5750087017055", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"561.1263487643578", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"561.1263487643578", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"561.6776888270101", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"561.6776888270101", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"562.2290288896623", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"562.2290288896623", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"562.7803689523146", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"562.7803689523146", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"563.3317090149669", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"563.3317090149669", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"563.8830490776193", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"563.8830490776193", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"564.4343891402715", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"564.4343891402715", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"564.9857292029237", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"564.9857292029237", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"565.5370692655761", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"565.5370692655761", ",", "1.3846153846153846"}], 
                    "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"565.8127392969022", ",", "1.3846153846153846"}], 
                    "}"}]}], "}"}], "]"}]}], "}"}]}], "}"}], ",", 
                    RowBox[{"Frame", "\[Rule]", "False"}], ",", 
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0.", ",", "93.17647058823529"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.", ",", "72."}], "}"}]}], "}"}]}], ",", 
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"93.17647058823529", ",", "72."}], "}"}]}]}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}]}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"FaceForm", "[", "None", "]"}], ",", 
                   RowBox[{"Rectangle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1."}], ",", 
                    RowBox[{"-", "1."}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"94.1764705882353", ",", "73."}], "}"}]}], "]"}], 
                   ",", 
                   RowBox[{"Inset", "[", 
                    RowBox[{
                    RowBox[{"Graphics", "[", 
                    RowBox[{
                    RowBox[{"{", "}"}], ",", 
                    RowBox[{"Frame", "\[Rule]", "False"}], ",", 
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1."}], ",", "94.1764705882353"}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1."}], ",", "73."}], "}"}]}], "}"}]}], ",", 
                    
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"95.1764705882353", ",", "74."}], "}"}]}]}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}]}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"FaceForm", "[", "None", "]"}], ",", 
                   RowBox[{"Rectangle", "[", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1."}], ",", 
                    RowBox[{"-", "1."}]}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"94.1764705882353", ",", "73."}], "}"}]}], "]"}], 
                   ",", 
                   RowBox[{"Inset", "[", 
                    RowBox[{
                    RowBox[{"Graphics", "[", 
                    RowBox[{
                    RowBox[{"{", "}"}], ",", 
                    RowBox[{"Frame", "\[Rule]", "False"}], ",", 
                    RowBox[{"PlotRange", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1."}], ",", "94.1764705882353"}], "}"}], 
                    ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1."}], ",", "73."}], "}"}]}], "}"}]}], ",", 
                    
                    RowBox[{"ImageSize", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"95.1764705882353", ",", "74."}], "}"}]}]}], 
                    "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}]}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"Text", "[", 
                   RowBox[{
                    RowBox[{"Framed", "[", 
                    RowBox[{
                    RowBox[{"Invisible", "[", 
                    RowBox[{"Style", "[", 
                    RowBox[{
                    RowBox[{
                    "DisplayForm", "[", 
                    "\"\<\[ScriptCapitalS]\[ScriptC]\[ScriptI]\
\[ScriptCapitalD]\[ScriptR]\[ScriptA]\[ScriptW]\>\"", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "14.5"}], ",", 
                    RowBox[{"FontSlant", "\[Rule]", "Plain"}], ",", 
                    RowBox[{"FontTracking", "\[Rule]", "\"\<Extended\>\""}], 
                    ",", 
                    RowBox[{"FontVariations", "\[Rule]", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
                    RowBox[{"ShowAutoStyles", "\[Rule]", "False"}], ",", 
                    RowBox[{"SingleLetterItalics", "\[Rule]", "False"}]}], 
                    "}"}]}], "]"}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Background", "\[Rule]", "None"}], ",", 
                    RowBox[{"FrameStyle", "\[Rule]", "None"}], ",", 
                    RowBox[{"FrameMargins", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}], ",", 
                    RowBox[{"RoundingRadius", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}]}], ",", 
                    RowBox[{"ContentPadding", "\[Rule]", "False"}]}], "}"}]}],
                     "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"4.658823529411765", ",", "64.8"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "0"}], "}"}]}], "]"}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{"Text", "[", 
                   RowBox[{
                    RowBox[{"Framed", "[", 
                    RowBox[{
                    RowBox[{"Style", "[", 
                    RowBox[{
                    RowBox[{
                    "DisplayForm", "[", 
                    "\"\<\[ScriptCapitalS]\[ScriptC]\[ScriptI]\
\[ScriptCapitalD]\[ScriptR]\[ScriptA]\[ScriptW]\>\"", "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
                    RowBox[{"FontSize", "\[Rule]", "14.5"}], ",", 
                    RowBox[{"FontSlant", "\[Rule]", "Plain"}], ",", 
                    RowBox[{"FontTracking", "\[Rule]", "\"\<Extended\>\""}], 
                    ",", 
                    RowBox[{"FontVariations", "\[Rule]", 
                    RowBox[{"{", "}"}]}], ",", 
                    RowBox[{"FontWeight", "\[Rule]", "Bold"}], ",", 
                    RowBox[{"ShowAutoStyles", "\[Rule]", "False"}], ",", 
                    RowBox[{"SingleLetterItalics", "\[Rule]", "False"}]}], 
                    "}"}]}], "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"Background", "\[Rule]", "None"}], ",", 
                    RowBox[{"FrameStyle", "\[Rule]", "None"}], ",", 
                    RowBox[{"FrameMargins", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}], ",", 
                    RowBox[{"RoundingRadius", "\[Rule]", 
                    RowBox[{"{", 
                    RowBox[{"0", ",", "0"}], "}"}]}], ",", 
                    RowBox[{"ContentPadding", "\[Rule]", "False"}]}], "}"}]}],
                     "]"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"4.658823529411765", ",", "64.8"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"1", ",", "0"}], "}"}]}], "]"}], "}"}]}], "}"}], 
               ",", 
               RowBox[{"Frame", "\[Rule]", "False"}], ",", 
               RowBox[{"PlotRange", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"0.", ",", "93.1764705882353"}], "}"}], ",", 
                  RowBox[{"{", 
                   RowBox[{"0.", ",", "72."}], "}"}]}], "}"}]}], ",", 
               RowBox[{"ImageSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"93.1764705882353", ",", "72."}], "}"}]}]}], "]"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}]}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"FaceForm", "[", "None", "]"}], ",", 
           RowBox[{"Rectangle", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1."}], ",", 
               RowBox[{"-", "1."}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"94.1764705882353", ",", "73."}], "}"}]}], "]"}], ",", 
           RowBox[{"Inset", "[", 
            RowBox[{
             RowBox[{"Graphics", "[", 
              RowBox[{
               RowBox[{"{", "}"}], ",", 
               RowBox[{"Frame", "\[Rule]", "False"}], ",", 
               RowBox[{"PlotRange", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "1."}], ",", "94.1764705882353"}], "}"}], 
                  ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "1."}], ",", "73."}], "}"}]}], "}"}]}], ",", 
               
               RowBox[{"ImageSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"95.1764705882353", ",", "74."}], "}"}]}]}], "]"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}]}], "]"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"FaceForm", "[", "None", "]"}], ",", 
           RowBox[{"Rectangle", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{
               RowBox[{"-", "1."}], ",", 
               RowBox[{"-", "1."}]}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"94.1764705882353", ",", "73."}], "}"}]}], "]"}], ",", 
           RowBox[{"Inset", "[", 
            RowBox[{
             RowBox[{"Graphics", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.333333", ",", "0.333333", ",", "0.333333"}], 
                    "]"}], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1", "]"}], ",", 
                   RowBox[{"AbsoluteDashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                   RowBox[{"CapForm", "[", "None", "]"}], ",", 
                   RowBox[{"JoinForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<Miter\>\"", ",", "3.25"}], "}"}], "]"}], ",", 
                   RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0.", ",", "0."}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"0.", ",", "72."}], "}"}]}], "}"}], "]"}]}], 
                  "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.333333", ",", "0.333333", ",", "0.333333"}], 
                    "]"}], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1", "]"}], ",", 
                   RowBox[{"AbsoluteDashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                   RowBox[{"CapForm", "[", "None", "]"}], ",", 
                   RowBox[{"JoinForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<Miter\>\"", ",", "3.25"}], "}"}], "]"}], ",", 
                   RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", "}"}], ",", 
                    RowBox[{"{", "}"}]}], "}"}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.333333", ",", "0.333333", ",", "0.333333"}], 
                    "]"}], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1", "]"}], ",", 
                   RowBox[{"AbsoluteDashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                   RowBox[{"CapForm", "[", "None", "]"}], ",", 
                   RowBox[{"JoinForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<Miter\>\"", ",", "3.25"}], "}"}], "]"}]}], 
                  "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.333333", ",", "0.333333", ",", "0.333333"}], 
                    "]"}], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1", "]"}], ",", 
                   RowBox[{"AbsoluteDashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                   RowBox[{"CapForm", "[", "None", "]"}], ",", 
                   RowBox[{"JoinForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<Miter\>\"", ",", "3.25"}], "}"}], "]"}], ",", 
                   RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"93.1764705882353", ",", "0."}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"93.1764705882353", ",", "72."}], "}"}]}], "}"}], 
                    "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.333333", ",", "0.333333", ",", "0.333333"}], 
                    "]"}], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1", "]"}], ",", 
                   RowBox[{"AbsoluteDashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                   RowBox[{"CapForm", "[", "None", "]"}], ",", 
                   RowBox[{"JoinForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<Miter\>\"", ",", "3.25"}], "}"}], "]"}], ",", 
                   RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", "}"}], ",", 
                    RowBox[{"{", "}"}]}], "}"}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.333333", ",", "0.333333", ",", "0.333333"}], 
                    "]"}], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1", "]"}], ",", 
                   RowBox[{"AbsoluteDashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                   RowBox[{"CapForm", "[", "None", "]"}], ",", 
                   RowBox[{"JoinForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<Miter\>\"", ",", "3.25"}], "}"}], "]"}]}], 
                  "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.333333", ",", "0.333333", ",", "0.333333"}], 
                    "]"}], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1", "]"}], ",", 
                   RowBox[{"AbsoluteDashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                   RowBox[{"CapForm", "[", "None", "]"}], ",", 
                   RowBox[{"JoinForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<Miter\>\"", ",", "3.25"}], "}"}], "]"}], ",", 
                   RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0.", ",", "0."}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"93.1764705882353", ",", "0."}], "}"}]}], "}"}], 
                    "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.333333", ",", "0.333333", ",", "0.333333"}], 
                    "]"}], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1", "]"}], ",", 
                   RowBox[{"AbsoluteDashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                   RowBox[{"CapForm", "[", "None", "]"}], ",", 
                   RowBox[{"JoinForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<Miter\>\"", ",", "3.25"}], "}"}], "]"}], ",", 
                   RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", "}"}], ",", 
                    RowBox[{"{", "}"}]}], "}"}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.333333", ",", "0.333333", ",", "0.333333"}], 
                    "]"}], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1", "]"}], ",", 
                   RowBox[{"AbsoluteDashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                   RowBox[{"CapForm", "[", "None", "]"}], ",", 
                   RowBox[{"JoinForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<Miter\>\"", ",", "3.25"}], "}"}], "]"}]}], 
                  "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.333333", ",", "0.333333", ",", "0.333333"}], 
                    "]"}], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1", "]"}], ",", 
                   RowBox[{"AbsoluteDashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                   RowBox[{"CapForm", "[", "None", "]"}], ",", 
                   RowBox[{"JoinForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<Miter\>\"", ",", "3.25"}], "}"}], "]"}], ",", 
                   RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"0.", ",", "72."}], "}"}], ",", 
                    RowBox[{"{", 
                    RowBox[{"93.1764705882353", ",", "72."}], "}"}]}], "}"}], 
                    "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.333333", ",", "0.333333", ",", "0.333333"}], 
                    "]"}], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1", "]"}], ",", 
                   RowBox[{"AbsoluteDashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                   RowBox[{"CapForm", "[", "None", "]"}], ",", 
                   RowBox[{"JoinForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<Miter\>\"", ",", "3.25"}], "}"}], "]"}], ",", 
                   RowBox[{"Line", "[", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"{", "}"}], ",", 
                    RowBox[{"{", "}"}]}], "}"}], "]"}]}], "}"}], ",", 
                 RowBox[{"{", 
                  RowBox[{
                   RowBox[{"RGBColor", "[", 
                    RowBox[{"0.333333", ",", "0.333333", ",", "0.333333"}], 
                    "]"}], ",", 
                   RowBox[{"AbsoluteThickness", "[", "1", "]"}], ",", 
                   RowBox[{"AbsoluteDashing", "[", 
                    RowBox[{"{", "}"}], "]"}], ",", 
                   RowBox[{"CapForm", "[", "None", "]"}], ",", 
                   RowBox[{"JoinForm", "[", 
                    RowBox[{"{", 
                    RowBox[{"\"\<Miter\>\"", ",", "3.25"}], "}"}], "]"}]}], 
                  "}"}]}], "}"}], ",", 
               RowBox[{"Frame", "\[Rule]", "False"}], ",", 
               RowBox[{"PlotRange", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "1."}], ",", "94.1764705882353"}], "}"}], 
                  ",", 
                  RowBox[{"{", 
                   RowBox[{
                    RowBox[{"-", "1."}], ",", "73."}], "}"}]}], "}"}]}], ",", 
               
               RowBox[{"ImageSize", "\[Rule]", 
                RowBox[{"{", 
                 RowBox[{"95.1764705882353", ",", "74."}], "}"}]}]}], "]"}], 
             ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"0", ",", "0"}], "}"}]}], "]"}]}], "}"}]}], "}"}], ",", 
       
       RowBox[{"{", "}"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"PlotRange", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1."}], ",", "94.1764705882353"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"-", "1."}], ",", "73."}], "}"}]}], "}"}]}], ",", 
       RowBox[{"ImageSize", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"95.1764705882353", ",", "74."}], "}"}]}], ",", 
       RowBox[{"AspectRatio", "\[Rule]", "0.7775030902348578"}], ",", 
       RowBox[{"Frame", "\[Rule]", "False"}], ",", 
       RowBox[{"Background", "\[Rule]", "None"}], ",", 
       RowBox[{"DisplayFunction", "\[Rule]", "Identity"}]}], "}"}]}], "]"}]}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.579618405851022*^9, 3.5796184296190567`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Display splash", "Subsection",
 CellChangeTimes->{{3.515438395000375*^9, 3.5154383978285*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"SplashContents", "=", 
   RowBox[{"Row", "[", "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"GridBox", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"Row", "[", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"Style", "[", 
                  RowBox[{
                   TagBox[
                    
                    StyleBox[
                    "\"\<\\[ScriptCapitalS]\\[ScriptC]\\[ScriptI]\\[\
ScriptCapitalD]\\[ScriptR]\\[ScriptA]\\[ScriptW]:\>\"",
                    ShowSpecialCharacters->False,
                    ShowStringCharacters->True,
                    NumberMarks->True],
                    FullForm], ",", 
                   RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}], ",", 
                   RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}]}], "]"}],
                  ",", "\"\< Publication\[Dash]quality scientific figures \
with Mathematica\>\""}], "}"}], "]"}], ",", 
              RowBox[{"FontFamily", "->", "\"\<Courier\>\""}]}], "]"}], "}"}],
            ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"Style", "[", 
             RowBox[{"\"\<M. A. Caprio, University of Notre Dame\>\"", ",", 
              RowBox[{"FontFamily", "->", "\"\<Courier\>\""}]}], "]"}], "}"}],
            ",", "\[IndentingNewLine]", 
           RowBox[{"(*", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"Row", "[", 
               RowBox[{"{", 
                RowBox[{"\"\<Comput. Phys. Commun. \>\"", ",", 
                 RowBox[{"textbf", "[", "\"\<171\>\"", "]"}], ",", 
                 "\"\<, 107 (2005)\>\""}], "}"}], "]"}], "}"}], ","}], "*)"}],
            "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{"Style", "[", 
             RowBox[{
              RowBox[{"\"\<Version \>\"", "<>", "$FigVersionString"}], ",", 
              RowBox[{"FontFamily", "->", "\"\<Courier\>\""}]}], "]"}], "}"}],
            ",", "\[IndentingNewLine]", 
           RowBox[{"{", "\[IndentingNewLine]", 
            RowBox[{"RowBox", "[", 
             RowBox[{"{", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"ButtonBox", "[", "\[IndentingNewLine]", 
                RowBox[{
                 RowBox[{"StyleBox", "[", 
                  RowBox[{"\"\<View color palette\>\"", ",", 
                   RowBox[{"FontFamily", "->", "\"\<Times\>\""}]}], "]"}], 
                 ",", "\[IndentingNewLine]", 
                 RowBox[{"ButtonNote", "->", "\"\<Named color palette\>\""}], 
                 ",", 
                 RowBox[{"ButtonFunction", "\[Rule]", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"NamedColorPalette", "[", "]"}], "&"}], ")"}]}], 
                 ",", 
                 RowBox[{"Active", "\[Rule]", "True"}], ",", 
                 RowBox[{"ButtonFrame", "\[Rule]", "\"\<DialogBox\>\""}], ",", 
                 RowBox[{"ButtonExpandable", "\[Rule]", "False"}], ",", 
                 RowBox[{"Evaluator", "\[Rule]", "Automatic"}]}], 
                "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
               RowBox[{"MakeButtonForURL", "[", 
                RowBox[{
                 RowBox[{"StyleBox", "[", 
                  RowBox[{"\"\<Visit home page\>\"", ",", 
                   RowBox[{"FontFamily", "->", "\"\<Times\>\""}]}], "]"}], 
                 ",", "$FigVersionURL", ",", 
                 RowBox[{"ButtonFrame", "\[Rule]", "\"\<DialogBox\>\""}], ",", 
                 RowBox[{"ButtonExpandable", "\[Rule]", "False"}]}], "]"}]}], 
              "\[IndentingNewLine]", "}"}], "]"}], "\[IndentingNewLine]", 
            "}"}]}], "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
         RowBox[{"ColumnAlignments", "\[Rule]", "Left"}]}], 
        "\[IndentingNewLine]", "]"}], "//", "DisplayForm"}], ",", 
      "\[IndentingNewLine]", "\"\<  \>\"", ",", "\[IndentingNewLine]", 
      "SplashLogo"}], "\[IndentingNewLine]", "}"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4956600655625*^9, 3.495660069625*^9}, {
   3.514821024484375*^9, 3.514821103046875*^9}, 3.51482185125*^9, {
   3.514821905671875*^9, 3.51482190953125*^9}, {3.515085539953125*^9, 
   3.515085582015625*^9}, {3.51536027215625*^9, 3.51536027465625*^9}, {
   3.515360681375*^9, 3.51536069175*^9}, {3.51536074284375*^9, 
   3.51536074415625*^9}, 3.515423556656625*^9, {3.516296719921875*^9, 
   3.5162968013125*^9}, {3.51629684978125*^9, 3.516296894078125*^9}, 
   3.516297200828125*^9, {3.579619112724516*^9, 3.5796191132515464`*^9}, 
   3.582816301278967*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"If", "[", "\[IndentingNewLine]", 
  RowBox[{"SciDraw`Config`Splash", ",", "\[IndentingNewLine]", 
   RowBox[{"Print", "[", "\[IndentingNewLine]", 
    RowBox[{"Framed", "[", 
     RowBox[{"SplashContents", ",", 
      RowBox[{"Background", "\[Rule]", "LightGray"}], ",", 
      RowBox[{"FrameMargins", "\[Rule]", "10"}], ",", 
      RowBox[{"FrameStyle", "\[Rule]", "None"}]}], "]"}], 
    "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{
  3.395089143765625*^9, {3.398798251046875*^9, 3.39879837440625*^9}, {
   3.3987984359375*^9, 3.398798467890625*^9}, {3.39879879175*^9, 
   3.398798792359375*^9}, {3.39879892084375*^9, 3.398798976890625*^9}, 
   3.39879900734375*^9, {3.398799045765625*^9, 3.398799080015625*^9}, 
   3.3988101679375*^9, 3.39881022890625*^9, 3.39881026340625*^9, {
   3.443994581078125*^9, 3.443994586921875*^9}, {3.495660060171875*^9, 
   3.49566008028125*^9}, {3.49566016078125*^9, 3.49566017196875*^9}, {
   3.49566020234375*^9, 3.4956602059375*^9}, {3.495660362875*^9, 
   3.495660367046875*^9}, {3.495660411484375*^9, 3.49566041525*^9}, 
   3.49722440828125*^9, 3.49722444265625*^9, {3.514821832*^9, 
   3.51482183340625*^9}, {3.5796188395845375`*^9, 3.5796188397895403`*^9}}],

Cell[BoxData[
 FrameBox[
  TemplateBox[{TagBox[
     GridBox[{{
        StyleBox[
         TemplateBox[{
           StyleBox[
           "\"\[ScriptCapitalS]\[ScriptC]\[ScriptI]\[ScriptCapitalD]\[ScriptR]\
\[ScriptA]\[ScriptW]:\"", StripOnInput -> False, FontFamily -> "Times", 
            FontWeight -> "Bold"], 
           "\" Publication\[Dash]quality scientific figures with \
Mathematica\""}, "RowDefault"], StripOnInput -> False, FontFamily -> 
         "Courier"]}, {
        StyleBox[
        "\"M. A. Caprio, University of Notre Dame\"", StripOnInput -> False, 
         FontFamily -> "Courier"]}, {
        StyleBox[
        "\"Version x.xx (January 1, 20xx)\"", StripOnInput -> False, 
         FontFamily -> "Courier"]}, {
        RowBox[{
          ButtonBox[
           StyleBox[
            RowBox[{"View", " ", "color", " ", "palette"}], FontFamily -> 
            "Times"], Active -> True, Appearance -> {Automatic, "DialogBox"}, 
           ButtonFunction :> (NamedColors`NamedColorPalette[]& ), ButtonNote -> 
           "Named color palette", Evaluator -> Automatic, ImageSize -> 
           Automatic], 
          TagBox[
           ButtonBox[
            StyleBox[
             RowBox[{"Visit", " ", "home", " ", "page"}], FontFamily -> 
             "Times"], Active -> True, Appearance -> {Automatic, "DialogBox"},
             ButtonData :> {
              URL["http://scidraw.nd.edu/landing/scidraw-0.99.html"], None}, 
            ButtonFunction :> (FrontEndExecute[{
               FrontEnd`NotebookLocate[#2]}]& ), ButtonNote -> 
            "http://scidraw.nd.edu/landing/scidraw-0.99.html", ImageSize -> 
            Automatic], DisplayForm]}]}}, 
      GridBoxAlignment -> {
       "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
        "RowsIndexed" -> {}}], DisplayForm],"\"  \"",GraphicsBox[{{{
        FaceForm[None], 
        RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
        InsetBox[
         GraphicsBox[{
           EdgeForm[None], 
           FaceForm[
            RGBColor[1., 0.894101, 0.709799]], 
           RectangleBox[{0., 0.}, {93.1764705882353, 72.}]}, Frame -> False, 
          ImageSize -> {95.1764705882353, 74.}, 
          PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0, 
         0}]}, {
        FaceForm[None], 
        RectangleBox[{0., 0.}, {93.1764705882353, 72.}], 
        InsetBox[
         GraphicsBox[{{
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             GraphicsBox[{{
                GrayLevel[0], 
                AbsoluteThickness[1], 
                Dashing[{}], 
                CapForm[None], 
                JoinForm[{"Miter", 3.25}], 
                
                LineBox[{{14.782805429864256`, 46.24615384615386}, {
                 43.58047834518423, 46.24615384615386}}]}, {
                GrayLevel[0], 
                AbsoluteThickness[1], 
                Dashing[{}], 
                CapForm[None], 
                JoinForm[{"Miter", 3.25}], 
                
                LineBox[{{20.54234001292825, 36.150000000000006`}, {
                 23.54234001292825, 36.150000000000006`}, {25.54234001292825, 
                 32.400000000000006`}, {44.34001292824823, 
                 32.400000000000006`}, {46.34001292824823, 
                 36.150000000000006`}, {49.34001292824823, 
                 36.150000000000006`}}]}, {
                GrayLevel[0], 
                AbsoluteThickness[1], 
                Dashing[{}], 
                CapForm[None], 
                JoinForm[{"Miter", 3.25}], 
                
                LineBox[{{26.301874595992246`, 18.553846153846155`}, {
                 55.099547511312224`, 18.553846153846155`}}]}, {
                EdgeForm[{
                  GrayLevel[0], 
                  AbsoluteThickness[1], 
                  Dashing[{}], 
                  CapForm[None], 
                  JoinForm[{"Miter", 3.25}]}], 
                FaceForm[
                 GrayLevel[0.5]], 
                
                PolygonBox[{{34.418791692075665`, 46.24615384615386}, {
                 29.704026666036818`, 46.24615384615386}, {
                 37.415840042594645`, 33.886479882377664`}, {
                 36.90680088862935, 33.568865116143016`}, {
                 40.700711053652235`, 32.400000000000006`}, {
                 41.31847355632861, 36.321526423509994`}, {40.80943440236331, 
                 36.00391165727534}}]}, {
                EdgeForm[{
                  GrayLevel[0], 
                  AbsoluteThickness[1], 
                  Dashing[{}], 
                  CapForm[None], 
                  JoinForm[{"Miter", 3.25}]}], 
                FaceForm[
                 GrayLevel[0.5]], 
                
                PolygonBox[{{32.97890804630967, 32.400000000000006`}, {
                 28.26414302027082, 32.400000000000006`}, {35.97595639682864, 
                 20.040326036223817`}, {35.466917242863346`, 
                 19.722711269989166`}, {39.26082740788623, 
                 18.553846153846155`}, {39.87858991056261, 
                 22.47537257735614}, {39.369550756597306`, 
                 22.157757811121492`}}]}}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{0., 0.}, {93.17647058823529, 72.}], 
            InsetBox[
             GraphicsBox[{{
                EdgeForm[None], 
                FaceForm[
                 RGBColor[0.5, 0.539994, 0.53]], 
                PolygonBox[CompressedData["
1:eJx13Xk0F9//B3B7CG1SSqgkpCxFRZpRoYVIUrQoaaNFIoqkQiupT4lKpLK0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                 "]]}, {
                RGBColor[1, 0, 0], 
                AbsoluteThickness[1], 
                Dashing[{}], 
                CapForm[None], 
                JoinForm[{"Miter", 3.25}], 
                LineBox[CompressedData["
1:eJx13XlUD9//B/B2lcpSIlIhSaKFQslMqCylJGlBJFtZkiJKQmUt8VEKKSFl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                 "]]}}, Frame -> False, ImageSize -> {93.17647058823529, 72.},
               PlotRange -> {{0., 93.17647058823529}, {0., 72.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, {
            FaceForm[None], 
            RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
            InsetBox[
             
             GraphicsBox[{}, Frame -> False, 
              ImageSize -> {95.1764705882353, 74.}, 
              PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0,
              0}]}, 
           InsetBox[
            FrameBox[
             StyleBox[
              StyleBox[
               TagBox[
               "\"\[ScriptCapitalS]\[ScriptC]\[ScriptI]\[ScriptCapitalD]\
\[ScriptR]\[ScriptA]\[ScriptW]\"", DisplayForm], StripOnInput -> False, 
               ShowAutoStyles -> False, SingleLetterItalics -> False, 
               FontFamily -> "Times", FontSize -> 14.5, FontWeight -> Bold, 
               FontSlant -> Plain, FontTracking -> "Extended"], StripOnInput -> 
              False, ShowContents -> False], Background -> None, 
             ContentPadding -> False, FrameMargins -> {{0, 0}, {0, 0}}, 
             FrameStyle -> None, RoundingRadius -> {0, 0}, StripOnInput -> 
             False], {4.658823529411765, 64.8}, {-1, 1}, Automatic, {1, 0}], 
           InsetBox[
            FrameBox[
             StyleBox[
              TagBox[
              "\"\[ScriptCapitalS]\[ScriptC]\[ScriptI]\[ScriptCapitalD]\
\[ScriptR]\[ScriptA]\[ScriptW]\"", DisplayForm], StripOnInput -> False, 
              ShowAutoStyles -> False, SingleLetterItalics -> False, 
              FontFamily -> "Times", FontSize -> 14.5, FontWeight -> Bold, 
              FontSlant -> Plain, FontTracking -> "Extended"], Background -> 
             None, ContentPadding -> False, FrameMargins -> {{0, 0}, {0, 0}}, 
             FrameStyle -> None, RoundingRadius -> {0, 0}, StripOnInput -> 
             False], {4.658823529411765, 64.8}, {-1, 1}, Automatic, {1, 0}]}, 
          Frame -> False, ImageSize -> {93.1764705882353, 72.}, 
          PlotRange -> {{0., 93.1764705882353}, {0., 72.}}], {0, 0}, {0, 
         0}]}, {
        FaceForm[None], 
        RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
        InsetBox[
         GraphicsBox[{}, Frame -> False, ImageSize -> {95.1764705882353, 74.},
           PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0, 
         0}]}, {
        FaceForm[None], 
        RectangleBox[{-1., -1.}, {94.1764705882353, 73.}], 
        InsetBox[
         GraphicsBox[{{
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{0., 0.}, {0., 72.}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{}, {}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{93.1764705882353, 0.}, {93.1764705882353, 72.}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{}, {}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{0., 0.}, {93.1764705882353, 0.}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{}, {}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{0., 72.}, {93.1764705882353, 72.}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}], 
            LineBox[{{}, {}}]}, {
            RGBColor[0.333333, 0.333333, 0.333333], 
            AbsoluteThickness[1], 
            Dashing[{}], 
            CapForm[None], 
            JoinForm[{"Miter", 3.25}]}}, Frame -> False, 
          ImageSize -> {95.1764705882353, 74.}, 
          PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}], {0, 0}, {0, 
         0}]}}, {}}, AspectRatio -> 0.7775030902348578, Background -> None, 
     DisplayFunction -> Identity, Frame -> False, 
     ImageSize -> {95.1764705882353, 74.}, 
     PlotRange -> {{-1., 94.1764705882353}, {-1., 73.}}]},
   "RowDefault"],
  Background->GrayLevel[0.85],
  FrameMargins->10,
  FrameStyle->None,
  StripOnInput->False]], "Print",
 CellChangeTimes->{3.579618878695138*^9, 3.5796191174527864`*^9}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["End package", "Section",
 CellChangeTimes->{{3.514823047703125*^9, 3.51482305353125*^9}}],

Cell[CellGroupData[{

Cell["Exit private context", "Subsection",
 CellChangeTimes->{{3.514823086015625*^9, 3.5148231094375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Exit package context", "Subsection",
 CellChangeTimes->{{3.514823092890625*^9, 3.51482312965625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Unprotect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<$*\>\""}], "]"}], "]"}], ";", 
  RowBox[{"EndPackage", "[", "]"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{3.514822637765625*^9, 3.515886460296875*^9}]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1370, 753},
WindowMargins->{{Automatic, -1}, {Automatic, 0}},
WindowFrame->"Normal",
FrontEndVersion->"9.0 for Microsoft Windows (64-bit) (January 25, 2013)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "ButtonBox"->{
  Cell[6930, 188, 1206, 32, 132, "Input",
   InitializationCell->True,
   CellTags->"ButtonBox"]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"ButtonBox", 692887, 14282}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 34, 0, 71, "Section"],
Cell[616, 24, 2981, 70, 272, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[3634, 99, 145, 2, 71, "Section"],
Cell[CellGroupData[{
Cell[3804, 105, 157, 2, 36, "Subsection"],
Cell[3964, 109, 1472, 24, 31, "Input",
 InitializationCell->True],
Cell[5439, 135, 184, 5, 31, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[5660, 145, 43, 0, 36, "Subsection"],
Cell[5706, 147, 183, 4, 31, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[5904, 154, 99, 1, 36, "Subsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6040, 160, 87, 1, 71, "Section"],
Cell[CellGroupData[{
Cell[6152, 165, 138, 2, 36, "Subsection"],
Cell[6293, 169, 549, 12, 31, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[6879, 186, 48, 0, 36, "Subsection"],
Cell[6930, 188, 1206, 32, 132, "Input",
 InitializationCell->True,
 CellTags->"ButtonBox"]
}, Open  ]],
Cell[CellGroupData[{
Cell[8173, 225, 182, 2, 36, "Subsection"],
Cell[8358, 229, 634638, 13082, 27352, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[643033, 13316, 100, 1, 28, "Subsection"],
Cell[643136, 13319, 4918, 100, 512, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[648079, 13423, 1296, 22, 132, "Input",
 InitializationCell->True],
Cell[649378, 13447, 42198, 783, 106, "Print"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[691637, 14237, 95, 1, 71, "Section"],
Cell[CellGroupData[{
Cell[691757, 14242, 106, 1, 36, "Subsection"],
Cell[691866, 14245, 96, 3, 31, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[691999, 14253, 107, 1, 36, "Subsection"],
Cell[692109, 14256, 432, 11, 52, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
