(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    312186,       8936]
NotebookOptionsPosition[    294624,       8386]
NotebookOutlinePosition[    295016,       8403]
CellTagsIndexPosition[    294973,       8400]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Header comments", "Section"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Title", ":", " ", "FigText"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Context", ":", " ", "SciDraw`"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Author", ":", " ", 
      RowBox[{"Mark", " ", 
       RowBox[{"A", ".", " ", "Caprio"}]}]}]}], ",", " ", 
    RowBox[{"Department", " ", "of", " ", "Physics"}], ",", " ", 
    RowBox[{"University", " ", "of", " ", "Notre", " ", "Dame"}]}], " ", 
   "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Summary", ":", " ", 
     RowBox[{"Miscellaneous", " ", "text", " ", "formatting", " ", 
      RowBox[{"utilities", "."}]}]}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{":", 
     RowBox[{"Copyright", ":", " ", 
      RowBox[{"Copyright", " ", "2011"}]}]}], ",", " ", 
    RowBox[{"Mark", " ", 
     RowBox[{"A", ".", " ", "Caprio"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Package", " ", 
     RowBox[{"Version", ":", " ", "0.0"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{":", 
    RowBox[{"Mathematica", " ", 
     RowBox[{"Version", ":", " ", "7.0"}]}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{":", "History", ":", "\[IndentingNewLine]", 
     RowBox[{
     "Package", " ", "MCText", " ", "started", " ", "December", " ", 
      "2003"}]}], ",", " ", 
    RowBox[{
    "based", " ", "upon", " ", "functions", " ", "written", " ", "for", " ", 
     RowBox[{"LevelScheme", ".", "\[IndentingNewLine]", "Distributed"}], " ", 
     "with", " ", "the", " ", "LevelScheme", " ", 
     RowBox[{"package", ".", "\[IndentingNewLine]", "October"}], " ", "2010.",
      " ", "Context", " ", "changed", " ", "to", " ", 
     RowBox[{"LevelScheme`", ".", "\[IndentingNewLine]", "May"}], " ", 
     "2011.", "  ", "Renamed", " ", "from", " ", "MCText", " ", "to", " ", 
     RowBox[{"FigText", ".", "  ", "Context"}], " ", "changed", " ", "to", 
     " ", 
     RowBox[{"SciDraw`", "."}]}]}], "\[IndentingNewLine]", "*)"}]}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.42784100378125*^9, 3.427841006546875*^9}, {
   3.453754056546875*^9, 3.4537540963125*^9}, {3.4972228680625*^9, 
   3.497222868328125*^9}, {3.51482044753125*^9, 3.51482050815625*^9}, {
   3.515278316921875*^9, 3.515278320265625*^9}, {3.51527848246875*^9, 
   3.515278552609375*^9}, 3.5661696732942133`*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin package", "Section"],

Cell[CellGroupData[{

Cell["Package context definition", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"BeginPackage", "[", 
   RowBox[{"\"\<SciDraw`\>\"", ",", "SciDraw`Private`$ExternalContexts"}], 
   "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.395087747453125*^9, 3.39508775096875*^9}, {
   3.39509064290625*^9, 3.395090643234375*^9}, 3.395090710546875*^9, {
   3.395091175015625*^9, 3.395091179703125*^9}, {3.395093472375*^9, 
   3.39509347784375*^9}, {3.395093608140625*^9, 3.3950936085*^9}, {
   3.395519039875*^9, 3.395519061546875*^9}, {3.495041989453125*^9, 
   3.495042010953125*^9}, {3.495042158078125*^9, 3.495042163671875*^9}, {
   3.497222416421875*^9, 3.497222462578125*^9}, {3.497222963890625*^9, 
   3.497222994640625*^9}, 3.497223030953125*^9, {3.514818766734375*^9, 
   3.514818800625*^9}, {3.5148197104375*^9, 3.514819710671875*^9}, {
   3.514819841546875*^9, 3.51481994284375*^9}, {3.514819979578125*^9, 
   3.514820025046875*^9}, {3.5148201316875*^9, 3.514820154671875*^9}, {
   3.51482025234375*^9, 3.514820275171875*^9}, {3.514820309703125*^9, 
   3.514820406921875*^9}, {3.51482051775*^9, 3.514820571328125*^9}, {
   3.514820843296875*^9, 3.51482087146875*^9}, 3.51482140903125*^9, {
   3.514821446859375*^9, 3.514821449890625*^9}, 3.514821641390625*^9, {
   3.514821674609375*^9, 3.514821798390625*^9}, {3.514823407859375*^9, 
   3.514823433140625*^9}, 3.51501104184375*^9, 3.515275343*^9, {
   3.515276331390625*^9, 3.51527633303125*^9}, {3.51542275479725*^9, 
   3.515422755141*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"Unprotect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}], ";"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Begin private context", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Begin", "[", "\"\<`Private`\>\"", "]"}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.514823442859375*^9, 3.5148234431875*^9}}]
}, Open  ]],

Cell["Dependencies", "Subsection",
 CellChangeTimes->{{3.514821147359375*^9, 3.51482114978125*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Mathematical text formatting", "Section",
 CellChangeTimes->{{3.515339553625*^9, 3.515339556390625*^9}, {
  3.5337449674375*^9, 3.53374497634375*^9}}],

Cell[CellGroupData[{

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   RowBox[{"L", 
    StyleBox[
     AdjustmentBox["A",
      BoxBaselineShift->-0.2,
      BoxMargins->{{-0.36, -0.1}, {0, 0}}],
     FontSize->Smaller], "T", 
    AdjustmentBox["E",
     BoxBaselineShift->0.5,
     BoxMargins->{{-0.075, -0.085}, {0, 0}}], "X"}]]]],
 "-like text formatting"
}], "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"textup", "[", "x_", "]"}], ":=", 
   RowBox[{"StyleForm", "[", 
    RowBox[{"x", ",", 
     RowBox[{"FontSlant", "\[Rule]", "\"\<Plain\>\""}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"textsl", "[", "x_", "]"}], ":=", 
   RowBox[{"StyleForm", "[", 
    RowBox[{"x", ",", 
     RowBox[{"FontSlant", "\[Rule]", "\"\<Oblique\>\""}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"textit", "[", "x_", "]"}], ":=", 
   RowBox[{"StyleForm", "[", 
    RowBox[{"x", ",", 
     RowBox[{"FontSlant", "\[Rule]", "\"\<Italic\>\""}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"textmd", "[", "x_", "]"}], ":=", 
   RowBox[{"StyleForm", "[", 
    RowBox[{"x", ",", 
     RowBox[{"FontWeight", "\[Rule]", "\"\<Plain\>\""}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"textbf", "[", "x_", "]"}], ":=", 
   RowBox[{"StyleForm", "[", 
    RowBox[{"x", ",", 
     RowBox[{"FontWeight", "\[Rule]", "\"\<Bold\>\""}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"textrm", "[", "x_", "]"}], ":=", 
   RowBox[{"StyleForm", "[", 
    RowBox[{"x", ",", 
     RowBox[{"FontFamily", "\[Rule]", "\"\<Times\>\""}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"texttt", "[", "x_", "]"}], ":=", 
   RowBox[{"StyleForm", "[", 
    RowBox[{"x", ",", 
     RowBox[{"FontFamily", "\[Rule]", "\"\<Courier\>\""}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"textsf", "[", "x_", "]"}], ":=", 
   RowBox[{"StyleForm", "[", 
    RowBox[{"x", ",", 
     RowBox[{"FontFamily", "\[Rule]", "\"\<Helvetica\>\""}]}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"hspace", "[", "Lems_", "]"}], ":=", 
   RowBox[{"AdjustmentBox", "[", 
    RowBox[{"\"\<\>\"", ",", 
     RowBox[{"BoxMargins", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"0", ",", "Lems"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}]}], "]"}]}], ";"}]], "Input",\

 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"textsize", "[", 
    RowBox[{"s_", ",", "x_"}], "]"}], ":=", 
   RowBox[{"StyleForm", "[", 
    RowBox[{"x", ",", 
     RowBox[{"FontSize", "\[Rule]", "s"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"textcolor", "[", 
    RowBox[{"c_", ",", "x_"}], "]"}], ":=", 
   RowBox[{"StyleForm", "[", 
    RowBox[{"x", ",", 
     RowBox[{"FontColor", "\[Rule]", "c"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"texttracking", "[", 
    RowBox[{"t_", ",", "x_"}], "]"}], ":=", 
   RowBox[{"StyleForm", "[", 
    RowBox[{"x", ",", 
     RowBox[{"FontTracking", "\[Rule]", "t"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"textfamily", "[", 
    RowBox[{"f_", ",", "x_"}], "]"}], ":=", 
   RowBox[{"StyleForm", "[", 
    RowBox[{"x", ",", 
     RowBox[{"FontFamily", "\[Rule]", "f"}]}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"texthidden", "[", "x_", "]"}], ":=", 
   RowBox[{"StyleForm", "[", 
    RowBox[{"x", ",", 
     RowBox[{"ShowContents", "\[Rule]", "False"}]}], "]"}]}], ";"}]}], "Input",\

 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"textsubscript", "[", "x_", "]"}], ":=", 
   RowBox[{"SubscriptBox", "[", 
    RowBox[{"\"\<\>\"", ",", "x"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"textsuperscript", "[", "y_", "]"}], ":=", 
   RowBox[{"SuperscriptBox", "[", 
    RowBox[{"\"\<\>\"", ",", "y"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"textsubsuperscript", "[", 
    RowBox[{"x_", ",", "y_"}], "]"}], ":=", 
   RowBox[{"SubsuperscriptBox", "[", 
    RowBox[{"\"\<\>\"", ",", "x", ",", "y"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->True],

Cell["Italic correction", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "textit", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"hspace", "\[Rule]", "0"}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"textit", "[", 
    RowBox[{"x_", ",", "Opts___"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"FullOpts", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", 
         RowBox[{"Opts", ",", 
          RowBox[{"Options", "[", "textit", "]"}]}], "}"}], "]"}]}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{"AdjustmentBox", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"StyleForm", "[", 
        RowBox[{"x", ",", 
         RowBox[{"FontSlant", "\[Rule]", "\"\<Italic\>\""}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"BoxMargins", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"hspace", "/.", "FullOpts"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}]}], "\[IndentingNewLine]",
       "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["General text formatting", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"StackText", "[", 
    RowBox[{"Alignment_", ",", "Spacing_", ",", "Lines_List", ",", 
     RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"GridBox", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"{", "#", "}"}], "&"}], "/@", "Lines"}], ",", 
     RowBox[{"ColumnAlignments", "\[Rule]", "Alignment"}], ",", 
     RowBox[{"RowSpacings", "\[Rule]", "Spacing"}], ",", "Opts"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SuperPrimeBox", "[", 
     RowBox[{"x_", ",", 
      RowBox[{"n", ":", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"_Integer", "?", "NonNegative"}], ")"}], ":", "1"}]}]}], 
     "]"}], ":=", 
    RowBox[{"SuperscriptBox", "[", 
     RowBox[{"x", ",", 
      RowBox[{"StringJoin", "[", 
       RowBox[{"Table", "[", 
        RowBox[{"\"\<\[Prime]\>\"", ",", 
         RowBox[{"{", "n", "}"}]}], "]"}], "]"}]}], "]"}]}], ";"}], 
  "\[IndentingNewLine]", 
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"SuperPrime", "[", "x_", "]"}], ":=", 
     RowBox[{"Superscript", "[", 
      RowBox[{"x", ",", "\"\<\[Prime]\>\""}], "]"}]}], ";"}], 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SuperPrime", "[", 
    RowBox[{"x_", ",", 
     RowBox[{"n", ":", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"_Integer", "?", "NonNegative"}], ")"}], ":", "1"}]}]}], 
    "]"}], ":=", 
   RowBox[{"Superscript", "[", 
    RowBox[{"x", ",", 
     RowBox[{"StringJoin", "[", 
      RowBox[{"Table", "[", 
       RowBox[{"\"\<\[Prime]\>\"", ",", 
        RowBox[{"{", "n", "}"}]}], "]"}], "]"}]}], "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.48181599803125*^9, 3.48181604925*^9}, {
  3.4818160843125*^9, 3.481816170328125*^9}, {3.481816202078125*^9, 
  3.481816203828125*^9}, {3.4818162516875*^9, 3.48181625884375*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Multiplet", "Subsection",
 CellChangeTimes->{{3.461092203296875*^9, 3.46109220475*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "MultipletLabel", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"EntrySeparator", "\[Rule]", "\"\<,\>\""}], ",", 
     RowBox[{"Delimiter", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<(\>\"", ",", "\"\<)\>\""}], "}"}]}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MultipletLabel", "[", 
    RowBox[{"Values_List", ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"DeducedEntrySeparator", ",", "DeducedDelimiter"}], "}"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"DeducedDelimiter", "=", 
       RowBox[{"Switch", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"OptionValue", "[", "Delimiter", "]"}], ",", 
         "\[IndentingNewLine]", "None", ",", 
         RowBox[{"{", 
          RowBox[{"\"\<\>\"", ",", "\"\<\>\""}], "}"}], ",", 
         "\[IndentingNewLine]", "_", ",", 
         RowBox[{"OptionValue", "[", "Delimiter", "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"DeducedEntrySeparator", "=", 
       RowBox[{"Switch", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"OptionValue", "[", "EntrySeparator", "]"}], ",", 
         "\[IndentingNewLine]", "None", ",", "\"\<\>\"", ",", 
         "\[IndentingNewLine]", "_", ",", 
         RowBox[{"OptionValue", "[", "EntrySeparator", "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"Row", "[", 
       RowBox[{"Join", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"DeducedDelimiter", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "}"}], ",", 
         RowBox[{"Riffle", "[", 
          RowBox[{"Values", ",", "DeducedEntrySeparator"}], "]"}], ",", 
         RowBox[{"{", 
          RowBox[{"DeducedDelimiter", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "}"}]}], "]"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.461092214125*^9, 3.461092289390625*^9}, {
   3.46109239584375*^9, 3.461092445609375*^9}, {3.461093160296875*^9, 
   3.461093251765625*^9}, {3.461093431796875*^9, 3.461093505640625*^9}, {
   3.461093635796875*^9, 3.461093661828125*^9}, 3.461093809390625*^9, {
   3.461101489453125*^9, 3.461101537515625*^9}, {3.46110159278125*^9, 
   3.4611016504375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"MultipletLabel", "[", 
  RowBox[{"{", 
   RowBox[{"1", ",", "2", ",", "3"}], "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"MultipletLabel", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"Delimiter", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"\"\<[\>\"", ",", "\"\<]\>\""}], "}"}]}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"MultipletLabel", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"EntrySeparator", "\[Rule]", "None"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"MultipletLabel", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"EntrySeparator", "\[Rule]", "None"}], ",", 
   RowBox[{"Delimiter", "\[Rule]", "None"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.46109381090625*^9, 3.461093868421875*^9}, {
  3.461101659671875*^9, 3.461101664515625*^9}}],

Cell[BoxData[
 TemplateBox[{"\"(\"","1","\",\"","2","\",\"","3","\")\""},
  "Row",
  DisplayFunction->(
   RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3, 
     "\[InvisibleSpace]", #4, "\[InvisibleSpace]", #5, 
     "\[InvisibleSpace]", #6, "\[InvisibleSpace]", #7}]& ),
  InterpretationFunction->(RowBox[{"Row", "[", 
     RowBox[{"{", 
       RowBox[{#, ",", #2, ",", #3, ",", #4, ",", #5, ",", #6, ",", #7}], 
       "}"}], "]"}]& )]], "Output",
 CellChangeTimes->{{3.46109382121875*^9, 3.461093868734375*^9}, {
  3.461101654921875*^9, 3.461101664796875*^9}}],

Cell[BoxData[
 TemplateBox[{"\"[\"","1","\",\"","2","\",\"","3","\"]\""},
  "Row",
  DisplayFunction->(
   RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3, 
     "\[InvisibleSpace]", #4, "\[InvisibleSpace]", #5, 
     "\[InvisibleSpace]", #6, "\[InvisibleSpace]", #7}]& ),
  InterpretationFunction->(RowBox[{"Row", "[", 
     RowBox[{"{", 
       RowBox[{#, ",", #2, ",", #3, ",", #4, ",", #5, ",", #6, ",", #7}], 
       "}"}], "]"}]& )]], "Output",
 CellChangeTimes->{{3.46109382121875*^9, 3.461093868734375*^9}, {
  3.461101654921875*^9, 3.461101664828125*^9}}],

Cell[BoxData[
 TemplateBox[{"\"(\"","1","\"\"","2","\"\"","3","\")\""},
  "Row",
  DisplayFunction->(
   RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3, 
     "\[InvisibleSpace]", #4, "\[InvisibleSpace]", #5, 
     "\[InvisibleSpace]", #6, "\[InvisibleSpace]", #7}]& ),
  InterpretationFunction->(RowBox[{"Row", "[", 
     RowBox[{"{", 
       RowBox[{#, ",", #2, ",", #3, ",", #4, ",", #5, ",", #6, ",", #7}], 
       "}"}], "]"}]& )]], "Output",
 CellChangeTimes->{{3.46109382121875*^9, 3.461093868734375*^9}, {
  3.461101654921875*^9, 3.461101664875*^9}}],

Cell[BoxData[
 TemplateBox[{"\"\"","1","\"\"","2","\"\"","3","\"\""},
  "Row",
  DisplayFunction->(
   RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3, 
     "\[InvisibleSpace]", #4, "\[InvisibleSpace]", #5, 
     "\[InvisibleSpace]", #6, "\[InvisibleSpace]", #7}]& ),
  InterpretationFunction->(RowBox[{"Row", "[", 
     RowBox[{"{", 
       RowBox[{#, ",", #2, ",", #3, ",", #4, ",", #5, ",", #6, ",", #7}], 
       "}"}], "]"}]& )]], "Output",
 CellChangeTimes->{{3.46109382121875*^9, 3.461093868734375*^9}, {
  3.461101654921875*^9, 3.461101664921875*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Sign character", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"SignString", "[", 
    RowBox[{"x_", "?", "NumericQ"}], "]"}], ":=", 
   RowBox[{"Switch", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Sign", "[", "x", "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"+", "1"}], ",", "\"\<+\>\"", ",", "\[IndentingNewLine]", "0", 
     ",", "\"\<\>\"", ",", "\[IndentingNewLine]", 
     RowBox[{"-", "1"}], ",", "\"\<-\>\""}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Formatting of root-containing quantities entirely under radical\
\>", "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"Sqrtize", ",", "Listable"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Sqrtize", "[", 
    RowBox[{"x_", "?", "NumericQ"}], "]"}], ":=", 
   RowBox[{"Which", "[", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"RationalQ", "[", "x", "]"}], ",", "x", ","}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"RationalQ", "[", 
      RowBox[{"x", "^", "2"}], "]"}], ",", 
     RowBox[{
      RowBox[{"Sign", "[", "x", "]"}], "*", 
      RowBox[{"SqrtBox", "[", 
       RowBox[{"x", "^", "2"}], "]"}]}], ",", "\[IndentingNewLine]", "True", 
     ",", "x"}], "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SetAttributes", "[", 
   RowBox[{"Radicalize", ",", "Listable"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"Radicalize", "[", 
    RowBox[{
     RowBox[{"x_", "?", "NumericQ"}], ",", "n_Integer"}], "]"}], ":=", 
   RowBox[{"Which", "[", "\[IndentingNewLine]", 
    RowBox[{"(*", 
     RowBox[{
      RowBox[{"RationalQ", "[", "x", "]"}], ",", "x", ","}], "*)"}], 
    "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"RationalQ", "[", 
      RowBox[{"x", "^", "n"}], "]"}], ",", 
     RowBox[{
      RowBox[{"Sign", "[", "x", "]"}], "*", 
      RowBox[{"RadicalBox", "[", 
       RowBox[{
        RowBox[{"Abs", "[", 
         RowBox[{"x", "^", "n"}], "]"}], ",", "n"}], "]"}]}], ",", 
     "\[IndentingNewLine]", "True", ",", "x"}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]}], "Input",
 InitializationCell->True],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"RationalQ", "[", "x_", "]"}], ":=", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"IntegerQ", "[", "x", "]"}], "||", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"Head", "[", "x", "]"}], "===", "Rational"}], ")"}]}], ")"}]}],
   ";"}]], "Input",
 InitializationCell->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"RationalQ", "[", "1", "]"}], "\[IndentingNewLine]", 
 RowBox[{"RationalQ", "[", 
  RowBox[{"1", "/", "5"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"RationalQ", "[", 
  RowBox[{
   RowBox[{"-", "1"}], "/", "5"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"RationalQ", "[", 
  RowBox[{"Sqrt", "[", "5", "]"}], "]"}]}], "Input"],

Cell[BoxData["True"], "Output"],

Cell[BoxData["True"], "Output"],

Cell[BoxData["True"], "Output"],

Cell[BoxData["False"], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Sqrtize", "[", "1", "]"}], "//", 
  "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Sqrtize", "[", 
   RowBox[{"1", "/", "5"}], "]"}], "//", 
  "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Sqrtize", "[", 
   RowBox[{
    RowBox[{"-", 
     RowBox[{"Sqrt", "[", "5", "]"}]}], "/", "2"}], "]"}], "//", 
  "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Sqrtize", "[", "Pi", "]"}], "//", "DisplayForm"}]}], "Input"],

Cell[BoxData[
 TagBox[
  SqrtBox["1"],
  DisplayForm]], "Output"],

Cell[BoxData[
 TagBox[
  SqrtBox[
   FractionBox["1", "25"]],
  DisplayForm]], "Output"],

Cell[BoxData[
 TagBox[
  RowBox[{"-", 
   SqrtBox[
    FractionBox["5", "4"]]}],
  DisplayForm]], "Output"],

Cell[BoxData[
 TagBox["\[Pi]",
  DisplayForm]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Radicalize", "[", 
   RowBox[{"1", ",", "3"}], "]"}], "//", 
  "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Radicalize", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      RowBox[{"3", "^", 
       RowBox[{"(", 
        RowBox[{"1", "/", "3"}], ")"}]}]}], "/", "2"}], ",", "3"}], "]"}], "//",
   "DisplayForm"}]}], "Input"],

Cell[BoxData[
 TagBox[
  RadicalBox["1", "3"],
  DisplayForm]], "Output"],

Cell[BoxData[
 TagBox[
  RowBox[{"-", 
   RadicalBox[
    FractionBox["3", "8"], "3"]}],
  DisplayForm]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["String alignment and value extraction", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "AlignmentBox", "]"}], "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"AlignmentMarker", "->", "\"\<&\>\""}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"Align", "\[Rule]", "True"}], ",", "\[IndentingNewLine]", 
     RowBox[{"ColumnAlignments", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"Right", ",", "Left"}], "}"}]}], ",", 
     RowBox[{"ColumnSpacings", "\[Rule]", "0"}]}], "\[IndentingNewLine]", 
    "}"}]}], ";"}]], "Input",
 InitializationCell->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"BreakString", "[", 
     RowBox[{"Separator_", ",", "Str_"}], "]"}], ":=", 
    RowBox[{"Module", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", "PosnList", "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"PosnList", "=", 
        RowBox[{"Join", "[", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"Null", ",", "0"}], "}"}], "}"}], ",", 
          RowBox[{"StringPosition", "[", 
           RowBox[{"Str", ",", "Separator"}], "]"}], ",", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{"StringLength", "[", "Str", "]"}], "+", "1"}], ",", 
             "Null"}], "}"}], "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{"StringTake", "[", 
          RowBox[{"Str", ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{"PosnList", "[", 
                RowBox[{"[", "i", "]"}], "]"}], "[", 
               RowBox[{"[", "2", "]"}], "]"}], "+", "1"}], ",", 
             RowBox[{
              RowBox[{
               RowBox[{"PosnList", "[", 
                RowBox[{"[", 
                 RowBox[{"i", "+", "1"}], "]"}], "]"}], "[", 
               RowBox[{"[", "1", "]"}], "]"}], "-", "1"}]}], "}"}]}], "]"}], 
         ",", "\[IndentingNewLine]", 
         RowBox[{"{", 
          RowBox[{"i", ",", "1", ",", 
           RowBox[{
            RowBox[{"Length", "[", "PosnList", "]"}], "-", "1"}]}], "}"}]}], 
        "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
   ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"AlignmentBox", "[", 
    RowBox[{"Str_", ",", 
     RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"FullOpts", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", 
         RowBox[{"Opts", ",", 
          RowBox[{"Options", "[", "AlignmentBox", "]"}]}], "}"}], "]"}]}], 
      "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"CheckOption", "[", 
       RowBox[{"Align", ",", 
        RowBox[{"True", "|", "False"}], ",", "FullOpts"}], "]"}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"CheckOption", "[", 
       RowBox[{"AlignmentMarker", ",", "_String", ",", "FullOpts"}], "]"}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"StyleBox", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"If", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Align", "/.", "FullOpts"}], ",", "\[IndentingNewLine]", 
          RowBox[{"GridBox", "[", "\[IndentingNewLine]", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"BreakString", "[", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"AlignmentMarker", "/.", "FullOpts"}], ")"}], ",", 
               "Str"}], "]"}], "}"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Sequence", "@@", 
             RowBox[{"FilterRules", "[", 
              RowBox[{"FullOpts", ",", 
               RowBox[{"Options", "@", "GridBox"}]}], "]"}]}]}], 
           "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
          RowBox[{"StringReplace", "[", 
           RowBox[{"Str", ",", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"AlignmentMarker", "/.", "FullOpts"}], ")"}], "->", 
             "\"\<\>\""}]}], "]"}]}], "\[IndentingNewLine]", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Sequence", "@@", 
         RowBox[{"FilterRules", "[", 
          RowBox[{"FullOpts", ",", 
           RowBox[{"Options", "@", "StyleBox"}]}], "]"}]}]}], 
       "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.566168775008206*^9, 3.5661688253582764`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"AlignmentBox", "[", 
   RowBox[{"\"\<a&b\>\"", ",", 
    RowBox[{"ColumnWidths", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"5", ",", "5"}], "}"}]}], ",", 
    RowBox[{"Align", "\[Rule]", "False"}]}], "]"}], "//", 
  "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AlignmentBox", "[", 
   RowBox[{"\"\<a&b\>\"", ",", 
    RowBox[{"ColumnWidths", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"5", ",", "5"}], "}"}]}]}], "]"}], "//", 
  "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"AlignmentBox", "[", 
   RowBox[{"\"\<aaaa&bbbb\>\"", ",", 
    RowBox[{"ColumnWidths", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"5", ",", "5"}], "}"}]}]}], "]"}], "//", 
  "DisplayForm"}]}], "Input"],

Cell[BoxData[
 TagBox["ab",
  DisplayForm]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False],

Cell[BoxData[
 TagBox[GridBox[{
    {"a", "b"}
   },
   GridBoxAlignment->{
    "Columns" -> {Right, {Left}}, "ColumnsIndexed" -> {}, 
     "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
   GridBoxItemSize->{
    "Columns" -> {{5}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  DisplayForm]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False],

Cell[BoxData[
 TagBox[GridBox[{
    {"aaaa", "bbbb"}
   },
   GridBoxAlignment->{
    "Columns" -> {Right, {Left}}, "ColumnsIndexed" -> {}, 
     "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
   GridBoxItemSize->{
    "Columns" -> {{5}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  DisplayForm]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"LaTeXTableEntryValue", "[", 
    RowBox[{"Value_", "?", "NumericQ"}], "]"}], ":=", "Value"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LaTeXTableEntryValue", "[", "Str_String", "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
      "FirstNumericPosn", ",", "\[IndentingNewLine]", "ErrorBarsPosn", ",", 
       "\[IndentingNewLine]", "Value"}], "\[IndentingNewLine]", "}"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"FirstNumericPosn", "=", 
       RowBox[{
        RowBox[{"StringPosition", "[", 
         RowBox[{"Str", ",", 
          RowBox[{"{", 
           RowBox[{
           "\"\<+\>\"", ",", "\"\<-\>\"", ",", "\"\<0\>\"", ",", "\"\<1\>\"", 
            ",", "\"\<2\>\"", ",", "\"\<3\>\"", ",", "\"\<4\>\"", ",", 
            "\"\<5\>\"", ",", "\"\<6\>\"", ",", "\"\<7\>\"", ",", "\"\<8\>\"",
             ",", "\"\<9\>\"", ",", "\"\<.\>\""}], "}"}], ",", "1"}], "]"}], 
        "[", 
        RowBox[{"[", 
         RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
      
      RowBox[{"ErrorBarsPosn", "=", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"Length", "[", 
           RowBox[{"StringPosition", "[", 
            RowBox[{"Str", ",", "\"\<(\>\"", ",", "1"}], "]"}], "]"}], 
          "\[GreaterEqual]", "1"}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"StringPosition", "[", 
           RowBox[{"Str", ",", 
            RowBox[{"{", 
             RowBox[{"\"\<(\>\"", ",", "\"\<\[PlusMinus]\>\""}], "}"}], ",", 
            "1"}], "]"}], "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "\[IndentingNewLine]", 
         
         RowBox[{
          RowBox[{"StringLength", "[", "Str", "]"}], "+", "1"}]}], 
        "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Value", "=", 
       RowBox[{"ToExpression", "[", "\[IndentingNewLine]", 
        RowBox[{"StringReplace", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"StringTake", "[", 
           RowBox[{"Str", ",", 
            RowBox[{"{", 
             RowBox[{"FirstNumericPosn", ",", 
              RowBox[{"ErrorBarsPosn", "-", "1"}]}], "}"}]}], "]"}], ",", 
          "\[IndentingNewLine]", 
          RowBox[{"{", 
           RowBox[{"\"\<&\>\"", "->", "\"\<\>\""}], "}"}]}], 
         "\[IndentingNewLine]", "]"}], "\[IndentingNewLine]", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{"!", 
         RowBox[{"NumericQ", "[", "Value", "]"}]}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"Message", "[", 
         RowBox[{
          RowBox[{"LaTeXTableEntryValue", "::", "notnumeric"}], ",", "Str", 
          ",", "Value"}], "]"}]}], "\[IndentingNewLine]", "]"}], ";", 
      "\[IndentingNewLine]", "Value"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Matrix formatting", "Subsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "SubarrayEllipsis", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Padding", "\[Rule]", "\"\<\[CenterEllipsis]\>\""}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SubarrayEllipsis", "[", 
    RowBox[{
     RowBox[{"m_", "?", "MatrixQ"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Rows", ":", 
        RowBox[{"(", 
         RowBox[{"_Integer", "|", "Infinity"}], ")"}]}], ",", 
       RowBox[{"Columns", ":", 
        RowBox[{"(", 
         RowBox[{"_Integer", "|", "Infinity"}], ")"}]}]}], "}"}], ",", 
     RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{
      "RowTrim", ",", "ColumnTrim", ",", "RowMax", ",", "ColumnMax", ",", 
       "MatrixTrimmed"}], "\[IndentingNewLine]", "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"RowTrim", "=", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Dimensions", "[", "m", "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ">", "Rows"}], ")"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"RowMax", "=", 
       RowBox[{"Min", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Dimensions", "[", "m", "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", "Rows"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ColumnTrim", "=", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Dimensions", "[", "m", "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], ">", "Columns"}], ")"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"ColumnMax", "=", 
       RowBox[{"Min", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Dimensions", "[", "m", "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}], ",", "Columns"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"ArrayPad", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"m", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"1", ";;", "RowMax"}], ",", 
           RowBox[{"1", ";;", "ColumnMax"}]}], "]"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"If", "[", 
             RowBox[{"RowTrim", ",", "1", ",", "0"}], "]"}]}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"If", "[", 
             RowBox[{"ColumnTrim", ",", "1", ",", "0"}], "]"}]}], "}"}]}], 
         "}"}], ",", "\[IndentingNewLine]", 
        RowBox[{"OptionValue", "[", "Padding", "]"}]}], "\[IndentingNewLine]",
        "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SubarrayEllipsis", "[", 
    RowBox[{"m_List", ",", 
     RowBox[{"{", 
      RowBox[{"Rows", ":", 
       RowBox[{"(", 
        RowBox[{"_Integer", "|", "Infinity"}], ")"}]}], "}"}], ",", 
     RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "\[IndentingNewLine]", 
      RowBox[{"RowTrim", ",", "RowMax", ",", "MatrixTrimmed"}], 
      "\[IndentingNewLine]", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"RowTrim", "=", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{
          RowBox[{"Dimensions", "[", "m", "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ">", "Rows"}], ")"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"RowMax", "=", 
       RowBox[{"Min", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Dimensions", "[", "m", "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", "Rows"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"ArrayPad", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"m", "[", 
         RowBox[{"[", 
          RowBox[{"1", ";;", "RowMax"}], "]"}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"If", "[", 
            RowBox[{"RowTrim", ",", "1", ",", "0"}], "]"}]}], "}"}], "}"}], 
        ",", "\[IndentingNewLine]", 
        RowBox[{"OptionValue", "[", "Padding", "]"}]}], "\[IndentingNewLine]",
        "]"}]}]}], "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.453752688421875*^9, 3.453752798171875*^9}, {
   3.453752835078125*^9, 3.453752858125*^9}, {3.453752915046875*^9, 
   3.453753005640625*^9}, {3.453753107703125*^9, 3.45375318890625*^9}, {
   3.453753269890625*^9, 3.4537533165*^9}, {3.453753348875*^9, 
   3.453753423375*^9}, {3.45375348009375*^9, 3.4537535103125*^9}, {
   3.45375362628125*^9, 3.453753644703125*^9}, {3.453753703703125*^9, 
   3.453753734171875*^9}, 3.45375387246875*^9, {3.453754018015625*^9, 
   3.453754038546875*^9}, {3.453754132359375*^9, 3.453754173328125*^9}, {
   3.471795786375*^9, 3.47179583884375*^9}, {3.471795928265625*^9, 
   3.471795978421875*^9}, {3.471796042375*^9, 3.471796044546875*^9}, {
   3.4717962060625*^9, 3.4717962070625*^9}, {3.471796247625*^9, 
   3.47179624865625*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"SubarrayEllipsis", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{"i", ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "10"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "10"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"5", ",", "5"}], "}"}]}], "]"}], "//", 
  "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SubarrayEllipsis", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{"i", ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "10"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "10"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"5", ",", "12"}], "}"}]}], "]"}], "//", 
  "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SubarrayEllipsis", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{"i", ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "5"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "10"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"5", ",", "5"}], "}"}]}], "]"}], "//", 
  "MatrixForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SubarrayEllipsis", "[", 
   RowBox[{
    RowBox[{"Table", "[", 
     RowBox[{"i", ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "10"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "10"}], "}"}]}], "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"5", ",", "5"}], "}"}], ",", 
    RowBox[{"Padding", "\[Rule]", "\"\<~\>\""}]}], "]"}], "//", 
  "TableForm"}]}], "Input",
 CellChangeTimes->{{3.45375376603125*^9, 3.4537537978125*^9}, {
  3.453753874375*^9, 3.4537538751875*^9}, {3.45375420128125*^9, 
  3.453754222765625*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "1", "1", "1", "1", "\<\"\[CenterEllipsis]\"\>"},
     {"2", "2", "2", "2", "2", "\<\"\[CenterEllipsis]\"\>"},
     {"3", "3", "3", "3", "3", "\<\"\[CenterEllipsis]\"\>"},
     {"4", "4", "4", "4", "4", "\<\"\[CenterEllipsis]\"\>"},
     {"5", "5", "5", "5", "5", "\<\"\[CenterEllipsis]\"\>"},
     {"\<\"\[CenterEllipsis]\"\>", "\<\"\[CenterEllipsis]\"\>", "\<\"\
\[CenterEllipsis]\"\>", "\<\"\[CenterEllipsis]\"\>", "\<\"\[CenterEllipsis]\"\
\>", "\<\"\[CenterEllipsis]\"\>"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.453753762515625*^9, 3.45375380025*^9}, 
   3.453753928140625*^9, 3.453754045546875*^9, {3.453754180296875*^9, 
   3.453754186*^9}, 3.453754223125*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "1", "1", "1", "1", "1", "1", "1", "1", "1"},
     {"2", "2", "2", "2", "2", "2", "2", "2", "2", "2"},
     {"3", "3", "3", "3", "3", "3", "3", "3", "3", "3"},
     {"4", "4", "4", "4", "4", "4", "4", "4", "4", "4"},
     {"5", "5", "5", "5", "5", "5", "5", "5", "5", "5"},
     {"\<\"\[CenterEllipsis]\"\>", "\<\"\[CenterEllipsis]\"\>", "\<\"\
\[CenterEllipsis]\"\>", "\<\"\[CenterEllipsis]\"\>", "\<\"\[CenterEllipsis]\"\
\>", "\<\"\[CenterEllipsis]\"\>", "\<\"\[CenterEllipsis]\"\>", "\<\"\
\[CenterEllipsis]\"\>", "\<\"\[CenterEllipsis]\"\>", "\<\"\[CenterEllipsis]\"\
\>"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.453753762515625*^9, 3.45375380025*^9}, 
   3.453753928140625*^9, 3.453754045546875*^9, {3.453754180296875*^9, 
   3.453754186*^9}, 3.4537542231875*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "1", "1", "1", "1", "\<\"\[CenterEllipsis]\"\>"},
     {"2", "2", "2", "2", "2", "\<\"\[CenterEllipsis]\"\>"},
     {"3", "3", "3", "3", "3", "\<\"\[CenterEllipsis]\"\>"},
     {"4", "4", "4", "4", "4", "\<\"\[CenterEllipsis]\"\>"},
     {"5", "5", "5", "5", "5", "\<\"\[CenterEllipsis]\"\>"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.453753762515625*^9, 3.45375380025*^9}, 
   3.453753928140625*^9, 3.453754045546875*^9, {3.453754180296875*^9, 
   3.453754186*^9}, 3.453754223234375*^9}],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "1", "1", "1", "1", "\<\"~\"\>"},
    {"2", "2", "2", "2", "2", "\<\"~\"\>"},
    {"3", "3", "3", "3", "3", "\<\"~\"\>"},
    {"4", "4", "4", "4", "4", "\<\"~\"\>"},
    {"5", "5", "5", "5", "5", "\<\"~\"\>"},
    {"\<\"~\"\>", "\<\"~\"\>", "\<\"~\"\>", "\<\"~\"\>", "\<\"~\"\>", \
"\<\"~\"\>"}
   },
   GridBoxAlignment->{
    "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
     "RowsIndexed" -> {}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[0.7]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  Function[BoxForm`e$, 
   TableForm[BoxForm`e$]]]], "Output",
 CellChangeTimes->{{3.453753762515625*^9, 3.45375380025*^9}, 
   3.453753928140625*^9, 3.453754045546875*^9, {3.453754180296875*^9, 
   3.453754186*^9}, 3.4537542233125*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", 
  RowBox[{
   RowBox[{"SubarrayEllipsis", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{"i", ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "10"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"j", ",", "10"}], "}"}]}], "]"}], ",", 
     RowBox[{"{", "5", "}"}]}], "]"}], ",", 
   RowBox[{"TableDepth", "\[Rule]", "1"}]}], "]"}]], "Input",
 CellChangeTimes->{
  3.4717959895*^9, {3.47179605803125*^9, 3.471796089015625*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", 
   TagBox[GridBox[{
      {
       RowBox[{"{", 
        RowBox[{
        "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", "1", ",", 
         "1", ",", "1", ",", "1"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{
        "2", ",", "2", ",", "2", ",", "2", ",", "2", ",", "2", ",", "2", ",", 
         "2", ",", "2", ",", "2"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{
        "3", ",", "3", ",", "3", ",", "3", ",", "3", ",", "3", ",", "3", ",", 
         "3", ",", "3", ",", "3"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{
        "4", ",", "4", ",", "4", ",", "4", ",", "4", ",", "4", ",", "4", ",", 
         "4", ",", "4", ",", "4"}], "}"}]},
      {
       RowBox[{"{", 
        RowBox[{
        "5", ",", "5", ",", "5", ",", "5", ",", "5", ",", "5", ",", "5", ",", 
         "5", ",", "5", ",", "5"}], "}"}]},
      {"\<\"\[CenterEllipsis]\"\>"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    Column], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$, TableDepth -> 1]]]], "Output",
 CellChangeTimes->{
  3.47179598978125*^9, {3.471796050109375*^9, 3.471796089390625*^9}, 
   3.471796293046875*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Pagination", "Subsection"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PageBreak", "[", "]"}], ":=", 
   RowBox[{"CellPrint", "[", 
    RowBox[{"Cell", "[", 
     RowBox[{"\"\<\>\"", ",", 
      RowBox[{"PageBreakBelow", "\[Rule]", "True"}]}], "]"}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.522027659109375*^9, 3.5220276775625*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Unit labels", "Subsection",
 CellChangeTimes->{{3.533749113921875*^9, 3.533749119328125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"UnitsLabel", "[", "FactorSequence___", "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "EntryList", "}"}], ",", "\[IndentingNewLine]", 
     "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"create", " ", "exponents"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"EntryList", "=", 
       RowBox[{"Replace", "[", 
        RowBox[{
         RowBox[{"{", "FactorSequence", "}"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"u_", ",", "p_"}], "}"}], "\[RuleDelayed]", 
          RowBox[{"Superscript", "[", 
           RowBox[{"u", ",", "p"}], "]"}]}], ",", 
         RowBox[{"{", "1", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"intersperse", " ", "thin", " ", "spaces"}], " ", "*)"}], 
      "\[IndentingNewLine]", 
      RowBox[{"EntryList", "=", 
       RowBox[{"Riffle", "[", 
        RowBox[{"EntryList", ",", "\"\<\[ThinSpace]\>\""}], 
        RowBox[{"(*", "ThinSpace", "*)"}], "]"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{
       "but", " ", "undo", " ", "spaces", " ", "around", " ", "solidus"}], 
       " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"EntryList", "=", 
       RowBox[{"Replace", "[", 
        RowBox[{"EntryList", ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"pre___", ",", "\"\<\[ThinSpace]\>\"", 
            RowBox[{"(*", "ThinSpace", "*)"}], ",", "\"\</\>\"", ",", 
            "\"\<\[ThinSpace]\>\"", 
            RowBox[{"(*", "ThinSpace", "*)"}], ",", "post___"}], "}"}], 
          "\[RuleDelayed]", 
          RowBox[{"{", 
           RowBox[{"pre", ",", "\"\</\>\"", ",", "post"}], "}"}]}], ",", 
         RowBox[{"{", "0", "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
      "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"create", " ", "row"}], " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Row", "[", "EntryList", "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533749359984375*^9, 3.5337493726875*^9}, {
   3.533749403125*^9, 3.5337495595*^9}, {3.533749647140625*^9, 
   3.533749699703125*^9}, {3.533749847890625*^9, 3.53374989521875*^9}, {
   3.53374996915625*^9, 3.53375003625*^9}, 3.534185633984375*^9}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"UnitsLabel", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"textit", "[", "\"\<e\>\"", "]"}], ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"\"\<fm\>\"", ",", "4"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"textrm", "[", "%", "]"}], "//", "DisplayForm"}], "  ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "see", " ", "what", " ", "it", " ", "will", " ", "look", " ", "like", " ", 
    "in", " ", "a", " ", "label"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{"UnitsLabel", "[", 
  RowBox[{"\"\<kg\>\"", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<m\>\"", ",", "2"}], "}"}], ",", "\"\</\>\"", ",", 
   RowBox[{"{", 
    RowBox[{"\"\<s\>\"", ",", "2"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"textrm", "[", "%", "]"}], "//", "DisplayForm", " ", 
  RowBox[{"(*", " ", 
   RowBox[{
   "see", " ", "what", " ", "it", " ", "will", " ", "look", " ", "like", " ", 
    "in", " ", "a", " ", "label"}], " ", "*)"}]}]}], "Input",
 CellChangeTimes->{{3.533749562078125*^9, 3.53374962421875*^9}, {
  3.533749913453125*^9, 3.53374993309375*^9}, {3.534185635203125*^9, 
  3.534185635640625*^9}, {3.6251808874716263`*^9, 3.6251808960516415`*^9}, {
  3.625182732286067*^9, 3.6251827503508987`*^9}}],

Cell[BoxData[
 TemplateBox[{TemplateBox[{
     TagBox[
      StyleBox["\"e\"", FontSlant -> "Italic"], 
      StyleForm[#, FontSlant -> "Italic"]& ], "2"}, "Superscript", SyntaxForm -> 
    SuperscriptBox],"\"\[ThinSpace]\"",
   TemplateBox[{"\"fm\"", "4"}, "Superscript", SyntaxForm -> SuperscriptBox]},
  
  "RowDefault"]], "Output",
 CellChangeTimes->{
  3.533749584734375*^9, 3.533749624984375*^9, 3.5337497023125*^9, {
   3.533749897828125*^9, 3.53374993415625*^9}, 3.533750039703125*^9, {
   3.6251808828852186`*^9, 3.6251808964416423`*^9}}],

Cell[BoxData[
 TagBox[
  TagBox[
   StyleBox[
    TemplateBox[{TemplateBox[{
        TagBox[
         StyleBox["\"e\"", FontSlant -> "Italic"], 
         StyleForm[#, FontSlant -> "Italic"]& ], "2"}, "Superscript", 
       SyntaxForm -> SuperscriptBox],"\"\[ThinSpace]\"",
      TemplateBox[{"\"fm\"", "4"}, "Superscript", SyntaxForm -> 
       SuperscriptBox]},
     "RowDefault"],
    FontFamily->"Times"],
   StyleForm[#, FontFamily -> "Times"]& ],
  DisplayForm]], "Output",
 CellChangeTimes->{
  3.533749584734375*^9, 3.533749624984375*^9, 3.5337497023125*^9, {
   3.533749897828125*^9, 3.53374993415625*^9}, 3.533750039703125*^9, {
   3.6251808828852186`*^9, 3.6251808964416423`*^9}}],

Cell[BoxData[
 TemplateBox[{
  "\"kg\"","\"\[ThinSpace]\"",
   TemplateBox[{"\"m\"", "2"}, "Superscript", SyntaxForm -> SuperscriptBox],
   "\"/\"",TemplateBox[{"\"s\"", "2"}, "Superscript", SyntaxForm -> 
    SuperscriptBox]},
  "RowDefault"]], "Output",
 CellChangeTimes->{
  3.533749584734375*^9, 3.533749624984375*^9, 3.5337497023125*^9, {
   3.533749897828125*^9, 3.53374993415625*^9}, 3.533750039703125*^9, {
   3.6251808828852186`*^9, 3.6251808964416423`*^9}}],

Cell[BoxData[
 TagBox[
  TagBox[
   StyleBox[
    TemplateBox[{
     "\"kg\"","\"\[ThinSpace]\"",
      TemplateBox[{"\"m\"", "2"}, "Superscript", SyntaxForm -> 
       SuperscriptBox],"\"/\"",
      TemplateBox[{"\"s\"", "2"}, "Superscript", SyntaxForm -> 
       SuperscriptBox]},
     "RowDefault"],
    FontFamily->"Times"],
   StyleForm[#, FontFamily -> "Times"]& ],
  DisplayForm]], "Output",
 CellChangeTimes->{
  3.533749584734375*^9, 3.533749624984375*^9, 3.5337497023125*^9, {
   3.533749897828125*^9, 3.53374993415625*^9}, 3.533750039703125*^9, {
   3.6251808828852186`*^9, 3.6251808964416423`*^9}}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Formatting for spectroscopy and nuclear physics", "Section",
 CellChangeTimes->{{3.533744983171875*^9, 3.53374499603125*^9}}],

Cell[CellGroupData[{

Cell["Spectroscopic \[ScriptL] notation", "Subsection",
 CellChangeTimes->{{3.566261859572538*^9, 3.5662618678425493`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"SpectroscopicLetter", "[", "0", "]"}], "=", "\"\<s\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SpectroscopicLetter", "[", "1", "]"}], "=", "\"\<p\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SpectroscopicLetter", "[", "2", "]"}], "=", "\"\<d\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SpectroscopicLetter", "[", "3", "]"}], "=", "\"\<f\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SpectroscopicLetter", "[", "4", "]"}], "=", "\"\<g\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SpectroscopicLetter", "[", "5", "]"}], "=", "\"\<h\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SpectroscopicLetter", "[", "6", "]"}], "=", "\"\<i\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SpectroscopicLetter", "[", "7", "]"}], "=", "\"\<j\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SpectroscopicLetter", "[", "8", "]"}], "=", "\"\<k\>\""}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.49226469321875*^9, 3.492264755703125*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["nlj shell label", "Subsection",
 CellChangeTimes->{{3.5663394045420218`*^9, 3.566339407812026*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "ShellLabel", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Style", "\[Rule]", "Italic"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"ShellLabel", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"n_", ",", "l_", ",", "j_"}], "}"}], ",", 
     RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{"n", ",", 
      RowBox[{"Subscript", "[", 
       RowBox[{
        RowBox[{"Style", "[", 
         RowBox[{
          RowBox[{"SpectroscopicLetter", "[", "l", "]"}], ",", 
          RowBox[{"OptionValue", "[", "Style", "]"}]}], "]"}], ",", 
        RowBox[{"SolidusFractionize", "[", "j", "]"}]}], "]"}]}], "}"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ShellLabel", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"l_", ",", "j_"}], "}"}], ",", 
     RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{"Subscript", "[", 
      RowBox[{
       RowBox[{"Style", "[", 
        RowBox[{
         RowBox[{"SpectroscopicLetter", "[", "l", "]"}], ",", 
         RowBox[{"OptionValue", "[", "Style", "]"}]}], "]"}], ",", 
       RowBox[{"SolidusFractionize", "[", "j", "]"}]}], "]"}], "}"}], "]"}]}],
   ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6252470943817472`*^9, 3.6252471166429863`*^9}, {
  3.6252471647690706`*^9, 3.625247279008072*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"ShellLabel", "[", 
  RowBox[{"{", 
   RowBox[{"0", ",", "0", ",", 
    RowBox[{"1", "/", "2"}]}], "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"ShellLabel", "[", 
  RowBox[{"{", 
   RowBox[{"0", ",", 
    RowBox[{"1", "/", "2"}]}], "}"}], "]"}]}], "Input",
 CellChangeTimes->{{3.5663394287620554`*^9, 3.5663394449020777`*^9}}],

Cell[BoxData[
 TemplateBox[{"0",SubscriptBox[
    StyleBox["\"s\"", Italic, StripOnInput -> False], 
    TagBox[
     GridBox[{{"1", "\"/\"", "2"}}, AutoDelete -> False, 
      GridBoxItemSize -> {
       "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
      GridBoxSpacings -> {"Columns" -> {0, 0, 0, 0}}, 
      BaselinePosition -> {{1, 3}, Baseline}], "Grid"]]},
  "RowDefault"]], "Output",
 CellChangeTimes->{{3.566339440502072*^9, 3.566339468272111*^9}, 
   3.566339576672262*^9, {3.625247168825078*^9, 3.625247282190477*^9}}],

Cell[BoxData[
 TemplateBox[{SubscriptBox[
    StyleBox["\"s\"", Italic, StripOnInput -> False], 
    TagBox[
     GridBox[{{"1", "\"/\"", "2"}}, AutoDelete -> False, 
      GridBoxItemSize -> {
       "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
      GridBoxSpacings -> {"Columns" -> {0, 0, 0, 0}}, 
      BaselinePosition -> {{1, 3}, Baseline}], "Grid"]]},
  "RowDefault"]], "Output",
 CellChangeTimes->{{3.566339440502072*^9, 3.566339468272111*^9}, 
   3.566339576672262*^9, {3.625247168825078*^9, 3.625247282190477*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Isotope label as NucleusBox -- DEPRECATED", "Subsection",
 CellChangeTimes->{{3.53374502825*^9, 3.533745082828125*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "NucleusBox", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"NuclearA", "->", "\"\<\>\""}], ",", 
     RowBox[{"NuclearZ", "->", "\"\<\>\""}], ",", 
     RowBox[{"NuclearN", "->", "\"\<\>\""}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"NucleusBox", "[", 
    RowBox[{"Element_", ",", 
     RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"FullOpts", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", 
         RowBox[{"Opts", ",", 
          RowBox[{"Options", "[", "NucleusBox", "]"}]}], "}"}], "]"}]}], 
      "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Row", "[", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"SubsuperscriptBox", "[", 
         RowBox[{"\"\<\>\"", ",", 
          RowBox[{"NuclearZ", "/.", "FullOpts"}], ",", 
          RowBox[{"NuclearA", "/.", "FullOpts"}]}], "]"}], ",", 
        RowBox[{"SubsuperscriptBox", "[", 
         RowBox[{"Element", ",", 
          RowBox[{"NuclearN", "/.", "FullOpts"}], ",", "\"\<\>\""}], "]"}]}], 
       "  ", 
       RowBox[{"(*", " ", 
        RowBox[{
        "to", " ", "match", " ", "subsuperscript", " ", "on", " ", "left", 
         " ", "for", " ", "alignment"}], " ", "*)"}], "\[IndentingNewLine]", 
       "}"}], "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{3.488191930234375*^9, 3.488191991546875*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"NucleusBox", "[", 
   RowBox[{"\"\<Au\>\"", ",", 
    RowBox[{"NuclearA", "\[Rule]", "\"\<A\>\""}], ",", 
    RowBox[{"NuclearZ", "->", "\"\<Z\>\""}], ",", 
    RowBox[{"NuclearN", "->", "\"\<N\>\""}]}], "]"}], "//", 
  "DisplayForm"}]], "Input"],

Cell[BoxData[
 TagBox[
  TemplateBox[{
   SubsuperscriptBox["", "Z", "A"],SubsuperscriptBox["Au", "N", ""]},
   "Row",
   DisplayFunction->(RowBox[{#, "\[InvisibleSpace]", #2}]& ),
   InterpretationFunction->(RowBox[{"Row", "[", 
      RowBox[{"{", 
        RowBox[{#, ",", #2}], "}"}], "]"}]& )],
  DisplayForm]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False,
 CellChangeTimes->{3.488191937328125*^9, 3.488191995625*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Isotope label", "Subsection",
 CellChangeTimes->{{3.533745088171875*^9, 3.533745090921875*^9}}],

Cell[TextData[{
 "Meant to roughly follow usage of ",
 Cell[BoxData[
  FormBox[
   StyleBox[
    RowBox[{"L", 
     StyleBox[
      AdjustmentBox["A",
       BoxBaselineShift->-0.4,
       BoxMargins->{{-0.5, -0.3}, {0, 0}}],
      FontSize->Smaller], "T", 
     AdjustmentBox["E",
      BoxBaselineShift->0.5,
      BoxMargins->{{-0.3, 0}, {0, 0}}], "X"}],
    SingleLetterItalics->False], TraditionalForm]]],
 " isotope package (",
 "Heiko Bauke)"
}], "Text",
 CellChangeTimes->{{3.533745100296875*^9, 3.533745114671875*^9}, {
  3.53374514778125*^9, 3.533745160453125*^9}}],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"LIMITATION", ":", " ", 
   RowBox[{
   "A", " ", "and", " ", "Z", " ", "are", " ", "left", " ", "aligned"}]}], 
  " ", "*)"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.492725582515625*^9, 3.492725604453125*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Isotope", "[", 
    RowBox[{
     RowBox[{"A_:", "None"}], ",", 
     RowBox[{"Z_:", "None"}], ",", 
     RowBox[{"N_:", "None"}], ",", 
     RowBox[{"Sup_:", "None"}], ",", "Element_String"}], "]"}], ":=", 
   RowBox[{"Which", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{
      RowBox[{"(", 
       RowBox[{"Z", "===", "None"}], ")"}], "&&", 
      RowBox[{"(", 
       RowBox[{"N", "===", "None"}], ")"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{
       RowBox[{
       "use", " ", "subsuperscript", " ", "on", " ", "both", " ", "sides", 
        " ", "if", " ", "use", " ", "on", " ", "either"}], ",", " ", 
       RowBox[{"to", " ", "match", " ", "alignment"}]}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{"Row", "[", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Superscript", "[", 
         RowBox[{"\"\<\>\"", ",", 
          RowBox[{"Replace", "[", 
           RowBox[{"A", ",", 
            RowBox[{"None", "\[Rule]", "\"\<\>\""}]}], "]"}]}], "]"}], ",", 
        RowBox[{"Superscript", "[", 
         RowBox[{"Element", ",", 
          RowBox[{"Replace", "[", 
           RowBox[{"Sup", ",", 
            RowBox[{"None", "\[Rule]", "\"\<\>\""}]}], "]"}]}], "]"}]}], "  ",
        "\[IndentingNewLine]", "}"}], "]"}], ",", "\[IndentingNewLine]", 
     "True", ",", "\[IndentingNewLine]", 
     RowBox[{"Row", "[", 
      RowBox[{"{", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Subsuperscript", "[", 
         RowBox[{"\"\<\>\"", ",", 
          RowBox[{"Replace", "[", 
           RowBox[{"Z", ",", 
            RowBox[{"None", "\[Rule]", "\"\<\>\""}]}], "]"}], ",", 
          RowBox[{"Replace", "[", 
           RowBox[{"A", ",", 
            RowBox[{"None", "\[Rule]", "\"\<\>\""}]}], "]"}]}], "]"}], ",", 
        RowBox[{"Subsuperscript", "[", 
         RowBox[{"Element", ",", 
          RowBox[{"Replace", "[", 
           RowBox[{"N", ",", 
            RowBox[{"None", "\[Rule]", "\"\<\>\""}]}], "]"}], ",", 
          RowBox[{"Replace", "[", 
           RowBox[{"Sup", ",", 
            RowBox[{"None", "\[Rule]", "\"\<\>\""}]}], "]"}]}], "]"}]}], "  ",
        "\[IndentingNewLine]", "}"}], "]"}]}], "\[IndentingNewLine]", "]"}]}],
   ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.4927254290625*^9, 3.492725513234375*^9}, {
  3.492725546203125*^9, 3.492725567953125*^9}, {3.492725665453125*^9, 
  3.492725668390625*^9}, {3.492725770234375*^9, 3.492725808640625*^9}, {
  3.566602781676073*^9, 3.5666028597854104`*^9}, {3.585073660697054*^9, 
  3.58507366395746*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Isotope", "[", 
    RowBox[{"PriorArgs___", ",", 
     RowBox[{
      RowBox[{"(", "Z_Integer", ")"}], "?", "NonNegative"}]}], "]"}], ":=", 
   RowBox[{"Isotope", "[", 
    RowBox[{"PriorArgs", ",", 
     RowBox[{"ElementAbbreviation", "[", "Z", "]"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.6251882183059025`*^9, 3.625188254997167*^9}, {
  3.62518834748973*^9, 3.625188392480209*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Isotope", "[", "\"\<C\>\"", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Isotope", "[", 
  RowBox[{"12", ",", "\"\<C\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Isotope", "[", 
  RowBox[{"12", ",", "6", ",", "\"\<C\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Isotope", "[", 
  RowBox[{"12", ",", "6", ",", "6", ",", "\"\<C\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Isotope", "[", 
  RowBox[{"12", ",", "None", ",", "6", ",", "\"\<C\>\""}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"Isotope", "[", 
  RowBox[{
  "12", ",", "None", ",", "None", ",", "\"\<*\>\"", ",", "\"\<C\>\""}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.492725706328125*^9, 3.492725750109375*^9}, {
  3.49272579659375*^9, 3.492725830453125*^9}}],

Cell[BoxData[
 TemplateBox[{InterpretationBox[
    SubsuperscriptBox["\"\"", "\"\"", "\"\""], 
    Subsuperscript["", "", ""], Editable -> False],InterpretationBox[
    SubsuperscriptBox["\"C\"", "\"\"", "\"\""], 
    Subsuperscript["C", "", ""], Editable -> False]},
  "Row",
  DisplayFunction->(RowBox[{#, "\[InvisibleSpace]", #2}]& ),
  InterpretationFunction->(RowBox[{"Row", "[", 
     RowBox[{"{", 
       RowBox[{#, ",", #2}], "}"}], "]"}]& )]], "Output",
 CellChangeTimes->{{3.492725715703125*^9, 3.49272575075*^9}, {
  3.49272580296875*^9, 3.492725830921875*^9}}],

Cell[BoxData[
 TemplateBox[{InterpretationBox[
    SubsuperscriptBox["\"\"", "\"\"", "12"], 
    Subsuperscript["", "", 12], Editable -> False],InterpretationBox[
    SubsuperscriptBox["\"C\"", "\"\"", "\"\""], 
    Subsuperscript["C", "", ""], Editable -> False]},
  "Row",
  DisplayFunction->(RowBox[{#, "\[InvisibleSpace]", #2}]& ),
  InterpretationFunction->(RowBox[{"Row", "[", 
     RowBox[{"{", 
       RowBox[{#, ",", #2}], "}"}], "]"}]& )]], "Output",
 CellChangeTimes->{{3.492725715703125*^9, 3.49272575075*^9}, {
  3.49272580296875*^9, 3.49272583096875*^9}}],

Cell[BoxData[
 TemplateBox[{InterpretationBox[
    SubsuperscriptBox["\"\"", "6", "12"], 
    Subsuperscript["", 6, 12], Editable -> False],InterpretationBox[
    SubsuperscriptBox["\"C\"", "\"\"", "\"\""], 
    Subsuperscript["C", "", ""], Editable -> False]},
  "Row",
  DisplayFunction->(RowBox[{#, "\[InvisibleSpace]", #2}]& ),
  InterpretationFunction->(RowBox[{"Row", "[", 
     RowBox[{"{", 
       RowBox[{#, ",", #2}], "}"}], "]"}]& )]], "Output",
 CellChangeTimes->{{3.492725715703125*^9, 3.49272575075*^9}, {
  3.49272580296875*^9, 3.49272583096875*^9}}],

Cell[BoxData[
 TemplateBox[{InterpretationBox[
    SubsuperscriptBox["\"\"", "6", "12"], 
    Subsuperscript["", 6, 12], Editable -> False],InterpretationBox[
    SubsuperscriptBox["\"C\"", "6", "\"\""], 
    Subsuperscript["C", 6, ""], Editable -> False]},
  "Row",
  DisplayFunction->(RowBox[{#, "\[InvisibleSpace]", #2}]& ),
  InterpretationFunction->(RowBox[{"Row", "[", 
     RowBox[{"{", 
       RowBox[{#, ",", #2}], "}"}], "]"}]& )]], "Output",
 CellChangeTimes->{{3.492725715703125*^9, 3.49272575075*^9}, {
  3.49272580296875*^9, 3.492725831015625*^9}}],

Cell[BoxData[
 TemplateBox[{InterpretationBox[
    SubsuperscriptBox["\"\"", "\"\"", "12"], 
    Subsuperscript["", "", 12], Editable -> False],InterpretationBox[
    SubsuperscriptBox["\"C\"", "6", "\"\""], 
    Subsuperscript["C", 6, ""], Editable -> False]},
  "Row",
  DisplayFunction->(RowBox[{#, "\[InvisibleSpace]", #2}]& ),
  InterpretationFunction->(RowBox[{"Row", "[", 
     RowBox[{"{", 
       RowBox[{#, ",", #2}], "}"}], "]"}]& )]], "Output",
 CellChangeTimes->{{3.492725715703125*^9, 3.49272575075*^9}, {
  3.49272580296875*^9, 3.4927258310625*^9}}],

Cell[BoxData[
 TemplateBox[{InterpretationBox[
    SubsuperscriptBox["\"\"", "\"\"", "12"], 
    Subsuperscript["", "", 12], Editable -> False],InterpretationBox[
    SubsuperscriptBox["\"C\"", "\"\"", "\"*\""], 
    Subsuperscript["C", "", "*"], Editable -> False]},
  "Row",
  DisplayFunction->(RowBox[{#, "\[InvisibleSpace]", #2}]& ),
  InterpretationFunction->(RowBox[{"Row", "[", 
     RowBox[{"{", 
       RowBox[{#, ",", #2}], "}"}], "]"}]& )]], "Output",
 CellChangeTimes->{{3.492725715703125*^9, 3.49272575075*^9}, {
  3.49272580296875*^9, 3.492725831109375*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Isotope", "[", 
  RowBox[{"12", ",", "6"}], "]"}]], "Input",
 CellChangeTimes->{
  3.625188267461589*^9, {3.625188379797386*^9, 3.6251883974098177`*^9}}],

Cell[BoxData[
 TemplateBox[{
  TemplateBox[{"\"\"", "12"}, "Superscript", SyntaxForm -> SuperscriptBox],
   TemplateBox[{"\"C\"", "\"\""}, "Superscript", SyntaxForm -> 
    SuperscriptBox]},
  "RowDefault"]], "Output",
 CellChangeTimes->{
  3.62518826788279*^9, {3.625188380078187*^9, 3.6251883976750183`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Isotope", "[", 
  RowBox[{
  "\"\<X\>\"", ",", "\"\<X\>\"", ",", "\"\<X\>\"", ",", "\"\<X\>\"", ",", 
   "\"\<X\>\""}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Isotope", "[", 
  RowBox[{"\"\<X\>\"", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Isotope", "[", 
  RowBox[{"\"\<+\>\"", ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Isotope", "[", 
   RowBox[{"\"\<+\>\"", ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1"}], "}"}]}], "]"}], "//", "DisplayForm"}]}], "Input",\

 CellChangeTimes->{{3.5850735940325522`*^9, 3.5850736052525682`*^9}, {
  3.585073678137885*^9, 3.5850737064987345`*^9}}],

Cell[BoxData[
 TemplateBox[{
  TemplateBox[{"\"\"", "\"X\"", "\"X\""}, "Subsuperscript"],
   TemplateBox[{"\"X\"", "\"X\"", "\"X\""}, "Subsuperscript"]},
  "RowDefault"]], "Output",
 CellChangeTimes->{
  3.5850736055925684`*^9, {3.585073670821472*^9, 3.5850737067795353`*^9}}],

Cell[BoxData[
 TemplateBox[{
  TemplateBox[{"\"\"", "2"}, "Superscript"],
   TemplateBox[{"\"H\"", "\"X\""}, "Superscript"]},
  "RowDefault"]], "Output",
 CellChangeTimes->{
  3.5850736055925684`*^9, {3.585073670821472*^9, 3.5850737067795353`*^9}}],

Cell[BoxData[
 TemplateBox[{
  TemplateBox[{"\"\"", "2"}, "Superscript"],
   TemplateBox[{"\"H\"", "\"+\""}, "Superscript"]},
  "RowDefault"]], "Output",
 CellChangeTimes->{
  3.5850736055925684`*^9, {3.585073670821472*^9, 3.5850737067795353`*^9}}],

Cell[BoxData[
 TagBox[
  TemplateBox[{
   TemplateBox[{"\"\"", "2"}, "Superscript"],
    TemplateBox[{"\"H\"", "\"+\""}, "Superscript"]},
   "RowDefault"],
  DisplayForm]], "Output",
 CellChangeTimes->{
  3.5850736055925684`*^9, {3.585073670821472*^9, 3.5850737067795353`*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Isotope label -- {Z,N} form", "Subsection",
 CellChangeTimes->{{3.533745088171875*^9, 3.533745090921875*^9}, {
  3.574462957474044*^9, 3.57446296191405*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Isotope", "[", 
    RowBox[{
     RowBox[{"Sup_:", "None"}], ",", 
     RowBox[{"{", 
      RowBox[{"Z_Integer", ",", "N_Integer"}], "}"}]}], "]"}], ":=", 
   RowBox[{"Isotope", "[", 
    RowBox[{
     RowBox[{"Z", "+", "N"}], ",", "None", ",", "None", ",", "Sup", ",", 
     RowBox[{"ElementAbbreviation", "[", "Z", "]"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.5744627248937182`*^9, 3.5744627993238225`*^9}, {
  3.57446283338387*^9, 3.574462933864011*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Isotope", "[", 
  RowBox[{"{", 
   RowBox[{"3", ",", "3"}], "}"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Isotope", "[", 
  RowBox[{"\"\<*\>\"", ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "3"}], "}"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.57446280483383*^9, 3.574462823733856*^9}, {
  3.5744629379840164`*^9, 3.5744629406940203`*^9}}],

Cell[BoxData[
 TemplateBox[{
  TemplateBox[{"\"\"", "6"}, "Superscript"],
   TemplateBox[{"\"Li\"", "\"\""}, "Superscript"]},
  "RowDefault"]], "Output",
 CellChangeTimes->{{3.5744628086638355`*^9, 3.5744628623039103`*^9}, 
   3.574462942724023*^9}],

Cell[BoxData[
 TemplateBox[{
  TemplateBox[{"\"\"", "6"}, "Superscript"],
   TemplateBox[{"\"Li\"", "\"*\""}, "Superscript"]},
  "RowDefault"]], "Output",
 CellChangeTimes->{{3.5744628086638355`*^9, 3.5744628623039103`*^9}, 
   3.574462942734023*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Isotope data", "Subsection",
 CellChangeTimes->{{3.545859365125*^9, 3.54585937465625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ElementAbbreviations", "=", "\n", "\t", 
    RowBox[{"{", 
     RowBox[{
     "\"\<H\>\"", ",", "\"\<He\>\"", ",", "\"\<Li\>\"", ",", "\"\<Be\>\"", 
      ",", "\"\<B\>\"", ",", "\"\<C\>\"", ",", "\"\<N\>\"", ",", "\"\<O\>\"", 
      ",", "\"\<F\>\"", ",", "\"\<Ne\>\"", ",", "\"\<Na\>\"", ",", 
      "\"\<Mg\>\"", ",", "\"\<Al\>\"", ",", "\"\<Si\>\"", ",", "\"\<P\>\"", 
      ",", "\n", "\t ", "\"\<S\>\"", ",", "\"\<Cl\>\"", ",", "\"\<Ar\>\"", 
      ",", "\"\<K\>\"", ",", "\"\<Ca\>\"", ",", "\"\<Sc\>\"", ",", 
      "\"\<Ti\>\"", ",", "\"\<V\>\"", ",", "\"\<Cr\>\"", ",", "\"\<Mn\>\"", 
      ",", "\"\<Fe\>\"", ",", "\"\<Co\>\"", ",", "\"\<Ni\>\"", ",", 
      "\"\<Cu\>\"", ",", "\n", "\t ", "\"\<Zn\>\"", ",", "\"\<Ga\>\"", ",", 
      "\"\<Ge\>\"", ",", "\"\<As\>\"", ",", "\"\<Se\>\"", ",", "\"\<Br\>\"", 
      ",", "\"\<Kr\>\"", ",", "\"\<Rb\>\"", ",", "\"\<Sr\>\"", ",", 
      "\"\<Y\>\"", ",", "\"\<Zr\>\"", ",", "\"\<Nb\>\"", ",", "\"\<Mo\>\"", 
      ",", "\"\<Tc\>\"", ",", "\n", "\t ", "\"\<Ru\>\"", ",", "\"\<Rh\>\"", 
      ",", "\"\<Pd\>\"", ",", "\"\<Ag\>\"", ",", "\"\<Cd\>\"", ",", 
      "\"\<In\>\"", ",", "\"\<Sn\>\"", ",", "\"\<Sb\>\"", ",", "\"\<Te\>\"", 
      ",", "\"\<I\>\"", ",", "\"\<Xe\>\"", ",", "\"\<Cs\>\"", ",", 
      "\"\<Ba\>\"", ",", "\"\<La\>\"", ",", "\n", "\t ", "\"\<Ce\>\"", ",", 
      "\"\<Pr\>\"", ",", "\"\<Nd\>\"", ",", "\"\<Pm\>\"", ",", "\"\<Sm\>\"", 
      ",", "\"\<Eu\>\"", ",", "\"\<Gd\>\"", ",", "\"\<Tb\>\"", ",", 
      "\"\<Dy\>\"", ",", "\"\<Ho\>\"", ",", "\"\<Er\>\"", ",", "\"\<Tm\>\"", 
      ",", "\"\<Yb\>\"", ",", "\n", "\t ", "\"\<Lu\>\"", ",", "\"\<Hf\>\"", 
      ",", "\"\<Ta\>\"", ",", "\"\<W\>\"", ",", "\"\<Re\>\"", ",", 
      "\"\<Os\>\"", ",", "\"\<Ir\>\"", ",", "\"\<Pt\>\"", ",", "\"\<Au\>\"", 
      ",", "\"\<Hg\>\"", ",", "\"\<Tl\>\"", ",", "\"\<Pb\>\"", ",", 
      "\"\<Bi\>\"", ",", "\"\<Po\>\"", ",", "\n", "\t ", "\"\<At\>\"", ",", 
      "\"\<Rn\>\"", ",", "\"\<Fr\>\"", ",", "\"\<Ra\>\"", ",", "\"\<Ac\>\"", 
      ",", "\"\<Th\>\"", ",", "\"\<Pa\>\"", ",", "\"\<U\>\"", ",", 
      "\"\<Np\>\"", ",", "\"\<Pu\>\"", ",", "\"\<Am\>\"", ",", "\"\<Cm\>\"", 
      ",", "\"\<Bk\>\"", ",", "\"\<Cf\>\"", ",", "\n", "\t ", "\"\<Es\>\"", 
      ",", "\"\<Fm\>\"", ",", "\"\<Md\>\"", ",", "\"\<No\>\"", ",", 
      "\"\<Lr\>\"", ",", " ", "\"\<Rf\>\"", ",", " ", "\"\<Db\>\"", ",", " ", 
      "\"\<Sg\>\"", ",", " ", "\"\<Bh\>\"", ",", " ", "\"\<Hs\>\"", ",", " ", 
      "\"\<Mt\>\"", ",", "\n", "\t", "\"\<Uun\>\"", ",", "\"\<Uuu\>\"", ",", 
      "\"\<Uub\>\""}], "}"}]}], ";"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"data", " ", "circa", " ", "Mathematica", " ", "5.0"}], " ", 
   "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"ElementAbbreviationsLength", "=", 
   RowBox[{"Length", "[", "ElementAbbreviations", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{3.54585929146875*^9, 3.545859384421875*^9}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "from", " ", "ChemicalElements", " ", "package", " ", "1.4", " ", 
     "Elements", " ", "list"}], ",", " ", 
    RowBox[{"converted", " ", "to", " ", "strings"}]}], " ", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"ElementNames", "=", 
     RowBox[{"{", 
      RowBox[{
      "\"\<Hydrogen\>\"", ",", "\"\<Helium\>\"", ",", "\"\<Lithium\>\"", ",", 
       "\"\<Beryllium\>\"", ",", "\"\<Boron\>\"", ",", "\"\<Carbon\>\"", ",", 
       "\"\<Nitrogen\>\"", ",", "\"\<Oxygen\>\"", ",", "\"\<Fluorine\>\"", 
       ",", "\"\<Neon\>\"", ",", "\"\<Sodium\>\"", ",", "\"\<Magnesium\>\"", 
       ",", "\"\<Aluminium\>\"", ",", "\"\<Silicon\>\"", ",", 
       "\"\<Phosphorus\>\"", ",", "\"\<Sulfur\>\"", ",", "\"\<Chlorine\>\"", 
       ",", "\"\<Argon\>\"", ",", "\"\<Potassium\>\"", ",", "\"\<Calcium\>\"",
        ",", "\"\<Scandium\>\"", ",", "\"\<Titanium\>\"", ",", 
       "\"\<Vanadium\>\"", ",", "\"\<Chromium\>\"", ",", "\"\<Manganese\>\"", 
       ",", "\"\<Iron\>\"", ",", "\"\<Cobalt\>\"", ",", "\"\<Nickel\>\"", 
       ",", "\"\<Copper\>\"", ",", "\"\<Zinc\>\"", ",", "\"\<Gallium\>\"", 
       ",", "\"\<Germanium\>\"", ",", "\"\<Arsenic\>\"", ",", 
       "\"\<Selenium\>\"", ",", "\"\<Bromine\>\"", ",", "\"\<Krypton\>\"", 
       ",", "\"\<Rubidium\>\"", ",", "\"\<Strontium\>\"", ",", 
       "\"\<Yttrium\>\"", ",", "\"\<Zirconium\>\"", ",", "\"\<Niobium\>\"", 
       ",", "\"\<Molybdenum\>\"", ",", "\"\<Technetium\>\"", ",", 
       "\"\<Ruthenium\>\"", ",", "\"\<Rhodium\>\"", ",", "\"\<Palladium\>\"", 
       ",", "\"\<Silver\>\"", ",", "\"\<Cadmium\>\"", ",", "\"\<Indium\>\"", 
       ",", "\"\<Tin\>\"", ",", "\"\<Antimony\>\"", ",", "\"\<Tellurium\>\"", 
       ",", "\"\<Iodine\>\"", ",", "\"\<Xenon\>\"", ",", "\"\<Caesium\>\"", 
       ",", "\"\<Barium\>\"", ",", "\"\<Lanthanum\>\"", ",", "\"\<Cerium\>\"",
        ",", "\"\<Praseodymium\>\"", ",", "\"\<Neodymium\>\"", ",", 
       "\"\<Promethium\>\"", ",", "\"\<Samarium\>\"", ",", "\"\<Europium\>\"",
        ",", "\"\<Gadolinium\>\"", ",", "\"\<Terbium\>\"", ",", 
       "\"\<Dysprosium\>\"", ",", "\"\<Holmium\>\"", ",", "\"\<Erbium\>\"", 
       ",", "\"\<Thulium\>\"", ",", "\"\<Ytterbium\>\"", ",", 
       "\"\<Lutetium\>\"", ",", "\"\<Hafnium\>\"", ",", "\"\<Tantalum\>\"", 
       ",", "\"\<Tungsten\>\"", ",", "\"\<Rhenium\>\"", ",", "\"\<Osmium\>\"",
        ",", "\"\<Iridium\>\"", ",", "\"\<Platinum\>\"", ",", "\"\<Gold\>\"", 
       ",", "\"\<Mercury\>\"", ",", "\"\<Thallium\>\"", ",", "\"\<Lead\>\"", 
       ",", "\"\<Bismuth\>\"", ",", "\"\<Polonium\>\"", ",", 
       "\"\<Astatine\>\"", ",", "\"\<Radon\>\"", ",", "\"\<Francium\>\"", 
       ",", "\"\<Radium\>\"", ",", "\"\<Actinium\>\"", ",", "\"\<Thorium\>\"",
        ",", "\"\<Protactinium\>\"", ",", "\"\<Uranium\>\"", ",", 
       "\"\<Neptunium\>\"", ",", "\"\<Plutonium\>\"", ",", 
       "\"\<Americium\>\"", ",", "\"\<Curium\>\"", ",", "\"\<Berkelium\>\"", 
       ",", "\"\<Californium\>\"", ",", "\"\<Einsteinium\>\"", ",", 
       "\"\<Fermium\>\"", ",", "\"\<Mendelevium\>\"", ",", "\"\<Nobelium\>\"",
        ",", "\"\<Lawrencium\>\"", ",", "\"\<Rutherfordium\>\"", ",", 
       "\"\<Dubnium\>\"", ",", "\"\<Seaborgium\>\"", ",", "\"\<Bohrium\>\"", 
       ",", "\"\<Hassium\>\"", ",", "\"\<Meitnerium\>\"", ",", 
       "\"\<Ununnilium\>\"", ",", "\"\<Unununium\>\"", ",", 
       "\"\<Ununbium\>\""}], "}"}]}], ";"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ElementNamesLength", "=", 
     RowBox[{"Length", "[", "ElementNames", "]"}]}], ";"}]}]}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.545859003828125*^9, 3.54585905278125*^9}, {
   3.54585933225*^9, 3.54585934228125*^9}, 3.545859384421875*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Hydrogen\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Helium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Lithium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"6", ",", "7"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Beryllium\>\"", "]"}], "=", 
   RowBox[{"{", "9", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Boron\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"10", ",", "11"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Carbon\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"12", ",", "13"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Nitrogen\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"14", ",", "15"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Oxygen\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"16", ",", "17", ",", "18"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Fluorine\>\"", "]"}], "=", 
   RowBox[{"{", "19", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Neon\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"20", ",", "21", ",", "22"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Sodium\>\"", "]"}], "=", 
   RowBox[{"{", "23", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Magnesium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"24", ",", "25", ",", "26"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Aluminium\>\"", "]"}], "=", 
   RowBox[{"{", "27", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Silicon\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"28", ",", "29", ",", "30"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Phosphorus\>\"", "]"}], "=", 
   RowBox[{"{", "31", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Sulfur\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"32", ",", "33", ",", "34", ",", "36"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Chlorine\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"35", ",", "37"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Argon\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"36", ",", "38", ",", "40"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Potassium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"39", ",", "41"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Calcium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"40", ",", "42", ",", "43", ",", "44", ",", "46", ",", "48"}], 
    "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Scandium\>\"", "]"}], "=", 
   RowBox[{"{", "45", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Titanium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"46", ",", "47", ",", "48", ",", "49", ",", "50"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Vanadium\>\"", "]"}], "=", 
   RowBox[{"{", "51", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Chromium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"50", ",", "52", ",", "53", ",", "54"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Manganese\>\"", "]"}], "=", 
   RowBox[{"{", "55", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Iron\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"54", ",", "56", ",", "57", ",", "58"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Cobalt\>\"", "]"}], "=", 
   RowBox[{"{", "59", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Nickel\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"58", ",", "60", ",", "61", ",", "62", ",", "64"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Copper\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"63", ",", "65"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Zinc\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"66", ",", "67", ",", "68", ",", "70"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Gallium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"69", ",", "71"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Germanium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"70", ",", "72", ",", "73", ",", "74", ",", "76"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Arsenic\>\"", "]"}], "=", 
   RowBox[{"{", "75", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Selenium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"74", ",", "76", ",", "77", ",", "78", ",", "80", ",", "82"}], 
    "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Bromine\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"79", ",", "81"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Krypton\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"78", ",", "80", ",", "82", ",", "83", ",", "84", ",", "86"}], 
    "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Rubidium\>\"", "]"}], "=", 
   RowBox[{"{", "85", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Strontium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"84", ",", "86", ",", "87", ",", "88"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Yttrium\>\"", "]"}], "=", 
   RowBox[{"{", "89", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Zirconium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"90", ",", "91", ",", "92", ",", "94"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Niobium\>\"", "]"}], "=", 
   RowBox[{"{", "93", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Molybdenum\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
    "92", ",", "94", ",", "95", ",", "96", ",", "97", ",", "98", ",", "100"}],
     "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Technetium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Ruthenium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
    "96", ",", "98", ",", "99", ",", "100", ",", "101", ",", "102", ",", 
     "104"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Rhodium\>\"", "]"}], "=", 
   RowBox[{"{", "103", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Palladium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
    "102", ",", "104", ",", "105", ",", "106", ",", "108", ",", "110"}], 
    "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Silver\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"107", ",", "109"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Cadmium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
    "106", ",", "108", ",", "110", ",", "111", ",", "112", ",", "113", ",", 
     "114", ",", "116"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Indium\>\"", "]"}], "=", 
   RowBox[{"{", "113", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Tin\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
    "112", ",", "114", ",", "115", ",", "116", ",", "117", ",", "118", ",", 
     "119", ",", "120", ",", "122", ",", "124"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Antimony\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"121", ",", "123"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Tellurium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
    "120", ",", "122", ",", "124", ",", "125", ",", "126", ",", "128", ",", 
     "130"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Iodine\>\"", "]"}], "=", 
   RowBox[{"{", "127", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Xenon\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
    "129", ",", "130", ",", "131", ",", "132", ",", "134", ",", "136"}], 
    "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Caesium\>\"", "]"}], "=", 
   RowBox[{"{", "133", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Barium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
    "130", ",", "132", ",", "134", ",", "135", ",", "136", ",", "137", ",", 
     "138"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Lanthanum\>\"", "]"}], "=", 
   RowBox[{"{", "138", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Cerium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"136", ",", "138", ",", "140", ",", "142"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Praseodymium\>\"", "]"}], "=", 
   RowBox[{"{", "141", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Neodymium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
    "142", ",", "143", ",", "145", ",", "146", ",", "148", ",", "150"}], 
    "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Promethium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Samarium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"144", ",", "150", ",", "152", ",", "154"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Europium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"151", ",", "153"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Gadolinium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
    "154", ",", "155", ",", "156", ",", "157", ",", "158", ",", "160"}], 
    "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Terbium\>\"", "]"}], "=", 
   RowBox[{"{", "159", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Dysprosium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
    "156", ",", "158", ",", "160", ",", "161", ",", "162", ",", "163", ",", 
     "164"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Holmium\>\"", "]"}], "=", 
   RowBox[{"{", "165", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Erbium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
    "162", ",", "164", ",", "166", ",", "167", ",", "168", ",", "170"}], 
    "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Thulium\>\"", "]"}], "=", 
   RowBox[{"{", "169", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Ytterbium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
    "168", ",", "170", ",", "171", ",", "172", ",", "173", ",", "174", ",", 
     "176"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Lutetium\>\"", "]"}], "=", 
   RowBox[{"{", "175", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Hafnium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"176", ",", "177", ",", "178", ",", "179", ",", "180"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Tantalum\>\"", "]"}], "=", 
   RowBox[{"{", "181", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Tungsten\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"180", ",", "182", ",", "183", ",", "184", ",", "186"}], "}"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Rhenium\>\"", "]"}], "=", 
   RowBox[{"{", "185", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Osmium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
    "184", ",", "186", ",", "187", ",", "188", ",", "189", ",", "190", ",", 
     "192"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Iridium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"191", ",", "193"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Platinum\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"194", ",", "195", ",", "196", ",", "198"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Gold\>\"", "]"}], "=", 
   RowBox[{"{", "197", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Mercury\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
    "196", ",", "198", ",", "199", ",", "200", ",", "201", ",", "202", ",", 
     "204"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Thallium\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"203", ",", "205"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Lead\>\"", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"204", ",", "206", ",", "207", ",", "208"}], "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Bismuth\>\"", "]"}], "=", 
   RowBox[{"{", "209", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Polonium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Astatine\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Radon\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Francium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Radium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Actinium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Thorium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Protactinium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Uranium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Neptunium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Plutonium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Americium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Curium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Berkelium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Californium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Einsteinium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Fermium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Mendelevium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Nobelium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Lawrencium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Rutherfordium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Dubnium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Seaborgium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Bohrium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Hassium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Meitnerium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Ununnilium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Unununium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", "\"\<Ununbium\>\"", "]"}], "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n"}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.54585923128125*^9, 3.54585923128125*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Isotope data retrieval", "Subsection",
 CellChangeTimes->{{3.545858998640625*^9, 3.545859001671875*^9}, {
  3.5458593891875*^9, 3.545859393703125*^9}}],

Cell["\<\
see also http://library.wolfram.com/infocenter/MathSource/6794/ \
\>", "Text",
 CellChangeTimes->{{3.625189309548142*^9, 3.6251893189136777`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ElementData", "[", "\"\<Properties\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.625188452774315*^9, 3.6251884579379234`*^9}}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"PacletInstall", "::", "dwnld"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"An error occurred downloading paclet \
\[NoBreak]\\!\\(\\\"ElementData-10.0.39\\\"\\)\[NoBreak] from site \[NoBreak]\
\\!\\(\\\"http://pacletserver.wolfram.com\\\"\\)\[NoBreak]: \
\[NoBreak]\\!\\(\\\"Network error\\\"\\)\[NoBreak]. \
\[NoBreak]\\!\\(\\\"Couldn't resolve host name\\\"\\)\[NoBreak]\"\>"}]], \
"Message", "MSG",
 CellChangeTimes->{3.6251884584371243`*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"ElementData", "::", "dlfail"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"Internet download of data for \
\[NoBreak]\\!\\(\\\"ElementData\\\"\\)\[NoBreak] failed. Use Help > Internet \
Connectivity... to test or reconfigure internet connectivity. \
\\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", \
ButtonFrame->None, ButtonData:>\\\"paclet:ref/ElementData\\\", ButtonNote -> \
\\\"ElementData::dlfail\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{3.6251884585463247`*^9}],

Cell[BoxData["$Failed"], "Output",
 CellChangeTimes->{3.6251884585463247`*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{"(*", " ", 
  RowBox[{"Note", ":", " ", 
   RowBox[{
    RowBox[{"ElementData", "[", 
     RowBox[{"Element", ",", "\"\<Abbreviation\>\""}], "]"}], " ", "works", 
    " ", "only", " ", 
    RowBox[{"online", ".", " ", "Therefore"}], " ", "using", " ", "static", 
    " ", "offline", " ", 
    RowBox[{"data", "."}]}]}], " ", "*)"}]], "Input",
 CellChangeTimes->{{3.545244120125*^9, 3.54524414846875*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ElementAbbreviation", "[", 
    RowBox[{"Z", ":", "0"}], "]"}], "=", "\"\<n\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ElementAbbreviation", "[", 
     RowBox[{
      RowBox[{"(", "Z_Integer", ")"}], "?", "Positive"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{"Z", "\[LessEqual]", "ElementAbbreviationsLength"}], ")"}]}], ":=", 
   RowBox[{"ElementAbbreviations", "[", 
    RowBox[{"[", "Z", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ElementAbbreviation", "[", 
     RowBox[{
      RowBox[{"(", "Z_Integer", ")"}], "?", "Positive"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{"Z", ">", "ElementAbbreviationsLength"}], ")"}]}], ":=", 
   RowBox[{"ToString", "[", "Z", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.545244094296875*^9, 3.5452441004375*^9}, {
   3.545244224890625*^9, 3.54524436778125*^9}, {3.545244637359375*^9, 
   3.54524463975*^9}, 3.545859284828125*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"ElementName", "[", 
    RowBox[{"Z", ":", "0"}], "]"}], "=", "\"\<Neutron\>\""}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ElementName", "[", 
     RowBox[{
      RowBox[{"(", "Z_Integer", ")"}], "?", "Positive"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{"Z", "\[LessEqual]", "ElementNamesLength"}], ")"}]}], ":=", 
   RowBox[{"ElementNames", "[", 
    RowBox[{"[", "Z", "]"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"ElementName", "[", 
     RowBox[{
      RowBox[{"(", "Z_Integer", ")"}], "?", "Positive"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{"Z", ">", "ElementNamesLength"}], ")"}]}], ":=", 
   RowBox[{"ToString", "[", "Z", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.545244094296875*^9, 3.5452441004375*^9}, {
  3.545244224890625*^9, 3.54524436778125*^9}, {3.545244637359375*^9, 
  3.54524463975*^9}, {3.545859284828125*^9, 3.54585932371875*^9}, {
  3.545859556375*^9, 3.5458595643125*^9}, {3.545860005640625*^9, 
  3.545860007328125*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
    RowBox[{"IsotopeIsStable", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Z", ":", "0"}], ",", 
       RowBox[{
        RowBox[{"(", "A_Integer", ")"}], "?", "Positive"}]}], "}"}], "]"}], ":=",
     "False"}], ";", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IsotopeIsStable", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"(", "Z_Integer", ")"}], "?", "Positive"}], ",", 
        RowBox[{
         RowBox[{"(", "A_Integer", ")"}], "?", "Positive"}]}], "}"}], "]"}], "/;", 
     RowBox[{"(", 
      RowBox[{"Z", "\[LessEqual]", "ElementNamesLength"}], ")"}]}], ":=", 
    RowBox[{"MemberQ", "[", 
     RowBox[{
      RowBox[{"StableIsotopes", "[", 
       RowBox[{"ElementName", "[", "Z", "]"}], "]"}], ",", "A"}], "]"}]}], 
   ";", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"IsotopeIsStable", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{
         RowBox[{"(", "Z_Integer", ")"}], "?", "Positive"}], ",", 
        RowBox[{
         RowBox[{"(", "A_Integer", ")"}], "?", "Positive"}]}], "}"}], "]"}], "/;", 
     RowBox[{"(", 
      RowBox[{"Z", ">", "ElementNamesLength"}], ")"}]}], ":=", "False"}], 
   ";"}], "*)"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.545859530046875*^9, 3.54585954809375*^9}, {
   3.545859628234375*^9, 3.5458596854375*^9}, {3.54585984865625*^9, 
   3.545859897578125*^9}, {3.545859937171875*^9, 3.54585997775*^9}, 
   3.54586021634375*^9, {3.625188531616853*^9, 3.625188532708855*^9}, {
   3.6251887441828265`*^9, 3.6251887441984262`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"StableIsotopes", "[", 
    RowBox[{"Z", ":", "0"}], "]"}], ":=", 
   RowBox[{"{", "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"StableIsotopes", "[", 
     RowBox[{
      RowBox[{"(", "Z_Integer", ")"}], "?", "Positive"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{"Z", "\[LessEqual]", "ElementNamesLength"}], ")"}]}], ":=", 
   RowBox[{"StableIsotopes", "[", 
    RowBox[{"ElementName", "[", "Z", "]"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"StableIsotopes", "[", 
     RowBox[{
      RowBox[{"(", "Z_Integer", ")"}], "?", "Positive"}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{"Z", ">", "ElementNamesLength"}], ")"}]}], ":=", 
   RowBox[{"{", "}"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.545859530046875*^9, 3.54585954809375*^9}, {
   3.545859628234375*^9, 3.5458596854375*^9}, {3.54585984865625*^9, 
   3.545859897578125*^9}, {3.545859937171875*^9, 3.54585997775*^9}, 
   3.54586021634375*^9, {3.6251885421780715`*^9, 3.625188591396158*^9}, {
   3.6251887441984262`*^9, 3.6251887442140265`*^9}, {3.6251890856840267`*^9, 
   3.6251891439501286`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"IsotopeIsStable", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Z", ":", "0"}], ",", 
      RowBox[{
       RowBox[{"(", "N_Integer", ")"}], "?", "Positive"}]}], "}"}], "]"}], ":=",
    "False"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IsotopeIsStable", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"(", "Z_Integer", ")"}], "?", "Positive"}], ",", 
       RowBox[{
        RowBox[{"(", "N_Integer", ")"}], "?", "NonNegative"}]}], "}"}], "]"}],
     "/;", 
    RowBox[{"(", 
     RowBox[{"Z", "\[LessEqual]", "ElementNamesLength"}], ")"}]}], ":=", 
   RowBox[{"MemberQ", "[", 
    RowBox[{
     RowBox[{"StableIsotopes", "[", 
      RowBox[{"ElementName", "[", "Z", "]"}], "]"}], ",", 
     RowBox[{"Z", "+", "N"}]}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"IsotopeIsStable", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{
        RowBox[{"(", "Z_Integer", ")"}], "?", "Positive"}], ",", 
       RowBox[{
        RowBox[{"(", "N_Integer", ")"}], "?", "NonNegative"}]}], "}"}], "]"}],
     "/;", 
    RowBox[{"(", 
     RowBox[{"Z", ">", "ElementNamesLength"}], ")"}]}], ":=", "False"}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.545859530046875*^9, 3.54585954809375*^9}, {
   3.545859628234375*^9, 3.5458596854375*^9}, {3.54585984865625*^9, 
   3.545859897578125*^9}, {3.545859937171875*^9, 3.54585997775*^9}, 
   3.54586021634375*^9, {3.6251885421780715`*^9, 3.625188591396158*^9}, {
   3.6251887441984262`*^9, 3.6251887442140265`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Isotope", "[", 
    RowBox[{"Args___", ",", 
     RowBox[{
      RowBox[{"(", "Z_Integer", ")"}], "?", "NonNegative"}]}], "]"}], ":=", 
   RowBox[{"Isotope", "[", 
    RowBox[{"Args", ",", 
     RowBox[{"ElementAbbreviation", "[", "Z", "]"}]}], "]"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.545243743265625*^9, 3.545243820453125*^9}, {
  3.545244162796875*^9, 3.545244207109375*^9}, {3.545244297890625*^9, 
  3.545244308265625*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Isotope", "[", 
  RowBox[{"12", ",", "6"}], "]"}]], "Input",
 CellChangeTimes->{{3.54524462175*^9, 3.545244623203125*^9}}],

Cell[BoxData[
 TemplateBox[{InterpretationBox[
    SubsuperscriptBox["\"\"", "\"\"", "12"], 
    Subsuperscript["", "", 12], Editable -> False],InterpretationBox[
    SubsuperscriptBox["\"C\"", "\"\"", "\"\""], 
    Subsuperscript["C", "", ""], Editable -> False]},
  "Row",
  DisplayFunction->(RowBox[{#, "\[InvisibleSpace]", #2}]& ),
  InterpretationFunction->(RowBox[{"Row", "[", 
     RowBox[{"{", 
       RowBox[{#, ",", #2}], "}"}], "]"}]& )]], "Output",
 CellChangeTimes->{3.545244623640625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ElementName", "[", "12", "]"}]], "Input",
 CellChangeTimes->{{3.5458602266875*^9, 3.545860229328125*^9}}],

Cell[BoxData["\<\"Magnesium\"\>"], "Output",
 CellChangeTimes->{3.545860229640625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"StableIsotopes", "[", "6", "]"}]], "Input",
 CellChangeTimes->{{3.6251892375034933`*^9, 3.6251892412318993`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"12", ",", "13"}], "}"}]], "Output",
 CellChangeTimes->{{3.6251892416687*^9, 3.6251892468479095`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IsotopeIsStable", "[", 
  RowBox[{"{", 
   RowBox[{"6", ",", "6"}], "}"}], "]"}]], "Input",
 CellChangeTimes->{{3.54585982009375*^9, 3.54585983859375*^9}, {
   3.6251885778085346`*^9, 3.6251885783077354`*^9}, 3.6251887442140265`*^9}],

Cell[BoxData["True"], "Output",
 CellChangeTimes->{
  3.545859838890625*^9, 3.545859901265625*^9, {3.545859946953125*^9, 
   3.5458599808125*^9}, {3.545860014484375*^9, 3.54586004221875*^9}, {
   3.54586009221875*^9, 3.54586012134375*^9}, {3.545860213390625*^9, 
   3.545860235046875*^9}, {3.6251885789317365`*^9, 3.625188593190161*^9}, 
   3.625188773183277*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Level spin-parity label as LabelJ[i]P -- DEPRECATED", "Subsection",
 CellChangeTimes->{{3.533745173421875*^9, 3.533745180828125*^9}, {
  3.533747553515625*^9, 3.533747567109375*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "LabelJiP", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Rational", "\[Rule]", "SolidusFractionize"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LabelJiP", "[", 
    RowBox[{"J_", ",", "i_", ",", 
     RowBox[{"P", ":", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"+", "1"}], "|", 
         RowBox[{"-", "1"}], "|", "None"}], ")"}], ":", 
       RowBox[{"+", "1"}]}]}], ",", 
     RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
   RowBox[{"SubsuperscriptBox", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"J", "/.", 
      RowBox[{"{", 
       RowBox[{"x_Rational", "\[RuleDelayed]", 
        RowBox[{
         RowBox[{"OptionValue", "[", "Rational", "]"}], "[", "x", "]"}]}], 
       "}"}]}], ",", "\[IndentingNewLine]", "i", ",", "\[IndentingNewLine]", 
     RowBox[{"Switch", "[", 
      RowBox[{"P", ",", 
       RowBox[{"+", "1"}], ",", "\"\<+\>\"", ",", 
       RowBox[{"-", "1"}], ",", "\"\<-\>\"", ",", "None", ",", "\"\<\>\""}], 
      "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "LabelJP", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Rational", "\[Rule]", "SolidusFractionize"}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LabelJP", "[", 
    RowBox[{"J_", ",", 
     RowBox[{"P", ":", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{
         RowBox[{"+", "1"}], "|", 
         RowBox[{"-", "1"}], "|", "None"}], ")"}], ":", 
       RowBox[{"+", "1"}]}]}], ",", 
     RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
   RowBox[{"SuperscriptBox", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"J", "/.", 
      RowBox[{"{", 
       RowBox[{"x_Rational", "\[RuleDelayed]", 
        RowBox[{
         RowBox[{"OptionValue", "[", "Rational", "]"}], "[", "x", "]"}]}], 
       "}"}]}], ",", "\[IndentingNewLine]", 
     RowBox[{"Switch", "[", 
      RowBox[{"P", ",", 
       RowBox[{"+", "1"}], ",", "\"\<+\>\"", ",", 
       RowBox[{"-", "1"}], ",", "\"\<-\>\"", ",", "None", ",", "\"\<\>\""}], 
      "]"}]}], "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.53374682515625*^9, 3.53374686459375*^9}, {
  3.533746975515625*^9, 3.533747061671875*^9}, {3.5337471781875*^9, 
  3.533747239125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"LabelJiP", "[", 
     RowBox[{"2", ",", "1", ",", 
      RowBox[{"-", "1"}]}], "]"}], ",", 
    RowBox[{"LabelJiP", "[", 
     RowBox[{"2", ",", "1", ",", "None"}], "]"}], ",", 
    RowBox[{"LabelJiP", "[", 
     RowBox[{
      RowBox[{"1", "/", "2"}], ",", "1"}], "]"}], ",", 
    RowBox[{"LabelJP", "[", 
     RowBox[{"1", "/", "2"}], "]"}]}], "}"}], "//", "DisplayForm"}]], "Input",\

 CellChangeTimes->{3.533747281015625*^9}],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    SubsuperscriptBox["2", "1", "-"], ",", 
    SubsuperscriptBox["2", "1", ""], ",", 
    SubsuperscriptBox[
     TagBox[GridBox[{
        {"1", "\<\"/\"\>", "2"}
       },
       AutoDelete->False,
       BaselinePosition->{{1, 3}, Baseline},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {0, 0, 0, 0}}],
      "Grid"], "1", "+"], ",", 
    SuperscriptBox[
     TagBox[GridBox[{
        {"1", "\<\"/\"\>", "2"}
       },
       AutoDelete->False,
       BaselinePosition->{{1, 3}, Baseline},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {0, 0, 0, 0}}],
      "Grid"], "+"]}], "}"}],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.533747025328125*^9, 3.533747063484375*^9}, 
   3.53374719703125*^9, {3.533747250390625*^9, 3.53374728146875*^9}, 
   3.625187082217307*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"LabelJiP", "[", 
     RowBox[{
      RowBox[{"1", "/", "2"}], ",", "1", ",", 
      RowBox[{"Rational", "\[Rule]", "DiagonalFractionize"}]}], "]"}], ",", 
    RowBox[{"LabelJiP", "[", 
     RowBox[{
      RowBox[{"1", "/", "2"}], ",", "1", ",", 
      RowBox[{"Rational", "\[Rule]", "Fractionize"}]}], "]"}]}], "}"}], "//", 
  "DisplayForm"}]], "Input",
 CellChangeTimes->{{3.533747088328125*^9, 3.533747120828125*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    SubsuperscriptBox[
     TagBox[
      StyleBox[
       TagBox[GridBox[{
          {
           AdjustmentBox[
            SubscriptBox["", 
             TagBox["1",
              DisplayForm]],
            BoxBaselineShift->-0.5], 
           AdjustmentBox[
            TagBox[
             StyleBox["\<\"/\"\>",
              FontSlant->"Oblique"],
             StyleForm[#, FontSlant -> "Oblique"]& ],
            BoxBaselineShift->0.], 
           AdjustmentBox[
            SubscriptBox["", 
             TagBox["2",
              DisplayForm]],
            BoxBaselineShift->0.]}
         },
         AutoDelete->False,
         BaselinePosition->{{1, 3}, Bottom},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
         GridBoxSpacings->{"Columns" -> {0, -0.1, -0.2, 0}}],
        "Grid"],
       ScriptBaselineShifts->{0, 0}],
      SciDraw`DiagonalFractionBox[-0.15]], "1", "+"], ",", 
    SubsuperscriptBox[
     FractionBox["1", "2"], "1", "+"]}], "}"}],
  DisplayForm]], "Output",
 CellChangeTimes->{3.533747121546875*^9, 3.53374719853125*^9, 
  3.533747271125*^9, 3.6251870831221085`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Level spin-parity label", "Subsection",
 CellChangeTimes->{{3.533745173421875*^9, 3.533745180828125*^9}, {
   3.533747553515625*^9, 3.533747567109375*^9}, 3.53374829125*^9}],

Cell["\<\
Caveat: Including a null string subscript still allows space for the \
subscript, which throws off the baseline of the label.  Therefore only use a \
subscript if necessary.\
\>", "Text",
 CellChangeTimes->{{3.543351456984375*^9, 3.543351493109375*^9}, {
  3.543351535453125*^9, 3.543351541765625*^9}}],

Cell["\<\
DEFICIENCY: \[OpenCurlyDoubleQuote]Jp\[CloseCurlyDoubleQuote] (i.e., without \
index) format is cumbersome to specify automatically through arguments, \
without options\
\>", "Text",
 CellChangeTimes->{{3.567900440597597*^9, 3.567900500298902*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "LevelLabel", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Rational", "\[Rule]", "SolidusFractionize"}], ",", 
     RowBox[{"Parity", "\[Rule]", "None"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LevelLabel", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"J_", ",", "i_", ",", "P_"}], "}"}], ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"JText", ",", "iValue", ",", "PValue", ",", "PText"}], "}"}], 
     ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"construct", " ", "entry", " ", "text"}], " ", "*)"}], 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"JText", "=", 
       RowBox[{"J", "/.", 
        RowBox[{"{", 
         RowBox[{"x_Rational", "\[RuleDelayed]", 
          RowBox[{
           RowBox[{"OptionValue", "[", "Rational", "]"}], "[", "x", "]"}]}], 
         "}"}]}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"iValue", "=", 
       RowBox[{"ReplaceSequential", "[", 
        RowBox[{"i", ",", 
         RowBox[{"{", 
          RowBox[{"Automatic", "\[Rule]", "None"}], "}"}]}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"PValue", "=", 
       RowBox[{"ReplaceSequential", "[", 
        RowBox[{"P", ",", 
         RowBox[{"{", 
          RowBox[{"Automatic", "\[Rule]", 
           RowBox[{"OptionValue", "[", "Parity", "]"}]}], "}"}]}], "]"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"PText", "=", 
       RowBox[{"Switch", "[", 
        RowBox[{"PValue", ",", 
         RowBox[{"+", "1"}], ",", "\"\<+\>\"", ",", 
         RowBox[{"-", "1"}], ",", "\"\<-\>\"", ",", "_", ",", "PValue"}], 
        "]"}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"generate", " ", "scriptbox", " ", "as", " ", "appropriate"}], 
       " ", "*)"}], "\[IndentingNewLine]", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{
         RowBox[{"(", 
          RowBox[{"iValue", "===", "None"}], ")"}], "&&", 
         RowBox[{"(", 
          RowBox[{"PValue", "===", "None"}], ")"}]}], ",", 
        "\[IndentingNewLine]", "JText", ",", "\[IndentingNewLine]", 
        RowBox[{"(", 
         RowBox[{"iValue", "===", "None"}], ")"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Superscript", "[", 
         RowBox[{"JText", ",", "PText"}], "]"}], ",", "\[IndentingNewLine]", 
        RowBox[{"(", 
         RowBox[{"PValue", "===", "None"}], ")"}], ",", "\[IndentingNewLine]", 
        RowBox[{"Subscript", "[", 
         RowBox[{"JText", ",", "iValue"}], "]"}], ",", "\[IndentingNewLine]", 
        "True", ",", "\[IndentingNewLine]", 
        RowBox[{"Subsuperscript", "[", 
         RowBox[{"JText", ",", "iValue", ",", "PText"}], "]"}]}], 
       "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"LevelLabel", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"J_", ",", "i_"}], "}"}], ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"LevelLabel", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"J", ",", "i", ",", "Automatic"}], "}"}], ",", "Opts"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"LevelLabel", "[", 
    RowBox[{
     RowBox[{"{", "J_", "}"}], ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"LevelLabel", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"J", ",", "Automatic", ",", "Automatic"}], "}"}], ",", "Opts"}],
     "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.53374682515625*^9, 3.53374686459375*^9}, {
   3.533746975515625*^9, 3.533747061671875*^9}, {3.5337471781875*^9, 
   3.533747239125*^9}, {3.53374758590625*^9, 3.53374759409375*^9}, {
   3.533747651390625*^9, 3.53374777528125*^9}, 3.533748024234375*^9, {
   3.533748155421875*^9, 3.533748161734375*^9}, 3.5433515144375*^9, {
   3.543351582890625*^9, 3.5433517798125*^9}, {3.547138743828125*^9, 
   3.547138780296875*^9}, {3.547138818984375*^9, 3.547138841890625*^9}, {
   3.54713939678125*^9, 3.547139415515625*^9}, {3.547139463921875*^9, 
   3.547139529921875*^9}, {3.551353632109375*^9, 3.55135363984375*^9}, {
   3.5513539675*^9, 3.5513539678125*^9}}],

Cell["Version with unwrapped arguments", "Text",
 CellChangeTimes->{{3.533747973546875*^9, 3.5337479775625*^9}, {
  3.533748098046875*^9, 3.533748102703125*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"LevelLabel", "[", 
    RowBox[{"J_", ",", 
     RowBox[{"i", ":", 
      RowBox[{"Except", "[", 
       RowBox[{"_", "?", "OptionQ"}], "]"}]}], ",", 
     RowBox[{"P", ":", 
      RowBox[{"Except", "[", 
       RowBox[{"_", "?", "OptionQ"}], "]"}]}], ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"LevelLabel", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"J", ",", "i", ",", "P"}], "}"}], ",", "Opts"}], "]"}]}], 
  ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"LevelLabel", "[", 
    RowBox[{"J_", ",", 
     RowBox[{"i", ":", 
      RowBox[{"Except", "[", 
       RowBox[{"_", "?", "OptionQ"}], "]"}]}], ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"LevelLabel", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"J", ",", "i"}], "}"}], ",", "Opts"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"LevelLabel", "[", 
    RowBox[{"J_", ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"LevelLabel", "[", 
    RowBox[{
     RowBox[{"{", "J", "}"}], ",", "Opts"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.53374682515625*^9, 3.53374686459375*^9}, {
  3.533746975515625*^9, 3.533747061671875*^9}, {3.5337471781875*^9, 
  3.533747239125*^9}, {3.53374758590625*^9, 3.53374759409375*^9}, {
  3.533747651390625*^9, 3.53374777528125*^9}, {3.533748000359375*^9, 
  3.53374809421875*^9}, {3.53374817215625*^9, 3.53374817665625*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"LevelLabel", "[", 
     RowBox[{"2", ",", "1", ",", 
      RowBox[{"-", "1"}]}], "]"}], ",", 
    RowBox[{"LevelLabel", "[", 
     RowBox[{"2", ",", "1", ",", "None"}], "]"}], ",", 
    RowBox[{"LevelLabel", "[", 
     RowBox[{
      RowBox[{"1", "/", "2"}], ",", "1"}], "]"}], ",", 
    RowBox[{"LevelLabel", "[", 
     RowBox[{"1", "/", "2"}], "]"}]}], "}"}], "//", "DisplayForm"}]], "Input",\

 CellChangeTimes->{
  3.533747281015625*^9, {3.533748113421875*^9, 3.533748128203125*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    SubsuperscriptBox["2", "1", "-"], ",", 
    SubsuperscriptBox["2", "1", ""], ",", 
    SubsuperscriptBox[GridBox[{
       {
        TagBox["1",
         DisplayForm], "/", 
        TagBox["2",
         DisplayForm]}
      },
      BaselinePosition->{{1, 3}, Baseline},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[-0.06999999999999999]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "1", ""], ",", 
    SubsuperscriptBox[GridBox[{
       {
        TagBox["1",
         DisplayForm], "/", 
        TagBox["2",
         DisplayForm]}
      },
      BaselinePosition->{{1, 3}, Baseline},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[-0.06999999999999999]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}], "", ""]}], "}"}],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.533747025328125*^9, 3.533747063484375*^9}, 
   3.53374719703125*^9, {3.533747250390625*^9, 3.53374728146875*^9}, {
   3.53374812996875*^9, 3.5337481351875*^9}, 3.53374818246875*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"{", 
   RowBox[{
    RowBox[{"LevelLabel", "[", 
     RowBox[{
      RowBox[{"1", "/", "2"}], ",", "1", ",", 
      RowBox[{"+", "1"}], ",", 
      RowBox[{"Rational", "\[Rule]", "DiagonalFractionize"}]}], "]"}], ",", 
    RowBox[{"LevelLabel", "[", 
     RowBox[{
      RowBox[{"1", "/", "2"}], ",", "1", ",", 
      RowBox[{"+", "1"}], ",", 
      RowBox[{"Rational", "\[Rule]", "Fractionize"}]}], "]"}]}], "}"}], "//", 
  "DisplayForm"}]], "Input",
 CellChangeTimes->{{3.533747088328125*^9, 3.533747120828125*^9}, {
  3.53374821034375*^9, 3.5337482193125*^9}}],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    SubsuperscriptBox[
     TagBox[
      StyleBox[GridBox[{
         {
          AdjustmentBox[
           SubscriptBox["", 
            TagBox["1",
             DisplayForm]],
           BoxBaselineShift->-0.5], 
          AdjustmentBox[
           SubscriptBox["", 
            TagBox[
             StyleBox["\<\"/\"\>",
              FontSlant->"Oblique"],
             StyleForm[#, FontSlant -> "Oblique"]& ]],
           BoxBaselineShift->-0.3], 
          AdjustmentBox[
           SubscriptBox["", 
            TagBox["2",
             DisplayForm]],
           BoxBaselineShift->0.]}
        },
        BaselinePosition->{{1, 3}, Bottom},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[-0.21]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ScriptBaselineShifts->{0, 0}],
      SciDraw`DiagonalFractionBox[-0.15]], "1", "+"], ",", 
    SubsuperscriptBox[
     FractionBox["1", "2"], "1", "+"]}], "}"}],
  DisplayForm]], "Output",
 CellChangeTimes->{3.533747121546875*^9, 3.53374719853125*^9, 
  3.533747271125*^9, 3.53374821965625*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"LevelLabel", "[", "2", "]"}], ",", 
   RowBox[{"LevelLabel", "[", 
    RowBox[{"2", ",", 
     RowBox[{"Parity", "\[Rule]", 
      RowBox[{"+", "1"}]}]}], "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.547139423609375*^9, 3.547139438703125*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"2", ",", 
   TemplateBox[{"2","\"+\""},
    "Superscript"]}], "}"}]], "Output",
 CellChangeTimes->{
  3.547139438984375*^9, {3.54713951128125*^9, 3.547139533796875*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"LevelLabel", "[", 
   RowBox[{"\"\<\!\(\*
StyleBox[\"J\",
FontSlant->\"Italic\"]\)\>\"", ",", "\"\<\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\>\"", ",", "\"\<\[Pi]\>\""}], "]"}], "//", 
  "DisplayForm"}]], "Input",
 CellChangeTimes->{{3.533748229890625*^9, 3.53374825275*^9}}],

Cell[BoxData[
 TagBox[
  SubsuperscriptBox[
   StyleBox["J",
    FontSlant->"Italic"], 
   StyleBox["i",
    FontSlant->"Italic"], "\[Pi]"],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.533748246640625*^9, 3.533748253140625*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Energy label", "Subsection",
 CellChangeTimes->{{3.533745230359375*^9, 3.533745246875*^9}, {
  3.582822467649203*^9, 3.582822469427606*^9}}],

Cell["E(level)", "Text",
 CellChangeTimes->{{3.533745250578125*^9, 3.533745284125*^9}, {
  3.582822476307218*^9, 3.5828224778204207`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "EnergyLabel", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Symbol", "\[Rule]", 
     RowBox[{"textit", "[", "\"\<E\>\"", "]"}]}], "}"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533745288921875*^9, 3.53374542921875*^9}, {
  3.53374560359375*^9, 3.53374570225*^9}, {3.5337457759375*^9, 
  3.533745914625*^9}, {3.53374595853125*^9, 3.533745974*^9}, {
  3.53374601284375*^9, 3.533746076546875*^9}, {3.53374613984375*^9, 
  3.533746176484375*^9}, {3.533746379765625*^9, 3.53374638625*^9}, {
  3.533746491625*^9, 3.533746494046875*^9}, {3.582822480878026*^9, 
  3.582822493092848*^9}, {3.5828232808162313`*^9, 3.582823286541441*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"EnergyLabel", "[", 
    RowBox[{"Level1_", ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Row", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"OptionValue", "[", "Symbol", "]"}], ",", "\"\<(\>\"", ",", 
        RowBox[{"Switch", "[", 
         RowBox[{"Level1", ",", "_List", ",", 
          RowBox[{"LevelLabel", "[", "Level1", "]"}], ",", "_", ",", 
          "Level1"}], "]"}], ",", "\"\<)\>\""}], "}"}], "]"}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533745288921875*^9, 3.53374542921875*^9}, {
   3.53374560359375*^9, 3.53374570225*^9}, {3.5337457759375*^9, 
   3.533745914625*^9}, {3.53374595853125*^9, 3.533745974*^9}, {
   3.53374601284375*^9, 3.533746076546875*^9}, {3.53374613984375*^9, 
   3.533746176484375*^9}, {3.533746229421875*^9, 3.53374628221875*^9}, 
   3.533746501859375*^9, {3.582822507242072*^9, 3.5828225646813736`*^9}, {
   3.5828226712607603`*^9, 3.5828226756599684`*^9}, {3.582822709028427*^9, 
   3.582822711649232*^9}, {3.5828232917674503`*^9, 3.5828232946222553`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Electromagnetic transition labels", "Subsection",
 CellChangeTimes->{{3.533745230359375*^9, 3.533745246875*^9}}],

Cell["Reduced transition probability -- B(\[Sigma]\[Lambda];i\[Rule]f)", \
"Text",
 CellChangeTimes->{{3.533745250578125*^9, 3.533745284125*^9}}],

Cell["\<\
Limitations -- does not support proper pass through of options to RTPLabel\
\>", "Text",
 CellChangeTimes->{{3.629413643011302*^9, 3.6294136694065485`*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "RTPLabel", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"MultipolaritySymbols", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<E\>\"", ",", "\"\<M\>\""}], "}"}]}], ",", 
     RowBox[{"MultipolarityStyle", "\[Rule]", "Italic"}]}], "}"}]}], 
  ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533745288921875*^9, 3.53374542921875*^9}, {
  3.53374560359375*^9, 3.53374570225*^9}, {3.5337457759375*^9, 
  3.533745914625*^9}, {3.53374595853125*^9, 3.533745974*^9}, {
  3.53374601284375*^9, 3.533746076546875*^9}, {3.53374613984375*^9, 
  3.533746176484375*^9}, {3.533746379765625*^9, 3.53374638625*^9}, {
  3.533746491625*^9, 3.533746494046875*^9}, {3.617457177360282*^9, 
  3.6174571851446953`*^9}, {3.6294135316271067`*^9, 3.629413532375908*^9}}],

Cell["\<\
\thandle default cases, where function provides \[OpenCurlyDoubleQuote]E\
\[CloseCurlyDoubleQuote] or \[OpenCurlyDoubleQuote]M\[CloseCurlyDoubleQuote] \
symbol\
\>", "Text",
 CellChangeTimes->{{3.53374617925*^9, 3.5337462065625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RTPLabel", "[", 
    RowBox[{
     RowBox[{"Multipolarity", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"sigma", ":", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"+", "1"}], "|", 
           RowBox[{"-", "1"}]}], ")"}]}], ",", "lambda_Integer"}], "}"}]}], 
     ",", "Level1_", ",", "Level2_", ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Mode", ",", "StyleDirective"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Mode", "=", 
       RowBox[{"Switch", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"sigma", "*", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], "^", "lambda"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"+", "1"}], ",", 
         RowBox[{
          RowBox[{"OptionValue", "[", "MultipolaritySymbols", "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", "  ", 
         RowBox[{"(*", " ", "\"\<E\>\"", " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"-", "1"}], ",", 
         RowBox[{
          RowBox[{"OptionValue", "[", "MultipolaritySymbols", "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], "  ", 
        RowBox[{"(*", " ", "\"\<M\>\"", " ", "*)"}], "\[IndentingNewLine]", 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"StyleDirective", "=", 
       RowBox[{"OptionValue", "[", "MultipolarityStyle", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"RTPLabel", "[", 
       RowBox[{
        RowBox[{"Row", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"Mode", ",", "StyleDirective"}], "]"}], ",", "lambda"}], 
          "}"}], "]"}], ",", "Level1", ",", "Level2", ",", "Opts"}], 
       "]"}]}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RTPLabel", "[", 
    RowBox[{"lambda_Integer", ",", "Level1_", ",", "Level2_", ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"RTPLabel", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"+", "1"}], ",", "lambda"}], "}"}], ",", "Level1", ",", 
     "Level2", ",", "Opts"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533745288921875*^9, 3.53374542921875*^9}, {
   3.53374560359375*^9, 3.53374570225*^9}, {3.5337457759375*^9, 
   3.533745914625*^9}, {3.53374595853125*^9, 3.533745974*^9}, {
   3.53374601284375*^9, 3.533746076546875*^9}, {3.53374613984375*^9, 
   3.533746176484375*^9}, {3.533746229421875*^9, 3.53374628221875*^9}, 
   3.533746501859375*^9, {3.617457212538344*^9, 3.6174572512732115`*^9}, 
   3.617457403451479*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RTPLabel", "[", 
    RowBox[{
     RowBox[{"Multipolarity", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"sigma", ":", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"+", "1"}], "|", 
           RowBox[{"-", "1"}]}], ")"}]}], ",", "lambda_Integer"}], "}"}]}], 
     ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Mode", ",", "StyleDirective"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Mode", "=", 
       RowBox[{"Switch", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"sigma", "*", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], "^", "lambda"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"+", "1"}], ",", 
         RowBox[{
          RowBox[{"OptionValue", "[", "MultipolaritySymbols", "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", "  ", 
         RowBox[{"(*", " ", "\"\<E\>\"", " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"-", "1"}], ",", 
         RowBox[{
          RowBox[{"OptionValue", "[", "MultipolaritySymbols", "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], "  ", 
        RowBox[{"(*", " ", "\"\<M\>\"", " ", "*)"}], "\[IndentingNewLine]", 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"StyleDirective", "=", 
       RowBox[{"OptionValue", "[", "MultipolarityStyle", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"RTPLabel", "[", 
       RowBox[{
        RowBox[{"Row", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"Style", "[", 
            RowBox[{"Mode", ",", "StyleDirective"}], "]"}], ",", "lambda"}], 
          "}"}], "]"}], ",", "Opts"}], "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RTPLabel", "[", 
    RowBox[{"lambda_Integer", ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"RTPLabel", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"+", "1"}], ",", "lambda"}], "}"}], ",", "Opts"}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533745288921875*^9, 3.53374542921875*^9}, {
   3.53374560359375*^9, 3.53374570225*^9}, {3.5337457759375*^9, 
   3.533745914625*^9}, {3.53374595853125*^9, 3.533745974*^9}, {
   3.53374601284375*^9, 3.533746076546875*^9}, {3.53374613984375*^9, 
   3.533746176484375*^9}, {3.533746229421875*^9, 3.53374628221875*^9}, 
   3.533746501859375*^9, {3.56018212871875*^9, 3.560182145703125*^9}, {
   3.6174572255955667`*^9, 3.6174572567488213`*^9}, 3.61745740382588*^9}],

Cell["\tgeneric case -- multipolarity symbol given explicitly", "Text",
 CellChangeTimes->{{3.533746167984375*^9, 3.533746170203125*^9}, {
  3.600182633450878*^9, 3.6001826414110007`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RTPLabel", "[", 
    RowBox[{
     RowBox[{"Multipolarity", ":", 
      RowBox[{"Except", "[", 
       RowBox[{
        RowBox[{"(", "_Integer", ")"}], "|", 
        RowBox[{"(", "_List", ")"}]}], "]"}]}], ",", "Level1_", ",", 
     "Level2_", ",", 
     RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
   RowBox[{"Row", "[", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"textit", "[", "\"\<B\>\"", "]"}], ",", "\"\<(\>\"", ",", 
      "Multipolarity", ",", "\"\<;\>\"", ",", "\[IndentingNewLine]", 
      RowBox[{"Switch", "[", 
       RowBox[{"Level1", ",", "_List", ",", 
        RowBox[{"LevelLabel", "[", "Level1", "]"}], ",", "_", ",", "Level1"}],
        "]"}], ",", "\[IndentingNewLine]", "\"\<\[Rule]\>\"", ",", 
      "\[IndentingNewLine]", 
      RowBox[{"Switch", "[", 
       RowBox[{"Level2", ",", "_List", ",", 
        RowBox[{"LevelLabel", "[", "Level2", "]"}], ",", "_", ",", "Level2"}],
        "]"}], ",", "\[IndentingNewLine]", "\"\<)\>\""}], 
     "\[IndentingNewLine]", "}"}], "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RTPLabel", "[", 
    RowBox[{
     RowBox[{"Multipolarity", ":", 
      RowBox[{"Except", "[", 
       RowBox[{
        RowBox[{"(", "_Integer", ")"}], "|", 
        RowBox[{"(", "_List", ")"}]}], "]"}]}], ",", 
     RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
   RowBox[{"Row", "[", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"textit", "[", "\"\<B\>\"", "]"}], ",", "\"\<(\>\"", ",", 
      "Multipolarity", ",", "\[IndentingNewLine]", "\"\<)\>\""}], 
     "\[IndentingNewLine]", "}"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533745288921875*^9, 3.53374542921875*^9}, {
  3.53374560359375*^9, 3.53374570225*^9}, {3.5337457759375*^9, 
  3.533745914625*^9}, {3.53374595853125*^9, 3.533745974*^9}, {
  3.53374601284375*^9, 3.53374612271875*^9}, {3.533748623875*^9, 
  3.53374865540625*^9}, {3.5601820895*^9, 3.560182098265625*^9}, {
  3.6001826006131334`*^9, 3.6001826209331865`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"RTPLabel", "[", "2", "]"}], "//", 
  "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RTPLabel", "[", 
   RowBox[{"2", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "1", ",", 
      RowBox[{"+", "1"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", 
      RowBox[{"+", "1"}]}], "}"}]}], "]"}], "//", 
  "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RTPLabel", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", 
      RowBox[{"-", "1"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", 
      RowBox[{"+", "1"}]}], "}"}]}], "]"}], "//", 
  "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RTPLabel", "[", 
   RowBox[{"\"\<\[Sigma]\[Lambda]\>\"", ",", 
    RowBox[{"{", 
     RowBox[{"\"\<\!\(\*
StyleBox[\"J\",
FontSlant->\"Italic\"]\)\>\"", ",", "\"\<\!\(\*
StyleBox[\"i\",
FontSlant->\"Italic\"]\)\>\""}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\"\<\!\(\*
StyleBox[\"J\",
FontSlant->\"Italic\"]\)\>\"", ",", "\"\<f\>\""}], "}"}]}], "]"}], "//", 
  "DisplayForm"}]}], "Input",
 CellChangeTimes->{{3.533745708828125*^9, 3.5337457203125*^9}, {
  3.53374630165625*^9, 3.53374633359375*^9}, {3.533746509203125*^9, 
  3.5337465494375*^9}, {3.533748695328125*^9, 3.533748800984375*^9}, {
  3.560182175328125*^9, 3.56018217971875*^9}}],

Cell[BoxData[
 TagBox[
  TemplateBox[{TagBox[
     StyleBox["\"B\"", FontSlant -> "Italic"], 
     StyleForm[#, FontSlant -> "Italic"]& ],"\"(\"",TemplateBox[{
      TagBox[
       StyleBox["\"E\"", FontSlant -> "Italic"], 
       StyleForm[#, FontSlant -> "Italic"]& ], "2"}, "Row", 
     DisplayFunction -> (RowBox[{#, "\[InvisibleSpace]", #2}]& ), 
     InterpretationFunction -> (RowBox[{"Row", "[", 
        RowBox[{"{", 
          RowBox[{#, ",", #2}], "}"}], "]"}]& )],"\")\""},
   "Row",
   DisplayFunction->(
    RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3, 
      "\[InvisibleSpace]", #4}]& ),
   InterpretationFunction->(RowBox[{"Row", "[", 
      RowBox[{"{", 
        RowBox[{#, ",", #2, ",", #3, ",", #4}], "}"}], "]"}]& )],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.533745750953125*^9, 3.533745762171875*^9}, {
   3.533746291421875*^9, 3.533746334109375*^9}, {3.533746507265625*^9, 
   3.5337465545*^9}, {3.533748707328125*^9, 3.533748714078125*^9}, 
   3.533748750015625*^9, {3.533748781859375*^9, 3.533748801359375*^9}, 
   3.560182180109375*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{TagBox[
     StyleBox["\"B\"", FontSlant -> "Italic"], 
     StyleForm[#, FontSlant -> "Italic"]& ],"\"(\"",TemplateBox[{
      TagBox[
       StyleBox["\"E\"", FontSlant -> "Italic"], 
       StyleForm[#, FontSlant -> "Italic"]& ], "2"}, "Row", 
     DisplayFunction -> (RowBox[{#, "\[InvisibleSpace]", #2}]& ), 
     InterpretationFunction -> (RowBox[{"Row", "[", 
        RowBox[{"{", 
          RowBox[{#, ",", #2}], "}"}], "]"}]& )],"\";\"",InterpretationBox[
     SubsuperscriptBox["2", "1", "\"+\""], 
     Subsuperscript[2, 1, "+"], Editable -> False],"\"\[Rule]\"",
    InterpretationBox[
     SubsuperscriptBox["0", "1", "\"+\""], 
     Subsuperscript[0, 1, "+"], Editable -> False],"\")\""},
   "Row",
   DisplayFunction->(
    RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3, 
      "\[InvisibleSpace]", #4, "\[InvisibleSpace]", #5, 
      "\[InvisibleSpace]", #6, "\[InvisibleSpace]", #7, 
      "\[InvisibleSpace]", #8}]& ),
   InterpretationFunction->(RowBox[{"Row", "[", 
      RowBox[{"{", 
        RowBox[{#, ",", #2, ",", #3, ",", #4, ",", #5, ",", #6, ",", #7, 
          ",", #8}], "}"}], "]"}]& )],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.533745750953125*^9, 3.533745762171875*^9}, {
   3.533746291421875*^9, 3.533746334109375*^9}, {3.533746507265625*^9, 
   3.5337465545*^9}, {3.533748707328125*^9, 3.533748714078125*^9}, 
   3.533748750015625*^9, {3.533748781859375*^9, 3.533748801359375*^9}, 
   3.560182180125*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{TagBox[
     StyleBox["\"B\"", FontSlant -> "Italic"], 
     StyleForm[#, FontSlant -> "Italic"]& ],"\"(\"",TemplateBox[{
      TagBox[
       StyleBox["\"E\"", FontSlant -> "Italic"], 
       StyleForm[#, FontSlant -> "Italic"]& ], "1"}, "Row", 
     DisplayFunction -> (RowBox[{#, "\[InvisibleSpace]", #2}]& ), 
     InterpretationFunction -> (RowBox[{"Row", "[", 
        RowBox[{"{", 
          RowBox[{#, ",", #2}], "}"}], "]"}]& )],"\";\"",InterpretationBox[
     SubsuperscriptBox["1", "1", "\"-\""], 
     Subsuperscript[1, 1, "-"], Editable -> False],"\"\[Rule]\"",
    InterpretationBox[
     SubsuperscriptBox["0", "1", "\"+\""], 
     Subsuperscript[0, 1, "+"], Editable -> False],"\")\""},
   "Row",
   DisplayFunction->(
    RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3, 
      "\[InvisibleSpace]", #4, "\[InvisibleSpace]", #5, 
      "\[InvisibleSpace]", #6, "\[InvisibleSpace]", #7, 
      "\[InvisibleSpace]", #8}]& ),
   InterpretationFunction->(RowBox[{"Row", "[", 
      RowBox[{"{", 
        RowBox[{#, ",", #2, ",", #3, ",", #4, ",", #5, ",", #6, ",", #7, 
          ",", #8}], "}"}], "]"}]& )],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.533745750953125*^9, 3.533745762171875*^9}, {
   3.533746291421875*^9, 3.533746334109375*^9}, {3.533746507265625*^9, 
   3.5337465545*^9}, {3.533748707328125*^9, 3.533748714078125*^9}, 
   3.533748750015625*^9, {3.533748781859375*^9, 3.533748801359375*^9}, 
   3.5601821801875*^9}],

Cell[BoxData[
 TagBox[
  TemplateBox[{TagBox[
     StyleBox["\"B\"", FontSlant -> "Italic"], 
     StyleForm[#, FontSlant -> "Italic"]& ],"\"(\"","\"\[Sigma]\[Lambda]\"",
    "\";\"",SubscriptBox[
    "\"\\!\\(\\*\\nStyleBox[\\\"J\\\",\\nFontSlant->\\\"Italic\\\"]\\)\"", 
     "\"\\!\\(\\*\\nStyleBox[\\\"i\\\",\\nFontSlant->\\\"Italic\\\"]\\)\""],
    "\"\[Rule]\"",SubscriptBox[
    "\"\\!\\(\\*\\nStyleBox[\\\"J\\\",\\nFontSlant->\\\"Italic\\\"]\\)\"", 
     "\"f\""],"\")\""},
   "Row",
   DisplayFunction->(
    RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3, 
      "\[InvisibleSpace]", #4, "\[InvisibleSpace]", #5, 
      "\[InvisibleSpace]", #6, "\[InvisibleSpace]", #7, 
      "\[InvisibleSpace]", #8}]& ),
   InterpretationFunction->(RowBox[{"Row", "[", 
      RowBox[{"{", 
        RowBox[{#, ",", #2, ",", #3, ",", #4, ",", #5, ",", #6, ",", #7, 
          ",", #8}], "}"}], "]"}]& )],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.533745750953125*^9, 3.533745762171875*^9}, {
   3.533746291421875*^9, 3.533746334109375*^9}, {3.533746507265625*^9, 
   3.5337465545*^9}, {3.533748707328125*^9, 3.533748714078125*^9}, 
   3.533748750015625*^9, {3.533748781859375*^9, 3.533748801359375*^9}, 
   3.56018218025*^9}]
}, Open  ]],

Cell["Reduced matrix element -- <f||\[Sigma]\[Lambda]||>", "Text",
 CellChangeTimes->{{3.533745250578125*^9, 3.533745284125*^9}, {
  3.6001822880876956`*^9, 3.600182304707719*^9}}],

Cell[TextData[{
 "Note: The \\Vert symbol [DoubleVerticalBar] is too small/low-slung in ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ".  Therefore, use as default two bars (with no space between them)."
}], "Text",
 CellChangeTimes->{{3.600198270485178*^9, 3.6001983241302533`*^9}, {
  3.600198366690313*^9, 3.6001984053453665`*^9}, {3.6001985693571277`*^9, 
  3.600198575739726*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "RMELabel", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"MultipolaritySymbols", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"\"\<Q\>\"", ",", "\"\<M\>\""}], "}"}]}], ",", 
     RowBox[{"MultipolarityStyle", "\[Rule]", "Bold"}], ",", 
     RowBox[{"Dividers", "\[Rule]", "\"\<||\>\""}]}], "}"}]}], ";"}]], "Input",\

 InitializationCell->True,
 CellChangeTimes->{{3.533745288921875*^9, 3.53374542921875*^9}, {
   3.53374560359375*^9, 3.53374570225*^9}, {3.5337457759375*^9, 
   3.533745914625*^9}, {3.53374595853125*^9, 3.533745974*^9}, {
   3.53374601284375*^9, 3.533746076546875*^9}, {3.53374613984375*^9, 
   3.533746176484375*^9}, {3.533746379765625*^9, 3.53374638625*^9}, {
   3.533746491625*^9, 3.533746494046875*^9}, {3.6001823098677263`*^9, 
   3.60018231949774*^9}, {3.600198191065067*^9, 3.600198195645073*^9}, {
   3.600198388060343*^9, 3.600198416140382*^9}, 3.6001985317815504`*^9, {
   3.617457050188859*^9, 3.617457086880123*^9}}],

Cell["\<\
\thandle default cases, where function provides \[OpenCurlyDoubleQuote]Q\
\[CloseCurlyDoubleQuote] or \[OpenCurlyDoubleQuote]M\[CloseCurlyDoubleQuote] \
symbol
\talternative MultipolaritySymbols\[Rule]{textbf[\[OpenCurlyDoubleQuote]Q\
\[CloseCurlyDoubleQuote]],textbf[\[OpenCurlyDoubleQuote]M\
\[CloseCurlyDoubleQuote]]}\
\>", "Text",
 CellChangeTimes->{{3.53374617925*^9, 3.5337462065625*^9}, 
   3.6001823239577456`*^9, {3.617456914843021*^9, 3.6174569296942472`*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RMELabel", "[", 
    RowBox[{
     RowBox[{"Multipolarity", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"sigma", ":", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"+", "1"}], "|", 
           RowBox[{"-", "1"}]}], ")"}]}], ",", "lambda_Integer"}], "}"}]}], 
     ",", "Level2_", ",", "Level1_", ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Mode", ",", "StyleDirective"}], "}"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Mode", "=", 
       RowBox[{"Switch", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"sigma", "*", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], "^", "lambda"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"+", "1"}], ",", 
         RowBox[{
          RowBox[{"OptionValue", "[", "MultipolaritySymbols", "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", "  ", 
         RowBox[{"(*", " ", "\"\<Q\>\"", " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"-", "1"}], ",", 
         RowBox[{
          RowBox[{"OptionValue", "[", "MultipolaritySymbols", "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], "  ", 
        RowBox[{"(*", " ", "\"\<M\>\"", " ", "*)"}], "\[IndentingNewLine]", 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"StyleDirective", "=", 
       RowBox[{"OptionValue", "[", "MultipolarityStyle", "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"RMELabel", "[", 
       RowBox[{
        RowBox[{"Subscript", "[", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"Mode", ",", "StyleDirective"}], "]"}], ",", "lambda"}], 
         "]"}], ",", "Level2", ",", "Level1", ",", "Opts"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RMELabel", "[", 
    RowBox[{"lambda_Integer", ",", "Level2_", ",", "Level1_", ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"RMELabel", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"+", "1"}], ",", "lambda"}], "}"}], ",", "Level2", ",", 
     "Level1", ",", "Opts"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533745288921875*^9, 3.53374542921875*^9}, {
   3.53374560359375*^9, 3.53374570225*^9}, {3.5337457759375*^9, 
   3.533745914625*^9}, {3.53374595853125*^9, 3.533745974*^9}, {
   3.53374601284375*^9, 3.533746076546875*^9}, {3.53374613984375*^9, 
   3.533746176484375*^9}, {3.533746229421875*^9, 3.53374628221875*^9}, 
   3.533746501859375*^9, {3.6001823317277565`*^9, 3.600182446352917*^9}, {
   3.6001828424465885`*^9, 3.60018287898965*^9}, {3.617457127050194*^9, 
   3.617457161900655*^9}, 3.6174574042626805`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"RMELabel", "[", 
    RowBox[{
     RowBox[{"Multipolarity", ":", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"sigma", ":", 
         RowBox[{"(", 
          RowBox[{
           RowBox[{"+", "1"}], "|", 
           RowBox[{"-", "1"}]}], ")"}]}], ",", "lambda_Integer"}], "}"}]}], 
     ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", "Mode", "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Mode", "=", 
       RowBox[{"Switch", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"sigma", "*", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"-", "1"}], ")"}], "^", "lambda"}]}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"+", "1"}], ",", 
         RowBox[{
          RowBox[{"OptionValue", "[", "MultipolaritySymbols", "]"}], "[", 
          RowBox[{"[", "1", "]"}], "]"}], ",", "  ", 
         RowBox[{"(*", " ", "\"\<E\>\"", " ", "*)"}], "\[IndentingNewLine]", 
         RowBox[{"-", "1"}], ",", 
         RowBox[{
          RowBox[{"OptionValue", "[", "MultipolaritySymbols", "]"}], "[", 
          RowBox[{"[", "2", "]"}], "]"}]}], "  ", 
        RowBox[{"(*", " ", "\"\<M\>\"", " ", "*)"}], "\[IndentingNewLine]", 
        "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"RMELabel", "[", 
       RowBox[{
        RowBox[{"Subscript", "[", 
         RowBox[{"Mode", ",", "lambda"}], "]"}], ",", "Opts"}], "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"RMELabel", "[", 
    RowBox[{"lambda_Integer", ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"RMELabel", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"+", "1"}], ",", "lambda"}], "}"}], ",", "Opts"}], "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533745288921875*^9, 3.53374542921875*^9}, {
   3.53374560359375*^9, 3.53374570225*^9}, {3.5337457759375*^9, 
   3.533745914625*^9}, {3.53374595853125*^9, 3.533745974*^9}, {
   3.53374601284375*^9, 3.533746076546875*^9}, {3.53374613984375*^9, 
   3.533746176484375*^9}, {3.533746229421875*^9, 3.53374628221875*^9}, 
   3.533746501859375*^9, {3.56018212871875*^9, 3.560182145703125*^9}, {
   3.6001824479829197`*^9, 3.6001824487379203`*^9}, {3.6001828934298716`*^9, 
   3.6001829345005026`*^9}}],

Cell["\tgeneric case -- multipolarity symbol given explicitly", "Text",
 CellChangeTimes->{{3.533746167984375*^9, 3.533746170203125*^9}, 
   3.6001826494336243`*^9}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"RMELabel", "[", 
   RowBox[{
    RowBox[{"Multipolarity", ":", 
     RowBox[{"Except", "[", 
      RowBox[{
       RowBox[{"(", "_Integer", ")"}], "|", 
       RowBox[{"(", "_List", ")"}]}], "]"}]}], ",", "Level2_", ",", "Level1_",
     ",", 
    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
  RowBox[{"Row", "[", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"\"\<\[LeftAngleBracket]\>\"", ",", 
     RowBox[{"Switch", "[", 
      RowBox[{"Level2", ",", "_List", ",", 
       RowBox[{"LevelLabel", "[", "Level2", "]"}], ",", "_", ",", "Level2"}], 
      "]"}], ",", 
     RowBox[{"OptionValue", "[", "Dividers", "]"}], ",", "Multipolarity", ",", 
     RowBox[{"OptionValue", "[", "Dividers", "]"}], ",", 
     RowBox[{"Switch", "[", 
      RowBox[{"Level1", ",", "_List", ",", 
       RowBox[{"LevelLabel", "[", "Level1", "]"}], ",", "_", ",", "Level1"}], 
      "]"}], ",", "\"\<\[RightAngleBracket]\>\""}], "\[IndentingNewLine]", 
    "}"}], "]"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RMELabel", "[", 
   RowBox[{
    RowBox[{"Multipolarity", ":", 
     RowBox[{"Except", "[", 
      RowBox[{
       RowBox[{"(", "_Integer", ")"}], "|", 
       RowBox[{"(", "_List", ")"}]}], "]"}]}], ",", 
    RowBox[{"OptionsPattern", "[", "]"}]}], "]"}], ":=", 
  RowBox[{"Row", "[", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{"\"\<\[LeftAngleBracket]\>\"", ",", 
     RowBox[{"OptionValue", "[", "Dividers", "]"}], ",", "Multipolarity", ",", 
     RowBox[{"OptionValue", "[", "Dividers", "]"}], ",", 
     "\"\<\[RightAngleBracket]\>\""}], "\[IndentingNewLine]", "}"}], 
   "]"}]}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533745288921875*^9, 3.53374542921875*^9}, {
  3.53374560359375*^9, 3.53374570225*^9}, {3.5337457759375*^9, 
  3.533745914625*^9}, {3.53374595853125*^9, 3.533745974*^9}, {
  3.53374601284375*^9, 3.53374612271875*^9}, {3.533748623875*^9, 
  3.53374865540625*^9}, {3.5601820895*^9, 3.560182098265625*^9}, {
  3.600182505198*^9, 3.6001825225180235`*^9}, {3.600182660296291*^9, 
  3.6001827105595627`*^9}, {3.600182750680179*^9, 3.6001827598153195`*^9}, {
  3.6001982071200895`*^9, 3.600198244290141*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"RMELabel", "[", "2", "]"}], "//", 
  "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RMELabel", "[", 
   RowBox[{"2", ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", 
      RowBox[{"+", "1"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "1", ",", 
      RowBox[{"+", "1"}]}], "}"}]}], "]"}], "//", 
  "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RMELabel", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "1", ",", 
      RowBox[{"+", "1"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"1", ",", "1", ",", 
      RowBox[{"-", "1"}]}], "}"}]}], "]"}], "//", 
  "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"RMELabel", "[", 
   RowBox[{
    RowBox[{"textit", "[", "\"\<T\>\"", "]"}], ",", 
    RowBox[{"{", 
     RowBox[{"\"\<\!\(\*
StyleBox[\"J\",
FontSlant->\"Italic\"]\)\>\"", ",", "\"\<f\>\""}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\"\<\!\(\*
StyleBox[\"J\",
FontSlant->\"Italic\"]\)\>\"", ",", "\"\<i\>\""}], "}"}]}], "]"}], "//", 
  "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"textfamily", "[", 
   RowBox[{"\"\<Times\>\"", ",", 
    RowBox[{"RMELabel", "[", "2", "]"}]}], "]"}], "//", 
  "DisplayForm"}]}], "Input",
 CellChangeTimes->{{3.533745708828125*^9, 3.5337457203125*^9}, {
  3.53374630165625*^9, 3.53374633359375*^9}, {3.533746509203125*^9, 
  3.5337465494375*^9}, {3.533748695328125*^9, 3.533748800984375*^9}, {
  3.560182175328125*^9, 3.56018217971875*^9}, {3.60018276372538*^9, 
  3.6001828241563077`*^9}, {3.600182922685321*^9, 3.6001829241878443`*^9}, {
  3.6001985475167923`*^9, 3.600198561509507*^9}}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\"\[LeftAngleBracket]\"","\"||\"",SubscriptBox[
     TagBox[
      StyleBox["\"Q\"", FontSlant -> "Italic"], 
      StyleForm[#, FontSlant -> "Italic"]& ], "2"],"\"||\"",
    "\"\[RightAngleBracket]\""},
   "RowDefault"],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.533745750953125*^9, 3.533745762171875*^9}, {
   3.533746291421875*^9, 3.533746334109375*^9}, {3.533746507265625*^9, 
   3.5337465545*^9}, {3.533748707328125*^9, 3.533748714078125*^9}, 
   3.533748750015625*^9, {3.533748781859375*^9, 3.533748801359375*^9}, 
   3.560182180109375*^9, {3.6001827743280425`*^9, 3.6001828244988127`*^9}, {
   3.6001829164177246`*^9, 3.6001829375280495`*^9}, {3.600198220680108*^9, 
   3.6001982475151463`*^9}, {3.600198399575359*^9, 3.6001984211753893`*^9}, {
   3.600198540706688*^9, 3.6001985619170136`*^9}}],

Cell[BoxData[
 TagBox[
  TemplateBox[{
   "\"\[LeftAngleBracket]\"",
    TemplateBox[{"0", "1", "\"+\""}, "Subsuperscript"],"\"||\"",SubscriptBox[
     TagBox[
      StyleBox["\"Q\"", FontSlant -> "Italic"], 
      StyleForm[#, FontSlant -> "Italic"]& ], "2"],"\"||\"",
    TemplateBox[{"2", "1", "\"+\""}, "Subsuperscript"],
    "\"\[RightAngleBracket]\""},
   "RowDefault"],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.533745750953125*^9, 3.533745762171875*^9}, {
   3.533746291421875*^9, 3.533746334109375*^9}, {3.533746507265625*^9, 
   3.5337465545*^9}, {3.533748707328125*^9, 3.533748714078125*^9}, 
   3.533748750015625*^9, {3.533748781859375*^9, 3.533748801359375*^9}, 
   3.560182180109375*^9, {3.6001827743280425`*^9, 3.6001828244988127`*^9}, {
   3.6001829164177246`*^9, 3.6001829375280495`*^9}, {3.600198220680108*^9, 
   3.6001982475151463`*^9}, {3.600198399575359*^9, 3.6001984211753893`*^9}, {
   3.600198540706688*^9, 3.6001985619220133`*^9}}],

Cell[BoxData[
 TagBox[
  TemplateBox[{
   "\"\[LeftAngleBracket]\"",
    TemplateBox[{"0", "1", "\"+\""}, "Subsuperscript"],"\"||\"",SubscriptBox[
     TagBox[
      StyleBox["\"Q\"", FontSlant -> "Italic"], 
      StyleForm[#, FontSlant -> "Italic"]& ], "1"],"\"||\"",
    TemplateBox[{"1", "1", "\"-\""}, "Subsuperscript"],
    "\"\[RightAngleBracket]\""},
   "RowDefault"],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.533745750953125*^9, 3.533745762171875*^9}, {
   3.533746291421875*^9, 3.533746334109375*^9}, {3.533746507265625*^9, 
   3.5337465545*^9}, {3.533748707328125*^9, 3.533748714078125*^9}, 
   3.533748750015625*^9, {3.533748781859375*^9, 3.533748801359375*^9}, 
   3.560182180109375*^9, {3.6001827743280425`*^9, 3.6001828244988127`*^9}, {
   3.6001829164177246`*^9, 3.6001829375280495`*^9}, {3.600198220680108*^9, 
   3.6001982475151463`*^9}, {3.600198399575359*^9, 3.6001984211753893`*^9}, {
   3.600198540706688*^9, 3.6001985619270134`*^9}}],

Cell[BoxData[
 TagBox[
  TemplateBox[{
   "\"\[LeftAngleBracket]\"",SubscriptBox[
    "\"\\!\\(\\*\\nStyleBox[\\\"J\\\",\\nFontSlant->\\\"Italic\\\"]\\)\"", 
     "\"f\""],"\"||\"",TagBox[
     StyleBox["\"T\"", FontSlant -> "Italic"], 
     StyleForm[#, FontSlant -> "Italic"]& ],"\"||\"",SubscriptBox[
    "\"\\!\\(\\*\\nStyleBox[\\\"J\\\",\\nFontSlant->\\\"Italic\\\"]\\)\"", 
     "\"i\""],"\"\[RightAngleBracket]\""},
   "RowDefault"],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.533745750953125*^9, 3.533745762171875*^9}, {
   3.533746291421875*^9, 3.533746334109375*^9}, {3.533746507265625*^9, 
   3.5337465545*^9}, {3.533748707328125*^9, 3.533748714078125*^9}, 
   3.533748750015625*^9, {3.533748781859375*^9, 3.533748801359375*^9}, 
   3.560182180109375*^9, {3.6001827743280425`*^9, 3.6001828244988127`*^9}, {
   3.6001829164177246`*^9, 3.6001829375280495`*^9}, {3.600198220680108*^9, 
   3.6001982475151463`*^9}, {3.600198399575359*^9, 3.6001984211753893`*^9}, {
   3.600198540706688*^9, 3.600198561929514*^9}}],

Cell[BoxData[
 TagBox[
  TagBox[
   StyleBox[
    TemplateBox[{"\"\[LeftAngleBracket]\"","\"||\"",SubscriptBox[
       TagBox[
        StyleBox["\"Q\"", FontSlant -> "Italic"], 
        StyleForm[#, FontSlant -> "Italic"]& ], "2"],"\"||\"",
      "\"\[RightAngleBracket]\""},
     "RowDefault"],
    FontFamily->"Times"],
   StyleForm[#, FontFamily -> "Times"]& ],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.533745750953125*^9, 3.533745762171875*^9}, {
   3.533746291421875*^9, 3.533746334109375*^9}, {3.533746507265625*^9, 
   3.5337465545*^9}, {3.533748707328125*^9, 3.533748714078125*^9}, 
   3.533748750015625*^9, {3.533748781859375*^9, 3.533748801359375*^9}, 
   3.560182180109375*^9, {3.6001827743280425`*^9, 3.6001828244988127`*^9}, {
   3.6001829164177246`*^9, 3.6001829375280495`*^9}, {3.600198220680108*^9, 
   3.6001982475151463`*^9}, {3.600198399575359*^9, 3.6001984211753893`*^9}, {
   3.600198540706688*^9, 3.6001985619320135`*^9}}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"MomentLabel", "[", 
    RowBox[{
     RowBox[{"lambda", ":", "1"}], ",", "Level1_", ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<\[Mu]\>\"", ",", "\"\<(\>\"", ",", 
      RowBox[{"Switch", "[", 
       RowBox[{"Level1", ",", "_List", ",", 
        RowBox[{"LevelLabel", "[", "Level1", "]"}], ",", "_", ",", "Level1"}],
        "]"}], ",", "\"\<)\>\""}], "}"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"MomentLabel", "[", 
    RowBox[{
     RowBox[{"lambda", ":", "2"}], ",", "Level1_", ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Row", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"textit", "[", "\"\<Q\>\"", "]"}], ",", "\"\<(\>\"", ",", 
      RowBox[{"Switch", "[", 
       RowBox[{"Level1", ",", "_List", ",", 
        RowBox[{"LevelLabel", "[", "Level1", "]"}], ",", "_", ",", "Level1"}],
        "]"}], ",", "\"\<)\>\""}], "}"}], "]"}]}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.533746626453125*^9, 3.533746697375*^9}, {
  3.533748877515625*^9, 3.53374889328125*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"MomentLabel", "[", 
   RowBox[{"1", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "1", ",", 
      RowBox[{"+", "1"}]}], "}"}]}], "]"}], "//", 
  "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"MomentLabel", "[", 
   RowBox[{"2", ",", 
    RowBox[{"{", 
     RowBox[{"2", ",", "1", ",", 
      RowBox[{"+", "1"}]}], "}"}]}], "]"}], "//", "DisplayForm"}]}], "Input",
 CellChangeTimes->{{3.53374672409375*^9, 3.533746760515625*^9}, {
  3.533748900125*^9, 3.5337489195625*^9}}],

Cell[BoxData[
 TagBox[
  TemplateBox[{"\"\[Mu]\"","\"(\"",SubsuperscriptBox["2", "1", "+"],"\")\""},
   "Row",
   DisplayFunction->(
    RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3, 
      "\[InvisibleSpace]", #4}]& ),
   InterpretationFunction->(RowBox[{"Row", "[", 
      RowBox[{"{", 
        RowBox[{#, ",", #2, ",", #3, ",", #4}], "}"}], "]"}]& )],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.53374674096875*^9, 3.533746761078125*^9}, {
  3.533748896859375*^9, 3.533748920703125*^9}}],

Cell[BoxData[
 TagBox[
  TemplateBox[{TagBox[
     StyleBox["\"Q\"", FontSlant -> "Italic"], 
     StyleForm[#, FontSlant -> "Italic"]& ],"\"(\"",SubsuperscriptBox[
    "2", "1", "+"],"\")\""},
   "Row",
   DisplayFunction->(
    RowBox[{#, "\[InvisibleSpace]", #2, "\[InvisibleSpace]", #3, 
      "\[InvisibleSpace]", #4}]& ),
   InterpretationFunction->(RowBox[{"Row", "[", 
      RowBox[{"{", 
        RowBox[{#, ",", #2, ",", #3, ",", #4}], "}"}], "]"}]& )],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.53374674096875*^9, 3.533746761078125*^9}, {
  3.533748896859375*^9, 3.533748920734375*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"MomentLabel", "[", 
  RowBox[{"1", ",", 
   RowBox[{"textit", "[", "\"\<J\>\"", "]"}]}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"MomentLabel", "[", 
  RowBox[{"2", ",", 
   RowBox[{"textit", "[", "\"\<J\>\"", "]"}]}], "]"}]}], "Input",
 CellChangeTimes->{{3.600178340239313*^9, 3.600178359255747*^9}}],

Cell[BoxData[
 TemplateBox[{"\"\[Mu]\"","\"(\"",TagBox[
    StyleBox["\"J\"", FontSlant -> "Italic"], 
    StyleForm[#, FontSlant -> "Italic"]& ],"\")\""},
  "RowDefault"]], "Output",
 CellChangeTimes->{{3.6001783506289315`*^9, 3.6001783597081475`*^9}}],

Cell[BoxData[
 TemplateBox[{TagBox[
    StyleBox["\"Q\"", FontSlant -> "Italic"], 
    StyleForm[#, FontSlant -> "Italic"]& ],"\"(\"",TagBox[
    StyleBox["\"J\"", FontSlant -> "Italic"], 
    StyleForm[#, FontSlant -> "Italic"]& ],"\")\""},
  "RowDefault"]], "Output",
 CellChangeTimes->{{3.6001783506289315`*^9, 3.6001783597081475`*^9}}]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Fraction formatting", "Section",
 CellChangeTimes->{{3.52776720034375*^9, 3.527767202453125*^9}}],

Cell[TextData[{
 "Notes on formatting in fraction constructs prior to ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " 6.0:\n\tApplying DisplayForm to inidividual fraction elements is required \
for quantities deep within (like Pi) to be displayed correctly even if full \
fraction is displayed in DisplayForm.\n\tRowBox seems to give most generous \
default spacing, which cannot be adjusted.  Applying DisplayForm to \
individual list elements makes this worse, but apparently only for RowBox.   \
Therefore, GridBox is preferred."
}], "Text",
 CellChangeTimes->{{3.5340241949375*^9, 3.5340242006875*^9}}],

Cell[CellGroupData[{

Cell["Native fraction", "Subsection",
 CellChangeTimes->{{3.52776726775*^9, 3.527767270125*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Fractionize", "[", 
     RowBox[{
      RowBox[{"x_", "?", "NumericQ"}], ",", 
      RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Denominator", "[", "x", "]"}], "==", "1"}], ")"}]}], ":=", 
   RowBox[{"DisplayForm", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"Fractionize", "[", 
     RowBox[{
      RowBox[{"x_", "?", "NumericQ"}], ",", 
      RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Denominator", "[", "x", "]"}], "!=", "1"}], ")"}]}], ":=", 
   RowBox[{"FractionBox", "[", 
    RowBox[{
     RowBox[{"Numerator", "[", "x", "]"}], ",", 
     RowBox[{"Denominator", "[", "x", "]"}], ",", "Opts"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f", ":", 
    RowBox[{"Fractionize", "[", 
     RowBox[{"x_List", ",", 
      RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}]}], ":=", 
   RowBox[{"Thread", "[", 
    RowBox[{
     RowBox[{"Unevaluated", "[", "f", "]"}], ",", "List", ",", "1"}], "]"}]}],
   ";"}]}], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Text fraction", "Subsection",
 CellChangeTimes->{{3.52776726775*^9, 3.527767270125*^9}, {
  3.5807519707278166`*^9, 3.5807519728778195`*^9}}],

Cell[TextData[{
 "In ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " 5-ish, apparently RowSpacings\[Rule]0,RowMinHeight\[Rule]{1,1.1} worked \
well.\nIn ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " 9, a little extra row spacing seems advisable -- ",
 "RowSpacings\[Rule]0,RowMinHeight\[Rule]{1,1.2}",
 ".\nNote Smaller might not genuinely give script size."
}], "Text",
 CellChangeTimes->{{3.5807524618585043`*^9, 3.580752493298548*^9}, {
  3.580752599418697*^9, 3.5807526018587*^9}, {3.580752865169069*^9, 
  3.580752873719081*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"TextFractionBox", "[", 
    RowBox[{"a_", ",", "b_", ",", 
     RowBox[{"Opts", ":", 
      RowBox[{"OptionsPattern", "[", "]"}]}]}], "]"}], ":=", 
   RowBox[{"Style", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"GridBox", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "a", "}"}], ",", 
         RowBox[{"{", "b", "}"}]}], "}"}], ",", "\[IndentingNewLine]", "Opts",
        ",", "\[IndentingNewLine]", 
       RowBox[{"RowLines", "\[Rule]", "True"}], ",", 
       RowBox[{"RowSpacings", "\[Rule]", "0"}], ",", 
       RowBox[{"RowMinHeight", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1.2"}], "}"}]}], ",", 
       RowBox[{"RowAlignments", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Bottom", ",", "Baseline"}], "}"}]}], ",", 
       RowBox[{"ColumnSpacings", "\[Rule]", "0"}]}], "\[IndentingNewLine]", 
      "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Dashing", "[", 
      RowBox[{"{", "}"}], "]"}], ",", 
     RowBox[{"AbsoluteThickness", "[", "0.5", "]"}], ",", "Smaller"}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.46721840684375*^9, 3.4672184733125*^9}, {
   3.580752120288026*^9, 3.580752121088027*^9}, 3.5807523392383327`*^9, {
   3.5807524964285526`*^9, 3.580752528108597*^9}, {3.5807525627686453`*^9, 
   3.5807525843786755`*^9}, {3.580752649648767*^9, 3.580752650448768*^9}, {
   3.580752774528942*^9, 3.5807527746789417`*^9}, {3.5807528218090076`*^9, 
   3.580752828829018*^9}, {3.580752859599061*^9, 3.580752862519065*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Style", "[", 
   RowBox[{
    RowBox[{"TextFractionBox", "[", 
     RowBox[{
      RowBox[{"Row", "[", 
       RowBox[{"{", 
        RowBox[{"\"\<3\>\"", ",", "\"\<\!\(\*
StyleBox[\"n\",
FontSlant->\"Italic\"]\)\>\""}], "}"}], "]"}], ",", "\"\<2\>\""}], "]"}], ",", 
    RowBox[{"FontFamily", "->", "Times"}]}], "]"}], "//", 
  "DisplayForm"}]], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.46721840684375*^9, 3.4672184733125*^9}, {
  3.580752120288026*^9, 3.580752121088027*^9}, {3.5807523392383327`*^9, 
  3.5807523442283397`*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox[
   StyleBox[GridBox[{
      {
       TemplateBox[{
        "\"3\"","\"\\!\\(\\*\\nStyleBox[\\\"n\\\",\\nFontSlant->\\\"Italic\\\"\
]\\)\""},
        "RowDefault"]},
      {"2"}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
       "Rows" -> {Bottom, {Baseline}}, "RowsIndexed" -> {}},
     GridBoxDividers->{
      "Columns" -> {{False}}, "ColumnsIndexed" -> {}, 
       "Rows" -> {False, {True}, False}, "RowsIndexed" -> {}},
     GridBoxItemSize->{
      "Columns" -> {{All}}, "ColumnsIndexed" -> {}, "Rows" -> {1, {1.2}}, 
       "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    StripOnInput->False,
    Dashing->{},
    Thickness->Absolute[0.5],
    FontSize->Smaller],
   StripOnInput->False,
   FontFamily->Times],
  DisplayForm]], "Output",
 CellChangeTimes->{
  3.5807522600482216`*^9, 3.58075234475834*^9, {3.5807524983385553`*^9, 
   3.5807525863586783`*^9}, 3.580752652598771*^9, 3.580752775768944*^9, 
   3.58075283029902*^9, 3.5828226170818653`*^9, 3.58282271640724*^9, 
   3.5828232964786587`*^9, 3.5850736671086655`*^9, 3.600182776998083*^9, 
   3.6001828817821927`*^9, {3.600182913907686*^9, 3.6001829361855288`*^9}, {
   3.6001982186951056`*^9, 3.6001982460951443`*^9}, {3.6001983966153545`*^9, 
   3.600198419535387*^9}, 3.600198535819113*^9, 3.6174574071642857`*^9, 
   3.6251842554893427`*^9, 3.6251844389154644`*^9, 3.6251844717223225`*^9, 
   3.6251847974976945`*^9, 3.6251849327811317`*^9, {3.625185229275253*^9, 
   3.6251852469032836`*^9}, 3.625185458253455*^9, {3.6251855155679555`*^9, 
   3.6251855252555723`*^9}, {3.625185562570838*^9, 3.625185592819291*^9}, {
   3.625185623894546*^9, 3.625185651350594*^9}, 3.625185730739134*^9, 
   3.6251858012512574`*^9, 3.625186396485903*^9, {3.6251865407549562`*^9, 
   3.625186549600172*^9}, 3.6251882585071735`*^9, {3.6251883761469803`*^9, 
   3.625188393634611*^9}, {3.625188572067724*^9, 3.6251885905381565`*^9}, {
   3.62518874638243*^9, 3.625188764618862*^9}, 3.6251892458495073`*^9, 
   3.625189834692348*^9, {3.6252471667658744`*^9, 3.625247280864475*^9}, 
   3.629413568474371*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TextFractionize", "[", 
     RowBox[{
      RowBox[{"x_", "?", "NumericQ"}], ",", 
      RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Denominator", "[", "x", "]"}], "==", "1"}], ")"}]}], ":=", 
   RowBox[{"DisplayForm", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"TextFractionize", "[", 
     RowBox[{
      RowBox[{"x_", "?", "NumericQ"}], ",", 
      RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Denominator", "[", "x", "]"}], "!=", "1"}], ")"}]}], ":=", 
   "\[IndentingNewLine]", 
   RowBox[{"TextFractionBox", "[", 
    RowBox[{
     RowBox[{"Numerator", "[", "x", "]"}], ",", 
     RowBox[{"Denominator", "[", "x", "]"}], ",", "Opts"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f", ":", 
    RowBox[{"TextFractionize", "[", 
     RowBox[{"x_List", ",", 
      RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}]}], ":=", 
   RowBox[{"Thread", "[", 
    RowBox[{
     RowBox[{"Unevaluated", "[", "f", "]"}], ",", "List", ",", "1"}], "]"}]}],
   ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.580751979757829*^9, 3.5807519920678463`*^9}, {
  3.5807520707979565`*^9, 3.58075207294796*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Solidus fraction", "Subsection",
 CellChangeTimes->{{3.52776726340625*^9, 3.527767265921875*^9}}],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
    RowBox[{"SolidusFractionBox", "[", 
     RowBox[{"x_", ",", "y_", ",", 
      RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], ":=", 
    RowBox[{"GridBox", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"DisplayForm", "[", "x", "]"}], ",", "\"\</\>\"", ",", 
         RowBox[{"DisplayForm", "[", "y", "]"}]}], "}"}], "}"}], ",", 
      RowBox[{"ColumnSpacings", "\[Rule]", 
       RowBox[{"-", "0.1"}]}], ",", 
      RowBox[{"BaselinePosition", "\[Rule]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "3"}], "}"}], ",", "Baseline"}], "}"}]}]}], 
     "]"}]}], ";"}], "*)"}]], "Input",
 CellChangeTimes->{{3.527769370265625*^9, 3.527769391328125*^9}, {
  3.534024393171875*^9, 3.5340243941875*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "SolidusFractionBox", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{"Spacings", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"SolidusFractionBox", "[", 
    RowBox[{"x_", ",", "y_", ",", 
     RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"FullOpts", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", 
         RowBox[{"Opts", ",", 
          RowBox[{"Options", "[", "SolidusFractionBox", "]"}]}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"Grid", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"x", ",", "\"\</\>\"", ",", "y"}], "}"}], "}"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"Spacings", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{"Flatten", "[", 
          RowBox[{"{", 
           RowBox[{"0", ",", 
            RowBox[{"(", 
             RowBox[{"Spacings", "/.", "FullOpts"}], ")"}], ",", "0"}], "}"}],
           "]"}], "}"}]}], ",", "\[IndentingNewLine]", 
       RowBox[{"BaselinePosition", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"1", ",", "3"}], "}"}], ",", "Baseline"}], "}"}]}]}], " ", 
      
      RowBox[{"(*", " ", 
       RowBox[{"use", " ", "baseline", " ", "of", " ", "denominator"}], " ", 
       "*)"}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}],
   ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.527769370265625*^9, 3.527769391328125*^9}, {
   3.534024336703125*^9, 3.53402437228125*^9}, {3.6251847287795734`*^9, 
   3.625184730807577*^9}, {3.625184835998562*^9, 3.6251848480417833`*^9}, {
   3.625185053572144*^9, 3.625185077471386*^9}, {3.6251851750183573`*^9, 
   3.62518524454768*^9}, {3.6251854402510233`*^9, 3.6251854550398493`*^9}, {
   3.625185502963134*^9, 3.6251855478756123`*^9}, 3.625185650180592*^9}],

Cell["Random old scratchwork...", "Text",
 CellChangeTimes->{{3.6251847383579903`*^9, 3.6251847430067987`*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"GridBox", "[", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"\"\<1\>\"", ",", "\"\</\>\"", ",", "\"\<2\>\""}], "}"}], "}"}], 
   "]"}], "//", "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Grid", "[", 
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"\"\<1\>\"", ",", "\"\</\>\"", ",", "\"\<2\>\""}], "}"}], "}"}], 
   "]"}], "//", "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Grid", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"\"\<1\>\"", ",", "\"\</\>\"", ",", "\"\<2\>\""}], "}"}], "}"}],
     ",", 
    RowBox[{"Spacings", "\[Rule]", "0"}]}], "]"}], "//", 
  "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Grid", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"\"\<1\>\"", ",", "\"\</\>\"", ",", "Pi"}], "}"}], "}"}], ",", 
    RowBox[{"Spacings", "\[Rule]", "0"}]}], "]"}], "//", 
  "DisplayForm"}]}], "Input",
 CellChangeTimes->{{3.53402425471875*^9, 3.534024286859375*^9}, {
  3.534024344875*^9, 3.534024351515625*^9}, {3.6251852632833123`*^9, 
  3.62518529061456*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "/", "2"}
   }],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.5340242644375*^9, 3.534024287171875*^9}, 
   3.53402435184375*^9, {3.62518526777612*^9, 3.6251852916909623`*^9}}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {"\<\"1\"\>", "\<\"/\"\>", "\<\"2\"\>"}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
   "Grid"],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.5340242644375*^9, 3.534024287171875*^9}, 
   3.53402435184375*^9, {3.62518526777612*^9, 3.6251852916909623`*^9}}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {"\<\"1\"\>", "\<\"/\"\>", "\<\"2\"\>"}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
    GridBoxSpacings->{"Columns" -> {{0}}}],
   "Grid"],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.5340242644375*^9, 3.534024287171875*^9}, 
   3.53402435184375*^9, {3.62518526777612*^9, 3.6251852916909623`*^9}}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {"\<\"1\"\>", "\<\"/\"\>", "\[Pi]"}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
    GridBoxSpacings->{"Columns" -> {{0}}}],
   "Grid"],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.5340242644375*^9, 3.534024287171875*^9}, 
   3.53402435184375*^9, {3.62518526777612*^9, 3.6251852916909623`*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"Grid", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"\"\<1\>\"", ",", "\"\</\>\"", ",", "\"\<2\>\""}], "}"}], "}"}],
     ",", 
    RowBox[{"Spacings", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"1", ",", "999"}], "}"}]}]}], "]"}], "//", 
  "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Grid", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"\"\<1\>\"", ",", "\"\</\>\"", ",", "\"\<2\>\""}], "}"}], "}"}],
     ",", 
    RowBox[{"Spacings", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1", ",", "3", ",", "0"}], "}"}], ",", "999"}], 
      "}"}]}]}], "]"}], "//", "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Grid", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"\"\<1\>\"", ",", "\"\</\>\"", ",", "\"\<2\>\""}], "}"}], "}"}],
     ",", 
    RowBox[{"Spacings", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "3", ",", "0"}], "}"}], "}"}]}]}], "]"}], "//",
   "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Grid", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"\"\<1\>\"", ",", "\"\</\>\"", ",", "\"\<2\>\""}], "}"}], "}"}],
     ",", 
    RowBox[{"Spacings", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "1", "}"}], ",", 
       RowBox[{"{", "9", "}"}]}], "}"}]}]}], "]"}], "//", 
  "DisplayForm"}], "\[IndentingNewLine]"}], "Input",
 CellChangeTimes->{{3.6251852964801707`*^9, 3.625185329006228*^9}, {
  3.6251853648082905`*^9, 3.6251853712355022`*^9}, {3.6251854154625797`*^9, 
  3.6251854179585843`*^9}}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {"\<\"1\"\>", "\<\"/\"\>", "\<\"2\"\>"}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
    GridBoxSpacings->{"Columns" -> {{1}}, "Rows" -> {{999}}}],
   "Grid"],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.625185302969782*^9, 3.625185329630229*^9}, 
   3.625185371797103*^9, 3.625185418410985*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {"\<\"1\"\>", "\<\"/\"\>", "\<\"2\"\>"}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
    GridBoxSpacings->{"Columns" -> {0, 1, 3, 0}, "Rows" -> {{999}}}],
   "Grid"],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.625185302969782*^9, 3.625185329630229*^9}, 
   3.625185371797103*^9, 3.625185418426585*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {"\<\"1\"\>", "\<\"/\"\>", "\<\"2\"\>"}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
    GridBoxSpacings->{"Columns" -> {0, 1, 3, 0}}],
   "Grid"],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.625185302969782*^9, 3.625185329630229*^9}, 
   3.625185371797103*^9, 3.625185418426585*^9}],

Cell[BoxData[
 TagBox[
  TagBox[GridBox[{
     {"\<\"1\"\>", "\<\"/\"\>", "\<\"2\"\>"}
    },
    AutoDelete->False,
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
    GridBoxSpacings->{"Columns" -> {1}, "Rows" -> {9}}],
   "Grid"],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.625185302969782*^9, 3.625185329630229*^9}, 
   3.625185371797103*^9, 3.625185418426585*^9}]
}, Open  ]],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SolidusFractionize", "[", 
     RowBox[{
      RowBox[{"x_", "?", "NumericQ"}], ",", 
      RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Denominator", "[", "x", "]"}], "==", "1"}], ")"}]}], ":=", 
   RowBox[{"DisplayForm", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"SolidusFractionize", "[", 
     RowBox[{
      RowBox[{"x_", "?", "NumericQ"}], ",", 
      RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Denominator", "[", "x", "]"}], "!=", "1"}], ")"}]}], ":=", 
   RowBox[{"SolidusFractionBox", "[", 
    RowBox[{
     RowBox[{"Numerator", "[", "x", "]"}], ",", 
     RowBox[{"Denominator", "[", "x", "]"}], ",", "Opts"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f", ":", 
    RowBox[{"SolidusFractionize", "[", 
     RowBox[{"x_List", ",", 
      RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}]}], ":=", 
   RowBox[{"Thread", "[", 
    RowBox[{
     RowBox[{"Unevaluated", "[", "f", "]"}], ",", "List", ",", "1"}], "]"}]}],
   ";"}]}], "Input",
 InitializationCell->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"SolidusFractionize", "[", 
  RowBox[{"1", "/", "2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Style", "[", 
  RowBox[{"%", ",", 
   RowBox[{"FontFamily", "->", "\"\<Times\>\""}], ",", "Large"}], 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"SolidusFractionize", "[", 
  RowBox[{
   RowBox[{"1", "/", "2"}], ",", 
   RowBox[{"ColumnSpacings", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "0.1"}], ",", 
      RowBox[{"-", "0.1"}]}], "}"}]}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"Style", "[", 
  RowBox[{"%", ",", 
   RowBox[{"FontFamily", "->", "\"\<Times\>\""}], ",", "Large"}], 
  "]"}]}], "Input",
 CellChangeTimes->{{3.6251847492624097`*^9, 3.6251847740196533`*^9}, {
  3.625185470015876*^9, 3.6251854860371037`*^9}, {3.625186338282201*^9, 
  3.6251863447874117`*^9}}],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "\<\"/\"\>", "2"}
   },
   AutoDelete->False,
   BaselinePosition->{{1, 3}, Baseline},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxSpacings->{"Columns" -> {0, 0, 0, 0}}],
  "Grid"]], "Output",
 CellChangeTimes->{{3.6251847638016353`*^9, 3.6251847998844986`*^9}, {
   3.625185231786857*^9, 3.625185249461688*^9}, {3.625185462902263*^9, 
   3.625185487144706*^9}, {3.6251856169369335`*^9, 3.6251856535345984`*^9}, 
   3.6251863453022127`*^9}],

Cell[BoxData[
 StyleBox[
  TagBox[GridBox[{
     {"1", "\<\"/\"\>", "2"}
    },
    AutoDelete->False,
    BaselinePosition->{{1, 3}, Baseline},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
    GridBoxSpacings->{"Columns" -> {0, 0, 0, 0}}],
   "Grid"],
  StripOnInput->False,
  FontFamily->"Times",
  FontSize->Large]], "Output",
 CellChangeTimes->{{3.6251847638016353`*^9, 3.6251847998844986`*^9}, {
   3.625185231786857*^9, 3.625185249461688*^9}, {3.625185462902263*^9, 
   3.625185487144706*^9}, {3.6251856169369335`*^9, 3.6251856535345984`*^9}, 
   3.6251863453022127`*^9}],

Cell[BoxData[
 TagBox[GridBox[{
    {"1", "\<\"/\"\>", "2"}
   },
   AutoDelete->False,
   BaselinePosition->{{1, 3}, Baseline},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxSpacings->{"Columns" -> {0, 0, 0, 0}}],
  "Grid"]], "Output",
 CellChangeTimes->{{3.6251847638016353`*^9, 3.6251847998844986`*^9}, {
   3.625185231786857*^9, 3.625185249461688*^9}, {3.625185462902263*^9, 
   3.625185487144706*^9}, {3.6251856169369335`*^9, 3.6251856535345984`*^9}, 
   3.6251863453022127`*^9}],

Cell[BoxData[
 StyleBox[
  TagBox[GridBox[{
     {"1", "\<\"/\"\>", "2"}
    },
    AutoDelete->False,
    BaselinePosition->{{1, 3}, Baseline},
    GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
    GridBoxSpacings->{"Columns" -> {0, 0, 0, 0}}],
   "Grid"],
  StripOnInput->False,
  FontFamily->"Times",
  FontSize->Large]], "Output",
 CellChangeTimes->{{3.6251847638016353`*^9, 3.6251847998844986`*^9}, {
   3.625185231786857*^9, 3.625185249461688*^9}, {3.625185462902263*^9, 
   3.625185487144706*^9}, {3.6251856169369335`*^9, 3.6251856535345984`*^9}, 
   3.6251863453022127`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Diagonal fraction", "Subsection",
 CellChangeTimes->{{3.527767308078125*^9, 3.527767310953125*^9}}],

Cell["\<\
CAVEAT: Spacing in EPS/PDF export and/or printing will differ from spacing \
on-screen.\
\>", "Text",
 CellChangeTimes->{{3.52776930153125*^9, 3.5277693268125*^9}}],

Cell["Imposing slant on slash seems to have no effect.", "Text",
 CellChangeTimes->{{3.527767234609375*^9, 3.527767236296875*^9}, 
   3.5277673998125*^9}],

Cell[TextData[{
 "ColumnSpacings->-0.1 worked well for Mathematica 5 (with Times), but \
ColumnSpacings->-0.3 (with Times) needed for Mathematica 6 on screen, and \
tighter for export.\n",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " 10 seems to work well with ColumnSpacings\[Rule]{-0.1,-0.3} for special \
case of EPS export of \[OpenCurlyDoubleQuote]1/2\[CloseCurlyDoubleQuote] in \
Times.\nSlash is too small (same height as digits) in Times EPS/PDF export if \
do as superscript, so do full height.\nAlignment of baseline with bottom of \
denominator -- pre-6 was GridBaseline\[Rule]{Bottom,{1,3}}, post-6 is \
BaselinePosition->{{1,3},Bottom}\n"
}], "Text",
 CellChangeTimes->{{3.427840928265625*^9, 3.4278409818125*^9}, 
   3.427918133203125*^9, {3.527767414078125*^9, 3.52776742853125*^9}, {
   3.527767510515625*^9, 3.527767601578125*^9}, 3.5277678841875*^9, {
   3.527769332328125*^9, 3.52776935246875*^9}, {3.527769691515625*^9, 
   3.527769712984375*^9}, {3.6251848635014105`*^9, 3.625184874156229*^9}, {
   3.625184908429489*^9, 3.625184930175927*^9}, {3.625189841821561*^9, 
   3.625189844910366*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"Options", "[", "DiagonalFractionBox", "]"}], "=", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Spacings", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", "0.1"}], ",", 
        RowBox[{"-", "0.3"}]}], "}"}]}], ",", 
     RowBox[{"Baseline", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0.5", ",", "0.0", ",", "0.0"}], "}"}]}], ",", 
     RowBox[{"KernForSuperscript", "\[Rule]", 
      RowBox[{"-", "0.15"}]}]}], "}"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"DiagonalFractionBox", "[", 
    RowBox[{"x_", ",", "y_", ",", 
     RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"FullOpts", "=", 
       RowBox[{"Flatten", "[", 
        RowBox[{"{", 
         RowBox[{"Opts", ",", 
          RowBox[{"Options", "[", "DiagonalFractionBox", "]"}]}], "}"}], 
        "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
     RowBox[{"TagBox", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"StyleBox", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Grid", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"{", "\[IndentingNewLine]", 
             RowBox[{
              RowBox[{"AdjustmentBox", "[", 
               RowBox[{
                RowBox[{"SubscriptBox", "[", 
                 RowBox[{"\"\<\>\"", ",", 
                  RowBox[{"DisplayForm", "[", "x", "]"}]}], "]"}], ",", 
                RowBox[{"BoxBaselineShift", "\[Rule]", 
                 RowBox[{"-", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"Baseline", "/.", "FullOpts"}], ")"}], "[", 
                    RowBox[{"[", "1", "]"}], "]"}], ")"}]}]}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"(*", 
               RowBox[{
                RowBox[{"AdjustmentBox", "[", 
                 RowBox[{
                  RowBox[{"SubscriptBox", "[", 
                   RowBox[{"\"\<\>\"", ",", 
                    RowBox[{"StyleForm", "[", 
                    RowBox[{"\"\</\>\"", ",", 
                    RowBox[{"FontSlant", "->", "\"\<Oblique\>\""}], ",", 
                    "Larger"}], "]"}]}], "]"}], ",", 
                  RowBox[{"BoxBaselineShift", "\[Rule]", 
                   RowBox[{"-", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{"Baseline", "/.", "FullOpts"}], ")"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ")"}]}]}]}], "]"}], ","}],
                "*)"}], "\[IndentingNewLine]", 
              RowBox[{"AdjustmentBox", "[", 
               RowBox[{
                RowBox[{"StyleForm", "[", 
                 RowBox[{"\"\</\>\"", ",", 
                  RowBox[{"FontSlant", "->", "\"\<Oblique\>\""}]}], "]"}], 
                ",", 
                RowBox[{"BoxBaselineShift", "\[Rule]", 
                 RowBox[{"-", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"Baseline", "/.", "FullOpts"}], ")"}], "[", 
                    RowBox[{"[", "2", "]"}], "]"}], ")"}]}]}]}], "]"}], ",", 
              "\[IndentingNewLine]", 
              RowBox[{"AdjustmentBox", "[", 
               RowBox[{
                RowBox[{"SubscriptBox", "[", 
                 RowBox[{"\"\<\>\"", ",", 
                  RowBox[{"DisplayForm", "[", "y", "]"}]}], "]"}], ",", 
                RowBox[{"BoxBaselineShift", "\[Rule]", 
                 RowBox[{"-", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{"Baseline", "/.", "FullOpts"}], ")"}], "[", 
                    RowBox[{"[", "3", "]"}], "]"}], ")"}]}]}]}], "]"}]}], 
             "\[IndentingNewLine]", "}"}], "}"}], ",", "\[IndentingNewLine]", 
           
           RowBox[{"Spacings", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{"Flatten", "[", 
              RowBox[{"{", 
               RowBox[{"0", ",", 
                RowBox[{"(", 
                 RowBox[{"Spacings", "/.", "FullOpts"}], ")"}], ",", "0"}], 
               "}"}], "]"}], "}"}]}], ",", "\[IndentingNewLine]", 
           RowBox[{"BaselinePosition", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"1", ",", "3"}], "}"}], ",", "Bottom"}], "}"}]}]}], 
          "\[IndentingNewLine]", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"ScriptBaselineShifts", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}]}]}], "\[IndentingNewLine]", "]"}], 
       ",", "\[IndentingNewLine]", 
       RowBox[{"DiagonalFractionBox", "[", 
        RowBox[{"(", 
         RowBox[{"KernForSuperscript", "/.", "FullOpts"}], ")"}], "]"}]}], 
      "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", "]"}]}], 
  ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.427840928265625*^9, 3.4278409818125*^9}, 
   3.427918133203125*^9, 3.527767414078125*^9, {3.527767585546875*^9, 
   3.5277675981875*^9}, 3.52776788584375*^9, {3.6251841842908173`*^9, 
   3.625184192262431*^9}, {3.625184252213337*^9, 3.6251842531493382`*^9}, 
   3.6251843147080464`*^9, {3.6251843995877953`*^9, 3.6251844368094606`*^9}, {
   3.6251844691327176`*^9, 3.6251844697255187`*^9}, {3.6251848847174473`*^9, 
   3.6251848985078716`*^9}, {3.6251850913710103`*^9, 3.625185100809027*^9}, {
   3.625185148763511*^9, 3.6251851522735176`*^9}, {3.6251855406371994`*^9, 
   3.625185590869288*^9}, 3.625185729475531*^9, 3.6251857984276524`*^9, {
   3.6251863939742985`*^9, 3.6251863941302986`*^9}, {3.625186538695753*^9, 
   3.625186547915369*^9}, {3.6251898320715437`*^9, 3.625189832367944*^9}}],

Cell["DiagonalFractionBox kerning setup", "Text"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Unprotect", "[", "TagBox", "]"}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TagBox", "/:", 
   RowBox[{"SuperscriptBox", "[", 
    RowBox[{
     RowBox[{"x", ":", 
      RowBox[{"TagBox", "[", 
       RowBox[{"_", ",", 
        RowBox[{"DiagonalFractionBox", "[", "Adjustment_", "]"}]}], "]"}]}], 
     ",", "n_"}], "]"}], ":=", 
   RowBox[{"SuperscriptBox", "[", 
    RowBox[{
     RowBox[{"AdjustmentBox", "[", 
      RowBox[{"x", ",", 
       RowBox[{"BoxMargins", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "Adjustment"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}]}], "]"}], ",", "n"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"TagBox", "/:", 
   RowBox[{"Superscript", "[", 
    RowBox[{
     RowBox[{"x", ":", 
      RowBox[{"TagBox", "[", 
       RowBox[{"_", ",", 
        RowBox[{"DiagonalFractionBox", "[", "Adjustment_", "]"}]}], "]"}]}], 
     ",", "n_"}], "]"}], ":=", 
   RowBox[{"Superscript", "[", 
    RowBox[{
     RowBox[{"AdjustmentBox", "[", 
      RowBox[{"x", ",", 
       RowBox[{"BoxMargins", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"0", ",", "Adjustment"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "0"}], "}"}]}], "}"}]}]}], "]"}], ",", "n"}], 
    "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Protect", "[", "TagBox", "]"}], ";"}]}], "Input",
 InitializationCell->True,
 CellChangeTimes->{{3.527768030078125*^9, 3.52776803634375*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DiagonalFractionize", "[", 
     RowBox[{
      RowBox[{"x_", "?", "NumericQ"}], ",", 
      RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Denominator", "[", "x", "]"}], "==", "1"}], ")"}]}], ":=", 
   RowBox[{"DisplayForm", "[", "x", "]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"DiagonalFractionize", "[", 
     RowBox[{
      RowBox[{"x_", "?", "NumericQ"}], ",", 
      RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}], "/;", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Denominator", "[", "x", "]"}], "!=", "1"}], ")"}]}], ":=", 
   RowBox[{"DiagonalFractionBox", "[", 
    RowBox[{
     RowBox[{"Numerator", "[", "x", "]"}], ",", 
     RowBox[{"Denominator", "[", "x", "]"}], ",", "Opts"}], "]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"f", ":", 
    RowBox[{"DiagonalFractionize", "[", 
     RowBox[{"x_List", ",", 
      RowBox[{"Opts___", "?", "OptionQ"}]}], "]"}]}], ":=", 
   RowBox[{"Thread", "[", 
    RowBox[{
     RowBox[{"Unevaluated", "[", "f", "]"}], ",", "List", ",", "1"}], "]"}]}],
   ";"}]}], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 "... formatting tests under ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " ~5"
}], "Subsection",
 CellChangeTimes->{{3.52776708871875*^9, 3.527767098921875*^9}, {
  3.527767146890625*^9, 3.527767148078125*^9}}],

Cell[TextData[{
 "CAVEAT: The output for some or all of these may have been obtained under a \
later version of ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 ", once \[OpenCurlyDoubleQuote]broken\[CloseCurlyDoubleQuote]."
}], "Text",
 CellChangeTimes->{{3.527768829890625*^9, 3.52776885009375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"Options", "[", "GridBox", "]"}], "\[IndentingNewLine]", 
 RowBox[{"Options", "[", "RowBox", "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"GridBaseline", "\[Rule]", "Axis"}], ",", 
   RowBox[{"RowSpacings", "\[Rule]", "1.`"}], ",", 
   RowBox[{"ColumnSpacings", "\[Rule]", "0.800000011920929`"}], ",", 
   RowBox[{"ColumnWidths", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"RowAlignments", "\[Rule]", "Baseline"}], ",", 
   RowBox[{"ColumnAlignments", "\[Rule]", 
    RowBox[{"{", "Center", "}"}]}], ",", 
   RowBox[{"GridFrame", "\[Rule]", "False"}], ",", 
   RowBox[{"GridFrameMargins", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0.4000000059604645`", ",", "0.4000000059604645`"}], "}"}], 
      ",", 
      RowBox[{"{", 
       RowBox[{"0.5`", ",", "0.5`"}], "}"}]}], "}"}]}], ",", 
   RowBox[{"RowLines", "\[Rule]", "False"}], ",", 
   RowBox[{"ColumnLines", "\[Rule]", "False"}], ",", 
   RowBox[{"RowMinHeight", "\[Rule]", "1.`"}], ",", 
   RowBox[{"RowsEqual", "\[Rule]", "False"}], ",", 
   RowBox[{"ColumnsEqual", "\[Rule]", "False"}], ",", 
   RowBox[{"AutoDelete", "\[Rule]", "True"}], ",", 
   RowBox[{"AllowScriptLevelChange", "\[Rule]", "True"}], ",", 
   RowBox[{"MultilineFunction", "\[Rule]", "None"}], ",", 
   RowBox[{
   "GridDefaultElement", "\[RuleDelayed]", "\<\"\[Placeholder]\"\>"}]}], 
  "}"}]], "Output"],

Cell[BoxData[
 RowBox[{"{", "}"}]], "Output"]
}, Open  ]],

Cell["Tests of fractionization", "Text"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"RowBox", "[", 
   RowBox[{"{", 
    RowBox[{"\"\<xxxx,\>\"", ",", 
     RowBox[{"SolidusFractionBox", "[", 
      RowBox[{"1", "/", "2"}], "]"}], ",", "\"\<,\>\"", ",", 
     RowBox[{"SolidusFractionBox", "[", "Pi", "]"}], ",", "\"\<xxx\>\""}], 
    "}"}], "]"}], "//", "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     RowBox[{"SolidusFractionBox", "[", 
      RowBox[{
       RowBox[{"Rationalize", "[", 
        RowBox[{"#", "/", "Pi"}], "]"}], "*", "Pi"}], "]"}], "&"}], ")"}], "/@", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Pi", "/", "2"}], ",", 
     RowBox[{"3", "*", "Pi"}]}], "}"}]}], "//", 
  "DisplayForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"SolidusFractionize", "[", 
   RowBox[{"1", "/", "2"}], "]"}], "//", "DisplayForm"}]}], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{
   RowBox[{"xxxx", ","}], GridBox[{
     {
      TagBox["1",
       DisplayForm], "/", 
      TagBox["2",
       DisplayForm]}
    },
    BaselinePosition->{Baseline, {1, 3}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[-0.06999999999999999]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], ",", 
   TagBox["\[Pi]",
    DisplayForm], "xxx"}],
  DisplayForm]], "Output"],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{GridBox[{
      {
       TagBox["\[Pi]",
        DisplayForm], "/", 
       TagBox["2",
        DisplayForm]}
     },
     BaselinePosition->{Baseline, {1, 3}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[-0.06999999999999999]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], ",", 
    TagBox[
     RowBox[{"3", " ", "\[Pi]"}],
     DisplayForm]}], "}"}],
  DisplayForm]], "Output"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     TagBox["1",
      DisplayForm], "/", 
     TagBox["2",
      DisplayForm]}
   },
   BaselinePosition->{Baseline, {1, 3}},
   GridBoxSpacings->{"Columns" -> {
       Offset[0.27999999999999997`], {
        Offset[-0.06999999999999999]}, 
       Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
       Offset[0.2], {
        Offset[0.4]}, 
       Offset[0.2]}, "RowsIndexed" -> {}}],
  DisplayForm]], "Output"]
}, Open  ]],

Cell["\tOld RowBox formatting, for comparison", "Text"],

Cell[BoxData[
 TagBox[
  RowBox[{"{", 
   RowBox[{
    RowBox[{
     TagBox["\[Pi]",
      DisplayForm], 
     TagBox["\<\"/\"\>",
      DisplayForm], 
     TagBox["2",
      DisplayForm]}], ",", 
    TagBox[
     RowBox[{"3", " ", "\[Pi]"}],
     DisplayForm]}], "}"}],
  DisplayForm]], "Output",
 GeneratedCell->False,
 CellAutoOverwrite->False],

Cell["\tDiagonal fraction option optimization", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"DiagonalFractionBox", ",", 
    RowBox[{"ColumnSpacings", "\[Rule]", 
     RowBox[{"-", "0.1"}]}], ",", 
    RowBox[{"Baseline", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"0.5", ",", "0.3", ",", "0.0"}], "}"}]}]}], "]"}], 
  ";"}]], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"textfamily", "[", 
   RowBox[{"\"\<Times New Roman\>\"", ",", 
    RowBox[{"textsize", "[", 
     RowBox[{"20", ",", "\[IndentingNewLine]", 
      RowBox[{"TightRowBox", "[", 
       RowBox[{"{", 
        RowBox[{"\"\<xxxx11,\>\"", ",", 
         RowBox[{"DiagonalFractionize", "[", 
          RowBox[{"1", "/", "2"}], "]"}], ",", "\"\<,\>\"", ",", 
         RowBox[{"textfamily", "[", 
          RowBox[{"Times", ",", 
           RowBox[{"DiagonalFractionize", "[", 
            RowBox[{"1", "/", "2"}], "]"}]}], "]"}], ",", "\"\<,\>\"", ",", 
         RowBox[{"DiagonalFractionize", "[", "Pi", "]"}], ",", "\"\<,\>\"", 
         ",", 
         RowBox[{"DiagonalFractionize", "[", 
          RowBox[{"Pi", "/", "2"}], "]"}], ",", "\"\<,\>\"", ",", 
         RowBox[{"DiagonalFractionize", "[", 
          RowBox[{"3", "*", 
           RowBox[{"Pi", "/", "2"}]}], "]"}], ",", "\"\<xxx\>\""}], "}"}], 
       "]"}]}], "\[IndentingNewLine]", "]"}]}], "]"}], "//", 
  "DisplayForm"}]], "Input"],

Cell["-0.1 {0.5,0.3,0.0}", "Text"],

Cell[BoxData[
 TagBox[
  TagBox[
   StyleBox[
    TagBox[
     StyleBox[GridBox[{
        {
         RowBox[{"xxxx11", ","}], 
         StyleBox[GridBox[{
            {
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["1",
                DisplayForm]],
              BoxBaselineShift->-0.5], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                StyleBox["\<\"/\"\>",
                 FontSlant->"Oblique"],
                StyleForm[#, FontSlant -> "Oblique"]& ]],
              BoxBaselineShift->-0.3], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["2",
                DisplayForm]],
              BoxBaselineShift->0]}
           },
           BaselinePosition->{Bottom, {1, 3}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[-0.06999999999999999]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ScriptBaselineShifts->{0, 0}], ",", 
         TagBox[
          StyleBox[GridBox[{
             {
              AdjustmentBox[
               SubscriptBox["", 
                TagBox["1",
                 DisplayForm]],
               BoxBaselineShift->-0.5], 
              AdjustmentBox[
               SubscriptBox["", 
                TagBox[
                 StyleBox["\<\"/\"\>",
                  FontSlant->"Oblique"],
                 StyleForm[#, FontSlant -> "Oblique"]& ]],
               BoxBaselineShift->-0.3], 
              AdjustmentBox[
               SubscriptBox["", 
                TagBox["2",
                 DisplayForm]],
               BoxBaselineShift->0]}
            },
            BaselinePosition->{Bottom, {1, 3}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[-0.06999999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ScriptBaselineShifts->{0, 0},
           FontFamily->"Times"],
          StyleForm[#, FontFamily -> Times]& ], ",", 
         TagBox["\[Pi]",
          DisplayForm], ",", 
         StyleBox[GridBox[{
            {
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["\[Pi]",
                DisplayForm]],
              BoxBaselineShift->-0.5], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                StyleBox["\<\"/\"\>",
                 FontSlant->"Oblique"],
                StyleForm[#, FontSlant -> "Oblique"]& ]],
              BoxBaselineShift->-0.3], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["2",
                DisplayForm]],
              BoxBaselineShift->0]}
           },
           BaselinePosition->{Bottom, {1, 3}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[-0.06999999999999999]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ScriptBaselineShifts->{0, 0}], ",", 
         StyleBox[GridBox[{
            {
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                RowBox[{"3", " ", "\[Pi]"}],
                DisplayForm]],
              BoxBaselineShift->-0.5], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                StyleBox["\<\"/\"\>",
                 FontSlant->"Oblique"],
                StyleForm[#, FontSlant -> "Oblique"]& ]],
              BoxBaselineShift->-0.3], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["2",
                DisplayForm]],
              BoxBaselineShift->0]}
           },
           BaselinePosition->{Bottom, {1, 3}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[-0.06999999999999999]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ScriptBaselineShifts->{0, 0}], "xxx"}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      FontSize->20],
     StyleForm[#, FontSize -> 20]& ],
    FontFamily->"Times New Roman"],
   StyleForm[#, FontFamily -> "Times New Roman"]& ],
  DisplayForm]], "Output"],

Cell["-0.1 {0.6,0.3,0.0}", "Text"],

Cell[BoxData[
 TagBox[
  TagBox[
   StyleBox[
    TagBox[
     StyleBox[GridBox[{
        {
         RowBox[{"xxxx11", ","}], 
         StyleBox[GridBox[{
            {
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["1",
                DisplayForm]],
              BoxBaselineShift->-0.6], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                StyleBox["\<\"/\"\>",
                 FontSlant->"Oblique"],
                StyleForm[#, FontSlant -> "Oblique"]& ]],
              BoxBaselineShift->-0.3], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["2",
                DisplayForm]],
              BoxBaselineShift->0]}
           },
           BaselinePosition->{Bottom, {1, 3}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[-0.06999999999999999]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ScriptBaselineShifts->{0, 0}], ",", 
         TagBox[
          StyleBox[GridBox[{
             {
              AdjustmentBox[
               SubscriptBox["", 
                TagBox["1",
                 DisplayForm]],
               BoxBaselineShift->-0.6], 
              AdjustmentBox[
               SubscriptBox["", 
                TagBox[
                 StyleBox["\<\"/\"\>",
                  FontSlant->"Oblique"],
                 StyleForm[#, FontSlant -> "Oblique"]& ]],
               BoxBaselineShift->-0.3], 
              AdjustmentBox[
               SubscriptBox["", 
                TagBox["2",
                 DisplayForm]],
               BoxBaselineShift->0]}
            },
            BaselinePosition->{Bottom, {1, 3}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[-0.06999999999999999]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ScriptBaselineShifts->{0, 0},
           FontFamily->"Times"],
          StyleForm[#, FontFamily -> Times]& ], ",", 
         TagBox["\[Pi]",
          DisplayForm], ",", 
         StyleBox[GridBox[{
            {
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["\[Pi]",
                DisplayForm]],
              BoxBaselineShift->-0.6], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                StyleBox["\<\"/\"\>",
                 FontSlant->"Oblique"],
                StyleForm[#, FontSlant -> "Oblique"]& ]],
              BoxBaselineShift->-0.3], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["2",
                DisplayForm]],
              BoxBaselineShift->0]}
           },
           BaselinePosition->{Bottom, {1, 3}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[-0.06999999999999999]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ScriptBaselineShifts->{0, 0}], ",", 
         StyleBox[GridBox[{
            {
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                RowBox[{"3", " ", "\[Pi]"}],
                DisplayForm]],
              BoxBaselineShift->-0.6], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                StyleBox["\<\"/\"\>",
                 FontSlant->"Oblique"],
                StyleForm[#, FontSlant -> "Oblique"]& ]],
              BoxBaselineShift->-0.3], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["2",
                DisplayForm]],
              BoxBaselineShift->0]}
           },
           BaselinePosition->{Bottom, {1, 3}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[-0.06999999999999999]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ScriptBaselineShifts->{0, 0}], "xxx"}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      FontSize->20],
     StyleForm[#, FontSize -> 20]& ],
    FontFamily->"Times New Roman"],
   StyleForm[#, FontFamily -> "Times New Roman"]& ],
  DisplayForm]], "Output"],

Cell["-0.2 {0.6,0.3,0.0}", "Text"],

Cell[BoxData[
 TagBox[
  TagBox[
   StyleBox[
    TagBox[
     StyleBox[GridBox[{
        {
         RowBox[{"xxxx11", ","}], 
         StyleBox[GridBox[{
            {
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["1",
                DisplayForm]],
              BoxBaselineShift->-0.6], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                StyleBox["\<\"/\"\>",
                 FontSlant->"Oblique"],
                StyleForm[#, FontSlant -> "Oblique"]& ]],
              BoxBaselineShift->-0.3], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["2",
                DisplayForm]],
              BoxBaselineShift->0]}
           },
           BaselinePosition->{Bottom, {1, 3}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[-0.13999999999999999`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ScriptBaselineShifts->{0, 0}], ",", 
         TagBox[
          StyleBox[GridBox[{
             {
              AdjustmentBox[
               SubscriptBox["", 
                TagBox["1",
                 DisplayForm]],
               BoxBaselineShift->-0.6], 
              AdjustmentBox[
               SubscriptBox["", 
                TagBox[
                 StyleBox["\<\"/\"\>",
                  FontSlant->"Oblique"],
                 StyleForm[#, FontSlant -> "Oblique"]& ]],
               BoxBaselineShift->-0.3], 
              AdjustmentBox[
               SubscriptBox["", 
                TagBox["2",
                 DisplayForm]],
               BoxBaselineShift->0]}
            },
            BaselinePosition->{Bottom, {1, 3}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[-0.13999999999999999`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ScriptBaselineShifts->{0, 0},
           FontFamily->"Times"],
          StyleForm[#, FontFamily -> Times]& ], ",", 
         TagBox["\[Pi]",
          DisplayForm], ",", 
         StyleBox[GridBox[{
            {
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["\[Pi]",
                DisplayForm]],
              BoxBaselineShift->-0.6], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                StyleBox["\<\"/\"\>",
                 FontSlant->"Oblique"],
                StyleForm[#, FontSlant -> "Oblique"]& ]],
              BoxBaselineShift->-0.3], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["2",
                DisplayForm]],
              BoxBaselineShift->0]}
           },
           BaselinePosition->{Bottom, {1, 3}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[-0.13999999999999999`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ScriptBaselineShifts->{0, 0}], ",", 
         StyleBox[GridBox[{
            {
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                RowBox[{"3", " ", "\[Pi]"}],
                DisplayForm]],
              BoxBaselineShift->-0.6], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                StyleBox["\<\"/\"\>",
                 FontSlant->"Oblique"],
                StyleForm[#, FontSlant -> "Oblique"]& ]],
              BoxBaselineShift->-0.3], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["2",
                DisplayForm]],
              BoxBaselineShift->0]}
           },
           BaselinePosition->{Bottom, {1, 3}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[-0.13999999999999999`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ScriptBaselineShifts->{0, 0}], "xxx"}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      FontSize->20],
     StyleForm[#, FontSize -> 20]& ],
    FontFamily->"Times New Roman"],
   StyleForm[#, FontFamily -> "Times New Roman"]& ],
  DisplayForm]], "Output"],

Cell["-0.2 {0.8,0.4,0.0}", "Text"],

Cell[BoxData[
 TagBox[
  TagBox[
   StyleBox[
    TagBox[
     StyleBox[GridBox[{
        {
         RowBox[{"xxxx11", ","}], 
         StyleBox[GridBox[{
            {
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["1",
                DisplayForm]],
              BoxBaselineShift->-0.8], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                StyleBox["\<\"/\"\>",
                 FontSlant->"Oblique"],
                StyleForm[#, FontSlant -> "Oblique"]& ]],
              BoxBaselineShift->-0.4], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["2",
                DisplayForm]],
              BoxBaselineShift->0]}
           },
           BaselinePosition->{Bottom, {1, 3}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[-0.13999999999999999`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ScriptBaselineShifts->{0, 0}], ",", 
         TagBox[
          StyleBox[GridBox[{
             {
              AdjustmentBox[
               SubscriptBox["", 
                TagBox["1",
                 DisplayForm]],
               BoxBaselineShift->-0.8], 
              AdjustmentBox[
               SubscriptBox["", 
                TagBox[
                 StyleBox["\<\"/\"\>",
                  FontSlant->"Oblique"],
                 StyleForm[#, FontSlant -> "Oblique"]& ]],
               BoxBaselineShift->-0.4], 
              AdjustmentBox[
               SubscriptBox["", 
                TagBox["2",
                 DisplayForm]],
               BoxBaselineShift->0]}
            },
            BaselinePosition->{Bottom, {1, 3}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[-0.13999999999999999`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ScriptBaselineShifts->{0, 0},
           FontFamily->"Times"],
          StyleForm[#, FontFamily -> Times]& ], ",", 
         TagBox["\[Pi]",
          DisplayForm], ",", 
         StyleBox[GridBox[{
            {
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["\[Pi]",
                DisplayForm]],
              BoxBaselineShift->-0.8], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                StyleBox["\<\"/\"\>",
                 FontSlant->"Oblique"],
                StyleForm[#, FontSlant -> "Oblique"]& ]],
              BoxBaselineShift->-0.4], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["2",
                DisplayForm]],
              BoxBaselineShift->0]}
           },
           BaselinePosition->{Bottom, {1, 3}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[-0.13999999999999999`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ScriptBaselineShifts->{0, 0}], ",", 
         StyleBox[GridBox[{
            {
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                RowBox[{"3", " ", "\[Pi]"}],
                DisplayForm]],
              BoxBaselineShift->-0.8], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                StyleBox["\<\"/\"\>",
                 FontSlant->"Oblique"],
                StyleForm[#, FontSlant -> "Oblique"]& ]],
              BoxBaselineShift->-0.4], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["2",
                DisplayForm]],
              BoxBaselineShift->0]}
           },
           BaselinePosition->{Bottom, {1, 3}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[-0.13999999999999999`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ScriptBaselineShifts->{0, 0}], "xxx"}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      FontSize->20],
     StyleForm[#, FontSize -> 20]& ],
    FontFamily->"Times New Roman"],
   StyleForm[#, FontFamily -> "Times New Roman"]& ],
  DisplayForm]], "Output"],

Cell["-0.2 {0.9,0.5,0.0}", "Text"],

Cell[BoxData[
 TagBox[
  TagBox[
   StyleBox[
    TagBox[
     StyleBox[GridBox[{
        {
         RowBox[{"xxxx11", ","}], 
         StyleBox[GridBox[{
            {
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["1",
                DisplayForm]],
              BoxBaselineShift->-0.9], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                StyleBox["\<\"/\"\>",
                 FontSlant->"Oblique"],
                StyleForm[#, FontSlant -> "Oblique"]& ]],
              BoxBaselineShift->-0.5], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["2",
                DisplayForm]],
              BoxBaselineShift->0]}
           },
           BaselinePosition->{Bottom, {1, 3}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[-0.13999999999999999`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ScriptBaselineShifts->{0, 0}], ",", 
         TagBox[
          StyleBox[GridBox[{
             {
              AdjustmentBox[
               SubscriptBox["", 
                TagBox["1",
                 DisplayForm]],
               BoxBaselineShift->-0.9], 
              AdjustmentBox[
               SubscriptBox["", 
                TagBox[
                 StyleBox["\<\"/\"\>",
                  FontSlant->"Oblique"],
                 StyleForm[#, FontSlant -> "Oblique"]& ]],
               BoxBaselineShift->-0.5], 
              AdjustmentBox[
               SubscriptBox["", 
                TagBox["2",
                 DisplayForm]],
               BoxBaselineShift->0]}
            },
            BaselinePosition->{Bottom, {1, 3}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[-0.13999999999999999`]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}],
           ScriptBaselineShifts->{0, 0},
           FontFamily->"Times"],
          StyleForm[#, FontFamily -> Times]& ], ",", 
         TagBox["\[Pi]",
          DisplayForm], ",", 
         StyleBox[GridBox[{
            {
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["\[Pi]",
                DisplayForm]],
              BoxBaselineShift->-0.9], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                StyleBox["\<\"/\"\>",
                 FontSlant->"Oblique"],
                StyleForm[#, FontSlant -> "Oblique"]& ]],
              BoxBaselineShift->-0.5], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["2",
                DisplayForm]],
              BoxBaselineShift->0]}
           },
           BaselinePosition->{Bottom, {1, 3}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[-0.13999999999999999`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ScriptBaselineShifts->{0, 0}], ",", 
         StyleBox[GridBox[{
            {
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                RowBox[{"3", " ", "\[Pi]"}],
                DisplayForm]],
              BoxBaselineShift->-0.9], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                StyleBox["\<\"/\"\>",
                 FontSlant->"Oblique"],
                StyleForm[#, FontSlant -> "Oblique"]& ]],
              BoxBaselineShift->-0.5], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["2",
                DisplayForm]],
              BoxBaselineShift->0]}
           },
           BaselinePosition->{Bottom, {1, 3}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[-0.13999999999999999`]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ScriptBaselineShifts->{0, 0}], "xxx"}
       },
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}}],
      FontSize->20],
     StyleForm[#, FontSize -> 20]& ],
    FontFamily->"Times New Roman"],
   StyleForm[#, FontFamily -> "Times New Roman"]& ],
  DisplayForm]], "Output"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"RowBox", "[", 
   RowBox[{"{", 
    RowBox[{"\"\<xxxx11,\>\"", ",", 
     RowBox[{"DiagonalFractionBox", "[", 
      RowBox[{"1", "/", "2"}], "]"}], ",", "\"\<,\>\"", ",", 
     RowBox[{"textfamily", "[", 
      RowBox[{"Times", ",", 
       RowBox[{"DiagonalFractionBox", "[", 
        RowBox[{"1", "/", "2"}], "]"}]}], "]"}], ",", "\"\<,\>\"", ",", 
     RowBox[{"DiagonalFractionBox", "[", "Pi", "]"}], ",", "\"\<,\>\"", ",", 
     RowBox[{"DiagonalFractionBox", "[", 
      RowBox[{"Pi", "/", "2"}], "]"}], ",", "\"\<,\>\"", ",", 
     RowBox[{"DiagonalFractionBox", "[", 
      RowBox[{"3", "*", 
       RowBox[{"Pi", "/", "2"}]}], "]"}], ",", "\"\<xxx\>\""}], "}"}], "]"}], 
  "//", "DisplayForm"}]], "Input"],

Cell[BoxData[
 TagBox[
  RowBox[{
   RowBox[{"xxxx11", ","}], 
   StyleBox[GridBox[{
      {
       AdjustmentBox[
        SubscriptBox["", 
         TagBox["1",
          DisplayForm]],
        BoxBaselineShift->-0.9], 
       AdjustmentBox[
        SubscriptBox["", 
         StyleBox["/",
          FontSlant->"Oblique"]],
        BoxBaselineShift->-0.5], 
       SubscriptBox["", 
        TagBox["2",
         DisplayForm]]}
     },
     BaselinePosition->{Bottom, {1, 3}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[-0.13999999999999999`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ScriptBaselineShifts->{0, 0}], ",", 
   TagBox[
    StyleBox[GridBox[{
       {
        AdjustmentBox[
         SubscriptBox["", 
          TagBox["1",
           DisplayForm]],
         BoxBaselineShift->-0.9], 
        AdjustmentBox[
         SubscriptBox["", 
          StyleBox["/",
           FontSlant->"Oblique"]],
         BoxBaselineShift->-0.5], 
        SubscriptBox["", 
         TagBox["2",
          DisplayForm]]}
      },
      BaselinePosition->{Bottom, {1, 3}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[-0.13999999999999999`]}, 
          Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}, "RowsIndexed" -> {}}],
     ScriptBaselineShifts->{0, 0},
     FontFamily->"Times"],
    StyleForm[#, FontFamily -> Times]& ], ",", 
   TagBox["\[Pi]",
    DisplayForm], ",", 
   StyleBox[GridBox[{
      {
       AdjustmentBox[
        SubscriptBox["", 
         TagBox["\[Pi]",
          DisplayForm]],
        BoxBaselineShift->-0.9], 
       AdjustmentBox[
        SubscriptBox["", 
         StyleBox["/",
          FontSlant->"Oblique"]],
        BoxBaselineShift->-0.5], 
       SubscriptBox["", 
        TagBox["2",
         DisplayForm]]}
     },
     BaselinePosition->{Bottom, {1, 3}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[-0.13999999999999999`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ScriptBaselineShifts->{0, 0}], ",", 
   StyleBox[GridBox[{
      {
       AdjustmentBox[
        SubscriptBox["", 
         TagBox[
          RowBox[{"3", " ", "\[Pi]"}],
          DisplayForm]],
        BoxBaselineShift->-0.9], 
       AdjustmentBox[
        SubscriptBox["", 
         StyleBox["/",
          FontSlant->"Oblique"]],
        BoxBaselineShift->-0.5], 
       SubscriptBox["", 
        TagBox["2",
         DisplayForm]]}
     },
     BaselinePosition->{Bottom, {1, 3}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[-0.13999999999999999`]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}],
    ScriptBaselineShifts->{0, 0}], "xxx"}],
  DisplayForm]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"DiagonalFractionize", "[", 
   RowBox[{"1", "/", "2"}], "]"}], "//", 
  "FullForm"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"textfamily", "[", 
   RowBox[{"\"\<Times New Roman\>\"", ",", "\[IndentingNewLine]", 
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"SuperscriptBox", "[", 
       RowBox[{
        RowBox[{"DiagonalFractionize", "[", 
         RowBox[{
          RowBox[{"1", "/", "2"}], ",", 
          RowBox[{"KernForSuperscript", "\[Rule]", "0"}]}], "]"}], ",", 
        "\"\<+\>\""}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"SuperscriptBox", "[", 
       RowBox[{
        RowBox[{"DiagonalFractionize", "[", 
         RowBox[{"1", "/", "2"}], "]"}], ",", "\"\<+\>\""}], "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"SubsuperscriptBox", "[", 
       RowBox[{
        RowBox[{"DiagonalFractionize", "[", 
         RowBox[{"1", "/", "2"}], "]"}], ",", "\"\<0\>\"", ",", "\"\<+\>\""}],
        "]"}]}], "\[IndentingNewLine]", "}"}]}], "\[IndentingNewLine]", "]"}],
   "//", "DisplayForm"}]}], "Input"],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"TagBox", "[", 
    RowBox[{
     RowBox[{"StyleBox", "[", 
      RowBox[{
       RowBox[{"GridBox", "[", 
        RowBox[{
         RowBox[{"List", "[", 
          RowBox[{"List", "[", 
           RowBox[{
            RowBox[{"AdjustmentBox", "[", 
             RowBox[{
              RowBox[{"SubscriptBox", "[", 
               RowBox[{"\"\<\>\"", ",", 
                RowBox[{"DisplayForm", "[", "1", "]"}]}], "]"}], ",", 
              RowBox[{"Rule", "[", 
               RowBox[{"BoxBaselineShift", ",", 
                RowBox[{"-", "0.5`"}]}], "]"}]}], "]"}], ",", 
            RowBox[{"AdjustmentBox", "[", 
             RowBox[{
              RowBox[{"SubscriptBox", "[", 
               RowBox[{"\"\<\>\"", ",", 
                RowBox[{"StyleForm", "[", 
                 RowBox[{"\"\</\>\"", ",", 
                  RowBox[{"Rule", "[", 
                   RowBox[{"FontSlant", ",", "\"\<Oblique\>\""}], "]"}]}], 
                 "]"}]}], "]"}], ",", 
              RowBox[{"Rule", "[", 
               RowBox[{"BoxBaselineShift", ",", 
                RowBox[{"-", "0.3`"}]}], "]"}]}], "]"}], ",", 
            RowBox[{"AdjustmentBox", "[", 
             RowBox[{
              RowBox[{"SubscriptBox", "[", 
               RowBox[{"\"\<\>\"", ",", 
                RowBox[{"DisplayForm", "[", "2", "]"}]}], "]"}], ",", 
              RowBox[{"Rule", "[", 
               RowBox[{"BoxBaselineShift", ",", "0.`"}], "]"}]}], "]"}]}], 
           "]"}], "]"}], ",", 
         RowBox[{"Rule", "[", 
          RowBox[{"ColumnSpacings", ",", 
           RowBox[{"-", "0.1`"}]}], "]"}], ",", 
         RowBox[{"Rule", "[", 
          RowBox[{"GridBaseline", ",", 
           RowBox[{"List", "[", 
            RowBox[{"Bottom", ",", 
             RowBox[{"List", "[", 
              RowBox[{"1", ",", "3"}], "]"}]}], "]"}]}], "]"}]}], "]"}], ",", 
       
       RowBox[{"Rule", "[", 
        RowBox[{"ScriptBaselineShifts", ",", 
         RowBox[{"List", "[", 
          RowBox[{"0", ",", "0"}], "]"}]}], "]"}]}], "]"}], ",", 
     RowBox[{"DiagonalFractionBox", "[", 
      RowBox[{"-", "0.15`"}], "]"}]}], "]"}],
   ShowSpecialCharacters->False,
   ShowStringCharacters->True,
   NumberMarks->True],
  FullForm]], "Output"],

Cell[BoxData[
 TagBox[
  TagBox[
   StyleBox[
    RowBox[{"{", 
     RowBox[{
      SuperscriptBox[
       AdjustmentBox[
        TagBox[
         StyleBox[GridBox[{
            {
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["1",
                DisplayForm]],
              BoxBaselineShift->-0.5], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                StyleBox["\<\"/\"\>",
                 FontSlant->"Oblique"],
                StyleForm[#, FontSlant -> "Oblique"]& ]],
              BoxBaselineShift->-0.3], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["2",
                DisplayForm]],
              BoxBaselineShift->0]}
           },
           BaselinePosition->{Bottom, {1, 3}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[-0.06999999999999999]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ScriptBaselineShifts->{0, 0}],
         DiagonalFractionBox[0]],
        BoxMargins->{{0, 0}, {0, 0}}], "+"], ",", 
      SuperscriptBox[
       AdjustmentBox[
        TagBox[
         StyleBox[GridBox[{
            {
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["1",
                DisplayForm]],
              BoxBaselineShift->-0.5], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox[
                StyleBox["\<\"/\"\>",
                 FontSlant->"Oblique"],
                StyleForm[#, FontSlant -> "Oblique"]& ]],
              BoxBaselineShift->-0.3], 
             AdjustmentBox[
              SubscriptBox["", 
               TagBox["2",
                DisplayForm]],
              BoxBaselineShift->0]}
           },
           BaselinePosition->{Bottom, {1, 3}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[-0.06999999999999999]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}],
          ScriptBaselineShifts->{0, 0}],
         DiagonalFractionBox[-0.15]],
        BoxMargins->{{0, -0.15}, {0, 0}}], "+"], ",", 
      SubsuperscriptBox[
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["2",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]], "0", "+"]}], "}"}],
    FontFamily->"Times New Roman"],
   StyleForm[#, FontFamily -> "Times New Roman"]& ],
  DisplayForm]], "Output"]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "... formatting tests under ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " 8"
}], "Subsection",
 CellChangeTimes->{{3.52776708871875*^9, 3.527767098921875*^9}, {
   3.527767146890625*^9, 3.527767148078125*^9}, 3.527767672234375*^9}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Options", "[", "GridBox", "]"}]], "Input",
 CellChangeTimes->{{3.52776767709375*^9, 3.52776767740625*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"AllowedDimensions", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"AllowScriptLevelChange", "\[Rule]", "True"}], ",", 
   RowBox[{"AutoDelete", "\[Rule]", "True"}], ",", 
   RowBox[{"BaselinePosition", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"BaseStyle", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"ColumnAlignments", "\[Rule]", "Center"}], ",", 
   RowBox[{"ColumnBackgrounds", "\[Rule]", "None"}], ",", 
   RowBox[{"ColumnLines", "\[Rule]", "False"}], ",", 
   RowBox[{"ColumnsEqual", "\[Rule]", "False"}], ",", 
   RowBox[{"ColumnSpacings", "\[Rule]", "0.8`"}], ",", 
   RowBox[{"ColumnWidths", "\[Rule]", "All"}], ",", 
   RowBox[{"DefaultBaseStyle", "\[Rule]", "\<\"Grid\"\>"}], ",", 
   RowBox[{"DefaultFrameStyle", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"DeleteWithContents", "\[Rule]", "True"}], ",", 
   RowBox[{"Editable", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"FrameStyle", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"GridBoxAlignment", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"GridBoxBackground", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"GridBoxDividers", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"GridBoxFrame", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"GridBoxItemSize", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"GridBoxItemStyle", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"GridBoxSpacings", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"GridDefaultElement", "\[Rule]", "\<\"\[Placeholder]\"\>"}], ",", 
   RowBox[{"GridFrame", "\[Rule]", "False"}], ",", 
   RowBox[{"GridFrameMargins", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0.4`", ",", "0.4`"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0.5`", ",", "0.5`"}], "}"}]}], "}"}]}], ",", 
   RowBox[{"MultilineFunction", "\[Rule]", "None"}], ",", 
   RowBox[{"RowAlignments", "\[Rule]", "Baseline"}], ",", 
   RowBox[{"RowBackgrounds", "\[Rule]", "None"}], ",", 
   RowBox[{"RowHeights", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"RowLines", "\[Rule]", "False"}], ",", 
   RowBox[{"RowMinHeight", "\[Rule]", "1.`"}], ",", 
   RowBox[{"RowsEqual", "\[Rule]", "False"}], ",", 
   RowBox[{"RowSpacings", "\[Rule]", "1.`"}], ",", 
   RowBox[{"Selectable", "\[Rule]", "Automatic"}]}], "}"}]], "Output",
 CellChangeTimes->{3.527767678109375*^9}]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Options", "[", "Row", "]"}]], "Input",
 CellChangeTimes->{{3.527767722*^9, 3.52776772371875*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Alignment", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Left", ",", "Baseline"}], "}"}]}], ",", 
   RowBox[{"Background", "\[Rule]", "None"}], ",", 
   RowBox[{"BaselinePosition", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"BaseStyle", "\[Rule]", 
    RowBox[{"{", "}"}]}], ",", 
   RowBox[{"DefaultBaseStyle", "\[Rule]", "\<\"Row\"\>"}], ",", 
   RowBox[{"Editable", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"Frame", "\[Rule]", "None"}], ",", 
   RowBox[{"FrameMargins", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"FrameStyle", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"ImageMargins", "\[Rule]", "0"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"RoundingRadius", "\[Rule]", "0"}], ",", 
   RowBox[{"Selectable", "\[Rule]", "Automatic"}], ",", 
   RowBox[{"StripOnInput", "\[Rule]", "False"}], ",", 
   RowBox[{"SyntaxForm", "\[Rule]", "Automatic"}]}], "}"}]], "Output",
 CellChangeTimes->{3.527767724015625*^9}]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"ColumnSpacings", "\[Rule]", 
   RowBox[{"-", "0.4"}]}], ",", 
  RowBox[{"Baseline", "\[Rule]", 
   RowBox[{"{", 
    RowBox[{"0.5", ",", "0.3", ",", "0.0"}], "}"}]}], ",", 
  RowBox[{"KernForSuperscript", "\[Rule]", 
   RowBox[{"-", "0.15"}]}]}]], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Style", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"DiagonalFractionize", "[", 
       RowBox[{
        RowBox[{"1", "/", "2"}], ",", 
        RowBox[{"ColumnSpacings", "\[Rule]", 
         RowBox[{"-", "0.4"}]}], ",", 
        RowBox[{"Baseline", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0.5", ",", "0.3", ",", "0.0"}], "}"}]}], ",", 
        RowBox[{"KernForSuperscript", "\[Rule]", 
         RowBox[{"-", "0.15"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"DiagonalFractionize", "[", 
       RowBox[{
        RowBox[{"1", "/", "2"}], ",", 
        RowBox[{"ColumnSpacings", "\[Rule]", 
         RowBox[{"-", "0.3"}]}], ",", 
        RowBox[{"Baseline", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0.5", ",", "0.3", ",", "0.0"}], "}"}]}], ",", 
        RowBox[{"KernForSuperscript", "\[Rule]", 
         RowBox[{"-", "0.15"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
      RowBox[{"DiagonalFractionize", "[", 
       RowBox[{
        RowBox[{"1", "/", "2"}], ",", 
        RowBox[{"ColumnSpacings", "\[Rule]", 
         RowBox[{"-", "0.2"}]}], ",", 
        RowBox[{"Baseline", "\[Rule]", 
         RowBox[{"{", 
          RowBox[{"0.5", ",", "0.3", ",", "0.0"}], "}"}]}], ",", 
        RowBox[{"KernForSuperscript", "\[Rule]", 
         RowBox[{"-", "0.15"}]}]}], "]"}]}], "\[IndentingNewLine]", "}"}], 
    ",", "\[IndentingNewLine]", 
    RowBox[{"FontFamily", "->", "Times"}], ",", "20"}], "\[IndentingNewLine]",
    "]"}], "//", "DisplayForm"}]], "Input",
 CellChangeTimes->{{3.527767766375*^9, 3.52776778409375*^9}, {
   3.52776783778125*^9, 3.5277678724375*^9}, {3.5277679143125*^9, 
   3.527768016234375*^9}, 3.52776805553125*^9}],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"{", 
    RowBox[{
     TagBox[
      StyleBox[GridBox[{
         {
          AdjustmentBox[
           SubscriptBox["", 
            TagBox["1",
             DisplayForm]],
           BoxBaselineShift->-0.5], 
          AdjustmentBox[
           SubscriptBox["", 
            TagBox[
             StyleBox["\<\"/\"\>",
              FontSlant->"Oblique"],
             StyleForm[#, FontSlant -> "Oblique"]& ]],
           BoxBaselineShift->-0.3], 
          AdjustmentBox[
           SubscriptBox["", 
            TagBox["2",
             DisplayForm]],
           BoxBaselineShift->0.]}
        },
        BaselinePosition->{{1, 3}, Bottom},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[-0.27999999999999997`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ScriptBaselineShifts->{0, 0}],
      SciDraw`DiagonalFractionBox[-0.15]], ",", 
     TagBox[
      StyleBox[GridBox[{
         {
          AdjustmentBox[
           SubscriptBox["", 
            TagBox["1",
             DisplayForm]],
           BoxBaselineShift->-0.5], 
          AdjustmentBox[
           SubscriptBox["", 
            TagBox[
             StyleBox["\<\"/\"\>",
              FontSlant->"Oblique"],
             StyleForm[#, FontSlant -> "Oblique"]& ]],
           BoxBaselineShift->-0.3], 
          AdjustmentBox[
           SubscriptBox["", 
            TagBox["2",
             DisplayForm]],
           BoxBaselineShift->0.]}
        },
        BaselinePosition->{{1, 3}, Bottom},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[-0.21]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ScriptBaselineShifts->{0, 0}],
      SciDraw`DiagonalFractionBox[-0.15]], ",", 
     TagBox[
      StyleBox[GridBox[{
         {
          AdjustmentBox[
           SubscriptBox["", 
            TagBox["1",
             DisplayForm]],
           BoxBaselineShift->-0.5], 
          AdjustmentBox[
           SubscriptBox["", 
            TagBox[
             StyleBox["\<\"/\"\>",
              FontSlant->"Oblique"],
             StyleForm[#, FontSlant -> "Oblique"]& ]],
           BoxBaselineShift->-0.3], 
          AdjustmentBox[
           SubscriptBox["", 
            TagBox["2",
             DisplayForm]],
           BoxBaselineShift->0.]}
        },
        BaselinePosition->{{1, 3}, Bottom},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[-0.13999999999999999`]}, 
            Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
          "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}, "RowsIndexed" -> {}}],
       ScriptBaselineShifts->{0, 0}],
      SciDraw`DiagonalFractionBox[-0.15]]}], "}"}],
   StripOnInput->False,
   FontFamily->Times,
   FontSize->20],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.527767779828125*^9, 3.527767787375*^9}, {
   3.527767838765625*^9, 3.527767930265625*^9}, {3.527767964171875*^9, 
   3.52776801753125*^9}, 3.527768056484375*^9}]
}, Open  ]],

Cell["\<\
However, kerning is ignored in superscript (bug report 111016).\
\>", "Text",
 CellChangeTimes->{{3.5277688668125*^9, 3.527768888734375*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"Style", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"{", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"SuperscriptBox", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DiagonalFractionize", "[", 
         RowBox[{
          RowBox[{"1", "/", "2"}], ",", 
          RowBox[{"ColumnSpacings", "\[Rule]", 
           RowBox[{"-", "0.3"}]}], ",", 
          RowBox[{"Baseline", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.3", ",", "0.0"}], "}"}]}], ",", 
          RowBox[{"KernForSuperscript", "\[Rule]", 
           RowBox[{"-", "1"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
        "\"\<+\>\""}], "\[IndentingNewLine]", "]"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{"SuperscriptBox", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"DiagonalFractionize", "[", 
         RowBox[{
          RowBox[{"1", "/", "2"}], ",", 
          RowBox[{"ColumnSpacings", "\[Rule]", 
           RowBox[{"-", "0.3"}]}], ",", 
          RowBox[{"Baseline", "\[Rule]", 
           RowBox[{"{", 
            RowBox[{"0.5", ",", "0.3", ",", "0.0"}], "}"}]}], ",", 
          RowBox[{"KernForSuperscript", "\[Rule]", 
           RowBox[{"+", "1"}]}]}], "]"}], ",", "\[IndentingNewLine]", 
        "\"\<+\>\""}], "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
     "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{"FontFamily", "->", "Times"}], ",", "20"}], "\[IndentingNewLine]",
    "]"}], "//", "DisplayForm"}]], "Input",
 CellChangeTimes->{{3.527767766375*^9, 3.52776778409375*^9}, {
   3.52776783778125*^9, 3.5277678724375*^9}, {3.5277679143125*^9, 
   3.527768016234375*^9}, {3.5277680609375*^9, 3.527768066921875*^9}, 
   3.52776892565625*^9}],

Cell[BoxData[
 TagBox[
  StyleBox[
   RowBox[{"{", 
    RowBox[{
     SuperscriptBox[
      AdjustmentBox[
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["2",
               DisplayForm]],
             BoxBaselineShift->0.]}
          },
          BaselinePosition->{{1, 3}, Bottom},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.21]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        SciDraw`DiagonalFractionBox[-1]],
       BoxMargins->{{0, -1}, {0, 0}}], "+"], ",", 
     SuperscriptBox[
      AdjustmentBox[
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["2",
               DisplayForm]],
             BoxBaselineShift->0.]}
          },
          BaselinePosition->{{1, 3}, Bottom},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.21]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        SciDraw`DiagonalFractionBox[1]],
       BoxMargins->{{0, 1}, {0, 0}}], "+"]}], "}"}],
   StripOnInput->False,
   FontFamily->Times,
   FontSize->20],
  DisplayForm]], "Output",
 CellChangeTimes->{3.52776806734375*^9, 3.527768926203125*^9}]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "... formatting tests under ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " 10"
}], "Subsection",
 CellChangeTimes->{{3.625184938943143*^9, 3.625184943513951*^9}}],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"DiagonalFractionize", "[", 
  RowBox[{"1", "/", "2"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"Style", "[", 
   RowBox[{"%", ",", 
    RowBox[{"FontFamily", "->", "\"\<Times\>\""}], ",", "Large"}], "]"}], "//",
   "DisplayForm"}]}], "Input",
 CellChangeTimes->{{3.625184945229954*^9, 3.625184965307189*^9}, {
  3.6251863280017824`*^9, 3.625186330981388*^9}}],

Cell[BoxData[
 RowBox[{"TagBox", "[", 
  RowBox[{
   RowBox[{"StyleBox", "[", 
    RowBox[{
     TagBox[GridBox[{
        {
         RowBox[{"AdjustmentBox", "[", 
          RowBox[{
           RowBox[{"SubscriptBox", "[", 
            RowBox[{"\<\"\"\>", ",", 
             TagBox["1",
              DisplayForm]}], "]"}], ",", 
           RowBox[{"BoxBaselineShift", "\[Rule]", 
            RowBox[{"-", "0.5`"}]}]}], "]"}], 
         RowBox[{"AdjustmentBox", "[", 
          RowBox[{
           TagBox[
            StyleBox["\<\"/\"\>",
             FontSlant->"Oblique"],
            StyleForm[#, FontSlant -> "Oblique"]& ], ",", 
           RowBox[{"BoxBaselineShift", "\[Rule]", "0.`"}]}], "]"}], 
         RowBox[{"AdjustmentBox", "[", 
          RowBox[{
           RowBox[{"SubscriptBox", "[", 
            RowBox[{"\<\"\"\>", ",", 
             TagBox["2",
              DisplayForm]}], "]"}], ",", 
           RowBox[{"BoxBaselineShift", "\[Rule]", "0.`"}]}], "]"}]}
       },
       AutoDelete->False,
       BaselinePosition->{{1, 3}, Bottom},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {0, -0.1, -0.2, 0}}],
      "Grid"], ",", 
     RowBox[{"ScriptBaselineShifts", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}]}]}], "]"}], ",", 
   RowBox[{"DiagonalFractionBox", "[", 
    RowBox[{"-", "0.15`"}], "]"}]}], "]"}]], "Output",
 CellChangeTimes->{{3.625184950221963*^9, 3.6251849655567894`*^9}, {
   3.6251855661588445`*^9, 3.625185595018895*^9}, 3.625186331776989*^9, 
   3.625186398217506*^9, {3.62518654273616*^9, 3.625186552579777*^9}}],

Cell[BoxData[
 TagBox[
  StyleBox[
   TagBox[
    StyleBox[
     TagBox[GridBox[{
        {
         AdjustmentBox[
          SubscriptBox["", 
           TagBox["1",
            DisplayForm]],
          BoxBaselineShift->-0.5], 
         AdjustmentBox[
          TagBox[
           StyleBox["\<\"/\"\>",
            FontSlant->"Oblique"],
           StyleForm[#, FontSlant -> "Oblique"]& ],
          BoxBaselineShift->0.], 
         AdjustmentBox[
          SubscriptBox["", 
           TagBox["2",
            DisplayForm]],
          BoxBaselineShift->0.]}
       },
       AutoDelete->False,
       BaselinePosition->{{1, 3}, Bottom},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
       
       GridBoxSpacings->{"Columns" -> {0, -0.1, -0.2, 0}}],
      "Grid"],
     ScriptBaselineShifts->{0, 0}],
    SciDraw`DiagonalFractionBox[-0.15]],
   StripOnInput->False,
   FontFamily->"Times",
   FontSize->Large],
  DisplayForm]], "Output",
 CellChangeTimes->{{3.625184950221963*^9, 3.6251849655567894`*^9}, {
   3.6251855661588445`*^9, 3.625185595018895*^9}, 3.625186331776989*^9, 
   3.625186398217506*^9, {3.62518654273616*^9, 3.625186552595377*^9}}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["...miscellaneous tests", "Subsection",
 CellChangeTimes->{{3.5277671596875*^9, 3.527767166078125*^9}}],

Cell["\<\
Brute force listability by Listable attribute causes unwanted threading over \
option lists....\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DiagonalFractionize", "[", 
  RowBox[{"a", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ColumnSpacings", "\[Rule]", "0.2"}], ",", 
     RowBox[{"ColumnSpacings", "\[Rule]", "0.2"}], ",", 
     RowBox[{"ColumnSpacings", "\[Rule]", "0.2"}]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"DiagonalFractionize", "[", 
    RowBox[{"a", ",", 
     RowBox[{"ColumnSpacings", "\[Rule]", "0.2`"}]}], "]"}], ",", 
   RowBox[{"DiagonalFractionize", "[", 
    RowBox[{"a", ",", 
     RowBox[{"ColumnSpacings", "\[Rule]", "0.2`"}]}], "]"}], ",", 
   RowBox[{"DiagonalFractionize", "[", 
    RowBox[{"a", ",", 
     RowBox[{"ColumnSpacings", "\[Rule]", "0.2`"}]}], "]"}]}], 
  "}"}]], "Output"]
}, Open  ]],

Cell["\<\
So instead explicitly force listability over first argument with rule...\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DiagonalFractionize", "[", 
  RowBox[{"a", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ColumnSpacings", "\[Rule]", "0.2"}], ",", 
     RowBox[{"ColumnSpacings", "\[Rule]", "0.2"}], ",", 
     RowBox[{"ColumnSpacings", "\[Rule]", "0.2"}]}], "}"}]}], "]"}]], "Input"],

Cell[BoxData[
 RowBox[{"DiagonalFractionize", "[", 
  RowBox[{"a", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"ColumnSpacings", "\[Rule]", "0.2`"}], ",", 
     RowBox[{"ColumnSpacings", "\[Rule]", "0.2`"}], ",", 
     RowBox[{"ColumnSpacings", "\[Rule]", "0.2`"}]}], "}"}]}], 
  "]"}]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"DiagonalFractionize", "[", 
    RowBox[{"Table", "[", 
     RowBox[{
      RowBox[{"1", "/", 
       RowBox[{"(", 
        RowBox[{"i", "*", "j"}], ")"}]}], ",", 
      RowBox[{"{", 
       RowBox[{"i", ",", "5"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"j", ",", "5"}], "}"}]}], "]"}], "]"}], "//", "MatrixForm"}], "//",
   "DisplayForm"}]], "Input"],

Cell[BoxData[
 TagBox[
  TagBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {
       TagBox["1",
        DisplayForm], 
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["2",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]], 
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["3",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]], 
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["4",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]], 
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["5",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]]},
      {
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["2",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]], 
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["4",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]], 
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["6",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]], 
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["8",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]], 
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["10",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]]},
      {
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["3",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]], 
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["6",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]], 
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["9",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]], 
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["12",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]], 
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["15",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]]},
      {
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["4",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]], 
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["8",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]], 
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["12",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]], 
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["16",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]], 
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["20",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]]},
      {
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["5",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]], 
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["10",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]], 
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["15",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]], 
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["20",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]], 
       TagBox[
        StyleBox[GridBox[{
           {
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["1",
               DisplayForm]],
             BoxBaselineShift->-0.5], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox[
               StyleBox["\<\"/\"\>",
                FontSlant->"Oblique"],
               StyleForm[#, FontSlant -> "Oblique"]& ]],
             BoxBaselineShift->-0.3], 
            AdjustmentBox[
             SubscriptBox["", 
              TagBox["25",
               DisplayForm]],
             BoxBaselineShift->0]}
          },
          BaselinePosition->{Bottom, {1, 3}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[-0.06999999999999999]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}],
         ScriptBaselineShifts->{0, 0}],
        DiagonalFractionBox[-0.15]]}
     }], "\[NoBreak]", ")"}],
   Function[BoxForm`e$, 
    MatrixForm[BoxForm`e$]]],
  DisplayForm]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Solidus fraction as string", "Subsection",
 CellChangeTimes->{{3.52776734515625*^9, 3.527767348984375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"FractionString", "[", 
    RowBox[{"x_", "?", "NumericQ"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"f", ",", "NumeratorString", ",", "DenominatorString"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"f", "=", 
       RowBox[{"Rationalize", "[", "x", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"NumeratorString", "=", 
       RowBox[{"ToString", "[", 
        RowBox[{"Numerator", "[", "f", "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"DenominatorString", "=", 
       RowBox[{"ToString", "[", 
        RowBox[{"Denominator", "[", "f", "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"f", "\[Equal]", "0"}], ",", "\"\<0\>\"", ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Denominator", "[", "f", "]"}], "\[Equal]", "1"}], ",", 
        RowBox[{"StringJoin", "[", "NumeratorString", "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Denominator", "[", "f", "]"}], "!=", "1"}], ",", 
        RowBox[{"StringJoin", "[", 
         RowBox[{
         "NumeratorString", ",", "\"\</\>\"", ",", "DenominatorString"}], 
         "]"}]}], "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
    "]"}]}], ";"}]], "Input",
 InitializationCell->True]
}, Closed]],

Cell[CellGroupData[{

Cell["Pi fraction as string", "Subsection",
 CellChangeTimes->{{3.52776734515625*^9, 3.5277673726875*^9}}],

Cell["PiFractionString", "Text"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"PiFractionString", "[", 
    RowBox[{"x_", "?", "NumericQ"}], "]"}], ":=", 
   RowBox[{"Module", "[", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"f", ",", "NumeratorString", ",", "DenominatorString"}], "}"}], 
     ",", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"f", "=", 
       RowBox[{"Rationalize", "[", 
        RowBox[{"x", "/", "Pi"}], "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"NumeratorString", "=", 
       RowBox[{"If", "[", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{
          RowBox[{"Numerator", "[", "f", "]"}], "\[Equal]", "1"}], ",", 
         "\[IndentingNewLine]", "\"\<\>\"", ",", "\[IndentingNewLine]", 
         RowBox[{"ToString", "[", 
          RowBox[{"Numerator", "[", "f", "]"}], "]"}]}], 
        "\[IndentingNewLine]", "]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"DenominatorString", "=", 
       RowBox[{"ToString", "[", 
        RowBox[{"Denominator", "[", "f", "]"}], "]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Which", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"f", "\[Equal]", "0"}], ",", "\"\<0\>\"", ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Denominator", "[", "f", "]"}], "\[Equal]", "1"}], ",", 
        RowBox[{"StringJoin", "[", 
         RowBox[{"NumeratorString", ",", "\"\<\[Pi]\>\""}], "]"}], ",", 
        "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"Denominator", "[", "f", "]"}], "!=", "1"}], ",", 
        RowBox[{"StringJoin", "[", 
         RowBox[{
         "NumeratorString", ",", "\"\<\[Pi]\>\"", ",", "\"\</\>\"", ",", 
          "DenominatorString"}], "]"}]}], "\[IndentingNewLine]", "]"}]}]}], 
    "\[IndentingNewLine]", "]"}]}], ";"}]], "Input",
 InitializationCell->True],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"PiFractionString", "[", 
  RowBox[{"0", "*", "Pi"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"PiFractionString", "[", 
  RowBox[{"1", "*", 
   RowBox[{"Pi", "/", "2"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"PiFractionString", "[", 
  RowBox[{"2", "*", "Pi"}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"PiFractionString", "[", 
  RowBox[{"2", "*", 
   RowBox[{"Pi", "/", "3"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"PiFractionString", "[", 
  RowBox[{"2", "*", "E", "*", 
   RowBox[{"Pi", "/", "3"}]}], "]"}], "\[IndentingNewLine]", 
 RowBox[{"PiFractionString", "[", "3.9", "]"}]}], "Input"],

Cell[BoxData["\<\"0\"\>"], "Output"],

Cell[BoxData["\<\"\[Pi]/2\"\>"], "Output"],

Cell[BoxData["\<\"2\[Pi]\"\>"], "Output"],

Cell[BoxData["\<\"2\[Pi]/3\"\>"], "Output"],

Cell[BoxData["\<\"2 E\[Pi]/3\"\>"], "Output"],

Cell[BoxData["\<\"1.24141\[Pi]\"\>"], "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["End package", "Section",
 CellChangeTimes->{{3.514823047703125*^9, 3.51482305353125*^9}}],

Cell[CellGroupData[{

Cell["Exit private context", "Subsection",
 CellChangeTimes->{{3.514823086015625*^9, 3.5148231094375*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"End", "[", "]"}], ";"}]], "Input",
 InitializationCell->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Exit package context", "Subsection",
 CellChangeTimes->{{3.514823092890625*^9, 3.51482312965625*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Protect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<*\>\""}], "]"}], "]"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Unprotect", "[", 
   RowBox[{"Evaluate", "[", 
    RowBox[{"$Context", "<>", "\"\<$*\>\""}], "]"}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"EndPackage", "[", "]"}], ";"}]}], "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1404, 928},
WindowMargins->{{Automatic, 213}, {Automatic, 30}},
WindowFrame->"Normal",
ShowSelection->True,
FrontEndVersion->"10.0 for Microsoft Windows (64-bit) (September 9, 2014)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 34, 0, 71, "Section"],
Cell[616, 24, 2642, 65, 272, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[3295, 94, 32, 0, 71, "Section"],
Cell[CellGroupData[{
Cell[3352, 98, 48, 0, 36, "Subsection"],
Cell[3403, 100, 1472, 24, 31, "Input",
 InitializationCell->True],
Cell[4878, 126, 184, 5, 31, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[5099, 136, 43, 0, 36, "Subsection"],
Cell[5145, 138, 183, 4, 31, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[5343, 145, 99, 1, 36, "Subsection"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5479, 151, 156, 2, 71, "Section"],
Cell[CellGroupData[{
Cell[5660, 157, 352, 13, 37, "Subsection"],
Cell[6015, 172, 1809, 57, 9573, "Input",
 InitializationCell->True],
Cell[7827, 231, 425, 14, 1758, "Input",
 InitializationCell->True],
Cell[8255, 247, 1205, 40, 6252, "Input",
 InitializationCell->True],
Cell[9463, 289, 627, 17, 4028, "Input",
 InitializationCell->True],
Cell[10093, 308, 33, 0, 1650, "Text"],
Cell[10129, 310, 1228, 34, 9573, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[11394, 349, 45, 0, 28, "Subsection"],
Cell[11442, 351, 510, 14, 31, "Input",
 InitializationCell->True],
Cell[11955, 367, 1444, 43, 72, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[13436, 415, 93, 1, 36, "Subsection"],
Cell[13532, 418, 2580, 60, 352, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[16137, 482, 944, 25, 92, "Input"],
Cell[17084, 509, 576, 12, 30, "Output"],
Cell[17663, 523, 576, 12, 30, "Output"],
Cell[18242, 537, 571, 12, 30, "Output"],
Cell[18816, 551, 572, 12, 30, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[19437, 569, 36, 0, 36, "Subsection"],
Cell[19476, 571, 498, 12, 132, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[20011, 588, 93, 2, 28, "Subsection"],
Cell[20107, 592, 1626, 47, 14000, "Input",
 InitializationCell->True],
Cell[21736, 641, 322, 11, 1758, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[22083, 656, 349, 8, 5142, "Input"],
Cell[22435, 666, 31, 0, 1867, "Output"],
Cell[22469, 668, 31, 0, 1867, "Output"],
Cell[22503, 670, 31, 0, 1867, "Output"],
Cell[22537, 672, 32, 0, 1867, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[22606, 677, 493, 15, 5142, "Input"],
Cell[23102, 694, 65, 3, 1918, "Output"],
Cell[23170, 699, 88, 4, 3313, "Output"],
Cell[23261, 705, 107, 5, 3313, "Output"],
Cell[23371, 712, 57, 2, 1867, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[23465, 719, 381, 13, 2940, "Input"],
Cell[23849, 734, 73, 3, 2134, "Output"],
Cell[23925, 739, 115, 5, 3313, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[24089, 750, 59, 0, 28, "Subsection"],
Cell[24151, 752, 554, 14, 112, "Input",
 InitializationCell->True],
Cell[24708, 768, 4138, 104, 572, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[28871, 876, 752, 22, 72, "Input"],
Cell[29626, 900, 104, 4, 30, "Output"],
Cell[29733, 906, 638, 19, 30, "Output"],
Cell[30374, 927, 644, 19, 30, "Output"]
}, Open  ]],
Cell[31033, 949, 3125, 76, 512, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[34195, 1030, 39, 0, 28, "Subsection"],
Cell[34237, 1032, 5293, 134, 592, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[39555, 1170, 1662, 52, 92, "Input"],
Cell[41220, 1224, 1214, 26, 102, "Output"],
Cell[42437, 1252, 1315, 28, 102, "Output"],
Cell[43755, 1282, 1032, 23, 87, "Output"],
Cell[44790, 1307, 966, 24, 102, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[45793, 1336, 493, 14, 31, "Input"],
Cell[46289, 1352, 1616, 46, 102, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[47954, 1404, 32, 0, 28, "Subsection"],
Cell[47989, 1406, 346, 10, 1465, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[48372, 1421, 99, 1, 28, "Subsection"],
Cell[48474, 1424, 2461, 57, 312, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[50960, 1485, 1279, 30, 92, "Input"],
Cell[52242, 1517, 547, 12, 30, "Output"],
Cell[52792, 1531, 690, 18, 46, "Output"],
Cell[53485, 1551, 467, 10, 30, "Output"],
Cell[53955, 1563, 610, 17, 46, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[54626, 1587, 131, 1, 71, "Section"],
Cell[CellGroupData[{
Cell[54782, 1592, 123, 1, 36, "Subsection"],
Cell[54908, 1595, 1227, 38, 192, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[56172, 1638, 105, 1, 36, "Subsection"],
Cell[56280, 1641, 1492, 43, 72, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[57797, 1688, 353, 9, 52, "Input"],
Cell[58153, 1699, 538, 11, 32, "Output"],
Cell[58694, 1712, 534, 11, 32, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[59277, 1729, 125, 1, 36, "Subsection"],
Cell[59405, 1732, 1582, 41, 3849, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[61012, 1777, 281, 7, 708, "Input"],
Cell[61296, 1786, 435, 12, 751, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[61780, 1804, 101, 1, 28, "Subsection"],
Cell[61884, 1807, 575, 19, 31, "Text"],
Cell[62462, 1828, 275, 7, 31, "Input",
 InitializationCell->True],
Cell[62740, 1837, 2651, 64, 232, "Input",
 InitializationCell->True],
Cell[65394, 1903, 473, 13, 31, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[65892, 1920, 758, 17, 132, "Input"],
Cell[66653, 1939, 572, 12, 30, "Output"],
Cell[67228, 1953, 569, 12, 30, "Output"],
Cell[67800, 1967, 565, 12, 30, "Output"],
Cell[68368, 1981, 562, 12, 30, "Output"],
Cell[68933, 1995, 564, 12, 30, "Output"],
Cell[69500, 2009, 572, 12, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[70109, 2026, 177, 4, 31, "Input"],
Cell[70289, 2032, 310, 7, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[70636, 2044, 745, 20, 92, "Input"],
Cell[71384, 2066, 276, 6, 30, "Output"],
Cell[71663, 2074, 248, 6, 30, "Output"],
Cell[71914, 2082, 248, 6, 30, "Output"],
Cell[72165, 2090, 277, 8, 30, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[72491, 2104, 163, 2, 36, "Subsection"],
Cell[72657, 2108, 546, 15, 31, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[73228, 2127, 368, 9, 52, "Input"],
Cell[73599, 2138, 249, 6, 30, "Output"],
Cell[73851, 2146, 250, 6, 30, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[74150, 2158, 96, 1, 36, "Subsection"],
Cell[74249, 2161, 2980, 47, 232, "Input",
 InitializationCell->True],
Cell[77232, 2210, 3799, 62, 232, "Input",
 InitializationCell->True],
Cell[81034, 2274, 17906, 542, 2272, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[98977, 2821, 157, 2, 28, "Subsection"],
Cell[99137, 2825, 156, 3, 29, "Text"],
Cell[CellGroupData[{
Cell[99318, 2832, 149, 2, 31, "Input"],
Cell[99470, 2836, 498, 11, 21, "Message"],
Cell[99971, 2849, 557, 11, 21, "Message"],
Cell[100531, 2862, 78, 1, 30, "Output"]
}, Open  ]],
Cell[100624, 2866, 427, 10, 31, "Input"],
Cell[101054, 2878, 1052, 28, 72, "Input",
 InitializationCell->True],
Cell[102109, 2908, 1124, 30, 72, "Input",
 InitializationCell->True],
Cell[103236, 2940, 1633, 44, 72, "Input",
 InitializationCell->True],
Cell[104872, 2986, 1229, 32, 72, "Input",
 InitializationCell->True],
Cell[106104, 3020, 1639, 47, 72, "Input",
 InitializationCell->True],
Cell[107746, 3069, 511, 14, 31, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[108282, 3087, 146, 3, 31, "Input"],
Cell[108431, 3092, 502, 11, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[108970, 3108, 129, 2, 31, "Input"],
Cell[109102, 3112, 86, 1, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[109225, 3118, 137, 2, 31, "Input"],
Cell[109365, 3122, 141, 3, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[109543, 3130, 257, 5, 31, "Input"],
Cell[109803, 3137, 363, 6, 30, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[110215, 3149, 188, 2, 36, "Subsection"],
Cell[110406, 3153, 2401, 66, 232, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[112832, 3223, 494, 15, 31, "Input"],
Cell[113329, 3240, 983, 29, 44, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[114349, 3274, 484, 13, 31, "Input"],
Cell[114836, 3289, 1200, 38, 61, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[116085, 3333, 179, 2, 36, "Subsection"],
Cell[116267, 3337, 312, 6, 29, "Text"],
Cell[116582, 3345, 258, 5, 29, "Text"],
Cell[116843, 3352, 4534, 111, 492, "Input",
 InitializationCell->True],
Cell[121380, 3465, 161, 2, 29, "Text"],
Cell[121544, 3469, 1605, 45, 72, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[123174, 3518, 552, 16, 31, "Input"],
Cell[123729, 3536, 1372, 39, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[125138, 3580, 598, 16, 31, "Input"],
Cell[125739, 3598, 1309, 41, 47, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[127085, 3644, 298, 8, 31, "Input"],
Cell[127386, 3654, 209, 6, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[127632, 3665, 316, 9, 31, "Input"],
Cell[127951, 3676, 233, 8, 30, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[128233, 3690, 146, 2, 36, "Subsection"],
Cell[128382, 3694, 138, 2, 29, "Text"],
Cell[128523, 3698, 716, 14, 31, "Input",
 InitializationCell->True],
Cell[129242, 3714, 1300, 27, 92, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[130579, 3746, 118, 1, 36, "Subsection"],
Cell[130700, 3749, 145, 2, 29, "Text"],
Cell[130848, 3753, 166, 3, 29, "Text"],
Cell[131017, 3758, 839, 18, 31, "Input",
 InitializationCell->True],
Cell[131859, 3778, 243, 5, 29, "Text"],
Cell[132105, 3785, 2888, 73, 232, "Input",
 InitializationCell->True],
Cell[134996, 3860, 2801, 72, 232, "Input",
 InitializationCell->True],
Cell[137800, 3934, 188, 2, 29, "Text"],
Cell[137991, 3938, 2108, 49, 232, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[140124, 3991, 1452, 44, 92, "Input"],
Cell[141579, 4037, 1086, 24, 30, "Output"],
Cell[142668, 4063, 1499, 32, 30, "Output"],
Cell[144170, 4097, 1500, 32, 30, "Output"],
Cell[145673, 4131, 1239, 26, 30, "Output"]
}, Open  ]],
Cell[146927, 4160, 180, 2, 29, "Text"],
Cell[147110, 4164, 392, 8, 29, "Text"],
Cell[147505, 4174, 1021, 21, 31, "Input",
 InitializationCell->True],
Cell[148529, 4197, 480, 9, 47, "Text"],
Cell[149012, 4208, 2953, 72, 232, "Input",
 InitializationCell->True],
Cell[151968, 4282, 2525, 64, 212, "Input",
 InitializationCell->True],
Cell[154496, 4348, 165, 2, 29, "Text"],
Cell[154664, 4352, 2207, 49, 132, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[156896, 4405, 1748, 50, 112, "Input"],
Cell[158647, 4457, 848, 16, 30, "Output"],
Cell[159498, 4475, 964, 19, 30, "Output"],
Cell[160465, 4496, 964, 19, 30, "Output"],
Cell[161432, 4517, 1026, 19, 30, "Output"],
Cell[162461, 4538, 952, 20, 30, "Output"]
}, Open  ]],
Cell[163428, 4561, 1263, 33, 52, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[164716, 4598, 525, 15, 52, "Input"],
Cell[165244, 4615, 510, 12, 30, "Output"],
Cell[165757, 4629, 603, 15, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[166397, 4649, 330, 8, 52, "Input"],
Cell[166730, 4659, 253, 5, 30, "Output"],
Cell[166986, 4666, 339, 7, 30, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[167386, 4680, 103, 1, 71, "Section"],
Cell[167492, 4683, 613, 11, 65, "Text"],
Cell[CellGroupData[{
Cell[168130, 4698, 96, 1, 36, "Subsection"],
Cell[168229, 4701, 1202, 37, 72, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[169468, 4743, 147, 2, 36, "Subsection"],
Cell[169618, 4747, 550, 14, 65, "Text"],
Cell[170171, 4763, 1648, 36, 172, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[171844, 4803, 581, 16, 31, "Input",
 InitializationCell->True],
Cell[172428, 4821, 2385, 52, 52, "Output"]
}, Open  ]],
Cell[174828, 4876, 1363, 40, 92, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[176228, 4921, 103, 1, 36, "Subsection"],
Cell[176334, 4924, 845, 23, 31, "Input"],
Cell[177182, 4949, 2116, 52, 192, "Input",
 InitializationCell->True],
Cell[179301, 5003, 111, 1, 29, "Text"],
Cell[CellGroupData[{
Cell[179437, 5008, 1111, 32, 92, "Input"],
Cell[180551, 5042, 221, 6, 44, "Output"],
Cell[180775, 5050, 368, 10, 44, "Output"],
Cell[181146, 5062, 411, 11, 44, "Output"],
Cell[181560, 5075, 407, 11, 44, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[182004, 5091, 1695, 52, 112, "Input"],
Cell[183702, 5145, 408, 11, 44, "Output"],
Cell[184113, 5158, 415, 11, 44, "Output"],
Cell[184531, 5171, 396, 11, 44, "Output"],
Cell[184930, 5184, 402, 11, 30, "Output"]
}, Open  ]],
Cell[185347, 5198, 1230, 37, 72, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[186602, 5239, 819, 21, 92, "Input"],
Cell[187424, 5262, 523, 12, 30, "Output"],
Cell[187950, 5276, 608, 16, 44, "Output"],
Cell[188561, 5294, 523, 12, 30, "Output"],
Cell[189087, 5308, 608, 16, 44, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[189744, 5330, 105, 1, 36, "Subsection"],
Cell[189852, 5333, 174, 4, 29, "Text"],
Cell[190029, 5339, 154, 2, 29, "Text"],
Cell[190186, 5343, 1122, 19, 101, "Text"],
Cell[191311, 5364, 5901, 132, 412, "Input",
 InitializationCell->True],
Cell[197215, 5498, 49, 0, 29, "Text"],
Cell[197267, 5500, 1639, 48, 92, "Input",
 InitializationCell->True],
Cell[198909, 5550, 1234, 37, 72, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[200180, 5592, 235, 7, 36, "Subsection"],
Cell[200418, 5601, 305, 7, 1146, "Text"],
Cell[CellGroupData[{
Cell[200748, 5612, 134, 2, 2042, "Input"],
Cell[200885, 5616, 1281, 29, 3016, "Output"],
Cell[202169, 5647, 45, 1, 1297, "Output"]
}, Open  ]],
Cell[202229, 5651, 40, 0, 1146, "Text"],
Cell[CellGroupData[{
Cell[202294, 5655, 847, 24, 2798, "Input"],
Cell[203144, 5681, 573, 20, 1297, "Output"],
Cell[203720, 5703, 609, 21, 1297, "Output"],
Cell[204332, 5726, 469, 16, 1297, "Output"]
}, Open  ]],
Cell[204816, 5745, 55, 0, 1146, "Text"],
Cell[204874, 5747, 347, 16, 1297, "Output"],
Cell[205224, 5765, 55, 0, 1146, "Text"],
Cell[205282, 5767, 310, 9, 1221, "Input"],
Cell[205595, 5778, 1026, 23, 3571, "Input"],
Cell[206624, 5803, 34, 0, 1146, "Text"],
Cell[206661, 5805, 5046, 142, 1650, "Output"],
Cell[211710, 5949, 34, 0, 1146, "Text"],
Cell[211747, 5951, 5046, 142, 1650, "Output"],
Cell[216796, 6095, 34, 0, 1146, "Text"],
Cell[216833, 6097, 5050, 142, 1650, "Output"],
Cell[221886, 6241, 34, 0, 1146, "Text"],
Cell[221923, 6243, 5050, 142, 1746, "Output"],
Cell[226976, 6387, 34, 0, 1146, "Text"],
Cell[227013, 6389, 5050, 142, 1746, "Output"],
Cell[CellGroupData[{
Cell[232088, 6535, 750, 17, 2042, "Input"],
Cell[232841, 6554, 3274, 110, 1375, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[236152, 6669, 1097, 27, 6649, "Input"],
Cell[237252, 6698, 2280, 59, 3849, "Output"],
Cell[239535, 6759, 3706, 108, 1333, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[243290, 6873, 257, 7, 28, "Subsection"],
Cell[CellGroupData[{
Cell[243572, 6884, 130, 2, 31, "Input"],
Cell[243705, 6888, 2442, 54, 107, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[246184, 6947, 121, 2, 31, "Input"],
Cell[246308, 6951, 999, 21, 50, "Output"]
}, Open  ]],
Cell[247322, 6975, 291, 8, 31, "Input"],
Cell[CellGroupData[{
Cell[247638, 6987, 1778, 41, 172, "Input"],
Cell[249419, 7030, 3437, 107, 37, "Output"]
}, Open  ]],
Cell[252871, 7140, 151, 3, 29, "Text"],
Cell[CellGroupData[{
Cell[253047, 7147, 1752, 39, 272, "Input"],
Cell[254802, 7188, 2531, 77, 42, "Output"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[257382, 7271, 187, 6, 28, "Subsection"],
Cell[CellGroupData[{
Cell[257594, 7281, 395, 9, 52, "Input"],
Cell[257992, 7292, 1657, 43, 50, "Output"],
Cell[259652, 7337, 1187, 38, 53, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[260888, 7381, 108, 1, 36, "Subsection"],
Cell[260999, 7384, 119, 3, 29, "Text"],
Cell[CellGroupData[{
Cell[261143, 7391, 295, 7, 31, "Input"],
Cell[261441, 7400, 446, 12, 30, "Output"]
}, Open  ]],
Cell[261902, 7415, 96, 2, 29, "Text"],
Cell[CellGroupData[{
Cell[262023, 7421, 295, 7, 31, "Input"],
Cell[262321, 7430, 302, 8, 30, "Output"]
}, Open  ]],
Cell[CellGroupData[{
Cell[262660, 7443, 407, 13, 31, "Input"],
Cell[263070, 7458, 26027, 758, 97, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[289146, 8222, 113, 1, 36, "Subsection"],
Cell[289262, 8225, 1463, 36, 232, "Input",
 InitializationCell->True]
}, Closed]],
Cell[CellGroupData[{
Cell[290762, 8266, 106, 1, 28, "Subsection"],
Cell[290871, 8269, 32, 0, 29, "Text"],
Cell[290906, 8271, 1829, 43, 312, "Input",
 InitializationCell->True],
Cell[CellGroupData[{
Cell[292760, 8318, 625, 14, 132, "Input"],
Cell[293388, 8334, 36, 0, 30, "Output"],
Cell[293427, 8336, 42, 0, 30, "Output"],
Cell[293472, 8338, 41, 0, 30, "Output"],
Cell[293516, 8340, 43, 0, 30, "Output"],
Cell[293562, 8342, 45, 0, 30, "Output"],
Cell[293610, 8344, 47, 0, 30, "Output"]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[293718, 8351, 95, 1, 71, "Section"],
Cell[CellGroupData[{
Cell[293838, 8356, 106, 1, 36, "Subsection"],
Cell[293947, 8359, 96, 3, 31, "Input",
 InitializationCell->True]
}, Open  ]],
Cell[CellGroupData[{
Cell[294080, 8367, 107, 1, 36, "Subsection"],
Cell[294190, 8370, 406, 12, 72, "Input",
 InitializationCell->True]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
